                       VolPack version 1.0beta3
                       ------------------------

Phil Lacroute
volpack@graphics.stanford.edu
16 December 1994

1. Introduction
---------------

VolPack is a portable library of fast volume rendering algorithms
that produce high-quality images.

2. Installation
---------------

To build the library, do the following:

  A. Type "./configure" in this directory.  This will run a shell
     script that determines the features of your operating system
     and then automatically chooses compiler flags and configuration
     constants for VolPack.

     Configure takes a number of options, but only the commonly-used
     ones are described here.  You can specify the top-level
     installation directory with the "--prefix=<directory>"
     option, and the top-level installation directory for
     architecture-dependent binaries with "--exec_prefix=<directory>".
     Both options default to /usr/local.

     If you want, you can look at the Makefile configure builds and
     override some of the options.

  B. Type "make".  This creates a library archive call "libvolpack.a".

  C. To compile the example programs type "make examples", or move
     to the examples directory and type "make".

  D. Type "make install" to install the library, include files, and
     manual entries.

  E. Look at the User's Guide in the "doc" directory for a tutorial
     introduction, and look at the examples programs in the "examples"
     directory (see examples/README).

If you have a version of "m4" that does not understand the -D option
then the compilation will fail (usually "make" will appear to hang
after the first call to m4).  Some systems have two versions of m4;
you can choose the correct one by editting the "M4" macro in
Makefile.in or by setting the M4 environment variable to the correct
path before running configure.  You can also install GNU m4.

If your optimizer has trouble or takes a long time on some of the
files you may want to use a lower optimization level for them.  All of the
files with names like vp_comp*.c are special-case versions of the
rendering routine and you may choose to optimize only the ones you
plan to use frequently.

An important note for HP-UX users:
The math library rint() function is broken in HP-UX 9.01 (and maybe
other releases), causing the VolPack test programs to generate blank
images.  This is fixed by HP patch "PHSS_3597", which HP-UX users can
get from HP support.

3. Documentation
----------------

The doc directory contains a user's guide to VolPack in HTML format
(volpack.html) which you can read using Mosaic or any other Web
browser.  A PostScript version is also available.

The man directory contains manual pages for each routine in the
library.

4. Support
----------

If you have problems, bug reports or bug fixes, please send mail to:

    volpack@graphics.stanford.edu

The author makes no commitment to fix bugs or provide support.
However, future releases with fixes and enhancements are planned.
If you like the library then drop us a note describing what you use it
for!

If you decide to use the software then please add yourself to our
mailing list so we can tell you about bug fixes and new versions of
the software.  Just send a message to

    majordomo@lists.stanford.edu

with the message body:

    subscribe volpack-announce

5. Data Sets and Other Goodies
------------------------------

One sample data set is provided in the examples directory.  Some
larger data sets and a more complete demonstration application,
vprender, are available from the Stanford Computer Graphics
Laboratory's ftp site:
    graphics.stanford.edu:pub/volpack
or
    http://www-graphics.stanford.edu/

6. Changes
----------

Release 1.0beta3 includes the following additions to release 1.0beta2:

    - a new shader for rendering shadows (see vpSetShadowLookupShader)
    - filtering routines for resampling volumes to different resolutions
    - the capability to produce images with different pixel formats,
      including formats with alpha channels
    - several important bug fixes, including a problem with depth
      cueing that caused "flashing" artifacts in rotation sequences
    - upgraded configuration script to autoconf 2.0 for even easier
      installation

See the "changes" file for a complete list.  There are minor
incompatible changes to the functions vpSetImage and vpGetImage.

7. Copyright
------------

VolPack is covered by the following copyright notice:

    Copyright (c) 1994 The Board of Trustees of The Leland Stanford
    Junior University.  All rights reserved.
  
    Permission to use, copy, modify and distribute this software and its
    documentation for any purpose is hereby granted without fee, provided
    that the above copyright notice and this permission notice appear in
    all copies of this software and that you do not sell the software.
    Commercial licensing is available by contacting the author.
   
    THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
    EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
    WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

    This version of the VolPack library is a modified version of the
    original available from Stanford University.  Modifications were
    made by the Center for Computational Sciences and Engineering,
    Lawrence Berkeley National Laboratory.  Modifications to VolPack
    (c) 2000 The Regents of the University of California (through
    E.O. Lawrence Berkeley National Laboratory), subject to approval by
    the U.S. Department of Energy.  Your use of this software is under
    license from Stanford University with respect to the underlying
    original VolPack code (see copyright notice and permission above)
    and The Regents of the University of California with respect to
    modifications thereto (see AmrVis license.txt file for applicable
    license terms).  Contact Berkeley Lab's Center for Computational
    Sciences and Engineering at webmaster@mothra.lbl.gov or Berkeley
    Lab's Technology Transfer Department at TTD@lbl.gov for questions
    or to receive more information.
 

8. Credits
----------

VolPack was written by Phil Lacroute at the Computer Graphics
Laboratory, Stanford University.  The algorithms are based on Phil's
Ph.D. thesis research and are described in the following paper:
Philippe Lacroute and Marc Levoy, Fast Volume Rendering Using a
Shear-Warp Factorization of the Viewing Transformation, Proc. SIGGRAPH
'94 (Orlando, Florida, July 24-29, 1994).  In Computer Graphics
Proceedings, Annual Conference Series, 1994, ACM SIGGRAPH, pp. 451-458.

If you publish a rendering made using VolPack and you would like to
make an attribution, the following form is suggested:

    Image generated using the Stanford VolPack volume renderer.

An appropriate longer attribution could omit the word Stanford but would
include a citation of the SIGGRAPH '94 paper:

    Image generated using the VolPack volume renderer [#].

    [#]  Philippe Lacroute and Marc Levoy, Fast Volume Rendering Using a
    Shear-Warp Factorization of the Viewing Transformation, Proc. SIGGRAPH
    '94 (Orlando, Florida, July 24-29, 1994).  In Computer Graphics
    Proceedings, Annual Conference Series, 1994, ACM SIGGRAPH, pp. 451-458.

##########################################################################
INTRODUCTION
##########################################################################

This code implements a single-grid variable density projection method
for the incompressible Navier-Stokes equations.   Here we use
Godunov upwind methodology for the advection terms, a Crank-Nicholson 
discretization of the viscous terms in the momentum equation, 
and an approximate node-based projection to enforce the divergence-free 
constraint on velocity. 

This algorithm is described in detail in several papers; here we refer
you to the section of the recent paper, "A Conservative Adaptive Projection 
Method for the Variable Density Incompressible Navier-Stokes Equations" 
on the single grid projection algorithm, which can be found on the web site.  
See also the references cited therein.

##########################################################################
MAKING THE EXECUTABLE
##########################################################################
	
To run this code, you must build the varden executable in this directory.
You will also want to build the AmrVis executable in ../pAmrvis.

Modify the GNUmakefile in this directory to set the following flags:

DIM = 2 
COMP = your compiler
DEBUG = TRUE or FALSE
PRECISION = DOUBLE or FLOAT
USE_MPI = FALSE
PROFILE = FALSE

If you want run-time contouring capability then make sure that
USE_GRAPHTOOL is set to TRUE.  If you don't, then leave that flag
at FALSE.

Now type "make."  This should build the executable in this directory.
If you have problems at this point, please contact Ann Almgren
at ASAlmgren@lbl.gov

The executable will look something like run2d.OSF1.KCC.ex .  This is a 
two-dimensional executable built with the OSF1 operating
system, the KCC compiler, and the DEBUG=FALSE flag set in the GNUmakefile.
If DEBUG=TRUE, the executable will look like run2d.OSF1.KCC.DEBUG.ex .
The DEBUG=TRUE option exercises certain debug options in the pBoxLib 
library, and turns on several Fortran debug options also,
which may be helpful if you are trying to debug a new code.  
The DEBUG=FALSE version runs more quickly.

Now, to build the AmrVis executable, type "make" in the pAmrvis directory.

##########################################################################
VIEWING THE DATA
##########################################################################

There are two ways to look at the data which this code generates.  

The first is contour plots - displayed at runtime on the screen (requiring
X windows) and/or as postscript files if you have compiled with
the USE_GRAPHTOOL flag set to TRUE.  See the documentation at the end
of the inputs file to control the contour plotting.  

The second is plot files (plt0001, e.g., after one time step), which
are generated by the VarDen code during runtime.  The frequency of 
plot file generation is controlled in the inputs file by the parameter 
"plot_int."  These files contain the velocity, scalars, pressure averaged 
onto cells, pressure gradient and vorticiy at the time specified.  You can 
add additional derived quantities to the plot files by modifying
Grid::writePlotFile.

To view these plot files you will need to make the 2D executable in
the ../pAmrvis directory.

After the plot file (plt0001, e.g.) has been created, it can be viewed by 
typing 

../pAmrvis/amrvis2d*ex plt0001

Sample plot files from each of the sample problems are included here
in the subdirectory PlotFiles.  

##########################################################################
RUNNING THE EXECUTABLE
##########################################################################

To run the code you will need two different files in your directory : 
one read by main(), the other read by FORT_PROBINIT.  The first
is typically called "inputs", but this name is set on the command
line.  The name of the second is typically "probin", but this
name is set in the inputs file which is read in.

There are six test problems set up for you to run; you can later
edit the prob.F file and the inputs and probin files to create your 
own test problems.  You can also modify the inputs and probin files
to run these test problems at different resolution and with different
parameters.

-----------------------------------------------------------------------------

To run a constant-density inviscid spindown problem, type

run2d.OSF1.KCC.ex inputs1

(This will read probin1)

-----------------------------------------------------------------------------

To run a variable-density inviscid bubble drop problem, type

run2d.OSF1.KCC.ex inputs2

(This will read probin2)

-----------------------------------------------------------------------------

To run a constant-density doubly periodic shear layer problem, type

run2d.OSF1.KCC.ex inputs3

(This will read probin3)

-----------------------------------------------------------------------------

To run a viscous flow-in-a-channel problem, type

run2d.OSF1.KCC.ex inputs4

(This will read probin4)

-----------------------------------------------------------------------------

To run a Poiseuille viscous flow problem in x-y, type

run2d.OSF1.KCC.ex inputs5.2d

(This will read probin5)

-----------------------------------------------------------------------------

To run a Poiseuille viscous flow problem in r-z, type

run2d.OSF1.KCC.ex inputs6

(This will read probin6)

##########################################################################

To set up a different problem using the variables as given : x-velocity (u),
                                                             y-velocity (v),
                                                             density  (rho),
                                                             tracer 

(1) Determine which problem-specific constant parameters you would like to 
    be able to change at run-time.   Put these into probin (using the format
    there) and edit probdata.H to incorporate them appropriately - make
    sure to add them both to the declaration statement as well as the
    common block.

(2) Edit FORT_INITDATA and/or the routines it calls in prob.F to set 
    up your initial data.  You must initialize all the state variables - 
    u, v, rho, and the tracer.  

(3) If you would like the velocity field to satisfy div(u) = S
    rather than div(u) = 0, you must set S on cell centers and
    on nodes by editing mkdivucc.F and mkdivunod.F .  The current
    default is S = 0.

(4) If you would like to have a forcing term in your scalar equation,
    define it in mkscalforce.F

IN INPUTS:

(5) Set boundary conditions using the boundary condition flags 
    bcx_lo,bcx_hi,bcy_lo and bcy_hi.  See the comments there for a 
    description of the flags.  If you are using inflow boundary conditions, 
    you must edit "setvelinflow" and "setscalinflow" in prob.F appropriately 
    to supply the correct inflow boundary conditions.

(6) If this is a viscous problem, set visc_coef to be the dynamic
    viscosity (assumed constant).

(7) If you would like your scalar to diffuse, set the diff_coef array
    appropriately.

(8) If you have gravity in your problem then set the gravity value 
    according to your physical units.  The default in mkforce.F is
    that gravity acts in the y-direction; you can of course change this.

(9) Set max_step and stop_time to determine how long your 
    calculation will run. If you want to be governed by max_step, 
    set stop_time to a very large number.  If you want to be governed 
    by stop_time, set max_step to be a very large integer.

(10)Set check_int and plot_int to govern your graphics output
    and restart capability.

(11)Set grid.n_cell to be the size (in index space) of your problem,
    e.g. for a 16x32 calculation you would set 
 
grid.n_cell  = 16 32

(12)Set grid.prob_lo and grid.prob_hi to be the physical coordinates of
    the low and high ends of your domain.  E.g. if your calculation is
    in a 1x2 box starting at the origin, then set 

grid.prob_lo  = 0. 0.
grid.prob_hi  = 1. 2.     

(13)Set the contour intervals to be positive numbers if you want to see
    run-time contour plots of the variables.  You can also have these
    generate postscript files at runtime, or both.

##########################################################################

IF YOU NEED TO, MODIFY THE FOLLOWING IN INPUTS.  OTHERWISE, LEAVE AT
THEIR DEFAULT VALUES.

(14) Set the cfl number to be any number from 0 to 1 (in order to keep
     the calculation stable).  Suggested value for a relatively stable
     problem is 0.9; if your problem is unstable at this value then you
     must reduce it accordingly.

(15) If the problem starts with a small velocity but large acceleration,
     it is suggested that you set init_shrink to be smaller than 1, e.g.
     0.1.  If not, leave init_shrink =  1.

(16) Decide how you want to advect your scalars, using conservative or
     convective differences.  Set grid.is_conserv appropriately.

(17) Leave slope_order = 4 and init_iter = 2 unless you have reasons
     to change them.

(18) On a double precision workstation or a CRAY, leave the tolerances 
     hg.tol and mac.tol at 1.e-12 unless you have reason to change them. 
     For a single precision machine you will need to raise these values.

(19)  Leave the multigrid flags as is unless you like to see the
      convergence of the multigrid solves. 

##########################################################################

If you want to advect n additional quantities as tracers in addition 
to density, you must follow these steps:

(1) Define N_STATE in Grid.cpp to be 4 + n.
    The current version of the code is set up to have only one scalar
   ("tracer") in addition to the density, hence N_STATE is set to 4.

(2) Modify "Grid::deriveData(...) appropriately, mimicing the format 
    which is there.  Note that you are allowed to choose the name of 
    the variable in deriveData - make sure that you then add the 
    variable to the list of contour variables in the inputs file, 
    using the same name.

(3) Modify "Grid::writePlotFile(...) appropriately, uncomment the 
    line which is commented there using the name "new_scalar" - replace
    new_scalar by the name you used in (2) above.

(4) Initialize the new variable appropriately in FORT_INITDATA in prob.F .

(5) Modify mkscalforce.F appropriately if there is a forcing term for the
    new scalar.

In this directory are six sets of inputs, probin and fixed_grids 
files which are used to test different grid configurations and problem
set-ups.  

The grid configurations are in files fixed_grids_1 through fixed_grids_6.
Associated with each is a set of inputs files, inputs_1_... through inputs_6.
and probin files, probin_1 through probin_6.   

There is also a plot file (plt0000_1 through plt0000_6) for each 
grid configuration so you can see the grid configurations.

******************************************************************************

fixed_grids_1/{inputs_1_xy_xper, inputs_1_xy_xsolid, inputs_1_rz}/probin_1 :

4 level 0 grids, 2 level 1 grids, 2 level 2 grids.

This is the only case with multiple level 0 grids.  It also has
level 2 grid boundaries overlaying level 1 grid boundaries overlaying
level 0 grid boundaries.  None of the fine grids touch the physical
boundaries.

Refinement ratio: 2 and 2.

The problem is based on inputs.2d.hotspot, and has nonzero divu.

This can be run with x-y with solid wall or periodic in the x-direction,
or r-z with solid in the r-direction. It uses solid wall in the 
low-y direction and outflow in the high-y direction 
(must use outflow because divu != 0).

******************************************************************************

fixed_grids_2/{inputs_2_xy_ysolid, inputs_2_xy_yinflow, 
               inputs_2_rz_zsolid, inputs_2_rz_zinflow}/probin_2 :

1 level 0 grid, 2 level 1 grids, 3 level 2 grids

This is the only case set up to test inflow.  One of the level 1
grids and two of the level 2 grids touch the low-y inflow face. This
has a level 2 grid spanning a level 1 grid interface.

Refinement ratio: 4 and 2.

The problem is based on inputs.2d.hotspot, and has nonzero divu.

This can be run with x-y or r-z, with solid wall in
the x-direction.   It uses solid wall or inflow in the low-y direction and
outflow in the high-y direction (must use outflow because divu != 0).

******************************************************************************

fixed_grids_3/{inputs_3}/probin_3 : 

1 level 0 grid, 3 level 1 grids, 3 level 2 grids

Refinement ratio: 4 and 2.

The problem is based on inputs.2d.hotspot, and has nonzero divu.

This should be run with x-y and periodic in the x-direction,
solid wall in the low-y direction and outflow in the high-y direction 
(must use outflow because divu != 0).  This is especially
useful for the periodic grid interfaces.

******************************************************************************

fixed_grids_4/{inputs_4}/probin_4 : 

1 level 0 grid, 5 level 1 grids

Refinement ratio: 2 

The problem is based on inputs.2d.viscbench, and has divu=0.

This is doubly periodic, and is useful for testing periodic interfaces
as well as different types of corners (inside, outside, diagonal).

******************************************************************************

fixed_grids_5/{inputs_5}/probin_5 : 

1 level 0 grid, 7 level 1 grids

Refinement ratio: 2 

The problem is based on inputs.2d.viscbench, and has divu=0.

This is doubly periodic, and is useful for testing periodic grid interfaces.

******************************************************************************

fixed_grids_6/{inputs_6}/probin_6 :

1 level 0 grid, 4 level 1 grid, 3 level 2 grids

Refinement ratio: 2 2

This problem is based on inputs.2d.viscbench, and has divu=0.

It is periodic in the x-direction and has some nasty level 1/2 and 
level 0/1 interfaces.  It is useful for testing periodic grid interfaces.
******************************************************************************

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** SETVELBC **
c ** Impose the physical boundary conditions on the velocity (u,v)
c *************************************************************************

      subroutine setvelbc(vel,DIMS,bc,visc_coef,dx,time)

      implicit none

      integer DIMS
      REAL_T  vel(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,3)
      integer bc(2,3)
      REAL_T visc_coef
      REAL_T dx(3)
      REAL_T time

c     Local variables
      integer is,ie,js,je,ks,ke,i,j,k
      integer ilo,ihi,jlo,jhi
      integer ng

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      ilo = cvmgt(lo_1-3,lo_1,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(hi_1+3,hi_1,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
      jlo = cvmgt(lo_2-3,lo_2,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
      jhi = cvmgt(hi_2+3,hi_2,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)

c     NOTE: IF BC == WALL, THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL
c           BOUNDARY, NOT IN THE GHOST CELL

      if (BCZ_LO .eq. WALL) then

        do ng = 1,3
        do j = js-3,je+3
        do i = is-3,ie+3
          vel(i,j,ks-ng,3) = zero
        enddo
        enddo
        enddo

        do j = jlo,jhi
        do i = ilo,ihi
          vel(i,j,ks-1,1) = (fifteen*vel(i,j,ks  ,1) - ten*vel(i,j,ks+1,1) + 
     $                         three*vel(i,j,ks+2,1)) / eight
          vel(i,j,ks-1,2) = (fifteen*vel(i,j,ks  ,2) - ten*vel(i,j,ks+1,2) + 
     $                         three*vel(i,j,ks+2,2)) / eight
          vel(i,j,ks-2,1) = vel(i,j,ks-1,1)
          vel(i,j,ks-3,1) = vel(i,j,ks-1,1)
          vel(i,j,ks-2,2) = vel(i,j,ks-1,2)
          vel(i,j,ks-3,2) = vel(i,j,ks-1,2)
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do j = js-3,je+3
          do i = is-3,ie+3
            vel(i,j,ks-ng,1) = zero
            vel(i,j,ks-ng,2) = zero
          enddo
          enddo
          enddo
        endif

      elseif (BCZ_LO .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,lo_3-3,3),DIMS,time,dx,2,0)

        do ng = 1,3
        do j = js-3,je+3
        do i = is-3,ie+3
          vel(i,j,ks-ng,1) = zero
          vel(i,j,ks-ng,2) = zero
        enddo
        enddo
        enddo

      elseif (BCZ_LO .eq. OUTLET) then

        do ng = 1,3
        do j = js-3,je+3
        do i = is-3,ie+3
          vel(i,j,ks-ng,1) = vel(i,j,ks,1)
          vel(i,j,ks-ng,2) = vel(i,j,ks,2)
          vel(i,j,ks-ng,3) = vel(i,j,ks,3)
        enddo
        enddo
        enddo

      endif

      if (BCZ_HI .eq. WALL) then

        do ng = 1,3
        do j = js-3,je+3
        do i = is-3,ie+3
          vel(i,j,ke+ng,3) = zero
        enddo
        enddo
        enddo

        do j = jlo,jhi
        do i = ilo,ihi
          vel(i,j,ke+1,1) = (fifteen*vel(i,j,ke  ,1) - ten*vel(i,j,ke-1,1) + 
     $                         three*vel(i,j,ke-2,1)) / eight
          vel(i,j,ke+1,2) = (fifteen*vel(i,j,ke  ,2) - ten*vel(i,j,ke-1,2) + 
     $                         three*vel(i,j,ke-2,2)) / eight
          vel(i,j,ke+2,1) = vel(i,j,ke+1,1)
          vel(i,j,ke+3,1) = vel(i,j,ke+1,1)
          vel(i,j,ke+2,2) = vel(i,j,ke+1,2)
          vel(i,j,ke+3,2) = vel(i,j,ke+1,2)
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do j = js-3,je+3
          do i = is-3,ie+3
            vel(i,j,ke+ng,1) = zero
            vel(i,j,ke+ng,2) = zero
          enddo
          enddo
          enddo
        endif

      elseif (BCZ_HI .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,lo_3-3,3),DIMS,time,dx,2,1)

        do ng = 1,3
        do j = js-3,je+3
        do i = is-3,ie+3
          vel(i,j,ke+ng,1) = zero
          vel(i,j,ke+ng,2) = zero
        enddo
        enddo
        enddo

      elseif (BCZ_HI .eq. OUTLET) then

        do ng = 1,3
        do j = js-3,je+3
        do i = is-3,ie+3
          vel(i,j,ke+ng,1) = vel(i,j,ke,1)
          vel(i,j,ke+ng,2) = vel(i,j,ke,2)
          vel(i,j,ke+ng,3) = vel(i,j,ke,3)
        enddo
        enddo
        enddo

      endif

      if (BCY_LO .eq. WALL) then

        do ng = 1,3
        do k = ks-3,ke+3
        do i = is-3,ie+3 
          vel(i,js-ng,k,2) = zero
        enddo
        enddo
        enddo

        do k = ks-3,ke+3
        do i = ilo,ihi
          vel(i,js-1,k,1) = (fifteen*vel(i,js  ,k,1) - ten*vel(i,js+1,k,1) + 
     $                         three*vel(i,js+2,k,1)) / eight
          vel(i,js-1,k,3) = (fifteen*vel(i,js  ,k,3) - ten*vel(i,js+1,k,3) + 
     $                         three*vel(i,js+2,k,3)) / eight
          vel(i,js-2,k,1) = vel(i,js-1,k,1)
          vel(i,js-3,k,1) = vel(i,js-1,k,1)
          vel(i,js-2,k,3) = vel(i,js-1,k,3)
          vel(i,js-3,k,3) = vel(i,js-1,k,3)
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do k = ks-3,ke+3
          do i = is-3,ie+3 
            vel(i,js-ng,k,1) = zero
            vel(i,js-ng,k,3) = zero
          enddo
          enddo
          enddo
        endif

      elseif (BCY_LO .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,lo_3-3,2),DIMS,time,dx,1,0)

        do ng = 1,3
        do k = ks-3,ke+3
        do i = is-3,ie+3
          vel(i,js-ng,k,1) = zero
          vel(i,js-ng,k,3) = zero
        enddo
        enddo
        enddo

      elseif (BCY_LO .eq. OUTLET) then

        do ng = 1,3
        do k = ks-3,ke+3
        do i = is-3,ie+3
          vel(i,js-ng,k,1) = vel(i,js,k,1)
          vel(i,js-ng,k,2) = vel(i,js,k,2)
          vel(i,js-ng,k,3) = vel(i,js,k,3)
        enddo
        enddo
        enddo

      else

      endif

      if (BCY_HI .eq. WALL) then

        do ng = 1,3
        do k = ks-3,ke+3 
        do i = is-3,ie+3 
          vel(i,je+ng,k,2) = zero
        enddo
        enddo
        enddo

        do k = ks-3,ke+3 
        do i = ilo,ihi
          vel(i,je+1,k,1) = (fifteen*vel(i,je  ,k,1) - ten*vel(i,je-1,k,1) + 
     $                     three*vel(i,je-2,k,1)) / eight
          vel(i,je+1,k,3) = (fifteen*vel(i,je  ,k,3) - ten*vel(i,je-1,k,3) + 
     $                     three*vel(i,je-2,k,3)) / eight
          vel(i,je+2,k,1) = vel(i,je+1,k,1)
          vel(i,je+3,k,1) = vel(i,je+1,k,1)
          vel(i,je+2,k,3) = vel(i,je+1,k,3)
          vel(i,je+3,k,3) = vel(i,je+1,k,3)
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do k = ks-3,ke+3
          do i = is-3,ie+3 
            vel(i,je+ng,k,1) = zero
            vel(i,je+ng,k,3) = zero
          enddo
          enddo
          enddo
        endif

      elseif (BCY_HI .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,lo_3-3,2),DIMS,time,dx,1,1)

        do ng = 1,3
        do k = ks-3,ke+3
        do i = is-3,ie+3 
          vel(i,je+ng,k,1) = zero
          vel(i,je+ng,k,3) = zero
        enddo
        enddo
        enddo

      elseif (BCY_HI .eq. OUTLET) then

        do ng = 1,3
        do k = ks-3,ke+3
        do i = is-3,ie+3
          vel(i,je+ng,k,1) = vel(i,je,k,1)
          vel(i,je+ng,k,2) = vel(i,je,k,2)
          vel(i,je+ng,k,3) = vel(i,je,k,3)
        enddo
        enddo
        enddo

      endif

      if (BCX_LO .eq. WALL) then

        do ng = 1,3
        do k = ks-3,ke+3 
        do j = js-3,je+3
          vel(is-ng,j,k,1) = zero
        enddo
        enddo
        enddo

        do k = ks-3,ke+3
        do j = js-3,je+3 
          vel(is-1,j,k,2) = (fifteen*vel(is  ,j,k,2) - ten*vel(is+1,j,k,2) + 
     $                         three*vel(is+2,j,k,2)) / eight
          vel(is-1,j,k,3) = (fifteen*vel(is  ,j,k,3) - ten*vel(is+1,j,k,3) + 
     $                         three*vel(is+2,j,k,3)) / eight
          vel(is-2,j,k,2) = vel(is-1,j,k,2)
          vel(is-3,j,k,2) = vel(is-1,j,k,2)
          vel(is-2,j,k,3) = vel(is-1,j,k,3)
          vel(is-3,j,k,3) = vel(is-1,j,k,3)
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do k = ks-3,ke+3
          do j = js-3,je+3 
            vel(is-ng,j,k,2) = zero
            vel(is-ng,j,k,3) = zero
          enddo
          enddo
          enddo
        endif

      elseif (BCX_LO .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,lo_3-3,1),DIMS,time,dx,0,0)

        do ng = 1,3
        do k = ks-3,ke+3 
        do j = js-3,je+3
          vel(is-ng,j,k,2) = zero
          vel(is-ng,j,k,3) = zero
        enddo
        enddo
        enddo

      elseif (BCX_LO .eq. OUTLET) then

        do ng = 1,3
        do k = ks-3,ke+3 
        do j = js-3,je+3
          vel(is-ng,j,k,1) = vel(is,j,k,1)
          vel(is-ng,j,k,2) = vel(is,j,k,2)
          vel(is-ng,j,k,3) = vel(is,j,k,3)
        enddo
        enddo
        enddo

      endif

      if (BCX_HI .eq. WALL) then

        do ng = 1,3
        do k = ks-3,ke+3
        do j = js-3,je+3
          vel(ie+ng,j,k,1) = zero
        enddo
        enddo
        enddo

        do k = ks-3,ke+3
        do j = js-3,je+3
          vel(ie+1,j,k,2) = (fifteen*vel(ie  ,j,k,2) - ten*vel(ie-1,j,k,2) + 
     $                         three*vel(ie-2,j,k,2)) / eight
          vel(ie+1,j,k,3) = (fifteen*vel(ie  ,j,k,3) - ten*vel(ie-1,j,k,3) + 
     $                         three*vel(ie-2,j,k,3)) / eight
          vel(ie+2,j,k,2) = vel(ie+1,j,k,2)
          vel(ie+3,j,k,2) = vel(ie+1,j,k,2)
          vel(ie+2,j,k,3) = vel(ie+1,j,k,3)
          vel(ie+3,j,k,3) = vel(ie+1,j,k,3)
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do k = ks-3,ke+3
          do j = js-3,je+3
            vel(ie+ng,j,k,2) = zero
            vel(ie+ng,j,k,3) = zero
          enddo
          enddo
          enddo
        endif

      elseif (BCX_HI .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,lo_3-3,1),DIMS,time,dx,0,1)

        do ng = 1,3
        do k = ks-3,ke+3
        do j = js-3,je+3
          vel(ie+ng,j,k,2) = zero
          vel(ie+ng,j,k,3) = zero
        enddo
        enddo
        enddo

      elseif (BCX_HI .eq. OUTLET) then

        do ng = 1,3
        do k = ks-3,ke+3
        do j = js-3,je+3
          vel(ie+ng,j,k,1) = vel(ie,j,k,1)
          vel(ie+ng,j,k,2) = vel(ie,j,k,2)
          vel(ie+ng,j,k,3) = vel(ie,j,k,3)
        enddo
        enddo
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** VELUPD **
c ** Update the velocity components using convective differencing of fluxes
c ** This field will then be projected to enforce the divergence constraint.
c *************************************************************************

      subroutine FORT_VELUPD(u,v,w,ustar,vstar,wstar,lapu,gradp,rhomid,
     $                       uadv,vadv,wadv,uhalfx,uhalfy,uhalfz,
     $                       force,dt,DIMS,dx)

      implicit none

      integer DIMS
      REAL_T       u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T       v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T       w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   ustar(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   vstar(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   wstar(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T   gradp(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  rhomid(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uadv(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T    vadv(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T    wadv(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T  uhalfx(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  uhalfy(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  uhalfz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T dt
      REAL_T dx(3)

c     Local variables
      integer i, j, k
      REAL_T ubar, vbar, wbar
      REAL_T ugradu, ugradv, ugradw

      do k = lo_3,hi_3 
       do j = lo_2,hi_2 
        do i = lo_1,hi_1 

          ubar = half*(uadv(i,j,k) + uadv(i+1,j,k))
          vbar = half*(vadv(i,j,k) + vadv(i,j+1,k))
          wbar = half*(wadv(i,j,k) + wadv(i,j,k+1))

          ugradu = ubar*(uhalfx(i+1,j,k,1) - uhalfx(i,j,k,1))/dx(1) + 
     $             vbar*(uhalfy(i,j+1,k,1) - uhalfy(i,j,k,1))/dx(2) +
     $             wbar*(uhalfz(i,j,k+1,1) - uhalfz(i,j,k,1))/dx(3)

          ugradv = ubar*(uhalfx(i+1,j,k,2) - uhalfx(i,j,k,2))/dx(1) + 
     $             vbar*(uhalfy(i,j+1,k,2) - uhalfy(i,j,k,2))/dx(2) +
     $             wbar*(uhalfz(i,j,k+1,2) - uhalfz(i,j,k,2))/dx(3)

          ugradw = ubar*(uhalfx(i+1,j,k,3) - uhalfx(i,j,k,3))/dx(1) + 
     $             vbar*(uhalfy(i,j+1,k,3) - uhalfy(i,j,k,3))/dx(2) +
     $             wbar*(uhalfz(i,j,k+1,3) - uhalfz(i,j,k,3))/dx(3)

          ustar(i,j,k) = u(i,j,k) + dt * ( half*lapu(i,j,k,1)/rhomid(i,j,k) 
     $                 - gradp(i,j,k,1)/rhomid(i,j,k) - ugradu + force(i,j,k,1) )

          vstar(i,j,k) = v(i,j,k) + dt * ( half*lapu(i,j,k,2)/rhomid(i,j,k) 
     $                 - gradp(i,j,k,2)/rhomid(i,j,k) - ugradv + force(i,j,k,2) )

          wstar(i,j,k) = w(i,j,k) + dt * ( half*lapu(i,j,k,3)/rhomid(i,j,k) 
     $                 - gradp(i,j,k,3)/rhomid(i,j,k) - ugradw + force(i,j,k,3) )

        enddo
       enddo
      enddo

      return
      end

c-----------------------------------------------------------------------
      subroutine hgfres_full(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, idim, idir, idd1)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision hx, hy
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1, 2)
      double precision sigmac(scl0:sch0,scl1:sch1, 2)
      integer ir, jr, idim, idir
      double precision fac0, fac1, tmp
      integer i, j, is, js, m, n
      integer idd1
      if (idim .eq. 0) then
         i = regl0
         if (idir .eq. 1) then
            is = i - 1
         else
            is = i
         end if
         fac0 = 1.d0 / 6.d0
         do j = regl1, regh1
            res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &          (sigmac(is,j-1,1) *
     &            (cdst(i-idir,j-1) - cdst(i,j-1) +
     &             2.d0 * (cdst(i-idir,j) - cdst(i,j))) +
     &           sigmac(is,j,1) *
     &            (cdst(i-idir,j+1) - cdst(i,j+1) +
     &             2.d0 * (cdst(i-idir,j) - cdst(i,j))) +
     &           sigmac(is,j-1,2) *
     &            (cdst(i-idir,j-1) - cdst(i-idir,j) +
     &             2.d0 * (cdst(i,j-1) - cdst(i,j))) +
     &           sigmac(is,j,2) *
     &            (cdst(i-idir,j+1) - cdst(i-idir,j) +
     &             2.d0 * (cdst(i,j+1) - cdst(i,j)))
     &           )
         end do
         fac0 = fac0 / jr
         i = i * ir
         if (idir .eq. 1) then
            is = i
         else
            is = i - 1
         end if
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*regl1, jr*regh1, jr
               tmp =
     &            sigmaf(is,j-n-1,1) *
     &             (fdst(i+idir,j-n-1) - fdst(i,j-n-1) +
     &              2.d0 * (fdst(i+idir,j-n) - fdst(i,j-n))) +
     &              sigmaf(is,j-n,1) *
     &             (fdst(i+idir,j-n+1) - fdst(i,j-n+1) +
     &              2.d0 * (fdst(i+idir,j-n) - fdst(i,j-n))) +
     &              sigmaf(is,j+n-1,1) *
     &             (fdst(i+idir,j+n-1) - fdst(i,j+n-1) +
     &              2.d0 * (fdst(i+idir,j+n) - fdst(i,j+n))) +
     &              sigmaf(is,j+n,1) *
     &             (fdst(i+idir,j+n+1) - fdst(i,j+n+1) +
     &              2.d0 * (fdst(i+idir,j+n) - fdst(i,j+n)))
               res(i,j) = res(i,j) - fac1 * (tmp +
     &              sigmaf(is,j-n-1,2) *
     &             (fdst(i+idir,j-n-1) - fdst(i+idir,j-n) +
     &              2.d0 * (fdst(i,j-n-1) - fdst(i,j-n))) +
     &              sigmaf(is,j-n,2) *
     &             (fdst(i+idir,j-n+1) - fdst(i+idir,j-n) +
     &              2.d0 * (fdst(i,j-n+1) - fdst(i,j-n))) +
     &              sigmaf(is,j+n-1,2) *
     &             (fdst(i+idir,j+n-1) - fdst(i+idir,j+n) +
     &              2.d0 * (fdst(i,j+n-1) - fdst(i,j+n))) +
     &              sigmaf(is,j+n,2) *
     &             (fdst(i+idir,j+n+1) - fdst(i+idir,j+n) +
     &              2.d0 * (fdst(i,j+n+1) - fdst(i,j+n)))
     &              )
            end do
         end do
      else
         j = regl1
         if (idir .eq. 1) then
            js = j - 1
         else
            js = j
         end if
         fac0 = 1.d0 / 6.d0
         do i = regl0, regh0
            res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &          (sigmac(i-1,js,1) *
     &            (cdst(i-1,j-idir) - cdst(i,j-idir) +
     &             2.d0 * (cdst(i-1,j) - cdst(i,j))) +
     &           sigmac(i,js,1) *
     &            (cdst(i+1,j-idir) - cdst(i,j-idir) +
     &             2.d0 * (cdst(i+1,j) - cdst(i,j))) +
     &           sigmac(i-1,js,2) *
     &            (cdst(i-1,j-idir) - cdst(i-1,j) +
     &             2.d0 * (cdst(i,j-idir) - cdst(i,j))) +
     &           sigmac(i,js,2) *
     &            (cdst(i+1,j-idir) - cdst(i+1,j) +
     &             2.d0 * (cdst(i,j-idir) - cdst(i,j)))
     &           )
         end do
         fac0 = fac0 / ir
         j = j * jr
         if (idir .eq. 1) then
            js = j
         else
            js = j - 1
         end if
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*regl0, ir*regh0, ir
               tmp =
     &              sigmaf(i-m-1,js,1) *
     &             (fdst(i-m-1,j+idir) - fdst(i-m,j+idir) +
     &              2.d0 * (fdst(i-m-1,j) - fdst(i-m,j))) +
     &              sigmaf(i-m,js,1) *
     &             (fdst(i-m+1,j+idir) - fdst(i-m,j+idir) +
     &              2.d0 * (fdst(i-m+1,j) - fdst(i-m,j))) +
     &              sigmaf(i+m-1,js,1) *
     &             (fdst(i+m-1,j+idir) - fdst(i+m,j+idir) +
     &              2.d0 * (fdst(i+m-1,j) - fdst(i+m,j))) +
     &              sigmaf(i+m,js,1) *
     &             (fdst(i+m+1,j+idir) - fdst(i+m,j+idir) +
     &              2.d0 * (fdst(i+m+1,j) - fdst(i+m,j)))
               res(i,j) = res(i,j) - fac1 * (tmp +
     &            sigmaf(i-m-1,js,2) *
     &             (fdst(i-m-1,j+idir) - fdst(i-m-1,j) +
     &              2.d0 * (fdst(i-m,j+idir) - fdst(i-m,j))) +
     &              sigmaf(i-m,js,2) *
     &             (fdst(i-m+1,j+idir) - fdst(i-m+1,j) +
     &              2.d0 * (fdst(i-m,j+idir) - fdst(i-m,j))) +
     &              sigmaf(i+m-1,js,2) *
     &             (fdst(i+m-1,j+idir) - fdst(i+m-1,j) +
     &              2.d0 * (fdst(i+m,j+idir) - fdst(i+m,j))) +
     &              sigmaf(i+m,js,2) *
     &             (fdst(i+m+1,j+idir) - fdst(i+m+1,j) +
     &              2.d0 * (fdst(i+m,j+idir) - fdst(i+m,j)))
     &              )
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgcres_full(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, ga, idd)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision hx, hy
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1, 2)
      double precision sigmac(scl0:sch0,scl1:sch1, 2)
      integer ir, jr, ga(0:1,0:1), idd
      double precision sum, fac, fac1
      integer ic, jc, if, jf, ii, ji, idir, jdir, m, n
      ic = regl0
      jc = regl1
      if = ic * ir
      jf = jc * jr
      sum = 0.d0
c quadrants
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) .eq. 1) then
               sum = sum
     &              + sigmaf(if+ii-1,jf+ji-1,1) *
     &              (fdst(if+idir,jf+jdir) - fdst(if,jf+jdir)
     &              + 2.d0 * (fdst(if+idir,jf) - fdst(if,jf)))
     &              + sigmaf(if+ii-1,jf+ji-1,2) *
     &            (fdst(if+idir,jf+jdir) - fdst(if+idir,jf)
     &             + 2.d0 * (fdst(if,jf+jdir) - fdst(if,jf)))
            else
               sum = sum
     &              + sigmac(ic+ii-1,jc+ji-1,1) *
     &            (cdst(ic+idir,jc+jdir) - cdst(ic,jc+jdir)
     &             + 2.d0 * (cdst(ic+idir,jc) - cdst(ic,jc)))
     &              + sigmac(ic+ii-1,jc+ji-1,2) *
     &            (cdst(ic+idir,jc+jdir) - cdst(ic+idir,jc)
     &             + 2.d0 * (cdst(ic,jc+jdir) - cdst(ic,jc)))
            end if
         end do
      end do
c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = 1.d0 / ir
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac * (
     &                 + sigmaf(if+m-1,jf+ji-1,1) *
     &                 (fdst(if+m-1,jf+jdir) - fdst(if+m,jf+jdir)
     &                 + 2.d0 * (fdst(if+m-1,jf) - fdst(if+m,jf)))
     &                 + sigmaf(if+m-1,jf+ji-1,2) *
     &                 (fdst(if+m-1,jf+jdir) - fdst(if+m-1,jf)
     &                 + 2.d0 * (fdst(if+m,jf+jdir) - fdst(if+m,jf)))
     &                 + sigmaf(if+m,jf+ji-1,1) *
     &               (fdst(if+m+1,jf+jdir) - fdst(if+m,jf+jdir)
     &                 + 2.d0 * (fdst(if+m+1,jf) - fdst(if+m,jf)))
     &                 + sigmaf(if+m,jf+ji-1,2) *
     &                 (fdst(if+m+1,jf+jdir) - fdst(if+m+1,jf)
     &                 + 2.d0 * (fdst(if+m,jf+jdir) - fdst(if+m,jf)))
     &                 )
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = 1.d0 / jr
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac * (
     &                 + sigmaf(if+ii-1,jf+n-1,1) *
     &                 (fdst(if+idir,jf+n-1) - fdst(if,jf+n-1)
     &                 + 2.d0 * (fdst(if+idir,jf+n) - fdst(if,jf+n)))
     &                 + sigmaf(if+ii-1,jf+n-1,2) *
     &                 (fdst(if+idir,jf+n-1) - fdst(if+idir,jf+n)
     &                 + 2.d0 * (fdst(if,jf+n-1) - fdst(if,jf+n)))
     &                 + sigmaf(if+ii-1,jf+n,1) *
     &                 (fdst(if+idir,jf+n+1) - fdst(if,jf+n+1)
     &                 + 2.d0 * (fdst(if+idir,jf+n) - fdst(if,jf+n)))
     &                 + sigmaf(if+ii-1,jf+n,2) *
     &                 (fdst(if+idir,jf+n+1) - fdst(if+idir,jf+n)
     &                 + 2.d0 * (fdst(if,jf+n+1) - fdst(if,jf+n)))
     &                 )
               end do
            end if
         end do
      end do
c weighting
      res(if,jf) = src(if,jf) - sum / 6.d0
      end

c nine-point terrain stencils
c-----------------------------------------------------------------------
      subroutine hgcen_full(cen, cenl0, cenh0, cenl1, cenh1,
     & sig, sbl0, sbh0, sbl1, sbh1,
     & regl0, regh0, regl1, regh1)
      integer cenl0, cenh0, cenl1, cenh1
      integer sbl0, sbh0, sbl1, sbh1
      integer regl0, regh0, regl1, regh1
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision sig(sbl0:sbh0,sbl1:sbh1, 2)
      double precision tmp
      integer i, j
      do j = regl1, regh1
         do i = regl0, regh0
            tmp = (sig(i-1,j-1,1) + sig(i-1,j,1)
     &           + sig(i  ,j-1,1) + sig(i  ,j,1)
     &           + sig(i-1,j-1,2) + sig(i-1,j,2)
     &           + sig(i  ,j-1,2) + sig(i  ,j,2))
            if ( tmp .eq. 0.0 ) then
               cen(i,j) = 0.0D0
            else
               cen(i,j) = 3.0D0 / tmp
            end if
         end do
      end do
c$$$      write(unit = 10, fmt = *) 'cen - hgcen_full'
c$$$      write(unit = 10, fmt = *) cen
c$$$      write(unit = 10, fmt = *) 'sig'
c$$$      write(unit = 10, fmt = *) sig
      end
c-----------------------------------------------------------------------
      subroutine hgrlx_full(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & sig,   sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision sig(sfl0:sfh0,sfl1:sfh1, 2)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision fac
      double precision AVG
      integer i, j
      AVG()= fac * (
     &     + sig(i-1,j-1,1) *
     &     (cor(i-1,j-1) - cor(i,j-1) + 2.d0 * cor(i-1,j))
     &     + sig(i-1,j  ,1) *
     &     (cor(i-1,j+1) - cor(i,j+1) + 2.d0 * cor(i-1,j))
     &     + sig(i  ,j-1,1) *
     &     (cor(i+1,j-1) - cor(i,j-1) + 2.d0 * cor(i+1,j))
     &     + sig(i  ,j  ,1) *
     &     (cor(i+1,j+1) - cor(i,j+1) + 2.d0 * cor(i+1,j))
     &     + sig(i-1,j-1,2) *
     &     (cor(i-1,j-1) - cor(i-1,j) + 2.d0 * cor(i,j-1))
     &     + sig(i-1,j  ,2) *
     &     (cor(i-1,j+1) - cor(i-1,j) + 2.d0 * cor(i,j+1))
     &     + sig(i  ,j-1,2) *
     &     (cor(i+1,j-1) - cor(i+1,j) + 2.d0 * cor(i,j-1))
     &     + sig(i  ,j  ,2) *
     &     (cor(i+1,j+1) - cor(i+1,j) + 2.d0 * cor(i,j+1))
     &     )

      fac = 1.d0 / 6.d0
      do j = regl1, regh1
cdir$ ivdep
         do i = regl0, regh0
               cor(i,j) = (AVG() - res(i,j)) * cen(i,j)
         end do
      end do
c$$$      write(unit = 10, fmt = *) 'cor'
c$$$      write(unit = 10, fmt = *) cor
c$$$      write(unit = 10, fmt = *) 'sig'
c$$$      write(unit = 10, fmt = *) sig
c$$$      write(unit = 10, fmt = *) 'res'
c$$$      write(unit = 10, fmt = *) res
c$$$      write(unit = 10, fmt = *) 'cen'
c$$$      write(unit = 10, fmt = *) cen
c$$$      stop
      end
c-----------------------------------------------------------------------
      subroutine hgres_full(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & dest,  destl0, desth0, destl1, desth1,
     & sig,   sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer destl0, desth0, destl1, desth1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision dest(destl0:desth0,destl1:desth1)
      double precision sig(sfl0:sfh0,sfl1:sfh1, 2)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision fac, tmp
      integer i, j
      fac = 1.d0 / 6.d0
      do j = regl1, regh1
         do i = regl0, regh0
               tmp =
     &           (sig(i-1,j-1,1) *
     &             (dest(i-1,j-1) - dest(i,j-1) +
     &              2.d0 * (dest(i-1,j) - dest(i,j))) +
     &            sig(i-1,j,1) *
     &             (dest(i-1,j+1) - dest(i,j+1) +
     &              2.d0 * (dest(i-1,j) - dest(i,j))) +
     &            sig(i,j-1,1) *
     &             (dest(i+1,j-1) - dest(i,j-1) +
     &              2.d0 * (dest(i+1,j) - dest(i,j))) +
     &            sig(i,j,1) *
     &             (dest(i+1,j+1) - dest(i,j+1) +
     &              2.d0 * (dest(i+1,j) - dest(i,j))))
               res(i,j) = src(i,j) - fac * (tmp +
     &           (sig(i-1,j-1,2) *
     &             (dest(i-1,j-1) - dest(i-1,j) +
     &              2.d0 * (dest(i,j-1) - dest(i,j))) +
     &            sig(i-1,j,2) *
     &             (dest(i-1,j+1) - dest(i-1,j) +
     &              2.d0 * (dest(i,j+1) - dest(i,j))) +
     &            sig(i,j-1,2) *
     &             (dest(i+1,j-1) - dest(i+1,j) +
     &              2.d0 * (dest(i,j-1) - dest(i,j))) +
     &            sig(i,j,2) *
     &             (dest(i+1,j+1) - dest(i+1,j) +
     &              2.d0 * (dest(i,j+1) - dest(i,j)))))
         end do
      end do
      end
c-----------------------------------------------------------------------

      subroutine hgrlnf_full(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & wrk,   wrkl0, wrkh0, wrkl1, wrkh1,
     & sig,   sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     &        doml0, domh0, doml1, domh1,
     & lsd, ipass)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer wrkl0, wrkh0, wrkl1, wrkh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      integer doml0, domh0, doml1, domh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1)
      double precision sig(sfl0:sfh0,sfl1:sfh1, 2)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      integer lsd, ipass
      double precision fac, betm, aj
      double precision RHSL0,RHSL1
      integer i, j, ioff
      RHSL0() = (res(i,j) - fac * (
     &           sig(i-1,j-1,1) *
     &             (cor(i-1,j-1) - cor(i,j-1)) +
     &            sig(i-1,j,1) *
     &             (cor(i-1,j+1) - cor(i,j+1)) +
     &            sig(i,j-1,1) *
     &             (cor(i+1,j-1) - cor(i,j-1)) +
     &            sig(i,j,1) *
     &             (cor(i+1,j+1) - cor(i,j+1)) +
     &            sig(i-1,j-1,2) *
     &             (cor(i-1,j-1) + 2.d0 * cor(i,j-1)) +
     &            sig(i-1,j,2) *
     &             (cor(i-1,j+1) + 2.d0 * cor(i,j+1)) +
     &            sig(i,j-1,2) *
     &             (cor(i+1,j-1) + 2.d0 * cor(i,j-1)) +
     &            sig(i,j,2) *
     &             (cor(i+1,j+1) + 2.d0 * cor(i,j+1))))

      RHSL1() = (res(i,j) - fac * (
     &           sig(i-1,j-1,1) *
     &             (cor(i-1,j-1) + 2.d0 * cor(i-1,j)) +
     &            sig(i-1,j,1) *
     &             (cor(i-1,j+1) + 2.d0 * cor(i-1,j)) +
     &            sig(i,j-1,1) *
     &             (cor(i+1,j-1) + 2.d0 * cor(i+1,j)) +
     &            sig(i,j,1) *
     &             (cor(i+1,j+1) + 2.d0 * cor(i+1,j)) +
     &            sig(i-1,j-1,2) *
     &             (cor(i-1,j-1) - cor(i-1,j)) +
     &            sig(i-1,j,2) *
     &             (cor(i-1,j+1) - cor(i-1,j)) +
     &            sig(i,j-1,2) *
     &            (cor(i+1,j-1) - cor(i+1,j)) +
     &            sig(i,j,2) *
     &             (cor(i+1,j+1) - cor(i+1,j))))
      fac = 1.d0 / 6.d0
      if (lsd .eq. 0) then
         if (mod(regl1,2) .eq. 0) then
            ioff = ipass
         else
            ioff = 1 - ipass
         end if
         i = regl0
         do j = regl1 + ioff, regh1, 2
            aj = fac *
     &        (2.d0 * (sig(i,j-1,1) + sig(i,j,1)) -
     &         (sig(i,j-1,2) + sig(i,j,2)))
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               wrk(i,j) = 0.d0
            else if (regl0 .eq. doml0) then
c neumann bdy:
               betm = -cen(i,j)
               cor(i,j) = RHSL0() * betm
               wrk(i,j) = 2.d0 * aj * betm
            end if
            wrk(i+1,j) = aj
         end do
c forward solve loop:
         do i = regl0 + 1, regh0 - 1
            do j = regl1 + ioff, regh1, 2
               aj = wrk(i,j)
               if (cen(i,j) .eq. 0.d0) then
                  betm = 0.d0
               else
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
               end if
               cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
               aj = fac *
     &           (2.d0 * (sig(i,j-1,1) + sig(i,j,1)) -
     &            (sig(i,j-1,2) + sig(i,j,2)))
               wrk(i+1,j) = aj
               wrk(i,j) = aj * betm
            end do
         end do
         i = regh0
         do j = regl1 + ioff, regh1, 2
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
            else if (regh0 .eq. domh0) then
c neumann bdy:
               aj = 2.d0 * wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
               cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
            else if (i .gt. regl0) then
c interface to grid at same level:
               aj = wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
               cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
               aj = fac *
     &           (2.d0 * (sig(i,j-1,1) + sig(i,j,1)) -
     &            (sig(i,j-1,2) + sig(i,j,2)))
               wrk(i,j) = aj * betm
            end if
         end do
      else
         if (mod(regl0,2) .eq. 0) then
            ioff = ipass
         else
            ioff = 1 - ipass
         end if
         j = regl1
         do i = regl0 + ioff, regh0, 2
            aj = fac *
     &        (2.d0 * (sig(i-1,j,2) + sig(i,j,2)) -
     &         (sig(i-1,j,1) + sig(i,j,1)))
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               wrk(i,j) = 0.d0
            else if (regl1 .eq. doml1) then
c neumann bdy:
               betm = -cen(i,j)
               cor(i,j) = RHSL1() * betm
               wrk(i,j) = 2.d0 * aj * betm
            end if
            wrk(i,j+1) = aj
         end do
c forward solve loop:
         do j = regl1 + 1, regh1 - 1
            do i = regl0 + ioff, regh0, 2
               aj = wrk(i,j)
               if (cen(i,j) .eq. 0.d0) then
                  betm = 0.d0
               else
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
               end if
               cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               aj = fac *
     &           (2.d0 * (sig(i-1,j,2) + sig(i,j,2)) -
     &            (sig(i-1,j,1) + sig(i,j,1)))
               wrk(i,j+1) = aj
               wrk(i,j) = aj * betm
            end do
         end do
         j = regh1
         do i = regl0 + ioff, regh0, 2
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
            else if (regh1 .eq. domh1) then
c neumann bdy:
               aj = 2.d0 * wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
               cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
            else if (j .gt. regl1) then
c interface to grid at same level:
               aj = wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
               cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               aj = fac *
     &           (2.d0 * (sig(i-1,j,2) + sig(i,j,2)) -
     &            (sig(i-1,j,1) + sig(i,j,1)))
               wrk(i,j) = aj * betm
            end if
         end do
      end if
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: PROB_3D.F,v 1.6 2003/01/22 23:11:05 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROB_F.H"
#include "ArrayLim.H"
#include "integrator.fh"

#define SDIM 3


c ::: -----------------------------------------------------------
c ::: This routine is called at problem initialization time
c ::: and when restarting from a checkpoint file.
c ::: The purpose is (1) to specify the initial time value
c ::: (not all problems start at time=0.0) and (2) to read
c ::: problem specific data from a namelist or other input
c ::: files and possibly store them or derived information
c ::: in FORTRAN common blocks for later use.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: init      => TRUE if called at start of problem run
c :::              FALSE if called from restart
c ::: name      => name of "probin" file
c ::: namlen    => length of name
c ::: strttime <=  start problem with this time variable
c ::: 
c ::: -----------------------------------------------------------
c
      subroutine FORT_PROBINIT (init,name,namlen,problo,probhi)
      integer init,namlen
      integer name(namlen)
      REAL_T  problo(SDIM), probhi(SDIM)

      integer untin,i,j,k

#include "probdata.H"
#include "xxmeth.fh"

      namelist /fortin/ tol_int, dengrad, bubgrad,ecent,
     $                   xcloud,ycloud,zcloud,radius,pertmag,
     $                   denfact,shockpos,rmach,
     $                   gamamb,gamcld,difmag, iorder, smallr, smallp, small

      REAL_T rn
c
c      Build "probin" filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      character probin*(maxlen)

      if (namlen .gt. maxlen) then
         write(6,*) 'probin file name too long'
         stop
      end if

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      pertmag = zero

      untin = 9
      if (namlen .eq. 0) then
c        open(untin,file='probin',form='formatted',status='old', action='read')
         open(untin,file='probin',form='formatted',status='old')
      else
c        open(untin,file=probin(1:namlen),form='formatted',status='old', action='read')
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if
      read(untin,fortin)
c      write(6,fortin)
      close(unit=untin)


c ::: define state of ambient gas
      rhoamb = one
      pamb = one/gamamb
      u1amb = zero
      u2amb = zero
      u3amb = zero
      eamb = pamb/((gamamb-one)*rhoamb)
c
c ::: define state of ambient but dense cloud
c
      rhocld = rhoamb*denfact
      pcld = pamb
      u1cld = u1amb
      u2cld = u2amb
      u3cld = u3amb
      ecld = pcld/((gamcld-one)*rhocld)
c
c ::: define state of shock
c
      ashk = sqrt(gamamb*pamb/rhoamb)
      u1shk = ashk*two*(rmach**2-one)/((gamamb+one)*rmach )
      u2shk = zero
      u3shk = zero
      rhoshk = rhoamb*((gamamb+one)*rmach**2)/((gamamb-one)*rmach**2 + two)
      pshk = pamb*(one + ( two*gamamb*(rmach**2 - one)) / (gamamb+one) )
      eshk = pshk / ((gamamb-one)*rhoshk)
     
      u1amb = u1amb - u1shk
      u1cld = u1cld - u1shk
      u1shk = zero
c
c ::: translate to conserved quantities
c
      eamb = rhoamb*(eamb + half*(u1amb**2 + u2amb**2 + u3amb**2))
      u1amb = rhoamb*u1amb
      u2amb = rhoamb*u2amb
      u3amb = rhoamb*u3amb

      eshk = rhoshk*(eshk + half*(u1shk**2 + u2shk**2 + u3shk**2))
      u1shk = rhoshk*u1shk
      u2shk = rhoshk*u2shk
      u3shk = rhoshk*u3shk

      ecld = rhocld*(ecld + half*(u1cld**2 + u2cld**2 + u3cld**2))
      u1cld = rhocld*u1cld
      u2cld = rhocld*u2cld
      u3cld = rhocld*u3cld

c
c  set random amplitudes
c
         if (pertmag .gt. zero) then

            do k = 4,8
               do j = 4,8
                  do i = 4,8
                     call blutilrand(rn)
                     ranampl(i,j,k) =  pertmag * two * (rn - half)
                     call blutilrand(rn)
                     ranphse(i,j,k) =   two * Pi * rn 
                  end do
               end do
            end do

         end if

      return
      end

c ::: -----------------------------------------------------------
c ::: This routine is called at problem setup time and is used
c ::: to initialize data on each grid.  
c ::: 
c ::: NOTE:  all arrays have one cell of ghost zones surrounding
c :::        the grid interior.  Values in these cells need not
c :::        be set here.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: level     => amr level of grid
c ::: time      => time at which to init data             
c ::: lo,hi     => index limits of grid interior (cell centered)
c ::: nstate    => number of state components.  You should know
c :::		   this already!
c ::: state     <=  Scalar array
c ::: delta     => cell size
c ::: xlo,xhi   => physical locations of lower left and upper
c :::              right hand corner of grid.  (does not include
c :::		   ghost region).
c ::: -----------------------------------------------------------
        subroutine FORT_INITDATA(level, time, lo, hi,
     $                           nstate, state, DIMS(state),
     $                           delta, xlo, xhi)

      integer    level, nstate
      integer    lo(SDIM),hi(SDIM)
      integer    DIMDEC(state)

      REAL_T     time, delta(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     state(DIMV(state),nstate)

c     ::::: local variables
      REAL_T     pert, dist

#include "probdata.H"

c ::: local var
      integer i, j, k, ii, jj, kk, intsx, intsy, intsz
      integer iamp,jamp,kamp
      REAL_T  dx, dy, dz,  rsq
      REAL_T  xcen, ycen, zcen
      
      dx = delta(1)
      dy = delta(2)
      dz = delta(3)


      do k = lo(3), hi(3)   
       do j = lo(2), hi(2)     
         do i = lo(1), hi(1)   

              xcen = xlo(1) + dx*(float(i-lo(1)) + half)
              ycen = xlo(2) + dy*(float(j-lo(2)) + half)
              zcen = xlo(3) + dz*(float(k-lo(3)) + half)

              if (xcen .lt. shockpos) then
                  state(i,j,k,1) = rhoshk
                  state(i,j,k,2) = u1shk
                  state(i,j,k,3) = u2shk
                  state(i,j,k,4) = u3shk
                  state(i,j,k,5) = eshk
#if(NADV>0)
                  state(i,j,k,6) = zero
#endif
              else
                  rsq = (xcen-xcloud)**2+(ycen-ycloud)**2+
     1                  ((zcen-zcloud)**2)/ecent
                  dist = sqrt(rsq)
                  if (dist .le. radius) then
                      pert = one
                      do kamp = 4,8
                      do jamp = 4,8
                      do iamp = 4,8
 
                         pert = pert + ranampl(iamp,jamp,kamp)*
     &                        cos(ranphse(iamp,jamp,kamp)+two*Pi*kamp*(xcen-xcloud)/radius)*
     &                        cos(ranphse(iamp,jamp,kamp)+two*Pi*jamp*(ycen-ycloud)/radius)*
     &                        cos(ranphse(iamp,jamp,kamp)+two*Pi*iamp*(zcen-zcloud)/radius)

                      end do
                      end do
                      end do
                      state(i,j,k,1) = pert * rhocld
                      state(i,j,k,2) = pert * u1cld
                      state(i,j,k,3) = pert * u2cld
                      state(i,j,k,4) = pert * u3cld
                      state(i,j,k,5) = pert * ecld
#if(NADV>0)
                      state(i,j,k,6) = pert * rhocld
#endif
                  else
                      state(i,j,k,1) = rhoamb
                      state(i,j,k,2) = u1amb
                      state(i,j,k,3) = u2amb
                      state(i,j,k,4) = u3amb
                      state(i,j,k,5) = eamb
#if(NADV>0)
                      state(i,j,k,6) = zero
#endif
                  end if
              end if

         end do
       end do
      end do

      return
      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: density gradient
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: lo,hi     => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: rho       => density array
c ::: ng        => number of ghost zones in rho array (should be 1)
c ::: nvar      => number of components in rho array (should be 1)
c ::: domlo,hi  => index extent of problem domain
c ::: delta     => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_DENERROR (tag,DIMS(tag),set,clear,
     &                          adv,DIMS(adv),lo,hi,nvar,
     &                          domlo,domhi,delta,xlo,
     &			        problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(adv)
      integer   lo(SDIM), hi(SDIM)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      REAL_T    delta(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    adv(DIMV(adv),nvar)
      REAL_T    x, y, z,ax, ay, az,aerr, denloc
      integer   i, j,k, leni, lenj, lenk
      REAL_T tracer
      logical ltest

#include "probdata.H"
#include "xxmeth.fh"

      leni = hi(1)-lo(1)
      lenj = hi(2)-lo(2)
      lenk = hi(3)-lo(3)
      
      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               ax = abs(adv(i+1,j,k,1) - adv(i-1,j,k,1))
               ay = abs(adv(i,j+1,k,1) - adv(i,j-1,k,1))
               az = abs(adv(i,j,k+1,1) - adv(i,j,k-1,1))
               aerr = max(ax,ay,az)
               denloc = min(adv(i,j,k,1),adv(i,j,k+1,1),adv(i,j,k-1,1))
               denloc = min(denloc,adv(i,j+1,k,1),adv(i,j-1,k,1))
               denloc = min(denloc,adv(i+1,j,k,1),adv(i-1,j,k,1))
               denloc = max(denloc,smallr)
               aerr = aerr / denloc
               tag(i,j,k) = cvmgt(set,tag(i,j,k),aerr.gt.dengrad)
            end do
         end do
      end do

      if (tol_int .gt. zero ) then
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tracer = adv(i,j,k,6)/adv(i,j,k,1)
                  ltest = (tracer.gt.tol_int) .and. (tracer.lt. (one-tol_int))
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),ltest)
               end do
            end do
         end do
      end if

      end

c
c     Fill den, xmom, ymom, zden, eden as a group.
c
      subroutine FORT_HYPFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                         xlo,time,bc)

      integer 	 DIMS(adv)
      integer    bc(SDIM,2,5)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv),5)

      call FORT_DENFILL  (adv(ARG_L1(adv),ARG_L2(adv),ARG_L3(adv),1),
     & DIMS(adv),domlo,domhi,delta,xlo,time,bc(1,1,1))

      call FORT_XMOMFILL (adv(ARG_L1(adv),ARG_L2(adv),ARG_L3(adv),2),
     & DIMS(adv),domlo,domhi,delta,xlo,time,bc(1,1,2))

      call FORT_YMOMFILL (adv(ARG_L1(adv),ARG_L2(adv),ARG_L3(adv),3),
     & DIMS(adv),domlo,domhi,delta,xlo,time,bc(1,1,3))

      call FORT_ZMOMFILL (adv(ARG_L1(adv),ARG_L2(adv),ARG_L3(adv),4),
     & DIMS(adv),domlo,domhi,delta,xlo,time,bc(1,1,4))

      call FORT_EDENFILL (adv(ARG_L1(adv),ARG_L2(adv),ARG_L3(adv),5),
     & DIMS(adv),domlo,domhi,delta,xlo,time,bc(1,1,5))

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: adv      <=  advected quantity array
c ::: lo,hi     => index extent of adv array
c ::: domlo,hi  => index extent of problem domain
c ::: delta     => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of adv array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_DENFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                         xlo,time,bc)

      integer 	 DIMS(adv)	
      integer    bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))

      integer    i, j, k
      REAL_T     y,x
      integer    lo(SDIM),hi(SDIM)

#include "probdata.H"

      lo(1) = adv_l1
      lo(2) = adv_l2
      lo(3) = adv_l3
      hi(1) = adv_h1
      hi(2) = adv_h2
      hi(3) = adv_h3

      call filcc (adv,DIMS(adv),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = rhoshk
               end do
            end do
         end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = rhoamb
               end do
            end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do i = lo(1), hi(1)
               do k = lo(3),hi(3)
                  adv(i,j,k) = adv(i,domlo(2),k)                     
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do i = lo(1), hi(1)
               do k = lo(3),hi(3)
                  adv(i,j,k) = adv(i,domhi(2),k)                         
               end do
            end do
	 end do
      end if

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domlo(3))                     
               end do
            end do
	 end do
      end if            

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domhi(3))                         
               end do
            end do
         end do
      end if          

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: adv      <=  advected quantity array
c ::: lo,hi     => index extent of adv array
c ::: domlo,hi  => index extent of problem domain
c ::: delta     => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of adv array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_XMOMFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMS(adv)
      integer    bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))

      integer    i, j,k
      REAL_T     y,x
      integer lo(SDIM),hi(SDIM)

       
#include "probdata.H"
      lo(1) = adv_l1
      lo(2) = adv_l2
      lo(3) = adv_l3
      hi(1) = adv_h1
      hi(2) = adv_h2
      hi(3) = adv_h3

      call filcc (adv,DIMS(adv),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = u1shk
               end do
            end do
         end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = u1amb
               end do
            end do
         end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = adv(i,domlo(2),k)                     
               end do
            end do
         end do
      end if

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = adv(i,domhi(2),k)                     
               end do
            end do
         end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domlo(3))                     
               end do
            end do
	 end do
      end if            

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domhi(3))                         
               end do
            end do
         end do
      end if

      end

      subroutine FORT_YMOMFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMS(adv)
      integer    lo(SDIM), hi(SDIM), bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))

      integer    i, j, k   
      REAL_T     y,x

#include "probdata.H"

      lo(1) = adv_l1
      lo(2) = adv_l2
      lo(3) = adv_l3
      hi(1) = adv_h1
      hi(2) = adv_h2
      hi(3) = adv_h3

      call filcc (adv,DIMS(adv),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  y = xlo(2) + delta(2)*(float(j-lo(2)) + 0.5)
                  adv(i,j,k) = u2shk
               end do
            end do
         end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = u2amb
               end do
            end do
         end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = -adv(i,domlo(2),k)
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = -adv(i,domhi(2),k)
               end do
            end do
         end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domlo(3))                     
               end do
            end do
	 end do
      end if

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domhi(3))                         
               end do
            end do
         end do
      end if

      end

      subroutine FORT_ZMOMFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMS(adv)
      integer    bc(SDIM,2),lo(SDIM),hi(SDIM)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))

      integer    i, j, k
      REAL_T     y,x

#include "probdata.H"

      lo(1) = adv_l1
      lo(2) = adv_l2
      lo(3) = adv_l3
      hi(1) = adv_h1
      hi(2) = adv_h2
      hi(3) = adv_h3

      call filcc (adv,DIMS(adv),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = u3shk
               end do
            end do
         end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = u3amb
               end do
            end do
         end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = -adv(i,domlo(2),k)
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = -adv(i,domhi(2),k)
               end do
            end do
         end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = -adv(i,j,domlo(3))                     
               end do
            end do
	 end do
      end if            

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = -adv(i,j,domhi(3))                         
               end do
            end do
         end do
      end if

      end

      subroutine FORT_EDENFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMS(adv)
      integer    lo(SDIM), hi(SDIM), bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))

      integer    i, j,k
      REAL_T     y,x

#include "probdata.H"

      lo(1) = adv_l1
      lo(2) = adv_l2
      lo(3) = adv_l3
      hi(1) = adv_h1
      hi(2) = adv_h2
      hi(3) = adv_h3

      call filcc (adv,DIMS(adv),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = eshk
               end do
            end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = eamb
               end do
            end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = adv(i,domlo(2),k)
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = adv(i,domhi(2),k)
               end do
            end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domlo(3))                     
               end do
            end do
         end do
      end if            

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domhi(3))                         
               end do
            end do
         end do
      end if

      end

      subroutine FORT_TRACFILL (adv,DIMS(adv),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMS(adv)
      integer    lo(SDIM), hi(SDIM), bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))

      integer    i, j,k
      REAL_T     y,x

#include "probdata.H"

      lo(1) = adv_l1
      lo(2) = adv_l2
      lo(3) = adv_l3
      hi(1) = adv_h1
      hi(2) = adv_h2
      hi(3) = adv_h3

      call filcc (adv,DIMS(adv),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do j = lo(2), hi(2)
               do k = lo(3), hi(3)
                  adv(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = adv(i,domlo(2),k)
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do i = lo(1), hi(1)
               do k = lo(3), hi(3)
                  adv(i,j,k) = adv(i,domhi(2),k)
               end do
            end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domlo(3))                     
               end do
            end do
         end do
      end if            

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do i = lo(1), hi(1)
               do j = lo(2), hi(2)
                  adv(i,j,k) = adv(i,j,domhi(3))                         
               end do
            end do
         end do
      end if

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "VISC_F.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define twentyfive 25.e0
#else
#define twentyfive 25.d0
#endif

#define DIMS  lo_1,lo_2,hi_1,hi_2
#define CDIMS loc_1,loc_2,hic_1,hic_2

c *************************************************************************
c ** RESID **
c ** Compute the residual. 
c *************************************************************************

      subroutine FORT_RESID(res,u,f,areax,areay,alpha,DIMS, 
     $                      dx,irz,resnorm,bc,level,idir,mu,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    res(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T      u(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T  areax(lo_1-ng+1:hi_1+ng  ,lo_2-ng+1:hi_2+ng-1)
      REAL_T  areay(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng  )
      REAL_T  alpha(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T  dx(2)
      REAL_T  resnorm
      integer irz
      integer bc(2,2)
      integer level
      integer idir
      REAL_T  mu

c     Local variables
      REAL_T rlu
      REAL_T r, vol
      integer i,j
      integer is,ie,js,je

      REAL_T ux_left,ux_left_wall
      REAL_T ux_rght,ux_rght_wall
      REAL_T uy_bot ,uy_bot_wall
      REAL_T uy_top ,uy_top_wall

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      call gsrbvbc(u,DIMS,bc,irz,idir,ng)

      resnorm = zero

      do j = js, je
      do i = is, ie

          ux_left = (u(i,j) - u(i-1,j)) 
          ux_left_wall = (-sixteen * u(is-1,j) + twenty * u(is,j)
     $                       -five * u(is+1,j) + u(is+2,j) ) * fifth
          ux_left = cvmgt(ux_left_wall, ux_left, i .eq. is .and.
     $                    (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) .and.
     $                    (irz .eq. 0 .or. (irz .eq. 1 .and. idir .eq. 0) ) )
          ux_left = areax(i,j) * ux_left / dx(1)

          ux_rght = (u(i+1,j) - u(i,j)) 
          ux_rght_wall = -(-sixteen * u(ie+1,j) + twenty * u(ie,j)
     $                        -five * u(ie-1,j) + u(ie-2,j) ) * fifth
          ux_rght = cvmgt(ux_rght_wall, ux_rght, i .eq. ie .and.
     $                    (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
          ux_rght = areax(i+1,j) * ux_rght / dx(1)

          uy_bot = (u(i,j) - u(i,j-1)) 
          uy_bot_wall = (-sixteen * u(i,js-1) + twenty * u(i,js)
     $                       -five * u(i,js+1) + u(i,js+2) ) * fifth
          uy_bot = cvmgt(uy_bot_wall, uy_bot, j .eq. js .and.
     $                    (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
          uy_bot = areay(i,j) * uy_bot / dx(2)

          uy_top = (u(i,j+1) - u(i,j)) 
          uy_top_wall = -(-sixteen * u(i,je+1) + twenty * u(i,je)
     $                       -five * u(i,je-1) + u(i,je-2) ) * fifth
          uy_top = cvmgt(uy_top_wall, uy_top, j .eq. je .and.
     $                    (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
          uy_top = areay(i,j+1) * uy_top / dx(2)

          rlu = alpha(i,j)*u(i,j) - mu*((ux_rght - ux_left)+
     $                                  (uy_top  - uy_bot ) )
          res(i,j) = f(i,j) - rlu

      enddo
      enddo

      if (irz .eq. 1 .and. idir .eq. 0) then
          do j = js,je 
            do i = is,ie 
              r = (i+half)*dx(1)
              vol = r * dx(1) * dx(2)
              res(i,j) = res(i,j) - mu*vol*u(i,j)/(r*r)
            enddo
          enddo
      endif

      do j = js,je 
        do i = is,ie 
          resnorm = max(resnorm,abs(res(i,j)))
        enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRBV **
c ** Gauss-Seidel red-black relaxation 
c *************************************************************************

      subroutine FORT_GSRBV(u,f,areax,areay,alpha,DIMS,dx,bc,level,
     $                      idir,nngsrb,mu,irz,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T      u(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T  areax(lo_1-ng+1:hi_1+ng  ,lo_2-ng+1:hi_2+ng-1)
      REAL_T  areay(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng  )
      REAL_T  alpha(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T dx(2)
      integer bc(2,2)
      integer level
      integer idir
      integer nngsrb
      integer irz
      REAL_T  mu

c     Local variables
      REAL_T rlam,rlu
      integer i,j,iter,iinc
      integer is,ie,js,je
      integer extra_xlo,extra_xhi,extra_ylo,extra_yhi

      REAL_T ux_left,ux_left_wall
      REAL_T ux_rght,ux_rght_wall
      REAL_T uy_bot ,uy_bot_wall
      REAL_T uy_top ,uy_top_wall
      REAL_T facx_left,facx_rght
      REAL_T facy_bot ,facy_top
      REAL_T r, vol
      logical ltest

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      call gsrbvbc(u,DIMS,bc,0,idir,ng)

      do iter = 1, 2*nngsrb
 
         extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
         extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
         extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
         extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)

 
         do j = lo_2-extra_ylo,hi_2+extra_yhi
            iinc = mod(j+iter+1+extra_xlo,2)
            do i = lo_1-extra_xlo+iinc,hi_1+extra_xhi,2

              ux_left = (u(i,j) - u(i-1,j)) 
              ux_left_wall = (-sixteen * u(is-1,j) + twenty * u(is,j)
     $                           -five * u(is+1,j) + u(is+2,j) ) * fifth
              ltest = (i .eq. is .and. level .eq. 0 .and. 
     $                 (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) .and.
     $                 (irz .eq. 0 .or. (irz .eq. 1 .and. idir .eq. 0) ) )
              ux_left   = cvmgt(ux_left_wall,ux_left,ltest)
              facx_left = cvmgt(four        ,one    ,ltest)
              ux_left   = areax(i,j) *   ux_left / dx(1)
              facx_left = areax(i,j) * facx_left / dx(1)

              ux_rght = (u(i+1,j) - u(i,j)) 
              ux_rght_wall = -(-sixteen * u(ie+1,j) + twenty * u(ie,j)
     $                            -five * u(ie-1,j) + u(ie-2,j) ) * fifth
              ltest = (i .eq. ie .and. level .eq. 0 .and. 
     $                 (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
              ux_rght   = cvmgt(ux_rght_wall,ux_rght,ltest)
              facx_rght = cvmgt(four        ,one    ,ltest)
              ux_rght   = areax(i+1,j) *   ux_rght / dx(1)
              facx_rght = areax(i+1,j) * facx_rght / dx(1)

              uy_bot = (u(i,j) - u(i,j-1)) 
              uy_bot_wall = (-sixteen * u(i,js-1) + twenty * u(i,js)
     $                          -five * u(i,js+1) + u(i,js+2) ) * fifth
              ltest = (j .eq. js .and. level .eq. 0 .and. 
     $                 (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
              uy_bot   = cvmgt(uy_bot_wall,uy_bot,ltest)
              facy_bot = cvmgt(four       ,one   ,ltest)
              uy_bot   = areay(i,j) *   uy_bot / dx(2)
              facy_bot = areay(i,j) * facy_bot / dx(2)

              uy_top = (u(i,j+1) - u(i,j)) 
              uy_top_wall = -(-sixteen * u(i,je+1) + twenty * u(i,je)
     $                           -five * u(i,je-1) + u(i,je-2) ) * fifth
              ltest = (j .eq. je .and. level .eq. 0 .and. 
     $                 (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
              uy_top   = cvmgt(uy_top_wall,uy_top,ltest)
              facy_top = cvmgt(four       ,one   ,ltest)
              uy_top   = areay(i,j+1) *   uy_top / dx(2)
              facy_top = areay(i,j+1) * facy_top / dx(2)

              rlu = alpha(i,j)*u(i,j) - mu*((ux_rght - ux_left)+
     $                                      (uy_top  - uy_bot ))

              if (irz .eq. 1 .and. idir .eq. 0) then
                r = (float(i)+half)*dx(1)
                vol = r * dx(1) * dx(2)
                rlu = rlu + mu * vol * u(i,j) / (r*r)
              endif

              rlam = alpha(i,j) + mu*(facx_left+facx_rght+facy_bot+facy_top)
              rlam = one/rlam

              u(i,j) = u(i,j) - rlam*(rlu - f(i,j))

            enddo
          enddo

          call gsrbvbc(u,DIMS,bc,0,idir,ng)

      enddo

      return
      end

c *************************************************************************
c ** GSRBVBC **
c ** Impose phyical boundary conditions
c *************************************************************************

      subroutine gsrbvbc(u,DIMS,bc,irz,idir,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T     u(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng)
      integer bc(2,2)
      integer irz
      integer idir

c     Local variables
      integer i,j,is,ie,js,je
      integer ilo,ihi,jlo,jhi

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      ilo = cvmgt(lo_1-ng,lo_1,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(hi_1+ng,hi_1,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
      jlo = cvmgt(lo_2-ng,lo_2,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
      jhi = cvmgt(hi_2+ng,hi_2,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)

c
c     The only boundary conditions we need to enforce are OUTLET,
c      and the r=0 wall, since all the others are zero 
c      (now that we've put the equations into residual-correction form).
c

      if (BCY_LO .eq. OUTLET) then
        do i = ilo,ihi
          u(i,js-1) = u(i,js)
        enddo
      endif

      if (BCY_HI .eq. OUTLET) then
        do i = ilo,ihi
          u(i,je+1) = u(i,je)
        enddo
      endif

      if ((BCX_LO .eq. OUTLET) .or.
     $    (BCX_LO .eq. WALL .and. idir .ne. 0 .and. irz .eq. 1) ) then
        do j = jlo,jhi
          u(is-1,j) = u(is,j)
        enddo
      endif

      if (BCX_HI .eq. OUTLET) then
        do j = jlo,jhi
          u(ie+1,j) = u(ie,j)
        enddo
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "MACPROJ_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define CDIMS loc_1,loc_2,loc_3,hic_1,hic_2,hic_3

c *************************************************************************
c ** INITSIGMA **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIGMA(sigmax,sigmay,sigmaz,rho,
     $                          areax,areay,areaz,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  sigmax(lo_1 -ng+1:hi_1 +ng  ,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmay(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng  ,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmaz(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng  )
      REAL_T    rho(lo_1-3:hi_1+3,lo_2-3:hi_2+3, lo_3-3:hi_3+3)
      REAL_T  areax(lo_1  :hi_1+1,lo_2  :hi_2  , lo_3  :hi_3  )
      REAL_T  areay(lo_1  :hi_1  ,lo_2  :hi_2+1, lo_3  :hi_3  )
      REAL_T  areaz(lo_1  :hi_1  ,lo_2  :hi_2  , lo_3  :hi_3+1)
      integer bc(2,3)

c     Local variables
      integer i,j,k
      REAL_T minsig,maxsig

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 

        do i = lo_1,hi_1+1 
          sigmax(i,j,k) = two * areax(i,j,k) / (rho(i,j,k) + rho(i-1,j,k))
        enddo

        if (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) then
          sigmax(lo_1,j,k) = areax(lo_1,j,k) / rho(lo_1-1,j,k)
        else if (BCX_LO .eq. OUTLET) then
          sigmax(lo_1,j,k) = areax(lo_1,j,k) / rho(lo_1,j,k)
        endif

        if (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) then
          sigmax(hi_1+1,j,k) = areax(hi_1+1,j,k) / rho(hi_1+1,j,k)
        else if (BCX_HI .eq. OUTLET) then
          sigmax(hi_1+1,j,k) = areax(hi_1+1,j,k) / rho(hi_1,j,k)
        endif

      enddo
      enddo

      do k = lo_3,hi_3 
      do i = lo_1,hi_1 

        do j = lo_2,hi_2+1 
          sigmay(i,j,k) = two * areay(i,j,k) / (rho(i,j,k) + rho(i,j-1,k))
        enddo

        if (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) then
          sigmay(i,lo_2,k) = areay(i,lo_2,k) / rho(i,lo_2-1,k)
        else if (BCY_LO .eq. OUTLET) then
          sigmay(i,lo_2,k) = areay(i,lo_2,k) / rho(i,lo_2  ,k)
        endif

        if (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) then
          sigmay(i,hi_2+1,k) = areay(i,hi_2,k) / rho(i,hi_2+1,k)
        else if (BCY_HI .eq. OUTLET) then
          sigmay(i,hi_2+1,k) = areay(i,hi_2,k) / rho(i,hi_2  ,k)
        endif

      enddo
      enddo

      do j = lo_2,hi_2 
      do i = lo_1,hi_1 

        do k = lo_3,hi_3+1 
          sigmaz(i,j,k) = two * areaz(i,j,k) / (rho(i,j,k) + rho(i,j,k-1))
        enddo

        if (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) then
          sigmaz(i,j,lo_3) = areaz(i,j,lo_3) / rho(i,j,lo_3-1)
        else if (BCZ_LO .eq. OUTLET) then
          sigmaz(i,j,lo_3) = areaz(i,j,lo_3) / rho(i,j,lo_3)
        endif

        if (BCZ_HI .eq. WALL .or. BCZ_HI .eq. INLET) then
          sigmaz(i,j,hi_3+1) = areaz(i,j,hi_3) / rho(i,j,hi_3+1)
        else if (BCZ_HI .eq. OUTLET) then
          sigmaz(i,j,hi_3+1) = areaz(i,j,hi_3) / rho(i,j,hi_3)
        endif
      enddo
      enddo

      return
      end


c *************************************************************************
c ** PROJUMAC **
c ** Update the edge-based velocities
c *************************************************************************

      subroutine FORT_PROJUMAC(uadv,vadv,wadv,sigmax,sigmay,sigmaz,phi,
     $                         areax,areay,areaz,dx,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   uadv(lo_1  :hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T   vadv(lo_1  :hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T   wadv(lo_1  :hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T  sigmax(lo_1 -ng+1:hi_1 +ng  ,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmay(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng  ,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmaz(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng  )
      REAL_T    phi(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng,lo_3-ng:hi_3+ng)
      REAL_T  areax(lo_1  :hi_1+1,lo_2  :hi_2  , lo_3  :hi_3  )
      REAL_T  areay(lo_1  :hi_1  ,lo_2  :hi_2+1, lo_3  :hi_3  )
      REAL_T  areaz(lo_1  :hi_1  ,lo_2  :hi_2  , lo_3  :hi_3+1)
      REAL_T     dx(3)
      integer bc(2,3)

c     Local variables
      integer i,j,k

      call setbc(phi,DIMS,bc,ng)

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1+1
          uadv(i,j,k) = uadv(i,j,k) - sigmax(i,j,k) / areax(i,j,k) * 
     $                  (phi(i,j,k)-phi(i-1,j,k))/dx(1)
      enddo
      enddo
      enddo

       do k = lo_3,hi_3 
       do j = lo_2,hi_2+1 
       do i = lo_1,hi_1 
          vadv(i,j,k) = vadv(i,j,k) - sigmay(i,j,k) / areay(i,j,k) * 
     $                  (phi(i,j,k)-phi(i,j-1,k))/dx(2)
       enddo
       enddo
       enddo

       do k = lo_3,hi_3+1 
       do j = lo_2,hi_2 
       do i = lo_1,hi_1 
          wadv(i,j,k) = wadv(i,j,k) - sigmaz(i,j,k) / areaz(i,j,k) * 
     $                 (phi(i,j,k)-phi(i,j,k-1))/dx(3)
       enddo
       enddo
       enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D( sig G(phi) )
c *************************************************************************

      subroutine FORT_RESIDUAL(resid,phi,f,sigmax,sigmay,sigmaz,DIMS,
     $                         dx,resnorm,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  resid(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T    phi(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  ,lo_3-ng  :hi_3+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T  sigmax(lo_1 -ng+1:hi_1 +ng  ,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmay(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng  ,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmaz(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng  )
      REAL_T dx(3)
      REAL_T resnorm
      integer bc(2,3)

c     Local variables
      REAL_T hxinv, hyinv, hzinv
      REAL_T rfac, corr
      integer i,j,k

      hxinv = one/dx(1)
      hyinv = one/dx(2)
      hzinv = one/dx(3)

      resnorm = zero

      call setbc(phi,DIMS,bc,ng)

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 
        do i = lo_1,hi_1 

          rfac = ( sigmax(i+1,j,k) + sigmax(i,j,k))*hxinv + 
     $           ( sigmay(i,j+1,k) + sigmay(i,j,k))*hyinv +
     $           ( sigmaz(i,j,k+1) + sigmaz(i,j,k))*hzinv

          corr = 
     $      ( sigmax(i+1,j,k)*phi(i+1,j,k) + sigmax(i,j,k)*phi(i-1,j,k))*hxinv
     $     +( sigmay(i,j+1,k)*phi(i,j+1,k) + sigmay(i,j,k)*phi(i,j-1,k))*hyinv
     $     +( sigmaz(i,j,k+1)*phi(i,j,k+1) + sigmaz(i,j,k)*phi(i,j,k-1))*hzinv

          resid(i,j,k) = f(i,j,k) - (corr - rfac*phi(i,j,k))

          resnorm = max(abs(resid(i,j,k)), resnorm)

        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RELAX **
c ** Jacobi relaxation
c *************************************************************************

      subroutine FORT_RELAX(phi,f,sigmax,sigmay,sigmaz,DIMS,dx,bc,nnrelax,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    phi(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  ,lo_3-ng  :hi_3+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T sigmax(lo_1 -ng+1:hi_1 +ng  ,lo_2 -ng+1:hi_2 +ng-1,
     $              lo_3 -ng+1:hi_3 +ng-1)
      REAL_T sigmay(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng  ,
     $              lo_3 -ng+1:hi_3 +ng-1)
      REAL_T sigmaz(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng-1,
     $              lo_3 -ng+1:hi_3 +ng  )
      REAL_T dx(3)
      integer bc(2,3)
      integer nnrelax

c     Local variables
      REAL_T rfac, corr
      integer i, j, k
      integer iter, iinc
      integer extra_xlo,extra_xhi
      integer extra_ylo,extra_yhi
      integer extra_zlo,extra_zhi

      if (ng .lt. 2*nnrelax) then
        print *,'NOT ENOUGH GHOST CELLS FOR RELAX '
        print *,'NG ',ng
        print *,'NNRELAX ',nnrelax
        stop
      endif

      call setbc(phi,DIMS,bc,ng)

      do iter = 1, 2*nnrelax

          extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
          extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
          extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
          extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)
          extra_zlo = cvmgt(ng-iter,0,BCZ_LO .eq. INTERIOR .or. BCZ_LO .eq. PERIODIC)
          extra_zhi = cvmgt(ng-iter,0,BCZ_HI .eq. INTERIOR .or. BCZ_HI .eq. PERIODIC)

          do k = lo_3-extra_zlo,hi_3+extra_zhi
          do j = lo_2-extra_ylo,hi_2+extra_yhi
           iinc = mod(j+k+iter+1+extra_xlo+2*ng,2)
           do i = lo_1-extra_xlo+iinc,hi_1+extra_xhi,2

              rfac = (sigmax(i+1,j,k) + sigmax(i,j,k))/dx(1) 
     $              +(sigmay(i,j+1,k) + sigmay(i,j,k))/dx(2)
     $              +(sigmaz(i,j,k+1) + sigmaz(i,j,k))/dx(3)

              corr = 
     $        ( sigmax(i+1,j,k)*phi(i+1,j,k) + sigmax(i,j,k)*phi(i-1,j,k))/dx(1)
     $       +( sigmay(i,j+1,k)*phi(i,j+1,k) + sigmay(i,j,k)*phi(i,j-1,k))/dx(2)
     $       +( sigmaz(i,j,k+1)*phi(i,j,k+1) + sigmaz(i,j,k)*phi(i,j,k-1))/dx(3)

              phi(i,j,k) = (corr - f(i,j,k))/rfac

            enddo
          enddo
          enddo

          call setbc(phi,DIMS,bc,ng)

      enddo

      return
      end


c *************************************************************************
c ** BC **
c ** Impose boundary conditions
c *************************************************************************

      subroutine setbc(phi,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  phi(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng,lo_3-ng:hi_3+ng)
      integer bc(2,3)

c     Local variables
      integer i, j, k, is, ie, js, je, ks, ke
      integer ilo,ihi,jlo,jhi,klo,khi

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      ilo = cvmgt(lo_1-ng,lo_1,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(hi_1+ng,hi_1,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
      jlo = cvmgt(lo_2-ng,lo_2,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
      jhi = cvmgt(hi_2+ng,hi_2,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)
      klo = cvmgt(lo_3-ng,lo_3,BCZ_LO .eq. INTERIOR .or. BCZ_LO .eq. PERIODIC)
      khi = cvmgt(hi_3+ng,hi_3,BCZ_HI .eq. INTERIOR .or. BCZ_HI .eq. PERIODIC)

      if (BCZ_LO .eq. OUTLET) then
        do j = jlo,jhi
        do i = ilo,ihi
          phi(i,j,ks-1) = -phi(i,j,ks)
        enddo
        enddo
      elseif (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) then
        do j = jlo,jhi
        do i = ilo,ihi
          phi(i,j,ks-1) =  phi(i,j,ks)
        enddo
        enddo
      endif

      if (BCZ_HI .eq. OUTLET) then
        do j = jlo,jhi
        do i = ilo,ihi
          phi(i,j,ke+1) = -phi(i,j,ke)
        enddo
        enddo
      elseif (BCZ_HI .eq. WALL .or.  BCZ_HI .eq. INLET) then
        do j = jlo,jhi
        do i = ilo,ihi
          phi(i,j,ke+1) =  phi(i,j,ke)
        enddo
        enddo
      endif

      if (BCY_LO .eq. OUTLET) then
        do k = klo,khi
        do i = ilo,ihi
          phi(i,js-1,k) = -phi(i,js,k)
        enddo
        enddo
      elseif (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) then
        do k = klo,khi
        do i = ilo,ihi
          phi(i,js-1,k) =  phi(i,js,k)
        enddo
        enddo
      endif

      if (BCY_HI .eq. OUTLET) then
        do k = klo,khi
        do i = ilo,ihi
          phi(i,je+1,k) = -phi(i,je,k)
        enddo
        enddo
      elseif (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) then
        do k = klo,khi
        do i = ilo,ihi
          phi(i,je+1,k) = -phi(i,je,k)
          phi(i,je+1,k) =  phi(i,je,k)
        enddo
        enddo
      endif

      if (BCX_LO .eq. OUTLET) then
        do k = klo,khi
        do j = jlo,jhi
          phi(is-1,j,k) = -phi(is,j,k)
        enddo
        enddo
      elseif (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) then
        do k = klo,khi
        do j = jlo,jhi
          phi(is-1,j,k) =  phi(is,j,k)
        enddo
        enddo
      endif

      if (BCX_HI .eq. OUTLET) then
        do k = klo,khi
        do j = jlo,jhi
          phi(ie+1,j,k) = -phi(ie,j,k)
        enddo
        enddo
      elseif (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) then
        do k = klo,khi
        do j = jlo,jhi
          phi(ie+1,j,k) =  phi(ie,j,k)
        enddo
        enddo
      endif

      return
      end

c *************************************************************************
c ** RHSMAC **
c ** Compute the right-hand-side D(U) for the MAC projection
c *************************************************************************

      subroutine FORT_RHSMAC(uadv,vadv,wadv,divu_src,rhs,
     $                       areax,areay,areaz,vol,DIMS,rhsnorm,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T     uadv(lo_1   :hi_1+1   ,lo_2  :hi_2      ,lo_3   :hi_3  )
      REAL_T     vadv(lo_1   :hi_1     ,lo_2  :hi_2+1    ,lo_3   :hi_3  )
      REAL_T     wadv(lo_1   :hi_1     ,lo_2  :hi_2      ,lo_3   :hi_3+1)
      REAL_T divu_src(lo_1   :hi_1     ,lo_2  :hi_2      ,lo_3   :hi_3  )
      REAL_T      rhs(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T    areax(lo_1   :hi_1+1   ,lo_2  :hi_2      ,lo_3   :hi_3  )
      REAL_T    areay(lo_1   :hi_1     ,lo_2  :hi_2+1    ,lo_3   :hi_3  )
      REAL_T    areaz(lo_1   :hi_1     ,lo_2  :hi_2      ,lo_3   :hi_3+1)
      REAL_T      vol(lo_1-1 :hi_1+1   ,lo_2-1:hi_2+1    ,lo_3-1 :hi_3+1)
      REAL_T  rhsnorm

c     Local variables
      integer i,j,k

      rhsnorm = zero

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          rhs(i,j,k) = areax(i+1,j,k)*uadv(i+1,j,k) - areax(i,j,k)*uadv(i,j,k)
     $                +areay(i,j+1,k)*vadv(i,j+1,k) - areay(i,j,k)*vadv(i,j,k)
     $                +areaz(i,j,k+1)*wadv(i,j,k+1) - areaz(i,j,k)*wadv(i,j,k)
 
          rhs(i,j,k) = rhs(i,j,k) - vol(i,j,k)*divu_src(i,j,k)

          rhsnorm = max(rhsnorm,abs(rhs(i,j,k)))

        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** COARSIGMA **
c ** Coarsen the edge-based sigma coefficients
c *************************************************************************

      subroutine FORT_COARSIGMA(sigmax,sigmay,sigmaz,
     $                          sigmaxc,sigmayc,sigmazc,DIMS,CDIMS,ng)

      implicit none

      integer DIMS
      integer CDIMS
      integer ng
      REAL_T  sigmax(lo_1 -ng+1:hi_1 +ng  ,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmay(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng  ,
     $               lo_3 -ng+1:hi_3 +ng-1)
      REAL_T  sigmaz(lo_1 -ng+1:hi_1 +ng-1,lo_2 -ng+1:hi_2 +ng-1,
     $               lo_3 -ng+1:hi_3 +ng  )
      REAL_T sigmaxc(loc_1-ng+1:hic_1+ng  ,loc_2-ng+1:hic_2+ng-1,
     $               loc_3-ng+1:hic_3+ng-1)
      REAL_T sigmayc(loc_1-ng+1:hic_1+ng-1,loc_2-ng+1:hic_2+ng  ,
     $               loc_3-ng+1:hic_3+ng-1)
      REAL_T sigmazc(loc_1-ng+1:hic_1+ng-1,loc_2-ng+1:hic_2+ng-1,
     $               loc_3-ng+1:hic_3+ng  )

c     Local variables
      integer i,j,k

      do k = lo_3,hi_3  ,2
      do j = lo_2,hi_2  ,2
      do i = lo_1,hi_1+1,2
          sigmaxc(i/2,j/2,k/2) = (sigmax(i,j,k  ) + sigmax(i,j+1,k  ) +
     $                            sigmax(i,j,k+1) + sigmax(i,j+1,k+1) ) * eighth
      enddo
      enddo
      enddo

      do k = lo_3,hi_3  ,2
      do j = lo_2,hi_2+1,2
      do i = lo_1,hi_1  ,2
          sigmayc(i/2,j/2,k/2) = (sigmay(i,j,k  ) + sigmay(i+1,j,k  ) +
     $                            sigmay(i,j,k+1) + sigmay(i+1,j,k+1) ) * eighth
      enddo
      enddo
      enddo

      do k = lo_3,hi_3+1,2
      do j = lo_2,hi_2  ,2
      do i = lo_1,hi_1  ,2
          sigmazc(i/2,j/2,k/2) = (sigmaz(i,j  ,k) + sigmaz(i+1,j  ,k) +
     $                            sigmaz(i,j+1,k) + sigmaz(i+1,j+1,k) ) * eighth
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservatively average the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,nex)

      implicit none

      integer DIMS
      integer CDIMS
      integer nex
      REAL_T  res(lo_1 -nex:hi_1 +nex,lo_2 -nex:hi_2 +nex,lo_3 -nex:hi_3 +nex)
      REAL_T resc(loc_1-nex:hic_1+nex,loc_2-nex:hic_2+nex,loc_3-nex:hic_3+nex)

c     Local variables
      integer i,j,k

      do k = lo_3,hi_3,2
      do j = lo_2,hi_2,2
        do i = lo_1,hi_1,2
          resc(i/2,j/2,k/2) = (res(i  ,j,k  ) + res(i  ,j+1,k  ) +
     $                         res(i+1,j,k  ) + res(i+1,j+1,k  ) +
     $                         res(i  ,j,k+1) + res(i  ,j+1,k+1) +
     $                         res(i+1,j,k+1) + res(i+1,j+1,k+1) ) * eighth
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise constant interpolation
c *************************************************************************

      subroutine FORT_INTERPOLATE(phi,deltac,DIMS,CDIMS,ng)

      implicit none

      integer DIMS
      integer CDIMS
      integer ng
      REAL_T    phi(lo_1 -ng:hi_1 +ng,lo_2 -ng:hi_2 +ng,lo_3 -ng:hi_3 +ng)
      REAL_T deltac(loc_1-ng:hic_1+ng,loc_2-ng:hic_2+ng,loc_3-ng:hic_3+ng)

c     Local variables
      integer i,j,k

      do k = lo_3,hi_3
      do j = lo_2,hi_2
        do i = lo_1,hi_1
          phi(i,j,k) = phi(i,j,k) + deltac(i/2,j/2,k/2)
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** SOLVEMAC **
c ** Conjugate gradient bottom-solver
c *************************************************************************

      subroutine FORT_SOLVEMAC(dest, dest0, source, sigmax, sigmay, sigmaz, 
     $                         sum, r, w, z, work, DIMS, dx, bc, norm,
     $                         prob_norm, ng)

      implicit none
      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng,lo_3-ng:hi_3+ng)
      REAL_T  dest0(lo_1-1 :hi_1+1 ,lo_2-1 :hi_2+1 ,lo_3-1 :hi_3+1)
      REAL_T source(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T sigmax(lo_1-ng+1:hi_1 +ng  ,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3 +ng-1)
      REAL_T sigmay(lo_1-ng+1:hi_1 +ng-1,lo_2-ng+1:hi_2+ng  ,lo_3-ng+1:hi_3 +ng-1)
      REAL_T sigmaz(lo_1-ng+1:hi_1 +ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3 +ng  )
      REAL_T    sum(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      r(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      z(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   work(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T dx(3)
      integer bc(2,3)
      REAL_T norm
      REAL_T prob_norm

c     Local variables
      integer i,j,k
      integer iter
      REAL_T alpha, beta, rho, rhol
      REAL_T local_norm
      REAL_T tol,tolfac

      tolfac = 1.0d-3

      call macperiodic(dest,DIMS,bc,ng)
      call       setbc(dest,DIMS,bc,ng)

      do k = lo_3-1,hi_3+1
      do j = lo_2-1,hi_2+1
      do i = lo_1-1,hi_1+1
         dest0(i,j,k) = dest(i,j,k)
          dest(i,j,k) = zero
      enddo
      enddo
      enddo

 10   do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          w(i,j,k) = 
     $     ( sigmax(i+1,j,k)*dest0(i+1,j,k) + 
     $       sigmax(i  ,j,k)*dest0(i-1,j,k) )/dx(1)
     $    +( sigmay(i,j+1,k)*dest0(i,j+1,k) + 
     $       sigmay(i,j  ,k)*dest0(i,j-1,k) )/dx(2)
     $    +( sigmaz(i,j,k+1)*dest0(i,j,k+1) + 
     $       sigmaz(i,j,k  )*dest0(i,j,k-1) )/dx(3)
     $   -( (sigmax(i+1,j,k) + sigmax(i,j,k))/dx(1) + 
     $      (sigmay(i,j+1,k) + sigmay(i,j,k))/dx(2) +
     $      (sigmaz(i,j,k+1) + sigmaz(i,j,k))/dx(3) )*dest0(i,j,k)
      enddo
      enddo
      enddo

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        r(i,j,k) = source(i,j,k) - w(i,j,k)
      enddo
      enddo
      enddo

      rho        = zero
      local_norm = zero

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho = rho + z(i,j,k) * r(i,j,k)
          local_norm = max(local_norm,abs(r(i,j,k)))
      enddo
      enddo
      enddo

      norm = local_norm

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          work(i,j,k) = zero
          dest(i,j,k) = z(i,j,k)
      enddo
      enddo
      enddo

      iter = 0

c     write(6,1000) iter, norm/prob_norm

100   call macperiodic(dest,DIMS,bc,ng)
      call       setbc(dest,DIMS,bc,ng)

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          w(i,j,k) = 
     $     ( sigmax(i+1,j,k)*dest(i+1,j,k) + 
     $       sigmax(i  ,j,k)*dest(i-1,j,k) )/dx(1)
     $    +( sigmay(i,j+1,k)*dest(i,j+1,k) + 
     $       sigmay(i,j  ,k)*dest(i,j-1,k) )/dx(2)
     $    +( sigmaz(i,j,k+1)*dest(i,j,k+1) + 
     $       sigmaz(i,j,k  )*dest(i,j,k-1) )/dx(3) - 
     $    ( (sigmax(i+1,j,k) + sigmax(i,j,k))/dx(1) + 
     $      (sigmay(i,j+1,k) + sigmay(i,j,k))/dx(2) +
     $      (sigmaz(i,j,k+1) + sigmaz(i,j,k))/dx(3) )*dest(i,j,k)
      enddo
      enddo
      enddo

      alpha = zero
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          alpha = alpha + dest(i,j,k)*w(i,j,k)
      enddo
      enddo
      enddo

      alpha = rho / alpha
      rhol = rho
      rho = zero
      norm = zero

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          work(i,j,k) = work(i,j,k) + alpha * dest(i,j,k)
          r(i,j,k) = r(i,j,k) - alpha * w(i,j,k)
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho = rho + z(i,j,k) * r(i,j,k)
          norm = max(norm,abs(r(i,j,k)))
      enddo
      enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then

        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1
            dest(i,j,k) = work(i,j,k) + dest0(i,j,k)
        enddo
        enddo
        enddo

        call setbc(dest,DIMS,bc,ng)

      else if (iter .ge. 100  .or.  norm .ge. 100.d0 * local_norm) then

        tolfac = 10.d0 * tolfac
        iter = 1
        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1
            dest(i,j,k) = zero
        enddo
        enddo
        enddo
        goto 10

      else

        beta = rho / rhol
        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1
            dest(i,j,k) = z(i,j,k) + beta * dest(i,j,k)
        enddo
        enddo
        enddo
        goto 100

      endif

c     call flush(6)

1000  format('Res/Res0 in solve: ',i4,2x,e12.5)
c     call flush(6)

      return
      end

c *************************************************************************
c ** MKSUMMAC **
c ** Pre-compute the sum of coefficients for the conjugate gradient solver
c *************************************************************************

      subroutine FORT_MKSUMMAC(sum,sigmax,sigmay,sigmaz,DIMS,dx,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    sum(lo_1-1   :hi_1+1   ,lo_2-1   :hi_2+1  ,
     $              lo_3-1   :hi_3+1   )
      REAL_T sigmax(lo_1-ng+1:hi_1+ng  ,lo_2-ng+1:hi_2+ng-1,
     $              lo_3-ng+1:hi_3+ng-1)
      REAL_T sigmay(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng  ,
     $              lo_3-ng+1:hi_3+ng-1)
      REAL_T sigmaz(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,
     $              lo_3-ng+1:hi_3+ng  )
      REAL_T dx(3)

c     Local variables
      integer i,j,k

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          sum(i,j,k) = (sigmax(i+1,j,k) + sigmax(i,j,k))/dx(1) +
     $                 (sigmay(i,j+1,k) + sigmay(i,j,k))/dx(2) +
     $                 (sigmaz(i,j,k+1) + sigmaz(i,j,k))/dx(3) 
          sum(i,j,k) = -sixth*sum(i,j,k)
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** MACPERIODIC **
c  Impose periodic boundary conditions on the single grid data in the
c   conjugate gradient bottom solver.
c *************************************************************************

      subroutine macperiodic(dest,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng,lo_3-ng:hi_3+ng)
      integer bc(2,3)

      integer i,j,k

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC) then
        do k = lo_3,hi_3
        do j = lo_2,hi_2
          dest(lo_1-1,j,k) = dest(hi_1,j,k)
          dest(hi_1+1,j,k) = dest(lo_1,j,k)
        enddo
        enddo
      endif
      if (BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC) then
        do k = lo_3,hi_3
        do i = lo_1,hi_1
          dest(i,lo_2-1,k) = dest(i,hi_2,k)
          dest(i,hi_2+1,k) = dest(i,lo_2,k)
        enddo
        enddo
      endif
      if (BCZ_LO .eq. PERIODIC .and. BCZ_HI .eq. PERIODIC) then
        do j = lo_2,hi_2
        do i = lo_1,hi_1
          dest(i,j,lo_3-1) = dest(i,j,hi_3)
          dest(i,j,hi_3+1) = dest(i,j,lo_3)
        enddo
        enddo
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

C
c $Id: INTERP_3D.F,v 1.26 2002/12/11 20:43:22 almgren Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "INTERP_F.H"
#include "ArrayLim.H"

#define IX_PROJ(A,B) (A+B*iabs(A))/B-iabs(A)
#define SDIM 3

c ::: --------------------------------------------------------------
c ::: nbinterp:  node based bilinear interpolation
c :::
c ::: INPUTS/OUTPUTS
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c :::
c ::: crse         =>  (const)  coarse grid data widened by 1 zone
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c :::
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: num_slp      =>  (const)  number of types of slopes
c :::
c ::: TEMPORARY ARRAYS
c ::: sl           =>  num_slp 1-D slope arrays
c ::: strip        =>  1-D temp array
c ::: --------------------------------------------------------------
c :::
      subroutine FORT_NBINTERP (crse, DIMS(crse), DIMS(cb),
     $                          fine, DIMS(fine), DIMS(fb),
     $                          lratiox, lratioy, lratioz, nvar,
     $                          sl, num_slp)

      integer DIMDEC(crse)
      integer DIMDEC(cb)
      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer lratiox, lratioy, lratioz, nvar
      integer num_slp
      REAL_T  fine(DIMV(fine),nvar)
      REAL_T  crse(DIMV(crse),nvar)
      REAL_T  sl(DIM1(cb),num_slp)

#define  SLX 1
#define  SLY 2
#define  SLZ 3
#define  SLXY 4
#define  SLXZ 5
#define  SLYZ 6
#define  SLXYZ 7

c ::: local var
      integer lx, ly, lz
      integer i, j, k, ifn, jfn, kfn, n
      integer ilo, ihi, jlo, jhi, klo, khi
      integer kstrtFine, kstopFine, jstrtFine, jstopFine, istrtFine, istopFine

      REAL_T fx, fy,fz
      REAL_T RX, RY, RZ, RXY, RXZ, RYZ, RXYZ
      REAL_T dx00, d0x0, d00x, dx10, dx01, d0x1, dx11
      REAL_T slope

      slope(i,j,k,n,fx,fy,fz) = crse(i,j,k,n) +
     &     fx*sl(i,SLX) + fy*sl(i,SLY) + fz*sl(i,SLZ) +
     &     fx*fy*sl(i,SLXY) + fx*fz*sl(i,SLXZ) + fy*fz*sl(i,SLYZ) +
     &     fx*fy*fz*sl(i,SLXYZ)

      RX = one/dble(lratiox)
      RY = one/dble(lratioy)
      RZ = one/dble(lratioz)
      RXY = RX*RY
      RXZ = RX*RZ
      RYZ = RY*RZ
      RXYZ = RX*RY*RZ

c
c     NOTES:
c         1) (i, j, k) loop over the coarse cells
c         2) ?strtFine and ?stopFine are the beginning and ending fine cell
c            indices corresponding to the current coarse cell.  ?stopFine
c            is restricted for the last coarse cell in each direction since
c            for this cell we only need to do the face and not the fine nodes
c            inside this cell.
c         3) (lx, ly, lz) as well as ?lo and ?hi refer to the fine node indices
c            as an offset from ?strtFine.
c
      do 100 n = 1, nvar
        do 110 k = ARG_L3(cb), ARG_H3(cb)
          kstrtFine = k * lratioz
          kstopFine = kstrtFine + lratioz - 1
          if (k .eq. ARG_H3(cb)) kstopFine = kstrtFine

          klo = max(ARG_L3(fb),kstrtFine) - kstrtFine
          khi = min(ARG_H3(fb),kstopFine) - kstrtFine

          do 120 j = ARG_L2(cb), ARG_H2(cb)
            jstrtFine = j * lratioy
            jstopFine = jstrtFine + lratioy - 1
            if (j .eq. ARG_H2(cb)) jstopFine = jstrtFine

            jlo = max(ARG_L2(fb),jstrtFine) - jstrtFine
            jhi = min(ARG_H2(fb),jstopFine) - jstrtFine

c
c           ::::: compute slopes :::::
c
c           NOTE: The IF logic in the calculation of the slopes is to
c                 prevent stepping out of bounds on the coarse data when
c                 computing the slopes on the ARG_H?(cb) cells.  These
c                 slopes actually are not used since they are multiplied by
c                 zero.
c
            do i = ARG_L1(cb), ARG_H1(cb)
              dx00 = zero
              if (i .NE. ARG_H1(cb)) dx00 = crse(i+1,j,k,n) - crse(i,j,k,n)

              d0x0 = zero
              if (j .NE. ARG_H2(cb)) d0x0 = crse(i,j+1,k,n) - crse(i,j,k,n)

              d00x = zero
              if (k .NE. ARG_H3(cb)) d00x = crse(i,j,k+1,n) - crse(i,j,k,n)

              dx10 = zero
              if (i .NE. ARG_H1(cb) .and. j .NE. ARG_H2(cb))
     $          dx10 = crse(i+1,j+1,k,n) - crse(i,j+1,k,n)

              dx01 = zero
              if (i .NE. ARG_H1(cb) .and. k .NE. ARG_H3(cb))
     $          dx01 = crse(i+1,j,k+1,n) - crse(i,j,k+1,n)

              d0x1 = zero
              if (j .NE. ARG_H2(cb) .and. k .NE. ARG_H3(cb))
     $          d0x1 = crse(i,j+1,k+1,n) - crse(i,j,k+1,n)

              dx11 = zero
              if (i .NE. ARG_H1(cb) .and. j .NE. ARG_H2(cb)
     $                              .and. k .NE. ARG_H3(cb)) 
     $          dx11 = crse(i+1,j+1,k+1,n) - crse(i,j+1,k+1,n)

              sl(i,SLX) = RX*dx00
              sl(i,SLY) = RY*d0x0
              sl(i,SLZ) = RZ*d00x

              sl(i,SLXY) = RXY*(dx10 - dx00)
              sl(i,SLXZ) = RXZ*(dx01 - dx00)
              sl(i,SLYZ) = RYZ*(d0x1 - d0x0)

              sl(i,SLXYZ) = RXYZ*(dx11 - dx01 - dx10 + dx00)
            end do

c
c           ::::: compute fine strip of interpolated data
c
            do lz = klo, khi
              kfn = lratioz * k + lz
              fz = dble(lz)

              do ly = jlo, jhi
                jfn = lratioy * j + ly
                fy = dble(ly)

                do i = ARG_L1(cb), ARG_H1(cb)
                  istrtFine = i * lratiox
                  istopFine = istrtFine + lratiox - 1
                  if (i .eq. ARG_H1(cb)) istopFine = istrtFine

                  ilo = max(ARG_L1(fb),istrtFine) - istrtFine
                  ihi = min(ARG_H1(fb),istopFine) - istrtFine

                  do lx = ilo, ihi
                    ifn = lratiox * i + lx
                    fx = dble(lx)

                    fine(ifn,jfn,kfn,n) = slope(i,j,k,n,fx,fy,fz)
                  end do
                end do
              end do
            end do

c         ::::: end of do j
120       continue
c       ::::: end of do k
110     continue
c     ::::: end of do n
100   continue

#undef  SLX
#undef  SLY
#undef  SLZ
#undef  SLXY
#undef  SLXZ
#undef  SLYZ
#undef  SLXYZ

      end


c ::: 
c ::: --------------------------------------------------------------
c ::: cbinterp:  cell centered bilinear interpolation
c ::: 
c ::: NOTE: it is assumed that the coarse grid array is
c ::: large enough to define interpolated values
c ::: in the region fblo:fbhi on the fine grid
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: DIMS(fb)     =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data 
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c ::: 
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: 
c ::: TEMPORARY ARRAYS
c ::: slx,sly,slxy =>  1-D slope arrays
c ::: strip        =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_CBINTERP (crse, DIMS(crse), DIMS(cb),
     $                          fine, DIMS(fine), DIMS(fb),
     $                          lratiox, lratioy, lratioz, nvar,
     $                          sl, num_slp, strip, strip_lo, strip_hi)

      integer DIMDEC(crse)
      integer DIMDEC(cb)
      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer lratiox, lratioy, lratioz, nvar
      integer num_slp
      integer strip_lo, strip_hi
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(DIMV(crse),nvar)
      REAL_T strip(strip_lo:strip_hi)
      REAL_T sl(DIM1(cb), num_slp)

c ::: local var
#if 0
      integer lx, ly
      integer hrat, ic, jc, jfn, jfc, i, j, n
      REAL_T x, y
      REAL_T denom
#endif
      call bl_abort("FORT_CBINTERP not implemented")

      end

c ::: --------------------------------------------------------------
c ::: ccinterp:   conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widened by 1 zone
c ::: and unrolled
c ::: clo,chi      =>  (const)  one dimensional limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c :::				slopes are to be defined. This is
c :::				the projection of (fblo,fbhi) down
c :::				to the coarse level 
c ::: fslo,fshi    =>  (const)  fine grid index limits where
c :::				slopes are needed.  This is the
c :::				refinement of (cslo,cshi) and
c :::				contains but may not be identical
c :::				to (fblo,fbhi).
c ::: cslope       =>  (modify) temp array coarse grid slopes
c ::: clen         =>  (const)  length of coarse grid slopes
c ::: fslope       =>  (modify) temp array for fine grid slope
c ::: flen         =>  (const)  length of fine grid slope array
c ::: fdat         =>  (const)  temp array for fine grid data
c ::: limslope     =>  (const)  != 0 => limit slopes
c :::
c ::: NOTE: data must be sent in so that 
c :::	    cslope(1,*) and crse(1,*) are associated with
c :::	    the same cell
c :::
c ::: 2-D EXAMPLE:
c ::: Suppose the patch called "fine" has index extent:
c ::: 
c ::: floi1 = 3, fhii1 = 12
c ::: floi2 = 8, fhii2 = 20
c ::: 
c ::: suppose the subergion of this patch that is to be filled 
c ::: by interpolation has index extent:
c ::: 
c ::: fb_l1 = 5,  fb_h1 = 10
c ::: fb_l2 = 13, fb_h2 = 20
c ::: 
c ::: suppose the refinement ratio is 2
c ::: 
c ::: Then the coarsening of this subregion (to level 0) is
c ::: 
c ::: cb_l1 = 2  cb_h1 = 5         (ncbx = 4)
c ::: cb_l2 = 6  cb_h2 = 10        (ncby = 5)
c ::: 
c ::: In order to compute slopes, we need one extra row of
c ::: coarse grid zones:
c ::: 
c ::: cslo(1) = 1  cshi(1) = 6         (ncsx = 6)
c ::: cslo(2) = 5  cshi(2) = 11        (ncsy = 7)
c ::: 
c ::: This is the size of the coarse grid array of data that filpatch 
c ::: has filled at level 0.
c ::: The "cslope" and "crse" arrays are this size.
c ::: 
c ::: In order to unroll the slope calculation we make these arrays look
c ::: like 1-D arrays.  The mapping from 2-D to 1-D is as follows:
c ::: 
c ::: The point (cb_l1,cb_l2) -> 1
c ::: The point (cslo(1),cslo(2)) -> clo = 1 - 1 - ncsx = -6
c ::: 
c ::: The point (cbhi(1),cbhi(2)) -> clen = ncby*ncsx - 2 = 5*6-2 = 28
c ::: The point (cshi(1),cshi(2)) -> chi = clo + ncsx*ncsy - 1 
c :::                                    =  -6 +    6*7    - 1 = 35
c ::: 
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |  chi  |  
c :::  11  |   30  |   31  |   32  |   33  |   34  |   35  |   cshi(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |  clen |       |  
c :::  10  |   24  |   25  |   26  |   27  |   28  |   29  |   cb_h2
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   9  |   18  |   19  |   20  |   21  |   22  |   23  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   8  |   12  |   13  |   14  |   15  |   16  |   17  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   7  |    6  |    7  |    8  |    9  |   10  |   11  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   6  |    0  |    1  |    2  |    3  |    4  |    5  |   cb_l2
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |  clo  |       |       |       |       |       |  
c :::   5  |   -6  |   -5  |   -4  |   -3  |   -2  |   -1  |   cslo(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::          1       2       3       4       5       6
c :::               cb_l1                    cb_h1
c :::       cslo(1)                                 cshi(1)
c ::: 
c ::: 
c ::: In the 1-D coordinates:
c :::    ist = 1    = stride in I direction
c :::    jst = 6    = stride in J direction  (ncsx)
c ::: 
c ::: --------------------------------------------------------------
      subroutine FORT_CCINTERP (fine, DIMS(fine), 
     $                          DIMS(fb),
     $                          nvar,lratiox,lratioy,lratioz,crse,clo,
     $                          chi, DIMS(cb),
     $		                fslo, fshi, cslope, clen, fslope, fdat,
     $                          flen, voff, bc, limslope,
     $                          fvcx, fvcy, fvcz, cvcx, cvcy, cvcz,
     $                          cmax, cmin, alpha)

      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer DIMDEC(cb)
      integer fslo(3), fshi(3)
      integer nvar, lratiox, lratioy, lratioz
      integer bc(3,2,nvar)
      integer clen, flen, clo, chi, limslope
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 3)
      REAL_T cmax(clo:chi)
      REAL_T cmin(clo:chi)
      REAL_T alpha(clo:chi)
      REAL_T fslope(flen, 3)
      REAL_T fdat(flen)
      REAL_T voff(flen)
      REAL_T fvcx(fb_l1:fb_h1+1)
      REAL_T fvcy(fb_l2:fb_h2+1)
      REAL_T fvcz(fb_l3:fb_h3+1)
      REAL_T cvcx(cb_l1:cb_h1+1)
      REAL_T cvcy(cb_l2:cb_h2+1)
      REAL_T cvcz(cb_l3:cb_h3+1)

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
      integer n, fn
      integer i, ii, ic, ioff
      integer j, jj, jc, joff
      integer k, kk, kc, koff
      integer ist, jst, kst
      integer cslo(3), cshi(3)
      REAL_T cen, forw, back, slp, sgn
      REAL_T fcen, ccen
      REAL_T xoff, yoff, zoff
      integer ncbx, ncby, ncbz
      integer ncsx, ncsy, ncsz
      integer islo, jslo, kslo
      integer icc, istart, iend
      integer ilo, ihi, jlo, jhi, klo, khi
      logical xok, yok, zok

c     :::::: helpful statement functions
      integer sloc
      integer strd
      REAL_T  slplft, slprgt
      REAL_T  corr_fact
      REAL_T  orig_corr_fact
      sloc(i,j,k) = clo+i-cslo(1)+ncsx*(j-cslo(2)+ncsy*(k-cslo(3)))

      slplft(i,strd,n) =  -sixteen/fifteen*crse(i-strd,n)
     $		         + half*crse(i,n)
     $                   + two3rd*crse(i+strd,n)
     $			 - tenth*crse(i+2*strd,n)
      slprgt(i,strd,n) =   sixteen/fifteen*crse(i+strd,n)
     $		         - half*crse(i,n)
     $                   - two3rd*crse(i-strd,n)
     $			 + tenth*crse(i-2*strd,n)

      ncbx = cb_h1-cb_l1+1
      ncby = cb_h2-cb_l2+1
      ncbz = cb_h3-cb_l3+1
      cslo(1) = cb_l1-1
      cshi(1) = cb_h1+1
      cslo(2) = cb_l2-1
      cshi(2) = cb_h2+1
      cslo(3) = cb_l3-1
      cshi(3) = cb_h3+1
      xok = (cb_h1-cb_l1+1 .ge. 2)
      yok = (cb_h2-cb_l2+1 .ge. 2)
      zok = (cb_h3-cb_l3+1 .ge. 2)
      ncsx = ncbx+2
      ncsy = ncby+2
      ncsz = ncbz+2
      ist = 1
      jst = ncsx
      kst = ncsx*ncsy
      islo = cb_l1-1
      jslo = cb_l2-1
      kslo = cb_l3-1

      do i = fb_l1, fb_h1 
         fn = i-fslo(1)+1
         ic = IX_PROJ(i,lratiox)
         fcen = half*(fvcx(i)+fvcx(i+1))
         ccen = half*(cvcx(ic)+cvcx(ic+1))
         voff(fn) = (fcen-ccen)/(cvcx(ic+1)-cvcx(ic))
      end do

      do 100 n = 1, nvar 

          do i = 1,clen

            alpha(i) = 1.d0

            cmax(i) = crse(i,n)
            cmin(i) = crse(i,n)

            do koff = -kst,kst,kst
            do joff = -jst,jst,jst
            do ioff = -ist,ist,ist
              cmax(i) = max(cmax(i),crse(i+ioff+joff+koff,n))
              cmin(i) = min(cmin(i),crse(i+ioff+joff+koff,n))
            end do
            end do
            end do

          end do

c ::: ::::: compute slopes in x direction
          if (limslope .ne. 0) then
             do i = 1, clen 
                cen = half*(crse(i+ist,n)-crse(i-ist,n))
                forw = two*(crse(i+ist,n)-crse(i,n))
                back = two*(crse(i,n)-crse(i-ist,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                cslope(i,1)=sign(one,cen)*min(slp,abs(cen))
             end do
             if (xok) then
                if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
                   do i = 1, clen, jst 
                      cen  = slplft(i,ist,n)
                      sgn  = sign(one,cen)
                      forw = two*(crse(i+ist,n)-crse(i,n))
                      back = two*(crse(i,n)-crse(i-ist,n))
                      slp  = min(abs(forw),abs(back))
                      slp  = cvmgp(slp,zero,forw*back)
                      cslope(i,1)=sgn*min(slp,abs(cen))
                   end do
                end if
                if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
                   do i = ncbx, clen, jst 
                      cen = slprgt(i,ist,n)
                      sgn  = sign(one,cen)
                      forw = two*(crse(i+ist,n)-crse(i,n))
                      back = two*(crse(i,n)-crse(i-ist,n))
                      slp  = min(abs(forw),abs(back))
                      slp  = cvmgp(slp,zero,forw*back)
                      cslope(i,1)=sgn*min(slp,abs(cen))
                   end do
                end if
             end if
	  else
             do i = 1, clen 
                cslope(i,1) = half*(crse(i+ist,n)-crse(i-ist,n))
             end do
             if (xok) then
                if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
                   do i = 1, clen, jst 
                      cslope(i,1) = slplft(i,ist,n)
                   end do
                end if
                if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
                   do i = ncbx, clen, jst 
                      cslope(i,1) = slprgt(i,ist,n)
                   end do
                end if
             end if
	  end if
c ::: ::::: compute slopes in y direction
          if (limslope .ne. 0) then
             do i = 1, clen 
                cen  = half*(crse(i+jst,n)-crse(i-jst,n))
                forw = two*(crse(i+jst,n)-crse(i,n))
                back = two*(crse(i,n)-crse(i-jst,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                cslope(i,2)=sign(one,cen)*min(slp,abs(cen))
             end do
             if (yok) then
                if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
                   do k = cb_l3, cb_h3
                      ilo = sloc(cb_l1,cb_l2,k)
                      ihi = sloc(cb_h1,cb_l2,k)
                      do i = ilo, ihi
                         cen  = slplft(i,jst,n)
                         sgn  = sign(one,cen)
                         forw = two*(crse(i+jst,n)-crse(i,n))
                         back = two*(crse(i,n)-crse(i-jst,n))
                         slp  = min(abs(forw),abs(back))
                         slp  = cvmgp(slp,zero,forw*back)
                         cslope(i,2)=sgn*min(slp,abs(cen))
                      end do
                   end do
                end if
                if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
                   do k = cb_l3, cb_h3
                      ilo = sloc(cb_l1,cb_h2,k)
                      ihi = sloc(cb_h1,cb_h2,k)
                      do i = ilo, ihi
                         cen  = slprgt(i,jst,n)
                         sgn  = sign(one,cen)
                         forw = two*(crse(i+jst,n)-crse(i,n))
                         back = two*(crse(i,n)-crse(i-jst,n))
                         slp  = min(abs(forw),abs(back))
                         slp  = cvmgp(slp,zero,forw*back)
                         cslope(i,2)=sgn*min(slp,abs(cen))
                      end do
                   end do
                end if
             end if
	  else
            do i = 1, clen 
              cslope(i,2) = half*(crse(i+jst,n)-crse(i-jst,n))
           end do
           if (yok) then
              if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
                 do k = cb_l2, cb_h3
                    ilo = sloc(cb_l1,cb_l2,k)
                    ihi = sloc(cb_h1,cb_l2,k)
                    do i = ilo, ihi
                       cslope(i,2) = slplft(i,jst,n)
                    end do
                 end do
              end if
              if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
                 do k = cb_l3, cb_h3
                    ilo = sloc(cb_l1,cb_h2,k)
                    ihi = sloc(cb_h1,cb_h2,k)
                    do i = ilo, ihi
                       cslope(i,2) = slprgt(i,jst,n)
                    end do
                 end do
              end if
           end if
         end if
c ::: ::::: compute slopes in z direction
          if (limslope .ne. 0) then
             do i = 1, clen 
                cen  = half*(crse(i+kst,n)-crse(i-kst,n))
                forw = two*(crse(i+kst,n)-crse(i,n))
                back = two*(crse(i,n)-crse(i-kst,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                cslope(i,3)=sign(one,cen)*min(slp,abs(cen))
             end do
             if (zok) then
                if (bclo(3,n) .eq. EXT_DIR .or. bclo(3,n).eq.HOEXTRAP) then
                   ilo = sloc(cb_l1,cb_l2,cb_l3)
                   ihi = sloc(cb_h1,cb_h2,cb_l3)
                   do i = ilo, ihi
                      cen  = slplft(i,kst,n)
                      sgn  = sign(one,cen)
                      forw = two*(crse(i+kst,n)-crse(i,n))
                      back = two*(crse(i,n)-crse(i-kst,n))
                      slp  = min(abs(forw),abs(back))
                      slp  = cvmgp(slp,zero,forw*back)
                      cslope(i,3)=sgn*min(slp,abs(cen))
                   end do
                end if
                if (bchi(3,n) .eq. EXT_DIR .or. bchi(3,n).eq.HOEXTRAP) then
                   ilo = sloc(cb_l1,cb_l2,cb_h3)
                   ihi = sloc(cb_h1,cb_h2,cb_h3)
                   do i = ilo, ihi
                      cen  = slprgt(i,kst,n)
                      sgn  = sign(one,cen)
                      forw = two*(crse(i+kst,n)-crse(i,n))
                      back = two*(crse(i,n)-crse(i-kst,n))
                      slp  = min(abs(forw),abs(back))
                      slp  = cvmgp(slp,zero,forw*back)
                      cslope(i,3)=sgn*min(slp,abs(cen))
                   end do
                end if
             end if
	  else
             do i = 1, clen 
                cslope(i,3) = half*(crse(i+kst,n)-crse(i-kst,n))
             end do
             if (zok) then
                if (bclo(3,n) .eq. EXT_DIR .or. bclo(3,n).eq.HOEXTRAP) then
                   ilo = sloc(cb_l1,cb_l2,cb_l3)
                   ihi = sloc(cb_h1,cb_h2,cb_l3)
                   do i = ilo, ihi
                      cslope(i,3) = slplft(i,kst,n)
                   end do
                end if
                if (bchi(3,n) .eq. EXT_DIR .or. bchi(3,n).eq.HOEXTRAP) then
                   ilo = sloc(cb_l1,cb_l2,cb_h3)
                   ihi = sloc(cb_h1,cb_h2,cb_h3)
                   do i = ilo, ihi
                      cslope(i,3) = slprgt(i,kst,n)
                   end do
                end if
             end if
	  end if

          do 200 kc = cb_l3, cb_h3 
             do 250 jc = cb_l2, cb_h2 

c :::           ::::: strip out fine grid slope vectors
                do ioff = 1, lratiox
                   icc = sloc(cb_l1,jc,kc)
                   istart = ioff
                   iend = ioff + (ncbx-1)*lratiox
                   do fn = istart, iend, lratiox 
                      fslope(fn,1) = cslope(icc,1)
                      fslope(fn,2) = cslope(icc,2)
                      fslope(fn,3) = cslope(icc,3)
                      fdat(fn) = crse(icc,n)
                      icc = icc + ist
                   end do
                end do

c               Limit slopes so as to not introduce new maxs or mins.
                jj = lratioy*jc
                jlo = max(jj,fb_l2) - jj
                jhi = min(jj+lratioy-1,fb_h2) - jj
                kk = lratioz*kc
                klo = max(kk,fb_l3) - kk
                khi = min(kk+lratioz-1,fb_h3) - kk
                do koff = klo, khi
                   k = lratioz*kc + koff
                   fcen = half*(fvcz(k) +fvcz(k+1))
                   ccen = half*(cvcz(kc)+cvcz(kc+1))
                   zoff = (fcen-ccen)/(cvcz(kc+1)-cvcz(kc))
                   do joff = jlo, jhi
                      j = lratioy*jc + joff
                      fcen = half*(fvcy(j) +fvcy(j+1))
                      ccen = half*(cvcy(jc)+cvcy(jc+1))
                      yoff = (fcen-ccen)/(cvcy(jc+1)-cvcy(jc))
                      do i = fb_l1, fb_h1
                         fn = i-fslo(1)+1
                         orig_corr_fact = 
     $                        voff(fn)*fslope(fn,1)+
     $                        yoff*fslope(fn,2)+
     $                        zoff*fslope(fn,3)
                         fine(i,j,k,n) = fdat(fn) + orig_corr_fact

                         ic = IX_PROJ(i,lratiox)
                         icc = sloc(ic,jc,kc)

                         if ( (fine(i,j,k,n) .gt. cmax(icc)) .and.
     $                       (abs(orig_corr_fact) .gt. 1.e-10*abs(fdat(fn)))) then 
                           corr_fact = (cmax(icc) - fdat(fn)) / orig_corr_fact
                           alpha(icc) = min(alpha(icc),corr_fact)
                         endif
                         if ( (fine(i,j,k,n) .lt. cmin(icc)) .and.
     $                       (abs(orig_corr_fact) .gt. 1.e-10*abs(fdat(fn)))) then 
                           corr_fact = (cmin(icc) - fdat(fn)) / orig_corr_fact
                           alpha(icc) = min(alpha(icc),corr_fact)
                         endif
#ifndef NDEBUG
                         if (alpha(icc) .lt. 0.d0) then
                           print *,'OOPS - ALPHA SHOULD BE POSITIVE IN CCINTERP '
                           print *,'ICC = ',icc
                           print *,'ALPHA = ',alpha(icc)
                           print *,'ORIG_CORR_FACT = ',orig_corr_fact
                           call bl_abort(" ")
                         endif
                         if (alpha(icc) .gt. 1.d0) then
                           print *,'OOPS - ALPHA SHOULD BE <= 1. IN CCINTERP '
                           print *,'ICC = ',icc
                           print *,'ALPHA = ',alpha(icc)
                           print *,'ORIG_CORR_FACT = ',orig_corr_fact
                           call bl_abort(" ")
                         endif
#endif
                       end do
                       end do
                   end do
c                end do

c :::           ::::: Now interpolate to fine grid for real.
                jj = lratioy*jc
                jlo = max(jj,fb_l2) - jj
                jhi = min(jj+lratioy-1,fb_h2) - jj
                kk = lratioz*kc
                klo = max(kk,fb_l3) - kk
                khi = min(kk+lratioz-1,fb_h3) - kk
                do koff = klo, khi
                   k = lratioz*kc + koff
                   fcen = half*(fvcz(k) +fvcz(k+1))
                   ccen = half*(cvcz(kc)+cvcz(kc+1))
                   zoff = (fcen-ccen)/(cvcz(kc+1)-cvcz(kc))
                   do joff = jlo, jhi
                      j = lratioy*jc + joff
                      fcen = half*(fvcy(j) +fvcy(j+1))
                      ccen = half*(cvcy(jc)+cvcy(jc+1))
                      yoff = (fcen-ccen)/(cvcy(jc+1)-cvcy(jc))
                      do i = fb_l1, fb_h1
                         fn = i-fslo(1)+1
                         ic = IX_PROJ(i,lratiox)
                         icc = sloc(ic,jc,kc)
                         fine(i,j,k,n) = fdat(fn) + alpha(icc) * (
     $                        voff(fn)*fslope(fn,1)+
     $                        yoff*fslope(fn,2)+
     $                        zoff*fslope(fn,3) )
                      end do
                   end do
                end do
250          continue
200       continue

100   continue

      end

c ::: 
c ::: --------------------------------------------------------------
c ::: linccinterp:   linear conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: The interpolation is linear in that it uses a
c ::: a limiting scheme that preserves the value of 
c ::: any linear combination of the
c ::: coarse grid data components--e.g.,
c ::: if sum_ivar a(ic,jc,ivar)*fab(ic,jc,ivar) = 0, then
c ::: sum_ivar a(ic,jc,ivar)*fab(if,jf,ivar) = 0 is satisfied
c ::: in all fine cells if,jf covering coarse cell ic,jc.
c ::: 
c ::: If lin_limit = 0, the interpolation scheme is identical to
c ::: the used in ccinterp for limslope=1; the results should
c ::: be exactly the same -- difference = hard 0.
c :::
c ::: Unlike FORT_CCINTERP, this routine does not do any clever unrolling
c ::: and it does not use any 1-d strip--all calculations are done
c ::: on full 2-d arrays.  The onlu concession to vectorization
c ::: is that the innermost loops are longest.
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio(2)    =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: clo,chi      =>  (const)  index limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c :::				slopes are to be defined. This is
c :::				the projection of (fblo,fbhi) down
c :::				to the coarse level 
c ::: ucslope      =>  (modify) temp array of unlimited coarse grid slopes
c ::: lcslope      =>  (modify) temp array of limited coarse grid slopes
c ::: slope_factor =>  (modify) temp array of slope limiting factors
c ::: lin_limit    =>  (const)  != 0 => do linear slope limiting scheme
c :::
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_LINCCINTERP (fine, DIMS(fine), fblo, fbhi, 
     &                          DIMS(fvcb), 
     &                          crse, DIMS(crse), DIMS(cvcb),
     &                          uc_xslope, lc_xslope, xslope_factor,
     &                          uc_yslope, lc_yslope, yslope_factor,
     &                          uc_zslope, lc_zslope, zslope_factor,
     &                          DIMS(cslope),
     &                          cslopelo, cslopehi,
     $                          nvar, lratiox, lratioy, lratioz, 
     $                          bc, lin_limit,
     $                          fvcx, fvcy, fvcz, cvcx, cvcy, cvcz,
     $                          voffx,voffy,voffz)

      implicit none

      integer DIMDEC(fine)
      integer DIMDEC(crse)
      integer DIMDEC(fvcb)
      integer DIMDEC(cvcb)
      integer DIMDEC(cslope)
      integer fblo(3), fbhi(3)
      integer cslopelo(3), cslopehi(3)
      integer lratiox, lratioy, lratioz, nvar, lin_limit
      integer bc(3,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(DIMV(crse), nvar)
      REAL_T uc_xslope(DIMV(cslope),nvar)
      REAL_T lc_xslope(DIMV(cslope),nvar)
      REAL_T xslope_factor(DIMV(cslope))
      REAL_T uc_yslope(DIMV(cslope),nvar)
      REAL_T lc_yslope(DIMV(cslope),nvar)
      REAL_T yslope_factor(DIMV(cslope))
      REAL_T uc_zslope(DIMV(cslope),nvar)
      REAL_T lc_zslope(DIMV(cslope),nvar)
      REAL_T zslope_factor(DIMV(cslope))
      REAL_T fvcx(DIM1(fvcb))
      REAL_T fvcy(DIM2(fvcb))
      REAL_T fvcz(DIM3(fvcb))
      REAL_T voffx(DIM1(fvcb))
      REAL_T voffy(DIM2(fvcb))
      REAL_T voffz(DIM3(fvcb))       
      REAL_T cvcx(DIM1(cvcb))
      REAL_T cvcy(DIM2(cvcb))
      REAL_T cvcz(DIM3(cvcb))

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
      integer n 
      integer i, ic
      integer j, jc
      integer k, kc
      REAL_T cen, forw, back, slp
      REAL_T factorn, denom
      REAL_T fxcen, cxcen, fycen, cycen, fzcen, czcen
      logical xok, yok, zok
      integer ncbx, ncby, ncbz

      ncbx = cslopehi(1)-cslopelo(1)+1
      ncby = cslopehi(2)-cslopelo(2)+1
      ncbz = cslopehi(3)-cslopelo(3)+1
      xok = (ncbx .ge. 2)
      yok = (ncby .ge. 2)
      zok = (ncbz .ge. 2)

      do k = fblo(3), fbhi(3)
        kc = IX_PROJ(k,lratioz)
        fzcen = half*(fvcz(k)+fvcz(k+1))
        czcen = half*(cvcz(kc)+cvcz(kc+1))
        voffz(k) = (fzcen-czcen)/(cvcz(kc+1)-cvcz(kc))
      end do
      do j = fblo(2), fbhi(2)
        jc = IX_PROJ(j,lratioy)
        fycen = half*(fvcy(j)+fvcy(j+1))
        cycen = half*(cvcy(jc)+cvcy(jc+1))
        voffy(j) = (fycen-cycen)/(cvcy(jc+1)-cvcy(jc))
      end do
      do i = fblo(1), fbhi(1)
         ic = IX_PROJ(i,lratiox)
         fxcen = half*(fvcx(i)+fvcx(i+1))
         cxcen = half*(cvcx(ic)+cvcx(ic+1))
         voffx(i) = (fxcen-cxcen)/(cvcx(ic+1)-cvcx(ic))
      end do

      if(ncbx.ge.ncby.and.ncbx.ge.ncbz)then

c=============== CASE 1: x direction is long direction ======================

c ... added to prevent underflow for small crse values

        do n = 1, nvar 
          do k = cslopelo(3)-1,cslopehi(3)+1
            do j = cslopelo(2)-1,cslopehi(2)+1
              do i = cslopelo(1)-1, cslopehi(1)+1 
                crse(i,j,k,n) = cvmgt(crse(i,j,k,n),zero,abs(crse(i,j,k,n)).gt.1.0D-20)
              end do
            end do
          end do
        end do

c ... computed unlimited and limited slopes

        do n = 1, nvar 

c ... --> in x direction

          do k=cslopelo(3), cslopehi(3)
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                uc_xslope(i,j,k,n) = half*(crse(i+1,j,k,n)-crse(i-1,j,k,n))


c ... note: the following 6 lines of code is repeated in two other places.
c           Similar code snippets appear three times in both the y and z
c           slope calculations.  Although it looks wasteful, writing the code
c           this way sped up the routine by ~10% (on DEC-alpha). So leave 
c           it alone unless you can make it faster -- rbp

                cen  = uc_xslope(i,j,k,n)
                forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

             end do
            end do
          end do
          if (xok) then
            if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
              i = cslopelo(1)
              do k=cslopelo(3), cslopehi(3)
                do j=cslopelo(2), cslopehi(2)
                  uc_xslope(i,j,k,n)  = -sixteen/fifteen*crse(i-1,j,k,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i+1,j,k,n) - tenth*crse(i+2,j,k,n)

                  cen  = uc_xslope(i,j,k,n)
                  forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
            if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
              i = cslopehi(1)
              do k=cslopelo(3), cslopehi(3)
                do j=cslopelo(2), cslopehi(2)
                  uc_xslope(i,j,k,n) = sixteen/fifteen*crse(i+1,j,k,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i-1,j,k,n) + tenth*crse(i-2,j,k,n)

                  cen  = uc_xslope(i,j,k,n)
                  forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if

c ... --> in y direction

          do k=cslopelo(3), cslopehi(3)
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                uc_yslope(i,j,k,n) = half*(crse(i,j+1,k,n)-crse(i,j-1,k,n))

                cen  = uc_yslope(i,j,k,n)
                forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end do
          end do
          if (yok) then
            if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
              j = cslopelo(2)
              do k=cslopelo(3), cslopehi(3)
                do i=cslopelo(1), cslopehi(1)
                  uc_yslope(i,j,k,n)  = -sixteen/fifteen*crse(i,j-1,k,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i,j+1,k,n) - tenth*crse(i,j+2,k,n)

                  cen  = uc_yslope(i,j,k,n)
                  forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
            if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
              j = cslopehi(2)
              do k=cslopelo(3), cslopehi(3)
                do i=cslopelo(1), cslopehi(1)
                  uc_yslope(i,j,k,n) = sixteen/fifteen*crse(i,j+1,k,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i,j-1,k,n) + tenth*crse(i,j-2,k,n)

                  cen  = uc_yslope(i,j,k,n)
                  forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if

c ... --> in z direction

          do k=cslopelo(3), cslopehi(3)
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                uc_zslope(i,j,k,n) = half*(crse(i,j,k+1,n)-crse(i,j,k-1,n))

                cen  = uc_zslope(i,j,k,n)
                forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

              end do
            end do
          end do
          if (zok) then
            if (bclo(3,n) .eq. EXT_DIR .or. bclo(3,n).eq.HOEXTRAP) then
              k = cslopelo(3)
              do j=cslopelo(2), cslopehi(2)
                do i=cslopelo(1), cslopehi(1)
                  uc_zslope(i,j,k,n)  = -sixteen/fifteen*crse(i,j,k-1,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i,j,k+1,n) - tenth*crse(i,j,k+2,n)
 
                  cen  = uc_zslope(i,j,k,n)
                  forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
            if (bchi(3,n) .eq. EXT_DIR .or. bchi(3,n).eq.HOEXTRAP) then
              k = cslopehi(3)
              do j=cslopelo(2), cslopehi(2)
                do i=cslopelo(1), cslopehi(1)
                  uc_zslope(i,j,k,n) = sixteen/fifteen*crse(i,j,k+1,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i,j,k-1,n) + tenth*crse(i,j,k-2,n)
  
                  cen  = uc_zslope(i,j,k,n)
                  forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
              end do
            end if
          end if
        end do

        if (lin_limit.eq.1)then

c ... compute linear limited slopes
c     Note that the limited and the unlimited slopes
c     have the same sign, and it is assumed that they do.

c ... --> compute slope factors

          do k=cslopelo(3), cslopehi(3)
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                xslope_factor(i,j,k) = one
                yslope_factor(i,j,k) = one
                zslope_factor(i,j,k) = one
              end do
            end do
          end do

          do n = 1, nvar 
            do k=cslopelo(3), cslopehi(3)
              do j=cslopelo(2), cslopehi(2)
                do i=cslopelo(1), cslopehi(1)
                  denom = uc_xslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_xslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  xslope_factor(i,j,k) = min(xslope_factor(i,j,k),factorn)

                  denom = uc_yslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_yslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  yslope_factor(i,j,k) = min(yslope_factor(i,j,k),factorn)

                  denom = uc_zslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_zslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  zslope_factor(i,j,k) = min(zslope_factor(i,j,k),factorn)
                end do
              end do
            end do
          end do

c ... --> compute linear limited slopes

          do n = 1, nvar 
            do k=cslopelo(3), cslopehi(3)
              do j=cslopelo(2), cslopehi(2)
                do i=cslopelo(1), cslopehi(1)
                  lc_xslope(i,j,k,n) = xslope_factor(i,j,k)*uc_xslope(i,j,k,n)
                  lc_yslope(i,j,k,n) = yslope_factor(i,j,k)*uc_yslope(i,j,k,n)
                  lc_zslope(i,j,k,n) = zslope_factor(i,j,k)*uc_zslope(i,j,k,n)
                end do
              end do
            end do
          end do
        end if

c ... do the interpolation

        do n = 1, nvar
          do k = fblo(3), fbhi(3)
            kc = IX_PROJ(k,lratioz)
            do j = fblo(2), fbhi(2)
              jc = IX_PROJ(j,lratioy)
              do i = fblo(1), fbhi(1)
                ic = IX_PROJ(i,lratiox)
                fine(i,j,k,n) = crse(ic,jc,kc,n) + voffx(i)*lc_xslope(ic,jc,kc,n)
     &                                      + voffy(j)*lc_yslope(ic,jc,kc,n)
     &                                      + voffz(k)*lc_zslope(ic,jc,kc,n)
              end do
            end do
          end do
        end do

      else if(ncby.ge.ncbx.and.ncby.ge.ncbz)then

c=============== CASE 2: y direction is long direction ======================

c ... added to prevent underflow for small crse values

        do n = 1, nvar 
          do k = cslopelo(3)-1,cslopehi(3)+1
            do i = cslopelo(1)-1, cslopehi(1)+1 
              do j = cslopelo(2)-1,cslopehi(2)+1
                crse(i,j,k,n) = cvmgt(crse(i,j,k,n),zero,abs(crse(i,j,k,n)).gt.1.0D-20)
              end do
            end do
          end do
        end do

c ... computed unlimited and limited slopes

        do n = 1, nvar 

c ... --> in x direction

          do k=cslopelo(3), cslopehi(3)
            do i=cslopelo(1), cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                uc_xslope(i,j,k,n) = half*(crse(i+1,j,k,n)-crse(i-1,j,k,n))

                cen  = uc_xslope(i,j,k,n)
                forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

              end do
            end do
          end do
          if (xok) then
            if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
              i = cslopelo(1)
              do k=cslopelo(3), cslopehi(3)
                do j=cslopelo(2), cslopehi(2)
                  uc_xslope(i,j,k,n)  = -sixteen/fifteen*crse(i-1,j,k,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i+1,j,k,n) - tenth*crse(i+2,j,k,n)

                  cen  = uc_xslope(i,j,k,n)
                  forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
            if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
              i = cslopehi(1)
              do k=cslopelo(3), cslopehi(3)
                do j=cslopelo(2), cslopehi(2)
                  uc_xslope(i,j,k,n) = sixteen/fifteen*crse(i+1,j,k,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i-1,j,k,n) + tenth*crse(i-2,j,k,n)

                  cen  = uc_xslope(i,j,k,n)
                  forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if

c ... --> in y direction

          do k=cslopelo(3), cslopehi(3)
            do i=cslopelo(1), cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                uc_yslope(i,j,k,n) = half*(crse(i,j+1,k,n)-crse(i,j-1,k,n))

                cen  = uc_yslope(i,j,k,n)
                forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

              end do
            end do
          end do
          if (yok) then
            if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
              j = cslopelo(2)
              do k=cslopelo(3), cslopehi(3)
                do i=cslopelo(1), cslopehi(1)
                  uc_yslope(i,j,k,n)  = -sixteen/fifteen*crse(i,j-1,k,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i,j+1,k,n) - tenth*crse(i,j+2,k,n)

                  cen  = uc_yslope(i,j,k,n)
                  forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
            if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
              j = cslopehi(2)
              do k=cslopelo(3), cslopehi(3)
                do i=cslopelo(1), cslopehi(1)
                  uc_yslope(i,j,k,n) = sixteen/fifteen*crse(i,j+1,k,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i,j-1,k,n) + tenth*crse(i,j-2,k,n)

                  cen  = uc_yslope(i,j,k,n)
                  forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if

c ... --> in z direction

          do k=cslopelo(3), cslopehi(3)
            do i=cslopelo(1), cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                uc_zslope(i,j,k,n) = half*(crse(i,j,k+1,n)-crse(i,j,k-1,n))

                cen  = uc_zslope(i,j,k,n)
                forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end do
          end do
          if (zok) then
            if (bclo(3,n) .eq. EXT_DIR .or. bclo(3,n).eq.HOEXTRAP) then
              k = cslopelo(3)
              do i=cslopelo(1), cslopehi(1)
                do j=cslopelo(2), cslopehi(2)
                  uc_zslope(i,j,k,n)  = -sixteen/fifteen*crse(i,j,k-1,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i,j,k+1,n) - tenth*crse(i,j,k+2,n)

                  cen  = uc_zslope(i,j,k,n)
                  forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                 end do
              end do
            end if
            if (bchi(3,n) .eq. EXT_DIR .or. bchi(3,n).eq.HOEXTRAP) then
              k = cslopehi(3)
              do i=cslopelo(1), cslopehi(1)
                do j=cslopelo(2), cslopehi(2)
                  uc_zslope(i,j,k,n) = sixteen/fifteen*crse(i,j,k+1,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i,j,k-1,n) + tenth*crse(i,j,k-2,n)

                  cen  = uc_zslope(i,j,k,n)
                  forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if
        end do

        if (lin_limit.eq.1)then

c ... compute linear limited slopes
c     Note that the limited and the unlimited slopes
c     have the same sign, and it is assumed that they do.

c ... --> compute slope factors

          do k=cslopelo(3), cslopehi(3)
            do i=cslopelo(1), cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                xslope_factor(i,j,k) = one
                yslope_factor(i,j,k) = one
                zslope_factor(i,j,k) = one
              end do
            end do
          end do

          do n = 1, nvar 
            do k=cslopelo(3), cslopehi(3)
              do i=cslopelo(1), cslopehi(1)
                do j=cslopelo(2), cslopehi(2)
                  denom = uc_xslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_xslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  xslope_factor(i,j,k) = min(xslope_factor(i,j,k),factorn)

                  denom = uc_yslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_yslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  yslope_factor(i,j,k) = min(yslope_factor(i,j,k),factorn)

                  denom = uc_zslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_zslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  zslope_factor(i,j,k) = min(zslope_factor(i,j,k),factorn)
                end do
              end do
            end do
          end do

c ... --> compute linear limited slopes

          do n = 1, nvar 
            do k=cslopelo(3), cslopehi(3)
              do i=cslopelo(1), cslopehi(1)
                do j=cslopelo(2), cslopehi(2)
                  lc_xslope(i,j,k,n) = xslope_factor(i,j,k)*uc_xslope(i,j,k,n)
                  lc_yslope(i,j,k,n) = yslope_factor(i,j,k)*uc_yslope(i,j,k,n)
                  lc_zslope(i,j,k,n) = zslope_factor(i,j,k)*uc_zslope(i,j,k,n)
                end do
              end do
            end do
          end do
        end if

c ... do the interpolation

        do n = 1, nvar
          do k = fblo(3), fbhi(3)
            kc = IX_PROJ(k,lratioz)
            do i = fblo(1), fbhi(1)
              ic = IX_PROJ(i,lratiox)
              do j = fblo(2), fbhi(2)
                jc = IX_PROJ(j,lratioy)
                fine(i,j,k,n) = crse(ic,jc,kc,n) + voffx(i)*lc_xslope(ic,jc,kc,n)
     &                                      + voffy(j)*lc_yslope(ic,jc,kc,n)
     &                                      + voffz(k)*lc_zslope(ic,jc,kc,n)
              end do
            end do
          end do
        end do

      else if(ncbz.ge.ncbx.and.ncbz.ge.ncby)then

c=============== CASE 3: z direction is long direction ======================

c ... added to prevent underflow for small crse values

        do n = 1, nvar 
          do j = cslopelo(2)-1,cslopehi(2)+1
            do i = cslopelo(1)-1, cslopehi(1)+1 
              do k = cslopelo(3)-1,cslopehi(3)+1
                crse(i,j,k,n) = cvmgt(crse(i,j,k,n),zero,abs(crse(i,j,k,n)).gt.1.0D-20)
              end do
            end do
          end do
        end do

c ... computed unlimited and limited slopes

        do n = 1, nvar 

c ... --> in x direction

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              do k=cslopelo(3), cslopehi(3)
                uc_xslope(i,j,k,n) = half*(crse(i+1,j,k,n)-crse(i-1,j,k,n))

                cen  = uc_xslope(i,j,k,n)
                forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end do
          end do
          if (xok) then
            if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
              i = cslopelo(1)
              do j=cslopelo(2), cslopehi(2)
                do k=cslopelo(3), cslopehi(3)
                  uc_xslope(i,j,k,n)  = -sixteen/fifteen*crse(i-1,j,k,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i+1,j,k,n) - tenth*crse(i+2,j,k,n)

                  cen  = uc_xslope(i,j,k,n)
                  forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                 end do
              end do
            end if
            if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
              i = cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                do k=cslopelo(3), cslopehi(3)
                  uc_xslope(i,j,k,n) = sixteen/fifteen*crse(i+1,j,k,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i-1,j,k,n) + tenth*crse(i-2,j,k,n)

                  cen  = uc_xslope(i,j,k,n)
                  forw = two*(crse(i+1,j,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i-1,j,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_xslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if

c ... --> in y direction

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              do k=cslopelo(3), cslopehi(3)
                uc_yslope(i,j,k,n) = half*(crse(i,j+1,k,n)-crse(i,j-1,k,n))

                cen  = uc_yslope(i,j,k,n)
                forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end do
          end do
          if (yok) then
            if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
              j = cslopelo(2)
              do i=cslopelo(1), cslopehi(1)
                do k=cslopelo(3), cslopehi(3)
                  uc_yslope(i,j,k,n)  = -sixteen/fifteen*crse(i,j-1,k,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i,j+1,k,n) - tenth*crse(i,j+2,k,n)

                  cen  = uc_yslope(i,j,k,n)
                  forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                 end do
              end do
            end if
            if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
              j = cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                do k=cslopelo(3), cslopehi(3)
                  uc_yslope(i,j,k,n) = sixteen/fifteen*crse(i,j+1,k,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i,j-1,k,n) + tenth*crse(i,j-2,k,n)
 
                  cen  = uc_yslope(i,j,k,n)
                  forw = two*(crse(i,j+1,k,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j-1,k,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_yslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
              end do
            end if
          end if

c ... --> in z direction

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              do k=cslopelo(3), cslopehi(3)
                uc_zslope(i,j,k,n) = half*(crse(i,j,k+1,n)-crse(i,j,k-1,n))

                cen  = uc_zslope(i,j,k,n)
                forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end do
          end do
          if (zok) then
            if (bclo(3,n) .eq. EXT_DIR .or. bclo(3,n).eq.HOEXTRAP) then
              k = cslopelo(3)
              do i=cslopelo(1), cslopehi(1)
                do j=cslopelo(2), cslopehi(2)
                  uc_zslope(i,j,k,n)  = -sixteen/fifteen*crse(i,j,k-1,n) 
     &                        + half*crse(i,j,k,n)
     $                        + two3rd*crse(i,j,k+1,n) - tenth*crse(i,j,k+2,n)

                  cen  = uc_zslope(i,j,k,n)
                  forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                 end do
              end do
            end if
            if (bchi(3,n) .eq. EXT_DIR .or. bchi(3,n).eq.HOEXTRAP) then
              k = cslopehi(3)
              do i=cslopelo(1), cslopehi(1)
                do j=cslopelo(2), cslopehi(2)
                  uc_zslope(i,j,k,n) = sixteen/fifteen*crse(i,j,k+1,n) 
     &                      - half*crse(i,j,k,n)
     $                      - two3rd*crse(i,j,k-1,n) + tenth*crse(i,j,k-2,n)

                  cen  = uc_zslope(i,j,k,n)
                  forw = two*(crse(i,j,k+1,n)-crse(i,j,k,n))
                  back = two*(crse(i,j,k,n)-crse(i,j,k-1,n))
                  slp  = min(abs(forw),abs(back))
                  slp  = cvmgp(slp,zero,forw*back)
                  lc_zslope(i,j,k,n)=sign(one,cen)*min(slp,abs(cen))

                end do
              end do
            end if
          end if
        end do

        if (lin_limit.eq.1)then

c ... compute linear limited slopes
c     Note that the limited and the unlimited slopes
c     have the same sign, and it is assumed that they do.

c ... --> compute slope factors

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              do k=cslopelo(3), cslopehi(3)
                xslope_factor(i,j,k) = one
                yslope_factor(i,j,k) = one
                zslope_factor(i,j,k) = one
              end do
            end do
          end do

          do n = 1, nvar 
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                do k=cslopelo(3), cslopehi(3)
                  denom = uc_xslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_xslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  xslope_factor(i,j,k) = min(xslope_factor(i,j,k),factorn)

                  denom = uc_yslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_yslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  yslope_factor(i,j,k) = min(yslope_factor(i,j,k),factorn)

                  denom = uc_zslope(i,j,k,n)
                  denom = cvmgt(denom,one,denom.ne.zero)
                  factorn = lc_zslope(i,j,k,n)/denom
                  factorn = cvmgt(one,factorn,denom.eq.zero)
                  zslope_factor(i,j,k) = min(zslope_factor(i,j,k),factorn)
                end do
              end do
            end do
          end do

c ... --> compute linear limited slopes

          do n = 1, nvar 
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                do k=cslopelo(3), cslopehi(3)
                  lc_xslope(i,j,k,n) = xslope_factor(i,j,k)*uc_xslope(i,j,k,n)
                  lc_yslope(i,j,k,n) = yslope_factor(i,j,k)*uc_yslope(i,j,k,n)
                  lc_zslope(i,j,k,n) = zslope_factor(i,j,k)*uc_zslope(i,j,k,n)
                end do
              end do
            end do
          end do
        end if

c ... do the interpolation

        do n = 1, nvar
          do j = fblo(2), fbhi(2)
            jc = IX_PROJ(j,lratioy)
            do i = fblo(1), fbhi(1)
              ic = IX_PROJ(i,lratiox)
              do k = fblo(3), fbhi(3)
                kc = IX_PROJ(k,lratioz)
                fine(i,j,k,n) = crse(ic,jc,kc,n) + voffx(i)*lc_xslope(ic,jc,kc,n)
     &                                      + voffy(j)*lc_yslope(ic,jc,kc,n)
     &                                      + voffz(k)*lc_zslope(ic,jc,kc,n)
              end do
            end do
          end do
        end do
      end if

      end
c ::: 
c ::: --------------------------------------------------------------
c ::: 

      subroutine FORT_CQINTERP (fine, DIMS(fine), 
     $                          DIMS(fb),
     $                          nvar, lratiox, lratioy, lratioz, crse,
     $                          clo, chi, DIMS(cb),
     $		                fslo, fshi, cslope, clen, fslope, fdat,
     $                          flen, voff, bc, limslope,
     $                          fvcx, fvcy, fvcz, cvcx, cvcy, cvcz)

      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer DIMDEC(cb)
      integer fslo(3), fshi(3)
      integer nvar, lratiox, lratioy, lratioz
      integer bc(3,2,nvar)
      integer clen, flen, clo, chi, limslope
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 3)
      REAL_T fslope(flen, 3)
      REAL_T fdat(flen)
      REAL_T voff(flen)
      REAL_T fvcx(fb_l1:fb_h1+1)
      REAL_T fvcy(fb_l2:fb_h2+1)
      REAL_T fvcz(fb_l3:fb_h3+1)
      REAL_T cvcx(cb_l1:cb_h1+1)
      REAL_T cvcy(cb_l2:cb_h2+1)
      REAL_T cvcz(cb_l3:cb_h3+1)

      call bl_abort('QUADRATIC INTERP NOT IMPLEMEMNTED IN 3-D')

      end

# if 0
c 
c -----------------------------------------------------------------
c THIS IS A SCALAR VERSION OF THE ABOVE CODE
c -----------------------------------------------------------------
c
      subroutine FORT_CCINTERP2 (fine, DIMS(fine),
     $                           fb_l1, fb_l2, fb_l3,
     $                           fb_h1, fb_h2, fb_h3,
     $                           nvar, lratiox, lratioy, lratioz, crse,
     $                           clo, chi, cb_l1, cb_l2, cb_l3,
     $                           cb_h1, cb_h2, cb_h3,
     $		                 fslo, fshi, cslope, clen, fslope, fdat,
     $                           flen, voff, bc, limslope)

      integer DIMDEC(fine)
      integer fb_l1, fb_l2, fb_l3
      integer fb_h1, fb_h2, fb_h3
      integer cb_l1, cb_l2, cb_l3
      integer cb_h1, cb_h2, cb_h3
      integer fslo(3), fshi(3)
      integer bc(3,2,nvar)
      integer lratiox, lratioy, lratioz, nvar, clen, flen, clo, chi
      integer limslope
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(cb_l1-1:cb_h1+1, cb_l2-1:cb_h2+1, 
     &            cb_l3-1:cb_h3+1, nvar )
      REAL_T cslope(cb_l1-1:cb_h1+1, cb_l2-1:cb_h2+1, 
     &              cb_l3-1:cb_h3+1, 3 )
      REAL_T fslope(flen, 3)
      REAL_T fdat(flen)
      REAL_T voff(flen)

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
      integer n, fn
      integer i, ii, ic, ioff
      integer j, jj, jc, joff
      integer k, kk, kc, koff
      REAL_T hafratx, hafraty, hafratz, volratiox, volratioy, volratioz
      REAL_T cen, forw, back, slp
      REAL_T xoff, yoff, zoff
      REAL_T cx, cy, cz
      REAL_T sgn
      integer ilo, ihi, jlo, jhi, klo, khi

c     :::::: helpful statement functions
      REAL_T  slplox, slphix, slploy, slphiy, slploz, slphiz
      REAL_T  c1, c2, c3, c4

      slplox(i,j,k,n) =  - c1*crse(i-1,j,k,n)
     $		         + c2*crse(i  ,j,k,n)
     $                   + c3*crse(i+1,j,k,n)
     $			 - c4*crse(i+2,j,k,n)
      slphix(i,j,k,n) =    c1*crse(i+1,j,k,n)
     $		         - c2*crse(i  ,j,k,n)
     $                   - c3*crse(i-1,j,k,n)
     $			 + c4*crse(i-2,j,k,n)
      slploy(i,j,k,n) =  - c1*crse(i,j-1,k,n)
     $		         + c2*crse(i,j  ,k,n)
     $                   + c3*crse(i,j+1,k,n)
     $			 - c4*crse(i,j+2,k,n)
      slphiy(i,j,k,n) =    c1*crse(i,j+1,k,n)
     $		         - c2*crse(i,j  ,k,n)
     $                   - c3*crse(i,j-1,k,n)
     $			 + c4*crse(i,j-2,k,n)
      slploz(i,j,k,n) =  - c1*crse(i,j,k-1,n)
     $		         + c2*crse(i,j,k  ,n)
     $                   + c3*crse(i,j,k+1,n)
     $			 - c4*crse(i,j,k+2,n)
      slphiz(i,j,k,n) =    c1*crse(i,j,k+1,n)
     $		         - c2*crse(i,j,k  ,n)
     $                   - c3*crse(i,j,k-1,n)
     $			 + c4*crse(i,j,k-2,n)
      
      c1 = sixteen/fifteen
      c2 = half
      c3 = two3rd
      c4 = tenth

      hafratx = half*dble(lratiox-1)
      hafraty = half*dble(lratioy-1)
      hafratz = half*dble(lratioz-1)

      volratiox = one/dble(lratiox)
      volratioy = one/dble(lratioy)
      volratioz = one/dble(lratioz)

      do n = 1, nvar
      do kc = cb_l3, cb_h3
      do jc = cb_l2, cb_h2
      do ic = cb_l1, cb_h1

c        ::::: compute x slopes
	 if (limslope .ne. 0) then
            cen  = half*(crse(ic+1,jc,kc,n)-crse(ic-1,jc,kc,n))
            forw = two*(crse(ic+1,jc,kc,n)-crse(ic,jc,kc,n))
            back = two*(crse(ic,jc,kc,n) - crse(ic-1,jc,kc,n))
	    slp  = min(abs(forw),abs(back))
	    slp  = cvmgp(slp,zero,forw*back)
	    sgn  = sign(one,cen)
            cx   = sgn*min(slp,abs(cen))
            if (ic.eq.cb_l1 .and. (bclo(1,n) .eq. EXT_DIR 
     &	        .or. bclo(1,n).eq.HOEXTRAP)) then
	        cen  = slplox(ic,jc,kc,n)
                cx   = sgn*min(slp,abs(cen))
            end if
            if (ic.eq.cb_h1 .and. (bchi(1,n) .eq. EXT_DIR 
     &          .or. bchi(1,n).eq.HOEXTRAP)) then
                cen  = slphix(ic,jc,kc,n)
                cx   = sgn*min(slp,abs(cen))
            end if
	 else
	    cx = half*(crse(ic+1,jc,kc,n)-crse(ic-1,jc,kc,n))
            if (ic.eq.cb_l1 .and. (bclo(1,n) .eq. EXT_DIR 
     &	        .or. bclo(1,n).eq.HOEXTRAP)) then
	        cx  = slplox(ic,jc,kc,n)
            end if
            if (ic.eq.cb_h1 .and. (bchi(1,n) .eq. EXT_DIR 
     &          .or. bchi(1,n).eq.HOEXTRAP)) then
                cx  = slphix(ic,jc,kc,n)
            end if
	 end if

c	 ::::: slopes in the Y direction
	 if (limslope .ne. 0) then
            cen  = half*(crse(ic,jc+1,kc,n)-crse(ic,jc-1,kc,n))
            forw = two*(crse(ic,jc+1,kc,n)-crse(ic,jc,kc,n))
            back = two*(crse(ic,jc,kc,n) - crse(ic,jc-1,kc,n))
	    slp  = min(abs(forw),abs(back))
	    slp  = cvmgp(slp,zero,forw*back)
	    sgn  = sign(one,cen)
            cy   = sgn*min(slp,abs(cen))
            if (jc.eq.cb_l2 .and. (bclo(2,n) .eq. EXT_DIR 
     &	        .or. bclo(2,n).eq.HOEXTRAP)) then
	        cen  = slploy(ic,jc,kc,n)
                cy   = sgn*min(slp,abs(cen))
            end if
            if (jc.eq.cb_h2 .and. (bchi(2,n) .eq. EXT_DIR 
     &          .or. bchi(2,n).eq.HOEXTRAP)) then
                cen  = slphiy(ic,jc,kc,n)
                cy   = sgn*min(slp,abs(cen))
            end if
	 else
	    cy = half*(crse(ic,jc+1,kc,n)-crse(ic,jc-1,kc,n))
            if (jc.eq.cb_l2 .and. (bclo(2,n) .eq. EXT_DIR 
     &	        .or. bclo(2,n).eq.HOEXTRAP)) then
	        cy   = slploy(ic,jc,kc,n)
            end if
            if (ic.eq.cb_h2 .and. (bchi(2,n) .eq. EXT_DIR 
     &          .or. bchi(2,n).eq.HOEXTRAP)) then
                cy   = slphiy(ic,jc,kc,n)
            end if
	 end if

c	 ::::: slopes in the Z direction
	 if (limslope .ne. 0) then
            cen  = half*(crse(ic,jc,kc+1,n)-crse(ic,jc,kc-1,n))
            forw = two*(crse(ic,jc,kc+1,n)-crse(ic,jc,kc,n))
            back = two*(crse(ic,jc,kc,n) - crse(ic,jc,kc-1,n))
	    slp  = min(abs(forw),abs(back))
	    slp  = cvmgp(slp,zero,forw*back)
	    sgn  = sign(one,cen)
            cz   = sgn*min(slp,abs(cen))
            if (kc.eq.cb_l3 .and. (bclo(3,n) .eq. EXT_DIR 
     &	        .or. bclo(3,n).eq.HOEXTRAP)) then
	        cen  = slploz(ic,jc,kc,n)
                cz   = sgn*min(slp,abs(cen))
            end if
            if (kc.eq.cb_h3 .and. (bchi(3,n) .eq. EXT_DIR 
     &          .or. bchi(3,n).eq.HOEXTRAP)) then
                cen  = slphiz(ic,jc,kc,n)
                cz   = sgn*min(slp,abs(cen))
            end if
	 else
	    cz = half*(crse(ic,jc,kc+1,n)-crse(ic,jc,kc-1,n))
            if (kc.eq.cb_l3 .and. (bclo(3,n) .eq. EXT_DIR 
     &	        .or. bclo(3,n).eq.HOEXTRAP)) then
	        cz   = slploz(ic,jc,kc,n)
            end if
            if (kc.eq.cb_h3 .and. (bchi(3,n) .eq. EXT_DIR 
     &          .or. bchi(3,n).eq.HOEXTRAP)) then
                cz   = slphiz(ic,jc,kc,n)
            end if
	 end if

c	 ::::: now interpolate to fine grid
	 ii  = lratiox*ic
	 ilo = max(ii,fb_l1) - ii
	 ihi = min(ii+lratiox-1,fb_h1) - ii
         jj  = lratioy*jc
	 jlo = max(jj,fb_l2) - jj
	 jhi = min(jj+lratioy-1,fb_h2) - jj
	 kk  = lratioz*kc
	 klo = max(kk,fb_l3) - kk
	 khi = min(kk+lratioz-1,fb_h2) - kk

	 do koff = klo, khi
	    k = lratioz*kc + koff
	    zoff = dble(koff)-hafratz
	    do joff = jlo, jhi
	       j = lratioy*jc + joff
	       yoff = dble(joff)-hafraty
	       do ioff = ilo, ihi
	          i = lratiox*ic + ioff
		  xoff = dble(ioff)-hafratx
		  fine(i,j,k,n) = crse(ic,jc,kc,n) + 
     &				( volratiox*xoff*cx + volratioy*yoff*cy 
     &                          + volratioz*zoff*cz )
	       end do
	    end do
	 end do
 
      end do
      end do
      end do
      end do

      end
#endif


c ::: 
c ::: --------------------------------------------------------------
c ::: pcinterp:  cell centered piecewise constant interpolation
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data 
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c ::: cblo,cbhi    =>  (const) coarse grid region containing fblo,fbhi
c ::: 
c ::: longdir      =>  (const)  which index direction is longest (1 or 2)
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: 
c ::: TEMPORARY ARRAYS
c ::: ftmp         =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_PCINTERP (crse,DIMS(crse),cblo,cbhi,
     &                          fine,DIMS(fine),fblo,fbhi,
     &                          longdir,lratiox,lratioy,lratioz,nvar,
     &                          ftmp, ftmp_lo, ftmp_hi)
      integer DIMDEC(crse)
      integer cblo(3), cbhi(3)
      integer DIMDEC(fine)
      integer fblo(3), fbhi(3)
      integer nvar, lratiox, lratioy, lratioz, longdir
      integer ftmp_lo, ftmp_hi
      REAL_T  crse(DIMV(crse), nvar)
      REAL_T  fine(DIMV(fine), nvar)
      REAL_T  ftmp(ftmp_lo:ftmp_hi)

      integer i, j, k, ic, jc, kc, ioff, joff, koff, n
      integer istrt, istop, jstrt, jstop, kstrt, kstop
      integer ilo, ihi, jlo, jhi, klo, khi

      if (longdir .eq. 1) then
         do n = 1, nvar
	 do kc = cblo(3), cbhi(3)
	    kstrt = kc*lratioz
	    kstop = (kc+1)*lratioz - 1
	    klo = max(fblo(3),kstrt)
	    khi = min(fbhi(3),kstop)
            do jc = cblo(2), cbhi(2)

c	       ::::: fill strip in i direction
	       do ioff = 0, lratiox-1
	          do ic = cblo(1), cbhi(1)
	             i = lratiox*ic + ioff
	             ftmp(i) = crse(ic,jc,kc,n)
                  end do
	       end do

c	       ::::: stuff into fine array
	       jstrt = jc*lratioy
	       jstop = (jc+1)*lratioy - 1
	       jlo = max(fblo(2),jstrt)
	       jhi = min(fbhi(2),jstop)
	       do k = klo, khi
	       do j = jlo, jhi
	       do i = fblo(1), fbhi(1)
	          fine(i,j,k,n) = ftmp(i)
	       end do
	       end do
	       end do
	    end do
	 end do
	 end do
      else if (longdir.eq.2) then
         do n = 1, nvar
	 do kc = cblo(3), cbhi(3)
	    kstrt = kc*lratioz
	    kstop = (kc+1)*lratioz - 1
	    klo = max(fblo(3),kstrt)
	    khi = min(fbhi(3),kstop)
            do ic = cblo(1), cbhi(1)

c	       ::::: fill strip in j direction
	       do joff = 0, lratioy-1
	          do jc = cblo(2), cbhi(2)
	             j = lratioy*jc + joff
	             ftmp(j) = crse(ic,jc,kc,n)
                  end do
	       end do

c	       ::::: stuff into fine array
	       istrt = ic*lratiox
	       istop = (ic+1)*lratiox - 1
	       ilo = max(fblo(1),istrt)
	       ihi = min(fbhi(1),istop)
	       do k = klo, khi
	       do i = ilo, ihi
	       do j = fblo(2), fbhi(2)
	          fine(i,j,k,n) = ftmp(j)
	       end do
	       end do
	       end do
	    end do
	 end do
	 end do
      else
         do n = 1, nvar
	 do ic = cblo(1), cbhi(1)
	    istrt = ic*lratiox
	    istop = (ic+1)*lratiox - 1
	    ilo = max(fblo(1),istrt)
	    ihi = min(fbhi(1),istop)
            do jc = cblo(2), cbhi(2)

c	       ::::: fill strip in k direction
	       do koff = 0, lratioz-1
	          do kc = cblo(3), cbhi(3)
	             k = lratioz*kc + koff
	             ftmp(k) = crse(ic,jc,kc,n)
                  end do
	       end do

c	       ::::: stuff into fine array
	       jstrt = jc*lratioy
	       jstop = (jc+1)*lratioy - 1
	       jlo = max(fblo(2),jstrt)
	       jhi = min(fbhi(2),jstop)
	       do i = ilo, ihi
	       do j = jlo, jhi
	       do k = fblo(3), fbhi(3)
	          fine(i,j,k,n) = ftmp(k)
	       end do
	       end do
	       end do
	    end do
	 end do
	 end do
      end if

      end


c ::: 
c ::: --------------------------------------------------------------
c ::: protect_interp:   redo interpolation if the result of linccinterp
c ::: generates under- or overshoots.
c ::: 
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: cblo,cbhi    =>  (const)  coarse equivalent of fblo,fbhi
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: clo,chi      =>  (const)  index limits of crse grid
c :::
c ::: --------------------------------------------------------------
c ::: 

      subroutine FORT_PROTECT_INTERP (fine, DIMS(fine), fblo, fbhi, 
     &                                crse, DIMS(crse), cblo, cbhi,
     &                                fine_state, DIMS(state), 
     &                                nvar, lratiox, lratioy, lratioz, bc)

      implicit none

      integer DIMDEC(fine)
      integer DIMDEC(crse)
      integer DIMDEC(state)
      integer fblo(3), fbhi(3)
      integer cblo(3), cbhi(3)
      integer lratiox, lratioy, lratioz, nvar
      integer bc(3,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(DIMV(crse), nvar)
      REAL_T fine_state(DIMV(state), nvar)
      REAL_T sum(nvar)
      REAL_T crse_tot(nvar)
      integer num_cells_ok(nvar)

      integer rMAX
      parameter (rMAX = 8)
      REAL_T alpha, sumN, sumP, crseTot, negVal, posVal
      REAL_T sum_fine_new,sum_fine_old
      REAL_T orig_fine(0:rMAX-1,0:rMAX-1,0:rMAX-1)
      integer redo_me
      integer ilo,ihi,jlo,jhi,klo,khi
      integer i,j,k,ic,jc,kc,n,nn
      integer numFineCells
      integer icase

      do kc = cblo(3), cbhi(3)
      do jc = cblo(2), cbhi(2)
      do ic = cblo(1), cbhi(1)

         ilo = max(lratiox*ic            ,fine_l1)
         ihi = min(lratiox*ic+(lratiox-1),fine_h1)
         jlo = max(lratioy*jc            ,fine_l2)
         jhi = min(lratioy*jc+(lratioy-1),fine_h2)
         klo = max(lratioz*kc            ,fine_l3)
         khi = min(lratioz*kc+(lratioz-1),fine_h3)

         do n = 2, nvar-1

            redo_me = 0
            do k = klo,khi
            do j = jlo,jhi
            do i = ilo,ihi
               if ((fine_state(i,j,k,n)+fine(i,j,k,n)) .lt. 0.d0) redo_me = 1
            enddo
            enddo
            enddo
c
c ****************************************************************************************
c
c           If all the fine values are non-negative after the original interpolated 
c            correction, then we do nothing here.
c
c           If any of the fine values are negative after the original interpolated
c            correction, then we do our best.
c
c           Special cases:
c
c             1) Coarse correction > 0, and fine_state has some cells with 
c                negative values which will be filled before adding to the other cells.
c                Use the correction to bring negative cells to zero, then
c                distribute the remaining positive proportionally.
c
c             2) Coarse correction > 0, and correction can not make them all
c                positive.  Add correction only to the negative cells, in proportion
c                to their magnitude.
c
c             3) Coarse correction < 0, and fine_state DOES NOT have enough
c                  have enough positive state to absorb it.  Here we bring
c                  all the positive fine cells to zero then distribute the remaining
c                  negative amount in such a way as to make them all as close to the
c                  same negative value as possible.
c
c             4) Coarse correction < 0, fine_state has enough
c                  positive state to absorb it without making any fine 
c                  cells negative, BUT fine_state+fine is currently negative
c                  in at least one fine cell.  Here just take a constant percentage
c                  away from each positive and don't touch the negatives.
c
c             crseTot = sum of all interpolated values of the correction,
c                       which is equivalent to the coarse correction * ratio**3
c             SumN = sum of all negative values of fine_state
c             SumP = sum of all positive values of fine_state
c
c ****************************************************************************************
c

            if (redo_me .eq. 1) then

               icase = 0
               sum_fine_old = 0.d0
               do k = klo,khi
               do j = jlo,jhi
               do i = ilo,ihi
                  sum_fine_old = sum_fine_old + fine(i,j,k,n)
                  orig_fine(i-ilo,j-jlo,k-klo) = fine(i,j,k,n)
               enddo
               enddo
               enddo

               crseTot = sum_fine_old
               numFineCells = (ihi-ilo+1) * (jhi-jlo+1) * (khi-klo+1)

               sumN = zero
               sumP = zero
               do k = klo,khi
               do j = jlo,jhi
               do i = ilo,ihi
                  if (fine_state(i,j,k,n) .le. 0.d0) then
                    sumN = SumN + fine_state(i,j,k,n)
                  else
                    sumP = sumP + fine_state(i,j,k,n)
                  endif
               enddo
               enddo
               enddo

               if (crseTot .gt. 0.d0 .and. crseTot .ge. abs(sumN)) then
c              Here we want to fill in the negative values first, then add
c                the remaining positive proportionally.

                   icase = 1
                   do k = klo,khi
                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,k,n) .le. 0.d0) then
                        fine(i,j,k,n) = -fine_state(i,j,k,n)
                      endif
                   enddo
                   enddo
                   enddo

                   if (sumP > 0.d0) then

                    alpha = (crseTot - abs(sumN)) / sumP

                    do k = klo,khi
                    do j = jlo,jhi
                    do i = ilo,ihi
                       if (fine_state(i,j,k,n) .ge. 0.d0) then
                         fine(i,j,k,n) = alpha * fine_state(i,j,k,n)
                       endif
                    enddo
                    enddo
                    enddo

                  else

                    posVal = (crseTot - abs(sumN)) / float(numFineCells)

                    do k = klo,khi
                    do j = jlo,jhi
                    do i = ilo,ihi
                       fine(i,j,k,n) = fine(i,j,k,n) + posVal
                    enddo
                    enddo
                    enddo

                  endif

               endif

               if (crseTot .gt. 0.d0. and. crseTot .lt. abs(sumN)) then
c              Here we don't have enough positive correction to fill all the
c                negative values of state, so we just try to fill them proportionally
c                and don't add any correction to the states already positive.

                   icase = 2
                   alpha = crseTot / abs(sumN)

                   do k = klo,khi
                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,k,n) .lt. 0.d0) then
                        fine(i,j,k,n) = alpha * abs(fine_state(i,j,k,n))
                      else 
                        fine(i,j,k,n) = 0.d0
                      endif
                   enddo
                   enddo
                   enddo

               endif

               if (crseTot .lt. 0.d0. and. abs(crseTot) .gt. sumP) then
c              Here we don't have enough positive states to absorb all the
c                negative correction, so we want to end up with all the fine
c                cells having the same negative value.

                   icase = 3
                   negVal = (sumP + sumN + crseTot)/float(numFineCells)

                   do k = klo,khi
                   do j = jlo,jhi
                   do i = ilo,ihi
                      fine(i,j,k,n) = negVal - fine_state(i,j,k,n)
                   enddo
                   enddo
                   enddo

               endif

               if (crseTot .lt. 0.d0 .and. abs(crseTot) .lt. sumP
     $                               .and. (sumP+sumN+crseTot) .gt. 0.d0) then
c              Here we have enough positive states to absorb all the
c                negative correction *and* redistribute to make negative cells
c                positive. 

                   icase = 4
                   alpha = (crseTot + sumN) / sumP

                   do k = klo,khi
                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,k,n) .lt. 0.d0) then
                        fine(i,j,k,n) = -fine_state(i,j,k,n)
                      else
                        fine(i,j,k,n) = alpha * fine_state(i,j,k,n)
                      endif  
                   enddo
                   enddo
                   enddo

               endif

               if (crseTot .lt. 0.d0. and. abs(crseTot) .lt. sumP
     $                               .and. (sumP+sumN+crseTot) .le. 0.d0) then
c              Here we have enough positive states to absorb all the
c                negative correction, but not to fix the states already negative. 
c                We bring all the positive states to zero, and use whatever 
c                remaining positiveness from the states to help the negative states.

                   icase = 5
                   alpha = (crseTot + sumP) / sumN

                   do k = klo,khi
                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,k,n) .gt. 0.d0) then
                        fine(i,j,k,n) = -fine_state(i,j,k,n)
                      else 
                        fine(i,j,k,n) = alpha * fine_state(i,j,k,n)
                      endif
                   enddo
                   enddo
                   enddo

               endif

               sum_fine_new = 0.d0
               do k = klo,khi
               do j = jlo,jhi
               do i = ilo,ihi
                  sum_fine_new = sum_fine_new + fine(i,j,k,n)
               enddo
               enddo
               enddo

               if (abs(sum_fine_new - sum_fine_old) .gt. 1.e-8) then
                  print *,' '
                  print *,'PROTECT_INTERP: BLEW CONSERVATION with ICASE = ',icase
                  print *,'AT COARSE CELL ',ic,jc,kc,' AND COMPONENT ',n
                  print *,'NEW SUM / OLD SUM ',sum_fine_new, sum_fine_old
                  print *,'CRSETOT ',crseTot
                  print *,'SUMP SUMN ',sumP,sumN
                  do k = klo,khi
                  do j = jlo,jhi
                  do i = ilo,ihi
                     print *,'FINE OLD NEW ',i,j,k,orig_fine(i-ilo,j-jlo,k-klo),
     $                                       fine(i,j,k,n), fine_state(i,j,k,n)
                  enddo
                  enddo
                  enddo
               endif

c              do k = klo,khi
c              do j = jlo,jhi
c              do i = ilo,ihi
c                 if ((fine_state(i,j,k,n) + fine(i,j,k,n)) .lt. 0.d0) then
c                    print *,'STILL NEGATIVE AT ',i,j,k,n
c                    print *,'AT COARSE CELL ',ic,jc,kc
c                    print *,'FINE STATE ',fine_state(i,j,k,n)
c                    print *,'FINE CORRECTION ',fine(i,j,k,n)
c                    print *,'CRSETOT ',crseTot
c                    print *,'SUMN / SUMP ',sumN, sumP
c                    print *,' '
c                 endif
c              enddo
c              enddo
c              enddo

c           End (if redo .eq. 1)
            endif

         enddo

c     Set sync for density (n=1) to sum of spec sync (2:nvar-1)
         do k = klo,khi
         do j = jlo,jhi
         do i = ilo,ihi
            fine(i,j,k,1) = 0.d0
            do n = 2,nvar-1
               fine(i,j,k,1) = fine(i,j,k,1) + fine(i,j,k,n)
            enddo
         enddo
         enddo
         enddo

c     End of coarse index loops
      enddo
      enddo
      enddo
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: DERIVE_2D.F,v 1.16 2002/11/14 23:04:56 lijewski Exp $ 
c
#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H" 
#include "CONSTANTS.H" 
#include "BC_TYPES.H" 
#include "DERIVE_F.H" 
#include "PROB_NS_F.H"
#include "ArrayLim.H"

#define SDIM 2

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
#define SMALL 1.0e-10
#else
#define SMALL 1.0d-10
#endif

c     -----------------------------------------------------------
c     This file contains functions which compute derived quantities.  
c     All of the argument lists have the same template, shown below
c     
c     INPUTS/OUTPUTS:
c     
c     e         <= the quantity derived
c     DIMS(e)   => index extent of e array
c     nv        => number of components in e array (should be 1)
c     dat       => data neded to derive e
c     DIMS(dat) => index limits of dat array
c     ncomp     => number of components of dat array (3)
c     lo,hi     => subrange of e array where result is requested
c     domlo,hi  => index extent of problem domain (cell centered)
c     delta     => cell spacing
c     xlo       => physical location of lower left hand
c 	           corner of e array
c     time      => problem evolution time
c     bc        => array of bndry types for component values
c                  valid only if component touches bndry
c     -----------------------------------------------------------

      subroutine FORT_DERKENG (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                         bc,level,grid_no)
c
c     This routine will derive kinetic energy from density
c     and the velocity field.
c
      integer    lo(2), hi(2)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j
      REAL_T     rho, u, v

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    rho = dat(i,j,1)
	    u   = dat(i,j,2)
	    v   = dat(i,j,3)
	    e(i,j,1) = half*rho*(u**2 + v**2)
	 end do
      end do

      end

      subroutine FORT_DERLOGS (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                         bc,level,grid_no)
c
c     This routine will derive log of given scalar quantity
c
      integer    lo(2), hi(2)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j
      REAL_T     rho

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    rho = max(dat(i,j,1),SMALL)
	    e(i,j,1) = log10(rho)
	 end do
      end do

      end

      subroutine FORT_DERMVEL (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                         bc,level,grid_no)
c
c ::: This routine will derive the magnitude of the velocity field
c ::: from the velocity field
c

      integer    lo(2), hi(2)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j
      REAL_T     u, v

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    u   = dat(i,j,1)
	    v   = dat(i,j,2)
	    e(i,j,1) = sqrt(u**2 + v**2)
	 end do
      end do

      end

      subroutine FORT_DERDVRHO (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                         bc,level,grid_no)
c
c ::: This routine will derive C/RHO
c
      integer    lo(2), hi(2)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    e(i,j,1) = dat(i,j,2)/dat(i,j,1)
	 end do
      end do

      end

      subroutine FORT_DERMPRHO (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                         bc,level,grid_no)
c
c ::: This routine will derive RHO*C
c
      integer    lo(2), hi(2)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    e(i,j,1) = dat(i,j,2)*dat(i,j,1)
	 end do
      end do

      end

      subroutine FORT_DERLGRHODUST (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                              lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                              bc,level,grid_no)
c
c ::: This routine will derive log(RHO*C)
c
      integer    lo(2), hi(2)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j
      REAL_T     dust

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    dust = max(SMALL,dat(i,j,2)*dat(i,j,1))
	    e(i,j,1) = log10(dust)
	 end do
      end do

      end

      subroutine FORT_DERMGVORT (vort,DIMS(vort),nv,dat,DIMS(dat),ncomp,
     &                           lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                           bc,level,grid_no)
c
c ::: This routine will derive magnitude of vorticity from
c ::: the velocity field
c
      integer    lo(2), hi(2)
      integer    DIMDEC(vort)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     vort(DIMV(vort),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer   i,j
      REAL_T    vx, uy, dx, dy
      logical   fixlft, fixrgt, fixbot, fixtop
      REAL_T    vxcen, vxlft, vxrgt, uycen, uybot, uytop, vorfun
c
c     ::::: some useful macro definitions
c
#     define U(i,j) dat(i,j,1)
#     define V(i,j) dat(i,j,2)
#     define VLOX bc(1,1,2)
#     define VHIX bc(1,2,2)
#     define ULOY bc(2,1,1)
#     define UHIY bc(2,2,1)
c
c     ::::: statement functions that implement stencil
c
      vxcen(i,j) = half*(V(i+1,j)-V(i-1,j))/dx
      vxlft(i,j) = (V(i+1,j)+three*V(i,j)-four*V(i-1,j))/(three*dx)
      vxrgt(i,j) = (four*V(i+1,j)-three*V(i,j)-V(i-1,j))/(three*dx)
      uycen(i,j) = half*(U(i,j+1)-U(i,j-1))/dy
      uybot(i,j) = (U(i,j+1)+three*U(i,j)-four*U(i,j-1))/(three*dy)
      uytop(i,j) = (four*U(i,j+1)-three*U(i,j)-U(i,j-1))/(three*dy)
      vorfun(vx,uy) = vx - uy

      dx = delta(1)
      dy = delta(2)

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
	    vx  = vxcen(i,j)
	    uy  = uycen(i,j)
	    vort(i,j,1) = vorfun(vx,uy)
	 end do
      end do

      fixlft = ( (lo(1) .eq. domlo(1)) .and. 
     &           (VLOX .eq. EXT_DIR .or. VLOX .eq. HOEXTRAP) )
      fixrgt = ( (hi(1) .eq. domhi(1)) .and. 
     &           (VHIX .eq. EXT_DIR .or. VHIX .eq. HOEXTRAP) )
      fixbot = ( (lo(2) .eq. domlo(2)) .and. 
     &           (ULOY .eq. EXT_DIR .or. ULOY .eq. HOEXTRAP) )
      fixtop = ( (hi(2) .eq. domhi(2)) .and. 
     &           (UHIY .eq. EXT_DIR .or. UHIY .eq. HOEXTRAP) )
c
c     ::::: handle special bndry conditions at the left edge
c
      if (fixlft) then
         i = lo(1)
         do j = lo(2), hi(2)
	    vx  = vxlft(i,j)
	    uy  = uycen(i,j)
    	    vort(i,j,1) = vorfun(vx,uy)
	 end do
      end if
c
c     ::::: handle special bndry conditions on the right
c
      if (fixrgt) then
         i = hi(1)
         do j = lo(2), hi(2)
	    vx  = vxrgt(i,j)
	    uy  = uycen(i,j)
    	    vort(i,j,1) = vorfun(vx,uy)
	 end do
      end if
c
c     ::::: handle special bndry conditions on bottom
c
      if (fixbot) then
         j = lo(2)
         do i = lo(1), hi(1)
	    vx  = vxcen(i,j)
	    uy  = uybot(i,j)
    	    vort(i,j,1) = vorfun(vx,uy)
	 end do
      end if
c
c     ::::: handle special bndry conditions on top
c
      if (fixtop) then
         j = hi(2)
         do i = lo(1), hi(1)
	    vx  = vxcen(i,j)
	    uy  = uytop(i,j)
    	    vort(i,j,1) = vorfun(vx,uy)
	 end do
      end if
c
c     ::::: check corners
c
      if (fixlft .and. fixbot) then
         i = lo(1)
	 j = lo(2)
         vx = vxlft(i,j)
	 uy = uybot(i,j)
	 vort(i,j,1) = vorfun(vx,uy)
      end if
      if (fixlft .and. fixtop) then
         i = lo(1)
	 j = hi(2)
         vx = vxlft(i,j)
         uy = uytop(i,j)
	 vort(i,j,1) = vorfun(vx,uy)
      end if
      if (fixrgt .and. fixtop) then
         i = hi(1)
	 j = hi(2)
	 vx = vxrgt(i,j)
         uy = uytop(i,j)
	 vort(i,j,1) = vorfun(vx,uy)
      end if
      if (fixrgt .and. fixbot) then
         i = hi(1)
	 j = lo(2)
	 vx = vxrgt(i,j)
	 uy = uybot(i,j)
	 vort(i,j,1) = vorfun(vx,uy)
      end if

#     undef U
#     undef V      
#     undef VLOX
#     undef VHIX
#     undef ULOY
#     undef UHIY

      end

      subroutine FORT_DERMGVORT2 (vort,DIMS(vort),nv,dat,DIMS(dat),ncomp,
     &                            lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                            bc,level,grid_no)
c
c ::: This routine will derive magnitude of vorticity from
c ::: the velocity field
c
      integer    lo(2), hi(2)
      integer    DIMDEC(vort)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     vort(DIMV(vort),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer   i,j
      integer   nxlo, nxhi, nylo, nyhi
      REAL_T    uy, vx, dx, dy
      REAL_T    uycen, uylo, uyhi
      REAL_T    vxcen, vxlo, vxhi
      REAL_T    vorfun
c
c     ::::: some useful macro definitions
c
#     define U(i,j) dat(i,j,1)
#     define V(i,j) dat(i,j,2)

#     define ULOY bc(2,1,1)
#     define UHIY bc(2,2,1)

#     define VLOX bc(1,1,2)
#     define VHIX bc(1,2,2)
c
c     ::::: statement functions that implement stencil
c
      uycen(i,j) = half*(U(i,j+1)-U(i,j-1))/dy
      uylo(i,j) = (eight*U(i,j)-six*U(i,j+1)+U(i,j+2))/(three*dy)
      uyhi(i,j) = (eight*U(i,j)-six*U(i,j-1)+U(i,j-2))/(three*dy)

      vxcen(i,j) = half*(V(i+1,j)-V(i-1,j))/dx
      vxlo(i,j) = (eight*V(i,j)-six*V(i+1,j)+V(i+2,j))/(three*dx)
      vxhi(i,j) = (eight*V(i,j)-six*V(i-1,j)+V(i-2,j))/(three*dx)

      vorfun(vx,uy) = vx - uy

      dx = delta(1)
      dy = delta(2)
c
c     :: at physical bndries where an edge value is prescribed,
c     :: set the value in the outside cell so that a central
c     :: difference formula is equivalent to the higher order
c     :: one sided formula
c
      if (lo(1) .eq. domlo(1)) then
         i = lo(1)
         if (VLOX.eq.EXT_DIR .or. VLOX.eq.HOEXTRAP) then
	   do j = lo(2), hi(2)
	      V(i-1,j) = vxlo(i,j)
	   end do
	 end if
      end if
      if (hi(1) .eq. domhi(1)) then
         i = hi(1)
         if (VHIX.eq.EXT_DIR .or. VHIX.eq.HOEXTRAP) then
	   do j = lo(2), hi(2)
	      V(i+1,j) = vxhi(i,j)
	   end do
	 end if
      end if
      if (lo(2) .eq. domlo(2)) then
         j = lo(2)
	 if (ULOY.eq.EXT_DIR .or. ULOY.eq.HOEXTRAP) then
	   do i = lo(1), hi(1)
	      U(i,j-1) = uylo(i,j)
	   end do
	 end if
      end if
      if (hi(2) .eq. domhi(2)) then
         j = hi(2)
	 if (UHIY.eq.EXT_DIR .or. UHIY.eq.HOEXTRAP) then
	   do i = lo(1), hi(1)
	      U(i,j+1) = uyhi(i,j)
	   end do
	 end if
      end if

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            uy = uycen(i,j)
            vx = vxcen(i,j)
            vort(i,j,1) = vorfun(vx,uy)
         end do
      end do

#     undef U
#     undef V      
#     undef ULOY
#     undef UHIY
#     undef VLOX
#     undef VHIX

      end

      subroutine FORT_DERMGDIVU (divu,DIMS(divu),nv,dat,DIMS(dat),ncomp,
     &                           lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                           bc,level,grid_no)
c
c ::: This routine will derive magnitude of the divergence of velocity
c
      integer    lo(2), hi(2)
      integer    DIMDEC(divu)
      integer    DIMDEC(dat)
      integer    domlo(2), domhi(2)
      integer    nv, ncomp
      integer    bc(2,2,ncomp)
      REAL_T     delta(2), xlo(2), time, dt
      REAL_T     divu(DIMV(divu),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer   i,j
      integer   nxlo, nxhi, nylo, nyhi
      REAL_T    ux, vy, dx, dy
      REAL_T    uxcen, uxlo, uxhi
      REAL_T    vycen, vylo, vyhi
c
c     ::::: some useful macro definitions
c
#     define U(i,j) dat(i,j,1)
#     define V(i,j) dat(i,j,2)

#     define ULOX bc(1,1,1)
#     define UHIX bc(1,2,1)

#     define VLOY bc(2,1,2)
#     define VHIY bc(2,2,2)
c
c     ::::: statement functions that implement stencil
c
      uxcen(i,j) = half*(U(i+1,j)-U(i-1,j))/dx
      uxlo(i,j) = (eight*U(i,j)-six*U(i+1,j)+U(i+2,j))/(three*dx)
      uxhi(i,j) = (eight*U(i,j)-six*U(i-1,j)+U(i-2,j))/(three*dx)

      vycen(i,j) = half*(V(i,j+1)-V(i,j-1))/dy
      vylo(i,j) = (eight*V(i,j)-six*V(i,j+1)+V(i,j+2))/(three*dy)
      vyhi(i,j) = (eight*V(i,j)-six*V(i,j-1)+V(i,j-2))/(three*dy)

      call FORT_XVELFILL(dat(ARG_L1(dat),ARG_L2(dat),1),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,1))
      call FORT_YVELFILL(dat(ARG_L1(dat),ARG_L2(dat),2),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,2))

      dx = delta(1)
      dy = delta(2)
c
c     :: at physical bndries where an edge value is prescribed,
c     :: set the value in the outside cell so that a central
c     :: difference formula is equivalent to the higher order
c     :: one sided formula
c
c     boundaries handled by fill routines
c
      if (lo(1) .eq. domlo(1)) then
         i = lo(1)
         if (ULOX.eq.EXT_DIR) then
           do j = lo(2), hi(2)
              U(i-1,j) = two*U(i-1,j)-U(i,j)
           end do
         else if (ULOX.eq.HOEXTRAP) then
           do j = lo(2), hi(2)
              U(i-1,j) = uxlo(i,j)
           end do
         end if
      end if
      if (hi(1) .eq. domhi(1)) then
         i = hi(1)
         if (UHIX.eq.EXT_DIR) then
           do j = lo(2), hi(2)
              U(i+1,j) = two*U(i+1,j)-U(i,j)
           end do
         else if (UHIX.eq.HOEXTRAP) then
           do j = lo(2), hi(2)
              U(i+1,j) = uxhi(i,j)
           end do
         end if
      end if
      if (lo(2) .eq. domlo(2)) then
         j = lo(2)
         if (VLOY.eq.EXT_DIR) then
           do i = lo(1), hi(1)
              V(i,j-1) = two*V(i,j-1)-V(i,j)
           end do
         else if (VLOY.eq.HOEXTRAP) then
           do i = lo(1), hi(1)
              V(i,j-1) = vylo(i,j)
           end do
         end if
      end if
      if (hi(2) .eq. domhi(2)) then
         j = hi(2)
         if (VHIY.eq.EXT_DIR) then
           do i = lo(1), hi(1)
              V(i,j+1) = two*V(i,j+1)-V(i,j)
           end do
         else if (VHIY.eq.HOEXTRAP) then
           do i = lo(1), hi(1)
              V(i,j+1) = vyhi(i,j)
           end do
         end if
      end if

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            ux = uxcen(i,j)
            vy = vycen(i,j)
            divu(i,j,1) = ux + vy
         end do
      end do
c
c we overwrote the ghost cells above, so set them back below
c
      call FORT_XVELFILL(dat(ARG_L1(dat),ARG_L2(dat),1),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,1))
      call FORT_YVELFILL(dat(ARG_L1(dat),ARG_L2(dat),2),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,2))

#     undef U
#     undef V      
#     undef ULOX
#     undef UHIX
#     undef VLOY
#     undef VHIY

      end

      subroutine FORT_GRADP_DIR (
     &     p,DIMS(p),
     &     gp,DIMS(gp),
     &     lo,hi,dir,dx)
c
c     compute a node centered pressure gradient in direction (dir)
c
      integer    DIMDEC(p)
      integer    DIMDEC(gp)
      integer    lo(SDIM),  hi(SDIM)
      integer    dir
      REAL_T     dx
      REAL_T     p(DIMV(p))
      REAL_T     gp(DIMV(gp))
      integer    i,j
      REAL_T     d

#if (BL_PRVERSION == 9)
      d = half
#else
      d = half/dx
#endif

      if (dir .eq. 0) then
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               gp(i,j) = d*(p(i+1,j)-p(i,j)+p(i+1,j+1)-p(i,j+1))
            end do
         end do
      else if (dir .eq. 1) then
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               gp(i,j) = d*(p(i,j+1)-p(i,j)+p(i+1,j+1)-p(i+1,j))
            end do
         end do
      else
         call bl_abort("FORT_GRADP_DIR: invalid dir")
      end if

      end

      subroutine FORT_DERAVGPRES (avgpres,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                            lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                            bc,level,grid_no)
c
c     This routine computes cell-centered pressure as average of the four
c       surrounding nodal values.
c
      integer DIMDEC(gp)
      integer DIMDEC(dat)
      REAL_T  avgpres(DIMV(gp))
      REAL_T  dat(DIMV(dat))
      integer nv, ncomp
      integer lo(2), hi(2)
      integer domlo(2), domhi(2)
      REAL_T  delta(2)
      REAL_T  xlo(2)
      REAL_T  time, dt
      integer bc(2,2,ncomp)
      integer level
      integer grid_no

      integer i,j

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            avgpres(i,j) = fourth*( dat(i+1,j  )+dat(i,j  ) +
     $                              dat(i+1,j+1)+dat(i,j+1) )
         end do
      end do

      end

c=========================================================


      subroutine FORT_DERGRDPX (grdpx,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                          bc,level,grid_no)
c
c     This routine computes pressure gradient in X direction
c
      integer lo(2), hi(2)
      integer DIMDEC(gp)
      integer DIMDEC(dat)
      integer domlo(2), domhi(2)
      integer nv, ncomp
      integer bc(2,2,ncomp)
      REAL_T  delta(2), xlo(2), time, dt
      REAL_T  grdpx(DIMV(gp),nv)
      REAL_T  dat(DIMV(dat),ncomp)
      integer level, grid_no
c
      call FORT_GRADP_DIR (
     &     dat,DIMS(dat),grdpx,DIMS(gp),
     &     lo,hi,0,delta(1))

      end

      subroutine FORT_DERGRDPY (grdpy,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     $                          bc,level,grid_no)
c
c     This routine computes pressure gradient in Y direction
c
      integer lo(2), hi(2)
      integer DIMDEC(gp)
      integer DIMDEC(dat)
      integer domlo(2), domhi(2)
      integer nv, ncomp
      integer bc(2,2,ncomp)
      REAL_T  delta(2), xlo(2), time, dt
      REAL_T  grdpy(DIMV(gp),nv)
      REAL_T  dat(DIMV(dat),ncomp)
      integer level, grid_no
c
      call FORT_GRADP_DIR (
     &     dat,DIMS(dat),grdpy,DIMS(gp),
     &     lo,hi,1,delta(2))

      end

c=========================================================

      subroutine FORT_DERGRDP (grdp,DIMS(gp),nv,p,DIMS(p),ncomp,
     &                         lo,hi,domlo,domhi,dx,xlo,time,dt,
     $                         bc,level,grid_no)
c
c     This routine computes the magnitude of pressure gradient 
c
      integer lo(2), hi(2)
      integer DIMDEC(gp)
      integer DIMDEC(p)
      integer domlo(2), domhi(2)
      integer nv, ncomp
      integer bc(2,2,ncomp)
      REAL_T  dx(2), xlo(2), time, dt
      REAL_T  grdp(DIMV(gp),nv)
      REAL_T  p(DIMV(p),ncomp)
      integer level, grid_no

      REAL_T     gpx, gpy
      integer    i,j
c
      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            gpx = half * (p(i+1,j,1)-p(i,j,1)+p(i+1,j+1,1)-p(i,j+1,1)) / dx(1)
            gpy = half * (p(i,j+1,1)-p(i,j,1)+p(i+1,j+1,1)-p(i+1,j,1)) / dx(2)
            grdp(i,j,1) = sqrt(gpx**2 + gpy**2)      
         end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROJOUTFLOWBC_F.H"
#include "ArrayLim.H"

#define SDIM 2

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
#define SMALL 1.0e-10
#else
#define SMALL 1.0d-10
#endif

c *************************************************************************
c ** EXTRAP_PROJ **
c *************************************************************************

      subroutine FORT_EXTRAP_PROJ(DIMS(u),u,DIMS(divu),divu,DIMS(rho),rho,
     &     r_len,redge,DIMS(uExt),uExt,DIMS(divuExt),divuExt,
     &     DIMS(rhoExt),rhoExt,lo,hi,face,zeroIt,hx)
      implicit none

c subtract divu_ave twice due to precision problems

      integer DIMDEC(u)
      integer DIMDEC(divu)
      integer DIMDEC(rho)
      integer DIMDEC(uExt)
      integer DIMDEC(divuExt)
      integer DIMDEC(rhoExt)
      integer r_len
      integer lo(SDIM),hi(SDIM)
      integer face
      REAL_T      u(DIMV(u),SDIM)
      REAL_T   divu(DIMV(divu))
      REAL_T    rho(DIMV(rho))
      REAL_T      uExt(DIMV(uExt),SDIM-1)
      REAL_T   divuExt(DIMV(divuExt))
      REAL_T   r hoExt(DIMV(rhoExt))
      REAL_T   redge(0:r_len-1)
      REAL_T   hx
      integer  zeroIt

c local variables
      integer ics,ice,jcs,jce
      integer ife,jfe
      integer if,jf
      REAL_T divu_ave1,divu_ave2
      REAL_T max_divu, min_divu
      REAL_T max_pert, small_pert
      parameter ( small_pert = SMALL)
      integer i,j

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      ics = ARG_L1(u)
      ice = ARG_H1(u)
      jcs = ARG_L2(u)
      jce = ARG_H2(u)

      ife = hi(1)
      jfe = hi(2)

      zeroIt = 0

      if (face .eq. XLO) then
         if=ife
         max_divu = half*(three*divu(ice-1,jcs) - divu(ice,jcs))
         min_divu = max_divu
         do j = jcs, jce
            uExt(j,if,1)    = half*(three*u(ice-1,j,2)    - u(ice,j,2))
         end do
         do j = jcs+1, jce-1
            divuExt(j,if) = half*(three*divu(ice-1,j) - divu(ice,j))
            rhoExt(j,if)  = half*(three*rho(ice-1,j)    - rho(ice,j))
            max_divu = max(max_divu,divuExt(j,if))
            min_divu = min(min_divu,divuExt(j,if))
         end do
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(jcs,if))
         do j = jcs+1, jce-1
            max_pert = MAX(max_pert,ABS(divuExt(j,if)))
         end do
      else if (face .eq. YLO) then
         jf = jfe
         max_divu = half*(three*divu(ics,jce-1) - divu(ics,jce))
         min_divu = max_divu
         do i = ics, ice
            uExt(i,jf,1)    = half*(three*u(i,jce-1,1)    - u(i,jce,1))
         end do
         do i = ics+1, ice-1
            divuExt(i,jf) = half*(three*divu(i,jce-1) - divu(i,jce))
            rhoExt(i,jf)  = half*(three*rho(i,jce-1)    - rho(i,jce))
            max_divu = max(max_divu,divuExt(i,jf))
            min_divu = min(min_divu,divuExt(i,jf))
         end do
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jf))
         do i = ics+1, ice-1
            max_pert = MAX(max_pert,ABS(divuExt(i,jf)))
         end do
      else if (face .eq. XHI) then
         if = ife
         max_divu = half*(three*divu(ics+1,jcs) - divu(ics,jcs))
         min_divu = max_divu
         do j = jcs, jce
            uExt(j,if,1)    = half*(three*u(ics+1,j,2)    - u(ics,j,2))
         end do
         do j = jcs+1, jce-1

            divuExt(j,if) = half*(three*divu(ics+1,j) - divu(ics,j))
c    $                      -(u(ics+1,j,1) - u(ics,j,1)) / hx

            rhoExt(j,if)  = half*(three*rho(ics+1,j)    - rho(ics,j))
            max_divu = max(max_divu,divuExt(j,if))
            min_divu = min(min_divu,divuExt(j,if))
         end do
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(jcs,if))
         do j = jcs+1, jce-1
            max_pert = MAX(max_pert,ABS(divuExt(j,if)))
         end do
      else if (face .eq. YHI) then
         jf = jfe
         max_divu = half*(three*divu(ics,jcs+1) - divu(ics,jcs))
         min_divu = max_divu
         do i = ics, ice
            uExt(i,jf,1)    = half*(three*u(i,jcs+1,1)    - u(i,jcs,1))
         end do
         do i = ics+1, ice-1
            divuExt(i,jf) = half*(three*divu(i,jcs+1) - divu(i,jcs))
            rhoExt(i,jf)  = half*(three*rho(i,jcs+1)    - rho(i,jcs))
            max_divu = max(max_divu,divuExt(i,jf))
            min_divu = min(min_divu,divuExt(i,jf))
         end do
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jf))
         do i = ics+1, ice-1
            max_pert = MAX(max_pert,ABS(divuExt(i,jf)))
         end do
      endif

c check to see if we should zero phi
      max_pert = max_pert/(ABS(divu_ave1+divu_ave2)+small_pert)
      if ((max_divu.eq.zero.and.min_divu.eq.zero)
     &     .or.(max_pert.le.small_pert)) then
         zeroIt = 1
      end if
#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

c *************************************************************************
c ** HGRELAX **
c *************************************************************************

#define DGX (beta(i-1)*phi(i-1) - (beta(i)+beta(i-1))*phi(i) \
            +beta(i)*phi(i+1))*(hxsqinv)

      subroutine FORT_HGRELAX(DIMS(rhs),rhs,DIMS(beta),beta,DIMS(phi),phi,
     &                        DIMS(dgphi),dgphi,lo,hi,h,isPeriodic,niter)
      implicit none
      integer DIMDEC(beta)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      integer DIMDEC(dgphi)
      REAL_T beta(DIM1(beta))
      REAL_T rhs(DIM1(rhs))
      REAL_T phi(DIM1(phi))
      REAL_T dgphi(DIM1(dgphi))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)
      integer niter

      integer ins, ine
      integer i,iter
      REAL_T lam
      logical setSingularPoint
      REAL_T hxsqinv
      integer redblack

      hxsqinv = 1.0D0/(h(1)*h(1))

      ins = lo(1)
      ine = hi(1)+1
      setSingularPoint = .false.

      do iter = 1,niter
         call setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
         do redblack = 0, 1
            do i=ins+redblack,ine,2
               dgphi(i) = DGX
               lam = hxsqinv*(beta(i)+beta(i-1))
c double dgphi at edges
               if ((i .eq. lo(1) .or. i .eq. hi(1)+1)
     &              .and. isPeriodic(1) .ne. 1) then
                  dgphi(i) = dgphi(i) * two
                  lam = lam* two
               endif
               lam = -one/lam
               phi(i) = phi(i) + lam*(rhs(i)-dgphi(i))
            enddo
         end do
      end do

      call setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)

      end

c *************************************************************************
c ** HGSUBTRACTAVGPHI **
c *************************************************************************

      subroutine FORT_HGSUBTRACTAVGPHI(DIMS(phi),phi,r_lo,r_hi,r,lo,hi,
     &                                 isPeriodic)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM1(phi))
      integer r_lo,r_hi
      REAL_T r(r_lo:r_hi)
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)

      REAL_T phitot,vtot
      REAL_T hdr,rnode
      integer ics,ins,ine
      integer i
      logical setSingularPoint

      ics = lo(1)
      ins = lo(1)
      ine = hi(1)+1
      hdr = half *(r(ics+1)-r(ics))
      setSingularPoint = .false.

      phitot = zero
      vtot = zero

      do i = ins,ine-ins-2
         rnode = r(i+ins-ics) - hdr
         phitot = phitot + phi(i) * rnode
         vtot   = vtot + rnode
      enddo
      do i = ine-ins-1,ine
         rnode = r(i+ins-ics-1) + hdr
         phitot = phitot + phi(i) * rnode
         vtot   = vtot + rnode
      enddo
      phitot = phitot/vtot
      do i = ins,ine
         phi(i) = phi(i) - phitot
      enddo

      call setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)

      end


c *************************************************************************
c ** HGRESID **
c *************************************************************************

      subroutine FORT_HGRESID(DIMS(rhs),rhs,DIMS(beta),beta,DIMS(phi),phi,
     &                   DIMS(resid),resid,DIMS(dgphi),dgphi,
     &                   lo,hi,h,isPeriodic,maxnorm)

      integer DIMDEC(beta)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      integer DIMDEC(resid)
      integer DIMDEC(dgphi)
      REAL_T beta(DIM1(beta))
      REAL_T rhs(DIM1(rhs))
      REAL_T phi(DIM1(phi))
      REAL_T resid(DIM1(resid))
      REAL_T dgphi(DIM1(dgphi))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)
      REAL_T hxsqinv,hysqinv

      integer i,j
      REAL_T maxnorm
      logical setSingularPoint
 
      hxsqinv = one/(h(1)*h(1))
      setSingularPoint = .false.
      maxnorm = zero

      call makeprojdgphi(phi,DIMS(phi),dgphi,DIMS(dgphi),beta,DIMS(beta),
     &                   lo,hi,h,isPeriodic,setSingularPoint)
      do i=lo(1),hi(1)+1
         resid(i) = rhs(i)-dgphi(i)
         maxnorm = max(maxnorm,ABS(resid(i)))         
      enddo
      end


c *************************************************************************
c ** SETPROJBC **
c *************************************************************************

      subroutine setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM1(phi))
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)
      logical setSingularPoint

      integer ins,ine
      
      ins = lo(1)
      ine = hi(1)+1

      if (isPeriodic(1) .NE. 1 .AND. setSingularPoint) then
         phi(ine) = zero
      endif

      if (isPeriodic(1).eq.1) then
         phi(ins-1) = phi(ine-1)
         phi(ine)   = phi(ins)
         phi(ine+1) = phi(ins+1)
      else
         phi(ins-1) = phi(ins+1)
         phi(ine+1) = phi(ine-1)
      endif

      end

c *************************************************************************
c ** HG_SHIFT_PHI **
c *************************************************************************

      subroutine FORT_HG_SHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      if (face .eq. XLO .or. face .eq. XHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(j,i)
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(i,j)
            enddo
         enddo
      endif
#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

c *************************************************************************
c ** HG_RESHIFT_PHI **
c *************************************************************************

      subroutine FORT_HG_RESHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      if (face .eq. XLO .or. face .eq. XHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(j,i)
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(i,j)
            enddo
         enddo
      endif
#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

c *************************************************************************
c ** HG_SOLVEHG **
c *************************************************************************

      subroutine FORT_SOLVEHG(p,DIMS(p),dest0,DIMS(dest0),
     &     source,DIMS(source),sigma,DIMS(sigma),
     &     cen,DIMS(cen),r,DIMS(r),w,DIMS(w),
     &     z,DIMS(z),x,DIMS(x),
     $     lo,hi,h,isPeriodic,maxiter,tol,abs_tol,max_jump,norm)
      
      implicit none

      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(p)
      integer DIMDEC(dest0)
      integer DIMDEC(source)
      integer DIMDEC(sigma)
      integer DIMDEC(r)
      integer DIMDEC(w)
      integer DIMDEC(z)
      integer DIMDEC(x)
      integer DIMDEC(cen)
      REAL_T   p(DIM1(p))
      REAL_T  dest0(DIM1(dest0))
      REAL_T source(DIM1(source))
      REAL_T  sigma(DIM1(sigma))
      REAL_T      r(DIM1(r))
      REAL_T      w(DIM1(w))
      REAL_T      z(DIM1(z))
      REAL_T      x(DIM1(x))
      REAL_T      cen(DIM1(cen))
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      integer maxiter
      REAL_T norm
      REAL_T tol
      REAL_T abs_tol,max_jump

c     Local variables
      REAL_T factor
      REAL_T  alpha,beta, rho, rho_old
      logical testx
      integer i,iter
      integer istart,iend
      REAL_T norm0,goal
      logical setSingularPoint

      istart = lo(1)
      iend = hi(1)+1
      
      setSingularPoint = .false.

      do i = lo(1)-1,hi(1)+2
         dest0(i) = p(i)
         p(i) = zero
      enddo
      
      do i=ARG_L1(w),ARG_H1(w)
         w(i) = zero
      enddo
      
      call setprojbc(DIMS(dest0),dest0,lo,hi,isPeriodic,setSingularPoint)
      call makeprojdgphi(dest0,DIMS(dest0),w,DIMS(w),sigma,DIMS(sigma),
     &     lo,hi,h,isPeriodic,setSingularPoint)
      
      do i = istart, iend 
         r(i) = source(i) - w(i)
      enddo
      
c note that all of this factor stuff is due to the problem being doubled
c at edges -- both the rhs and the operator.
      rho = zero
      norm0 = zero
      do i = istart, iend
         factor = one
         testx  = (i .eq. lo(1) .or. i .eq. hi(1)+1)
         factor = cvmgt(factor*half,factor,testx)
         z(i) = r(i) 
         rho    = rho + factor * z(i) * r(i) 
         norm0 = max(norm0,abs(r(i)))
      enddo
      norm = norm0
      
      goal = max(tol * norm0,abs_tol)
      
      if (norm0 .le. goal) then
         do i = istart, iend 
            p(i) = dest0(i)
         enddo
         return
      endif
      
      do i = istart, iend 
         x(i) = zero
         p(i) = z(i)
      enddo
      
      iter  = 0
      
 100  continue  
      
      do i=ARG_L1(w),ARG_H1(w)
         w(i) = zero
      enddo
      
      call setprojbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
      call makeprojdgphi(p,DIMS(p),w,DIMS(w),sigma,DIMS(sigma),
     &     lo,hi,h,isPeriodic,setSingularPoint)
      
      alpha = zero
      do i = istart, iend 
         factor = one
         testx  = (i .eq. lo(1) .or. i .eq. hi(1)+1)
         factor = cvmgt(factor*half,factor,testx)
         alpha  = alpha + factor*p(i)*w(i) 
      enddo
      
      if (alpha .ne. zero) then
         alpha = rho / alpha
      else
         print *, "divide by zero"
         goto 101
      endif

      rho_old  = rho
      rho   = zero
      norm = zero
      do i = istart, iend 
         factor = one
         testx  = (i .eq. lo(1) .or. i .eq. hi(1)+1)
         factor = cvmgt(factor*half,factor,testx)
         x(i) = x(i) + alpha * p(i)
         r(i) = r(i) - alpha * w(i)
         z(i) = r(i) 
         rho    = rho + factor * z(i) * r(i) 
         norm = max(norm,abs(r(i)))
      enddo
      
      iter = iter+1
c      write(6,*) iter,norm

      if (iter .gt. maxiter .or. norm .gt. max_jump*norm0) then
         
         goto 101

      else if (norm .lt. goal) then
         
         do i = istart, iend 
            p(i) = x(i) + dest0(i)
         enddo
         
         return

      else
         
         beta = rho / rho_old
         do i = istart, iend 
            p(i) = z(i) + beta * p(i)
         enddo
         
        goto 100
        
      endif
      
 101  print *, "cg solve in proj failed to coverge"
      do i = istart, iend 
         p(i) = dest0(i)
      enddo

      return
      end

c *************************************************************************
c ** makeprojdgphi **
c *************************************************************************

      subroutine makeprojdgphi(phi,DIMS(phi),dgphi,DIMS(dgphi),
     &                     beta,DIMS(beta),
     &                     lo,hi,h,isPeriodic,setSingularPoint)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(phi)
      integer DIMDEC(dgphi)
      integer DIMDEC(beta)
      REAL_T    phi(DIM1(phi))
      REAL_T  dgphi(DIM1(dgphi))
      REAL_T  beta(DIM1(beta))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      logical setSingularPoint

c     Local variables
      REAL_T hxsqinv
      integer is,ie
      integer i

      is = lo(1)
      ie = hi(1)

      hxsqinv = one/(h(1)*h(1))
      
      if (isPeriodic(1).eq.1 ) then
          phi(ie+2) = phi(is+1)
          phi(is-1) = phi(ie  )
      endif

      do i = is,ie+1
         dgphi(i) = DGX
      enddo
      
c  double dgphi at edges
      if (isPeriodic(1) .ne. 1) then
        dgphi(is) = dgphi(is) * two
        dgphi(ie+1) = dgphi(ie+1) * two
      endif

      if (setSingularPoint .and. isPeriodic(1) .NE. 1) then
         dgphi(hi(1)+1) = zero
      endif

      return
      end

c *************************************************************************
c ** COARSIG **
c ** Coarsening of the sig coefficients
c *************************************************************************

      subroutine FORT_COARSIG(sigma,DIMS(sigma),sigmac,DIMS(sigmac),
     &                        lo,hi,loc,hic,isPeriodic)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(sigma)
      integer DIMDEC(sigmac)
      REAL_T  sigma(DIM1(sigma))
      REAL_T sigmac(DIM1(sigmac))
      integer isPeriodic(SDIM)

c     Local variables
      integer i,i2 

      do i = loc(1),hic(1) 
         i2 = 2*(i-loc(1))+lo(1)
         sigmac(i) = half*(sigma(i2) +sigma(i2+1))
      enddo

      if (isPeriodic(1).eq.1) then
         sigmac(loc(1)-1) = sigmac(hic(1))
         sigmac(hic(1)+1) = sigmac(loc(1))
      else
         sigmac(loc(1)-1) = zero
         sigmac(hic(1)+1) = zero
      endif

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,DIMS(res),resc,DIMS(resc),
     &                        lo,hi,loc,hic,isPeriodic)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(res)
      integer DIMDEC(resc)
      REAL_T   res(DIM1(res))
      REAL_T  resc(DIM1(resc))
      integer isPeriodic(SDIM)

c     Local variables
      integer i,ii
      integer istart,iend

      istart = loc(1)
      iend = hic(1)+1
      
      if (isPeriodic(1).eq.1) then
          res(hi(1)+1) = res(lo(1)  )
          res(hi(1)+2) = res(lo(1)+1)
          res(lo(1)-1) = res(hi(1)  )
      endif

      do i = istart,iend
         ii = 2*(i-loc(1))+lo(1)
         resc(i) = half*res(ii) + fourth*(res(ii+1)+res(ii-1))
      enddo

c  the top version is what we use when we double the problem at edges
c  the bottom version (commented out) is what we would use if we did not 
c      double the problem at edges.
      if (isPeriodic(1) .NE. 1) then
        i = loc(1)
        ii = 2*(i-loc(1))+lo(1)
        
        resc(i) = half*(res(ii) + res(ii+1))
c        resc(i) = half*res(ii) + fourth*res(ii+1)
        
        i = hic(1)+1
        ii = 2*(i-loc(1))+lo(1)
        
        resc(i) = half*(res(ii) + res(ii-1))
c        resc(i) = half*res(ii) + fourth*res(ii-1)

      endif

      return
      end


c *************************************************************************
c ** INTERP **
c ** Simple bilinear interpolation
c *************************************************************************

      subroutine FORT_INTERP(phi,DIMS(phi),temp,DIMS(temp),deltac,DIMS(deltac),
     &                       sigma,DIMS(sigma),lo,hi,loc,hic,isPeriodic)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(phi)
      integer DIMDEC(deltac)
      integer DIMDEC(sigma)
      integer DIMDEC(temp)
      REAL_T     phi(DIM1(phi))
      REAL_T  deltac(DIM1(deltac))
      REAL_T  sigma(DIM1(sigma))
      REAL_T   temp(DIM1(temp))
      integer isPeriodic(SDIM)

c     Local variables
      integer ii,ic
      integer is,ie,isc,iec
      logical setSingularPoint

      is = lo(1)
      ie = hi(1)

      isc = loc(1)
      iec = hic(1)

      do ic = isc, iec+1
         ii = 2*(ic-isc)+is
         temp(ii) = deltac(ic)
      enddo
      do ic = isc, iec 
         ii = 2*(ic-isc)+is
         temp(ii+1) = half*(deltac(ic) + deltac(ic+1)) 
      enddo
      
      do ii = is,ie+1
         phi(ii) = phi(ii) + temp(ii)
      enddo

      return
      end

c *************************************************************************
c ** HGPHIBC **
c ** Solution by back substitution
c *************************************************************************

      subroutine FORT_HGPHIBC(hx,sigExt,s,x,length,per)
c
c    Compute the value of phi for hgproj to be used at an outflow face,
c    assuming that the tangential velocity on the edges of the outflow boundary
c    are either zero or periodic.  
c
      implicit none

      integer length
      integer per
      REAL_T       s(  length+1)
      REAL_T       x(  length+1)
      REAL_T       r( 0:length-1)
      REAL_T  sigExt(0:length-1)
      REAL_T hx
      
c     Local variables
      integer NstripMAX
      parameter (NstripMAX = 2000)
      integer ics, ice
      integer i, j, icL, icR, neq
      REAL_T a(NstripMAX), b(NstripMAX), c(NstripMAX)
      REAL_T alpha, beta, sVal
      logical rNormed
      REAL_T vtot, rnode, hdr
      REAL_T phitot
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3
      
      ics = 0
      ice = length-1

c     This description assumes outflow at yhi; however, code works for 
c     outflow at any face.      
c     Solve d/dx( 1/rho d/dx( phi ) ) = dU/dx - (S - S_ave) [S = divu if U is 
c     zero, S = d/dt(divu) if U = (ustar - uold)/dt] with periodic or Neumann
c     boundary conditions, using a tridiagonal solve which detects, and deals 
c     with the singular equations.  In the Neumann case, arbitrarily set the 
c     upper right corner to zero to pin the solution.  Note that the RHS of 
c     this equation satisfies the solvability constraint that 
c     Int[RHS.dV] = 0 by construction.
c     This implies that the normal component takes up the slack:
c     
c                        d/dy( 1/rho d/dy( phi ) ) = dV/dy - S_ave
c     
c     This information should be used to construct the normal gradient of the
c     normal velocity, for the advective/diffusive step, for example.

      do i = 2,length
         icR = ics + i - 1
         icL = ics + i - 2
         a(i) = sigExt(icL)
         c(i) = sigExt(icR)
         b(i) = - a(i) - c(i)
      end do

      if (per .eq. 1) then
         
         hdr = 0.0d0

c     Do left-side periodic BC (since first/last node coincide, use first 
c     node only (retain r-stuff here, just to be sure scaling is not destroyed)
         neq = length
         if ( neq .gt. NStripMax ) then
            call bl_abort('HGPHIBC: NstripMax too small')
         end if
         icL = ice
         icR = ics
         beta = sigExt(icL)
         c(1) = sigExt(icR)
         b(1) = - beta - c(1)
         
c     Do right-side periodic on penultimate node
         icL = ice - 1
         icR = ice
         a(neq) = sigExt(icL)
         alpha  = sigExt(icR)
         b(neq) = - a(neq) - alpha
         
         call cyclic(a,b,c,alpha,beta,s,x,neq)
      else

c     Solid walls, Neumann conditions

         hdr = half*(r(ics+1) - r(ics))
         neq = length + 1
         if ( neq .gt. NStripMax ) then
            call bl_abort('HGPHIBC: NstripMax too small')
         end if
         icR = ics
         c(1) = sigExt(icR)
         b(1) = - c(1)

         icL = ice
         a(neq) = sigExt(icL)
         b(neq) = - a(neq)

c     Solve the equations (we know they're singular, pass the arbitrary value, 
c     and a flag that we've already normalized the rhs, in the sense that
c                          Int[dU/dx - (S-S_ave)] == 0
         sVal = zero
         rNormed = .true.
         call tridag_sing(a,b,c,s,x,neq,sVal,rNormed)
      end if
      
#if 1
c     Try normalizing phi to average to zero
      phitot = zero
      vtot = zero
C     do i = 1, length-1
      do i = 2, length-1
c        rnode = r(ics+i-1) - hdr
c        phitot = phitot + x(i)*rnode
c        vtot = vtot + rnode

         phitot = phitot + x(i)
           vtot =   vtot + one

      end do
      do i = length,neq

c        rnode = r(ics+i-2) + hdr
c        phitot = phitot + x(i)*rnode
c        vtot = vtot + rnode

         phitot = phitot + x(i)
         vtot = vtot + one

      end do
      phitot = phitot / vtot
      do i = 1,neq
         x(i) = x(i) - phitot
      end do
#endif
      
#undef XLO
#undef YLO
#undef XHI
#undef YHI
      end

c *************************************************************************
c ** OLDHGPHIBC **
c ** Solution by back substitution
c *************************************************************************

      subroutine FORT_OLDHGPHIBC(hx,r,uExt, divuExt,rhoExt,x,flag,length,per)
c
c    Compute the value of phi for hgproj to be used at an outflow face,
c    assuming that the tangential velocity on the edges of the outflow boundary
c    are either zero or periodic.  
c
      implicit none

      integer length
      integer per
      REAL_T       x(  length+1)
      REAL_T       r( 0:length-1)
      REAL_T    uExt(0:length-1)
      REAL_T divuExt(0:length-1)
      REAL_T  rhoExt(0:length-1)
      REAL_T    flag(0:length-1)
      REAL_T hx
      
c     Local variables
      integer NstripMAX
      parameter (NstripMAX = 2000)
      integer ics, ice
      integer i, j, icL, icR, neq
      REAL_T a(NstripMAX), b(NstripMAX), c(NstripMAX), s(NstripMAX)
      REAL_T alpha, beta, sVal
      logical rNormed
      REAL_T vtot, rnode, hdr
      REAL_T phitot
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3
      
      ics = 0
      ice = length-1

c     This description assumes outflow at yhi; however, code works for 
c     outflow at any face.      
c     Solve d/dx( 1/rho d/dx( phi ) ) = dU/dx - (S - S_ave) [S = divu if U is 
c     zero, S = d/dt(divu) if U = (ustar - uold)/dt] with periodic or Neumann
c     boundary conditions, using a tridiagonal solve which detects, and deals 
c     with the singular equations.  In the Neumann case, arbitrarily set the 
c     upper right corner to zero to pin the solution.  Note that the RHS of 
c     this equation satisfies the solvability constraint that 
c     Int[RHS.dV] = 0 by construction.
c     This implies that the normal component takes up the slack:
c     
c                        d/dy( 1/rho d/dy( phi ) ) = dV/dy - S_ave
c     
c     This information should be used to construct the normal gradient of the
c     normal velocity, for the advective/diffusive step, for example.

      do i = 2,length
         icR = ics + i - 1
         icL = ics + i - 2
         a(i) = r(icL) / rhoExt(icL)
         c(i) = r(icR) / rhoExt(icR)
         b(i) = - a(i) - c(i)
         rnode = half*(r(icL)+r(icR))
         s(i) = (r(icR)*flag(icR)*uExt(icR)-r(icL)*flag(icL)*uExt(icL))*hx
     &        -  rnode*half*(divuExt(icL)+divuExt(icR))*hx*hx
      end do

      if (per .eq. 1) then
         
         hdr = 0.0D0 ! FIXME: This wasn't set before, used below

c     Do left-side periodic BC (since first/last node coincide, use first 
c     node only (retain r-stuff here, just to be sure scaling is not destroyed)
         neq = length
         if ( neq .gt. NStripMax ) then
            call bl_abort('HGPHIBC: NstripMax too small')
         end if
         icL = ice
         icR = ics
         beta = r(icL) / rhoExt(icL)
         c(1) = r(icR) / rhoExt(icR)
         b(1) = - beta - c(1)
         rnode = half*(r(icL)+r(icR))
         s(1) = (flag(icR)*r(icR)*uExt(icR)-flag(icL)*r(icL)*uExt(icL))*hx
     &        -  rnode*half*(divuExt(icL)+divuExt(icR))*hx*hx
         
c     Do right-side periodic on penultimate node
         icL = ice - 1
         icR = ice
         a(neq) = r(icL) / rhoExt(icL)
         alpha  = r(icR) / rhoExt(icR)
         b(neq) = - a(neq) - alpha
         s(neq) = (flag(icR)*r(icR)*uExt(icR)-flag(icL)*r(icL)*uExt(icL))*hx
     &          -  rnode*half*(divuExt(icL)+divuExt(icR))*hx*hx
         
c     Solve the equations
         call cyclic(a,b,c,alpha,beta,s,x,neq)
      else

c     Solid walls, Neumann conditions
         hdr = half*(r(ics+1) - r(ics))
         neq = length + 1
         if ( neq .gt. NStripMax ) then
            call bl_abort('HGPHIBC: NstripMax too small')
         end if
         icR = ics
         c(1) = r(icR) / rhoExt(icR-ics)
         b(1) = - c(1)
         rnode = r(ics) - hdr
         s(1) =  flag(icR)*r(icR)*uExt(icR)*hx
     &        -  rnode*half*divuExt(icR)*hx*hx

         icL = ice
         a(neq) = r(icL) / rhoExt(icL)
         b(neq) = - a(neq)
         rnode = r(ice) + hdr
         s(neq) = -flag(icL)*r(icL)*uExt(icL)*hx
     &        -  rnode*half*divuExt(icL)*hx*hx
         
c     Solve the equations (we know they're singular, pass the arbitrary value, 
c     and a flag that we've already normalized the rhs, in the sense that
c                          Int[dU/dx - (S-S_ave)] == 0
         sVal = zero
         rNormed = .true.
         call tridag_sing(a,b,c,s,x,neq,sVal,rNormed)
      end if
      
#if 1
c     Try normalizing phi to average to zero
      phitot = zero
      vtot = zero
C     do i = 1, length-1
      do i = 2, length-1
         rnode = r(ics+i-1) - hdr
         phitot = phitot + x(i)*rnode
         vtot = vtot + rnode
      end do
      do i = length,neq
         rnode = r(ics+i-2) + hdr
         phitot = phitot + x(i)*rnode
         vtot = vtot + rnode
      end do
      phitot = phitot / vtot
      do i = 1,neq
         x(i) = x(i) - phitot
      end do
#endif
      
#undef XLO
#undef YLO
#undef XHI
#undef YHI
      end

c *************************************************************************
c ** RHOGBC **
c *************************************************************************

      subroutine FORT_RHOGBC(rho,DIMS(rho),phi,DIMS(phi),
     &                       face,gravity,dx)
c
c    Compute the contribution of gravity to the boundary conditions
c      for phi at outflow faces only.
c
      implicit none

      integer DIMDEC(rho)
      integer DIMDEC(phi)
      integer face
      REAL_T  rho(DIMV(rho))
      REAL_T  phi(DIMV(phi))
      REAL_T  dx(2)
      REAL_T  gravity
      
c     Local variables
      integer i,j
      REAL_T rhog
      REAL_T rhoExt

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      if (face .eq. YLO .or. face .eq. YHI) 
     $   call bl_abort('SHOULDNT BE IN RHOGBC WITH FACE IN Y-DIR')

c     Ok to only use low index of phi because phi is only one
c        node wide in i-direction.
      i = ARG_L1(phi)

      if (face .eq. XLO) then

        rhog = zero
        do j = ARG_H2(phi)-1,ARG_L2(phi),-1
          rhoExt = half*(three*rho(i,j)-rho(i+1,j))
          rhog = rhog + gravity * rhoExt * dx(2)
          phi(i,j) = phi(i,j) + rhog
        end do

      else if (face .eq. XHI) then

        rhog = zero
        do j = ARG_H2(phi)-1,ARG_L2(phi),-1
          rhoExt  = half*(three*rho(i-1,j)-rho(i-2,j))
          rhog = rhog + gravity * rhoExt * dx(2)
          phi(i,j) = phi(i,j) + rhog
        end do

      endif

#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end


      SUBROUTINE tridag_sing(a,b,c,r,u,n,sVal,rNormed)
      INTEGER n,NMAX
      REAL_T a(n),b(n),c(n),r(n),u(n), sVal
      REAL_T eps
      PARAMETER (NMAX=2000)
      PARAMETER (eps=1.D-12)
      INTEGER j
      REAL_T bet,gam(NMAX)
      logical rNormed, singular
      singular = .false.
      if(n.gt.NMAX)then
         call bl_abort('TRIDAG_SING: NMAX too small in tridag')
      end if
      if((b(1).eq.zero).or.(ABS(b(n)).le.eps))then
         call bl_abort('TRIDAG_SING: rewrite equations')
      end if
      bet=b(1)
      u(1)=r(1)/bet
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
        if(ABS(bet).le.eps) then
           if (rNormed .and.  (j .eq. n)) then
              singular = .true.
           else
              call bl_abort('tridag failed')
           end if
        end if
        if (singular) then
           u(j) = sVal
        else
           u(j)=(r(j)-a(j)*u(j-1))/bet
        end if
11    continue
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    continue
      return
      END
      
      SUBROUTINE tridag(a,b,c,r,u,n)
      INTEGER n,NMAX
      REAL_T a(n),b(n),c(n),r(n),u(n)
      PARAMETER (NMAX=2000)
      INTEGER j
      REAL_T bet,gam(NMAX)
      if(n.gt.NMAX)then
         call bl_abort('TRIDAG: NMAX too small in tridag')
      end if
      if(b(1) .eq. 0.0D0) then
         call bl_abort('TRIDAG: rewrite equations')
      end if
      bet=b(1)
      u(1)=r(1)/bet
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
        if(bet .eq. 0.0D0) call bl_abort('tridag failed')
        u(j)=(r(j)-a(j)*u(j-1))/bet
11    continue
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    continue
      return
      END

      SUBROUTINE cyclic(a,b,c,alpha,beta,r,x,n)
      INTEGER n,NMAX
      REAL_T alpha,beta,a(n),b(n),c(n),r(n),x(n)
      PARAMETER (NMAX=2000)
      INTEGER i
      REAL_T fact,gamma,bb(NMAX),u(NMAX),z(NMAX),den
      if(n.le.2)then
         call bl_abort('CYCLIC: n too small in cyclic')
      end if
      if(n.gt.NMAX)then
         call bl_abort('CYCLIC: NMAX too small in cyclic')
      end if
      gamma=-b(1)
      bb(1)=b(1)-gamma
      bb(n)=b(n)-alpha*beta/gamma
      do 11 i=2,n-1
        bb(i)=b(i)
11    continue
      call tridag(a,bb,c,r,x,n)
      u(1)=gamma
      u(n)=alpha
      do 12 i=2,n-1
        u(i)=0.0D0
12    continue
      call tridag(a,bb,c,u,z,n)
      den=one+z(1)+beta*z(n)/gamma
      fact=cvmgt(zero,(x(1)+beta*x(n)/gamma)/den,den.eq.zero)
      do 13 i=1,n
        x(i)=x(i)-fact*z(i)
13    continue
      return
      END


c *************************************************************************
c ** FILL_ONED **
c *************************************************************************

      subroutine FORT_FILL_ONED(lenx,leny,length,faces,numOutFlowFaces,
     $                          cc0,cc1,cc2,cc3,r0,r1,r2,r3,cc_conn,nodal_conn,per,hx,hy)

      integer lenx,leny,length
      integer faces(4)
      integer numOutFlowFaces
      integer per
      REAL_T cc0(0:leny+1,3)
      REAL_T cc1(0:lenx+1,3)
      REAL_T cc2(0:leny+1,3)
      REAL_T cc3(0:lenx+1,3)
      REAL_T  r0(leny)
      REAL_T  r1(lenx)
      REAL_T  r2(leny)
      REAL_T  r3(lenx)
      REAL_T     cc_conn(length)
      REAL_T  nodal_conn(length+1)
      REAL_T  hx,hy

      integer xlo_outflow,ylo_outflow
      integer xhi_outflow,yhi_outflow
      integer i,ifinal,n
      REAL_T  rnode,vol,sum

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

c     Want to find the single non-outflow face.
      xlo_outflow = 0
      ylo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
      enddo

c     Possible combinations of faces to come in here:
c       cc0 cc1 cc2 cc3
c       XLO 
c           YLO 
c               XHI
c                   YHI
c       XLO YLO 
c       XLO         YHI 
c           YLO XHI 
c           YLO     YHI 
c       XLO YLO XHI
c       XLO     XHI YHI
c       XLO YLO     YHI
c           YLO XHI YHI
c       XLO YLO XHI YHI

c     We must remember here that the cc* arrays have already been
c       ordered so that the 2nd spatial dimension is one cell wide.

c     cc*(i,1) = rho
c     cc*(i,2) = divu
c     cc*(i,3) = tangential vel.
 
      vol = hx*hy

      ifinal = 0

      if (numOutFlowFaces .eq. 4 .or. 
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 0) ) then

          rnode = r0(1)
          do i = 1,leny
            cc_conn(i) = rnode/cc0(i,1)
          enddo

          do i = 2,leny
            nodal_conn(i) = rnode*(      (cc0(i,3) - cc0(i-1,3))*hx
     &                             -half*(cc0(i,2)+cc0(i-1,2))*vol )
          enddo
          i = 1
          nodal_conn(i) = rnode*(     (cc0(i,3) - cc0(i-1,3))*hx
     &                           -half*cc0(i,2)*vol )
          if (per .eq. 1) then
            nodal_conn(i) = nodal_conn(i) - half*rnode*cc0(leny,2)*vol 
          endif

          i = leny+1
          nodal_conn(i) = rnode*(     (cc0(i,3) - cc0(i-1,3))*hx
     &                           -half*cc0(i-1,2)*vol )
          ifinal = leny

      endif

      if (yhi_outflow .eq. 1 .and. 
     $    .not. (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then

          do i = 1,lenx
            cc_conn(ifinal+i) = r3(i)/cc3(i,1)
          enddo

          do i = 2,lenx
            rnode = half*(r3(i)+r3(i-1))
            nodal_conn(ifinal+i) = rnode*(      (cc3(i,3) - cc3(i-1,3))*hy
     &                                    -half*(cc3(i,2)+cc3(i-1,2))*vol )
          enddo
          i = 1
          rnode = 1.5d0*r3(1) - 0.5d0*r3(2)
c         Note: we get away with using r3(i) in place of r3(i-1), which isnt
c               defined, because if this is r-z, then the vel. at i-1 is zero,
c               and if not, then r is identically 1.
          nodal_conn(ifinal+i) = nodal_conn(ifinal+i) + 
     &                           r3(i)*(cc3(i,3) - cc3(i-1,3))*hy
     &                           -half*rnode*cc3(i,2)*vol

          if (per .eq. 1) then
            nodal_conn(ifinal+i) = nodal_conn(ifinal+i) - half*rnode*cc3(lenx,2)*vol 
          endif

          i = lenx+1
          rnode = 1.5d0*r3(lenx) - 0.5d0*r3(lenx-1)
c         Note: same reasoning as above for using r3(i-1)
          nodal_conn(ifinal+i) = 
     &                           r3(i-1)*(cc3(i,3) - cc3(i-1,3))*hy
     &                           -half*rnode*cc3(i-1,2)*vol

          ifinal = ifinal + lenx

      endif

      if (xhi_outflow .eq. 1) then
          rnode = r2(1)
          do i = 1,leny
            cc_conn(ifinal+i) = rnode/cc2(leny+1-i,1)
          enddo

          do i = 2,leny
            nodal_conn(ifinal+i) = rnode*(      (cc2(leny+2-i,3)-cc2(leny+1-i,3))*hx
     &                                    -half*(cc2(leny+2-i,2)+cc2(leny+1-i,2))*vol )
          enddo
          i = 1
          nodal_conn(ifinal+i) = nodal_conn(ifinal+i) +
     &                        rnode*(     (cc2(leny+2-i,3) - cc2(leny+1-i,3))*hx
     &                               -half*cc2(leny+1-i,2)*vol )
          if (per .eq. 1) then
            nodal_conn(ifinal+i) = nodal_conn(ifinal+i) - half*rnode*cc2(1,2)*vol 
          endif

          i = leny+1
          nodal_conn(ifinal+i) = 
     &                        rnode*(     (cc2(leny+2-i,3) - cc2(leny+1-i,3))*hx
     &                               -half*cc2(leny+2-i,2)*vol )

          do i = 1,leny+1
            nodal_conn(ifinal+i) = -nodal_conn(ifinal+i)
          enddo

          ifinal = ifinal + leny
      endif


      if (ylo_outflow .eq. 1) then

          do i = 1,lenx
            cc_conn(ifinal+i) = r1(lenx+1-i)/cc1(lenx+1-i,1)
          enddo

          do i = 2,lenx
            rnode = half*(r1(lenx+2-i)+r1(lenx+1-i))
            nodal_conn(ifinal+i) = rnode*(      (cc1(lenx+2-i,3)-cc1(lenx+1-i,3))*hy
     &                                    -half*(cc1(lenx+2-i,2)+cc1(lenx+1-i,2))*vol )
          enddo
          i = 1
          rnode = 1.5d0*r1(lenx) - 0.5d0*r1(lenx-1)
c         Note: we get away with using r1(lenx)
c               because if this is r-z, then the outside vel.
c               and if not, then r is identically 1.
          nodal_conn(ifinal+i) = nodal_conn(ifinal+i) + 
     &                           r1(lenx)*(cc1(lenx+2-i,3) - cc1(lenx+1-i,3))*hy
     &                           -half*rnode*cc1(lenx+1-i,2)*vol
          if (per .eq. 1) then
            nodal_conn(ifinal+i) = nodal_conn(ifinal+i) - half*rnode*cc1(1,2)*vol 
          endif

          i = lenx+1
          rnode = 1.5d0*r1(2) - 0.5d0*r1(1)
c         Note: same reasoning as above for using r1(1)
          nodal_conn(ifinal+i) = 
     &                           r1(1)*(cc1(lenx+2-i,3) - cc1(lenx+1-i,3))*hy
     &                           -half*rnode*cc1(lenx+2-i,2)*vol

          do i = 1,lenx+1
            nodal_conn(ifinal+i) = -nodal_conn(ifinal+i)
          enddo
          ifinal = ifinal + lenx
      endif

      if (numOutFlowFaces .lt. 4 .and.
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 1) ) then

          rnode = r0(1)
          do i = 1,leny
            cc_conn(ifinal+i) = rnode/cc0(i,1)
          enddo
          do i = 2,leny
            nodal_conn(ifinal+i) = rnode*(      (cc0(i,3) - cc0(i-1,3))*hx
     &                                    -half*(cc0(i,2)+cc0(i-1,2))*vol )
          enddo
          i = 1
          nodal_conn(ifinal+i) = nodal_conn(ifinal+i) + 
     &                           rnode*(     (cc0(i,3) - cc0(i-1,3))*hx
     &                                  -half*cc0(i,2)*vol )
          i = leny+1
          nodal_conn(ifinal+i) = rnode*(     (cc0(i,3) - cc0(i-1,3))*hx
     &                           -half*cc0(i-1,2)*vol )

          ifinal = ifinal + leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
          do i = 1,lenx
            cc_conn(ifinal+i) = r3(i)/cc3(i,1)
          enddo

          do i = 2,lenx
            rnode = half*(r3(i)+r3(i-1))
            nodal_conn(ifinal+i) = rnode*(      (cc3(i,3) - cc3(i-1,3))*hy
     &                                    -half*(cc3(i,2)+cc3(i-1,2))*vol )
          enddo
          i = 1
          rnode = 1.5d0*r3(1) - 0.5d0*r3(2)
c         Note: we get away with using r3(i) in place of r3(i-1), which isnt
c               defined, because if this is r-z, then the vel. at i-1 is zero,
c               and if not, then r is identically 1.
          nodal_conn(ifinal+i) = nodal_conn(ifinal+i) + 
     &                           r3(i)*(cc3(i,3) - cc3(i-1,3))*hy
     &                           -half*rnode*cc3(i,2)*vol
          i = lenx+1
          rnode = 1.5d0*r3(lenx) - 0.5d0*r3(lenx-1)
c         Note: same reasoning as above for using r3(i-1)
          nodal_conn(ifinal+i) = 
     &                           r3(i-1)*(cc3(i,3) - cc3(i-1,3))*hy
     &                           -half*rnode*cc3(i-1,2)*vol

          ifinal = ifinal + lenx
      endif

      length = ifinal

#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

c *************************************************************************
c ** ALLPHI_FROM_X **
c *************************************************************************

      subroutine FORT_ALLPHI_FROM_X(lenx,leny,length,faces,numOutFlowFaces,
     $                              phi0,phi1,phi2,phi3,x)

      integer lenx,leny,length
      integer numOutFlowFaces
      integer faces(4)
      REAL_T phi0(0:leny)
      REAL_T phi1(0:lenx)
      REAL_T phi2(0:leny)
      REAL_T phi3(0:lenx)
      REAL_T x(0:length)

      integer xlo_outflow,ylo_outflow
      integer xhi_outflow,yhi_outflow
      integer i,j,ifinal,n

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

c     Possible combinations of faces to come in here:
c       phi0 phi1 phi2 phi3
c       XLO  YLO 
c       XLO            YHI 
c            YLO  XHI 
c            YLO       YHI 
c       XLO  YLO  XHI
c       XLO       XHI  YHI
c       XLO  YLO       YHI
c            YLO  XHI  YHI
c       XLO  YLO  XHI  YHI

c     Want to find which are outflow faces.
      xlo_outflow = 0
      ylo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
      enddo

c     We know that the faces are ordered: XLO,XHI,YLO,YHI
      
      ifinal = 0

      if (numOutFlowFaces .eq. 4 .or. 
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 0) ) then
        do j = 0,leny
          phi0(j) = x(j)
        enddo
        ifinal = leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    .not. (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
        do i = 0,lenx
          phi3(i) = x(i+ifinal)
        enddo
        ifinal = ifinal+lenx
      endif

      if (xhi_outflow .eq. 1) then
        do j = 0,leny
          phi2(leny-j) = x(ifinal+j)
        enddo
        ifinal = ifinal+leny
      endif

      if (ylo_outflow .eq. 1) then
        if (numOutFlowFaces .eq. 4) then 
          do i = 0,lenx-1
            phi1(lenx-i) = x(ifinal+i)
          enddo
          phi1(0) = x(0)
        else
          do i = 0,lenx
            phi1(lenx-i) = x(ifinal+i)
          enddo
        endif
        ifinal = ifinal+lenx
      endif

      if (numOutFlowFaces .lt. 4 .and.
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 1) ) then
        do j = 0,leny
          phi0(j) = x(j+ifinal)
        enddo
        ifinal = ifinal+leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
        do i = 0,lenx
          phi3(i) = x(i+ifinal)
        enddo
        ifinal = ifinal+lenx
      endif

      end


c *************************************************************************
c ** PHI_FROM_X **
c *************************************************************************

      subroutine FORT_PHI_FROM_X(DIMS(phi),phi,length,x,per)

      integer DIMDEC(phi)
      integer length
      REAL_T phi(DIMV(phi))
      REAL_T x(length+1)
      integer per

      integer lenx, leny
      integer i,j

c     We know that the faces are ordered: XLO,XHI,YLO,YHI
      lenx = ARG_H1(phi)-ARG_L1(phi)
      leny = ARG_H2(phi)-ARG_L2(phi)

      if (lenx .eq. 0) then
        do j = 1,length
          phi(ARG_L1(phi),j-1) = x(j)
        enddo
        if (per .eq. 1) then
          phi(ARG_L1(phi),ARG_H2(phi)) = phi(ARG_L1(phi),ARG_L2(phi))
        else
          phi(ARG_L1(phi),ARG_H2(phi)) = x(length+1)
        endif
      elseif (leny .eq. 0) then
        do i = 1,length
          phi(i-1,ARG_L2(phi)) = x(i)
        enddo
        if (per .eq. 1) then
          phi(ARG_H1(phi),ARG_L2(phi)) = phi(ARG_L1(phi),ARG_L2(phi))
        else
          phi(ARG_H1(phi),ARG_L2(phi)) = x(length+1)
        endif
      endif

#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "VISC_F.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define twentyfive 25.e0
#else
#define twentyfive 25.d0
#endif

#define DIMS  lo_1,lo_2,hi_1,hi_2
#define CDIMS loc_1,loc_2,hic_1,hic_2

c *************************************************************************
c ** INITSIG **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIGV(sigma,rho,rmu,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer DIMS
      REAL_T sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T rmu
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi

c     Local variables
      integer i,j

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        sigma(i,j) = rmu/rho(i,j)

      enddo
      enddo

      if (bcx_lo .eq. PERIODIC) then
        do j = lo_2,hi_2
          sigma(lo_1-1,j) = sigma(hi_1,j)
        enddo
      else if (bcx_lo .eq. WALL) then
        do j = lo_2,hi_2
          sigma(lo_1-1,j) = sigma(lo_1,j)
        enddo
      else if (bcx_lo .eq. INLET) then
        do j = lo_2,hi_2
          sigma(lo_1-1,j) = rmu / rho(lo_1-1,j)
        enddo
      else if (bcx_lo .eq. OUTLET) then
        do j = lo_2,hi_2
          sigma(lo_1-1,j) = sigma(lo_1,j)
        enddo
      endif

      if (bcx_hi .eq. PERIODIC) then
        do j = lo_2,hi_2
          sigma(hi_1+1,j) = sigma(lo_1,j)
        enddo
      else if (bcx_hi .eq. WALL) then
        do j = lo_2,hi_2
          sigma(hi_1+1,j) = sigma(hi_1,j)
        enddo
      else if (bcx_hi .eq. INLET) then
        do j = lo_2,hi_2
          sigma(hi_1+1,j) = rmu / rho(hi_1+1,j)
        enddo
      else if (bcx_hi .eq. OUTLET) then
        do j = lo_2,hi_2
          sigma(hi_1+1,j) = sigma(hi_1,j)
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do i = lo_1,hi_1
          sigma(i,lo_2-1) = sigma(i,hi_2)
        enddo
      else if (bcy_lo .eq. WALL) then
        do i = lo_1,hi_1
          sigma(i,lo_2-1) = sigma(i,lo_2)
        enddo
      else if (bcy_lo .eq. INLET) then
        do i = lo_1,hi_1
          sigma(i,lo_2-1) = rmu / rho(i,lo_2-1)
        enddo
      else if (bcy_lo .eq. OUTLET) then
        do i = lo_1,hi_1
          sigma(i,lo_2-1) = sigma(i,lo_2)
        enddo
      endif

      if (bcy_hi .eq. PERIODIC) then
        do i = lo_1,hi_1
          sigma(i,hi_2+1) = sigma(i,lo_2)
        enddo
      else if (bcy_hi .eq. WALL) then
        do i = lo_1,hi_1
          sigma(i,hi_2+1) = sigma(i,hi_2)
        enddo
      else if (bcy_hi .eq. INLET) then
        do i = lo_1,hi_1
          sigma(i,hi_2+1) = rmu / rho(i,hi_2+1)
        enddo
      else if (bcy_hi .eq. OUTLET) then
        do i = lo_1,hi_1
          sigma(i,hi_2+1) = sigma(i,hi_2)
        enddo
      endif


      return
      end

c *************************************************************************
c ** RHSNORM **
c ** Take the norm of the right-hand-side and fill the inflow registers
c *************************************************************************

      subroutine FORT_RHSNORM(rhs,source,DIMS,rnorm,
     $                        uinx_lo,uinx_hi,uiny_lo,uiny_hi)

      implicit none
      integer DIMS
      REAL_T     rhs(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  source(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T    uinx_lo(lo_2-1:hi_2+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1)
      REAL_T rnorm

c     Local variables
      integer i,j

      rnorm = zero

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          rnorm = max(rnorm,abs(rhs(i,j)))
          source(i,j) = rhs(i,j)
        enddo
      enddo

      do j = lo_2-1,hi_2+1
        uinx_lo(j) = rhs(lo_1-1,j)
        uinx_hi(j) = rhs(hi_1+1,j)
      enddo

      do i = lo_1-1,hi_1+1 
        uiny_lo(i) = rhs(i,lo_2-1)
        uiny_hi(i) = rhs(i,hi_2+1)
      enddo

      return
      end

c *************************************************************************
c ** RESID_XY **
c ** Compute the residual in Cartesian (x-y) geometry
c *************************************************************************

      subroutine FORT_RESID(res,u,f,sigma,
     $                      uinx_lo,uinx_hi,uiny_lo,uiny_hi,r,rhalf,
     $                      DIMS,hx,hy,
     $                      resnorm,bcx_lo,bcx_hi,bcy_lo,bcy_hi,level,irz,idir)

      implicit none

      integer DIMS
      REAL_T    res(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinx_lo(lo_2-1:hi_2+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1)
      REAL_T          r(lo_1-1:hi_1+1)
      REAL_T      rhalf(lo_1  :hi_1+2)
      REAL_T hx
      REAL_T hy
      REAL_T resnorm
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer level
      integer irz
      integer idir

c     Local variables
      REAL_T ux_left,ux_left_wall
      REAL_T ux_rght,ux_rght_wall
      REAL_T uy_bot , uy_bot_wall
      REAL_T uy_top , uy_top_wall
      REAL_T hxsqinv, hysqinv
      logical ltest
      integer is,ie,js,je
      integer i,j

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      if (level .eq. 0) then
        call gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,
     $               DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,irz,idir)
      endif
      do j = lo_2,hi_2 
        do i = lo_1,hi_1 

            ux_left = (u(i,j) - u(i-1,j))
            ux_left_wall = (-sixteen * u(is-1,j) + twenty * u(is,j)
     $                         -five * u(is+1,j) + u(is+2,j) ) * fifth
            ltest = ( i .eq. is .and. level .eq. 0 .and.
     $               (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) .and.
     $               (irz .eq. 0 .or. (irz .eq. 1 .and. idir .eq. 0)) )
            ux_left   = cvmgt(ux_left_wall, ux_left,ltest)
            ux_left   = rhalf(i) *   ux_left * hxsqinv

            ux_rght = (u(i+1,j) - u(i,j))
            ux_rght_wall = ( sixteen * u(ie+1,j) - twenty * u(ie,j)
     $                         +five * u(ie-1,j) - u(ie-2,j) ) * fifth
            ltest = ( i .eq. ie .and. level .eq. 0 .and.
     $               (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) )
            ux_rght   = cvmgt(ux_rght_wall,ux_rght,ltest)
            ux_rght   = rhalf(i+1) *   ux_rght * hxsqinv

            uy_bot = (u(i,j) - u(i,j-1))
            uy_bot_wall = (-sixteen * u(i,js-1) + twenty * u(i,js)
     $                        -five * u(i,js+1) + u(i,js+2) ) * fifth
            ltest = ( j .eq. js .and. level .eq. 0 .and.
     $                (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) )
            uy_bot   = cvmgt(uy_bot_wall,uy_bot,ltest)
            uy_bot   = r(i) *   uy_bot * hysqinv

            uy_top = (u(i,j+1) - u(i,j))
            uy_top_wall = (sixteen * u(i,je+1) - twenty * u(i,je)
     $                       +five * u(i,je-1) - u(i,je-2) ) * fifth
            ltest = ( j .eq. je .and. level .eq. 0 .and.
     $                (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) )
            uy_top   = cvmgt(uy_top_wall,uy_top,ltest)
            uy_top   = r(i) *   uy_top * hysqinv

            res(i,j) = f(i,j) - (
     $         u(i,j) - sigma(i,j) * (ux_rght-ux_left+uy_top-uy_bot) / r(i) )

        enddo
      enddo

      if (irz .eq. 1 .and. idir .eq. 0) then
        do j = js,je 
          do i = is,ie 
            res(i,j) = res(i,j) - sigma(i,j)*u(i,j)/(r(i)*r(i))
          enddo
        enddo
      endif

      resnorm = zero

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          resnorm = max(resnorm,abs(res(i,j)))
        enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRBV **
c ** Gauss-Seidel red-black relaxation 
c *************************************************************************

      subroutine FORT_GSRBV(u,f,sigma,uinx_lo,uinx_hi,uiny_lo,uiny_hi,
     $                      r,rhalf,DIMS,hx,hy,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,level,irz,idir,nngsrb)

      implicit none

      integer DIMS
      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinx_lo(lo_2-1:hi_2+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1)
      REAL_T          r(lo_1-1:hi_1+1)
      REAL_T      rhalf(lo_1  :hi_1+2)
      REAL_T hx
      REAL_T hy
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer level
      integer irz
      integer idir
      integer nngsrb

c     Local variables
      REAL_T ux_left,ux_left_wall,facx_left
      REAL_T ux_rght,ux_rght_wall,facx_rght
      REAL_T uy_bot , uy_bot_wall,facy_bot
      REAL_T uy_top , uy_top_wall,facy_top
      REAL_T rlam, rlu
      REAL_T hxsqinv, hysqinv
      integer i,j,iter,ioff,iinc
      integer is,ie,js,je
      logical ltest

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      if (level .eq. 0) then
          call gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,
     $                 DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,irz,idir)
      else
          if (bcx_lo .eq. PERIODIC) then
            do j = js-1,je+1 
              u(is-1,j) = u(ie,j)
            enddo
          elseif (bcx_lo .eq. OUTLET) then
            do j = js-1,je+1 
              u(is-1,j) = u(is,j)
            enddo
          endif

          if (bcx_hi .eq. PERIODIC) then
            do j = js-1,je+1 
              u(ie+1,j) = u(is,j)
            enddo
          elseif (bcx_hi .eq. OUTLET) then
            do j = js-1,je+1 
              u(ie+1,j) = u(ie,j)
            enddo
          endif

          if (bcy_lo .eq. PERIODIC) then
            do i = is,ie 
              u(i,js-1) = u(i,je)
            enddo
          elseif (bcy_lo .eq. OUTLET) then
            do i = is-1,ie+1 
              u(i,js-1) = u(i,js)
            enddo
          endif

          if (bcy_hi .eq. PERIODIC) then
            do i = is,ie 
              u(i,je+1) = u(i,js)
            enddo
          elseif (bcy_hi .eq. OUTLET) then
            do i = is-1,ie+1 
              u(i,je+1) = u(i,je)
            enddo
          endif
      endif

      do iter = 1, nngsrb 
       do ioff = 0,1

          do j = js,je 
            iinc = mod(j+ioff,2)
            do i = is+iinc,ie,2

              ux_left = (u(i,j) - u(i-1,j))
              ux_left_wall = (-sixteen * u(is-1,j) + twenty * u(is,j)
     $                           -five * u(is+1,j) + u(is+2,j) ) * fifth
              ltest = ( i .eq. is .and. level .eq. 0 .and.
     $                 (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) .and.
     $                 (irz .eq. 0 .or. (irz .eq. 1 .and. idir .eq. 0)) )
              ux_left   = cvmgt(ux_left_wall, ux_left,ltest)
              facx_left = cvmgt(four        ,one     ,ltest)
              ux_left   = rhalf(i) *   ux_left * hxsqinv
              facx_left = rhalf(i) * facx_left * hxsqinv

              ux_rght = (u(i+1,j) - u(i,j))
              ux_rght_wall = ( sixteen * u(ie+1,j) - twenty * u(ie,j)
     $                           +five * u(ie-1,j) - u(ie-2,j) ) * fifth
              ltest = ( i .eq. ie .and. level .eq. 0 .and.
     $                 (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) )
              ux_rght   = cvmgt(ux_rght_wall,ux_rght,ltest)
              facx_rght = cvmgt(four        ,one    ,ltest)
              ux_rght   = rhalf(i+1) *   ux_rght * hxsqinv
              facx_rght = rhalf(i+1) * facx_rght * hxsqinv

              uy_bot = (u(i,j) - u(i,j-1))
              uy_bot_wall = (-sixteen * u(i,js-1) + twenty * u(i,js)
     $                          -five * u(i,js+1) + u(i,js+2) ) * fifth
              ltest = ( j .eq. js .and. level .eq. 0 .and.
     $                  (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) )
              uy_bot   = cvmgt(uy_bot_wall,uy_bot,ltest)
              facy_bot = cvmgt(four       ,one   ,ltest)
              uy_bot   = r(i) *   uy_bot * hysqinv
              facy_bot = r(i) * facy_bot * hysqinv

              uy_top = (u(i,j+1) - u(i,j))
              uy_top_wall = (sixteen * u(i,je+1) - twenty * u(i,je)
     $                         +five * u(i,je-1) - u(i,je-2) ) * fifth
              ltest = ( j .eq. je .and. level .eq. 0 .and.
     $                  (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) )
              uy_top   = cvmgt(uy_top_wall,uy_top,ltest)
              facy_top = cvmgt(four       ,one   ,ltest)
              uy_top   = r(i) *   uy_top * hysqinv
              facy_top = r(i) * facy_top * hysqinv

              rlu = u(i,j) - sigma(i,j) * (ux_rght-ux_left+uy_top-uy_bot) / r(i)
              if (irz .eq. 1 .and. idir .eq. 0) 
     $          rlu = rlu + sigma(i,j) * u(i,j) / (r(i)*r(i))

              rlam = one + sigma(i,j)*(facx_left+facx_rght+facy_bot+facy_top)
              rlam = one/rlam
              u(i,j) = u(i,j) - rlam*(rlu - f(i,j))

            enddo
          enddo

          if (level .eq. 0) then
            call gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,
     $                   DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,irz,idir)
          else 

            if (bcx_lo .eq. PERIODIC) then
              do j = js-1,je+1 
                u(is-1,j) = u(ie,j)
              enddo
            elseif ( bcx_lo .eq. OUTLET .or.
     $              (bcx_lo .eq. WALL .and. idir .ne. 0 .and. irz .eq. 1) ) then
              do j = lo_2-1,hi_2+1 
                u(is-1,j) = u(is,j)
              enddo
            endif

            if (bcx_hi .eq. PERIODIC) then
              do j = js-1,je+1 
                u(ie+1,j) = u(is,j)
              enddo
            elseif (bcx_hi .eq. OUTLET) then
              do j = lo_2-1,hi_2+1 
                u(ie+1,j) = u(ie,j)
              enddo
            endif

            if (bcy_lo .eq. PERIODIC) then
              do i = is,ie 
                u(i,js-1) = u(i,je)
              enddo
            elseif (bcy_lo .eq. OUTLET) then
              do i = lo_1-1,hi_1+1 
                u(i,js-1) = u(i,js)
              enddo
            endif

            if (bcy_hi .eq. PERIODIC) then
              do i = is,ie 
                u(i,je+1) = u(i,js)
              enddo
            elseif (bcy_hi .eq. OUTLET) then
              do i = lo_1-1,hi_1+1 
                u(i,je+1) = u(i,je)
              enddo
            endif

          endif

       enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRBVBC **
c ** Impose phyical boundary conditions
c *************************************************************************

      subroutine gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,
     $                   DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,irz,idir)

      implicit none

      integer DIMS
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinx_lo(lo_2-1:hi_2+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer irz
      integer idir

c     Local variables
      integer i,j,is,ie,js,je

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

c     NOTE: WHEN BC = WALL or INLET, THE STENCILS ASSUME THE GHOST CELL VALUES
c           APPLY AT THE EDGE, NOT AT THE CELL OUTSIDE!!!

      if (bcy_lo .eq. OUTLET) then

        do i = is,ie 
          u(i,js-1) = u(i,js)
        enddo

      elseif (bcy_lo .eq. INLET) then

        do i = is-1,ie+1 
          u(i,js-1) = uiny_lo(i)
        enddo

      elseif (bcy_lo .eq. WALL) then

        do i = is,ie 
          u(i,js-1) = zero
        enddo

      elseif (bcy_lo .eq. PERIODIC) then

        do i = is,ie 
          u(i,js-1) = u(i,je)
        enddo

      endif

      if (bcy_hi .eq. OUTLET) then

        do i = is-1,ie+1 
          u(i,je+1) = u(i,je)
        enddo

      elseif (bcy_hi .eq. INLET) then

        do i = is-1,ie+1 
          u(i,je+1) = uiny_hi(i)
        enddo

      elseif (bcy_hi .eq. WALL) then

        do i = is,ie 
          u(i,je+1) = zero
        enddo

      elseif (bcy_hi .eq. PERIODIC) then

        do i = is,ie 
          u(i,je+1) = u(i,js)
        enddo

      endif

      if (bcx_lo .eq. OUTLET) then

        do j = js-1,je+1 
          u(is-1,j) = u(is,j)
        enddo

      elseif (bcx_lo .eq. INLET) then

        do j = js-1,je+1 
          u(is-1,j) = uinx_lo(j)
        enddo

      elseif (bcx_lo .eq. WALL) then

        if (idir .eq. 0) then
          do j = js-1,je+1 
            u(is-1,j) = zero
          enddo
        else
          do j = js-1,je+1 
            u(is-1,j) = cvmgt(zero,u(is,j),irz .eq. 0)
          enddo
        endif

      elseif (bcx_lo .eq. PERIODIC) then

        do j = js-1,je+1 
          u(is-1,j) = u(ie,j)
        enddo

      endif

      if (bcx_hi .eq. OUTLET) then

        do j = js-1,je+1 
          u(ie+1,j) = u(ie,j)
        enddo

      elseif (bcx_hi .eq. INLET) then

        do j = js-1,je+1 
          u(ie+1,j) = uinx_hi(j)
        enddo

      elseif (bcx_hi .eq. WALL) then

        do j = js-1,je+1 
          u(ie+1,j) = zero
        enddo

      elseif (bcx_hi .eq. PERIODIC) then

        do j = js-1,je+1 
          u(ie+1,j) = u(is,j)
        enddo

      endif

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,r)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T   res(lo_1 :hi_1 ,lo_2 :hi_2 )
      REAL_T  resc(loc_1:hic_1,loc_2:hic_2)
      REAL_T     r(lo_1-1:hi_1+1)

c     Local variables
      REAL_T vtot
      integer i,j
      integer twoi,twoj

      do j = loc_2,hic_2 
        do i = loc_1,hic_1 
          twoi = 2*(i-loc_1)+ lo_1
          twoj = 2*(j-loc_2)+ lo_2
          vtot = (r(twoi) + r(twoi+1))*two
          resc(i,j) = (res(twoi  ,twoj) + res(twoi  ,twoj+1))*r(twoi) + 
     $                (res(twoi+1,twoj) + res(twoi+1,twoj+1))*r(twoi+1)
          resc(i,j) = resc(i,j)/vtot
        enddo
      enddo

      return
      end

c *************************************************************************
c ** COARSIGV **
c ** Coarsening of the coefficients
c *************************************************************************

      subroutine FORT_COARSIGV(sigma,sigmac,DIMS,CDIMS,r)

      implicit none
      integer DIMS
      integer CDIMS
      REAL_T   sigma(lo_1 -1:hi_1 +1,lo_2 -1:hi_2+1 )
      REAL_T  sigmac(loc_1-1:hic_1+1,loc_2-1:hic_2+1)
      REAL_T       r(lo_1-1:hi_1+1)

c     Local variables
      REAL_T vtot
      integer i,j,twoi,twoj

      do j = loc_2,hic_2 
        do i = loc_1,hic_1 
          twoi = 2*(i-loc_1)+ lo_1
          twoj = 2*(j-loc_2)+ lo_2
          vtot = (r(twoi) + r(twoi+1))*two
          sigmac(i,j) = (sigma(twoi  ,twoj) + sigma(twoi  ,twoj+1))*r(twoi) 
     $                 +(sigma(twoi+1,twoj) + sigma(twoi+1,twoj+1))*r(twoi+1)
          sigmac(i,j) = sigmac(i,j)/vtot
        enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise-constant interpolation 
c *************************************************************************

      subroutine FORT_INTERPOLATE(u,deltac,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T       u(lo_1 -1:hi_1 +1,lo_2 -1:hi_2 +1)
      REAL_T  deltac(loc_1-1:hic_1+1,loc_2-1:hic_2+1)

c     Local variables
      integer i,j,twoi,twoj

      do j = loc_2,hic_2 
        do i = loc_1,hic_1 

          twoi = 2*(i-loc_1)+lo_1
          twoj = 2*(j-loc_2)+lo_2

          u(twoi  ,twoj  ) = u(twoi  ,twoj  ) + deltac(i,j)
          u(twoi+1,twoj  ) = u(twoi+1,twoj  ) + deltac(i,j)
          u(twoi  ,twoj+1) = u(twoi  ,twoj+1) + deltac(i,j)
          u(twoi+1,twoj+1) = u(twoi+1,twoj+1) + deltac(i,j)

        enddo
      enddo


      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** MKFORCE **
c ** Define the forcing terms in the momentum equation
c ***************************************************************

      subroutine FORT_MKFORCE(force,u,rho,gravity,visc_coef,time,dx,DIMS)

      implicit none

      integer DIMS

      REAL_T  force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T      u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      REAL_T    rho(lo_1-3:hi_1+3,lo_2-3:hi_2+3)
      REAL_T  gravity
      REAL_T  time
      REAL_T  dx(2)
      REAL_T  visc_coef

c     Local variables
      integer i,j 

      do j = lo_2-1,hi_2+1
      do i = lo_1-1,hi_1+1
        force(i,j,1) = zero
        force(i,j,2) = gravity
      enddo
      enddo

      return
      end

#include "ArrayLim.H" 
      subroutine FORT_KINE(u,DIMS(u),xmean,ymean,tix,tiy,lo,hi)
      implicit none
      integer DIMDEC(u)
      integer lo(2), hi(2)
      REAL_T  u(DIMV(u),2)
      REAL_T  xmean,ymean,tix,tiy
      integer i,j

      do j = lo(2),hi(2)
      do i = lo(1),hi(1)
             xmean = xmean + u(i,j,1)
             ymean = ymean + u(i,j,2)
             tix = tix + u(i,j,1)**2
             tiy = tiy + u(i,j,2)**2
      enddo
      enddo
      end


      subroutine FORT_WRITEVEL(u,DIMS(u),lo,hi,psize)
      implicit none
      integer DIMDEC(u)
      integer lo(2), hi(2)
      REAL_T  u(DIMV(u),2)
      REAL_T  psize(2)
      integer i,j,n

      open(3,file='Turb',form='formatted') 
      rewind 3
      write(3,*)hi(1)-lo(1)+1,hi(2)-lo(2)+1,1
      write(3,*)psize(1),psize(2),1.d0
      write(3,*)1,1,1
      do n = 1,3
      do j = lo(2),hi(2)
      do i = lo(1),hi(1)
         write(3,*)u(i,j,n)
      enddo
      enddo
      enddo

      close(3)
      end

c-----------------------------------------------------------------------
c Works for CELL-based data.
      subroutine iprodc(
     & v0,    v0l0, v0h0, v0l1, v0h1,
     & v1,    v1l0, v1h0, v1l1, v1h1,
     &        regl0, regh0, regl1, regh1,
     & sum)
      integer v0l0, v0h0, v0l1, v0h1
      integer v1l0, v1h0, v1l1, v1h1
      integer regl0, regh0, regl1, regh1
      double precision v0(v0l0:v0h0,v0l1:v0h1)
      double precision v1(v1l0:v1h0,v1l1:v1h1)
      double precision sum
      integer i, j
      do j = regl1, regh1
         do i = regl0, regh0
            sum = sum + v0(i,j) * v1(i,j)
         end do
      end do
      end
c-----------------------------------------------------------------------
c Works for NODE-based data.
      subroutine iprodn(
     & v0,    v0l0, v0h0, v0l1, v0h1,
     & v1,    v1l0, v1h0, v1l1, v1h1,
     &        regl0, regh0, regl1, regh1,
     & sum)
      integer v0l0, v0h0, v0l1, v0h1
      integer v1l0, v1h0, v1l1, v1h1
      integer regl0, regh0, regl1, regh1
      double precision v0(v0l0:v0h0,v0l1:v0h1)
      double precision v1(v1l0:v1h0,v1l1:v1h1)
      double precision sum, sum0
      integer i, j
      sum0 = 0.5d0 * (v0(regl0,regl1) * v1(regl0,regl1) +
     &                v0(regl0,regh1) * v1(regl0,regh1) +
     &                v0(regh0,regl1) * v1(regh0,regl1) +
     &                v0(regh0,regh1) * v1(regh0,regh1))
      do i = regl0 + 1, regh0 - 1
         sum0 = sum0 + (v0(i,regl1) * v1(i,regl1) +
     &                  v0(i,regh1) * v1(i,regh1))
      end do
      do j = regl1 + 1, regh1 - 1
         sum0 = sum0 + (v0(regl0,j) * v1(regl0,j) +
     &                  v0(regh0,j) * v1(regh0,j))
      end do
      sum = sum + 0.5d0 * sum0
      do j = regl1 + 1, regh1 - 1
         do i = regl0 + 1, regh0 - 1
            sum = sum + v0(i,j) * v1(i,j)
         end do
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine bref(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & idir, ncomp)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer idir
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      integer i, j, nc
      do nc = 1, ncomp
      if (idir .eq. 0) then
         do i = regl0, regh0
            do j = regl1, regh1
               dest(i,j,nc) = src(bbh0-(i-regl0),j,nc)
            end do
         end do
      else
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = src(i,bbh1-(j-regl1),nc)
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine brefm(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & bbl0,  bbh0, bbl1, bbh1, ra, ncomp)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer ra(0:1)
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      integer i, j, nc
      do nc = 1, ncomp
      if (ra(0) .eq. 0 .and. ra(1) .eq. 0) then
         do j = regl1, regh1
            do i = regl0, regh0
                  dest(i,j,nc) = src(bbl0+(i-regl0),bbl1+(j-regl1),nc)
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 1) then
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = src(bbl0+(i-regl0),bbh1-(j-regl1),nc)
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 0) then
         do i = regl0, regh0
            do j = regl1, regh1
               dest(i,j,nc) = src(bbh0-(i-regl0),bbl1+(j-regl1),nc)
            end do
         end do
      else
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = src(bbh0-(i-regl0),bbh1-(j-regl1),nc)
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine bneg(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1, idir, ncomp)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer idir
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      integer i, j, nc
      do nc = 1, ncomp
      if (idir .eq. 0) then
         do i = regl0, regh0
            do j = regl1, regh1
               dest(i,j,nc) = -src(bbh0-(i-regl0),j,nc)
            end do
         end do
      else
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = -src(i,bbh1-(j-regl1),nc)
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine bnegm(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1, ra, ncomp)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer ra(0:1)
      double precision dest(destl0:desth0,destl1:desth1, ncomp)
      double precision src(srcl0:srch0,srcl1:srch1, ncomp)
      integer i, j, nc
      do nc = 1, ncomp
      if (ra(0) .eq. 0 .and. ra(1) .eq. 0) then
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = -src(bbl0+(i-regl0),bbl1+(j-regl1),nc)
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 1) then
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = -src(bbl0+(i-regl0),bbh1-(j-regl1),nc)
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 0) then
         do i = regl0, regh0
            do j = regl1, regh1
               dest(i,j,nc) = -src(bbh0-(i-regl0),bbl1+(j-regl1),nc)
            end do
         end do
      else
         do i = regl0, regh0
            do j = regl1, regh1
               dest(i,j,nc) = -src(bbh0-(i-regl0),bbh1-(j-regl1),nc)
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL-based velocity data.
c This routine assumes that the inflow face velocity data has not yet
c been altered.  Running fill_borders should call this routine on every
c inflow face, so that binfil can be run for subsequent fills
      subroutine binflo(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & idir, ncomp)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer idir
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      integer i, j,nc
      do nc = 1, ncomp
      if (idir .eq. 0) then
         if (regl0 .lt. bbh0) then
            do i = regl0, regh0
               do j = regl1, regh1
                  dest(i,j,nc) = 2.d0 * dest(regh0,j,nc)
     &            - src(bbh0-(i-regl0),j,nc)
               end do
            end do
         else
            do i = regh0, regl0, -1
               do j = regl1, regh1
                  dest(i,j,nc) = 2.d0 * dest(regl0,j,nc)
     &            - src(bbh0-(i-regl0),j,nc)
               end do
            end do
         end if
      else
         if (regl1 .lt. bbh1) then
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,nc) = 2.d0 * dest(i,regh1,nc)
     &            - src(i,bbh1-(j-regl1),nc)
               end do
            end do
         else
            do j = regh1, regl1, -1
               do i = regl0, regh0
                  dest(i,j,nc) = 2.d0 * dest(i,regl1,nc)
     &            - src(i,bbh1-(j-regl1),nc)
               end do
            end do
         end if
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL-based velocity data.
c This routine is called when the inflow face velocity data has already
c been altered by a call to fill_borders.  The box bb must have been
c extended to one cell past the boundary by the boundary::box routine.

      subroutine binfil(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & idir, ncomp)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer idir
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      integer i, j, nc
      do nc = 1, ncomp
      if (idir .eq. 0) then
         if (regl0 .lt. bbh0) then
            do i = regl0, regh0
               do j = regl1, regh1
                  dest(i,j,nc) = src(bbl0,j,nc) + src(bbl0+1,j,nc) -
     &                        src(bbh0-(i-regl0),j,nc)
               end do
            end do
         else
            do i = regh0, regl0, -1
               do j = regl1, regh1
                  dest(i,j,nc) = src(bbh0-1,j,nc) + src(bbh0,j,nc) -
     &                        src(bbl0+(regh0-i),j,nc)
               end do
            end do
         end if
      else
         if (regl1 .lt. bbh1) then
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,nc) = src(i,bbl1,nc) + src(i,bbl1+1,nc) -
     &                        src(i,bbh1-(j-regl1),nc)
               end do
            end do
         else
            do j = regh1, regl1, -1
               do i = regl0, regh0
                  dest(i,j,nc) = src(i,bbh1-1,nc) + src(i,bbh1,nc) -
     &                        src(i,bbl1+(regh1-j),nc)
               end do
            end do
         end if
      end if
      end do
      end
c-----------------------------------------------------------------------
c     Interpolation...
c-----------------------------------------------------------------------
c CELL-based data only.
      subroutine acint2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & ir, jr, ncomp, integ, i1, i2)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer ir, jr
      integer i1, i2, integ
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      double precision xoff, yoff, sx, sy
      integer i, j, ic, jc, nc
      do nc = 1, ncomp
      do j = regl1, regh1
         jc = j/jr
         yoff = (mod(j,jr) + 0.5D0) / jr - 0.5D0
         do i = regl0, regh0
            ic = i/ir
            xoff = (mod(i,ir) + 0.5D0) / ir - 0.5D0
            sy = 0.5D0 * (src(ic,jc+1,nc) - src(ic,jc-1,nc))
            sx = 0.5D0 * (src(ic+1,jc,nc) - src(ic-1,jc,nc))
            dest(i,j,nc) = src(ic,jc,nc) + xoff * sx + yoff * sy
         end do
      end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
      subroutine anint2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & ir, jr, ncomp, i1, i2, integ)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer ir, jr,nc
      integer i1, i2, integ
      double precision dest(destl0:desth0,destl1:desth1, ncomp)
      double precision src(srcl0:srch0,srcl1:srch1, ncomp)
      double precision p, q
      integer ic, jc, j, m
      do nc = 1, ncomp
         do jc = bbl1, bbh1
            do ic = bbl0, bbh0
               dest(ir*ic,jr*jc,nc) = src(ic,jc,nc)
            end do
         end do
         do m = 1, jr-1
            q = dble(m)/jr
            p = 1.0d0 - q
            do jc = bbl1, bbh1-1
               do ic = bbl0, bbh0
                  dest(ir*ic,jr*jc+m,nc) = p * src(ic,jc,nc) +
     &                                  q * src(ic,jc+1,nc)
               end do
            end do
         end do
         do m = 1, ir-1
            q = dble(m)/ir
            p = 1.0d0 - q
            do ic = bbl0, bbh0-1
cdir$ ivdep
               do j = regl1, regh1
                  dest(ir*ic+m,j,nc) = p * dest(ir*ic,j,nc) +
     &                              q * dest(ir*(ic+1),j,nc)
               end do
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c     Restrictions....
c-----------------------------------------------------------------------
c CELL-based data only.
      subroutine acrst1(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, i1, i2)
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, ncomp, integ
      integer i1, i2
      double precision dest(destl0:desth0,destl1:desth1, ncomp)
      double precision src(srcl0:srch0,srcl1:srch1, ncomp)
      double precision fac
      integer i, j, m, n, nc
      do nc = 1, ncomp
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = 0.d0
            end do
         end do
         do n = 0, jr-1
            do m = 0, ir-1
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,nc) = dest(i,j,nc) + src(i*ir+m,j*jr+n,nc)
                  end do
               end do
            end do
         end do
         if (integ .eq. 0) then
            fac = 1.d0 / (ir*jr)
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,nc) = dest(i,j,nc) * fac
               end do
            end do
         end if
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
      subroutine anrst1(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, i1, i2)
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, ncomp
      integer i1, i2, integ
      double precision dest(destl0:desth0,destl1:desth1, ncomp)
      double precision src(srcl0:srch0,srcl1:srch1, ncomp)
      integer i, j,nc
      do nc = 1, ncomp
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = src(i*ir,j*jr,nc)
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse region defined by reg, which must be smaller than
c fine region by at least one coarse cell on all sides.
      subroutine anrst2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, i1, i2)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, integ, i1, i2
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      double precision fac0, fac1, fac
      integer i, j, m, n, nc
      do nc = 1, ncomp
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,nc) = 0.d0
            end do
         end do
         fac0 = 1.d0 / (ir*ir * jr*jr)
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5d0 * fac
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,nc) = dest(i,j,nc) +
     &                           fac * (src(i*ir-m,j*jr-n,nc)+
     &                                  src(i*ir-m,j*jr+n,nc)+
     &                                  src(i*ir+m,j*jr-n,nc)+
     &                                  src(i*ir+m,j*jr+n,nc))
                  end do
               end do
            end do
         end do
         if (integ .eq. 1) then
            fac = ir * jr
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,nc) = fac * dest(i,j,nc)
               end do
            end do
         end if
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse region defined by reg.
      subroutine anfr2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, idim, idir)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, idim, idir, integ
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      double precision fac0, fac1, fac
      integer i, j, m, n, nc
      do nc = 1, ncomp
         if (idim .eq. 0) then
            if (integ .eq. 0) then
               fac = (0.5d0 + 0.5d0 / ir)
               fac0 = 1.d0 / (ir*ir * jr*jr)
            else
               fac = 1.d0
               fac0 = 1.d0 / (ir * jr)
            end if
            i = regl0
            do j = regl1, regh1
               dest(i,j,nc) = fac * src(i*ir,j*jr,nc)
            end do
            do n = 0, jr-1
               fac1 = (jr-n) * fac0
               if (n .eq. 0) fac1 = 0.5d0 * fac1
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  do j = regl1, regh1
                     dest(i,j,nc) = dest(i,j,nc) +
     &                  fac * (src(i*ir+m,j*jr-n,nc)+
     &                         src(i*ir+m,j*jr+n,nc))
                  end do
               end do
            end do
         else
            if (integ .eq. 0) then
               fac = (0.5d0 + 0.5d0 / jr)
               fac0 = 1.d0 / (ir*ir * jr*jr)
            else
               fac = 1.d0
               fac0 = 1.d0 / (ir * jr)
            end if
            j = regl1
            do i = regl0, regh0
               dest(i,j,nc) = fac * src(i*ir,j*jr,nc)
            end do
            do n = idir, idir*(jr-1), idir
               fac1 = (jr-abs(n)) * fac0
               do m = 0, ir-1
                  fac = (ir-m) * fac1
                  if (m .eq. 0) fac = 0.5d0 * fac
                  do  i = regl0, regh0
                     dest(i,j,nc) = dest(i,j,nc)
     &            + fac * (src(i*ir-m,j*jr+n,nc)
     &                    +src(i*ir+m,j*jr+n,nc))
                  end do
               end do
            end do
         end if
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse point defined by reg.
      subroutine anor2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, idir0, idir1)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, idir0, idir1, integ
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      double precision fac0, fac1, fac
      integer i, j, m, n, nc
      do nc = 1, ncomp
         if (integ .eq. 0) then
            fac = (0.75d0 + 0.25d0/ir + 0.25d0/jr - 0.25d0/(ir*jr))
            fac0 = 1.d0 / (ir*ir * jr*jr)
         else
            fac = 1.d0
            fac0 = 1.d0 / (ir * jr)
         end if
         i = regl0
         j = regl1
         dest(i,j,nc) = fac * src(i*ir,j*jr,nc)
         do n = idir1, idir1*(jr-1), idir1
            fac1 = (jr-abs(n)) * fac0
            do m = idir0, idir0*(ir-1), idir0
               fac = (ir-abs(m)) * fac1
               dest(i,j,nc) = dest(i,j,nc) + fac * src(i*ir+m,j*jr+n,nc)
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse point defined by reg.
      subroutine anir2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, idir0, idir1)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, idir0, idir1, integ
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      double precision fac0, fac1, fac
      integer i, j, m, n, nc
      do nc = 1, ncomp
         if (integ .eq. 0) then
            fac = (0.25d0 + 0.25d0/ir + 0.25d0/jr + 0.25d0/(ir*jr))
            fac0 = 1.d0/(ir*ir * jr*jr)
         else
            fac = 1.d0
            fac0 = 1.d0/(ir*jr)
         end if
         i = regl0
         j = regl1
         dest(i,j,nc) = fac * src(i*ir,j*jr,nc)
         do m = idir0, idir0*(ir-1), idir0
            fac1 = (ir-abs(m)) * fac0
            fac = jr * fac1
            dest(i,j,nc) = dest(i,j,nc) + fac * src(i*ir+m,j*jr,nc)
         end do
         do n = idir1, idir1*(jr-1), idir1
            fac1 = (jr-abs(n)) * fac0
            fac = ir * fac1
            dest(i,j,nc) = dest(i,j,nc) + fac * src(i*ir,j*jr+n,nc)
            do m = idir0, idir0*(ir-1), idir0
               fac = (ir-abs(m)) * fac1
               dest(i,j,nc) = dest(i,j,nc) + fac *
     &               (src(i*ir+m,j*jr+n,nc) +
     &                src(i*ir-m,j*jr+n,nc) +
     &                src(i*ir+m,j*jr-n,nc))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse point defined by reg.
      subroutine andr2(
     & dest,  destl0, desth0, destl1, desth1,
     &        regl0, regh0, regl1, regh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & ir, jr, ncomp, integ, idir1, i2)
      integer ncomp
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr, idir1, integ
      double precision dest(destl0:desth0,destl1:desth1,ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,ncomp)
      double precision fac0, fac1, fac
      integer i, j, m, n, nc, i2
      do nc = 1, ncomp
         if (integ .eq. 0) then
            fac = (0.5d0 + 0.5d0 / ir + 0.5d0 / jr - 0.5d0 / (ir*jr))
            fac0 = 1.d0 / (ir*ir * jr*jr)
         else
            fac = 1.d0
            fac0 = 1.d0 / (ir * jr)
         end if
         i = regl0
         j = regl1
         dest(i,j,nc) = fac * src(i*ir,j*jr,nc)
         do n = idir1, idir1*(jr-1), idir1
            fac1 = (jr-abs(n)) * fac0
            do m = 1, ir-1
               fac = (ir-m) * fac1
               dest(i,j,nc) = dest(i,j,nc) + fac *
     &               (src(i*ir+m,j*jr+n,nc) +
     &                src(i*ir-m,j*jr-n,nc))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse region defined by reg.
c Handles any corner geometry except all-coarse.
      subroutine ancr2(
     & dest, destl0,desth0,destl1,desth1,
     &       regl0,regh0,regl1,regh1,
     & src,  srcl0,srch0,srcl1,srch1,
     & ir, jr, ncomp, integ, ga, i2)
      integer ncomp
      integer destl0,desth0,destl1,desth1
      integer regl0,regh0,regl1,regh1
      integer srcl0,srch0,srcl1,srch1
      integer ir, jr, ga(0:1,0:1), integ
      double precision dest(destl0:desth0,destl1:desth1,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1, ncomp)
      double precision cube, center, cfac, fac0, fac1, fac
      integer i, j, ii, ji, idir, jdir, m, n, nc, i2
      i = regl0
      j = regl1
      do nc = 1, ncomp
      dest(i,j,nc) = 0.0D0
      cube = ir * jr
      if (integ .eq. 0) then
         center = 1.0D0 / cube
         fac0 = 1.0D0 / (cube**2)
         cfac = 0.25D0 * cube * fac0 * (ir-1) * (jr-1)
      else
         center = 1.0D0
         fac0 = 1.0D0 / cube
      end if
c octants
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji) .eq. 1) then
                     do n = jdir, jdir*(jr-1), jdir
                        fac1 = (jr-abs(n)) * fac0
                        do m = idir, idir*(ir-1), idir
                           fac = (ir-abs(m)) * fac1
                           dest(i,j,nc) = dest(i,j,nc) +
     &                       fac * src(i*ir+m,j*jr+n,nc)
                        end do
                     end do
               else if (integ .eq. 0) then
                  center = center + cfac
               end if
            end do
          end do
c faces
      fac1 = jr * fac0
      cfac = 0.50D0 * cube * fac0 * (ir-1)
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,0) + ga(ii,1) .eq. 2) then
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     dest(i,j,nc) = dest(i,j,nc) +
     &                 fac * src(i*ir+m,j*jr,nc)
                  end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
      fac1 = ir * fac0
      cfac = 0.50D0 * cube * fac0 * (jr-1)
         do ji = 0, 1
            jdir = 2 * ji - 1
            if (ga(0,ji) + ga(1,ji) .eq. 2) then
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     dest(i,j,nc) = dest(i,j,nc) +
     &                 fac * src(i*ir,j*jr+n,nc)
                  end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
c center
      dest(i,j,nc) = dest(i,j,nc) +
     &  center * src(i*ir,j*jr,nc)
      end do
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** MKADVVEL **
c ** Predict normal edge velocities to be MAC-projected and used
c **  for advection velocities
c ***************************************************************

      subroutine FORT_MKADVVEL(u,ux,uy,v,vx,vy,rho,force,px,py,lapu,
     $                         dx,dt,DIMS,stleft,strght,sttop,stbot,uadv,vadv,
     $                         utrans,vtrans,bcx_lo,bcx_hi,bcy_lo,bcy_hi,
     $                         visc_coef,irz)

      implicit none

      integer DIMS

      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     ux(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     uy(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     vx(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     vy(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T     px(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     py(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)

      REAL_T  stleft(lo_1-1:hi_1+1)
      REAL_T  strght(lo_1-1:hi_1+1)
      REAL_T   stbot(lo_2-1:hi_2+1)
      REAL_T   sttop(lo_2-1:hi_2+1)

      REAL_T   uadv(lo_1:hi_1+1,lo_2:hi_2  )
      REAL_T utrans(lo_1:hi_1+1,lo_2:hi_2  )
      REAL_T   vadv(lo_1:hi_1  ,lo_2:hi_2+1)
      REAL_T vtrans(lo_1:hi_1  ,lo_2:hi_2+1)
      REAL_T  dx(2)
      REAL_T  dt
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi
      REAL_T  visc_coef
      integer irz

c     Local variables
      REAL_T ubardth, vbardth
      REAL_T hx, hy,dth
      REAL_T uplus,uminus,vplus,vminus,ut,vt
      REAL_T utr,vtr,savg
      REAL_T uptop,upbot,umtop,umbot
      REAL_T vplft,vprgt,vmlft,vmrgt
      REAL_T vtop,vbot,ulft,urgt
      REAL_T flgp,flgm

      REAL_T eps

      REAL_T umax,umin,vmax,vmin,rhomax,rhomin

      logical ltp,ltm,ltx,lty,ltm0,ltp0
      integer i,j,is,js,ie,je

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      dth = half*dt
      hx = dx(1)
      hy = dx(2)

      umax   = -1.e30
      vmax   = -1.e30
      rhomax = -1.e30
      umin   =  1.e30
      vmin   =  1.e30
      rhomin =  1.e30
      do j = lo_2, hi_2
      do i = lo_1, hi_1
         umax = max(u(i,j),umax)
         umin = min(u(i,j),umin)
         vmax = max(v(i,j),vmax)
         vmin = min(v(i,j),vmin)
         rhomax = max(rho(i,j),rhomax)
         rhomin = min(rho(i,j),rhomin)
      enddo
      enddo

      write(6,1000) umax,umin
      write(6,1001) vmax,vmin
      write(6,1002) rhomax,rhomin

 1000 format(' U  MAX/MIN IN VELPRED ',e21.14,2x,e21.14)
 1001 format(' V  MAX/MIN IN VELPRED ',e21.14,2x,e21.14)
 1002 format('RHO MAX/MIN IN VELPRED ',e21.14,2x,e21.14)
c      call flush(6)

c     Create the y-velocity to be used for transverse derivatives.
      do j = js,je+1 
        do i = is,ie

          vtop = v(i,j ) - (half + dth*v(i,j)/hy) * vy(i,j)
c    $           + dth * lapu(i,j  ,2) / rho(i,j  )
          vbot = v(i,j-1) + (half - dth*v(i,j-1)/hy) * vy(i,j-1)
c    $           + dth * lapu(i,j-1,2) / rho(i,j-1)

          vtop = cvmgt(v(i,js-1),vtop,j.eq.js   .and. bcy_lo .eq. INLET)
          vtop = cvmgt(v(i,je+1),vtop,j.eq.je+1 .and. bcy_hi .eq. INLET)
          vtop = cvmgt(zero     ,vtop,j.eq.js   .and. bcy_lo .eq. WALL)
          vtop = cvmgt(zero     ,vtop,j.eq.je+1 .and. bcy_hi .eq. WALL)

          vbot = cvmgt(v(i,js-1),vbot,j.eq.js   .and. bcy_lo .eq. INLET)
          vbot = cvmgt(v(i,je+1),vbot,j.eq.je+1 .and. bcy_hI .eq. INLET)
          vbot = cvmgt(zero     ,vbot,j.eq.js   .and. bcy_lo .eq. WALL)
          vbot = cvmgt(zero     ,vbot,j.eq.je+1 .and. bcy_hi .eq. WALL)

          vtrans(i,j)=cvmgp(vbot,vtop,vbot+vtop)
          ltm = ( (vbot .le. zero  .and.  vtop .ge. zero)  .or.  
     $             (abs(vbot+vtop) .lt. eps))
          vtrans(i,j) = cvmgt(zero,vtrans(i,j),ltm)
        enddo
      enddo

c     Create the x-velocity to be used for transverse derivatives.
      do j = js,je 
        do i = is,ie+1 

          urgt = u(i,j ) - (half + dth*u(i,j)/hx) * ux(i,j)
c    $           + dth * lapu(i  ,j,1) / rho(i  ,j)
          ulft = u(i-1,j) + (half - dth*u(i-1,j)/hx) * ux(i-1,j)
c    $           + dth * lapu(i-1,j,1) / rho(i-1,j)

          urgt = cvmgt(u(is-1,j),urgt,i.eq.is   .and. bcx_lo .eq. INLET)
          urgt = cvmgt(u(ie+1,j),urgt,i.eq.ie+1 .and. bcx_hi .eq. INLET)
          urgt = cvmgt(zero     ,urgt,i.eq.is   .and. bcx_lo .eq. WALL)
          urgt = cvmgt(zero     ,urgt,i.eq.ie+1 .and. bcx_hi .eq. WALL)

          ulft = cvmgt(u(is-1,j),ulft,i.eq.is   .and. bcx_lo .eq. INLET)
          ulft = cvmgt(u(ie+1,j),ulft,i.eq.ie+1 .and. bcx_hi .eq. INLET)
          ulft = cvmgt(zero     ,ulft,i.eq.is   .and. bcx_lo .eq. WALL)
          ulft = cvmgt(zero     ,ulft,i.eq.ie+1 .and. bcx_hi .eq. WALL)

          utrans(i,j) = cvmgp(ulft,urgt,ulft+urgt)
          ltm=( (ulft .le. zero  .and.  urgt .ge. zero)  .or.  
     $          (abs(ulft+urgt) .lt. eps) )
          utrans(i,j) = cvmgt(zero,utrans(i,j),ltm)

        enddo
      enddo

c ::: loop for x fluxes

      do j = js,je 
        do i = is,ie 
          upbot = u(i,j  ) + (half - dth*v(i,j  )/hy) * uy(i,j  )
c    $            + dth * lapu(i,j  ,1) / rho(i,j  )
          uptop = u(i,j+1) - (half + dth*v(i,j+1)/hy) * uy(i,j+1)
c    $            + dth * lapu(i,j+1,1) / rho(i,j+1)

          uptop = cvmgt(u(i,je+1),uptop,j.eq.je .and. bcy_hi.eq.INLET)
          upbot = cvmgt(u(i,je+1),upbot,j.eq.je .and. bcy_hi.eq.INLET)

          uptop = cvmgt(upbot,uptop,j.eq.je .and. bcy_hi.eq.WALL)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)

          flgp=cvmgt(zero,one,abs(vtrans(i,j+1)).lt.eps)
          uplus = cvmgp(upbot,uptop,vtrans(i,j+1))
          uplus = flgp * uplus + (one - flgp)*half*(uptop+upbot)

          umtop = u(i,j ) - (half + dth*v(i,j)/hy) * uy(i,j)
c    $            + dth * lapu(i,j  ,1) / rho(i,j  )
          umbot = u(i,j-1) + (half - dth*v(i,j-1)/hy) * uy(i,j-1)
c    $            + dth * lapu(i,j-1,1) / rho(i,j-1)

          umtop = cvmgt(u(i,js-1),umtop,j.eq.js .and. bcy_lo.eq.INLET)
          umbot = cvmgt(u(i,js-1),umbot,j.eq.js .and. bcy_lo.eq.INLET)

          umbot = cvmgt(umtop,umbot,j.eq.js .and. bcy_lo.eq.WALL)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL  .and.  visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)

          flgm=cvmgt(zero,one,abs(vtrans(i,j)).lt.eps)
          uminus = cvmgp(umbot,umtop,vtrans(i,j))
          uminus = flgm * uminus + (one - flgm)*half*(umtop+umbot)

          utr = half * (vtrans(i,j)+vtrans(i,j+1))*(uplus - uminus) / hy
          ut = (lapu(i,j,1)-px(i,j))/rho(i,j) - utr + force(i,j,1)

          ubardth = dth*u(i,j)/hx

          stleft(i  )= u(i,j) + (half-ubardth)*ux(i,j) + dth*ut
          strght(i-1)= u(i,j) - (half+ubardth)*ux(i,j) + dth*ut

        enddo

        if (bcx_lo .eq. PERIODIC) then
          stleft(is-1) = stleft(ie  )
        elseif (bcx_lo .eq. WALL) then
          stleft(is-1) = zero
          strght(is-1) = zero
        elseif (bcx_lo .eq. INLET) then
          stleft(is-1) = u(is-1,j)
          strght(is-1) = u(is-1,j)
        elseif (bcx_lo .eq. OUTLET) then
          stleft(is-1) = strght(is-1)
        endif
        if (bcx_hi .eq. PERIODIC) then
          strght(ie  ) = strght(is-1)
        elseif (bcx_hi .eq. WALL) then
          stleft(ie  ) = zero
          strght(ie  ) = zero
        elseif (bcx_hi .eq. INLET) then
          stleft(ie) = u(ie+1,j)
          strght(ie) = u(ie+1,j)
        elseif (bcx_hi .eq. OUTLET) then
          strght(ie  ) = stleft(ie)
        endif

        do i = is-1, ie 

          savg = half*(strght(i) + stleft(i))
          ltx = ( (stleft(i) .le. zero  .and.  
     $             strght(i) .ge. zero)  .or.  
     $           (abs(stleft(i) + strght(i)) .lt. eps) )

          uadv(i+1,j)=cvmgp(stleft(i),strght(i),savg)
          uadv(i+1,j)=cvmgt(savg,uadv(i+1,j),ltx)

        enddo

        if (bcx_lo .eq. WALL) then
          uadv(is  ,j) = zero
        endif
        if (bcx_hi .eq. WALL) then
          uadv(ie+1,j) = zero
        endif

      enddo

c ::: loop for y fluxes

      do i = is, ie 
        do j = js, je 

          vplft = v(i,j ) + (half - dth*u(i,j)/hx) * vx(i,j)
c    $            + dth * lapu(i  ,j,2) / rho(i  ,j)
          vprgt = v(i+1,j) - (half + dth*u(i+1,j)/hx) * vx(i+1,j)
c    $            + dth * lapu(i+1,j,2) / rho(i+1,j)

          vprgt = cvmgt(v(ie+1,j),vprgt,i.eq.ie .and. bcx_hi.eq.INLET)
          vplft = cvmgt(v(ie+1,j),vplft,i.eq.ie .and. bcx_hi.eq.INLET)

          vprgt = cvmgt(vplft,vprgt,i.eq.ie .and. bcx_hi.eq.WALL)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL  .and.  visc_coef .gt. zero)
          vprgt = cvmgt(zero,vprgt,ltp0)
          vplft = cvmgt(zero,vplft,ltp0)

          flgp=cvmgt(zero,one,abs(utrans(i+1,j)).lt.eps)
          vplus = cvmgp(vplft,vprgt,utrans(i+1,j))
          vplus = flgp * vplus + (one - flgp)*half*(vprgt+vplft)

          vmrgt = v(i,j ) - (half + dth*u(i,j)/hx) * vx(i,j)
c    $            + dth * lapu(i  ,j,2) / rho(i  ,j)
          vmlft = v(i-1,j) + (half - dth*u(i-1,j)/hx) * vx(i-1,j)
c    $            + dth * lapu(i-1,j,2) / rho(i-1,j)

          vmrgt = cvmgt(v(is-1,j),vmrgt,i.eq.is .and. bcx_lo.eq.INLET)
          vmlft = cvmgt(v(is-1,j),vmlft,i.eq.is .and. bcx_lo.eq.INLET)

          vmlft = cvmgt(vmrgt,vmlft,i.eq.is .and. bcx_lo.eq.WALL)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL  .and.  visc_coef .gt. zero
     $            .and. irz .eq. 0)
          vmrgt = cvmgt(zero,vmrgt,ltm0)
          vmlft = cvmgt(zero,vmlft,ltm0)

          flgm=cvmgt(zero,one,abs(utrans(i,j)).lt.eps)
          vminus = cvmgp(vmlft,vmrgt,utrans(i,j))
          vminus = flgm * vminus + (one - flgm)*half*(vmrgt+vmlft)

          vtr = half * (utrans(i,j)+utrans(i+1,j))*(vplus - vminus) / hx

          vt = (lapu(i,j,2)-py(i,j))/rho(i,j) - vtr + force(i,j,2)
          vbardth = dth*v(i,j)/hy

          stbot(j  )= v(i,j) + (half-vbardth)*vy(i,j) + dth*vt
          sttop(j-1)= v(i,j) - (half+vbardth)*vy(i,j) + dth*vt

        enddo

        if (bcy_lo .eq. PERIODIC) then
          stbot(js-1) = stbot(je  )
        elseif (bcy_lo .eq. WALL) then
          stbot(js-1) = zero
          sttop(js-1) = zero
        elseif (bcy_lo .eq. INLET) then
          stbot(js-1) = v(i,js-1)
          sttop(js-1) = v(i,js-1)
        elseif (bcy_lo .eq. OUTLET) then
          stbot(js-1) = sttop(js-1)
        endif

        if (bcy_hi .eq. PERIODIC) then
          sttop(je  ) = sttop(js-1)
        elseif (bcy_hi .eq. WALL) then
          stbot(je  ) = zero
          sttop(je  ) = zero
        elseif (bcy_hi .eq. INLET) then
          stbot(je  ) = v(i,je+1)
          sttop(je  ) = v(i,je+1)
        elseif (bcy_hi .eq. OUTLET) then
          sttop(je  ) = stbot(je)
        endif


        do j = js-1, je 
          savg = half*(stbot(j)+sttop(j))
          lty = ( (stbot(j) .le. zero  .and.  sttop(j) .ge. zero) .or.
     $            (abs(stbot(j) + sttop(j)) .lt. eps) )

          vadv(i,j+1)=cvmgp(stbot(j),sttop(j),savg)
          vadv(i,j+1)=cvmgt(savg,vadv(i,j+1),lty)
        enddo

        if (bcy_lo .eq. WALL) then
          vadv(i,js  ) = zero
        endif
        if (bcy_hi .eq. WALL) then
          vadv(i,je+1) = zero
        endif

      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/


#include <REAL.H>
#include "LO_BCTYPES.H"
#include "MCLO_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
      subroutine FORT_RESIDL (
     $     res, DIMS(res), 
     $     rhs, DIMS(rhs),
     $     phi, DIMS(phi),
     $     lo, hi, nc
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(phi)
      REAL_T phi(DIMV(phi),nc)
      integer DIMDEC(rhs)
      REAL_T rhs(DIMV(rhs),nc)
      integer DIMDEC(res)
      REAL_T res(DIMV(res),nc)
c
      integer i
      integer j
      integer k
      integer n
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  res(i,j,k,n) = rhs(i,j,k,n) - phi(i,j,k,n)
               enddo
            enddo
         enddo
      enddo
c     
      end
c-----------------------------------------------------------------------
      subroutine FORT_HARMONIC_AVERAGEEC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc,
     $     cdir
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer cdir
      integer DIMDEC(f)
      REAL_T f(DIMV(f),nc)
      integer DIMDEC(c)
      REAL_T c(DIMV(c),nc)
c
      REAL_T  factor
      parameter(factor=4.0d0)

      integer n
      integer i
      integer j
      integer k
c
      if ( cdir .eq. 0 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)+1
c                  
                     c(i,j,k,n) = factor/(
     $                    + 1.0/f(2*i,2*j  ,2*k  ,n)
     $                    + 1.0/f(2*i,2*j+1,2*k  ,n)
     $                    + 1.0/f(2*i,2*j  ,2*k+1,n)
     $                    + 1.0/f(2*i,2*j+1,2*k+1,n) )
c                     
                  enddo
               enddo
            enddo
         enddo
      else if (cdir .eq. 1 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)+1
                  do i = lo(1), hi(1)
c
                     c(i,j,k,n) = factor/(
     $                    + 1.0/f(2*i  ,2*j,2*k  ,n)
     $                    + 1.0/f(2*i+1,2*j,2*k  ,n)
     $                    + 1.0/f(2*i  ,2*j,2*k+1,n)
     $                    + 1.0/f(2*i+1,2*j,2*k+1,n) )
c                     
                  enddo
               enddo
            enddo
         enddo
      else if (cdir .eq. 2 ) then
         do n = 1, nc
            do k = lo(3), hi(3)+1
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
c                     
                     c(i,j,k,n) = factor/(
     $                    + 1.0/f(2*i  ,2*j  ,2*k,n)
     $                    + 1.0/f(2*i+1,2*j  ,2*k,n)
     $                    + 1.0/f(2*i  ,2*j+1,2*k,n)
     $                    + 1.0/f(2*i+1,2*j+1,2*k,n) )
c                     
                  enddo
               enddo
            enddo
         enddo
      endif
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_AVERAGEEC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc,
     $     cdir
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer cdir
      integer DIMDEC(f)
      REAL_T f(DIMV(f),nc)
      integer DIMDEC(c)
      REAL_T c(DIMV(c),nc)
c     
      integer n
      integer i
      integer j
      integer k
      REAL_T factor
      parameter(factor = 0.25d0)
c     
      if ( cdir .eq. 0 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)+1
c     
                     c(i,j,k,n) = factor*(
     $                    + f(2*i,2*j  ,2*k  ,n)
     $                    + f(2*i,2*j+1,2*k  ,n)
     $                    + f(2*i,2*j  ,2*k+1,n)
     $                    + f(2*i,2*j+1,2*k+1,n) )
c                     
                  enddo
               enddo
            enddo
         enddo
      else if (cdir .eq. 1 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)+1
                  do i = lo(1), hi(1)
c                     
                     c(i,j,k,n) = factor*(
     $                    + f(2*i  ,2*j,2*k  ,n)
     $                    + f(2*i+1,2*j,2*k  ,n)
     $                    + f(2*i  ,2*j,2*k+1,n)
     $                    + f(2*i+1,2*j,2*k+1,n) )
c                     
                  enddo
               enddo
            enddo
         enddo
      else if (cdir .eq. 2 ) then
         do n = 1, nc
            do k = lo(3), hi(3)+1
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
c     
                     c(i,j,k,n) = factor*(
     $                    + f(2*i  ,2*j  ,2*k,n)
     $                    + f(2*i+1,2*j  ,2*k,n)
     $                    + f(2*i  ,2*j+1,2*k,n)
     $                    + f(2*i+1,2*j+1,2*k,n) )
c                     
                  enddo
               enddo
            enddo
         enddo
      endif
c     
      end
c-----------------------------------------------------------------------
      subroutine FORT_AVERAGECC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc
     $     )
c
      integer nc
      integer DIMDEC(f)
      integer DIMDEC(c)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i
      integer j
      integer k
      integer n
      REAL_T factor
      parameter(factor=0.125d0)
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
c                  
                  c(i,j,k,n) =  factor*(
     $                 + f(2*i+1,2*j+1,2*k  ,n)
     $                 + f(2*i  ,2*j+1,2*k  ,n)
     $                 + f(2*i+1,2*j  ,2*k  ,n)
     $                 + f(2*i  ,2*j  ,2*k  ,n)
     $                 + f(2*i+1,2*j+1,2*k+1,n)
     $                 + f(2*i  ,2*j+1,2*k+1,n)
     $                 + f(2*i+1,2*j  ,2*k+1,n)
     $                 + f(2*i  ,2*j  ,2*k+1,n) )
c                     
               enddo
            enddo
         enddo
      enddo
c     
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: VISCOPERATOR_3D.F,v 1.5 1998/03/31 17:26:41 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "VISCOPERATOR_F.H"
#include "ArrayLim.H"

#define SDIM 3

c :: ----------------------------------------------------------
c :: VISCEXTRAP
c ::             extrapolate viscous terms to ghost zones
c ::
c :: INPUTS / OUTPUTS:
c ::  visc        <=> array containing visc terms
c ::  DIMS(visc)   => index limits for visc
c ::  lo,hi        => index limits for grid interior
c ::  ncomp        => number of components
c :: ----------------------------------------------------------
c ::
       subroutine FORT_VISCEXTRAP (visc,DIMS(visc),lo,hi,ncomp)

       integer DIMDEC(visc)
       integer lo(SDIM), hi(SDIM)
       integer ncomp
       REAL_T  visc(DIMV(visc),ncomp)

       integer i, j, k, n

       do n = 1, ncomp
c         ::::: left side
          i = lo(1)-1
          do k = lo(3), hi(3)
             do j = lo(2), hi(2)
c            visc(i,j,k,n) = two*visc(i+1,j,k,n) - visc(i+2,j,k,n)
                visc(i,j,k,n) = visc(i+1,j,k,n)
             end do
          end do

c         ::::: right side
          i = hi(1)+1
          do k = lo(3), hi(3)
             do j = lo(2), hi(2)
c            visc(i,j,k,n) = two*visc(i-1,j,k,n) - visc(i-2,j,k,n)
                visc(i,j,k,n) = visc(i-1,j,k,n)
             end do
          end do

c         ::::: bottom side
          j = lo(2)-1
          do k = lo(3), hi(3)
             do i = lo(1), hi(1)
c            visc(i,j,k,n) = two*visc(i,j+1,k,n) - visc(i,j+2,k,n)
                visc(i,j,k,n) = visc(i,j+1,k,n)
             end do
          end do

c         ::::: top side
          j = hi(2)+1
          do k = lo(3), hi(3)
             do i = lo(1), hi(1)
c            visc(i,j,k,n) = two*visc(i,j-1,k,n) - visc(i,j-2,k,n)
                visc(i,j,k,n) = visc(i,j-1,k,n)
             end do
          end do

c         ::::: down side
          k = lo(3)-1
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
c            visc(i,j,k,n) = two*visc(i,j,k+1,n) - visc(i,j,k+2,n)
                visc(i,j,k,n) = visc(i,j,k+1,n)
             end do
          end do

c         ::::: up side
          k = hi(3)+1
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
c            visc(i,j,k,n) = two*visc(i,j,k-1,n) - visc(i,j,k-2,n)
                visc(i,j,k,n) = visc(i,j,k-1,n)
             end do
          end do

c         ::::: k-edges
          i = lo(1)-1
          j = lo(2)-1
          do k = lo(3), hi(3)
             visc(i,j,k,n) = visc(i+1,j+1,k,n)
          end do
          
          i = lo(1)-1
          j = hi(2)+1
          do k = lo(3), hi(3)
             visc(i,j,k,n) = visc(i+1,j-1,k,n)
          end do

          i = hi(1)+1
          j = lo(2)-1
          do k = lo(3), hi(3)
             visc(i,j,k,n) = visc(i-1,j+1,k,n)
          end do
          
          i = hi(1)+1
          j = hi(2)+1
          do k = lo(3), hi(3)
             visc(i,j,k,n) = visc(i-1,j-1,k,n)
          end do

c         ::::: j-edges
          i = lo(1)-1
          k = lo(3)-1
          do j = lo(2), hi(2)
             visc(i,j,k,n) = visc(i+1,j,k+1,n)
          end do
          
          i = lo(1)-1
          k = hi(3)+1
          do j = lo(2), hi(2)
             visc(i,j,k,n) = visc(i+1,j,k-1,n)
          end do

          i = hi(1)+1
          k = lo(3)-1
          do j = lo(2), hi(2)
             visc(i,j,k,n) = visc(i-1,j,k+1,n)
          end do
          
          i = hi(1)+1
          k = hi(3)+1
          do j = lo(2), hi(2)
             visc(i,j,k,n) = visc(i-1,j,k-1,n)
          end do

c         ::::: i-edges
          j = lo(2)-1
          k = lo(3)-1
          do i = lo(1), hi(1)
             visc(i,j,k,n) = visc(i,j+1,k+1,n)
          end do
          
          j = lo(2)-1
          k = hi(3)+1
          do i = lo(1), hi(1)
             visc(i,j,k,n) = visc(i,j+1,k-1,n)
          end do

          j = hi(2)+1
          k = lo(3)-1
          do i = lo(1), hi(1)
             visc(i,j,k,n) = visc(i,j-1,k+1,n)
          end do
          
          j = hi(2)+1
          k = hi(3)+1
          do i = lo(1), hi(1)
             visc(i,j,k,n) = visc(i,j-1,k-1,n)
          end do

c         ::::: corners
          i = lo(1)-1
          j = lo(2)-1
          k = lo(3)-1
          visc(i,j,k,n) = visc(i+1,j+1,k+1,n)

          i = lo(1)-1
          j = hi(2)+1
          k = lo(3)-1
          visc(i,j,k,n) = visc(i+1,j-1,k+1,n)

          i = hi(1)+1
          j = hi(2)+1
          k = lo(3)-1
          visc(i,j,k,n) = visc(i-1,j-1,k+1,n)

          i = hi(1)+1
          j = lo(2)-1
          k = lo(3)-1
          visc(i,j,k,n) = visc(i-1,j+1,k+1,n)

          i = lo(1)-1
          j = lo(2)-1
          k = hi(3)+1
          visc(i,j,k,n) = visc(i+1,j+1,k-1,n)

          i = lo(1)-1
          j = hi(2)+1
          k = hi(3)+1
          visc(i,j,k,n) = visc(i+1,j-1,k-1,n)

          i = hi(1)+1
          j = lo(2)-1
          k = hi(3)+1
          visc(i,j,k,n) = visc(i-1,j+1,k-1,n)

          i = hi(1)+1
          j = hi(2)+1
          k = hi(3)+1
          visc(i,j,k,n) = visc(i-1,j-1,k-1,n)

       end do

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c ::: SCCS stuff "@(#)FABUTIL_3D.F	3.1\t6/25/93"

#define   FORT_CINTERP   cinterp3d
#define   FORT_PCINTERP  pcinterp3d
#define   FORT_VCINTERP  vcinterp3d
#define   FORT_CARTGRIDMINMAX  cartgridminmax3d

#include "REAL.H"
#include "CONSTANTS.H"

#define IX_PROJ(A,B) (A+B*iabs(A))/B-iabs(A)


c ::: --------------------------------------------------------------
      subroutine FORT_CARTGRIDMINMAX (data, dlo1, dlo2, dlo3, dhi1, dhi2, dhi3,
     $                                vfracdata, vfeps, dmin, dmax)
      implicit none

      integer dlo1, dlo2, dlo3, dhi1, dhi2, dhi3
      REAL_T data(dlo1:dhi1 ,dlo2:dhi2, dlo3:dhi3)
      REAL_T vfracdata(dlo1:dhi1 ,dlo2:dhi2, dlo3:dhi3)
      REAL_T vfeps, dmin, dmax

      integer i, j, k

      dmax = -bigreal
      dmin = bigreal
      do 410 k = dlo3, dhi3
        do 420 j = dlo2, dhi2
          do 430 i = dlo1, dhi1
              if ( .not. (vfracdata(i,j,k).lt.vfeps)) then
                dmax = max(dmax,data(i,j,k))
                dmin = min(dmin,data(i,j,k))
              endif
430       continue
420     continue
410   continue

      return
      end


c ::: --------------------------------------------------------------
      subroutine FORT_CINTERP (fine,floi1,floi2,floi3,fhii1,fhii2,fhii3,
     $  fblo,fbhi,nvar,lratio, crse,clo,chi,cblo,cbhi,fslo,fshi, cslope,
     $ clen,fslope,fdat,flen,voff)

      integer floi1,floi2,floi3, fhii1,fhii2,fhii3
      integer fblo(3), fbhi(3)
      integer cblo(3), cbhi(3)
      integer fslo(3), fshi(3)
      integer lratio, nvar, clen, flen, clo, chi
      REAL_T fine(floi1 :fhii1 ,floi2 :fhii2 ,floi3 :fhii3, nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 3)
      REAL_T fslope(flen, 3)
      REAL_T fdat(flen)
      REAL_T voff(flen)

c ::: NOTE: data must be sent in so that 
c ::: cslope(1,*) and crse(1,*) are associated with
c ::: the same cell

c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: cinterp:   conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio       =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: and unrolled
c ::: clo,chi      =>  (const)  one dimensional limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c ::: slopes are to be defined. This is
c ::: the projection of (fblo,fbhi) down
c ::: to the coarse level 
c ::: fslo,fshi    =>  (const)  fine grid index limits where
c ::: slopes are needed.  This is the
c ::: refinement of (cslo,cshi) and
c ::: contains but may not be identical
c ::: to (fblo,fbhi).
c ::: cslope       =>  (modify) temp array coarse grid slopes
c ::: clen         =>  (const)  length of coarse gtid slopes
c ::: fslope       =>  (modify) temp array for fine grid slope
c ::: flen         =>  (const)  length of fine grid slope array
c ::: fdat         =>  (const)  temp array for fine grid data
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer k, kc, koff
      integer ist, jst, kst
      REAL_T hafrat, volratio
      REAL_T cen, forw, back, slp
      REAL_T xoff, yoff, zoff
      integer ncbx, ncby, ncbz
      integer ncsx, ncsy, ncsz
      integer islo, jslo, kslo
      integer icc, istart, iend
      integer lenx, leny, lenz, maxlen

      hafrat = half*float(lratio-1)
      volratio = one/float(lratio)

      ncbx = cbhi(1)-cblo(1)+1
      ncby = cbhi(2)-cblo(2)+1
      ncbz = cbhi(3)-cblo(3)+1
      ncsx = ncbx+2
      ncsy = ncby+2
      ncsz = ncbz+2
      ist = 1
      jst = ncsx
      kst = ncsx*ncsy
      islo = cblo(1)-1
      jslo = cblo(2)-1
      kslo = cblo(3)-1
      lenx = fbhi(1)-fblo(1)+1
      leny = fbhi(2)-fblo(2)+1
      lenz = fbhi(3)-fblo(3)+1
      maxlen = max(lenx,leny,lenz)
      if (maxlen .eq. lenx) then
          do 100 i = fblo(1), fbhi(1) 
              fn = i-fslo(1)+1
              ioff = mod(fn-1,lratio)
              voff(fn) = float(ioff)-hafrat
100       continue
      else if (maxlen .eq. leny) then
          do 110 j = fblo(2), fbhi(2) 
              fn = j-fslo(2)+1
              joff = mod(fn-1,lratio)
              voff(fn) = float(joff)-hafrat
110       continue
      else
          do 120 k = fblo(3), fbhi(3) 
              fn = k-fslo(3)+1
              koff = mod(fn-1,lratio)
              voff(fn) = float(koff)-hafrat
120       continue
      end if
      do 130 n = 1, nvar 

c ::: ::::: compute slopes in x direction
          do 140 i = 1, clen 
              cen = half*(crse(i+ist,n)-crse(i-ist,n))
              forw = crse(i+ist,n)-crse(i,n)
              back = crse(i,n)-crse(i-ist,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,1)=cvmgp(slp,zero,forw*back)
140       continue
c ::: ::::: compute slopes in y direction
          do 150 i = 1, clen 
              cen = half*(crse(i+jst,n)-crse(i-jst,n))
              forw = crse(i+jst,n)-crse(i,n)
              back = crse(i,n)-crse(i-jst,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,2)=cvmgp(slp,zero,forw*back)
150       continue
c ::: ::::: compute slopes in z direction
          do 160 i = 1, clen 
              cen = half*(crse(i+kst,n)-crse(i-kst,n))
              forw = crse(i+kst,n)-crse(i,n)
              back = crse(i,n)-crse(i-kst,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,3)=cvmgp(slp,zero,forw*back)
160       continue

          if (maxlen .eq. lenx) then
              do 170 kc = cblo(3), cbhi(3) 
                  do 180 jc = cblo(2), cbhi(2) 

c ::: ..,.......::::: strip out a fine grid slope vector
                      do 190 ioff = 1, lratio 
                          icc = clo + ist + jst*(jc-jslo) + kst*(kc-
     $                    kslo)
                          istart = ioff
                          iend = ioff + (ncbx-1)*lratio
                          do 200 fn = istart, iend, lratio 
                              fslope(fn,1) = cslope(icc,1)
                              fslope(fn,2) = cslope(icc,2)
                              fslope(fn,3) = cslope(icc,3)
                              fdat(fn) = crse(icc,n)
                              icc = icc + ist
200                       continue
190                   continue

                      do 210 koff = 0, lratio-1 
                          k = lratio*kc + koff
                          if (k .lt. fblo(3)) then
                              goto 210
c                             --- next ---
                          end if
                          if (k .gt. fbhi(3)) then
                              goto 211
c                             --- break ---
                          end if
                          zoff = float(koff)-hafrat
                          do 220 joff = 0, lratio-1 
                              j = lratio*jc + joff
                              if (j .lt. fblo(2)) then
                                  goto 220
c                                 --- next ---
                              end if
                              if (j .gt. fbhi(2)) then
                                  goto 221
c                                 --- break ---
                              end if
                              yoff = float(joff)-hafrat

                              do 230 i = fblo(1), fbhi(1) 
                                  fn = i-fslo(1)+1
                                  fine(i,j,k,n) = fdat(fn) + volratio* 
     $                            (voff(fn)*fslope(fn,1)+yoff*fslope(fn,
     $                            2)+ zoff*fslope(fn,3))
230                           continue
220                       continue
221                       continue
210                   continue
211                   continue
180               continue
170           continue
          else if (maxlen .eq. leny) then
              do 240 kc = cblo(3), cbhi(3) 
                  do 250 ic = cblo(1), cbhi(1) 

c ::: ..,.......::::: strip out a fine grid slope vector
                      do 260 joff = 1, lratio 
                          icc = clo + ist*(ic-islo) + jst + kst*(kc-
     $                    kslo)
                          istart = joff
                          iend = joff + (ncby-1)*lratio
                          do 270 fn = istart, iend, lratio 
                              fslope(fn,1) = cslope(icc,1)
                              fslope(fn,2) = cslope(icc,2)
                              fslope(fn,3) = cslope(icc,3)
                              fdat(fn) = crse(icc,n)
                              icc = icc + jst
270                       continue
260                   continue

                      do 280 koff = 0, lratio-1 
                          k = lratio*kc + koff
                          if (k .lt. fblo(3)) then
                              goto 280
c                             --- next ---
                          end if
                          if (k .gt. fbhi(3)) then
                              goto 281
c                             --- break ---
                          end if
                          zoff = float(koff)-hafrat
                          do 290 ioff = 0, lratio-1 
                              i = lratio*ic + ioff
                              if (i .lt. fblo(1)) then
                                  goto 290
c                                 --- next ---
                              end if
                              if (i .gt. fbhi(1)) then
                                  goto 291
c                                 --- break ---
                              end if
                              xoff = float(ioff)-hafrat

                              do 300 j = fblo(2), fbhi(2) 
                                  fn = j-fslo(2)+1
                                  fine(i,j,k,n) = fdat(fn) + volratio* 
     $                            (xoff*fslope(fn,1)+voff(fn)*fslope(fn,
     $                            2)+ zoff*fslope(fn,3))
300                           continue
290                       continue
291                       continue
280                   continue
281                   continue
250               continue
240           continue
          else
              do 310 jc = cblo(2), cbhi(2) 
                  do 320 ic = cblo(1), cbhi(1) 

c ::: ..,.......::::: strip out a fine grid slope vector
                      do 330 koff = 1, lratio 
                          icc = clo + ist*(ic-islo) + jst*(jc-jslo) + 
     $                    kst
                          istart = koff
                          iend = koff + (ncbz-1)*lratio
                          do 340 fn = istart, iend, lratio 
                              fslope(fn,1) = cslope(icc,1)
                              fslope(fn,2) = cslope(icc,2)
                              fslope(fn,3) = cslope(icc,3)
                              fdat(fn) = crse(icc,n)
                              icc = icc + kst
340                       continue
330                   continue

                      do 350 joff = 0, lratio-1 
                          j = lratio*jc + joff
                          if (j .lt. fblo(2)) then
                              goto 350
c                             --- next ---
                          end if
                          if (j .gt. fbhi(2)) then
                              goto 351
c                             --- break ---
                          end if
                          yoff = float(joff)-hafrat
                          do 360 ioff = 0, lratio-1 
                              i = lratio*ic + ioff
                              if (i .lt. fblo(1)) then
                                  goto 360
c                                 --- next ---
                              end if
                              if (i .gt. fbhi(1)) then
                                  goto 361
c                                 --- break ---
                              end if
                              xoff = float(ioff)-hafrat

                              do 370 k = fblo(3), fbhi(3) 
                                  fn = k-fslo(3)+1
                                  fine(i,j,k,n) = fdat(fn) + volratio* 
     $                            (xoff*fslope(fn,1)+yoff*fslope(fn,2)+ 
     $                            voff(fn)*fslope(fn,3))
370                           continue
360                       continue
361                       continue
350                   continue
351                   continue
320               continue
310           continue
          end if
130   continue

      return
      end


c ::: --------------------------------------------------------------
      subroutine FORT_PCINTERP (fine,floi1,floi2,floi3,fhii1,fhii2,fhii3,
     $ fblo, fbhi,lrat,nvar, crse,cloi1,cloi2,cloi3,chii1,chii2,chii3,
     $ cblo, cbhi,temp,tloi,thii)

      integer floi1,floi2,floi3
      integer fhii1,fhii2,fhii3
      integer cloi1,cloi2,cloi3
      integer chii1,chii2,chii3

      integer fblo(3), fbhi(3)
      integer cblo(3), cbhi(3)
      integer lrat, nvar, tloi, thii
      REAL_T fine(floi1 :fhii1 ,floi2 :fhii2 ,floi3 :fhii3, nvar)
      REAL_T crse(cloi1 :chii1 ,cloi2 :chii2 ,cloi3 :chii3, nvar)
      REAL_T temp(tloi:thii + 1)
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: pcinterp:  use piecewise constant interpolation to define
c ::: values on the subregion of the fine FAB defined
c ::: by (fblo,fbhi).
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fab to get interpolated values
c ::: flo,fhi      =>  (const)  index limits of fine
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: crse         =>  (const)  fab holding coarse grid values
c ::: clo,chi      =>  (const)  index limits of src
c ::: cblo,cbhi    =>  (const)  subregion of coarse grid holding values
c ::: temp         =>  (modify) temporary space for vectorization
c ::: tlo,thi      =>  (const)  index limits of temp space
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: local var
      integer i,j,k,ic,jc,kc,ioff,n
      integer ixproj,ii,ll
      ixproj(ii,ll) = (ii + ll*iabs(ii))/ll - iabs(ii)

      do 130 k = fblo(3), fbhi(3) 
          kc = ixproj(k,lrat)
          do 140 j = fblo(2), fbhi(2) 
              jc = ixproj(j,lrat)
              do 150 n = 1, nvar 
                  do 160 ioff = 0, lrat-1 
                      do 170 ic = cblo(1),cbhi(1) 
                          i = lrat*ic + ioff
                          temp(i) = crse(ic,jc,kc,n)
170                   continue
160               continue
                  do 180 i = fblo(1), fbhi(1) 
                      fine(i,j,k,n) = temp(i)
180               continue
150           continue
140       continue
130   continue

      return
      end


c ::: --------------------------------------------------------------
      subroutine FORT_VCINTERP (fine,floi1,floi2,floi3,fhii1,fhii2,
     $ fhii3,fbloi1,fbloi2,fbloi3, fbhii1,fbhii2,fbhii3,nvar,lratio, 
     $ crse,clo,chi,cblo,cbhi, fslo,fshi,cvloi1,cvloi2,cvloi3,cvhii1,
     $ cvhii2,cvhii3, cslope,clen,fslope,fdat,flen,voff, cvc1,fvc1,cvc2,
     $ fvc2,cvc3,fvc3)

      integer floi1,floi2,floi3
      integer fhii1,fhii2,fhii3
      integer fbloi1,fbloi2,fbloi3
      integer fbhii1,fbhii2,fbhii3
      integer cvloi1,cvloi2,cvloi3
      integer cvhii1,cvhii2,cvhii3

      integer cblo(3), cbhi(3)
      integer fslo(3), fshi(3)
      integer lratio, nvar, clen, flen, clo, chi
      REAL_T fine(floi1 :fhii1 ,floi2 :fhii2 ,floi3 :fhii3, nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 3)
      REAL_T fslope(flen, 3)
      REAL_T fdat(flen)
      REAL_T voff(flen)

      REAL_T cvc1(cvloi1 :cvhii1+1)
      REAL_T cvc2(cvloi2 :cvhii2+1)
      REAL_T cvc3(cvloi3 :cvhii3+1)
      REAL_T fvc1(fbloi1 :fbhii1+1)
      REAL_T fvc2(fbloi2 :fbhii2+1)
      REAL_T fvc3(fbloi3 :fbhii3+1)

c ::: NOTE: data must be sent in so that 
c ::: cslope(1,*) and crse(1,*) are associated with
c ::: the same cell

c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: vcinterp:   conservative interpolation in volume coordinates
c ::: from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio       =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: and unrolled
c ::: clo,chi      =>  (const)  one dimensional limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c ::: slopes are to be defined. This is
c ::: the projection of (fblo,fbhi) down
c ::: to the coarse level 
c ::: fslo,fshi    =>  (const)  fine grid index limits where
c ::: slopes are needed.  This is the
c ::: refinement of (cslo,cshi) and
c ::: contains but may not be identical
c ::: to (fblo,fbhi).
c ::: cslope       =>  (modify) temp array coarse grid slopes
c ::: clen         =>  (const)  length of coarse gtid slopes
c ::: fslope       =>  (modify) temp array for fine grid slope
c ::: flen         =>  (const)  length of fine grid slope array
c ::: fdat         =>  (const)  temp array for fine grid data
c ::: cvlo,cvhi    =>  (const)  coarse grid index limits where
c ::: volume coordinates are defined
c ::: cvc1         =>  (const)  coarse grid volume coords, x-dir
c ::: cvc2         =>  (const)  coarse grid volume coords, y_dir
c ::: cvc3         =>  (const)  coarse grid volume coords, z-dir
c ::: fvc1         =>  (const)  fine grid volume coords, x-dir
c ::: fvc2         =>  (const)  fine grid volume coords, y-dir
c ::: fvc3         =>  (const)  fine grid volume coords, z-dir
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer k, kc, koff
      integer ist, jst, kst
      REAL_T cen, forw, back, slp
      REAL_T xoff, yoff, zoff
      REAL_T fcen, ccen
      integer ncbx, ncby, ncbz
      integer ncsx, ncsy, ncsz
      integer islo, jslo, kslo
      integer icc, istart, iend
      integer lenx, leny, lenz, maxlen

      ncbx = cbhi(1)-cblo(1)+1
      ncby = cbhi(2)-cblo(2)+1
      ncbz = cbhi(3)-cblo(3)+1
      ncsx = ncbx+2
      ncsy = ncby+2
      ncsz = ncbz+2
      ist = 1
      jst = ncsx
      kst = ncsx*ncsy
      islo = cblo(1)-1
      jslo = cblo(2)-1
      kslo = cblo(3)-1
      lenx = fbhii1-fbloi1+1
      leny = fbhii2-fbloi2+1
      lenz = fbhii3-fbloi3+1
      maxlen = max(lenx,leny,lenz)
      if (maxlen .eq. lenx) then
          do 380 i = fbloi1, fbhii1 
              fn = i-fslo(1)+1
              ic = IX_PROJ(i,lratio)
              fcen = half*(fvc1(i)+fvc1(i+1))
              ccen = half*(cvc1(ic)+cvc1(ic+1))
              voff(fn) = (fcen-ccen)/(cvc1(ic+1)-cvc1(ic))
380       continue
      else if (maxlen .eq. leny) then
          do 390 j = fbloi2, fbhii2 
              fn = j-fslo(2)+1
              jc = IX_PROJ(j,lratio)
              fcen = half*(fvc2(j)+fvc2(j+1))
              ccen = half*(cvc2(jc)+cvc2(jc+1))
              voff(fn) = (fcen-ccen)/(cvc2(jc+1)-cvc2(jc))
390       continue
      else
          do 400 k = fbloi3, fbhii3 
              fn = k-fslo(3)+1
              kc = IX_PROJ(k,lratio)
              fcen = half*(fvc3(k)+fvc3(k+1))
              ccen = half*(cvc3(kc)+cvc3(kc+1))
              voff(fn) = (fcen-ccen)/(cvc3(kc+1)-cvc3(kc))
400       continue
      end if
      do 410 n = 1, nvar 

c ::: ::::: compute slopes in x direction
          do 420 i = 1, clen 
              cen = half*(crse(i+ist,n)-crse(i-ist,n))
              forw = crse(i+ist,n)-crse(i,n)
              back = crse(i,n)-crse(i-ist,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,1)=cvmgp(slp,zero,forw*back)
420       continue
c ::: ::::: compute slopes in y direction
          do 430 i = 1, clen 
              cen = half*(crse(i+jst,n)-crse(i-jst,n))
              forw = crse(i+jst,n)-crse(i,n)
              back = crse(i,n)-crse(i-jst,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,2)=cvmgp(slp,zero,forw*back)
430       continue
c ::: ::::: compute slopes in z direction
          do 440 i = 1, clen 
              cen = half*(crse(i+kst,n)-crse(i-kst,n))
              forw = crse(i+kst,n)-crse(i,n)
              back = crse(i,n)-crse(i-kst,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,3)=cvmgp(slp,zero,forw*back)
440       continue

          if (maxlen .eq. lenx) then
              do 450 kc = cblo(3), cbhi(3) 
                  do 460 jc = cblo(2), cbhi(2) 

c ::: ..,.......::::: strip out a fine grid slope vector
                      do 470 ioff = 1, lratio 
                          icc = clo + ist + jst*(jc-jslo) + kst*(kc-
     $                    kslo)
                          istart = ioff
                          iend = ioff + (ncbx-1)*lratio
                          do 480 fn = istart, iend, lratio 
                              fslope(fn,1) = cslope(icc,1)
                              fslope(fn,2) = cslope(icc,2)
                              fslope(fn,3) = cslope(icc,3)
                              fdat(fn) = crse(icc,n)
                              icc = icc + ist
480                       continue
470                   continue

                      do 490 koff = 0, lratio-1 
                          k = lratio*kc + koff
                          if (k .lt. fbloi3) then
                              goto 490
c                             --- next ---
                          end if
                          if (k .gt. fbhii3) then
                              goto 491
c                             --- break ---
                          end if
                          fcen = half*(fvc3(k)+fvc3(k+1))
                          ccen = half*(cvc3(kc)+cvc3(kc+1))
                          zoff = (fcen-ccen)/(cvc3(kc+1)-cvc3(kc))
                          do 500 joff = 0, lratio-1 
                              j = lratio*jc + joff
                              if (j .lt. fbloi2) then
                                  goto 500
c                                 --- next ---
                              end if
                              if (j .gt. fbhii2) then
                                  goto 501
c                                 --- break ---
                              end if
                              fcen = half*(fvc2(j)+fvc2(j+1))
                              ccen = half*(cvc2(jc)+cvc2(jc+1))
                              yoff = (fcen-ccen)/(cvc2(jc+1)-cvc2(jc))

                              do 510 i = fbloi1, fbhii1 
                                  fn = i-fslo(1)+1
                                  fine(i,j,k,n) = fdat(fn) + voff(fn)*
     $                            fslope(fn,1)+yoff*fslope(fn,2)+ zoff*
     $                            fslope(fn,3)
510                           continue
500                       continue
501                       continue
490                   continue
491                   continue
460               continue
450           continue
          else if (maxlen .eq. leny) then
              do 520 kc = cblo(3), cbhi(3) 
                  do 530 ic = cblo(1), cbhi(1) 

c ::: ..,.......::::: strip out a fine grid slope vector
                      do 540 joff = 1, lratio 
                          icc = clo + ist*(ic-islo) + jst + kst*(kc-
     $                    kslo)
                          istart = joff
                          iend = joff + (ncby-1)*lratio
                          do 550 fn = istart, iend, lratio 
                              fslope(fn,1) = cslope(icc,1)
                              fslope(fn,2) = cslope(icc,2)
                              fslope(fn,3) = cslope(icc,3)
                              fdat(fn) = crse(icc,n)
                              icc = icc + jst
550                       continue
540                   continue

                      do 560 koff = 0, lratio-1 
                          k = lratio*kc + koff
                          if (k .lt. fbloi3) then
                              goto 560
c                             --- next ---
                          end if
                          if (k .gt. fbhii3) then
                              goto 561
c                             --- break ---
                          end if
                          fcen = half*(fvc3(k)+fvc3(k+1))
                          ccen = half*(cvc3(kc)+cvc3(kc+1))
                          zoff = (fcen-ccen)/(cvc3(kc+1)-cvc3(kc))
                          do 570 ioff = 0, lratio-1 
                              i = lratio*ic + ioff
                              if (i .lt. fbloi1) then
                                  goto 570
c                                 --- next ---
                              end if
                              if (i .gt. fbhii1) then
                                  goto 571
c                                 --- break ---
                              end if
                              fcen = half*(fvc1(i)+fvc1(i+1))
                              ccen = half*(cvc1(ic)+cvc1(ic+1))
                              xoff = (fcen-ccen)/(cvc1(ic+1)-cvc1(ic))

                              do 580 j = fbloi2, fbhii2 
                                  fn = j-fslo(2)+1
                                  fine(i,j,k,n) = fdat(fn) + xoff*
     $                            fslope(fn,1)+voff(fn)*fslope(fn,2)+ 
     $                            zoff*fslope(fn,3)
580                           continue
570                       continue
571                       continue
560                   continue
561                   continue
530               continue
520           continue
          else
              do 590 jc = cblo(2), cbhi(2) 
                  do 600 ic = cblo(1), cbhi(1) 

c ::: ..,.......::::: strip out a fine grid slope vector
                      do 610 koff = 1, lratio 
                          icc = clo + ist*(ic-islo) + jst*(jc-jslo) + 
     $                    kst
                          istart = koff
                          iend = koff + (ncbz-1)*lratio
                          do 620 fn = istart, iend, lratio 
                              fslope(fn,1) = cslope(icc,1)
                              fslope(fn,2) = cslope(icc,2)
                              fslope(fn,3) = cslope(icc,3)
                              fdat(fn) = crse(icc,n)
                              icc = icc + kst
620                       continue
610                   continue

                      do 630 joff = 0, lratio-1 
                          j = lratio*jc + joff
                          if (j .lt. fbloi2) then
                              goto 630
c                             --- next ---
                          end if
                          if (j .gt. fbhii2) then
                              goto 631
c                             --- break ---
                          end if
                          fcen = half*(fvc2(j)+fvc2(j+1))
                          ccen = half*(cvc2(jc)+cvc2(jc+1))
                          yoff = (fcen-ccen)/(cvc2(jc+1)-cvc2(jc))
                          do 640 ioff = 0, lratio-1 
                              i = lratio*ic + ioff
                              if (i .lt. fbloi1) then
                                  goto 640
c                                 --- next ---
                              end if
                              if (i .gt. fbhii1) then
                                  goto 641
c                                 --- break ---
                              end if
                              fcen = half*(fvc1(i)+fvc1(i+1))
                              ccen = half*(cvc1(ic)+cvc1(ic+1))
                              xoff = (fcen-ccen)/(cvc1(ic+1)-cvc1(ic))

                              do 650 k = fbloi3, fbhii3 
                                  fn = k-fslo(3)+1
                                  fine(i,j,k,n) = fdat(fn) + xoff*
     $                            fslope(fn,1)+yoff*fslope(fn,2)+ 
     $                            voff(fn)*fslope(fn,3)
650                           continue
640                       continue
641                       continue
630                   continue
631                   continue
600               continue
590           continue
          end if
410   continue

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c     $Id: MCLO_2D.F,v 1.2 1998/11/17 19:11:09 lijewski Exp $
c
#include <REAL.H>
#include <LO_BCTYPES.H>
#include <MCLO_F.H>
#include <ArrayLim.H>

c-----------------------------------------------------------------------
      subroutine FORT_RESIDL (
     $     res, DIMS(res), 
     $     rhs, DIMS(rhs),
     $     phi, DIMS(phi),
     $     lo, hi, nc
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(phi)
      REAL_T phi(DIMV(phi),nc)
      integer DIMDEC(rhs)
      REAL_T rhs(DIMV(rhs),nc)
      integer DIMDEC(res)
      REAL_T res(DIMV(res),nc)
c
      integer i
      integer j
      integer n
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               res(i,j,n) = rhs(i,j,n) - phi(i,j,n)
            enddo
         enddo
      enddo
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_HARMONIC_AVERAGEEC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc,
     $     cdir
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer cdir
      integer DIMDEC(f)
      REAL_T f(DIMV(f),nc)
      integer DIMDEC(c)
      REAL_T c(DIMV(c),nc)
c
      REAL_T factor, den
      parameter(factor=2.00)
      integer n
      integer i
      integer j
c
      if ( cdir .eq. 0 ) then
         do n = 1, nc
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)+1
                  den = f(2*i,2*j,n) + f(2*i,2*j+1,n)
                  if (den .ne. 0.0) then
                    c(i,j,n) =  factor*f(2*i,2*j,n)*f(2*i,2*j+1,n)/den
                  else
                    c(i,j,n) =  0.0
                  endif
               enddo
            enddo
         enddo
      else if (cdir .eq. 1 ) then
         do n = 1, nc
            do j = lo(2), hi(2)+1
               do i = lo(1), hi(1)
                  den = f(2*i,2*j,n) + f(2*i+1,2*j,n)
                  if (den .ne. 0.0) then
                    c(i,j,n) =  factor*f(2*i,2*j,n)*f(2*i+1,2*j,n)/den
                  else
                    c(i,j,n) =  0.0
                  endif
               enddo
            enddo
         enddo
      endif
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_AVERAGEEC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc,
     $     cdir
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer cdir
      integer DIMDEC(f)
      REAL_T f(DIMV(f),nc)
      integer DIMDEC(c)
      REAL_T c(DIMV(c),nc)
c
      integer n
      integer i
      integer j
      REAL_T denom
      parameter(denom=0.50d0)
c
      if (cdir .eq. 0 ) then
         do n = 1, nc
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)+1
                  c(i,j,n) = (f(2*i,2*j,n) + f(2*i,2*j+1,n))*denom
               enddo
            enddo
         enddo
      else if (cdir .eq. 1) then
         do n = 1, nc
            do j = lo(2), hi(2)+1
               do i = lo(1), hi(1)
                  c(i,j,n) = (f(2*i,2*j,n) + f(2*i+1,2*j,n))*denom
               enddo
            enddo
         enddo
      endif
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_AVERAGECC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc
     $     )
c
      integer nc
      integer DIMDEC(f)
      integer DIMDEC(c)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i
      integer j
      integer n
      REAL_T denom
      parameter(denom=0.25d0)
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               c(i,j,n) =  (
     $              f(2*i+1,2*j+1,n) + f(2*i  ,2*j+1,n)
     $              + f(2*i+1,2*j  ,n) + f(2*i  ,2*j  ,n))*denom
            enddo
         enddo
      enddo
c
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "MACPROJ_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2
#define CDIMS loc_1,loc_2,hic_1,hic_2

c *************************************************************************
c ** INITSIGMA **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIGMA(sigmax,sigmay,rho,r,rhalf,DIMS,
     $                          bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer DIMS
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T    rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      r(lo_1-1:hi_1+1)
      REAL_T  rhalf(lo_1:hi_1+2)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi

c     Local variables
      integer i,j

      do j = lo_2,hi_2 
        do i = lo_1+1,hi_1 
          sigmax(i,j) = two * rhalf(i) /
     $                  (rho(i,j) + rho(i-1,j))
        enddo

        if (bcx_lo .eq. PERIODIC) then
          sigmax(lo_1,j) = two * rhalf(lo_1) /
     $                     (rho(lo_1,j) + rho(hi_1,j))
        else if (bcx_lo .eq. WALL) then
          sigmax(lo_1,j) = rhalf(lo_1) / rho(lo_1,j)
        else if (bcx_lo .eq. INLET) then
          sigmax(lo_1,j) = rhalf(lo_1) / rho(lo_1-1,j)
        else if (bcx_lo .eq. OUTLET) then
          sigmax(lo_1,j) = rhalf(lo_1) / rho(lo_1,j)
        endif

        if (bcx_hi .eq. PERIODIC) then
          sigmax(hi_1+1,j) = sigmax(lo_1,j)
        else if (bcx_hi .eq. WALL) then
          sigmax(hi_1+1,j) = rhalf(hi_1+1) / rho(hi_1,j)
        else if (bcx_hi .eq. INLET) then
          sigmax(hi_1+1,j) = rhalf(hi_1+1) / rho(hi_1+1,j)
        else if (bcx_hi .eq. OUTLET) then
          sigmax(hi_1+1,j) = rhalf(hi_1+1) / rho(hi_1,j)
        endif
      enddo

      do i = lo_1,hi_1 
        do j = lo_2+1,hi_2 
          sigmay(i,j) = two * r(i) /
     $                  (rho(i,j) + rho(i,j-1))
        enddo

        if (bcy_lo .eq. PERIODIC) then
          sigmay(i,lo_2) = two * r(i) /
     $                     (rho(i,lo_2) + rho(i,hi_2))
        else if (bcy_lo .eq. WALL) then
          sigmay(i,lo_2) = r(i) / rho(i,lo_2)
        else if (bcy_lo .eq. INLET) then
          sigmay(i,lo_2) = r(i) / rho(i,lo_2-1)
        else if (bcy_lo .eq. OUTLET) then
          sigmay(i,lo_2) = r(i) / rho(i,lo_2)
        endif

        if (bcy_hi .eq. PERIODIC) then
          sigmay(i,hi_2+1) = sigmay(i,lo_2)
        else if (bcy_hi .eq. WALL) then
          sigmay(i,hi_2+1) = r(i) / rho(i,hi_2)
        else if (bcy_hi .eq. INLET) then
          sigmay(i,hi_2+1) = r(i) / rho(i,hi_2+1)
        else if (bcy_hi .eq. OUTLET) then
          sigmay(i,hi_2+1) = r(i) / rho(i,hi_2)
        endif
      enddo

      return
      end

c *************************************************************************
c ** GRADMAC **
c ** Compute the gradient of phi
c *************************************************************************

      subroutine FORT_GRADMAC(gradpx,gradpy,phi,DIMS,hx,hy,bcx_lo,bcx_hi,
     $                        bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T    phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T gradpx(lo_1:hi_1+1,lo_2:hi_2  )
      REAL_T gradpy(lo_1:hi_1  ,lo_2:hi_2+1)
      REAL_T hx
      REAL_T hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      integer i, is, ie, j, js, je

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      do j = js,je 
        do i = is,ie+1
          gradpx(i,j) = (phi(i,j) - phi(i-1,j))/hx
        enddo

        if (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) then
          gradpx(is  ,j) = zero
        endif
        if (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) then
          gradpx(ie+1,j) = zero
        endif

      enddo

      do i = is,ie 
        do j = js,je+1 
          gradpy(i,j) = (phi(i,j) - phi(i,j-1))/hy
        enddo

        if (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) then
          gradpy(i,js  ) = zero
        endif
        if (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) then
          gradpy(i,je+1) = zero
        endif

      enddo

      return
      end

c *************************************************************************
c ** PROJUMAC **
c ** Update the edge-based velocities
c *************************************************************************

      subroutine FORT_PROJUMAC(uadv,vadv,gradpx,gradpy,rho,DIMS)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T   uadv(lo_1  :hi_1+1,lo_2:hi_2  )
      REAL_T   vadv(lo_1  :hi_1  ,lo_2:hi_2+1)
      REAL_T gradpx(lo_1  :hi_1+1,lo_2:hi_2  )
      REAL_T gradpy(lo_1  :hi_1  ,lo_2:hi_2+1)
      REAL_T    rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)

c     Local variables
      REAL_T  rhx,rhy
      integer i,j

      do j = lo_2,hi_2
        do i = lo_1,hi_1+1

          rhx = two / (rho(i,j) + rho(i-1,j))
          uadv(i,j) = uadv(i,j) - gradpx(i,j) * rhx

        enddo
      enddo

      do j = lo_2,hi_2+1 
        do i = lo_1,hi_1 

          rhy = two / (rho(i,j) + rho(i,j-1))
          vadv(i,j) = vadv(i,j) - gradpy(i,j) * rhy

        enddo
      enddo


      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D( sig G(phi) )
c *************************************************************************

      subroutine FORT_RESIDUAL(resid,phi,f,sigmax,sigmay,r,DIMS,
     $                         hx,hy,resnorm,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T  resid(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T    phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T      r(lo_1-1:hi_1+1)
      REAL_T hx
      REAL_T hy
      REAL_T resnorm
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      REAL_T hxsqinv, hysqinv
      REAL_T rfac, corr
      integer i,j

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      resnorm = zero

      call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 

          rfac = ( sigmax(i+1,j) + sigmax(i,j))*hxsqinv + 
     $           ( sigmay(i,j+1) + sigmay(i,j))*hysqinv
          corr = 
     $      ( sigmax(i+1,j)*phi(i+1,j) + sigmax(i,j)*phi(i-1,j))*hxsqinv + 
     $      ( sigmay(i,j+1)*phi(i,j+1) + sigmay(i,j)*phi(i,j-1))*hysqinv

          resid(i,j) = f(i,j) - (corr - rfac*phi(i,j))

          resnorm = max(abs(resid(i,j))/r(i), resnorm)

        enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRB **
c ** Gauss-Seidel red-black or line solve relaxation (depending on hy/hx)
c *************************************************************************

      subroutine FORT_GSRB(phi,f,sigmax,sigmay,DIMS,hx,hy,
     $                     bcx_lo,bcx_hi,bcy_lo,bcy_hi,nngsrb)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T    phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T hx
      REAL_T hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi
      integer nngsrb

c     Local variables
      REAL_T hxsq, hysq, rfac, corr
      integer i, j, ioff, iinc
      integer iter

c     Additional temporaries for the line solve
      REAL_T a_ls(0:4096)
      REAL_T b_ls(0:4096)
      REAL_T c_ls(0:4096)
      REAL_T r_ls(0:4096)
      REAL_T u_ls(0:4096)
      REAL_T cf0, cf1, cf2, cf3
      REAL_T delta

      integer do_line
      integer ilen,jlen

      if (hy. gt. 1.5*hx) then
        do_line = 1
        ilen = hi_1-lo_1+1
        if (ilen .gt. 4096) then
          print *,'TOO BIG FOR LINE SOLVE IN GSRB: ilen = ',ilen
          stop
        endif
      else if (hx .gt. 1.5*hy) then
        do_line = 2
        jlen = hi_2-lo_2+1
        if (jlen .gt. 4096) then
          print *,'TOO BIG FOR LINE SOLVE IN GSRB: jlen = ',jlen
          stop
        endif
      else
        do_line = 0
      endif

      hxsq = hx*hx
      hysq = hy*hy

      call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      do iter = 1, nngsrb 

c   Standard Gauss-Seidel relaxation with red-black ordering
        if (do_line .eq. 0) then
         do ioff = 0,1 
          do j = lo_2,hi_2 
            iinc = mod(j+ioff,2)
            do i = lo_1+iinc,hi_1,2 

              rfac = (sigmax(i+1,j) + sigmax(i,j))/hxsq + 
     $               (sigmay(i,j+1) + sigmay(i,j))/hysq

              corr = 
     $        ( sigmax(i+1,j)*phi(i+1,j) + sigmax(i,j)*phi(i-1,j))/hxsq +
     $        ( sigmay(i,j+1)*phi(i,j+1) + sigmay(i,j)*phi(i,j-1))/hysq

              phi(i,j) = (corr - f(i,j))/rfac

            enddo
          enddo

          call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

         enddo

c   Line solve in the horizontal direction
        elseif (do_line .eq. 1) then

         do ioff = 0,1 
          do j = lo_2+ioff,hi_2,2 

            cf1 = cvmgt(one, zero, (j .eq. lo_2) .and. 
     $                  (bcy_lo .eq. WALL .or. bcy_lo.eq. INLET))
            cf1 = cvmgt(-one, cf1, (j .eq. lo_2) .and. bcy_lo .eq. OUTLET)

            cf3 = cvmgt(one, zero, (j .eq. hi_2) .and. 
     $                  (bcy_hi .eq. WALL .or. bcy_hi.eq. INLET))
            cf3 = cvmgt(-one, cf3, (j .eq. hi_2) .and. bcy_hi .eq. OUTLET)

            do i = lo_1,hi_1
              a_ls(i-lo_1) = sigmax(i,j) / hxsq

              cf0 = cvmgt(one, zero, (i .eq. lo_1) .and. 
     $                    (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET))
              cf0 = cvmgt(-one, cf0, (i .eq. lo_1) .and. bcx_lo .eq. OUTLET)

              cf2 = cvmgt(one, zero, (i .eq. hi_1) .and. 
     $                    (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET))
              cf2 = cvmgt(-one, cf2, (i .eq. hi_1) .and. bcx_hi .eq. OUTLET)

              delta = (sigmax(i,j)*cf0 + sigmax(i+1,j)*cf2) / hxsq
     $              + (sigmay(i,j)*cf1 + sigmay(i,j+1)*cf3) / hysq
              b_ls(i-lo_1) = -(sigmax(i+1,j) + sigmax(i,j)) / hxsq
     $                       -(sigmay(i,j+1) + sigmay(i,j)) / hysq
              c_ls(i-lo_1) = sigmax(i+1,j) / hxsq
              r_ls(i-lo_1) = f(i,j) -
     $           (sigmay(i,j)*phi(i,j-1) + sigmay(i,j+1)*phi(i,j+1)) / hysq
            enddo

            call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,ilen)

            do i = lo_1,hi_1
              phi(i,j) = u_ls(i-lo_1)
            enddo

          enddo

         call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

         enddo


c   Line solve in the vertical direction
        elseif (do_line .eq. 2) then

         do ioff = 0,1 
          do i = lo_1+ioff,hi_1,2 

            cf0 = cvmgt(one, zero, (i .eq. lo_1) .and. 
     $                  (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET))
            cf0 = cvmgt(-one, cf0, (i .eq. lo_1) .and. bcx_lo .eq. OUTLET)

            cf2 = cvmgt(one, zero, (i .eq. hi_1) .and. 
     $                  (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET))
            cf2 = cvmgt(-one, cf2, (i .eq. hi_1) .and. bcx_hi .eq. OUTLET)

            do j = lo_2,hi_2
              a_ls(j-lo_2) = sigmay(i,j) / hysq
              cf1 = cvmgt(one, zero, (j .eq. lo_2) .and. 
     $                    (bcy_lo .eq. WALL .or. bcy_lo.eq. INLET))
              cf1 = cvmgt(-one, cf1, (j .eq. lo_2) .and. bcy_lo .eq. OUTLET)

              cf3 = cvmgt(one, zero, (j .eq. hi_2) .and. 
     $                    (bcy_hi .eq. WALL .or. bcy_hi.eq. INLET))
              cf3 = cvmgt(-one, cf3, (j .eq. hi_2) .and. bcy_hi .eq. OUTLET)
              delta = (sigmax(i,j)*cf0 + sigmax(i+1,j)*cf2) / hxsq
     $              + (sigmay(i,j)*cf1 + sigmay(i,j+1)*cf3) / hysq
              b_ls(j-lo_2) = -(sigmax(i+1,j) + sigmax(i,j)) / hxsq
     $                       -(sigmay(i,j+1) + sigmay(i,j)) / hysq + delta
              c_ls(j-lo_2) = sigmay(i,j+1) / hysq
              r_ls(j-lo_2) = f(i,j) -
     $           (sigmax(i,j)*phi(i-1,j) + sigmax(i+1,j)*phi(i+1,j)) / hxsq
            enddo

            call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,jlen)

            do j = lo_2,hi_2
              phi(i,j) = u_ls(j-lo_2)
            enddo

          enddo

         call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

         enddo

       endif

      enddo

      return
      end


c *************************************************************************
c ** BC **
c ** Impose boundary conditions
c *************************************************************************

      subroutine bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T  phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi

c     Local variables
      integer i, j, is, ie, js, je

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (bcy_lo .eq. OUTLET) then
        do i = is,ie 
          phi(i,js-1) = -phi(i,js)
        enddo
      elseif (bcy_lo .eq. INLET .or. bcy_lo .eq. WALL) then
        do i = is-1,ie+1 
          phi(i,js-1) =  phi(i,js)
        enddo
      elseif (bcy_lo .eq. PERIODIC) then
        do i = is,ie 
          phi(i,js-1) = phi(i,je)
        enddo
      endif

      if (bcy_hi .eq. OUTLET) then
        do i = is,ie 
          phi(i,je+1) = -phi(i,je)
        enddo
      elseif (bcy_hi .eq. INLET .or. bcy_hi .eq. WALL) then
        do i = is-1,ie+1 
          phi(i,je+1) = phi(i,je)
        enddo
      elseif (bcy_hi .eq. PERIODIC) then
        do i = is,ie 
          phi(i,je+1) = phi(i,js)
        enddo
      endif

      if (bcx_lo .eq. OUTLET) then
        do j = js,je 
          phi(is-1,j) = -phi(is,j)
        enddo
      elseif (bcx_lo .eq. INLET .or. bcx_lo .eq. WALL) then
        do j = js-1,je+1 
          phi(is-1,j) =  phi(is,j)
        enddo
      elseif (bcx_lo .eq. PERIODIC) then
        do j = js,je 
          phi(is-1,j) = phi(ie,j)
        enddo
      endif

      if (bcx_hi .eq. OUTLET) then
        do j = js,je 
          phi(ie+1,j) = -phi(ie,j)
        enddo
      elseif (bcx_hi .eq. INLET .or. bcx_hi .eq. WALL) then
        do j = js-1,je+1 
          phi(ie+1,j) = phi(ie,j)
        enddo
      elseif (bcx_hi .eq. PERIODIC) then
        do j = js,je 
          phi(ie+1,j) = phi(is,j)
        enddo
      endif

      return
      end

c *************************************************************************
c ** RHSMAC **
c ** Compute the right-hand-side D(U) for the MAC projection
c *************************************************************************

      subroutine FORT_RHSMAC(uadv,vadv,divu_src,rhs,
     $                       DIMS,hx,hy,r,rhalf,rhsnorm)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T     uadv(lo_1  :hi_1+1,lo_2:hi_2  )
      REAL_T     vadv(lo_1  :hi_1  ,lo_2:hi_2+1)
      REAL_T divu_src(lo_1  :hi_1  ,lo_2:hi_2)
      REAL_T      rhs(lo_1  :hi_1  ,lo_2:hi_2)
      REAL_T        r(lo_1-1:hi_1+1)
      REAL_T    rhalf(lo_1:hi_1+2)
      REAL_T  hx
      REAL_T  hy
      REAL_T  rhsnorm

c     Local variables
      integer i,j

      rhsnorm = zero

      do j = lo_2,hi_2
        do i = lo_1,hi_1

          rhs(i,j) = (rhalf(i+1)*uadv(i+1,j) - 
     $                rhalf(i  )*uadv(i  ,j))/hx + 
     $            r(i  )*(vadv(i,j+1) - vadv(i,j))/hy

          rhs(i,j) = rhs(i,j) - r(i)*divu_src(i,j)

          rhsnorm = max(rhsnorm,abs(rhs(i,j))/r(i))

        enddo
      enddo

      return
      end

c *************************************************************************
c ** COARSIGMA **
c ** Coarsen the edge-based sigma coefficients
c *************************************************************************

      subroutine FORT_COARSIGMA(sigmax,sigmay,sigmaxc,sigmayc,DIMS,CDIMS)

      implicit none
      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      REAL_T  sigmax(lo_1 :hi_1 +1,lo_2 :hi_2   )
      REAL_T  sigmay(lo_1 :hi_1   ,lo_2 :hi_2 +1)
      REAL_T sigmaxc(loc_1:hic_1+1,loc_2:hic_2  )
      REAL_T sigmayc(loc_1:hic_1  ,loc_2:hic_2+1)

c     Local variables
      integer i,j,twoi,twoj

      do j = loc_2,hic_2 
        do i = loc_1,hic_1+1 
          twoi = 2*(i-loc_1)+lo_1
          twoj = 2*(j-loc_2)+lo_2
          sigmaxc(i,j) = half*(sigmax(twoi,twoj) + sigmax(twoi,twoj+1))
        enddo
      enddo

      do j = loc_2,hic_2+1 
        do i = loc_1,hic_1 
          twoi = 2*(i-loc_1)+lo_1
          twoj = 2*(j-loc_2)+lo_2
          sigmayc(i,j) = half*(sigmay(twoi,twoj) + sigmay(twoi+1,twoj))
        enddo
      enddo


      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservatively average the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS)

      implicit none
      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      REAL_T  res(lo_1 :hi_1 ,lo_2 :hi_2)
      REAL_T resc(loc_1:hic_1,loc_2:hic_2)

c     Local variables
      integer i,j,twoi,twoj

c ::: NOTE: dont need factor of r here for volume-weighting because
c ::: what were calling the residual is really already r*residual

      do j = loc_2,hic_2 
        do i = loc_1,hic_1 
          twoi = 2*(i-loc_1)+lo_1
          twoj = 2*(j-loc_2)+lo_2
          resc(i,j) = ((res(twoi  ,twoj) + res(twoi  ,twoj+1)) + 
     $                 (res(twoi+1,twoj) + res(twoi+1,twoj+1)))*fourth
        enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise constant interpolation
c *************************************************************************

      subroutine FORT_INTERPOLATE(phi,deltac,DIMS,CDIMS)

      implicit none
      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      REAL_T    phi(lo_1 -1:hi_1 +1,lo_2 -1:hi_2 +1)
      REAL_T deltac(loc_1-1:hic_1+1,loc_2-1:hic_2+1)

c     Local variables
      integer i,j,twoi,twoj

      do j = loc_2, hic_2 
        do i = loc_1, hic_1 

          twoi = 2*(i-loc_1)+lo_1
          twoj = 2*(j-loc_2)+lo_2
          phi(twoi  ,twoj  ) = phi(twoi  ,twoj  ) + deltac(i,j)
          phi(twoi+1,twoj  ) = phi(twoi+1,twoj  ) + deltac(i,j)
          phi(twoi  ,twoj+1) = phi(twoi  ,twoj+1) + deltac(i,j)
          phi(twoi+1,twoj+1) = phi(twoi+1,twoj+1) + deltac(i,j)

        enddo
      enddo

      return
      end

c *************************************************************************
c ** SOLVEMAC **
c ** Conjugate gradient bottom-solver
c *************************************************************************

      subroutine FORT_SOLVEMAC(dest, dest0, source, sigmax, sigmay, sum, 
     $                         r, w, z, work, x, DIMS, hx, hy, 
     $                         bcx_lo, bcx_hi, bcy_lo, bcy_hi, norm, prob_norm)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T   dest(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  dest0(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T source(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T    sum(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T      r(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T      w(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T      z(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T   work(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T      x(lo_1-1:hi_1+1)
      REAL_T hx
      REAL_T hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi
      REAL_T norm
      REAL_T prob_norm

c     Local variables
      integer i,j,iter,is,ie,js,je
      REAL_T alpha, beta, rho, rhol
      REAL_T  tol,tolfac
      REAL_T local_norm
      REAL_T hxsqinv
      REAL_T hysqinv
 
      tolfac = 1.0d-3

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      call bc(dest,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      do j = js-1,je+1 
        do i = is-1,ie+1 
          dest0(i,j) = dest(i,j)
           dest(i,j) = zero
        enddo
      enddo

  10  do j = js,je 
        do i = is,ie 
          w(i,j) = 
     $     ( sigmax(i+1,j)*dest0(i+1,j) + 
     $       sigmax(i  ,j)*dest0(i-1,j) )*hxsqinv + 
     $     ( sigmay(i,j+1)*dest0(i,j+1) + 
     $       sigmay(i,j  )*dest0(i,j-1) )*hysqinv - 
     $    ( (sigmax(i+1,j) + sigmax(i,j))*hxsqinv + 
     $      (sigmay(i,j+1) + sigmay(i,j))*hysqinv )*dest0(i,j)
        enddo
      enddo

      rho = zero
      norm = zero

      do j = js, je 
        do i = is, ie 
          r(i,j) = source(i,j) - w(i,j)
        enddo
      enddo

      local_norm = zero
      do j = js, je 
        do i = is, ie 
          z(i,j) = r(i,j) 
          rho = rho + z(i,j) * r(i,j)
          local_norm = max(local_norm,abs(r(i,j)))
          norm       = max(norm      ,abs(r(i,j)/x(i)))
        enddo
      enddo

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do j = js, je 
        do i = is, ie 
          work(i,j) = zero
          dest(i,j) = z(i,j)
        enddo
      enddo

      iter = 0

c     write(6,1000) iter, norm/prob_norm

100   call bc(dest,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      do j = js,je 
        do i = is,ie 
          w(i,j) = 
     $     ( sigmax(i+1,j)*dest(i+1,j) + 
     $       sigmax(i,j)*dest(i-1,j) )*hxsqinv + 
     $     ( sigmay(i,j+1)*dest(i,j+1) + 
     $       sigmay(i,j)*dest(i,j-1) )*hysqinv - 
     $    ( (sigmax(i+1,j) + sigmax(i,j))*hxsqinv + 
     $      (sigmay(i,j+1) + sigmay(i,j))*hysqinv )*dest(i,j)
        enddo
      enddo


      alpha = zero
      do j = js, je 
        do i = is, ie 
          alpha = alpha + dest(i,j)*w(i,j)
        enddo
      enddo

      alpha = rho / alpha
      rhol = rho
      rho = zero
      norm = zero
      do j = js, je 
        do i = is, ie 
          work(i,j) = work(i,j) + alpha * dest(i,j)
          r(i,j) = r(i,j) - alpha * w(i,j)
          z(i,j) = r(i,j) 
          rho = rho + z(i,j) * r(i,j)
          norm = max(norm,abs(r(i,j)/x(i)))
        enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then
         
         do j = js, je 
            do i = is, ie 
               dest(i,j) = work(i,j) + dest0(i,j)
            enddo
         enddo

         call bc(dest,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)
         
      else if (iter .ge. 100  .or.  norm .ge. 100.d0*local_norm) then

         tolfac = 10.d0 * tolfac
         iter = 1
         do j = js, je 
            do i = is, ie 
               dest(i,j) = zero
            enddo
         enddo
         goto 10

      else

        beta = rho / rhol
        do j = js, je 
          do i = is, ie 
            dest(i,j) = z(i,j) + beta * dest(i,j)
          enddo
        enddo
        goto 100
      endif

c      call flush(6)

1000  format('Res/Res0 in solve: ',i4,2x,e12.5)
c      call flush(6)

      return
      end

c *************************************************************************
c ** MKSUMMAC **
c ** Pre-compute the sum of coefficients for the conjugate gradient solver
c *************************************************************************

      subroutine FORT_MKSUMMAC(sigmax,sigmay,sum,DIMS,hx,hy,
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T    sum(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T hx
      REAL_T hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      REAL_T  hxsqinv
      REAL_T  hysqinv
      integer i,j

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      do j = lo_2,hi_2
        do i = lo_1,hi_1
          sum(i,j) = (sigmax(i+1,j) + sigmax(i,j))*hxsqinv +
     $               (sigmay(i,j+1) + sigmay(i,j))*hysqinv
          sum(i,j) = -fourth*sum(i,j)
        enddo
      enddo

      return
      end



c *************************************************************************
c ** TRIDIAG **
c ** Do a tridiagonal solve 
c *************************************************************************

      subroutine tridiag(a,b,c,r,u,n)

      integer n
      integer nmax

      REAL_T a(n)
      REAL_T b(n)
      REAL_T c(n)
      REAL_T r(n)
      REAL_T u(n)

      parameter (nmax = 4098)

      integer j
      REAL_T bet
      REAL_T gam(nmax)
      if (b(1) .eq. 0) print *,'CANT HAVE B(1) = ZERO'

      bet = b(1)
      u(1) = r(1)/bet

      do j = 2,n
        gam(j) = c(j-1)/bet
        bet = b(j) - a(j)*gam(j)
        if (bet .eq. 0) then
          print *,'TRIDIAG FAILED '
          stop
        endif
        u(j) = (r(j)-a(j)*u(j-1))/bet
      enddo

      do j = n-1,1,-1
        u(j) = u(j) - gam(j+1)*u(j+1)
      enddo

      return
      end

c
c $Id: BLParmParse_F.f,v 1.7 2003/01/03 19:25:11 car Exp $
c
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_new(ipp, str)
      INTEGER ipp
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_new_cpp(ipp, istr, NSTR)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_record_new(ipp, ippr, str)
      INTEGER ipp, ippr
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_record_new_cpp(ipp, ippr, istr, NSTR)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_int(ierr, ipp, str, ival)
      INTEGER ierr, ipp
      INTEGER ival
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_int_cpp(ierr, ipp, istr, NSTR, ival)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_int_n(ierr, ipp, str, ival, nval)
      INTEGER ierr, ipp, nval
      INTEGER ival(*)
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_int_n_cpp(ierr, ipp, istr, NSTR, ival, nval)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_logical(ierr, ipp, str, lval)
      INTEGER ierr, ipp
      LOGICAL lval
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
      INTEGER ival
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_logical_cpp(ierr, ipp, istr, NSTR, ival)
      IF ( IERR .NE. 0 ) THEN
          IF ( ival .NE. 0 ) THEN
              lval = .TRUE.
          ELSE
              lval = .FALSE.
          END IF
      END IF
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_real(ierr, ipp, str, rval)
      INTEGER ierr, ipp
      REAL rval
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_real_cpp(ierr, ipp, istr, NSTR, rval)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_real_n(ierr, ipp, str, rval,nval)
      INTEGER ierr, ipp, nval
      REAL rval(*)
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_real_n_cpp(ierr, ipp, istr, NSTR, rval,nval)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_double(ierr, ipp, str, dval)
      INTEGER ierr, ipp
      DOUBLE PRECISION dval
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_double_cpp(ierr, ipp, istr, NSTR, dval)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_double_n(ierr, ipp, str, dval, nval)
      INTEGER ierr, ipp, nval
      DOUBLE PRECISION dval
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_double_n_cpp(ierr, ipp, istr, NSTR, dval,nval)
      END
c-----------------------------------------------------------------------
      SUBROUTINE bl_pp_get_string(ierr, ipp, str, ostr)
      INTEGER ierr, ipp
      CHARACTER*(*) ostr
      CHARACTER*(*) str
      INTEGER NSTR
      PARAMETER (NSTR = 128)
      INTEGER istr(NSTR)
      INTEGER iostr(NSTR)
C
      CALL blstr2int(istr, NSTR, str)
      CALL bl_pp_get_string_cpp(ierr, ipp, istr, NSTR, iostr, NSTR)
      IF ( ierr .ne. 0 ) THEN
          CALL blint2str(ostr, iostr, NSTR)
      END IF
      END

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: PROB_2D.F,v 1.22 2002/10/17 20:36:40 marc Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROB_AMR_F.H"
#include "PROB_NS_F.H"
#include "ArrayLim.H"

#define SDIM 2

c ::: -----------------------------------------------------------
c ::: This routine is called at problem initialization time
c ::: and when restarting from a checkpoint file.
c ::: The purpose is (1) to specify the initial time value
c ::: (not all problems start at time=0.0) and (2) to read
c ::: problem specific data from a namelist or other input
c ::: files and possibly store them or derived information
c ::: in FORTRAN common blocks for later use.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: init      => TRUE if called at start of problem run
c :::              FALSE if called from restart
c ::: name      => name of "probin" file
c ::: namlen    => length of name
c ::: strttime <=  start problem with this time variable
c ::: 
c ::: -----------------------------------------------------------
      subroutine FORT_PROBINIT (init,name,namlen,problo,probhi)
      integer init,namlen
      integer name(namlen)
      integer untin, i
      REAL_T  problo(SDIM), probhi(SDIM)

#include "probdata.H"

      namelist /fortin/ denerr, vorterr, adverr, temperr,
     &			denfact, xblob, yblob, zblob, radblob, 
     &                  velfact, probtype, randfact, bubgrad,
     &			rhozero, tempzero, c_d, r_d, 
     &                  adv_dir, adv_vel, axis_dir, radvort
c
c      Build "probin" filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      character probin*(maxlen)

      if (namlen .gt. maxlen) then
         write(6,*) 'probin file name too long'
         stop
      end if

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      untin = 9
      if (namlen .eq. 0) then
         open(untin,file='probin',form='formatted',status='old')
      else
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if

      read(untin,fortin)
c      write(6,fortin)
      close(unit=untin)

c
c     Initialize the common blocks
c
      do i=1, SDIM
        f_problo(i) = problo(i)
        f_probhi(i) = probhi(i)
      enddo

      end

c ::: -----------------------------------------------------------
c ::: This routine is called at problem setup time and is used
c ::: to initialize data on each grid.  The velocity field you
c ::: provide does not have to be divergence free and the pressure
c ::: field need not be set.  A subsequent projection iteration
c ::: will define aa divergence free velocity field along with a
c ::: consistant pressure.
c ::: 
c ::: NOTE:  all arrays have one cell of ghost zones surrounding
c :::        the grid interior.  Values in these cells need not
c :::        be set here.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: level     => amr level of grid
c ::: time      => time at which to init data             
c ::: lo,hi     => index limits of grid interior (cell centered)
c ::: nscal     => number of scalar quantities.  You should know
c :::		   this already!
c ::: vel      <=  Velocity array
c ::: scal     <=  Scalar array
c ::: press    <=  Pressure array
c ::: dx       => cell size
c ::: xlo,xhi   => physical locations of lower left and upper
c :::              right hand corner of grid.  (does not include
c :::		   ghost region).
c ::: -----------------------------------------------------------
      subroutine FORT_INITDATA(level,time,lo,hi,nscal,
     &	 	               vel,scal,DIMS(state),press,DIMS(press),
     &                         dx,xlo,xhi)
      integer    level, nscal
      integer    lo(SDIM),hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))

#include "probdata.H"

      if (probtype .eq. 1) then
         call initspin(level,time,lo,hi,nscal,
     &     	       vel,scal,DIMS(state),press,DIMS(press),
     &                 dx,xlo,xhi)

      else if (probtype .eq. 2) then
         call initbubble(level,time,lo,hi,nscal,
     &     	         vel,scal,DIMS(state),press,DIMS(press),
     &                   dx,xlo,xhi)

      else if (probtype .eq. 3) then
         call initvort(level,time,lo,hi,nscal,
     &     	       vel,scal,DIMS(state),press,DIMS(press),
     &                 dx,xlo,xhi)

      else if (probtype .eq. 4) then
         call initchannel(level,time,lo,hi,nscal,
     &     	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 5) then
         call initpervort(level,time,lo,hi,nscal,
     &     	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 6) then
         call inithotspot(level,time,lo,hi,nscal,
     &     	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 7) then
         call initviscbench(level,time,lo,hi,nscal,
     &     	            vel,scal,DIMS(state),press,DIMS(press),
     &                      dx,xlo,xhi)

      else
         write(6,*) "INITDATA: bad probtype = ",probtype
      end if

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initbubble(level,time,lo,hi,nscal,
     &	 	            vel,scal,DIMS(state),press,DIMS(press),
     &                      dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, n
      REAL_T  x, y
      REAL_T  hx, hy
      REAL_T  dist
      REAL_T  x_vel, y_vel

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
         y_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = adv_vel
      else 
         write(6,*) "initbubble: adv_dir = ",adv_dir
         stop
      end if

      do j = lo(2), hi(2)
         y = xlo(2) + hy*(float(j-lo(2)) + half)
         do i = lo(1), hi(1)
            x = xlo(1) + hx*(float(i-lo(1)) + half)
c            dist = sqrt((x-xblob)**2 + (y-yblob)**2)
            dist = sqrt((x-xblob)**2)
            vel(i,j,1) = x_vel
            vel(i,j,2) = y_vel
            scal(i,j,1) = one + half*(denfact-one)*(one-tanh(30.*(dist-radblob)))
c           scal(i,j,1) = cvmgt(denfact,one,dist.lt.radblob)
            do n = 2,nscal-1
               scal(i,j,n) = one
            end do                  
            scal(i,j,nscal) = cvmgt(one,zero,dist.lt.radblob)
	 end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initspin(level,time,lo,hi,nscal,
     &	 	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, n
      REAL_T  x, y
      REAL_T  hx, hy
      REAL_T  dist
      REAL_T  x_vel, y_vel
      REAL_T  spx, spy, cpx, cpy

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
         y_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = adv_vel
      else 
         write(6,*) "INITSPIN: adv_dir = ",adv_dir
         stop
      end if

         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
	    spy = sin(Pi*y)
	    cpy = cos(Pi*y)
	    do i = lo(1), hi(1)
               x = xlo(1) + hx*(float(i-lo(1)) + half)

 	       spx = sin(Pi*x)
               cpx = cos(Pi*x)

               vel(i,j,1) = x_vel - velfact*two*spy*cpy*spx**2
               vel(i,j,2) = y_vel + velfact*two*spx*cpx*spy**2

  	       dist = sqrt((x-xblob)**2 + (y-yblob)**2)

               scal(i,j,1) = one + (denfact-one) * tanh(10.*(dist-radblob))
               do n = 2,nscal-1
                  scal(i,j,n) = one
               end do                  
	       scal(i,j,nscal) = cvmgt(one,zero,dist.lt.radblob)

	    end do
         end do

      end
c
c ::: -----------------------------------------------------------
c ::: This case is an unsteady  viscous benchmark for which the 
c ::: exact solution is,
c :::     u(x,y,t) = - Cos(Pi x) Sin(Pi y) Exp(-2 Pi^2 Nu t)
c :::     v(x,y,t) =   Sin(Pi x) Cos(Pi y) Exp(-2 Pi^2 Nu t)
c :::     p(x,y,t) = - {Cos(2 Pi x) + Cos(2 Pi y)} Exp(-4 Pi^2 Nu t) / 4
c ::: In the utilities, iamrlib/BenchMarks, there is a 
c ::: tool ViscBench2d.cpp that reads a plot file and compares the
c ::: solution against this exact solution.  This benchmark was
c ::: originally derived by G.I. Taylor (Phil. Mag., Vol. 46, No. 274, 
c ::: pp. 671-674, 1923) and Ethier and Steinman 
c ::: (Intl. J. Num. Meth. Fluids, Vol. 19, pp. 369-375, 1994) give 
c ::: the pressure field.
c
      subroutine initviscbench(level,time,lo,hi,nscal,
     &	 	               vel,scal,DIMS(state),press,DIMS(press),
     &                         dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, n
      REAL_T  x, y
      REAL_T  hx, hy
      REAL_T  spx, spy, cpx, cpy

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)

      do j = lo(2), hi(2)
         y = xlo(2) + hy*(float(j-lo(2)) + half)
         spy = sin(Pi*y)
         cpy = cos(Pi*y)

         do i = lo(1), hi(1)
            x = xlo(1) + hx*(float(i-lo(1)) + half)

            spx = sin(Pi*x)
            cpx = cos(Pi*x)

            vel(i,j,1) = - cpx*spy
            vel(i,j,2) =   spx*cpy

            scal(i,j,1) = one
            do n = 2,nscal
               scal(i,j,n) = cpx*cpy
            end do                  

         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initvort(level,time,lo,hi,nscal,
     &	 	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)
      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, n
      REAL_T  x, y, r
      REAL_T  hx, hy
      REAL_T  c, ux, uy
      REAL_T  umagin, umagout, absu, sinth, costh
      REAL_T  small, a, b, r0

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      small = 1.0e-10

      r0 = two/three * radvort
      a = one / ((radvort - r0)*(two*radvort - r0))
      b = a * radvort**2 * (radvort - r0)

         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half) - yblob
	    do i = lo(1), hi(1)
               x = xlo(1) + hx*(float(i-lo(1)) + half) - xblob
  	       r = sqrt(x**2 + y**2)
c              umagin = .5*r - 4*r**3
c              umagout = radvort*(.5*radvort - 4*radvort**3)/max(radvort,r)
               umagin = velfact * (one - a*(r - r0)**2)
               umagout = velfact * b/max(radvort,r)
               absu = cvmgp(umagout,umagin,r - radvort)
               sinth = y/max(r,small*radvort)
               costh = x/max(r,small*radvort)
               vel(i,j,1) = -absu*sinth
               vel(i,j,2) = absu*costh
               scal(i,j,1) = cvmgt(denfact,one,r.lt.radblob)
               do n = 2,nscal-1
                  scal(i,j,n) = one
               end do                  
               scal(i,j,nscal) = cvmgt(one,zero,r.lt.radblob)
	    end do
         end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initchannel(level,time,lo,hi,nscal,
     &	 	             vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, n
      REAL_T  x, y
      REAL_T  hx, hy
      REAL_T  dist

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)

      do j = lo(2), hi(2)
         y = xlo(2) + hy*(float(j-lo(2)) + half)
         do i = lo(1), hi(1)
            vel(i,j,1) = adv_vel
            vel(i,j,2) = zero
            scal(i,j,1) = one

            do n = 2,nscal-1
               scal(i,j,n) = one
            end do                  

            x = xlo(1) + hx*(float(i-lo(1)) + half)
  	    dist = sqrt((x-xblob)**2 + (y-yblob)**2)
	    scal(i,j,nscal) = cvmgt(one,zero,dist.lt.radblob)

         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initpervort(level,time,lo,hi,nscal,
     &	 	             vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, n
      REAL_T  x, y
      REAL_T  hx, hy
      REAL_T  dist

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)

         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
	    do i = lo(1), hi(1)

               x = xlo(1) + hx*(float(i-lo(1)) + half)

               vel(i,j,1) = tanh(30.*(.25-abs(y-.5)))
               vel(i,j,2) = .05*sin(two*Pi*x)

               scal(i,j,1) = one
               do n = 2,nscal-1
                  scal(i,j,n) = one
               end do
                  
  	       dist = sqrt((x-xblob)**2 + (y-yblob)**2)
	       scal(i,j,nscal) = cvmgt(one,zero,dist.lt.radblob)
	    end do
         end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine inithotspot(level,time,lo,hi,nscal,
     &	 	             vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))


c     ::::: local variables
      integer i, j, n
      REAL_T  x, y
      REAL_T  hx, hy
      REAL_T  x_vel, y_vel
      REAL_T  dist

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
         y_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = adv_vel
      else 
         write(6,*) "inithotspot: adv_dir = ",adv_dir
         stop
      end if

      do j = lo(2), hi(2)
         y = xlo(2) + hy*(float(j-lo(2)) + half)
         do i = lo(1), hi(1)
            x = xlo(1) + hx*(float(i-lo(1)) + half)
            dist = sqrt((x-xblob)**2 + (y-yblob)**2)
            vel(i,j,1) = x_vel
            vel(i,j,2) = y_vel
            scal(i,j,1) = one/denfact + (one - one/denfact)
     &           *half*(one + tanh(40.*(dist - radblob)))
            scal(i,j,2) = cvmgt(one,zero,dist.lt.radblob)
            do n = 3,nscal-1
               scal(i,j,n) = one
            end do
            scal(i,j,nscal) = one / scal(i,j,1)
         end do
      end do
      
      end
      
c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: density gradient
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: rho       => density array
c ::: DIMS(rho) => index extent of rho array
c ::: lo,hi     => index extent of grid
c ::: nvar      => number of components in rho array (should be 1)
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_DENERROR (tag,DIMS(tag),set,clear,
     &                          rho,DIMS(rho),lo,hi,nvar,
     &                          domlo,domhi,dx,xlo,
     &			        problo,time,level)

      integer   DIMDEC(rho)
      integer   DIMDEC(tag)
      integer   lo(SDIM), hi(SDIM)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    rho(DIMV(rho), nvar)

      integer   i, j

#include "probdata.H"

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            tag(i,j) = cvmgt(set,tag(i,j),rho(i,j,1).lt.denerr)
	 end do
      end do

      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: density gradient
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: adv       => scalar array
c ::: DIMS(adv) => index extent of scalar array
c ::: lo,hi     => index extent of grid
c ::: nvar      => number of components in rho array (should be 1)
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_ADVERROR (tag,DIMS(tag),set,clear,
     &                          adv,DIMS(adv),lo,hi,nvar,
     &                          domlo,domhi,dx,xlo,
     &			        problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(adv)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      integer   lo(SDIM), hi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    adv(DIMV(adv),nvar)

      REAL_T    x, y, ax, ay, aerr, dy
      integer   i, j

#include "probdata.H"

c     probtype = SPIN
      if (probtype .eq. 1) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
           end do
        end do

c     probtype = BUBBLE
      else if (probtype .eq. 2) then

        if (level .eq. 0) then
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
             end do
          end do
        end if

c     probtype = VORTEX IN A BOX
      else if (probtype .eq. 3) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
           end do
        end do

c     probtype = CHANNEL
      else if (probtype .eq. 4) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
           end do
        end do

c     probtype = PERIODIC SHEAR LAYER
      else if (probtype .eq. 5) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
           end do
        end do

c     probtype = HOT SPOT
      else if (probtype .eq. 6) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
           end do
        end do


c     probtype = VISCOUS BENCHMARK
      else if (probtype .eq. 7) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),adv(i,j,1).gt.adverr)
           end do
        end do

      else
        print *,'DONT KNOW THIS PROBTYPE IN FORT_ADVERROR ',probtype
        stop
      end if
 
      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the
c ::: temperature gradient
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: temp      => density array
c ::: DIMS(temp)=> index extent of temp array
c ::: lo,hi     => index extent of grid
c ::: nvar      => number of components in rho array (should be 1)
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::              corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_TEMPERROR (tag,DIMS(tag),set,clear,
     &                          temperature,DIMS(temp),lo,hi,nvar,
     &                          domlo,domhi,dx,xlo,
     &                          problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(temp)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      integer   lo(SDIM), hi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    temperature(DIMV(temp),nvar)

      REAL_T    x, y, ax, ay, aerr
      integer   i, j

#include "probdata.H"

c     probtype = SPIN
      if (probtype .eq. 1) then

c     probtype = BUBBLE
      else if (probtype .eq. 2) then

c     probtype = VORTEX IN A BOX
      else if (probtype .eq. 3) then

c     probtype = CHANNEL
      else if (probtype .eq. 4) then

c     probtype = PERIODIC SHEAR LAYER
      else if (probtype .eq. 5) then

c     probtype = HOT SPOT
      else if (probtype .eq. 6) then

        if (level .eq. 0) then
c         ::::: refine around entire hot spot
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                tag(i,j) = cvmgt(set,tag(i,j),temperature(i,j,1).gt.temperr)
             end do
          end do
        else
c         ::::: refine where there is temperature gradient
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                ax = abs(temperature(i+1,j,1) - temperature(i-1,j,1))
                ay = abs(temperature(i,j+1,1) - temperature(i,j-1,1))
                aerr = max(ax,ay)
                tag(i,j) = cvmgt(set,tag(i,j),aerr.gt.bubgrad)
             end do
          end do
        end if


c     probtype = VISCOUS BENCHMARK
      else if (probtype .eq. 7) then

      else
        print *,'DONT KNOW THIS PROBTYPE IN FORT_TEMPERROR ',probtype
        stop
      end if

      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: magnitude of vorticity
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: vort      => array of vorticity values
c ::: DIMS(vor) => index extent of vort array
c ::: nvar      => number of components in vort array (should be 1)
c ::: lo,hi     => index extent of grid
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_MVERROR (tag,DIMS(tag),set,clear,
     &                         vort,DIMS(vort),lo,hi,nvar,
     &                         domlo,domhi,dx,xlo,
     &			       problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(vort)
      integer   nvar, set, clear, level
      integer   lo(SDIM), hi(SDIM)
      integer   domlo(SDIM), domhi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    vort(DIMV(vort),nvar)

      REAL_T    x, y
      integer   i, j

#include "probdata.H"

c     probtype = SPIN
      if (probtype .eq. 1) then

c     probtype = BUBBLE
      else if (probtype .eq. 2) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),abs(vort(i,j,1)).gt.vorterr)
           end do
        end do

c     probtype = VORTEX IN A BOX
      else if (probtype .eq. 3) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),abs(vort(i,j,1)).gt.vorterr)
           end do
        end do

c     probtype = CHANNEL
      else if (probtype .eq. 4) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),abs(vort(i,j,1)).gt.vorterr)
           end do
        end do

c     probtype = PERIODIC SHEAR LAYER
      else if (probtype .eq. 5) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),abs(vort(i,j,1)).gt.vorterr)
           end do
        end do

c     probtype = HOT SPOT
      else if (probtype .eq. 6) then

        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),abs(vort(i,j,1)).gt.vorterr)
           end do
        end do

c     probtype = VISCOUS BENCHMARK
      else if (probtype .eq. 7) then
        do j = lo(2), hi(2)
           do i = lo(1), hi(1)
              tag(i,j) = cvmgt(set,tag(i,j),abs(vort(i,j,1)).gt.vorterr)
           end do
        end do

      else
        print *,'DONT KNOW THIS PROBTYPE IN FORT_MVERROR ',probtype
        stop
      end if

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data and that all non-interior cells have
c ::         have been filled with a large real number.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: rho      <=  density array
c ::: DIMS(rho) => index extent of rho array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_DENFILL (rho,DIMS(rho),domlo,domhi,dx,
     &                         xlo,time,bc )

      integer    DIMDEC(rho)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     rho(DIMV(rho))
      integer    bc(SDIM,2)

      integer    i, j

#include "probdata.H"

      call filcc(rho,DIMS(rho),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(rho).lt.domlo(1)) then
         do i = ARG_L1(rho), domlo(1)-1
            do j = ARG_L2(rho), ARG_H2(rho)
	       rho(i,j) = denfact
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(rho).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(rho)
            do j = ARG_L2(rho), ARG_H2(rho)
	       rho(i,j) = denfact
	    end do
	 end do
      end if            


      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(rho).lt.domlo(2)) then
           do j = ARG_L2(rho), domlo(2)-1
              do i = ARG_L1(rho), ARG_H1(rho)
	         rho(i,j) = denfact
	      end do
	   end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(rho).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(rho)
            do i = ARG_L1(rho), ARG_H1(rho)
	       rho(i,j) = denfact
	    end do
	 end do
      end if            

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data and that all non-interior cells have
c ::         have been filled with a large real number.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: adv      <=  advected quantity array
c ::: DIMS(adv) => index extent of adv array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of adv array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_ADVFILL (adv,DIMS(adv),domlo,domhi,dx,xlo,time,bc)

      integer    DIMDEC(adv)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))
      integer    bc(SDIM,2)

      integer    i, j

#include "probdata.H"

      call filcc(adv,DIMS(adv),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(adv).lt.domlo(1)) then
         do i = ARG_L1(adv), domlo(1)-1
            do j = ARG_L2(adv), ARG_H2(adv)
	       adv(i,j) = zero
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(adv).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(adv)
            do j = ARG_L2(adv), ARG_H2(adv)
	       adv(i,j) = zero
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(adv).lt.domlo(2)) then

         do j = ARG_L2(adv), domlo(2)-1
            do i = ARG_L1(adv), ARG_H1(adv)
	       adv(i,j) = zero
	    end do
	 end do

      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(adv).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(adv)
            do i = ARG_L1(adv), ARG_H1(adv)
	       adv(i,j) = zero
	    end do
	 end do
      end if            

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.
c :::
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data and that all non-interior cells have
c ::         have been filled with a large real number.
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: temperature <=  temperature array
c ::: DIMS(temp)   => index extent of adv array
c ::: domlo,hi     => index extent of problem domain
c ::: dx           => cell spacing
c ::: xlo          => physical location of lower left hand
c :::                 corner of temperature array
c ::: time         => problem evolution time
c ::: bc           => array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_TEMPFILL (temperature,DIMS(temp),domlo,domhi,dx,
     &                          xlo,time,bc )

      integer    DIMDEC(temp)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     temperature(DIMV(temp))
      integer    bc(SDIM,2)

      integer    i, j

#include "probdata.H"

      call filcc(temperature,DIMS(temp),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(temp).lt.domlo(1)) then
         do i = ARG_L1(temp), domlo(1)-1
           do j = ARG_L2(temp), ARG_H2(temp)
               temperature(i,j) = one
           end do
         end do
      end if

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(temp).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(temp)
           do j = ARG_L2(temp), ARG_H2(temp)
               temperature(i,j) = one
           end do
         end do
      end if    

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(temp).lt.domlo(2)) then
         do j = ARG_L2(temp), domlo(2)-1
           do i = ARG_L1(temp), ARG_H1(temp)
               temperature(i,j) = one
          end do
       end do
      end if    

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(temp).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(temp)
           do i = ARG_L1(temp), ARG_H1(temp)
               temperature(i,j) = one
           end do
         end do
      end if    

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data and that all non-interior cells have
c ::         have been filled with a large real number.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: u        <=  x velocity array
c ::: DIMS(u)   => index extent of u array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_XVELFILL (u,DIMS(u),domlo,domhi,dx,xlo,time,bc)

      integer    DIMDEC(u)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     u(DIMV(u))
      integer    bc(SDIM,2)

      integer    i, j
      REAL_T     x_vel

#include "probdata.H"

      if (adv_dir .eq. 1)then
         x_vel = adv_vel
      else  
         x_vel = zero
      end if

      call filcc(u,DIMS(u),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(u).lt.domlo(1)) then
         do i = ARG_L1(u), domlo(1)-1
            do j = ARG_L2(u), ARG_H2(u)
	       u(i,j) = x_vel
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(u).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(u)
            do j = ARG_L2(u), ARG_H2(u)
	       u(i,j) = x_vel
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(u).lt.domlo(2)) then
         do j = ARG_L2(u), domlo(2)-1
            do i = ARG_L1(u), ARG_H1(u)
	       u(i,j) = zero
	    end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(u).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(u)
            do i = ARG_L1(u), ARG_H1(u)
	       u(i,j) = zero
	    end do
	 end do
      end if            

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data and that all non-interior cells have
c ::         have been filled with a large real number.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: v        <=  y velocity array
c ::: DIMS(v)  => index extent of v array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_YVELFILL (v,DIMS(v),domlo,domhi,dx,xlo,time,bc)

      integer    DIMDEC(v)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     v(DIMV(v))
      integer    bc(SDIM,2)

      integer    i, j
      REAL_T     y_vel

#include "probdata.H"

      if (adv_dir .eq. 2) then
         y_vel = adv_vel
      else  
         y_vel = zero
      end if

      call filcc(v,DIMS(v),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(v).lt.domlo(1)) then
         do i = ARG_L1(v), domlo(1)-1
           do j = ARG_L2(v),ARG_H2(v)
	     v(i,j) = zero
	   end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(v).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(v)
           do j = ARG_L2(v), ARG_H2(v)
	     v(i,j) = zero
	   end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(v).lt.domlo(2)) then
         do j = ARG_L2(v), domlo(2)-1
           do i = ARG_L1(v), ARG_H1(v)
             v(i,j) = y_vel
	   end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(v).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(v)
           do i = ARG_L1(v), ARG_H1(v)
	     v(i,j) = y_vel
	   end do
	 end do
      end if            

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: p        <=  pressure array
c ::: DIMS(p)   => index extent of p array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi) 
c ::: -----------------------------------------------------------

      subroutine FORT_PRESFILL (p,DIMS(p),domlo,domhi,dx,xlo,time,bc)

      integer    DIMDEC(p)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     p(DIMV(p))
      integer    bc(SDIM,2)

      integer    i, j
      integer    ilo, ihi, jlo, jhi
      logical    fix_xlo, fix_xhi, fix_ylo, fix_yhi
      logical    per_xlo, per_xhi, per_ylo, per_yhi

      fix_xlo = (ARG_L1(p) .lt. domlo(1)) .and. (bc(1,1) .ne. INT_DIR)
      per_xlo = (ARG_L1(p) .lt. domlo(1)) .and. (bc(1,1) .eq. INT_DIR)
      fix_xhi = (ARG_H1(p) .gt. domhi(1)) .and. (bc(1,2) .ne. INT_DIR)
      per_xhi = (ARG_H1(p) .gt. domhi(1)) .and. (bc(1,2) .eq. INT_DIR)
      fix_ylo = (ARG_L2(p) .lt. domlo(2)) .and. (bc(2,1) .ne. INT_DIR)
      per_ylo = (ARG_L2(p) .lt. domlo(2)) .and. (bc(2,1) .eq. INT_DIR)
      fix_yhi = (ARG_H2(p) .gt. domhi(2)) .and. (bc(2,2) .ne. INT_DIR)
      per_yhi = (ARG_H2(p) .gt. domhi(2)) .and. (bc(2,2) .eq. INT_DIR)

      ilo = max(ARG_L1(p),domlo(1))
      ihi = min(ARG_H1(p),domhi(1))
      jlo = max(ARG_L2(p),domlo(2))
      jhi = min(ARG_H2(p),domhi(2))
c
c     ::::: left side
c
      if (fix_xlo) then
         do i = ARG_L1(p), domlo(1)-1
            do j = jlo,jhi
               p(i,j) = p(ilo,j)
            end do
         end do
         if (fix_ylo) then
            do i = ARG_L1(p), domlo(1)-1
               do j = ARG_L2(p), domlo(2)-1
                  p(i,j) = p(ilo,jlo)
               end do
            end do
         else if (per_ylo) then
            do i = ARG_L1(p), domlo(1)-1
               do j = ARG_L2(p), domlo(2)-1
                  p(i,j) = p(ilo,j)
               end do
            end do
         end if
         if (fix_yhi) then
            do i = ARG_L1(p), domlo(1)-1
               do j = domhi(2)+1, ARG_H2(p)
                  p(i,j) = p(ilo,jhi)
               end do
            end do
         else if (per_yhi) then
            do i = ARG_L1(p), domlo(1)-1
               do j = domhi(2)+1, ARG_H2(p)
                  p(i,j) = p(ilo,j)
               end do
            end do
         end if
      end if
c
c     ::::: right side
c
      if (fix_xhi) then
         do i = domhi(1)+1, ARG_H1(p)
            do j = jlo,jhi
               p(i,j) = p(ihi,j)
            end do
	 end do
	 if (fix_ylo) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = ARG_L2(p), domlo(2)-1
                  p(i,j) = p(ihi,jlo)
               end do
	    end do
	 else if (per_ylo) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = ARG_L2(p), domlo(2)-1
                  p(i,j) = p(ihi,j)
               end do
	    end do
         end if
	 if (fix_yhi) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = domhi(2)+1, ARG_H2(p)
                  p(i,j) = p(ihi,jhi)
               end do
	    end do
	 else if (per_yhi) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = domhi(2)+1, ARG_H2(p)
                  p(i,j) = p(ihi,j)
               end do
	    end do
         end if
      end if
      
      if (fix_ylo) then
         do j = ARG_L2(p), domlo(2)-1
            do i = ilo, ihi
               p(i,j) = p(i,jlo)
            end do
	 end do
	 if (per_xlo) then
          do j = ARG_L2(p), domlo(2)-1
               do i = ARG_L1(p), domlo(1)-1
                  p(i,j) = p(i,jlo)
               end do
	    end do
         end if
	 if (per_xhi) then
           do j = ARG_L2(p), domlo(2)-1
               do i = domhi(1)+1, ARG_H1(p)
                  p(i,j) = p(i,jlo)
               end do
	    end do
         end if
      end if

      if (fix_yhi) then
         do j = domhi(2)+1, ARG_H2(p)
            do i = ilo, ihi
               p(i,j) = p(i,jhi)
            end do
	 end do
	 if (per_xlo) then
	    do j = domhi(2)+1, ARG_H2(p)
               do i = ARG_L1(p), domlo(1)-1
                  p(i,j) = p(i,jhi)
               end do
	    end do
         end if
	 if (per_xhi) then
	    do j = domhi(2)+1, ARG_H2(p)
               do i = domhi(1)+1, ARG_H1(p)
                  p(i,j) = p(i,jhi)
               end do
	    end do
         end if
      end if

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: divu     <=  divu array
c ::: DIMS(divu)=> index extent of p array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi) 
c ::: -----------------------------------------------------------

      subroutine FORT_DIVUFILL (divu,DIMS(divu),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMDEC(divu)
      integer    bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     divu(DIMV(divu))

      integer    i, j
      integer    ilo, ihi, jlo, jhi
      REAL_T     y

      integer lo(SDIM), hi(SDIM)

      lo(1) = ARG_L1(divu)
      hi(1) = ARG_H1(divu)
      lo(2) = ARG_L2(divu)
      hi(2) = ARG_H2(divu)

      ilo = max(lo(1),domlo(1))
      ihi = min(hi(1),domhi(1))
      jlo = max(lo(2),domlo(2))
      jhi = min(hi(2),domhi(2))

      call filcc (divu,DIMS(divu),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
           if(jlo.le.jhi)then
             do j = jlo, jhi
               do i = lo(1), domlo(1)-1
                 divu(i,j) = divu(domlo(1),j)
               end do
             end do
           end if
           if (lo(2).lt.domlo(2)) then
             do j = lo(2), domlo(2)-1
               do i = lo(1), domlo(1)-1
                 divu(i,j) = divu(domlo(1),domlo(2))
               end do
             end do
           end if
           if(hi(2).gt.domhi(2))then
             do j = domhi(2)+1, hi(2)
               do i = lo(1), domlo(1)-1
                 divu(i,j) = divu(domlo(1),domhi(2))
               end do
             end do
           end if

      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
           if(jlo.le.jhi)then
             do j = jlo,jhi
               do i = domhi(1)+1,hi(1)
                 divu(i,j) = divu(domhi(1),j)
               end do
             end do
           end if
           if (lo(2).lt.domlo(2)) then
             do j = lo(2), domlo(2)-1
               do i = domhi(1)+1,hi(1)
                 divu(i,j) = divu(domhi(1),domlo(2))
               end do
             end do
           end if
           if(hi(2).gt.domhi(2))then
             do j = domhi(2)+1, hi(2)
               do i = domhi(1)+1,hi(1)
                 divu(i,j) = divu(domhi(1),domhi(2))
               end do
             end do
           end if
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
           if(ilo.le.ihi)then
             do j = lo(2), domlo(2)-1
               do i = ilo,ihi
                 divu(i,j) = divu(i,domlo(2))
               end do
             end do
           end if
           if (lo(1).lt.domlo(1)) then
             do j = lo(2), domlo(2)-1
               do i = lo(1), domlo(1)-1
                 divu(i,j) = divu(domlo(1),domlo(2))
               end do
             end do
           end if
           if(hi(1).gt.domhi(1))then
             do j = lo(2), domlo(2)-1
               do i = domhi(1)+1, hi(1)
                 divu(i,j) = divu(domhi(1),domlo(2))
               end do
             end do
           end if

      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
           if(ilo.le.ihi)then
             do j = domhi(2)+1, hi(2)
               do i = ilo,ihi
                 divu(i,j) = divu(i,domhi(2))
               end do
             end do
           end if
           if (lo(1).lt.domlo(1)) then
             do j = domhi(2)+1, hi(2)
               do i = lo(1), domlo(1)-1
                 divu(i,j) = divu(domlo(1),domhi(2))
               end do
             end do
           end if
           if(hi(1).gt.domhi(1))then
             do j = domhi(2)+1, hi(2)
               do i = domhi(1)+1, hi(1)
                 divu(i,j) = divu(domhi(1),domhi(2))
               end do
             end do
           end if
      end if            

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: dsdt     <=  dsdt array
c ::: DIMS(dsdt)=> index extent of p array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi) 
c ::: -----------------------------------------------------------


      subroutine FORT_DSDTFILL (dsdt,DIMS(dsdt),domlo,domhi,delta,
     &                          xlo,time,bc )

      integer    DIMDEC(dsdt)
      integer    bc(SDIM,2)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     delta(SDIM), xlo(SDIM), time
      REAL_T     dsdt(DIMV(dsdt))

      integer    i, j
      integer    ilo, ihi, jlo, jhi
      REAL_T     y

      integer lo(SDIM), hi(SDIM)

      lo(1) = ARG_L1(dsdt)
      hi(1) = ARG_H1(dsdt)
      lo(2) = ARG_L2(dsdt)
      hi(2) = ARG_H2(dsdt)

      ilo = max(lo(1),domlo(1))
      ihi = min(hi(1),domhi(1))
      jlo = max(lo(2),domlo(2))
      jhi = min(hi(2),domhi(2))

      call filcc (dsdt,DIMS(dsdt),domlo,domhi,delta,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
           do i = lo(1), domlo(1)-1
             do j = lo(2), hi(2)
               dsdt(i,j) = zero
             end do
           end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
           do i = domhi(1)+1, hi(1)
             do j = lo(2), hi(2)
               dsdt(i,j) = zero
             end do
           end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
           do j = lo(2), domlo(2)-1
              do i = lo(1), hi(1)
                 dsdt(i,j) = zero
              end do
           end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
           do j = domhi(2)+1, hi(2)
              do i = lo(1), hi(1)
                 dsdt(i,j) = zero
              end do
           end do
      end if            

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** SLOPEZ **
c ** Compute the slope of nvar components of s in the z-direction
c *************************************************************************

      subroutine FORT_SLOPEZ(s,slz,dzscr,DIMS,nvar,bcz_lo,bcz_hi,slope_order)

      implicit none

      integer DIMS
      integer nvar
      integer bcz_lo,bcz_hi
      integer slope_order

      REAL_T      s(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,nvar)
      REAL_T    slz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,nvar)
      REAL_T  dzscr(lo_3-1:hi_3+1,4)

      integer cen,lim,flag,fromm

      parameter( cen = 1 )
      parameter( lim = 2 )
      parameter( flag = 3 )
      parameter( fromm = 4 )

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag

      integer is,js,ks,ie,je,ke,i,j,k,iv

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

c ::: HERE DOING 1ST ORDER
      if (slope_order .eq. 0) then
        do iv = 1,nvar 
          do k = ks-1,ke+1 
           do j = js-1,je+1 
            do i = is-1,ie+1 
              slz(i,j,k,iv) = zero
            enddo
           enddo
          enddo
        enddo

c ::: HERE DOING 2ND ORDER
      else if (slope_order .eq. 2) then

        do iv = 1,nvar 
          do k = ks,ke 
          do j = js-1,je+1 
          do i = is-1,ie+1 

              del  = half*(s(i,j,k+1,iv) - s(i,j,k-1,iv))
              dpls = two *(s(i,j,k+1,iv) - s(i,j,k  ,iv))
              dmin = two *(s(i,j,k  ,iv) - s(i,j,k-1,iv))
              slim = min(abs(dpls),abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slz(i,j,k,iv)= sflag*min(slim,abs(del))

          enddo
          enddo
          enddo

          if (bcz_lo .eq. PERIODIC) then

            do j = js-1,je+1 
            do i = is-1,ie+1 
              slz(i,j,ks-1,iv) = slz(i,j,ke,iv)
            enddo
            enddo

          elseif (bcz_lo .eq. WALL  .or.  bcz_lo .eq. INLET) then

            do j = js-1,je+1 
            do i = is-1,ie+1 
              slz(i,j,ks-1,iv) = zero
              del = (s(i,j,ks+1,iv)+three*s(i,j,ks,iv)-
     $               four*s(i,j,ks-1,iv)) * third
              dpls = two*(s(i,j,ks+1,iv) - s(i,j,ks  ,iv))
              dmin = two*(s(i,j,ks  ,iv) - s(i,j,ks-1,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slz(i,j,ks,iv)= sflag*min(slim,abs(del))
            enddo
            enddo

          elseif (bcz_lo .eq. OUTLET) then

            do j = js-1,je+1 
            do i = is-1, ie+1 
              slz(i,j,ks-1,iv) = zero
            enddo
            enddo

          endif

          if (bcz_hi .eq. PERIODIC) then

            do j = js-1,je+1 
            do i = is-1,ie+1 
              slz(i,j,ke+1,iv) = slz(i,j,ks,iv)
            enddo
            enddo

          elseif (bcz_hi .eq. WALL  .or.  bcz_hi .eq. INLET) then

            do j = js-1,je+1 
            do i = is-1, ie+1 
              slz(i,j,ke+1,iv) = zero
              del = -(s(i,j,ke-1,iv)+three*s(i,j,ke,iv)-
     $                four*s(i,j,ke+1,iv)) * third
              dpls = two*(s(i,j,ke+1,iv) - s(i,j,ke  ,iv))
              dmin = two*(s(i,j,ke  ,iv) - s(i,j,ke-1,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slz(i,j,ke,iv)= sflag*min(slim,abs(del))
            enddo
            enddo

          elseif (bcz_hi .eq. OUTLET) then

            do j = js-1,je+1 
            do i = is-1, ie+1 
              slz(i,j,ke+1,iv) = zero
            enddo
            enddo

          endif
        enddo

      else 

c ::: HERE DOING 4TH ORDER

      do iv=1,nvar 
        do j = js-1,je+1 
        do i = is-1,ie+1 
          do k = ks,ke 
            dzscr(k,cen) = half*(s(i,j,k+1,iv)-s(i,j,k-1,iv))
            dmin = two*(s(i,j,k  ,iv)-s(i,j,k-1,iv))
            dpls = two*(s(i,j,k+1,iv)-s(i,j,k  ,iv))
            dzscr(k,lim)  = min(abs(dmin),abs(dpls))
            dzscr(k,lim)  = cvmgp(dzscr(k,lim),zero,dpls*dmin)
            dzscr(k,flag) = sign(one,dzscr(k,cen))
            dzscr(k,fromm)= dzscr(k,flag)*min(dzscr(k,lim),abs(dzscr(k,cen)))
          enddo

          if (bcz_lo .eq. PERIODIC) then
            dzscr(ks-1,fromm) = dzscr(ke,fromm)
          else
            dzscr(ks-1,fromm) = dzscr(ks,fromm)
          endif

          if (bcz_hi .eq. PERIODIC) then
            dzscr(ke+1,fromm) = dzscr(ks,fromm)
          else
            dzscr(ke+1,fromm) = dzscr(ke,fromm)
          endif

          do k = ks,ke 

            ds = two * two3rd * dzscr(k,cen) - 
     $           sixth * (dzscr(k+1,fromm) + dzscr(k-1,fromm))
            slz(i,j,k,iv) = dzscr(k,flag)*min(abs(ds),dzscr(k,lim))

          enddo

          if (bcz_lo .eq. PERIODIC) then

            slz(i,j,ks-1,iv) = slz(i,j,ke,iv)

          elseif (bcz_lo .eq. WALL  .or.  bcz_lo .eq. INLET) then

            slz(i,j,ks-1,iv) = zero
            del = -sixteen/fifteen*s(i,j,ks-1,iv) +  half*s(i,j,ks  ,iv) + 
     $                      two3rd*s(i,j,ks+1,iv) - tenth*s(i,j,ks+2,iv)
            dmin = two*(s(i,j,ks  ,iv)-s(i,j,ks-1,iv))
            dpls = two*(s(i,j,ks+1,iv)-s(i,j,ks  ,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            slz(i,j,ks,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at ks+1 using the revised dzscr(ks,fromm)
            dzscr(ks,fromm) = slz(i,j,ks,iv)
            ds = two * two3rd * dzscr(ks+1,cen) -
     $           sixth * (dzscr(ks+2,fromm) + dzscr(ks,fromm))
            slz(i,j,ks+1,iv) = dzscr(ks+1,flag)*min(abs(ds),dzscr(ks+1,lim))

          elseif (bcz_lo .eq. OUTLET) then

            slz(i,j,ks-1,iv) = zero

          endif

          if (bcz_hi .eq. PERIODIC) then

            slz(i,j,ke+1,iv) = slz(i,j,ks,iv)

          elseif (bcz_hi .eq. WALL  .or.  bcz_hi .eq. INLET) then

            slz(i,j,ke+1,iv) = zero
            del = -( -sixteen/fifteen*s(i,j,ke+1,iv) +  half*s(i,j,ke  ,iv) 
     $            +            two3rd*s(i,j,ke-1,iv) - tenth*s(i,j,ke-2,iv) )
            dmin = two*(s(i,j,ke  ,iv)-s(i,j,ke-1,iv))
            dpls = two*(s(i,j,ke+1,iv)-s(i,j,ke  ,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            slz(i,j,ke,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at ke-1 using the revised dzscr(ke,fromm)
            dzscr(ke,fromm) = slz(i,j,ke,iv)
            ds = two * two3rd * dzscr(ke-1,cen) -
     $           sixth * (dzscr(ke-2,fromm) + dzscr(ke,fromm))
            slz(i,j,ke-1,iv) = dzscr(ke-1,flag)*min(abs(ds),dzscr(ke-1,lim))

          elseif (bcz_hi .eq. OUTLET) then

            slz(i,j,ke+1,iv) = zero

          endif
        enddo
      enddo
      enddo

      endif
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** MKVELFLUX **
c ** Create the time-centered edge states for the velocity components
c ***************************************************************

      subroutine FORT_MKVELFLUX(s,sedgex,sedgey,slopex,slopey,uadv,vadv,
     $                          utrans,vtrans,rho,px,py,lapu,
     $                          s_l,s_r,s_b,s_t,DIMS,
     $                          dx,dt,force,visc_coef,irz,
     $                          bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer DIMS

      REAL_T       s(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  sedgex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  sedgey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  slopex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  slopey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T    uadv(lo_1:hi_1+1,lo_2:hi_2  )
      REAL_T    vadv(lo_1:hi_1  ,lo_2:hi_2+1)
      REAL_T  utrans(lo_1:hi_1+1,lo_2:hi_2  )
      REAL_T  vtrans(lo_1:hi_1  ,lo_2:hi_2+1)
      REAL_T     rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      px(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      py(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)

      REAL_T    s_l(lo_1:hi_1+1,2)
      REAL_T    s_r(lo_1:hi_1+1,2)
      REAL_T    s_b(lo_2:hi_2+1,2)
      REAL_T    s_t(lo_2:hi_2+1,2)

      REAL_T  dx(2)
      REAL_T  dt
      integer irz
      REAL_T  visc_coef
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      REAL_T ubardth, vbardth
      REAL_T hx, hy, dth
      REAL_T uplus,uminus,vplus,vminus,ut,vt
      REAL_T utr,vtr,savg,uavg,vavg
      REAL_T uptop,upbot,umtop,umbot,uplft,uprgt,umlft,umrgt
      REAL_T vptop,vpbot,vmtop,vmbot,vplft,vprgt,vmlft,vmrgt

      REAL_T eps

      logical ltm0,ltp0
      integer i,j,is,js,ie,je,n

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      dth = half*dt

      hx = dx(1)
      hy = dx(2)

      do j = js,je 
        do i = is,ie 

          vpbot = s(i,j  ,2) + (half - dth*s(i,j  ,2)/hy) * slopey(i,j,  2) 
c    $            + dth * lapu(i,j  ,2) / rho(i,j)
          vptop = s(i,j+1,2) - (half + dth*s(i,j+1,2)/hy) * slopey(i,j+1,2)
c    $            + dth * lapu(i,j+1,2) / rho(i,j+1)
          upbot = s(i,j  ,1) + (half - dth*s(i,j  ,2)/hy) * slopey(i,j  ,1)
c    $            + dth * lapu(i,  j,1) / rho(i,j)
          uptop = s(i,j+1,1) - (half + dth*s(i,j+1,2)/hy) * slopey(i,j+1,1)
c    $            + dth * lapu(i,j+1,1) / rho(i,j+1)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. INLET)
          vptop = cvmgt(s(i,je+1,2),vptop,ltp0)
          vpbot = cvmgt(s(i,je+1,2),vpbot,ltp0)
          uptop = cvmgt(s(i,je+1,1),uptop,ltp0)
          upbot = cvmgt(s(i,je+1,1),upbot,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL)
          vptop = cvmgt(zero,vptop,ltp0)
          vpbot = cvmgt(zero,vpbot,ltp0)
          uptop = cvmgt(upbot,uptop,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)

          uplus = cvmgp(upbot,uptop,vtrans(i,j+1))
          uavg  = half * (upbot + uptop)
          uplus = cvmgt(uplus, uavg, abs(vtrans(i,j+1)) .gt. eps)

          vplus = cvmgp(vpbot,vptop,vtrans(i,j+1))
          vavg  = half * (vpbot + vptop)
          vplus = cvmgt(vplus, vavg, abs(vtrans(i,j+1)) .gt. eps)

          vmtop = s(i,j  ,2) - (half + dth*s(i,j  ,2)/hy) * slopey(i,j  ,2)
c    $            + dth * lapu(i,j  ,2) / rho(i,j)
          vmbot = s(i,j-1,2) + (half - dth*s(i,j-1,2)/hy) * slopey(i,j-1,2)
c    $            + dth * lapu(i,j-1,2) / rho(i,j-1)
          umtop = s(i,j  ,1) - (half + dth*s(i,j  ,2)/hy) * slopey(i,j  ,1)
c    $            + dth * lapu(i,j  ,1) / rho(i,j)
          umbot = s(i,j-1,1) + (half - dth*s(i,j-1,2)/hy) * slopey(i,j-1,1)
c    $            + dth * lapu(i,j-1,1) / rho(i,j-1)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. INLET)
          vmtop = cvmgt(s(i,js-1,2),vmtop,ltm0)
          vmbot = cvmgt(s(i,js-1,2),vmbot,ltm0)
          umtop = cvmgt(s(i,js-1,1),umtop,ltm0)
          umbot = cvmgt(s(i,js-1,1),umbot,ltm0)

          ltm0 = (j .eq. js .and. bcy_lo .eq. WALL)
          vmtop = cvmgt(zero ,vmtop,ltm0)
          vmbot = cvmgt(zero ,vmbot,ltm0)
          umbot = cvmgt(umtop,umbot,ltm0)

          ltm0 = (j .eq. js .and. bcy_lo .eq. WALL .and. visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)

          uminus = cvmgp(umbot,umtop,vtrans(i,j))
          uavg   = half * (umbot + umtop)
          uminus = cvmgt(uminus, uavg, abs(vtrans(i,j)) .gt. eps)

          vminus = cvmgp(vmbot,vmtop,vtrans(i,j))
          vavg   = half * (vmbot + vmtop)
          vminus = cvmgt(vminus, vavg, abs(vtrans(i,j)) .gt. eps)

          utr = half * (vtrans(i,j)+vtrans(i,j+1))*(uplus - uminus) / hy
          vtr = half * (vtrans(i,j)+vtrans(i,j+1))*(vplus - vminus) / hy

          ut = (lapu(i,j,1)-px(i,j))/rho(i,j) - utr + force(i,j,1)
          vt = (lapu(i,j,2)-py(i,j))/rho(i,j) - vtr + force(i,j,2)

          ubardth = dth*s(i,j,1)/hx

          s_l(i+1,1)= s(i,j,1) + (half-ubardth)*slopex(i,j,1) + dth*ut
          s_l(i+1,2)= s(i,j,2) + (half-ubardth)*slopex(i,j,2) + dth*vt

          s_r(i  ,1)= s(i,j,1) - (half+ubardth)*slopex(i,j,1) + dth*ut
          s_r(i  ,2)= s(i,j,2) - (half+ubardth)*slopex(i,j,2) + dth*vt

        enddo

        if (bcx_lo .eq. PERIODIC) then
          s_l(is  ,1) = s_l(ie+1,1)
          s_l(is  ,2) = s_l(ie+1,2)
        elseif (bcx_lo .eq. WALL) then
          s_l(is  ,1) = zero
          s_r(is  ,1) = zero
          s_l(is  ,2) = s_r(is  ,2)
        elseif (bcx_lo .eq. INLET) then
          s_l(is  ,1) = s(is-1,j,1)
          s_l(is  ,2) = s(is-1,j,2)
        elseif (bcx_lo .eq. OUTLET) then
          s_l(is  ,1) = s_r(is  ,1)
          s_l(is  ,2) = s_r(is  ,2)
        endif

        if (bcx_hi .eq. PERIODIC) then
          s_r(ie+1,1) = s_r(is  ,1)
          s_r(ie+1,2) = s_r(is  ,2)
        elseif (bcx_hi .eq. WALL) then
          s_l(ie+1,1) = zero
          s_r(ie+1,1) = zero
          s_r(ie+1,2) = s_l(ie+1,2)
        elseif (bcx_hi .eq. INLET) then
          s_r(ie+1,1) = s(ie+1,j,1)
          s_r(ie+1,2) = s(ie+1,j,2)
        elseif (bcx_hi .eq. OUTLET) then
          s_r(ie+1,1) = s_l(ie+1,1)
          s_r(ie+1,2) = s_l(ie+1,2)
        endif

        do n = 1,2
        do i = is, ie+1 
          sedgex(i,j,n)=cvmgp(s_l(i,n),s_r(i,n),uadv(i,j))
          savg = half*(s_r(i,n) + s_l(i,n))
          sedgex(i,j,n)=cvmgt(savg,sedgex(i,j,n),abs(uadv(i,j)) .lt. eps)
        enddo
        enddo

        if (bcx_lo .eq. WALL) then
          sedgex(is  ,j,1) = zero
        endif
        if (bcx_hi .eq. WALL) then
          sedgex(ie+1,j,1) = zero
        endif

        if (bcx_lo .eq. WALL .and. visc_coef .gt. 0.0 .and. irz .eq. 0) then
          sedgex(is  ,j,2) = zero
        endif
        if (bcx_hi .eq. WALL .and. visc_coef .gt. 0.0) then
          sedgex(ie+1,j,2) = zero
        endif

      enddo

c ::: loop for y fluxes

      do i = is, ie 
        do j = js, je 

          vplft = s(i  ,j,2) + (half - dth*s(i  ,j,1)/hx) * slopex(i  ,j,2)
c    $            + dth * lapu(i  ,j,2) / rho(i  ,j)
          vprgt = s(i+1,j,2) - (half + dth*s(i+1,j,1)/hx) * slopex(i+1,j,2)
c    $            + dth * lapu(i+1,j,2) / rho(i+1,j)
          uplft = s(i,j ,1 ) + (half - dth*s(i  ,j,1)/hx) * slopex(i  ,j,1)
c    $            + dth * lapu(i  ,j,1) / rho(i  ,j)
          uprgt = s(i+1,j,1) - (half + dth*s(i+1,j,1)/hx) * slopex(i+1,j,1)
c    $            + dth * lapu(i+1,j,1) / rho(i+1,j)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. INLET)
          uprgt = cvmgt(s(ie+1,j,1),uprgt,ltp0)
          uplft = cvmgt(s(ie+1,j,1),uplft,ltp0)
          vprgt = cvmgt(s(ie+1,j,2),vprgt,ltp0)
          vplft = cvmgt(s(ie+1,j,2),vplft,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL)
          uprgt = cvmgt(zero,uprgt,ltp0)
          uplft = cvmgt(zero,uplft,ltp0)
          vprgt = cvmgt(vplft,vprgt,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL  .and.  visc_coef .gt. zero)
          vprgt = cvmgt(zero,vprgt,ltp0)
          vplft = cvmgt(zero,vplft,ltp0)

          uplus = cvmgp(uplft,uprgt,utrans(i+1,j))
          uavg  = half * (uplft + uprgt)
          uplus = cvmgt(uplus, uavg, abs(utrans(i+1,j)) .gt. eps)

          vplus = cvmgp(vplft,vprgt,utrans(i+1,j))
          vavg  = half * (vplft + vprgt)
          vplus = cvmgt(vplus, vavg, abs(utrans(i+1,j)) .gt. eps)

          vmrgt = s(i  ,j,2) - (half + dth*s(i  ,j,1)/hx) * slopex(i  ,j,2)
c    $            + dth * lapu(i  ,j,2) / rho(i  ,j)
          vmlft = s(i-1,j,2) + (half - dth*s(i-1,j,1)/hx) * slopex(i-1,j,2)
c    $            + dth * lapu(i-1,j,2) / rho(i-1,j)
          umrgt = s(i  ,j,1) - (half + dth*s(i  ,j,1)/hx) * slopex(i  ,j,1)
c    $            + dth * lapu(i  ,j,1) / rho(i  ,j)
          umlft = s(i-1,j,1) + (half - dth*s(i-1,j,1)/hx) * slopex(i-1,j,1)
c    $            + dth * lapu(i-1,j,1) / rho(i-1,j)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. INLET)
          umrgt = cvmgt(s(is-1,j,1),umrgt,ltm0)
          umlft = cvmgt(s(is-1,j,1),umlft,ltm0)
          vmrgt = cvmgt(s(is-1,j,2),vmrgt,ltm0)
          vmlft = cvmgt(s(is-1,j,2),vmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL)
          umrgt = cvmgt(zero ,umrgt,ltm0)
          umlft = cvmgt(zero ,umlft,ltm0)
          vmlft = cvmgt(vmrgt,vmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL  .and.  
     $            visc_coef .gt. zero .and. irz .eq. 0)
          vmrgt = cvmgt(zero,vmrgt,ltm0)
          vmlft = cvmgt(zero,vmlft,ltm0)

          uminus = cvmgp(umlft,umrgt,utrans(i,j))
          uavg   = half * (umlft + umrgt)
          uminus = cvmgt(uminus, uavg, abs(utrans(i,j)) .gt. eps)

          vminus = cvmgp(vmlft,vmrgt,utrans(i,j))
          vavg   = half * (vmlft + vmrgt)
          vminus = cvmgt(vminus, vavg, abs(utrans(i,j)) .gt. eps)

          utr = half * (utrans(i,j)+utrans(i+1,j))*(uplus - uminus) / hx
          vtr = half * (utrans(i,j)+utrans(i+1,j))*(vplus - vminus) / hx

          ut = (lapu(i,j,1)-px(i,j))/rho(i,j) - utr + force(i,j,1)
          vt = (lapu(i,j,2)-py(i,j))/rho(i,j) - vtr + force(i,j,2)

          vbardth = dth*s(i,j,2)/hy

          s_b(j+1,1)= s(i,j,1) + (half-vbardth)*slopey(i,j,1) + dth*ut
          s_t(j  ,1)= s(i,j,1) - (half+vbardth)*slopey(i,j,1) + dth*ut
          s_b(j+1,2)= s(i,j,2) + (half-vbardth)*slopey(i,j,2) + dth*vt
          s_t(j  ,2)= s(i,j,2) - (half+vbardth)*slopey(i,j,2) + dth*vt

        enddo

        if (bcy_lo .eq. PERIODIC) then
          s_b(js  ,1) = s_b(je+1,1)
          s_b(js  ,2) = s_b(je+1,2)
        elseif (bcy_lo .eq. WALL) then
          s_b(js  ,1) = s_t(js  ,1)
          s_b(js  ,2) = zero
          s_t(js  ,2) = zero
        elseif (bcy_lo .eq. INLET) then
          s_b(js  ,1) = s(i,js-1,1)
          s_b(js  ,2) = s(i,js-1,2)
        elseif (bcy_lo .eq. OUTLET) then
          s_b(js  ,1) = s_t(js  ,1)
          s_b(js  ,2) = s_t(js  ,2)
        endif

        if (bcy_hi .eq. PERIODIC) then
          s_t(je+1,1) = s_t(js  ,1)
          s_t(je+1,2) = s_t(js  ,2)
        elseif (bcy_hi .eq. WALL) then
          s_t(je+1,1) = s_b(je+1,1)
          s_b(je+1,2) = zero
          s_t(je+1,2) = zero
        elseif (bcy_hi .eq. INLET) then
          s_t(je+1,1) = s(i,je+1,1)
          s_t(je+1,2) = s(i,je+1,2)
        elseif (bcy_hi .eq. OUTLET) then
          s_t(je+1,1) = s_b(je+1,1)
          s_t(je+1,2) = s_b(je+1,2)
        endif

        do n = 1,2
        do j = js, je+1 
          sedgey(i,j,n)=cvmgp(s_b(j,n),s_t(j,n),vadv(i,j))
          savg = half*(s_b(j,n) + s_t(j,n))
          sedgey(i,j,n)=cvmgt(savg,sedgey(i,j,n),abs(vadv(i,j)) .lt. eps)
        enddo
        enddo

        if ((visc_coef .gt. zero)  .and.  (bcy_lo .eq. WALL)) then
          sedgey(i,js  ,1) = zero
          sedgey(i,js  ,2) = zero
        endif
        if ((visc_coef .gt. zero)  .and.  (bcy_hi .eq. WALL)) then
          sedgey(i,je+1,1) = zero
          sedgey(i,je+1,2) = zero
        endif

      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"
#include "AmrDeriveIntScalLen_F.H"

      subroutine FORT_SCALLEN (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,dx,ovlo,ovhi,TSL_z,corr,corrSize,
     $ ug,uglo1,uglo2,uglo3,ughi1,ughi2,ughi3)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3

      integer uglo1,uglo2,uglo3
      integer ughi1,ughi2,ughi3

      integer corrSize

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T dx(3)
      REAL_T  u(1:uhii1-uloi1+1, 1:uhii2-uloi2+1, 1:uhii3-uloi3+1, nvar)
      REAL_T ug(1:ughi1-uglo1+1, 1:ughi2-uglo2+1, 1:ughi3-uglo3+1)
      REAL_T TSL_z(1:uhii3-uloi3+1)
      REAL_T corr(0:corrSize-1)

      integer i,j,k,imax,jmax,kmax, ir, vComp
      REAL_T average, sum

      vComp = 1
      
      imax = uhii1-uloi1+1
      jmax = uhii2-uloi2+1
      kmax = uhii3-uloi3+1

      do i=1,imax
         do k=1,kmax
            do j=1,jmax
               ug(i,     j,k) = u(i,j,k,vComp)
               ug(i+imax,j,k) = u(i,j,k,vComp)
            enddo
         enddo
      enddo

      average = 0.d0
      do  k=1,kmax
         do i=1,imax/2
            ir = i-1
            sum = zero
            do j=1,jmax
               do ibase=1,imax
                  sum = sum + ug(ibase,j,k)*ug(ibase+ir,j,k)                  
               enddo
            enddo
            corr(ir) = sum
         enddo

         factor = corr(0)
         if (factor.ne.zero) then
            do ir = 0,imax/2-1
               corr(ir) = corr(ir)/factor
            enddo
         endif
         
         sum = 0.d0
         do ir=1,imax/2-1
            sum = sum+half*(corr(ir)+corr(ir-1))*dx(vComp)
         enddo
         
         average = average + sum
         TSL_z(k) = sum
c         write(*,*)" integral scale at k = ",k, " is ", sum         
      enddo

      end

      subroutine FORT_TKE (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,dx,ovlo,ovhi,TKE_z)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T dx(3)
      REAL_T u(1:uhii1-uloi1+1, 1:uhii2-uloi2+1, 1:uhii3-uloi3+1, nvar)
      REAL_T TKE_z(1:uhii3-uloi3+1)

      integer i,j,k,imax,jmax,kmax
      REAL_T average, sum, ave(3), tmp(3)
      
      imax = uhii1-uloi1+1
      jmax = uhii2-uloi2+1
      kmax = uhii3-uloi3+1

c     Turb kinetic energy
      do k=1,kmax
         do n = 1,3
            ave(n) = zero
         end do
         do j=1,jmax
            do i=1,imax
               do n = 1,3
                  ave(n) = ave(n) + u(i,j,k,n)
               end do                
            end do
         end do
         do n = 1,3
            ave(n) = ave(n)/(jmax*imax)
            tmp(n) = zero
         end do
         do j=1,jmax
            do i=1,imax
               do n = 1,3
                  tmp(n) = tmp(n) + (u(i,j,k,n) - ave(n))**2
               end do                
            end do
         end do
         TKE_z(k) = zero
         do n = 1,3
            TKE_z(k) = TKE_z(k) + half*tmp(n)/(jmax*imax)
         end do
      end do
      end

      subroutine FORT_GUS (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,dx,ovlo,ovhi,GUS_z)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T dx(3)
      REAL_T u(1:uhii1-uloi1+1, 1:uhii2-uloi2+1, 1:uhii3-uloi3+1, nvar)
      REAL_T GUS_z(2:uhii3-uloi3)

      integer i,j,k,imax,jmax,kmax
      REAL_T ave(3), uprime(3)
      
      imax = uhii1-uloi1+1
      jmax = uhii2-uloi2+1
      kmax = uhii3-uloi3+1

c     Grad(U) sqrd
      sum = 0.d0
      DO k=2, kmax-1
        sum = zero
        DO n=1,3
          DO j=2, jmax-1
            DO i=2, imax-1
               vx = (u(i+1,j,k,n)-u(i-1,j,k,n))/(2.*dx(1))
               vy = (u(i,j+1,k,n)-u(i,j-1,k,n))/(2.*dx(2))
               vz = (u(i,j,k+1,n)-u(i,j,k-1,n))/(2.*dx(3))
               sum =sum+vx*vx+vy*vy+vz*vz
            ENDDO
          ENDDO
        ENDDO
        GUS_z(k) = sum / dfloat((imax-2)*(jmax-2)*(kmax-2))
      ENDDO


      end

      subroutine FORT_TI (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,dx,ovlo,ovhi,TIz)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T dx(3)
      REAL_T u(1:uhii1-uloi1+1, 1:uhii2-uloi2+1, 1:uhii3-uloi3+1, nvar)
      REAL_T TI_z(1:uhii3-uloi3+1)

      integer i,j,k,imax,jmax,kmax,vComp
      REAL_T average, sum

      vComp = 1
      
      imax = uhii1-uloi1+1
      jmax = uhii2-uloi2+1
      kmax = uhii3-uloi3+1

c     Turbulent intensity (of vComp component)
      do k=1,kmax
         average = zero
         do j=1,jmax
            do i=1,imax
               average= average + u(i,j,k,vComp)
            enddo
         enddo
   
         average = average/dfloat(imax*jmax)

         do j=1,jmax
            do i=1,imax
               sum = sum +(u(i,j,k,vComp)-average)**2
            enddo
         enddo

         sum = dsqrt(sum/dfloat(imax*jmax))
         TI_z(k) = sum
c         write(*,*) "turbulent intensity at ",k," = ",sum
      enddo
      end

      subroutine FORT_TAVG (T,Tloi1,Tloi2,Tloi3,Thii1,Thii2,Thii3,
     $ nvar,dx,ovlo,ovhi,TAVG_z)

      integer Tloi1,Tloi2,Tloi3
      integer Thii1,Thii2,Thii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T dx(3)
      REAL_T T(1:Thii1-Tloi1+1, 1:Thii2-Tloi2+1, 1:Thii3-Tloi3+1, nvar)
      REAL_T TAVG_z(1:Thii3-Tloi3+1)

      integer i,j,k,imax,jmax,kmax
      REAL_T average, sum, avg
      
      imax = Thii1-Tloi1+1
      jmax = Thii2-Tloi2+1
      kmax = Thii3-Tloi3+1

c     Average T
      do k=1,kmax
         TAVG_z(k) = zero
         do j=1,jmax
            do i=1,imax
               TAVG_z(k) = TAVG_z(k) + T(i,j,k,1)
            end do
         end do
         TAVG_z(k) = TAVG_z(k)/(jmax*imax)
      end do
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: DERIVE_2D.F,v 1.20 2002/07/23 17:11:56 lijewski Exp $
c

#include "CONSTANTS.H"
#include "Derived.H"

#define DIM 2

c
c The following routine does NOT have the signature of a derived function.
c
c This routine assumes domain is of form: [(0,0),(xlen,ylen)]
c
       subroutine FORT_RANDMOVE (a,DIMS(c),b,c,d,u,nspec,x,y,spec,
     &                           dx,dy,dt,dxinv,dyinv)

       implicit none

       integer DIMDEC(c), nspec, spec
       REAL_T  x, y, dx, dy, dt, dxinv, dyinv
       REAL_T  a(DIMV(c),0:nspec-1)
       REAL_T  b(DIMV(c),0:nspec-1)
       REAL_T  c(DIMV(c),0:nspec-1)
       REAL_T  d(DIMV(c),0:nspec-1)
       REAL_T  u(DIMV(c),2)

       integer i, ix, iy
       REAL_T  rn

       if (spec.lt.zero.or.spec.ge.nspec) stop 'bad species ref (df)'
       !
       ! First advect stuff ...
       !
       ix = x * dxinv
       iy = y * dyinv

       if ((ix.ge.c_l1.and.ix.le.c_h1) .and.
     &      (iy.ge.c_l2.and.iy.le.c_h2)) then

          x = x + u(ix,iy,1) * dt
          y = y + u(ix,iy,2) * dt

          if (x.lt.zero) x = -x

       end if
       !
       ! Now do the stochastic diffusion ...
       !
       ix = x * dxinv
       iy = y * dyinv

       if ((ix.ge.c_l1.and.ix.le.c_h1) .and.
     &      (iy.ge.c_l2.and.iy.le.c_h2)) then

          call blutilrand(rn)

          if (rn.lt.a(ix,iy,spec)*dt) then
             x = x - dx
          else if (rn.lt.b(ix,iy,spec)*dt) then
             x = x + dx
          else if (rn.lt.c(ix,iy,spec)*dt) then
             y = y - dy
          else if (rn.lt.d(ix,iy,spec)*dt) then
             y = y + dy
          end if

       end if

       end

       subroutine FORT_MAXDTDIFF (d,DIMS(c),nspec,x,y,spec,
     &                            dx,dy,dt,dxinv,dyinv)

       implicit none

       integer DIMDEC(c), nspec, spec
       REAL_T  x, y, dx, dy, dt, dxinv, dyinv
       REAL_T  d(DIMV(c),0:nspec-1)

       integer i, j, ilo, ihi, jlo, jhi, ix, iy
       REAL_T  rn, dmax

       if (spec.lt.zero.or.spec.ge.nspec) stop 'bad species ref (df)'

       ix   = x * dxinv
       iy   = y * dyinv
       dmax = 0

       if ((ix.ge.c_l1.and.ix.le.c_h1) .and.
     &      (iy.ge.c_l2.and.iy.le.c_h2)) then

          ilo = max(ix-2,c_l1)
          ihi = min(ix+2,c_h1)
          jlo = max(iy-2,c_l2)
          jhi = min(iy+2,c_h2)

          do i = ilo, ihi
             do j = jlo, jhi
                dmax = max(dmax,d(i,j,spec))
             end do
          end do

       end if

       if (dmax.gt.zero) dt = min(dt,.1/dmax)

       end
c
c This routine assumes domain is of form: [(0,0),(xlen,ylen)]
c
c conc is really conc.invert(1) so we can multiply instead of divide ...
c
       subroutine FORT_CHEMMOVE (rf,DIMS(c),rr,conc,nspec,nreac,
     &                           edges,edgeslen,pedges,x,y,spec,
     &                           dx,dy,dt,rxn,dxinv,dyinv)

       implicit none

       integer DIMDEC(c), nspec, nreac, spec, rxn
       integer edgeslen, edges(0:edgeslen-1), pedges(0:nspec-1)
       REAL_T  x, y, dx, dy, dt, dxinv, dyinv
       REAL_T  rf(DIMV(c),0:nreac-1)
       REAL_T  rr(DIMV(c),0:nreac-1)
       REAL_T  conc(DIMV(c),0:nspec-1)

       integer i, ix, iy, ie, nedges, rxnid, factor, tospec, nu
       REAL_T  rn, lambda, netreact

       if (spec.lt.zero.or.spec.ge.nspec) stop 'bad species ref (ch)'

       ix = x * dxinv
       iy = y * dyinv

       if ((ix.ge.c_l1.and.ix.le.c_h1) .and.
     &      (iy.ge.c_l2.and.iy.le.c_h2)) then

          call blutilrand(rn)

          if (pedges(spec).lt.zero) stop 'invalid reaction ref (ch)'

          lambda = 0
          nedges = edges(pedges(spec))

          if (nedges.le.zero) stop 'nedges must be positive (ch)'

          do ie = 0, nedges-1

             rxnid  = edges(pedges(spec)+ie*4+1)
             factor = edges(pedges(spec)+ie*4+2)
             tospec = edges(pedges(spec)+ie*4+3)
             nu     = edges(pedges(spec)+ie*4+4)

             if (factor.gt.zero) then
c                netreact = max(rf(ix,iy,rxnid)-rr(ix,iy,rxnid),zero)
                netreact = rf(ix,iy,rxnid)
                lambda   = nu*lambda+netreact*conc(ix,iy,spec)*dt/factor
             else
c                netreact = max(rr(ix,iy,rxnid)-rf(ix,iy,rxnid),zero)
                netreact = rr(ix,iy,rxnid)
                lambda   = nu*lambda-netreact*conc(ix,iy,spec)*dt/factor
             end if

             if (rn.lt.lambda) then
                rxn  = rxnid
                spec = tospec
                goto 100
             end if

          end do

       end if

100    continue

       end

       subroutine FORT_MAXLAMBDA (rf,DIMS(c),rr,conc,nspec,nreac,
     &                            edges,edgeslen,pedges)

       implicit none

       integer DIMDEC(c), nspec, nreac
       integer edgeslen, edges(0:edgeslen-1), pedges(0:nspec-1)
       REAL_T  rf(DIMV(c),0:nreac-1)
       REAL_T  rr(DIMV(c),0:nreac-1)
       REAL_T  conc(DIMV(c),0:nspec-1)

       integer i, ispec, ix, iy, ie, nedges, rxnid, factor, tospec, nu
       REAL_T  rn, lambda, lmax, netreact

       do ispec = 0, nspec-1

          lmax   = 0
          nedges = edges(pedges(ispec))

          do ix = c_l1, c_h1
             do iy = c_l2, c_h2

                lambda = 0

                do ie = 0, nedges-1
                   rxnid  = edges(pedges(ispec)+ie*4+1)
                   factor = edges(pedges(ispec)+ie*4+2)
                   tospec = edges(pedges(ispec)+ie*4+3)
                   nu     = edges(pedges(ispec)+ie*4+4)

                   if (factor.gt.zero) then
c                      netreact = max(rf(ix,iy,rxnid)-rr(ix,iy,rxnid),zero)
                      netreact = rf(ix,iy,rxnid)
                      lambda   = nu*lambda+netreact*conc(ix,iy,ispec)/factor
                   else
c                      netreact = max(rr(ix,iy,rxnid)-rf(ix,iy,rxnid),zero)
                      netreact = rr(ix,iy,rxnid)
                      lambda   = nu*lambda-netreact*conc(ix,iy,ispec)/factor
                   end if
                end do

                lmax = max(lmax,lambda)

             end do
          end do

          write(*,*) 'spec = ', ispec, 'lmax = ', lmax

       end do

       end

       subroutine FORT_MAXDTLAMBDA (rf,DIMS(c),rr,conc,nspec,nreac,
     &                              edges,edgeslen,pedges,x,y,spec,
     &                              dx,dy,dt,dxinv,dyinv)

       implicit none

       integer DIMDEC(c), nspec, nreac, spec
       integer edgeslen, edges(0:edgeslen-1), pedges(0:nspec-1)
       REAL_T  x, y, dx, dy, dt, dxinv, dyinv
       REAL_T  rf(DIMV(c),0:nreac-1)
       REAL_T  rr(DIMV(c),0:nreac-1)
       REAL_T  conc(DIMV(c),0:nspec-1)

       integer i, j, ix, iy, ie, nedges, rxnid, factor, tospec, nu
       integer ilo, ihi, jlo, jhi, ipos
       REAL_T  lambda, lmax, netreact

       if (spec.lt.zero.or.spec.ge.nspec) stop 'bad species ref (ch)'

       ix   = x * dxinv
       iy   = y * dyinv
       lmax = 0

       if (pedges(spec).lt.zero) stop 'invalid reaction ref (ch)'

       lambda = 0
       nedges = edges(pedges(spec))

       if (nedges.le.zero) stop 'nedges must be positive (ch)'

       do ie = 0, nedges-1
          rxnid  = edges(pedges(spec)+ie*4+1)
          factor = edges(pedges(spec)+ie*4+2)
          tospec = edges(pedges(spec)+ie*4+3)
          nu     = edges(pedges(spec)+ie*4+4)

          if (factor.gt.zero) then
c             netreact = max(rf(ix,iy,rxnid)-rr(ix,iy,rxnid),zero)
             netreact = rf(ix,iy,rxnid)
             lambda   = nu*lambda+netreact*conc(ix,iy,spec)/factor
          else
c             netreact = max(rr(ix,iy,rxnid)-rf(ix,iy,rxnid),zero)
             netreact = rr(ix,iy,rxnid)
             lambda   = nu*lambda-netreact*conc(ix,iy,spec)/factor
          end if
       end do

       lmax = max(lmax,lambda)

       if (lmax.gt.zero) dt = min(dt,.1/lmax)

       end

      subroutine FORT_PROBFAB (rf,DIMS(c),rr,prob,DIMS(p),
     &                         nspec,nreac,ispec,
     &                         edges,edgeslen,pedges,isrz,dx,dy)

       implicit none

       integer DIMDEC(c), DIMDEC(p), nspec, nreac, ispec, isrz
       integer edgeslen, edges(0:edgeslen-1), pedges(0:nspec-1)
       REAL_T  rf(DIMV(c),0:nreac-1)
       REAL_T  rr(DIMV(c),0:nreac-1)
       REAL_T  prob(DIMV(p)), dx, dy

       integer ix, iy, ie, nedges, rxnid, factor, nu
       REAL_T  lambda, lmax, vol

       if (ispec.lt.zero.or.ispec.gt.nspec-1) stop 'invalid ispec'

       nedges = edges(pedges(ispec))

       do iy = p_l2, p_h2
          do ix = p_l1, p_h1

             vol = dx*dy

             if (isrz.ne.0) vol = vol*half*Pi*dx*(2*p_l1+1)

             lambda = 0

             do ie = 0, nedges-1

                rxnid  = edges(pedges(ispec)+ie*4+1)
                factor = edges(pedges(ispec)+ie*4+2)
                nu     = edges(pedges(ispec)+ie*4+4)

                if (factor.gt.zero) then
                   lambda = nu*lambda + rf(ix,iy,rxnid)/factor
                else
                   lambda = nu*lambda - rr(ix,iy,rxnid)/factor
                end if

             end do

             prob(ix,iy) = lambda*vol

          end do
       end do

       end

       subroutine FORT_ACCUMPROB (prob, DIMS(p), totreact, cumprob)

       implicit none

       integer DIMDEC(p)
       REAL_T  prob(DIMV(p)), totreact, cumprob

       integer ix, iy

       do iy = p_l2, p_h2
          do ix = p_l1, p_h1

             prob(ix,iy) = cumprob+prob(ix,iy)/totreact
             cumprob     = prob(ix,iy)

          enddo
       enddo

       end

       subroutine FORT_SELECTPOS (prob,DIMS(c),rn,dx,dy,x,y)

       implicit none

       integer DIMDEC(c)
       REAL_T  prob(DIMV(c))
       REAL_T  dx,dy,x,y,rn

       integer ix, iy

       do iy = c_l2, c_h2-1
           if (rn.le.prob(c_h1,iy)) go to 100
       enddo

100    continue

       do ix = c_l1, c_h1-1
          if (rn.le.prob(ix,iy)) go to 200
       enddo

200    continue

       x = (ix+half)*dx
       y = (iy+half)*dy

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define N_STATE 5
#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** MKFLUX **
c ** Create the time-centered edge states for the velocity components
c ***************************************************************

      subroutine FORT_MKFLUX(s,sedgex,sedgey,sedgez,
     $                       slopex,slopey,slopez,uadv,vadv,wadv,
     $                       utrans,vtrans,wtrans,force,
     $                       s_l,s_r,s_b,s_t,s_d,s_u,DIMS,
     $                       dx,dt,visc_coef,bc,velpred,nstart,nend)

      implicit none

      integer DIMS
      integer nstart,nend

      REAL_T       s(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,N_STATE)
      REAL_T  sedgex(lo_1  :hi_1+1,lo_2  :hi_2  ,lo_3  :hi_3  ,N_STATE)
      REAL_T  sedgey(lo_1  :hi_1  ,lo_2  :hi_2+1,lo_3  :hi_3  ,N_STATE)
      REAL_T  sedgez(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3+1,N_STATE)
      REAL_T  slopex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,N_STATE)
      REAL_T  slopey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,N_STATE)
      REAL_T  slopez(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,N_STATE)
      REAL_T    uadv(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T    vadv(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T    wadv(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T  utrans(lo_1-1:hi_1+2,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  vtrans(lo_1-1:hi_1+1,lo_2-1:hi_2+2,lo_3-1:hi_3+1)
      REAL_T  wtrans(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+2)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,nstart:nend)

      REAL_T    s_l(lo_1-1:hi_1+2)
      REAL_T    s_r(lo_1-1:hi_1+2)
      REAL_T    s_b(lo_2-1:hi_2+2)
      REAL_T    s_t(lo_2-1:hi_2+2)
      REAL_T    s_d(lo_3-1:hi_3+2)
      REAL_T    s_u(lo_3-1:hi_3+2)

      REAL_T  dx(3)
      REAL_T  dt
      REAL_T  visc_coef
      integer bc(2,3)
      integer velpred

c     Local variables
      REAL_T ubardth, vbardth, wbardth
      REAL_T hx, hy, hz, dth
      REAL_T splus,sminus,st,str,savg
      REAL_T sptop,spbot,smtop,smbot,splft,sprgt,smlft,smrgt
      logical test

      REAL_T eps

      integer i,j,k,is,js,ks,ie,je,ke,n

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      dth = half*dt

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

c ::: loop for x fluxes

      do n = nstart,nend
       if (velpred .eq. 0 .or. n .eq. 1) then
        do k = ks,ke 
        do j = js,je 
         do i = is-1,ie+1 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Y-DIRECTION
c        ******************************************************************

          spbot = s(i,j  ,k,n) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,n)
c    $            + dth * force(i,  j,k,n)
          sptop = s(i,j+1,k,n) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,n)
c    $            + dth * force(i,j+1,k,n)

          sptop = cvmgt(s(i,je+1,k,n),sptop,j.eq.je .and. BCY_HI .eq. INLET)
          spbot = cvmgt(s(i,je+1,k,n),spbot,j.eq.je .and. BCY_HI .eq. INLET)

          if (j .eq. je .and. BCY_HI .eq. WALL) then
            if (n .eq. 2) then
              sptop = zero
              spbot = zero
            else if (n .eq. 1 .or. n .eq. 3) then
              sptop = cvmgt(zero,spbot,visc_coef .gt. zero)
              spbot = cvmgt(zero,spbot,visc_coef .gt. zero)
            else
              sptop = spbot
            endif
          endif

          splus = cvmgp(spbot,sptop,vtrans(i,j+1,k))
          savg  = half * (spbot + sptop)
          splus = cvmgt(splus, savg, abs(vtrans(i,j+1,k)) .gt. eps)

          smtop = s(i,j  ,k,n) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,n)
c    $            + dth * force(i,j  ,k,n)
          smbot = s(i,j-1,k,n) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,n)
c    $            + dth * force(i,j-1,k,n)

          smtop = cvmgt(s(i,js-1,k,n),smtop,j.eq.js .and. BCY_LO .eq. INLET)
          smbot = cvmgt(s(i,js-1,k,n),smbot,j.eq.js .and. BCY_LO .eq. INLET)

          if (j .eq. js .and. BCY_LO .eq. WALL) then
            if (n .eq. 2) then
              smtop = zero
              smbot = zero
            else if (n .eq. 1 .or. n .eq. 3) then
              smtop = cvmgt(zero,smtop,visc_coef .gt. zero)
              smbot = cvmgt(zero,smtop,visc_coef .gt. zero)
            else
              smbot = smtop
            endif
          endif

          sminus = cvmgp(smbot,smtop,vtrans(i,j,k))
          savg   = half * (smbot + smtop)
          sminus = cvmgt(sminus, savg, abs(vtrans(i,j,k)) .gt. eps)

          str =  half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(splus - sminus) / hy

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Z-DIRECTION
c        ******************************************************************

          spbot = s(i,j,k  ,n) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,n)
c    $            + dth * force(i,j,k  ,n)
          sptop = s(i,j,k+1,n) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,n)
c    $            + dth * force(i,j,k+1,n)

          sptop = cvmgt(s(i,j,ke+1,n),sptop,k.eq.ke .and. BCZ_HI .eq. INLET)
          spbot = cvmgt(s(i,j,ke+1,n),spbot,k.eq.ke .and. BCZ_HI .eq. INLET)

          if (k .eq. ke .and. BCZ_HI .eq. WALL) then
            if (n .eq. 3) then
              sptop = zero
              spbot = zero
            else if (n .eq. 1 .or. n .eq. 2) then
              sptop = cvmgt(zero,spbot,visc_coef .gt. zero)
              spbot = cvmgt(zero,spbot,visc_coef .gt. zero)
            else
              sptop = spbot
            endif
          endif

          splus = cvmgp(spbot,sptop,wtrans(i,j,k+1))
          savg  = half * (spbot + sptop)
          splus = cvmgt(splus, savg, abs(wtrans(i,j,k+1)) .gt. eps)

          smtop = s(i,j,k  ,n) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,n)
c    $            + dth * force(i,j,k  ,n)
          smbot = s(i,j,k-1,n) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,n)
c    $            + dth * force(i,j,k-1,n)

          smtop = cvmgt(s(i,j,ks-1,n),smtop,k.eq.ks .and. BCZ_LO .eq. INLET)
          smbot = cvmgt(s(i,j,ks-1,n),smbot,k.eq.ks .and. BCZ_LO .eq. INLET)

          if (k .eq. ks .and. BCZ_LO .eq. WALL) then
            if (n .eq. 3) then
              smtop = zero
              smbot = zero
            else if (n .eq. 1 .or. n .eq. 2) then
              smtop = cvmgt(zero,smtop,visc_coef .gt. zero)
              smbot = cvmgt(zero,smtop,visc_coef .gt. zero)
            else 
              smbot = smtop
            endif
          endif

          sminus = cvmgp(smbot,smtop,wtrans(i,j,k))
          savg   = half * (smbot + smtop)
          sminus = cvmgt(sminus, savg, abs(wtrans(i,j,k)) .gt. eps)

          str = str + half * (wtrans(i,j,k)+wtrans(i,j,k+1))*
     $                       (splus - sminus) / hz

c        ******************************************************************
c        MAKE LEFT AND RIGHT STATES
c        ******************************************************************

          st = force(i,j,k,n) - str
          ubardth = dth*s(i,j,k,1)/hx

          s_l(i+1)= s(i,j,k,n) + (half-ubardth)*slopex(i,j,k,n) + dth*st
          s_r(i  )= s(i,j,k,n) - (half+ubardth)*slopex(i,j,k,n) + dth*st

        enddo

        if (velpred .eq. 1) then
          do i = is, ie+1 
            savg = half*(s_r(i) + s_l(i))
            test = ( (s_l(i) .le. zero  .and.
     $                s_r(i) .ge. zero)  .or.
     $              (abs(s_l(i) + s_r(i)) .lt. eps) )
            sedgex(i,j,k,n)=cvmgp(s_l(i),s_r(i),savg)
            sedgex(i,j,k,n)=cvmgt(savg,sedgex(i,j,k,n),test)
          enddo
        else
          do i = is, ie+1 
            sedgex(i,j,k,n)=cvmgp(s_l(i),s_r(i),uadv(i,j,k))
            savg = half*(s_r(i) + s_l(i))
            sedgex(i,j,k,n)=cvmgt(savg,sedgex(i,j,k,n),abs(uadv(i,j,k)) .lt. eps)
          enddo
        endif

        if (BCX_LO .eq. WALL) then
          if (n .eq. 1) then
            sedgex(is,j,k,n) = zero
          else if (n .eq. 2 .or. n .eq. 3) then
            sedgex(is,j,k,n) = cvmgt(zero,s_r(is),visc_coef .gt. 0.0)
          else 
            sedgex(is,j,k,n) = s_r(is)
          endif
        elseif (BCX_LO .eq. INLET) then
          sedgex(is,j,k,n) = s(is-1,j,k,n)
        elseif (BCX_LO .eq. OUTLET) then
          sedgex(is,j,k,n) = s_r(is)
        endif

        if (BCX_HI .eq. WALL) then
          if (n .eq. 1) then
            sedgex(ie+1,j,k,n) = zero
          else if (n .eq. 2 .or. n .eq. 3) then
            sedgex(ie+1,j,k,n) = cvmgt(zero,s_l(ie+1),visc_coef .gt. 0.0)
          else 
            sedgex(ie+1,j,k,n) = s_l(ie+1)
          endif
        elseif (BCX_HI .eq. INLET) then
          sedgex(ie+1,j,k,n) = s(ie+1,j,k,n)
        elseif (BCX_HI .eq. OUTLET) then
          sedgex(ie+1,j,k,n) = s_l(ie+1)
        endif

        if (velpred .eq. 1) then
          do i = is, ie+1 
            uadv(i,j,k) = sedgex(i,j,k,1)
          enddo
        endif

        enddo
        enddo
       endif
      enddo

c        ******************************************************************
c        ******************************************************************
c        ******************************************************************

c ::: loop for y fluxes

      do n = nstart,nend
       if (velpred .eq. 0 .or. n .eq. 2) then
       do k = ks, ke 
       do i = is, ie 
        do j = js-1, je+1 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN X-DIRECTION
c        ******************************************************************

          splft = s(i  ,j,k,n) + (half - dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,n)
c    $            + dth * force(i  ,j,k,n)
          sprgt = s(i+1,j,k,n) - (half + dth*s(i+1,j,k,1)/hx)*slopex(i+1,j,k,n)
c    $            + dth * force(i+1,j,k,n)

          sprgt = cvmgt(s(ie+1,j,k,n),sprgt,i.eq.ie .and. BCX_HI .eq. INLET)
          splft = cvmgt(s(ie+1,j,k,n),splft,i.eq.ie .and. BCX_HI .eq. INLET)

          if (i .eq. ie .and. BCX_HI .eq. WALL) then
            if (n .eq. 1) then
              sprgt = zero
              splft = zero
            else if (n .eq. 2 .or. n .eq. 3) then
              sprgt = cvmgt(zero,splft,visc_coef .gt. zero)
              splft = cvmgt(zero,splft,visc_coef .gt. zero)
            else
              sprgt = splft
            endif
          endif

          splus = cvmgp(splft,sprgt,utrans(i+1,j,k))
          savg  = half * (splft + sprgt)
          splus = cvmgt(splus, savg, abs(utrans(i+1,j,k)) .gt. eps)

          smrgt = s(i  ,j,k,n) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,n)
c    $            + dth * force(i  ,j,k,n)
          smlft = s(i-1,j,k,n) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,n)
c    $            + dth * force(i-1,j,k,n)

          smrgt = cvmgt(s(is-1,j,k,n),smrgt,i.eq.is .and. BCX_LO .eq. INLET)
          smlft = cvmgt(s(is-1,j,k,n),smlft,i.eq.is .and. BCX_LO .eq. INLET)

          if (i .eq. is .and. BCX_LO .eq. WALL) then
            if (n .eq. 1) then
              smrgt = zero
              smlft = zero
            else if (n .eq. 2 .or. n .eq. 3) then
              smrgt = cvmgt(zero,smrgt,visc_coef .gt. zero)
              smlft = cvmgt(zero,smrgt,visc_coef .gt. zero)
            else
              smlft = smrgt
            endif
          endif
 
          sminus = cvmgp(smlft,smrgt,utrans(i,j,k))
          savg   = half * (smlft + smrgt)
          sminus = cvmgt(sminus, savg, abs(utrans(i,j,k)) .gt. eps)

          str    = half * (utrans(i,j,k)+utrans(i+1,j,k))*(splus - sminus) / hx

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Z-DIRECTION
c        ******************************************************************

          spbot = s(i,j,k  ,n) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,n)
c    $            + dth * force(i,j,k  ,n)
          sptop = s(i,j,k+1,n) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,n)
c    $            + dth * force(i,j,k+1,n)

          sptop = cvmgt(s(i,j,ke+1,n),sptop,k.eq.ke .and. BCZ_HI .eq. INLET)
          spbot = cvmgt(s(i,j,ke+1,n),spbot,k.eq.ke .and. BCZ_HI .eq. INLET)

          if (k .eq. ke .and. BCZ_HI .eq. WALL) then
            if (n .eq. 3) then
              sptop = zero
              spbot = zero
            else if (n .eq. 1 .or. n .eq. 2) then
              sptop = cvmgt(zero,spbot,visc_coef .gt. zero)
              spbot = cvmgt(zero,spbot,visc_coef .gt. zero)
            else
              sptop = spbot
            endif
          endif

          splus = cvmgp(spbot,sptop,wtrans(i,j,k+1))
          savg  = half * (spbot + sptop)
          splus = cvmgt(splus, savg, abs(wtrans(i,j,k+1)) .gt. eps)

          smtop = s(i,j,k  ,n) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,n)
c    $            + dth * force(i,j,k  ,n)
          smbot = s(i,j,k-1,n) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,n)
c    $            + dth * force(i,j,k-1,n)

          smtop = cvmgt(s(i,j,ks-1,n),smtop,k.eq.ke .and. BCZ_LO .eq. INLET)
          smbot = cvmgt(s(i,j,ks-1,n),smbot,k.eq.ke .and. BCZ_LO .eq. INLET)

          if (k .eq. ks  .and.  BCZ_LO .eq. WALL) then
            if (n .eq. 3) then
              smtop = zero
              smbot = zero
            else if (n .eq. 1 .or. n .eq. 2) then
              smbot = cvmgt(zero,smtop,visc_coef .gt. zero)
              smtop = cvmgt(zero,smtop,visc_coef .gt. zero)
            else
              smbot = smtop
            endif
          endif

          sminus = cvmgp(smbot,smtop,wtrans(i,j,k))
          savg   = half * (smbot + smtop)
          sminus = cvmgt(sminus, savg, abs(wtrans(i,j,k)) .gt. eps)

          str = str + half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(splus - sminus) / hz

c        ******************************************************************
c        MAKE TOP AND BOTTOM STATES
c        ******************************************************************

          st = force(i,j,k,n) - str

          vbardth = dth*s(i,j,k,2)/hy

          s_b(j+1)= s(i,j,k,n) + (half-vbardth)*slopey(i,j,k,n) + dth*st
          s_t(j  )= s(i,j,k,n) - (half+vbardth)*slopey(i,j,k,n) + dth*st
        enddo

        if (velpred .eq. 1) then
          do j = js, je+1 
            savg = half*(s_t(j) + s_b(j))
            test = ( (s_b(j) .le. zero  .and.
     $                s_t(j) .ge. zero)  .or.
     $             (abs(s_b(j) + s_t(j)) .lt. eps) )
            sedgey(i,j,k,n)=cvmgp(s_b(j),s_t(j),savg)
            sedgey(i,j,k,n)=cvmgt(savg,sedgey(i,j,k,n),test)
          enddo
        else
          do j = js, je+1 
            sedgey(i,j,k,n)=cvmgp(s_b(j),s_t(j),vadv(i,j,k))
            savg = half*(s_t(j) + s_b(j))
            sedgey(i,j,k,n)=cvmgt(savg,sedgey(i,j,k,n),abs(vadv(i,j,k)) .lt. eps)
          enddo
        endif

        if (BCY_LO .eq. WALL) then
          if (n .eq. 2) then
            sedgey(i,js,k,n) = zero
          else if (n .eq. 1 .or. n .eq. 3) then
            sedgey(i,js,k,n) = cvmgt(zero,s_t(js),visc_coef .gt. 0.0)
          else
            sedgey(i,js,k,n) = s_t(js)
          endif
        elseif (BCY_LO .eq. INLET) then
          sedgey(i,js,k,n) = s(i,js-1,k,n)
        elseif (BCY_LO .eq. OUTLET) then
          sedgey(i,js,k,n) = s_t(js)
        endif

        if (BCY_HI .eq. WALL) then
          if (n .eq. 2) then
            sedgey(i,je+1,k,n) = zero
          else if (n .eq. 1 .or. n .eq. 3) then
            sedgey(i,je+1,k,n) = cvmgt(zero,s_b(je+1),visc_coef .gt. 0.0)
          else
            sedgey(i,je+1,k,n) = s_b(je+1)
          endif
        elseif (BCY_HI .eq. INLET) then
          sedgey(i,je+1,k,n) = s(i,je+1,k,n)
        elseif (BCY_HI .eq. OUTLET) then
          sedgey(i,je+1,k,n) = s_b(je+1)
        endif

        if (velpred .eq. 1) then
          do j = js, je+1 
            vadv(i,j,k) = sedgey(i,j,k,2)
          enddo
        endif

        enddo
        enddo
       endif
      enddo

c        ******************************************************************
c        ******************************************************************
c        ******************************************************************

c ::: loop for z fluxes

      do n = nstart,nend
        if (velpred .eq. 0 .or. n .eq. 3) then
        do j = js, je 
        do i = is, ie 
          do k = ks-1, ke+1 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN X-DIRECTION
c        ******************************************************************

          splft = s(i  ,j,k,n) + (half - dth*s(i  ,j,k,1)/hx) * slopex(i  ,j,k,n)
c    $            + dth * force(i  ,j,k,n)
          sprgt = s(i+1,j,k,n) - (half + dth*s(i+1,j,k,1)/hx) * slopex(i+1,j,k,n)
c    $            + dth * force(i+1,j,k,n)

          sprgt = cvmgt(s(ie+1,j,k,n),sprgt,i.eq.ie .and. BCX_HI .eq. INLET)
          splft = cvmgt(s(ie+1,j,k,n),splft,i.eq.ie .and. BCX_HI .eq. INLET)

          if (i .eq. ie  .and.  BCX_HI .eq. WALL) then
            if (n .eq. 1) then
              sprgt = zero
              splft = zero
            else if (n .eq. 2 .or. n .eq. 3) then
              sprgt = cvmgt(zero,splft,visc_coef .gt. zero)
              splft = cvmgt(zero,splft,visc_coef .gt. zero)
            else
              sprgt = splft
            endif
          endif

          splus = cvmgp(splft,sprgt,utrans(i+1,j,k))
          savg  = half * (splft + sprgt)
          splus = cvmgt(splus, savg, abs(utrans(i+1,j,k)) .gt. eps)

          smrgt = s(i  ,j,k,n) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,n)
c    $            + dth * force(i  ,j,k,n)
          smlft = s(i-1,j,k,n) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,n)
c    $            + dth * force(i-1,j,k,n)

          smrgt = cvmgt(s(is-1,j,k,n),smrgt,i.eq.is .and. BCX_LO .eq. INLET)
          smlft = cvmgt(s(is-1,j,k,n),smlft,i.eq.is .and. BCX_LO .eq. INLET)

          if (i .eq. is  .and.  BCX_LO .eq. WALL) then
            if (n .eq. 1) then
              smrgt = zero
              smlft = zero
            else if (n .eq. 2 .or. n .eq. 3) then
              smrgt = cvmgt(zero,smrgt,visc_coef .gt. zero)
              smlft = cvmgt(zero,smrgt,visc_coef .gt. zero)
            else
              smlft = smrgt
            endif
          endif
 
          sminus = cvmgp(smlft,smrgt,utrans(i,j,k))
          savg   = half * (smlft + smrgt)
          sminus = cvmgt(sminus, savg, abs(utrans(i,j,k)) .gt. eps)

          str = half * (utrans(i,j,k)+utrans(i+1,j,k))*(splus - sminus) / hx

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Y-DIRECTION
c        ******************************************************************

          spbot = s(i,j  ,k,n) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,n)
c    $            + dth * force(i,  j,k,n)
          sptop = s(i,j+1,k,n) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,n)
c    $            + dth * force(i,j+1,k,n)

          sptop = cvmgt(s(i,je+1,k,n),sptop,j.eq.je .and. BCY_HI .eq. INLET)
          spbot = cvmgt(s(i,je+1,k,n),spbot,j.eq.je .and. BCY_HI .eq. INLET)

          if (j .eq. je .and. BCY_HI .eq. WALL) then
            if (n .eq. 2) then
              sptop = zero
              spbot = zero
            else if (n .eq. 1 .or. n .eq. 3) then
              sptop = cvmgt(zero,spbot,visc_coef .gt. zero)
              spbot = cvmgt(zero,spbot,visc_coef .gt. zero)
            else
              sptop = spbot
            endif
          endif

          splus = cvmgp(spbot,sptop,vtrans(i,j+1,k))
          savg  = half * (spbot + sptop)
          splus = cvmgt(splus, savg, abs(vtrans(i,j+1,k)) .gt. eps)

          smtop = s(i,j  ,k,n) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,n)
c    $            + dth * force(i,j  ,k,n)
          smbot = s(i,j-1,k,n) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,n)
c    $            + dth * force(i,j-1,k,n)

          smtop = cvmgt(s(i,js-1,k,n),smtop,j.eq.js .and. BCY_LO .eq. INLET)
          smbot = cvmgt(s(i,js-1,k,n),smbot,j.eq.js .and. BCY_LO .eq. INLET)

          if (j .eq. js  .and.  BCY_LO .eq. WALL) then
            if (n .eq. 2) then
              smtop = zero
              smbot = zero
            else if (n .eq. 1 .or. n .eq. 3) then
              smtop = cvmgt(zero,smtop,visc_coef .gt. zero)
              smbot = cvmgt(zero,smtop,visc_coef .gt. zero)
            else
              smbot = smtop
            endif
          endif

          sminus = cvmgp(smbot,smtop,vtrans(i,j,k))
          savg   = half * (smbot + smtop)
          sminus = cvmgt(sminus, savg, abs(vtrans(i,j,k)) .gt. eps)

          str =  str + half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(splus - sminus) / hy

c        ******************************************************************
c        MAKE DOWN AND UP STATES
c        ******************************************************************

          st = force(i,j,k,n) - str

          wbardth = dth*s(i,j,k,3)/hz

          s_d(k+1)= s(i,j,k,n) + (half-wbardth)*slopez(i,j,k,n) + dth*st
          s_u(k  )= s(i,j,k,n) - (half+wbardth)*slopez(i,j,k,n) + dth*st

        enddo

        if (velpred .eq. 1) then
          do k = ks, ke+1 
            savg = half*(s_d(k) + s_u(k))
            test = ( (s_d(k) .le. zero  .and.
     $                s_u(k) .ge. zero)  .or.
     $             (abs(s_d(k) + s_u(k)) .lt. eps) )
            sedgez(i,j,k,n)=cvmgp(s_d(k),s_u(k),savg)
            sedgez(i,j,k,n)=cvmgt(savg,sedgez(i,j,k,n),test)
          enddo
        else
          do k = ks, ke+1 
            sedgez(i,j,k,n)=cvmgp(s_d(k),s_u(k),wadv(i,j,k))
            savg = half*(s_d(k) + s_u(k))
            sedgez(i,j,k,n)=cvmgt(savg,sedgez(i,j,k,n),abs(wadv(i,j,k)) .lt. eps)
          enddo
        endif

        if (BCZ_LO .eq. WALL) then
          if (n .eq. 3) then
            sedgez(i,j,ks,n) = zero
          else if (n .eq. 1 .or. n .eq. 2) then
            sedgez(i,j,ks,n) = cvmgt(zero,s_u(ks),visc_coef .gt. 0.0)
          else
            sedgez(i,j,ks,n) = s_u(ks)
          endif
        elseif (BCZ_LO .eq. INLET) then
          sedgez(i,j,ks,n) = s(i,j,ks-1,n)
        elseif (BCZ_LO .eq. OUTLET) then
          sedgez(i,j,ks,n) = s_u(ks)
        endif

        if (BCZ_HI .eq. WALL) then
          if (n .eq. 3) then
            sedgez(i,j,ke+1,n) = zero
          else if (n .eq. 1 .or. n .eq. 2) then
            sedgez(i,j,ke+1,n) = cvmgt(zero,s_d(ke+1),visc_coef .gt. 0.0)
          else
            sedgez(i,j,ke+1,n) = s_d(ke+1)
          endif
        elseif (BCZ_HI .eq. INLET) then
          sedgez(i,j,ke+1,n) = s(i,j,ke+1,n)
        elseif (BCZ_HI .eq. OUTLET) then
          sedgez(i,j,ke+1,n) = s_d(ke+1)
        endif

        if (velpred .eq. 1) then
          do k = ks, ke+1 
            wadv(i,j,k) = sedgez(i,j,k,3)
          enddo
        endif

        enddo
        enddo
       endif
      enddo

      return
      end

c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along face
      subroutine hgfres(
     & res,    resl0,resh0,resl1,resh1,resl2,resh2,
     & src,    srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & fdst,   fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2,
     & cdst,   cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2,
     & sigmaf, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & sigmac, scl0,sch0,scl1,sch1,scl2,sch2,
     &         regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz, ir, jr, kr, idim, idir,idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2
      integer cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1,fdstl2:fdsth2)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1,cdstl2:cdsth2)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigmac(scl0:sch0,scl1:sch1,scl2:sch2)
      double precision hx, hy, hz
      integer ir, jr, kr, idim, idir
      integer idd
      double precision hxm2, hym2, hzm2, fac0, fac1, fac2, tmp
      integer i, j, k, is, js, ks, l, m, n
      if (idim .eq. 0) then
         i = regl0
         if (idir .eq. 1) then
            is = i - 1
         else
            is = i
         end if
         fac0 = 0.5D0 * ir / (ir + 1.0D0)
         hxm2 = 1.0D0 / (ir * ir * hx * hx)
         hym2 = 1.0D0 / (jr * jr * hy * hy)
         hzm2 = 1.0D0 / (kr * kr * hz * hz)
         do k = regl2, regh2
            do j = regl1, regh1
               res(i*ir,j*jr,k*kr) =
     &           src(i*ir,j*jr,k*kr) - fac0 *
     &             (hxm2 *
     &               ((sigmac(is,j-1,k-1) + sigmac(is,j-1,k) +
     &                 sigmac(is,j,k-1)   + sigmac(is,j,k)) *
     &                 (cdst(i-idir,j,k) - cdst(i,j,k))) +
     &              hym2 *
     &               ((sigmac(is,j-1,k-1) + sigmac(is,j-1,k)) *
     &                 (cdst(i,j-1,k) - cdst(i,j,k)) +
     &                (sigmac(is,j,k-1) + sigmac(is,j,k)) *
     &                 (cdst(i,j+1,k) - cdst(i,j,k))) +
     &              hzm2 *
     &               ((sigmac(is,j-1,k-1) + sigmac(is,j,k-1)) *
     &                 (cdst(i,j,k-1) - cdst(i,j,k)) +
     &                (sigmac(is,j-1,k) + sigmac(is,j,k)) *
     &                 (cdst(i,j,k+1) - cdst(i,j,k))))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * jr * kr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         hzm2 = kr * kr * hzm2
         i = i * ir
         if (idir .eq. 1) then
            is = i
         else
            is = i - 1
         end if
         do l = 0, kr-1
            fac2 = (kr-l) * fac0
            if (l .eq. 0) fac2 = 0.5D0 * fac2
            do n = 0, jr-1
               fac1 = (jr-n) * fac2
               if (n .eq. 0) fac1 = 0.5D0 * fac1
               do k = kr*regl2, kr*regh2, kr
                  do j = jr*regl1, jr*regh1, jr
                     tmp = hxm2 *
     &                 ((sigmaf(is,j-n-1,k-l-1) + sigmaf(is,j-n-1,k-l) +
     &                   sigmaf(is,j-n,k-l-1) + sigmaf(is,j-n,k-l)) *
     &                   (fdst(i+idir,j-n,k-l) - fdst(i,j-n,k-l)) +
     &                  (sigmaf(is,j-n-1,k+l-1) + sigmaf(is,j-n-1,k+l) +
     &                   sigmaf(is,j-n,k+l-1) + sigmaf(is,j-n,k+l)) *
     &                   (fdst(i+idir,j-n,k+l) - fdst(i,j-n,k+l)) +
     &                  (sigmaf(is,j+n-1,k-l-1) + sigmaf(is,j+n-1,k-l) +
     &                   sigmaf(is,j+n,k-l-1) + sigmaf(is,j+n,k-l)) *
     &                   (fdst(i+idir,j+n,k-l) - fdst(i,j+n,k-l)) +
     &                  (sigmaf(is,j+n-1,k+l-1) + sigmaf(is,j+n-1,k+l) +
     &                   sigmaf(is,j+n,k+l-1) + sigmaf(is,j+n,k+l)) *
     &                   (fdst(i+idir,j+n,k+l) - fdst(i,j+n,k+l)))
                     tmp = tmp + hym2 *
     &                ((sigmaf(is,j-n-1,k-l-1) + sigmaf(is,j-n-1,k-l)) *
     &                   (fdst(i,j-n-1,k-l) - fdst(i,j-n,k-l)) +
     &                  (sigmaf(is,j-n,k-l-1) + sigmaf(is,j-n,k-l)) *
     &                   (fdst(i,j-n+1,k-l) - fdst(i,j-n,k-l)) +
     &                 (sigmaf(is,j-n-1,k+l-1) + sigmaf(is,j-n-1,k+l)) *
     &                   (fdst(i,j-n-1,k+l) - fdst(i,j-n,k+l)) +
     &                  (sigmaf(is,j-n,k+l-1) + sigmaf(is,j-n,k+l)) *
     &                   (fdst(i,j-n+1,k+l) - fdst(i,j-n,k+l)) +
     &                 (sigmaf(is,j+n-1,k-l-1) + sigmaf(is,j+n-1,k-l)) *
     &                   (fdst(i,j+n-1,k-l) - fdst(i,j+n,k-l)) +
     &                  (sigmaf(is,j+n,k-l-1) + sigmaf(is,j+n,k-l)) *
     &                   (fdst(i,j+n+1,k-l) - fdst(i,j+n,k-l)) +
     &                 (sigmaf(is,j+n-1,k+l-1) + sigmaf(is,j+n-1,k+l)) *
     &                   (fdst(i,j+n-1,k+l) - fdst(i,j+n,k+l)) +
     &                  (sigmaf(is,j+n,k+l-1) + sigmaf(is,j+n,k+l)) *
     &                   (fdst(i,j+n+1,k+l) - fdst(i,j+n,k+l)))
                  res(i,j,k) = res(i,j,k) - fac1 * (tmp + hzm2 *
     &                ((sigmaf(is,j-n-1,k-l-1) + sigmaf(is,j-n,k-l-1)) *
     &                   (fdst(i,j-n,k-l-1) - fdst(i,j-n,k-l)) +
     &                  (sigmaf(is,j-n-1,k-l) + sigmaf(is,j-n,k-l)) *
     &                   (fdst(i,j-n,k-l+1) - fdst(i,j-n,k-l)) +
     &                 (sigmaf(is,j-n-1,k+l-1) + sigmaf(is,j-n,k+l-1)) *
     &                   (fdst(i,j-n,k+l-1) - fdst(i,j-n,k+l)) +
     &                  (sigmaf(is,j-n-1,k+l) + sigmaf(is,j-n,k+l)) *
     &                   (fdst(i,j-n,k+l+1) - fdst(i,j-n,k+l)) +
     &                 (sigmaf(is,j+n-1,k-l-1) + sigmaf(is,j+n,k-l-1)) *
     &                   (fdst(i,j+n,k-l-1) - fdst(i,j+n,k-l)) +
     &                  (sigmaf(is,j+n-1,k-l) + sigmaf(is,j+n,k-l)) *
     &                   (fdst(i,j+n,k-l+1) - fdst(i,j+n,k-l)) +
     &                 (sigmaf(is,j+n-1,k+l-1) + sigmaf(is,j+n,k+l-1)) *
     &                   (fdst(i,j+n,k+l-1) - fdst(i,j+n,k+l)) +
     &                  (sigmaf(is,j+n-1,k+l) + sigmaf(is,j+n,k+l)) *
     &                   (fdst(i,j+n,k+l+1) - fdst(i,j+n,k+l))))
                  end do
               end do
            end do
         end do
      else if (idim .eq. 1) then
         j = regl1
         if (idir .eq. 1) then
            js = j - 1
         else
            js = j
         end if
         fac0 = 0.5D0 * jr / (jr + 1.0D0)
         hxm2 = 1.0D0 / (ir * ir * hx * hx)
         hym2 = 1.0D0 / (jr * jr * hy * hy)
         hzm2 = 1.0D0 / (kr * kr * hz * hz)
         do k = regl2, regh2
            do i = regl0, regh0
               res(i*ir,j*jr,k*kr) =
     &           src(i*ir,j*jr,k*kr) - fac0 *
     &             (hxm2 *
     &               ((sigmac(i-1,js,k-1) + sigmac(i-1,js,k)) *
     &                 (cdst(i-1,j,k) - cdst(i,j,k)) +
     &                (sigmac(i,js,k-1) + sigmac(i,js,k)) *
     &                 (cdst(i+1,j,k) - cdst(i,j,k))) +
     &              hym2 *
     &               ((sigmac(i-1,js,k-1) + sigmac(i-1,js,k) +
     &                 sigmac(i,js,k-1)   + sigmac(i,js,k)) *
     &                 (cdst(i,j-idir,k) - cdst(i,j,k))) +
     &              hzm2 *
     &               ((sigmac(i-1,js,k-1) + sigmac(i,js,k-1)) *
     &                 (cdst(i,j,k-1) - cdst(i,j,k)) +
     &                (sigmac(i-1,js,k) + sigmac(i,js,k)) *
     &                 (cdst(i,j,k+1) - cdst(i,j,k))))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * ir * kr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         hzm2 = kr * kr * hzm2
         j = j * jr
         if (idir .eq. 1) then
            js = j
         else
            js = j - 1
         end if
         do l = 0, kr-1
            fac2 = (kr-l) * fac0
            if (l .eq. 0) fac2 = 0.5D0 * fac2
            do m = 0, ir-1
               fac1 = (ir-m) * fac2
               if (m .eq. 0) fac1 = 0.5D0 * fac1
               do k = kr*regl2, kr*regh2, kr
                  do i = ir*regl0, ir*regh0, ir
                     tmp = hxm2 *
     &                ((sigmaf(i-m-1,js,k-l-1) + sigmaf(i-m-1,js,k-l)) *
     &                   (fdst(i-m-1,j,k-l) - fdst(i-m,j,k-l)) +
     &                  (sigmaf(i-m,js,k-l-1) + sigmaf(i-m,js,k-l)) *
     &                   (fdst(i-m+1,j,k-l) - fdst(i-m,j,k-l)) +
     &                 (sigmaf(i-m-1,js,k+l-1) + sigmaf(i-m-1,js,k+l)) *
     &                   (fdst(i-m-1,j,k+l) - fdst(i-m,j,k+l)) +
     &                  (sigmaf(i-m,js,k+l-1) + sigmaf(i-m,js,k+l)) *
     &                   (fdst(i-m+1,j,k+l) - fdst(i-m,j,k+l)) +
     &                 (sigmaf(i+m-1,js,k-l-1) + sigmaf(i+m-1,js,k-l)) *
     &                   (fdst(i+m-1,j,k-l) - fdst(i+m,j,k-l)) +
     &                  (sigmaf(i+m,js,k-l-1) + sigmaf(i+m,js,k-l)) *
     &                   (fdst(i+m+1,j,k-l) - fdst(i+m,j,k-l)) +
     &                 (sigmaf(i+m-1,js,k+l-1) + sigmaf(i+m-1,js,k+l)) *
     &                   (fdst(i+m-1,j,k+l) - fdst(i+m,j,k+l)) +
     &                  (sigmaf(i+m,js,k+l-1) + sigmaf(i+m,js,k+l)) *
     &                   (fdst(i+m+1,j,k+l) - fdst(i+m,j,k+l)))
                     tmp = tmp + hym2 *
     &                 ((sigmaf(i-m-1,js,k-l-1) + sigmaf(i-m-1,js,k-l) +
     &                   sigmaf(i-m,js,k-l-1) + sigmaf(i-m,js,k-l)) *
     &                   (fdst(i-m,j+idir,k-l) - fdst(i-m,j,k-l)) +
     &                  (sigmaf(i-m-1,js,k+l-1) + sigmaf(i-m-1,js,k+l) +
     &                   sigmaf(i-m,js,k+l-1) + sigmaf(i-m,js,k+l)) *
     &                   (fdst(i-m,j+idir,k+l) - fdst(i-m,j,k+l)) +
     &                  (sigmaf(i+m-1,js,k-l-1) + sigmaf(i+m-1,js,k-l) +
     &                   sigmaf(i+m,js,k-l-1) + sigmaf(i+m,js,k-l)) *
     &                   (fdst(i+m,j+idir,k-l) - fdst(i+m,j,k-l)) +
     &                  (sigmaf(i+m-1,js,k+l-1) + sigmaf(i+m-1,js,k+l) +
     &                   sigmaf(i+m,js,k+l-1) + sigmaf(i+m,js,k+l)) *
     &                   (fdst(i+m,j+idir,k+l) - fdst(i+m,j,k+l)))
                  res(i,j,k) = res(i,j,k) - fac1 * (tmp + hzm2 *
     &                ((sigmaf(i-m-1,js,k-l-1) + sigmaf(i-m,js,k-l-1)) *
     &                   (fdst(i-m,j,k-l-1) - fdst(i-m,j,k-l)) +
     &                  (sigmaf(i-m-1,js,k-l) + sigmaf(i-m,js,k-l)) *
     &                   (fdst(i-m,j,k-l+1) - fdst(i-m,j,k-l)) +
     &                 (sigmaf(i-m-1,js,k+l-1) + sigmaf(i-m,js,k+l-1)) *
     &                   (fdst(i-m,j,k+l-1) - fdst(i-m,j,k+l)) +
     &                  (sigmaf(i-m-1,js,k+l) + sigmaf(i-m,js,k+l)) *
     &                   (fdst(i-m,j,k+l+1) - fdst(i-m,j,k+l)) +
     &                 (sigmaf(i+m-1,js,k-l-1) + sigmaf(i+m,js,k-l-1)) *
     &                   (fdst(i+m,j,k-l-1) - fdst(i+m,j,k-l)) +
     &                  (sigmaf(i+m-1,js,k-l) + sigmaf(i+m,js,k-l)) *
     &                   (fdst(i+m,j,k-l+1) - fdst(i+m,j,k-l)) +
     &                 (sigmaf(i+m-1,js,k+l-1) + sigmaf(i+m,js,k+l-1)) *
     &                   (fdst(i+m,j,k+l-1) - fdst(i+m,j,k+l)) +
     &                  (sigmaf(i+m-1,js,k+l) + sigmaf(i+m,js,k+l)) *
     &                   (fdst(i+m,j,k+l+1) - fdst(i+m,j,k+l))))
                  end do
               end do
            end do
         end do
      else
         k = regl2
         if (idir .eq. 1) then
            ks = k - 1
         else
            ks = k
         end if
         fac0 = 0.5D0 * kr / (kr + 1.0D0)
         hxm2 = 1.0D0 / (ir * ir * hx * hx)
         hym2 = 1.0D0 / (jr * jr * hy * hy)
         hzm2 = 1.0D0 / (kr * kr * hz * hz)
         do j = regl1, regh1
            do i = regl0, regh0
               res(i*ir,j*jr,k*kr) =
     &           src(i*ir,j*jr,k*kr) - fac0 *
     &             (hxm2 *
     &               ((sigmac(i-1,j-1,ks) + sigmac(i-1,j,ks)) *
     &                 (cdst(i-1,j,k) - cdst(i,j,k)) +
     &                (sigmac(i,j-1,ks) + sigmac(i,j,ks)) *
     &                 (cdst(i+1,j,k) - cdst(i,j,k))) +
     &              hym2 *
     &               ((sigmac(i-1,j-1,ks) + sigmac(i,j-1,ks)) *
     &                 (cdst(i,j-1,k) - cdst(i,j,k)) +
     &                (sigmac(i-1,j,ks) + sigmac(i,j,ks)) *
     &                 (cdst(i,j+1,k) - cdst(i,j,k))) +
     &              hzm2 *
     &               ((sigmac(i-1,j-1,ks) + sigmac(i-1,j,ks) +
     &                 sigmac(i,j-1,ks)   + sigmac(i,j,ks)) *
     &                 (cdst(i,j,k-idir) - cdst(i,j,k))))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * ir * jr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         hzm2 = kr * kr * hzm2
         k = k * kr
         if (idir .eq. 1) then
            ks = k
         else
            ks = k - 1
         end if
         do n = 0, jr-1
            fac2 = (jr-n) * fac0
            if (n .eq. 0) fac2 = 0.5D0 * fac2
            do m = 0, ir-1
               fac1 = (ir-m) * fac2
               if (m .eq. 0) fac1 = 0.5D0 * fac1
               do j = jr*regl1, jr*regh1, jr
                  do i = ir*regl0, ir*regh0, ir
                     tmp = hxm2 *
     &                ((sigmaf(i-m-1,j-n-1,ks) + sigmaf(i-m-1,j-n,ks)) *
     &                   (fdst(i-m-1,j-n,k) - fdst(i-m,j-n,k)) +
     &                  (sigmaf(i-m,j-n-1,ks) + sigmaf(i-m,j-n,ks)) *
     &                   (fdst(i-m+1,j-n,k) - fdst(i-m,j-n,k)) +
     &                 (sigmaf(i-m-1,j+n-1,ks) + sigmaf(i-m-1,j+n,ks)) *
     &                   (fdst(i-m-1,j+n,k) - fdst(i-m,j+n,k)) +
     &                  (sigmaf(i-m,j+n-1,ks) + sigmaf(i-m,j+n,ks)) *
     &                   (fdst(i-m+1,j+n,k) - fdst(i-m,j+n,k)) +
     &                 (sigmaf(i+m-1,j-n-1,ks) + sigmaf(i+m-1,j-n,ks)) *
     &                   (fdst(i+m-1,j-n,k) - fdst(i+m,j-n,k)) +
     &                  (sigmaf(i+m,j-n-1,ks) + sigmaf(i+m,j-n,ks)) *
     &                   (fdst(i+m+1,j-n,k) - fdst(i+m,j-n,k)) +
     &                 (sigmaf(i+m-1,j+n-1,ks) + sigmaf(i+m-1,j+n,ks)) *
     &                   (fdst(i+m-1,j+n,k) - fdst(i+m,j+n,k)) +
     &                  (sigmaf(i+m,j+n-1,ks) + sigmaf(i+m,j+n,ks)) *
     &                   (fdst(i+m+1,j+n,k) - fdst(i+m,j+n,k)))
                     tmp = tmp + hym2 *
     &                ((sigmaf(i-m-1,j-n-1,ks) + sigmaf(i-m,j-n-1,ks)) *
     &                   (fdst(i-m,j-n-1,k) - fdst(i-m,j-n,k)) +
     &                  (sigmaf(i-m-1,j-n,ks) + sigmaf(i-m,j-n,ks)) *
     &                   (fdst(i-m,j-n+1,k) - fdst(i-m,j-n,k)) +
     &                 (sigmaf(i-m-1,j+n-1,ks) + sigmaf(i-m,j+n-1,ks)) *
     &                   (fdst(i-m,j+n-1,k) - fdst(i-m,j+n,k)) +
     &                  (sigmaf(i-m-1,j+n,ks) + sigmaf(i-m,j+n,ks)) *
     &                   (fdst(i-m,j+n+1,k) - fdst(i-m,j+n,k)) +
     &                 (sigmaf(i+m-1,j-n-1,ks) + sigmaf(i+m,j-n-1,ks)) *
     &                   (fdst(i+m,j-n-1,k) - fdst(i+m,j-n,k)) +
     &                  (sigmaf(i+m-1,j-n,ks) + sigmaf(i+m,j-n,ks)) *
     &                   (fdst(i+m,j-n+1,k) - fdst(i+m,j-n,k)) +
     &                 (sigmaf(i+m-1,j+n-1,ks) + sigmaf(i+m,j+n-1,ks)) *
     &                   (fdst(i+m,j+n-1,k) - fdst(i+m,j+n,k)) +
     &                  (sigmaf(i+m-1,j+n,ks) + sigmaf(i+m,j+n,ks)) *
     &                   (fdst(i+m,j+n+1,k) - fdst(i+m,j+n,k)))
                  res(i,j,k) = res(i,j,k) - fac1 * (tmp + hzm2 *
     &                 ((sigmaf(i-m-1,j-n-1,ks) + sigmaf(i-m-1,j-n,ks) +
     &                   sigmaf(i-m,j-n-1,ks) + sigmaf(i-m,j-n,ks)) *
     &                   (fdst(i-m,j-n,k+idir) - fdst(i-m,j-n,k)) +
     &                  (sigmaf(i-m-1,j+n-1,ks) + sigmaf(i-m-1,j+n,ks) +
     &                   sigmaf(i-m,j+n-1,ks) + sigmaf(i-m,j+n,ks)) *
     &                   (fdst(i-m,j+n,k+idir) - fdst(i-m,j+n,k)) +
     &                  (sigmaf(i+m-1,j-n-1,ks) + sigmaf(i+m-1,j-n,ks) +
     &                   sigmaf(i+m,j-n-1,ks) + sigmaf(i+m,j-n,ks)) *
     &                   (fdst(i+m,j-n,k+idir) - fdst(i+m,j-n,k)) +
     &                  (sigmaf(i+m-1,j+n-1,ks) + sigmaf(i+m-1,j+n,ks) +
     &                   sigmaf(i+m,j+n-1,ks) + sigmaf(i+m,j+n,ks)) *
     &                   (fdst(i+m,j+n,k+idir) - fdst(i+m,j+n,k))))
                  end do
               end do
            end do
         end do
      end if
      end

c end of variable density stencils
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along face
      subroutine hgeres(
     & res,    resl0,resh0,resl1,resh1,resl2,resh2,
     & src,    srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & fdst,   fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2,
     & cdst,   cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2,
     & sigmaf, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & sigmac, scl0,sch0,scl1,sch1,scl2,sch2,
     &         regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz, ir, jr, kr, ga, ivect)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2
      integer cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1,fdstl2:fdsth2)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1,cdstl2:cdsth2)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigmac(scl0:sch0,scl1:sch1,scl2:sch2)
      double precision hx, hy, hz
      integer ir, jr, kr, ivect(0:2), ga(0:1,0:1,0:1)
      double precision r3, hxm2, hym2, hzm2, hxm2c, hym2c, hzm2c
      double precision center, cfac, ffac, fac0, fac1, fac, tmp
      integer ic, jc, kc, if, jf, kf, ii, ji, ki, idir, jdir, kdir
      integer l, m, n
      r3 = ir * jr * kr
      hxm2c = 1.0D0 / (ir * ir * hx * hx)
      hym2c = 1.0D0 / (jr * jr * hy * hy)
      hzm2c = 1.0D0 / (kr * kr * hz * hz)
      hxm2 = ir * ir * hxm2c
      hym2 = jr * jr * hym2c
      hzm2 = kr * kr * hzm2c
      ic = regl0
      jc = regl1
      kc = regl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      center = 0.0D0
      if (ivect(0) .eq. 0) then
         do if = ir*regl0, ir*regh0, ir
            res(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac0 = 1.0D0 / ir
         ffac = ir
         cfac = r3
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) .eq. 1) then
                  center = center + ffac
                  do m = 0, ir-1
                     fac = (ir-m) * fac0
                     if (m .eq. 0) fac = 0.5D0 * fac
                     do if = ir*regl0, ir*regh0, ir
                        tmp = hxm2 *
     &                    (sigmaf(if-m-1,jf+ji-1,kf+ki-1) *
     &                      (fdst(if-m-1,jf,kf) - fdst(if-m,jf,kf)) +
     &                     sigmaf(if-m,jf+ji-1,kf+ki-1) *
     &                      (fdst(if-m+1,jf,kf) - fdst(if-m,jf,kf)) +
     &                     sigmaf(if+m-1,jf+ji-1,kf+ki-1) *
     &                      (fdst(if+m-1,jf,kf) - fdst(if+m,jf,kf)) +
     &                     sigmaf(if+m,jf+ji-1,kf+ki-1) *
     &                      (fdst(if+m+1,jf,kf) - fdst(if+m,jf,kf)))
                        tmp = tmp + hym2 *
     &                    ((sigmaf(if-m-1,jf+ji-1,kf+ki-1) +
     &                      sigmaf(if-m,jf+ji-1,kf+ki-1)) *
     &                      (fdst(if-m,jf+jdir,kf) - fdst(if-m,jf,kf)) +
     &                     (sigmaf(if+m-1,jf+ji-1,kf+ki-1) +
     &                      sigmaf(if+m,jf+ji-1,kf+ki-1)) *
     &                      (fdst(if+m,jf+jdir,kf) - fdst(if+m,jf,kf)))
                     res(if,jf,kf) = res(if,jf,kf) + fac * (tmp + hzm2 *
     &                    ((sigmaf(if-m-1,jf+ji-1,kf+ki-1) +
     &                      sigmaf(if-m,jf+ji-1,kf+ki-1)) *
     &                      (fdst(if-m,jf,kf+kdir) - fdst(if-m,jf,kf)) +
     &                     (sigmaf(if+m-1,jf+ji-1,kf+ki-1) +
     &                      sigmaf(if+m,jf+ji-1,kf+ki-1)) *
     &                      (fdst(if+m,jf,kf+kdir) - fdst(if+m,jf,kf))))
                     end do
                  end do
               else
                  center = center + cfac
                  do ic = regl0, regh0
                     if = ic * ir
                     res(if,jf,kf) = res(if,jf,kf) + r3 *
     &                (sigmac(ic-1,jc+ji-1,kc+ki-1) *
     &                   (hxm2c * (cdst(ic-1,jc,kc) - cdst(ic,jc,kc)) +
     &                  hym2c * (cdst(ic,jc+jdir,kc) - cdst(ic,jc,kc)) +
     &                 hzm2c * (cdst(ic,jc,kc+kdir) - cdst(ic,jc,kc))) +
     &                 sigmac(ic,jc+ji-1,kc+ki-1) *
     &                   (hxm2c * (cdst(ic+1,jc,kc) - cdst(ic,jc,kc)) +
     &                  hym2c * (cdst(ic,jc+jdir,kc) - cdst(ic,jc,kc)) +
     &                  hzm2c * (cdst(ic,jc,kc+kdir) - cdst(ic,jc,kc))))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) - ga(0,ji,1-ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * jr)
                  ffac = ir * (jr - 1)
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*regl0, ir*regh0, ir
                           tmp = hxm2 *
     &       ((sigmaf(if-m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if-m-1,jf+n,kf+ki-1)) *
     &         (fdst(if-m-1,jf+n,kf) - fdst(if-m,jf+n,kf)) +
     &        (sigmaf(if-m,jf+n-1,kf+ki-1)
     &            + sigmaf(if-m,jf+n,kf+ki-1)) *
     &         (fdst(if-m+1,jf+n,kf) - fdst(if-m,jf+n,kf)) +
     &        (sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf+n,kf+ki-1)) *
     &         (fdst(if+m-1,jf+n,kf) - fdst(if+m,jf+n,kf)) +
     &        (sigmaf(if+m,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m+1,jf+n,kf) - fdst(if+m,jf+n,kf)))
                           tmp = tmp + hym2 *
     &       ((sigmaf(if-m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if-m,jf+n-1,kf+ki-1)) *
     &         (fdst(if-m,jf+n-1,kf) - fdst(if-m,jf+n,kf)) +
     &        (sigmaf(if-m-1,jf+n,kf+ki-1)
     &            + sigmaf(if-m,jf+n,kf+ki-1)) *
     &         (fdst(if-m,jf+n+1,kf) - fdst(if-m,jf+n,kf)) +
     &        (sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n-1,kf+ki-1)) *
     &         (fdst(if+m,jf+n-1,kf) - fdst(if+m,jf+n,kf)) +
     &        (sigmaf(if+m-1,jf+n,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m,jf+n+1,kf) - fdst(if+m,jf+n,kf)))
                  res(if,jf,kf) = res(if,jf,kf)
     &            + fac * (tmp + hzm2 *
     &       ((sigmaf(if-m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if-m-1,jf+n,kf+ki-1) +
     &         sigmaf(if-m,jf+n-1,kf+ki-1)
     &            + sigmaf(if-m,jf+n,kf+ki-1)) *
     &         (fdst(if-m,jf+n,kf+kdir) - fdst(if-m,jf+n,kf)) +
     &        (sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf+n,kf+ki-1) +
     &         sigmaf(if+m,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m,jf+n,kf+kdir) - fdst(if+m,jf+n,kf))))
                        end do
                     end do
                  end do
               end if
               if (ga(0,ji,ki) - ga(0,1-ji,ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * kr)
                  ffac = ir * (kr - 1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*regl0, ir*regh0, ir
                           tmp = hxm2 *
     &       ((sigmaf(if-m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if-m-1,jf+ji-1,kf+l)) *
     &         (fdst(if-m-1,jf,kf+l) - fdst(if-m,jf,kf+l)) +
     &        (sigmaf(if-m,jf+ji-1,kf+l-1)
     &            + sigmaf(if-m,jf+ji-1,kf+l)) *
     &         (fdst(if-m+1,jf,kf+l) - fdst(if-m,jf,kf+l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l)) *
     &         (fdst(if+m-1,jf,kf+l) - fdst(if+m,jf,kf+l)) +
     &        (sigmaf(if+m,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m+1,jf,kf+l) - fdst(if+m,jf,kf+l)))
                           tmp = tmp + hym2 *
     &       ((sigmaf(if-m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if-m-1,jf+ji-1,kf+l) +
     &         sigmaf(if-m,jf+ji-1,kf+l-1)
     &            + sigmaf(if-m,jf+ji-1,kf+l)) *
     &         (fdst(if-m,jf+jdir,kf+l) - fdst(if-m,jf,kf+l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l) +
     &         sigmaf(if+m,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m,jf+jdir,kf+l) - fdst(if+m,jf,kf+l)))
                           res(if,jf,kf) = res(if,jf,kf)
     &            + fac * (tmp + hzm2 *
     &       ((sigmaf(if-m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if-m,jf+ji-1,kf+l-1)) *
     &         (fdst(if-m,jf,kf+l-1) - fdst(if-m,jf,kf+l)) +
     &        (sigmaf(if-m-1,jf+ji-1,kf+l)
     &            + sigmaf(if-m,jf+ji-1,kf+l)) *
     &         (fdst(if-m,jf,kf+l+1) - fdst(if-m,jf,kf+l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l-1)) *
     &         (fdst(if+m,jf,kf+l-1) - fdst(if+m,jf,kf+l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m,jf,kf+l+1) - fdst(if+m,jf,kf+l))))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do if = ir*regl0, ir*regh0, ir
            res(if,jf,kf) = src(if,jf,kf) - res(if,jf,kf) / center
         end do
      else if (ivect(1) .eq. 0) then
         do jf = jr*regl1, jr*regh1, jr
            res(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac0 = 1.0D0 / jr
         ffac = jr
         cfac = r3
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) .eq. 1) then
                  center = center + ffac
                  do  n = 0, jr-1
                     fac = (jr-n) * fac0
                     if (n .eq. 0) fac = 0.5D0 * fac
                     do  jf = jr*regl1, jr*regh1, jr
                        tmp = hxm2 *
     &                    ((sigmaf(if+ii-1,jf-n-1,kf+ki-1) +
     &                      sigmaf(if+ii-1,jf-n,kf+ki-1)) *
     &                      (fdst(if+idir,jf-n,kf) - fdst(if,jf-n,kf)) +
     &                     (sigmaf(if+ii-1,jf+n-1,kf+ki-1) +
     &                      sigmaf(if+ii-1,jf+n,kf+ki-1)) *
     &                      (fdst(if+idir,jf+n,kf) - fdst(if,jf+n,kf)))
                        tmp = tmp + hym2 *
     &                    (sigmaf(if+ii-1,jf-n-1,kf+ki-1) *
     &                      (fdst(if,jf-n-1,kf) - fdst(if,jf-n,kf)) +
     &                     sigmaf(if+ii-1,jf-n,kf+ki-1) *
     &                      (fdst(if,jf-n+1,kf) - fdst(if,jf-n,kf)) +
     &                     sigmaf(if+ii-1,jf+n-1,kf+ki-1) *
     &                      (fdst(if,jf+n-1,kf) - fdst(if,jf+n,kf)) +
     &                     sigmaf(if+ii-1,jf+n,kf+ki-1) *
     &                      (fdst(if,jf+n+1,kf) - fdst(if,jf+n,kf)))
                     res(if,jf,kf) = res(if,jf,kf) + fac * (tmp + hzm2 *
     &                    ((sigmaf(if+ii-1,jf-n-1,kf+ki-1) +
     &                      sigmaf(if+ii-1,jf-n,kf+ki-1)) *
     &                      (fdst(if,jf-n,kf+kdir) - fdst(if,jf-n,kf)) +
     &                     (sigmaf(if+ii-1,jf+n-1,kf+ki-1) +
     &                      sigmaf(if+ii-1,jf+n,kf+ki-1)) *
     &                      (fdst(if,jf+n,kf+kdir) - fdst(if,jf+n,kf))))
                     end do
                  end do
               else
                  center = center + cfac
                  do jc = regl1, regh1
                     jf = jc * jr
                     res(if,jf,kf) = res(if,jf,kf) + r3 *
     &                (sigmac(ic+ii-1,jc-1,kc+ki-1) *
     &                 (hxm2c * (cdst(ic+idir,jc,kc) - cdst(ic,jc,kc)) +
     &                  hym2c * (cdst(ic,jc-1,kc) - cdst(ic,jc,kc)) +
     &                 hzm2c * (cdst(ic,jc,kc+kdir) - cdst(ic,jc,kc))) +
     &                 sigmac(ic+ii-1,jc,kc+ki-1) *
     &                 (hxm2c * (cdst(ic+idir,jc,kc) - cdst(ic,jc,kc)) +
     &                  hym2c * (cdst(ic,jc+1,kc) - cdst(ic,jc,kc)) +
     &                  hzm2c * (cdst(ic,jc,kc+kdir) - cdst(ic,jc,kc))))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) - ga(ii,0,1-ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * jr)
                  ffac = jr * (ir - 1)
                  center = center + ffac
                  do n = 0, jr-1
                     fac1 = (jr-n) * fac0
                     if (n .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do jf = jr*regl1, jr*regh1, jr
                           tmp = hxm2 *
     &       ((sigmaf(if+m-1,jf-n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf-n,kf+ki-1)) *
     &         (fdst(if+m-1,jf-n,kf) - fdst(if+m,jf-n,kf)) +
     &        (sigmaf(if+m,jf-n-1,kf+ki-1)
     &            + sigmaf(if+m,jf-n,kf+ki-1)) *
     &         (fdst(if+m+1,jf-n,kf) - fdst(if+m,jf-n,kf)) +
     &        (sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf+n,kf+ki-1)) *
     &         (fdst(if+m-1,jf+n,kf) - fdst(if+m,jf+n,kf)) +
     &        (sigmaf(if+m,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m+1,jf+n,kf) - fdst(if+m,jf+n,kf)))
                           tmp = tmp + hym2 *
     &       ((sigmaf(if+m-1,jf-n-1,kf+ki-1)
     &            + sigmaf(if+m,jf-n-1,kf+ki-1)) *
     &         (fdst(if+m,jf-n-1,kf) - fdst(if+m,jf-n,kf)) +
     &        (sigmaf(if+m-1,jf-n,kf+ki-1)
     &            + sigmaf(if+m,jf-n,kf+ki-1)) *
     &         (fdst(if+m,jf-n+1,kf) - fdst(if+m,jf-n,kf)) +
     &        (sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n-1,kf+ki-1)) *
     &         (fdst(if+m,jf+n-1,kf) - fdst(if+m,jf+n,kf)) +
     &        (sigmaf(if+m-1,jf+n,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m,jf+n+1,kf) - fdst(if+m,jf+n,kf)))
                           res(if,jf,kf) = res(if,jf,kf)
     &            + fac * (tmp + hzm2 *
     &       ((sigmaf(if+m-1,jf-n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf-n,kf+ki-1) +
     &         sigmaf(if+m,jf-n-1,kf+ki-1)
     &            + sigmaf(if+m,jf-n,kf+ki-1)) *
     &         (fdst(if+m,jf-n,kf+kdir) - fdst(if+m,jf-n,kf)) +
     &        (sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf+n,kf+ki-1) +
     &         sigmaf(if+m,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m,jf+n,kf+kdir) - fdst(if+m,jf+n,kf))))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,0,ki) - ga(1-ii,0,ki) .eq. 1) then
                  fac0 = 1.0D0 / (jr * kr)
                  ffac = jr * (kr - 1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = 0, jr-1
                        fac = (jr-n) * fac1
                        if (n .eq. 0) fac = 0.5D0 * fac
                        do jf = jr*regl1, jr*regh1, jr
                           tmp = hxm2 *
     &       ((sigmaf(if+ii-1,jf-n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf-n-1,kf+l) +
     &         sigmaf(if+ii-1,jf-n,kf+l-1)
     &            + sigmaf(if+ii-1,jf-n,kf+l)) *
     &         (fdst(if+idir,jf-n,kf+l) - fdst(if,jf-n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf+l) +
     &         sigmaf(if+ii-1,jf+n,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if+idir,jf+n,kf+l) - fdst(if,jf+n,kf+l)))
                           tmp = tmp + hym2 *
     &       ((sigmaf(if+ii-1,jf-n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf-n-1,kf+l)) *
     &         (fdst(if,jf-n-1,kf+l) - fdst(if,jf-n,kf+l)) +
     &        (sigmaf(if+ii-1,jf-n,kf+l-1)
     &            + sigmaf(if+ii-1,jf-n,kf+l)) *
     &         (fdst(if,jf-n+1,kf+l) - fdst(if,jf-n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf+l)) *
     &         (fdst(if,jf+n-1,kf+l) - fdst(if,jf+n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if,jf+n+1,kf+l) - fdst(if,jf+n,kf+l)))
                           res(if,jf,kf) = res(if,jf,kf)
     &            + fac * (tmp + hzm2 *
     &       ((sigmaf(if+ii-1,jf-n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf-n,kf+l-1)) *
     &         (fdst(if,jf-n,kf+l-1) - fdst(if,jf-n,kf+l)) +
     &        (sigmaf(if+ii-1,jf-n-1,kf+l)
     &            + sigmaf(if+ii-1,jf-n,kf+l)) *
     &         (fdst(if,jf-n,kf+l+1) - fdst(if,jf-n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l-1)) *
     &         (fdst(if,jf+n,kf+l-1) - fdst(if,jf+n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if,jf+n,kf+l+1) - fdst(if,jf+n,kf+l))))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do jf = jr*regl1, jr*regh1, jr
            res(if,jf,kf) = src(if,jf,kf) - res(if,jf,kf) / center
         end do
      else
         do kf = kr*regl2, kr*regh2, kr
            res(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac0 = 1.0D0 / kr
         ffac = kr
         cfac = r3
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) .eq. 1) then
                  center = center + ffac
                  do l = 0, kr-1
                     fac = (kr-l) * fac0
                     if (l .eq. 0) fac = 0.5D0 * fac
                     do kf = kr*regl2, kr*regh2, kr
                        tmp = hxm2 *
     &                    ((sigmaf(if+ii-1,jf+ji-1,kf-l-1) +
     &                      sigmaf(if+ii-1,jf+ji-1,kf-l)) *
     &                      (fdst(if+idir,jf,kf-l) - fdst(if,jf,kf-l)) +
     &                     (sigmaf(if+ii-1,jf+ji-1,kf+l-1) +
     &                      sigmaf(if+ii-1,jf+ji-1,kf+l)) *
     &                      (fdst(if+idir,jf,kf+l) - fdst(if,jf,kf+l)))
                        tmp = tmp + hym2 *
     &                    ((sigmaf(if+ii-1,jf+ji-1,kf-l-1) +
     &                      sigmaf(if+ii-1,jf+ji-1,kf-l)) *
     &                      (fdst(if,jf+jdir,kf-l) - fdst(if,jf,kf-l)) +
     &                     (sigmaf(if+ii-1,jf+ji-1,kf+l-1) +
     &                      sigmaf(if+ii-1,jf+ji-1,kf+l)) *
     &                      (fdst(if,jf+jdir,kf+l) - fdst(if,jf,kf+l)))
                     res(if,jf,kf) = res(if,jf,kf) + fac * (tmp + hzm2 *
     &                    (sigmaf(if+ii-1,jf+ji-1,kf-l-1) *
     &                      (fdst(if,jf,kf-l-1) - fdst(if,jf,kf-l)) +
     &                     sigmaf(if+ii-1,jf+ji-1,kf-l) *
     &                      (fdst(if,jf,kf-l+1) - fdst(if,jf,kf-l)) +
     &                     sigmaf(if+ii-1,jf+ji-1,kf+l-1) *
     &                      (fdst(if,jf,kf+l-1) - fdst(if,jf,kf+l)) +
     &                     sigmaf(if+ii-1,jf+ji-1,kf+l) *
     &                      (fdst(if,jf,kf+l+1) - fdst(if,jf,kf+l))))
                     end do
                  end do
               else
                  center = center + cfac
                  do kc = regl2, regh2
                     kf = kc * kr
                     res(if,jf,kf) = res(if,jf,kf) + r3 *
     &                (sigmac(ic+ii-1,jc+ji-1,kc-1) *
     &                 (hxm2c * (cdst(ic+idir,jc,kc) - cdst(ic,jc,kc)) +
     &                  hym2c * (cdst(ic,jc+jdir,kc) - cdst(ic,jc,kc)) +
     &                    hzm2c * (cdst(ic,jc,kc-1) - cdst(ic,jc,kc))) +
     &                 sigmac(ic+ii-1,jc+ji-1,kc) *
     &                 (hxm2c * (cdst(ic+idir,jc,kc) - cdst(ic,jc,kc)) +
     &                  hym2c * (cdst(ic,jc+jdir,kc) - cdst(ic,jc,kc)) +
     &                    hzm2c * (cdst(ic,jc,kc+1) - cdst(ic,jc,kc))))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do  ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) - ga(ii,1-ji,0) .eq. 1) then
                  fac0 = 1.0D0 / (ir * kr)
                  ffac = kr * (ir - 1)
                  center = center + ffac
                  do  l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do kf = kr*regl2, kr*regh2, kr
                           tmp = hxm2 *
     &       ((sigmaf(if+m-1,jf+ji-1,kf-l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf-l)) *
     &         (fdst(if+m-1,jf,kf-l) - fdst(if+m,jf,kf-l)) +
     &        (sigmaf(if+m,jf+ji-1,kf-l-1)
     &            + sigmaf(if+m,jf+ji-1,kf-l)) *
     &         (fdst(if+m+1,jf,kf-l) - fdst(if+m,jf,kf-l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l)) *
     &         (fdst(if+m-1,jf,kf+l) - fdst(if+m,jf,kf+l)) +
     &        (sigmaf(if+m,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m+1,jf,kf+l) - fdst(if+m,jf,kf+l)))
                           tmp = tmp + hym2 *
     &       ((sigmaf(if+m-1,jf+ji-1,kf-l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf-l) +
     &         sigmaf(if+m,jf+ji-1,kf-l-1)
     &            + sigmaf(if+m,jf+ji-1,kf-l)) *
     &         (fdst(if+m,jf+jdir,kf-l) - fdst(if+m,jf,kf-l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l) +
     &         sigmaf(if+m,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m,jf+jdir,kf+l) - fdst(if+m,jf,kf+l)))
                        res(if,jf,kf) = res(if,jf,kf)
     &            + fac * (tmp + hzm2 *
     &       ((sigmaf(if+m-1,jf+ji-1,kf-l-1)
     &            + sigmaf(if+m,jf+ji-1,kf-l-1)) *
     &         (fdst(if+m,jf,kf-l-1) - fdst(if+m,jf,kf-l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf-l)
     &            + sigmaf(if+m,jf+ji-1,kf-l)) *
     &         (fdst(if+m,jf,kf-l+1) - fdst(if+m,jf,kf-l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l-1)) *
     &         (fdst(if+m,jf,kf+l-1) - fdst(if+m,jf,kf+l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m,jf,kf+l+1) - fdst(if+m,jf,kf+l))))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,ji,0) - ga(1-ii,ji,0) .eq. 1) then
                  fac0 = 1.0D0 / (jr * kr)
                  ffac = kr * (jr - 1)
                  center = center + ffac
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        do kf = kr*regl2, kr*regh2, kr
                           tmp = hxm2 *
     &       ((sigmaf(if+ii-1,jf+n-1,kf-l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf-l) +
     &         sigmaf(if+ii-1,jf+n,kf-l-1)
     &            + sigmaf(if+ii-1,jf+n,kf-l)) *
     &         (fdst(if+idir,jf+n,kf-l) - fdst(if,jf+n,kf-l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf+l) +
     &         sigmaf(if+ii-1,jf+n,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if+idir,jf+n,kf+l) - fdst(if,jf+n,kf+l)))
                           tmp = tmp + hym2 *
     &       ((sigmaf(if+ii-1,jf+n-1,kf-l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf-l)) *
     &         (fdst(if,jf+n-1,kf-l) - fdst(if,jf+n,kf-l)) +
     &        (sigmaf(if+ii-1,jf+n,kf-l-1)
     &            + sigmaf(if+ii-1,jf+n,kf-l)) *
     &         (fdst(if,jf+n+1,kf-l) - fdst(if,jf+n,kf-l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf+l)) *
     &         (fdst(if,jf+n-1,kf+l) - fdst(if,jf+n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if,jf+n+1,kf+l) - fdst(if,jf+n,kf+l)))
                           res(if,jf,kf) = res(if,jf,kf)
     &            + fac * (tmp + hzm2 *
     &       ((sigmaf(if+ii-1,jf+n-1,kf-l-1)
     &            + sigmaf(if+ii-1,jf+n,kf-l-1)) *
     &         (fdst(if,jf+n,kf-l-1) - fdst(if,jf+n,kf-l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf-l)
     &            + sigmaf(if+ii-1,jf+n,kf-l)) *
     &         (fdst(if,jf+n,kf-l+1) - fdst(if,jf+n,kf-l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l-1)) *
     &         (fdst(if,jf+n,kf+l-1) - fdst(if,jf+n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if,jf+n,kf+l+1) - fdst(if,jf+n,kf+l))))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do kf = kr*regl2, kr*regh2, kr
            res(if,jf,kf) = src(if,jf,kf) - res(if,jf,kf) / center
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along face
      subroutine hgcres(
     & res,    resl0,resh0,resl1,resh1,resl2,resh2,
     & src,    srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & fdst,   fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2,
     & cdst,   cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2,
     & sigmaf, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & sigmac, scl0,sch0,scl1,sch1,scl2,sch2,
     &         regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz, ir, jr, kr, ga, idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2
      integer cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1,fdstl2:fdsth2)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1,cdstl2:cdsth2)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigmac(scl0:sch0,scl1:sch1,scl2:sch2)
      double precision hx, hy, hz
      integer ir, jr, kr, ga(0:1,0:1,0:1), idd
      double precision r3, hxm2, hym2, hzm2, hxm2c, hym2c, hzm2c
      double precision sum, center, cfac, ffac, fac1, fac2, fac
      integer ic, jc, kc, if, jf, kf, ii, ji, ki, idir, jdir, kdir
      integer l, m, n
      r3 = ir * jr * kr
      hxm2c = 1.0D0 / (ir * ir * hx * hx)
      hym2c = 1.0D0 / (jr * jr * hy * hy)
      hzm2c = 1.0D0 / (kr * kr * hz * hz)
      hxm2 = ir * ir * hxm2c
      hym2 = jr * jr * hym2c
      hzm2 = kr * kr * hzm2c
      ic = regl0
      jc = regl1
      kc = regl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      sum = 0.0D0
      center = 0.0D0
c octants
      fac = 1.0D0
      ffac = 0.5D0
      cfac = 0.5D0 * r3
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) .eq. 1) then
                  center = center + ffac
                  sum = sum + fac * sigmaf(if+ii-1,jf+ji-1,kf+ki-1) *
     &              (hxm2 * (fdst(if+idir,jf,kf) - fdst(if,jf,kf)) +
     &               hym2 * (fdst(if,jf+jdir,kf) - fdst(if,jf,kf)) +
     &               hzm2 * (fdst(if,jf,kf+kdir) - fdst(if,jf,kf)))
               else
                  center = center + cfac
                  sum = sum + r3 * sigmac(ic+ii-1,jc+ji-1,kc+ki-1) *
     &              (hxm2c * (cdst(ic+idir,jc,kc) - cdst(ic,jc,kc)) +
     &               hym2c * (cdst(ic,jc+jdir,kc) - cdst(ic,jc,kc)) +
     &               hzm2c * (cdst(ic,jc,kc+kdir) - cdst(ic,jc,kc)))
               end if
            end do
         end do
      end do
c faces
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) - ga(ii,ji,1-ki) .eq. 1) then
                  fac2 = 1.0D0 / (ir * jr)
                  ffac = 0.5D0 * (ir-1) * (jr-1)
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac2
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac *
     &                    (hxm2 *
     &       ((sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf+n,kf+ki-1)) *
     &         (fdst(if+m-1,jf+n,kf) - fdst(if+m,jf+n,kf)) +
     &        (sigmaf(if+m,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m+1,jf+n,kf) - fdst(if+m,jf+n,kf))) +
     &                     hym2 *
     &       ((sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n-1,kf+ki-1)) *
     &         (fdst(if+m,jf+n-1,kf) - fdst(if+m,jf+n,kf)) +
     &        (sigmaf(if+m-1,jf+n,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m,jf+n+1,kf) - fdst(if+m,jf+n,kf))) +
     &                     hzm2 *
     &       ((sigmaf(if+m-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m-1,jf+n,kf+ki-1) +
     &         sigmaf(if+m,jf+n-1,kf+ki-1)
     &            + sigmaf(if+m,jf+n,kf+ki-1)) *
     &         (fdst(if+m,jf+n,kf+kdir) - fdst(if+m,jf+n,kf))))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(ii,1-ji,ki) .eq. 1) then
                  fac2 = 1.0D0 / (ir * kr)
                  ffac = 0.5D0 * (ir-1) * (kr-1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac2
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac *
     &                    (hxm2 *
     &       ((sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l)) *
     &         (fdst(if+m-1,jf,kf+l) - fdst(if+m,jf,kf+l)) +
     &        (sigmaf(if+m,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m+1,jf,kf+l) - fdst(if+m,jf,kf+l))) +
     &                     hym2 *
     &       ((sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l) +
     &         sigmaf(if+m,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m,jf+jdir,kf+l) - fdst(if+m,jf,kf+l))) +
     &                     hzm2 *
     &       ((sigmaf(if+m-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+m,jf+ji-1,kf+l-1)) *
     &         (fdst(if+m,jf,kf+l-1) - fdst(if+m,jf,kf+l)) +
     &        (sigmaf(if+m-1,jf+ji-1,kf+l)
     &            + sigmaf(if+m,jf+ji-1,kf+l)) *
     &         (fdst(if+m,jf,kf+l+1) - fdst(if+m,jf,kf+l))))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(1-ii,ji,ki) .eq. 1) then
                  fac2 = 1.0D0 / (jr * kr)
                  ffac = 0.5D0 * (jr-1) * (kr-1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac2
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        sum = sum + fac *
     &                    (hxm2 *
     &       ((sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf+l) +
     &         sigmaf(if+ii-1,jf+n,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if+idir,jf+n,kf+l) - fdst(if,jf+n,kf+l))) +
     &                     hym2 *
     &       ((sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n-1,kf+l)) *
     &         (fdst(if,jf+n-1,kf+l) - fdst(if,jf+n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if,jf+n+1,kf+l) - fdst(if,jf+n,kf+l))) +
     &                     hzm2 *
     &       ((sigmaf(if+ii-1,jf+n-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+n,kf+l-1)) *
     &         (fdst(if,jf+n,kf+l-1) - fdst(if,jf+n,kf+l)) +
     &        (sigmaf(if+ii-1,jf+n-1,kf+l)
     &            + sigmaf(if+ii-1,jf+n,kf+l)) *
     &         (fdst(if,jf+n,kf+l+1) - fdst(if,jf+n,kf+l))))
                     end do
                  end do
               end if
            end do
         end do
      end do
c edges
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(ii,1-ji,ki), ga(ii,1-ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / ir
                  ffac = 0.5D0 * (ir-1)
                  center = center + ffac
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     sum = sum + fac *
     &                    (hxm2 *
     &       (sigmaf(if+m-1,jf+ji-1,kf+ki-1) *
     &         (fdst(if+m-1,jf,kf) - fdst(if+m,jf,kf)) +
     &        sigmaf(if+m,jf+ji-1,kf+ki-1) *
     &         (fdst(if+m+1,jf,kf) - fdst(if+m,jf,kf))) +
     &                     hym2 *
     &       (sigmaf(if+m-1,jf+ji-1,kf+ki-1)
     &            + sigmaf(if+m,jf+ji-1,kf+ki-1)) *
     &         (fdst(if+m,jf+jdir,kf) - fdst(if+m,jf,kf)) +
     &                     hzm2 *
     &       (sigmaf(if+m-1,jf+ji-1,kf+ki-1)
     &            + sigmaf(if+m,jf+ji-1,kf+ki-1)) *
     &         (fdst(if+m,jf,kf+kdir) - fdst(if+m,jf,kf)))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(1-ii,ji,ki), ga(1-ii,ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / jr
                  ffac = 0.5D0 * (jr-1)
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     sum = sum + fac *
     &                    (hxm2 *
     &       (sigmaf(if+ii-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+ii-1,jf+n,kf+ki-1)) *
     &         (fdst(if+idir,jf+n,kf) - fdst(if,jf+n,kf)) +
     &                     hym2 *
     &       (sigmaf(if+ii-1,jf+n-1,kf+ki-1) *
     &         (fdst(if,jf+n-1,kf) - fdst(if,jf+n,kf)) +
     &        sigmaf(if+ii-1,jf+n,kf+ki-1) *
     &         (fdst(if,jf+n+1,kf) - fdst(if,jf+n,kf))) +
     &                     hzm2 *
     &       (sigmaf(if+ii-1,jf+n-1,kf+ki-1)
     &            + sigmaf(if+ii-1,jf+n,kf+ki-1)) *
     &         (fdst(if,jf+n,kf+kdir) - fdst(if,jf+n,kf)))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,1-ji,ki), ga(1-ii,ji,ki), ga(1-ii,1-ji,ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / kr
                  ffac = 0.5D0 * (kr-1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac = (kr-abs(l)) * fac1
                     sum = sum + fac *
     &                    (hxm2 *
     &       (sigmaf(if+ii-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+ji-1,kf+l)) *
     &         (fdst(if+idir,jf,kf+l) - fdst(if,jf,kf+l)) +
     &                     hym2 *
     &       (sigmaf(if+ii-1,jf+ji-1,kf+l-1)
     &            + sigmaf(if+ii-1,jf+ji-1,kf+l)) *
     &         (fdst(if,jf+jdir,kf+l) - fdst(if,jf,kf+l)) +
     &                     hzm2 *
     &       (sigmaf(if+ii-1,jf+ji-1,kf+l-1) *
     &         (fdst(if,jf,kf+l-1) - fdst(if,jf,kf+l)) +
     &        sigmaf(if+ii-1,jf+ji-1,kf+l) *
     &         (fdst(if,jf,kf+l+1) - fdst(if,jf,kf+l))))
                  end do
               end if
            end do
         end do
      end do
c weighting
      res(if,jf,kf) = src(if,jf,kf) - sum / center
      end
c-----------------------------------------------------------------------
c NODE-based data, factor of 2 only.
      subroutine hgints_dense(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & sigx, sigy, sigz,
     &       sbl0,sbh0,sbl1,sbh1,sbl2,sbh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & ir, jr, kr)
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer sbl0,sbh0,sbl1,sbh1,sbl2,sbh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer ir, jr, kr
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision sigx(sbl0:sbh0,sbl1:sbh1,sbl2:sbh2)
      double precision sigy(sbl0:sbh0,sbl1:sbh1,sbl2:sbh2)
      double precision sigz(sbl0:sbh0,sbl1:sbh1,sbl2:sbh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      integer i, j, k, ic, jc, kc
      do kc = bbl2, bbh2
         do jc = bbl1, bbh1
            do ic = bbl0, bbh0
               dest(ir*ic,jr*jc,kr*kc) = src(ic,jc,kc)
            end do
         end do
      end do
      if (ir .eq. 2) then
         do kc = bbl2, bbh2
            do jc = bbl1, bbh1
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i+1,j,k) = ((sigx(i,j-1,k-1) + sigx(i,j-1,k) +
     &                              sigx(i,j,k-1) + sigx(i,j,k)) *
     &                             src(ic,jc,kc) +
     &                           (sigx(i+1,j-1,k-1) + sigx(i+1,j-1,k) +
     &                              sigx(i+1,j,k-1) + sigx(i+1,j,k)) *
     &                             src(ic+1,jc,kc)) /
     &                             (sigx(i,j-1,k-1) + sigx(i,j-1,k) +
     &                              sigx(i,j,k-1) + sigx(i,j,k) +
     &                             sigx(i+1,j-1,k-1) + sigx(i+1,j-1,k) +
     &                              sigx(i+1,j,k-1) + sigx(i+1,j,k))
               end do
            end do
         end do
      end if
      if (jr .eq. 2) then
         do kc = bbl2, bbh2
            do jc = bbl1, bbh1-1
               do ic = bbl0, bbh0
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i,j+1,k) = ((sigy(i-1,j,k-1) + sigy(i-1,j,k) +
     &                              sigy(i,j,k-1) + sigy(i,j,k)) *
     &                             src(ic,jc,kc) +
     &                            (sigy(i-1,j+1,k-1) + sigy(i-1,j+1,k) +
     &                              sigy(i,j+1,k-1) + sigy(i,j+1,k)) *
     &                             src(ic,jc+1,kc)) /
     &                             (sigy(i-1,j,k-1) + sigy(i-1,j,k) +
     &                              sigy(i,j,k-1) + sigy(i,j,k) +
     &                             sigy(i-1,j+1,k-1) + sigy(i-1,j+1,k) +
     &                              sigy(i,j+1,k-1) + sigy(i,j+1,k))
               end do
            end do
         end do
      end if
      if (kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1
               do ic = bbl0, bbh0
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i,j,k+1) = ((sigz(i-1,j-1,k) + sigz(i-1,j,k) +
     &                              sigz(i,j-1,k) + sigz(i,j,k)) *
     &                             src(ic,jc,kc) +
     &                            (sigz(i-1,j-1,k+1) + sigz(i-1,j,k+1) +
     &                              sigz(i,j-1,k+1) + sigz(i,j,k+1)) *
     &                             src(ic,jc,kc+1)) /
     &                             (sigz(i-1,j-1,k) + sigz(i-1,j,k) +
     &                              sigz(i,j-1,k) + sigz(i,j,k) +
     &                             sigz(i-1,j-1,k+1) + sigz(i-1,j,k+1) +
     &                              sigz(i,j-1,k+1) + sigz(i,j,k+1))
               end do
            end do
         end do
      end if
      if (ir .eq. 2 .and. jr .eq. 2) then
         do kc = bbl2, bbh2
            do jc = bbl1, bbh1-1
cdir$ ivdep
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i+1,j+1,k) = ((sigx(i,j,k-1) + sigx(i,j,k) +
     &                             sigx(i,j+1,k-1) + sigx(i,j+1,k)) *
     &                            dest(i,j+1,k) +
     &                            (sigx(i+1,j,k-1) + sigx(i+1,j,k) +
     &                            sigx(i+1,j+1,k-1) + sigx(i+1,j+1,k)) *
     &                            dest(i+2,j+1,k) +
     &                            (sigy(i,j,k-1) + sigy(i,j,k) +
     &                             sigy(i+1,j,k-1) + sigy(i+1,j,k)) *
     &                            dest(i+1,j,k) +
     &                            (sigy(i,j+1,k-1) + sigy(i,j+1,k) +
     &                            sigy(i+1,j+1,k-1) + sigy(i+1,j+1,k)) *
     &                            dest(i+1,j+2,k)) /
     &                           (sigx(i,j,k-1) + sigx(i,j,k) +
     &                            sigx(i,j+1,k-1) + sigx(i,j+1,k) +
     &                            sigx(i+1,j,k-1) + sigx(i+1,j,k) +
     &                            sigx(i+1,j+1,k-1) + sigx(i+1,j+1,k) +
     &                            sigy(i,j,k-1) + sigy(i,j,k) +
     &                            sigy(i+1,j,k-1) + sigy(i+1,j,k) +
     &                            sigy(i,j+1,k-1) + sigy(i,j+1,k) +
     &                            sigy(i+1,j+1,k-1) + sigy(i+1,j+1,k))
               end do
            end do
         end do
      end if
      if (ir .eq. 2 .and. kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1
cdir$ ivdep
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i+1,j,k+1) = ((sigx(i,j-1,k) + sigx(i,j-1,k+1) +
     &                             sigx(i,j,k) + sigx(i,j,k+1)) *
     &                            dest(i,j,k+1) +
     &                            (sigx(i+1,j-1,k) + sigx(i+1,j-1,k+1) +
     &                             sigx(i+1,j,k) + sigx(i+1,j,k+1)) *
     &                            dest(i+2,j,k+1) +
     &                            (sigz(i,j-1,k) + sigz(i,j,k) +
     &                             sigz(i+1,j-1,k) + sigz(i+1,j,k)) *
     &                            dest(i+1,j,k) +
     &                            (sigz(i,j-1,k+1) + sigz(i,j,k+1) +
     &                            sigz(i+1,j-1,k+1) + sigz(i+1,j,k+1)) *
     &                            dest(i+1,j,k+2)) /
     &                           (sigx(i,j-1,k) + sigx(i,j-1,k+1) +
     &                            sigx(i,j,k) + sigx(i,j,k+1) +
     &                            sigx(i+1,j-1,k) + sigx(i+1,j-1,k+1) +
     &                            sigx(i+1,j,k) + sigx(i+1,j,k+1) +
     &                            sigz(i,j-1,k) + sigz(i,j,k) +
     &                            sigz(i+1,j-1,k) + sigz(i+1,j,k) +
     &                            sigz(i,j-1,k+1) + sigz(i,j,k+1) +
     &                            sigz(i+1,j-1,k+1) + sigz(i+1,j,k+1))
               end do
            end do
         end do
      end if
      if (jr .eq. 2 .and. kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1-1
cdir$ ivdep
               do ic = bbl0, bbh0
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i,j+1,k+1) = ((sigy(i-1,j,k) + sigy(i-1,j,k+1) +
     &                             sigy(i,j,k) + sigy(i,j,k+1)) *
     &                            dest(i,j,k+1) +
     &                            (sigy(i-1,j+1,k) + sigy(i-1,j+1,k+1) +
     &                             sigy(i,j+1,k) + sigy(i,j+1,k+1)) *
     &                            dest(i,j+2,k+1) +
     &                            (sigz(i-1,j,k) + sigz(i-1,j+1,k) +
     &                             sigz(i,j,k) + sigz(i,j+1,k)) *
     &                            dest(i,j+1,k) +
     &                            (sigz(i-1,j,k+1) + sigz(i-1,j+1,k+1) +
     &                             sigz(i,j,k+1) + sigz(i,j+1,k+1)) *
     &                            dest(i,j+1,k+2)) /
     &                           (sigy(i-1,j,k) + sigy(i-1,j,k+1) +
     &                            sigy(i,j,k) + sigy(i,j,k+1) +
     &                            sigy(i-1,j+1,k) + sigy(i-1,j+1,k+1) +
     &                            sigy(i,j+1,k) + sigy(i,j+1,k+1) +
     &                            sigz(i-1,j,k) + sigz(i-1,j+1,k) +
     &                            sigz(i,j,k) + sigz(i,j+1,k) +
     &                            sigz(i-1,j,k+1) + sigz(i-1,j+1,k+1) +
     &                            sigz(i,j,k+1) + sigz(i,j+1,k+1))
               end do
            end do
         end do
      end if
      if (ir .eq. 2 .and. jr .eq. 2 .and. kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1-1
cdir$ ivdep
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
               dest(i+1,j+1,k+1) = ((sigx(i,j,k) + sigx(i,j,k+1) +
     &                               sigx(i,j+1,k) + sigx(i,j+1,k+1)) *
     &                              dest(i,j+1,k+1) +
     &                              (sigx(i+1,j,k) + sigx(i+1,j,k+1) +
     &                            sigx(i+1,j+1,k) + sigx(i+1,j+1,k+1)) *
     &                              dest(i+2,j+1,k+1) +
     &                              (sigy(i,j,k) + sigy(i,j,k+1) +
     &                               sigy(i+1,j,k) + sigy(i+1,j,k+1)) *
     &                              dest(i+1,j,k+1) +
     &                              (sigy(i,j+1,k) + sigy(i,j+1,k+1) +
     &                            sigy(i+1,j+1,k) + sigy(i+1,j+1,k+1)) *
     &                              dest(i+1,j+2,k+1) +
     &                              (sigz(i,j,k) + sigz(i,j+1,k) +
     &                               sigz(i+1,j,k) + sigz(i+1,j+1,k)) *
     &                              dest(i+1,j+1,k) +
     &                              (sigz(i,j,k+1) + sigz(i,j+1,k+1) +
     &                            sigz(i+1,j,k+1) + sigz(i+1,j+1,k+1)) *
     &                              dest(i+1,j+1,k+2))
               dest(i+1,j+1,k+1) = dest(i+1,j+1,k+1) /
     &                             (sigx(i,j,k) + sigx(i,j,k+1) +
     &                              sigx(i,j+1,k) + sigx(i,j+1,k+1) +
     &                              sigx(i+1,j,k) + sigx(i+1,j,k+1) +
     &                             sigx(i+1,j+1,k) + sigx(i+1,j+1,k+1) +
     &                              sigy(i,j,k) + sigy(i,j,k+1) +
     &                              sigy(i+1,j,k) + sigy(i+1,j,k+1) +
     &                              sigy(i,j+1,k) + sigy(i,j+1,k+1) +
     &                             sigy(i+1,j+1,k) + sigy(i+1,j+1,k+1) +
     &                              sigz(i,j,k) + sigz(i,j+1,k) +
     &                              sigz(i+1,j,k) + sigz(i+1,j+1,k) +
     &                              sigz(i,j,k+1) + sigz(i,j+1,k+1) +
     &                              sigz(i+1,j,k+1) + sigz(i+1,j+1,k+1))
               end do
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c NODE-based data, factor of 2 only.
      subroutine hgints(
     & dest,  destl0,desth0,destl1,desth1,destl2,desth2,
     &        regl0,regh0,regl1,regh1,regl2,regh2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     & src,   srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &        bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & ir, jr, kr)
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer ir, jr, kr
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      integer i, j, k, ic, jc, kc
      do kc = bbl2, bbh2
         do jc = bbl1, bbh1
            do ic = bbl0, bbh0
               dest(ir*ic,jr*jc,kr*kc) = src(ic,jc,kc)
            end do
         end do
      end do
      if (ir .eq. 2) then
         do kc = bbl2, bbh2
            do jc = bbl1, bbh1
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i+1,j,k) = (signd(i,j,k,1)   * src(ic,jc,kc) +
     &                          signd(i+1,j,k,1) * src(ic+1,jc,kc)) /
     &                         (signd(i,j,k,1) + signd(i+1,j,k,1))
               end do
            end do
         end do
      end if
      if (jr .eq. 2) then
         do kc = bbl2, bbh2
            do jc = bbl1, bbh1-1
               do ic = bbl0, bbh0
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i,j+1,k) = (signd(i,j,k,2)   * src(ic,jc,kc) +
     &                          signd(i,j+1,k,2) * src(ic,jc+1,kc)) /
     &                         (signd(i,j,k,2) + signd(i,j+1,k,2))
               end do
            end do
         end do
      end if
      if (kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1
               do ic = bbl0, bbh0
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i,j,k+1) = (signd(i,j,k,3)   * src(ic,jc,kc) +
     &                          signd(i,j,k+1,3) * src(ic,jc,kc+1)) /
     &                         (signd(i,j,k,3) + signd(i,j,k+1,3))
               end do
            end do
         end do
      end if
      if (ir .eq. 2 .and. jr .eq. 2) then
         do kc = bbl2, bbh2
            do jc = bbl1, bbh1-1
cdir$ ivdep
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                 dest(i+1,j+1,k) = (signd(i,j+1,k,1)   * dest(i,j+1,k) +
     &                            signd(i+1,j+1,k,1) * dest(i+2,j+1,k) +
     &                            signd(i+1,j,k,2)   * dest(i+1,j,k) +
     &                           signd(i+1,j+1,k,2) * dest(i+1,j+2,k)) /
     &                          (signd(i,j+1,k,1) + signd(i+1,j+1,k,1) +
     &                            signd(i+1,j,k,2) + signd(i+1,j+1,k,2))
               end do
            end do
         end do
      end if
      if (ir .eq. 2 .and. kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1
cdir$ ivdep
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
               dest(i+1,j,k+1) = (signd(i,j,k+1,1)   * dest(i,j,k+1) +
     &                            signd(i+1,j,k+1,1) * dest(i+2,j,k+1) +
     &                            signd(i+1,j,k,3)   * dest(i+1,j,k) +
     &                           signd(i+1,j,k+1,3) * dest(i+1,j,k+2)) /
     &                          (signd(i,j,k+1,1) + signd(i+1,j,k+1,1) +
     &                            signd(i+1,j,k,3) + signd(i+1,j,k+1,3))
               end do
            end do
         end do
      end if
      if (jr .eq. 2 .and. kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1-1
cdir$ ivdep
               do ic = bbl0, bbh0
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                 dest(i,j+1,k+1) = (signd(i,j,k+1,2)   * dest(i,j,k+1) +
     &                            signd(i,j+1,k+1,2) * dest(i,j+2,k+1) +
     &                            signd(i,j+1,k,3)   * dest(i,j+1,k) +
     &                           signd(i,j+1,k+1,3) * dest(i,j+1,k+2)) /
     &                          (signd(i,j,k+1,2) + signd(i,j+1,k+1,2) +
     &                            signd(i,j+1,k,3) + signd(i,j+1,k+1,3))
               end do
            end do
         end do
      end if
      if (ir .eq. 2 .and. jr .eq. 2 .and. kr .eq. 2) then
         do kc = bbl2, bbh2-1
            do jc = bbl1, bbh1-1
cdir$ ivdep
               do ic = bbl0, bbh0-1
                  i = ir * ic
                  j = jr * jc
                  k = kr * kc
                  dest(i+1,j+1,k+1) =
     &                (signd(i,j+1,k+1,1)   * dest(i,j+1,k+1) +
     &                 signd(i+1,j+1,k+1,1) * dest(i+2,j+1,k+1) +
     &                 signd(i+1,j,k+1,2)   * dest(i+1,j,k+1) +
     &                 signd(i+1,j+1,k+1,2) * dest(i+1,j+2,k+1) +
     &                 signd(i+1,j+1,k,3)   * dest(i+1,j+1,k) +
     &                 signd(i+1,j+1,k+1,3) * dest(i+1,j+1,k+2)) /
     &                 (signd(i,j+1,k+1,1) + signd(i+1,j+1,k+1,1) +
     &                  signd(i+1,j,k+1,2) + signd(i+1,j+1,k+1,2) +
     &                  signd(i+1,j+1,k,3) + signd(i+1,j+1,k+1,3))
               end do
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c CELL-based data only.
      subroutine hgsrst(
     & destx, desty, destz,
     &     destl0,desth0,destl1,desth1,destl2,desth2,
     &     regl0,regh0,regl1,regh1,regl2,regh2,
     & srcx, srcy, srcz,
     &     srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr)
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr
      double precision destx(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision desty(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision destz(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision srcx(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision srcy(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision srcz(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      integer i, j, k, i2, j2, k2
      if (ir .ne. 2 .and. jr .ne. 2 .and. kr .ne. 2) then
          stop "this can't happen"
      endif
      if (ir .eq. 2 .and. jr .eq. 2 .and. kr .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  i2 = 2 * i
                  j2 = 2 * j
                  k2 = 2 * k
                  destx(i,j,k) = 0.5D0 / (1.0D0 / (srcx(i2,j2,k2) +
     &                                            srcx(i2,j2,k2+1) +
     &                                            srcx(i2,j2+1,k2) +
     &                                            srcx(i2,j2+1,k2+1)) +
     &                                    1.0D0 / (srcx(i2+1,j2,k2) +
     &                                            srcx(i2+1,j2,k2+1) +
     &                                            srcx(i2+1,j2+1,k2) +
     &                                            srcx(i2+1,j2+1,k2+1)))
                  desty(i,j,k) = 0.5D0 / (1.0D0 / (srcy(i2,j2,k2) +
     &                                            srcy(i2,j2,k2+1) +
     &                                            srcy(i2+1,j2,k2) +
     &                                            srcy(i2+1,j2,k2+1)) +
     &                                    1.0D0 / (srcy(i2,j2+1,k2) +
     &                                            srcy(i2,j2+1,k2+1) +
     &                                            srcy(i2+1,j2+1,k2) +
     &                                            srcy(i2+1,j2+1,k2+1)))
                  destz(i,j,k) = 0.5D0 / (1.0D0 / (srcz(i2,j2,k2) +
     &                                            srcz(i2,j2+1,k2) +
     &                                            srcz(i2+1,j2,k2) +
     &                                            srcz(i2+1,j2+1,k2)) +
     &                                    1.0D0 / (srcz(i2,j2,k2+1) +
     &                                            srcz(i2,j2+1,k2+1) +
     &                                            srcz(i2+1,j2,k2+1) +
     &                                            srcz(i2+1,j2+1,k2+1)))
               end do
            end do
         end do
      else if (ir .eq. 2 .and. jr .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  i2 = 2 * i
                  j2 = 2 * j
                  destx(i,j,k) = 1.0D0 / (1.0D0 / (srcx(i2,j2,k) +
     &                                           srcx(i2,j2+1,k)) +
     &                                   1.0D0 / (srcx(i2+1,j2,k) +
     &                                           srcx(i2+1,j2+1,k)))
                  desty(i,j,k) = 1.0D0 / (1.0D0 / (srcy(i2,j2,k) +
     &                                           srcy(i2+1,j2,k)) +
     &                                   1.0D0 / (srcy(i2,j2+1,k) +
     &                                           srcy(i2+1,j2+1,k)))
                  destz(i,j,k) = 0.25D0 * (srcz(i2,j2,k) +
     &                                     srcz(i2,j2+1,k) +
     &                                     srcz(i2+1,j2,k) +
     &                                     srcz(i2+1,j2+1,k))
               end do
            end do
         end do
      else if (ir .eq. 2 .and. kr .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  i2 = 2 * i
                  k2 = 2 * k
                  destx(i,j,k) = 1.0D0 / (1.0D0 / (srcx(i2,j,k2) +
     &                                           srcx(i2,j,k2+1)) +
     &                                   1.0D0 / (srcx(i2+1,j,k2) +
     &                                           srcx(i2+1,j,k2+1)))
                  desty(i,j,k) = 0.25D0 * (srcy(i2,j,k2) +
     &                                     srcy(i2,j,k2+1) +
     &                                     srcy(i2+1,j,k2) +
     &                                     srcy(i2+1,j,k2+1))
                  destz(i,j,k) = 1.0D0 / (1.0D0 / (srcz(i2,j,k2) +
     &                                           srcz(i2+1,j,k2)) +
     &                                   1.0D0 / (srcz(i2,j,k2+1) +
     &                                           srcz(i2+1,j,k2+1)))
               end do
            end do
         end do
      else if (jr .eq. 2 .and. kr .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  j2 = 2 * j
                  k2 = 2 * k
                  destx(i,j,k) = 0.25D0 * (srcx(i,j2,k2) +
     &                                     srcx(i,j2,k2+1) +
     &                                     srcx(i,j2+1,k2) +
     &                                     srcx(i,j2+1,k2+1))
                  desty(i,j,k) = 1.0D0 / (1.0D0 / (srcy(i,j2,k2) +
     &                                           srcy(i,j2,k2+1)) +
     &                                   1.0D0 / (srcy(i,j2+1,k2) +
     &                                           srcy(i,j2+1,k2+1)))
                  destz(i,j,k) = 1.0D0 / (1.0D0 / (srcz(i,j2,k2) +
     &                                           srcz(i,j2+1,k2)) +
     &                                   1.0D0 / (srcz(i,j2,k2+1) +
     &                                           srcz(i,j2+1,k2+1)))
               end do
            end do
         end do
      else if (ir .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  i2 = 2 * i
                  destx(i,j,k) = 2.0D0 / (1.0D0 / srcx(i2,j,k) +
     &                                   1.0D0 / srcx(i2+1,j,k))
                  desty(i,j,k) = 0.5D0 * (srcy(i2,j,k) +
     &                                    srcy(i2+1,j,k))
                  destz(i,j,k) = 0.5D0 * (srcz(i2,j,k) +
     &                                    srcz(i2+1,j,k))
               end do
            end do
         end do
      else if (jr .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  j2 = 2 * j
                  destx(i,j,k) = 0.5D0 * (srcx(i,j2,k) +
     &                                    srcx(i,j2+1,k))
                  desty(i,j,k) = 2.0D0 / (1.0D0 / srcy(i,j2,k) +
     &                                   1.0D0 / srcy(i,j2+1,k))
                  destz(i,j,k) = 0.5D0 * (srcz(i,j2,k) +
     &                                    srcz(i,j2+1,k))
               end do
            end do
         end do
      else if (kr .eq. 2) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  k2 = 2 * k
                  destx(i,j,k) = 0.5D0 * (srcx(i,j,k2) +
     &                                    srcx(i,j,k2+1))
                  desty(i,j,k) = 0.5D0 * (srcy(i,j,k2) +
     &                                    srcy(i,j,k2+1))
                  destz(i,j,k) = 2.0D0 / (1.0D0 / srcz(i,j,k2) +
     &                                   1.0D0 / srcz(i,j,k2+1))
               end do
            end do
         end do
      end if
      end
c seven-point variable stencils
c-----------------------------------------------------------------------
      subroutine hgcen(
     & cen,   cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     &        regl0,regh0,regl1,regh1,regl2,regh2,idd)
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision tmp
      integer i, j, k
      integer idd
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               tmp = (signd(i-1,j,k,1) + signd(i,j,k,1) 
     &              + signd(i,j-1,k,2) + signd(i,j,k,2)
     &              + signd(i,j,k-1,3) + signd(i,j,k,3))
               if ( tmp .eq. 0.0D0 ) then
                  cen(i,j,k) = 0.0D0
               else
                  cen(i,j,k) = 1.0D0 / tmp
               end if
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c sig here contains three different directions all stored on "nodes"
      subroutine hgrlxu(
     & cor, res, sig, cen,
     &     resl0,resh0,resl1,resh1,resl2,resh2,
     & mask,
     &     regl0,regh0,regl1,regh1,regl2,regh2,idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cor(*)
      double precision res(*)
      double precision sig(*)
      double precision cen(*)
      double precision mask(*)
      double precision AVG
      integer i, jdiff, kdiff, ly, lz
      integer idd
      AVG() = (sig(i-1)        * cor(i-1) +
     &         sig(i)          * cor(i+1) +
     &         sig(i+ly-jdiff) * cor(i-jdiff) +
     &         sig(i+ly)       * cor(i+jdiff) +
     &         sig(i+lz-kdiff) * cor(i-kdiff) +
     &         sig(i+lz)       * cor(i+kdiff))
      jdiff =  resh0 - resl0 + 1
      kdiff = (resh1 - resl1 + 1) * jdiff
      ly    = (resh2 - resl2 + 1) * kdiff
      lz    = 2 * ly
cdir$ ivdep
      do i = (regl2 - resl2) * kdiff + (regl1 - resl1) * jdiff +
     &          (regl0 - resl0) + 1,
     &          (regh2 - resl2) * kdiff + (regh1 - resl1) * jdiff +
     &          (regh0 - resl0) + 1, 2
         cor(i) = cor(i)
     &      + mask(i) * ((AVG() - res(i)) * cen(i) - cor(i))
      end do
cdir$ ivdep
      do i = (regl2 - resl2) * kdiff + (regl1 - resl1) * jdiff +
     &          (regl0 - resl0) + 2,
     &          (regh2 - resl2) * kdiff + (regh1 - resl1) * jdiff +
     &          (regh0 - resl0) + 1, 2
         cor(i) = cor(i)
     &      + mask(i) * ((AVG() - res(i)) * cen(i) - cor(i))
      end do
      end
c-----------------------------------------------------------------------
c sig here contains three different directions all stored on "nodes"
      subroutine hgrlxur(
     & cor, res, signd, cen,
     &     resl0,resh0,resl1,resh1,resl2,resh2,
     &     regl0,regh0,regl1,regh1,regl2,regh2,idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cor(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision signd(resl0:resh0,resl1:resh1,resl2:resh2,3)
      double precision cen(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision AVG
      integer i, j, k, ipar0, ipass, jdiff, kdiff, ly, lz
      integer idd, ipar
      AVG() = (signd(i-1,j,k,1) * cor(i-1,j,k) +
     &         signd(i,j,k,1)   * cor(i+1,j,k) +
     &         signd(i,j-1,k,2) * cor(i,j-1,k) +
     &         signd(i,j,k,2)   * cor(i,j+1,k) +
     &         signd(i,j,k-1,3) * cor(i,j,k-1) +
     &         signd(i,j,k,3)   * cor(i,j,k+1))
      do ipass = 0, 1
         ipar0 = ipass
         do k = regl2, regh2
            ipar0 = 1 - ipar0
            ipar = ipar0
            do j = regl1, regh1
               ipar = 1 - ipar
cdir$ ivdep
               do i = regl0 + ipar, regh0, 2
                  cor(i,j,k) = (AVG() - res(i,j,k)) * cen(i,j,k)
               end do
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlx(
     & cor,   corl0,corh0,corl1,corh1,corl2,corh2,
     & res,   resl0,resh0,resl1,resh1,resl2,resh2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     & cen,   cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     &        regl0,regh0,regl1,regh1,regl2,regh2)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      integer i, j, k, ipar0, ipar, ipass
      double precision AVG
      AVG() = (signd(i-1,j,k,1) * cor(i-1,j,k) +
     &         signd(i,j,k,1)   * cor(i+1,j,k) +
     &         signd(i,j-1,k,2) * cor(i,j-1,k) +
     &         signd(i,j,k,2)   * cor(i,j+1,k) +
     &         signd(i,j,k-1,3) * cor(i,j,k-1) +
     &         signd(i,j,k,3)   * cor(i,j,k+1))
      do ipass = 0, 1
         ipar0 = ipass
         do k = regl2, regh2
            ipar0 = 1 - ipar0
            ipar = ipar0
            do j = regl1, regh1
               ipar = 1 - ipar
cdir$ ivdep
               do i = regl0 + ipar, regh0, 2
                  cor(i,j,k) = (AVG() - res(i,j,k)) * cen(i,j,k)
               end do
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlxl(
     & cor,   corl0,corh0,corl1,corh1,corl2,corh2,
     & res,   resl0,resh0,resl1,resh1,resl2,resh2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     & cen,   cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     &        regl0,regh0,regl1,regh1,regl2,regh2,
     &        doml0,domh0,doml1,domh1,doml2,domh2,
     & lsd)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer doml0,domh0,doml1,domh1,doml2,domh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      double precision wrk(256)
      integer lsd
      double precision betm, aj
      double precision RHSL2
      integer i, j, k, kw, ipass, ipar

      RHSL2() = (res(i,j,k) - (signd(i-1,j,k,1) * cor(i-1,j,k) +
     &                        signd(i,j,k,1)   * cor(i+1,j,k) +
     &                        signd(i,j-1,k,2) * cor(i,j-1,k) +
     &                        signd(i,j,k,2)   * cor(i,j+1,k)))

      if (lsd .ne. 2) then
         print *, "Line solve not implemented in dimension", lsd
          stop
      end if

      do ipass = 1, 0, -1
         ipar = ipass
         do i = regl0, regh0
            ipar = 1 - ipar
            do j = regl1 + ipar, regh1, 2
               k = regl2
               betm = -cen(i,j,k)
               if (betm .eq. 0.0D0) then
c dirichlet bdy:
                  cor(i,j,k) = 0.0D0
                  wrk(1) = 0.0D0
               else if (regl2 .eq. doml2) then
c neumann bdy:
                  cor(i,j,k) = RHSL2() * betm
                  aj = signd(i,j,k,3)
                  wrk(1) = 2.0D0 * aj * betm
               else
c interface to grid at same level:
                  aj = signd(i,j,k-1,3)
                  cor(i,j,k) = (RHSL2() - aj * cor(i,j,k-1)) * betm
                  aj = signd(i,j,k,3)
                  wrk(1) = aj * betm
               end if
c forward solve loop:
               do k = regl2 + 1, regh2 - 1
                  kw = k - regl2
                  if (cen(i,j,k) .eq. 0.0D0) then
                     betm = 0.0D0
                  else
                     betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(kw))
                  end if
                  cor(i,j,k) = (RHSL2() - aj * cor(i,j,k-1)) * betm
                  aj = signd(i,j,k,3)
                  wrk(kw + 1) = aj * betm
               end do
               k = regh2
               kw = k - regl2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
                  cor(i,j,k) = 0.0D0
               else if (regh2 .eq. domh2) then
c neumann bdy:
                  aj = 2.0D0 * aj
                  betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(kw))
                  cor(i,j,k) = (RHSL2() - aj * cor(i,j,k-1)) * betm
               else if (kw .gt. 0) then
c interface to grid at same level:
                  betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(kw))
                  cor(i,j,k) = RHSL2() - aj * cor(i,j,k-1)
                  aj = signd(i,j,k,3)
                  cor(i,j,k) = (cor(i,j,k) - aj * cor(i,j,k+1)) * betm
               end if
c back substitution loop:
               do k = regh2 - 1, regl2, -1
                  kw = k - regl2
                  cor(i,j,k) = cor(i,j,k) - wrk(kw + 1) * cor(i,j,k+1)
               end do
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlnf(
     & cor,   corl0,corh0,corl1,corh1,corl2,corh2,
     & res,   resl0,resh0,resl1,resh1,resl2,resh2,
     & wrk,   wrkl0,wrkh0,wrkl1,wrkh1,wrkl2,wrkh2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     & cen,   cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     & regl0, regh0,regl1,regh1,regl2,regh2,
     & doml0, domh0,doml1,domh1,doml2,domh2,
     & lsd, ipass)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer wrkl0,wrkh0,wrkl1,wrkh1,wrkl2,wrkh2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer doml0,domh0,doml1,domh1,doml2,domh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1,wrkl2:wrkh2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      integer lsd, ipass
      double precision betm, aj
      double precision rhsl0, rhsl1, rhsl2
      integer i, j, k, ioff, ipar
      RHSL0() = (res(i,j,k) - (signd(i,j-1,k,2) * cor(i,j-1,k) +
     &                        signd(i,j,k,2)   * cor(i,j+1,k) +
     &                        signd(i,j,k-1,3) * cor(i,j,k-1) +
     &                        signd(i,j,k,3)   * cor(i,j,k+1)))

      RHSL1() = (res(i,j,k) - (signd(i-1,j,k,1) * cor(i-1,j,k) +
     &                        signd(i,j,k,1)   * cor(i+1,j,k) +
     &                        signd(i,j,k-1,3) * cor(i,j,k-1) +
     &                        signd(i,j,k,3)   * cor(i,j,k+1)))

      RHSL2() = (res(i,j,k) - (signd(i-1,j,k,1) * cor(i-1,j,k) +
     &                        signd(i,j,k,1)   * cor(i+1,j,k) +
     &                        signd(i,j-1,k,2) * cor(i,j-1,k) +
     &                        signd(i,j,k,2)   * cor(i,j+1,k)))

      if (lsd .eq. 0) then
         if (mod(regl1 + regl2, 2) .eq. 0) then
            ioff = 1 - ipass
         else
            ioff = ipass
         end if
         i = regl0
         ipar = ioff
         do k = regl2, regh2
            ipar = 1 - ipar
            do j = regl1 + ipar, regh1, 2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
                  wrk(i,j,k) = 0.0D0
               else if (regl0 .eq. doml0) then
c neumann bdy:
                  betm = -cen(i,j,k)
                  cor(i,j,k) = RHSL0() * betm
                  aj = signd(i,j,k,1)
                  wrk(i,j,k) = 2.0D0 * aj * betm
               end if
            end do
         end do
c forward solve loop:
         do i = regl0 + 1, regh0 - 1
            ipar = ioff
            do k = regl2, regh2
               ipar = 1 - ipar
               do j = regl1 + ipar, regh1, 2
                  aj = signd(i-1,j,k,1)
                  if (cen(i,j,k) .eq. 0.0D0) then
                     betm = 0.0D0
                  else
                     betm = 1.0D0
     &                    / (-1.0D0 / cen(i,j,k) - aj * wrk(i-1,j,k))
                  end if
                  cor(i,j,k) = (RHSL0() - aj * cor(i-1,j,k)) * betm
                  aj = signd(i,j,k,1)
                  wrk(i,j,k) = aj * betm
               end do
            end do
         end do
         i = regh0
         ipar = ioff
         do k = regl2, regh2
            ipar = 1 - ipar
            do j = regl1 + ipar, regh1, 2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
               else if (regh0 .eq. domh0) then
c neumann bdy:
                  aj = 2.0D0 * signd(i-1,j,k,1)
                betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(i-1,j,k))
                  cor(i,j,k) = (RHSL0() - aj * cor(i-1,j,k)) * betm
               else if (i .gt. regl0) then
c interface to grid at same level:
                  aj = signd(i-1,j,k,1)
                betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(i-1,j,k))
                  cor(i,j,k) = (RHSL0() - aj * cor(i-1,j,k)) * betm
                  aj = signd(i,j,k,1)
                  wrk(i,j,k) = aj * betm
               end if
            end do
         end do
      else if (lsd .eq. 1) then
         if (mod(regl0 + regl2, 2) .eq. 0) then
            ioff = 1 - ipass
         else
            ioff = ipass
         end if
         j = regl1
         ipar = ioff
         do  k = regl2, regh2
            ipar = 1 - ipar
            do i = regl0 + ipar, regh0, 2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
                  wrk(i,j,k) = 0.0D0
               else if (regl1 .eq. doml1) then
c neumann bdy:
                  betm = -cen(i,j,k)
                  cor(i,j,k) = RHSL1() * betm
                  aj = signd(i,j,k,2)
                  wrk(i,j,k) = 2.0D0 * aj * betm
               end if
            end do
         end do
c forward solve loop:
         do j = regl1 + 1, regh1 - 1
            ipar = ioff
            do k = regl2, regh2
               ipar = 1 - ipar
               do i = regl0 + ipar, regh0, 2
                  aj = signd(i,j-1,k,2)
                  if (cen(i,j,k) .eq. 0.0D0) then
                     betm = 0.0D0
                  else
                     betm = 1.0D0
     &                    / (-1.0D0 / cen(i,j,k) - aj * wrk(i,j-1,k))
                  end if
                  cor(i,j,k) = (RHSL1() - aj * cor(i,j-1,k)) * betm
                  aj = signd(i,j,k,2)
                  wrk(i,j,k) = aj * betm
               end do
            end do
         end do
         j = regh1
         ipar = ioff
         do k = regl2, regh2
            ipar = 1 - ipar
            do i = regl0 + ipar, regh0, 2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
               else if (regh1 .eq. domh1) then
c neumann bdy:
                  aj = 2.0D0 * signd(i,j-1,k,2)
                betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(i,j-1,k))
                  cor(i,j,k) = (RHSL1() - aj * cor(i,j-1,k)) * betm
               else if (j .gt. regl1) then
c interface to grid at same level:
                  aj = signd(i,j-1,k,2)
                betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(i,j-1,k))
                  cor(i,j,k) = (RHSL1() - aj * cor(i,j-1,k)) * betm
                  aj = signd(i,j,k,2)
                  wrk(i,j,k) = aj * betm
               end if
            end do
         end do
      else
         if (mod(regl0 + regl1, 2) .eq. 0) then
            ioff = 1 - ipass
         else
            ioff = ipass
         end if
         k = regl2
         ipar = ioff
         do j = regl1, regh1
            ipar = 1 - ipar
            do i = regl0 + ipar, regh0, 2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
                  wrk(i,j,k) = 0.0D0
               else if (regl2 .eq. doml2) then
c neumann bdy:
                  betm = -cen(i,j,k)
                  cor(i,j,k) = RHSL2() * betm
                  aj = signd(i,j,k,3)
                  wrk(i,j,k) = 2.0D0 * aj * betm
               end if
            end do
         end do
c forward solve loop:
         do k = regl2 + 1, regh2 - 1
            ipar = ioff
            do j = regl1, regh1
               ipar = 1 - ipar
               do i = regl0 + ipar, regh0, 2
                  aj = signd(i,j,k-1,3)
                  if (cen(i,j,k) .eq. 0.0D0) then
                     betm = 0.0D0
                  else
                     betm = 1.0D0
     &                    / (-1.0D0 / cen(i,j,k) - aj * wrk(i,j,k-1))
                  end if
                  cor(i,j,k) = (RHSL2() - aj * cor(i,j,k-1)) * betm
                  aj = signd(i,j,k,3)
                  wrk(i,j,k) = aj * betm
               end do
            end do
         end do
         k = regh2
         ipar = ioff
         do j = regl1, regh1
            ipar = 1 - ipar
            do i = regl0 + ipar, regh0, 2
               if (cen(i,j,k) .eq. 0.0D0) then
c dirichlet bdy:
               else if (regh2 .eq. domh2) then
c neumann bdy:
                  aj = 2.0D0 * signd(i,j,k-1,3)
                betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(i,j,k-1))
                  cor(i,j,k) = (RHSL2() - aj * cor(i,j,k-1)) * betm
               else if (k .gt. regl2) then
c interface to grid at same level:
                  aj = signd(i,j,k-1,3)
                betm = 1.0D0 / (-1.0D0 / cen(i,j,k) - aj * wrk(i,j,k-1))
                  cor(i,j,k) = (RHSL2() - aj * cor(i,j,k-1)) * betm
                  aj = signd(i,j,k,3)
                  wrk(i,j,k) = aj * betm
               end if
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgres(
     & res,   resl0,resh0,resl1,resh1,resl2,resh2,
     & src,   srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & dest,  destl0,desth0,destl1,desth1,destl2,desth2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     &        regl0,regh0,regl1,regh1,regl2,regh2)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      integer i, j, k
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               res(i,j,k) = src(i,j,k) -
     &        (signd(i-1,j,k,1) * (dest(i-1,j,k) - dest(i,j,k)) +
     &         signd(i,j,k,1)   * (dest(i+1,j,k) - dest(i,j,k)) +
     &         signd(i,j-1,k,2) * (dest(i,j-1,k) - dest(i,j,k)) +
     &         signd(i,j,k,2)   * (dest(i,j+1,k) - dest(i,j,k)) +
     &         signd(i,j,k-1,3) * (dest(i,j,k-1) - dest(i,j,k)) +
     &         signd(i,j,k,3)   * (dest(i,j,k+1) - dest(i,j,k)))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgresu(
     & res, resl0,resh0,resl1,resh1,resl2,resh2,
     & src, dest, signd, mask,
     &      regl0,regh0,regl1,regh1,regl2,regh2,
     & idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(*)
      double precision src(*)
      double precision dest(*)
      double precision signd(*)
      double precision mask(*)
      integer i, jdiff, kdiff, ly, lz
      integer idd
      jdiff = resh0 - resl0 + 1
      kdiff = (resh1 - resl1 + 1) * jdiff
      ly    = (resh2 - resl2 + 1) * kdiff
      lz    = 2 * ly
      do i = (regl2 - resl2) * kdiff + (regl1 - resl1) * jdiff +
     &          (regl0 - resl0) + 1,
     &          (regh2 - resl2) * kdiff + (regh1 - resl1) * jdiff +
     &          (regh0 - resl0) + 1
         res(i) = mask(i) * (src(i) -
     &     (signd(i-1)        * (dest(i-1) - dest(i)) +
     &      signd(i)          * (dest(i+1) - dest(i)) +
     &      signd(i+ly-jdiff) * (dest(i-jdiff) - dest(i)) +
     &      signd(i+ly)       * (dest(i+jdiff) - dest(i)) +
     &      signd(i+lz-kdiff) * (dest(i-kdiff) - dest(i)) +
     &      signd(i+lz)       * (dest(i+kdiff) - dest(i))))
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgresur(
     & res, resl0,resh0,resl1,resh1,resl2,resh2,
     & src, dest, signd,
     &      regl0,regh0,regl1,regh1,regl2,regh2,
     & idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision dest(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision signd(resl0:resh0,resl1:resh1,resl2:resh2,3)
      integer i, j, k, jdiff, kdiff, ly, lz
      integer idd
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               res(i,j,k) = src(i,j,k) -
     &        (signd(i-1,j,k,1) * (dest(i-1,j,k) - dest(i,j,k)) +
     &         signd(i,j,k,1)   * (dest(i+1,j,k) - dest(i,j,k)) +
     &         signd(i,j-1,k,2) * (dest(i,j-1,k) - dest(i,j,k)) +
     &         signd(i,j,k,2)   * (dest(i,j+1,k) - dest(i,j,k)) +
     &         signd(i,j,k-1,3) * (dest(i,j,k-1) - dest(i,j,k)) +
     &         signd(i,j,k,3)   * (dest(i,j,k+1) - dest(i,j,k)))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgscon(
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     & sigx, sigy, sigz,
     &        scl0,sch0,scl1,sch1,scl2,sch2,
     &        regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz)
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision sigx(scl0:sch0,scl1:sch1,scl2:sch2)
      double precision sigy(scl0:sch0,scl1:sch1,scl2:sch2)
      double precision sigz(scl0:sch0,scl1:sch1,scl2:sch2)
      double precision hx, hy, hz
      double precision facx, facy, facz
      integer i, j, k
      facx = 0.25D0 / (hx*hx)
      facy = 0.25D0 / (hy*hy)
      facz = 0.25D0 / (hz*hz)
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0-1, regh0
               signd(i,j,k,1) = facx *
     &               (sigx(i,j-1,k-1) + sigx(i,j-1,k) +
     &                sigx(i,j,k-1)   + sigx(i,j,k))
            end do
         end do
      end do
      do k = regl2, regh2
         do j = regl1-1, regh1
            do i = regl0, regh0
               signd(i,j,k,2) = facy *
     &               (sigy(i-1,j,k-1) + sigy(i-1,j,k) +
     &                sigy(i,j,k-1)   + sigy(i,j,k))
            end do
         end do
      end do
      do k = regl2-1, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               signd(i,j,k,3) = facz *
     &               (sigz(i-1,j-1,k) + sigz(i-1,j,k) +
     &                sigz(i,j-1,k)   + sigz(i,j,k))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlx_no_sigma(
     & cor, corl0,corh0,corl1,corh1,corl2,corh2,
     & res, resl0,resh0,resl1,resh1,resl2,resh2,
     & sigx, sigy, sigz,
     &      sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & cen, cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     &      regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision sigx(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigy(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigz(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      double precision hx, hy, hz, hxm2, hym2, hzm2
      double precision AVG
      integer i, j, k, ipass, ipar, ipar0
      AVG() = 0.25D0 * (hxm2 *
     &          ((sigx(i-1,j-1,k-1) + sigx(i-1,j-1,k) +
     &            sigx(i-1,j,k-1)   + sigx(i-1,j,k)) * cor(i-1,j,k) +
     &           (sigx(i,j-1,k-1)   + sigx(i,j-1,k) +
     &            sigx(i,j,k-1)     + sigx(i,j,k)) * cor(i+1,j,k)) +
     &                 hym2 *
     &          ((sigy(i-1,j-1,k-1) + sigy(i-1,j-1,k) +
     &            sigy(i,j-1,k-1)   + sigy(i,j-1,k)) * cor(i,j-1,k) +
     &           (sigy(i-1,j,k-1)   + sigy(i-1,j,k) +
     &            sigy(i,j,k-1)     + sigy(i,j,k)) * cor(i,j+1,k)) +
     &                 hzm2 *
     &          ((sigz(i-1,j-1,k-1) + sigz(i-1,j,k-1) +
     &            sigz(i,j-1,k-1)   + sigz(i,j,k-1)) * cor(i,j,k-1) +
     &           (sigz(i-1,j-1,k)   + sigz(i-1,j,k) +
     &            sigz(i,j-1,k)     + sigz(i,j,k)) * cor(i,j,k+1)))
      hxm2 = 1.0D0 / (hx*hx)
      hym2 = 1.0D0 / (hy*hy)
      hzm2 = 1.0D0 / (hz*hz)
      do ipass = 0, 1
         ipar0 = ipass
         do k = regl2, regh2
            ipar0 = 1 - ipar0
            ipar = ipar0
            do j = regl1, regh1
               ipar = 1 - ipar
cdir$ ivdep
               do i = regl0 + ipar, regh0, 2
                  cor(i,j,k) = (AVG() - res(i,j,k)) * cen(i,j,k)
               end do
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgres_no_sigma(
     & res,  resl0,resh0,resl1,resh1,resl2,resh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     & sigx, sigy, sigz,
     &       sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision sigx(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigy(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision sigz(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2)
      double precision hx, hy, hz, hxm2, hym2, hzm2
      integer i, j, k
      hxm2 = 1.0D0 / (hx*hx)
      hym2 = 1.0D0 / (hy*hy)
      hzm2 = 1.0D0 / (hz*hz)
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  res(i,j,k) = src(i,j,k) - 0.25D0 *        (hxm2 *
     &              ((sigx(i-1,j-1,k-1) + sigx(i-1,j-1,k) +
     &                sigx(i-1,j,k-1)   + sigx(i-1,j,k)) *
     &                (dest(i-1,j,k) - dest(i,j,k)) +
     &               (sigx(i,j-1,k-1)   + sigx(i,j-1,k) +
     &                sigx(i,j,k-1)     + sigx(i,j,k)) *
     &                (dest(i+1,j,k) - dest(i,j,k))) +       hym2 *
     &              ((sigy(i-1,j-1,k-1) + sigy(i-1,j-1,k) +
     &                sigy(i,j-1,k-1)   + sigy(i,j-1,k)) *
     &                (dest(i,j-1,k) - dest(i,j,k)) +
     &               (sigy(i-1,j,k-1)   + sigy(i-1,j,k) +
     &                sigy(i,j,k-1)     + sigy(i,j,k)) *
     &                (dest(i,j+1,k) - dest(i,j,k))) +       hzm2 *
     &              ((sigz(i-1,j-1,k-1) + sigz(i-1,j,k-1) +
     &                sigz(i,j-1,k-1)   + sigz(i,j,k-1)) *
     &                (dest(i,j,k-1) - dest(i,j,k)) +
     &               (sigz(i-1,j-1,k)   + sigz(i-1,j,k) +
     &                sigz(i,j-1,k)     + sigz(i,j,k)) *
     &                (dest(i,j,k+1) - dest(i,j,k)))             )
               end do
            end do
         end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlnb(
     & cor, corl0,corh0,corl1,corh1,corl2,corh2,
     & wrk, wrkl0,wrkh0,wrkl1,wrkh1,wrkl2,wrkh2,
     &      regl0,regh0,regl1,regh1,regl2,regh2,
     & lsd, ipass)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer wrkl0,wrkh0,wrkl1,wrkh1,wrkl2,wrkh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1,wrkl2:wrkh2)
      integer lsd, ipass
      integer ioff, ipar, i, j, k
      if (lsd .eq. 0) then
         if (mod(regl1 + regl2, 2) .eq. 0) then
            ioff = 1 - ipass
         else
            ioff = ipass
         end if
c back substitution loop:
         do i = regh0 - 1, regl0, -1
            ipar = ioff
            do k = regl2, regh2
               ipar = 1 - ipar
               do j = regl1 + ipar, regh1, 2
                  cor(i,j,k) = cor(i,j,k) - wrk(i,j,k) * cor(i+1,j,k)
               end do
            end do
         end do
      else if (lsd .eq. 1) then
         if (mod(regl0 + regl2, 2) .eq. 0) then
            ioff = 1 - ipass
         else
            ioff = ipass
         end if
c back substitution loop:
         do j = regh1 - 1, regl1, -1
            ipar = ioff
            do k = regl2, regh2
               ipar = 1 - ipar
               do i = regl0 + ipar, regh0, 2
                  cor(i,j,k) = cor(i,j,k) - wrk(i,j,k) * cor(i,j+1,k)
               end do
            end do
         end do
      else
         if (mod(regl0 + regl1, 2) .eq. 0) then
            ioff = 1 - ipass
         else
            ioff = ipass
         end if
c back substitution loop:
         do k = regh2 - 1, regl2, -1
            ipar = ioff
            do j = regl1, regh1
               ipar = 1 - ipar
               do i = regl0 + ipar, regh0, 2
                  cor(i,j,k) = cor(i,j,k) - wrk(i,j,k) * cor(i,j,k+1)
               end do
            end do
         end do
      end if
      end
c Unrolled indexing in these 3 routines uses the fact that each array
c has a border of width 1
c-----------------------------------------------------------------------
c Works for NODE-based data.
      subroutine hgip(
     & v0, v1, mask,
     &     regl0,regh0,regl1,regh1,regl2,regh2,
     & sum)
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision v0(*)
      double precision v1(*)
      double precision mask(*)
      double precision sum
      integer i, jdiff, kdiff
      jdiff = regh0 - regl0 + 1
      kdiff = (regh1 - regl1 + 1) * jdiff
      do i = kdiff + jdiff + 2, kdiff * (regh2 - regl2) - jdiff - 1
         sum = sum + mask(i) * v0(i) * v1(i)
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgcg1(
     & r, p, z, x, w, c, mask,
     &     regl0,regh0,regl1,regh1,regl2,regh2,
     & alpha, rho)
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision r(*)
      double precision p(*)
      double precision z(*)
      double precision x(*)
      double precision w(*)
      double precision c(*)
      double precision mask(*)
      double precision alpha, rho
      integer i, jdiff, kdiff
      jdiff = regh0 - regl0 + 1
      kdiff = (regh1 - regl1 + 1) * jdiff
      do i = kdiff + jdiff + 2, kdiff * (regh2 - regl2) - jdiff - 1
         r(i) = r(i) - alpha * w(i)
         x(i) = x(i) + alpha * p(i)
         z(i) = r(i) * c(i)
         rho = rho + mask(i) * z(i) * r(i)
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgcg2(
     & p, z,
     &     regl0,regh0,regl1,regh1,regl2,regh2,
     & alpha)
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision p(*)
      double precision z(*)
      double precision alpha
      integer i, jdiff, kdiff
      jdiff = regh0 - regl0 + 1
      kdiff = (regh1 - regl1 + 1) * jdiff
      do i = kdiff + jdiff + 2, kdiff * (regh2 - regl2) - jdiff - 1
         p(i) = alpha * p(i) + z(i)
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgcg_cd(
     & r, p, z, x, w, c, mask,
     & ngrids, strid1, strid2, nvals,
     & rs, ps, zs, xs, ws, cs, ms,
     & nsets, edge, nvals1, nvals2, dstart, sstart,
     & dstrd1, dstrd2, sstrd1, sstrd2,
     & hx, alpha, rho, it, pcode)
      double precision r(0:*), p(0:*), z(0:*)
      double precision x(0:*), w(0:*), c(0:*), mask(0:*)
      integer ngrids
      integer strid1(ngrids), strid2(ngrids), nvals(ngrids)
      integer rs(ngrids), ps(ngrids), zs(ngrids)
      integer xs(ngrids), ws(ngrids), cs(ngrids), ms(ngrids)
      double precision edge(0:*)
      integer nsets
      integer nvals1(nsets), nvals2(nsets)
      integer dstart(nsets), sstart(nsets)
      integer dstrd1(nsets), dstrd2(nsets)
      integer sstrd1(nsets), sstrd2(nsets)
      double precision hx, alpha, rho
      double precision hxm2, facm, tol, rhoold
      integer it, pcode, k, i, j, MAXITER
      parameter (MAXITER = 250)
      hxm2 = 1.0D0 / (hx*hx)
cifdef HG_CROSS_STENCIL
      facm = -hxm2
celse
c      facm = -hxm2 / three
cendif
      rho = 0.0D0
      do k = 1, ngrids
c must do this loop over entire array to initialize borders of p
         do i = 0, nvals(k) - 1
            z(zs(k)+i) = r(rs(k)+i) * c(cs(k)+i)
            p(ps(k)+i) = z(zs(k)+i)
            rho = rho + mask(ms(k)+i) * z(zs(k)+i) * r(rs(k)+i)
         end do
      end do
      tol = rho / 1000
      if (tol .le. 0.0D0) return
 100  continue
      it = it + 1
      if (it .gt. MAXITER) then
         STOP "FORTRAN hgcg---conjugate-gradient iteration failed"
      end if
      rhoold = rho
      alpha = 0.0D0
      do k = 1, nsets
         do j = 0, nvals2(k) - 1
            do i = 0, nvals1(k) - 1
               edge(dstart(k) + j * dstrd2(k) + i * dstrd1(k)) =
     &         edge(sstart(k) + j * sstrd2(k) + i * sstrd1(k))
            end do
         end do
      end do
      do k = 1, ngrids
         do i = strid1(k) + strid2(k) + 1,
     &              nvals(k) - strid1(k) - strid2(k) - 2
cifdef HG_CROSS_STENCIL
            w(ws(k)+i) = facm *
     &        (p(ps(k)+i-1) + p(ps(k)+i+1) +
     &         p(ps(k)+i-strid1(k)) + p(ps(k)+i+strid1(k)) +
     &         p(ps(k)+i-strid2(k)) + p(ps(k)+i+strid2(k)) -
     &         6.0D0 * p(ps(k)+i))
celse
c            print *, "FORTRAN hgcg---full box stencils not implemented"
cendif
            alpha = alpha + mask(ms(k)+i) * p(ps(k)+i) * w(ws(k)+i)
         end do
      end do
      alpha = rho / alpha
      rho = 0.0D0
      do k = 1, ngrids
         do i = strid1(k) + strid2(k) + 1,
     &              nvals(k) - strid1(k) - strid2(k) - 2
            r(rs(k)+i) = r(rs(k)+i) - alpha * w(ws(k)+i)
            x(xs(k)+i) = x(xs(k)+i) + alpha * p(ps(k)+i)
            z(zs(k)+i) = r(rs(k)+i) * c(cs(k)+i)
            rho = rho + mask(ms(k)+i) * z(zs(k)+i) * r(rs(k)+i)
         end do
      end do
      if (pcode .ge. 3) then
         print *, it, rho
      end if
      if (rho .le. tol .or. it .gt. MAXITER) return
      alpha = rho / rhoold
      do k = 1, ngrids
         do i = strid1(k) + strid2(k) + 1,
     &              nvals(k) - strid1(k) - strid2(k) - 2
            p(ps(k)+i) = alpha * p(ps(k)+i) + z(zs(k)+i)
         end do
      end do
      go to 100
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "ArrayLim.H"

#define SDIM 3

      subroutine TRANSV(v,DIMS(v),dx,domnlo,v1,DIMS(v1),v2,DIMS(v2))
      implicit none
      integer DIMDEC(v)
      integer DIMDEC(v1)
      integer DIMDEC(v2)
      REAL_T  v(DIMV(v),*)
      REAL_T v1(DIMV(v),*)
      REAL_T v2(DIMV(v),*)
      REAL_T dx(SDIM), domnlo(SDIM)
      integer i,j,k
      REAL_T x,y,vx,vy,vz,vr,vt,r,st,ct

      do j=ARG_L2(v),ARG_H2(v)

         do k=ARG_L3(v),ARG_H3(v)
            y = (float(k)+0.5d0)*dx(3)+domnlo(3)
            do i=ARG_L1(v),ARG_H1(v)
               x = (float(i)+0.5d0)*dx(1)+domnlo(1)

               vx = v(i,j,k,1)*1.d-2
               vy = v(i,j,k,3)*1.d-2
               vz = v(i,j,k,2)*1.d-2

               r = SQRT(x*x + y*y)
               if (r.le.2.5d0) then

                  if (r.lt.1.d-10) then
                     print *,'PUKE! illdefined if r=0'
                     call bl_abort(" ")
                  else
                     st = y / r
                     ct = x / r
                     vr = vx*ct + vy*st
                     vt = vy*ct - vx*st
                  endif
                  
               else 

                  vr = 0.d0
                  vt = 0.d0
                  vz = 0.d0

               endif

               v1(i,j,k,1) = vr
               v1(i,j,k,2) = vt
               v1(i,j,k,3) = vz

               v2(i,j,k,1) = vr*vr
               v2(i,j,k,2) = vt*vt
               v2(i,j,k,3) = vz*vz

            enddo
         enddo
      enddo

      end

      
      subroutine ROOTMS(v1, v2, DIMS(v))
      implicit none
      integer DIMDEC(v)
      REAL_T v1(DIMV(v),3)
      REAL_T v2(DIMV(v),3)
      integer i,j,k,n

      do k=ARG_L3(v),ARG_H3(v)
         do j=ARG_L2(v),ARG_H2(v)
            do i=ARG_L1(v),ARG_H1(v)
               do n=1,3
                  v2(i,j,k,n) = sqrt(abs(v2(i,j,k,n) - v1(i,j,k,n)**2))
               enddo
            enddo
         enddo
      enddo
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: INTERPBNDRYDATA_3D.F,v 1.2 2002/10/19 18:33:57 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "BC_TYPES.H"
#include "REAL.H"
#include "CONSTANTS.H"
#include "INTERPBNDRYDATA_F.H"
#include "ArrayLim.H"

#define SDIM 3
#define NUMDERIV 5
#define XDER   1
#define YDER   2
#define X2DER  3
#define Y2DER  4
#define XYDER  5

c ---------------------------------------------------------------
c ::  FORT_BDINTERPXLO : Interpolation on Xlo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(3)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(3), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM23(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, yy, ainterp
      integer  i, j, k, ic, jc, kc, joff, koff, n
      integer  jclo, jchi, kclo, kchi, ratioy, ratioz

      ratioy = ratios(2)
      ratioz = ratios(3)

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_L1(cb)-1
      i    = lo(1)-1

      do n = 1, nvar
c        ::::: define interp coefs
         do kc = kclo, kchi
         k = ratioz*kc
         do jc = jclo, jchi
            j = ratioy*jc
            derives(jc,kc,XDER)  = half*(crse(ic,jc+1,kc,n) - crse(ic,jc-1,kc,n))
            derives(jc,kc,X2DER) = half*(crse(ic,jc+1,kc,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc-1,kc,n))
            derives(jc,kc,YDER)  = half*(crse(ic,jc,kc+1,n) - crse(ic,jc,kc-1,n))
            derives(jc,kc,Y2DER) = half*(crse(ic,jc,kc+1,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc,kc-1,n))
            derives(jc,kc,XYDER) = forth*(crse(ic,jc+1,kc+1,n) - crse(ic,jc-1,kc+1,n)
     &                     + crse(ic,jc-1,kc-1,n) - crse(ic,jc+1,kc-1,n))

            if (mask(i,j-1,k) .ne. not_covered) then
               derives(jc,kc,XDER)  = crse(ic,jc+1,kc,n) - crse(ic,jc,kc,n)
               derives(jc,kc,X2DER) = zero
            end if
            if (mask(i,j+ratioy,k) .ne. not_covered) then
               derives(jc,kc,XDER)  = crse(ic,jc,kc,n) - crse(ic,jc-1,kc,n)
               derives(jc,kc,X2DER) = zero
            end if
            if (mask(i,j-1,k)     .ne. not_covered .and.
     $          mask(i,j+ratioy,k) .ne. not_covered) then
               derives(jc,kc,XDER)  = zero
            end if

            if (mask(i,j,k-1) .ne. not_covered) then
               derives(jc,kc,YDER)  = crse(ic,jc,kc+1,n) - crse(ic,jc,kc,n)
               derives(jc,kc,Y2DER) = zero
            end if
            if (mask(i,j,k+ratioz) .ne. not_covered) then
               derives(jc,kc,YDER)  = crse(ic,jc,kc,n) - crse(ic,jc,kc-1,n)
               derives(jc,kc,Y2DER) = zero
            end if
            if (mask(i,j,k-1)     .ne. not_covered .and.
     $          mask(i,j,k+ratioz) .ne. not_covered) then
               derives(jc,kc,YDER)  = zero
            end if
            if ( 
     $           ( mask(i,j+ratioy,k+ratioz) .ne. not_covered ) .or.
     $           ( mask(i,j-1,k+ratioz)     .ne. not_covered ) .or.
     $           ( mask(i,j+ratioy,k-1)     .ne. not_covered ) .or.
     $           ( mask(i,j-1,k-1)         .ne. not_covered ) ) then

               derives(jc,kc,XYDER) = zero
            end if
         end do
         end do

c        ::::: interpolate to fine grid
         do koff = 0, ratioz - 1
            yy = (dble(koff - ratioz/2) + half)/ratioz
            do kc = kclo,kchi
               k = ratioz*kc + koff
               do joff = 0, ratioy - 1
                  xx = (dble(joff - ratioy/2) + half)/ratioy
                  do jc = jclo, jchi
                     j = ratioy*jc + joff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + xx*derives(jc,kc,XDER) 
     &                     + derives(jc,kc,X2DER)*xx**2 + yy*derives(jc,kc,YDER) 
     &                     + derives(jc,kc,Y2DER)*yy**2 + xx*yy*derives(jc,kc,XYDER) 
                  end do
               end do
            end do
         end do
      end do

      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPXHI : Interpolation on Xhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(3)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(3), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM23(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, yy, ainterp
      integer  i, j, k, ic, jc, kc, joff, koff, n
      integer  jclo, jchi, kclo, kchi, ratioy, ratioz

      ratioy = ratios(2)
      ratioz = ratios(3)

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_H1(cb)+1
      i    = hi(1)+1

      do n = 1, nvar
c        ::::: define interp coefs
         do kc = kclo, kchi
         k = ratioz*kc
         do jc = jclo, jchi
            j = ratioy*jc
            derives(jc,kc,XDER)  = half*(crse(ic,jc+1,kc,n) - crse(ic,jc-1,kc,n))
            derives(jc,kc,X2DER) = half*(crse(ic,jc+1,kc,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc-1,kc,n))
            derives(jc,kc,YDER)  = half*(crse(ic,jc,kc+1,n) - crse(ic,jc,kc-1,n))
            derives(jc,kc,Y2DER) = half*(crse(ic,jc,kc+1,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc,kc-1,n))
            derives(jc,kc,XYDER) = forth*(crse(ic,jc+1,kc+1,n) - crse(ic,jc-1,kc+1,n)
     &                     + crse(ic,jc-1,kc-1,n) - crse(ic,jc+1,kc-1,n))

            if (mask(i,j-1,k) .ne. not_covered) then
               derives(jc,kc,XDER)  = crse(ic,jc+1,kc,n) - crse(ic,jc,kc,n)
               derives(jc,kc,X2DER) = zero
            end if
            if (mask(i,j+ratioy,k) .ne. not_covered) then
               derives(jc,kc,XDER)  = crse(ic,jc,kc,n) - crse(ic,jc-1,kc,n)
               derives(jc,kc,X2DER) = zero
            end if
            if (mask(i,j-1,k)     .ne. not_covered .and.
     $          mask(i,j+ratioy,k) .ne. not_covered) then
               derives(jc,kc,XDER)  = zero
            end if

            if (mask(i,j,k-1) .ne. not_covered) then
               derives(jc,kc,YDER)  = crse(ic,jc,kc+1,n) - crse(ic,jc,kc,n)
               derives(jc,kc,Y2DER) = zero
            end if
            if (mask(i,j,k+ratioz) .ne. not_covered) then
               derives(jc,kc,YDER)  = crse(ic,jc,kc,n) - crse(ic,jc,kc-1,n)
               derives(jc,kc,Y2DER) = zero
            end if
            if (mask(i,j,k-1)     .ne. not_covered .and.
     $          mask(i,j,k+ratioz) .ne. not_covered) then
               derives(jc,kc,YDER)  = zero
            end if
            if (
     $           ( mask(i,j+ratioy,k+ratioz) .ne. not_covered ) .or.
     $           ( mask(i,j-1,k+ratioz)     .ne. not_covered ) .or.
     $           ( mask(i,j+ratioy,k-1)     .ne. not_covered ) .or.
     $           ( mask(i,j-1,k-1)         .ne. not_covered ) ) then
               
                derives(jc,kc,XYDER) = zero
            end if
         end do
         end do

c        ::::: interpolate to fine grid
         do koff = 0, ratioz - 1
            yy = (dble(koff - ratioz/2) + half)/ratioz
            do kc = kclo,kchi
               k = ratioz*kc + koff
               do joff = 0, ratioy - 1
                  xx = (dble(joff - ratioy/2) + half)/ratioy
                  do jc = jclo, jchi
                     j = ratioy*jc + joff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + xx*derives(jc,kc,XDER) 
     &                     + derives(jc,kc,X2DER)*xx**2 + yy*derives(jc,kc,YDER) 
     &                     + derives(jc,kc,Y2DER)*yy**2 + xx*yy*derives(jc,kc,XYDER) 
                  end do
               end do
            end do
         end do
      end do

      return
      end
      
c ---------------------------------------------------------------
c ::  FORT_BDINTERPYLO : Interpolation on Ylo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(3)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(3), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM13(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, yy, ainterp
      integer  i, j, k, ic, jc, kc, ioff, koff, n
      integer  iclo, ichi, kclo, kchi, ratiox, ratioz

      ratiox = ratios(1)
      ratioz = ratios(3)

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_L2(cb)-1
      j    = lo(2)-1

      do n = 1, nvar
c        ::::: define interp coefs
         do kc = kclo, kchi
         k = ratioz*kc
         do ic = iclo, ichi
            i = ratiox*ic
            derives(ic,kc,XDER)  = half*(crse(ic+1,jc,kc,n) - crse(ic-1,jc,kc,n))
            derives(ic,kc,X2DER) = half*(crse(ic+1,jc,kc,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic-1,jc,kc,n))
            derives(ic,kc,YDER)  = half*(crse(ic,jc,kc+1,n) - crse(ic,jc,kc-1,n))
            derives(ic,kc,Y2DER) = half*(crse(ic,jc,kc+1,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc,kc-1,n))
            derives(ic,kc,XYDER) = forth*(crse(ic+1,jc,kc+1,n) - crse(ic-1,jc,kc+1,n)
     &                     + crse(ic-1,jc,kc-1,n) - crse(ic+1,jc,kc-1,n))

            if (mask(i-1,j,k) .ne. not_covered) then
               derives(ic,kc,XDER)  = crse(ic+1,jc,kc,n) - crse(ic,jc,kc,n)
               derives(ic,kc,X2DER) = zero
            end if
            if (mask(i+ratiox,j,k) .ne. not_covered) then
               derives(ic,kc,XDER)  = crse(ic,jc,kc,n) - crse(ic-1,jc,kc,n)
               derives(ic,kc,X2DER) = zero
            end if
            if (mask(i-1,j,k)     .ne. not_covered .and.
     $          mask(i+ratiox,j,k) .ne. not_covered) then
               derives(ic,kc,XDER)  = zero
            end if

            if (mask(i,j,k-1) .ne. not_covered) then
               derives(ic,kc,YDER)  = crse(ic,jc,kc+1,n) - crse(ic,jc,kc,n)
               derives(ic,kc,Y2DER) = zero
            end if
            if (mask(i,j,k+ratioz) .ne. not_covered) then
               derives(ic,kc,YDER)  = crse(ic,jc,kc,n) - crse(ic,jc,kc-1,n)
               derives(ic,kc,Y2DER) = zero
            end if
            if (mask(i,j,k-1)     .ne. not_covered .and.
     $          mask(i,j,k+ratioz) .ne. not_covered) then
               derives(ic,kc,YDER)  = zero
            end if
            if (
     $           ( mask(i+ratiox,j,k+ratioz) .ne. not_covered ) .or.
     $           ( mask(i-1,j,k+ratioz)     .ne. not_covered ) .or.
     $           ( mask(i+ratiox,j,k-1)     .ne. not_covered ) .or.
     $           ( mask(i-1,j,k-1)         .ne. not_covered ) ) then
               
                derives(ic,kc,XYDER) = zero
            end if
         end do
         end do

c        ::::: interpolate to fine grid
         do koff = 0, ratioz - 1
            yy = (dble(koff - ratioz/2) + half)/ratioz
            do kc = kclo,kchi
               k = ratioz*kc + koff
               do ioff = 0, ratiox - 1
                  xx = (dble(ioff - ratiox/2) + half)/ratiox
                  do ic = iclo, ichi
                     i = ratiox*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + xx*derives(ic,kc,XDER) 
     &                     + derives(ic,kc,X2DER)*xx**2 + yy*derives(ic,kc,YDER) 
     &                     + derives(ic,kc,Y2DER)*yy**2 + xx*yy*derives(ic,kc,XYDER) 
                  end do
               end do
            end do
         end do
      end do

      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPYHI : Interpolation on Yhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(3)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(3), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM13(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, yy, ainterp
      integer  i, j, k, ic, jc, kc, ioff, koff, n
      integer  iclo, ichi, kclo, kchi, ratiox, ratioz

      ratiox = ratios(1)
      ratioz = ratios(3)

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_H2(cb)+1
      j    = hi(2)+1

      do n = 1, nvar
c        ::::: define interp coefs
         do kc = kclo, kchi
         k = ratioz*kc
         do ic = iclo, ichi
            i = ratiox*ic
            derives(ic,kc,XDER)  = half*(crse(ic+1,jc,kc,n) - crse(ic-1,jc,kc,n))
            derives(ic,kc,X2DER) = half*(crse(ic+1,jc,kc,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic-1,jc,kc,n))
            derives(ic,kc,YDER)  = half*(crse(ic,jc,kc+1,n) - crse(ic,jc,kc-1,n))
            derives(ic,kc,Y2DER) = half*(crse(ic,jc,kc+1,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc,kc-1,n))
            derives(ic,kc,XYDER) = forth*(crse(ic+1,jc,kc+1,n) - crse(ic-1,jc,kc+1,n)
     &                     + crse(ic-1,jc,kc-1,n) - crse(ic+1,jc,kc-1,n))

            if (mask(i-1,j,k) .ne. not_covered) then
               derives(ic,kc,XDER)  = crse(ic+1,jc,kc,n) - crse(ic,jc,kc,n)
               derives(ic,kc,X2DER) = zero
            end if
            if (mask(i+ratiox,j,k) .ne. not_covered) then
               derives(ic,kc,XDER)  = crse(ic,jc,kc,n) - crse(ic-1,jc,kc,n)
               derives(ic,kc,X2DER) = zero
            end if
            if (mask(i-1,j,k)     .ne. not_covered .and.
     $          mask(i+ratiox,j,k) .ne. not_covered) then
               derives(ic,kc,XDER)  = zero
            end if

            if (mask(i,j,k-1) .ne. not_covered) then
               derives(ic,kc,YDER)  = crse(ic,jc,kc+1,n) - crse(ic,jc,kc,n)
               derives(ic,kc,Y2DER) = zero
            end if
            if (mask(i,j,k+ratioz) .ne. not_covered) then
               derives(ic,kc,YDER)  = crse(ic,jc,kc,n) - crse(ic,jc,kc-1,n)
               derives(ic,kc,Y2DER) = zero
            end if
            if (mask(i,j,k-1)     .ne. not_covered .and.
     $          mask(i,j,k+ratioz) .ne. not_covered) then
               derives(ic,kc,YDER)  = zero
            end if

            if ( 
     $           ( mask(i+ratiox,j,k+ratioz) .ne. not_covered ) .or.
     $           ( mask(i-1,j,k+ratioz)     .ne. not_covered ) .or.
     $           ( mask(i+ratiox,j,k-1)     .ne. not_covered ) .or.
     $           ( mask(i-1,j,k-1)         .ne. not_covered ) ) then

               derives(ic,kc,XYDER) = zero
            end if
         end do
         end do

c        ::::: interpolate to fine grid
         do koff = 0, ratioz - 1
            yy = (dble(koff - ratioz/2) + half)/ratioz
            do kc = kclo,kchi
               k = ratioz*kc + koff
               do ioff = 0, ratiox - 1
                  xx = (dble(ioff - ratiox/2) + half)/ratiox
                  do ic = iclo, ichi
                     i = ratiox*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + xx*derives(ic,kc,XDER) 
     &                     + derives(ic,kc,X2DER)*xx**2 + yy*derives(ic,kc,YDER) 
     &                     + derives(ic,kc,Y2DER)*yy**2 + xx*yy*derives(ic,kc,XYDER) 
                  end do
               end do
            end do
         end do
      end do

      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPZLO : Interpolation on Zlo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(3)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPZLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(3), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM12(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, yy, ainterp
      integer  i, j, k, ic, jc, kc, ioff, joff, n
      integer  iclo, ichi, jclo, jchi, ratiox, ratioy

      ratiox = ratios(1)
      ratioy = ratios(2)

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      kc   = ARG_L3(cb)-1
      k    = lo(3)-1

      do n = 1, nvar
c     ::::: define interp coefs
         do jc = jclo, jchi
            j = ratioy*jc
            do ic = iclo, ichi
               i = ratiox*ic
               
               derives(ic,jc,XDER)  = half*(crse(ic+1,jc,kc,n) - crse(ic-1,jc,kc,n) )
               derives(ic,jc,X2DER) = half*(crse(ic+1,jc,kc,n) - two*crse(ic,jc,kc,n) + crse(ic-1,jc,kc,n) )
               derives(ic,jc,YDER)  = half*(crse(ic,jc+1,kc,n) - crse(ic,jc-1,kc,n) )
               derives(ic,jc,Y2DER) = half*(crse(ic,jc+1,kc,n) - two*crse(ic,jc,kc,n) + crse(ic,jc-1,kc,n) )
               derives(ic,jc,XYDER) = forth*(crse(ic+1,jc+1,kc,n) - crse(ic-1,jc+1,kc,n)
     &              + crse(ic-1,jc-1,kc,n) - crse(ic+1,jc-1,kc,n))
               
               if (mask(i-1,j,k) .ne. not_covered) then
                  derives(ic,jc,XDER)  = crse(ic+1,jc,kc,n) - crse(ic,jc,kc,n)
                  derives(ic,jc,X2DER) = zero
               end if
               if (mask(i+ratiox,j,k) .ne. not_covered) then
                  derives(ic,jc,XDER)  = crse(ic,jc,kc,n) - crse(ic-1,jc,kc,n)
                  derives(ic,jc,X2DER) = zero
               end if
               if (mask(i-1,j,k)     .ne. not_covered .and. 
     $             mask(i+ratiox,j,k) .ne. not_covered) then
                  derives(ic,jc,XDER)  = zero
               end if

               if (mask(i,j-1,k) .ne. not_covered) then
                  derives(ic,jc,YDER)  = crse(ic,jc+1,kc,n) - crse(ic,jc,kc,n)
                  derives(ic,jc,Y2DER) = zero
               end if
               if (mask(i,j+ratioy,k) .ne. not_covered) then
                  derives(ic,jc,YDER)  = crse(ic,jc,kc,n) - crse(ic,jc-1,kc,n)
                  derives(ic,jc,Y2DER) = zero
               end if
               if (mask(i,j-1,k)     .ne. not_covered .and. 
     $             mask(i,j+ratioy,k) .ne. not_covered) then
                  derives(ic,jc,YDER)  = zero
               end if

               if (
     $              ( mask(i+ratiox,j+ratioy,k) .ne. not_covered ) .or.
     $              ( mask(i-1,j+ratioy,k)     .ne. not_covered ) .or.
     $              ( mask(i+ratiox,j-1,k)     .ne. not_covered ) .or.
     $              ( mask(i-1,j-1,k)         .ne. not_covered ) ) then
                  
                  derives(ic,jc,XYDER) = zero
               end if
            end do
         end do
         
c     ::::: interpolate to fine grid
         do joff = 0, ratioy - 1
            yy = (dble(joff - ratioy/2) + half)/ratioy
            do jc = jclo,jchi
               j = ratioy*jc + joff
               do ioff = 0, ratiox - 1
                  xx = (dble(ioff - ratiox/2) + half)/ratiox
                  do ic = iclo, ichi
                     i = ratiox*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + xx*derives(ic,jc,XDER) 
     &                    + derives(ic,jc,X2DER)*xx**2 + yy*derives(ic,jc,YDER) 
     &                    + derives(ic,jc,Y2DER)*yy**2 + xx*yy*derives(ic,jc,XYDER) 
                  end do
               end do
            end do
         end do
      end do
      
      return
      end
      
c ---------------------------------------------------------------
c ::  FORT_BDINTERPZHI : Interpolation on Zhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(3)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPZHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(3), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM12(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, yy, ainterp
      integer  i, j, k, ic, jc, kc, ioff, joff, n
      integer  iclo, ichi, jclo, jchi, ratiox, ratioy

      ratiox = ratios(1)
      ratioy = ratios(2)

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      kc   = ARG_H3(cb)+1
      k    = hi(3)+1

      do n = 1, nvar
c        ::::: define interp coefs
         do jc = jclo, jchi
         j = ratioy*jc
         do ic = iclo, ichi
            i = ratiox*ic
            derives(ic,jc,XDER)  = half*(crse(ic+1,jc,kc,n) - crse(ic-1,jc,kc,n))
            derives(ic,jc,X2DER) = half*(crse(ic+1,jc,kc,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic-1,jc,kc,n))
            derives(ic,jc,YDER)  = half*(crse(ic,jc+1,kc,n) - crse(ic,jc-1,kc,n))
            derives(ic,jc,Y2DER) = half*(crse(ic,jc+1,kc,n) - two*crse(ic,jc,kc,n)
     &                     + crse(ic,jc-1,kc,n))
            derives(ic,jc,XYDER) = forth*(crse(ic+1,jc+1,kc,n) - crse(ic-1,jc+1,kc,n)
     &                     + crse(ic-1,jc-1,kc,n) - crse(ic+1,jc-1,kc,n))

            if (mask(i-1,j,k) .ne. not_covered) then
               derives(ic,jc,XDER)  = crse(ic+1,jc,kc,n) - crse(ic,jc,kc,n)
               derives(ic,jc,X2DER) = zero
            end if
            if (mask(i+ratiox,j,k) .ne. not_covered) then
               derives(ic,jc,XDER)  = crse(ic,jc,kc,n) - crse(ic-1,jc,kc,n)
               derives(ic,jc,X2DER) = zero
            end if
            if (mask(i-1,j,k)     .ne. not_covered .and. 
     $          mask(i+ratiox,j,k) .ne. not_covered) then
               derives(ic,jc,XDER)  = zero
            end if

            if (mask(i,j-1,k) .ne. not_covered) then
               derives(ic,jc,YDER)  = crse(ic,jc+1,kc,n) - crse(ic,jc,kc,n)
               derives(ic,jc,Y2DER) = zero
            end if
            if (mask(i,j+ratioy,k) .ne. not_covered) then
               derives(ic,jc,YDER)  = crse(ic,jc,kc,n) - crse(ic,jc-1,kc,n)
               derives(ic,jc,Y2DER) = zero
            end if
            if (mask(i,j-1,k)     .ne. not_covered .and. 
     $          mask(i,j+ratioy,k) .ne. not_covered) then
               derives(ic,jc,YDER)  = zero
            end if
            if (
     $           ( mask(i+ratiox,j+ratioy,k) .ne. not_covered ) .or.
     $           ( mask(i-1,j+ratioy,k)     .ne. not_covered ) .or.
     $           ( mask(i+ratiox,j-1,k)     .ne. not_covered ) .or.
     $           ( mask(i-1,j-1,k)         .ne. not_covered ) ) then
               
                derives(ic,jc,XYDER) = zero
            end if
         end do
         end do

c        ::::: interpolate to fine grid
         do joff = 0, ratioy - 1
            yy = (dble(joff - ratioy/2) + half)/ratioy
            do jc = jclo,jchi
               j = ratioy*jc + joff
               do ioff = 0, ratiox - 1
                  xx = (dble(ioff - ratiox/2) + half)/ratiox
                  do ic = iclo, ichi
                     i = ratiox*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + xx*derives(ic,jc,XDER) 
     &                     + derives(ic,jc,X2DER)*xx**2 + yy*derives(ic,jc,YDER) 
     &                     + derives(ic,jc,Y2DER)*yy**2 + xx*yy*derives(ic,jc,XYDER) 
                  end do
               end do
            end do
         end do
      end do

      return
      end

#undef NUMDERIV
#undef XDER
#undef YDER
#undef X2DER
#undef Y2DER
#undef XYDER

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define twentyfive 25.e0
#else
#define twentyfive 25.d0
#endif

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** LAPLAC **
c ** Compute the diffusive/viscous terms 
c ********************************************************************

      subroutine laplac(u,lapu,areax,areay,vol,DIMS,dx,
     $                  diff_coef,irz,bc,n)

      implicit none

      integer DIMS
      REAL_T      u(lo_1-3:hi_1+3,lo_2-3:hi_2+3)
      REAL_T   lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  areax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T  areay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T    vol(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  dx(2)
      REAL_T  diff_coef
      integer bc(2,2)
      integer irz
      integer n

c     Local variables
      REAL_T ux_left, ux_left_wall
      REAL_T ux_rght, ux_rght_wall
      REAL_T uy_bot, uy_bot_wall
      REAL_T uy_top, uy_top_wall
      REAL_T r
      integer is, ie, js, je
      integer i,j

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (diff_coef .gt. zero) then

        do j = js, je
        do i = is, ie

            ux_left = (u(i,j) - u(i-1,j)) 
            ux_left_wall = (-sixteen * u(is-1,j) + twenty * u(is,j)
     $                         -five * u(is+1,j) + u(is+2,j) ) * fifth
            ux_left = cvmgt(ux_left_wall, ux_left, i .eq. is .and.
     $                      (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) .and.
     $                      (irz .eq. 0 .or. (irz .eq. 1 .and. n .eq. 0)) )
            ux_left = areax(i,j) * ux_left / dx(1)

            ux_rght = (u(i+1,j) - u(i,j)) 
            ux_rght_wall = -(-sixteen * u(ie+1,j) + twenty * u(ie,j) 
     $                          -five * u(ie-1,j) + u(ie-2,j) ) * fifth
            ux_rght = cvmgt(ux_rght_wall, ux_rght, i .eq. ie .and.
     $                      (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
            ux_rght = areax(i+1,j) * ux_rght / dx(1)

            uy_bot = (u(i,j) - u(i,j-1)) 
            uy_bot_wall = (-sixteen * u(i,js-1) + twenty * u(i,js) 
     $                         -five * u(i,js+1) + u(i,js+2) ) * fifth
            uy_bot = cvmgt(uy_bot_wall, uy_bot, j .eq. js .and.
     $                      (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
            uy_bot = areay(i,j) * uy_bot / dx(2)

            uy_top = (u(i,j+1) - u(i,j)) 
            uy_top_wall = -(-sixteen * u(i,je+1) + twenty * u(i,je)
     $                          -five * u(i,je-1) + u(i,je-2) ) * fifth
            uy_top = cvmgt(uy_top_wall, uy_top, j .eq. je .and.
     $                      (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
            uy_top = areay(i,j+1) * uy_top / dx(2)

            lapu(i,j) = diff_coef * (ux_rght-ux_left+uy_top-uy_bot) / vol(i,j)

        enddo
        enddo

        if (n .eq. 0 .and. irz. eq. 1) then
          do j = js, je 
          do i = is, ie 
            r = (i+half)*dx(1)
            lapu(i,j) = lapu(i,j) - diff_coef*u(i,j)/(r*r)
          enddo
          enddo
        endif

      else

        do j = js, je 
        do i = is, ie 
          lapu(i,j) = zero
        enddo
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define threehalves    1.5e0
#else
#define threehalves    1.5d0
#endif

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** SETSCALBC **
c ** Impose the physical boundary conditions on scalars s
c *************************************************************************

      subroutine setscalbc(s,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,
     $                     irz,which_scal,dx,time)

      implicit none

      integer DIMS
      integer which_scal
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer irz
      REAL_T  dx(2)
      REAL_T  time
      REAL_T  s(lo_1-1:hi_1+1,lo_2-1:hi_2+1)

c     Local variables
      integer is,ie,js,je,i,j

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (bcy_lo .eq. PERIODIC) then
        do i = is,ie 
          s(i,js-1)=s(i,je)
        enddo

      elseif (bcy_lo .eq. WALL) then

c     NOTE: THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL BOUNDARY,
c           NOT IN THE GHOST CELL
        do i = is,ie 
c         s(i,js-1) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-1) = s(i,js)
        enddo

      elseif (bcy_lo .eq. INLET) then

        call scalinflow(s,DIMS,time,dx(1),1,0,which_scal)

      elseif (bcy_lo .eq. OUTLET) then

        do i = is,ie 
c         s(i,js-1) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-1) = s(i,js)
        enddo

      endif

      if (bcy_hi .eq. PERIODIC) then
        do i = is,ie 
          s(i,je+1)=s(i,js)
        enddo

      elseif (bcy_hi .eq. WALL) then

c     NOTE: THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL BOUNDARY,
c           NOT IN THE GHOST CELL
        do i = is,ie 
c         s(i,je+1) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+1) = s(i,je)
        enddo

      elseif (bcy_hi .eq. INLET) then

        call scalinflow(s,DIMS,time,dx(1),1,1,which_scal)

      elseif (bcy_hi .eq. OUTLET) then

        do i = is,ie 
c         s(i,je+1) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+1) = s(i,je)
        enddo

      endif

      if (bcx_lo .eq. PERIODIC) then
        do j = js-1,je+1 
          s(is-1,j) = s(ie,j)
        enddo

      elseif (bcx_lo .eq. WALL) then

c     NOTE: THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL BOUNDARY,
c           NOT IN THE GHOST CELL

        if (irz .eq. 1) then

          do j = js-1,je+1 
            s(is-1,j) = s(is,j)
          enddo

        else

          do j = js-1,je+1 
c           s(is-1,j) = threehalves*s(is,j) - half*s(is+1,j)
            s(is-1,j) = s(is,j)
          enddo

        endif

      elseif (bcx_lo .eq. INLET) then

        call scalinflow(s,DIMS,time,dx(2),0,0,which_scal)

      elseif (bcx_lo .eq. OUTLET) then

        do j = js-1,je+1 
c         s(is-1,j) = threehalves*s(is,j) - half*s(is+1,j)
          s(is-1,j) = s(is,j)
        enddo

      endif

      if (bcx_hi .eq. PERIODIC) then
        do j = js-1,je+1 
          s(ie+1,j) = s(is,j)
        enddo

      elseif (bcx_hi .eq. WALL) then

c     NOTE: THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL BOUNDARY,
c           NOT IN THE GHOST CELL

        if (irz .eq. 1) then

          do j = js-1,je+1 
c           s(ie+1,j) = threehalves*s(ie,j) - half*s(ie-1,j)
            s(ie+1,j) = s(ie,j)
          enddo

        else

          do j = js-1,je+1 
c           s(ie+1,j) = threehalves*s(ie,j) - half*s(ie-1,j)
            s(ie+1,j) = s(ie,j)
          enddo

        endif

      elseif (bcx_hi .eq. INLET) then

        call scalinflow(s,DIMS,time,dx(2),0,1,which_scal)

      elseif (bcx_hi .eq. OUTLET) then

        do j = js-1,je+1 
c         s(ie+1,j) = threehalves*s(ie,j) - half*s(ie-1,j)
          s(ie+1,j) = s(ie,j)
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: STATS_3D.F,v 1.3 2000/07/20 17:37:17 sstanley Exp $
c

#include "REAL.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"

#include "StatTypes.H"
#define SDIM 3


c ::: -----------------------------------------------------------
c ::: This routine calculates the velocity statistics using Reynolds
c ::: averaging.
c :::
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: ssDat        =>  (const)  SlabStat data
c ::: nSSComp      =>  (const)  Number of components in ssDat
c ::: DIMS(dat)    =>  (const)  Dimensions of SlabStat data
c ::: nStats       =>  (const)  Number of statistics to calculate
c ::: nStns        =>  (const)  Number of stations in the statistic array
c ::: stats       <=   (modify) Array to hold statistics
c :::
c :::                  Output Values:
c :::                      <U> <V> <uu> <vv> <uv> TKE
c :::                  
c ::: vblo, vbhi   =>  (const)  subregion where statistics are calculated
c ::: axialDir     =>  (const)  streamwise direction.  This must be either 
c :::                           1 or 2.
c ::: -----------------------------------------------------------
c
      subroutine FORT_VEL_RA_RND(ssDat, nSSComp, DIMS(ssdat),
     $                           nStats, nStns, stats, physStn,
     $                           vblo, vbhi, dx, probLo, probHi,
     $                           axialDir, nStations)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer nSSComp, nStats, nStns, axialDir, nStations
      integer vblo(SDIM), vbhi(SDIM)
      integer DIMDEC(ssdat)
      REAL_T ssDat(DIMV(ssdat),nSSComp)
      REAL_T stats(nStns,nStats)
      REAL_T physStn(nStns)
      REAL_T dx(SDIM), probLo(SDIM), probHi(SDIM)

c
c     ::::: local variables
c
      integer i, j, k, n, r, profDir, nSSexpect, nStatsExpect
      integer flo(SDIM), fhi(SDIM)
      integer rho, rho2,
     $        u, u2, rhoU, rhoU2,
     $        v, v2, rhoV, rhoV2,
     $        w, w2, rhoW, rhoW2,
     $        tr, tr2, rhoTr, rhoTr2,
     $        uV, uW, vW, rhoUV, rhoUW, rhoVW,
     $        uTr, vTr, wTr, rhoUTr, rhoVTr, rhoWTr,
     $        p, p2, uP, vP, wP
      integer stnCnt(:)
      allocatable stnCnt

      REAL_T tol, x, y, z, rad, xoff, yoff, zoff, VaBar, VrBar, VtBar, 
     $       VaVrBar, VaVtBar, VrVtBar, theta, Va2Bar, Vr2Bar, Vt2Bar
      REAL_T cl(SDIM)


c
c     ------------------------------
c     ::: Define Local Constants :::
c     ------------------------------
c
      parameter (nSSexpect = 35, nStatsExpect = 10)

      call SET_LOHI(DIMS(ssdat), flo, fhi)

      do n = 1, SDIM
        cl(n) = half * (probLo(n) + probHi(n))
      enddo

      allocate(stnCnt(nStns))


c
c     -----------------------------
c     ::: Perform Sanity Checks :::
c     -----------------------------
c
      call SANITY_TEST_RND(nStns, nStats, nSSComp, profDir, 
     $                     nSSexpect, nStatsExpect, vblo, vbhi,
     $                     axialDir)


c
c     ------------------------------------------
c     ::: Define SlabStat Variable Locations :::
c     ------------------------------------------
c
      rho    = 1
      u      = 2
      rhoU   = 3
      v      = 4
      rhoV   = 5
      w      = 6
      rhoW   = 7
      tr     = 8
      rhoTr  = 9
      p      = 10
      rho2   = 11
      u2     = 12
      rhoU2  = 13
      v2     = 14
      rhoV2  = 15
      w2     = 16
      rhoW2  = 17
      tr2    = 18
      rhoTr2 = 19
      p2     = 20
      uV     = 21
      uW     = 22
      vW     = 23
      rhoUV  = 24
      rhoUW  = 25
      rhoVW  = 26
      uTr    = 27
      vTr    = 28
      wTr    = 29
      rhoUTr = 30
      rhoVTr = 31
      rhoWTr = 32
      uP     = 33
      vP     = 34
      wP     = 35


c
c     ---------------------------------------
c     ::: Calculate The Physical Location :::
c     ---------------------------------------
c
c     This logic is for round flowfields only.  For planar flowfields the
c     physical locations are easy.  But, for round flowfields we need to 
c     determine which radiuses are defined by the grid spacing of the domain.
c
      if (profDir .ne. axialDir) then
c
c       NOTE: This assumes the axial direction is always 2 (y).
c
        tol = ten**(-10) * SQRT(dx(1)**2 + dx(3)**2)
        call CLC_RADIUS(vblo(1), vbhi(1), vblo(3), vbhi(3),
     $                  probLo(1), probLo(3),
     $                  dx(1), dx(3), cl(1), cl(3), tol,
     $                  nStns, nStations, physStn)

      else
        tol = ten**(-10) * dx(profDir)
        nStations = vbhi(profDir) - vblo(profDir) + 1
        do n = 0, nStations-1
          physStn(n+1) = (FLOAT(n) + half) * dx(profDir)
        enddo
      endif

      do n = 1, nStations
        stnCnt(n) = 0

        do i = 1, nStatsExpect
          stats(n,i) = zero
        enddo
      enddo

c
c     ----------------------------
c     ::: Calculate Statistics :::
c     ----------------------------
c
      do k = vblo(3), vbhi(3)
        z = probLo(3) + (half + FLOAT(k)) * dx(3)

        do j = vblo(2), vbhi(2)
          y = probLo(2) + (half + FLOAT(j)) * dx(2)

          do i = vblo(1), vbhi(1)
            x = probLo(1) + (half + FLOAT(i)) * dx(1)

c
c           ::: Calculate radius and set profile index :::
c
            if (profDir .ne. axialDir) then
              xoff = x - cl(1)
              zoff = z - cl(3)

              rad = SQRT(xoff**2 + zoff**2)
              xoff = MIN(one, xoff/rad)
              xoff = MAX(-one, xoff)
              theta = SIGN(one, -zoff) * ACOS(xoff)

              do r = 1, nStations
                if (physStn(r)-tol .LT. rad .AND. 
     $              rad .LT. physStn(r)+tol)          n = r
              enddo

            else
              xoff = x - cl(1)
              zoff = z - cl(3)

              rad = SQRT(xoff**2 + zoff**2)
              xoff = MIN(one, xoff/rad)
              xoff = MAX(-one, xoff)
              theta = SIGN(one, -zoff) * ACOS(xoff)

              n = j + 1
            endif



c
c           ::: Calculate Statistics :::
c
            stnCnt(n) = stnCnt(n) + 1

            VaBar = ssDat(i,j,k,v)
            VrBar =   ssDat(i,j,k,u)*cos(theta) - ssDat(i,j,k,w)*sin(theta)
            VtBar = - ssDat(i,j,k,w)*cos(theta) - ssDat(i,j,k,u)*sin(theta)
            Va2Bar = ssDat(i,j,k,v2)
            Vr2Bar = ssDat(i,j,k,u2) * cos(theta)**2
     $             - two * ssDat(i,j,k,uW) * cos(theta) * sin(theta)
     $             + ssDat(i,j,k,w2) * sin(theta)**2
            Vt2Bar = ssDat(i,j,k,w2) * cos(theta)**2
     $             + two * ssDat(i,j,k,uW) * cos(theta) * sin(theta)
     $             + ssDat(i,j,k,u2) * sin(theta)**2
            VaVrBar =   ssDat(i,j,k,uV) * cos(theta) 
     $                - ssDat(i,j,k,vW) * sin(theta)
            VaVtBar = - ssDat(i,j,k,vW) * cos(theta) 
     $                - ssDat(i,j,k,uV) * sin(theta)
            VrVtBar = - ssDat(i,j,k,uW) * cos(theta)**2
     $                + (ssDat(i,j,k,w2) - ssDat(i,j,k,u2))
     $                                            * cos(theta) * sin(theta)
     $                - ssDat(i,j,k,uW) * sin(theta)**2

            stats(n,1) = stats(n,1) + VaBar
            stats(n,2) = stats(n,2) + VrBar
            stats(n,3) = stats(n,3) + VtBar
            stats(n,4) = stats(n,4) + Va2Bar - VaBar**2
            stats(n,5) = stats(n,5) + Vr2Bar - VrBar**2
            stats(n,6) = stats(n,6) + Vt2Bar - VtBar**2
            stats(n,7) = stats(n,7) + VaVrBar - VaBar * VrBar
            stats(n,8) = stats(n,8) + VaVtBar - VaBar * VtBar
            stats(n,9) = stats(n,9) + VrVtBar - VrBar * VtBar
            stats(n,10) = stats(n,10) + half * ( Va2Bar - VaBar**2
     $                                         + Vr2Bar - VrBar**2
     $                                         + Vt2Bar - VtBar**2)
          enddo
        enddo
      enddo

      do r = 1, nStations
        do n = 1, nStats
          stats(r,n) = stats(r,n) / FLOAT(stnCnt(r))
        enddo
      enddo


c
c
      return
      end


c ::: -----------------------------------------------------------
c ::: This routine calculates the velocity statistics using Favre
c ::: averaging.
c :::
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: ssDat        =>  (const)  SlabStat data
c ::: nSSComp      =>  (const)  Number of components in ssDat
c ::: DIMS(dat)    =>  (const)  Dimensions of SlabStat data
c ::: nStats       =>  (const)  Number of statistics to calculate
c ::: nStns        =>  (const)  Number of stations in the statistic array
c ::: stats       <=   (modify) Array to hold statistics
c :::
c :::                  Output Values:
c :::                      <U> <V> <uu> <vv> <uv> TKE
c :::                  
c ::: vblo, vbhi   =>  (const)  subregion where statistics are calculated
c ::: axialDir     =>  (const)  streamwise direction.  This must be either 
c :::                           1 or 2.
c ::: -----------------------------------------------------------
c
      subroutine FORT_VEL_FA_RND(ssDat, nSSComp, DIMS(ssdat),
     $                           nStats, nStns, stats, physStn,
     $                           vblo, vbhi, dx, probLo, probHi,
     $                           axialDir, nStations)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer nSSComp, nStats, nStns, axialDir, nStations
      integer vblo(SDIM), vbhi(SDIM)
      integer DIMDEC(ssdat)
      REAL_T ssDat(DIMV(ssdat),nSSComp)
      REAL_T stats(nStns,nStats)
      REAL_T physStn(nStns)
      REAL_T dx(SDIM), probLo(SDIM), probHi(SDIM)

c
c     ::::: local variables
c
      integer i, j, k, n, r, profDir, nSSexpect, nStatsExpect
      integer flo(SDIM), fhi(SDIM)
      integer rho, rho2,
     $        u, u2, rhoU, rhoU2,
     $        v, v2, rhoV, rhoV2,
     $        w, w2, rhoW, rhoW2,
     $        tr, tr2, rhoTr, rhoTr2,
     $        uV, uW, vW, rhoUV, rhoUW, rhoVW, 
     $        uTr, vTr, wTr, rhoUTr, rhoVTr, rhoWTr, 
     $        p, p2, uP, vP, wP
      integer stnCnt(:)
      allocatable stnCnt

      REAL_T tol, x, y, z, rad, xoff, yoff, zoff, rVaBar, rVrBar, rVtBar, 
     $       rVaVrBar, rVaVtBar, rVrVtBar, theta, rVa2Bar, rVr2Bar, rVt2Bar,
     $       rBar
      REAL_T cl(SDIM)


c
c     ------------------------------
c     ::: Define Local Constants :::
c     ------------------------------
c
      parameter (nSSexpect = 35, nStatsExpect = 10)

      call SET_LOHI(DIMS(ssdat), flo, fhi)

      do n = 1, SDIM
        cl(n) = half * (probLo(n) + probHi(n))
      enddo

      allocate(stnCnt(nStns))


c
c     -----------------------------
c     ::: Perform Sanity Checks :::
c     -----------------------------
c
      call SANITY_TEST_RND(nStns, nStats, nSSComp, profDir, 
     $                     nSSexpect, nStatsExpect, vblo, vbhi,
     $                     axialDir)


c
c     ------------------------------------------
c     ::: Define SlabStat Variable Locations :::
c     ------------------------------------------
c
      rho    = 1
      u      = 2
      rhoU   = 3
      v      = 4
      rhoV   = 5
      w      = 6
      rhoW   = 7
      tr     = 8
      rhoTr  = 9
      p      = 10
      rho2   = 11
      u2     = 12
      rhoU2  = 13
      v2     = 14
      rhoV2  = 15
      w2     = 16
      rhoW2  = 17
      tr2    = 18
      rhoTr2 = 19
      p2     = 20
      uV     = 21
      uW     = 22
      vW     = 23
      rhoUV  = 24
      rhoUW  = 25
      rhoVW  = 26
      uTr    = 27
      vTr    = 28
      wTr    = 29
      rhoUTr = 30
      rhoVTr = 31
      rhoWTr = 32
      uP     = 33
      vP     = 34
      wP     = 35


c
c     ---------------------------------------
c     ::: Calculate The Physical Location :::
c     ---------------------------------------
c
c     This logic is for round flowfields only.  For planar flowfields the
c     physical locations are easy.  But, for round flowfields we need to 
c     determine which radiuses are defined by the grid spacing of the domain.
c
      if (profDir .ne. axialDir) then
c
c       NOTE: This assumes the axial direction is always 2 (y).
c
        tol = ten**(-10) * SQRT(dx(1)**2 + dx(3)**2)
        call CLC_RADIUS(vblo(1), vbhi(1), vblo(3), vbhi(3),
     $                  probLo(1), probLo(3),
     $                  dx(1), dx(3), cl(1), cl(3), tol,
     $                  nStns, nStations, physStn)

      else
        tol = ten**(-10) * dx(profDir)
        nStations = vbhi(profDir) - vblo(profDir) + 1
        do n = 0, nStations-1
          physStn(n+1) = (FLOAT(n) + half) * dx(profDir)
        enddo
      endif

      do n = 1, nStations
        do i = 1, nStatsExpect
          stats(n,i) = zero
        enddo
      enddo

c
c     ----------------------------
c     ::: Calculate Statistics :::
c     ----------------------------
c
      do k = vblo(3), vbhi(3)
        z = probLo(3) + (half + FLOAT(k)) * dx(3)

        do j = vblo(2), vbhi(2)
          y = probLo(2) + (half + FLOAT(j)) * dx(2)

          do i = vblo(1), vbhi(1)
            x = probLo(1) + (half + FLOAT(i)) * dx(1)

c
c           ::: Calculate radius and set profile index :::
c
            if (profDir .ne. axialDir) then
              xoff = x - cl(1)
              zoff = z - cl(3)

              rad = SQRT(xoff**2 + zoff**2)
              xoff = MIN(one, xoff/rad)
              xoff = MAX(-one, xoff)
              theta = SIGN(one, -zoff) * ACOS(xoff)

              do r = 1, nStations
                if (physStn(r)-tol .LT. rad .AND. 
     $              rad .LT. physStn(r)+tol)          n = r
              enddo

            else
              xoff = x - cl(1)
              zoff = z - cl(3)

              rad = SQRT(xoff**2 + zoff**2)
              xoff = MIN(one, xoff/rad)
              xoff = MAX(-one, xoff)
              theta = SIGN(one, -zoff) * ACOS(xoff)

              n = j + 1
            endif



c
c           ::: Calculate Statistics :::
c
            stnCnt(n) = stnCnt(n) + 1

            rBar = ssDat(i,j,k,rho)
            rVaBar = ssDat(i,j,k,rhoV)
            rVrBar =   ssDat(i,j,k,rhoU)*cos(theta) 
     $                                  - ssDat(i,j,k,rhoW)*sin(theta)
            rVtBar = - ssDat(i,j,k,rhoW)*cos(theta) 
     $                                  - ssDat(i,j,k,rhoU)*sin(theta)
            rVa2Bar = ssDat(i,j,k,rhoV2)
            rVr2Bar = ssDat(i,j,k,rhoU2) * cos(theta)**2
     $              - two * ssDat(i,j,k,rhoUW) * cos(theta) * sin(theta)
     $              + ssDat(i,j,k,rhoW2) * sin(theta)**2
            rVt2Bar = ssDat(i,j,k,rhoW2) * cos(theta)**2
     $              + two * ssDat(i,j,k,rhoUW) * cos(theta) * sin(theta)
     $              + ssDat(i,j,k,rhoU2) * sin(theta)**2
            rVaVrBar =   ssDat(i,j,k,rhoUV) * cos(theta) 
     $                 - ssDat(i,j,k,rhoVW) * sin(theta)
            rVaVtBar = - ssDat(i,j,k,rhoVW) * cos(theta) 
     $                 - ssDat(i,j,k,rhoUV) * sin(theta)
            rVrVtBar = - ssDat(i,j,k,rhoUW) * cos(theta)**2
     $                 + (ssDat(i,j,k,rhoW2) - ssDat(i,j,k,rhoU2))
     $                                            * cos(theta) * sin(theta)
     $                 - ssDat(i,j,k,rhoUW) * sin(theta)**2

            stats(n,1) = stats(n,1) + rVaBar / rBar
            stats(n,2) = stats(n,2) + rVrBar / rBar
            stats(n,3) = stats(n,3) + rVtBar / rBar
            stats(n,4) = stats(n,4) + rVa2Bar / rBar - rVaBar**2 / rBar**2
            stats(n,5) = stats(n,5) + rVr2Bar / rBar - rVrBar**2 / rBar**2
            stats(n,6) = stats(n,6) + rVt2Bar / rBar - rVtBar**2 / rBar**2
            stats(n,7) = stats(n,7) + rVaVrBar / rBar 
     $                                             - rVaBar * rVrBar / rBar**2
            stats(n,8) = stats(n,8) + rVaVtBar / rBar 
     $                                             - rVaBar * rVtBar / rBar**2
            stats(n,9) = stats(n,9) + rVrVtBar / rBar 
     $                                             - rVrBar * rVtBar / rBar**2
            stats(n,10) = stats(n,10) + half * ( 
     $                                 rVa2Bar / rBar - rVaBar**2 / rBar**2
     $                               + rVr2Bar / rBar - rVrBar**2 / rBar**2
     $                               + rVt2Bar / rBar - rVtBar**2 / rBar**2 )
          enddo
        enddo
      enddo

      do r = 1, nStations
        do n = 1, nStats
          stats(r,n) = stats(r,n) / FLOAT(stnCnt(r))
        enddo
      enddo


c
c
      return
      end



c ::: ---------------------------------------------------------------------
c ::: This routine does general sanity testing on the inputs for the
c ::: SlabStat statistics routines.  This should be called by each of the 
c ::: actual fortran routines used to calculate statistics.  This routine
c ::: also sets the profile direction, profDir.
c :::
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: nStns         => (const)  Number of stations in the statistic array
c ::: nStats        => (const)  Number of statistics to calculate
c ::: nSSComp       => (const)  Number of components in ssDat
c ::: profDir      <=           Profile direction
c ::: nSSexpect     => (const)  Number of components in ssDat
c ::: nStatsExpect  => (const)  Te number of statistics expected to calculate
c ::: vblo, vbhi    => (const)  subregion where statistics are calculated
c ::: axialDir      => (const)  streamwise direction
c ::: ---------------------------------------------------------------------
c
      subroutine SANITY_TEST_RND(nStns, nStats, nSSComp, profDir,
     $                           nSSexpect, nStatsExpect, vblo, vbhi,
     $                           axialDir)

      implicit none
c
c     ::: Passed Variables :::
c
      integer nStns, nStats, nSSComp, profDir, nSSexpect, nStatsExpect,
     $        axialDir
      integer vblo(SDIM), vbhi(SDIM)

c
c     ::: Local Variables :::
c
      integer n, profDim

c
c     -----------------------------
c     ::: Perform Sanity Checks :::
c     -----------------------------
c
      profDir = -1
      profDim = 1
      do n = 1, SDIM - 1
        if (vbhi(n) - vblo(n) + 1 .gt. 1) then
          if (profDir .ne. -1) then
            write(*,1000) vblo, vbhi
 1000       format("Error: Valid region of SlabStat data is dimensioned",
     $            /"       greater than one in more than one direction.",
     $            /"       vblo = ", SDIM(I4,1x),
     $            /"       vbhi = ", SDIM(I4,1x))
            call BL_PD_ABORT()
          endif

          profDim = vbhi(n) - vblo(n) + 1
          profDir = n
        endif
      enddo
      profDim = profDim * (vbhi(3) - vblo(3) + 1)

      if (nStns .lt. profDim) then
        write(*,1010) nStns, profDir, profDim, vblo, vbhi
 1010   format("Error: The dimensions of the statistics array are insufficient",
     $        /"       to hold the profile.",
     $        /"       nStns = ", I4, 6x, "profDir = ", I1, 
     $                                6x, "profDim = ", I4,
     $        /"       vblo = ", SDIM(I4,1x),
     $        /"       vbhi = ", SDIM(I4,1x))
        call BL_PD_ABORT()
      endif

      if (nSSComp .lt. nSSexpect) then
        write(*,1020) nSSexpect, nSSComp
 1020   format("Error: There are fewer SlabStat components than are expected",
     $         "       from the NavierStokes statistics routines.  The",
     $         "       SlabStat components defined in this routine should be",
     $         "       updated to match those saved by the code.",
     $         "       nSSexpect = ", I4, "     nSSComp = ", I4)
        call BL_PD_ABORT()
      endif

      if (nStats .ne. nStatsExpect) then
        write(*,1030) nStatsExpect, nStats
 1030   format("Error: The number of statistics passed in do not match what",
     $         "       was expected.",
     $         "       nStatsExpect = ", I4, "     nStats = ", I4)
        call BL_PD_ABORT()
      endif

      if (axialDir .ne. 2) then
        write(*,1040) axialDir
 1040   format("Error: The running statistics routines are only implemented",
     $        /"       for axialDir=2.",
     $        /"       axialDir = ", I1)
        call BL_PD_ABORT()
      endif

c
c
      return
      end



      SUBROUTINE CLC_RADIUS(lo1, hi1, lo2, hi2, probLo1, probLo2, 
     $                      dx1, dx2, cl1, cl2, tol,
     $                      nAlloc, nStns, physLoc)

c
c     *****************************
c     *** Variable Declarations ***
c     *****************************
c
      IMPLICIT NONE

c
c     *** Passed Variables ***
c
      INTEGER lo1, lo2, hi1, hi2, nAlloc, nStns
      REAL_T cl1, cl2, tol, dx1, dx2, probLo1, probLo2
      REAL_T physLoc(nAlloc)

c
c     *** Local Variables ***
c
      INTEGER n, m, r
      REAL_T rad, xyz1, xyz2
      LOGICAL found


c
c     **************************************************
c     *** Determine the Values of the Radius Present ***
c     **************************************************
c
c     The tolerence is used here to determine whether a radius has already 
c     been added to the physLoc array.  All of the distinct radiuses are
c     added to the list here and then it is sorted below from lowest to 
c     highest.
c
      nStns = 0
      DO n = lo1, hi1
        xyz1 = probLo1 + (half + FLOAT(n)) * dx1
        DO m = lo2, hi2
          xyz2 = probLo2 + (half + FLOAT(m)) * dx2
          rad = SQRT( (xyz1 - cl1)**2 + (xyz2 - cl2)**2 )

          found = .FALSE.
          DO r = 1, nStns
            IF (physLoc(r)-tol .LT. rad .AND. rad .LT. physLoc(r)+tol) THEN
              found = .TRUE.
            ENDIF
          ENDDO

          IF (.NOT.found) THEN
            nStns = nStns + 1
            physLoc(nStns) = rad
          ENDIF
        ENDDO
      ENDDO

c
c     *********************************
c     *** Sort the List of Radiuses ***
c     *********************************
c
      DO n = 1, nStns - 1
        DO m = 1, nStns - n
          IF (physLoc(m) .GT. physLoc(m+1)) THEN
            rad = physLoc(m)
            physLoc(m) = physLoc(m+1)
            physLoc(m+1) = rad
          ENDIF
        ENDDO
      ENDDO

c
c
      RETURN
      END

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: ABec_3D.F,v 1.8 2002/11/27 21:54:35 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>

#include "ABec_F.H"
#include "ArrayLim.H"
#include "CONSTANTS.H"

c-----------------------------------------------------------------------
c      
c     Gauss-Seidel Red-Black (GSRB):
c     Apply the GSRB relaxation to the state phi for the equation
c     L(phi) = alpha*a(x)*phi(x) - beta*Div(b(x)Grad(phi(x))) = rhs(x)
c     central differenced, according to the arrays of boundary
c     masks (m#) and auxiliary data (f#).
c     
c     In general, if the linear operator L=gamma*y-rho, the GS relaxation
c     is y = (R - rho)/gamma.  Near a boundary, the ghost data is filled
c     using a polynomial interpolant based on the "old" phi values, so
c     L=(gamma-delta)*y - rho + delta*yOld.  The resulting iteration is
c     
c     y = (R - delta*yOld + rho)/(gamma - delta)
c     
c     This expression is valid additionally in the interior provided
c     delta->0 there.  delta is constructed by summing all the
c     contributions to the central stencil element coming from boundary 
c     interpolants.  The f#s contain the corresponding coefficient of 
c     the interpolating polynomial.  The masks are set > 0 if the boundary 
c     value was filled with an interpolant involving the central stencil 
c     element.
c     
c-----------------------------------------------------------------------
      subroutine FORT_GSRB (
     $     phi,DIMS(phi),
     $     rhs,DIMS(rhs),
     $     alpha, beta,
     $     a,  DIMS(a),
     $     bX, DIMS(bX), 
     $     bY, DIMS(bY),
     $     bZ, DIMS(bZ),
     $     f0, DIMS(f0),
     $     m0, DIMS(m0),
     $     f1, DIMS(f1),
     $     m1, DIMS(m1),
     $     f2, DIMS(f2),
     $     m2, DIMS(m2),
     $     f3, DIMS(f3),
     $     m3, DIMS(m3),
     $     f4, DIMS(f4),
     $     m4, DIMS(m4),
     $     f5, DIMS(f5),
     $     m5, DIMS(m5),
     $     lo,hi,nc,
     $     h,redblack
     $     )
      REAL_T alpha, beta
      integer DIMDEC(phi)
      integer DIMDEC(rhs)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer DIMDEC(bZ)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      integer nc
      integer redblack
      integer DIMDEC(f0)
      REAL_T f0(DIMV(f0))
      integer DIMDEC(f1)
      REAL_T f1(DIMV(f1))
      integer DIMDEC(f2)
      REAL_T f2(DIMV(f2))
      integer DIMDEC(f3)
      REAL_T f3(DIMV(f3))
      integer DIMDEC(f4)
      REAL_T f4(DIMV(f4))
      integer DIMDEC(f5)
      REAL_T f5(DIMV(f5))
      integer DIMDEC(m0)
      integer m0(DIMV(m0))
      integer DIMDEC(m1)
      integer m1(DIMV(m1))
      integer DIMDEC(m2)
      integer m2(DIMV(m2))
      integer DIMDEC(m3)
      integer m3(DIMV(m3))
      integer DIMDEC(m4)
      integer m4(DIMV(m4))
      integer DIMDEC(m5)
      integer m5(DIMV(m5))
      REAL_T  h(BL_SPACEDIM)
      REAL_T   phi(DIMV(phi),nc)
      REAL_T   rhs(DIMV(rhs),nc)
      REAL_T     a(DIMV(a))
      REAL_T    bX(DIMV(bX))
      REAL_T    bY(DIMV(bY))
      REAL_T    bZ(DIMV(bZ))
c
      integer  i, j, k, ioff, n
c
      REAL_T dhx, dhy, dhz, cf0, cf1, cf2, cf3, cf4, cf5
      REAL_T delta, gamma, rho, rho_xy, rho_yz, rho_xz
c
      integer do_line
      integer LSDIM
      parameter (LSDIM=127)
      REAL_T a_ls(0:LSDIM)
      REAL_T b_ls(0:LSDIM)
      REAL_T c_ls(0:LSDIM)
      REAL_T r_ls(0:LSDIM)
      REAL_T u_ls(0:LSDIM)
      integer ilen,jlen,klen

      ilen = hi(1)-lo(1)+1
      jlen = hi(2)-lo(2)+1
      klen = hi(3)-lo(3)+1

#if 0
      if (klen .gt. ilen .and. klen .gt. jlen) then
        do_line = 3
        if (klen .gt. LSDIM) then
          print *,'TOO BIG FOR LINE SOLVE IN GSRB: klen = ',klen
          call bl_error("stop")
        endif
      else if (jlen .gt. ilen .and. jlen .gt. klen) then
        do_line = 2
        if (jlen .gt. LSDIM) then
          print *,'JLEN TOO BIG FOR LINE SOLVE IN GSRB: jlen = ',jlen
          call bl_error("stop")
        endif
      else if (ilen .gt. jlen .and. ilen .gt. klen) then
        do_line = 1
        if (ilen .gt. LSDIM) then
          print *,'ILEN TOO BIG FOR LINE SOLVE IN GSRB: ilen = ',ilen
          call bl_error("stop")
        endif
      else 
        do_line = 0
      endif
#endif

      do_line = 0

      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
      dhz = beta/h(3)**2

      do n = 1, nc
         if (do_line .eq. 0) then
          do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               ioff = MOD(j + k + redblack,2)
               do i = lo(1) + ioff,hi(1),2
c
                  cf0 = cvmgt(f0(lo(1),j,k), 0.0D0,
     $                 (i .eq. lo(1)) .and. (m0(lo(1)-1,j,k).gt.0))
                  cf1 = cvmgt(f1(i,lo(2),k), 0.D00,
     $                 (j .eq. lo(2)) .and. (m1(i,lo(2)-1,k).gt.0))
                  cf2 = cvmgt(f2(i,j,lo(3)), 0.0D0,
     $                 (k .eq. lo(3)) .and. (m2(i,j,lo(3)-1).gt.0))
                  cf3 = cvmgt(f3(hi(1),j,k), 0.0D0,
     $                 (i .eq. hi(1)) .and. (m3(hi(1)+1,j,k).gt.0))
                  cf4 = cvmgt(f4(i,hi(2),k), 0.0D0,
     $                 (j .eq. hi(2)) .and. (m4(i,hi(2)+1,k).gt.0))
                  cf5 = cvmgt(f5(i,j,hi(3)), 0.0D0,
     $                 (k .eq. hi(3)) .and. (m5(i,j,hi(3)+1).gt.0))
c
                  delta = dhx*(bX(i,j,k)*cf0 + bX(i+1,j,k)*cf3)
     $                 +  dhy*(bY(i,j,k)*cf1 + bY(i,j+1,k)*cf4)
     $                 +  dhz*(bZ(i,j,k)*cf2 + bZ(i,j,k+1)*cf5)
c                  
                  gamma = alpha*a(i,j,k)
     $                 +   dhx*(bX(i,j,k)+bX(i+1,j,k))
     $                 +   dhy*(bY(i,j,k)+bY(i,j+1,k))
     $                 +   dhz*(bZ(i,j,k)+bZ(i,j,k+1))
c
                  rho =  dhx*( bX(i  ,j,k)*phi(i-1,j,k,n)
     $                 +       bX(i+1,j,k)*phi(i+1,j,k,n) )
     $                 + dhy*( bY(i,j  ,k)*phi(i,j-1,k,n)
     $                 +       bY(i,j+1,k)*phi(i,j+1,k,n) )
     $                 + dhz*( bZ(i,j,k  )*phi(i,j,k-1,n)
     $                 +       bZ(i,j,k+1)*phi(i,j,k+1,n) )
c
                  phi(i,j,k,n) = (rhs(i,j,k,n)+rho-phi(i,j,k,n)*delta)
     $                 /                   (gamma - delta)
c                  
               end do
            end do
          end do

         else if (do_line .eq. 3) then

           do j = lo(2), hi(2)
             ioff = MOD(j + redblack,2)
             do i = lo(1) + ioff,hi(1),2
c
               do k = lo(3),hi(3)
                  cf0 = cvmgt(f0(lo(1),j,k), 0.0D0,
     $                 (i .eq. lo(1)) .and. (m0(lo(1)-1,j,k).gt.0))
                  cf1 = cvmgt(f1(i,lo(2),k), 0.0D0,
     $                 (j .eq. lo(2)) .and. (m1(i,lo(2)-1,k).gt.0))
                  cf2 = cvmgt(f2(i,j,lo(3)), 0.0D0,
     $                 (k .eq. lo(3)) .and. (m2(i,j,lo(3)-1).gt.0))
                  cf3 = cvmgt(f3(hi(1),j,k), 0.0D0,
     $                 (i .eq. hi(1)) .and. (m3(hi(1)+1,j,k).gt.0))
                  cf4 = cvmgt(f4(i,hi(2),k), 0.0D0,
     $                 (j .eq. hi(2)) .and. (m4(i,hi(2)+1,k).gt.0))
                  cf5 = cvmgt(f5(i,j,hi(3)), 0.0D0,
     $                 (k .eq. hi(3)) .and. (m5(i,j,hi(3)+1).gt.0))
c
                  delta = dhx*(bX(i,j,k)*cf0 + bX(i+1,j,k)*cf3)
     $                 +  dhy*(bY(i,j,k)*cf1 + bY(i,j+1,k)*cf4)
     $                 +  dhz*(bZ(i,j,k)*cf2 + bZ(i,j,k+1)*cf5)
c                  
                  gamma = alpha*a(i,j,k)
     $                 +   dhx*(bX(i,j,k)+bX(i+1,j,k))
     $                 +   dhy*(bY(i,j,k)+bY(i,j+1,k))
     $                 +   dhz*(bZ(i,j,k)+bZ(i,j,k+1))
c
                  rho_xy =  dhx*( bX(i  ,j,k)*phi(i-1,j,k,n)
     $                    +       bX(i+1,j,k)*phi(i+1,j,k,n) )
     $                    + dhy*( bY(i,j  ,k)*phi(i,j-1,k,n)
     $                    +       bY(i,j+1,k)*phi(i,j+1,k,n) )

                  a_ls(k-lo(3)) = -dhz*bZ(i,j,k)
                  b_ls(k-lo(3)) = gamma - delta
                  c_ls(k-lo(3)) = -dhz*bZ(i,j,k+1)
                  r_ls(k-lo(3)) = rhs(i,j,k,n) + rho_xy - phi(i,j,k,n)*delta

                  if (k .eq. lo(3))
     $               r_ls(k-lo(3)) = r_ls(k-lo(3)) + dhz*bZ(i,j,k)*phi(i,j,k-1,n)

                  if (k .eq. hi(3))
     $               r_ls(k-lo(3)) = r_ls(k-lo(3)) + dhz*bZ(i,j,k+1)*phi(i,j,k+1,n)
                end do
c
                call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,klen)

                do k = lo(3),hi(3)
                  phi(i,j,k,n) = u_ls(k-lo(3))
                end do
c                  
               end do
            end do

         else if (do_line .eq. 2) then

           do k = lo(3), hi(3)
             ioff = MOD(k + redblack,2)
             do i = lo(1) + ioff,hi(1),2
c
               do j = lo(2),hi(2)
                  cf0 = cvmgt(f0(lo(1),j,k), 0.0D0,
     $                 (i .eq. lo(1)) .and. (m0(lo(1)-1,j,k).gt.0))
                  cf1 = cvmgt(f1(i,lo(2),k), 0.0D0,
     $                 (j .eq. lo(2)) .and. (m1(i,lo(2)-1,k).gt.0))
                  cf2 = cvmgt(f2(i,j,lo(3)), 0.0D0,
     $                 (k .eq. lo(3)) .and. (m2(i,j,lo(3)-1).gt.0))
                  cf3 = cvmgt(f3(hi(1),j,k), 0.0D0,
     $                 (i .eq. hi(1)) .and. (m3(hi(1)+1,j,k).gt.0))
                  cf4 = cvmgt(f4(i,hi(2),k), 0.0D0,
     $                 (j .eq. hi(2)) .and. (m4(i,hi(2)+1,k).gt.0))
                  cf5 = cvmgt(f5(i,j,hi(3)), 0.0D0,
     $                 (k .eq. hi(3)) .and. (m5(i,j,hi(3)+1).gt.0))
c
                  delta = dhx*(bX(i,j,k)*cf0 + bX(i+1,j,k)*cf3)
     $                 +  dhy*(bY(i,j,k)*cf1 + bY(i,j+1,k)*cf4)
     $                 +  dhz*(bZ(i,j,k)*cf2 + bZ(i,j,k+1)*cf5)
c                  
                  gamma = alpha*a(i,j,k)
     $                 +   dhx*(bX(i,j,k)+bX(i+1,j,k))
     $                 +   dhy*(bY(i,j,k)+bY(i,j+1,k))
     $                 +   dhz*(bZ(i,j,k)+bZ(i,j,k+1))
c
                  rho_xz =  dhx*( bX(i  ,j,k)*phi(i-1,j,k,n)
     $                    +       bX(i+1,j,k)*phi(i+1,j,k,n) )
     $                    + dhz*( bZ(i,j,k  )*phi(i,j,k-1,n)
     $                    +       bZ(i,j,k+1)*phi(i,j,k+1,n) )

                  a_ls(j-lo(2)) = -dhy*bY(i,j,k)
                  b_ls(j-lo(2)) = gamma - delta
                  c_ls(j-lo(2)) = -dhy*bY(i,j+1,k)
                  r_ls(j-lo(2)) = rhs(i,j,k,n) + rho_xz - phi(i,j,k,n)*delta

                  if (j .eq. lo(2))
     $               r_ls(j-lo(2)) = r_ls(j-lo(2)) + dhy*bY(i,j,k)*phi(i,j-1,k,n)

                  if (j .eq. hi(2))
     $               r_ls(j-lo(2)) = r_ls(j-lo(2)) + dhy*bY(i,j+1,k)*phi(i,j+1,k,n)
                end do
c
                call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,jlen)

                do j = lo(2),hi(2)
                  phi(i,j,k,n) = u_ls(j-lo(2))
                end do
c                  
               end do
            end do

         else if (do_line .eq. 1) then

           do k = lo(3), hi(3)
             ioff = MOD(k + redblack,2)
             do j = lo(2) + ioff,hi(2),2
c
               do i = lo(1),hi(1)
                  cf0 = cvmgt(f0(lo(1),j,k), 0.0D0,
     $                 (i .eq. lo(1)) .and. (m0(lo(1)-1,j,k).gt.0))
                  cf1 = cvmgt(f1(i,lo(2),k), 0.0D0,
     $                 (j .eq. lo(2)) .and. (m1(i,lo(2)-1,k).gt.0))
                  cf2 = cvmgt(f2(i,j,lo(3)), 0.0D0,
     $                 (k .eq. lo(3)) .and. (m2(i,j,lo(3)-1).gt.0))
                  cf3 = cvmgt(f3(hi(1),j,k), 0.0D0,
     $                 (i .eq. hi(1)) .and. (m3(hi(1)+1,j,k).gt.0))
                  cf4 = cvmgt(f4(i,hi(2),k), 0.0D0,
     $                 (j .eq. hi(2)) .and. (m4(i,hi(2)+1,k).gt.0))
                  cf5 = cvmgt(f5(i,j,hi(3)), 0.0D0,
     $                 (k .eq. hi(3)) .and. (m5(i,j,hi(3)+1).gt.0))
c
                  delta = dhx*(bX(i,j,k)*cf0 + bX(i+1,j,k)*cf3)
     $                 +  dhy*(bY(i,j,k)*cf1 + bY(i,j+1,k)*cf4)
     $                 +  dhz*(bZ(i,j,k)*cf2 + bZ(i,j,k+1)*cf5)
c                  
                  gamma = alpha*a(i,j,k)
     $                 +   dhx*(bX(i,j,k)+bX(i+1,j,k))
     $                 +   dhy*(bY(i,j,k)+bY(i,j+1,k))
     $                 +   dhz*(bZ(i,j,k)+bZ(i,j,k+1))
c
                  rho_yz =  dhy*( bY(i,j  ,k)*phi(i,j-1,k,n)
     $                    +       bY(i,j+1,k)*phi(i,j+1,k,n) )
     $                    + dhz*( bZ(i,j,k  )*phi(i,j,k-1,n)
     $                    +       bZ(i,j,k+1)*phi(i,j,k+1,n) )

                  a_ls(i-lo(1)) = -dhx*bX(i,j,k)
                  b_ls(i-lo(1)) = gamma - delta
                  c_ls(i-lo(1)) = -dhx*bX(i+1,j,k)
                  r_ls(i-lo(1)) = rhs(i,j,k,n) + rho_yz - phi(i,j,k,n)*delta

                  if (i .eq. lo(1))
     $               r_ls(i-lo(1)) = r_ls(i-lo(1)) + dhx*bX(i,j,k)*phi(i-1,j,k,n)

                  if (i .eq. hi(1))
     $               r_ls(i-lo(1)) = r_ls(i-lo(1)) + dhx*bX(i+1,j,k)*phi(i+1,j,k,n)
                end do
c
                call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,ilen)

                do i = lo(1),hi(1)
                  phi(i,j,k,n) = u_ls(i-lo(1))
                end do
c                  
               end do
            end do
         endif
      end do
c     
      end
c-----------------------------------------------------------------------
c
c     Solve Preconditioned system here
c
      subroutine FORT_CGPRECND(
     $     zz,DIMS(zz),
     $     rho,
     $     rr,DIMS(rr),
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     bZ,DIMS(bZ),
     $     lo,hi,nc,
     $     h
     $     )
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(zz)
      integer DIMDEC(rr)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer DIMDEC(bZ)
      REAL_T zz(DIMV(zz),nc)
      REAL_T rr(DIMV(rr),nc)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T bZ(DIMV(bZ))
      REAL_T h(BL_SPACEDIM), rho
c
      integer i,j, k, n
      REAL_T de, dhx, dhy, dhz
c
      rho = 0.0D0
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
      dhz = beta/h(3)**2
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  de = 1.0D0/(alpha*a(i,j,k)
     $                 + dhx*(bX(i+1,j,k)+bX(i,j,k))
     $                 + dhy*(bY(i,j+1,k)+bY(i,j,k))
     $                 + dhz*(bZ(i,j,k+1)+bZ(i,j,k))
     $                 )
                  zz(i,j,k,n) = rr(i,j,k,n)*de
                  rho = rho + zz(i,j,k,n)*rr(i,j,k,n)
               end do
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
c
c     Fill in a matrix x vector operator here
c
      subroutine FORT_ADOTX(
     $     y,DIMS(y),
     $     x,DIMS(x),
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     bZ,DIMS(bZ),
     $     lo,hi,nc,
     $     h
     $     )
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(y)
      integer DIMDEC(x)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer DIMDEC(bZ)
      REAL_T  y(DIMV(y),nc)
      REAL_T  x(DIMV(x),nc)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T bZ(DIMV(bZ))
      REAL_T h(BL_SPACEDIM)
c
      integer i,j,k,n
      REAL_T dhx,dhy,dhz
c
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
      dhz = beta/h(3)**2
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  y(i,j,k,n) = alpha*a(i,j,k)*x(i,j,k,n)
     $                 - dhx*
     $                 (   bX(i+1,j,k)*( x(i+1,j,k,n) - x(i  ,j,k,n) )
     $                 -   bX(i  ,j,k)*( x(i  ,j,k,n) - x(i-1,j,k,n) ) )
     $                 - dhy*
     $                 (   bY(i,j+1,k)*( x(i,j+1,k,n) - x(i,j  ,k,n) )
     $                 -   bY(i,j  ,k)*( x(i,j  ,k,n) - x(i,j-1,k,n) ) )
     $                 - dhz*
     $                 (   bZ(i,j,k+1)*( x(i,j,k+1,n) - x(i,j,k  ,n) )
     $                 -   bZ(i,j,k  )*( x(i,j,k  ,n) - x(i,j,k-1,n) ) )
               end do
            end do
         end do
      end do
      end

c-----------------------------------------------------------------------
c
c     Fill in a matrix x vector operator here
c
      subroutine FORT_NORMA(
     &     res,
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     bZ,DIMS(bZ),
     $     lo,hi,nc,
     $     h
     $     )
      REAL_T alpha, beta, res
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer DIMDEC(bZ)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T bZ(DIMV(bZ))
      REAL_T h(BL_SPACEDIM)
c
      integer i,j,k,n
      REAL_T dhx,dhy,dhz
c
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
      dhz = beta/h(3)**2
c
      res = 0.0D0
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  res = max(res, 
     &                 abs(alpha*a(i,j,k)
     &                 + dhx*(bX(i+1,j,k) + bX(i,j,k))
     &                 + dhy*(bY(i,j+1,k) + bY(i,j,k))
     $                 - dhz*(bZ(i,j,k+1) + bZ(i,j,k)))
     &                 + abs( -dhx*bX(i+1,j,k)) + abs( -dhx*bX(i,j,k))
     &                 + abs( -dhy*bY(i,j+1,k)) + abs( -dhy*bY(i,j,k))
     &                 + abs( -dhz*bZ(i,j,k+1)) + abs( -dhz*bZ(i,j,k)))
               end do
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c
c     Fill in fluxes
c
      subroutine FORT_FLUX(
     $     x,DIMS(x),
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     bZ,DIMS(bZ),
     $     lo,hi,nc,
     $     h,
     $     xflux,DIMS(xflux),
     $     yflux,DIMS(yflux),
     $     zflux,DIMS(zflux)
     $     )
      implicit none
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(x)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer DIMDEC(bZ)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(zflux)
      REAL_T  x(DIMV(x),nc)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T bZ(DIMV(bZ))
      REAL_T xflux(DIMV(xflux),nc)
      REAL_T yflux(DIMV(yflux),nc)
      REAL_T zflux(DIMV(zflux),nc)
      REAL_T h(BL_SPACEDIM)
c
      REAL_T dhx, dhy, dhz
      integer i,j,k,n
c
      dhx = one/h(1)
      dhy = one/h(2)
      dhz = one/h(3)
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)+1
                  xflux(i,j,k,n) = - dhx*bX(i,j,k)*( x(i,j,k,n) - x(i-1,j,k,n) )
               end do
            end do
         end do
      end do
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)+1
               do i = lo(1), hi(1)
                  yflux(i,j,k,n) = - dhy*bY(i,j,k)*( x(i,j,k,n) - x(i,j-1,k,n) )
               end do
            end do
         end do
      end do
      do n = 1, nc
         do k = lo(3), hi(3)+1
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  zflux(i,j,k,n) = - dhz*bZ(i,j,k)*( x(i,j,k,n) - x(i,j,k-1,n) )
               end do
            end do
         end do
      end do
      end

      

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: SYNCREG_3D.F,v 1.13 2002/08/29 22:14:52 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "SYNCREG_F.H"
#include "ArrayLim.H"

#define SDIM 3

c ::: -----------------------------------------------------------
c ::: coarsen fine grid node centered data along edge of node
c ::: centered fine grid array.
c :::
c ::: INPUTS/OUTPUTS:
c ::: crse      <=  node centered coarse data
c ::: DIMS(crse) => index limits for crse
c ::: fine       => node centered fine data
c ::: DIMS(fine)=> index limits for fine
c ::: lo,hi      => node centered subregion of crse to define
c ::: dir        => index direction of normal (0 based)
c ::: ratios     => IntVect refinement ratio      
c ::: -----------------------------------------------------------

      subroutine FORT_SRCRSEREG(fine,DIMS(fine),crse,DIMS(crse),lo,hi,dir,
     &                          ratios)

      integer    DIMDEC(fine)
      integer    DIMDEC(crse)
      integer    lo(SDIM)
      integer    hi(SDIM)
      integer    dir
      integer    ratios(0:SDIM-1)
      REAL_T     fine(DIMV(fine))
      REAL_T     crse(DIMV(crse))
      
      integer    i, j, k, ic, jc, kc
      integer    m, n
      integer    ratiox, ratioy, ratioz
      REAL_T     one28, fourthirds, threefourths
      REAL_T     coeff, denom
      REAL_T     temp

      one28        = eight * sixteen
      fourthirds   = four * third
      threefourths = three * fourth

c     NOTE: the reason that the coefficients add up to 1/ratio_norm and NOT to 1
c           is because the divergences and DGphi were computed using the
c           local dx, so in order to add the fine contribution to the
c           coarse contribution the fine contribution must be weighted
c           by dx_fine/dx_coarse = 1/ratio

      ratiox = ratios(0)
      ratioy = ratios(1)
      ratioz = ratios(2)

c     NOTE: we multiply fine by 1/2 on the edges and 1/3 on the corners
c           since they are counted in all three directions; later we 
c           multiply by 2 and 3, respectively, to restore them to their
c           previous values.
      
      if (dir .eq. 0) then
       
c        ::::: sum in j and k directions
         ic = lo(1)
         i = ratiox*ic

         do kc = lo(3), hi(3)
           do jc = lo(2), hi(2)
             crse(ic,jc,kc) = zero
           end do
         end do

         j = ratioy*lo(2)
         do k = fine_l3, fine_h3
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         j = ratioy*hi(2)
         do k = fine_l3, fine_h3
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         k = ratioz*lo(3)
         do j = fine_l2, fine_h2
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         k = ratioz*hi(3)
         do j = fine_l2, fine_h2
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         j = ratioy*lo(2)
         k = ratioz*lo(3)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         j = ratioy*hi(2)
         k = ratioz*lo(3)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         j = ratioy*lo(2)
         k = ratioz*hi(3)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         j = ratioy*hi(2)
         k = ratioz*hi(3)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         denom = one / (ratiox * ratioy**2 * ratioz**2)
         do n = 0, (ratioz-1)
           do m = 0, (ratioy-1)
             coeff = (ratioy - m) * (ratioz - n) * denom
             if (n .eq. 0) coeff = half * coeff
             if (m .eq. 0) coeff = half * coeff
             do kc = lo(3), hi(3)
               k = ratioz*kc
               do jc = lo(2), hi(2)
                 j = ratioy*jc
                 crse(ic,jc,kc) = crse(ic,jc,kc) + coeff * 
     $               ( fine(i,j+m,k+n) + fine(i,j-m,k+n)
     $                +fine(i,j+m,k-n) + fine(i,j-m,k-n) )
               end do
             end do
           end do
         end do

         j = ratioy*lo(2)
         do k = fine_l3, fine_h3
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         j = ratioy*hi(2)
         do k = fine_l3, fine_h3
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         k = ratioz*lo(3)
         do j = fine_l2, fine_h2
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         k = ratioz*hi(3)
         do j = fine_l2, fine_h2
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         j = ratioy*lo(2)
         k = ratioz*lo(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

         j = ratioy*hi(2)
         k = ratioz*lo(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

         j = ratioy*lo(2)
         k = ratioz*hi(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

         j = ratioy*hi(2)
         k = ratioz*hi(3)
         fine(i,j,k) = threefourths*fine(i,j,k)
      
      else if (dir .eq. 1) then
c
c        ::::: sum in i and k directions
c
         jc = lo(2)
         j = ratioy*jc

         do kc = lo(3), hi(3)
           do ic = lo(1), hi(1)
             crse(ic,jc,kc) = zero
           end do
         end do

         i = ratiox*lo(1)
         do k = fine_l3, fine_h3
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         i = ratiox*hi(1)
         do k = fine_l3, fine_h3
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         k = ratioz*lo(3)
         do i = fine_l1, fine_h1
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         k = ratioz*hi(3)
         do i = fine_l1, fine_h1
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         i = ratiox*lo(1)
         k = ratioz*lo(3)
         fine(i,j,k) = four*third*fine(i,j,k)

         i = ratiox*hi(1)
         k = ratioz*lo(3)
         fine(i,j,k) = four*third*fine(i,j,k)

         i = ratiox*lo(1)
         k = ratioz*hi(3)
         fine(i,j,k) = four*third*fine(i,j,k)

         i = ratiox*hi(1)
         k = ratioz*hi(3)
         fine(i,j,k) = four*third*fine(i,j,k)

         denom = one / (ratioy * ratiox**2 * ratioz**2)
         do n = 0, (ratioz-1)
           do m = 0, (ratiox-1)
             coeff = (ratiox - m) * (ratioz - n) * denom
             if (n .eq. 0) coeff = half * coeff
             if (m .eq. 0) coeff = half * coeff
             do kc = lo(3), hi(3)
               k = ratioz*kc
               do ic = lo(1), hi(1)
                 i = ratiox*ic
                 crse(ic,jc,kc) = crse(ic,jc,kc) + coeff * 
     $               ( fine(i+m,j,k+n) + fine(i-m,j,k+n)
     $                +fine(i+m,j,k-n) + fine(i-m,j,k-n) )
               end do
             end do
           end do
         end do

         i = ratiox*lo(1)
         do k = fine_l3, fine_h3
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         i = ratiox*hi(1)
         do k = fine_l3, fine_h3
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         k = ratioz*lo(3)
         do i = fine_l1, fine_h1
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         k = ratioz*hi(3)
         do i = fine_l1, fine_h1
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         i = ratiox*lo(1)
         k = ratioz*lo(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

         i = ratiox*hi(1)
         k = ratioz*lo(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

         i = ratiox*lo(1)
         k = ratioz*hi(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

         i = ratiox*hi(1)
         k = ratioz*hi(3)
         fine(i,j,k) = threefourths*fine(i,j,k)

       else if (dir .eq. 2) then

c        ::::: sum in i and j directions
         kc = lo(3)
         k = ratioz*kc

         do jc = lo(2), hi(2)
           do ic = lo(1), hi(1)
             crse(ic,jc,kc) = zero
           end do
         end do

         i = ratiox*lo(1)
         do j = fine_l2, fine_h2
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         i = ratiox*hi(1)
         do j = fine_l2, fine_h2
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         j = ratioy*lo(2)
         do i = fine_l1, fine_h1
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         j = ratioy*hi(2)
         do i = fine_l1, fine_h1
           fine(i,j,k) = half*fine(i,j,k)
         enddo

         i = ratiox*lo(1)
         j = ratioy*lo(2)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         i = ratiox*hi(1)
         j = ratioy*lo(2)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         i = ratiox*lo(1)
         j = ratioy*hi(2)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         i = ratiox*hi(1)
         j = ratioy*hi(2)
         fine(i,j,k) = fourthirds*fine(i,j,k)

         denom = one / (ratioz * ratiox**2 * ratioy**2)
         do n = 0, (ratioy-1)
           do m = 0, (ratiox-1)
             coeff = (ratiox - m) * (ratioy - n) * denom
             if (n .eq. 0) coeff = half * coeff
             if (m .eq. 0) coeff = half * coeff
             do jc = lo(2), hi(2)
               j = ratioy*jc
               do ic = lo(1), hi(1)
                 i = ratiox*ic
                 crse(ic,jc,kc) = crse(ic,jc,kc) + coeff * 
     $               ( fine(i+m,j+n,k) + fine(i-m,j+n,k)
     $                +fine(i+m,j-n,k) + fine(i-m,j-n,k) )
               end do
             end do
           end do
         end do

         i = ratiox*lo(1)
         do j = fine_l2, fine_h2
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         i = ratiox*hi(1)
         do j = fine_l2, fine_h2
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         j = ratioy*lo(2)
         do i = fine_l1, fine_h1
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         j = ratioy*hi(2)
         do i = fine_l1, fine_h1
           fine(i,j,k) = two*fine(i,j,k)
         enddo

         i = ratiox*lo(1)
         j = ratioy*lo(2)
         fine(i,j,k) = threefourths*fine(i,j,k)

         i = ratiox*hi(1)
         j = ratioy*lo(2)
         fine(i,j,k) = threefourths*fine(i,j,k)

         i = ratiox*lo(1)
         j = ratioy*hi(2)
         fine(i,j,k) = threefourths*fine(i,j,k)

         i = ratiox*hi(1)
         j = ratioy*hi(2)
         fine(i,j,k) = threefourths*fine(i,j,k)

      end if

      end

c ::: -----------------------------------------------------------
c ::: create mask at nodes using values at surrounding cells
c :::
c ::: INPUTS/OUTPUTS:
c ::: mask       <=  node-centered mask array
c ::: DIMS(mask)  => index limits for mask
c ::: cells       => cell-centered array (each value is 0. or 1.)
c ::: DIMS(cells) => index limits for cells
c ::: -----------------------------------------------------------

      subroutine FORT_MAKEMASK(mask,DIMS(mask),cells,DIMS(cells))

      integer    DIMDEC(mask)
      integer    DIMDEC(cells)
      REAL_T     mask(DIMV(mask))
      REAL_T     cells(DIMV(cells))

      integer    i, j, k

      do k = ARG_L3(mask), ARG_H3(mask)
       do j = ARG_L2(mask), ARG_H2(mask)
        do i = ARG_L1(mask), ARG_H1(mask)
 
          mask(i,j,k) = cells(i,j  ,k  ) + cells(i-1,j  ,k  )
     $                + cells(i,j-1,k  ) + cells(i-1,j-1,k  )
     $                + cells(i,j  ,k-1) + cells(i-1,j  ,k-1)
     $                + cells(i,j-1,k-1) + cells(i-1,j-1,k-1)

        end do
       end do
      end do

      end

c ::: -----------------------------------------------------------
c ::: modify mask from values 0. through 8. to values 0. or 1.
c :::
c ::: INPUTS/OUTPUTS:
c ::: mask       <=  node-centered mask array
c ::: DIMS(mask)  => index limits for mask
c ::: -----------------------------------------------------------

      subroutine FORT_CONVERTMASK(mask,DIMS(mask))

      integer    DIMDEC(mask)
      REAL_T     mask(DIMV(mask))
 
      integer    i, j, k

      do k = ARG_L3(mask), ARG_H3(mask)
       do j = ARG_L2(mask), ARG_H2(mask)
        do i = ARG_L1(mask), ARG_H1(mask)
 
          if (mask(i,j,k) .gt. 7.5D0) then
             mask(i,j,k) = zero
          else
             mask(i,j,k) = one
          end if

        end do
       end do
      end do
 
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c ::: SCCS stuff "@(#)FABUTIL_2D.F	3.1\t6/25/93"

#define   FORT_CINTERP       cinterp2d
#define   FORT_PCINTERP      pcinterp2d

#include "REAL.H"
#include "CONSTANTS.H"

c ::: --------------------------------------------------------------
      subroutine FORT_CINTERP (fine,floi1,floi2,fhii1,fhii2, fblo,fbhi,
     $ nvar,lratio, crse,clo,chi,cblo,cbhi,fslo,fshi, cslope,clen,
     $ fslope,fdat,flen,voff)

      integer floi1,floi2, fhii1,fhii2

      integer fblo(2), fbhi(2)
      integer cblo(2), cbhi(2)
      integer fslo(2), fshi(2)
      integer lratio, nvar, clen, flen, clo, chi
      REAL_T fine(floi1 :fhii1 ,floi2 :fhii2, nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 2)
      REAL_T fslope(flen, 2)
      REAL_T fdat(flen)
      REAL_T voff(flen)

c ::: NOTE: data must be sent in so that 
c ::: cslope(1,*) and crse(1,*) are associated with
c ::: the same cell

c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: cinterp:   conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio       =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: and unrolled
c ::: clo,chi      =>  (const)  one dimensional limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c ::: slopes are to be defined. This is
c ::: the projection of (fblo,fbhi) down
c ::: to the coarse level 
c ::: fslo,fshi    =>  (const)  fine grid index limits where
c ::: slopes are needed.  This is the
c ::: refinement of (cslo,cshi) and
c ::: contains but may not be identical
c ::: to (fblo,fbhi).
c ::: cslope       =>  (modify) temp array coarse grid slopes
c ::: clen         =>  (const)  length of coarse gtid slopes
c ::: fslope       =>  (modify) temp array for fine grid slope
c ::: flen         =>  (const)  length of fine grid slope array
c ::: fdat         =>  (const)  temp array for fine grid data
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer ist, jst
      REAL_T hafrat, volratio
      REAL_T cen, forw, back, slp
      REAL_T xoff, yoff
      integer ncbx, ncby
      integer ncsx, ncsy
      integer islo, jslo
      integer icc, istart, iend
      integer lenx, leny, maxlen

      hafrat = half*float(lratio-1)
      volratio = one/float(lratio)

      ncbx = cbhi(1)-cblo(1)+1
      ncby = cbhi(2)-cblo(2)+1
      ncsx = ncbx+2
      ncsy = ncby+2
      ist = 1
      jst = ncsx
      islo = cblo(1)-1
      jslo = cblo(2)-1
      lenx = fbhi(1)-fblo(1)+1
      leny = fbhi(2)-fblo(2)+1
      maxlen = max(lenx,leny)
      if (maxlen .eq. lenx) then
          do 100 i = fblo(1), fbhi(1) 
              fn = i-fslo(1)+1
              ioff = mod(fn-1,lratio)
              voff(fn) = float(ioff)-hafrat
100       continue
      else
          do 110 j = fblo(2), fbhi(2) 
              fn = j-fslo(2)+1
              joff = mod(fn-1,lratio)
              voff(fn) = float(joff)-hafrat
110       continue
      end if
      do 120 n = 1, nvar 

c ::: ::::: compute slopes in x direction
          do 130 i = 1, clen 
              cen = half*(crse(i+ist,n)-crse(i-ist,n))
              forw = crse(i+ist,n)-crse(i,n)
              back = crse(i,n)-crse(i-ist,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,1)=cvmgp(slp,zero,forw*back)
130       continue
c ::: ::::: compute slopes in y direction
          do 140 i = 1, clen 
              cen = half*(crse(i+jst,n)-crse(i-jst,n))
              forw = crse(i+jst,n)-crse(i,n)
              back = crse(i,n)-crse(i-jst,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,2)=cvmgp(slp,zero,forw*back)
140       continue
          if (maxlen .eq. lenx) then
              do 150 jc = cblo(2), cbhi(2) 

c ::: ..,.......::::: strip out a fine grid slope vector
                  do 160 ioff = 1, lratio 
                      icc = clo + ist + jst*(jc-jslo)
                      istart = ioff
                      iend = ioff + (ncbx-1)*lratio
                      do 170 fn = istart, iend, lratio 
                          fslope(fn,1) = cslope(icc,1)
                          fslope(fn,2) = cslope(icc,2)
                          fdat(fn) = crse(icc,n)
                          icc = icc + ist
170                   continue
160               continue

                  do 180 joff = 0, lratio-1 
                      j = lratio*jc + joff
                      if (j .lt. fblo(2)) then
                          goto 180
c                         --- next ---
                      end if
                      if (j .gt. fbhi(2)) then
                          goto 181
c                         --- break ---
                      end if
                      yoff = float(joff)-hafrat

                      do 190 i = fblo(1), fbhi(1) 
                          fn = i-fslo(1)+1
                          fine(i,j,n) = fdat(fn) + volratio* (voff(fn)*
     $                    fslope(fn,1)+yoff*fslope(fn,2))
190                   continue
180               continue
181               continue
150           continue
          else
              do 200 ic = cblo(1), cbhi(1) 

c ::: ..,.......::::: strip out a fine grid slope vector
                  do 210 joff = 1, lratio 
                      icc = clo + ist*(ic-islo) + jst
                      istart = joff
                      iend = joff + (ncby-1)*lratio
                      do 220 fn = istart, iend, lratio 
                          fslope(fn,1) = cslope(icc,1)
                          fslope(fn,2) = cslope(icc,2)
                          fdat(fn) = crse(icc,n)
                          icc = icc + jst
220                   continue
210               continue

                  do 230 ioff = 0, lratio-1 
                      i = lratio*ic + ioff
                      if (i .lt. fblo(1)) then
                          goto 230
c                         --- next ---
                      end if
                      if (i .gt. fbhi(1)) then
                          goto 231
c                         --- break ---
                      end if
                      xoff = float(ioff)-hafrat

                      do 240 j = fblo(2), fbhi(2) 
                          fn = j-fslo(2)+1
                          fine(i,j,n) = fdat(fn) + volratio* (xoff*
     $                    fslope(fn,1)+voff(fn)*fslope(fn,2))
240                   continue
230               continue
231               continue
200           continue
          end if
120   continue

      return
      end


c ::: --------------------------------------------------------------
      subroutine FORT_PCINTERP (fine,floi1,floi2,fhii1,fhii2,fblo, fbhi,lrat,
     $ nvar, crse,cloi1,cloi2,chii1,chii2,cblo, cbhi,temp,tloi,thii)

      integer floi1,floi2
      integer fhii1,fhii2
      integer cloi1,cloi2
      integer chii1,chii2

      integer fblo(2), fbhi(2)
      integer cblo(2), cbhi(2)
      integer lrat, nvar, tloi, thii
      REAL_T fine(floi1 :fhii1 ,floi2 :fhii2, nvar)
      REAL_T crse(cloi1 :chii1 ,cloi2 :chii2, nvar)
      REAL_T temp(tloi:thii + 1)
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: pcinterp:  use piecewise constant interpolation to define
c ::: values on the subregion of the fine FAB defined
c ::: by (fblo,fbhi).
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fab to get interpolated values
c ::: flo,fhi      =>  (const)  index limits of fine
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: crse         =>  (const)  fab holding coarse grid values
c ::: clo,chi      =>  (const)  index limits of src
c ::: cblo,cbhi    =>  (const)  subregion of coarse grid holding values
c ::: temp         =>  (modify) temporary space for vectorization
c ::: tlo,thi      =>  (const)  index limits of temp space
c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: local var
      integer i,j,k,ic,jc,kc,ioff,n
      integer ixproj,ii,ll
      ixproj(ii,ll) = (ii + ll*iabs(ii))/ll - iabs(ii)


      do 120 j = fblo(2), fbhi(2) 
          jc = ixproj(j,lrat)
          do 130 n = 1, nvar 
              do 140 ioff = 0, lrat-1 
                  do 150 ic = cblo(1),cbhi(1) 
                      i = lrat*ic + ioff
                      temp(i) = crse(ic,jc,n)
150               continue
140           continue
              do 160 i = fblo(1), fbhi(1) 
                  fine(i,j,n) = temp(i)
160           continue
130       continue
120   continue

      return
      end






      subroutine cartgridminmax2d (data, lo1, lo2, hi1, hi2,
     $                         vfracdata, vfeps, dmin, dmax)
      implicit none

      integer lo1, lo2, hi1, hi2
      REAL_T data(lo1:hi1 ,lo2:hi2)
      REAL_T vfracdata(lo1:hi1 ,lo2:hi2)
      REAL_T vfeps, dmin, dmax

      integer i, j

      dmax = -bigreal
      dmin = bigreal
      do 420 j = lo2, hi2
          do 430 i = lo1, hi1
c      print *, "i j vfracdata(i,j) = ",i,j,vfracdata(i,j)
              if ( .not. (vfracdata(i,j).lt.vfeps)) then
                dmax = max(dmax,data(i,j))
                dmin = min(dmin,data(i,j))
              endif
430       continue
420   continue

      return
      end

c-----------------------------------------------------------------------
      subroutine hggrad_dense(
     & gpx, gpy, gpz,
     &       gpl0,gph0,gpl1,gph1,gpl2,gph2,
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       fregl0,fregh0,fregl1,fregh1,fregl2,fregh2,
     & hx, hy, hz, idummy)
      integer gpl0,gph0,gpl1,gph1,gpl2,gph2
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer fregl0,fregh0,fregl1,fregh1,fregl2,fregh2
      double precision hx, hy, hz
      double precision gpx(gpl0:gph0,gpl1:gph1,gpl2:gph2)
      double precision gpy(gpl0:gph0,gpl1:gph1,gpl2:gph2)
      double precision gpz(gpl0:gph0,gpl1:gph1,gpl2:gph2)
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2)
      integer idummy
      integer i, j, k
      do k = fregl2, fregh2
          do j = fregl1, fregh1
              do i = fregl0, fregh0
               gpx(i,j,k) = 0.25d0 *
     &            (dest(i+1,j,k  ) + dest(i+1,j+1,k  ) +
     &             dest(i+1,j,k+1) + dest(i+1,j+1,k+1) -
     &             dest(i  ,j,k  ) - dest(i  ,j+1,k  ) -
     &             dest(i  ,j,k+1) - dest(i  ,j+1,k+1))
               gpy(i,j,k) = 0.25d0 *
     &            (dest(i,j+1,k  ) + dest(i+1,j+1,k  ) +
     &             dest(i,j+1,k+1) + dest(i+1,j+1,k+1) -
     &             dest(i,j  ,k  ) - dest(i+1,j  ,k  ) -
     &             dest(i,j  ,k+1) - dest(i+1,j  ,k+1))
               gpz(i,j,k) = 0.25d0 *
     &            (dest(i,j  ,k+1) + dest(i+1,j  ,k+1) +
     &             dest(i,j+1,k+1) + dest(i+1,j+1,k+1) -
     &             dest(i,j  ,k  ) - dest(i+1,j  ,k  ) -
     &             dest(i,j+1,k  ) - dest(i+1,j+1,k  ))
              end do
          end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgdiv_dense(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     &      fregl0,fregh0,fregl1,fregh1,fregl2,fregh2,
     & hx, hy, hz, idummy, jdummy)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer fregl0,fregh0,fregl1,fregh1,fregl2,fregh2
      double precision hx, hy, hz
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision fac
      integer idummy, jdummy
      integer i, j, k
      fac = 0.25d0
      do k = fregl2, fregh2
         do j = fregl1, fregh1
            do i = fregl0, fregh0
             src(i,j,k) = fac *
     &              (uf(i  ,j-1,k-1) - uf(i-1,j-1,k-1) +
     &               uf(i  ,j-1,k  ) - uf(i-1,j-1,k  ) +
     &               uf(i  ,j  ,k-1) - uf(i-1,j  ,k-1) +
     &               uf(i  ,j  ,k  ) - uf(i-1,j  ,k  ) +
     &               vf(i-1,j  ,k-1) - vf(i-1,j-1,k-1) +
     &               vf(i-1,j  ,k  ) - vf(i-1,j-1,k  ) +
     &               vf(i  ,j  ,k-1) - vf(i  ,j-1,k-1) +
     &               vf(i  ,j  ,k  ) - vf(i  ,j-1,k  ) +
     &               wf(i-1,j-1,k  ) - wf(i-1,j-1,k-1) +
     &               wf(i-1,j  ,k  ) - wf(i-1,j  ,k-1) +
     &               wf(i  ,j-1,k  ) - wf(i  ,j-1,k-1) +
     &               wf(i  ,j  ,k  ) - wf(i  ,j  ,k-1))
              end do
          end do
      end do
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfdiv_dense(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uc, vc, wc,
     &      cl0,ch0,cl1,ch1,cl2,ch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & hx, hy, hz, ir, jr, kr, idim, idir, idd1, idd2)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision hx, hy, hz
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision vc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision wc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      integer ir, jr, kr, idim, idir
      double precision fac0, fac1, fac, tmp
      integer i, j, k, iuc, iuf, juc, juf, kuc, kuf, l, m, n
      integer idd1, idd2
      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            iuc = i - 1
            iuf = i * ir
         else
            iuc = i
            iuf = i * ir - 1
         end if
         fac0 = 0.25d0
         do  k = cregl2, cregh2
            do  j = cregl1, cregh1
             src(i*ir,j*jr,k*kr) = fac0 *
     &           ((vc(iuc,j,k) - vc(iuc,j-1,k) +
     &             vc(iuc,j,k-1) - vc(iuc,j-1,k-1)) +
     &            (wc(iuc,j,k) - wc(iuc,j,k-1) +
     &             wc(iuc,j-1,k) - wc(iuc,j-1,k-1)) -
     &     idir * (uc(iuc,j,k) + uc(iuc,j,k-1) +
     &             uc(iuc,j-1,k) + uc(iuc,j-1,k-1)))
              end do
          end do
         fac0 = fac0 / (jr * kr)
         i = i * ir
         do l = 0, kr-1
            fac1 = (kr-l) * fac0
            if (l .eq. 0) fac1 = 0.5D0 * fac1
            do n = 0, jr-1
               fac = (jr-n) * fac1
               if (n .eq. 0) fac = 0.5D0 * fac
               do k = kr*cregl2, kr*cregh2, kr
                  do j = jr*cregl1, jr*cregh1, jr
                     tmp = idir *
     &                 (uf(iuf,j-n  ,k-l) + uf(iuf,j-n  ,k-l-1) +
     &                  uf(iuf,j-n-1,k-l) + uf(iuf,j-n-1,k-l-1) +
     &                  uf(iuf,j-n  ,k+l) + uf(iuf,j-n  ,k+l-1) +
     &                  uf(iuf,j-n-1,k+l) + uf(iuf,j-n-1,k+l-1) +
     &                  uf(iuf,j+n  ,k-l) + uf(iuf,j+n  ,k-l-1) +
     &                  uf(iuf,j+n-1,k-l) + uf(iuf,j+n-1,k-l-1) +
     &                  uf(iuf,j+n  ,k+l) + uf(iuf,j+n  ,k+l-1) +
     &                  uf(iuf,j+n-1,k+l) + uf(iuf,j+n-1,k+l-1))
                     tmp = tmp +
     &                 (vf(iuf,j-n,k-l  ) - vf(iuf,j-n-1,k-l  ) +
     &                  vf(iuf,j-n,k-l-1) - vf(iuf,j-n-1,k-l-1) +
     &                  vf(iuf,j-n,k+l  ) - vf(iuf,j-n-1,k+l  ) +
     &                  vf(iuf,j-n,k+l-1) - vf(iuf,j-n-1,k+l-1) +
     &                  vf(iuf,j+n,k-l  ) - vf(iuf,j+n-1,k-l  ) +
     &                  vf(iuf,j+n,k-l-1) - vf(iuf,j+n-1,k-l-1) +
     &                  vf(iuf,j+n,k+l  ) - vf(iuf,j+n-1,k+l  ) +
     &                  vf(iuf,j+n,k+l-1) - vf(iuf,j+n-1,k+l-1))
                     src(i,j,k) = src(i,j,k) + fac * (tmp +
     &                 (wf(iuf,j-n  ,k-l) - wf(iuf,j-n  ,k-l-1) +
     &                  wf(iuf,j-n-1,k-l) - wf(iuf,j-n-1,k-l-1) +
     &                  wf(iuf,j-n  ,k+l) - wf(iuf,j-n  ,k+l-1) +
     &                  wf(iuf,j-n-1,k+l) - wf(iuf,j-n-1,k+l-1) +
     &                  wf(iuf,j+n  ,k-l) - wf(iuf,j+n  ,k-l-1) +
     &                  wf(iuf,j+n-1,k-l) - wf(iuf,j+n-1,k-l-1) +
     &                  wf(iuf,j+n  ,k+l) - wf(iuf,j+n  ,k+l-1) +
     &                  wf(iuf,j+n-1,k+l) - wf(iuf,j+n-1,k+l-1)))
                  end do
               end do
            end do
         end do
      else if (idim .eq. 1) then
         j = cregl1
         if (idir .eq. 1) then
            juc = j - 1
            juf = j * jr
         else
            juc = j
            juf = j * jr - 1
         end if
         fac0 = 0.25d0
         do k = cregl2, cregh2
            do i = cregl0, cregh0
               src(i*ir,j*jr,k*kr) = fac0 *
     &           ((uc(i,juc,k) - uc(i-1,juc,k) +
     &             uc(i,juc,k-1) - uc(i-1,juc,k-1)) -
     &     idir * (vc(i,juc,k) + vc(i,juc,k-1) +
     &             vc(i-1,juc,k) + vc(i-1,juc,k-1)) +
     &            (wc(i,juc,k) - wc(i,juc,k-1) +
     &             wc(i-1,juc,k) - wc(i-1,juc,k-1)))
            end do
         end do
         fac0 = fac0 / (ir * kr)
         j = j * jr
         do l = 0, kr-1
            fac1 = (kr-l) * fac0
            if (l .eq. 0) fac1 = 0.5D0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5D0 * fac
               do k = kr*cregl2, kr*cregh2, kr
                  do i = ir*cregl0, ir*cregh0, ir
                     tmp =
     &                 (uf(i-m,juf,k-l  ) - uf(i-m-1,juf,k-l) +
     &                  uf(i-m,juf,k-l-1) - uf(i-m-1,juf,k-l-1) +
     &                  uf(i-m,juf,k+l  ) - uf(i-m-1,juf,k+l) +
     &                  uf(i-m,juf,k+l-1) - uf(i-m-1,juf,k+l-1) +
     &                  uf(i+m,juf,k-l  ) - uf(i+m-1,juf,k-l) +
     &                  uf(i+m,juf,k-l-1) - uf(i+m-1,juf,k-l-1) +
     &                  uf(i+m,juf,k+l  ) - uf(i+m-1,juf,k+l) +
     &                  uf(i+m,juf,k+l-1) - uf(i+m-1,juf,k+l-1))
                     tmp = tmp + idir *
     &                 (vf(i-m  ,juf,k-l) + vf(i-m  ,juf,k-l-1) +
     &                  vf(i-m-1,juf,k-l) + vf(i-m-1,juf,k-l-1) +
     &                  vf(i-m  ,juf,k+l) + vf(i-m  ,juf,k+l-1) +
     &                  vf(i-m-1,juf,k+l) + vf(i-m-1,juf,k+l-1) +
     &                  vf(i+m  ,juf,k-l) + vf(i+m  ,juf,k-l-1) +
     &                  vf(i+m-1,juf,k-l) + vf(i+m-1,juf,k-l-1) +
     &                  vf(i+m  ,juf,k+l) + vf(i+m  ,juf,k+l-1) +
     &                  vf(i+m-1,juf,k+l) + vf(i+m-1,juf,k+l-1))
                     src(i,j,k) = src(i,j,k) + fac * (tmp +
     &                 (wf(i-m  ,juf,k-l) - wf(i-m  ,juf,k-l-1) +
     &                  wf(i-m-1,juf,k-l) - wf(i-m-1,juf,k-l-1) +
     &                  wf(i-m  ,juf,k+l) - wf(i-m  ,juf,k+l-1) +
     &                  wf(i-m-1,juf,k+l) - wf(i-m-1,juf,k+l-1) +
     &                  wf(i+m  ,juf,k-l) - wf(i+m  ,juf,k-l-1) +
     &                  wf(i+m-1,juf,k-l) - wf(i+m-1,juf,k-l-1) +
     &                  wf(i+m  ,juf,k+l) - wf(i+m  ,juf,k+l-1) +
     &                  wf(i+m-1,juf,k+l) - wf(i+m-1,juf,k+l-1)))
                  end do
               end do
            end do
         end do
      else
         k = cregl2
         if (idir .eq. 1) then
            kuc = k - 1
            kuf = k * kr
         else
            kuc = k
            kuf = k * kr - 1
         end if
         fac0 = 0.25d0
         do j = cregl1, cregh1
            do i = cregl0, cregh0
               src(i*ir,j*jr,k*kr) = fac0 *
     &           ((uc(i,j,kuc) - uc(i-1,j,kuc) +
     &             uc(i,j-1,kuc) - uc(i-1,j-1,kuc)) +
     &            (vc(i,j,kuc) - vc(i,j-1,kuc) +
     &             vc(i-1,j,kuc) - vc(i-1,j-1,kuc)) -
     &     idir * (wc(i,j,kuc) + wc(i,j-1,kuc) +
     &             wc(i-1,j,kuc) + wc(i-1,j-1,kuc)))
            end do
         end do
         fac0 = fac0 / (ir * jr)
         k = k * kr
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5D0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5D0 * fac
               do j = jr*cregl1, jr*cregh1, jr
                  do i = ir*cregl0, ir*cregh0, ir
                     tmp =
     &                 (uf(i-m,j-n  ,kuf) - uf(i-m-1,j-n  ,kuf) +
     &                  uf(i-m,j-n-1,kuf) - uf(i-m-1,j-n-1,kuf) +
     &                  uf(i-m,j+n  ,kuf) - uf(i-m-1,j+n  ,kuf) +
     &                  uf(i-m,j+n-1,kuf) - uf(i-m-1,j+n-1,kuf) +
     &                  uf(i+m,j-n  ,kuf) - uf(i+m-1,j-n  ,kuf) +
     &                  uf(i+m,j-n-1,kuf) - uf(i+m-1,j-n-1,kuf) +
     &                  uf(i+m,j+n  ,kuf) - uf(i+m-1,j+n  ,kuf) +
     &                  uf(i+m,j+n-1,kuf) - uf(i+m-1,j+n-1,kuf))
                     tmp = tmp +
     &                 (vf(i-m  ,j-n,kuf) - vf(i-m  ,j-n-1,kuf) +
     &                  vf(i-m-1,j-n,kuf) - vf(i-m-1,j-n-1,kuf) +
     &                  vf(i-m  ,j+n,kuf) - vf(i-m  ,j+n-1,kuf) +
     &                  vf(i-m-1,j+n,kuf) - vf(i-m-1,j+n-1,kuf) +
     &                  vf(i+m  ,j-n,kuf) - vf(i+m  ,j-n-1,kuf) +
     &                  vf(i+m-1,j-n,kuf) - vf(i+m-1,j-n-1,kuf) +
     &                  vf(i+m  ,j+n,kuf) - vf(i+m  ,j+n-1,kuf) +
     &                  vf(i+m-1,j+n,kuf) - vf(i+m-1,j+n-1,kuf))
                     src(i,j,k) = src(i,j,k) + fac * (tmp + idir *
     &                 (wf(i-m  ,j-n,kuf) + wf(i-m  ,j-n-1,kuf) +
     &                  wf(i-m-1,j-n,kuf) + wf(i-m-1,j-n-1,kuf) +
     &                  wf(i-m  ,j+n,kuf) + wf(i-m  ,j+n-1,kuf) +
     &                  wf(i-m-1,j+n,kuf) + wf(i-m-1,j+n-1,kuf) +
     &                  wf(i+m  ,j-n,kuf) + wf(i+m  ,j-n-1,kuf) +
     &                  wf(i+m-1,j-n,kuf) + wf(i+m-1,j-n-1,kuf) +
     &                  wf(i+m  ,j+n,kuf) + wf(i+m  ,j+n-1,kuf) +
     &                  wf(i+m-1,j+n,kuf) + wf(i+m-1,j+n-1,kuf)))
                  end do
               end do
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgediv_dense(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uc, vc, wc,
     &      cl0,ch0,cl1,ch1,cl2,ch2,
     & uf, vf, wf,
     &     fl0,fh0,fl1,fh1,fl2,fh2,
     &     cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & hx, hy, hz, ir, jr, kr, ga, ivect)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision hx, hy, hz
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision vc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision wc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      integer ir, jr, kr, ivect(0:2), ga(0:1,0:1,0:1)
      double precision fac0, fac1, fac
      integer ic, jc, kc, if, jf, kf, iuc, iuf, juc, juf, kuc, kuf
      integer ii, ji, ki, idir, jdir, kdir, l, m, n
      ic = cregl0
      jc = cregl1
      kc = cregl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      if (ivect(0) .eq. 0) then
         do if = ir*cregl0, ir*cregh0, ir
            src(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac1 = 1.0D0 / ir
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) .eq. 1) then
                  kuf = kf + ki - 1
                  juf = jf + ji - 1
                  do m = 0, ir-1
                     fac = (ir-m) * fac1
                     if (m .eq. 0) fac = 0.5D0 * fac
                     do if = ir*cregl0, ir*cregh0, ir
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                 (
     &                    (uf(if-m,juf,kuf) - uf(if-m-1,juf,kuf) +
     &                     uf(if+m,juf,kuf) - uf(if+m-1,juf,kuf)) +
     &                                  jdir *
     &                    (vf(if-m,juf,kuf) + vf(if-m-1,juf,kuf) +
     &                     vf(if+m,juf,kuf) + vf(if+m-1,juf,kuf)) +
     &                                  kdir *
     &                    (wf(if-m,juf,kuf) + wf(if-m-1,juf,kuf) +
     &                     wf(if+m,juf,kuf) + wf(if+m-1,juf,kuf)))
                     end do
                  end do
               else
                  kuc = kc + ki - 1
                  juc = jc + ji - 1
                  do ic = cregl0, cregh0
                     if = ic * ir
                     src(if,jf,kf) = src(if,jf,kf) +
     &                 (       (uc(ic,juc,kuc) - uc(ic-1,juc,kuc)) +
     &                  jdir * (vc(ic,juc,kuc) + vc(ic-1,juc,kuc)) +
     &                  kdir * (wc(ic,juc,kuc) + wc(ic-1,juc,kuc)))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) - ga(0,ji,1-ki) .eq. 1) then
                  kuf = kf + ki - 1
                  fac0 = 1.0D0 / (ir * jr)
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*cregl0, ir*cregh0, ir
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (
     &            (uf(if-m  ,jf+n  ,kuf) - uf(if-m-1,jf+n  ,kuf) +
     &             uf(if-m  ,jf+n-1,kuf) - uf(if-m-1,jf+n-1,kuf) +
     &             uf(if+m  ,jf+n  ,kuf) - uf(if+m-1,jf+n  ,kuf) +
     &             uf(if+m  ,jf+n-1,kuf) - uf(if+m-1,jf+n-1,kuf)) +
c
     &            (vf(if-m  ,jf+n  ,kuf) - vf(if-m  ,jf+n-1,kuf) +
     &             vf(if-m-1,jf+n  ,kuf) - vf(if-m-1,jf+n-1,kuf) +
     &             vf(if+m  ,jf+n  ,kuf) - vf(if+m  ,jf+n-1,kuf) +
     &             vf(if+m-1,jf+n  ,kuf) - vf(if+m-1,jf+n-1,kuf)) +
     &                                         kdir *
     &            (wf(if-m  ,jf+n,kuf) + wf(if-m  ,jf+n-1,kuf) +
     &             wf(if-m-1,jf+n,kuf) + wf(if-m-1,jf+n-1,kuf) +
     &             wf(if+m  ,jf+n,kuf) + wf(if+m  ,jf+n-1,kuf) +
     &             wf(if+m-1,jf+n,kuf) + wf(if+m-1,jf+n-1,kuf)))
                        end do
                     end do
                  end do
               end if
               if (ga(0,ji,ki) - ga(0,1-ji,ki) .eq. 1) then
                  juf = jf + ji - 1
                  fac0 = 1.0D0 / (ir * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*cregl0, ir*cregh0, ir
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (
     &            (uf(if-m,juf,kf+l  ) - uf(if-m-1,juf,kf+l  ) +
     &             uf(if-m,juf,kf+l-1) - uf(if-m-1,juf,kf+l-1) +
     &             uf(if+m,juf,kf+l  ) - uf(if+m-1,juf,kf+l  ) +
     &             uf(if+m,juf,kf+l-1) - uf(if+m-1,juf,kf+l-1)) +
     &                                        jdir *
     &            (vf(if-m  ,juf,kf+l) + vf(if-m  ,juf,kf+l-1) +
     &             vf(if-m-1,juf,kf+l) + vf(if-m-1,juf,kf+l-1) +
     &             vf(if+m  ,juf,kf+l) + vf(if+m  ,juf,kf+l-1) +
     &             vf(if+m-1,juf,kf+l) + vf(if+m-1,juf,kf+l-1)) +
c
     &            (wf(if-m  ,juf,kf+l) - wf(if-m  ,juf,kf+l-1) +
     &             wf(if-m-1,juf,kf+l) - wf(if-m-1,juf,kf+l-1) +
     &             wf(if+m  ,juf,kf+l) - wf(if+m  ,juf,kf+l-1) +
     &             wf(if+m-1,juf,kf+l) - wf(if+m-1,juf,kf+l-1)))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do if = ir*cregl0, ir*cregh0, ir
            src(if,jf,kf) = 0.25d0 * src(if,jf,kf)
         end do

      else if (ivect(1) .eq. 0) then
         do jf = jr*cregl1, jr*cregh1, jr
            src(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac1 = 1.0D0 / jr
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) .eq. 1) then
                  kuf = kf + ki - 1
                  iuf = if + ii - 1
                  do  n = 0, jr-1
                     fac = (jr-n) * fac1
                     if (n .eq. 0) fac = 0.5D0 * fac
                     do jf = jr*cregl1, jr*cregh1, jr
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                 (idir *
     &                    (uf(iuf,jf-n,kuf) + uf(iuf,jf-n-1,kuf) +
     &                     uf(iuf,jf+n,kuf) + uf(iuf,jf+n-1,kuf)) +
c
     &                    (vf(iuf,jf-n,kuf) - vf(iuf,jf-n-1,kuf) +
     &                     vf(iuf,jf+n,kuf) - vf(iuf,jf+n-1,kuf)) +
     &                                  kdir *
     &                    (wf(iuf,jf-n,kuf) + wf(iuf,jf-n-1,kuf) +
     &                     wf(iuf,jf+n,kuf) + wf(iuf,jf+n-1,kuf)))
                     end do
                  end do
               else
                  kuc = kc + ki - 1
                  iuc = ic + ii - 1
                  do jc = cregl1, cregh1
                     jf = jc * jr
                     src(if,jf,kf) = src(if,jf,kf) +
     &                 (idir * (uc(iuc,jc,kuc) + uc(iuc,jc-1,kuc)) +
     &                         (vc(iuc,jc,kuc) - vc(iuc,jc-1,kuc)) +
     &                  kdir * (wc(iuc,jc,kuc) + wc(iuc,jc-1,kuc)))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) - ga(ii,0,1-ki) .eq. 1) then
                  kuf = kf + ki - 1
                  fac0 = 1.0D0 / (ir * jr)
                  do n = 0, jr-1
                     fac1 = (jr-n) * fac0
                     if (n .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do jf = jr*cregl1, jr*cregh1, jr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (
     &            (uf(if+m  ,jf-n  ,kuf) - uf(if+m-1,jf-n  ,kuf) +
     &             uf(if+m  ,jf-n-1,kuf) - uf(if+m-1,jf-n-1,kuf) +
     &             uf(if+m  ,jf+n  ,kuf) - uf(if+m-1,jf+n  ,kuf) +
     &             uf(if+m  ,jf+n-1,kuf) - uf(if+m-1,jf+n-1,kuf)) +
     &            (vf(if+m  ,jf-n  ,kuf) - vf(if+m  ,jf-n-1,kuf) +
     &             vf(if+m-1,jf-n  ,kuf) - vf(if+m-1,jf-n-1,kuf) +
     &             vf(if+m  ,jf+n  ,kuf) - vf(if+m  ,jf+n-1,kuf) +
     &             vf(if+m-1,jf+n  ,kuf) - vf(if+m-1,jf+n-1,kuf)) +
     &                                        kdir *
     &            (wf(if+m  ,jf-n,kuf) + wf(if+m  ,jf-n-1,kuf) +
     &             wf(if+m-1,jf-n,kuf) + wf(if+m-1,jf-n-1,kuf) +
     &             wf(if+m  ,jf+n,kuf) + wf(if+m  ,jf+n-1,kuf) +
     &             wf(if+m-1,jf+n,kuf) + wf(if+m-1,jf+n-1,kuf)))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,0,ki) - ga(1-ii,0,ki) .eq. 1) then
                  iuf = if + ii - 1
                  fac0 = 1.0D0 / (jr * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = 0, jr-1
                        fac = (jr-n) * fac1
                        if (n .eq. 0) fac = 0.5D0 * fac
                        do jf = jr*cregl1, jr*cregh1, jr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (idir *
     &            (uf(iuf,jf-n  ,kf+l  ) + uf(iuf,jf-n-1,kf+l  ) +
     &             uf(iuf,jf-n  ,kf+l-1) + uf(iuf,jf-n-1,kf+l-1) +
     &             uf(iuf,jf+n  ,kf+l  ) + uf(iuf,jf+n-1,kf+l  ) +
     &             uf(iuf,jf+n  ,kf+l-1) + uf(iuf,jf+n-1,kf+l-1)) +
     &            (vf(iuf,jf-n  ,kf+l  ) - vf(iuf,jf-n-1,kf+l  ) +
     &             vf(iuf,jf-n  ,kf+l-1) - vf(iuf,jf-n-1,kf+l-1) +
     &             vf(iuf,jf+n  ,kf+l  ) - vf(iuf,jf+n-1,kf+l  ) +
     &             vf(iuf,jf+n  ,kf+l-1) - vf(iuf,jf+n-1,kf+l-1)) +
     &            (wf(iuf,jf-n  ,kf+l  ) - wf(iuf,jf-n  ,kf+l-1) +
     &             wf(iuf,jf-n-1,kf+l  ) - wf(iuf,jf-n-1,kf+l-1) +
     &             wf(iuf,jf+n  ,kf+l  ) - wf(iuf,jf+n  ,kf+l-1) +
     &             wf(iuf,jf+n-1,kf+l  ) - wf(iuf,jf+n-1,kf+l-1)))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do jf = jr*cregl1, jr*cregh1, jr
            src(if,jf,kf) = 0.25d0 * src(if,jf,kf)
         end do

      else
         do kf = kr*cregl2, kr*cregh2, kr
            src(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac1 = 1.0D0 / kr
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) .eq. 1) then
                  juf = jf + ji - 1
                  iuf = if + ii - 1
                  do l = 0, kr-1
                     fac = (kr-l) * fac1
                     if (l .eq. 0) fac = 0.5D0 * fac
                     do kf = kr*cregl2, kr*cregh2, kr
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                 (idir *
     &                    (uf(iuf,juf,kf-l) + uf(iuf,juf,kf-l-1) +
     &                     uf(iuf,juf,kf+l) + uf(iuf,juf,kf+l-1)) +
     &                                  jdir *
     &                    (vf(iuf,juf,kf-l) + vf(iuf,juf,kf-l-1) +
     &                     vf(iuf,juf,kf+l) + vf(iuf,juf,kf+l-1)) +
c
     &                    (wf(iuf,juf,kf-l) - wf(iuf,juf,kf-l-1) +
     &                     wf(iuf,juf,kf+l) - wf(iuf,juf,kf+l-1)))
                     end do
                  end do
               else
                  juc = jc + ji - 1
                  iuc = ic + ii - 1
                  do kc = cregl2, cregh2
                     kf = kc * kr
                     src(if,jf,kf) = src(if,jf,kf) +
     &                 (idir * (uc(iuc,juc,kc) + uc(iuc,juc,kc-1)) +
     &                  jdir * (vc(iuc,juc,kc) + vc(iuc,juc,kc-1)) +
     &                         (wc(iuc,juc,kc) - wc(iuc,juc,kc-1)))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) - ga(ii,1-ji,0) .eq. 1) then
                  juf = jf + ji - 1
                  fac0 = 1.0D0 / (ir * kr)
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do kf = kr*cregl2, kr*cregh2, kr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (
     &            (uf(if+m,juf,kf-l  ) - uf(if+m-1,juf,kf-l) +
     &             uf(if+m,juf,kf-l-1) - uf(if+m-1,juf,kf-l-1) +
     &             uf(if+m,juf,kf+l  ) - uf(if+m-1,juf,kf+l) +
     &             uf(if+m,juf,kf+l-1) - uf(if+m-1,juf,kf+l-1)) +
     &                                        jdir *
     &            (vf(if+m  ,juf,kf-l) + vf(if+m  ,juf,kf-l-1) +
     &             vf(if+m-1,juf,kf-l) + vf(if+m-1,juf,kf-l-1) +
     &             vf(if+m  ,juf,kf+l) + vf(if+m  ,juf,kf+l-1) +
     &             vf(if+m-1,juf,kf+l) + vf(if+m-1,juf,kf+l-1)) +
c
     &            (wf(if+m  ,juf,kf-l) - wf(if+m  ,juf,kf-l-1) +
     &             wf(if+m-1,juf,kf-l) - wf(if+m-1,juf,kf-l-1) +
     &             wf(if+m  ,juf,kf+l) - wf(if+m  ,juf,kf+l-1) +
     &             wf(if+m-1,juf,kf+l) - wf(if+m-1,juf,kf+l-1)))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,ji,0) - ga(1-ii,ji,0) .eq. 1) then
                  iuf = if + ii - 1
                  fac0 = 1.0D0 / (jr * kr)
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        do kf = kr*cregl2, kr*cregh2, kr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (idir *
     &            (uf(iuf,jf+n,kf-l  ) + uf(iuf,jf+n-1,kf-l  ) +
     &             uf(iuf,jf+n,kf-l-1) + uf(iuf,jf+n-1,kf-l-1) +
     &             uf(iuf,jf+n,kf+l  ) + uf(iuf,jf+n-1,kf+l  ) +
     &             uf(iuf,jf+n,kf+l-1) + uf(iuf,jf+n-1,kf+l-1)) +
c
     &            (vf(iuf,jf+n,kf-l  ) - vf(iuf,jf+n-1,kf-l  ) +
     &             vf(iuf,jf+n,kf-l-1) - vf(iuf,jf+n-1,kf-l-1) +
     &             vf(iuf,jf+n,kf+l  ) - vf(iuf,jf+n-1,kf+l  ) +
     &             vf(iuf,jf+n,kf+l-1) - vf(iuf,jf+n-1,kf+l-1)) +
c
     &            (wf(iuf,jf+n,kf-l  ) - wf(iuf,jf+n  ,kf-l-1) +
     &             wf(iuf,jf+n-1,kf-l) - wf(iuf,jf+n-1,kf-l-1) +
     &             wf(iuf,jf+n,kf+l  ) - wf(iuf,jf+n  ,kf+l-1) +
     &             wf(iuf,jf+n-1,kf+l) - wf(iuf,jf+n-1,kf+l-1)))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do kf = kr*cregl2, kr*cregh2, kr
            src(if,jf,kf) = 0.25d0 * src(if,jf,kf)
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcdiv_dense(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uc, vc, wc,
     &      cl0,ch0,cl1,ch1,cl2,ch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & hx, hy, hz, ir, jr, kr, ga, ijnk)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision hx, hy, hz
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision vc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision wc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      integer ir, jr, kr, ga(0:1,0:1,0:1), ijnk(0:2)
      double precision sum, fac0, fac1, fac
      integer ic, jc, kc, if, jf, kf, iuc, iuf, juc, juf, kuc, kuf
      integer ii, ji, ki, idir, jdir, kdir, l, m, n
      ic = cregl0
      jc = cregl1
      kc = cregl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      sum = 0.0D0
c octants
      do ki = 0, 1
         kdir = 2 * ki - 1
         kuf = kf + ki - 1
         kuc = kc + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            juf = jf + ji - 1
            juc = jc + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) .eq. 1) then
                  iuf = if + ii - 1
                  sum = sum +
     &              (idir * uf(iuf,juf,kuf) +
     &               jdir * vf(iuf,juf,kuf) +
     &               kdir * wf(iuf,juf,kuf))
               else
                  iuc = ic + ii - 1
                  sum = sum +
     &              (idir * uc(iuc,juc,kuc) +
     &               jdir * vc(iuc,juc,kuc) +
     &               kdir * wc(iuc,juc,kuc))
               end if
            end do
         end do
      end do
c faces
      do ki = 0, 1
         kdir = 2 * ki - 1
         kuf = kf + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            juf = jf + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               iuf = if + ii - 1
               if (ga(ii,ji,ki) - ga(ii,ji,1-ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * jr)
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac * (
     &               (uf(if+m,jf+n  ,kuf) - uf(if+m-1,jf+n  ,kuf) +
     &                uf(if+m,jf+n-1,kuf) - uf(if+m-1,jf+n-1,kuf)) +
c
     &               (vf(if+m  ,jf+n,kuf) - vf(if+m  ,jf+n-1,kuf) +
     &                vf(if+m-1,jf+n,kuf) - vf(if+m-1,jf+n-1,kuf)) +
     &                                     kdir *
     &               (wf(if+m  ,jf+n,kuf) + wf(if+m  ,jf+n-1,kuf) +
     &                wf(if+m-1,jf+n,kuf) + wf(if+m-1,jf+n-1,kuf)))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(ii,1-ji,ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac * (
     &                (uf(if+m  ,juf,kf+l  ) - uf(if+m-1,juf,kf+l  ) +
     &                 uf(if+m  ,juf,kf+l-1) - uf(if+m-1,juf,kf+l-1)) +
     &                                     jdir *
     &                (vf(if+m  ,juf,kf+l  ) + vf(if+m  ,juf,kf+l-1) +
     &                 vf(if+m-1,juf,kf+l  ) + vf(if+m-1,juf,kf+l-1)) +
c
     &                (wf(if+m  ,juf,kf+l  ) - wf(if+m  ,juf,kf+l-1) +
     &                 wf(if+m-1,juf,kf+l  ) - wf(if+m-1,juf,kf+l-1)))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(1-ii,ji,ki) .eq. 1) then
                  fac0 = 1.0D0 / (jr * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        sum = sum + fac * (idir *
     &                (uf(iuf,jf+n  ,kf+l  ) + uf(iuf,jf+n  ,kf+l-1) +
     &                 uf(iuf,jf+n-1,kf+l  ) + uf(iuf,jf+n-1,kf+l-1)) +
c
     &                (vf(iuf,jf+n  ,kf+l  ) - vf(iuf,jf+n-1,kf+l  ) +
     &                 vf(iuf,jf+n  ,kf+l-1) - vf(iuf,jf+n-1,kf+l-1)) +
c
     &                (wf(iuf,jf+n  ,kf+l  ) - wf(iuf,jf+n  ,kf+l-1) +
     &                 wf(iuf,jf+n-1,kf+l  ) - wf(iuf,jf+n-1,kf+l-1)))
                     end do
                  end do
               end if
            end do
         end do
      end do
c edges
      do ki = 0, 1
         kdir = 2 * ki - 1
         kuf = kf + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            juf = jf + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               iuf = if + ii - 1
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(ii,1-ji,ki), ga(ii,1-ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / ir
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     sum = sum + fac * (
     &                 (uf(if+m,juf,kuf) - uf(if+m-1,juf,kuf)) +
     &                                  jdir *
     &                 (vf(if+m,juf,kuf) + vf(if+m-1,juf,kuf)) +
     &                                  kdir *
     &                 (wf(if+m,juf,kuf) + wf(if+m-1,juf,kuf)))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(1-ii,ji,ki), ga(1-ii,ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / jr
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     sum = sum + fac * (idir *
     &                 (uf(iuf,jf+n,kuf) + uf(iuf,jf+n-1,kuf)) +
c
     &                 (vf(iuf,jf+n,kuf) - vf(iuf,jf+n-1,kuf)) +
     &                                  kdir *
     &                 (wf(iuf,jf+n,kuf) + wf(iuf,jf+n-1,kuf)))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,1-ji,ki), ga(1-ii,ji,ki), ga(1-ii,1-ji,ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / kr
                  do l = kdir, kdir*(kr-1), kdir
                     fac = (kr-abs(l)) * fac1
                     sum = sum + fac * (idir *
     &                 (uf(iuf,juf,kf+l) + uf(iuf,juf,kf+l-1)) +
     &                                  jdir *
     &                 (vf(iuf,juf,kf+l) + vf(iuf,juf,kf+l-1)) +
c
     &                 (wf(iuf,juf,kf+l) - wf(iuf,juf,kf+l-1)))
                  end do
               end if
            end do
         end do
      end do
c weighting
      src(if,jf,kf) = 0.25d0 * sum
      end
c-----------------------------------------------------------------------
      subroutine hggrad(
     & gpx, gpy, gpz,
     &       gpl0,gph0,gpl1,gph1,gpl2,gph2,
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       fregl0,fregh0,fregl1,fregh1,fregl2,fregh2,
     & hx, hy, hz, idummy)
      integer gpl0,gph0,gpl1,gph1,gpl2,gph2
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer fregl0,fregh0,fregl1,fregh1,fregl2,fregh2
      double precision gpx(gpl0:gph0,gpl1:gph1,gpl2:gph2)
      double precision gpy(gpl0:gph0,gpl1:gph1,gpl2:gph2)
      double precision gpz(gpl0:gph0,gpl1:gph1,gpl2:gph2)
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision hx, hy, hz
      double precision hxm1h, hym1h, hzm1h
      integer i, j, k
      integer idummy
      hxm1h = 0.25d0 / hx
      hym1h = 0.25d0 / hy
      hzm1h = 0.25d0 / hz
      do k = fregl2, fregh2
         do j = fregl1, fregh1
            do i = fregl0, fregh0
               gpx(i,j,k) = hxm1h * (dest(i+1,j,k) + dest(i+1,j+1,k) +
     &                           dest(i+1,j,k+1) + dest(i+1,j+1,k+1) -
     &                           dest(i,j,k) - dest(i,j+1,k) -
     &                           dest(i,j,k+1) - dest(i,j+1,k+1))
               gpy(i,j,k) = hym1h * (dest(i,j+1,k) + dest(i+1,j+1,k) +
     &                           dest(i,j+1,k+1) + dest(i+1,j+1,k+1) -
     &                           dest(i,j,k) - dest(i+1,j,k) -
     &                           dest(i,j,k+1) - dest(i+1,j,k+1))
               gpz(i,j,k) = hzm1h * (dest(i,j,k+1) + dest(i+1,j,k+1) +
     &                           dest(i,j+1,k+1) + dest(i+1,j+1,k+1) -
     &                           dest(i,j,k) - dest(i+1,j,k) -
     &                           dest(i,j+1,k) - dest(i+1,j+1,k))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgdiv(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     &      fregl0,fregh0,fregl1,fregh1,fregl2,fregh2,
     & hx, hy, hz, idummy, jdummy)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer fregl0,fregh0,fregl1,fregh1,fregl2,fregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision hx, hy, hz
      double precision hxm1, hym1, hzm1, fac
      integer idummy, jdummy
      integer i, j, k
      hxm1 = 1.0D0 / hx
      hym1 = 1.0D0 / hy
      hzm1 = 1.0D0 / hz
      fac = 0.25d0
      do k = fregl2, fregh2
         do j = fregl1, fregh1
            do i = fregl0, fregh0
               src(i,j,k) = fac *
     &              (hxm1 * (uf(i  ,j-1,k-1) - uf(i-1,j-1,k-1) +
     &                       uf(i  ,j-1,k  ) - uf(i-1,j-1,k) +
     &                       uf(i  ,j  ,k-1) - uf(i-1,j  ,k-1) +
     &                       uf(i  ,j  ,k  ) - uf(i-1,j  ,k  )) +
     &               hym1 * (vf(i-1,j  ,k-1) - vf(i-1,j-1,k-1) +
     &                       vf(i-1,j  ,k  ) - vf(i-1,j-1,k  ) +
     &                       vf(i  ,j  ,k-1) - vf(i  ,j-1,k-1) +
     &                       vf(i  ,j  ,k  ) - vf(i  ,j-1,k  )) +
     &               hzm1 * (wf(i-1,j-1,k  ) - wf(i-1,j-1,k-1) +
     &                       wf(i-1,j  ,k  ) - wf(i-1,j  ,k-1) +
     &                       wf(i  ,j-1,k  ) - wf(i  ,j-1,k-1) +
     &                       wf(i  ,j  ,k  ) - wf(i  ,j  ,k-1)))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfdiv(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uc, vc, wc,
     &      cl0,ch0,cl1,ch1,cl2,ch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     & cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & hx, hy, hz, ir, jr, kr, idim, idir, i1, i2)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision vc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision wc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision hx, hy, hz
      integer ir, jr, kr, idim, idir, i1, i2
      double precision hxm1, hym1, hzm1, fac0, fac1, fac, tmp
      integer i, j, k, iuc, iuf, juc, juf, kuc, kuf, l, m, n
      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            iuc = i - 1
            iuf = i * ir
         else
            iuc = i
            iuf = i * ir - 1
         end if
         fac0 = 0.5D0 * ir / (ir + 1.0D0)
         hxm1 = 1.0D0 / (ir * hx)
         hym1 = 1.0D0 / (jr * hy)
         hzm1 = 1.0D0 / (kr * hz)
         do k = cregl2, cregh2
            do j = cregl1, cregh1
               src(i*ir,j*jr,k*kr) = fac0 *
     &           (hym1 * (vc(iuc,j  ,k  ) - vc(iuc,j-1,k  ) +
     &                    vc(iuc,j  ,k-1) - vc(iuc,j-1,k-1)) +
     &            hzm1 * (wc(iuc,j  ,k  ) - wc(iuc,j  ,k-1) +
     &                    wc(iuc,j-1,k  ) - wc(iuc,j-1,k-1)) -
     &            hxm1 * idir * (uc(iuc,j  ,k) + uc(iuc,j  ,k-1) +
     &                           uc(iuc,j-1,k) + uc(iuc,j-1,k-1)))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * jr * kr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         hzm1 = kr * hzm1
         i = i * ir
         do l = 0, kr-1
            fac1 = (kr-l) * fac0
            if (l .eq. 0) fac1 = 0.5D0 * fac1
            do n = 0, jr-1
               fac = (jr-n) * fac1
               if (n .eq. 0) fac = 0.5D0 * fac
               do k = kr*cregl2, kr*cregh2, kr
                  do j = jr*cregl1, jr*cregh1, jr
                     tmp = hxm1 * idir *
     &                 (uf(iuf,j-n  ,k-l) + uf(iuf,j-n  ,k-l-1) +
     &                  uf(iuf,j-n-1,k-l) + uf(iuf,j-n-1,k-l-1) +
     &                  uf(iuf,j-n  ,k+l) + uf(iuf,j-n  ,k+l-1) +
     &                  uf(iuf,j-n-1,k+l) + uf(iuf,j-n-1,k+l-1) +
     &                  uf(iuf,j+n  ,k-l) + uf(iuf,j+n  ,k-l-1) +
     &                  uf(iuf,j+n-1,k-l) + uf(iuf,j+n-1,k-l-1) +
     &                  uf(iuf,j+n  ,k+l) + uf(iuf,j+n  ,k+l-1) +
     &                  uf(iuf,j+n-1,k+l) + uf(iuf,j+n-1,k+l-1))
                     tmp = tmp + hym1 *
     &                 (vf(iuf,j-n,k-l  ) - vf(iuf,j-n-1,k-l  ) +
     &                  vf(iuf,j-n,k-l-1) - vf(iuf,j-n-1,k-l-1) +
     &                  vf(iuf,j-n,k+l  ) - vf(iuf,j-n-1,k+l  ) +
     &                  vf(iuf,j-n,k+l-1) - vf(iuf,j-n-1,k+l-1) +
     &                  vf(iuf,j+n,k-l  ) - vf(iuf,j+n-1,k-l  ) +
     &                  vf(iuf,j+n,k-l-1) - vf(iuf,j+n-1,k-l-1) +
     &                  vf(iuf,j+n,k+l  ) - vf(iuf,j+n-1,k+l  ) +
     &                  vf(iuf,j+n,k+l-1) - vf(iuf,j+n-1,k+l-1))
                     src(i,j,k) = src(i,j,k) + fac * (tmp + hzm1 *
     &                 (wf(iuf,j-n,k-l  ) - wf(iuf,j-n  ,k-l-1) +
     &                  wf(iuf,j-n-1,k-l) - wf(iuf,j-n-1,k-l-1) +
     &                  wf(iuf,j-n,k+l  ) - wf(iuf,j-n  ,k+l-1) +
     &                  wf(iuf,j-n-1,k+l) - wf(iuf,j-n-1,k+l-1) +
     &                  wf(iuf,j+n,k-l  ) - wf(iuf,j+n  ,k-l-1) +
     &                  wf(iuf,j+n-1,k-l) - wf(iuf,j+n-1,k-l-1) +
     &                  wf(iuf,j+n,k+l  ) - wf(iuf,j+n  ,k+l-1) +
     &                  wf(iuf,j+n-1,k+l) - wf(iuf,j+n-1,k+l-1)))
                  end do
               end do
            end do
         end do
      else if (idim .eq. 1) then
         j = cregl1
         if (idir .eq. 1) then
            juc = j - 1
            juf = j * jr
         else
            juc = j
            juf = j * jr - 1
         end if
         fac0 = 0.5D0 * jr / (jr + 1.0D0)
         hxm1 = 1.0D0 / (ir * hx)
         hym1 = 1.0D0 / (jr * hy)
         hzm1 = 1.0D0 / (kr * hz)
         do k = cregl2, cregh2
            do i = cregl0, cregh0
               src(i*ir,j*jr,k*kr) = fac0 *
     &           (hxm1 * (uc(i,juc,k  ) - uc(i-1,juc,k  ) +
     &                    uc(i,juc,k-1) - uc(i-1,juc,k-1)) -
     &            hym1 * idir * (vc(i  ,juc,k) + vc(i  ,juc,k-1) +
     &                           vc(i-1,juc,k) + vc(i-1,juc,k-1)) +
     &            hzm1 * (wc(i  ,juc,k) - wc(i  ,juc,k-1) +
     &                    wc(i-1,juc,k) - wc(i-1,juc,k-1)))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * ir * kr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         hzm1 = kr * hzm1
         j = j * jr
         do l = 0, kr-1
            fac1 = (kr-l) * fac0
            if (l .eq. 0) fac1 = 0.5D0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5D0 * fac
               do k = kr*cregl2, kr*cregh2, kr
                  do i = ir*cregl0, ir*cregh0, ir
                     tmp = hxm1 *
     &                 (uf(i-m,juf,k-l  ) - uf(i-m-1,juf,k-l  ) +
     &                  uf(i-m,juf,k-l-1) - uf(i-m-1,juf,k-l-1) +
     &                  uf(i-m,juf,k+l  ) - uf(i-m-1,juf,k+l  ) +
     &                  uf(i-m,juf,k+l-1) - uf(i-m-1,juf,k+l-1) +
     &                  uf(i+m,juf,k-l  ) - uf(i+m-1,juf,k-l  ) +
     &                  uf(i+m,juf,k-l-1) - uf(i+m-1,juf,k-l-1) +
     &                  uf(i+m,juf,k+l  ) - uf(i+m-1,juf,k+l  ) +
     &                  uf(i+m,juf,k+l-1) - uf(i+m-1,juf,k+l-1))
                     tmp = tmp + hym1 * idir *
     &                 (vf(i-m  ,juf,k-l) + vf(i-m  ,juf,k-l-1) +
     &                  vf(i-m-1,juf,k-l) + vf(i-m-1,juf,k-l-1) +
     &                  vf(i-m  ,juf,k+l) + vf(i-m  ,juf,k+l-1) +
     &                  vf(i-m-1,juf,k+l) + vf(i-m-1,juf,k+l-1) +
     &                  vf(i+m  ,juf,k-l) + vf(i+m  ,juf,k-l-1) +
     &                  vf(i+m-1,juf,k-l) + vf(i+m-1,juf,k-l-1) +
     &                  vf(i+m  ,juf,k+l) + vf(i+m  ,juf,k+l-1) +
     &                  vf(i+m-1,juf,k+l) + vf(i+m-1,juf,k+l-1))
                     src(i,j,k) = src(i,j,k) + fac * (tmp + hzm1 *
     &                 (wf(i-m  ,juf,k-l) - wf(i-m  ,juf,k-l-1) +
     &                  wf(i-m-1,juf,k-l) - wf(i-m-1,juf,k-l-1) +
     &                  wf(i-m  ,juf,k+l) - wf(i-m  ,juf,k+l-1) +
     &                  wf(i-m-1,juf,k+l) - wf(i-m-1,juf,k+l-1) +
     &                  wf(i+m  ,juf,k-l) - wf(i+m  ,juf,k-l-1) +
     &                  wf(i+m-1,juf,k-l) - wf(i+m-1,juf,k-l-1) +
     &                  wf(i+m  ,juf,k+l) - wf(i+m  ,juf,k+l-1) +
     &                  wf(i+m-1,juf,k+l) - wf(i+m-1,juf,k+l-1)))
                  end do
               end do
            end do
         end do
      else
         k = cregl2
         if (idir .eq. 1) then
            kuc = k - 1
            kuf = k * kr
         else
            kuc = k
            kuf = k * kr - 1
         end if
         fac0 = 0.5D0 * kr / (kr + 1.0D0)
         hxm1 = 1.0D0 / (ir * hx)
         hym1 = 1.0D0 / (jr * hy)
         hzm1 = 1.0D0 / (kr * hz)
         do j = cregl1, cregh1
            do i = cregl0, cregh0
               src(i*ir,j*jr,k*kr) = fac0 *
     &           (hxm1 * (uc(i  ,j  ,kuc) - uc(i-1,j  ,kuc) +
     &                    uc(i  ,j-1,kuc) - uc(i-1,j-1,kuc)) +
     &            hym1 * (vc(i  ,j  ,kuc) - vc(i  ,j-1,kuc) +
     &                    vc(i-1,j  ,kuc) - vc(i-1,j-1,kuc)) -
     &            hzm1 * idir * (wc(i  ,j,kuc) + wc(i  ,j-1,kuc) +
     &                           wc(i-1,j,kuc) + wc(i-1,j-1,kuc)))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * ir * jr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         hzm1 = kr * hzm1
         k = k * kr
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5D0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5D0 * fac
               do j = jr*cregl1, jr*cregh1, jr
                  do i = ir*cregl0, ir*cregh0, ir
                     tmp = hxm1 *
     &                 (uf(i-m,j-n  ,kuf) - uf(i-m-1,j-n  ,kuf) +
     &                  uf(i-m,j-n-1,kuf) - uf(i-m-1,j-n-1,kuf) +
     &                  uf(i-m,j+n  ,kuf) - uf(i-m-1,j+n  ,kuf) +
     &                  uf(i-m,j+n-1,kuf) - uf(i-m-1,j+n-1,kuf) +
     &                  uf(i+m,j-n  ,kuf) - uf(i+m-1,j-n  ,kuf) +
     &                  uf(i+m,j-n-1,kuf) - uf(i+m-1,j-n-1,kuf) +
     &                  uf(i+m,j+n  ,kuf) - uf(i+m-1,j+n  ,kuf) +
     &                  uf(i+m,j+n-1,kuf) - uf(i+m-1,j+n-1,kuf))
                     tmp = tmp + hym1 *
     &                 (vf(i-m  ,j-n,kuf) - vf(i-m  ,j-n-1,kuf) +
     &                  vf(i-m-1,j-n,kuf) - vf(i-m-1,j-n-1,kuf) +
     &                  vf(i-m  ,j+n,kuf) - vf(i-m  ,j+n-1,kuf) +
     &                  vf(i-m-1,j+n,kuf) - vf(i-m-1,j+n-1,kuf) +
     &                  vf(i+m  ,j-n,kuf) - vf(i+m  ,j-n-1,kuf) +
     &                  vf(i+m-1,j-n,kuf) - vf(i+m-1,j-n-1,kuf) +
     &                  vf(i+m  ,j+n,kuf) - vf(i+m  ,j+n-1,kuf) +
     &                  vf(i+m-1,j+n,kuf) - vf(i+m-1,j+n-1,kuf))
                    src(i,j,k) = src(i,j,k) + fac * (tmp + hzm1 * idir *
     &                 (wf(i-m  ,j-n,kuf) + wf(i-m  ,j-n-1,kuf) +
     &                  wf(i-m-1,j-n,kuf) + wf(i-m-1,j-n-1,kuf) +
     &                  wf(i-m  ,j+n,kuf) + wf(i-m  ,j+n-1,kuf) +
     &                  wf(i-m-1,j+n,kuf) + wf(i-m-1,j+n-1,kuf) +
     &                  wf(i+m  ,j-n,kuf) + wf(i+m  ,j-n-1,kuf) +
     &                  wf(i+m-1,j-n,kuf) + wf(i+m-1,j-n-1,kuf) +
     &                  wf(i+m  ,j+n,kuf) + wf(i+m  ,j+n-1,kuf) +
     &                  wf(i+m-1,j+n,kuf) + wf(i+m-1,j+n-1,kuf)))
                  end do
               end do
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgediv(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uc, vc, wc,
     &      cl0,ch0,cl1,ch1,cl2,ch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & hx, hy, hz, ir, jr, kr, ga, ivect)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision vc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision wc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision hx, hy, hz
      integer ir, jr, kr, ivect(0:2), ga(0:1,0:1,0:1)
      double precision r3, hxm1, hym1, hzm1, hxm1c, hym1c, hzm1c
      double precision center, cfac, ffac, fac0, fac1, fac
      integer ic, jc, kc, if, jf, kf, iuc, iuf, juc, juf, kuc, kuf
      integer ii, ji, ki, idir, jdir, kdir, l, m, n
      r3 = ir * jr * kr
      hxm1c = 1.0D0 / (ir * hx)
      hym1c = 1.0D0 / (jr * hy)
      hzm1c = 1.0D0 / (kr * hz)
      hxm1 = ir * hxm1c
      hym1 = jr * hym1c
      hzm1 = kr * hzm1c
      ic = cregl0
      jc = cregl1
      kc = cregl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      center = 0.0D0
      if (ivect(0) .eq. 0) then
         do if = ir*cregl0, ir*cregh0, ir
            src(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac1 = 1.0D0 / ir
         ffac = ir
         cfac = r3
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) .eq. 1) then
                  kuf = kf + ki - 1
                  juf = jf + ji - 1
                  center = center + ffac
                  do m = 0, ir-1
                     fac = (ir-m) * fac1
                     if (m .eq. 0) fac = 0.5D0 * fac
                     do if = ir*cregl0, ir*cregh0, ir
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                 (hxm1 *
     &                    (uf(if-m,juf,kuf) - uf(if-m-1,juf,kuf) +
     &                     uf(if+m,juf,kuf) - uf(if+m-1,juf,kuf)) +
     &                                  hym1 * jdir *
     &                    (vf(if-m,juf,kuf) + vf(if-m-1,juf,kuf) +
     &                     vf(if+m,juf,kuf) + vf(if+m-1,juf,kuf)) +
     &                                  hzm1 * kdir *
     &                    (wf(if-m,juf,kuf) + wf(if-m-1,juf,kuf) +
     &                     wf(if+m,juf,kuf) + wf(if+m-1,juf,kuf)))
                     end do
                  end do
               else
                  kuc = kc + ki - 1
                  juc = jc + ji - 1
                  center = center + cfac
                  do ic = cregl0, cregh0
                     if = ic * ir
                     src(if,jf,kf) = src(if,jf,kf) + r3 *
     &            (hxm1c *        (uc(ic,juc,kuc) - uc(ic-1,juc,kuc)) +
     &             hym1c * jdir * (vc(ic,juc,kuc) + vc(ic-1,juc,kuc)) +
     &             hzm1c * kdir * (wc(ic,juc,kuc) + wc(ic-1,juc,kuc)))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) - ga(0,ji,1-ki) .eq. 1) then
                  kuf = kf + ki - 1
                  fac0 = 1.0D0 / (ir * jr)
                  ffac = ir * (jr - 1)
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*cregl0, ir*cregh0, ir
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (hxm1 *
     &                (uf(if-m,jf+n,kuf) - uf(if-m-1,jf+n,kuf) +
     &                 uf(if-m,jf+n-1,kuf) - uf(if-m-1,jf+n-1,kuf) +
     &                 uf(if+m,jf+n,kuf) - uf(if+m-1,jf+n,kuf) +
     &                 uf(if+m,jf+n-1,kuf) - uf(if+m-1,jf+n-1,kuf)) +
     &                                        hym1 *
     &                (vf(if-m,jf+n,kuf) - vf(if-m,jf+n-1,kuf) +
     &                 vf(if-m-1,jf+n,kuf) - vf(if-m-1,jf+n-1,kuf) +
     &                 vf(if+m,jf+n,kuf) - vf(if+m,jf+n-1,kuf) +
     &                 vf(if+m-1,jf+n,kuf) - vf(if+m-1,jf+n-1,kuf)) +
     &                                        hzm1 * kdir *
     &                (wf(if-m,jf+n,kuf) + wf(if-m,jf+n-1,kuf) +
     &                 wf(if-m-1,jf+n,kuf) + wf(if-m-1,jf+n-1,kuf) +
     &                 wf(if+m,jf+n,kuf) + wf(if+m,jf+n-1,kuf) +
     &                 wf(if+m-1,jf+n,kuf) + wf(if+m-1,jf+n-1,kuf)))
                        end do
                     end do
                  end do
               end if
               if (ga(0,ji,ki) - ga(0,1-ji,ki) .eq. 1) then
                  juf = jf + ji - 1
                  fac0 = 1.0D0 / (ir * kr)
                  ffac = ir * (kr - 1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*cregl0, ir*cregh0, ir
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (hxm1 *
     &                (uf(if-m,juf,kf+l) - uf(if-m-1,juf,kf+l) +
     &                 uf(if-m,juf,kf+l-1) - uf(if-m-1,juf,kf+l-1) +
     &                 uf(if+m,juf,kf+l) - uf(if+m-1,juf,kf+l) +
     &                 uf(if+m,juf,kf+l-1) - uf(if+m-1,juf,kf+l-1)) +
     &                                        hym1 * jdir *
     &                (vf(if-m,juf,kf+l) + vf(if-m,juf,kf+l-1) +
     &                 vf(if-m-1,juf,kf+l) + vf(if-m-1,juf,kf+l-1) +
     &                 vf(if+m,juf,kf+l) + vf(if+m,juf,kf+l-1) +
     &                 vf(if+m-1,juf,kf+l) + vf(if+m-1,juf,kf+l-1)) +
     &                                        hzm1 *
     &                (wf(if-m,juf,kf+l) - wf(if-m,juf,kf+l-1) +
     &                 wf(if-m-1,juf,kf+l) - wf(if-m-1,juf,kf+l-1) +
     &                 wf(if+m,juf,kf+l) - wf(if+m,juf,kf+l-1) +
     &                 wf(if+m-1,juf,kf+l) - wf(if+m-1,juf,kf+l-1)))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do if = ir*cregl0, ir*cregh0, ir
            src(if,jf,kf) = src(if,jf,kf) / center
         end do
      else if (ivect(1) .eq. 0) then
         do jf = jr*cregl1, jr*cregh1, jr
            src(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac1 = 1.0D0 / jr
         ffac = jr
         cfac = r3
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) .eq. 1) then
                  kuf = kf + ki - 1
                  iuf = if + ii - 1
                  center = center + ffac
                  do n = 0, jr-1
                     fac = (jr-n) * fac1
                     if (n .eq. 0) fac = 0.5D0 * fac
                     do jf = jr*cregl1, jr*cregh1, jr
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                 (hxm1 * idir *
     &                    (uf(iuf,jf-n,kuf) + uf(iuf,jf-n-1,kuf) +
     &                     uf(iuf,jf+n,kuf) + uf(iuf,jf+n-1,kuf)) +
     &                                  hym1 *
     &                    (vf(iuf,jf-n,kuf) - vf(iuf,jf-n-1,kuf) +
     &                     vf(iuf,jf+n,kuf) - vf(iuf,jf+n-1,kuf)) +
     &                                  hzm1 * kdir *
     &                    (wf(iuf,jf-n,kuf) + wf(iuf,jf-n-1,kuf) +
     &                     wf(iuf,jf+n,kuf) + wf(iuf,jf+n-1,kuf)))
                     end do
                  end do
               else
                  kuc = kc + ki - 1
                  iuc = ic + ii - 1
                  center = center + cfac
                  do jc = cregl1, cregh1
                     jf = jc * jr
                     src(if,jf,kf) = src(if,jf,kf) + r3 *
     &            (hxm1c * idir * (uc(iuc,jc,kuc) + uc(iuc,jc-1,kuc)) +
     &             hym1c *        (vc(iuc,jc,kuc) - vc(iuc,jc-1,kuc)) +
     &             hzm1c * kdir * (wc(iuc,jc,kuc) + wc(iuc,jc-1,kuc)))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) - ga(ii,0,1-ki) .eq. 1) then
                  kuf = kf + ki - 1
                  fac0 = 1.0D0 / (ir * jr)
                  ffac = jr * (ir - 1)
                  center = center + ffac
                  do n = 0, jr-1
                     fac1 = (jr-n) * fac0
                     if (n .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do jf = jr*cregl1, jr*cregh1, jr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (hxm1 *
     &                (uf(if+m,jf-n,kuf) - uf(if+m-1,jf-n,kuf) +
     &                 uf(if+m,jf-n-1,kuf) - uf(if+m-1,jf-n-1,kuf) +
     &                 uf(if+m,jf+n,kuf) - uf(if+m-1,jf+n,kuf) +
     &                 uf(if+m,jf+n-1,kuf) - uf(if+m-1,jf+n-1,kuf)) +
     &                                        hym1 *
     &                (vf(if+m,jf-n,kuf) - vf(if+m,jf-n-1,kuf) +
     &                 vf(if+m-1,jf-n,kuf) - vf(if+m-1,jf-n-1,kuf) +
     &                 vf(if+m,jf+n,kuf) - vf(if+m,jf+n-1,kuf) +
     &                 vf(if+m-1,jf+n,kuf) - vf(if+m-1,jf+n-1,kuf)) +
     &                                        hzm1 * kdir *
     &                (wf(if+m,jf-n,kuf) + wf(if+m,jf-n-1,kuf) +
     &                 wf(if+m-1,jf-n,kuf) + wf(if+m-1,jf-n-1,kuf) +
     &                 wf(if+m,jf+n,kuf) + wf(if+m,jf+n-1,kuf) +
     &                 wf(if+m-1,jf+n,kuf) + wf(if+m-1,jf+n-1,kuf)))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,0,ki) - ga(1-ii,0,ki) .eq. 1) then
                  iuf = if + ii - 1
                  fac0 = 1.0D0 / (jr * kr)
                  ffac = jr * (kr - 1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = 0, jr-1
                        fac = (jr-n) * fac1
                        if (n .eq. 0) fac = 0.5D0 * fac
                        do jf = jr*cregl1, jr*cregh1, jr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (hxm1 * idir *
     &                (uf(iuf,jf-n,kf+l) + uf(iuf,jf-n-1,kf+l) +
     &                 uf(iuf,jf-n,kf+l-1) + uf(iuf,jf-n-1,kf+l-1) +
     &                 uf(iuf,jf+n,kf+l) + uf(iuf,jf+n-1,kf+l) +
     &                 uf(iuf,jf+n,kf+l-1) + uf(iuf,jf+n-1,kf+l-1)) +
     &                                        hym1 *
     &                (vf(iuf,jf-n,kf+l) - vf(iuf,jf-n-1,kf+l) +
     &                 vf(iuf,jf-n,kf+l-1) - vf(iuf,jf-n-1,kf+l-1) +
     &                 vf(iuf,jf+n,kf+l) - vf(iuf,jf+n-1,kf+l) +
     &                 vf(iuf,jf+n,kf+l-1) - vf(iuf,jf+n-1,kf+l-1)) +
     &                                        hzm1 *
     &                (wf(iuf,jf-n,kf+l) - wf(iuf,jf-n,kf+l-1) +
     &                 wf(iuf,jf-n-1,kf+l) - wf(iuf,jf-n-1,kf+l-1) +
     &                 wf(iuf,jf+n,kf+l) - wf(iuf,jf+n,kf+l-1) +
     &                 wf(iuf,jf+n-1,kf+l) - wf(iuf,jf+n-1,kf+l-1)))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do jf = jr*cregl1, jr*cregh1, jr
            src(if,jf,kf) = src(if,jf,kf) / center
         end do
      else
         do kf = kr*cregl2, kr*cregh2, kr
            src(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac1 = 1.0D0 / kr
         ffac = kr
         cfac = r3
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) .eq. 1) then
                  juf = jf + ji - 1
                  iuf = if + ii - 1
                  center = center + ffac
                  do l = 0, kr-1
                     fac = (kr-l) * fac1
                     if (l .eq. 0) fac = 0.5D0 * fac
                     do kf = kr*cregl2, kr*cregh2, kr
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                 (hxm1 * idir *
     &                    (uf(iuf,juf,kf-l) + uf(iuf,juf,kf-l-1) +
     &                     uf(iuf,juf,kf+l) + uf(iuf,juf,kf+l-1)) +
     &                                  hym1 * jdir *
     &                    (vf(iuf,juf,kf-l) + vf(iuf,juf,kf-l-1) +
     &                     vf(iuf,juf,kf+l) + vf(iuf,juf,kf+l-1)) +
     &                                  hzm1 *
     &                    (wf(iuf,juf,kf-l) - wf(iuf,juf,kf-l-1) +
     &                     wf(iuf,juf,kf+l) - wf(iuf,juf,kf+l-1)))
                     end do
                  end do
               else
                  juc = jc + ji - 1
                  iuc = ic + ii - 1
                  center = center + cfac
                  do kc = cregl2, cregh2
                     kf = kc * kr
                     src(if,jf,kf) = src(if,jf,kf) + r3 *
     &             (hxm1c * idir * (uc(iuc,juc,kc) + uc(iuc,juc,kc-1)) +
     &              hym1c * jdir * (vc(iuc,juc,kc) + vc(iuc,juc,kc-1)) +
     &              hzm1c *        (wc(iuc,juc,kc) - wc(iuc,juc,kc-1)))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) - ga(ii,1-ji,0) .eq. 1) then
                  juf = jf + ji - 1
                  fac0 = 1.0D0 / (ir * kr)
                  ffac = kr * (ir - 1)
                  center = center + ffac
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do kf = kr*cregl2, kr*cregh2, kr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (hxm1 *
     &                (uf(if+m,juf,kf-l) - uf(if+m-1,juf,kf-l) +
     &                 uf(if+m,juf,kf-l-1) - uf(if+m-1,juf,kf-l-1) +
     &                 uf(if+m,juf,kf+l) - uf(if+m-1,juf,kf+l) +
     &                 uf(if+m,juf,kf+l-1) - uf(if+m-1,juf,kf+l-1)) +
     &                                        hym1 * jdir *
     &                (vf(if+m,juf,kf-l) + vf(if+m,juf,kf-l-1) +
     &                 vf(if+m-1,juf,kf-l) + vf(if+m-1,juf,kf-l-1) +
     &                 vf(if+m,juf,kf+l) + vf(if+m,juf,kf+l-1) +
     &                 vf(if+m-1,juf,kf+l) + vf(if+m-1,juf,kf+l-1)) +
     &                                        hzm1 *
     &                (wf(if+m,juf,kf-l) - wf(if+m,juf,kf-l-1) +
     &                 wf(if+m-1,juf,kf-l) - wf(if+m-1,juf,kf-l-1) +
     &                 wf(if+m,juf,kf+l) - wf(if+m,juf,kf+l-1) +
     &                 wf(if+m-1,juf,kf+l) - wf(if+m-1,juf,kf+l-1)))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,ji,0) - ga(1-ii,ji,0) .eq. 1) then
                  iuf = if + ii - 1
                  fac0 = 1.0D0 / (jr * kr)
                  ffac = kr * (jr - 1)
                  center = center + ffac
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        do kf = kr*cregl2, kr*cregh2, kr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                                       (hxm1 * idir *
     &                (uf(iuf,jf+n,kf-l) + uf(iuf,jf+n-1,kf-l) +
     &                 uf(iuf,jf+n,kf-l-1) + uf(iuf,jf+n-1,kf-l-1) +
     &                 uf(iuf,jf+n,kf+l) + uf(iuf,jf+n-1,kf+l) +
     &                 uf(iuf,jf+n,kf+l-1) + uf(iuf,jf+n-1,kf+l-1)) +
     &                                        hym1 *
     &                (vf(iuf,jf+n,kf-l) - vf(iuf,jf+n-1,kf-l) +
     &                 vf(iuf,jf+n,kf-l-1) - vf(iuf,jf+n-1,kf-l-1) +
     &                 vf(iuf,jf+n,kf+l) - vf(iuf,jf+n-1,kf+l) +
     &                 vf(iuf,jf+n,kf+l-1) - vf(iuf,jf+n-1,kf+l-1)) +
     &                                        hzm1 *
     &                (wf(iuf,jf+n,kf-l) - wf(iuf,jf+n,kf-l-1) +
     &                 wf(iuf,jf+n-1,kf-l) - wf(iuf,jf+n-1,kf-l-1) +
     &                 wf(iuf,jf+n,kf+l) - wf(iuf,jf+n,kf+l-1) +
     &                 wf(iuf,jf+n-1,kf+l) - wf(iuf,jf+n-1,kf+l-1)))
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do kf = kr*cregl2, kr*cregh2, kr
            src(if,jf,kf) = src(if,jf,kf) / center
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcdiv(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & uc, vc, wc,
     &      cl0,ch0,cl1,ch1,cl2,ch2,
     & uf, vf, wf,
     &      fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & hx, hy, hz, ir, jr, kr, ga, ijnk)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision uc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision vc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision wc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision uf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision vf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision wf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision hx, hy, hz
      integer ir, jr, kr, ga(0:1,0:1,0:1),ijnk(3)
      double precision r3, hxm1, hym1, hzm1, hxm1c, hym1c, hzm1c
      double precision sum, center, cfac, ffac, fac0, fac1, fac
      integer ic, jc, kc, if, jf, kf, iuc, iuf, juc, juf, kuc, kuf
      integer ii, ji, ki, idir, jdir, kdir, l, m, n
      r3 = ir * jr * kr
      hxm1c = 1.0D0 / (ir * hx)
      hym1c = 1.0D0 / (jr * hy)
      hzm1c = 1.0D0 / (kr * hz)
      hxm1 = ir * hxm1c
      hym1 = jr * hym1c
      hzm1 = kr * hzm1c
      ic = cregl0
      jc = cregl1
      kc = cregl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      sum = 0.0D0
      center = 0.0D0
c octants
      fac = 1.0D0
      ffac = 0.5D0
      cfac = 0.5D0 * r3
      do ki = 0, 1
         kdir = 2 * ki - 1
         kuf = kf + ki - 1
         kuc = kc + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            juf = jf + ji - 1
            juc = jc + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) .eq. 1) then
                  iuf = if + ii - 1
                  center = center + ffac
                  sum = sum + fac *
     &              (hxm1 * idir * uf(iuf,juf,kuf) +
     &               hym1 * jdir * vf(iuf,juf,kuf) +
     &               hzm1 * kdir * wf(iuf,juf,kuf))
               else
                  iuc = ic + ii - 1
                  center = center + cfac
                  sum = sum + r3 *
     &              (hxm1c * idir * uc(iuc,juc,kuc) +
     &               hym1c * jdir * vc(iuc,juc,kuc) +
     &               hzm1c * kdir * wc(iuc,juc,kuc))
               end if
            end do
         end do
      end do
c faces
      do ki = 0, 1
         kdir = 2 * ki - 1
         kuf = kf + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            juf = jf + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               iuf = if + ii - 1
               if (ga(ii,ji,ki) - ga(ii,ji,1-ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * jr)
                  ffac = 0.5D0 * (ir-1) * (jr-1)
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac * (hxm1 *
     &               (uf(if+m,jf+n,kuf) - uf(if+m-1,jf+n,kuf) +
     &                uf(if+m,jf+n-1,kuf) - uf(if+m-1,jf+n-1,kuf)) +
     &                                     hym1 *
     &               (vf(if+m,jf+n,kuf) - vf(if+m,jf+n-1,kuf) +
     &                vf(if+m-1,jf+n,kuf) - vf(if+m-1,jf+n-1,kuf)) +
     &                                     hzm1 * kdir *
     &               (wf(if+m,jf+n,kuf) + wf(if+m,jf+n-1,kuf) +
     &                wf(if+m-1,jf+n,kuf) + wf(if+m-1,jf+n-1,kuf)))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(ii,1-ji,ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * kr)
                  ffac = 0.5D0 * (ir-1) * (kr-1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac * (hxm1 *
     &               (uf(if+m,juf,kf+l) - uf(if+m-1,juf,kf+l) +
     &                uf(if+m,juf,kf+l-1) - uf(if+m-1,juf,kf+l-1)) +
     &                                     hym1 * jdir *
     &               (vf(if+m,juf,kf+l) + vf(if+m,juf,kf+l-1) +
     &                vf(if+m-1,juf,kf+l) + vf(if+m-1,juf,kf+l-1)) +
     &                                     hzm1 *
     &               (wf(if+m,juf,kf+l) - wf(if+m,juf,kf+l-1) +
     &                wf(if+m-1,juf,kf+l) - wf(if+m-1,juf,kf+l-1)))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(1-ii,ji,ki) .eq. 1) then
                  fac0 = 1.0D0 / (jr * kr)
                  ffac = 0.5D0 * (jr-1) * (kr-1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        sum = sum + fac * (hxm1 * idir *
     &               (uf(iuf,jf+n,kf+l) + uf(iuf,jf+n,kf+l-1) +
     &                uf(iuf,jf+n-1,kf+l) + uf(iuf,jf+n-1,kf+l-1)) +
     &                                     hym1 *
     &               (vf(iuf,jf+n,kf+l) - vf(iuf,jf+n-1,kf+l) +
     &                vf(iuf,jf+n,kf+l-1) - vf(iuf,jf+n-1,kf+l-1)) +
     &                                     hzm1 *
     &               (wf(iuf,jf+n,kf+l) - wf(iuf,jf+n,kf+l-1) +
     &                wf(iuf,jf+n-1,kf+l) - wf(iuf,jf+n-1,kf+l-1)))
                     end do
                  end do
               end if
            end do
         end do
      end do
c edges
      do ki = 0, 1
         kdir = 2 * ki - 1
         kuf = kf + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            juf = jf + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               iuf = if + ii - 1
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(ii,1-ji,ki), ga(ii,1-ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / ir
                  ffac = 0.5D0 * (ir-1)
                  center = center + ffac
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     sum = sum + fac * (hxm1 *
     &                 (uf(if+m,juf,kuf) - uf(if+m-1,juf,kuf)) +
     &                                  hym1 * jdir *
     &                 (vf(if+m,juf,kuf) + vf(if+m-1,juf,kuf)) +
     &                                  hzm1 * kdir *
     &                 (wf(if+m,juf,kuf) + wf(if+m-1,juf,kuf)))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(1-ii,ji,ki), ga(1-ii,ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / jr
                  ffac = 0.5D0 * (jr-1)
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     sum = sum + fac * (hxm1 * idir *
     &                 (uf(iuf,jf+n,kuf) + uf(iuf,jf+n-1,kuf)) +
     &                                  hym1 *
     &                 (vf(iuf,jf+n,kuf) - vf(iuf,jf+n-1,kuf)) +
     &                                  hzm1 * kdir *
     &                 (wf(iuf,jf+n,kuf) + wf(iuf,jf+n-1,kuf)))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,1-ji,ki), ga(1-ii,ji,ki), ga(1-ii,1-ji,ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / kr
                  ffac = 0.5D0 * (kr-1)
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac = (kr-abs(l)) * fac1
                     sum = sum + fac * (hxm1 * idir *
     &                 (uf(iuf,juf,kf+l) + uf(iuf,juf,kf+l-1)) +
     &                                  hym1 * jdir *
     &                 (vf(iuf,juf,kf+l) + vf(iuf,juf,kf+l-1)) +
     &                                  hzm1 *
     &                 (wf(iuf,juf,kf+l) - wf(iuf,juf,kf+l-1)))
                  end do
               end if
            end do
         end do
      end do
c weighting
      src(if,jf,kf) = sum / center
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "ArrayLim.H"
#include "CONSTANTS.H"
      
#define SDIM 3

      subroutine HACKD(d,DIMS(d),dx,domnlo)
      implicit none
      integer DIMDEC(d)
      REAL_T d(DIMV(d))
      REAL_T dx(SDIM), domnlo(SDIM)
      integer i,j,k
      REAL_T x,y,z,r

      do k=ARG_L3(d),ARG_H3(d)
         z = (float(k)+0.5d0)*dx(3) + domnlo(3)
         do j=ARG_L2(d),ARG_H2(d)
            y = (float(j)+0.5d0)*dx(2) + domnlo(2)
            do i=ARG_L1(d),ARG_H1(d)
               x = (float(i)+0.5d0)*dx(1) + domnlo(1)
               
               r = dsqrt(x**2 + y**2 + z**2)

#if 0
               if (r.gt.0.03) then
                  d(i,j,k) = 5000.d0
               else
                  d(i,j,k) = 0.d0
                  cnt = cnt + 1
               endif
#elif 1
               if (x.gt.-.059999) then
                  d(i,j,k) = 5000.d0
               else
                  d(i,j,k) = 0.d0
               endif
#else
               r = dsqrt(x**2 + y**2 + (z-.06d0)**2)
               if (r.gt.0.015d0) then
                  d(i,j,k) = 5000.d0
               else
                  d(i,j,k) = 0.d0
               endif
#endif

            enddo
         enddo
      enddo
      end


      subroutine BILIN(c,DIMS(c), f, DIMS(f),r)
      implicit none
      integer r
      integer DIMDEC(c)
      integer DIMDEC(f)
      REAL_T c(DIMV(c))
      REAL_T f(DIMV(f))
      integer i,j,k,ii,jj,kk
      REAL_T x,y,z

      do k=ARG_L3(c),ARG_H3(c)
         do j=ARG_L2(c),ARG_H2(c)
            do i=ARG_L1(c),ARG_H1(c)
               do ii=0,r-1
                  do jj=0,r-1
                     do kk=0,r-1
                        f(r*i+ii,r*j+jj,r*k+kk) = c(i,j,k)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo

      do k=ARG_L3(c),ARG_H3(c)-1
         do j=ARG_L2(c),ARG_H2(c)-1
            do i=ARG_L1(c),ARG_H1(c)-1
               do ii=1,r
                  do jj=1,r
                     do kk=1,r
                        x = (float(ii)-0.5d0)/(float(r))
                        y = (float(jj)-0.5d0)/(float(r))
                        z = (float(kk)-0.5d0)/(float(r))
                        f(r*i+ii,r*j+jj,r*k+kk) =
     &                       c(i,j,k)*(1.d0-x)*(1.d0-y)*(1.d0-z) +
     &                       c(i+1,j,k)*x*(1.d0-y)*(1.d0-z) +
     &                       c(i,j+1,k)*(1.d0-x)*y*(1.d0-z) +
     &                       c(i+1,j+1,k)*x*y*(1.d0-z) +
     &                       c(i,j,k+1)*(1.d0-x)*(1.d0-y)*z +
     &                       c(i+1,j,k+1)*x*(1.d0-y)*z +
     &                       c(i,j+1,k+1)*(1.d0-x)*y*z +
     &                       c(i+1,j+1,k+1)*x*y*z
                     enddo
                  enddo
               enddo               
            enddo
         enddo
      enddo
            
      end

      subroutine PROCESS(lo, hi, domlo, tf, DIMS(tf), T, DIMS(T),
     &     listi, listj, listk, listlen, delta, area, sVal, imeth)
      implicit none
      integer lo(SDIM), hi(SDIM), domlo(SDIM)
      integer DIMDEC(T)
      integer DIMDEC(tf)
      REAL_T T(DIMV(T))
      integer tf(DIMV(tf))
      integer listi(*)
      integer listj(*)
      integer listk(*)
      integer listlen
      REAL_T delta(SDIM)
      REAL_T area, sVal
      integer imeth

      integer i,j,k,n,klo,ierr
      REAL_T Tb(2,2,2),myArea
      logical isOne, isZero

      klo = MAX(lo(3) - 1,domlo(3))

      do k=klo,hi(3)
         do j=lo(2)-1,hi(2)
            do i=lo(1)-1,hi(1)
               if (T(i,j,k).LE.sVal) then
                  tf(i,j,k) = 0
               else
                  tf(i,j,k) = 1
               end if
            end do
         end do
      end do

      listlen = 0
      do k=klo,hi(3)-1
         do j=lo(2)-1,hi(2)-1
            do i=lo(1)-1,hi(1)-1

               isOne =  (tf(i+1,j,k).eq.1)
     &              .or.(tf(i,j+1,k).eq.1)
     &              .or.(tf(i,j,k+1).eq.1)

               isZero = (tf(i+1,j,k).eq.0)
     &              .or.(tf(i,j+1,k).eq.0)
     &              .or.(tf(i,j,k+1).eq.0)

               if ( ((tf(i,j,k).eq.0).and.isOne).or.
     &              ((tf(i,j,k).eq.1).and.isZero)) then

                  listlen = listlen + 1
                  listi(listlen) = i
                  listj(listlen) = j
                  listk(listlen) = k
               end if
            end do
         end do
      end do

      area = zero
      do n=1,listlen
         i = listi(n)
         j = listj(n)
         k = listk(n)
         Tb(1,1,1) = T(  i,  j,  k)
         Tb(2,1,1) = T(i+1,  j,  k)
         Tb(1,2,1) = T(  i,j+1,  k)
         Tb(2,2,1) = T(i+1,j+1,  k)
         Tb(1,1,2) = T(  i,  j,k+1)
         Tb(2,1,2) = T(i+1,  j,k+1)
         Tb(1,2,2) = T(  i,j+1,k+1)
         Tb(2,2,2) = T(i+1,j+1,k+1)
         if (imeth.eq.1) then
            ierr = 0
            call jarea(Tb,sVal,delta,myArea,ierr)
            if (ierr.ne.0) then
               print *,'something bad happened'
               exit
            endif
         else
            call temparea(Tb,sVal,delta,myArea)
         endif
         area = area + myArea
      end do

      end


      subroutine jarea (c, c0, h, value, code)

c     input:
c
c     c   is the (2x2x2) array of corner values
c     c0  is the desired level set
c     h   is the (3) array of grid spacings
c
c     output:
c     value  is the area (0 when an error occurs)
c     code   is the integer output code (0 means no error)

      implicit none

      integer edges
      integer faces
      integer nodes

      parameter (edges = 12)
      parameter (faces = 6)
      parameter (nodes = 8)

      double precision c0
      double precision c(2, 2, 2)
      double precision coordinate(nodes, 3)
      double precision ex
      double precision h(3)
      double precision point(edges, 3)
      double precision temp
      double precision v(nodes)
      double precision v1
      double precision v2
      double precision value
      double precision x0
      double precision x1
      double precision x2
      double precision y0
      double precision y1
      double precision y2
      double precision z0
      double precision z1
      double precision z2

      integer code
      integer count
      integer currentedge
      integer currentface
      integer cutedges
      integer edge
      integer edge2corner(edges, 2)
      integer edge2face(edges, 2)
      integer edgelist(edges)
      integer face2edge(faces, 4)
      integer i
      integer j
      integer k
      integer n
      integer n1
      integer n2
      integer nextedge
      integer nextface
      integer p
      integer points
      integer start

      logical cut(edges)

      data ((edge2corner(i, j), j = 1, 2), i = 1, edges) /
     1     5, 6,
     2     5, 7,
     3     8, 7,
     4     6, 8,
     5     2, 4,
     6     3, 4,
     7     1, 3,
     8     1, 2,
     9     2, 6,
     X     1, 5,
     1     3, 7,
     2     4, 8 /

      data ((edge2face(i, j), j = 1, 2), i = 1, edges) /
     1     4, 6,
     2     1, 4,
     3     4, 5,
     4     3, 4,
     5     2, 3,
     6     2, 5,
     7     1, 2,
     8     2, 6,
     9     3, 6,
     X     1, 6,
     1     1, 5,
     2     3, 5 /

      data ((face2edge(i, j), j = 1, 4), i = 1, faces) /
     1     2, 11, 7, 10,
     2     7, 6, 5, 8,
     3     4, 9, 5, 12,
     4     1, 4, 3, 2,
     5     3, 12, 6, 11,
     6     1, 10, 8, 9 /

c     initialize output values

      code = 0
      value = 0

c     store node values and coordinates

      n = 0
      do i = 1, 2
         do j = 1, 2
            do k = 1, 2
               n = n + 1
               v(n) = c(i, j, k)
               if (i .eq. 1) then
                  coordinate(n, 1) = 0
               else
                  coordinate(n, 1) = h(1)
               endif
               if (j .eq. 1) then
                  coordinate(n, 2) = 0
               else
                  coordinate(n, 2) = h(2)
               endif
               if (k .eq. 1) then
                  coordinate(n, 3) = 0
               else
                  coordinate(n, 3) = h(3)
               endif
            enddo
         enddo
      enddo

c     mark the cut edges and find the cut points

      start = 0
      do edge = 1, edges
         n1 = edge2corner(edge, 1)
         n2 = edge2corner(edge, 2)
         v1 = v(n1)
         v2 = v(n2)
         cut(edge) =
     &        (v1 .lt. c0 .and. c0 .lt. v2) .or.
     &        (v2 .lt. c0 .and. c0 .lt. v1)

         if (cut(edge)) then
            start = edge
            do p = 1, 3
               point(edge, p) =
     &              coordinate(n1, p) * abs ((v1 - c0) / (v1 - v2)) +
     &              coordinate(n2, p) * abs ((c0 - v2) / (v1 - v2))
            enddo
         endif
      enddo

c     exit if there are no cut edges

      if (start .eq. 0) go to 99999

c     make a list of cut edges by traversing the faces

      cutedges = 1
      edgelist(cutedges) = start
      currentedge = start
      currentface = edge2face(currentedge, 1)

 1100 continue
      count = 0
      nextedge = 0
      do i = 1, 4
         edge = face2edge(currentface, i)
         if (cut(edge) .and. .not. (edge .eq. currentedge)) then
            count = count + 1
            nextedge = edge
         endif
      enddo

      if (count .ne. 1) then
c        some face has other than 0 or 2 cut edges
         code = 1
         go to 99999
      endif

      if (nextedge .ne. edgelist(1)) then
         if (currentface .eq. edge2face(nextedge, 1)) then
            currentface = edge2face(nextedge, 2)
         else
            currentface = edge2face(nextedge, 1)
         endif
         currentedge = nextedge
         cutedges = cutedges + 1
         edgelist(cutedges) = currentedge
         go to 1100
      endif

      count = 0
      do edge = 1, edges
         if (cut(edge)) then
            count = count + 1
         endif
      enddo

      if (count .ne. cutedges) then
c        the traverse omits some cut edges
         code = 2
         go to 99999
      endif

c     sum the triangular areas

      edge = edgelist(1)
      x0 = point(edge, 1)
      y0 = point(edge, 2)
      z0 = point(edge, 3)
      do i = 2, cutedges - 1
         edge = edgelist(i)
         x1 = point(edge, 1) - x0
         y1 = point(edge, 2) - y0
         z1 = point(edge, 3) - z0
         edge = edgelist(i + 1)
         x2 = point(edge, 1) - x0
         y2 = point(edge, 2) - y0
         z2 = point(edge, 3) - z0
         temp = sqrt ( abs (
     &        x2**2*y1**2 - 2*x1*x2*y1*y2 + x1**2*y2**2 +
     &        x2**2*z1**2 + y2**2*z1**2 - 2*x1*x2*z1*z2 -
     &        2*y1*y2*z1*z2 + x1**2*z2**2 + y1**2*z2**2)) / 2
         value = value + temp
      enddo

c     exit

99999 continue
      end

      subroutine temparea(T,Tlev,delta,Area)

      REAL_T T(2,2,2),Tlev
      REAL_T delta(3),Area


      REAL_T axp,axm,ayp,aym,azp,azm

      REAL_T facearea,t11,t12,t21,t22,dx,dy,dz

      dx = delta(1)
      dy = delta(2)
      dz = delta(3)


      t11 = T(1,1,1)
      t21 = T(2,1,1)
      t12 = T(1,2,1)
      t22 = T(2,2,1)

      azm = facearea(t11,t21,t12,t22,dx,dy,Tlev)

      t11 = T(1,1,2)
      t21 = T(2,1,2)
      t12 = T(1,2,2)
      t22 = T(2,2,2)

      azp = facearea(t11,t21,t12,t22,dx,dy,Tlev)

      t11 = T(1,1,1)
      t21 = T(1,2,1)
      t12 = T(1,1,2)
      t22 = T(1,2,2)

      axm = facearea(t11,t21,t12,t22,dy,dz,Tlev)

      t11 = T(2,1,1)
      t21 = T(2,2,1)
      t12 = T(2,1,2)
      t22 = T(2,2,2)

      axp = facearea(t11,t21,t12,t22,dy,dz,Tlev)

      t11 = T(1,1,1)
      t21 = T(2,1,1)
      t12 = T(1,1,2)
      t22 = T(2,1,2)

      aym = facearea(t11,t21,t12,t22,dy,dz,Tlev)

      t11 = T(1,2,1)
      t21 = T(2,2,1)
      t12 = T(1,2,2)
      t22 = T(2,2,2)

      ayp = facearea(t11,t21,t12,t22,dy,dz,Tlev)

      Area = dsqrt((azp-azm)**2+ (ayp-aym)**2 + (axp-axm)**2)

      return
      end

      REAL_T function facearea(t11,t21,t12,t22,
     1           dx,dy,Tlev)

      REAL_T t11,t12,t21,t22,dx,dy,Tlev

      REAL_T lengless,lengmore
      REAL_T edge1,edge2,edge3,edge4

      if(t11.gt.Tlev)then
        if(t21.gt.Tlev)then
          if(t12.gt.Tlev)then
            if(t22.gt.Tlev)then
              facearea = dx*dy
            else
              edge1=lengless(t12,t22,Tlev,dx)
              edge2=lengless(t21,t22,Tlev,dy)
              facearea = dx*dy-edge1*edge2*half
            endif
          else
            if(t22.gt.Tlev)then
              edge1=lengless(t12,t22,Tlev,dx)
              edge2=lengless(t11,t12,Tlev,dy)
              facearea = dx*dy-edge1*edge2*half
            else
              edge1=lengmore(t21,t22,Tlev,dy)
              edge2=lengmore(t11,t12,Tlev,dy)
              facearea = dx*(edge1+edge2)*half
            endif
          endif
        else
          if(t12.gt.Tlev)then
            if(t22.gt.Tlev)then
              edge1=lengless(t11,t21,Tlev,dx)
              edge2=lengless(t21,t22,Tlev,dy)
              facearea = dx*dy-edge1*edge2*half
            else
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t12,t22,Tlev,dx)
              facearea = dy*half*(edge1+edge2)
            endif
          else
            if(t22.gt.Tlev)then
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t21,t22,Tlev,dy)
              edge3=lengmore(t12,t22,Tlev,dx)
              edge4=lengmore(t11,t12,Tlev,dy)
              facearea = half*(edge1*edge4+edge2*edge3)
            else
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t11,t12,Tlev,dy)
              facearea = half*edge1*edge2
            endif
          endif
        endif
      else
        if(t21.gt.Tlev)then
          if(t12.gt.Tlev)then
            if(t22.gt.Tlev)then
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t11,t12,Tlev,dy)
              facearea = dx*dy-half*edge1*edge2
            else
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t21,t22,Tlev,dy)
              edge3=lengmore(t12,t22,Tlev,dx)
              edge4=lengmore(t11,t12,Tlev,dy)
              facearea = dx*dy-half*(edge1*edge4+edge2*edge3)
            endif
          else
            if(t22.gt.Tlev)then
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t12,t22,Tlev,dx)
              facearea = dy*half*(edge1+edge2)
            else
              edge1=lengmore(t11,t21,Tlev,dx)
              edge2=lengmore(t21,t22,Tlev,dy)
              facearea = half*edge1*edge2
            endif
          endif
        else
          if(t12.gt.Tlev)then
            if(t22.gt.Tlev)then
              edge1=lengmore(t21,t22,Tlev,dy)
              edge2=lengmore(t11,t12,Tlev,dy)
              facearea = dx*(edge1+edge2)*half
            else
              edge1=lengmore(t12,t22,Tlev,dx)
              edge2=lengmore(t11,t12,Tlev,dy)
              facearea = half*edge1*edge2
            endif
          else
            if(t22.gt.Tlev)then
              edge1=lengmore(t12,t22,Tlev,dx)
              edge2=lengmore(t21,t22,Tlev,dy)
              facearea = half*edge1*edge2
            else
              facearea = zero
            endif
          endif
        endif
      endif
      
      return
      end

      REAL_T function lengless(t1,t2,Tlev,dx)
      REAL_T t1,t2,Tlev,dx
      if(t1.lt.Tlev)then
           lengless = (TLev -t1)*dx/(t2-t1)
      else
           lengless = (TLev -t2)*dx/(t1-t2)
      endif
      return
      end

      REAL_T function lengmore(t1,t2,Tlev,dx)
      REAL_T  t1,t2,Tlev,dx
      if(t1.lt.Tlev)then
           lengmore = dx -(TLev -t1)*dx/(t2-t1)
      else
           lengmore = dx - (TLev -t2)*dx/(t1-t2)
      endif
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: ARRAYLIM_3D.F,v 1.1 2000/04/21 16:20:21 sstanley Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <ArrayLim.H>

#define SDIM 3

c ::: -----------------------------------------------------------
c ::: This routine sets the values for the lo() and hi() arrays
c ::: from the ARG_L1, ARG_H1, ... macros.  This is done since
c ::: it is more convenient to use the lo() and hi() arrays.
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: DIMS(holder)=> index extent of place holder array
c ::: lo(SDIM)    <= lower index limits
c ::: hi(SDIM)    <= upper index limits
c ::: -----------------------------------------------------------

      subroutine SET_LOHI(DIMS(holder), lo, hi)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer DIMDEC(holder)
      integer lo(SDIM), hi(SDIM)


c
c     --------------------------------------
c     :::: Set Values for lo() and hi() ::::
c     --------------------------------------
c
      lo(1) = ARG_L1(holder)
      hi(1) = ARG_H1(holder)
      lo(2) = ARG_L2(holder)
      hi(2) = ARG_H2(holder)
      lo(3) = ARG_L3(holder)
      hi(3) = ARG_H3(holder)

      return
      end


c ::: -----------------------------------------------------------
c ::: This routine sets the values for the ARG_L1, ARG_H1, ... macros
c ::: from the lo() and hi() arrays.  This is done since
c ::: it is more convenient to use the macros to dimension arrays.
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: FF_DIMS(holder) <=  index extent of place holder array
c ::: lo(SDIM)         => lower index limits
c ::: hi(SDIM)         => upper index limits
c ::: -----------------------------------------------------------

      subroutine SET_ARGS(DIMS(holder), lo, hi)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer DIMDEC(holder)
      integer lo(SDIM), hi(SDIM)

c
c     --------------------------------------
c     :::: Set Values for lo() and hi() ::::
c     --------------------------------------
c
      ARG_L1(holder) = lo(1)
      ARG_H1(holder) = hi(1)
      ARG_L2(holder) = lo(2)
      ARG_H2(holder) = hi(2)
      ARG_L3(holder) = lo(3)
      ARG_H3(holder) = hi(3)

c
c
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "ArrayLim.H"

#define SDIM 3

      subroutine WRITEVEL(u,DIMS(u),lo,hi,psize)
      implicit none
      integer DIMDEC(u)
      integer lo(SDIM), hi(SDIM)
      REAL_T  u(DIMV(u),SDIM)
      REAL_T  psize(SDIM)
      integer i,j,k,n

      open(3,file='Turb',form='formatted') 
      rewind 3
      write(3,*)hi(1)-lo(1)+1,hi(2)-lo(2)+1,hi(3)-lo(3)+1
      write(3,*)psize(1),psize(2),psize(3)
      write(3,*)1,1,1
      do n = 1,SDIM
      do k = lo(3),hi(3)
      do j = lo(2),hi(2)
      do i = lo(1),hi(1)
         write(3,*)u(i,j,k,n)
      enddo
      enddo
      enddo
      enddo

      close(3)
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/


#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>
#include <CONSTANTS.H>
#include <SPECIALIZE_F.H>
#include <ArrayLim.H>

c
c     This function copies floating point numbers from one array to another.
c
      subroutine FORT_FASTCOPY (dest,
     &                          DIMS(dest),
     &                          imin, jmin, imax, jmax,
     &                          src,
     &                          DIMS(src),
     &                          imn,  jmn,  imx,  jmx,
     &                          ncomp)

      implicit none
c
c     Bounds to fill in dest
c
      integer imin, jmin, imax, jmax
      integer DIMDEC(dest)
c
c     Bounds to fill from src
c
      integer imn,  jmn,  imx,  jmx
      integer DIMDEC(src)
      integer ncomp
      
      REAL_T  dest(DIMV(dest),ncomp)
      REAL_T  src(DIMV(src),ncomp)
c
c     Local variables
c
      integer i,j,k,ioff,joff

      ioff=imn-imin
      joff=jmn-jmin

      do k = 1, ncomp
         do j = jmin,jmax
            do i = imin,imax
               dest(i,j,k) = src(i+ioff,j+joff,k)
            end do
         end do
      end do

      end
c
c     This function sets a section of an array to a value.
c
      subroutine FORT_FASTSETVAL (val,lo,hi,dest,DIMS(dest),ncomp)

      implicit none

      integer ncomp
      integer lo(2), hi(2)
      integer DIMDEC(dest)
      REAL_T  val
      REAL_T  dest(DIMV(dest),ncomp)
c
c     Local variables
c 
      integer i,j,k
      integer imin,jmin,imax,jmax

      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)

      do k = 1, ncomp
         do j = jmin,jmax
            do i = imin,imax
               dest(i,j,k) = val
            end do
         end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: SLABSTAT_2D.F,v 1.4 2002/11/27 21:54:19 car Exp $
c
#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"
#include "SLABSTAT_F.H"

#define SDIM 2

c
c ::: -----------------------------------------------------------
c ::: This is a general routine to calculate the running statistics
c ::: required to calculate the Reynolds averaged first four moments
c ::: of the state components passed in.  This is a general routine 
c ::: and will work for any number of state components.  If the state
c ::: is passed in in the order (a, b, c, d), then the running averages
c ::: which are returned are in the order,
c :::   <a>,   <b>,   <c>,   <d>,
c :::   <a^2>, <b^2>, <c^2>, <d^2>,
c :::   <a^3>, <b^3>, <c^3>, <d^3>,
c :::   <a^4>, <b^4>, <c^4>, <d^4>
c :::
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: runStats      <=  Array to contain the running statistics
c ::: DIMS(runStats) => Dimensions of the running statistics array
c ::: nStats         => Number of components in the statistics array
c ::: state          =) Array containing the state data
c ::: DIMS(state)    => Dimensions of the state data array
c ::: nStateComp     => Number of components in the state array
c ::: dt             => Time step
c ::: delta          => Grid spacing
c ::: -----------------------------------------------------------
c
      subroutine FORT_REYNAVG_FIRST4MOMS(state, DIMS(state), nStateComp,
     $                                   runStats, DIMS(runStats), nStats,
     $                                   dt, delta)

      implicit none

c
c     ::::: passed variables
c
      integer nStats, nStateComp
      integer DIMDEC(state)
      integer DIMDEC(runStats)
      REAL_T dt
      REAL_T delta(SDIM)
      REAL_T runStats(DIMV(runStats),nStats)
      REAL_T state(DIMV(state),nStateComp)

c
c     ::::: local variables
c
      integer i, j, n, nghost
      integer loStats(SDIM), hiStats(SDIM)
      integer loState(SDIM), hiState(SDIM)


c
c     ===================================
c     ::: Set the Values of LO and HI :::
c     ===================================
c
      call SET_LOHI(DIMS(runStats), loStats, hiStats)
      call SET_LOHI(DIMS(state), loState, hiState)

#ifndef NDEBUG
      if (nStats .NE. 4*nStateComp) then
        write(*,1000) nStats, nStateComp
 1000   format('Incorrect relationship between nStats and nStateComp in',
     $        /'FORT_REYNAVG_FIRST4MOMS.  Shoud have nStats = 4*nStateComp',
     $        /'   nStats = ', I5, 5x, 'nStateComp = ', I5)
        call bl_error("stop")
      endif

      nghost = 0
      do n = 1, SDIM
        if (loState(n) .GT. loStats(n) - nghost .OR.
     $      hiState(n) .LT. hiStats(n) + nghost) then
          write(*,1010) n, nghost, loStats, hiStats, loState, hiState
 1010     format('Incorrect number of ghost cells in the state date in',
     $          /'FORT_REYNAVG_FIRST4MOMS.',
     $          /'   Direction = ', I2, 5x, 'nghost = ', I2,
     $          /'   loStats = ', SDIM (I2,1x), 5x, 'hiStats = ', SDIM (I2,1x),
     $          /'   loState = ', SDIM (I2,1x), 5x, 'hiState = ', SDIM (I2,1x))
           call bl_error("stop")
        endif
      enddo
#endif


c
c     ====================================
c     ::: Calculate Running Statistics :::
c     ====================================
c
      do n = 1, nStateComp
        do j = loStats(2), hiStats(2)
          do i = loStats(1), hiStats(1)
            runStats(i,j,n) = runStats(i,j,n)            + dt * state(i,j,n)
            runStats(i,j,n+nStateComp) = runStats(i,j,n+nStateComp)
     $                                                   + dt * state(i,j,n)**2
            runStats(i,j,n+2*nStateComp) = runStats(i,j,n+2*nStateComp)
     $                                                   + dt * state(i,j,n)**3
            runStats(i,j,n+3*nStateComp) = runStats(i,j,n+3*nStateComp)
     $                                                   + dt * state(i,j,n)**4
          enddo
        enddo
      enddo

c
c
      return
      end




c
c ::: -----------------------------------------------------------
c ::: This is a general routine to calculate the running statistics
c ::: required to calculate the Favre averaged first four moments
c ::: of the state components passed in.  This is a general routine 
c ::: and will work for any number of state components.  The first state 
c ::: component is assumed to be density, so it is used in the Favre averages.
c ::: If the state is passed in in the order (Rho, a, b, c, d),
c ::: then the running averages which are returned are in the order,
c :::   <Rho>,   <Rho a>,   <Rho b>,   <Rho c>,   <Rho d>,
c :::   <Rho^2>, <Rho a^2>, <Rho b^2>, <Rho c^2>, <Rho d^2>,
c :::   <Rho^3>, <Rho a^3>, <Rho b^3>, <Rho c^3>, <Rho d^3>,
c :::   <Rho^4>, <Rho a^4>, <Rho b^4>, <Rho c^4>, <Rho d^4>
c :::
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: runStats      <=  Array to contain the running statistics
c ::: DIMS(runStats) => Dimensions of the running statistics array
c ::: nStats         => Number of components in the statistics array
c ::: state          =) Array containing the state data
c ::: DIMS(state)    => Dimensions of the state data array
c ::: nStateComp     => Number of components in the state array
c ::: dt             => Time step
c ::: delta          => Grid spacing
c ::: -----------------------------------------------------------
c
      subroutine FORT_FAVREAVG_FIRST4MOMS(state, DIMS(state), nStateComp,
     $                                    runStats, DIMS(runStats), nStats,
     $                                    dt, delta)

      implicit none

c
c     ::::: passed variables
c
      integer nStats, nStateComp
      integer DIMDEC(state)
      integer DIMDEC(runStats)
      REAL_T dt
      REAL_T delta(SDIM)
      REAL_T runStats(DIMV(runStats),nStats)
      REAL_T state(DIMV(state),nStateComp)

c
c     ::::: local variables
c
      integer i, j, n, nghost
      integer loStats(SDIM), hiStats(SDIM)
      integer loState(SDIM), hiState(SDIM)


c
c     ===================================
c     ::: Set the Values of LO and HI :::
c     ===================================
c
      call SET_LOHI(DIMS(runStats), loStats, hiStats)
      call SET_LOHI(DIMS(state), loState, hiState)

#ifndef NDEBUG
      if (nStats .NE. 4*nStateComp) then
        write(*,1000) nStats, nStateComp
 1000   format('Incorrect relationship between nStats and nStateComp in',
     $        /'FORT_FAVREAVG_FIRST4MOMS.  Shoud have nStats = 4*nStateComp',
     $        /'   nStats = ', I5, 5x, 'nStateComp = ', I5)
        call bl_error("stop")
      endif

      nghost = 0
      do n = 1, SDIM
        if (loState(n) .GT. loStats(n) - nghost .OR.
     $      hiState(n) .LT. hiStats(n) + nghost) then
          write(*,1010) n, nghost, loStats, hiStats, loState, hiState
 1010     format('Incorrect number of ghost cells in the state date in',
     $          /'FORT_FAVREAVG_FIRST4MOMS.',
     $          /'   Direction = ', I2, 5x, 'nghost = ', I2,
     $          /'   loStats = ', SDIM (I2,1x), 5x, 'hiStats = ', SDIM (I2,1x),
     $          /'   loState = ', SDIM (I2,1x), 5x, 'hiState = ', SDIM (I2,1x))
          call bl_error("stop")
        endif
      enddo
#endif


c
c     ====================================
c     ::: Calculate Running Statistics :::
c     ====================================
c
      do j = loStats(2), hiStats(2)
        do i = loStats(1), hiStats(1)
          runStats(i,j,1) = runStats(i,j,1)              + dt * state(i,j,1)
          runStats(i,j,1+nStateComp) = runStats(i,j,1+nStateComp)
     $                                                   + dt * state(i,j,1)**2
          runStats(i,j,1+2*nStateComp) = runStats(i,j,1+2*nStateComp)
     $                                                   + dt * state(i,j,1)**3
          runStats(i,j,1+3*nStateComp) = runStats(i,j,1+3*nStateComp)
     $                                                   + dt * state(i,j,1)**4
        enddo
      enddo

      do n = 2, nStateComp
        do j = loStats(2), hiStats(2)
          do i = loStats(1), hiStats(1)
            runStats(i,j,n) = runStats(i,j,n)
     $                                  + dt * (state(i,j,1) * state(i,j,n))
            runStats(i,j,n+nStateComp) = runStats(i,j,n+nStateComp)
     $                                  + dt * (state(i,j,1) * state(i,j,n))**2
            runStats(i,j,n+2*nStateComp) = runStats(i,j,n+2*nStateComp)
     $                                  + dt * (state(i,j,1) * state(i,j,n))**3
            runStats(i,j,n+3*nStateComp) = runStats(i,j,n+3*nStateComp)
     $                                  + dt * (state(i,j,1) * state(i,j,n))**4
          enddo
        enddo
      enddo

c
c
      return
      end

(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     40789,       1347]*)
(*NotebookOutlinePosition[     41639,       1377]*)
(*  CellTagsIndexPosition[     41595,       1373]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData["definition of tau"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(tauxxdef = 
      tauxx[i_ + half, j_] \[Rule] 2\ mu[i + half, j]\ dudx[i + half, j]\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(tauxx[half + i_, j_] \[Rule] 2\ dudx[half + i, j]\ mu[half + i, j]\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tauyydef = 
      tauyy[i_, j_ + half] \[Rule] 2\ mu[i, j + half]\ dvdy[i, j + half]\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(tauyy[i_, half + j_] \[Rule] 2\ dvdy[i, half + j]\ mu[i, half + j]\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tauxydef = 
      tauxy[i_, j_] \[Rule] mu[i, j]\ \((dudy[i, j] + dvdx[i, j])\)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauxydef\)\" is similar \
to existing symbols \!\({tauxxdef, tauyydef}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauxy\)\" is similar to \
existing symbols \!\({tauxx, tauyy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudy\)\" is similar to \
existing symbols \!\({dudx, dvdy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(tauxy[i_, j_] \[Rule] \((dudy[i, j] + dvdx[i, j])\)\ mu[i, j]\)], 
  "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions of derivatives"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dudydef1 = 
      dudy[i_, j_ + half] \[Rule] \(u[i, j + 1] - u[i, j]\)\/hy\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dudy[i_, half + j_] \[Rule] \(\(-u[i, j]\) + u[i, 1 + j]\)\/hy\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dvdxdef1 = 
      dvdx[i_ + half, j_] \[Rule] \(v[i + 1, j] - v[i, j]\)\/hx\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dvdx[half + i_, j_] \[Rule] \(\(-v[i, j]\) + v[1 + i, j]\)\/hx\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dudydef2 = 
      dudy[i_ + half, j_] \[Rule] 
        \(u[i, j + 1] - u[i, j - 1] + u[i + 1, j + 1] - u[i + 1, j - 1]\)\/\(4
            \ hy\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dudy[half + i_, j_] \[Rule] 
      \(\(-u[i, \(-1\) + j]\) + u[i, 1 + j] - u[1 + i, \(-1\) + j] + 
          u[1 + i, 1 + j]\)\/\(4\ hy\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dvdxdef2 = 
      dvdx[i_, j_ + half] \[Rule] 
        \(v[i + 1, j + 1] - v[i - 1, j + 1] + v[i + 1, j] - v[i - 1, j]\)\/\(4
            \ hx\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dvdx[i_, half + j_] \[Rule] 
      \(\(-v[\(-1\) + i, j]\) - v[\(-1\) + i, 1 + j] + v[1 + i, j] + 
          v[1 + i, 1 + j]\)\/\(4\ hx\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dudxdef = dudx[i_ + half, j_] \[Rule] \(u[i + 1, j] - u[i, j]\)\/hx\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dudx[half + i_, j_] \[Rule] \(\(-u[i, j]\) + u[1 + i, j]\)\/hx\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dvdydef = dvdy[i_, j_ + half] \[Rule] \(v[i, j + 1] - v[i, j]\)\/hy\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dvdy[i_, half + j_] \[Rule] \(\(-v[i, j]\) + v[i, 1 + j]\)\/hy\)], 
  "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions used to test taylor expansions"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(taylorudef = 
      u[i_, j_] \[Rule] 
        U[x0, y0] + DuDx[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\) + 
          DuDy[x0, y0]\ \((\((j + 1\/2)\)\ hy - y0)\) + 
          1\/2\ D2uDy2[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\)\^2 + 
          1\/2\ D2uDx2[x0, y0]\ \((\((j + 1\/2)\)\ hy - y0)\)\^2 + 
          D2uDxDy[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\)\ 
            \((\((j + 1\/2)\)\ hy - y0)\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DuDy\)\" is similar to \
existing symbol \"\!\(DuDx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2uDx2\)\" is similar \
to existing symbol \"\!\(D2uDy2\)\"."\)], "Message"],

Cell[BoxData[
    \(u[i_, j_] \[Rule] 
      1\/2\ \((hy\ \((1\/2 + j)\) - y0)\)\^2\ D2uDx2[x0, y0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hy\ \((1\/2 + j)\) - y0)\)\ 
          D2uDxDy[x0, y0] + 
        1\/2\ \((hx\ \((1\/2 + i)\) - x0)\)\^2\ D2uDy2[x0, y0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ DuDx[x0, y0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DuDy[x0, y0] + U[x0, y0]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = dudy[i + half, j] //. {dudydef1, dudydef2, taylorudef}; \)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx, y0 \[Rule] hy\/2}\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx, hy\/2]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = dudy[i, j + half] //. {dudydef1, dudydef2, taylorudef}; \)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx\/2, y0 \[Rule] hy}\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = dudx[i + half, j] //. {dudxdef, taylorudef}; \)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx, y0 \[Rule] hy\/2}\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx, hy\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(taylorvdef = 
      v[i_, j_] \[Rule] 
        V[x0, y0] + DvDx[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\) + 
          DvDy[x0, y0]\ \((\((j + 1\/2)\)\ hy - y0)\) + 
          1\/2\ D2vDy2[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\)\^2 + 
          1\/2\ D2vDx2[x0, y0]\ \((\((j + 1\/2)\)\ hy - y0)\)\^2 + 
          D2vDxDy[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\)\ 
            \((\((j + 1\/2)\)\ hy - y0)\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(taylorvdef\)\" is \
similar to existing symbol \"\!\(taylorudef\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DvDx\)\" is similar to \
existing symbol \"\!\(DuDx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DvDy\)\" is similar to \
existing symbols \!\({DuDy, DvDx}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2vDy2\)\" is similar \
to existing symbol \"\!\(D2uDy2\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell1\"\) will be suppressed \
during this calculation."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2vDx2\)\" is similar \
to existing symbols \!\({D2uDx2, D2vDy2}\)."\)], "Message"],

Cell[BoxData[
    \(v[i_, j_] \[Rule] 
      1\/2\ \((hy\ \((1\/2 + j)\) - y0)\)\^2\ D2vDx2[x0, y0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hy\ \((1\/2 + j)\) - y0)\)\ 
          D2vDxDy[x0, y0] + 
        1\/2\ \((hx\ \((1\/2 + i)\) - x0)\)\^2\ D2vDy2[x0, y0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ DvDx[x0, y0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DvDy[x0, y0] + V[x0, y0]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = dvdy[i, j + half] //. {dvdydef, taylorvdef}; \)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx\/2, y0 \[Rule] hy}\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DvDy[hx\/2, hy]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = dvdx[i, j + half] //. {dvdxdef1, dvdxdef2, taylorvdef}; \)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx\/2, y0 \[Rule] hy}\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DvDx[hx\/2, hy]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = dvdx[i + half, j] //. {dvdxdef1, dvdxdef2, taylorvdef}; \)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx, y0 \[Rule] hy\/2}\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DvDx[hx, hy\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(taylormudef = 
      mu[i_, j_] \[Rule] 
        MU[x0, y0] + DmuDx[x0, y0]\ \((\((i + 1\/2)\)\ hx - x0)\) + 
          DmuDy[x0, y0]\ \((\((j + 1\/2)\)\ hy - y0)\)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(taylormudef\)\" is \
similar to existing symbol \"\!\(taylorudef\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DmuDx\)\" is similar to \
existing symbol \"\!\(DuDx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DmuDy\)\" is similar to \
existing symbols \!\({DmuDx, DuDy}\)."\)], "Message"],

Cell[BoxData[
    \(mu[i_, j_] \[Rule] 
      \((hx\ \((1\/2 + i)\) - x0)\)\ DmuDx[x0, y0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DmuDy[x0, y0] + MU[x0, y0]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["tests"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(dog = 
      tauxx[i + half, j] //. {tauxxdef, dudxdef, taylormudef, taylorudef}; 
    \)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog //. {half \[Rule] 1\/2, i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx, 
        y0 \[Rule] hy\/2}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(2\ DuDx[hx, hy\/2]\ MU[hx, hy\/2]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = 
      tauyy[i, j + half] //. {tauyydef, dvdydef, taylormudef, taylorvdef}; 
    \)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog //. {half \[Rule] 1\/2, i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx\/2, 
        y0 \[Rule] hy}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(2\ DvDy[hx\/2, hy]\ MU[hx\/2, hy]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = 
      tauxy[i, j + half] //. {tauxydef, dudydef1, dudydef2, dvdxdef1, 
          dvdxdef2, taylormudef, taylorudef, taylorvdef}; \)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog //. {half \[Rule] 1\/2, i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx\/2, 
        y0 \[Rule] hy}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DuDy[hx\/2, hy] + DvDx[hx\/2, hy])\)\ MU[hx\/2, hy]\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(dog = 
      tauxy[i + half, j] //. {tauxydef, dudydef1, dudydef2, dvdxdef1, 
          dvdxdef2, taylormudef, taylorudef, taylorvdef}; \)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog //. {half \[Rule] 1\/2, i \[Rule] 0, j \[Rule] 0, x0 \[Rule] hx, 
        y0 \[Rule] hy\/2}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DuDy[hx, hy\/2] + DvDx[hx, hy\/2])\)\ MU[hx, hy\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions used for fortran output"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(murepl1 = mu[i_, j_ + half] \[Rule] muY[i, j + 1]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(mu[i_, half + j_] \[Rule] muY[i, 1 + j]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(murepl2 = mu[i_ + half, j_] \[Rule] muX[i + 1, j]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(mu[half + i_, j_] \[Rule] muX[1 + i, j]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(urepl = u[i_, j_] \[Rule] U[i, j, 1]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(u[i_, j_] \[Rule] U[i, j, 1]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(vrepl = v[i_, j_] \[Rule] U[i, j, 2]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(vrepl\)\" is similar to \
existing symbol \"\!\(urepl\)\"."\)], "Message"],

Cell[BoxData[
    \(v[i_, j_] \[Rule] U[i, j, 2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tauxy[i, j + half] //. {tauxydef, dudydef1, dudydef2, dvdxdef1, 
        dvdxdef2, murepl1, murepl2, urepl, vrepl}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(muY[i, 1 + j]\ 
      \((\(\(-U[i, j, 1]\) + U[i, 1 + j, 1]\)\/hy + 
          \(1\/\(4\ hx\)\((
            \(-U[\(-1\) + i, j, 2]\) - U[\(-1\) + i, 1 + j, 2] + 
              U[1 + i, j, 2] + U[1 + i, 1 + j, 2])\)\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(tauxy[i, j + half] - tauxy[i, j - 1 + half] + tauxx[i + half, j] - 
        tauxx[i - 1 + half, j] //. {tauxxdef, tauxydef, dudydef1, dudydef2, 
        dvdxdef1, dvdxdef2, dudxdef, dvdydef, murepl1, murepl2, urepl, vrepl}
        \)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(2\ muX[i, j]\ \((\(-U[\(-1\) + i, j, 1]\) + U[i, j, 1])\)\)\/hx
            \)\) + \(2\ muX[1 + i, j]\ 
          \((\(-U[i, j, 1]\) + U[1 + i, j, 1])\)\)\/hx - 
      muY[i, j]\ 
        \((\(\(-U[i, \(-1\) + j, 1]\) + U[i, j, 1]\)\/hy + 
            \(1\/\(4\ hx\)\((
              \(-U[\(-1\) + i, \(-1\) + j, 2]\) - U[\(-1\) + i, j, 2] + 
                U[1 + i, \(-1\) + j, 2] + U[1 + i, j, 2])\)\))\) + 
      muY[i, 1 + j]\ 
        \((\(\(-U[i, j, 1]\) + U[i, 1 + j, 1]\)\/hy + 
            \(1\/\(4\ hx\)\((
              \(-U[\(-1\) + i, j, 2]\) - U[\(-1\) + i, 1 + j, 2] + 
                U[1 + i, j, 2] + U[1 + i, 1 + j, 2])\)\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Extract stencil information from operator"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog = 
      alpha\ a[i, j]\ U[i, j, 1] - 
          \(1\/vol\) 
            \((beta\ \((
                  hy\ \((tauxx[i + half, j] - tauxx[i - 1 + half, j])\) + 
                    hx\ \((tauxy[i, j + half] - tauxy[i, j - 1 + half])\))\))
              \) //. {tauxxdef, tauxydef, dudydef1, dudydef2, dvdxdef1, 
          dvdxdef2, dudxdef, dvdydef, murepl1, murepl2, urepl, vrepl, 
          vol \[Rule] hx\ hy}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(beta\)\" is similar to \
existing symbol \"\!\(Beta\)\"."\)], "Message"],

Cell[BoxData[
    \(alpha\ a[i, j]\ U[i, j, 1] - 
      \(1\/\(hx\ hy\)\((
        beta\ \((
            hy\ \((\(-\(\(2\ muX[i, j]\ 
                            \((\(-U[\(-1\) + i, j, 1]\) + U[i, j, 1])\)\)\/hx
                          \)\) + 
                    \(2\ muX[1 + i, j]\ 
                        \((\(-U[i, j, 1]\) + U[1 + i, j, 1])\)\)\/hx)\) + 
              hx\ \((\(-muY[i, j]\)\ 
                      \((\(\(-U[i, \(-1\) + j, 1]\) + U[i, j, 1]\)\/hy + 
                          \(1\/\(4\ hx\)\((
                            \(-U[\(-1\) + i, \(-1\) + j, 2]\) - 
                              U[\(-1\) + i, j, 2] + U[1 + i, \(-1\) + j, 2] + 
                              U[1 + i, j, 2])\)\))\) + 
                    muY[i, 1 + j]\ 
                      \((\(\(-U[i, j, 1]\) + U[i, 1 + j, 1]\)\/hy + 
                          \(1\/\(4\ hx\)\((
                            \(-U[\(-1\) + i, j, 2]\) - 
                              U[\(-1\) + i, 1 + j, 2] + U[1 + i, j, 2] + 
                              U[1 + i, 1 + j, 2])\)\))\))\))\))\)\)\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i, j, 1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(alpha\ a[i, j] + \(2\ beta\ muX[i, j]\)\/hx\^2 + 
      \(2\ beta\ muX[1 + i, j]\)\/hx\^2 + \(beta\ muY[i, j]\)\/hy\^2 + 
      \(beta\ muY[i, 1 + j]\)\/hy\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i + 1, j, 1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(2\ beta\ muX[1 + i, j]\)\/hx\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i - 1, j, 1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(2\ beta\ muX[i, j]\)\/hx\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i, j + 1, 1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(beta\ muY[i, 1 + j]\)\/hy\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i, j - 1, 1]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(beta\ muY[i, j]\)\/hy\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog = 
      alpha\ a[i, j]\ U[i, j, 2] - 
          \(1\/vol\) 
            \((beta\ \((
                  hy\ \((tauxy[i + half, j] - tauxy[i - 1 + half, j])\) + 
                    hx\ \((tauyy[i, j + half] - tauyy[i, j - 1 + half])\))\))
              \) //. {tauyydef, tauxydef, dudydef1, dudydef2, dvdxdef1, 
          dvdxdef2, dudxdef, dvdydef, murepl1, murepl2, urepl, vrepl, 
          vol \[Rule] hx\ hy}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(alpha\ a[i, j]\ U[i, j, 2] - 
      \(1\/\(hx\ hy\)\((
        beta\ \((
            hx\ \((\(-\(\(2\ muY[i, j]\ 
                            \((\(-U[i, \(-1\) + j, 2]\) + U[i, j, 2])\)\)\/hy
                          \)\) + 
                    \(2\ muY[i, 1 + j]\ 
                        \((\(-U[i, j, 2]\) + U[i, 1 + j, 2])\)\)\/hy)\) + 
              hy\ \((\(-muX[i, j]\)\ 
                      \((\(\(-U[\(-1\) + i, j, 2]\) + U[i, j, 2]\)\/hx + 
                          \(1\/\(4\ hy\)\((
                            \(-U[\(-1\) + i, \(-1\) + j, 1]\) + 
                              U[\(-1\) + i, 1 + j, 1] - U[i, \(-1\) + j, 1] + 
                              U[i, 1 + j, 1])\)\))\) + 
                    muX[1 + i, j]\ 
                      \((\(\(-U[i, j, 2]\) + U[1 + i, j, 2]\)\/hx + 
                          \(1\/\(4\ hy\)\((
                            \(-U[i, \(-1\) + j, 1]\) + U[i, 1 + j, 1] - 
                              U[1 + i, \(-1\) + j, 1] + U[1 + i, 1 + j, 1])
                            \)\))\))\))\))\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i, j, 2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(alpha\ a[i, j] + \(beta\ muX[i, j]\)\/hx\^2 + 
      \(beta\ muX[1 + i, j]\)\/hx\^2 + \(2\ beta\ muY[i, j]\)\/hy\^2 + 
      \(2\ beta\ muY[i, 1 + j]\)\/hy\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i + 1, j, 2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(beta\ muX[1 + i, j]\)\/hx\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i - 1, j, 2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(beta\ muX[i, j]\)\/hx\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i, j + 1, 2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(2\ beta\ muY[i, 1 + j]\)\/hy\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Coefficient[Expand[dog], U[i, j - 1, 2]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(-\(\(2\ beta\ muY[i, j]\)\/hy\^2\)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"dependentCellsNotCovered is a function which returns a logical expression \
suitable for\ninclusion in fortran.  Give an expression, exp, we wish to \
determine which mesh locations are accessed by the expression.  However, we \
do not wish to examine\nall possible locations, only those outside the grid \
patch region.  So we provide\na second argument, which is a boolean function \
taking two arguments.  The combination will give logical expressions testing \
the mask for cells utilized by the\nexpression and for which the boolean \
function, logfunc[il,jl], evaluates as true. The\nthird argument is the name \
of the mask array"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(Clear[dependentCellsNotCovered]\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dependentCellsNotCovered[exp_, logfunc_, maskfun_] := 
      Module[{cond, lexp}, cond = False; lexp = exp; 
        For[il = \(-2\), il \[LessEqual] \(+2\), \(il++\), 
          For[jl = \(-2\), jl \[LessEqual] \(+2\), \(jl++\), 
            For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
              If[logfunc[il, jl] && 
                  Coefficient[Expand[exp], U[i + il, j + jl, kl]] =!= 0, 
                cond = cond || maskfun[i + il, j + jl] > 0]]]]; cond]\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(exp\)\" is similar to \
existing symbol \"\!\(Exp\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(lexp\)\" is similar to \
existing symbol \"\!\(exp\)\"."\)], "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"dependentCellsCovered is more or less the converse of \
dependentCellsNotCovered.\ndependentCellsCovered will return true if all the \
cells in the expression (properly\nrestricted by the mask function) ARE \
covered.  dependentCellsNotCovered returned\ntrue if one or more of the cells \
were not covered."], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(Clear[dependentCellsCovered]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dependentCellsCovered[exp_, logfunc_, maskfun_] := 
      Module[{cond, lexp}, cond = True; lexp = exp; 
        For[il = \(-2\), il \[LessEqual] \(+2\), \(il++\), 
          For[jl = \(-2\), jl \[LessEqual] \(+2\), \(jl++\), 
            For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
              If[logfunc[il, jl] && 
                  Coefficient[Expand[exp], U[i + il, j + jl, kl]] =!= 0, 
                cond = cond && maskfun[i + il, j + jl] == 0]]]]; cond]\)], 
  "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"this is an alternate definition which treats cells with mask .eq. 1 as \
untrusted,\nrather than mask .gt. 0"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(dependentCellsNotCoveredalt[exp_, logfunc_, maskfun_] := 
      Module[{cond, lexp}, cond = False; lexp = exp; 
        For[il = \(-2\), il \[LessEqual] \(+2\), \(il++\), 
          For[jl = \(-2\), jl \[LessEqual] \(+2\), \(jl++\), 
            For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
              If[logfunc[il, jl] && 
                  Coefficient[Expand[exp], U[i + il, j + jl, kl]] =!= 0, 
                cond = cond || maskfun[i + il, j + jl] == 1]]]]; cond]\)], 
  "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dependentCellsNotCovered[
      abba\ U[i + 1, j - 1, 1] + U[i - 1, j - 1, 2], #2 < 0&, masks]\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(masks[\(-1\) + i, \(-1\) + j] > 0 || masks[1 + i, \(-1\) + j] > 0\)], 
  "Output"]
}, Open  ]],

Cell[BoxData[
    \(f[x_] := 
      \(f1\ \((x - x2)\)\ \((x - x3)\)\)\/\(\((x1 - x2)\)\ \((x1 - x3)\)\) + 
        \(f2\ \((x - x1)\)\ \((x - x3)\)\)\/\(\((x2 - x1)\)\ 
            \((x2 - x3)\)\) + 
        \(f3\ \((x - x1)\)\ \((x - x2)\)\)\/\(\((x3 - x1)\)\ 
            \((x3 - x2)\)\)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog = 
      Simplify[\[PartialD]\_x f[x] /. {x1 \[Rule] 0, x2 \[Rule] \(-h\), 
            x3 \[Rule] \(-2\)\ h, x \[Rule] 0}]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(3\ f1 - 4\ f2 + f3\)\/\(2\ h\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {f1 \[Rule] 0, f2 \[Rule] h\^2, f3 \[Rule] 4\ h\^2}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(0\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog /. {f1 \[Rule] 0, f2 \[Rule] h\^3, f3 \[Rule] 8\ h\^3}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(2\ h\^2\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dog = 
      Simplify[\[PartialD]\_\(x, x\)f[x] /. {x1 \[Rule] 0, x2 \[Rule] \(-h\), 
            x3 \[Rule] \(-2\)\ h, x \[Rule] 0}]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(f1 - 2\ f2 + f3\)\/h\^2\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"definitions for Do One-sided Derivative in X direction.  if sign is \
positive, \nit means extend the stencil in the positivie x direction.  if \
negative, extend\nin other direction"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(DOneX[u_, i_, j_, sign_]\  := \ 
      \((\(-u[i + 2, j]\) + 4*u[i + 1, j] - 3*u[i, j])\)/\((2*hx)\)\  /; \ 
        sign == 1\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(sign\)\" is similar to \
existing symbol \"\!\(Sign\)\"."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(DOneX[u_, i_, j_, sign_]\  := \ 
      \((u[i - 2, j] - 4*u[i - 1, j] + 3*u[i, j])\)/\((2*hx)\)\  /; \ 
        sign == \(-1\)\)], "Input"],

Cell[BoxData[
    \(DOneX[u_, i_, j_, k_, sign_]\  := \ 
      \((\(-u[i + 2, j, k]\) + 4*u[i + 1, j, k] - 3*u[i, j, k])\)/
          \((2*hx)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneX[u_, i_, j_, k_, sign_]\  := \ 
      \((u[i - 2, j, k] - 4*u[i - 1, j, k] + 3*u[i, j, k])\)/\((2*hx)\)\  /; 
        \ sign == \(-1\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      DOneX[u, 0, 0, \(-1\)] //. {taylorudef, x0 \[Rule] hx\/2, 
          y0 \[Rule] hy\/2}]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx\/2, hy\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      DOneX[u, 0, 0, \(+1\)] //. {taylorudef, x0 \[Rule] hx\/2, 
          y0 \[Rule] hy\/2}]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx\/2, hy\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"definitions for Do One-sided Derivative in Y direction.  if sign is \
positive, \nit means extend the stencil in the positivie y direction.  if \
negative, extend\nin other direction"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(DOneY[u_, i_, j_, sign_]\  := \ 
      \((\(-u[i, j + 2]\) + 4*u[i, j + 1] - 3*u[i, j])\)/\((2*hy)\)\  /; \ 
        sign == 1\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DOneY\)\" is similar to \
existing symbol \"\!\(DOneX\)\"."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(DOneY[u_, i_, j_, sign_]\  := \ 
      \((u[i, j - 2] - 4*u[i, j - 1] + 3*u[i, j])\)/\((2*hy)\)\  /; \ 
        sign == \(-1\)\)], "Input"],

Cell[BoxData[
    \(DOneY[u_, i_, j_, k_, sign_]\  := \ 
      \((\(-u[i, j + 2, k]\) + 4*u[i, j + 1, k] - 3*u[i, j, k])\)/
          \((2*hy)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneY[u_, i_, j_, k_, sign_]\  := \ 
      \((u[i, j - 2, k] - 4*u[i, j - 1, k] + 3*u[i, j, k])\)/\((2*hy)\)\  /; 
        \ sign == \(-1\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      DOneY[u, 0, 0, \(-1\)] //. {taylorudef, x0 \[Rule] hx\/2, 
          y0 \[Rule] hy\/2}]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      DOneY[u, 0, 0, \(+1\)] //. {taylorudef, x0 \[Rule] hx\/2, 
          y0 \[Rule] hy\/2}]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions for two sided deriv in x direction."], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(DTwoX[u_, i_, j_] := \(u[i + 1, j] - u[i - 1, j]\)\/\(2\ hx\)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DTwoX[u_, i_, j_, k_] := 
      \(u[i + 1, j, k] - u[i - 1, j, k]\)\/\(2\ hx\)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      DTwoX[u, 0, 0] //. {taylorudef, x0 \[Rule] hx\/2, y0 \[Rule] hy\/2}]
      \)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx\/2, hy\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DTwoY[u_, i_, j_] := \(u[i, j + 1] - u[i, j - 1]\)\/\(2\ hy\)\)], 
  "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DTwoY\)\" is similar to \
existing symbol \"\!\(DTwoX\)\"."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(DTwoY[u_, i_, j_, k_] := 
      \(u[i, j + 1, k] - u[i, j - 1, k]\)\/\(2\ hy\)\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(Simplify[
      DTwoY[u, 0, 0] //. {taylorudef, x0 \[Rule] hx\/2, y0 \[Rule] hy\/2}]
      \)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(DeleteFile["\<dog.mf\>"]; \)\), 
    \(\(CopyFile["\<DV_2D.mF\>", "\<dog.mf\>"]; \)\), 
    \(\(Splice["\<dog.mf\>"]; \)\), 
    \(\(DeleteFile["\<DV_2D.F\>"]; \)\), 
    \(\(CopyFile["\<dog.f\>", "\<DV_2D.F\>"]; \)\), 
    \(<< "\<!touch DV_2D.F\>"\)}], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudxe\)\" is similar to \
existing symbol \"\!\(dudx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudxw\)\" is similar to \
existing symbols \!\({dudx, dudxe}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dvdyn\)\" is similar to \
existing symbol \"\!\(dvdy\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dvdys\)\" is similar to \
existing symbols \!\({dvdy, dvdyn}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudyn\)\" is similar to \
existing symbols \!\({dudy, dvdyn}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(maskn\)\" is similar to \
existing symbol \"\!\(masks\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell1\"\) will be suppressed \
during this calculation."\)], "Message"],

Cell[BoxData[
    \(DeleteFile::"nffil" \( : \ \) 
      "File not found during \!\(DeleteFile[\"DV_2D.F\"]\)."\)], "Message"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["Start figuring out how to write stencil"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(out1 = 
      alpha\ a[i, j]\ U[i, j, 1] - 
          \(1\/vol\((
            beta\ \((
                hy\ \((tauxx[i + half, j] - tauxx[i - 1 + half, j])\) + 
                  hx\ \((tauxy[i, j + half] - tauxy[i, j - 1 + half])\))\))
            \)\) //. {tauxxdef, tauxydef, dudydef1, dudydef2, dvdxdef1, 
          dvdxdef2, dudxdef, dvdydef, murepl1, murepl2, urepl, vrepl, 
          vol \[Rule] hx\ hy}\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Coefficient[Expand[out1], U[i, j, 1]]\)], "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["setup to use the Format.m package "], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(Off[General::"\<spell\>", General::"\<spell1\>"]; \)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\(SetOptions[$Output, PageWidth \[Rule] 73]; \)\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(<< "\</usr/people/wyc/_math/MathSource/Format/Format.m\>"\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(stencilDef[exp_, kin_] := 
      Block[{iind, il, jl, kl, list1, list2, indices, tmp, indtrn}, 
        indices = {{0, 0, KO}, {\(-1\), 0, KW}, {0, \(-1\), KS}, {\(-1\), 
              \(-1\), KSW}, {\(-1\), \(+1\), KNW}}; list1 = {}; list2 = {}; 
        For[iind = 1, iind \[LessEqual] 5, \(iind++\), 
          il = indices\[LeftDoubleBracket]iind, 1\[RightDoubleBracket]; 
          jl = indices\[LeftDoubleBracket]iind, 2\[RightDoubleBracket]; 
          indtrn = indices\[LeftDoubleBracket]iind, 3\[RightDoubleBracket]; 
          For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
            tmp = Coefficient[Expand[exp], U[i + il, j + jl, kl]]; 
            If[tmp =!= 0, list1 = Append[list1, coef[i, j, indtrn, kin, kl]]; 
              list2 = Append[list2, 
                  \(+Coefficient[Expand[exp], U[i + il, j, kl]]\)]]]]; 
        FortranAssign[Evaluate[list1], list2, 
          AssignToArray \[Rule] {muY, muX, a, coef, polycoef}]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(stencilInc[exp_, kin_] := 
      Block[{iind, il, jl, kl, list1, list2, indices, tmp, indtrn}, 
        indices = {{0, 0, KO}, {\(-1\), 0, KW}, {0, \(-1\), KS}, {\(-1\), 
              \(-1\), KSW}, {\(-1\), \(+1\), KNW}}; list1 = {}; list2 = {}; 
        For[iind = 1, iind \[LessEqual] 5, \(iind++\), 
          il = indices\[LeftDoubleBracket]iind, 1\[RightDoubleBracket]; 
          jl = indices\[LeftDoubleBracket]iind, 2\[RightDoubleBracket]; 
          indtrn = indices\[LeftDoubleBracket]iind, 3\[RightDoubleBracket]; 
          For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
            tmp = Coefficient[Expand[exp], U[i + il, j + jl, kl]]; 
            If[tmp =!= 0, list1 = Append[list1, coef[i, j, indtrn, kin, kl]]; 
              list2 = Append[list2, 
                  coef[i, j, indtrn, kin, kl] + 
                    Coefficient[Expand[exp], U[i + il, j, kl]]]]]]; 
        FortranAssign[Evaluate[list1], list2, 
          AssignToArray \[Rule] {muY, muX, a, coef, polycoef}]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(stencilDec[exp_, kin_] := 
      Block[{iind, il, jl, kl, list1, list2, indices, tmp, indtrn}, 
        indices = {{0, 0, KO}, {\(-1\), 0, KW}, {0, \(-1\), KS}, {\(-1\), 
              \(-1\), KSW}, {\(-1\), \(+1\), KNW}}; list1 = {}; list2 = {}; 
        For[iind = 1, iind \[LessEqual] 5, \(iind++\), 
          il = indices\[LeftDoubleBracket]iind, 1\[RightDoubleBracket]; 
          jl = indices\[LeftDoubleBracket]iind, 2\[RightDoubleBracket]; 
          indtrn = indices\[LeftDoubleBracket]iind, 3\[RightDoubleBracket]; 
          For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
            tmp = Coefficient[Expand[exp], U[i + il, j + jl, kl]]; 
            If[tmp =!= 0, 
              list1 = Append[list1, coef[i, jl, indtrn, kin, kl]]; 
              list2 = Append[list2, 
                  coef[i, j, indtrn, kin, kl] - 
                    Coefficient[Expand[exp], U[i + il, j, kl]]]]]]; 
        FortranAssign[Evaluate[list1], list2, 
          AssignToArray \[Rule] {muY, muX, a, coef, polycoef}]]\)], "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"This is slight variation on dependentCellsNotCovered.  Uses Format.m"], 
  "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(Clear[depCellNotCovered]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dependentCellIsCovered[exp_, logfunc_, maskfun_] := 
      Module[{cond, lexp}, cond = False; lexp = exp; 
        For[il = \(-2\), il \[LessEqual] \(+2\), \(il++\), 
          For[jl = \(-2\), jl \[LessEqual] \(+2\), \(jl++\), 
            For[kl = 1, kl \[LessEqual] 2, \(kl++\), 
              If[logfunc[il, jl] && 
                  Coefficient[Expand[exp], U[i + il, j + jl, kl]] =!= 0, 
                cond = cond || maskfun[i + il, j + jl] > 0]]]]; 
        FortranAssign[cond, AssignToArray \[Rule] {maskray}]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Clear[stencoef]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(stencilDef[out1, 1]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dog1 = 
      InputForm[
        Expand[vol\ 
              \((alpha\ a[i, j]\ U[i, j, 1] - 
                  \(1\/vol\((
                    beta\ \((
                        hy\ \((tauxx[i + half, j] - tauxx[i - 1 + half, j])
                              \) + hx\ 
                            \((tauxy[i, j + half] - tauxy[i, j - 1 + half])\))
                        \))\)\))\) //. {tauxxdef, tauxydef, murepl1, murepl2, 
              urepl, vrepl, vol \[Rule] hx\ hy}]]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Splice["\<dog.mf\>", FormatType \[Rule] OutputForm]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(Splice["\<ratdog.mf\>", FormatType \[Rule] OutputForm]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(exntop + exnbot\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dependentCellIsCovered[exntop + exnbot, indexcond, maskray]\)], "Input",\

  AspectRatioFixed->True],

Cell[BoxData[
    \(Expand[exntop]\)], "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(outdog = 
      2\ beta\ hy\ dudx[\(-1\) + half + i, j] //. {dudxdef, 
          u[i - 1, j] \[Rule] u[i, j]}\)], "Input",
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{535, 959},
WindowMargins->{{Automatic, 359}, {Automatic, 22}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 94, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1850, 57, 146, 4, 27, "Input"],
Cell[1999, 63, 103, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2139, 70, 146, 4, 27, "Input"],
Cell[2288, 76, 103, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2428, 83, 141, 4, 27, "Input"],
Cell[2572, 89, 191, 3, 55, "Message"],
Cell[2766, 94, 182, 3, 39, "Message"],
Cell[2951, 99, 179, 3, 39, "Message"],
Cell[3133, 104, 160, 3, 39, "Message"],
Cell[3296, 109, 98, 2, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3443, 117, 103, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[3571, 123, 134, 3, 50, "Input"],
Cell[3708, 128, 99, 2, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3844, 135, 134, 3, 47, "Input"],
Cell[3981, 140, 99, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4117, 147, 203, 5, 69, "Input"],
Cell[4323, 154, 171, 3, 69, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4531, 162, 203, 5, 65, "Input"],
Cell[4737, 169, 171, 3, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4945, 177, 129, 3, 47, "Input"],
Cell[5077, 182, 99, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5213, 189, 129, 3, 50, "Input"],
Cell[5345, 194, 99, 2, 50, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5493, 202, 119, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[5637, 208, 458, 9, 190, "Input"],
Cell[6098, 219, 175, 3, 39, "Message"],
Cell[6276, 224, 179, 3, 39, "Message"],
Cell[6458, 229, 401, 7, 193, "Output"]
}, Open  ]],
Cell[6874, 239, 128, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[7027, 246, 128, 3, 47, "Input"],
Cell[7158, 251, 49, 1, 47, "Output"]
}, Open  ]],
Cell[7222, 255, 128, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[7375, 262, 128, 3, 47, "Input"],
Cell[7506, 267, 49, 1, 47, "Output"]
}, Open  ]],
Cell[7570, 271, 114, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[7709, 277, 128, 3, 47, "Input"],
Cell[7840, 282, 49, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7926, 288, 458, 9, 190, "Input"],
Cell[8387, 299, 187, 3, 39, "Message"],
Cell[8577, 304, 175, 3, 39, "Message"],
Cell[8755, 309, 179, 3, 39, "Message"],
Cell[8937, 314, 179, 3, 39, "Message"],
Cell[9119, 319, 161, 3, 39, "Message"],
Cell[9283, 324, 185, 3, 39, "Message"],
Cell[9471, 329, 401, 7, 193, "Output"]
}, Open  ]],
Cell[9887, 339, 114, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[10026, 345, 128, 3, 47, "Input"],
Cell[10157, 350, 49, 1, 47, "Output"]
}, Open  ]],
Cell[10221, 354, 128, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[10374, 361, 128, 3, 47, "Input"],
Cell[10505, 366, 49, 1, 47, "Output"]
}, Open  ]],
Cell[10569, 370, 128, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[10722, 377, 128, 3, 47, "Input"],
Cell[10853, 382, 49, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10939, 388, 223, 5, 65, "Input"],
Cell[11165, 395, 188, 3, 39, "Message"],
Cell[11356, 400, 176, 3, 39, "Message"],
Cell[11535, 405, 181, 3, 39, "Message"],
Cell[11719, 410, 173, 3, 88, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11941, 419, 82, 2, 47, "Section",
  Evaluatable->False],
Cell[12026, 423, 150, 4, 43, "Input"],

Cell[CellGroupData[{
Cell[12201, 431, 154, 3, 47, "Input"],
Cell[12358, 436, 67, 1, 47, "Output"]
}, Open  ]],
Cell[12440, 440, 150, 4, 43, "Input"],

Cell[CellGroupData[{
Cell[12615, 448, 154, 3, 47, "Input"],
Cell[12772, 453, 67, 1, 47, "Output"]
}, Open  ]],
Cell[12854, 457, 199, 4, 43, "Input"],

Cell[CellGroupData[{
Cell[13078, 465, 154, 3, 47, "Input"],
Cell[13235, 470, 88, 1, 47, "Output"]
}, Open  ]],
Cell[13338, 474, 199, 4, 43, "Input"],

Cell[CellGroupData[{
Cell[13562, 482, 154, 3, 47, "Input"],
Cell[13719, 487, 88, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13856, 494, 112, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[13993, 500, 108, 2, 27, "Input"],
Cell[14104, 504, 73, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14214, 510, 108, 2, 27, "Input"],
Cell[14325, 514, 73, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14435, 520, 95, 2, 27, "Input"],
Cell[14533, 524, 62, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14632, 530, 95, 2, 27, "Input"],
Cell[14730, 534, 177, 3, 39, "Message"],
Cell[14910, 539, 62, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15009, 545, 173, 3, 43, "Input"],
Cell[15185, 550, 254, 5, 95, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15476, 560, 290, 5, 75, "Input"],
Cell[15769, 567, 686, 13, 266, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16492, 585, 121, 2, 45, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[16638, 591, 475, 10, 115, "Input"],
Cell[17116, 603, 175, 3, 39, "Message"],
Cell[17294, 608, 1081, 21, 397, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18412, 634, 95, 2, 27, "Input"],
Cell[18510, 638, 192, 3, 91, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18739, 646, 99, 2, 27, "Input"],
Cell[18841, 650, 76, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18954, 656, 99, 2, 27, "Input"],
Cell[19056, 660, 72, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19165, 666, 99, 2, 27, "Input"],
Cell[19267, 670, 73, 1, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19377, 676, 99, 2, 27, "Input"],
Cell[19479, 680, 69, 1, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19585, 686, 475, 10, 115, "Input"],
Cell[20063, 698, 1076, 20, 382, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21176, 723, 95, 2, 27, "Input"],
Cell[21274, 727, 192, 3, 91, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21503, 735, 99, 2, 27, "Input"],
Cell[21605, 739, 73, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21715, 745, 99, 2, 27, "Input"],
Cell[21817, 749, 69, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21923, 755, 99, 2, 27, "Input"],
Cell[22025, 759, 76, 1, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22138, 765, 99, 2, 27, "Input"],
Cell[22240, 769, 72, 1, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22349, 775, 720, 11, 154, "Subsubsection",
  Evaluatable->False],
Cell[23072, 788, 90, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[23187, 794, 527, 10, 123, "Input"],
Cell[23717, 806, 173, 3, 39, "Message"],
Cell[23893, 811, 174, 3, 39, "Message"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[24116, 820, 390, 7, 90, "Subsubsection",
  Evaluatable->False],
Cell[24509, 829, 87, 2, 27, "Input"],
Cell[24599, 833, 524, 10, 123, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[25160, 848, 192, 4, 58, "Subsubsection",
  Evaluatable->False],
Cell[25355, 854, 531, 10, 123, "Input"],

Cell[CellGroupData[{
Cell[25911, 868, 156, 4, 43, "Input"],
Cell[26070, 874, 102, 2, 27, "Output"]
}, Open  ]],
Cell[26187, 879, 329, 7, 68, "Input"],

Cell[CellGroupData[{
Cell[26541, 890, 186, 4, 27, "Input"],
Cell[26730, 896, 66, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[26833, 902, 117, 2, 34, "Input"],
Cell[26953, 906, 35, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27025, 912, 117, 2, 34, "Input"],
Cell[27145, 916, 41, 1, 32, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27223, 922, 192, 4, 28, "Input"],
Cell[27418, 928, 59, 1, 47, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[27538, 936, 263, 5, 79, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[27826, 945, 159, 3, 43, "Input"],
Cell[27988, 950, 175, 3, 39, "Message"]
}, Open  ]],
Cell[28178, 956, 159, 3, 43, "Input"],
Cell[28340, 961, 174, 3, 59, "Input"],
Cell[28517, 966, 172, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[28714, 973, 162, 4, 47, "Input"],
Cell[28879, 979, 52, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28968, 985, 162, 4, 47, "Input"],
Cell[29133, 991, 52, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[29234, 998, 263, 5, 79, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[29522, 1007, 159, 3, 43, "Input"],
Cell[29684, 1012, 177, 3, 39, "Message"]
}, Open  ]],
Cell[29876, 1018, 159, 3, 43, "Input"],
Cell[30038, 1023, 174, 3, 59, "Input"],
Cell[30215, 1028, 172, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[30412, 1035, 162, 4, 47, "Input"],
Cell[30577, 1041, 52, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30666, 1047, 162, 4, 47, "Input"],
Cell[30831, 1053, 52, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[30932, 1060, 127, 2, 45, "Subsection",
  Evaluatable->False],
Cell[31062, 1064, 123, 3, 47, "Input"],
Cell[31188, 1069, 137, 3, 47, "Input"],

Cell[CellGroupData[{
Cell[31350, 1076, 150, 4, 47, "Input"],
Cell[31503, 1082, 52, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31592, 1088, 123, 3, 50, "Input"],
Cell[31718, 1093, 177, 3, 39, "Message"]
}, Open  ]],
Cell[31910, 1099, 137, 3, 50, "Input"],

Cell[CellGroupData[{
Cell[32072, 1106, 150, 4, 47, "Input"],
Cell[32225, 1112, 52, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32314, 1118, 312, 7, 107, "Input"],
Cell[32629, 1127, 176, 3, 39, "Message"],
Cell[32808, 1132, 181, 3, 39, "Message"],
Cell[32992, 1137, 176, 3, 39, "Message"],
Cell[33171, 1142, 181, 3, 39, "Message"],
Cell[33355, 1147, 181, 3, 39, "Message"],
Cell[33539, 1152, 160, 3, 39, "Message"],
Cell[33702, 1157, 177, 3, 39, "Message"],
Cell[33882, 1162, 161, 3, 39, "Message"],
Cell[34046, 1167, 126, 2, 23, "Message"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[34233, 1176, 116, 2, 47, "Section",
  Evaluatable->False],
Cell[34352, 1180, 469, 10, 115, "Input"],
Cell[34824, 1192, 96, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[34945, 1198, 114, 2, 45, "Subsection",
  Evaluatable->False],
Cell[35062, 1202, 113, 2, 27, "Input"],
Cell[35178, 1206, 106, 2, 27, "Input"],
Cell[35287, 1210, 116, 2, 27, "Input"],
Cell[35406, 1214, 1004, 16, 203, "Input"],
Cell[36413, 1232, 1050, 17, 203, "Input"],
Cell[37466, 1251, 1066, 18, 203, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38569, 1274, 152, 4, 45, "Subsection",
  Evaluatable->False],
Cell[38724, 1280, 83, 2, 27, "Input"],
Cell[38810, 1284, 579, 10, 123, "Input"],
Cell[39392, 1296, 74, 2, 27, "Input"],
Cell[39469, 1300, 78, 2, 27, "Input"],
Cell[39550, 1304, 535, 12, 155, "Input"],
Cell[40088, 1318, 110, 2, 27, "Input"],
Cell[40201, 1322, 113, 2, 27, "Input"],
Cell[40317, 1326, 74, 2, 27, "Input"],
Cell[40394, 1330, 120, 3, 27, "Input"],
Cell[40517, 1335, 73, 2, 27, "Input"],
Cell[40593, 1339, 168, 4, 43, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "HGPROJ_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define CDIMS loc_1,loc_2,loc_3,hic_1,hic_2,hic_3
#define GDIMS g_lo_1,g_lo_2,g_lo_3,g_hi_1,g_hi_2,g_hi_3
#define PDIMS p_lo_1,p_lo_2,p_lo_3,p_hi_1,p_hi_2,p_hi_3

#if BL_USE_FLOAT
#define sixteenth  .0625e0
#else
#define sixteenth  .0625d0
#endif

c *************************************************************************
c ** MKCOEFF **
c ** Define the coefficients along the axis as averages of sig.
c *************************************************************************

      subroutine FORT_MKCOEFF(coeff,sig,DIMS,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   sig(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2  +ng,lo_3-ng:hi_3  +ng)
      REAL_T coeff(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng,3)

c     Local variables
      integer i,j,k

      do k = lo_3  ,hi_3+1
      do j = lo_2  ,hi_2+1
      do i = lo_1-1,hi_1+1 
          coeff(i,j,k,1) = ( sig(i,j,k  ) + sig(i,j-1,k  ) +
     $                       sig(i,j,k-1) + sig(i,j-1,k-1) ) * fourth
          coeff(i,j,k,1) = coeff(i,j,k,1)
      enddo
      enddo
      enddo

      do k = lo_3  ,hi_3+1
      do j = lo_2-1,hi_2+1 
      do i = lo_1  ,hi_1+1
          coeff(i,j,k,2) = ( sig(i,j,k  ) + sig(i-1,j,k  ) +
     $                       sig(i,j,k-1) + sig(i-1,j,k-1) ) * fourth
          coeff(i,j,k,2) = coeff(i,j,k,2)
      enddo
      enddo
      enddo

      do k = lo_3-1,hi_3+1 
      do j = lo_2  ,hi_2+1
      do i = lo_1  ,hi_1+1   
          coeff(i,j,k,3) = ( sig(i  ,j,k) + sig(i  ,j-1,k) +
     $                       sig(i-1,j,k) + sig(i-1,j-1,k) ) * fourth
          coeff(i,j,k,3) = coeff(i,j,k,3)
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** GRADHG **
c ** Compute the cell-centered gradient of the nodal pressure field
c *************************************************************************

      subroutine FORT_GRADHG(gphi,GDIMS,phi,PDIMS,DIMS,dx)

      implicit none

      integer DIMS
      integer g_lo_1, g_lo_2, g_lo_3
      integer g_hi_1, g_hi_2, g_hi_3
      integer p_lo_1, p_lo_2, p_lo_3
      integer p_hi_1, p_hi_2, p_hi_3
      REAL_T  gphi(g_lo_1:g_hi_1,g_lo_2:g_hi_2,g_lo_3:g_hi_3,3)
      REAL_T   phi(p_lo_1:p_hi_1,p_lo_2:p_hi_2,p_lo_3:p_hi_3)
      REAL_T  dx(3)
      
c     Local variables
      integer i, j, k,n

      do k = lo_3,hi_3
         do j = lo_2,hi_2
            do i = lo_1,hi_1
               
               gphi(i,j,k,1) = fourth*(phi(i+1,j,k  ) + phi(i+1,j+1,k  ) +
     $              phi(i+1,j,k+1) + phi(i+1,j+1,k+1) -
     $              phi(i  ,j,k  ) - phi(i  ,j+1,k  ) -
     $              phi(i  ,j,k+1) - phi(i  ,j+1,k+1) ) /dx(1)
               
               gphi(i,j,k,2) = fourth*(phi(i,j+1,k  ) + phi(i+1,j+1,k  ) +
     $              phi(i,j+1,k+1) + phi(i+1,j+1,k+1) -
     $              phi(i,j  ,k  ) - phi(i+1,j  ,k  ) -
     $              phi(i,j  ,k+1) - phi(i+1,j  ,k+1) ) /dx(2)
               
               gphi(i,j,k,3) = fourth*(phi(i,j  ,k+1) + phi(i+1,j  ,k+1) + 
     $              phi(i,j+1,k+1) + phi(i+1,j+1,k+1) -
     $              phi(i,j  ,k  ) - phi(i+1,j  ,k  ) -
     $              phi(i,j+1,k  ) - phi(i+1,j+1,k  ) ) /dx(3)
            enddo
         enddo
      enddo

      return
      end

c *************************************************************************
c ** RHSHG **
c ** Compute the right-hand-side D(V) for the projection
c *************************************************************************

      subroutine FORT_RHSHG(du,u,divu_src,vol,DIMS,dx,bc,norm,ng,
     $                      is_singular,sum_src,sum_fac)

      implicit none

      integer DIMS
      integer ng
      REAL_T        du(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T         u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,3)
      REAL_T  divu_src(lo_1  :hi_1+1,lo_2  :hi_2+1,lo_3  :hi_3+1)
      REAL_T       vol(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  dx(3)
      REAL_T sum_src, sum_fac
      integer is_singular
      integer bc(2,3)

c     Local variables
      REAL_T fac,facx,facy,facz,norm
      REAL_T factor
      REAL_T  vavg
      integer i, j, k, n
      integer is,ie,js,je,ks,ke
      integer istrt,iend
      integer jstrt,jend
      integer kstrt,kend

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      if (BCX_LO .eq. WALL) then
        do n = 1,3
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k,n) = zero
        enddo
        enddo
        enddo
      endif

      if (BCX_HI .eq. WALL) then
        do n = 1,3
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k,n) = zero
        enddo
        enddo
        enddo
      endif

      if (BCY_LO .eq. WALL) then
        do n = 1,3
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,js-1,k,n) = zero
        enddo
        enddo
        enddo
      endif

      if (BCY_HI .eq. WALL) then
        do n = 1,3
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,je+1,k,n) = zero
        enddo
        enddo
        enddo
      endif

      if (BCZ_LO .eq. WALL) then
        do n = 1,3
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ks-1,n) = zero
        enddo
        enddo
        enddo
      endif

      if (BCZ_HI .eq. WALL) then
        do n = 1,3
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ke+1,n) = zero
        enddo
        enddo
        enddo
      endif
 
      facx = fourth / dx(1)
      facy = fourth / dx(2)
      facz = fourth / dx(3)

      do k = kstrt,kend 
      do j = jstrt,jend 
      do i = istrt,iend 

          du(i,j,k) = ((vol(i  ,j-1,k  )*u(i  ,j-1,k  ,1) + 
     $                  vol(i  ,j  ,k  )*u(i  ,j  ,k  ,1) +
     $                  vol(i  ,j-1,k-1)*u(i  ,j-1,k-1,1) + 
     $                  vol(i  ,j  ,k-1)*u(i  ,j  ,k-1,1)) - 
     $                 (vol(i-1,j-1,k  )*u(i-1,j-1,k  ,1) + 
     $                  vol(i-1,j  ,k  )*u(i-1,j  ,k  ,1)  +
     $                  vol(i-1,j-1,k-1)*u(i-1,j-1,k-1,1) + 
     $                  vol(i-1,j  ,k-1)*u(i-1,j  ,k-1,1)) ) * facx
     $              + ((vol(i-1,j  ,k  )*u(i-1,j  ,k  ,2) + 
     $                  vol(i  ,j  ,k  )*u(i  ,j  ,k  ,2) +
     $                  vol(i-1,j  ,k-1)*u(i-1,j  ,k-1,2) + 
     $                  vol(i  ,j  ,k-1)*u(i  ,j  ,k-1,2)) - 
     $                 (vol(i-1,j-1,k  )*u(i-1,j-1,k  ,2) + 
     $                  vol(i  ,j-1,k  )*u(i  ,j-1,k  ,2) +
     $                  vol(i-1,j-1,k-1)*u(i-1,j-1,k-1,2) + 
     $                  vol(i  ,j-1,k-1)*u(i  ,j-1,k-1,2)) ) * facy
     $              + ((vol(i-1,j  ,k  )*u(i-1,j  ,k  ,3) + 
     $                  vol(i  ,j  ,k  )*u(i  ,j  ,k  ,3) +
     $                  vol(i-1,j-1,k  )*u(i-1,j-1,k  ,3) + 
     $                  vol(i  ,j-1,k  )*u(i  ,j-1,k  ,3)) - 
     $                 (vol(i-1,j  ,k-1)*u(i-1,j  ,k-1,3) + 
     $                  vol(i  ,j  ,k-1)*u(i  ,j  ,k-1,3) +
     $                  vol(i-1,j-1,k-1)*u(i-1,j-1,k-1,3) + 
     $                  vol(i  ,j-1,k-1)*u(i  ,j-1,k-1,3)) ) * facz
          vavg = 
     $          (vol(i,j,k  ) + vol(i-1,j,k  ) + vol(i,j-1,k  ) + vol(i-1,j-1,k  )
     $          +vol(i,j,k-1) + vol(i-1,j,k-1) + vol(i,j-1,k-1) + vol(i-1,j-1,k-1))
          du(i,j,k) = du(i,j,k) - vavg * divu_src(i,j,k)
        
          fac = one
          fac = cvmgt(two*fac,fac,(i .eq. is  ) .and. 
     $                (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) )
          fac = cvmgt(two*fac,fac,(i .eq. ie+1) .and. 
     $                (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
          fac = cvmgt(two*fac,fac,(j .eq. js  ) .and. 
     $                (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
          fac = cvmgt(two*fac,fac,(j .eq. je+1) .and. 
     $                (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
          fac = cvmgt(two*fac,fac,(k .eq. ks  ) .and. 
     $                (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) )
          fac = cvmgt(two*fac,fac,(k .eq. ke+1) .and. 
     $                (BCZ_HI .eq. WALL .or. BCZ_HI .eq. INLET) )
 
          du(i,j,k) = du(i,j,k) * fac

          if (i .eq. 5 .and. j .eq. 1 .and. k .eq. 0) then
            print *,'DU ',du(i,j,k)
            print *,'VAVG ',vavg
            print *,'FAC ',fac
          endif

      enddo
      enddo
      enddo

      if (is_singular .eq. 1) then
        sum_src  = zero
        sum_fac  = zero
        do k = kstrt, kend 
        do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(half*factor,factor,i.eq.is .or. i.eq.ie+1)
          factor = cvmgt(half*factor,factor,j.eq.js .or. j.eq.je+1)
          factor = cvmgt(half*factor,factor,k.eq.ks .or. k.eq.ke+1)
          sum_src = sum_src + factor * du(i,j,k)
          sum_fac = sum_fac + factor
        enddo
        enddo
        enddo
      endif

      norm = zero

      do k = kstrt, kend 
      do j = jstrt, jend 
      do i = istrt, iend 
        norm = max(norm, abs(du(i,j,k)))
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** ADJUSTRHS **
c ** Adjust the RHS so it sums to zero if the problem has no outflow boundaries.
c *************************************************************************

      subroutine FORT_ADJUSTRHS(du,DIMS,bc,ng,sum_src)

      implicit none

      integer DIMS
      integer bc(2,3)
      integer ng
      REAL_T  du(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  sum_src

c     Local variables
      integer i, j, k
      integer istart,iend,jstart,jend,kstart,kend

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)
      kstart = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend   = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      do k = kstart,kend 
      do j = jstart,jend 
         do i = istart,iend 
           du(i,j,k) = du(i,j,k) - sum_src
         enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** PROJUHG **
c ** Define the updated pressure and vector field
c *************************************************************************

      subroutine FORT_PROJUHG(u,pressure,phi,gradphi,rhonph,DIMS,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T         u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,3)
      REAL_T  pressure(lo_1  :hi_1+1,lo_2  :hi_2+1,lo_3  :hi_3+1)
      REAL_T       phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T   gradphi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T    rhonph(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)

c     Local variables
      integer i, j, k

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          u(i,j,k,1) = u(i,j,k,1) - gradphi(i,j,k,1)/rhonph(i,j,k)
          u(i,j,k,2) = u(i,j,k,2) - gradphi(i,j,k,2)/rhonph(i,j,k)
          u(i,j,k,3) = u(i,j,k,3) - gradphi(i,j,k,3)/rhonph(i,j,k)
        enddo
      enddo
      enddo

    
      print *,'UMAX ',u(7,7,7,1)

      do k = lo_3,hi_3+1
      do j = lo_2,hi_2+1
        do i = lo_1,hi_1+1 
c          pressure(i,j,k) = pressure(i,j,k) + phi(i,j,k)
           pressure(i,j,k) = phi(i,j,k)
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D(sig G(phi))
c *************************************************************************

      subroutine FORT_RESIDUAL(residual,phi,source,coeff,dgphi,
     $                         DIMS,dx,resnorm,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  residual(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T       phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T    source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T     coeff(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng,3)
      REAL_T     dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  dx(3)
      REAL_T  resnorm
      integer bc(2,3)

c     Local variables
      integer i,j,k
      integer istrt,jstrt,kstrt
      integer iend,jend,kend

      resnorm = zero

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      call makedgphi(phi,dgphi,coeff,DIMS,dx,bc,ng,istrt,jstrt,kstrt,iend,jend,kend)

      do k = kstrt,kend
      do j = jstrt,jend
        do i = istrt,iend
          residual(i,j,k) = source(i,j,k) - dgphi(i,j,k)
        enddo
      enddo
      enddo

      do k = kstrt,kend 
      do j = jstrt,jend 
        do i = istrt,iend 
          resnorm = max(resnorm,abs(residual(i,j,k)))
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RELAX **
c ** Gauss-Seidel relaxation
c *************************************************************************

      subroutine FORT_RELAX(phi,source,coeff,dgphi,DIMS,dx,bc,nnrelax,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T     phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T   coeff(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng,3)
      REAL_T   dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T dx(3)
      integer bc(2,3)
      integer nnrelax

c     Local variables
      REAL_T  facx, facy, facz
      REAL_T  rfac, mult
      integer i,j,k
      integer iter, ioff, iinc
      integer is,ie,js,je,ks,ke
      integer istrt, jstrt, kstrt
      integer iend, jend, kend
      integer extra_xlo,extra_xhi
      integer extra_ylo,extra_yhi
      integer extra_zlo,extra_zhi

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      facx = one/(dx(1)*dx(1))
      facy = one/(dx(2)*dx(2))
      facz = one/(dx(3)*dx(3))

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      if (2*nnrelax .gt. ng) then
        print *,'DONT HAVE ENOUGH BUFFER CELLS IN HG:RELAX '
        print *,'NG = ',ng
        print *,'NRELAX = ',nnrelax
        stop
      endif
 
      do iter = 1, 2*nnrelax 

        extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
        extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
        extra_zlo = cvmgt(ng-iter,0,BCZ_LO .eq. INTERIOR .or. BCZ_LO .eq. PERIODIC)

        extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
        extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)
        extra_zhi = cvmgt(ng-iter,0,BCZ_HI .eq. INTERIOR .or. BCZ_HI .eq. PERIODIC)

        do k = kstrt-extra_zlo,kend+extra_zhi
        do j = jstrt-extra_ylo,jend+extra_yhi
          iinc = mod(j+k+iter+1+extra_xlo+2*ng,2)
          do i = istrt-extra_xlo+iinc,iend+extra_xhi,2

            dgphi(i,j,k) =
     $         (coeff(i  ,j,k,1) * (phi(i+1,j,k) - phi(i,j,k)) +
     $          coeff(i-1,j,k,1) * (phi(i-1,j,k) - phi(i,j,k)) ) * facx +
     $         (coeff(i,j  ,k,2) * (phi(i,j+1,k) - phi(i,j,k)) +
     $          coeff(i,j-1,k,2) * (phi(i,j-1,k) - phi(i,j,k)) ) * facy +
     $         (coeff(i,j,k  ,3) * (phi(i,j,k+1) - phi(i,j,k)) +
     $          coeff(i,j,k-1,3) * (phi(i,j,k-1) - phi(i,j,k)) ) * facz


              rfac =  (coeff(i,j,k,1) + coeff(i-1,j,k,1)) * facx +
     $                (coeff(i,j,k,2) + coeff(i,j-1,k,2)) * facy +
     $                (coeff(i,j,k,3) + coeff(i,j,k-1,3)) * facz 

              mult = one 
              mult = cvmgt(two*mult,mult,
     $                     i.eq.is   .and. (BCX_LO.eq.WALL.or.BCX_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     j.eq.js   .and. (BCY_LO.eq.WALL.or.BCY_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     k.eq.ks   .and. (BCZ_LO.eq.WALL.or.BCZ_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     i.eq.ie+1 .and. (BCX_HI.eq.WALL.or.BCX_HI.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     j.eq.je+1 .and. (BCY_HI.eq.WALL.or.BCY_HI.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     k.eq.ke+1 .and. (BCZ_HI.eq.WALL.or.BCZ_HI.eq.INLET))

              dgphi(i,j,k) = mult*dgphi(i,j,k)
              rfac = mult * rfac

              rfac = one/rfac

              phi(i,j,k) = phi(i,j,k) + rfac*(dgphi(i,j,k) - source(i,j,k))

        enddo
        enddo
        enddo

      enddo

      return
      end

c *************************************************************************
c ** COARSIG **
c ** Coarsening of the sig coefficients
c *************************************************************************

      subroutine FORT_COARSIG(sig,sigc,DIMS,CDIMS,ng)

      implicit none

      integer DIMS
      integer CDIMS
      integer ng
      REAL_T  sig(lo_1 -ng:hi_1 +ng,lo_2 -ng:hi_2 +ng,lo_3 -ng:hi_3 +ng)
      REAL_T sigc(loc_1-ng:hic_1+ng,loc_2-ng:hic_2+ng,loc_3-ng:hic_3+ng)

c     Local variables
      integer i ,j, k

      do k = lo_3,hi_3,2
      do j = lo_2,hi_2,2
      do i = lo_1,hi_1,2
        sigc(i/2,j/2,k/2) = ( sig(i  ,j,k  ) + sig(i  ,j+1,k  )+ 
     $                        sig(i+1,j,k  ) + sig(i+1,j+1,k  )+
     $                        sig(i  ,j,k+1) + sig(i  ,j+1,k+1)+
     $                        sig(i+1,j,k+1) + sig(i+1,j+1,k+1) ) * eighth

      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,bc,ng)

      implicit none

      integer DIMS
      integer CDIMS
      integer ng
      REAL_T   res(lo_1 -ng:hi_1 +1+ng,lo_2 -ng:hi_2 +1+ng,lo_3 -ng:hi_3 +1+ng)
      REAL_T  resc(loc_1-ng:hic_1+1+ng,loc_2-ng:hic_2+1+ng,loc_3-ng:hic_3+1+ng)
      integer bc(2,3)

c     Local variables
      integer i,j,k,ii,jj,kk
      integer istrt,jstrt,kstrt
      integer iend,jend,kend
      REAL_T cen, faces, sides, corners

      istrt = cvmgt((lo_1  )/2+1,(lo_1  )/2,BCX_LO .eq. OUTLET)
      iend  = cvmgt((hi_1+1)/2-1,(hi_1+1)/2,BCX_HI .eq. OUTLET)

      jstrt = cvmgt((lo_2  )/2+1,(lo_2  )/2,BCY_LO .eq. OUTLET)
      jend  = cvmgt((hi_2+1)/2-1,(hi_2+1)/2,BCY_HI .eq. OUTLET)

      kstrt = cvmgt((lo_3  )/2+1,(lo_3  )/2,BCZ_LO .eq. OUTLET)
      kend  = cvmgt((hi_3+1)/2-1,(hi_3+1)/2,BCZ_HI .eq. OUTLET)

      if (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) then
        do k = lo_3-1,hi_3+2
        do j = lo_2-1,hi_2+2
          res(lo_1-1,j,k) = res(lo_1+1,j,k)
        enddo
        enddo
      endif
      if (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) then
        do k = lo_3-1,hi_3+2
        do j = lo_2-1,hi_2+2
          res(hi_1+2,j,k) = res(hi_1  ,j,k)
        enddo
        enddo
      endif

      if (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) then
        do k = lo_3-1,hi_3+2
        do i = lo_1-1,hi_1+2
          res(i,lo_2-1,k) = res(i,lo_2+1,k)
        enddo
        enddo
      endif
      if (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) then
        do k = lo_3-1,hi_3+2
        do i = lo_1-1,hi_1+2
          res(i,hi_2+2,k) = res(i,hi_2  ,k)
        enddo
        enddo
      endif

      if (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) then
        do j = lo_2-1,hi_2+2
        do i = lo_1-1,hi_1+2
          res(i,j,lo_3-1) = res(i,j,lo_3+1)
        enddo
        enddo
      endif
      if (BCZ_HI .eq. WALL .or. BCZ_HI .eq. INLET) then
        do j = lo_2-1,hi_2+2
        do i = lo_1-1,hi_1+2
          res(i,j,hi_3+2) = res(i,j,hi_3  )
        enddo
        enddo
      endif

      do k = kstrt,kend
      do j = jstrt,jend
      do i = istrt,iend

          ii = 2*i
          jj = 2*j
          kk = 2*k

          cen = res(ii,jj,kk)

          faces = res(ii+1,jj,kk) + res(ii-1,jj,kk) +
     $            res(ii,jj+1,kk) + res(ii,jj-1,kk) +
     $            res(ii,jj,kk+1) + res(ii,jj,kk-1)

          sides = res(ii+1,jj+1,kk) + res(ii-1,jj+1,kk) +
     $            res(ii+1,jj-1,kk) + res(ii-1,jj-1,kk) +
     $            res(ii+1,jj,kk+1) + res(ii-1,jj,kk+1) +
     $            res(ii+1,jj,kk-1) + res(ii-1,jj,kk-1) +
     $            res(ii,jj+1,kk+1) + res(ii,jj-1,kk+1) +
     $            res(ii,jj+1,kk-1) + res(ii,jj-1,kk-1)

          corners = res(ii+1,jj+1,kk+1) + res(ii-1,jj+1,kk+1) +
     $              res(ii+1,jj-1,kk+1) + res(ii-1,jj-1,kk+1) +
     $              res(ii+1,jj+1,kk-1) + res(ii-1,jj+1,kk-1) +
     $              res(ii+1,jj-1,kk-1) + res(ii-1,jj-1,kk-1)

          resc(i,j,k) = eighth * (cen + half   * faces + 
     $                                  fourth * sides + 
     $                                  eighth * corners)

      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERP **
c ** Simple bilinear interpolation
c *************************************************************************

      subroutine FORT_INTERP(phi,deltac,DIMS,CDIMS,ng)

      implicit none

      integer DIMS
      integer CDIMS
      integer ng
      REAL_T     phi(lo_1 -ng:hi_1 +1+ng,lo_2 -ng:hi_2 +1+ng,lo_3 -ng:hi_3 +1+ng)
      REAL_T  deltac(loc_1-ng:hic_1+1+ng,loc_2-ng:hic_2+1+ng,loc_3-ng:hic_3+1+ng)

c     Local variables
      integer i,j,k

      do k = lo_3,hi_3+1,2
      do j = lo_2,hi_2+1,2
      do i = lo_1,hi_1+1,2
          phi(i,j,k) = phi(i,j,k) + deltac(i/2,j/2,k/2)
      enddo
      enddo
      enddo

      do k = lo_3+1,hi_3  ,2
      do j = lo_2  ,hi_2+1,2
      do i = lo_1  ,hi_1+1,2
        phi(i,j,k) = phi(i,j,k) + half*(deltac(i/2,j/2,k/2)+deltac(i/2,j/2,k/2+1))
      enddo
      enddo
      enddo

      do k = lo_3  ,hi_3+1,2
      do j = lo_2+1,hi_2  ,2
      do i = lo_1  ,hi_1+1,2
        phi(i,j,k) = phi(i,j,k) + half*(deltac(i/2,j/2,k/2)+deltac(i/2,j/2+1,k/2))
      enddo
      enddo
      enddo

      do k = lo_3  ,hi_3+1,2
      do j = lo_2  ,hi_2+1,2
      do i = lo_1+1,hi_1  ,2
        phi(i,j,k) = phi(i,j,k) + half*(deltac(i/2,j/2,k/2)+deltac(i/2+1,j/2,k/2))
      enddo
      enddo
      enddo

      do k = lo_3  ,hi_3+1,2
      do j = lo_2+1,hi_2,2
      do i = lo_1+1,hi_1,2
        phi(i,j,k) = phi(i,j,k) + 
     $     fourth*(deltac(i/2,j/2  ,k/2)+deltac(i/2+1,j/2  ,k/2)
     $            +deltac(i/2,j/2+1,k/2)+deltac(i/2+1,j/2+1,k/2))
      enddo
      enddo
      enddo

      do k = lo_3+1,hi_3  ,2
      do j = lo_2  ,hi_2+1,2
      do i = lo_1+1,hi_1  ,2
        phi(i,j,k) = phi(i,j,k) + 
     $     fourth*(deltac(i/2,j/2,k/2  )+deltac(i/2+1,j/2,k/2  )
     $            +deltac(i/2,j/2,k/2+1)+deltac(i/2+1,j/2,k/2+1))
      enddo
      enddo
      enddo

      do k = lo_3+1,hi_3  ,2
      do j = lo_2+1,hi_2  ,2
      do i = lo_1  ,hi_1+1,2
        phi(i,j,k) = phi(i,j,k) + 
     $     fourth*(deltac(i/2,j/2,k/2  )+deltac(i/2,j/2+1,k/2  )
     $            +deltac(i/2,j/2,k/2+1)+deltac(i/2,j/2+1,k/2+1))
      enddo
      enddo
      enddo

      do k = lo_3+1,hi_3,2
      do j = lo_2+1,hi_2,2
      do i = lo_1+1,hi_1,2
        phi(i,j,k) = phi(i,j,k) + 
     $     eighth*(deltac(i/2  ,j/2,k/2  )+deltac(i/2  ,j/2+1,k/2  )
     $            +deltac(i/2  ,j/2,k/2+1)+deltac(i/2  ,j/2+1,k/2+1)
     $            +deltac(i/2+1,j/2,k/2  )+deltac(i/2+1,j/2+1,k/2  )
     $            +deltac(i/2+1,j/2,k/2+1)+deltac(i/2+1,j/2+1,k/2+1))
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** MAKEDGPHI **
c ** Compute D(sig G(phi))
c *************************************************************************

      subroutine makedgphi(phi,dgphi,coeff,DIMS,dx,bc,ng,rlo_1,rlo_2,rlo_3,
     $                                                   rhi_1,rhi_2,rhi_3)

      implicit none

      integer DIMS
      integer ng
      integer rlo_1,rlo_2,rlo_3
      integer rhi_1,rhi_2,rhi_3
      REAL_T    phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  coeff(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng,3)
      REAL_T  dx(3)
      integer bc(2,3)

c     Local variables
      REAL_T facx, facy, facz
      REAL_T mult
      integer istart,iend
      integer jstart,jend
      integer kstart,kend
      integer i,j,k

      facx = one / (dx(1)*dx(1))
      facy = one / (dx(2)*dx(2))
      facz = one / (dx(3)*dx(3))

      istart = cvmgt(lo_1+1,rlo_1,BCX_LO .eq. OUTLET)
      jstart = cvmgt(lo_2+1,rlo_2,BCY_LO .eq. OUTLET)
      kstart = cvmgt(lo_3+1,rlo_3,BCZ_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,rhi_1,BCX_HI .eq. OUTLET)
      jend   = cvmgt(hi_2  ,rhi_2,BCY_HI .eq. OUTLET)
      kend   = cvmgt(hi_3  ,rhi_3,BCZ_HI .eq. OUTLET)

      do k = kstart,kend
      do j = jstart,jend
      do i = istart,iend

            dgphi(i,j,k) = 
     $         (coeff(i  ,j,k,1) * (phi(i+1,j,k) - phi(i,j,k)) +
     $          coeff(i-1,j,k,1) * (phi(i-1,j,k) - phi(i,j,k)) ) * facx +
     $         (coeff(i,j  ,k,2) * (phi(i,j+1,k) - phi(i,j,k)) +
     $          coeff(i,j-1,k,2) * (phi(i,j-1,k) - phi(i,j,k)) ) * facy +
     $         (coeff(i,j,k  ,3) * (phi(i,j,k+1) - phi(i,j,k)) +
     $          coeff(i,j,k-1,3) * (phi(i,j,k-1) - phi(i,j,k)) ) * facz

            mult = one 
            mult = cvmgt(two*mult,mult,
     $                   i.eq.lo_1   .and. (BCX_LO.eq.WALL.or.BCX_LO.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   j.eq.lo_2   .and. (BCY_LO.eq.WALL.or.BCY_LO.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   k.eq.lo_3   .and. (BCZ_LO.eq.WALL.or.BCZ_LO.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   i.eq.hi_1+1 .and. (BCX_HI.eq.WALL.or.BCX_HI.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   j.eq.hi_2+1 .and. (BCY_HI.eq.WALL.or.BCY_HI.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   k.eq.hi_3+1 .and. (BCZ_HI.eq.WALL.or.BCZ_HI.eq.INLET))

            dgphi(i,j,k) = mult*dgphi(i,j,k)

      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** SOLVEHG **
c *************************************************************************

      subroutine FORT_SOLVEHG(dest,dest0,source,coeff,sum,r,w,z,work,
     $                        DIMS,dx,bc,
     $                        maxiter,norm,prob_norm,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  dest0(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  coeff(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng,3)
      REAL_T    sum(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T      r(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T      w(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T      z(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T   work(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T dx(3)
      integer bc(2,3)
      integer maxiter
      REAL_T norm
      REAL_T prob_norm
      REAL_T sum0

c     Local variables
      REAL_T  factor
      REAL_T  alpha
      REAL_T  beta
      REAL_T  rho
      REAL_T  rhol
      REAL_T  local_norm
      REAL_T  tol, tolfac
      integer i,j,k
      integer iter
      integer istrt,iend
      integer jstrt,jend
      integer kstrt,kend

      tolfac = 1.0d-3

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)
      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      call setperiodic(dest,DIMS,bc,ng)

      do k = lo_3-1,hi_3+2
      do j = lo_2-1,hi_2+2
         do i = lo_1-1,hi_1+2
            dest0(i,j,k) = dest(i,j,k)
            dest(i,j,k) = zero
         enddo
      enddo
      enddo

  10  call makedgphi(dest0,w,coeff,DIMS,dx,bc,ng,istrt,jstrt,kstrt,iend,jend,kend)

      rho = zero
      norm = zero

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          r(i,j,k) = source(i,j,k) - w(i,j,k)
        enddo
      enddo
      enddo

      local_norm = zero
      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(half*factor,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(half*factor,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(half*factor,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          local_norm  = max(local_norm, abs(r(i,j,k)))
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho    = rho + z(i,j,k) * r(i,j,k) * factor
          norm   = max(norm,abs(r(i,j,k)))
        enddo
      enddo
      enddo

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          work(i,j,k) = zero
          dest(i,j,k) = z(i,j,k)
        enddo
      enddo
      enddo

      iter = 1
c     write(6,1000) iter, norm/prob_norm

 100  call setperiodic(dest,DIMS,bc,ng)

      call makedgphi(dest,w,coeff,DIMS,dx,bc,ng,istrt,jstrt,kstrt,iend,jend,kend)

      alpha = zero
      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(half*factor,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(half*factor,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(half*factor,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          alpha  = alpha + dest(i,j,k)*w(i,j,k) * factor
        enddo
      enddo
      enddo

      alpha = rho / alpha
      rhol  = rho
      rho   = zero
      norm  = zero

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(half*factor,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(half*factor,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(half*factor,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          work(i,j,k) = work(i,j,k) + alpha * dest(i,j,k)
          r(i,j,k) = r(i,j,k) - alpha * w(i,j,k)
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho    = rho + z(i,j,k) * r(i,j,k) * factor
          norm   = max(norm,abs(r(i,j,k)))
        enddo
      enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then

        do k = kstrt, kend 
        do j = jstrt, jend 
          do i = istrt, iend 
            dest(i,j,k) = work(i,j,k) + dest0(i,j,k)
          enddo
        enddo
        enddo

      else if (iter .ge. maxiter .or. norm .ge. 100.d0*local_norm) then

        tolfac = 10.d0 * tolfac 
        iter = 1 
        do k = kstrt, kend 
        do j = jstrt, jend 
          do i = istrt, iend 
            dest(i,j,k) = zero
          enddo
        enddo
        enddo
        goto 10

      else

        beta = rho / rhol
        do k = kstrt, kend 
        do j = jstrt, jend 
          do i = istrt, iend 
            dest(i,j,k) = z(i,j,k) + beta * dest(i,j,k)
          enddo
        enddo
        enddo
        goto 100

      endif

1000  format('Res/Res0 in solve: ',i4,2x,e12.5)
c     call flush(6)

      return
      end

c *************************************************************************
c ** MAKESUM **
c *************************************************************************

      subroutine FORT_MAKESUM(sum,coeff,DIMS,dx,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    sum(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      REAL_T  coeff(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng,3)
      REAL_T  dx(3)
      integer bc(2,3)

c     Local variables
      integer i, j, k
      integer is, ie, js, je, ks, ke
      integer istrt,iend
      integer jstrt,jend
      integer kstrt,kend
      REAL_T  facx, facy, facz
      REAL_T  mult

      facx = one/(dx(1)*dx(1))
      facy = one/(dx(2)*dx(2))
      facz = one/(dx(3)*dx(3))

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      do k = kstrt, kend 
      do j = jstrt, jend 
      do i = istrt, iend 
        sum(i,j,k) = - (
     $              (coeff(i,j,k,1) + coeff(i-1,j,k,1)) * facx +
     $              (coeff(i,j,k,2) + coeff(i,j-1,k,2)) * facy +
     $              (coeff(i,j,k,3) + coeff(i,j,k-1,3)) * facz )
         mult = one 
         mult = cvmgt(two*mult,mult,
     $                i.eq.is   .and. (BCX_LO.eq.WALL.or.BCX_LO.eq.INLET))
         mult = cvmgt(two*mult,mult,
     $                j.eq.js   .and. (BCY_LO.eq.WALL.or.BCY_LO.eq.INLET))
         mult = cvmgt(two*mult,mult,
     $                k.eq.ks   .and. (BCZ_LO.eq.WALL.or.BCZ_LO.eq.INLET))
         mult = cvmgt(two*mult,mult,
     $                i.eq.ie+1 .and. (BCX_HI.eq.WALL.or.BCX_HI.eq.INLET))
         mult = cvmgt(two*mult,mult,
     $                j.eq.je+1 .and. (BCY_HI.eq.WALL.or.BCY_HI.eq.INLET))
         mult = cvmgt(two*mult,mult,
     $                     k.eq.ke+1 .and. (BCZ_HI.eq.WALL.or.BCZ_HI.eq.INLET))
         sum(i,j,k) = mult * sum(i,j,k)

      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** SETPERIODIC **
c  Impose periodic boundary conditions on the single grid data in the
c   conjugate gradient bottom solver.
c *************************************************************************

      subroutine setperiodic(dest,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng,lo_3-ng:hi_3+1+ng)
      integer bc(2,3)

      integer i,j,k

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC) then
        do k = lo_3,hi_3+1 
        do j = lo_2,hi_2+1 
          dest(hi_1+2,j,k) = dest(lo_1+1,j,k)
          dest(lo_1-1,j,k) = dest(hi_1  ,j,k)
        enddo
        enddo
      endif

      if (BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC) then
        do k = lo_3,hi_3+1
        do i = lo_1,hi_1+1
          dest(i,hi_2+2,k) = dest(i,lo_2+1,k)
          dest(i,lo_2-1,k) = dest(i,hi_2  ,k)
        enddo
        enddo
      endif

      if (BCZ_LO .eq. PERIODIC .and. BCZ_HI .eq. PERIODIC) then
        do j = lo_2,hi_2+1
        do i = lo_1,hi_1+1
          dest(i,j,hi_3+2) = dest(i,j,lo_3+1)
          dest(i,j,lo_3-1) = dest(i,j,hi_3  )
        enddo
        enddo
      endif

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC .and.
     $    BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC) then
        do k = lo_3,hi_3+1
          dest(lo_1-1,lo_2-1,k) = dest(hi_1,hi_2,k)
          dest(lo_1-1,hi_2+2,k) = dest(hi_1,lo_2+1,k)
          dest(hi_1+2,lo_2-1,k) = dest(lo_1+1,hi_2,k)
          dest(hi_1+2,hi_2+2,k) = dest(lo_1+1,lo_2+1,k)
        enddo
      endif

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC .and.
     $    BCZ_LO .eq. PERIODIC .and. BCZ_HI .eq. PERIODIC) then
        do j = lo_2,hi_2+1
          dest(lo_1-1,j,lo_3-1) = dest(hi_1,j,hi_3)
          dest(lo_1-1,j,hi_3+2) = dest(hi_1,j,lo_3+1)
          dest(hi_1+2,j,lo_3-1) = dest(lo_1+1,j,hi_3)
          dest(hi_1+2,j,hi_3+2) = dest(lo_1+1,j,lo_3+1)
        enddo
      endif

      if (BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC .and.
     $    BCZ_LO .eq. PERIODIC .and. BCZ_HI .eq. PERIODIC) then
        do i = lo_1,hi_1+1
          dest(i,lo_2-1,lo_3-1) = dest(i,hi_2,hi_3)
          dest(i,lo_2-1,hi_3+2) = dest(i,hi_2,lo_3+1)
          dest(i,hi_2+2,lo_3-1) = dest(i,lo_2+1,hi_3)
          dest(i,hi_2+2,hi_3+2) = dest(i,lo_2+1,lo_3+1)
        enddo
      endif

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC .and.
     &    BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC .and.
     &    BCZ_LO .eq. PERIODIC .and. BCZ_HI .eq. PERIODIC) then
          dest(lo_1-1,lo_1-1,lo_3-1) = dest(hi_1  ,hi_2  ,hi_3)
          dest(hi_1+2,lo_1-1,lo_3-1) = dest(lo_1+1,hi_2  ,hi_3)
          dest(lo_1-1,hi_2+2,lo_3-1) = dest(hi_1  ,lo_1+1,hi_3)
          dest(hi_1+2,hi_2+2,lo_3-1) = dest(lo_1+1,lo_1+1,hi_3)
          dest(lo_1-1,lo_1-1,hi_3+2) = dest(hi_1  ,hi_2  ,lo_3+1)
          dest(hi_1+2,lo_1-1,hi_3+2) = dest(lo_1+1,hi_2  ,lo_3+1)
          dest(lo_1-1,hi_2+2,hi_3+2) = dest(hi_1  ,lo_1+1,lo_3+1)
          dest(hi_1+2,hi_2+2,hi_3+2) = dest(lo_1+1,lo_1+1,lo_3+1)
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "CONSTANTS.H"
#include "ArrayLim.H"
#include "BC_TYPES.H"
#include "xtra_F.H"

#define DIM 2

      subroutine FORT_PUSHVTOG(lo, hi, dlo, dhi, U, DIMS(U), nc)
      implicit none
      integer nc
      integer  lo(DIM),  hi(DIM)
      integer dlo(DIM), dhi(DIM)
      integer DIMDEC(U)
      REAL_T U(DIMV(U),nc)
      integer i,j,k,n
      REAL_T xlo(DIM), dx(DIM)

c     Make up something for these that gets what we want
      do n=1,DIM
         dx(n) = one
         xlo(n) = one
      end do

      do n=1,nc
         call hoextraptocc(U(ARG_L1(U),ARG_L2(U),n),DIMS(U),dlo,dhi,dx,xlo)
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** PROBINIT **
c ** Read in the problem-dependent parameters for the FORTRAN common blocks
c *************************************************************************

      subroutine FORT_PROBINIT (name,namlen)
      integer namlen
      integer name(namlen)
      integer untin, i

#include "probdata.H"

      namelist /fortin/ prob_type, 
     $                  in_xvel, in_yvel, in_zvel, in_density, in_tracer,
     $                  xblob, yblob, zblob, radblob, denblob, velfact

c      Build `probin' filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      character probin*(maxlen)

      if (namlen .gt. maxlen) then
         write(6,*) 'probin file name too long'
         stop
      end if

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      untin = 9
      if (namlen .eq. 0) then
         open(untin,file='probin',form='formatted',status='old')
      else
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if
  
      write(6,*) ' '
      write(6,*) 'READING PROBIN_FILE ',probin(1:namlen)
      write(6,*) ' '

      read(untin,fortin)
      close(unit=untin)

      end

c *************************************************************************
c ** INITDATA **
c ** Call the appropriate subroutine to initialize the data
c *************************************************************************

      subroutine FORT_INITDATA(u,v,w,scal,DIMS,dx,time,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numscal)
      REAL_T  dx(3)
      REAL_T  time

      if (prob_type .eq. 1) then

        call initspin(u,v,w,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 2) then

        call initbubble(u,v,w,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 3) then

        call initshear(u,v,w,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 4) then

        call initchannel(u,v,w,scal,dx,DIMS,numscal)

      else 

        print *,'DONT KNOW THIS PROBLEM TYPE: ',prob_type
        stop
 
      endif

      return
      end

c *************************************************************************
c ** INITSPIN **
c ** Initialize the constant density flow-in-a-box problem
c *************************************************************************

      subroutine initspin(u,v,w,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numscal)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z 
      REAL_T spx, spy, spz, cpx, cpy, cpz
      integer i, j, k, n

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i-lo_1) + half)
        y = dx(2)*(float(j-lo_2) + half)
        z = dx(3)*(float(k-lo_3) + half)

        spx = sin(Pi*x)
        cpx = cos(Pi*x)
        spy = sin(Pi*y)
        cpy = cos(Pi*y)
        spz = sin(Pi*z)
        cpz = cos(Pi*z)

        u(i,j,k) =  velfact*two*spy*cpy*spx**2
        v(i,j,k) = -velfact*two*spx*cpx*spy**2
        w(i,j,k) =  zero

        scal(i,j,k,1) = one

      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,k,n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITBUBBLE **
c ** Initialize the bubble-drop in a box problem
c *************************************************************************

      subroutine initbubble(u,v,w,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numscal)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z, r
      integer i, j, k, n

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        u(i,j,k) = zero
        v(i,j,k) = zero
        w(i,j,k) = zero

        x = dx(1)*(float(i-lo_1) + half)
        y = dx(2)*(float(j-lo_2) + half)
        z = dx(3)*(float(k-lo_3) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)

        scal(i,j,k,1) = one+(denblob-one)*(half+half*tanh(100.d0*(radblob-r)))
c       scal(i,j,k,1) = cvmgt(denblob,one,r .lt. radblob)

      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,k,n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITSHEAR **
c ** Initialize a constant density doubly-periodic shear problem
c *************************************************************************

      subroutine initshear(u,v,w,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numscal)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z
      integer i, j, k, n

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i-lo_1) + half)
        y = dx(2)*(float(j-lo_2) + half)
        z = dx(3)*(float(k-lo_3) + half)

        u(i,j,k) = tanh(30.d0*(fourth - abs(y-half)))
        v(i,j,k) = 0.05d0 * sin(two*Pi*x)
        w(i,j,k) = zero

        scal(i,j,k,1) = one

      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,k,n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITCHANNEL **
c ** Initialize the channel inflow problem
c *************************************************************************

      subroutine initchannel(u,v,w,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numscal)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z, r
      integer i, j, k, n

      if (numscal .lt. 2) then
        print *,"CHANNEL FLOW NEEDS MORE SCALARS"
        stop
      endif

      do k = lo_3-1,hi_3+1
      do j = lo_2-1,hi_2+1
      do i = lo_1-1,hi_1+1

        u(i,j,k) = in_xvel
        v(i,j,k) = in_yvel
        w(i,j,k) = in_zvel

      enddo
      enddo
      enddo

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i-lo_1) + half)
        y = dx(2)*(float(j-lo_2) + half)
        z = dx(3)*(float(k-lo_3) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)

        scal(i,j,k,1) = cvmgt(denblob,in_density,r .lt. radblob)
        scal(i,j,k,2) = cvmgt(one    ,in_tracer ,r .lt. radblob)

      enddo
      enddo
      enddo

      do n = 3, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,k,n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** DERVORT **
c ** Derive a cell-centered vorticity
c *************************************************************************

      subroutine FORT_DERVORT(state,derval,derlo_1,derlo_2,derlo_3,
     $                        derhi_1,derhi_2,derhi_3,DIMS,dx)

      implicit none

      integer DIMS
      integer derlo_1,derlo_2,derlo_3
      integer derhi_1,derhi_2,derhi_3
      REAL_T   state(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,5)
      REAL_T  derval(derlo_1:derhi_1,derlo_2:derhi_2,derlo_3:derhi_3)
      REAL_T  dx(3)

c     Local variables
      integer i, j, k
      REAL_T derx, dery, derz

      do k = lo_3, hi_3 
       do j = lo_2, hi_2 
        do i = lo_1, hi_1 

          derx = eighth*(state(i+1,j+1,k-1,3)+state(i-1,j+1,k-1,3)
     $                  +state(i+1,j+1,k+1,3)+state(i-1,j+1,k+1,3)
     $                  -state(i+1,j-1,k-1,3)-state(i-1,j-1,k-1,3)
     $                  -state(i+1,j-1,k+1,3)-state(i-1,j-1,k+1,3)) / dx(2) -
     $           eighth*(state(i+1,j+1,k+1,2)+state(i-1,j+1,k+1,2)
     $                  +state(i+1,j-1,k+1,2)+state(i-1,j-1,k+1,2)
     $                  -state(i+1,j+1,k-1,2)-state(i-1,j+1,k-1,2)
     $                  -state(i+1,j-1,k-1,2)-state(i-1,j-1,k-1,2)) / dx(3)

          dery = eighth*(state(i+1,j+1,k-1,3)+state(i+1,j-1,k-1,3)
     $                  +state(i+1,j+1,k+1,3)+state(i+1,j-1,k+1,3)
     $                  -state(i-1,j+1,k-1,3)-state(i-1,j-1,k-1,3)
     $                  -state(i-1,j+1,k+1,3)-state(i-1,j-1,k+1,3)) / dx(1) -
     $           eighth*(state(i+1,j+1,k+1,1)+state(i-1,j+1,k+1,1)
     $                  +state(i+1,j-1,k+1,1)+state(i-1,j-1,k+1,1)
     $                  -state(i+1,j+1,k-1,1)-state(i-1,j+1,k-1,1)
     $                  -state(i+1,j-1,k-1,1)-state(i-1,j-1,k-1,1)) / dx(3)

          derz = eighth*(state(i+1,j+1,k-1,2)+state(i+1,j-1,k-1,2)
     $                  +state(i+1,j+1,k+1,2)+state(i+1,j-1,k+1,2)
     $                  -state(i-1,j+1,k-1,2)-state(i-1,j-1,k-1,2)
     $                  -state(i-1,j+1,k+1,2)-state(i-1,j-1,k+1,2)) / dx(1) -
     $           eighth*(state(i+1,j+1,k-1,1)+state(i-1,j+1,k-1,1)
     $                  +state(i+1,j+1,k+1,1)+state(i-1,j+1,k+1,1)
     $                  -state(i+1,j-1,k-1,1)-state(i-1,j-1,k-1,1)
     $                  -state(i+1,j-1,k+1,1)-state(i-1,j-1,k+1,1)) / dx(2)

          derval(i,j,k) = sqrt(derx**2 + dery**2 + derz**2)

        enddo
       enddo
      enddo

      return
      end

c *************************************************************************
c ** DERAVGP **
c ** Average nodal pressure onto cell centers for plotting purposes
c *************************************************************************

      subroutine FORT_DERAVGP(pressure,dat,DIMS)

      implicit none

      integer DIMS
      REAL_T  pressure(lo_1:hi_1+1,lo_2:hi_2+1,lo_3:hi_3+1)
      REAL_T       dat(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3)

c     Local variables
      integer i, j, k

      do k = lo_3, hi_3
       do j = lo_2, hi_2
        do i = lo_1, hi_1
          dat(i,j,k) = (pressure(i,j  ,k  ) + pressure(i+1,j  ,k  ) +
     $                  pressure(i,j+1,k  ) + pressure(i+1,j+1,k  ) +
     $                  pressure(i,j  ,k+1) + pressure(i+1,j  ,k+1) +
     $                  pressure(i,j+1,k+1) + pressure(i+1,j+1,k+1) ) * eighth
        enddo
       enddo
      enddo

      return
      end

c *************************************************************************
c ** FORT_SETCELLVELBC **
c ** set velocity bc for computation of derived variables
c *************************************************************************

      subroutine FORT_SETCELLVELBC(u,v,w,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,
     $                             bcz_lo,bcz_hi,visc_coef,dx,time)
      
      implicit none

#include "probdata.H"      

      integer DIMS
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      REAL_T visc_coef
      REAL_T dx(3)
      REAL_T time

c     Local variables
      integer i, j, k, is, ie, js, je, ks, ke

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      if (bcz_lo .eq. PERIODIC) then
        do j = js,je
        do i = is,ie
          w(i,j,ks-1) = w(i,j,ke)
          v(i,j,ks-1) = v(i,j,ke)
          u(i,j,ks-1) = u(i,j,ke)
        enddo
        enddo
      elseif (bcz_lo .eq. OUTLET) then
        do j = js,je
        do i = is,ie
          w(i,j,ks-1) = w(i,j,ks)
          v(i,j,ks-1) = v(i,j,ks)
          u(i,j,ks-1) = u(i,j,ks)
        enddo
        enddo
      elseif (bcz_lo .eq. INLET) then
        do j = js,je
        do i = is,ie
          w(i,j,ks-1) =  two* in_zvel - w(i,j,ks)
          v(i,j,ks-1) =  -v(i,j,ks)
          u(i,j,ks-1) =  -u(i,j,ks)
        enddo
        enddo
      elseif (bcz_lo .eq. WALL) then
        do j = js,je
        do i = is,ie
           w(i,j,ks-1) =  -w(i,j,ks)
           v(i,j,ks-1) =  three*v(i,j,ks) - three*v(i,j,ks+1) + v(i,j,ks+2)
           u(i,j,ks-1) =  three*u(i,j,ks) - three*u(i,j,ks+1) + u(i,j,ks+2)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do j = js,je
           do i = is,ie
              u(i,j,ks-1) =  -u(i,j,ks)
              v(i,j,ks-1) =  -v(i,j,ks)
           enddo
           enddo
        endif
      endif

      if (bcz_hi .eq. PERIODIC) then
        do j = js,je
        do i = is,ie
          w(i,j,ke+1) = w(i,j,ks)
          v(i,j,ke+1) = v(i,j,ks)
          u(i,j,ke+1) = u(i,j,ks)
        enddo
        enddo
      elseif (bcz_hi .eq. OUTLET) then
        do j = js,je
        do i = is,ie
          w(i,j,ke+1) = w(i,j,ke)
          v(i,j,ke+1) = v(i,j,ke)
          u(i,j,ke+1) = u(i,j,ke)
        enddo
        enddo
      elseif (bcz_hi .eq. INLET) then 
        do j = js,je
        do i = is,ie
          w(i,j,ke+1) = two*in_zvel - w(i,j,ke)
          v(i,j,ke+1) = - v(i,j,ke)
          u(i,j,ke+1) = - u(i,j,ke)
        enddo
        enddo
      elseif (bcz_hi .eq. WALL) then
        do j = js,je
        do i = is,ie
          w(i,j,ke+1) = -w(i,j,ke)
          v(i,j,ke+1) =  three*v(i,j,ke) - three*v(i,j,ke-1) + v(i,j,ke-2)
          u(i,j,ke+1) =  three*u(i,j,ke) - three*u(i,j,ke-1) + u(i,j,ke-2)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do j = js,je
           do i = is,ie
              v(i,j,ke+1) = -v(i,j,ke)
              u(i,j,ke+1) = -u(i,j,ke)
           enddo
           enddo
        endif
      endif

      if (bcy_lo .eq. PERIODIC) then
        do k = ks-1,ke+1
        do i = is  ,ie
          w(i,js-1,k) = w(i,je,k)
          v(i,js-1,k) = v(i,je,k)
          u(i,js-1,k) = u(i,je,k)
        enddo
        enddo
      elseif (bcy_lo .eq. OUTLET) then
        do k = ks-1,ke+1
        do i = is  ,ie
          w(i,js-1,k) = w(i,js,k)
          v(i,js-1,k) = v(i,js,k)
          u(i,js-1,k) = u(i,js,k)
        enddo
        enddo
      elseif (bcy_lo .eq. INLET) then
        do k = ks-1,ke+1
        do i = is  ,ie
          v(i,js-1,k) =  two* in_yvel - v(i,js,k)
          w(i,js-1,k) =  -w(i,js,k)
          u(i,js-1,k) =  -u(i,js,k)
        enddo
        enddo
      elseif (bcy_lo .eq. WALL) then
        do k = ks-1,ke+1
        do i = is  ,ie
           v(i,js-1,k) =  -v(i,js,k)
           u(i,js-1,k) =  three*u(i,js,k) - three*u(i,js+1,k)+u(i,js+2,k)
           w(i,js-1,k) =  three*w(i,js,k) - three*w(i,js+1,k)+w(i,js+2,k)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do i = is  ,ie
              u(i,js-1,k) =  -u(i,js,k)
              w(i,js-1,k) =  -w(i,js,k)
           enddo
           enddo
        endif
      endif

      if (bcy_hi .eq. PERIODIC) then
        do k = ks-1,ke+1
        do i = is,ie
          w(i,je+1,k) = w(i,js,k)
          v(i,je+1,k) = v(i,js,k)
          u(i,je+1,k) = u(i,js,k)
        enddo
        enddo
      elseif (bcy_hi .eq. OUTLET) then
        do k = ks-1,ke+1
        do i = is,ie
          w(i,je+1,k) = w(i,je,k)
          v(i,je+1,k) = v(i,je,k)
          u(i,je+1,k) = u(i,je,k)
        enddo
        enddo
      elseif (bcy_hi .eq. INLET) then 
        do k = ks-1,ke+1
        do i = is  ,ie
          v(i,je+1,k) = two*in_yvel - v(i,je,k)
          w(i,je+1,k) = - w(i,je,k)
          u(i,je+1,k) = - u(i,je,k)
        enddo
        enddo
      elseif (bcy_hi .eq. WALL) then
        do k = ks-1,ke+1
        do i = is  ,ie
          v(i,je+1,k) = -v(i,je,k)
          w(i,je+1,k) =  three*w(i,je,k) - three*w(i,je-1,k)+w(i,je-2,k)
          u(i,je+1,k) =  three*u(i,je,k) - three*u(i,je-1,k)+u(i,je-2,k)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do i = is  ,ie
              w(i,je+1,k) = -w(i,je,k)
              u(i,je+1,k) = -u(i,je,k)
           enddo
           enddo
        endif
      endif

      if (bcx_lo .eq. PERIODIC) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k) = u(ie,j,k)
          v(is-1,j,k) = v(ie,j,k)
          w(is-1,j,k) = w(ie,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. OUTLET) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k) = u(is,j,k)
          v(is-1,j,k) = v(is,j,k)
          w(is-1,j,k) = w(is,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. INLET) then 
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k) =  two*in_xvel - u(is,j,k)
          v(is-1,j,k) =  - v(is,j,k)
          w(is-1,j,k) =  - w(is,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. WALL) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k) =  -u(is,j,k)
          v(is-1,j,k) =  three*v(is,j,k)-three*v(is+1,j,k)+v(is+2,j,k)
          w(is-1,j,k) =  three*w(is,j,k)-three*w(is+1,j,k)+w(is+2,j,k)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do j = js-1,je+1
              v(is-1,j,k) =  -v(is,j,k)
              w(is-1,j,k) =  -w(is,j,k)
           enddo
           enddo
        endif
      endif

      if (bcx_hi .eq. PERIODIC) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k) = u(is,j,k)
          v(ie+1,j,k) = v(is,j,k)
          w(ie+1,j,k) = w(is,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. OUTLET) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k) = u(ie,j,k)
          v(ie+1,j,k) = v(ie,j,k)
          w(ie+1,j,k) = w(ie,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. INLET) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k) = two *in_xvel - u(ie,j,k)
          v(ie+1,j,k) = - v(ie,j,k)
          w(ie+1,j,k) = - w(ie,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. WALL) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k) = - u(ie,j,k)
          v(ie+1,j,k) =  three*v(ie,j,k)-three*v(ie-1,j,k)+v(ie-2,j,k)
          w(ie+1,j,k) =  three*w(ie,j,k)-three*w(ie-1,j,k)+w(ie-2,j,k)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do j = js-1,je+1
              v(ie+1,j,k) = - v(ie,j,k)
              w(ie+1,j,k) = - w(ie,j,k)
           enddo
           enddo
        endif
      endif

      return
      end


c *************************************************************************
c ** VELINFLOW **
c ** Impose the inflow boundary conditions on velocity
c *************************************************************************

      subroutine velinflow(u,DIMS,time,idir,is_hi)

      implicit none

#include "probdata.H"

      integer DIMS
      REAL_T u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T time
      integer idir,is_hi

c     Local variables
      integer i,j,k

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do k = lo_3-1,hi_3+1 
          do j = lo_2-1,hi_2+1 
            u(lo_1-1,j,k) = in_xvel
          enddo
          enddo
        else
          do k = lo_3-1,hi_3+1 
          do j = lo_2-1,hi_2+1 
            u(hi_1+1,j,k) = in_xvel
          enddo
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          do k = lo_3-1,hi_3+1 
          do i = lo_1-1,hi_1+1 
            u(i,lo_2-1,k) = in_yvel
          enddo
          enddo
        else
          do k = lo_3-1,hi_3+1 
          do i = lo_1-1,hi_1+1 
            u(i,hi_2+1,k) = in_yvel
          enddo
          enddo
        endif

      elseif (idir .eq. 2) then

        if (is_hi .eq. 0) then
          do j = lo_2-1,hi_2+1 
          do i = lo_1-1,hi_1+1 
            u(i,j,lo_3-1) = in_zvel
          enddo
          enddo
        else
          do j = lo_2-1,hi_2+1 
          do i = lo_1-1,hi_1+1 
            u(i,j,hi_3+1) = in_zvel
          enddo
          enddo
        endif

      else
        print *,'bogus idir in velinflow ',idir
        stop
      endif

      return
      end

c *************************************************************************
c ** SCALINFLOW **
c ** Impose the inflow boundary conditions on scalars
c *************************************************************************

      subroutine scalinflow(s,DIMS,time,idir,is_hi,which_scal)

      implicit none

#include "probdata.H"

      integer DIMS
      REAL_T  s(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  time
      integer idir, is_hi
      integer which_scal

c     Local variables
      integer i,j,k
      REAL_T  inflow_val
    
      if (which_scal .eq. 0) then
        inflow_val = in_density
      elseif (which_scal .eq. 1) then
        inflow_val = in_tracer
      else
        print *,"STOP IN SCALINFLOW "
        print *," --  DONT HAVE VALUE FOR THIS VARIABLE "
        stop
      endif

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do k = lo_3-1,hi_3+1 
          do j = lo_2-1,hi_2+1 
            s(lo_1-1,j,k) = inflow_val
          enddo
          enddo
        else
          do k = lo_3-1,hi_3+1 
          do j = lo_2-1,hi_2+1 
            s(hi_1+1,j,k) = inflow_val
          enddo
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          do k = lo_3-1,hi_3+1 
          do i = lo_1-1,hi_1+1 
            s(i,lo_2-1,k) = inflow_val
          enddo
          enddo
        else
          do k = lo_3-1,hi_3+1 
          do i = lo_1-1,hi_1+1 
            s(i,hi_2+1,k) = inflow_val
          enddo
          enddo
        endif

      elseif (idir .eq. 2) then

        if (is_hi .eq. 0) then
          do j = lo_2-1,hi_2+1 
          do i = lo_1-1,hi_1+1 
            s(i,j,lo_3-1) = inflow_val
          enddo
          enddo
        else
          do j = lo_2-1,hi_2+1 
          do i = lo_1-1,hi_1+1 
            s(i,j,hi_3+1) = inflow_val
          enddo
          enddo
        endif

      else

        print *,'bogus idir in scalinflow ',idir
        stop

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: FILCC_1D.F,v 1.1 2001/08/16 23:06:48 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "ArrayLim.H"

#define SDIM 1

c ::: -----------------------------------------------------------
c ::: This routine is intended to be a generic fill function
c ::: for cell-centered data.  It knows how to extrapolate
c ::: and reflect data and is used to supplement the problem-specific
c ::: fill functions which call it.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: q           <=  array to fill
c ::: lo,hi        => index extent of q array
c ::: domlo,domhi  => index extent of problem domain
c ::: dx           => cell spacing
c ::: xlo          => physical location of lower left hand
c :::	              corner of q array
c ::: bc	   => array of boundary flags bc(SPACEDIM,lo:hi)
c ::: 
c ::: NOTE: all corner as well as edge data is filled if not EXT_DIR
c ::: -----------------------------------------------------------

      subroutine filcc(q,DIMS(q),domlo,domhi,dx,xlo,bc)

      integer    DIMDEC(q)
      integer    domlo(SDIM), domhi(SDIM)
      integer    bc(SDIM,2)
      REAL_T     xlo(SDIM), dx(SDIM)
      REAL_T     q(DIMV(q))

      integer    nlft, nrgt
      integer    ilo, ihi
      integer    i
      integer    is, ie

      nlft = max(0,domlo(1)-ARG_L1(q))
      nrgt = max(0,ARG_H1(q)-domhi(1))

      is = max(ARG_L1(q),domlo(1))
      ie = min(ARG_H1(q),domhi(1))

c     ::::: first fill sides
      if (nlft .gt. 0) then
         ilo = domlo(1)

	 if (bc(1,1) .eq. FOEXTRAP) then
	    do i = 1, nlft
	       q(ilo-i) = q(ilo)
	    end do
	 else if (bc(1,1) .eq. HOEXTRAP) then
	    do i = 2, nlft
	       q(ilo-i) = q(ilo) 
	    end do 
            if (ilo+2 .le. ie) then 
               q(ilo-1) = (fifteen*q(ilo) - ten*q(ilo+1) + 
     $                        three*q(ilo+2)) * eighth
            else 
	       q(ilo-1) = half*(three*q(ilo) - q(ilo+1))
            end if
	 else if (bc(1,1) .eq. REFLECT_EVEN) then
	    do i = 1, nlft
	       q(ilo-i) = q(ilo+i-1)
	    end do
	 else if (bc(1,1) .eq. REFLECT_ODD) then
	    do i = 1, nlft
	       q(ilo-i) = -q(ilo+i-1)
	    end do
	 end if
      end if

      if (nrgt .gt. 0) then
         ihi = domhi(1)

	 if (bc(1,2) .eq. FOEXTRAP) then
	    do i = 1, nrgt
	       q(ihi+i) = q(ihi)
	    end do
         else if (bc(1,2) .eq. HOEXTRAP) then
            do i = 2, nrgt
               q(ihi+i) = q(ihi)
            end do
            if (ihi-2 .ge. is) then
	       q(ihi+1) = (fifteen*q(ihi) - ten*q(ihi-1) + 
     $                        three*q(ihi-2)) * eighth
            else
	       q(ihi+1) = half*(three*q(ihi) - q(ihi-1))
            end if
	 else if (bc(1,2) .eq. REFLECT_EVEN) then
	    do i = 1, nrgt
	       q(ihi+i) = q(ihi-i+1)
	    end do
	 else if (bc(1,2) .eq. REFLECT_ODD) then
	    do i = 1, nrgt
	       q(ihi+i) = -q(ihi-i+1)
	    end do
	 end if
      end if

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include <CONSTANTS.H>
#include <REAL.H>
#include <DIMS.H>

#include "main_F.H"


#define TEST_EXT 1
#define POWER 3
#define MUPOWER 3


      subroutine FORT_FILLCRSE (
     $     crse, DIMS(crse),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(crse)
      REAL_T crse(DIMV(crse),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, k, n
      REAL_T x, y, z

      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)

      do k=ARG_L3(crse), ARG_H3(crse)
         z = (k+0.5)*h(3)
         do j=ARG_L2(crse), ARG_H2(crse)
            y = (j + 0.5)*h(2)
            do i=ARG_L1(crse), ARG_H1(crse)
               x = (i + 0.5)*h(1)
               crse(i,j,k,1)=cux*x**POWER+cuy*y**POWER+cuz*z**POWER
               crse(i,j,k,2)=cvx*x**POWER+cvy*y**POWER+cvz*z**POWER
               crse(i,j,k,3)=cwx*x**POWER+cwy*y**POWER+cwz*z**POWER
            enddo
         enddo
      enddo
      
      end
      

      
      subroutine FORT_FILLFINE (
     $     fine, DIMS(fine),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(fine)
      REAL_T fine(DIMV(fine),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, k, n
      REAL_T x, y,z
c
      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)
c
      do k=ARG_L3(fine), ARG_H3(fine)
         z = (k + 0.5)*h(3)
#if TEST_EXT
         if( k.lt.0) z = 0
#endif
         do j=ARG_L2(fine), ARG_H2(fine)
            y = (j + 0.5)*h(2)
#if TEST_EXT
            if( j.lt.0) y = 0
#endif
            do i=ARG_L1(fine), ARG_H1(fine)
               x = (i + 0.5)*h(1)
#if TEST_EXT
               if( i.lt.0) x = 0
#endif
               fine(i,j,k,1)=cux*x**POWER+cuy*y**POWER+cuz*z**POWER
               fine(i,j,k,2)=cvx*x**POWER+cvy*y**POWER+cvz*z**POWER
               fine(i,j,k,3)=cwx*x**POWER+cwy*y**POWER+cwz*z**POWER
            enddo
         enddo
      enddo


      end
      
      subroutine FORT_FILLRHS (
     $     rhs, DIMS(rhs),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(rhs)
      REAL_T rhs(DIMV(rhs),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, k, n
      REAL_T x, y,z
c
      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)
c
      do k=ARG_L3(rhs), ARG_H3(rhs)
         z = (k + 0.5)*h(3)
         do j=ARG_L2(rhs), ARG_H2(rhs)
            y = (j + 0.5)*h(2)
            do i=ARG_L1(rhs), ARG_H1(rhs)
               x = (i + 0.5)*h(1)
#if (POWER==3)&(MUPOWER==3)
               rhs(i,j,k,1)= -(
     -  18*alpha*cux*x**4 + 3*beta*y**2*(3*cvx*x**2 + 3*cuy*y**2) + 
     -  3*gamma*z**2*(3*cwx*x**2 + 3*cuz*z**2) + 
     -  12*cux*x*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  6*cuy*y*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  6*cuz*z*(1 + alpha*x**3 + beta*y**3 + gamma*z**3)
     &              )
               rhs(i,j,k,2)= -(
     -  18*beta*cvy*y**4 + 3*alpha*x**2*(3*cvx*x**2 + 3*cuy*y**2) + 
     -  3*gamma*z**2*(3*cwy*y**2 + 3*cvz*z**2) + 
     -  6*cvx*x*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  12*cvy*y*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  6*cvz*z*(1 + alpha*x**3 + beta*y**3 + gamma*z**3)
     &              )
               rhs(i,j,k,3)= -(
     -  18*cwz*gamma*z**4 + 3*alpha*x**2*(3*cwx*x**2 + 3*cuz*z**2) + 
     -  3*beta*y**2*(3*cwy*y**2 + 3*cvz*z**2) + 
     -  6*cwx*x*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  6*cwy*y*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  12*cwz*z*(1 + alpha*x**3 + beta*y**3 + gamma*z**3)
     &              )
#endif
#if (POWER==2)&(MUPOWER==3)
               rhs(i,j,k,1)= -(
     -   12*alpha*cux*x**3 + 3*beta*y**2*(2*cvx*x + 2*cuy*y) + 
     -  3*gamma*z**2*(2*cwx*x + 2*cuz*z) + 
     -  4*cux*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  2*cuy*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  2*cuz*(1 + alpha*x**3 + beta*y**3 + gamma*z**3)
     &              )
               rhs(i,j,k,2)= -(
     -  12*beta*cvy*y**3 + 3*alpha*x**2*(2*cvx*x + 2*cuy*y) + 
     -  3*gamma*z**2*(2*cwy*y + 2*cvz*z) + 
     -  2*cvx*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  4*cvy*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  2*cvz*(1 + alpha*x**3 + beta*y**3 + gamma*z**3)
     &              )
               rhs(i,j,k,3)= -(
     -  12*cwz*gamma*z**3 + 3*alpha*x**2*(2*cwx*x + 2*cuz*z) + 
     -  3*beta*y**2*(2*cwy*y + 2*cvz*z) + 
     -  2*cwx*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  2*cwy*(1 + alpha*x**3 + beta*y**3 + gamma*z**3) + 
     -  4*cwz*(1 + alpha*x**3 + beta*y**3 + gamma*z**3)
     &              )
#endif
            enddo
         enddo
      enddo


      end
      

      subroutine FORT_MAKEMU(
     $     mu,DIMS(mu),
     $     h, idir )

      integer idir
      integer DIMDEC(mu)
      REAL_T mu(DIMV(mu))
      REAL_T h(BL_SPACEDIM)

      integer i,j,k
      REAL_T x,y,z
c
      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)
c

      if( idir .eq. 0 ) then
         do k=ARG_L3(mu),ARG_H3(mu)
            z = (k+0.5)*h(3)
            do j=ARG_L2(mu),ARG_H2(mu)
               y = (j+0.5)*h(2)
               do i=ARG_L1(mu),ARG_H1(mu)
                  x = (i)*h(1)
                  mu(i,j,k) = 1+alpha*x**MUPOWER+beta*y**MUPOWER+gamma*z**MUPOWER
               enddo
            enddo
         enddo
      else if( idir .eq. 1 ) then
         do k=ARG_L3(mu),ARG_H3(mu)
            z = (k+0.5)*h(3)
            do j=ARG_L2(mu),ARG_H2(mu)
               y = (j)*h(2)
               do i=ARG_L1(mu),ARG_H1(mu)
                  x = (i+0.5)*h(1)
                  mu(i,j,k) = 1+alpha*x**MUPOWER+beta*y**MUPOWER+gamma*z**MUPOWER
               enddo
            enddo
         enddo
      else if( idir .eq. 2 ) then
         do k=ARG_L3(mu),ARG_H3(mu)
            z = (k)*h(3)
            do j=ARG_L2(mu),ARG_H2(mu)
               y = (j+0.5)*h(2)
               do i=ARG_L1(mu),ARG_H1(mu)
                  x = (i+0.5)*h(1)
                  mu(i,j,k) = 1+alpha*x**MUPOWER+beta*y**MUPOWER+gamma*z**MUPOWER
               enddo
            enddo
         enddo
      else
         write(6,*)'FORT_MAKEMU: bad idir'
         stop
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include <CONSTANTS.H>
#include <REAL.H>

#include "main_F.H"

#if 0
c .. 1 is 0
c .. 2 is x
c .. 3 is xy
#define DOGU 1

c .. 1 is y**2
c .. 2 is y
c .. 3 is (24-y)**2
c .. 4 is 0
c .. 5 is x**2
#define DOGV 1

      subroutine FORT_FILLCRSE (
     $     crse, DIMS(crse),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(crse)
      REAL_T crse(DIMV(crse),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, n
      REAL_T x, y
c      
      do n=1,nc
         if( n .eq. 1 ) then
            do j=ARG_L2(crse), ARG_H2(crse)
               y = (j + 0.5)*h(2)
               do i=ARG_L1(crse), ARG_H1(crse)
                  x = (i + 0.5)*h(1)
#if DOGU==1
                  crse(i,j,n)=0
#elif DOGU==2
                  crse(i,j,n)=x
#elif DOGU==3
                  crse(i,j,n)=x*y
#else
                  error is error
#endif
               enddo
            enddo
         else
            do j=ARG_L2(crse), ARG_H2(crse)
               y = (j + 0.5)*h(2)
               do i=ARG_L1(crse), ARG_H1(crse)
                  x = (i + 0.5)*h(1)
#if DOGV==1
                  crse(i,j,n)=y*y
#elif DOGV==2
                  crse(i,j,n)=y
#elif DOGV==3
                  crse(i,j,n)=(24-y)*(24-y)
#elif DOGV==4
                  crse(i,j,n)=0
#elif DOGV==5
                  crse(i,j,n)=x*x
#else
                  error is error
#endif
               enddo
            enddo
         endif
      enddo
      end
      

      
      subroutine FORT_FILLFINE (
     $     fine, DIMS(fine),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(fine)
      REAL_T fine(DIMV(fine),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, n
      REAL_T x, y
c
      do n=1,nc
         if( n .eq. 1 ) then
            do j=ARG_L2(fine), ARG_H2(fine)
               y = (j + 0.5)*h(2)
               do i=ARG_L1(fine), ARG_H1(fine)
                  x = (i + 0.5)*h(1)
                  if( x .gt. 0 ) then
#if DOGU==1
                  fine(i,j,n)=0
#elif DOGU==2
                  fine(i,j,n)=x
#elif DOGU==3
                  fine(i,j,n)=x*y
#else
                  error is error
#endif
                  else
c....................at physical boundary, use homog bc
                     fine(i,j,n) = 0
                  endif
               enddo
            enddo
         else
            do j=ARG_L2(fine), ARG_H2(fine)
               y = (j + 0.5)*h(2)
               do i=ARG_L1(fine), ARG_H1(fine)
                  x = (i + 0.5)*h(1)
                  if( x .gt. 0 ) then
#if DOGV==1
                  fine(i,j,n)=y*y
#elif DOGV==2
                  fine(i,j,n)=y
#elif DOGV==3
                  fine(i,j,n)=(24-y)*(24-y)
#elif DOGV==4
                  fine(i,j,n)=0
#elif DOGV==5
                  fine(i,j,n)=x*x
#else
                  error is error
#endif
                  else
                     fine(i,j,n) = 0
                  endif
               enddo
            enddo
         endif
      enddo
      end
#else
      
#define TEST_EXT 0
#define POWER 3
#define MUPOWER 3


      subroutine FORT_FILLCRSE (
     $     crse, DIMS(crse),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(crse)
      REAL_T crse(DIMV(crse),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, n
      REAL_T x, y

      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)

      do j=ARG_L2(crse), ARG_H2(crse)
         y = (j + 0.5)*h(2)
         do i=ARG_L1(crse), ARG_H1(crse)
            x = (i + 0.5)*h(1)
            crse(i,j,1)=cux*x**POWER+cuy*y**POWER
            crse(i,j,2)=cvx*x**POWER+cvy*y**POWER
         enddo
      enddo
      
      end
      

      
      subroutine FORT_FILLFINE (
     $     fine, DIMS(fine),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(fine)
      REAL_T fine(DIMV(fine),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, n
      REAL_T x, y
c
      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)
c
      do j=ARG_L2(fine), ARG_H2(fine)
         y = (j + 0.5)*h(2)
#if TEST_EXT
         if( j.lt.0) y = 0
#endif
         do i=ARG_L1(fine), ARG_H1(fine)
            x = (i + 0.5)*h(1)
#if TEST_EXT
            if( i.lt.0) x = 0
#endif
            fine(i,j,1)=cux*x**POWER+cuy*y**POWER
            fine(i,j,2)=cvx*x**POWER+cvy*y**POWER
         enddo
      enddo


      end
      
      subroutine FORT_FILLRHS (
     $     rhs, DIMS(rhs),
     $     h, nc
     $     )
      integer nc
      integer DIMDEC(rhs)
      REAL_T rhs(DIMV(rhs),nc)
      REAL_T h(BL_SPACEDIM)
c
      integer  i, j, n
      REAL_T x, y
c
      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)
c
      do j=ARG_L2(rhs), ARG_H2(rhs)
         y = (j + 0.5)*h(2)
         do i=ARG_L1(rhs), ARG_H1(rhs)
            x = (i + 0.5)*h(1)
#if (POWER==3)&(MUPOWER==3)
            rhs(i,j,1)= -(
     -           18*alpha*cux*x**4 + 3*beta*y**2*(3*cvx*x**2 + 3*cuy*y**2) + 
     -           12*cux*x*(1 + alpha*x**3 + beta*y**3) + 
     -           6*cuy*y*(1 + alpha*x**3 + beta*y**3)
     &           )
            rhs(i,j,2)= -(
     -           18*beta*cvy*y**4 + 3*alpha*x**2*(3*cvx*x**2 + 3*cuy*y**2) + 
     -           6*cvx*x*(1 + alpha*x**3 + beta*y**3) + 
     -           12*cvy*y*(1 + alpha*x**3 + beta*y**3) 
     &           )
#endif
#if (POWER==2)&(MUPOWER==3)
            rhs(i,j,1)= -(
     -           12*alpha*cux*x**3 + 3*beta*y**2*(2*cvx*x + 2*cuy*y) + 
     -           4*cux*(1 + alpha*x**3 + beta*y**3) + 
     -           2*cuy*(1 + alpha*x**3 + beta*y**3)
     &           )
            rhs(i,j,2)= -(
     -           12*beta*cvy*y**3 + 3*alpha*x**2*(2*cvx*x + 2*cuy*y) + 
     -           2*cvx*(1 + alpha*x**3 + beta*y**3) + 
     -           4*cvy*(1 + alpha*x**3 + beta*y**3)
     &           )
#endif
         enddo
      enddo
      
      
      end
      
      subroutine FORT_MAKEMU(
     $     mu,DIMS(mu),
     $     h, idir )

      integer idir
      integer DIMDEC(mu)
      REAL_T mu(DIMV(mu))
      REAL_T h(BL_SPACEDIM)

      integer i,j
      REAL_T x,y
c
      REAL_T cux,cuy,cuz
      REAL_T cvx,cvy,cvz
      REAL_T cwx,cwy,cwz
      REAL_T alpha,beta,gamma
      namelist /fortin/ cux,cuy,cuz,
     $     cvx,cvy,cvz,cwx,cwy,cwz,alpha,beta,gamma
c      
      open(9,file='probin',form='formatted',status='old')
      read(9,fortin)
      close(9)
c

      if( idir .eq. 0 ) then
         do j=ARG_L2(mu),ARG_H2(mu)
            y = (j+0.5)*h(2)
            do i=ARG_L1(mu),ARG_H1(mu)
               x = (i)*h(1)
               mu(i,j) = 1+alpha*x**MUPOWER+beta*y**MUPOWER
            enddo
         enddo
      else if( idir .eq. 1 ) then
         do j=ARG_L2(mu),ARG_H2(mu)
            y = (j)*h(2)
            do i=ARG_L1(mu),ARG_H1(mu)
               x = (i+0.5)*h(1)
               mu(i,j) = 1+alpha*x**MUPOWER+beta*y**MUPOWER
            enddo
         enddo
      else
         write(6,*)'FORT_MAKEMU: bad idir'
         stop
      endif
      
      return
      end
      
#endif

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: DERIVE_3D.F,v 1.19 2002/07/22 21:35:32 lijewski Exp $
c

#include "REAL.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"
#include "Derived.H"

#ifdef BL_DERIVE_IAMR
#define TRACER_POSITION 5
#else
#define TRACER_POSITION 6
#endif

      subroutine FORT_SETGAMMA (gam)
      REAL_T gam
#include "xxmeth.fh"	

      gamma = gam
      end

      subroutine FORT_SETALPHA (alp)
      REAL_T alp
#include "xxmeth.fh"	

      alpha = alp
      end

      subroutine FORT_SETQPOS (qpos)
      integer qpos
#include "xxmeth.fh"	

      qposition = qpos
      end
c
c     derive log density:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERLGDN (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k
      REAL_T smallr

      data smallr /1.0e-6/

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = log10(max(u(i,j,k,1),smallr))
               end do
            end do
         end do
      end
c
c     derive density:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERDEN (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,1)
               end do
            end do
         end do
      end
c
c     derive x velocity:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERXVEL (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3 :dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,2)/u(i,j,k,1)
               end do
            end do
         end do
      end
c
c     derive y velocity:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERYVEL (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,3)/u(i,j,k,1)
               end do
            end do
         end do
      end
c
c     derive z velocity:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERZVEL (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,4)/u(i,j,k,1)
               end do
            end do
         end do
      end
c
c     derive total energy  = (rho*E)/rho:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERTENG (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo,xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3,ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,5)/u(i,j,k,1)
               end do
            end do
         end do
      end
c
c     derive total energy  = (rho*(E-(u^2+v^2)/2)/rho:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERIENG (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k
      REAL_T vx,vy,vz,eng

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  vx = u(i,j,k,2)/u(i,j,k,1)
                  vy = u(i,j,k,3)/u(i,j,k,1)
                  vz = u(i,j,k,4)/u(i,j,k,1)
                  eng = u(i,j,k,5)/u(i,j,k,1)
                  dat(i,j,k) = eng - (vx**2+vy**2+vz**2)*half
               end do
            end do
         end do
      end
c
c     derive kenetic energy  = rho(u**2 + v**2 + w**2)/2
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERKENG (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo,xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3,ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k
      REAL_T eng

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  eng = u(i,j,k,2)**2 + u(i,j,k,3)**2 + u(i,j,k,4)**2
                  dat(i,j,k) = half*eng/u(i,j,k,1)
               end do
            end do
         end do
      end
c
c     derive vorticity
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
c     Uses one-sided derivatives at edges.
c
      subroutine FORT_DERVORT (f,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo,xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3,ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T f(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      REAL_T uym,uyp,uy,uzm,uzp,uz
      REAL_T vxm,vxp,vx,vzm,vzp,vz
      REAL_T wxm,wxp,wx,wym,wyp,wy
      REAL_T uc,vc,wc
      REAL_T uy2m,uy2p,uz2m,uz2p
      REAL_T vx2m,vx2p,vz2m,vz2p
      REAL_T wx2m,wx2p,wy2m,wy2p
      REAL_T vorx,vory,vorz
      REAL_T ddx,ddy,ddz
      integer i,j,k

      ddx = half*float(uhii1-uloi1+1)/(xhi(1)-xlo(1))
      ddy = half*float(uhii2-uloi2+1)/(xhi(2)-xlo(2))
      ddz = half*float(uhii3-uloi3+1)/(xhi(3)-xlo(3))

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
		  uc = f(i,j,k,2)/f(i,j,k,1)

		  if (j.eq.ovlo(2).and.j+2.le.ovhi(2)) then
		     uy2p = f(i,j+2,k,2)/f(i,j+2,k,1)
		     uyp  = f(i,j+1,k,2)/f(i,j+1,k,1)
		     uy   = ddy*(-uy2p+4*uyp-3*uc)
		  else if (j.eq.ovlo(2)) then
		     uyp = f(i,j+1,k,2)/f(i,j+1,k,1)
		     uy  = 2*ddy*(uyp-uc)
		  else if (j.eq.ovhi(2).and.j-2.ge.ovlo(2)) then
		     uy2m = f(i,j-2,k,2)/f(i,j-2,k,1)
		     uym  = f(i,j-1,k,2)/f(i,j-1,k,1)
		     uy   = ddy*(+uy2m-4*uym+3*uc)
		  else if (j.eq.ovhi(2)) then
		     uym = f(i,j-1,k,2)/f(i,j-1,k,1)
		     uy  = 2*ddy*(-uym+uc)
		  else if (j.gt.ovlo(2).and.j.lt.ovhi(2) ) then
		     uyp = f(i,j+1,k,2)/f(i,j+1,k,1)
		     uym = f(i,j-1,k,2)/f(i,j-1,k,1)
		     uy  = ddy*(uyp-uym)
		  else
		     write(6,*) 'uy'
		     stop
		  end if

		  if (k.eq.ovlo(3).and.k+2.le.ovhi(3)) then
		     uz2p = f(i,j,k+2,2)/f(i,j,k+2,1)
		     uzp  = f(i,j,k+1,2)/f(i,j,k+1,1)
		     uz   = ddz*(-uz2p+4*uzp-3*uc)
		  else if (k.eq.ovlo(3)) then
		     uzp = f(i,j,k+1,2)/f(i,j,k+1,1)
		     uz  = 2*ddz*(uzp-uc)
		  else if (k.eq.ovhi(3).and.k-2.ge.ovlo(3)) then
		     uz2m = f(i,j,k-2,2)/f(i,j,k-2,1)
		     uzm  = f(i,j,k-1,2)/f(i,j,k-1,1)
		     uz   = ddz*(+uz2m-4*uzm+3*uc)
		  else if (k.eq.ovhi(3)) then
		     uzm = f(i,j,k-1,2)/f(i,j,k-1,1)
		     uz  = 2*ddz*(-uzm+uc)
		  else if (k.gt.ovlo(3) .and. k.lt.ovhi(3)) then
		     uzp = f(i,j,k+1,2)/f(i,j,k+1,1)
		     uzm = f(i,j,k-1,2)/f(i,j,k-1,1)
		     uz  = ddz*(uzp-uzm)
		  else
		     write(6,*) 'uz'
		     stop
		  end if

		  vc = f(i,j,k,3)/f(i,j,k,1)

		  if (i.eq.ovlo(1).and.i+2.le.ovhi(1)) then
		     vx2p = f(i+2,j,k,3)/f(i+2,j,k,1)
		     vxp = f(i+1,j,k,3)/f(i+1,j,k,1)
		     vx = ddx*(-vx2p+4*vxp-3*vc)
		  else if (i.eq.ovlo(1)) then
		     vxp = f(i+1,j,k,3)/f(i+1,j,k,1)
		     vx = 2*ddx*(vxp-vc)
		  else if (i.eq.ovhi(1).and.i-2.ge.ovlo(1)) then
		     vx2m = f(i-2,j,k,3)/f(i-2,j,k,1)
		     vxm = f(i-1,j,k,3)/f(i-1,j,k,1)
		     vx = ddx*(+vx2m-4*vxm+3*vc)
		  else if (i.eq.ovhi(1)) then
		     vxm = f(i-1,j,k,3)/f(i-1,j,k,1)
		     vx = 2*ddx*(-vxm+vc)
		  else if (i.gt.ovlo(1).and.i.lt.ovhi(1)) then
		     vxp = f(i+1,j,k,3)/f(i+1,j,k,1)
		     vxm = f(i-1,j,k,3)/f(i-1,j,k,1)
		     vx = ddx*(vxp-vxm)
		  else
		     write(6,*) 'vx'
		     stop
		  end if

		  if (k.eq.ovlo(3).and.k+2.le.ovhi(3)) then
		     vz2p = f(i,j,k+2,3)/f(i,j,k+2,1)
		     vzp  = f(i,j,k+1,3)/f(i,j,k+1,1)
		     vz   = ddz*(-vz2p+4*vzp-3*vc)
		  else if (k.eq.ovlo(3)) then
		     vzp = f(i,j,k+1,3)/f(i,j,k+1,1)
		     vz  = 2*ddz*(vzp-vc)
		  else if (k.eq.ovhi(3).and.k-2.ge.ovlo(3)) then
		     vz2m = f(i,j,k-2,3)/f(i,j,k-2,1)
		     vzm  = f(i,j,k-1,3)/f(i,j,k-1,1)
		     vz   = ddz*(+vz2m-4*vzm+3*vc)
		  else if (k.eq.ovhi(3)) then
		     vzm = f(i,j,k-1,3)/f(i,j,k-1,1)
		     vz  = 2*ddz*(-vzm+vc)
		  else if (k.gt.ovlo(3).and.k.lt.ovhi(3)) then
		     vzp = f(i,j,k+1,3)/f(i,j,k+1,1)
		     vzm = f(i,j,k-1,3)/f(i,j,k-1,1)
		     vz  = ddz*(vzp-vzm)
		  else
		     write(6,*) 'vz'
		     stop
		  end if

                  wc = f(i,j,k,4)/f(i,j,k,1)

		  if (i.eq.ovlo(1).and.i+2.le.ovhi(1)) then
		     wx2p = f(i+2,j,k,4)/f(i+2,j,k,1)
		     wxp  = f(i+1,j,k,4)/f(i+1,j,k,1)
		     wx   = ddx*(-wx2p+4*wxp-3*wc)
		  else if (i.eq.ovlo(1)) then
		     wxp = f(i+1,j,k,4)/f(i+1,j,k,1)
		     wx  = 2*ddx*(wxp-wc)
		  else if (i.eq.ovhi(1).and.i-2.ge.ovlo(1)) then
		     wx2m = f(i-2,j,k,4)/f(i-2,j,k,1)
		     wxm  = f(i-1,j,k,4)/f(i-1,j,k,1)
		     wx   = ddx*(+wx2m-4*wxm+3*wc)
		  else if (i.eq.ovhi(1)) then
		     wxm = f(i-1,j,k,4)/f(i-1,j,k,1)
		     wx  = 2*ddx*(-wxm+wc)
		  else if (i.gt.ovlo(1).and.i.lt.ovhi(1)) then
		     wxp = f(i+1,j,k,4)/f(i+1,j,k,1)
		     wxm = f(i-1,j,k,4)/f(i-1,j,k,1)
		     wx  = ddx*(wxp-wxm)
		  else
		     write(6,*) 'wx'
		     stop
		  end if

		  if (j.eq.ovlo(2).and.j+2.le.ovhi(2)) then
		     wy2p = f(i,j+2,k,4)/f(i,j+2,k,1)
		     wyp  = f(i,j+1,k,4)/f(i,j+1,k,1)
		     wy   = ddy*(-wy2p+4*wyp-3*wc)
		  else if (j.eq.ovlo(2)) then
		     wyp = f(i,j+1,k,4)/f(i,j+1,k,1)
		     wy  = 2*ddy*(wyp-wc)
		  else if (j.eq.ovhi(2).and.j-2.ge.ovlo(2)) then
		     wy2m = f(i,j-2,k,4)/f(i,j-2,k,1)
		     wym  = f(i,j-1,k,4)/f(i,j-1,k,1)
		     wy   = ddy*(+wy2m-4*wym+3*wc)
		  else if (j.eq.ovhi(2)) then
		     wym = f(i,j-1,k,4)/f(i,j-1,k,1)
		     wy  = 2*ddy*(-wym+wc)
		  else if (j.gt.ovlo(2).and.j.lt.ovhi(2)) then
		     wyp = f(i,j+1,k,4)/f(i,j+1,k,1)
		     wym = f(i,j-1,k,4)/f(i,j-1,k,1)
		     wy  = ddy*(wyp-wym)
		  else
		     write(6,*) 'wy'
		     stop
		  end if

                  vorx = wy-vz
                  vory = uz-wx
                  vorz = vx-uy

                  dat(i,j,k) = sqrt(vorx**2+vory**2+vorz**2)
               end do
            end do
         end do
      end

c
c     derive concentration variable
c
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERCON (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo,xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3,ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
c                 dat(i,j,k) = u(i,j,k,nvar)/u(i,j,k,1)
c JBB
                  dat(i,j,k) = u(i,j,k,nvar)
               end do
            end do
         end do
      end
c
c      SUMMASS
c   
c      MASS = sum{ vol(i,j)*rho(i,j) }
c   
c      Inputs / Outputs:
c   
c      rho        => density field
c      rlo,rhi    => index limits of rho aray
c      lo,hi      => index limits of grid interior
c      delta      => cell size
c      sum        <=  total mass
c      tmp        => temp column array
c
       subroutine FORT_SUMMASS (rho,DIMS(rho),DIMS(grid),delta,sum,tmp)
       integer DIMDEC(rho)
       integer DIMDEC(grid)
       REAL_T  sum, delta(3)
       REAL_T  rho(DIMV(rho))
       REAL_T  tmp(DIM2(grid))

       integer i, j, k
       REAL_T  dx, dy, dz, vol

       dx = delta(1)
       dy = delta(2)
       dz = delta(3)
       vol = dx*dy*dz

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do k = ARG_L3(grid), ARG_H3(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             do j = ARG_L2(grid), ARG_H2(grid)
                tmp(j) = tmp(j) + vol*rho(i,j,k)
             end do
          end do
       end do

       sum = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          sum = sum + tmp(j)
       end do
       end
c
c      SUMCONC
c   
c      CONC = sum{ vol(i,j,k)*conc(i,j,k)*(1-conc(i,j,k) }
c   
c      Inputs / Outputs:
c   
c      conc       => concentration
c      rlo,rhi    => index limits of rho aray
c      lo,hi      => index limits of grid interior
c      delta      => cell size
c      sum        <= concentration sum
c      tmp        => temp column array
c
       subroutine FORT_SUMCONC (conc,DIMS(conc),DIMS(grid),delta,sum,tmp)
       integer DIMDEC(conc)
       integer DIMDEC(grid)
       REAL_T  sum, delta(3)
       REAL_T  conc(DIMV(conc))
       REAL_T  tmp(DIM2(grid))

       integer i, j, k
       REAL_T  dx, dy, dz, vol

       dx = delta(1)
       dy = delta(2)
       dz = delta(3)
       vol = dx*dy*dz

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do k = ARG_L3(grid), ARG_H3(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             do j = ARG_L2(grid), ARG_H2(grid)
c               tmp(j) = tmp(j) + vol * conc(i,j,k) * (1-conc(i,j,k))
c JBB
                tmp(j) = tmp(j) + vol * conc(i,j,k) 
             end do
          end do
       end do

       sum = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          sum = sum + tmp(j)
       end do
       end
c
c      SUMVORT
c   
c      VORT = sum{ vol(i,j,k)*vort(i,j,k)**2 }
c   
c      Inputs / Outputs:
c   
c      vort       => vorticity
c      vlo,vhi    => index limits of vorticity array
c      lo,hi      => index limits of grid interior
c      delta      => cell size
c      sum        <= vorticity sum
c      tmp        => temp column array
c
       subroutine FORT_SUMVORT (vort,DIMS(vort),DIMS(grid),delta,sum,tmp)
       integer DIMDEC(vort)
       integer DIMDEC(grid)
       REAL_T  sum, delta(3)
       REAL_T  vort(DIMV(vort))
       REAL_T  tmp(DIM2(grid))

       integer i, j, k
       REAL_T  dx, dy, dz, vol

       dx = delta(1)
       dy = delta(2)
       dz = delta(3)
       vol = dx*dy*dz

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do k = ARG_L3(grid), ARG_H3(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             do j = ARG_L2(grid), ARG_H2(grid)
                tmp(j) = tmp(j) + vol*vort(i,j,k) * vort(i,j,k)
             end do
          end do
       end do

       sum = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          sum = sum + tmp(j)
       end do
       end

c
c     derive dilitation
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
c     Uses one-sided derivatives at edges.
c
      subroutine FORT_DERDILI (f,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo,xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3,ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T f(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      REAL_T ux2m,ux2p,uxm,uxp,ux
      REAL_T vy2m,vy2p,vym,vyp,vy
      REAL_T wz2m,wz2p,wzm,wzp,wz
      REAL_T uc,vc,wc
      REAL_T ddx,ddy,ddz
      integer i,j,k

      ddx = half*float(uhii1-uloi1+1)/(xhi(1)-xlo(1))
      ddy = half*float(uhii2-uloi2+1)/(xhi(2)-xlo(2))
      ddz = half*float(uhii3-uloi3+1)/(xhi(3)-xlo(3))

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
		  uc = f(i,j,k,2)/f(i,j,k,1)

		  if (i.eq.ovlo(1).and.i+2.le.ovhi(1)) then
		     ux2p = f(i+2,j,k,2)/f(i+2,j,k,1)
		     uxp = f(i+1,j,k,2)/f(i+1,j,k,1)
		     ux = ddx*(-ux2p+4*uxp-3*uc)
		  else if (i.eq.ovlo(1)) then
		     uxp = f(i+1,j,k,2)/f(i+1,j,k,1)
		     ux = 2*ddx*(uxp-uc)
		  else if (i.eq.ovhi(1).and.i-2.ge.ovlo(1)) then
		     ux2m = f(i-2,j,k,2)/f(i-2,j,k,1)
		     uxm = f(i-1,j,k,2)/f(i-1,j,k,1)
		     ux = ddx*(+ux2m-4*uxm+3*uc)
		  else if (i.eq.ovhi(1)) then
		     uxm = f(i-1,j,k,2)/f(i-1,j,k,1)
		     ux = 2*ddx*(-uxm+uc)
		  else if (i.gt.ovlo(1).and.i.lt.ovhi(1)) then
		     uxp = f(i+1,j,k,2)/f(i+1,j,k,1)
		     uxm = f(i-1,j,k,2)/f(i-1,j,k,1)
		     ux = ddx*(uxp-uxm)
		  else
		     write(6,*) 'ux'
		     stop
		  end if

		  vc = f(i,j,k,3)/f(i,j,k,1)

		  if (j.eq.ovlo(2).and.j+2.le.ovhi(2)) then
		     vy2p = f(i,j+2,k,3)/f(i,j+2,k,1)
		     vyp  = f(i,j+1,k,3)/f(i,j+1,k,1)
		     vy   = ddy*(-vy2p+4*vyp-3*vc)
		  else if (j.eq.ovlo(2)) then
		     vyp = f(i,j+1,k,3)/f(i,j+1,k,1)
		     vy  = 2*ddy*(vyp-vc)
		  else if (j.eq.ovhi(2).and.j-2.ge.ovlo(2)) then
		     vy2m = f(i,j-2,k,3)/f(i,j-2,k,1)
		     vym  = f(i,j-1,k,3)/f(i,j-1,k,1)
		     vy   = ddy*(+vy2m-4*vym+3*vc)
		  else if (j.eq.ovhi(2)) then
		     vym = f(i,j-1,k,3)/f(i,j-1,k,1)
		     vy  = 2*ddy*(-vym+vc)
		  else if (j.gt.ovlo(2).and.j.lt.ovhi(2) ) then
		     vyp = f(i,j+1,k,3)/f(i,j+1,k,1)
		     vym = f(i,j-1,k,3)/f(i,j-1,k,1)
		     vy  = ddy*(vyp-vym)
		  else
		     write(6,*) 'vy'
		     stop
		  end if

		  wc = f(i,j,k,4)/f(i,j,k,1)

		  if (k.eq.ovlo(3).and.k+2.le.ovhi(3)) then
		     wz2p = f(i,j,k+2,4)/f(i,j,k+2,1)
		     wzp  = f(i,j,k+1,4)/f(i,j,k+1,1)
		     wz   = ddz*(-wz2p+4*wzp-3*wc)
		  else if (k.eq.ovlo(3)) then
		     wzp = f(i,j,k+1,4)/f(i,j,k+1,1)
		     wz  = 2*ddz*(wzp-wc)
		  else if (k.eq.ovhi(3).and.k-2.ge.ovlo(3)) then
		     wz2m = f(i,j,k-2,4)/f(i,j,k-2,1)
		     wzm  = f(i,j,k-1,4)/f(i,j,k-1,1)
		     wz   = ddz*(+wz2m-4*wzm+3*wc)
		  else if (k.eq.ovhi(3)) then
		     wzm = f(i,j,k-1,4)/f(i,j,k-1,1)
		     wz  = 2*ddz*(-wzm+wc)
		  else if (k.gt.ovlo(3) .and. k.lt.ovhi(3)) then
		     wzp = f(i,j,k+1,4)/f(i,j,k+1,1)
		     wzm = f(i,j,k-1,4)/f(i,j,k-1,1)
		     wz  = ddz*(wzp-wzm)
		  else
		     write(6,*) 'wz'
		     stop
		  end if

                  dat(i,j,k) = ux + vy + wz
               end do
            end do
         end do
      end

c
c      The following routine does NOT have the signature of a derived function.
c
c      BINTRAC
c   
c      Bin the tracer for concentration in the following intervals:
c
c           (0.25, 0.75), (0.1, 0.9) & (0.05, 0.95)
c   
c      Inputs / Outputs:
c   
c      trac       => tracer (rho(i,j,k)*conc(i,j,k))
c      rho        => density
c      DIMS(c)    => index limits of rho and trac arrays
c      lo,hi      => index limits of grid interior
c      delta      => cell size
c      sum        <= concentration sum
c
       subroutine FORT_BINTRAC (trac,DIMS(c),rho,lo,hi,delta,sum)

       integer DIMDEC(c)
       integer lo(3), hi(3)
       REAL_T  sum(3), delta(3)
       REAL_T  trac(DIMV(c))
       REAL_T  rho(DIMV(c))

       integer i, j, k
       REAL_T  vol,conc

       vol = delta(1)*delta(2)*delta(3)

       do i = 1, 3
          sum(i) = zero
       end do

       do k = lo(3), hi(3)
          do i = lo(1), hi(1)
             do j = lo(2), hi(2)

                if (rho(i,j,k) .gt. 0) then

                   conc = trac(i,j,k) / rho(i,j,k)
                
                   if ((conc .gt. .25) .and. (conc .lt. .75)) then
                      sum(1) = sum(1) + vol * trac(i,j,k)
                   end if

                   if ((conc .gt. .1) .and. (conc .lt. .9)) then
                      sum(2) = sum(2) + vol * trac(i,j,k)
                   end if

                   if ((conc .gt. .05) .and. (conc .lt. .95)) then
                      sum(3) = sum(3) + vol * trac(i,j,k)
                   end if

                end if

             end do
          end do
       end do

       end
c
c     derive tracer:  
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     dat         <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of dat array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERTRAC (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,TRACER_POSITION)
               end do
            end do
         end do
      end



c
      subroutine FORT_DERTMASK (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)
      REAL_T ryco, ryco2

      integer i,j,k

#include "xxmeth.fh"	

c     write(6,*) 'FORT_DERTMASK:  using alpha = ', alpha

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  ryco2 = u(i,j,k,9)
                  ryco  = u(i,j,k,11)
		  if (abs(ryco2).gt.alpha*abs(ryco)) then
                    dat(i,j,k) = u(i,j,k,6)
		  else
                    dat(i,j,k) = 0.0
		  endif
               end do
            end do
         end do
      end


c
      subroutine FORT_DERSTATE (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo, xhi,dat,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3, ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T dat(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k

#include "xxmeth.fh"	

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
                  dat(i,j,k) = u(i,j,k,qposition)
               end do
            end do
         end do
      end




c
c                          sqrt(u**2 + v**2 + w**2)
c     derive mach number = ------------------------
c                           sqrt(gamma * pres / rho)
c     
c     Inputs/Outputs
c     u            =>  (const)  state array
c     ulo,uhi      =>  (const)  index limits of u
c     nvar         =>  (const)  number of variables in state array
c     xlo          =>  (const)  physical location of lo end of u
c     xhi          =>  (const)  physical location of hi end of u
c     mach        <=>  (modify) array holding derived data
c     dlo,dhi      =>  (const)  index limits of mach array
c     ovlo,ovhi    =>  (const)  subregion where derivation is done
c
      subroutine FORT_DERMACH (u,uloi1,uloi2,uloi3,uhii1,uhii2,uhii3,
     $ nvar,xlo,xhi,mach,dloi1,dloi2,dloi3,dhii1,dhii2,dhii3,ovlo,ovhi)

      integer uloi1,uloi2,uloi3
      integer uhii1,uhii2,uhii3
      integer dloi1,dloi2,dloi3
      integer dhii1,dhii2,dhii3

      integer ovlo(3), ovhi(3)
      integer nvar
      REAL_T vx, vy, vz
      REAL_T xlo(3), xhi(3)
      REAL_T u(uloi1:uhii1, uloi2:uhii2, uloi3:uhii3, nvar)
      REAL_T mach(dloi1:dhii1, dloi2:dhii2, dloi3:dhii3)

      integer i,j,k
      REAL_T vvtmp, rho, c, eng, pres
#include "xxmeth.fh"	

      do k = ovlo(3),ovhi(3) 
          do j = ovlo(2),ovhi(2) 
              do i = ovlo(1),ovhi(1) 
		  rho = u(i,j,k,1)
                  vx = u(i,j,k,2)/rho
                  vy = u(i,j,k,3)/rho
                  vz = u(i,j,k,4)/rho

                  vvtmp = vx**2 + vy**2 + vz**2
		  eng = u(i,j,k,5) - half * rho * vvtmp
		  pres = eng * (gamma - one)
		  c = sqrt(gamma * pres / rho)
                  mach(i,j,k) = sqrt(vvtmp) / c
               end do
            end do
         end do
      end

       subroutine FORT_SELECTPOS (prob,DIMS(c),rn,dx,dy,dz,x,y,z)

       implicit none

       integer DIMDEC(c)
       REAL_T  prob(DIMV(c))
       REAL_T  dx,dy,dz,x,y,z,rn

       integer ix, iy, iz

       do iz = c_l3, c_h3-1
           if (rn.le.prob(c_h1,c_h2,iz)) go to 100
       enddo

100    continue

       do iy = c_l2, c_h2-1
           if (rn.le.prob(c_h1,iy,iz)) go to 200
       enddo

200    continue

       do ix = c_l1, c_h1-1
          if (rn.le.prob(ix,iy,iz)) go to 300
       enddo

300    continue

       x = (ix+half)*dx
       y = (iy+half)*dy
       z = (iz+half)*dz

       end

      subroutine FORT_PROBFAB (rf,DIMS(c),rr,prob,DIMS(p),
     &                         nspec,nreac,ispec,
     &                         edges,edgeslen,pedges,isrz,dx,dy,dz)

       implicit none

       integer DIMDEC(c), DIMDEC(p), nspec, nreac, ispec, isrz
       integer edgeslen, edges(0:edgeslen-1), pedges(0:nspec-1)
       REAL_T  rf(DIMV(c),0:nreac-1)
       REAL_T  rr(DIMV(c),0:nreac-1)
       REAL_T  prob(DIMV(p)), dx, dy, dz

       integer ix, iy, iz, ie, nedges, rxnid, factor, nu
       REAL_T  lambda, lmax

       if (ispec.lt.zero.or.ispec.gt.nspec-1) stop 'invalid ispec'

       nedges = edges(pedges(ispec))

       do iz = p_l3, p_h3
          do iy = p_l2, p_h2
             do ix = p_l1, p_h1

                lambda = 0

                do ie = 0, nedges-1

                   rxnid  = edges(pedges(ispec)+ie*4+1)
                   factor = edges(pedges(ispec)+ie*4+2)
                   nu     = edges(pedges(ispec)+ie*4+4)

                   if (factor.gt.zero) then
                      lambda = nu*lambda + rf(ix,iy,iz,rxnid)/factor
                   else
                      lambda = nu*lambda - rr(ix,iy,iz,rxnid)/factor
                   end if

                end do

                prob(ix,iy,iz) = lambda*dx*dy*dz

             end do
          end do
       enddo

       end

       subroutine FORT_ACCUMPROB (prob, DIMS(p), totreact, cumprob)

       implicit none

       integer DIMDEC(p)
       REAL_T  prob(DIMV(p)), totreact, cumprob

       integer ix, iy, iz

       do iz = p_l3, p_h3
          do iy = p_l2, p_h2
             do ix = p_l1, p_h1

                prob(ix,iy,iz) = cumprob+prob(ix,iy,iz)/totreact
                cumprob        = prob(ix,iy,iz)

             enddo
          enddo
       enddo

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** SCALUPD **
c ** Update the scalars using conservative or convective differencing of fluxes
c *************************************************************************

      subroutine scalupd(s,sn,sedgex,sedgey,uadv,vadv,
     $                   diff,force,areax,areay,vol,DIMS,
     $                   dx,dt,is_conserv,numscal)

      implicit none

      integer DIMS
      integer numscal
      REAL_T       s(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal)
      REAL_T      sn(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal)
      REAL_T  sedgex(lo_1  :hi_1+1,lo_2  :hi_2  ,numscal)
      REAL_T  sedgey(lo_1  :hi_1  ,lo_2  :hi_2+1,numscal)
      REAL_T    uadv(lo_1:hi_1+1,lo_2:hi_2  )
      REAL_T    vadv(lo_1:hi_1  ,lo_2:hi_2+1)
      REAL_T    diff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T   areax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T   areay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T     vol(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T dx(2)
      REAL_T dt
      integer is_conserv(numscal)

c     Local variables
      REAL_T  divsu
      REAL_T  uconv
      REAL_T  vconv
      integer i,j,n

      do n = 1, numscal

      if (is_conserv(n) .eq. 1) then

        do j = lo_2,hi_2
        do i = lo_1,hi_1

          divsu = ( sedgex(i+1,j,n)*uadv(i+1,j)*areax(i+1,j) - 
     $              sedgex(i  ,j,n)*uadv(i  ,j)*areax(i  ,j)
     $            + sedgey(i,j+1,n)*vadv(i,j+1)*areay(i,j+1) - 
     $              sedgey(i,j  ,n)*vadv(i,j  )*areay(i,j  ) ) / vol(i,j)

          sn(i,j,n) = s(i,j,n) - dt*divsu + half*dt*diff(i,j,n)+dt*force(i,j,n)

        enddo
        enddo
 
      else 

        do j = lo_2,hi_2
        do i = lo_1,hi_1

          uconv = half * (uadv(i+1,j) + uadv(i,j))
          vconv = half * (vadv(i,j+1) + vadv(i,j))

          divsu = uconv * (sedgex(i+1,j,n) - sedgex(i,j,n)) / dx(1)  +
     $            vconv * (sedgey(i,j+1,n) - sedgey(i,j,n)) / dx(2) 

          sn(i,j,n) = s(i,j,n) - dt*divsu + half*dt*diff(i,j,n) + dt*force(i,j,n)

        enddo
        enddo

      endif

      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#undef  BL_LANG_CC
#define BL_LANG_FORT

//#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "INTERP_F.H"
#include "ArrayLim.H"

#include "ONE_D.H"


#define IX_PROJ(A,B) (A+B*iabs(A))/B-iabs(A)
#define SDIM BL_SPACEDIM

c ::: --------------------------------------------------------------
c ::: nbinterp:  node based bilinear interpolation
c ::: 
c ::: INPUTS/OUTPUTS
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: DIMS(fb)     =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data widened by 1 zone
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c ::: 
c ::: lratio       =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: num_slp      =>  (const)  number of types of slopes
c ::: strip_lo,strip_hi  =>  (const)  index limits of strip array
c ::: 
c :::  ::: TEMPORARY ARRAYS
c ::: sl           =>  num_slp 1-D slope arrays
c ::: strip        =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_NBINTERP (crse, DIMS(crse), DIMS(cb),
     $                          fine, DIMS(fine), DIMS(fb),
     $		                lratio, nvar,
     $                          sl, num_slp, strip, strip_lo, strip_hi)

      integer DIMDEC(crse)
      integer DIMDEC(cb)
      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer lratio, nvar
      integer num_slp
      integer strip_lo, strip_hi
      REAL_T  fine(DIMV(fine), nvar)
      REAL_T  crse(DIMV(crse), nvar)
      REAL_T    sl(DIM1(cb),num_slp)
      REAL_T strip(strip_lo:strip_hi,0:lratio)

#define  SLX 1
#define  SLY 2
#define  SLXY 3

c ::: local var
      integer lx, ly, lz
      integer i,j,k,ii,jj,kk,n
      integer ibeg,iend,jstrs,jends,jbeg,jend
      integer lys,lye
      REAL_T invratio

      invratio = one/dble(lratio)
      ibeg = max( ARG_L1(cb)*lratio, ARG_L1(fine) )
      iend = min( ARG_H1(cb)*lratio, ARG_H1(fine) )

      do 100 n = 1, nvar 
c         ::: first fill a strip that will fit
          do i = ARG_L1(cb), ARG_H1(cb)-1 
            sl(i,SLX) = invratio*(crse(i+1,n)-crse(i,n))
          enddo
          i = ARG_H1(cb)

            do lx = 0, lratio-1
              do i = ARG_L1(cb), ARG_H1(cb)-1 
                ii = i*lratio + lx
                strip(ii,0) = crse(i,n)
     $		             + dble(lx)*sl(i,SLX) 
	      enddo
	    enddo
            i = ARG_H1(cb)
            ii = i*lratio
            strip(ii,0) = crse(i,n) 
c ::: copy on intersection
            do i = ibeg,iend 
              fine(i,n) = strip(i,0)
            enddo
100   continue
      return
      end

#undef  SLX
#undef  SLY
#undef  SLXY

c ::: 
c ::: --------------------------------------------------------------
c ::: cbinterp:  cell centered bilinear interpolation
c ::: 
c ::: NOTE: it is assumed that the coarse grid array is
c ::: large enough to define interpolated values
c ::: in the region fblo:fbhi on the fine grid
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: DIMS(fb)     =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data 
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c ::: 
c ::: lratio       =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: 
c ::: TEMPORARY ARRAYS
c ::: slx,sly,slxy =>  1-D slope arrays
c ::: strip        =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_CBINTERP (crse, DIMS(crse), DIMS(cb),
     $                          fine, DIMS(fine), DIMS(fb),
     $		                lratio, nvar,
     $                          sl, num_slp, strip, strip_lo, strip_hi)

      integer DIMDEC(crse)
      integer DIMDEC(cb)
      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer lratio, nvar
      integer num_slp
      integer strip_lo, strip_hi
      REAL_T  fine(DIMV(fine), nvar)
      REAL_T  crse(DIMV(crse), nvar)
      REAL_T    sl(DIM1(cb),num_slp)
      REAL_T strip(strip_lo:strip_hi)

#define SLX 1
#define SLY 2
#define SLXY 3

c ::: local var
      integer lx, ly
      integer hrat, ic, jc, jfn, jfc, i, j, n
      REAL_T x, y
      REAL_T denom

      denom = one/dble(2*lratio)
      hrat = lratio/2
      do 200 n = 1, nvar 
c ::: first fill a strip that will fit
          do ic = ARG_L1(cb),ARG_H1(cb)-1
            sl(ic,SLX) = crse(ic+1,n)-crse(ic,n)
	  enddo

            do lx = 0, lratio-1
              do ic = ARG_L1(cb), ARG_H1(cb)-1
                i = ic*lratio + lx
                x = denom*(two*lratio + one)
                strip(i) = crse(ic,n) + x*sl(ic,SLX) 
	      enddo
	    enddo

c ::: stuff into output array
            do i = ARG_L1(fb), ARG_H1(fb) 
              fine(i,n) = strip(i-hrat)
            enddo
230       continue
200   continue

      return
      end

#undef  SLX
#undef  SLY
#undef  SLXY

c ::: 
c ::: --------------------------------------------------------------
c ::: ccinterp:   conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio       =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: and unrolled
c ::: clo,chi      =>  (const)  one dimensional limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c :::				slopes are to be defined. This is
c :::				the projection of (fblo,fbhi) down
c :::				to the coarse level 
c ::: fslo,fshi    =>  (const)  fine grid index limits where
c :::				slopes are needed.  This is the
c :::				refinement of (cslo,cshi) and
c :::				contains but may not be identical
c :::				to (fblo,fbhi).
c ::: cslope       =>  (modify) temp array coarse grid slopes
c ::: clen         =>  (const)  length of coarse gtid slopes
c ::: fslope       =>  (modify) temp array for fine grid slope
c ::: flen         =>  (const)  length of fine grid slope array
c ::: fdat         =>  (const)  temp array for fine grid data
c ::: limslope     =>  (const)  != 0 => limit slopes
c :::
c ::: NOTE: data must be sent in so that 
c :::	    cslope(1,*) and crse(1,*) are associated with
c :::	    the same cell
c :::
c ::: EXAMPLE:
c ::: Suppose the patch called "fine" has index extent:
c ::: 
c ::: floi1 = 3, fhii1 = 12
c ::: floi2 = 8, fhii2 = 20
c ::: 
c ::: suppose the subergion of this patch that is to be filled 
c ::: by interpolation has index extent:
c ::: 
c ::: fblo(1) = 5, fbhi(1) = 10
c ::: fblo(2) = 13, fbhi(2) = 20
c ::: 
c ::: suppose the refinement ratio is 2
c ::: 
c ::: Then the coarsening of this subregion (to level 0) is
c ::: 
c ::: cb_l1 = 2  cb_h1 = 5         (ncbx = 4)
c ::: cb_l2 = 6  cb_h2 = 10        (ncby = 5)
c ::: 
c ::: In order to compute slopes, we need one extra row of
c ::: coarse grid zones:
c ::: 
c ::: cslo(1) = 1  cshi(1) = 6         (ncsx = 6)
c ::: cslo(2) = 5  cshi(2) = 11        (ncsy = 7)
c ::: 
c ::: This is the size of the coarse grid array of data that filpatch 
c ::: has filled at level 0.
c ::: The "cslope" and "crse" arrays are this size.
c ::: 
c ::: In order to unroll the slope calculation we make these arrays look
c ::: like 1-D arrays.  The mapping from 2-D to 1-D is as fillows:
c ::: 
c ::: The point (cb_l(1),cb_l(2)) -> 1
c ::: The point (cslo(1),cslo(2)) -> clo = 1 - 1 - ncsx = -6
c ::: 
c ::: The point (cb_h1,cb_h2) -> clen = ncby*ncsx - 2 = 5*6-2 = 28
c ::: The point (cshi(1),cshi(2)) -> chi = clo + ncsx*ncsy - 1 
c :::                                    =  -6 +    6*7    - 1 = 35
c ::: 
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |  chi  |  
c :::  11  |   30  |   31  |   32  |   33  |   34  |   35  |   cshi(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |  clen |       |  
c :::  10  |   24  |   25  |   26  |   27  |   28  |   29  |   cb_h(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   9  |   18  |   19  |   20  |   21  |   22  |   23  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   8  |   12  |   13  |   14  |   15  |   16  |   17  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   7  |    6  |    7  |    8  |    9  |   10  |   11  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   6  |    0  |    1  |    2  |    3  |    4  |    5  |   cb_l(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |  clo  |       |       |       |       |       |  
c :::   5  |   -6  |   -5  |   -4  |   -3  |   -2  |   -1  |   cslo(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::          1       2       3       4       5       6
c :::               cb_l1                   cb_h1
c :::       cslo(1)                                 cshi(1)
c ::: 
c ::: 
c ::: In the 1-D coordinates:
c :::    ist = 1    = stride in I direction
c :::    jst = 6    = stride in J direction  (ncsx)
c ::: 
c ::: --------------------------------------------------------------
c ::: 
#if 0
      subroutine FORT_CCINTERP (fine, DIMS(fine), 
     $                          fb_l1, fb_h1, 
     $                          nvar, lratio, crse, clo, chi, 
     $                          cb_l1, cb_h1,
     $		                fslo, fshi, cslope, clen, fslope, fdat,
     $                          flen, voff, bc, limslope,
     $                          fvcx, cvcx)


      integer DIMDEC(fine)
      integer fslo(1), fshi(1)
      integer fb_l1, fb_h1
      integer cb_l1, cb_h1
      integer clo, chi
      integer lratio, nvar, clen, flen, limslope
      integer bc(1,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 2)
      REAL_T fslope(flen, 2)
      REAL_T fdat(flen)
      REAL_T voff(flen)
      REAL_T fvcx(fb_l1:fb_h1+1)
      REAL_T cvcx(cb_l1:cb_h1+1)

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer ist, jst
      REAL_T hafrat, volratio
      REAL_T cen, forw, back, slp, sgn
      REAL_T fcen, ccen
      REAL_T xoff, yoff
      integer ncbx, ncby
      integer ncsx, ncsy
      integer islo, jslo
      integer icc, istart, iend
      integer lenx, leny, maxlen
      logical xok, yok

      hafrat = half*dble(lratio-1)
      volratio = one/dble(lratio)

      ncbx = cb_h1-cb_l1+1
      ncsx = ncbx+2
      ist = 1
      do 200 i = fb_l1, fb_h1
          fn = i-fslo(1)+1
          ic = IX_PROJ(i,lratio)
          fcen = half*(fvcx(i)+fvcx(i+1))
          ccen = half*(cvcx(ic)+cvcx(ic+1))
          voff(fn) = (fcen-ccen)/(cvcx(ic+1)-cvcx(ic))
200   continue
      do 210 n = 1, nvar

c ::: ::::: compute slopes in x direction
          do 220 i = 1, clen
              cen = half*(crse(i+ist,n)-crse(i-ist,n))
              forw = crse(i+ist,n)-crse(i,n)
              back = crse(i,n)-crse(i-ist,n)
              slp = sign(one,cen)*min(abs(cen),abs(forw),abs(back))
              cslope(i,1)=cvmgp(slp,zero,forw*back)
220       continue

c ::: .....::::: strip out a fine grid slope vector
          do 230 ioff = 1, lratio
              icc = clo + ist
              istart = ioff
              iend = ioff + (ncbx-1)*lratio
              do 240 fn = istart, iend, lratio
                  fslope(fn,1) = cslope(icc,1)
                  fdat(fn) = crse(icc,n)
                  icc = icc + ist
240           continue
230       continue
          do 250 i = fb_l1, fb_h1
              fn = i-fslo(1)+1
              fine(i,n) = fdat(fn) + voff(fn)*fslope(fn,1)
250       continue
210   continue

      return
      end

#endif




# if 1

      subroutine FORT_CCINTERP (fine, DIMS(fine), 
     $                          fb_l1, fb_h1, 
     $                          nvar, lratio, crse, clo, chi, 
     $                          cb_l1, cb_h1,
     $		                fslo, fshi, cslope, clen, fslope, fdat,
     $                          flen, voff, bc, limslope,
     $                          fvcx, cvcx)

      integer DIMDEC(fine)
      integer fslo(1), fshi(1)
      integer fb_l1, fb_h1
      integer cb_l1, cb_h1
      integer clo, chi
      integer lratio, nvar, clen, flen, limslope
      integer bc(1,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 2)
      REAL_T fslope(flen, 2)
      REAL_T fdat(flen)
      REAL_T voff(flen)
      REAL_T fvcx(fb_l1:fb_h1+1)
      REAL_T cvcx(cb_l1:cb_h1+1)
#if 0
#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)
#endif

c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer ist, jst
      REAL_T hafrat, volratio
      REAL_T cen, forw, back, slp, sgn
      REAL_T fcen, ccen
      REAL_T xoff, yoff
      integer ncbx, ncby
      integer ncsx, ncsy
      integer islo, jslo
      integer icc, istart, iend
      integer lenx, leny, maxlen
      logical xok, yok

      hafrat = half*dble(lratio-1)
      volratio = one/dble(lratio)

      ncbx = cb_h1-cb_l1+1
      xok = (ncbx .ge. 2)
      ncsx = ncbx+2
      ist = 1
      islo = cb_l1-1
      jst = ncsx
      lenx = fb_h1-fb_l1+1
         do i = fb_l1, fb_h1 
          fn = i-fslo(1)+1
          ic = IX_PROJ(i,lratio)
          fcen = half*(fvcx(i)+fvcx(i+1))
          ccen = half*(cvcx(ic)+cvcx(ic+1))
          voff(fn) = (fcen-ccen)/(cvcx(ic+1)-cvcx(ic))
        enddo   


c ::: ::::: added to prevent underflow for small crse values
      do n = 1, nvar 
        do i = clo, chi 
          crse(i,n) = cvmgt(crse(i,n),zero,abs(crse(i,n)).gt.1.0D-20)
        enddo
      enddo

      do 290 n = 1, nvar 

c ::: ::::: compute slopes in x direction
         if (limslope .ne. 0) then
            do i = 1, clen 
               cen = half*(crse(i+ist,n)-crse(i-ist,n))
               forw = two*(crse(i+ist,n)-crse(i,n))
               back = two*(crse(i,n)-crse(i-ist,n))
               slp  = min(abs(forw),abs(back))
               slp  = cvmgp(slp,zero,forw*back)
               cslope(i,1)=sign(one,cen)*min(slp,abs(cen))
            enddo
            if (xok) then
c               if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
               if (bc(1,1,n) .eq. EXT_DIR .or. bc(1,1,n).eq.HOEXTRAP) then
                  do i = 1, clen, jst 
                     cen  = -sixteen/fifteen*crse(i-ist,n) + half*crse(i,n)
     $                    + two3rd*crse(i+ist,n) - tenth*crse(i+2*ist,n)
                     sgn  = sign(one,crse(i+ist,n)-crse(i-ist,n))
                     forw = two*(crse(i+ist,n)-crse(i,n))
                     back = two*(crse(i,n)-crse(i-ist,n))
                     slp  = min(abs(forw),abs(back))
                     slp  = cvmgp(slp,zero,forw*back)
                     cslope(i,1)=sgn*min(slp,abs(cen))
                  enddo
               endif
               if (bc(1,2,n) .eq. EXT_DIR .or. bc(1,2,n).eq.HOEXTRAP) then
                  do i = ncbx, clen, jst 
                     cen = sixteen/fifteen*crse(i+ist,n) - half*crse(i,n)
     $                    - two3rd*crse(i-ist,n) + tenth*crse(i-2*ist,n)
                     sgn  = sign(one,crse(i+ist,n)-crse(i-ist,n))
                     forw = two*(crse(i+ist,n)-crse(i,n))
                     back = two*(crse(i,n)-crse(i-ist,n))
                     slp  = min(abs(forw),abs(back))
                     slp  = cvmgp(slp,zero,forw*back)
                     cslope(i,1)=sgn*min(slp,abs(cen))
                  enddo
               endif
            endif
         else
            do i = 1, clen 
               cen = half*(crse(i+ist,n)-crse(i-ist,n))
               cslope(i,1)=cen
            enddo
            if (xok) then
c               if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
               if (bc(1,1,n) .eq. EXT_DIR .or. bc(1,1,n).eq.HOEXTRAP) then
                  do i = 1, clen, jst 
                     cen  = -sixteen/fifteen*crse(i-ist,n) + half*crse(i,n)
     $                    + two3rd*crse(i+ist,n) - tenth*crse(i+2*ist,n)
                     cslope(i,1)=cen
                  enddo
               endif
               if (bc(1,2,n) .eq. EXT_DIR .or. bc(1,2,n).eq.HOEXTRAP) then
                  do i = ncbx, clen, jst 
                     cen = sixteen/fifteen*crse(i+ist,n) - half*crse(i,n)
     $                    - two3rd*crse(i-ist,n) + tenth*crse(i-2*ist,n)
                     cslope(i,1)=cen
                  enddo
               endif
            endif
         endif

c           ::::: strip out a fine grid slope vector
            do 370 ioff = 1, lratio 
              icc = clo + ist 
              istart = ioff
              iend = ioff + (ncbx-1)*lratio
              do 380 fn = istart, iend, lratio 
                fslope(fn,1) = cslope(icc,1)
c                fslope(fn,2) = cslope(icc,2)
                fdat(fn) = crse(icc,n)
                icc = icc + ist
380           continue
370         continue

              do 400 i = fb_l1, fb_h1 
                fn = i-fslo(1)+1
                fine(i,n) = fdat(fn) + voff(fn)*fslope(fn,1)
400           continue
391         continue

290   continue

	

      return
      end
#endif

c ::: 
c ::: --------------------------------------------------------------
c ::: pcinterp:  cell centered piecewise constant interpolation
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data 
c ::: clo,chi      =>  (const)  index limits of coarse grid
c ::: cblo,cbhi    =>  (const) coarse grid region containing fblo,fbhi
c ::: 
c ::: longdir      =>  (const)  which index direction is longest (1 or 2)
c ::: ratio        =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: 
c ::: TEMPORARY ARRAYS
c ::: ftmp         =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_PCINTERP (crse,DIMS(crse),cblo,cbhi,
     &                          fine,DIMS(fine),fblo,fbhi,
     &                          longdir,lratio,nvar,ftmp,ftmp_lo,ftmp_hi)
      integer DIMDEC(crse)
      integer cblo(2), cbhi(2)
      integer DIMDEC(fine)
      integer fblo(2), fbhi(2)
      integer ftmp_lo, ftmp_hi
      integer nvar, lratio, longdir
      REAL_T  crse(DIMV(crse), nvar)
      REAL_T  fine(DIMV(fine), nvar)
      REAL_T  ftmp(ftmp_lo:ftmp_hi)
	REAL_T sumrho

      integer i, j, ic, jc, ioff, joff, n

         do n = 1, nvar
	    do ioff = 0, lratio-1
	       do ic = cblo(1), cbhi(1)
	          i = lratio*ic + ioff
	          ftmp(i) = crse(ic,n)
               enddo
	    enddo
	    do i = fblo(1), fbhi(1)
	       fine(i,n) = ftmp(i)
	    enddo
	 enddo

#if 0
	do i = fblo(1), fbhi(1)
	   sumrho = fine(i,5)+fine(i,8)
	   if(abs(sumrho-fine(i,1)) .gt. 1.d-15) then
		write(6,*)'  sum of rhos .ne. total '
   	   endif
	enddo
#endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: LP_3D.F,v 1.4 2002/08/29 22:14:39 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <CONSTANTS.H>
#include <REAL.H>

#include "LP_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
c      
c     Gauss-Seidel Red-Black (GSRB):
c     Apply the GSRB relaxation to the state phi for the equation
c     L(phi) = Div(Grad(phi(x))) = rhs(x) central differenced, according
c     to the arrays of boundary masks (m#) and auxiliary data (f#).
c     
c     In general, if the linear operator L=gamma*y-rho, the GS relaxation
c     is y = (R - rho)/gamma.  Near a boundary, the ghost data is filled
c     using a polynomial interpolant based on the "old" phi values, so
c     L=(gamma-delta)*y - rho + delta*yOld.   The resulting iteration is
c     
c     y = (R - delta*yOld + rho)/(gamma - delta)
c     
c     This expression is valid additionally in the interior provided
c     delta->0 there.  delta is constructed by summing all the
c     contributions to the central stencil element coming from boundary 
c     interpolants.  The f#s contain the corresponding coefficient of 
c     the interpolating polynomial.  The masks are set > 0 if the boundary 
c     value was filled with an interpolant involving the central stencil 
c     element.
c     
c-----------------------------------------------------------------------
      subroutine FORT_GSRB (
     $     phi, DIMS(phi),
     $     rhs, DIMS(rhs),
     $     f0, DIMS(f0), m0, DIMS(m0),
     $     f1, DIMS(f1), m1, DIMS(m1),
     $     f2, DIMS(f2), m2, DIMS(m2),
     $     f3, DIMS(f3), m3, DIMS(m3),
     $     f4, DIMS(f4), m4, DIMS(m4),
     $     f5, DIMS(f5), m5, DIMS(m5),
     $     lo, hi, nc,
     $     h, redblack
     $     )
      integer nc
      integer DIMDEC(phi)
      REAL_T  phi(DIMV(phi),nc)
      integer DIMDEC(rhs)
      REAL_T  rhs(DIMV(rhs),nc)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      integer redblack
      integer DIMDEC(f0)
      integer DIMDEC(f1)
      integer DIMDEC(f2)
      integer DIMDEC(f3)
      integer DIMDEC(f4)
      integer DIMDEC(f5)
      REAL_T  f0(DIMV(f0))
      REAL_T  f1(DIMV(f1))
      REAL_T  f2(DIMV(f2))
      REAL_T  f3(DIMV(f3))
      REAL_T  f4(DIMV(f4))
      REAL_T  f5(DIMV(f5))
      integer DIMDEC(m0)
      integer DIMDEC(m1)
      integer DIMDEC(m2)
      integer DIMDEC(m3)
      integer DIMDEC(m4)
      integer DIMDEC(m5)
      integer m0(DIMV(m0))
      integer m1(DIMV(m1))
      integer m2(DIMV(m2))
      integer m3(DIMV(m3))
      integer m4(DIMV(m4))
      integer m5(DIMV(m5))
      REAL_T  h
c
      integer  i, j, k, ioff, n
c
      REAL_T cf0, cf1, cf2, cf3, cf4, cf5
      REAL_T delta, gamma, rho
c
      gamma = 6.0D0
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               ioff = MOD(j + k + redblack,2)
               do i = lo(1) + ioff,hi(1),2
c
                  cf0 = cvmgt(f0(lo(1),j,k), 0.0D0,
     $                 (i .eq. lo(1)) .and. (m0(lo(1)-1,j,k).gt.0))
                  cf1 = cvmgt(f1(i,lo(2),k), 0.0D0,
     $                 (j .eq. lo(2)) .and. (m1(i,lo(2)-1,k).gt.0))
                  cf2 = cvmgt(f2(i,j,lo(3)), 0.0D0,
     $                 (k .eq. lo(3)) .and. (m2(i,j,lo(3)-1).gt.0))
                  cf3 = cvmgt(f3(hi(1),j,k), 0.0D0,
     $                 (i .eq. hi(1)) .and. (m3(hi(1)+1,j,k).gt.0))
                  cf4 = cvmgt(f4(i,hi(2),k), 0.0D0,
     $                 (j .eq. hi(2)) .and. (m4(i,hi(2)+1,k).gt.0))
                  cf5 = cvmgt(f5(i,j,hi(3)), 0.0D0,
     $                 (k .eq. hi(3)) .and. (m5(i,j,hi(3)+1).gt.0))
c
                  delta = cf0 + cf1 + cf2 + cf3 + cf4 + cf5
c
                  rho =  phi(i-1,j,k,n) + phi(i+1,j,k,n)
     $                 + phi(i,j-1,k,n) + phi(i,j+1,k,n)
     $                 + phi(i,j,k-1,n) + phi(i,j,k+1,n)
c
                  phi(i,j,k,n) 
     $                 = (rhs(i,j,k,n)*h*h - rho + phi(i,j,k,n)*delta)
     $                 /             (delta - gamma)
c                  
               end do
            end do
         end do
      end do
c     
      end
c-----------------------------------------------------------------------
c
c     Solve Preconditioned system here
c
      subroutine FORT_CGPRECND(
     $     zz, DIMS(zz),
     $     rho,
     $     rr, DIMS(rr),
     $     lo, hi, nc,
     $     h
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(zz)
      REAL_T  zz(DIMV(zz),nc)
      integer DIMDEC(rr)
      REAL_T  rr(DIMV(rr),nc)
      REAL_T  h
      REAL_T  rho
c
      integer i
      integer j
      integer k
      integer n
      REAL_T denom
c
      rho = 0.0D0
      denom = -h**2*sixth
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  zz(i,j,k,n) = rr(i,j,k,n)*denom
                  rho = rho + zz(i,j,k,n)*rr(i,j,k,n)
               end do
            end do
         end do
      end do
c     
      end
c-----------------------------------------------------------------------
c
c     Fill in a matrix x vector operator here
c
      subroutine FORT_ADOTX(
     $     y, DIMS(y),
     $     x, DIMS(x),
     $     lo, hi, nc,
     $     h
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(y)
      REAL_T  y(DIMV(y),nc)
      integer DIMDEC(x)
      REAL_T  x(DIMV(x),nc)
      REAL_T  h
c
      integer i, j, k, n
      REAL_T scal
c     
      scal = 1.0D0/h**2
c     
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  y(i,j,k,n) = scal*
     $                 ( x(i-1,j,k,n) + x(i+1,j,k,n)
     $                 + x(i,j-1,k,n) + x(i,j+1,k,n)
     $                 + x(i,j,k-1,n) + x(i,j,k+1,n)
     $                 - 6*x(i,j,k,n) )
               end do
            end do
         end do
      end do
c     
      end

c-----------------------------------------------------------------------
c
c     Fill in fluxes
c
      subroutine FORT_FLUX(
     $     x,DIMS(x),
     $     lo,hi,nc,
     $     h,
     $     xflux,DIMS(xflux),
     $     yflux,DIMS(yflux),
     $     zflux,DIMS(zflux)
     $     )
      implicit none
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(x)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(zflux)
      REAL_T  x(DIMV(x),nc)
      REAL_T xflux(DIMV(xflux),nc)
      REAL_T yflux(DIMV(yflux),nc)
      REAL_T zflux(DIMV(zflux),nc)
      REAL_T h(BL_SPACEDIM)
c
      REAL_T dhx, dhy, dhz
      integer i,j,k,n
c
      dhx = one/h(1)
      dhy = one/h(2)
      dhz = one/h(3)
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)+1
                  xflux(i,j,k,n) = - dhx*( x(i,j,k,n) - x(i-1,j,k,n) )
               end do
            end do
         end do
      end do
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)+1
               do i = lo(1), hi(1)
                  yflux(i,j,k,n) = - dhy*( x(i,j,k,n) - x(i,j-1,k,n) )
               end do
            end do
         end do
      end do
      do n = 1, nc
         do k = lo(3), hi(3)+1
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  zflux(i,j,k,n) = - dhz*( x(i,j,k,n) - x(i,j,k-1,n) )
               end do
            end do
         end do
      end do
      end

      
      

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: PROJECTION_2D.F,v 1.38 2002/11/14 23:04:56 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROJECTION_F.H"
#include "ArrayLim.H"

#define SDIM 2

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
#define SMALL 1.0e-10
#else
#define SMALL 1.0d-10
#endif

       subroutine FORT_FILTERP (
     &     pnew,scratch,DIMS(p),
     &     lo,hi,dx,fac,
     &     wrap_around_x,wrap_around_y)
c
c     ----------------------------------------------------------
c     filter the pressure coming out of the level projection
c     
c     pnew := pnew - fac * lap_5pt(pnew)
c     
c     INPUTS / OUTPUTS:
c     pnew       => 
c     pnew      <=> 
c     p_lo,p_hi  => index limits of pressure array
c     lo,hi      => index limits of cell centered interior
c     fac        => fudge factor for filtering
c     wrap_around_x => is this a single periodic box in the x-direction
c     wrap_around_y => is this a single periodic box in the y-direction
c     
c     ----------------------------------------------------------
c 
       integer    DIMDEC(p)
       REAL_T     pnew(DIMV(p))
       REAL_T     scratch(DIMV(p))
       integer    lo(2), hi(2)
       REAL_T     dx(2)
       REAL_T     fac
       integer    wrap_around_x
       integer    wrap_around_y
       integer i, j

       if ( abs(dx(1)-dx(2)) .gt. 1.D-8 .and. fac .gt. 1.D-4 )then
          print *, 'is filter properly formatted for dx != dy ?'
       end if

       do j = lo(2)+1, hi(2)
          do i = lo(1)+1, hi(1)
             scratch(i,j) = four * pnew(i,j) - 
     $         (pnew(i-1,j) + pnew(i+1,j) + pnew(i,j-1) + pnew(i,j+1) )
             scratch(i,j) = - eighth * scratch(i,j) * fac
          end do
       end do
 
       if (wrap_around_x .eq. 1) then
         i = lo(1)
         do j = lo(2)+1, hi(2)
             scratch(i,j) = four * pnew(i,j) - 
     $         (pnew(hi(1),j) + pnew(i+1,j) + pnew(i,j-1) + pnew(i,j+1) )
             scratch(i,j) = - eighth * scratch(i,j) * fac
         end do

         i = hi(1)+1
         do j = lo(2)+1, hi(2)
             scratch(i,j) = four * pnew(i,j) - 
     $         (pnew(i-1,j) + pnew(lo(1)+1,j) + pnew(i,j-1) + pnew(i,j+1) )
             scratch(i,j) = - eighth * scratch(i,j) * fac
         end do
       end if
 
       if (wrap_around_y .eq. 1) then
         j = lo(2)
         do i = lo(1)+1, hi(1)
             scratch(i,j) = four * pnew(i,j) - 
     $         (pnew(i-1,j) + pnew(i+1,j) + pnew(i,hi(2)) + pnew(i,j+1) )
             scratch(i,j) = - eighth * scratch(i,j) * fac
         end do

         j = hi(2)+1
         do i = lo(1)+1, hi(1)
             scratch(i,j) = four * pnew(i,j) - 
     $         (pnew(i-1,j) + pnew(i+1,j) + pnew(i,j-1) + pnew(i,lo(2)+1) )
             scratch(i,j) = - eighth * scratch(i,j) * fac
         end do
       end if
 
       if (wrap_around_x .eq. 1 .and. wrap_around_y .eq. 1) then
         i = lo(1)
         j = lo(2)
           scratch(i,j) = four * pnew(i,j) - 
     $       (pnew(hi(1),j) + pnew(i+1,j) + pnew(i,hi(2)) + pnew(i,j+1) )
           scratch(i,j) = - eighth * scratch(i,j) * fac

         i = hi(1)+1
         j = lo(2)
           scratch(i,j) = four * pnew(i,j) - 
     $       (pnew(i-1,j) + pnew(lo(1)+1,j) + pnew(i,hi(2)) + pnew(i,j+1) )
           scratch(i,j) = - eighth * scratch(i,j) * fac

         i = lo(1)
         j = hi(2)+1
           scratch(i,j) = four * pnew(i,j) - 
     $       (pnew(hi(1),j) + pnew(i+1,j) + pnew(i,j-1) + pnew(i,lo(2)+1) )
           scratch(i,j) = - eighth * scratch(i,j) * fac

         i = hi(1)+1
         j = hi(2)+1
           scratch(i,j) = four * pnew(i,j) - 
     $       (pnew(i-1,j) + pnew(lo(1)+1,j) + pnew(i,j-1) + pnew(i,lo(2)+1) )
           scratch(i,j) = - eighth * scratch(i,j) * fac
       end if

       do j = lo(2)+1, hi(2)
          do i = lo(1)+1, hi(1)
             pnew(i,j) = pnew(i,j) + scratch(i,j)
          end do
       end do

       if (wrap_around_x .eq. 1) then
         do j = lo(2)+1, hi(2)
           pnew(lo(1)  ,j) = pnew(lo(1)  ,j) + scratch(lo(1)  ,j)
           pnew(hi(1)+1,j) = pnew(hi(1)+1,j) + scratch(hi(1)+1,j)
         end do
       end if

       if (wrap_around_y .eq. 1) then
         do i = lo(1)+1, hi(1)
           pnew(i,lo(2)  ) = pnew(i,lo(2)  ) + scratch(i,lo(2)  )
           pnew(i,hi(2)+1) = pnew(i,hi(2)+1) + scratch(i,hi(2)+1)
         end do
       end if

       if (wrap_around_x .eq. 1 .and. wrap_around_y .eq. 1) then
         pnew(lo(1)  ,lo(2)  ) = pnew(lo(1)  ,lo(2)  ) + scratch(lo(1)  ,lo(2)  )
         pnew(hi(1)+1,lo(2)  ) = pnew(hi(1)+1,lo(2)  ) + scratch(hi(1)+1,lo(2)  )
         pnew(lo(1)  ,hi(2)+1) = pnew(lo(1)  ,hi(2)+1) + scratch(lo(1)  ,hi(2)+1)
         pnew(hi(1)+1,hi(2)+1) = pnew(hi(1)+1,hi(2)+1) + scratch(hi(1)+1,hi(2)+1)
       end if

       end

       subroutine FORT_ACCEL_TO_VEL( lo, hi, 
     &     uold,DIMS(uold),
     &     dt,
     &     unew,DIMS(unew) )
c
c     This function converts unew into a velocity via
c     Unew = Uold + alpha*Unew
c
       integer    lo(SDIM), hi(SDIM)
       REAL_T     dt
       integer    DIMDEC(uold),DIMDEC(unew)
       REAL_T     uold(DIMV(uold),SDIM)
       REAL_T     unew(DIMV(unew),SDIM)

       integer i, j, n

       do n = 1, SDIM
          do j = lo(2)-1, hi(2)+1
             do i = lo(1)-1, hi(1)+1
                unew(i,j,n) = uold(i,j,n) + dt*unew(i,j,n)
             end do
          end do
       end do

       end

      subroutine FORT_VEL_TO_ACCEL( lo, hi, 
     &     unew,DIMS(unew),
     &     uold,DIMS(uold),
     &     dt )
c     
c     This function converts unew into an acceleration
c     
      integer    lo(SDIM), hi(SDIM)
      REAL_T     dt
      integer    DIMDEC(unew),DIMDEC(uold)
      REAL_T     uold(DIMV(uold),SDIM)
      REAL_T     unew(DIMV(unew),SDIM)
     
      integer i, j, n
      REAL_T dt_inv
   
      dt_inv = one/dt

      do n = 1, SDIM
         do j = lo(2)-1, hi(2)+1
            do i = lo(1)-1, hi(1)+1
               unew(i,j,n) = (unew(i,j,n)-uold(i,j,n))*dt_inv
            end do
         end do
      end do

      end

      subroutine FORT_PROJ_UPDATE(
     &     boxlo, boxhi, nvar, ngrow,
     &     un, DIMS(un),
     &     alpha,
     &     uo, DIMS(uo) )
c     
c     This function updates un via un = un + alpha*uo
c     The loop bounds are determined in the C++
c     
      integer    boxlo(SDIM), boxhi(SDIM), nvar, ngrow
      REAL_T     alpha
      integer    DIMDEC(un),DIMDEC(uo)
      REAL_T     un(DIMV(un),nvar)
      REAL_T     uo(DIMV(uo),nvar)

      integer i, j, n

      do n = 1, nvar
         do j = boxlo(2), boxhi(2)
            do i = boxlo(1), boxhi(1)
               un(i,j,n) = un(i,j,n) + alpha*uo(i,j,n)
            end do
         end do
      end do

      end

      subroutine FORT_RADMPY(a,DIMS(grid),domlo,domhi,ng,r,nr,bogus_value)
c 
c     multiply A by Radius r
c
c 
c     NOTE: THIS ROUTINE HAS BEEN MODIFIED SO THAT ALL VALUES
c           OUTSIDE THE DOMAIN ARE SET TO BOGUS VALUE
c
      integer    ng,nr
      integer    DIMDEC(grid)
      integer    domlo(2), domhi(2)
      REAL_T     a(ARG_L1(grid)-ng:ARG_H1(grid)+ng, 
     $             ARG_L2(grid)-ng:ARG_H2(grid)+ng)
      REAL_T     r(ARG_L1(grid)-nr:ARG_H1(grid)+nr)
      REAL_T     bogus_value

      integer i, j

      do j = ARG_L2(grid)-ng, ARG_H2(grid)+ng
         do i = ARG_L1(grid)-ng, ARG_H1(grid)+ng
           a(i,j) = r(i)*a(i,j)
         end do
      end do

      if (ARG_L1(grid)-ng .lt. domlo(1)) then
         do j = ARG_L2(grid)-ng, ARG_H2(grid)+ng
         do i = ARG_L1(grid)-ng, domlo(1)-1
           a(i,j) = bogus_value
         end do
         end do
      end if

      if (ARG_H1(grid)+ng .gt. domhi(1)) then
         do j = ARG_L2(grid)-ng, ARG_H2(grid)+ng
         do i = domhi(1)+1, ARG_H1(grid)+ng
           a(i,j) = bogus_value
         end do
         end do
      end if

      end

      subroutine FORT_RADDIV(a,DIMS(grid),domlo,domhi,ng,r,nr,bogus_value)
c 
c     divide A by Radius r
c
c 
c     NOTE: THIS ROUTINE HAS BEEN MODIFIED SO THAT ALL VALUES
c           OUTSIDE THE DOMAIN ARE SET TO BOGUS VALUE
c
      integer    ng,nr
      integer    DIMDEC(grid)
      integer    domlo(2), domhi(2)
      REAL_T     a(ARG_L1(grid)-ng:ARG_H1(grid)+ng, 
     $             ARG_L2(grid)-ng:ARG_H2(grid)+ng)
      REAL_T     r(ARG_L1(grid)-nr:ARG_H1(grid)+nr)
      REAL_T     bogus_value

      integer i, j

      do j = ARG_L2(grid)-ng, ARG_H2(grid)+ng
         do i = ARG_L1(grid)-ng, ARG_H1(grid)+ng
           a(i,j) = a(i,j)/r(i)
         end do
      end do

      if (ARG_L1(grid)-ng .lt. domlo(1)) then
         do j = ARG_L2(grid)-ng, ARG_H2(grid)+ng
         do i = ARG_L1(grid)-ng, domlo(1)-1
           a(i,j) = bogus_value
         end do
         end do
      end if

      if (ARG_H1(grid)+ng .gt. domhi(1)) then
         do j = ARG_L2(grid)-ng, ARG_H2(grid)+ng
         do i = domhi(1)+1, ARG_H1(grid)+ng
           a(i,j) = bogus_value
         end do
         end do
      end if

      end

      subroutine FORT_HGN2C(
     &     isrz,lrweighted, DIMS(nodedat), nodedat,
     &     DIMS(ccdat), lo, hi, ccdat)

c     ----------------------------------------------------------
c     HGN2C
c     averages node centered data to cell centers for use in 
c     holy grail projection

      implicit none
      integer isrz,lrweighted
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(ccdat)
      integer DIMDEC(nodedat)
      REAL_T  nodedat(DIMV(nodedat))
      REAL_T  ccdat(DIMV(ccdat))

      integer i,j

      if (ARG_H1(ccdat)   .lt. lo(1) .or. 
     &    ARG_L1(ccdat)   .gt. hi(1) .or. 
     &    ARG_H2(ccdat)   .lt. lo(2) .or. 
     &    ARG_L2(ccdat)   .gt. hi(2) .or. 
     &    ARG_H1(nodedat) .lt. lo(1)+1 .or. 
     &    ARG_L1(nodedat) .gt. hi(1) .or. 
     &    ARG_H2(nodedat) .lt. lo(2)+1 .or. 
     &    ARG_L2(nodedat) .gt. hi(2) ) then 
        call bl_abort("FORT_HG_CELL_TO_NODE: bad index limits")
      end if

      if(isrz.eq.1.and.lrweighted.ne.1)then
        call bl_abort('FORT_HGN2C: isrz=1 and lrweighted!=1 not implmented')
      end if

      do j=lo(2),hi(2)
        do i=lo(1),hi(1)
          ccdat(i,j) = fourth*(nodedat(i,j)+nodedat(i+1,j)+
     &                         nodedat(i,j+1)+nodedat(i+1,j+1))
        end do
      end do

      end

      subroutine FORT_HGC2N(
     &     nghost, DIMS(dat), dat, rcen,
     &     DIMS(rhs), rhs,
     &     domlo, domhi, dr, is_rz, imax) 
c
c     ----------------------------------------------------------
c     HGC2N
c     averages cell centered data to nodes for use in 
c     holy grail projection
c     
c     INPUTS / OUTPUTS:
c     nghost      => indicates buffer of rhs that does not need values
c     dat         => cell centered array to be averaged
c     DIMS(dat)   => index limits of dat
c     rcen        => r-coordinate cell centers if geoem is r-z; 
c     otherwise, should be 1
c     rhslo,rhshi => index extents of rhs
c     rhs         <= node centered array with results
c     ----------------------------------------------------------
c 
      implicit none
      integer nghost 
      integer domlo(SDIM), domhi(SDIM)
      integer DIMDEC(dat)
      integer DIMDEC(rhs)
      REAL_T  dr
      REAL_T  rcen(DIM1(dat))
      REAL_T  dat(DIMV(dat))
      REAL_T  rhs(DIMV(rhs))
      integer is_rz, imax

      integer i, j
      REAL_T  factor, rhi, rlo

      if (ARG_L1(rhs)+1 .lt. ARG_L1(dat) .or. 
     $     ARG_H1(rhs)-1 .gt. ARG_H1(dat) .or.
     &     ARG_L2(rhs)+1 .lt. ARG_L2(dat) .or. 
     $     ARG_H2(rhs)-1 .gt. ARG_H2(dat)) then
         call bl_abort("FORT_HG_CELL_TO_NODE: bad index limits")
      end if

      if (is_rz.ne.1) then
         do j=ARG_L2(rhs)+nghost,ARG_H2(rhs)-nghost
            do i=ARG_L1(rhs)+nghost,ARG_H1(rhs)-nghost
               rhs(i,j) = fourth*(dat(i-1,j-1)+dat(i-1,j)+
     &                            dat(i  ,j-1)+dat(i  ,j) )
            end do
         end do

      else

#if BL_PRVERSION == 9
         do j=ARG_L2(rhs)+nghost,ARG_H2(rhs)-nghost
            do i=ARG_L1(rhs)+nghost,ARG_H1(rhs)-nghost
               if (i .eq. imax) then
                  rhi = rcen(i-1)
               else 
                  rhi = rcen(i)
               end if
               if (i .eq. 0) then
                  rlo = rcen(i)
               else
                  rlo = rcen(i-1)
               end if

               rhs(i,j) = fourth*(rlo * (dat(i-1,j-1) + dat(i-1,j)) +
     &                            rhi * (dat(i  ,j-1) + dat(i  ,j)))
            end do
         end do
         factor = dr/24.0D0
         do j=ARG_L2(rhs)+nghost,ARG_H2(rhs)-nghost
            do i=ARG_L1(rhs)+nghost,ARG_H1(rhs)-nghost
               if (i .eq. imax) then
                  rhi = -one
               else 
                  rhi = one
               end if
               if (i .eq. 0) then
                  rlo = -one
               else
                  rlo = one
               end if
               rhs(i,j) = rhs(i,j) + factor *
     &              (rlo * (dat(i-1,j-1) + dat(i-1,j)) -
     &               rhi * (dat(i  ,j-1) + dat(i  ,j)))
            end do
         end do

#else
         do j=ARG_L2(rhs)+nghost,ARG_H2(rhs)-nghost
            do i=ARG_L1(rhs)+nghost,ARG_H1(rhs)-nghost
               if (i .eq. imax) then
                  rhi = rcen(i-1)
               else 
                  rhi = rcen(i)
               end if
               if (i .eq. 0) then
                  rlo = rcen(i)
               else 
                  rlo = rcen(i-1)
               end if
               rhs(i,j) = fourth*(rlo * (dat(i-1,j-1) + dat(i-1,j)) +
     &                            rhi * (dat(i  ,j-1) + dat(i  ,j)))
               if (i .eq. 0) rhs(i,j) = half * rhs(i,j)
            end do
         end do
#endif
      end if

      end

c ::: -----------------------------------------------------------
c ::: This routine will compute D (U / dt + sigma G^perp phi)
c :::
c ::: NOTE: phi is node-centered
c :::       sigma is cell-centered      
c :::       U is cell-centered      
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: phi        => node centered data
c ::: DIMS(phi)  => index limits for phi
c ::: sigma      => cell-centered coefficient array
c ::: DIMS(sigma)=> index limits for sigma      
c ::: u          => cell-centered velocity array
c ::: DIMS(u)    => index limits for u      
c ::: divgp     <=  node-centered divergence of gradient
c ::: DIMS(divgp)=> index limits for divgp
c ::: lo,hi      => node-centered subregion of divgp to define
c ::: dx         => cell sizes      
c ::: mult       => scalar multiplicative factor      
c ::: -----------------------------------------------------------

      subroutine FORT_FILTRHS(phi,DIMS(phi),sigma,DIMS(sigma),
     &                        divgp,DIMS(divgp),
     &                        lo,hi,dx,mult,is_rz)
      implicit none

      integer    DIMDEC(phi)
      integer    DIMDEC(sigma)
      integer    DIMDEC(divgp)
      integer    lo(SDIM), hi(SDIM)
      REAL_T     dx(SDIM), mult
      REAL_T     phi(DIMV(phi))
      REAL_T     sigma(DIMV(sigma))
      REAL_T     divgp(DIMV(divgp))
      integer    is_rz
      
      integer    i, j
      REAL_T     p1, p2, p3, p4, denom
      REAL_T     rminv,rpinv,fac
      REAL_T     gpy_ul,gpy_ur,gpy_ll,gpy_lr
      REAL_T     pext, vext

#if BL_PRVERSION==9
c     FOR NINE-POINT STENCIL
      denom = one/(twelve*dx(1)**2) + one/(twelve*dx(2)**2) 
#else
c     FOR FIVE-POINT STENCIL
      denom = one/(four*dx(1)**2) + one/(four*dx(2)**2)
#endif

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            p1 = sigma(i-1,j-1)*(-phi(i-1,j-1) + phi(i  ,j-1)
     &                           +phi(i-1,j  ) - phi(i  ,j  ))
            p2 = sigma(i-1,j  )*(-phi(i-1,j+1) + phi(i  ,j+1)
     &                           +phi(i-1,j)   - phi(i  ,j  ))
            p3 = sigma(i  ,j-1)*(-phi(i+1,j-1) + phi(i  ,j-1)
     &                           +phi(i+1,j)   - phi(i  ,j  ))
            p4 = sigma(i  ,j  )*(-phi(i+1,j+1) + phi(i  ,j+1)
     &                           +phi(i+1,j)   - phi(i  ,j  ))
            divgp(i,j) = denom*(p1+p2+p3+p4)
         enddo
      enddo

      if (is_rz .eq. 1) then

c      extra term added to DGphi for cylindrical coordinates
       do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            rpinv = half / (dble(i)+half)
            rminv = half / (dble(i)-half)

            pext = ((sigma(i-1,j-1) * (phi(i,j-1) - phi(i,j)) +
     $               sigma(i-1,j  ) * (phi(i,j+1) - phi(i,j))) * rminv -
     $              (sigma(i  ,j-1) * (phi(i,j-1) - phi(i,j)) +
     $               sigma(i  ,j  ) * (phi(i,j+1) - phi(i,j))) * rpinv)

            divgp(i,j) = divgp(i,j) + denom*pext
         enddo
       enddo

c      extra term added to DGbarphi for cylindrical coordinates --
c        here we subtract it since we want D G^perp phi
       fac = one / (twelve * dx(2)**2)
       do j = lo(2), hi(2)
       do i = lo(1), hi(1)
           rminv = fac / (dble(i)-half)
           rpinv = fac / (dble(i)+half)
   
	   gpy_ur = half * sigma(i  ,j  ) * ( phi(i+1,j+1) + phi(i,j+1) 
     $                                       -phi(i+1,j  ) - phi(i,j  ))
	   gpy_ul = half * sigma(i-1,j  ) * ( phi(i-1,j+1) + phi(i,j+1) 
     $                                       -phi(i-1,j  ) - phi(i,j  ))
	   gpy_lr = half * sigma(i  ,j-1) * ( phi(i+1,j  ) + phi(i,j  ) 
     $                                       -phi(i+1,j-1) - phi(i,j-1))
	   gpy_ll = half * sigma(i-1,j-1) * ( phi(i-1,j  ) + phi(i,j  ) 
     $                                       -phi(i-1,j-1) - phi(i,j-1))
           vext =  (gpy_lr - gpy_ur)*rpinv 
     $            +(gpy_ul - gpy_ll)*rminv
           divgp(i,j) = divgp(i,j) - vext
        enddo
        enddo

      endif

      do j = lo(2), hi(2)
      do i = lo(1), hi(1)
           divgp(i,j) = divgp(i,j) * mult
      enddo
      enddo

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** MKVELFLUX **
c ** Create the time-centered edge states for the velocity components
c ***************************************************************

      subroutine FORT_MKVELFLUX(s,sedgex,sedgey,sedgez,
     $                          slopex,slopey,slopez,uadv,vadv,wadv,
     $                          utrans,vtrans,wtrans,
     $                          rho,px,py,pz,lapu,
     $                          s_l,s_r,s_b,s_t,s_d,s_u,DIMS,
     $                          dx,dt,force,visc_coef,
     $                          bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS

      REAL_T       s(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  sedgex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  sedgey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  sedgez(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  slopex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  slopey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  slopez(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T    uadv(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T    vadv(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T    wadv(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T  utrans(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T  vtrans(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T  wtrans(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T     rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      px(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      py(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      pz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)

      REAL_T    s_l(lo_1:hi_1+1,3)
      REAL_T    s_r(lo_1:hi_1+1,3)
      REAL_T    s_b(lo_2:hi_2+1,3)
      REAL_T    s_t(lo_2:hi_2+1,3)
      REAL_T    s_d(lo_3:hi_3+1,3)
      REAL_T    s_u(lo_3:hi_3+1,3)

      REAL_T  dx(3)
      REAL_T  dt
      REAL_T  visc_coef
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T ubardth, vbardth, wbardth
      REAL_T hx, hy, hz, dth
      REAL_T uplus,uminus,vplus,vminus,wplus,wminus,ut,vt,wt
      REAL_T utr,vtr,wtr,savg,uavg,vavg,wavg
      REAL_T uptop,upbot,umtop,umbot,uplft,uprgt,umlft,umrgt
      REAL_T vptop,vpbot,vmtop,vmbot,vplft,vprgt,vmlft,vmrgt
      REAL_T wptop,wpbot,wmtop,wmbot,wplft,wprgt,wmlft,wmrgt

      REAL_T eps

      logical ltm0,ltp0
      integer i,j,k,is,js,ks,ie,je,ke,n

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      dth = half*dt

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      do k = ks,ke 
      do j = js,je 
        do i = is,ie 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Y-DIRECTION
c        ******************************************************************

          wpbot = s(i,j  ,k,3) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,3) 
c    $            + dth * lapu(i,j  ,k,3) / rho(i,j,k)
          wptop = s(i,j+1,k,3) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,3)
c    $            + dth * lapu(i,j+1,k,3) / rho(i,j+1,k)
          vpbot = s(i,j  ,k,2) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,2) 
c    $            + dth * lapu(i,j  ,k,2) / rho(i,j,k)
          vptop = s(i,j+1,k,2) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,2)
c    $            + dth * lapu(i,j+1,k,2) / rho(i,j+1,k)
          upbot = s(i,j  ,k,1) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,1)
c    $            + dth * lapu(i,  j,k,1) / rho(i,j,k)
          uptop = s(i,j+1,k,1) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,1)
c    $            + dth * lapu(i,j+1,k,1) / rho(i,j+1,k)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. INLET)
          wptop = cvmgt(s(i,je+1,k,3),wptop,ltp0)
          wpbot = cvmgt(s(i,je+1,k,3),wpbot,ltp0)
          vptop = cvmgt(s(i,je+1,k,2),vptop,ltp0)
          vpbot = cvmgt(s(i,je+1,k,2),vpbot,ltp0)
          uptop = cvmgt(s(i,je+1,k,1),uptop,ltp0)
          upbot = cvmgt(s(i,je+1,k,1),upbot,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL)
          vptop = cvmgt(zero,vptop,ltp0)
          vpbot = cvmgt(zero,vpbot,ltp0)
          uptop = cvmgt(upbot,uptop,ltp0)
          wptop = cvmgt(wpbot,wptop,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)
          wptop = cvmgt(zero,wptop,ltp0)
          wpbot = cvmgt(zero,wpbot,ltp0)

          uplus = cvmgp(upbot,uptop,vtrans(i,j+1,k))
          uavg  = half * (upbot + uptop)
          uplus = cvmgt(uplus, uavg, abs(vtrans(i,j+1,k)) .gt. eps)

          vplus = cvmgp(vpbot,vptop,vtrans(i,j+1,k))
          vavg  = half * (vpbot + vptop)
          vplus = cvmgt(vplus, vavg, abs(vtrans(i,j+1,k)) .gt. eps)

          wplus = cvmgp(wpbot,wptop,vtrans(i,j+1,k))
          wavg  = half * (wpbot + wptop)
          wplus = cvmgt(wplus, wavg, abs(vtrans(i,j+1,k)) .gt. eps)

          wmtop = s(i,j  ,k,3) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,3)
c    $            + dth * lapu(i,j  ,k,3) / rho(i,j,k)
          wmbot = s(i,j-1,k,3) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,3)
c    $            + dth * lapu(i,j-1,k,3) / rho(i,j-1,k)
          vmtop = s(i,j  ,k,2) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,2)
c    $            + dth * lapu(i,j  ,k,2) / rho(i,j,k)
          vmbot = s(i,j-1,k,2) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,2)
c    $            + dth * lapu(i,j-1,k,2) / rho(i,j-1,k)
          umtop = s(i,j  ,k,1) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,1)
c    $            + dth * lapu(i,j  ,k,1) / rho(i,j,k)
          umbot = s(i,j-1,k,1) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,1)
c    $            + dth * lapu(i,j-1,k,1) / rho(i,j-1,k)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. INLET)
          wmtop = cvmgt(s(i,js-1,k,3),wmtop,ltm0)
          wmbot = cvmgt(s(i,js-1,k,3),wmbot,ltm0)
          vmtop = cvmgt(s(i,js-1,k,2),vmtop,ltm0)
          vmbot = cvmgt(s(i,js-1,k,2),vmbot,ltm0)
          umtop = cvmgt(s(i,js-1,k,1),umtop,ltm0)
          umbot = cvmgt(s(i,js-1,k,1),umbot,ltm0)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL)
          vmtop = cvmgt(zero ,vmtop,ltm0)
          vmbot = cvmgt(zero ,vmbot,ltm0)
          umbot = cvmgt(umtop,umbot,ltm0)
          wmbot = cvmgt(wmtop,wmbot,ltm0)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL  .and.  
     $            visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)
          wmtop = cvmgt(zero,wmtop,ltm0)
          wmbot = cvmgt(zero,wmbot,ltm0)

          uminus = cvmgp(umbot,umtop,vtrans(i,j,k))
          uavg   = half * (umbot + umtop)
          uminus = cvmgt(uminus, uavg, abs(vtrans(i,j,k)) .gt. eps)

          vminus = cvmgp(vmbot,vmtop,vtrans(i,j,k))
          vavg   = half * (vmbot + vmtop)
          vminus = cvmgt(vminus, vavg, abs(vtrans(i,j,k)) .gt. eps)

          wminus = cvmgp(wmbot,wmtop,vtrans(i,j,k))
          wavg   = half * (wmbot + wmtop)
          wminus = cvmgt(wminus, wavg, abs(vtrans(i,j,k)) .gt. eps)

          utr =  half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(uplus - uminus) / hy
          vtr =  half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(vplus - vminus) / hy
          wtr =  half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(wplus - wminus) / hy

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Z-DIRECTION
c        ******************************************************************

          wpbot = s(i,j,k  ,3) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,3) 
c    $            + dth * lapu(i,j,k  ,3) / rho(i,j,k)
          wptop = s(i,j,k+1,3) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,3)
c    $            + dth * lapu(i,j,k+1,3) / rho(i,j,k+1)
          vpbot = s(i,j,k  ,2) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,2) 
c    $            + dth * lapu(i,j,k  ,2) / rho(i,j,k)
          vptop = s(i,j,k+1,2) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,2)
c    $            + dth * lapu(i,j,k+1,2) / rho(i,j,k+1)
          upbot = s(i,j,k  ,1) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,1)
c    $            + dth * lapu(i,j,k  ,1) / rho(i,j,k)
          uptop = s(i,j,k+1,1) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,1)
c    $            + dth * lapu(i,j,k+1,1) / rho(i,j,k+1)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. INLET)
          wptop = cvmgt(s(i,j,ke+1,3),wptop,ltp0)
          wpbot = cvmgt(s(i,j,ke+1,3),wpbot,ltp0)
          vptop = cvmgt(s(i,j,ke+1,2),vptop,ltp0)
          vpbot = cvmgt(s(i,j,ke+1,2),vpbot,ltp0)
          uptop = cvmgt(s(i,j,ke+1,1),uptop,ltp0)
          upbot = cvmgt(s(i,j,ke+1,1),upbot,ltp0)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL)
          wptop = cvmgt(zero,wptop,ltp0)
          wpbot = cvmgt(zero,wpbot,ltp0)
          uptop = cvmgt(upbot,uptop,ltp0)
          vptop = cvmgt(vpbot,vptop,ltp0)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)
          vptop = cvmgt(zero,vptop,ltp0)
          vpbot = cvmgt(zero,vpbot,ltp0)

          uplus = cvmgp(upbot,uptop,wtrans(i,j,k+1))
          uavg  = half * (upbot + uptop)
          uplus = cvmgt(uplus, uavg, abs(wtrans(i,j,k+1)) .gt. eps)

          vplus = cvmgp(vpbot,vptop,wtrans(i,j,k+1))
          vavg  = half * (vpbot + vptop)
          vplus = cvmgt(vplus, vavg, abs(wtrans(i,j,k+1)) .gt. eps)

          wplus = cvmgp(wpbot,wptop,wtrans(i,j,k+1))
          wavg  = half * (wpbot + wptop)
          wplus = cvmgt(wplus, wavg, abs(wtrans(i,j,k+1)) .gt. eps)

          wmtop = s(i,j,k  ,3) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,3)
c    $            + dth * lapu(i,j,k  ,3) / rho(i,j,k)
          wmbot = s(i,j,k-1,3) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,3)
c    $            + dth * lapu(i,j,k-1,3) / rho(i,j,k-1)
          vmtop = s(i,j,k  ,2) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,2)
c    $            + dth * lapu(i,j,k  ,2) / rho(i,j,k)
          vmbot = s(i,j,k-1,2) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,2)
c    $            + dth * lapu(i,j,k-1,2) / rho(i,j,k-1)
          umtop = s(i,j,k  ,1) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,1)
c    $            + dth * lapu(i,j,k  ,1) / rho(i,j,k)
          umbot = s(i,j,k-1,1) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,1)
c    $            + dth * lapu(i,j,k-1,1) / rho(i,j,k-1)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. INLET)
          wmtop = cvmgt(s(i,j,ks-1,3),wmtop,ltm0)
          wmbot = cvmgt(s(i,j,ks-1,3),wmbot,ltm0)
          vmtop = cvmgt(s(i,j,ks-1,2),vmtop,ltm0)
          vmbot = cvmgt(s(i,j,ks-1,2),vmbot,ltm0)
          umtop = cvmgt(s(i,j,ks-1,1),umtop,ltm0)
          umbot = cvmgt(s(i,j,ks-1,1),umbot,ltm0)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL)
          wmtop = cvmgt(zero ,wmtop,ltm0)
          wmbot = cvmgt(zero ,wmbot,ltm0)
          umbot = cvmgt(umtop,umbot,ltm0)
          vmbot = cvmgt(vmtop,vmbot,ltm0)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL  .and.  
     $            visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)
          vmtop = cvmgt(zero,vmtop,ltm0)
          vmbot = cvmgt(zero,vmbot,ltm0)

          uminus = cvmgp(umbot,umtop,wtrans(i,j,k))
          uavg   = half * (umbot + umtop)
          uminus = cvmgt(uminus, uavg, abs(wtrans(i,j,k)) .gt. eps)

          vminus = cvmgp(vmbot,vmtop,wtrans(i,j,k))
          vavg   = half * (vmbot + vmtop)
          vminus = cvmgt(vminus, vavg, abs(wtrans(i,j,k)) .gt. eps)

          wminus = cvmgp(wmbot,wmtop,wtrans(i,j,k))
          wavg   = half * (wmbot + wmtop)
          wminus = cvmgt(wminus, wavg, abs(wtrans(i,j,k)) .gt. eps)

          utr = utr + 
     $            half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(uplus - uminus) / hz
          vtr = vtr + 
     $            half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(vplus - vminus) / hz
          wtr = wtr +    
     $            half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(wplus - wminus) / hz

c        ******************************************************************
c        MAKE LEFT AND RIGHT STATES
c        ******************************************************************

          ut = (lapu(i,j,k,1)-px(i,j,k))/rho(i,j,k) - utr + force(i,j,k,1)
          vt = (lapu(i,j,k,2)-py(i,j,k))/rho(i,j,k) - vtr + force(i,j,k,2)
          wt = (lapu(i,j,k,3)-pz(i,j,k))/rho(i,j,k) - wtr + force(i,j,k,3)

          ubardth = dth*s(i,j,k,1)/hx

          s_l(i+1,1)= s(i,j,k,1) + (half-ubardth)*slopex(i,j,k,1) + dth*ut
          s_l(i+1,2)= s(i,j,k,2) + (half-ubardth)*slopex(i,j,k,2) + dth*vt
          s_l(i+1,3)= s(i,j,k,3) + (half-ubardth)*slopex(i,j,k,3) + dth*wt

          s_r(i  ,1)= s(i,j,k,1) - (half+ubardth)*slopex(i,j,k,1) + dth*ut
          s_r(i  ,2)= s(i,j,k,2) - (half+ubardth)*slopex(i,j,k,2) + dth*vt
          s_r(i  ,3)= s(i,j,k,3) - (half+ubardth)*slopex(i,j,k,3) + dth*wt

        enddo

        if (bcx_lo .eq. PERIODIC) then
          s_l(is  ,1) = s_l(ie+1,1)
          s_l(is  ,2) = s_l(ie+1,2)
          s_l(is  ,3) = s_l(ie+1,3)
        elseif (bcx_lo .eq. WALL) then
          s_l(is  ,1) = zero
          s_r(is  ,1) = zero
          s_l(is  ,2) = s_r(is  ,2)
          s_l(is  ,3) = s_r(is  ,3)
        elseif (bcx_lo .eq. INLET) then
          s_l(is  ,1) = s(is-1,j,k,1)
          s_l(is  ,2) = s(is-1,j,k,2)
          s_l(is  ,3) = s(is-1,j,k,3)
        elseif (bcx_lo .eq. OUTLET) then
          s_l(is  ,1) = s_r(is  ,1)
          s_l(is  ,2) = s_r(is  ,2)
          s_l(is  ,3) = s_r(is  ,3)
        else
          print *,'bogus bcx_lo in mkvelflux ',bcx_lo
          stop
        endif

        if (bcx_hi .eq. PERIODIC) then
          s_r(ie+1,1) = s_r(is  ,1)
          s_r(ie+1,2) = s_r(is  ,2)
          s_r(ie+1,3) = s_r(is  ,3)
        elseif (bcx_hi .eq. WALL) then
          s_l(ie+1,1) = zero
          s_r(ie+1,1) = zero
          s_r(ie+1,2) = s_l(ie+1,2)
          s_r(ie+1,3) = s_l(ie+1,3)
        elseif (bcx_hi .eq. INLET) then
          s_r(ie+1,1) = s(ie+1,j,k,1)
          s_r(ie+1,2) = s(ie+1,j,k,2)
          s_r(ie+1,3) = s(ie+1,j,k,3)
        elseif (bcx_hi .eq. OUTLET) then
          s_r(ie+1,1) = s_l(ie+1,1)
          s_r(ie+1,2) = s_l(ie+1,2)
          s_r(ie+1,3) = s_l(ie+1,3)
        else
          print *,'bogus bcx_hi in mkvelflux ',bcx_hi
          stop
        endif

        do n = 1,3
        do i = is, ie+1 
          sedgex(i,j,k,n)=cvmgp(s_l(i,n),s_r(i,n),uadv(i,j,k))
          savg = half*(s_r(i,n) + s_l(i,n))
          sedgex(i,j,k,n)=cvmgt(savg,sedgex(i,j,k,n),abs(uadv(i,j,k)) .lt. eps)
        enddo
        enddo

        if (visc_coef .gt. 0.  .and. bcx_lo .eq. WALL) then
          sedgex(is  ,j,k,3) = zero
          sedgex(is  ,j,k,2) = zero
          sedgex(is  ,j,k,1) = zero
        endif

        if (visc_coef .gt. 0.  .and. bcx_hi .eq. WALL) then
          sedgex(ie+1,j,k,3) = zero
          sedgex(ie+1,j,k,2) = zero
          sedgex(ie+1,j,k,1) = zero
        endif
      enddo
      enddo

c        ******************************************************************
c        ******************************************************************
c        ******************************************************************

c ::: loop for y fluxes

      do k = ks, ke 
      do i = is, ie 
        do j = js, je 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN X-DIRECTION
c        ******************************************************************

          wplft = s(i  ,j,k,3) + (half - dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,3)
c    $            + dth * lapu(i  ,j,k,3) / rho(i  ,j,k)
          wprgt = s(i+1,j,k,3) - (half + dth*s(i+1,j,k,1)/hx)*slopex(i+1,j,k,3)
c    $            + dth * lapu(i+1,j,k,3) / rho(i+1,j,k)
          vplft = s(i  ,j,k,2) + (half - dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,2)
c    $            + dth * lapu(i  ,j,k,2) / rho(i  ,j,k)
          vprgt = s(i+1,j,k,2) - (half + dth*s(i+1,j,k,1)/hx)*slopex(i+1,j,k,2)
c    $            + dth * lapu(i+1,j,k,2) / rho(i+1,j,k)
          uplft = s(i  ,j,k,1) + (half - dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,1)
c    $            + dth * lapu(i  ,j,k,1) / rho(i  ,j,k)
          uprgt = s(i+1,j,k,1) - (half + dth*s(i+1,j,k,1)/hx)*slopex(i+1,j,k,1)
c    $            + dth * lapu(i+1,j,k,1) / rho(i+1,j,k)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. INLET)
          uprgt = cvmgt(s(ie+1,j,k,1),uprgt,ltp0)
          uplft = cvmgt(s(ie+1,j,k,1),uplft,ltp0)
          vprgt = cvmgt(s(ie+1,j,k,2),vprgt,ltp0)
          vplft = cvmgt(s(ie+1,j,k,2),vplft,ltp0)
          wprgt = cvmgt(s(ie+1,j,k,3),wprgt,ltp0)
          wplft = cvmgt(s(ie+1,j,k,3),wplft,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL)
          uprgt = cvmgt(zero,uprgt,ltp0)
          uplft = cvmgt(zero,uplft,ltp0)
          vprgt = cvmgt(vplft,vprgt,ltp0)
          wprgt = cvmgt(wplft,wprgt,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL  .and.  visc_coef .gt. zero)
          vprgt = cvmgt(zero,vprgt,ltp0)
          vplft = cvmgt(zero,vplft,ltp0)
          wprgt = cvmgt(zero,wprgt,ltp0)
          wplft = cvmgt(zero,wplft,ltp0)

          uplus = cvmgp(uplft,uprgt,utrans(i+1,j,k))
          uavg  = half * (uplft + uprgt)
          uplus = cvmgt(uplus, uavg, abs(utrans(i+1,j,k)) .gt. eps)

          vplus = cvmgp(vplft,vprgt,utrans(i+1,j,k))
          vavg  = half * (vplft + vprgt)
          vplus = cvmgt(vplus, vavg, abs(utrans(i+1,j,k)) .gt. eps)

          wplus = cvmgp(wplft,wprgt,utrans(i+1,j,k))
          wavg  = half * (wplft + wprgt)
          wplus = cvmgt(wplus, wavg, abs(utrans(i+1,j,k)) .gt. eps)

          wmrgt = s(i  ,j,k,3) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,3)
c    $            + dth * lapu(i  ,j,k,3) / rho(i  ,j,k)
          wmlft = s(i-1,j,k,3) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,3)
c    $            + dth * lapu(i-1,j,k,3) / rho(i-1,j,k)
          vmrgt = s(i  ,j,k,2) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,2)
c    $            + dth * lapu(i  ,j,k,2) / rho(i  ,j,k)
          vmlft = s(i-1,j,k,2) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,2)
c    $            + dth * lapu(i-1,j,k,2) / rho(i-1,j,k)
          umrgt = s(i  ,j,k,1) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,1)
c    $            + dth * lapu(i  ,j,k,1) / rho(i  ,j,k)
          umlft = s(i-1,j,k,1) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,1)
c    $            + dth * lapu(i-1,j,k,1) / rho(i-1,j,k)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. INLET)
          umrgt = cvmgt(s(is-1,j,k,1),umrgt,ltm0)
          umlft = cvmgt(s(is-1,j,k,1),umlft,ltm0)
          vmrgt = cvmgt(s(is-1,j,k,2),vmrgt,ltm0)
          vmlft = cvmgt(s(is-1,j,k,2),vmlft,ltm0)
          wmrgt = cvmgt(s(is-1,j,k,3),wmrgt,ltm0)
          wmlft = cvmgt(s(is-1,j,k,3),wmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL)
          umrgt = cvmgt(zero ,umrgt,ltm0)
          umlft = cvmgt(zero ,umlft,ltm0)
          vmlft = cvmgt(vmrgt,vmlft,ltm0)
          wmlft = cvmgt(wmrgt,wmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL  .and.  
     $            visc_coef .gt. zero)
          vmrgt = cvmgt(zero,vmrgt,ltm0)
          vmlft = cvmgt(zero,vmlft,ltm0)
          wmrgt = cvmgt(zero,wmrgt,ltm0)
          wmlft = cvmgt(zero,wmlft,ltm0)
 
          uminus = cvmgp(umlft,umrgt,utrans(i,j,k))
          uavg   = half * (umlft + umrgt)
          uminus = cvmgt(uminus, uavg, abs(utrans(i,j,k)) .gt. eps)

          vminus = cvmgp(vmlft,vmrgt,utrans(i,j,k))
          vavg   = half * (vmlft + vmrgt)
          vminus = cvmgt(vminus, vavg, abs(utrans(i,j,k)) .gt. eps)

          wminus = cvmgp(wmlft,wmrgt,utrans(i,j,k))
          wavg   = half * (wmlft + wmrgt)
          wminus = cvmgt(wminus, wavg, abs(utrans(i,j,k)) .gt. eps)

          utr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(uplus - uminus) / hx
          vtr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(vplus - vminus) / hx
          wtr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(wplus - wminus) / hx

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Z-DIRECTION
c        ******************************************************************

          wpbot = s(i,j,k  ,3) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,3) 
c    $            + dth * lapu(i,j,k  ,3) / rho(i,j,k)
          wptop = s(i,j,k+1,3) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,3)
c    $            + dth * lapu(i,j,k+1,3) / rho(i,j,k+1)
          vpbot = s(i,j,k  ,2) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,2) 
c    $            + dth * lapu(i,j,k  ,2) / rho(i,j,k)
          vptop = s(i,j,k+1,2) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,2)
c    $            + dth * lapu(i,j,k+1,2) / rho(i,j,k+1)
          upbot = s(i,j,k  ,1) + (half - dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,1)
c    $            + dth * lapu(i,j,k  ,1) / rho(i,j,k)
          uptop = s(i,j,k+1,1) - (half + dth*s(i,j,k+1,3)/hz)*slopez(i,j,k+1,1)
c    $            + dth * lapu(i,j,k+1,1) / rho(i,j,k+1)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. INLET)
          wptop = cvmgt(s(i,j,ke+1,3),wptop,ltp0)
          wpbot = cvmgt(s(i,j,ke+1,3),wpbot,ltp0)
          vptop = cvmgt(s(i,j,ke+1,2),vptop,ltp0)
          vpbot = cvmgt(s(i,j,ke+1,2),vpbot,ltp0)
          uptop = cvmgt(s(i,j,ke+1,1),uptop,ltp0)
          upbot = cvmgt(s(i,j,ke+1,1),upbot,ltp0)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL)
          wptop = cvmgt(zero,wptop,ltp0)
          wpbot = cvmgt(zero,wpbot,ltp0)
          uptop = cvmgt(upbot,uptop,ltp0)
          vptop = cvmgt(vpbot,vptop,ltp0)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)
          vptop = cvmgt(zero,vptop,ltp0)
          vpbot = cvmgt(zero,vpbot,ltp0)

          uplus = cvmgp(upbot,uptop,wtrans(i,j,k+1))
          uavg  = half * (upbot + uptop)
          uplus = cvmgt(uplus, uavg, abs(wtrans(i,j,k+1)) .gt. eps)

          vplus = cvmgp(vpbot,vptop,wtrans(i,j,k+1))
          vavg  = half * (vpbot + vptop)
          vplus = cvmgt(vplus, vavg, abs(wtrans(i,j,k+1)) .gt. eps)

          wplus = cvmgp(wpbot,wptop,wtrans(i,j,k+1))
          wavg  = half * (wpbot + wptop)
          wplus = cvmgt(wplus, wavg, abs(wtrans(i,j,k+1)) .gt. eps)

          wmtop = s(i,j,k  ,3) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,3)
c    $            + dth * lapu(i,j,k  ,3) / rho(i,j,k)
          wmbot = s(i,j,k-1,3) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,3)
c    $            + dth * lapu(i,j,k-1,3) / rho(i,j,k-1)
          vmtop = s(i,j,k  ,2) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,2)
c    $            + dth * lapu(i,j,k  ,2) / rho(i,j,k)
          vmbot = s(i,j,k-1,2) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,2)
c    $            + dth * lapu(i,j,k-1,2) / rho(i,j,k-1)
          umtop = s(i,j,k  ,1) - (half + dth*s(i,j,k  ,3)/hz)*slopez(i,j,k  ,1)
c    $            + dth * lapu(i,j,k  ,1) / rho(i,j,k)
          umbot = s(i,j,k-1,1) + (half - dth*s(i,j,k-1,3)/hz)*slopez(i,j,k-1,1)
c    $            + dth * lapu(i,j,k-1,1) / rho(i,j,k-1)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. INLET)
          wmtop = cvmgt(s(i,j,ks-1,3),wmtop,ltm0)
          wmbot = cvmgt(s(i,j,ks-1,3),wmbot,ltm0)
          vmtop = cvmgt(s(i,j,ks-1,2),vmtop,ltm0)
          vmbot = cvmgt(s(i,j,ks-1,2),vmbot,ltm0)
          umtop = cvmgt(s(i,j,ks-1,1),umtop,ltm0)
          umbot = cvmgt(s(i,j,ks-1,1),umbot,ltm0)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL)
          wmtop = cvmgt(zero ,wmtop,ltm0)
          wmbot = cvmgt(zero ,wmbot,ltm0)
          umbot = cvmgt(umtop,umbot,ltm0)
          vmbot = cvmgt(vmtop,vmbot,ltm0)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL  .and.  
     $            visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)
          vmtop = cvmgt(zero,vmtop,ltm0)
          vmbot = cvmgt(zero,vmbot,ltm0)

          uminus = cvmgp(umbot,umtop,wtrans(i,j,k))
          uavg   = half * (umbot + umtop)
          uminus = cvmgt(uminus, uavg, abs(wtrans(i,j,k)) .gt. eps)

          vminus = cvmgp(vmbot,vmtop,wtrans(i,j,k))
          vavg   = half * (vmbot + vmtop)
          vminus = cvmgt(vminus, vavg, abs(wtrans(i,j,k)) .gt. eps)

          wminus = cvmgp(wmbot,wmtop,wtrans(i,j,k))
          wavg   = half * (wmbot + wmtop)
          wminus = cvmgt(wminus, wavg, abs(wtrans(i,j,k)) .gt. eps)

          utr = utr + 
     $            half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(uplus - uminus) / hz
          vtr = vtr + 
     $            half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(vplus - vminus) / hz
          wtr = wtr +    
     $            half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(wplus - wminus) / hz

c        ******************************************************************
c        MAKE TOP AND BOTTOM STATES
c        ******************************************************************

          ut = (lapu(i,j,k,1)-px(i,j,k))/rho(i,j,k) - utr + force(i,j,k,1)
          vt = (lapu(i,j,k,2)-py(i,j,k))/rho(i,j,k) - vtr + force(i,j,k,2)
          wt = (lapu(i,j,k,3)-pz(i,j,k))/rho(i,j,k) - wtr + force(i,j,k,3)

          vbardth = dth*s(i,j,k,2)/hy

          s_b(j+1,1)= s(i,j,k,1) + (half-vbardth)*slopey(i,j,k,1) + dth*ut
          s_t(j  ,1)= s(i,j,k,1) - (half+vbardth)*slopey(i,j,k,1) + dth*ut
          s_b(j+1,2)= s(i,j,k,2) + (half-vbardth)*slopey(i,j,k,2) + dth*vt
          s_t(j  ,2)= s(i,j,k,2) - (half+vbardth)*slopey(i,j,k,2) + dth*vt
          s_b(j+1,3)= s(i,j,k,3) + (half-vbardth)*slopey(i,j,k,3) + dth*wt
          s_t(j  ,3)= s(i,j,k,3) - (half+vbardth)*slopey(i,j,k,3) + dth*wt

        enddo

        if (bcy_lo .eq. PERIODIC) then
          s_b(js  ,1) = s_b(je+1,1)
          s_b(js  ,2) = s_b(je+1,2)
          s_b(js  ,3) = s_b(je+1,3)
        elseif (bcy_lo .eq. WALL) then
          s_b(js  ,1) = s_t(js  ,1)
          s_b(js  ,3) = s_t(js  ,3)
          s_b(js  ,2) = zero
          s_t(js  ,2) = zero
        elseif (bcy_lo .eq. INLET) then
          s_b(js  ,1) = s(i,js-1,k,1)
          s_b(js  ,2) = s(i,js-1,k,2)
          s_b(js  ,3) = s(i,js-1,k,3)
        elseif (bcy_lo .eq. OUTLET) then
          s_b(js  ,1) = s_t(js  ,1)
          s_b(js  ,2) = s_t(js  ,2)
          s_b(js  ,3) = s_t(js  ,3)
        else
          print *,'bogus bcy_lo in mkvelflux ',bcy_lo
          stop
        endif

        if (bcy_hi .eq. PERIODIC) then
          s_t(je+1,1) = s_t(js  ,1)
          s_t(je+1,2) = s_t(js  ,2)
          s_t(je+1,3) = s_t(js  ,3)
        elseif (bcy_hi .eq. WALL) then
          s_t(je+1,1) = s_b(je+1,1)
          s_t(je+1,3) = s_b(je+1,3)
          s_b(je+1,2) = zero
          s_t(je+1,2) = zero
        elseif (bcy_hi .eq. INLET) then
          s_t(je+1,1) = s(i,je+1,k,1)
          s_t(je+1,2) = s(i,je+1,k,2)
          s_t(je+1,3) = s(i,je+1,k,3)
        elseif (bcy_hi .eq. OUTLET) then
          s_t(je+1,1) = s_b(je+1,1)
          s_t(je+1,2) = s_b(je+1,2)
          s_t(je+1,3) = s_b(je+1,3)
        else
          print *,'bogus bcy_hi in mkvelflux ',bcy_hi
          stop
        endif

        do n = 1,3
        do j = js, je+1 
          sedgey(i,j,k,n)=cvmgp(s_b(j,n),s_t(j,n),vadv(i,j,k))
          savg = half*(s_t(j,n) + s_b(j,n))
          sedgey(i,j,k,n)=cvmgt(savg,sedgey(i,j,k,n),abs(vadv(i,j,k)) .lt. eps)
        enddo
        enddo

        if (visc_coef .gt. 0.  .and. bcy_lo .eq. WALL) then
          sedgey(i,js  ,k,3) = zero
          sedgey(i,js  ,k,2) = zero
          sedgey(i,js  ,k,1) = zero
        endif

        if (visc_coef .gt. 0.  .and. bcy_hi .eq. WALL) then
          sedgey(i,je+1,k,3) = zero
          sedgey(i,je+1,k,2) = zero
          sedgey(i,je+1,k,1) = zero
        endif

      enddo
      enddo


c        ******************************************************************
c        ******************************************************************
c        ******************************************************************

c ::: loop for z fluxes

      do j = js, je 
      do i = is, ie 
        do k = ks, ke 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN X-DIRECTION
c        ******************************************************************

          wplft = s(i  ,j,k,3) + (half - dth*s(i  ,j,k,1)/hx) * slopex(i  ,j,k,3)
c    $            + dth * lapu(i  ,j,k,3) / rho(i,j,k)
          wprgt = s(i+1,j,k,3) - (half + dth*s(i+1,j,k,1)/hx) * slopex(i+1,j,k,3)
c    $            + dth * lapu(i+1,j,k,3) / rho(i+1,j,k)
          vplft = s(i  ,j,k,2) + (half - dth*s(i  ,j,k,1)/hx) * slopex(i  ,j,k,2)
c    $            + dth * lapu(i  ,j,k,2) / rho(i,j,k)
          vprgt = s(i+1,j,k,2) - (half + dth*s(i+1,j,k,1)/hx) * slopex(i+1,j,k,2)
c    $            + dth * lapu(i+1,j,k,2) / rho(i+1,j,k)
          uplft = s(i  ,j,k,1) + (half - dth*s(i  ,j,k,1)/hx) * slopex(i  ,j,k,1)
c    $            + dth * lapu(i  ,j,k,1) / rho(i,j,k)
          uprgt = s(i+1,j,k,1) - (half + dth*s(i+1,j,k,1)/hx) * slopex(i+1,j,k,1)
c    $            + dth * lapu(i+1,j,k,1) / rho(i+1,j,k)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. INLET)
          uprgt = cvmgt(s(ie+1,j,k,1),uprgt,ltp0)
          uplft = cvmgt(s(ie+1,j,k,1),uplft,ltp0)
          vprgt = cvmgt(s(ie+1,j,k,2),vprgt,ltp0)
          vplft = cvmgt(s(ie+1,j,k,2),vplft,ltp0)
          wprgt = cvmgt(s(ie+1,j,k,3),wprgt,ltp0)
          wplft = cvmgt(s(ie+1,j,k,3),wplft,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL)
          uprgt = cvmgt(zero,uprgt,ltp0)
          uplft = cvmgt(zero,uplft,ltp0)
          vprgt = cvmgt(vplft,vprgt,ltp0)
          wprgt = cvmgt(wplft,wprgt,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL  .and.  visc_coef .gt. zero)
          vprgt = cvmgt(zero,vprgt,ltp0)
          vplft = cvmgt(zero,vplft,ltp0)
          wprgt = cvmgt(zero,wprgt,ltp0)
          wplft = cvmgt(zero,wplft,ltp0)

          uplus = cvmgp(uplft,uprgt,utrans(i+1,j,k))
          uavg  = half * (uplft + uprgt)
          uplus = cvmgt(uplus, uavg, abs(utrans(i+1,j,k)) .gt. eps)

          vplus = cvmgp(vplft,vprgt,utrans(i+1,j,k))
          vavg  = half * (vplft + vprgt)
          vplus = cvmgt(vplus, vavg, abs(utrans(i+1,j,k)) .gt. eps)

          wplus = cvmgp(wplft,wprgt,utrans(i+1,j,k))
          wavg  = half * (wplft + wprgt)
          wplus = cvmgt(wplus, wavg, abs(utrans(i+1,j,k)) .gt. eps)

          wmrgt = s(i  ,j,k,3) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,3)
c    $            + dth * lapu(i  ,j,k,3) / rho(i  ,j,k)
          wmlft = s(i-1,j,k,3) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,3)
c    $            + dth * lapu(i-1,j,k,3) / rho(i-1,j,k)
          vmrgt = s(i  ,j,k,2) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,2)
c    $            + dth * lapu(i  ,j,k,2) / rho(i  ,j,k)
          vmlft = s(i-1,j,k,2) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,2)
c    $            + dth * lapu(i-1,j,k,2) / rho(i-1,j,k)
          umrgt = s(i  ,j,k,1) - (half + dth*s(i  ,j,k,1)/hx)*slopex(i  ,j,k,1)
c    $            + dth * lapu(i  ,j,k,1) / rho(i  ,j,k)
          umlft = s(i-1,j,k,1) + (half - dth*s(i-1,j,k,1)/hx)*slopex(i-1,j,k,1)
c    $            + dth * lapu(i-1,j,k,1) / rho(i-1,j,k)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. INLET)
          umrgt = cvmgt(s(is-1,j,k,1),umrgt,ltm0)
          umlft = cvmgt(s(is-1,j,k,1),umlft,ltm0)
          vmrgt = cvmgt(s(is-1,j,k,2),vmrgt,ltm0)
          vmlft = cvmgt(s(is-1,j,k,2),vmlft,ltm0)
          wmrgt = cvmgt(s(is-1,j,k,3),wmrgt,ltm0)
          wmlft = cvmgt(s(is-1,j,k,3),wmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL)
          umrgt = cvmgt(zero ,umrgt,ltm0)
          umlft = cvmgt(zero ,umlft,ltm0)
          vmlft = cvmgt(vmrgt,vmlft,ltm0)
          wmlft = cvmgt(wmrgt,wmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL  .and.  
     $            visc_coef .gt. zero)
          vmrgt = cvmgt(zero,vmrgt,ltm0)
          vmlft = cvmgt(zero,vmlft,ltm0)
          wmrgt = cvmgt(zero,wmrgt,ltm0)
          wmlft = cvmgt(zero,wmlft,ltm0)
 
          uminus = cvmgp(umlft,umrgt,utrans(i,j,k))
          uavg   = half * (umlft + umrgt)
          uminus = cvmgt(uminus, uavg, abs(utrans(i,j,k)) .gt. eps)

          vminus = cvmgp(vmlft,vmrgt,utrans(i,j,k))
          vavg   = half * (vmlft + vmrgt)
          vminus = cvmgt(vminus, vavg, abs(utrans(i,j,k)) .gt. eps)

          wminus = cvmgp(wmlft,wmrgt,utrans(i,j,k))
          wavg   = half * (wmlft + wmrgt)
          wminus = cvmgt(wminus, wavg, abs(utrans(i,j,k)) .gt. eps)

          utr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(uplus - uminus) / hx
          vtr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(vplus - vminus) / hx
          wtr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(wplus - wminus) / hx

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Y-DIRECTION
c        ******************************************************************

          wpbot = s(i,j  ,k,3) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,3) 
c    $            + dth * lapu(i,j  ,k,3) / rho(i,j,k)
          wptop = s(i,j+1,k,3) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,3)
c    $            + dth * lapu(i,j+1,k,3) / rho(i,j+1,k)
          vpbot = s(i,j  ,k,2) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,2) 
c    $            + dth * lapu(i,j  ,k,2) / rho(i,j,k)
          vptop = s(i,j+1,k,2) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,2)
c    $            + dth * lapu(i,j+1,k,2) / rho(i,j+1,k)
          upbot = s(i,j  ,k,1) + (half - dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,1)
c    $            + dth * lapu(i,  j,k,1) / rho(i,j,k)
          uptop = s(i,j+1,k,1) - (half + dth*s(i,j+1,k,2)/hy)*slopey(i,j+1,k,1)
c    $            + dth * lapu(i,j+1,k,1) / rho(i,j+1,k)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. INLET)
          wptop = cvmgt(s(i,je+1,k,3),wptop,ltp0)
          wpbot = cvmgt(s(i,je+1,k,3),wpbot,ltp0)
          vptop = cvmgt(s(i,je+1,k,2),vptop,ltp0)
          vpbot = cvmgt(s(i,je+1,k,2),vpbot,ltp0)
          uptop = cvmgt(s(i,je+1,k,1),uptop,ltp0)
          upbot = cvmgt(s(i,je+1,k,1),upbot,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL)
          vptop = cvmgt(zero,vptop,ltp0)
          vpbot = cvmgt(zero,vpbot,ltp0)
          uptop = cvmgt(upbot,uptop,ltp0)
          wptop = cvmgt(wpbot,wptop,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)
          wptop = cvmgt(zero,wptop,ltp0)
          wpbot = cvmgt(zero,wpbot,ltp0)

          uplus = cvmgp(upbot,uptop,vtrans(i,j+1,k))
          uavg  = half * (upbot + uptop)
          uplus = cvmgt(uplus, uavg, abs(vtrans(i,j+1,k)) .gt. eps)

          vplus = cvmgp(vpbot,vptop,vtrans(i,j+1,k))
          vavg  = half * (vpbot + vptop)
          vplus = cvmgt(vplus, vavg, abs(vtrans(i,j+1,k)) .gt. eps)

          wplus = cvmgp(wpbot,wptop,vtrans(i,j+1,k))
          wavg  = half * (wpbot + wptop)
          wplus = cvmgt(wplus, wavg, abs(vtrans(i,j+1,k)) .gt. eps)

          wmtop = s(i,j  ,k,3) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,3)
c    $            + dth * lapu(i,j  ,k,3) / rho(i,j,k)
          wmbot = s(i,j-1,k,3) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,3)
c    $            + dth * lapu(i,j-1,k,3) / rho(i,j-1,k)
          vmtop = s(i,j  ,k,2) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,2)
c    $            + dth * lapu(i,j  ,k,2) / rho(i,j,k)
          vmbot = s(i,j-1,k,2) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,2)
c    $            + dth * lapu(i,j-1,k,2) / rho(i,j-1,k)
          umtop = s(i,j  ,k,1) - (half + dth*s(i,j  ,k,2)/hy)*slopey(i,j  ,k,1)
c    $            + dth * lapu(i,j  ,k,1) / rho(i,j,k)
          umbot = s(i,j-1,k,1) + (half - dth*s(i,j-1,k,2)/hy)*slopey(i,j-1,k,1)
c    $            + dth * lapu(i,j-1,k,1) / rho(i,j-1,k)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. INLET)
          wmtop = cvmgt(s(i,js-1,k,3),wmtop,ltm0)
          wmbot = cvmgt(s(i,js-1,k,3),wmbot,ltm0)
          vmtop = cvmgt(s(i,js-1,k,2),vmtop,ltm0)
          vmbot = cvmgt(s(i,js-1,k,2),vmbot,ltm0)
          umtop = cvmgt(s(i,js-1,k,1),umtop,ltm0)
          umbot = cvmgt(s(i,js-1,k,1),umbot,ltm0)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL)
          vmtop = cvmgt(zero ,vmtop,ltm0)
          vmbot = cvmgt(zero ,vmbot,ltm0)
          umbot = cvmgt(umtop,umbot,ltm0)
          wmbot = cvmgt(wmtop,wmbot,ltm0)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL  .and. visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)
          wmtop = cvmgt(zero,wmtop,ltm0)
          wmbot = cvmgt(zero,wmbot,ltm0)

          uminus = cvmgp(umbot,umtop,vtrans(i,j,k))
          uavg   = half * (umbot + umtop)
          uminus = cvmgt(uminus, uavg, abs(vtrans(i,j,k)) .gt. eps)

          vminus = cvmgp(vmbot,vmtop,vtrans(i,j,k))
          vavg   = half * (vmbot + vmtop)
          vminus = cvmgt(vminus, vavg, abs(vtrans(i,j,k)) .gt. eps)

          wminus = cvmgp(wmbot,wmtop,vtrans(i,j,k))
          wavg   = half * (wmbot + wmtop)
          wminus = cvmgt(wminus, wavg, abs(vtrans(i,j,k)) .gt. eps)

          utr =  utr  + 
     $              half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(uplus - uminus) / hy
          vtr =  vtr + 
     $              half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(vplus - vminus) / hy
          wtr =  wtr + 
     $              half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(wplus - wminus) / hy

c        ******************************************************************
c        MAKE DOWN AND UP STATES
c        ******************************************************************

          ut = (lapu(i,j,k,1)-px(i,j,k))/rho(i,j,k) - utr + force(i,j,k,1)
          vt = (lapu(i,j,k,2)-py(i,j,k))/rho(i,j,k) - vtr + force(i,j,k,2)
          wt = (lapu(i,j,k,3)-pz(i,j,k))/rho(i,j,k) - wtr + force(i,j,k,3)

          wbardth = dth*s(i,j,k,3)/hz

          s_d(k+1,1)= s(i,j,k,1) + (half-wbardth)*slopez(i,j,k,1) + dth*ut
          s_u(k  ,1)= s(i,j,k,1) - (half+wbardth)*slopez(i,j,k,1) + dth*ut
          s_d(k+1,2)= s(i,j,k,2) + (half-wbardth)*slopez(i,j,k,2) + dth*vt
          s_u(k  ,2)= s(i,j,k,2) - (half+wbardth)*slopez(i,j,k,2) + dth*vt
          s_d(k+1,3)= s(i,j,k,3) + (half-wbardth)*slopez(i,j,k,3) + dth*wt
          s_u(k  ,3)= s(i,j,k,3) - (half+wbardth)*slopez(i,j,k,3) + dth*wt

        enddo

        if (bcz_lo .eq. PERIODIC) then
          s_d(ks  ,1) = s_d(ke+1,1)
          s_d(ks  ,2) = s_d(ke+1,2)
          s_d(ks  ,3) = s_d(ke+1,3)
        elseif (bcz_lo .eq. WALL) then
          s_d(ks  ,1) = s_u(ks  ,1)
          s_d(ks  ,2) = s_u(ks  ,2)
          s_d(ks  ,3) = zero
          s_u(ks  ,3) = zero
        elseif (bcz_lo .eq. INLET) then
          s_d(ks  ,1) = s(i,j,ks-1,1)
          s_d(ks  ,2) = s(i,j,ks-1,2)
          s_d(ks  ,3) = s(i,j,ks-1,3)
        elseif (bcz_lo .eq. OUTLET) then
          s_d(ks  ,1) = s_u(ks  ,1)
          s_d(ks  ,2) = s_u(ks  ,2)
          s_d(ks  ,3) = s_u(ks  ,3)
        else
          print *,'bogus bcz_lo in mkvelflux ',bcz_lo
          stop
        endif

        if (bcz_hi .eq. PERIODIC) then
          s_u(ke+1,1) = s_u(ks  ,1)
          s_u(ke+1,2) = s_u(ks  ,2)
          s_u(ke+1,3) = s_u(ks  ,3)
        elseif (bcz_hi .eq. WALL) then
          s_u(ke+1,1) = s_d(ke+1,1)
          s_u(ke+1,2) = s_d(ke+1,2)
          s_d(ke+1,3) = zero
          s_u(ke+1,3) = zero
        elseif (bcz_hi .eq. INLET) then
          s_u(ke+1,1) = s(i,j,ke+1,1)
          s_u(ke+1,2) = s(i,j,ke+1,2)
          s_u(ke+1,3) = s(i,j,ke+1,3)
        elseif (bcz_hi .eq. OUTLET) then
          s_u(ke+1,1) = s_d(ke+1,1)
          s_u(ke+1,2) = s_d(ke+1,2)
          s_u(ke+1,3) = s_d(ke+1,3)
        else
          print *,'bogus bcz_hi in mkvelflux ',bcz_hi
          stop
        endif

        do n = 1,3
        do k = ks, ke+1 
          sedgez(i,j,k,n)=cvmgp(s_d(k,n),s_u(k,n),wadv(i,j,k))
          savg = half*(s_d(k,n) + s_u(k,n))
          sedgez(i,j,k,n)=cvmgt(savg,sedgez(i,j,k,n),abs(wadv(i,j,k)) .lt. eps)
        enddo
        enddo

        if ((visc_coef .gt. zero)  .and.  (bcz_lo .eq. WALL)) then
          sedgez(i,j,ks  ,1) = zero
          sedgez(i,j,ks  ,2) = zero
          sedgez(i,j,ks  ,3) = zero
        endif

        if ((visc_coef .gt. zero)  .and.  (bcz_hi .eq. WALL)) then
          sedgez(i,j,ke+1,1) = zero
          sedgez(i,j,ke+1,2) = zero
          sedgez(i,j,ke+1,3) = zero
        endif

      enddo
      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: GODUNOV_2D.F,v 1.36 2003/02/28 18:35:06 almgren Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "GODUNOV_F.H"
#include "ArrayLim.H"

#define SDIM 2
#define XVEL 1
#define YVEL 2

      subroutine FORT_ESTDT (
     &     vel,DIMS(vel),
     &     tforces,DIMS(tf),
     &     rho,DIMS(rho),
     &     lo,hi,dt,dx,cfl,u_max)
c 
c     ----------------------------------------------------------
c     estimate the timestep for this grid and scale by CFL number
c     This routine sets dt as dt = dt_est*cfl where
c     dt_est is estimated from the actual velocities and their 
c     total forcing
c     ----------------------------------------------------------
c 
      REAL_T    u, v
      REAL_T    small
      REAL_T    dt_start
      REAL_T    tforce1
      REAL_T    tforce2
      integer   i, j
      integer lo(SDIM), hi(SDIM)
      REAL_T  dt,dx(SDIM),cfl,u_max(SDIM)

      integer DIMDEC(vel)
      integer DIMDEC(rho)
      integer DIMDEC(tf)

      REAL_T  vel(DIMV(vel),SDIM)
      REAL_T  rho(DIMV(rho))
      REAL_T  tforces(DIMV(tf),SDIM)

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
      small   = 1.0e-8
#else
      small   = 1.0d-8
#endif
      u       = zero
      v       = zero
      tforce1 = zero
      tforce2 = zero

      do j = lo(2), hi(2)
         do i = lo(1), hi(1)
            u = max(u,abs(vel(i,j,1)))
            v = max(v,abs(vel(i,j,2)))
c            tforce1 = max(tforce1,abs(tforces(i,j,1)/rho(i,j)))
c            tforce2 = max(tforce2,abs(tforces(i,j,2)/rho(i,j)))
         end do
      end do

      u_max(1) = u
      u_max(2) = v

      dt_start = 1.0D+20
      dt = dt_start

      if (u .gt. small) dt = min(dt,dx(1)/u)
      if (v .gt. small) dt = min(dt,dx(2)/v)

      if (tforce1 .gt. small) then
        dt  = min(dt,sqrt(two*dx(1)/tforce1))
      end if

      if (tforce2 .gt. small) then
        dt  = min(dt,sqrt(two*dx(2)/tforce2))
      end if

      if (dt .eq. dt_start) dt = min(dx(1),dx(2))

      dt = dt*cfl

      end

      subroutine FORT_TEST_U_RHO(
     &     u,DIMS(u),
     &     v,DIMS(v),
     &     rho,DIMS(rho),
     &     lo,hi,dt,dx,cflmax,u_max,verbose )
c
c     This subroutine computes the extrema of the density
c     and velocities at cell centers
c
      integer DIMDEC(u)
      integer DIMDEC(v)
      integer DIMDEC(rho)
      REAL_T  u(DIMV(u))
      REAL_T  v(DIMV(v))
      REAL_T  rho(DIMV(rho))
      integer lo(SDIM)
      integer hi(SDIM)
      REAL_T  dt
      REAL_T  dx(SDIM)
      REAL_T  cflmax
      REAL_T  u_max(SDIM)
      integer verbose
c
      REAL_T  hx, hy
      REAL_T  umax, vmax, rhomax
      REAL_T  umin, vmin, rhomin
      integer imin, imax, jmin, jmax
      integer i, j
c
      hx   = dx(1)
      hy   = dx(2)
      imin = lo(1)
      imax = hi(1)
      jmin = lo(2)
      jmax = hi(2)
      umax = -1.d200
      vmax = -1.d200
      umin =  1.d200
      vmin =  1.d200
      rhomax = -1.d200
      rhomin =  1.d200
c
      do j = jmin, jmax
         do i = imin, imax
            umax = max(umax,u(i,j))
            umin = min(umin,u(i,j))
            vmax = max(vmax,v(i,j))
            vmin = min(vmin,v(i,j))
            rhomax = max(rhomax,rho(i,j))
            rhomin = min(rhomin,rho(i,j))
         end do
      end do

      u_max(1) = max(abs(umax), abs(umin))
      u_max(2) = max(abs(vmax), abs(vmin))
      cflmax   = dt*max(u_max(1)/hx,u_max(2)/hy)

      if(verbose.eq.1)then
        write(6,1000) umax,umin,u_max(1) 
        write(6,1001) vmax,vmin,u_max(2) 
        write(6,1002) rhomax,rhomin
#ifndef	BL_NO_FORT_FLUSH
c        call flush(6)
#endif
      end if

 1000 format(' U  MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1001 format(' V  MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1002 format('RHO MAX/MIN      ',e21.14,2x,e21.14)

      end

      subroutine FORT_TEST_UMAC_RHO(
     &     umac,DIMS(umac),
     &     vmac,DIMS(vmac),
     &     rho,DIMS(rho),
     &     lo,hi,dt,dx,cflmax,u_max)
c
c     This subroutine computes the extrema of the density
c     and mac edge velocities
c
      integer DIMDEC(umac)
      integer DIMDEC(vmac)
      integer DIMDEC(rho)
      integer imin, imax, jmin, jmax
      integer i, j
      integer lo(SDIM),hi(SDIM)
      REAL_T  dt, dx(SDIM), u_max(SDIM), cflmax
      REAL_T  hx, hy
      REAL_T  umax, vmax, rhomax
      REAL_T  umin, vmin, rhomin
      REAL_T  umac(DIMV(umac))
      REAL_T  vmac(DIMV(vmac))
      REAL_T  rho(DIMV(rho))

      hx   = dx(1)
      hy   = dx(2)
      imin = lo(1)
      imax = hi(1)
      jmin = lo(2)
      jmax = hi(2)
      umax = -1.d200
      vmax = -1.d200
      umin =  1.d200
      vmin =  1.d200
      rhomax = -1.d200
      rhomin =  1.d200

      do j = jmin, jmax
         do i = imin, imax+1
            umax = max(umax,umac(i,j))
            umin = min(umin,umac(i,j))
         end do
      end do
      do j = jmin, jmax+1
         do i = imin, imax
            vmax = max(vmax,vmac(i,j))
            vmin = min(vmin,vmac(i,j))
         end do
      end do
      do j = jmin, jmax
         do i = imin, imax
            rhomax = max(rhomax,rho(i,j))
            rhomin = min(rhomin,rho(i,j))
         end do
      end do

      u_max(1) = max(abs(umax), abs(umin))
      u_max(2) = max(abs(vmax), abs(vmin))
      cflmax   = dt*max(u_max(1)/hx,u_max(2)/hy)

      write(6,1000) umax,umin,u_max(1) 
      write(6,1001) vmax,vmin,u_max(2) 
      write(6,1002) rhomax,rhomin

 1000 format('UMAC MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1001 format('VMAC MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1002 format('RHO  MAX/MIN      ',e21.14,2x,e21.14)

#ifndef	BL_NO_FORT_FLUSH
c      call flush(6)
#endif

      end

      subroutine FORT_TRANSVEL(
     &     u, ulo, uhi, sx, ubc, slxscr,
     &     v, vlo, vhi, sy, vbc, slyscr,
     &     DIMS(s), DIMS(work),
     &     lo,hi,dt,dx,use_minion,tforces)
c
c     This subroutine computes the advective velocities used in
c     the transverse derivatives of the Godunov box
c
      implicit none
      integer i,j
      integer ubc(SDIM,2),vbc(SDIM,2)
      integer lo(SDIM),hi(SDIM)
      integer imin,jmin,imax,jmax
      REAL_T hx, hy, dt, dth, dthx, dthy,dx(SDIM)
      REAL_T uad,vad
      REAL_T eps,eps_for_bc
      logical ltm
      parameter( eps        = 1.0D-6 )
      parameter( eps_for_bc = 1.0D-10 )
      integer DIMDEC(s)
      integer DIMDEC(work)
      REAL_T  u(DIMV(s))
      REAL_T  v(DIMV(s))
      REAL_T ulo(DIMV(work)),uhi(DIMV(work))
      REAL_T vlo(DIMV(work)),vhi(DIMV(work))
      REAL_T sx(DIMV(work))
      REAL_T sy(DIMV(work))
      REAL_T slxscr(DIM1(s), 4)
      REAL_T slyscr(DIM2(s), 4)

      integer use_minion
      REAL_T tforces(DIMV(work),SDIM)

      dth  = half*dt
      dthx = half*dt / dx(1)
      dthy = half*dt / dx(2)
      hx   = dx(1)
      hy   = dx(2)
      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)
c
c     --------------------------------------------------------------
c     compute the x transverse velocities
c     --------------------------------------------------------------
c
      call FORT_SLOPES(u,DIMS(s),
     &     sx,sy,DIMS(work),lo,hi,slxscr,slyscr,ubc)

      do i = imin, imax+1
         do j = jmin-1,jmax+1
            ulo(i,j) = u(i-1,j) + (half  - dthx*u(i-1,j))*sx(i-1,j)
            uhi(i,j) = u(i,j)   + (-half - dthx*u(i,  j))*sx(i,j)
         end do
      end do

      if(use_minion.eq.1)then
        do i = imin, imax+1
          do j = jmin-1,jmax+1
            ulo(i,j) = ulo(i,j) + dth*tforces(i-1,j,1)
            uhi(i,j) = uhi(i,j) + dth*tforces(i,  j,1)
          end do
        end do
      end if

      call trans_xbc(u,DIMS(s),
     &     ulo,uhi,DIMS(work),ulo,DIMS(work),lo,hi,XVEL,ubc,eps_for_bc)

      do i = imin,imax+1
         do j = jmin-1,jmax+1
            uad = cvmgp(ulo(i,j),uhi(i,j),ulo(i,j)+uhi(i,j))
            ltm = ulo(i,j) .le. zero  .and.  uhi(i,j) .ge. zero
            ltm = ltm .or. (abs(ulo(i,j)+uhi(i,j)) .lt. eps)
            ulo(i,j) = cvmgt(zero,uad,ltm)
         end do
      end do
c
c     compute the y transverse velocities
c
      call FORT_SLOPES(v,DIMS(s),
     &     sx,sy,DIMS(work),lo,hi,slxscr,slyscr,vbc)

      do i = imin-1,imax+1
         do j = jmin,jmax+1
            vlo(i,j) = v(i,j-1) + (half  - dthy*v(i,j-1))*sy(i,j-1)
            vhi(i,j) = v(i,j)   + (-half - dthy*v(i,j  ))*sy(i,j)
         end do
      end do

      if(use_minion.eq.1)then
         do i = imin-1, imax+1
            do j = jmin,jmax+1
               vlo(i,j) = vlo(i,j) + dth*tforces(i,j-1,2)
               vhi(i,j) = vhi(i,j) + dth*tforces(i,j,  2)
            end do
         end do
      end if

      call trans_ybc(v,DIMS(s),
     &     vlo,vhi,DIMS(work),vlo,DIMS(work),lo,hi,YVEL,vbc,eps_for_bc)

      do i = imin-1,imax+1
         do j = jmin,jmax+1
            vad = cvmgp(vlo(i,j),vhi(i,j),vlo(i,j)+vhi(i,j))
            ltm = vlo(i,j) .le. zero  .and.  vhi(i,j) .ge. zero
            ltm = ltm .or. (abs(vlo(i,j)+vhi(i,j)) .lt. eps)
            vlo(i,j) = cvmgt(zero,vad,ltm)
         end do
      end do

      end

      subroutine FORT_ESTATE(s, tforces, DIMS(s),

     &     u, xlo, xhi, sx, uad, slxscr, stxlo, stxhi,
     &     uedge, DIMS(uedge), xstate, DIMS(xstate),

     &     v, ylo, yhi, sy, vad, slyscr, stylo, styhi,
     &     vedge, DIMS(vedge), ystate, DIMS(ystate),

     &     DIMS(work),
     &     bc,lo,hi,dt,dx,n,velpred, use_minion)
c
      integer i,j,n,velpred
      integer lo(SDIM),hi(SDIM),bc(SDIM,2)
      integer imin,jmin,imax,jmax
      REAL_T place_to_break
      REAL_T hx, hy, dt, dth, dthx, dthy, dx(SDIM)
      REAL_T tr,stx,sty,fu,fv
      REAL_T eps,eps_for_bc
      logical ltx,lty
      parameter( eps        = 1.0D-6 )
      parameter( eps_for_bc = 1.0D-10 )

      integer DIMDEC(s)
      integer DIMDEC(work)
      integer DIMDEC(uedge)
      integer DIMDEC(vedge)
      integer DIMDEC(xstate)
      integer DIMDEC(ystate)

      REAL_T s(DIMV(s))
      REAL_T u(DIMV(s))
      REAL_T v(DIMV(s))
      REAL_T stxlo(DIM1(s)),stxhi(DIM1(s)),slxscr(DIM1(s),4)
      REAL_T stylo(DIM2(s)),styhi(DIM2(s)),slyscr(DIM2(s),4)

      REAL_T uedge(DIMV(uedge)), xstate(DIMV(uedge))
      REAL_T vedge(DIMV(vedge)), ystate(DIMV(vedge))

      REAL_T xlo(DIMV(work)), xhi(DIMV(work))
      REAL_T ylo(DIMV(work)), yhi(DIMV(work))
      REAL_T  sx(DIMV(work)), uad(DIMV(work)) 
      REAL_T  sy(DIMV(work)), vad(DIMV(work)) 
      REAL_T tforces(DIMV(work))

      integer use_minion

      dth  = half*dt
      dthx = half*dt/dx(1)
      dthy = half*dt/dx(2)
      hx = dx(1)
      hy = dx(2)
      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)
c
c     compute the slopes
c
c     trace the state to the cell edges
c
      call FORT_SLOPES(s,DIMS(s),
     &     sx,sy,DIMS(work),lo,hi,slxscr,slyscr,bc)
c
c     trace the state to the cell edges
c
      do i = imin, imax+1
         do j = jmin-1,jmax+1
            xlo(i,j) = s(i-1,j) + (half - dthx*u(i-1,j))*sx(i-1,j)
            xhi(i,j) = s(i  ,j) - (half + dthx*u(i  ,j))*sx(i  ,j)
         end do
      end do

      if(use_minion.eq.1)then
         do i = imin, imax+1
            do j = jmin-1,jmax+1
               xlo(i,j) = xlo(i,j) + dth*tforces(i-1,j)
               xhi(i,j) = xhi(i,j) + dth*tforces(i,  j)
            end do
         end do
      end if

      call trans_xbc(s,DIMS(s),
     &     xlo,xhi,DIMS(work),uad,DIMS(work),lo,hi,n,bc,eps_for_bc)
      
      do i = imin, imax+1
         do j = jmin-1,jmax+1
            fu  = cvmgt(zero,one,abs(uad(i,j)).lt.eps)
            stx = cvmgp(xlo(i,j),xhi(i,j),uad(i,j))
            xlo(i,j) = fu*stx + (one - fu)*half*(xhi(i,j)+xlo(i,j))
         end do
      end do

      do j = jmin,jmax+1
         do i = imin-1,imax+1
            ylo(i,j) = s(i,j-1) + (half - dthy*v(i,j-1))*sy(i,j-1)
            yhi(i,j) = s(i,j  ) - (half + dthy*v(i,j  ))*sy(i,j  )
         end do
      end do

      if(use_minion.eq.1)then
         do i = imin-1, imax+1
            do j = jmin,jmax+1
               ylo(i,j) = ylo(i,j) + dth*tforces(i,j-1)
               yhi(i,j) = yhi(i,j) + dth*tforces(i,j)
            end do
         end do
      end if

      call trans_ybc(s,DIMS(s),
     &     ylo,yhi,DIMS(work),vad,DIMS(work),lo,hi,n,bc,eps_for_bc)

      do j = jmin,jmax+1
         do i = imin-1,imax+1
            fv  = cvmgt(zero,one,abs(vad(i,j)).lt.eps)
            sty = cvmgp(ylo(i,j),yhi(i,j),vad(i,j))
            ylo(i,j) = fv*sty + (one - fv)*half*(yhi(i,j)+ylo(i,j))
         end do
      end do
c
c     compute the xedge state
c
      if ((velpred.ne.1) .or. (n.eq.XVEL)) then
         do 100 j = jmin,jmax
            do i = imin-1,imax+1
               tr = half*
     &              (vad(i,j+1)+vad(i,j))*
     &              (ylo(i,j+1)-ylo(i,j))/hy
               
               stxlo(i+1) = s(i,j) + (half-dthx*u(i,j))*sx(i,j)
     &              - dth*tr
     &              + dth*tforces(i,j)
               stxhi(i  ) = s(i,j) - (half+dthx*u(i,j))*sx(i,j)
     &              - dth*tr
     &              + dth*tforces(i,j)
            end do

            if (bc(1,1).eq.EXT_DIR .and. uad(imin,j).ge.zero) then
               stxhi(imin) = s(imin-1,j)
               stxlo(imin) = s(imin-1,j)
            else if (bc(1,1).eq.EXT_DIR .and. uad(imin,j).lt.zero) then
               stxlo(imin) = stxhi(imin)
            else if (bc(1,1).eq.FOEXTRAP.or.bc(1,1).eq.HOEXTRAP
     &              .or.bc(1,1).eq.REFLECT_EVEN) then
               stxlo(imin) = stxhi(imin)
            else if (bc(1,1).eq.REFLECT_ODD) then
               stxhi(imin) = zero
               stxlo(imin) = stxhi(imin)
            end if

            if (bc(1,2).eq.EXT_DIR .and. uad(imax+1,j).le.zero) then
               stxlo(imax+1) = s(imax+1,j)
               stxhi(imax+1) = s(imax+1,j)
            else if (bc(1,2).eq.EXT_DIR .and. uad(imax+1,j).gt.zero) then
               stxhi(imax+1) = stxlo(imax+1) 
            else if (bc(1,2).eq.FOEXTRAP.or.bc(1,2).eq.HOEXTRAP
     &              .or.bc(1,2).eq.REFLECT_EVEN) then
               stxhi(imax+1) = stxlo(imax+1)
            else if (bc(1,2).eq.REFLECT_ODD) then
               stxlo(imax+1) = zero
               stxhi(imax+1) = zero
            end if

            if ( velpred .eq. 1 ) then
               do i = imin, imax+1
                  ltx = stxlo(i) .le. zero  .and.  stxhi(i) .ge. zero
                  ltx = ltx .or. (abs(stxlo(i)+stxhi(i)) .lt. eps)
                  stx = cvmgp(stxlo(i),stxhi(i),stxlo(i)+stxhi(i))
                  xstate(i,j) = cvmgt(zero,stx,ltx)
               end do
            else
               do i = imin, imax+1
                  xstate(i,j) = cvmgp(stxlo(i),stxhi(i),uedge(i,j))
                  xstate(i,j) = cvmgt(half*(stxlo(i)+stxhi(i)),xstate(i,j),
     &                 abs(uedge(i,j)).lt.eps)
               end do
            end if
            place_to_break = 1
100      continue
      end if
c
c     compute the yedge states
c      
      if ((velpred.ne.1) .or. (n.eq.YVEL)) then
         do 200 i = imin, imax
            do j = jmin-1,jmax+1
               tr = half*
     &              (uad(i+1,j)+uad(i,j))*
     &              (xlo(i+1,j)-xlo(i,j))/hx

               stylo(j+1)= s(i,j) + (half-dthy*v(i,j))*sy(i,j)
     &              - dth*tr
     &              + dth*tforces(i,j)
               styhi(j  )= s(i,j) - (half+dthy*v(i,j))*sy(i,j)
     &              - dth*tr
     &              + dth*tforces(i,j)
            end do

            if (bc(2,1).eq.EXT_DIR .and. vad(i,jmin).ge.zero) then
               styhi(jmin) = s(i,jmin-1)
               stylo(jmin) = s(i,jmin-1)
            else if (bc(2,1).eq.EXT_DIR .and. vad(i,jmin).lt.zero) then
               stylo(jmin) = styhi(jmin)
            else if (bc(2,1).eq.FOEXTRAP.or.bc(2,1).eq.HOEXTRAP
     &              .or.bc(2,1).eq.REFLECT_EVEN) then
               stylo(jmin) = styhi(jmin)
            else if (bc(2,1).eq.REFLECT_ODD) then
               styhi(jmin) = zero
               stylo(jmin) = zero
            end if
            
            if (bc(2,2).eq.EXT_DIR .and. vad(i,jmax+1).le.zero) then
               stylo(jmax+1) = s(i,jmax+1)
               styhi(jmax+1) = s(i,jmax+1)
            else if (bc(2,2).eq.EXT_DIR .and. vad(i,jmax+1).gt.zero) then
               styhi(jmax+1) = stylo(jmax+1)
            else if (bc(2,2).eq.FOEXTRAP.or.bc(2,2).eq.HOEXTRAP
     &              .or.bc(2,2).eq.REFLECT_EVEN) then
               styhi(jmax+1) = stylo(jmax+1)
            else if (bc(2,2).eq.REFLECT_ODD) then
               stylo(jmax+1) = zero
               styhi(jmax+1) = zero
            end if

            if ( velpred .eq. 1 ) then
               do j = jmin, jmax+1
                  lty = stylo(j) .le. zero  .and.  styhi(j) .ge. zero
                  lty = lty .or. (abs(stylo(j)+styhi(j)) .lt. eps)
                  sty = cvmgp(stylo(j),styhi(j),stylo(j)+styhi(j))
                  ystate(i,j)=cvmgt(zero,sty,lty)
               end do
            else
               do j=jmin,jmax+1
                  ystate(i,j) = cvmgp(stylo(j),styhi(j),vedge(i,j))
                  ystate(i,j) = cvmgt(half*(stylo(j)+styhi(j)),ystate(i,j),
     &                 abs(vedge(i,j)).lt.eps)
               end do
            end if
            place_to_break = 1
200      continue
      end if
      end

      subroutine FORT_ESTATE_FPU(s, tforces, divu, DIMS(s),
     &     xlo, xhi, sx, slxscr, stxlo, stxhi,
     &     uedge, DIMS(uedge), xstate, DIMS(xstate),

     &     ylo, yhi, sy, slyscr, stylo, styhi,
     &     vedge, DIMS(vedge), ystate, DIMS(ystate),

     &     DIMS(work),
     &     bc,lo,hi,dt,dx,n,use_minion,iconserv)
c
c     This subroutine computes edges states, right now it uses
c     a lot of memory, but there becomes a trade off between
c     simplicity-efficiency in the new way of computing states
c     and complexity in the old way.  By eliminating loops over
c     state components though, the new way uses much less memory.
c
      integer i,j,n
      integer lo(SDIM),hi(SDIM),bc(SDIM,2)
      integer imin,jmin,imax,jmax
      REAL_T place_to_break
      REAL_T hx, hy, dt, dth, dthx, dthy
      REAL_T tr,ubar,vbar,stx,sty,fu,fv,dx(SDIM)
      REAL_T eps,eps_for_bc
      logical ltx,lty
      parameter( eps        = 1.0D-6 )
      parameter( eps_for_bc = 1.0D-10 )

      integer DIMDEC(s)
      integer DIMDEC(work)
      integer DIMDEC(uedge)
      integer DIMDEC(xstate)
      integer DIMDEC(vedge)
      integer DIMDEC(ystate)

      REAL_T s(DIMV(s))
      REAL_T stxlo(DIM1(s)),stxhi(DIM1(s)),slxscr(DIM1(s),4)
      REAL_T stylo(DIM2(s)),styhi(DIM2(s)),slyscr(DIM2(s),4)

      REAL_T uedge(DIMV(uedge)), xstate(DIMV(xstate))
      REAL_T vedge(DIMV(vedge)), ystate(DIMV(ystate))

      REAL_T xlo(DIMV(work)), xhi(DIMV(work))
      REAL_T ylo(DIMV(work)), yhi(DIMV(work))
      REAL_T  sx(DIMV(work))
      REAL_T  sy(DIMV(work))
      REAL_T tforces(DIMV(work))
      REAL_T divu(DIMV(work))

#if 0
      REAL_T extra_work(DIMV(work),6)
#endif
      
      REAL_T spx,smx,spy,smy,st,denom

      integer use_minion, iconserv
      integer inc

      REAL_T umax

      dth  = half*dt
      dthx = half*dt / dx(1)
      dthy = half*dt / dx(2)
      hx   = dx(1)
      hy   = dx(2)
      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)
c
c     compute the slopes
c
      call FORT_SLOPES(
     &     s,DIMS(s),
     &     sx,sy,DIMS(work),
     &     lo,hi,slxscr,slyscr,bc)
c
c     trace the state to the cell edges
c
      do j = jmin-1,jmax+1
         do i = imin,  imax+1
            xlo(i,j) = s(i-1,j) + (half  - dthx*uedge(i,j))*sx(i-1,j)
            xhi(i,j) = s(i,  j) + (-half - dthx*uedge(i,j))*sx(i,  j)
         end do
      end do

      if(use_minion.eq.1)then
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               xlo(i,j) = xlo(i,j) + dth*tforces(i-1,j)
               xhi(i,j) = xhi(i,j) + dth*tforces(i,  j)
            end do
         end do
         if (iconserv .eq. 1) then
           do j = jmin-1,jmax+1
            do i = imin,  imax+1
               xlo(i,j) = xlo(i,j) - dth*s(i-1,j)*divu(i-1,j)
               xhi(i,j) = xhi(i,j) - dth*s(i  ,j)*divu(i,  j)
            end do
           end do
         end if
      end if

      call trans_xbc(
     &     s,DIMS(s),
     &     xlo,xhi,DIMS(work),uedge,DIMS(uedge),
     &     lo,hi,n,bc,eps_for_bc)

      do j = jmin-1,jmax+1
         do i = imin,  imax+1
            fu  = cvmgt(zero,one,abs(uedge(i,j)).lt.eps)
            stx = cvmgp(xlo(i,j),xhi(i,j),uedge(i,j))
            xlo(i,j) = fu*stx + (one - fu)*half*(xhi(i,j)+xlo(i,j))
         end do
      end do

      do j = jmin,  jmax+1
         do i = imin-1,imax+1
            ylo(i,j) = s(i,j-1) + (half  - dthy*vedge(i,j))*sy(i,j-1)
            yhi(i,j) = s(i,j)   + (-half - dthy*vedge(i,j))*sy(i,j)
         end do
      end do

      if (use_minion.eq.1)then
         do j = jmin, jmax+1
            do i = imin-1,  imax+1
               ylo(i,j) = ylo(i,j) + dth*tforces(i,j-1)
               yhi(i,j) = yhi(i,j) + dth*tforces(i,j  )
            end do
         end do
         if (iconserv .eq. 1) then
           do j = jmin-1,jmax+1
            do i = imin,  imax+1
               ylo(i,j) = ylo(i,j) - dth*s(i,j-1)*divu(i,j-1)
               yhi(i,j) = yhi(i,j) - dth*s(i,j  )*divu(i,j  )
            end do
           end do
         end if
      end if

      call trans_ybc(
     &     s,DIMS(s),
     &     ylo,yhi,DIMS(work),vedge,DIMS(vedge),
     &     lo,hi,n,bc,eps_for_bc)

      do j = jmin,  jmax+1
         do i = imin-1,imax+1
            fv  = cvmgt(zero,one,abs(vedge(i,j)).lt.eps)
            sty = cvmgp(ylo(i,j),yhi(i,j),vedge(i,j))
            ylo(i,j) = fv*sty + (one - fv)*half*(yhi(i,j)+ylo(i,j))
         end do
      end do

#if 0
      call bdsslope(s,lo(1),lo(2),hi(1),hi(2),
     $              extra_work(lo(1)-1,lo(2)-1,1),
     $              extra_work(lo(1)-1,lo(2)-1,2),
     $              extra_work(lo(1)-1,lo(2)-1,3),
     $              dx)
#endif
c
c     compute the xedge states
c
      do j = jmin,jmax

            do i = imin-1,imax+1
               spx = s(i,j) + half * sx(i,j)
               smx = s(i,j) - half * sx(i,j)

               if (iconserv.eq.1) then

                  st = -(vedge(i,j+1)*ylo(i,j+1) - vedge(i,j)*ylo(i,j))/hy
     &                 + s(i,j)*(vedge(i,j+1)-vedge(i,j))/hy
     &                 - s(i,j)*divu(i,j)

               else

#if 1
                  if (vedge(i,j)*vedge(i,j+1).le.0.d0) then
                     vbar = 0.5d0*(vedge(i,j)+vedge(i,j+1))
                     if (vbar.lt.0.d0) then
                        inc = 1
                     else
                        inc = 0
                     endif
                     tr = vbar*(s(i,j+inc)-s(i,j+inc-1))/hy
                  else
                     tr = half*(vedge(i,j+1) + vedge(i,j)) *
     &                    (  ylo(i,j+1) - ylo(i,j)  ) / hy
                  endif

#else
                  tr = half*(vedge(i,j+1) + vedge(i,j)) * extra_work(i,j,2)
#endif
                  st =  -tr

               endif

               stxlo(i+1)= spx - dthx*uedge(i+1,j)*sx(i,j) + dth*(st + tforces(i,j))
               stxhi(i  )= smx - dthx*uedge(i  ,j)*sx(i,j) + dth*(st + tforces(i,j))

            end do

            if (bc(1,1).eq.EXT_DIR .and. uedge(imin,j).ge.zero) then
               stxhi(imin) = s(imin-1,j)
               stxlo(imin) = s(imin-1,j)
            else if (bc(1,1).eq.EXT_DIR .and. uedge(imin,j).lt.zero) then
               stxlo(imin) = stxhi(imin)
            else if (bc(1,1).eq.FOEXTRAP.or.bc(1,1).eq.HOEXTRAP
     &              .or.bc(1,1).eq.REFLECT_EVEN) then
               stxlo(imin) = stxhi(imin)
            else if (bc(1,1).eq.REFLECT_ODD) then
               stxhi(imin) = zero
               stxlo(imin) = zero
            end if
            if (bc(1,2).eq.EXT_DIR .and. uedge(imax+1,j).le.zero) then
               stxlo(imax+1) = s(imax+1,j)
               stxhi(imax+1) = s(imax+1,j)
            else if (bc(1,2).eq.EXT_DIR .and. uedge(imax+1,j).gt.zero) then
               stxhi(imax+1) = stxlo(imax+1)
            else if (bc(1,2).eq.FOEXTRAP.or.bc(1,2).eq.HOEXTRAP
     &              .or.bc(1,2).eq.REFLECT_EVEN) then
               stxhi(imax+1) = stxlo(imax+1)
            else if (bc(1,2).eq.REFLECT_ODD) then
               stxlo(imax+1) = zero
               stxhi(imax+1) = zero
            end if
            
            do i = imin, imax+1
               xstate(i,j) = cvmgp(stxlo(i),stxhi(i),uedge(i,j))
               xstate(i,j) = cvmgt(half*(stxlo(i)+stxhi(i)),xstate(i,j)
     &              ,abs(uedge(i,j)).lt.eps)
            end do
            place_to_break = 1
      end do
c
c     compute the yedge states
c
      do i = imin,imax
            
            do j = jmin-1,jmax+1
               spy = s(i,j) + half * sy(i,j)
               smy = s(i,j) - half * sy(i,j)

               if (iconserv.eq.1) then

                  st = -(uedge(i+1,j)*xlo(i+1,j) - uedge(i,j)*xlo(i,j))/hx
     &                 + s(i,j)*(uedge(i+1,j)-uedge(i,j))/hx
     &                 - s(i,j)*divu(i,j)

               else

#if 1
                  if (uedge(i,j)*uedge(i+1,j).le.0.d0) then
                     ubar = 0.5d0*(uedge(i,j)+uedge(i+1,j))
                     if (ubar.lt.0.d0) then
                        inc = 1
                     else
                        inc = 0
                     endif
                     tr = ubar*(s(i+inc,j)-s(i+inc-1,j))/hx
                  else
                     tr = half*(uedge(i+1,j) + uedge(i,j)) *
     &                           (xlo(i+1,j) -   xlo(i,j)  ) / hx
                  endif
#else
                  tr = half*(uedge(i+1,j) + uedge(i,j)) * extra_work(i,j,1)
#endif
                  st = -tr

               endif

               stylo(j+1)= spy - dthy*vedge(i,j+1)*sy(i,j) + dth*(st + tforces(i,j))
               styhi(j  )= smy - dthy*vedge(i,j  )*sy(i,j) + dth*(st + tforces(i,j))

            end do
            
            if (bc(2,1).eq.EXT_DIR .and. vedge(i,jmin).ge.zero) then
               styhi(jmin) = s(i,jmin-1)
               stylo(jmin) = s(i,jmin-1)
            else if (bc(2,1).eq.EXT_DIR .and. vedge(i,jmin).lt.zero) then
               stylo(jmin) = styhi(jmin)
            else if (bc(2,1).eq.FOEXTRAP.or.bc(2,1).eq.HOEXTRAP
     &              .or.bc(2,1).eq.REFLECT_EVEN) then
               stylo(jmin) = styhi(jmin)
            else if (bc(2,1).eq.REFLECT_ODD) then
               styhi(jmin) = zero
               stylo(jmin) = zero
            end if
            
            if (bc(2,2).eq.EXT_DIR .and. vedge(i,jmax+1).le.zero) then
               stylo(jmax+1) = s(i,jmax+1)
               styhi(jmax+1) = s(i,jmax+1)
            else if (bc(2,2).eq.EXT_DIR .and. vedge(i,jmax+1).gt.zero) then
               styhi(jmax+1) = stylo(jmax+1)
            else if (bc(2,2).eq.FOEXTRAP.or.bc(2,2).eq.HOEXTRAP
     &              .or.bc(2,2).eq.REFLECT_EVEN) then
               styhi(jmax+1) = stylo(jmax+1)
            else if (bc(2,2).eq.REFLECT_ODD) then
               stylo(jmax+1) = zero
               styhi(jmax+1) = zero
            end if
            
            do j=jmin,jmax+1
               ystate(i,j) = cvmgp(stylo(j),styhi(j),vedge(i,j))
               ystate(i,j) = cvmgt(half*(stylo(j)+styhi(j)),ystate(i,j),
     &              abs(vedge(i,j)).lt.eps)
            end do
            place_to_break = 1
      end do
      end


      subroutine FORT_ADV_FORCING(
     &     aofs,DIMS(aofs),
     &     xflux,DIMS(xflux),
     &     uedge,DIMS(uedge),
     &     areax,DIMS(ax),
     &     yflux,DIMS(yflux),
     &     vedge,DIMS(vedge),
     &     areay,DIMS(ay),
     &     vol,DIMS(vol),
     &     lo,hi,iconserv )
c
c     This subroutine uses scalar edge states to compute
c     an advective tendency
c
      implicit none
      integer i,j
      integer iconserv
      REAL_T divux,divuy
      integer imin,jmin,imax,jmax
      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(aofs)
      integer DIMDEC(vol)
      integer DIMDEC(uedge)
      integer DIMDEC(vedge)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(ax)
      integer DIMDEC(ay)
      REAL_T aofs(DIMV(aofs))
      REAL_T vol(DIMV(vol))
      REAL_T uedge(DIMV(uedge))
      REAL_T vedge(DIMV(vedge))
      REAL_T xflux(DIMV(xflux))
      REAL_T yflux(DIMV(yflux))
      REAL_T areax(DIMV(ax))
      REAL_T areay(DIMV(ay))

      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)
c
c     if nonconservative initialize the advective tendency as -U*grad(S)
c
      if ( iconserv .ne. 1 ) then
         do j = jmin,jmax
            do i = imin,imax
               divux = (
     &              areax(i+1,j)*uedge(i+1,j) -
     &              areax(i,  j)*uedge(i,  j) )/vol(i,j)
               divuy = (
     &              areay(i,j+1)*vedge(i,j+1) -
     &              areay(i,j  )*vedge(i,j  ) )/vol(i,j)
               aofs(i,j) =
     &              - divux*half*(xflux(i+1,j) + xflux(i,j))
     &              - divuy*half*(yflux(i,j+1) + yflux(i,j))
            end do
         end do
      end if
c
c     convert edge states to fluxes
c
      do j = jmin,jmax
         do i = imin,imax+1
            xflux(i,j) = xflux(i,j)*uedge(i,j)*areax(i,j)
         end do
      end do
      do j = jmin,jmax+1
         do i = imin,imax
            yflux(i,j) = yflux(i,j)*vedge(i,j)*areay(i,j)
         end do
      end do
c     
c     compute part of advective tendency that depends on the flux convergence
c     
      if ( iconserv .ne. 1 ) then
         do j = jmin,jmax
            do i = imin,imax
               aofs(i,j) = aofs(i,j) + (
     &              xflux(i+1,j) - xflux(i,j) +
     &              yflux(i,j+1) - yflux(i,j))/vol(i,j)
            end do
         end do
      else
         do j = jmin,jmax
            do i = imin,imax
               aofs(i,j) = (
     &              xflux(i+1,j) - xflux(i,j) +
     &              yflux(i,j+1) - yflux(i,j))/vol(i,j)
            end do
         end do
      end if

      end

      subroutine FORT_SYNC_ADV_FORCING(
     &     sync,DIMS(sync),
     &     xflux,DIMS(xflux),
     &     ucor,DIMS(ucor),
     &     areax,DIMS(ax),
     &     yflux,DIMS(yflux),
     &     vcor,DIMS(vcor),
     &     areay,DIMS(ay),
     &     vol,DIMS(vol),
     &     lo,hi,iconserv )
c
c     This subroutine computes the sync advective tendency
c     for a state variable
c
      implicit none
      integer i,j
      integer iconserv
      integer imin,jmin,imax,jmax
      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(sync)
      integer DIMDEC(vol)
      integer DIMDEC(ucor)
      integer DIMDEC(vcor)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(ax)
      integer DIMDEC(ay)
      REAL_T sync(DIMV(sync))
      REAL_T vol(DIMV(vol))
      REAL_T ucor(DIMV(ucor))
      REAL_T vcor(DIMV(vcor))
      REAL_T xflux(DIMV(xflux))
      REAL_T yflux(DIMV(yflux))
      REAL_T areax(DIMV(ax))
      REAL_T areay(DIMV(ay))

      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)
c
c     compute corrective fluxes from edge states 
c     and perform conservative update
c
      do j = jmin,jmax
         do i = imin,imax+1
            xflux(i,j) = xflux(i,j)*ucor(i,j)*areax(i,j)
         end do
      end do
      do j = jmin,jmax+1
         do i = imin,imax
            yflux(i,j) = yflux(i,j)*vcor(i,j)*areay(i,j)
         end do
      end do

      do j = jmin,jmax
         do i = imin,imax
            sync(i,j) = sync(i,j) + (
     &           xflux(i+1,j) - xflux(i,j) +
     &           yflux(i,j+1) - yflux(i,j) )/vol(i,j)
         end do
      end do

      end

      subroutine trans_xbc(
     &     s,DIMS(s),
     &     xlo,xhi,DIMS(xx),uad,DIMS(uad),
     &     lo,hi,n,xbc,eps)
c
c     This subroutine processes boundary conditions on information
c     traced to cell faces in the x direction.  This is used for
c     computing velocities and edge states used in calculating
c     transverse derivatives
c
      integer DIMDEC(s), DIMDEC(xx), DIMDEC(uad)
      integer n
      integer lo(SDIM), hi(SDIM)
      REAL_T stx
      REAL_T s(DIMV(s))
      REAL_T xlo(DIMV(xx))
      REAL_T xhi(DIMV(xx))
      REAL_T uad(DIMV(uad))
      REAL_T eps
      integer xbc(SDIM,2)
      logical ltest
      integer j
      integer imin,jmin,imax,jmax

      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)

      if (xbc(1,1).eq.EXT_DIR) then
         if (n .eq. XVEL) then
            do j = jmin-1,jmax+1
              if (uad(imin,j) .ge. zero) then
                 xhi(imin,j) = s(imin-1,j)
                 xlo(imin,j) = s(imin-1,j)
              else 
                 xlo(imin,j) = xhi(imin,j)
              end if
            end do
         else
            do j = jmin-1,jmax+1
               ltest = uad(imin,j).le.eps
               stx   = cvmgt(xhi(imin,j),s(imin-1,j),ltest)
               xhi(imin,j) = stx
               xlo(imin,j) = stx
            end do
         end if
      else if (xbc(1,1).eq.FOEXTRAP.or.xbc(1,1).eq.HOEXTRAP
     &        .or.xbc(1,1).eq.REFLECT_EVEN) then
         do j = jmin-1,jmax+1
            xlo(imin,j) = xhi(imin,j)
         end do
      else if (xbc(1,1).eq.REFLECT_ODD) then
         do j = jmin-1,jmax+1
            xhi(imin,j) = zero
            xlo(imin,j) = zero
         end do
      end if
c
      if (xbc(1,2).eq.EXT_DIR) then
         if (n .eq. XVEL) then
            do j = jmin-1,jmax+1
              if (uad(imax+1,j) .le. zero) then
                 xhi(imax+1,j) = s(imax+1,j)
                 xlo(imax+1,j) = s(imax+1,j)
               else 
                 xhi(imax+1,j) = xlo(imax+1,j)
               end if
             end do
         else
            do j = jmin-1,jmax+1
               ltest = uad(imax+1,j).ge.-eps
               stx   = cvmgt(xlo(imax+1,j),s(imax+1,j),ltest)
               xhi(imax+1,j) = stx
               xlo(imax+1,j) = stx
            end do
         end if
      else if (xbc(1,2).eq.FOEXTRAP.or.xbc(1,2).eq.HOEXTRAP
     &        .or.xbc(1,2).eq.REFLECT_EVEN) then
         do j = jmin-1,jmax+1
            xhi(imax+1,j) = xlo(imax+1,j)
         end do
      else if (xbc(1,2).eq.REFLECT_ODD) then
         do j = jmin-1,jmax+1
            xhi(imax+1,j) = zero
            xlo(imax+1,j) = zero
         end do
      end if

      end

      subroutine trans_ybc(
     &     s,DIMS(s),
     &     ylo,yhi,DIMS(yy),vad,DIMS(vad),
     &     lo,hi,n,ybc,eps)
c
c     This subroutine processes boundary conditions on information
c     traced to cell faces in the y direction.  This is used for
c     computing velocities and edge states used in calculating
c     transverse derivatives
c
      integer DIMDEC(s), DIMDEC(yy), DIMDEC(vad)
      integer n
      integer lo(SDIM), hi(SDIM)
      REAL_T sty
      REAL_T s(DIMV(s))
      REAL_T ylo(DIMV(yy))
      REAL_T yhi(DIMV(yy))
      REAL_T vad(DIMV(vad))
      REAL_T eps
      integer ybc(SDIM,2)
      logical ltest
      integer i
      integer imin,jmin,imax,jmax

      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)

      if (ybc(2,1).eq.EXT_DIR) then
         if (n .eq. YVEL) then
            do i = imin-1,imax+1
              if (vad(i,jmin).ge.zero) then
                 yhi(i,jmin) = s(i,jmin-1)
                 ylo(i,jmin) = s(i,jmin-1)
              else
                 ylo(i,jmin) = yhi(i,jmin)
              end if
            end do
         else
            do i = imin-1,imax+1
               ltest = vad(i,jmin).le.eps
               sty   = cvmgt(yhi(i,jmin),s(i,jmin-1),ltest)
               yhi(i,jmin) = sty
               ylo(i,jmin) = sty
            end do
         end if
      else if (ybc(2,1).eq.FOEXTRAP.or.ybc(2,1).eq.HOEXTRAP
     &        .or.ybc(2,1).eq.REFLECT_EVEN) then
         do i = imin-1,imax+1
            ylo(i,jmin) = yhi(i,jmin)
         end do
      else if (ybc(2,1).eq.REFLECT_ODD) then
         do i = imin-1,imax+1
            yhi(i,jmin) = zero
            ylo(i,jmin) = zero
         end do
      end if

      if (ybc(2,2).eq.EXT_DIR) then
         if (n .eq. YVEL) then
            do i = imin-1,imax+1
              if (vad(i,jmax+1).le.zero) then
                 ylo(i,jmax+1) = s(i,jmax+1)
                 yhi(i,jmax+1) = s(i,jmax+1)
              else
                 yhi(i,jmax+1) = ylo(i,jmax+1)
              end if
            end do
         else
            do i = imin-1,imax+1
               ltest = vad(i,jmax+1).ge.-eps
               sty   = cvmgt(ylo(i,jmax+1),s(i,jmax+1),ltest)
               yhi(i,jmax+1) = sty
               ylo(i,jmax+1) = sty
            end do
         end if
      else if (ybc(2,2).eq.FOEXTRAP.or.ybc(2,2).eq.HOEXTRAP
     &        .or.ybc(2,2).eq.REFLECT_EVEN) then
         do i = imin-1,imax+1
            yhi(i,jmax+1) = ylo(i,jmax+1)
         end do
      else if (ybc(2,2).eq.REFLECT_ODD) then
         do i = imin-1,imax+1
            ylo(i,jmax+1) = zero
            yhi(i,jmax+1) = zero
         end do
      end if

      end

      subroutine FORT_SLOPES (s,DIMS(s),slx,sly,DIMS(sl),
     &     lo,hi,slxscr,slyscr,bc)
c 
c     this subroutine computes first, second or forth order slopes of
c     a 2D scalar field.
c
c     Boundary conditions on interior slopes are handled automatically
c     by the ghost cells
c
c     Boundary conditions on EXT_DIR and HOEXTRAP slopes are implemented
c     by setting them to zero outside of the domain and using a
c     one-sided derivative from the interior
c
      implicit none

#include "GODCOMM_F.H"

      integer lo(SDIM), hi(SDIM)
      integer bc(SDIM,2)
      integer DIMDEC(s)
      integer DIMDEC(sl)
      REAL_T     s(DIMV(s))
      REAL_T   slx(DIMV(sl))
      REAL_T   sly(DIMV(sl))
      REAL_T slxscr(DIM1(s), 4)
      REAL_T slyscr(DIM2(s), 4)

      integer cen,lim,flag,fromm
      parameter( cen = 1 )
      parameter( lim = 2 )
      parameter( flag = 3 )
      parameter( fromm = 4 )

      integer imin,jmin,imax,jmax,i,j
      integer ng
      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflg

      ng = lo(1) - ARG_L1(s)

      imin = lo(1)
      jmin = lo(2)
      imax = hi(1)
      jmax = hi(2)
c
c ::: ::::: added to prevent underflow for small s values
c
      do j = lo(2)-ng, hi(2)+ng
        do i = lo(1)-ng, hi(1)+ng
	  s(i,j) = cvmgt(s(i,j), zero, abs(s(i,j)).gt.1.0D-20)
        end do
      end do
c
c     COMPUTE 0TH order slopes
c
      if (slope_order.eq.1) then
        if (ng .lt. 1) then
	   call bl_abort("FORT_SLOPES: not enough bndry cells for 1st order")
        end if
        do j = jmin-1,jmax+1
           do i = imin-1,imax+1
              slx(i,j) = zero
              sly(i,j) = zero
  	   end do
        end do
      end if
c
c     COMPUTE 2nd order slopes
c
      if (slope_order.eq.2) then
         if (ng .lt. 2) then
            call bl_abort("SLOPE_2D: not enough bndry cells for 2nd order")
         end if
c
c     ------------------------ x slopes
c
         if (use_unlimited_slopes) then
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  slx(i,j) = half*(s(i+1,j)-s(i-1,j))
               end do
            end do
            if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
                  slx(imin-1,j) = zero
                  slx(imin,j)   = (s(imin+1,j)+three*s(imin,j)-four*s(imin-1,j))/three
               end do
            end if
            if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
                  slx(imax+1,j) = zero
                  slx(imax,j)   = -(s(imax-1,j)+three*s(imax,j)-four*s(imax+1,j))/three
               end do
            end if
         else
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  del  = half*(s(i+1,j)-s(i-1,j))
                  dpls = two*(s(i+1,j) - s(i ,j))
                  dmin = two*(s(i ,j) - s(i-1,j))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(i,j)= sflg*min(slim,abs(del))
               end do
            end do
            
            if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
                  slx(imin-1,j) = zero
                  del  = (s(imin+1,j)+three*s(imin,j)-four*s(imin-1,j))/three
                  dpls = two*(s(imin+1,j) - s(imin  ,j))
                  dmin = two*(s(imin  ,j) - s(imin-1,j))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(imin,j)= sflg*min(slim,abs(del))
               end do
            end if
            if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
                  slx(imax+1,j) = zero
                  del  = -(s(imax-1,j)+three*s(imax,j)-four*s(imax+1,j))/three
                  dpls = two*(s(imax+1,j) - s(imax  ,j))
                  dmin = two*(s(imax  ,j) - s(imax-1,j))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(imax,j)= sflg*min(slim,abs(del))
               end do
            end if
         end if
c
c     ------------------------ y slopes
c
         if (use_unlimited_slopes) then
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  sly(i,j) = half*(s(i,j+1)-s(i,j-1))
               end do
            end do
            if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
               do i = imin-1, imax+1
                  sly(i,jmin-1) = zero
                  sly(i,jmin) = (s(i,jmin+1)+three*s(i,jmin)-four*s(i,jmin-1))/three
               end do
            end if
            if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
               do i = imin-1, imax+1
                  sly(i,jmax+1) = zero
                  sly(i,jmax) = -(s(i,jmax-1)+three*s(i,jmax)-four*s(i,jmax+1))/three
               end do
            end if
         else
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  del  = half*(s(i,j+1)-s(i,j-1))
                  dpls = two*(s(i,j+1) - s(i,j ))
                  dmin = two*(s(i,j ) - s(i,j-1))
                  slim = min(abs(dpls),abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,j)= sflg*min(slim,abs(del))
               end do
            end do

            if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
               do i = imin-1, imax+1
                  sly(i,jmin-1) = zero
                  del  = (s(i,jmin+1)+three*s(i,jmin)-four*s(i,jmin-1))/three
                  dpls = two*(s(i,jmin+1) - s(i,jmin  ))
                  dmin = two*(s(i,jmin  ) - s(i,jmin-1))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,jmin)= sflg*min(slim,abs(del))
               end do
            end if
            if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
               do i = imin-1, imax+1
                  sly(i,jmax+1) = zero
                  del  = -(s(i,jmax-1)+three*s(i,jmax)-four*s(i,jmax+1))/three
                  dpls = two*(s(i,jmax+1) - s(i,jmax  ))
                  dmin = two*(s(i,jmax  ) - s(i,jmax-1))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,jmax)= sflg*min(slim,abs(del))
               end do
            end if
         end if
c
c ... end, if slope_order .eq. 2
c
      end if
c
c     COMPUTE 4TH order slopes
c
      if (slope_order.eq.4) then
         if (ng .lt. 3) then
            call bl_abort("SLOPE_2D: not enough bndry cells for 4th order")
         end if
c         
c     ------------------------ x slopes
c
         if (use_unlimited_slopes) then
            do j = jmin-1,jmax+1
               do i = imin-2,imax+2
                  slxscr(i,cen)  = half*(s(i+1,j)-s(i-1,j))
               end do
               do i = imin-1,imax+1
                  slx(i,j) = two * two3rd * slxscr(i,cen) -
     &                 sixth * (slxscr(i+1,cen) + slxscr(i-1,cen))
               end do
            end do
            
            if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
                  slx(imin,j) = -sixteen/fifteen*s(imin-1,j) + half*s(imin,j) + 
     &                 two3rd*s(imin+1,j) - tenth*s(imin+2,j)
                  slx(imin-1,j) = zero
               end do
            end if
            if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
                  slx(imax,j) = -( -sixteen/fifteen*s(imax+1,j) + half*s(imax,j) + 
     &                 two3rd*s(imax-1,j) - tenth*s(imax-2,j) )
                  slx(imax+1,j) = zero
               end do
            end if
         else
            do j = jmin-1,jmax+1
               do i = imin-2,imax+2
                  dmin           =  two*(s(i,  j)-s(i-1,j))
                  dpls           =  two*(s(i+1,j)-s(i  ,j))
                  slxscr(i,cen)  = half*(s(i+1,j)-s(i-1,j))
                  slxscr(i,lim)  = min(abs(dmin),abs(dpls))
                  slxscr(i,lim)  = cvmgp(slxscr(i,lim),zero,dpls*dmin)
                  slxscr(i,flag) = sign(one,slxscr(i,cen))
                  slxscr(i,fromm)= slxscr(i,flag)*
     &                 min(slxscr(i,lim),abs(slxscr(i,cen)))
               end do

               do i = imin-1,imax+1
                  ds = two * two3rd * slxscr(i,cen) -
     &                 sixth * (slxscr(i+1,fromm) + slxscr(i-1,fromm))
                  slx(i,j) = slxscr(i,flag)*min(abs(ds),slxscr(i,lim))
               end do

               if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
                  del  = -sixteen/fifteen*s(imin-1,j) + half*s(imin,j) + 
     &                 two3rd*s(imin+1,j) - tenth*s(imin+2,j)
                  dmin = two*(s(imin  ,j)-s(imin-1,j))
                  dpls = two*(s(imin+1,j)-s(imin  ,j))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(imin-1,j) = zero
                  slx(imin,  j) = sflg*min(slim,abs(del))

c                 Recalculate the slope at imin+1 using the revised slxscr(imin,fromm)
                  slxscr(imin,fromm) = slx(imin,j)
                  ds = two * two3rd * slxscr(imin+1,cen) -
     $               sixth * (slxscr(imin+2,fromm) + slxscr(imin,fromm))
                  slx(imin+1,j) = slxscr(imin+1,flag)*min(abs(ds),slxscr(imin+1,lim))
               end if

               if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
                  del  = -( -sixteen/fifteen*s(imax+1,j) + half*s(imax,j) + 
     &                 two3rd*s(imax-1,j) - tenth*s(imax-2,j) )
                  dmin = two*(s(imax  ,j)-s(imax-1,j))
                  dpls = two*(s(imax+1,j)-s(imax  ,j))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(imax,  j) = sflg*min(slim,abs(del))
                  slx(imax+1,j) = zero

c                 Recalculate the slope at imax-1 using the revised slxscr(imax,fromm)
                  slxscr(imax,fromm) = slx(imax,j)
                  ds = two * two3rd * slxscr(imax-1,cen) -
     $               sixth * (slxscr(imax-2,fromm) + slxscr(imax,fromm))
                  slx(imax-1,j) = slxscr(imax-1,flag)*min(abs(ds),slxscr(imax-1,lim))
               end if
            end do
         end if
c
c     ------------------------ y slopes
c
         if (use_unlimited_slopes) then
            do i = imin-1,imax+1
               do j = jmin-2,jmax+2
                  slyscr(j,cen)  = half*(s(i,j+1)-s(i,j-1))
               end do
               do j = jmin-1,jmax+1
                  sly(i,j) = two * two3rd * slyscr(j,cen) -
     &                 sixth * (slyscr(j+1,cen) + slyscr(j-1,cen))
               end do
            end do
            
            if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
               do i = imin-1, imax+1
                  sly(i,jmin-1) = zero
                  sly(i,jmin) = -sixteen/fifteen*s(i,jmin-1) + half*s(i,jmin) + 
     &                 two3rd*s(i,jmin+1) - tenth*s(i,jmin+2)
               end do
            end if
            if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
               do i = imin-1, imax+1
                  sly(i,jmax) = -( -sixteen/fifteen*s(i,jmax+1) + half*s(i,jmax) + 
     &                 two3rd*s(i,jmax-1) - tenth*s(i,jmax-2) )
                  sly(i,jmax+1) = zero
               end do
            end if
         else
            do i = imin-1,imax+1
              do j = jmin-2,jmax+2
                  dmin           =  two*(s(i,j  )-s(i,j-1))
                  dpls           =  two*(s(i,j+1)-s(i,j  ))
                  slyscr(j,cen)  = half*(s(i,j+1)-s(i,j-1))
                  slyscr(j,lim)  = min(abs(dmin),abs(dpls))
                  slyscr(j,lim)  = cvmgp(slyscr(j,lim),zero,dpls*dmin)
                  slyscr(j,flag) = sign(one,slyscr(j,cen))
                  slyscr(j,fromm)= slyscr(j,flag)*
     &                 min(slyscr(j,lim),abs(slyscr(j,cen)))
               end do
               do j = jmin-1,jmax+1
                  ds = two * two3rd * slyscr(j,cen) -
     &                 sixth * (slyscr(j+1,fromm) + slyscr(j-1,fromm))
                  sly(i,j) = slyscr(j,flag)*min(abs(ds),slyscr(j,lim))
               end do

               if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
                  del  = -sixteen/fifteen*s(i,jmin-1) + half*s(i,jmin) + 
     &                 two3rd*s(i,jmin+1) - tenth*s(i,jmin+2)
                  dmin = two*(s(i,jmin  )-s(i,jmin-1))
                  dpls = two*(s(i,jmin+1)-s(i,jmin  ))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,jmin-1) = zero
                  sly(i,jmin  ) = sflg*min(slim,abs(del))

c                 Recalculate the slope at jmin+1 using the revised slyscr(jmin,fromm)
                  slyscr(jmin,fromm) = sly(i,jmin)
                  ds = two * two3rd * slyscr(jmin+1,cen) -
     $               sixth * (slyscr(jmin+2,fromm) + slyscr(jmin,fromm))
                  sly(i,jmin+1) = slyscr(jmin+1,flag)*min(abs(ds),slyscr(jmin+1,lim))
               end if

               if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
                  del  = -( -sixteen/fifteen*s(i,jmax+1) + half*s(i,jmax) + 
     &                 two3rd*s(i,jmax-1) - tenth*s(i,jmax-2) )
                  dmin = two*(s(i,jmax  )-s(i,jmax-1))
                  dpls = two*(s(i,jmax+1)-s(i,jmax  ))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,jmax  ) = sflg*min(slim,abs(del))
                  sly(i,jmax+1) = zero

c                 Recalculate the slope at jmax-1 using the revised slyscr(jmax,fromm)
                  slyscr(jmax,fromm) = sly(i,jmax)
                  ds = two * two3rd * slyscr(jmax-1,cen) -
     $               sixth * (slyscr(jmax-2,fromm) + slyscr(jmax,fromm))
                  sly(i,jmax-1) = slyscr(jmax-1,flag)*min(abs(ds),slyscr(jmax-1,lim))
               end if
           end do
         end if
c
c ... end, if slope_order .eq. 4
c
      end if

      end

      subroutine FORT_SCALMINMAX(s,DIMS(s),sn,DIMS(sn),
     &     lo,hi,bc)
c
c     correct an advected field for under/over shoots
c
      integer DIMDEC(s)
      integer DIMDEC(sn)
      integer lo(SDIM), hi(SDIM)
      integer bc(SDIM,2)
      REAL_T s(DIMV(s))
      REAL_T sn(DIMV(sn))
      integer  i, j, imin, imax, jmin, jmax
      REAL_T   smin, smax

      imin = lo(1)
      imax = hi(1)
      jmin = lo(2)
      jmax = hi(2)
c
c     set corner values for s
c
c     :: corner ilo, jlo
c
      if (bc(1,1).ne.INT_DIR .or. bc(2,1).ne.INT_DIR) then
         s(imin-1,jmin-1) = s(imin,jmin)
      end if
c
c     :: corner ihi, jlo
c
      if (bc(1,2).ne.INT_DIR .or. bc(2,1).ne.INT_DIR) then
         s(imax+1,jmin-1) = s(imax,jmin)
      end if
c
c     :: corner ilo, jhi
c
      if (bc(1,1).ne.INT_DIR .or. bc(2,2).ne.INT_DIR) then
         s(imin-1,jmax+1) = s(imin,jmax)
      end if
c
c     :: corner ihi, jhi
c
      if (bc(1,2).ne.INT_DIR .or. bc(2,2).ne.INT_DIR) then
         s(imax+1,jmax+1) = s(imax,jmax)
      end if
c
c     compute extrema of s
c
      do j = jmin, jmax         
         do i = imin, imax
            smin = min(
     &           s(i-1,j-1),s(i  ,j-1),s(i+1,j-1),
     &           s(i-1,j  ),s(i  ,j  ),s(i+1,j  ),
     &           s(i-1,j+1),s(i  ,j+1),s(i+1,j+1))
            smax = max(
     &           s(i-1,j-1),s(i  ,j-1),s(i+1,j-1),
     &           s(i-1,j  ),s(i  ,j  ),s(i+1,j  ),
     &           s(i-1,j+1),s(i  ,j+1),s(i+1,j+1))
            sn(i,j) = max(sn(i,j),smin)
            sn(i,j) = min(sn(i,j),smax)
         end do
      end do

      end

      subroutine FORT_SUM_TF_GP(
     &     tforces,DIMS(tf),
     &     gp,DIMS(gp),
     &     rho,DIMS(rho),
     &     lo,hi )
c
c     sum pressure forcing into tforces
c
      integer i, j, n
      integer DIMDEC(tf)
      integer DIMDEC(gp)
      integer DIMDEC(rho)
      integer lo(SDIM), hi(SDIM)
      REAL_T tforces(DIMV(tf),SDIM)
      REAL_T gp(DIMV(gp),SDIM)
      REAL_T rho(DIMV(rho))

      do n = 1, SDIM
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               tforces(i,j,n) = (
     &              tforces(i,j,n)
     &              -    gp(i,j,n))/rho(i,j)
            end do
         end do
      end do

      end

      subroutine FORT_SUM_TF_GP_VISC(
     &     tforces,DIMS(tf),
     &     visc,DIMS(visc),
     &     gp,DIMS(gp),
     &     rho,DIMS(rho),
     &     lo,hi )
c
c     sum pressure forcing and viscous forcing into
c     tforces
c
      integer i, j, n
      integer DIMDEC(tf)
      integer DIMDEC(visc)
      integer DIMDEC(gp)
      integer DIMDEC(rho)
      integer lo(SDIM), hi(SDIM)
      REAL_T tforces(DIMV(tf),SDIM)
      REAL_T visc(DIMV(visc),SDIM)
      REAL_T gp(DIMV(gp),SDIM)
      REAL_T rho(DIMV(rho))

      do n = 1, SDIM
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               tforces(i,j,n) = (
     &              tforces(i,j,n)
     &              +  visc(i,j,n)
     &              -    gp(i,j,n))/rho(i,j)
            end do
         end do
      end do

      end

      subroutine FORT_SUM_TF_DIVU(
     &     S,DIMS(S),
     &     tforces,DIMS(tf),
     &     divu,DIMS(divu),
     &     rho,DIMS(rho),
     &     lo,hi,nvar,iconserv )
c
c     sum divU*S into tforces or divide tforces by rho
c     depending on the value of iconserv
c
      integer nvar, iconserv
      integer lo(SDIM), hi(SDIM)
      integer i, j, n

      integer DIMDEC(S)
      integer DIMDEC(tf)
      integer DIMDEC(divu)
      integer DIMDEC(rho)

      REAL_T S(DIMV(S),nvar)
      REAL_T tforces(DIMV(tf),nvar)
      REAL_T divu(DIMV(divu))
      REAL_T rho(DIMV(rho))

      if ( iconserv .eq. 1 ) then
         do n = 1, nvar
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tforces(i,j,n) = 
     &            tforces(i,j,n) - S(i,j,n)*divu(i,j)
               end do
            end do
         end do
      else
         do n = 1, nvar
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tforces(i,j,n) =
     &            tforces(i,j,n)/rho(i,j)
               end do
            end do
         end do
      end if

      end

      subroutine FORT_SUM_TF_DIVU_VISC(
     &     S,DIMS(S),
     &     tforces,DIMS(tf),
     &     divu,DIMS(divu),
     &     visc,DIMS(visc),
     &     rho,DIMS(rho),
     &     lo,hi,nvar,iconserv )
c
c     sum tforces, viscous foricing and divU*S into tforces
c     depending on the value of iconserv
c
      integer nvar, iconserv
      integer lo(SDIM), hi(SDIM)
      integer i, j, n

      integer DIMDEC(S)
      integer DIMDEC(tf)
      integer DIMDEC(divu)
      integer DIMDEC(visc)
      integer DIMDEC(rho)

      REAL_T S(DIMV(S),nvar)
      REAL_T tforces(DIMV(tf),nvar)
      REAL_T divu(DIMV(divu))
      REAL_T visc(DIMV(visc),nvar)
      REAL_T rho(DIMV(rho))

      if ( iconserv .eq. 1 ) then
         do n = 1, nvar
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tforces(i,j,n) = 
     &                 tforces(i,j,n)
     &                 +  visc(i,j,n)
     &                 -     S(i,j,n)*divu(i,j)
               end do
            end do
         end do
      else
         do n = 1, nvar
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tforces(i,j,n) = (
     &                 tforces(i,j,n)
     &                 +  visc(i,j,n) )/rho(i,j)
               end do
            end do
         end do
      end if

      end

      subroutine FORT_UPDATE_TF(
     &     s,       DIMS(s),
     &     sn,      DIMS(sn),
     &     tforces, DIMS(tf),
     &     lo,hi,dt,nvar)
c
c     update a field with a forcing term
c
      integer i, j, n, nvar
      integer DIMDEC(s)
      integer DIMDEC(sn)
      integer DIMDEC(tf)
      integer lo(SDIM), hi(SDIM)
      REAL_T dt
      REAL_T s(DIMV(s),nvar)
      REAL_T sn(DIMV(sn),nvar)
      REAL_T tforces(DIMV(tf),nvar)

      do n = 1,nvar
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               sn(i,j,n) = s(i,j,n) + dt*tforces(i,j,n)
            end do
         end do
      end do

      end

      subroutine FORT_CORRECT_TF(
     &     ss,  sp,  DIMS(ss),
     &     tfs, tfn, DIMS(tfs),
     &     lo,hi,dt,nvar)
c
c     correct 1st order rk to second-order
c
      integer i, j, n, nvar
      integer lo(SDIM), hi(SDIM)
      REAL_T dt,hdt

      integer DIMDEC(ss)
      integer DIMDEC(tfs)
      REAL_T  ss(DIMV(ss),nvar)
      REAL_T  sp(DIMV(ss),nvar)
      REAL_T tfs(DIMV(tfs),nvar)
      REAL_T tfn(DIMV(tfs),nvar)

      hdt = half*dt
      do n = 1,nvar
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               sp(i,j,n) = ss(i,j,n)
     &              + hdt*(tfs(i,j,n)-tfn(i,j,n))
            end do
         end do
      end do

      end

      subroutine FORT_UPDATE_AOFS_TF(
     &     s,       DIMS(s),
     &     sn,      DIMS(sn),
     &     aofs,    DIMS(aofs),
     &     tforces, DIMS(tf),
     &     lo,hi,dt,nvar)
c
c     update a field with an advective tendency
c     and a forcing term
c
      integer i, j, n, nvar
      integer DIMDEC(s)
      integer DIMDEC(sn)
      integer DIMDEC(aofs)
      integer DIMDEC(tf)
      integer lo(SDIM), hi(SDIM)
      REAL_T dt
      REAL_T s(DIMV(s),nvar)
      REAL_T sn(DIMV(sn),nvar)
      REAL_T aofs(DIMV(aofs),nvar)
      REAL_T tforces(DIMV(tf),nvar)

      do n = 1,nvar
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               sn(i,j,n) = s(i,j,n)
     &              - dt*aofs(i,j,n)
     &              + dt*tforces(i,j,n)
            end do
         end do
      end do

      end

      subroutine FORT_UPDATE_AOFS_TF_GP(
     &     u,       DIMS(u),
     &     un,      DIMS(un),
     &     aofs,    DIMS(aofs),
     &     tforces, DIMS(tf),
     &     gp,      DIMS(gp),
     &     rho,     DIMS(rho),
     &     lo, hi, dt)

c
c     update the velocities
c
      integer i, j, n
      integer DIMDEC(u)
      integer DIMDEC(un)
      integer DIMDEC(aofs)
      integer DIMDEC(rho)
      integer DIMDEC(gp)
      integer DIMDEC(tf)
      integer lo(SDIM), hi(SDIM)
      REAL_T u(DIMV(u),SDIM)
      REAL_T un(DIMV(un),SDIM)
      REAL_T aofs(DIMV(aofs),SDIM)
      REAL_T rho(DIMV(rho))
      REAL_T gp(DIMV(gp),SDIM)
      REAL_T tforces(DIMV(tf),SDIM)
      REAL_T dt

      do n = 1, SDIM
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               un(i,j,n) = u(i,j,n) 
     &              - dt*   aofs(i,j,n)
     &              + dt*tforces(i,j,n)/rho(i,j)
     &              - dt*     gp(i,j,n)/rho(i,j)
            end do
         end do
      end do

      end


      subroutine bdsslope(s,lo_1,lo_2,hi_1,hi_2,slx,sly,sc,dx)

      integer lo_1,lo_2,hi_1,hi_2
      REAL_T      s(lo_1-3:hi_1+3,lo_2-3:hi_2+3)
      REAL_T    slx(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    sly(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   slxy(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   sint(lo_1-2:hi_1+2,lo_2-2:hi_2+2)
      REAL_T     sc(lo_1-1:hi_1+1,lo_2-1:hi_2+1,4)
      REAL_T dx(2)     

      REAL_T   diff(lo_1-1:hi_1+1,4)
      REAL_T   smin(lo_1-1:hi_1+1,4)
      REAL_T   smax(lo_1-1:hi_1+1,4)
      REAL_T sumdif(lo_1-1:hi_1+1)
      REAL_T sgndif(lo_1-1:hi_1+1)
      integer   kdp(lo_1-1:hi_1+1)

      REAL_T hx,hy,sumloc,redfac,redmax,div
      REAL_T choice1,choice2
      REAL_T eps
      integer inc1, inc2, inc3, inc4
      integer i,j,k,ll,is,ie,js,je

      hx = dx(1)
      hy = dx(2)
      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      eps = 1.d-8

      do i = is-2,ie+1
        do j = js-2,je+1
          sint(i,j) = (
     $              s(i-1,j-1) + s(i-1,j+2) + s(i+2,j-1) + s(i+2,j+2)
     $     - seven*(s(i-1,j  ) + s(i-1,j+1) + s(i  ,j-1) + s(i+1,j-1) + 
     $              s(i  ,j+2) + s(i+1,j+2) + s(i+2,j  ) + s(i+2,j+1)) + 
     $       49.d0*(s(i  ,j  ) + s(i+1,j  ) + s(i  ,j+1) + s(i+1,j+1)) ) / 144.d0
        enddo
      enddo

      do j = js-1,je+1
        do i = is-1,ie+1 

          slx(i,j) = half*(sint(i  ,j) + sint(i  ,j-1) - 
     $                     sint(i-1,j) - sint(i-1,j-1) ) / hx
          sly(i,j) = half*(sint(i  ,j) - sint(i  ,j-1) + 
     $                     sint(i-1,j) - sint(i-1,j-1) ) / hy
          slxy(i,j) = (sint(i,j  ) - sint(i  ,j-1) - 
     $                 sint(i-1,j) + sint(i-1,j-1) ) / (hx*hy)
        enddo
      enddo

      do j = js-1,je+1

        do i = is-1,ie+1
          smin(i,4) = min(s(i,j), s(i+1,j), s(i,j+1), s(i+1,j+1))
          smax(i,4) = max(s(i,j), s(i+1,j), s(i,j+1), s(i+1,j+1))
          smin(i,3) = min(s(i,j), s(i+1,j), s(i,j-1), s(i+1,j-1))
          smax(i,3) = max(s(i,j), s(i+1,j), s(i,j-1), s(i+1,j-1))
          smin(i,2) = min(s(i,j), s(i-1,j), s(i,j+1), s(i-1,j+1))
          smax(i,2) = max(s(i,j), s(i-1,j), s(i,j+1), s(i-1,j+1))
          smin(i,1) = min(s(i,j), s(i-1,j), s(i,j-1), s(i-1,j-1))
          smax(i,1) = max(s(i,j), s(i-1,j), s(i,j-1), s(i-1,j-1))

          sc(i,j,4) = s(i,j) + half*(hx*slx(i,j) + hy*sly(i,j)) 
     $                + fourth*hx*hy*slxy(i,j)
          sc(i,j,3) = s(i,j) + half*(hx*slx(i,j) - hy*sly(i,j)) 
     $                - fourth*hx*hy*slxy(i,j)
          sc(i,j,2) = s(i,j) - half*(hx*slx(i,j) - hy*sly(i,j))
     $                - fourth*hx*hy*slxy(i,j)
          sc(i,j,1) = s(i,j) - half*(hx*slx(i,j) + hy*sly(i,j))
     $                + fourth*hx*hy*slxy(i,j)

          sc(i,j,4) = max(min(sc(i,j,4), smax(i,4)), smin(i,4))
          sc(i,j,3) = max(min(sc(i,j,3), smax(i,3)), smin(i,3))
          sc(i,j,2) = max(min(sc(i,j,2), smax(i,2)), smin(i,2))
          sc(i,j,1) = max(min(sc(i,j,1), smax(i,1)), smin(i,1))
        enddo

        do ll = 1,3 
          do i = is-1,ie+1 
            sumloc = fourth*(sc(i,j,4) + sc(i,j,3) + 
     $                       sc(i,j,2) + sc(i,j,1))
            sumdif(i) = (sumloc - s(i,j))*4.
            sgndif(i) = sign(one,sumdif(i))

            diff(i,4) = (sc(i,j,4) - s(i,j))*sgndif(i)
            diff(i,3) = (sc(i,j,3) - s(i,j))*sgndif(i)
            diff(i,2) = (sc(i,j,2) - s(i,j))*sgndif(i)
            diff(i,1) = (sc(i,j,1) - s(i,j))*sgndif(i)

            inc1 = cvmgp(1,0,diff(i,1) - eps)
            inc2 = cvmgp(1,0,diff(i,2) - eps)
            inc3 = cvmgp(1,0,diff(i,3) - eps)
            inc4 = cvmgp(1,0,diff(i,4) - eps)
            kdp(i) = inc1 + inc2 + inc3 + inc4
          enddo

          do k = 1,4 
            do i = is-1,ie+1 
              div = cvmgt(one,kdp(i),kdp(i) .lt. 1)
	      choice1 = sumdif(i)*sgndif(i)/div
              redfac = cvmgt(choice1,zero,diff(i,k).gt.eps)
              kdp(i) = cvmgt(kdp(i) - 1,kdp(i),diff(i,k) .gt. eps)
              choice1 = sc(i,j,k) - smin(i,k)
              choice2 = smax(i,k) - sc(i,j,k)
              redmax = cvmgp(choice1,choice2,sgndif(i))
              redfac = min(redfac,redmax)
              sumdif(i) = sumdif(i) - redfac*sgndif(i)
              sc(i,j,k) = sc(i,j,k) - redfac*sgndif(i)
            enddo
          enddo
        enddo

        do i = is-1,ie+1 
          slx(i,j) = half*(sc(i,j,4) + sc(i,j,3) - 
     $                     sc(i,j,1) - sc(i,j,2))/hx
          sly(i,j) = half*(sc(i,j,4) + sc(i,j,2) - 
     $                     sc(i,j,1) - sc(i,j,3))/hy
        enddo
      enddo

      return
      end

      subroutine FORT_ESTATE_BDS(s, tforces, divu, DIMS(s),
     &     xlo, xhi, sx, slxscr, stxlo, stxhi,
     &     uedge, DIMS(uedge), xstate, DIMS(xstate),

     &     ylo, yhi, sy, slyscr, stylo, styhi,
     &     vedge, DIMS(vedge), ystate, DIMS(ystate),

     &     DIMS(work),
     &     bc,lo,hi,dt,dx,n,use_minion,iconserv)
c
c     This subroutine computes edges states, right now it uses
c     a lot of memory, but there becomes a trade off between
c     simplicity-efficiency in the new way of computing states
c     and complexity in the old way.  By eliminating loops over
c     state components though, the new way uses much less memory.
c
      implicit none
      integer i,j,n
      integer lo(SDIM),hi(SDIM),bc(SDIM,2)
      integer is,js,ie,je
      REAL_T place_to_break
      REAL_T hx, hy, dt, dth, dthx, dthy
      REAL_T tr,ubar,vbar,stx,sty,fu,fv,dx(SDIM)
      REAL_T eps,eps_for_bc
      logical ltx,lty
      parameter( eps        = 1.0D-6 )
      parameter( eps_for_bc = 1.0D-10 )

      integer DIMDEC(s)
      integer DIMDEC(work)
      integer DIMDEC(uedge)
      integer DIMDEC(xstate)
      integer DIMDEC(vedge)
      integer DIMDEC(ystate)

      REAL_T s(DIMV(s))
      REAL_T stxlo(DIM1(s)),stxhi(DIM1(s)),slxscr(DIM1(s),4)
      REAL_T stylo(DIM2(s)),styhi(DIM2(s)),slyscr(DIM2(s),4)

      REAL_T uedge(DIMV(uedge)), xstate(DIMV(xstate))
      REAL_T vedge(DIMV(vedge)), ystate(DIMV(ystate))

      REAL_T xlo(DIMV(work)), xhi(DIMV(work))
      REAL_T ylo(DIMV(work)), yhi(DIMV(work))
      REAL_T  sx(DIMV(work))
      REAL_T  sy(DIMV(work))
      REAL_T tforces(DIMV(work))
      REAL_T    divu(DIMV(work))
      
      REAL_T spx,smx,spy,smy,st,denom
      REAL_T smin,smax

      REAL_T   sc(DIMV(work),4)
      REAL_T gamp(DIM1(work))
      REAL_T gamm(DIM1(work))
      REAL_T   xm(DIM1(work))
      REAL_T   ym(DIM1(work))
      REAL_T    c(DIM1(work),4)
      REAL_T dt3rd

      integer choose_hi(DIM1(work))

      integer use_minion, iconserv
      integer inc
      integer iup,isign,jup,jsign
      REAL_T vtrans,vmult,vdif,stem,vaddif

      dth  = half*dt
      dthx = half*dt / dx(1)
      dthy = half*dt / dx(2)
      hx   = dx(1)
      hy   = dx(2)
      is = lo(1)
      js = lo(2)
      ie = hi(1)
      je = hi(2)

      dt3rd = dt * third

      smax = s(is,js)
      smin = s(is,js)
      do j = js,je
        do i = is,ie
          smax = max(smax,s(i,j))
          smin = min(smin,s(i,j))
        enddo
      enddo

      call bdsslope(s,lo(1),lo(2),hi(1),hi(2),sx,sy,sc,dx)

      do j = js,je 

        do i = is-1,ie 
          choose_hi(i+1) = cvmgp(0,1,uedge(i+1,j))
        end do 
        if (bc(1,1).eq.FOEXTRAP.or.bc(1,1).eq.HOEXTRAP
     &          .or.bc(1,1).eq.REFLECT_EVEN) then
           choose_hi(is) = 1
        endif
        if (bc(1,2).eq.FOEXTRAP.or.bc(1,2).eq.HOEXTRAP
     &          .or.bc(1,2).eq.REFLECT_EVEN) then
           choose_hi(ie+1) = 0
        endif

        do i = is-1,ie 
          iup   = cvmgt(i,i+1,choose_hi(i+1).eq.0)
          isign = cvmgt(1,-1, choose_hi(i+1).eq.0)
          vtrans = vedge(iup,j+1)
          jup = cvmgp(j,j+1,vtrans)
          jsign = cvmgp(1,-1,vtrans)
          vmult = cvmgp(uedge(i+1,j),half*(uedge(i+1,j)+uedge(i+1,j+1)),vtrans)
          xm(i) = isign*half*hx - two3rd*dt*vmult
          xm(i) = cvmgp(xm(i), isign*min(isign*xm(i),hx*half), vtrans)
          ym(i) = jsign*half*hy - dt3rd*vedge(iup,j+1)

          c(i,1) = sc(iup,jup,1)
          c(i,2) = sc(iup,jup,2)
          c(i,3) = sc(iup,jup,3)
          c(i,4) = sc(iup,jup,4)

        enddo

        call bilin(gamp,c,xm,ym,hx,hy,is-1,ie,lo(1),hi(1))

c       Impose BCs on gamp.
        if (j .eq. je) then
          do i = is-1, ie  
            if (bc(2,2).eq.EXT_DIR .and.(vedge(i,je+1).le.zero) ) then
               gamp(i) = s(i,je+1)
            else if (bc(2,2).eq.REFLECT_ODD) then
               gamp(i) = zero
            end if
          end do
        end if

        do i = is-1,ie 
          iup   = cvmgt(i,i+1,choose_hi(i+1).eq.0)
          isign = cvmgt(1,-1, choose_hi(i+1).eq.0)
          vtrans = vedge(iup,j)
          jup = cvmgp(j-1,j,vtrans)
          jsign = cvmgp(1,-1,vtrans)
          vmult = cvmgp(half*(uedge(i+1,j)+uedge(i+1,j-1)),uedge(i+1,j),vtrans)
          xm(i) = isign*half*hx - two3rd*dt*vmult
          xm(i) = cvmgp(isign*min(isign*xm(i),hx*half), xm(i), vtrans)
          ym(i) = jsign*half*hy - dt3rd*vedge(iup,j)

          c(i,1) = sc(iup,jup,1)
          c(i,2) = sc(iup,jup,2)
          c(i,3) = sc(iup,jup,3)
          c(i,4) = sc(iup,jup,4)

        enddo

        call bilin(gamm,c,xm,ym,hx,hy,is-1,ie,lo(1),hi(1))

c       Impose BCs on gamm.
        if (j .eq. js) then
          do i = is-1, ie 
            if (bc(2,1).eq.EXT_DIR .and.(vedge(i,js).ge.zero) ) then
               gamm(i) = s(i,js-1)
            else if (bc(2,1).eq.REFLECT_ODD) then
               gamm(i) = zero
            end if
          end do
        end if

        do i = is-1, ie 
          iup   = cvmgt(i,i+1,choose_hi(i+1).eq.0)
          isign = cvmgt(1,-1, choose_hi(i+1).eq.0)
          vdif   = dth*(vedge(iup,j+1)*gamp(i) - vedge(iup,j  )*gamm(i) ) / hy
          stem   = s(iup,j) + (isign*hx - uedge(i+1,j)*dt)*half*sx(iup,j)

c         vaddif = dth*stem*(uedge(iup+1,j) - uedge(iup,j))/hx
          vaddif = dth*stem*(divu(iup,j) - (vedge(iup,j+1)-vedge(iup,j))/hy)

          xstate(i+1,j) = stem - vdif - vaddif + dth*tforces(iup,j)

          if (iconserv .eq. 0) 
     $      xstate(i+1,j) = xstate(i+1,j) + dth*stem*divu(iup,j)

        enddo
      enddo

      do j = js-1,je 

        do i = is,ie 
          choose_hi(i) = cvmgp(0,1,vedge(i,j+1))
          if ( (j .eq. js-1) .and. 
     &       (bc(2,1).eq.FOEXTRAP.or.bc(2,1).eq.HOEXTRAP
     &                           .or.bc(2,1).eq.REFLECT_EVEN) )
     &     choose_hi(i) = 1
          if ( (j .eq. je) .and. 
     &       (bc(2,2).eq.FOEXTRAP.or.bc(2,2).eq.HOEXTRAP
     &                           .or.bc(2,2).eq.REFLECT_EVEN) )
     &     choose_hi(i) = 0
        end do 

        do i = is,ie 
          jup   = cvmgt(j,j+1,choose_hi(i).eq.0)
          jsign = cvmgt(1, -1,choose_hi(i).eq.0)
          vtrans = uedge(i+1,jup)
          iup = cvmgp(i,i+1,vtrans)
          isign = cvmgp(1,-1,vtrans)
          vmult = cvmgp(vedge(i,j+1),half*(vedge(i,j+1)+vedge(i+1,j+1)),vtrans)
          xm(i) = isign*half*hx - dt3rd*uedge(i+1,jup)
          ym(i) = jsign*half*hy - two3rd*dt*vmult
          ym(i) = cvmgp(ym(i),jsign*min(jsign*ym(i),hy*half),vtrans)

          c(i,1) = sc(iup,jup,1)
          c(i,2) = sc(iup,jup,2)
          c(i,3) = sc(iup,jup,3)
          c(i,4) = sc(iup,jup,4)
        enddo

        call bilin(gamp,c,xm,ym,hx,hy,is,ie,lo(1),hi(1))

c       Impose BCs on gamp.
        if (bc(1,2).eq.EXT_DIR .and.(uedge(ie+1,j).le.zero) ) then
           gamp(ie) = s(ie+1,j)
        else if (bc(1,2).eq.REFLECT_ODD) then
           gamp(ie) = zero
        end if

        do i = is,ie 
          jup   = cvmgt(j,j+1,choose_hi(i).eq.0)
          jsign = cvmgt(1, -1,choose_hi(i).eq.0)
          vtrans = uedge(i,jup)
          iup = cvmgp(i-1,i,vtrans)
          isign = cvmgp(1,-1,vtrans)
          vmult = cvmgp(half*(vedge(i,j+1)+vedge(i-1,j+1)),vedge(i,j+1),vtrans)
          xm(i) = isign*half*hx - dt3rd*uedge(i,jup)
          ym(i) = jsign*half*hy - two3rd*dt*vmult
          ym(i) = cvmgp(jsign*min(jsign*ym(i),hy*half),ym(i),vtrans)

          c(i,1) = sc(iup,jup,1)
          c(i,2) = sc(iup,jup,2)
          c(i,3) = sc(iup,jup,3)
          c(i,4) = sc(iup,jup,4)
        enddo

        call bilin(gamm,c,xm,ym,hx,hy,is,ie,lo(1),hi(1))

c       Impose BCs on gamm.
        if (bc(1,1).eq.EXT_DIR .and.(uedge(is,j).ge.zero) ) then
           gamm(is) = s(is,j)
        else if (bc(1,1).eq.REFLECT_ODD) then
           gamm(is) = zero
        end if

        do i = is,ie 
          jup   = cvmgt(j,j+1,choose_hi(i).eq.0)
          jsign = cvmgt(1, -1,choose_hi(i).eq.0)
          vdif   = dth*(uedge(i+1,jup)*gamp(i)-uedge(i,jup)*gamm(i))/hx
          stem   = s(i,jup) + (jsign*hy - vedge(i,j+1)*dt)*half*sy(i,jup)

c         vaddif = dth*stem*(vedge(i,jup+1) - vedge(i,jup))/hy
          vaddif = dth*stem*(divu(i,jup) - (uedge(i+1,jup)-uedge(i,jup))/hx)

          ystate(i,j+1) = stem - vdif - vaddif + dth*tforces(i,jup)

          if (iconserv .eq. 0) 
     $      ystate(i,j+1) = ystate(i,j+1) + dth*stem*divu(i,jup)

        enddo
      enddo

c     
c     Impose BCs on xstate.
c     
      do j = js,je 
        if (bc(1,1).eq.EXT_DIR .and. uedge(is,j).ge.zero) then
           xstate(is,j) = s(is-1,j)
        else if (bc(1,1).eq.REFLECT_ODD) then
           xstate(is,j) = zero
        end if

        if (bc(1,2).eq.EXT_DIR .and. uedge(ie+1,j).le.zero) then
           xstate(ie+1,j) = s(ie+1,j)
        else if (bc(1,2).eq.REFLECT_ODD) then
           xstate(ie+1,j) = zero
        end if
      enddo

c     
c     Impose BCs on ystate.
c     
      do i = is,ie 
        if (bc(2,1).eq.EXT_DIR .and.(vedge(i,js).ge.zero) ) then
           ystate(i,js) = s(i,js-1)
        else if (bc(2,1).eq.REFLECT_ODD) then
            ystate(i,js) = zero
        end if

        if (bc(2,2).eq.EXT_DIR .and. (vedge(i,je+1).le.zero) ) then
           ystate(i,je+1) = s(i,je+1)
        else if (bc(2,2).eq.REFLECT_ODD) then
            ystate(i,je+1) = zero
        end if
      enddo

#if 0
      do j = js,je 
      do i = is,ie+1
          if (xstate(i,j).lt. zero) print *,'NEG XSTATE ',i,j,xstate(i,j)
          if (abs(xstate(i,j)).gt. 1.e20) print *,'BIG XSTATE ',i,j,xstate(i,j)
      enddo
      enddo
      do j = js,je+1 
      do i = is,ie
          if (ystate(i,j).lt. zero) print *,'NEG YSTATE ',i,j,ystate(i,j)
          if (abs(ystate(i,j)).gt. 1.e20) print *,'BIG YSTATE ',i,j,ystate(i,j)
      enddo
      enddo
#endif

      end

      subroutine bilin(poly,c,x,y,hx,hy,istart,iend,lo_1,hi_1)

      integer lo_1,hi_1
      integer istart,iend
      REAL_T poly(lo_1-1:hi_1+1)
      REAL_T    x(lo_1-1:hi_1+1)
      REAL_T    y(lo_1-1:hi_1+1)
      REAL_T    c(lo_1-1:hi_1+1,4)
      REAL_T hx, hy
      REAL_T centx, centy
      REAL_T l1,l2,l3,l4

      integer i

      centx = hx/2
      centy = hy/2

      do i = istart,iend

        l1 = (-centx - x(i))*(-centy - y(i))
        l2 = (-centx - x(i))*( centy - y(i))
        l3 = ( centx - x(i))*(-centy - y(i))
        l4 = ( centx - x(i))*( centy - y(i))

        poly(i) = l2*c(i,3) + l3*c(i,2) - l1*c(i,4) - l4*c(i,1)
        poly(i) = -poly(i)/(hx*hy)
      enddo

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "MACOUTFLOWBC_F.H"
#include "ArrayLim.H"

#define SDIM 2

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
#define SMALL 1.0e-10
#else
#define SMALL 1.0d-10
#endif


c *************************************************************************
c ** EXTRAP_MAC
c *************************************************************************

      subroutine FORT_EXTRAP_MAC(DIMS(u0),u0,DIMS(u1),u1,DIMS(div),divu,DIMS(rho),rho,
     &                         r_len,redge,DIMS(divuExt),divuExt,
     &                         DIMS(rhoExt),rhoExt,dx,lo,hi,face,per,zeroIt)
c
c     Compute the value of phi for macproj 
c
c     (subtract divu_ave twice due to precision problems)
      implicit none

      integer DIMDEC(u0)
      integer DIMDEC(u1)
      integer DIMDEC(div)
      integer DIMDEC(rho)
      integer r_len
      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(divuExt)
      integer DIMDEC(rhoExt)
      REAL_T      u0(DIMV(u0))
      REAL_T      u1(DIMV(u1))
      REAL_T divu(DIMV(div))
      REAL_T    rho(DIMV(rho))
      REAL_T  redge(0:r_len-1)
      REAL_T   divuExt(DIMV(divuExt))
      REAL_T   rhoExt(DIMV(rhoExt))
      REAL_T   dx(2)
      integer face
      integer per
      integer zeroIt
      
c     Local variables
      REAL_T small_pert
      REAL_T small_udiff
      parameter ( small_pert = SMALL)
      parameter (small_udiff = SMALL)
      integer i, j, neq,n
      REAL_T divu_ave1,divu_ave2
      REAL_T max_divu, min_divu, max_pert
      REAL_T diff
      REAL_T rc,hx,hy
      integer ics,ice,jcs,jce
      integer ifs,ife,jfs,jfe
      integer if,jf,ic,jc
c     NOTE: Assumes that rho at edge between i, i-1 = half*(rho(i)+rho(i-1))
c             (1) Linear fit of rho between nodes
c             (2) rho, divu on same boxes (box)
c             (3) phi is on box, shifted up one
c             (4) u is edge-based, on surroundingNodes(box)

c     Compute average of divu over outflow bc.  Set trivial solution if average
c     is zero, or if divu is constant
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3
      ics = ARG_L1(rho)
      ice = ARG_H1(rho)
      jcs = ARG_L2(rho)
      jce = ARG_H2(rho)

      ifs = lo(1)
      ife = hi(1)
      jfs = lo(2)
      jfe = hi(2)

      hx = dx(1)
      hy = dx(2)

      zeroIt = 0

      if (face .eq. XLO) then

         if = ifs
         max_divu = divu(ics,jcs)
         min_divu = max_divu
         do j = jcs, jce
            divuExt(j,if) = divu(ics,j)
            rhoExt(j,if)  = rho(ics,j)
            max_divu = max(max_divu,divuExt(j,if))
            min_divu = min(min_divu,divuExt(j,if))
         end do

c        Here we modify divuExt to include the velocity terms.
         do j = jcs, jce
            divuExt(j,if) = redge(j-jcs)*(divuExt(j,if)*hy*hy - (u1(ics,j+1)-u1(ics,j))*hy)
         end do

         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)

         max_pert = ABS(divuExt(jcs,if))
         do j = jcs, jce
            max_pert = MAX(max_pert,ABS(divuExt(j,if)))
         end do
      
c        Make sure u_mac is periodic
         if (per .eq. 1) then
           diff = u1(ics,jcs)-u1(ics,jce+1)
           if (ABS(diff) .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE XLO : umac not periodic'
              write(6,*) 'V AT    TOP: ',u1(ics,jce+1)
              write(6,*) 'V AT BOTTOM: ',u1(ics,jcs  )
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. YLO) then

         jf = jfs
         max_divu = divu(ics,jcs)
         min_divu = max_divu
         do i = ics, ice
            divuExt(i,jf) = divu(i,jcs)
            rhoExt(i,jf)  = rho(i,jcs)
            max_divu = max(max_divu,divuExt(i,jf))
            min_divu = min(min_divu,divuExt(i,jf))
         end do

c        Here we modify divuExt to include the velocity terms.
         do i = ics, ice
            rc = half*(redge(i+1-ics)+redge(i-ics))
            divuExt(i,jf) = rc*divuExt(i,jf)*hx*hx - 
     $                      (redge(i+1-ics)*u0(i+1,jcs)-redge(i-ics)*u0(i,jcs))*hx
         end do

         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jf))
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,jf)))
         end do
      
c        Make sure u_mac is periodic
         if (per .eq. 1) then
           diff = u0(ics,jcs)-u0(ice+1,jcs)
           if (ABS(diff) .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE YLO : umac not periodic'
              write(6,*) 'U AT LEFT: ',u0(ics  ,jcs)
              write(6,*) 'U AT RGHT: ',u0(ice+1,jcs)
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. XHI) then

         if = ife
         max_divu = divu(ice,jcs)
         min_divu = max_divu
         do j = jcs, jce
            divuExt(j,if) = divu(ice,j)
            rhoExt(j,if)  = rho(ice,j)
            max_divu = max(max_divu,divuExt(j,if))
            min_divu = min(min_divu,divuExt(j,if))
         end do

c        Here we modify divuExt to include the velocity terms.
         do j = jcs, jce
            divuExt(j,if) = redge(j-jcs)*(divuExt(j,if)*hy*hy - (u1(ice,j+1)-u1(ice,j))*hy)
         end do

         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)

         max_pert = ABS(divuExt(jcs,if))
         do j = jcs, jce
            max_pert = MAX(max_pert,ABS(divuExt(j,if)))
         end do
      
c        Make sure u_mac is periodic
         if (per .eq. 1) then
           diff = u1(ice,jcs)-u1(ice,jce+1)
           if (ABS(diff) .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE XHI : umac not periodic'
              write(6,*) 'V AT    TOP: ',u1(ice,jce+1)
              write(6,*) 'V AT BOTTOM: ',u1(ice,jcs  )
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. YHI) then

         jf = jfe
         max_divu = divu(ics,jce)
         min_divu = max_divu
         do i = ics, ice
            divuExt(i,jf) = divu(i,jce)
            rhoExt(i,jf)  = rho(i,jce)
            max_divu = max(max_divu,divuExt(i,jf))
            min_divu = min(min_divu,divuExt(i,jf))
         end do

c        Here we modify divuExt to include the velocity terms.
         do i = ics, ice
            rc = half*(redge(i+1-ics)+redge(i-ics))
            divuExt(i,jf) = rc*divuExt(i,jf)*hx*hx - 
     $                      (redge(i+1-ics)*u0(i+1,jce)-redge(i-ics)*u0(i,jce))*hx
         end do

         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,redge,r_len,lo,hi,divu_ave2,face)

         max_pert = ABS(divuExt(ics,jf))
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,jf)))
         end do
      
c        Make sure u_mac is periodic
         if (per .eq. 1) then
           diff = u0(ics,jce)-u0(ice+1,jce)
           if (ABS(diff) .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE YHI : umac not periodic'
              write(6,*) 'U AT LEFT: ',u0(ics  ,jce)
              write(6,*) 'U AT RGHT: ',u0(ice+1,jce)
              call bl_abort(" ")
           endif
         endif

      endif
      
c  check to see if we should zero phi
         max_pert = max_pert/(ABS(divu_ave1+divu_ave2)+small_pert)
      if ((max_divu.eq.zero.and.min_divu.eq.zero)
     &     .or.(max_pert.le.small_pert)) then
         zeroIt = 1
      end if
      end

c *************************************************************************
c ** SUBTRACTAVG
c *************************************************************************

      subroutine subtractavg(DIMS(divu),divu,redge,r_len,lo,hi,divu_ave,face)
      implicit none
      integer DIMDEC(divu)
      integer r_len
      integer lo(SDIM),hi(SDIM)
      REAL_T  redge(0:r_len-1)
      REAL_T divu(DIMV(divu))
      REAL_T divu_ave
      integer face

      integer i,j
      REAL_T rcen
      REAL_T vtot

      divu_ave = zero
      vtot = zero

      if (face .eq. XLO .or. face .eq. XHI) then
         i = lo(1)
         do j=lo(2),hi(2)
            vtot = vtot+one
            divu_ave = divu_ave+divu(j,i)
         enddo
         divu_ave = divu_ave/vtot
         do j=lo(2),hi(2)
            divu(j,i) = divu(j,i) - divu_ave
         enddo
      elseif (face .eq. YLO .or. face .eq. YHI) then
         j = lo(2)
         do i=lo(1),hi(1)
            rcen = half*(redge(i)+redge(i+1))
            vtot = vtot+rcen
            divu_ave = divu_ave+rcen*divu(i,j)
         enddo
         divu_ave = divu_ave/vtot
         do i=lo(1),hi(1)
            divu(i,j) = divu(i,j) - divu_ave
         enddo
      else 
         print*, "bad value of face in subtractavg"
      endif

      end
#undef XLO
#undef YLO
#undef XHI
#undef YHI


c *************************************************************************
c ** MACRELAX
c *************************************************************************

#define DGX (beta(i)*phi(i-1) - (beta(i)+beta(i+1))*phi(i) \
            +beta(i+1)*phi(i+1))*(hxsqinv)

      subroutine FORT_MACRELAX(DIMS(rhs),rhs,DIMS(beta),beta,DIMS(phi),phi,
     &                        lo,hi,h,isPeriodic,niter)
      implicit none
      integer DIMDEC(beta)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      REAL_T beta(DIM1(beta))
      REAL_T rhs(DIM1(rhs))
      REAL_T phi(DIM1(phi))
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)

c Local variables
      integer redblack
      integer ics,ice
      integer i,iter
      REAL_T lam, dg
      REAL_T phitot,vtot
      logical setSingularPoint
      REAL_T maxnorm
      REAL_T hxsqinv
      integer niter

      hxsqinv = 1.0D0/(h(1)*h(1))
      ics = lo(1)
      ice = hi(1)

      setSingularPoint = .false.
      call setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)

      do iter = 1,niter
         do redblack = 0,1
            do i=ics+redblack,ice,2
               dg = DGX
               lam = -one/(hxsqinv*(beta(i)+beta(i+1)))
               phi(i) = phi(i) + lam*(rhs(i)-dg)
            enddo
           call setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
         end do
      end do

      end

c *************************************************************************
c ** MACSUBTRACTAVGPHI
c *************************************************************************

      subroutine FORT_MACSUBTRACTAVGPHI(DIMS(phi),phi,r_lo,r_hi,r,lo,hi,
     &                                  isPeriodic)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM1(phi))
      integer r_lo,r_hi
      REAL_T r(r_lo:r_hi)
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)

      REAL_T phitot,vtot
      integer ics,ice,ine
      integer i
      logical setSingularPoint

      ics = lo(1)
      ice = hi(1)
      setSingularPoint = .false.

      phitot = zero
      vtot   = zero
      do i=ics,ice
         phitot = phitot+phi(i)*r(i)
         vtot = vtot + r(i)
      enddo
      phitot = phitot/vtot
      do i=ics,ice
         phi(i) = phi(i) - phitot
      enddo

      call setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
      
      end

c *************************************************************************
c ** MACRESID
c *************************************************************************

      subroutine FORT_MACRESID(DIMS(rhs),rhs,DIMS(beta),beta,DIMS(phi),phi,
     &                    DIMS(resid),resid,lo,hi,h,isPeriodic,maxnorm)
      implicit none
      integer DIMDEC(beta)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      integer DIMDEC(resid)
      REAL_T beta(DIM1(beta))
      REAL_T rhs(DIM1(rhs))
      REAL_T phi(DIM1(phi))
      REAL_T resid(DIM1(resid))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)

      REAL_T maxnorm
      integer i
      REAL_T hxsqinv

      hxsqinv = one/(h(1)*h(1))

      maxnorm = zero
      do i = lo(1),hi(1)
         resid(i) = rhs(i)-(DGX)
         maxnorm = max(maxnorm,ABS(resid(i)))
      enddo

      end

c *************************************************************************
c ** SETMACBC
c *************************************************************************

      subroutine setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM1(phi))
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)
      integer ics,ice
      logical setSingularPoint
      ics = lo(1)
      ice = hi(1)

      if (isPeriodic(1) .NE. 1 .and. setSingularPoint) then
         phi(ice)= zero
      endif

      if (isPeriodic(1).eq.1) then
         phi(ics-1) = phi(ice)
         phi(ice+1) = phi(ics)
      else
         phi(ics-1) = phi(ics)
         phi(ice+1) = phi(ice)
      endif

      end

c *************************************************************************
c ** MAC_SHIFT_PHI
c *************************************************************************

      subroutine FORT_MAC_SHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      if (face .eq. XLO .or. face .eq. XHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(j,i)
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(i,j)
            enddo
         enddo
      endif
#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

c *************************************************************************
c ** MAC_RESHIFT_PHI
c *************************************************************************


      subroutine FORT_MAC_RESHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j
#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      if (face .eq. XLO .or. face .eq. XHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(j,i)
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j) = in(i,j)
            enddo
         enddo
      endif
#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end


c *************************************************************************
c ** SOLVEMAC
c *************************************************************************

      subroutine FORT_SOLVEMAC(p, DIMS(p),dest0, DIMS(dest0),
     &                         source,DIMS(source), sigma, DIMS(sigma),
     &                         cen, DIMS(cen),
     $                         r,DIMS(r), w, DIMS(w),z, DIMS(z),
     &                         x, DIMS(x),lo, hi, h,
     $                         isPeriodic, maxiter, tol, abs_tol,max_jump,norm)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(p)
      integer DIMDEC(dest0)
      integer DIMDEC(source)
      integer DIMDEC(sigma)
      integer DIMDEC(cen)
      integer DIMDEC(r)
      integer DIMDEC(w)
      integer DIMDEC(z)
      integer DIMDEC(x)
      REAL_T      p(DIM1(p))
      REAL_T  dest0(DIM1(dest0))
      REAL_T source(DIM1(source))
      REAL_T  sigma(DIM1(sigma))
      REAL_T    cen(DIM1(cen))
      REAL_T      r(DIM1(r))
      REAL_T      w(DIM1(w))
      REAL_T      z(DIM1(z))
      REAL_T      x(DIM1(x))
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      REAL_T norm
      REAL_T tol
      integer maxiter
      REAL_T abs_tol,max_jump

c     Local variables
      integer i,iter
      integer istart,iend
      REAL_T alpha, beta, rho, rho_old
      REAL_T goal
      REAL_T norm0
      logical setSingularPoint

      istart = lo(1)
      iend = hi(1)

      setSingularPoint = .false.

      do i = lo(1)-1,hi(1)+1 
         dest0(i) = p(i)
         p(i) = zero
      enddo

      do i=ARG_L1(w),ARG_H1(w)
         w(i) = zero
      enddo

      call setmacbc(DIMS(dest0),dest0,lo,hi,isPeriodic,setSingularPoint)
      call makemacdgphi(dest0,DIMS(dest0),w,DIMS(w),sigma,DIMS(sigma),
     &               lo,hi,h,isPeriodic,setSingularPoint)

      do i = istart, iend 
         r(i) = source(i) - w(i)
      enddo
      
      rho = zero
      norm0 = zero
      do i = istart, iend 
         norm0 = max(norm0, abs(r(i)))
         z(i) = r(i) 
         rho = rho + z(i) * r(i)
      enddo
      norm = norm0
      
      goal = max(tol*norm0,abs_tol)
      
      if (norm0 .le. goal) then
         do i = istart, iend 
            p(i) = dest0(i)
         enddo
         return
      endif

      do i = istart, iend 
         x(i) = zero
         p(i) = z(i)
      enddo
      
      iter = 0
      
 100  continue
      
      do i=ARG_L1(w),ARG_H1(w)
         w(i) = zero
      enddo
      
      call setmacbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
      call makemacdgphi(p,DIMS(p),w,DIMS(w),sigma,DIMS(sigma),
     &     lo,hi,h,isPeriodic,setSingularPoint)
      
      alpha = zero
      do i = istart, iend 
         alpha = alpha + p(i)*w(i)
      enddo
      
      alpha = rho / alpha
      rho_old = rho
      rho = zero
      norm = zero
      do i = istart, iend 
         x(i) = x(i) + alpha * p(i)
         r(i) = r(i) - alpha * w(i)
         z(i) = r(i) 
         rho = rho + z(i) * r(i)
         norm = max(norm,abs(r(i)))
      enddo
      
      iter = iter+1
c      write(6,*) iter,norm

      if (iter .gt. maxiter .or. norm .gt. max_jump*norm0) then
         
         print *, "cg solve in mac failed to converge"
         do i = istart, iend 
            p(i) = x(i) + dest0(i)
         enddo
         call setmacbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
         
      else if (norm .lt. goal) then

         do i = istart, iend 
            p(i) = x(i) + dest0(i)
         enddo
         call setmacbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
         
      else

        beta = rho / rho_old
        do i = istart, iend 
           p(i) = z(i) + beta * p(i)
        enddo

        goto 100

      endif

      return
      end

      subroutine makemacdgphi(phi,DIMS(phi),dgphi,DIMS(dgphi),
     &                     beta,DIMS(beta),
     &                     lo,hi,h,isPeriodic,setSingularPoint)
      implicit none

      integer DIMDEC(phi)
      integer DIMDEC(dgphi)
      integer DIMDEC(beta)
      REAL_T phi(DIM1(phi))
      REAL_T dgphi(DIM1(dgphi))
      REAL_T beta(DIM1(beta))
      integer lo(SDIM),hi(SDIM)
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      logical setSingularPoint

      integer i,j
      REAL_T hxsqinv

      hxsqinv = one/(h(1)*h(1))

      do i = lo(1),hi(1) 
         dgphi(i) = DGX
      enddo

      end

c *************************************************************************
c ** COARSIGMA **
c ** Coarsen the edge-based sigma coefficients
c *************************************************************************

      subroutine FORT_COARSIGMA(sigma,DIMS(sigma),sigmac,DIMS(sigmac),
     &                          lo,hi,loc,hic)

      implicit none
      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(sigma)
      integer DIMDEC(sigmac)
      REAL_T  sigma(DIM1(sigma))
      REAL_T sigmac(DIM1(sigmac))

c     Local variables
      integer i,twoi

      do i = loc(1),hic(1)+1
        twoi = 2*(i-loc(1))+lo(1)
        sigmac(i) = sigma(twoi)
      enddo

      return
      end


c *************************************************************************
c ** RESTRICT **
c ** Conservatively average the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,DIMS(res),resc,DIMS(resc),
     &                         lo,hi,loc,hic)

      implicit none
      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(res)
      integer DIMDEC(resc)
      REAL_T  res(DIM1(res))
      REAL_T resc(DIM1(resc))

c     Local variables
      integer i,twoi

c ::: NOTE: dont need factor of r here for volume-weighting because
c ::: what were calling the residual is really already r*residual

        do i = loc(1),hic(1) 
          twoi = 2*(i-loc(1))+lo(1)
          resc(i) = half*(res(twoi) + res(twoi+1))
        enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise constant interpolation
c *************************************************************************

      subroutine FORT_INTERPOLATE(phi,DIMS(phi),deltac,DIMS(deltac),
     &                            lo,hi,loc,hic)

      implicit none
      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(phi)
      integer DIMDEC(deltac)
      REAL_T    phi(DIM1(phi))
      REAL_T deltac(DIM1(deltac))

c     Local variables
      integer i,twoi

      do i = loc(1), hic(1) 
         twoi = 2*(i-loc(1))+lo(1)
         phi(twoi  ) = phi(twoi  ) + deltac(i)
         phi(twoi+1) = phi(twoi+1) + deltac(i)
      enddo
      
      return
      end


c *************************************************************************
c ** MACPHIBC **
c *************************************************************************

      subroutine FORT_MACPHIBC(phi,length,divuExt,rhoExt,redge,hx,per)
c
c    Compute the value of phi for macproj to be used at an  outflow face,
c    assuming that the tangential velocity on the edges of the outflow boundary
c    are either zero or periodic.
c
      implicit none
      integer length
      integer r_len
      integer per
      REAL_T     phi(length)
      REAL_T divuExt(0:length-1)
      REAL_T  rhoExt(0:length-1)
      REAL_T   redge(0:length)
      REAL_T hx

c     Local variables
      integer NstripMAX
      parameter (NstripMAX = 2000)
      integer i, j, neq,n
      REAL_T a(NstripMAX), b(NstripMAX), c(NstripMAX), s(NstripMAX)
      REAL_T alpha, beta, sVal
      logical rNormed
      REAL_T vtot
      REAL_T rL, rR, diff
      REAL_T phitot
      REAL_T rcen
      integer ics, ice

c     This description assumes outflow at yhi; however, code works for 
c     outflow at any face.
c     NOTE: Assumes that rho at edge between i, i-1 = half*(rho(i)+rho(i-1))
c             (1) Linear fit of rho between nodes
c             (2) rho, divu on same boxes (box)
c             (3) phi is on box, shifted up one

c     Solve d/dx( 1/rho d/dx( phi ) ) = dU/dx - (S - S_ave) [S = divu] 
c     w/periodic or Neumann BC's, using a tridiagonal solve which detects, 
c     and deals with, the singular equations.  In the Neumann case, 
c     arbitrarily set the upper right corner to zero to pin the solution.  
c     Note that the RHS of this equation satisfies the solvability 
c     constraint that Int[RHS.dV] = 0 by construction.
c     This implies that the normal component takes up the slack:
c     
c                        d/dy( 1/rho d/dy( phi ) ) = dV/dy - S_ave
c     
c     This information should be used to construct the normal gradient of the
c     normal velocity, for the advective/diffusive step, for example.
c     In this implementation, use that d/dy == 0 at top, so y-edge centered 
c     values come directly from cell-centers just inside domain

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

      ics = 0
      ice = length-1
      neq = length

      if ( neq .gt. NStripMax ) then
         call bl_error( 'MACPHIBC: NStripMax too small' )
      end if

c     Carry out non-trivial solve.  First set interior equations, then do BC's
      do n = 2,neq-1
         i = n + ics - 1
         a(n)=two*redge(i  )/(rhoExt(i)+rhoExt(i-1))
         c(n)=two*redge(i+1)/(rhoExt(i)+rhoExt(i+1))
         b(n)=- a(n) - c(n)
         s(n)= -divuExt(i)
      end do
      
      if (per .eq. 1) then
         
c     Do left-side periodic BC (keep r in there to guarantee correct scaling)
         i = ics
         beta=two*redge(i  )/(rhoExt(i)+rhoExt(ice))
         c(1)=two*redge(i+1)/(rhoExt(i)+rhoExt(i+1))
         b(1)=- beta - c(1)
         s(1)= -divuExt(i)
         
c     Do right-side periodic
         i = ice
         a(neq)=two*redge(i  )/(rhoExt(i)+rhoExt(i-1))
         alpha =two*redge(i+1)/(rhoExt(i)+rhoExt(ics))
         b(neq)=- a(neq) - alpha
         s(neq)= -divuExt(i)
         
c     Solve the equations
         call cyclic(a,b,c,alpha,beta,s,phi,neq)
         
      else
c     Solid walls, Neumann conditions (dphi/dx=u=0)
         i = ics
         c(1) = two*redge(i+1)/(rhoExt(i)+rhoExt(i+1))
         b(1) = - c(1)
         s(1)=  -divuExt(i)
         
         i = ice
         a(neq) = two*redge(i)/(rhoExt(i)+rhoExt(i-1))
         b(neq) = - a(neq)
         s(neq)= -divuExt(i)

c     Solve the equations (we know they're singular, pass the arbitrary value,
c     and a flag that we've already normalized the rhs, in the sense that
c     Int[dU/dx - (S-S_ave)] == 0
         sVal = zero
         rNormed = .true.
         call tridag_sing(a,b,c,s,phi,neq,sVal,rNormed)
         
      end if
      
c     Try normalizing phi to average to zero
      phitot = zero
      vtot = zero
      do n = 1,neq
         rcen = half*(redge(ics+n) + redge(ics+n-1))
         phitot = phitot + phi(n)*rcen
         vtot = vtot + rcen
      end do
      phitot = phitot / vtot
      do n = 1,neq
         phi(n) = phi(n) - phitot
      end do

#undef XLO
#undef YLO
#undef XHI
#undef YHI
      end

c *************************************************************************
c ** MACFILL_ONED **
c *************************************************************************

      subroutine FORT_MACFILL_ONED(lenx,leny,length,faces,numOutFlowFaces,
     $                             cc0,cc1,cc2,cc3,
     $                             r0, r1, r2, r3 , conn, redge_conn)

      integer lenx,leny,length
      integer faces(4)
      integer numOutFlowFaces
      REAL_T cc0(leny,2)
      REAL_T cc1(lenx,2)
      REAL_T cc2(leny,2)
      REAL_T cc3(lenx,2)
      REAL_T conn(length,2)
      REAL_T r0(leny+1)
      REAL_T r1(lenx+1)
      REAL_T r2(leny+1)
      REAL_T r3(lenx+1)
      REAL_T redge_conn(length+1)

      integer xlo_outflow,ylo_outflow
      integer xhi_outflow,yhi_outflow
      integer i,ifinal,n
      REAL_T sum

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

c     Want to find the single non-outflow face.
      xlo_outflow = 0
      ylo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
      enddo

c     Possible combinations of faces to come in here:
c       cc0 cc1 cc2 cc3
c       XLO YLO 
c       XLO         YHI 
c           YLO XHI 
c           YLO     YHI 
c       XLO YLO XHI
c       XLO     XHI YHI
c       XLO YLO     YHI
c           YLO XHI YHI
c       XLO YLO XHI YHI

c     We must remember here that the cc* arrays have already been
c       ordered so that the 2nd dimension is one cell wide.

      ifinal = 0
      if (numOutFlowFaces .eq. 4 .or. 
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 0) ) then
          do i = 1,leny
            conn(i,1) = cc0(i,1)
            conn(i,2) = cc0(i,2)
          enddo
          do i = 1,leny+1
            redge_conn(i) = r0(i)
          enddo
          ifinal = leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    .not. (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
          do i = 1,lenx
            conn(ifinal+i,1) = cc3(i,1)
            conn(ifinal+i,2) = cc3(i,2)
          enddo
          do i = 1,lenx+1
            redge_conn(ifinal+i) = r3(i)
          enddo
          ifinal = ifinal + lenx
      endif

      if (xhi_outflow .eq. 1) then
          do i = 1,leny
            conn(ifinal+i,1) = cc2(leny+1-i,1)
            conn(ifinal+i,2) = cc2(leny+1-i,2)
          enddo
          do i = 1,leny+1
            redge_conn(ifinal+i) = r2(leny+2-i)
          enddo
          ifinal = ifinal + leny
      endif

      if (ylo_outflow .eq. 1) then
          do i = 1,lenx
            conn(ifinal+i,1) = cc1(lenx+1-i,1)
            conn(ifinal+i,2) = cc1(lenx+1-i,2)
          enddo
          do i = 1,lenx+1
            redge_conn(ifinal+i) = r1(lenx+2-i)
          enddo
          ifinal = ifinal + lenx
      endif

      if (numOutFlowFaces .lt. 4 .and.
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 1) ) then
          do i = 1,leny
            conn(ifinal+i,1) = cc0(i,1)
            conn(ifinal+i,2) = cc0(i,2)
          enddo
          do i = 1,leny+1
            redge_conn(ifinal+i) = r0(i)
          enddo
          ifinal = ifinal + leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
          do i = 1,lenx
            conn(ifinal+i,1) = cc3(i,1)
            conn(ifinal+i,2) = cc3(i,2)
          enddo
          do i = 1,lenx+1
            redge_conn(ifinal+i) = r3(i)
          enddo
          ifinal = ifinal + lenx
      endif

      length = ifinal
      sum = zero
      do i = 1,length
        sum = sum + conn(i,2)
      enddo

#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end

c *************************************************************************
c ** MACPHI_FROM_X **
c *************************************************************************

      subroutine FORT_MACPHI_FROM_X(DIMS(phi),phi,length,x)

      integer DIMDEC(phi)
      integer length
      REAL_T phi(DIMV(phi))
      REAL_T x(length)

      integer lenx, leny
      integer i,j

c     We know that the faces are ordered: XLO,XHI,YLO,YHI
      lenx = ARG_H1(phi)-ARG_L1(phi)
      leny = ARG_H2(phi)-ARG_L2(phi)

      if (lenx .eq. 0) then
        do j = 1,length
          phi(ARG_L1(phi),j-1) = x(j)
        enddo
      elseif (leny .eq. 0) then
        do i = 1,length
          phi(i-1,ARG_L2(phi)) = x(i)
        enddo
      endif

#undef XLO
#undef YLO
#undef XHI
#undef YHI

      end 

c *************************************************************************
c ** MACALLPHI_FROM_X **
c *************************************************************************

      subroutine FORT_MACALLPHI_FROM_X(lenx,leny,length,faces,numOutFlowFaces,
     $                                 phi0,phi1,phi2,phi3,x)

      integer lenx,leny,length
      integer numOutFlowFaces
      integer faces(4)
      REAL_T phi0(0:leny-1)
      REAL_T phi1(0:lenx-1)
      REAL_T phi2(0:leny-1)
      REAL_T phi3(0:lenx-1)
      REAL_T x(0:length-1)

      integer xlo_outflow,ylo_outflow
      integer xhi_outflow,yhi_outflow
      integer i,j,ifinal,n

#define XLO 0
#define YLO 1
#define XHI 2
#define YHI 3

c     Possible combinations of faces to come in here:
c       phi0 phi1 phi2 phi3
c       XLO  YLO 
c       XLO            YHI 
c            YLO  XHI 
c            YLO       YHI 
c       XLO  YLO  XHI
c       XLO       XHI  YHI
c       XLO  YLO       YHI
c            YLO  XHI  YHI
c       XLO  YLO  XHI  YHI

c     Want to find which are outflow faces.
      xlo_outflow = 0
      ylo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
      enddo

c     We know that the faces are ordered: XLO,XHI,YLO,YHI
      
      ifinal = 0

      if (numOutFlowFaces .eq. 4 .or. 
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 0) ) then
        do j = 0,leny-1
          phi0(j) = x(j)
        enddo
        ifinal = leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    .not. (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
        do i = 0,lenx-1
          phi3(i) = x(i+ifinal)
        enddo
        ifinal = ifinal+lenx
      endif

      if (xhi_outflow .eq. 1) then
        do j = 0,leny-1
          phi2(leny-1-j) = x(ifinal+j)
        enddo
        ifinal = ifinal+leny
      endif

      if (ylo_outflow .eq. 1) then
        if (numOutFlowFaces .eq. 4) then 
          do i = 0,lenx-1
            phi1(lenx-1-i) = x(ifinal+i)
          enddo
          phi1(0) = x(0)
        else
          do i = 0,lenx-1
            phi1(lenx-1-i) = x(ifinal+i)
          enddo
        endif
        ifinal = ifinal+lenx
      endif

      if (numOutFlowFaces .lt. 4 .and.
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 1) ) then
        do j = 0,leny-1
          phi0(j) = x(j+ifinal)
        enddo
        ifinal = ifinal+leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
        do i = 0,lenx-1
          phi3(i) = x(i+ifinal)
        enddo
        ifinal = ifinal+lenx
      endif

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: MG_3D.F,v 1.2 1998/12/14 20:23:47 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>
#include <CONSTANTS.H>
#include "MG_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
      subroutine FORT_AVERAGE (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc
     $     )
      integer nc
      integer DIMDEC(c)
      integer DIMDEC(f)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i, i2, i2p1
      integer j, j2, j2p1
      integer k, k2, k2p1
      integer n
      REAL_T denom
      parameter(denom=eighth)
c
      do n = 1, nc
         do k = lo(3), hi(3)
            k2 = 2*k
            k2p1 = k2 + 1
	    do j = lo(2), hi(2)
               j2 = 2*j
               j2p1 = j2 + 1
cdir$   ivdep
               do i = lo(1), hi(1)
                  i2 = 2*i
                  i2p1 = i2 + 1
c                  
                  c(i,j,k,n) =  (
     $                 + f(i2p1,j2p1,k2  ,n) + f(i2,j2p1,k2  ,n)
     $                 + f(i2p1,j2  ,k2  ,n) + f(i2,j2  ,k2  ,n)
     $                 + f(i2p1,j2p1,k2p1,n) + f(i2,j2p1,k2p1,n)
     $                 + f(i2p1,j2  ,k2p1,n) + f(i2,j2  ,k2p1,n)
     $                 )*denom
c
               end do
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_INTERP (
     $     f, DIMS(f),
     $     c, DIMS(c),
     $     lo, hi, nc
     $     )
      integer nc
      integer DIMDEC(f)
      integer DIMDEC(c)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i, i2, i2p1
      integer j, j2, j2p1
      integer k, k2, k2p1
      integer n
c
      do n = 1, nc
         do k = lo(3), hi(3)
            k2 = 2*k
            k2p1 = k2 + 1
	    do j = lo(2), hi(2)
               j2 = 2*j
               j2p1 = j2 + 1
cdir$   ivdep
               do i = lo(1), hi(1)
                  i2 = 2*i
                  i2p1 = i2 + 1
c
                  f(i2p1,j2p1,k2  ,n) = c(i,j,k,n) + f(i2p1,j2p1,k2  ,n)
                  f(i2  ,j2p1,k2  ,n) = c(i,j,k,n) + f(i2  ,j2p1,k2  ,n)
                  f(i2p1,j2  ,k2  ,n) = c(i,j,k,n) + f(i2p1,j2  ,k2  ,n)
                  f(i2  ,j2  ,k2  ,n) = c(i,j,k,n) + f(i2  ,j2  ,k2  ,n)
                  f(i2p1,j2p1,k2p1,n) = c(i,j,k,n) + f(i2p1,j2p1,k2p1,n)
                  f(i2  ,j2p1,k2p1,n) = c(i,j,k,n) + f(i2  ,j2p1,k2p1,n)
                  f(i2p1,j2  ,k2p1,n) = c(i,j,k,n) + f(i2p1,j2  ,k2p1,n)
                  f(i2  ,j2  ,k2p1,n) = c(i,j,k,n) + f(i2  ,j2  ,k2p1,n)
c
               end do
            end do
         end do
      end do
c
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: DERIVE_3D.F,v 1.2 1999/05/24 18:11:42 car Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "DERIVE_F.H"
#include "ArrayLim.H"
#include "integrator.fh"

#if defined(BL_USE_FLOAT) || defined(BL_T3E)
#define  BL_USE_FLOAT_CONST
#define  onetominussix 1.0e-6
#define  onetominusten 1.0e-10
#define  onetoten      1.0e+10
#define  onepointfour  1.4
#endif

#if defined(BL_USE_DOUBLE) && !defined(BL_T3E)
#define  BL_USE_DOUBLE_CONST
#define  onetominussix 1.0d-6
#define  onetominusten 1.0d-10
#define  onetoten      1.0d+10
#define  onepointfour  1.4d+00
#endif

#define SDIM 3      

c
c     A derived-quantity derivation routine that copies from input to output.
c
      subroutine FORT_DERCOPY (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     $                         lo,hi,domlo,domhi,delta,xlo,time,dt,bc,
     $                         level,gridno)
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp, level, gridno
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)

      integer    i,j,k,nc

      if (nv .ne. ncomp) then
         write(6,*) "FORT_DERCOPY: invalid call"
	 stop
      end if

      if ((e_l1 .ne. dat_l1) .or.
     $    (e_l2 .ne. dat_l2) .or.
     $    (e_l3 .ne. dat_l3) .or.
     $    (e_h1 .ne. dat_h1) .or.
     $    (e_h2 .ne. dat_h2) .or.
     $    (e_h3 .ne. dat_h3)) then
         write(6,*) "FORT_DERCOPY: invalid call"
	 stop
      end if

      do nc = 1, nv
         do k = e_l3, e_h3
            do j = e_l2, e_h2
               do i = e_l1, e_h1
                  e(i,j,k,nc) = dat(i,j,k,nc)
               enddo
            enddo
         enddo
      enddo

      end

c ::: -----------------------------------------------------------
c ::: This routine will derive log of given scalar quantity
c ::: 
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: e        <=  logden array (cell centered)
c ::: elo,ehi   => index extent of e array
c ::: nv        => number of components in e array (should be 1)
c ::: dat       => data neded to derive logden
c :::		   should be density 
c ::: dlo,dhi   => index limits of dat array
c ::: ncomp     => number of components of dat array (3)
c ::: lo,hi     => subrange of e array where result is requested
c ::: domlo,hi  => index extent of problem domain (cell centered)
c ::: delta     => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of e array
c ::: time      => problem evolution time
c ::: bc        => array of bndry types for component values
c :::              valid only if component touches bndry
c ::: -----------------------------------------------------------

      subroutine FORT_DERLOGS (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     $                         lo,hi,domlo,domhi,delta,xlo,time,dt,bc,
     $                         level,gridno)
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp, level, gridno
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)

      integer    i,j,k
      integer    nxlo, nxhi, nylo, nyhi, nzlo, nzhi
      REAL_T     rho
      REAL_T     sml

      parameter (sml = 1.0e-10)
c      
c::::: lets punt if not in domain interior
c
      nxlo = max(0,domlo(1)-lo(1))
      nxhi = max(0,hi(1)-domhi(1))
      nylo = max(0,domlo(2)-lo(2))
      nyhi = max(0,hi(2)-domhi(2))
      nzlo = max(0,domlo(3)-lo(3))
      nzhi = max(0,hi(3)-domhi(3))

      if (nxlo+nxhi+nylo+nyhi+nzlo+nzhi .gt. 0) then
         write(6,*) "FORT_DERLOGS: outside domain"
	 stop
      end if

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               rho = max(dat(i,j,k,1),sml)
               e(i,j,k,1) = log10(rho)
            enddo
         enddo
      enddo

      end

c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: derive velocity:  this routine will derive velocity
c :::                   from momentum
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: e        <=  velocity array (cell centered)
c ::: elo,ehi   => index extent of e array
c ::: nv        => number of components in e array (should be 1)
c ::: dat       => data neded to derive velocity
c ::: dlo,dhi   => index limits of dat array
c ::: ncomp     => number of components of dat array (2)
c ::: lo,hi     => subrange of e array where result is requested
c ::: domlo,hi  => index extent of problem domain (cell centered)
c ::: delta     => cell spacing
c ::: xlo       => physical location of lower left hand
c :::              corner of e array
c ::: time      => problem evolution time
c ::: bc        => array of bndry types for component values
c :::              valid only if component touches bndry
c ::: -----------------------------------------------------------
      subroutine FORT_DERVEL (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     $                        lo,hi,domlo,domhi,delta,xlo,time,dt,bc,
     $                        level,gridno)

      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp, level, gridno
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)

      integer i,j,k
      integer    nlft, nrgt, nbot, ntop,nfrnt, nbck
      REAL_T     u, v, w
c
c::::: lets punt if not in domain interior
c
      nlft = max(0,domlo(1)-lo(1))
      nrgt = max(0,hi(1)-domhi(1))
      nbot = max(0,domlo(2)-lo(2))
      ntop = max(0,hi(2)-domhi(2))
      nfrnt = max(0,domlo(3)-lo(3))
      nbck = max(0,hi(3)-domhi(3))

      if (nlft+nrgt+nbot+ntop+nfrnt+nbck .gt. 0) then
         write(6,*) "FORT_DERXVEL: outside domain"
         stop
      end if

      do k = lo(3),hi(3)
         do j = lo(2),hi(2)
            do i = lo(1),hi(1)
               e(i,j,k,1) = dat(i,j,k,2)/dat(i,j,k,1)
            end do
         end do
      end do

      end

c ::: ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c ::: this thing will derive pressure.  Calls eos.
c :::
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: e        <=  pressuree array (cell centered)
c ::: elo,ehi   => index extent of e array
c ::: nv        => number of components in e array (should be 1)
c ::: dat       => data neded to derive pressure
c ::: dlo,dhi   => index limits of dat array
c ::: ncomp     => number of components of dat array (4)
c ::: lo,hi     => subrange of e array where result is requested
c ::: domlo,hi  => index extent of problem domain (cell centered)
c ::: delta     => cell spacing
c ::: xlo       => physical location of lower left hand
c :::              corner of e array
c ::: time      => problem evolution time
c ::: bc        => array of bndry types for component values
c :::              valid only if component touches bndry
c ::: -----------------------------------------------------------

      subroutine FORT_DERPRES (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     $                         lo,hi,domlo,domhi,delta,xlo,time,dt,bc,
     $                         level,gridno)

      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp, level, gridno
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM), time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
c
c ::: local arrays
c
      REAL_T eint
      REAL_T cdum, gdum, csdum, rhomax, rhomin
c
c ::: local var
c
      integer i,j,k
      integer npts, ii, ist
      REAL_T rho, ux, uy,uz, pmax, pmin, bigp

#include "xxmeth.fh"

      smallp = onetominussix
      bigp = onetoten

      do k = lo(3),hi(3)
         do j = lo(2),hi(2)
            do i = lo(1), hi(1)
               rho = dat(i,j,k,1)
               ux = dat(i,j,k,2)/rho
               uy = dat(i,j,k,3)/rho
               uz = dat(i,j,k,4)/rho
               eint = (dat(i,j,k,5) - half*(ux**2+uy**2+uz**2))/rho
               e(i,j,k,2) = eint
               e(i,j,k,3) = rho
               e(i,j,k,4) = dat(i,j,k,6)/rho
            end do
         end do
      end do

      call eos(e(ARG_L1(e),ARG_L2(e),ARG_L3(e),3),
     $     e(ARG_L1(e),ARG_L2(e),ARG_L3(e),2),
     $     e(ARG_L1(e),ARG_L2(e),ARG_L3(e),4),
     $     DIMS(e),
     $     gdum,
     $     e(ARG_L1(e),ARG_L2(e),ARG_L3(e),1),
     $     cdum, csdum,
     $     DIMS(e),
     $     lo, hi, 0, 1, 0, 0)

      end

      subroutine eos(rho,eint,comp,DIMS(rho),gamc,p,c,csml,DIMS(c),
     $               lo,hi,lgamc,lp,lc,lcsml)

      integer lgamc, lp, lc, lcsml
      integer lo(3), hi(3)
      integer DIMDEC(rho)
      integer DIMDEC(c)
      REAL_T rho(DIMV(rho),1)
      REAL_T eint(DIMV(rho),1)
      REAL_T comp(DIMV(rho),1)
      REAL_T c(DIMV(c),1)
      REAL_T gamc(DIMV(c),1)
      REAL_T p(DIMV(c),1)
      REAL_T csml(DIMV(c),1)
      REAL_T pres, cc, psml
      integer j,k

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            call eosstrip(rho(lo(1),j,k,1),
     $                    eint(lo(1),j,k,1),
     $                    comp(lo(1),j,k,1),
     $                    gamc(lo(1),j,k,1),
     $                    p(lo(1),j,k,1),
     $                    c(lo(1),j,k,1),
     $                    csml(lo(1),j,k,1),
     $                    lo(1),hi(1),lgamc,lp,lc,lcsml,j,k)
         end do
      end do

      end

       subroutine eosstrip(rrr,eee,comp,gamiso,ppp,c,csml,nlo,nhi,
     &                lgamc,lp,lc,lcsml,jin,kin)

c :: 
c :: Inputs and Outpus
c :: rrr      => (const)  mass density
c :: eee      => (const)  internal energy per unit volume
c :: comp     => (const)  the volume fraction of HE 
c :: n        => (const)  size of all argument arrays
c :: nlo      => (const)  beginning location
c :: nhi      => (const)  end location
c :: gamiso  <=  (modify) sound speed gamma
c :: ppp     <=  (modify) pressure
c :: c       <=  (modify) sound speed
c :: csml    <=  (modify) sound speed floor
c :: lgamc    => (const)  =1 -> return gamiso
c :: lp       => (const)  =1 -> return pressure
c :: lc       => (const)  =1 -> return sound speed
c :: lcsml    => (const)  =1 -> return sound speed floor
 
c
c::::: dummy arguments
c
      integer    n, nlo, nhi
      integer    lgamc, lp, lc, lcsml
      REAL_T     rrr(nlo:nhi), eee(nlo:nhi), comp(nlo:nhi), ppp(nlo:nhi)
      REAL_T     gamiso(nlo:nhi), c(nlo:nhi), csml(nlo:nhi)
      REAL_T     comptmp

      integer    jin,kin
 
#include  "xxmeth.fh"
#include "probdata.H"
c 
c::::: local variables
c
      integer    k,npts
      REAL_T     ptmp,gamtmp,gamctmp

c::::: calculate gamma by linear interpolation.
c
      if (lgamc .eq. 1) then
         do k = nlo,nhi
            comptmp = max(min(comp(k),one),zero)
            gamiso(k) = one/(comptmp/gamcld+(one-comptmp)/gamamb)
         end do
      end if
c 
c::::: calculate presure in units of eee
c
      if (lp .eq. 1) then
         do k = nlo,nhi
            comptmp = max(min(comp(k),one),zero)
            gamtmp= one+one/(comptmp/(gamcld-one)+(one-comptmp)/(gamamb-one))
            ppp(k) = (gamtmp - one)*eee(k)*rrr(k)
         end do
      end if
 
      if (lcsml .eq. 1 .and. lc .ne. 1) then
         write(6,*) "EOS: cannot ask for csml without c"
	 stop
      end if

      if (lc .eq. 1) then
         if (lp .eq. 1 .and. lgamc .eq. 1) then
            do k = nlo,nhi
               c(k) = sqrt(gamiso(k)*abs(ppp(k))/max(rrr(k),smallr))
               c(k) = max(c(k),small)
            end do
	 else if (lp .eq. 1 .and. lgamc .ne. 1) then
c
c::::: have pressure but not gamiso 
c
            do k = nlo,nhi
               comptmp = max(min(comp(k),one),zero)
               gamtmp= one+one/(comptmp/(gamcld-one)+(one-comptmp)/(gamamb-one))
               c(k) = sqrt(gamtmp*abs(ppp(k))/max(rrr(k),smallr))
               c(k) = max(c(k),small)
            end do
	 else if (lgamc .eq. 1 .and. lp .ne. 1) then
c
c::::: have gamiso but not pressure	 
c
            do k = nlo,nhi
               comptmp = max(min(comp(k),one),zero)
               gamtmp= one+one/(comptmp/(gamcld-one)+(one-comptmp)/(gamamb-one))
               ptmp = (gamtmp - one)*eee(k)*rrr(k)
               c(k) = sqrt(gamiso(k)*abs(ptmp)/max(rrr(k),smallr))
               c(k) = max(c(k),small)
            end do
         else
            do k = nlo,nhi
               comptmp = max(min(comp(k),one),zero)
               gamtmp= one+one/(comptmp/(gamcld-one)+(one-comptmp)/(gamamb-one))
               ptmp = (gamtmp-one)*eee(k)*rrr(k)
               gamctmp = one/(comptmp/gamcld+(one-comptmp)/gamamb)
               c(k) = sqrt(gamctmp*abs(ptmp)/max(rrr(k),smallr))
               c(k) = max(c(k),small)
            end do
	 end if

	 if (lcsml .eq. 1) then
            do k = nlo,nhi
               csml(k) = max(small,small*c(k))
            end do
         end if
      end if

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROJOUTFLOWBC_F.H"
#include "ArrayLim.H"

#define SDIM 3

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
#define SMALL 1.0e-10
#define sixteenth  .0625e0
#else
#define SMALL 1.0d-10
#define sixteenth  .0625d0
#endif

      subroutine FORT_EXTRAP_PROJ(DIMS(u),u,DIMS(divu),divu,DIMS(rho),rho,
     &     DIMS(uExt),uExt,DIMS(divuExt),divuExt,
     &     DIMS(rhoExt),rhoExt,lo,hi,face, zeroIt)
      implicit none

c    compute divu_ave twice due to precision problems

      integer DIMDEC(u)
      integer DIMDEC(divu)
      integer DIMDEC(rho)
      integer DIMDEC(uExt)
      integer DIMDEC(divuExt)
      integer DIMDEC(rhoExt)
      integer face
      integer lo(SDIM),hi(SDIM)
      REAL_T      u(DIMV(u),SDIM)
      REAL_T   divu(DIMV(divu))
      REAL_T    rho(DIMV(rho))
      REAL_T   uExt(DIMV(uExt),SDIM-1)
      REAL_T   divuExt(DIMV(divuExt))
      REAL_T   rhoExt(DIMV(rhoExt))
      integer  zeroIt

c local variables
      integer ics,ice,jcs,jce,kcs,kce
      integer ife,jfe,kfe
      integer if,jf,kf
      REAL_T divu_ave1,divu_ave2
      REAL_T max_divu, min_divu
      REAL_T max_pert, small_pert
      parameter ( small_pert = SMALL)
      integer i,j,k

#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5

      ics = ARG_L1(u)
      ice = ARG_H1(u)
      jcs = ARG_L2(u)
      jce = ARG_H2(u)
      kcs = ARG_L3(u)
      kce = ARG_H3(u)

      ife = hi(1)
      jfe = hi(2)
      kfe = hi(3)

      zeroIt = 0

      if (face .eq. XLO) then
         if=ife
         max_divu = divu(ice-1,jcs,kcs)
         min_divu = max_divu
         do k = kcs, kce
         do j = jcs, jce
            uExt(j,k,if,1)  = half*(three*u(ice-1,j,k,2)   -  u(ice,j,k,2))
            uExt(j,k,if,2)  = half*(three*u(ice-1,j,k,3)   -  u(ice,j,k,3))
            divuExt(j,k,if) = half*(three*divu(ice-1,j,k)  - divu(ice,j,k))
            rhoExt(j,k,if)  = half*(three*rho(ice-1,j,k)   -  rho(ice,j,k))
            max_divu = max(max_divu,divuExt(j,k,if))
            min_divu = min(min_divu,divuExt(j,k,if))
         end do
         end do
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(jcs,kcs,if))
         do k = kcs, kce
         do j = jcs, jce
            max_pert = MAX(max_pert,ABS(divuExt(j,k,if)))
         end do
         end do
      else if (face .eq. YLO) then
         jf = jfe
         max_divu = divu(ics,jce-1,kcs)
         min_divu = max_divu
         do k = kcs, kce
         do i = ics, ice
            uExt(i,k,jf,1)    = half*(three*u(i,jce-1,k,1)    - u(i,jce,k,1))
            uExt(i,k,jf,2)    = half*(three*u(i,jce-1,k,3)    - u(i,jce,k,3))
            divuExt(i,k,jf) = half*(three*divu(i,jce-1,k) - divu(i,jce,k))
            rhoExt(i,k,jf)  = half*(three*rho(i,jce-1,k)    - rho(i,jce,k))
            max_divu = max(max_divu,divuExt(i,k,jf))
            min_divu = min(min_divu,divuExt(i,k,jf))
         end do
         end do
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,kcs,jf))
         do k = kcs, kce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,k,jf)))
         end do
         end do
      else if (face .eq. ZLO) then
         kf = kfe
         max_divu = divu(ics,jcs,kce-1)
         min_divu = max_divu
         do j = jcs, jce
         do i = ics, ice
            uExt(i,j,kf,1)    = half*(three*u(i,j,kce-1,2)    - u(i,j,kce,2))
            uExt(i,j,kf,2)    = half*(three*u(i,j,kce-1,3)    - u(i,j,kce,3))
            divuExt(i,j,kf) = half*(three*divu(i,j,kce-1) - divu(i,j,kce))
            rhoExt(i,j,kf)  = half*(three*rho(i,j,kce-1)    - rho(i,j,kce))
            max_divu = max(max_divu,divuExt(i,j,kf))
            min_divu = min(min_divu,divuExt(i,j,kf))
         end do
         end do
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jcs,kf))
         do j = jcs, jce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,j,kf)))
         end do
         end do
      else if (face .eq. XHI) then
         if = ife
         max_divu = divu(ics+1,jcs,kcs)
         min_divu = max_divu
         do k = kcs, kce
         do j = jcs, jce
            uExt(j,k,if,1)    = half*(three*u(ics+1,j,k,2)    - u(ics,j,k,2))
            uExt(j,k,if,2)    = half*(three*u(ics+1,j,k,3)    - u(ics,j,k,3))
            divuExt(j,k,if) = half*(three*divu(ics+1,j,k) - divu(ics,j,k))
            rhoExt(j,k,if)  = half*(three*rho(ics+1,j,k)    - rho(ics,j,k))
            max_divu = max(max_divu,divuExt(j,k,if))
            min_divu = min(min_divu,divuExt(j,k,if))
         end do
         end do
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(jcs,kcs,if))
         do k = kcs, kce
         do j = jcs, jce
            max_pert = MAX(max_pert,ABS(divuExt(j,k,if)))
         end do
         end do
      else if (face .eq. YHI) then
         jf = jfe
         max_divu = divu(ics,jcs+1,kcs)
         min_divu = max_divu
         do k = kcs, kce
         do i = ics, ice
            uExt(i,k,jf,1)    = half*(three*u(i,jcs+1,k,1)    - u(i,jcs,k,1))
            uExt(i,k,jf,2)    = half*(three*u(i,jcs+1,k,3)    - u(i,jcs,k,3))
            divuExt(i,k,jf) = half*(three*divu(i,jcs+1,k) - divu(i,jcs,k))
            rhoExt(i,k,jf)  = half*(three*rho(i,jcs+1,k)    - rho(i,jcs,k))
            max_divu = max(max_divu,divuExt(i,k,jf))
            min_divu = min(min_divu,divuExt(i,k,jf))
         end do
         end do
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,kcs,jf))
         do k = kcs, kce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,k,jf)))
         end do
         end do
      else if (face .eq. ZHI) then
         kf = kfe
         max_divu = divu(ics,jcs,kcs+1)
         min_divu = max_divu
         do j = jcs, jce
         do i = ics, ice
            uExt(i,j,kf,1)    = half*(three*u(i,j,kcs+1,1)    - u(i,j,kcs,1))
            uExt(i,j,kf,2)    = half*(three*u(i,j,kcs+1,2)    - u(i,j,kcs,2))
            divuExt(i,j,kf) = half*(three*divu(i,j,kcs+1) - divu(i,j,kcs))
            rhoExt(i,j,kf)  = half*(three*rho(i,j,kcs+1)    - rho(i,j,kcs))
            max_divu = max(max_divu,divuExt(i,j,kf))
            min_divu = min(min_divu,divuExt(i,j,kf))
         end do
         end do
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jcs,kf))
         do j = jcs, jce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,j,kf)))
         end do
         end do
      endif

c  check to see if we should zero phi
         max_pert = max_pert/(ABS(divu_ave1+divu_ave2)+small_pert)
      if ((max_divu.eq.zero.and.min_divu.eq.zero)
     &     .or.(max_pert.le.small_pert)) then
         zeroIt = 1
      end if
#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI
      end

      subroutine FORT_COMPUTE_COEFF(DIMS(rhs),rhs,DIMS(beta),beta,
     &                              DIMS(uExt),uExt,DIMS(divuExt),divuExt,
     &                              DIMS(rhoExt),rhoExt,
     &                              lo,hi,h,isPeriodic)
      implicit none
      integer DIMDEC(rhs)
      integer DIMDEC(beta)
      integer DIMDEC(uExt)
      integer DIMDEC(divuExt)
      integer DIMDEC(rhoExt)
      integer lo(SDIM),hi(SDIM)
      REAL_T uExt(DIM12(uExt),SDIM-1)
      REAL_T divuExt(DIM12(divuExt))
      REAL_T rhoExt(DIM12(rhoExt))
      REAL_T beta(DIM12(beta))
      REAL_T rhs(DIM12(rhs))
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)

      integer ics,ice,jcs,jce
      integer ins,ine,jns,jne
      integer i,j
      REAL_T hxm1,hym1

      ics = lo(1)
      ice = hi(1)
      jcs = lo(2)
      jce = hi(2)
      ins = ics
      jns = jcs
      ine = ice+1
      jne = jce+1

      hxm1 = one/h(1)
      hym1 = one/h(2)
      
      do j=jcs,jce
         do i=ics,ice
            beta(i,j) = one/rhoExt(i,j)
         enddo
      enddo

      do j=jns+1,jne-1
         do i=ins+1,ine-1
            rhs(i,j) = half*
     @           (hxm1 * (uExt(i,j-1,1) - uExt(i-1,j-1,1) +
     @                    uExt(i,j  ,1) - uExt(i-1,j  ,1)) +
     @            hym1 * (uExt(i-1,j,2) - uExt(i-1,j-1,2) +
     @                    uExt(i  ,j,2) - uExt(i,j-1  ,2))) 
     &           - fourth * ( divuExt(i-1,j  ) + divuExt(i-1,j-1) +
     &                        divuExt(i  ,j-1) + divuExt(i  ,j  ) ) 
         enddo
      enddo

      if (isPeriodic(1) .eq. 1) then
         do j=jcs,jce
            beta(ics-1,j) = beta(ice,j)
            beta(ice+1,j) = beta(ics,j)
         enddo 
         do j = jns+1,jne-1
            rhs(ins,j) = half*
     @           (hxm1 * (uExt(ics,j-1,1) - uExt(ice,j-1,1) +
     @                    uExt(ics,j  ,1) - uExt(ice,j,1  )) +
     @            hym1 * (uExt(ice,j  ,2) - uExt(ice,j-1,2) +
     @                    uExt(ics,j  ,2) - uExt(ics,j-1,2))) 
     &           - fourth * ( divuExt(ice,j  ) + divuExt(ice,j-1) +
     &                        divuExt(ics,j-1) + divuExt(ics  ,j  ) ) 

            rhs(ine,j) = rhs(ins,j)

            
         enddo
      else
         do j=jcs,jce
            beta(ics-1,j) = zero
            beta(ice+1,j) = zero
         enddo
         do j = jns+1,jne-1
            i = ins
            rhs(i,j) = half*
     @           (hxm1 * (uExt(i,j-1,1) + uExt(i,j  ,1) ) +
     @            hym1 * (uExt(i  ,j,2) - uExt(i,j-1,2))) 
     &           - fourth * (divuExt(i,j-1) + divuExt(i,j) ) 

            i = ine
            rhs(i,j) = half*
     @           (hxm1 * (- uExt(i-1,j-1,1) - uExt(i-1,j  ,1)) +
     @            hym1 * (  uExt(i-1,j  ,2) - uExt(i-1,j-1,2))) 
     &        - fourth * ( divuExt(i-1,j  ) + divuExt(i-1,j-1) ) 

         enddo
      endif

      if (isPeriodic(2) .eq. 1) then
         do i=ics,ice
            beta(i,jcs-1) = beta(i,jce)
            beta(i,jce+1) = beta(i,jcs)
         enddo
         do i = ins+1,ine-1
            rhs(i,jns) = half*
     @           (hxm1 * (uExt(i  ,jce,1) - uExt(i-1,jce,1) +
     @                    uExt(i  ,jcs,1) - uExt(i-1,jcs,1))+
     @            hym1 * (uExt(i-1,jcs,2) - uExt(i-1,jce,2) +
     @                    uExt(i  ,jcs,2) - uExt(i  ,jce,2))) 
     &           - fourth * ( divuExt(i-1,jcs) + divuExt(i-1,jce) +
     &                        divuExt(i  ,jce) + divuExt(i  ,jcs) ) 

            rhs(i,jne) = rhs(i,jns)
         enddo
      else
         do i=ics,ice
            beta(i,jcs-1) = zero
            beta(i,jce+1) = zero
         enddo
         do i = ins+1,ine-1
            j = jns
            rhs(i,j) = half*
     @           (hxm1 * (uExt(i,j  ,1) - uExt(i-1,j  ,1)) +
     @            hym1 * (uExt(i-1,j,2) + uExt(i  ,j,2) )) 
     &           - fourth * ( divuExt(i-1,j) + divuExt(i,j) )

            j = jne
            rhs(i,j) = half*
     @           (hxm1 * ( uExt(i  ,j-1,1) - uExt(i-1,j-1,1)) +
     @            hym1 * (-uExt(i-1,j-1,2) - uExt(i  ,j-1,2))) 
     &           - fourth * ( divuExt(i-1,j-1) + divuExt(i  ,j-1)) 
         enddo
      endif

      if (isPeriodic(1) .eq. 1 .AND. isPeriodic(2) .eq. 1) then

         beta(ics-1,jcs-1) = beta(ice,jce)
         beta(ics-1,jce+1) = beta(ice,jcs)
         beta(ice+1,jcs-1) = beta(ics,jce)
         beta(ice+1,jce+1) = beta(ics,jcs)

         rhs(ins,jns) = half*
     @        (hxm1 * (uExt(ics,jce,1) - uExt(ice,jce,1) +
     @                 uExt(ics,jcs,1) - uExt(ice,jcs,1)) +
     @         hym1 * (uExt(ice,jcs,2) - uExt(ice,jce,2) +
     @                 uExt(ics,jcs,2) - uExt(ics,jce,2))) 
     &        - fourth * (divuExt(ice,jcs) + divuExt(ice,jce) +
     &                    divuExt(ics,jce) + divuExt(ics,jcs) ) 

         rhs(ins,jne) = rhs(ins,jns) 
         rhs(ine,jns) = rhs(ins,jns) 
         rhs(ine,jne) = rhs(ins,jns) 

      else if (isPeriodic(1) .eq. 1 .AND. isPeriodic(2) .NE. 1) then

         beta(ics-1,jcs-1) = beta(ice,jcs-1)
         beta(ics-1,jce+1) = beta(ice,jce+1)
         beta(ice+1,jcs-1) = beta(ics,jcs-1)
         beta(ice+1,jce+1) = beta(ics,jce+1)

         rhs(ins,jns) = half*
     @        (hxm1 * (uExt(ics,jcs,1) - uExt(ice,jcs,1  )) +
     @         hym1 * (uExt(ice,jcs,2) + uExt(ics,jcs,2) )) 
     &        - fourth * ( divuExt(ice,jcs) + divuExt(ics,jcs) ) 
         
         rhs(ins,jne) = half*
     @        (hxm1 * (  uExt(ics,jce,1) - uExt(ice,jce,1) ) +
     @         hym1 * (- uExt(ice,jce,2) - uExt(ics,jce,2))) 
     &        - fourth * ( divuExt(ice,jce) + divuExt(ics,jce)) 
         
         rhs(ine,jns) = rhs(ins,jns)
         rhs(ine,jne) = rhs(ins,jne)

      else if (isPeriodic(1) .NE. 1 .AND. isPeriodic(2) .eq. 1) then

         beta(ics-1,jcs-1) = beta(ics-1,jce)
         beta(ics-1,jce+1) = beta(ics-1,jcs)
         beta(ice+1,jcs-1) = beta(ice+1,jce)
         beta(ice+1,jce+1) = beta(ice+1,jcs)

         rhs(ins,jns) = half*
     @        (hxm1 * (uExt(ics,jce,1) + uExt(ics,jcs,1))+
     @         hym1 * (uExt(ics,jcs,2) - uExt(ics,jce,2))) 
     &      - fourth * ( divuExt(ics,jce) + divuExt(ics,jcs) ) 
         
         rhs(ine,jns) = half*
     @        (hxm1 * (uExt(ice,jce,1) - uExt(ice,jcs,1))+
     @         hym1 * (uExt(ice,jcs,2) - uExt(ice,jce,2))) 
     &        - fourth * ( divuExt(ice,jcs) + divuExt(ice,jce)) 
         
         rhs(ins,jne) = rhs(ins,jns)
         rhs(ine,jne) = rhs(ine,jns)

      else

         beta(ics-1,jcs-1) = zero
         beta(ics-1,jce+1) = zero
         beta(ice+1,jcs-1) = zero
         beta(ice+1,jce+1) = zero

         i = ins
         j = jns
         rhs(i,j) = half* (hxm1 * (uExt(i,j,1) ) + hym1 * (uExt(i,j,2) )) 
     &        - fourth * ( divuExt(i,j) )

         
         i = ine
         j = jns
         rhs(i,j) = half* (hxm1 * (-uExt(i-1,j,1))+ hym1 * (uExt(i-1,j,2))) 
     &        - fourth * ( divuExt(i-1,j))
         
         i = ins
         j = jne
         rhs(i,j) = half* (hxm1 * (uExt(i,j-1,1) ) + hym1 * (-uExt(i,j-1,2))) 
     &        - fourth * (divuExt(i  ,j-1)) 

         i = ine
         j = jne
         rhs(i,j) = half*(hxm1 *(-uExt(i-1,j-1,1)) + hym1 *(-uExt(i-1,j-1,2))) 
     &        - fourth * ( divuExt(i-1,j-1)) 

      endif

c  double rhs at edges
      if (isPeriodic(1) .ne. 1) then
         do j=jns,jne
            rhs(ins,j) = rhs(ins,j) * two
            rhs(ine,j) = rhs(ine,j) * two
         enddo
      endif
      if (isPeriodic(2) .ne. 1) then
         do i = ins,ine
            rhs(i,jns) = rhs(i,jns) * two
            rhs(i,jne) = rhs(i,jne) * two
         enddo
      endif
 

      end

#define DGXY_5PT    half * (hxsqinv * \
           ((beta(i-1,j-1) + beta(i-1,j)) * (phi(i-1,j) - phi(i,j)) + \
            (beta(i  ,j-1) + beta(i  ,j)) * (phi(i+1,j) - phi(i,j))) + \
            hysqinv * \
           ((beta(i-1,j-1) + beta(i,j-1)) *(phi(i,j-1) - phi(i,j)) + \
            (beta(i-1,j  ) + beta(i,j  )) *(phi(i,j+1) - phi(i,j))))


      subroutine FORT_HGRELAX(DIMS(rhs),rhs,DIMS(beta),beta,DIMS(phi),phi,
     &                        DIMS(dgphi),dgphi,lo,hi,h,isPeriodic,niter)
      implicit none
      integer DIMDEC(beta)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      integer DIMDEC(dgphi)
      REAL_T beta(DIM12(beta))
      REAL_T rhs(DIM12(rhs))
      REAL_T phi(DIM12(phi))
      REAL_T dgphi(DIM12(dgphi))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)
      integer niter

      logical setSingularPoint
      REAL_T lam
      integer i,j
      integer redblack,iter
      integer ins,ine,jns,jne
      REAL_T hxsqinv, hysqinv
      integer iinc

      ins = lo(1)
      ine = hi(1)+1
      jns = lo(2)
      jne = hi(2)+1
      hxsqinv = one/(h(1)*h(1))
      hysqinv = one/(h(2)*h(2))

      if (h(2). gt. 1.5D0*h(1)) then
         call bl_abort("line solve for proj_bc not yet implemented")
      elseif (h(1) .gt. 1.5D0*h(2)) then
         call bl_abort("line solve for proj_bc not yet implemented")
      endif
      
      setSingularPoint = .false.

      do iter = 1,niter
         call setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
         do redblack = 0,1
            do j=jns,jne
               iinc = mod(j+redblack,2)
               do i=ins+iinc,ine,2

                  dgphi(i,j) = DGXY_5PT
                  lam =  (hxsqinv +hysqinv) * (beta(i-1,j-1) + beta(i-1,j) +
     @                              beta(i  ,j-1) + beta(i  ,j))
c double dgphi at edges
                  if ((i .eq. lo(1) .or. i .eq. hi(1)+1) 
     &                 .and. isPeriodic(1) .ne. 1) then
                     dgphi(i,j) = dgphi(i,j)*two
                     lam = lam* two
                  endif
                  if ((j .eq. lo(2) .or. j .eq. hi(2)+1) 
     &                 .and. isPeriodic(2) .ne. 1) then
                     dgphi(i,j) = dgphi(i,j)*two
                     lam = lam*two
                  endif
                  lam =  -two/lam
                  phi(i,j) = phi(i,j) + lam*(rhs(i,j)-dgphi(i,j))
               enddo
            enddo
         end do
      end do

      call setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)

      end
      
      subroutine FORT_HGSUBTRACTAVGPHI(DIMS(phi),phi,lo,hi,isPeriodic)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM12(phi))
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)

      REAL_T phitot,vtot
      integer ins,ine,jns,jne
      integer i,j
      logical setSingularPoint

      phitot = zero
      vtot = zero
      ins = lo(1)
      ine = hi(1)+1
      jns = lo(2)
      jne = hi(2)+1
      setSingularPoint = .false.

      do j = jns,jne
         do i = ins,ine
            phitot = phitot + phi(i,j) 
            vtot   = vtot + one
         enddo
      enddo
      phitot = phitot/vtot
      do j = jns,jne
         do i = ins,ine
            phi(i,j) = phi(i,j) - phitot
         enddo
      enddo

      call setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
   
      end

      subroutine FORT_HGRESID(DIMS(rhs),rhs,DIMS(beta),beta,DIMS(phi),phi,
     &                   DIMS(resid),resid,DIMS(dgphi),dgphi,
     &                   lo,hi,h,isPeriodic,maxnorm)

      integer DIMDEC(beta)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      integer DIMDEC(resid)
      integer DIMDEC(dgphi)
      REAL_T beta(DIM12(beta))
      REAL_T rhs(DIM12(rhs))
      REAL_T phi(DIM12(phi))
      REAL_T resid(DIM12(resid))
      REAL_T dgphi(DIM12(dgphi))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)
      REAL_T hxsqinv,hysqinv
      
      integer i,j
      REAL_T maxnorm
      logical setSingularPoint

      hxsqinv = one/(h(1)*h(1))
      hysqinv = one/(h(2)*h(2))
      setSingularPoint = .false.
      maxnorm = zero

      call makeprojdgphi(phi,DIMS(phi),dgphi,DIMS(dgphi),beta,DIMS(beta),
     &                   lo,hi,h,isPeriodic,setSingularPoint)
      do j=lo(2),hi(2)+1
        do i=lo(1),hi(1)+1
           resid(i,j) = rhs(i,j)-dgphi(i,j)
           maxnorm = max(maxnorm,ABS(resid(i,j)))         
        enddo
      enddo
      end

      subroutine setprojbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM12(phi))
      integer isPeriodic(SDIM)
      logical setSingularPoint
      integer lo(SDIM),hi(SDIM)

      integer ins,ine,jns,jne
      integer i,j
    
      ins = lo(1)
      ine = hi(1)+1
      jns = lo(2)
      jne = hi(2)+1


      if (isPeriodic(1) .NE. 1 .AND. isPeriodic(2) .NE. 1 
     &     .AND. setSingularPoint) then
         phi(ine,jne) = zero
      endif

      if (isPeriodic(1) .eq. 1) then
         do j= jns,jne
            phi(ins-1,j) = phi(ine-1,j)
            phi(ine,j)   = phi(ins,j)
            phi(ine+1,j) = phi(ins+1,j)
         enddo
      else
         do j= jns,jne
            phi(ins-1,j) = phi(ins+1,j)
            phi(ine+1,j) = phi(ine-1,j)
         enddo
      endif

      if (isPeriodic(2) .eq. 1) then
         do i= ins,ine
            phi(i,jns-1) = phi(i,jne-1)
            phi(i,jne)   = phi(i,jns)
            phi(i,jne+1) = phi(i,jns+1)
         enddo
      else
         do i= ins,ine
            phi(i,jns-1) = phi(i,jns+1)
            phi(i,jne+1) = phi(i,jne-1)
         enddo
      endif

      end

      subroutine FORT_HG_SHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j,k
#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5
      if (face .eq. XLO .or. face .eq. XHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(k,i,j)
               enddo
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(i,k,j)
               enddo
            enddo
         enddo
      else if (face .eq. ZLO .or. face .eq. ZHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(i,j,k)
               enddo
            enddo
         enddo
      endif

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI
      end

      subroutine FORT_HG_RESHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j,k
#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5
      if (face .eq. XLO .or. face .eq. XHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               out(ARG_L1(out),j,k) = in(j,k,ARG_L3(in))
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,ARG_L2(out),k) = in(i,k,ARG_L3(in))
            enddo
         enddo
      else if (face .eq. ZLO .or. face .eq. ZHI) then
         do j= ARG_L2(out),ARG_H2(out)
            do i = ARG_L1(out),ARG_H1(out)
               out(i,j,ARG_L3(out)) = in(i,j,ARG_L3(in))
            enddo
         enddo
      endif

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI

      end

      
      subroutine FORT_SOLVEHG(p,DIMS(p),dest0,DIMS(dest0),
     &     source,DIMS(source),sigma,DIMS(sigma),
     &     cen,DIMS(cen),r,DIMS(r),w,DIMS(w),
     &     z,DIMS(z),x,DIMS(x),
     $     lo,hi,h,isPeriodic,maxiter,tol,abs_tol,max_jump,norm)
      
      implicit none

      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(p)
      integer DIMDEC(dest0)
      integer DIMDEC(source)
      integer DIMDEC(sigma)
      integer DIMDEC(r)
      integer DIMDEC(w)
      integer DIMDEC(z)
      integer DIMDEC(x)
      integer DIMDEC(cen)
      REAL_T   p(DIM12(p))
      REAL_T  dest0(DIM12(dest0))
      REAL_T source(DIM12(source))
      REAL_T  sigma(DIM12(sigma))
      REAL_T      r(DIM12(r))
      REAL_T      w(DIM12(w))
      REAL_T      z(DIM12(z))
      REAL_T      x(DIM12(x))
      REAL_T      cen(DIM12(cen))
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      integer maxiter
      REAL_T norm
      REAL_T tol
      REAL_T abs_tol,max_jump

c     Local variables
      REAL_T factor
      REAL_T  alpha,beta, rho, rho_old
      logical testx,testy
      integer i,j,iter
      integer istart,iend,jstart,jend
      REAL_T norm0,goal
      logical setSingularPoint

      istart = lo(1)
      iend = hi(1)+1
      jstart = lo(2)
      jend = hi(2)+1
      
      setSingularPoint = .false.

      do j = lo(2)-1,hi(2)+2
         do i = lo(1)-1,hi(1)+2
            dest0(i,j) = p(i,j)
            p(i,j) = zero
         enddo
      enddo

      do j=ARG_L2(w),ARG_H2(w)
         do i=ARG_L1(w),ARG_H1(w)
            w(i,j) = zero
         enddo
      enddo

      call setprojbc(DIMS(dest0),dest0,lo,hi,isPeriodic,setSingularPoint)
      call makeprojdgphi(dest0,DIMS(dest0),w,DIMS(w),sigma,DIMS(sigma),
     &        lo,hi,h,isPeriodic,setSingularPoint)

      do j = jstart, jend 
        do i = istart, iend 
          r(i,j) = source(i,j) - w(i,j)
        enddo
      enddo

c note that all of this factor stuff is due to the problem being doubled
c at edges -- both the rhs and the operator.
      rho = zero
      norm0 = zero
      do j = jstart, jend 
         do i = istart, iend
            factor = one
            testx  = (i .eq. lo(1) .or. i .eq. hi(1)+1)
            testy  = (j .eq. lo(2) .or. j .eq. hi(2)+1)
            factor = cvmgt(factor*half,factor,testx)
            factor = cvmgt(factor*half,factor,testy)
            z(i,j) = r(i,j) 
            rho    = rho + factor * z(i,j) * r(i,j) 
            norm0 = max(norm0,abs(r(i,j)))
         enddo
      enddo
      norm = norm0

      goal = max(tol * norm0,abs_tol)

      if (norm0 .le. goal) then
         do j = jstart, jend
            do i = istart, iend 
               p(i,j) = dest0(i,j)
            enddo
         enddo
         return
      endif
      
      do j = jstart, jend 
        do i = istart, iend 
          x(i,j) = zero
          p(i,j) = z(i,j)
        enddo
      enddo

      iter  = 0

100   continue  

      do j=ARG_L2(w),ARG_H2(w)
         do i=ARG_L1(w),ARG_H1(w)
            w(i,j) = zero
         enddo
      enddo

      call setprojbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
      call makeprojdgphi(p,DIMS(p),w,DIMS(w),sigma,DIMS(sigma),
     &      lo,hi,h,isPeriodic,setSingularPoint)

      alpha = zero
      do j = jstart, jend 
        do i = istart, iend 
            factor = one
            testx  = (i .eq. lo(1) .or. i .eq. hi(1)+1)
            testy  = (j .eq. lo(2) .or. j .eq. hi(2)+1)
            factor = cvmgt(factor*half,factor,testx)
            factor = cvmgt(factor*half,factor,testy)
            alpha  = alpha + factor*p(i,j)*w(i,j) 
        enddo
      enddo

      if (alpha .ne. zero) then
         alpha = rho / alpha
      else
         print *, "divide by zero"
         goto 101
      endif
         
      rho_old  = rho
      rho   = zero
      norm = zero
      do j = jstart, jend 
         do i = istart, iend 
            factor = one
            testx  = (i .eq. lo(1) .or. i .eq. hi(1)+1)
            testy  = (j .eq. lo(2) .or. j .eq. hi(2)+1)
            factor = cvmgt(factor*half,factor,testx)
            factor = cvmgt(factor*half,factor,testy)
            x(i,j) = x(i,j) + alpha * p(i,j)
            r(i,j) = r(i,j) - alpha * w(i,j)
            z(i,j) = r(i,j) 
            rho    = rho + factor * z(i,j) * r(i,j) 
            norm = max(norm,abs(r(i,j)))
         enddo
      enddo

      iter = iter+1
c      write(6,*) iter,norm

      if (iter .gt. maxiter .or. norm .gt. max_jump*norm0) then

         goto 101

      else if (norm .lt. goal) then

         do j = jstart, jend 
            do i = istart, iend 
               p(i,j) = x(i,j) + dest0(i,j)
            enddo
         enddo
         
         return

      else
         
        beta = rho / rho_old
        do j = jstart, jend 
          do i = istart, iend 
            p(i,j) = z(i,j) + beta * p(i,j)
          enddo
        enddo

        goto 100

      endif

 101  print *, "cg solve in proj failed to coverge"
      do j = jstart, jend 
         do i = istart, iend 
            p(i,j) = dest0(i,j)
         enddo
      enddo
      
      return
      end

      subroutine makeprojdgphi(phi,DIMS(phi),dgphi,DIMS(dgphi),
     &                     beta,DIMS(beta),
     &                     lo,hi,h,isPeriodic,setSingularPoint)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(phi)
      integer DIMDEC(dgphi)
      integer DIMDEC(beta)
      REAL_T    phi(DIM12(phi))
      REAL_T  dgphi(DIM12(dgphi))
      REAL_T  beta(DIM12(beta))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      logical setSingularPoint

c     Local variables
      REAL_T hxsqinv, hysqinv
      integer is,ie,js,je
      integer i,j

      is = lo(1)
      js = lo(2)
      ie = hi(1)
      je = hi(2)

      hxsqinv = one/(h(1)*h(1))
      hysqinv = one/(h(2)*h(2))
      
      if (isPeriodic(1) .eq. 1) then
        do j = js,je+1 
          phi(ie+2,j) = phi(is+1,j)
          phi(is-1,j) = phi(ie  ,j)
        enddo
      endif

      if (isPeriodic(2) .eq. 1) then
        do i = is,ie+1 
          phi(i,je+2) = phi(i,js+1)
          phi(i,js-1) = phi(i,je  )
        enddo
      endif

      if (isPeriodic(1) .eq. 1 .and. isPeriodic(2) .eq. 1) then
        phi(is-1,js-1) = phi(ie  ,je  )
        phi(is-1,je+2) = phi(ie  ,js+1)
        phi(ie+2,js-1) = phi(is+1,je  )
        phi(ie+2,je+2) = phi(is+1,js+1)
      endif    

      do j = js,je+1
        do i = is,ie+1
           dgphi(i,j) = DGXY_5PT
        enddo
      enddo

c double dgphi at edges
      if (isPeriodic(1) .ne. 1) then
         do j=js,je+1
            dgphi(is,j) = dgphi(is,j) * two
            dgphi(ie+1,j) = dgphi(ie+1,j) * two
         enddo
      endif
      if (isPeriodic(2) .ne. 1) then
         do i = is,ie+1
            dgphi(i,js) = dgphi(i,js) * two
            dgphi(i,je+1) = dgphi(i,je+1) * two
         enddo
      endif

      if (setSingularPoint .and. 
     &     isPeriodic(1) .NE. 1 .and. isPeriodic(2) .NE. 1) then
         dgphi(hi(1)+1,hi(2)+1) = zero
      endif

      return
      end


c *************************************************************************
c ** COARSIG **
c ** Coarsening of the sig coefficients
c *************************************************************************

      subroutine FORT_COARSIG(sigma,DIMS(sigma),sigmac,DIMS(sigmac),
     &                        lo,hi,loc,hic,isPeriodic)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(sigma)
      integer DIMDEC(sigmac)
      REAL_T  sigma(DIM12(sigma))
      REAL_T sigmac(DIM12(sigmac))
      integer isPeriodic(SDIM)

c     Local variables
      integer i ,j
      integer i2,j2

      do j = loc(2),hic(2) 
        do i = loc(1),hic(1) 
          i2 = 2*(i-loc(1))+lo(1)
          j2 = 2*(j-loc(2))+lo(2)
          sigmac(i,j) = (sigma(i2  ,j2) + sigma(i2  ,j2+1)+ 
     $                   sigma(i2+1,j2) + sigma(i2+1,j2+1))*fourth
        enddo
      enddo

      if (isPeriodic(1) .eq. 1) then
         
         do j = loc(2)-1,hic(2)+1 
            sigmac(loc(1)-1,j) = sigmac(hic(1),j)
            sigmac(hic(1)+1,j) = sigmac(loc(1),j)
         enddo
      else
         do j = loc(2)-1,hic(2)+1
            sigmac(loc(1)-1,j) = zero
            sigmac(hic(1)+1,j) = zero
         enddo
      endif

      if (isPeriodic(2) .eq. 1) then
         
         do i = loc(1)-1,hic(1)+1 
            sigmac(i,loc(2)-1) = sigmac(i,hic(2))
            sigmac(i,hic(2)+1) = sigmac(i,loc(2))
         enddo
      else
         do i = loc(1)-1,hic(1)+1
            sigmac(i,loc(2)-1) = zero
            sigmac(i,hic(2)+1) = zero
         enddo
         
      endif

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,DIMS(res),resc,DIMS(resc),
     &                        lo,hi,loc,hic,isPeriodic)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(res)
      integer DIMDEC(resc)
      REAL_T   res(DIM12(res))
      REAL_T  resc(DIM12(resc))
      integer isPeriodic(SDIM)

c     Local variables
      integer i,j,ii,jj
      integer istart,iend
      integer jstart,jend

      istart = loc(1)
      iend = hic(1)+1
      jstart = loc(2)
      jend = hic(2)+1
      
      if (isPeriodic(1) .eq. 1) then
        do j = lo(2)-1,hi(2)+2
          res(hi(1)+1,j) = res(lo(1)  ,j)
          res(hi(1)+2,j) = res(lo(1)+1,j)
          res(lo(1)-1,j) = res(hi(1)  ,j)
        enddo
      endif

      if (isPeriodic(2) .eq. 1) then
        do i = lo(1)-1,hi(1)+2
          res(i,hi(2)+1) = res(i,lo(2)  )
          res(i,hi(2)+2) = res(i,lo(2)+1)
          res(i,lo(2)-1) = res(i,hi(2)  )
        enddo
      endif

      do j = jstart,jend
        do i = istart,iend

          ii = 2*(i-loc(1))+lo(1)
          jj = 2*(j-loc(2))+lo(2)

          resc(i,j) = fourth*res(ii  ,jj) + 
     $               eighth*(res(ii+1,jj  ) + res(ii-1,jj  ) + 
     $                       res(ii  ,jj+1) + res(ii  ,jj-1) ) +
     $            sixteenth*(res(ii+1,jj+1) + res(ii+1,jj-1) + 
     $                       res(ii-1,jj+1) + res(ii-1,jj-1) )
        enddo
      enddo

c  the top version is what we use when we double the problem at edges
c  the bottom version (commented out) is what we would use if we did not 
c      double the problem at edges.
      if (isPeriodic(1) .NE. 1) then
        i = loc(1)
        ii = 2*(i-loc(1))+lo(1)

        do j = jstart,jend
          jj = 2*(j-loc(2))+lo(2)
          resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  )) + 
     $                eighth*(res(ii,jj-1) + res(ii+1,jj-1)+
     $                        res(ii,jj+1) + res(ii+1,jj+1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii+1,jj  ) + 
cnd     $                       res(ii  ,jj+1) + res(ii  ,jj-1) ) +
cnd     $            sixteenth*(res(ii+1,jj+1) + res(ii+1,jj-1))
        enddo

        i = hic(1)+1
        ii = 2*(i-loc(1))+lo(1)

        do j = jstart,jend
          jj = 2*(j-loc(2))+lo(2)
          resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  )) + 
     $                eighth*(res(ii,jj-1) + res(ii-1,jj-1)+
     $                        res(ii,jj+1) + res(ii-1,jj+1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii-1,jj  ) + 
cnd     $                       res(ii  ,jj+1) + res(ii  ,jj-1) ) +
cnd     $            sixteenth*(res(ii-1,jj+1) + res(ii-1,jj-1) )
        enddo


      endif

      if (isPeriodic(2) .NE. 1) then
        j = loc(2)
        jj = 2*(j-loc(2))+lo(2)

        do i = istart,iend
          ii = 2*(i-loc(1))+lo(1)
          resc(i,j) = fourth*(res(ii  ,jj) + res(ii  ,jj+1)) + 
     $                eighth*(res(ii+1,jj) + res(ii+1,jj+1)+
     $                        res(ii-1,jj) + res(ii-1,jj+1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii+1,jj  ) + res(ii-1,jj  ) + 
cnd     $                       res(ii  ,jj+1)) +
cnd     $            sixteenth*(res(ii+1,jj+1) + res(ii-1,jj+1))
        enddo

        j = hic(2)+1
        jj = 2*(j-loc(2))+lo(2)

        do i = istart,iend
          ii = 2*(i-loc(1))+lo(1)
          resc(i,j) = fourth*(res(ii  ,jj) + res(ii  ,jj-1)) + 
     $                eighth*(res(ii+1,jj) + res(ii+1,jj-1)+
     $                        res(ii-1,jj) + res(ii-1,jj-1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii+1,jj  ) + res(ii-1,jj  ) + 
cnd     $                       res(ii  ,jj-1) ) +
cnd     $            sixteenth*(res(ii+1,jj-1) + res(ii-1,jj-1) )
        enddo
      endif

      if ( isPeriodic(1) .NE. 1 .and. isPeriodic(2) .NE. 1 ) then
        i = loc(1)
        j = loc(2)
        ii = 2*(i-loc(1))+lo(1)
        jj = 2*(j-loc(2))+lo(2)
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  ) +
     $                      res(ii,jj+1) + res(ii+1,jj+1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii+1,jj  ) + res(ii  ,jj+1)) +
cnd     $            sixteenth*(res(ii+1,jj+1))

        i = hic(1)+1
        j = hic(2)+1
        ii = 2*(i-loc(1))+lo(1)
        jj = 2*(j-loc(2))+lo(2)
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  ) +
     $                      res(ii,jj-1) + res(ii-1,jj-1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii-1,jj  ) + res(ii  ,jj-1) ) +
cnd     $            sixteenth*(res(ii-1,jj-1) )

        i = loc(1)
        j = hic(2)+1
        ii = 2*(i-loc(1))+lo(1)
        jj = 2*(j-loc(2))+lo(2)

        resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  ) +
     $                      res(ii,jj-1) + res(ii+1,jj-1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii+1,jj  ) + res(ii  ,jj-1) ) +
cnd     $            sixteenth*(res(ii+1,jj-1) )

        i = hic(1)+1
        j = loc(2)
        ii = 2*(i-loc(1))+lo(1)
        jj = 2*(j-loc(2))+lo(2)

        resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  ) +
     $                      res(ii,jj+1) + res(ii-1,jj+1) )
cnd          resc(i,j) = fourth*res(ii  ,jj) + 
cnd     $               eighth*(res(ii-1,jj  ) + res(ii  ,jj+1)) +
cnd     $            sixteenth*(res(ii-1,jj+1))

      endif

      return
      end


c *************************************************************************
c ** INTERP **
c ** Simple bilinear interpolation
c *************************************************************************

      subroutine FORT_INTERP(phi,DIMS(phi),temp,DIMS(temp),deltac,DIMS(deltac),
     &                       sigma,DIMS(sigma),lo,hi,loc,hic,isPeriodic)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(phi)
      integer DIMDEC(deltac)
      integer DIMDEC(sigma)
      integer DIMDEC(temp)
      REAL_T     phi(DIM12(phi))
      REAL_T  deltac(DIM12(deltac))
      REAL_T  sigma(DIM12(sigma))
      REAL_T   temp(DIM12(temp))
      integer isPeriodic(SDIM)

c     Local variables
      integer ii,jj,ic,jc
      integer is,ie,js,je,isc,iec,jsc,jec
      logical setSingularPoint

      is = lo(1)
      js = lo(2)
      ie = hi(1)
      je = hi(2)

      isc = loc(1)
      jsc = loc(2)
      iec = hic(1)
      jec = hic(2)

      do jc = jsc, jec+1 
        do ic = isc, iec+1
          ii = 2*(ic-isc)+is
          jj = 2*(jc-jsc)+js
          temp(ii,jj) = deltac(ic,jc)
        enddo
      enddo
      do jc = jsc, jec
        do ic = isc, iec+1
          ii = 2*(ic-isc)+is
          jj = 2*(jc-jsc)+js
          temp(ii,jj+1) = half*(deltac(ic,jc) + deltac(ic,jc+1)) 
        enddo
      enddo
      do jc = jsc, jec+1 
        do ic = isc, iec
          ii = 2*(ic-isc)+is
          jj = 2*(jc-jsc)+js
          temp(ii+1,jj) = half*(deltac(ic,jc) + deltac(ic+1,jc))
        enddo
      enddo
      do jc = jsc, jec 
        do ic = isc, iec 
          ii = 2*(ic-isc)+is
          jj = 2*(jc-jsc)+js
          temp(ii+1,jj+1) = fourth*(deltac(ic,jc  ) + deltac(ic+1,jc  ) + 
     $                             deltac(ic,jc+1) + deltac(ic+1,jc+1) )
        enddo
      enddo

      do jj=js,je+1
         do ii = is,ie+1
            phi(ii,jj) = phi(ii,jj) + temp(ii,jj)
         enddo
      enddo

      return
      end

      subroutine FORT_RHOGBC(rho,DIMS(rho),phi,DIMS(phi),
     &                       face,gravity,dx)
c
c    Compute the contribution of gravity to the boundary conditions
c      for phi at outflow faces only.
c
      implicit none

      integer DIMDEC(rho)
      integer DIMDEC(phi)
      integer face
      REAL_T  rho(DIMV(rho))
      REAL_T  phi(DIMV(phi))
      REAL_T  dx(3)
      REAL_T  gravity
      
c     Local variables
      integer i,j,k
      REAL_T rhog
      REAL_T rho_i,rho_ip1,rho_im1
      REAL_T rho_j,rho_jp1,rho_jm1
      REAL_T rhoExt
      
#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5

      if (face .eq. ZLO .or. face .eq. ZHI) 
     $   call bl_abort('SHOULDNT BE IN RHOGBC WITH FACE IN Y-DIR')

c     Ok to only use low index of phi because phi is only one
c        node wide in direction of face.

      if (face .eq. XLO) then

        i = ARG_L1(phi)

        j = ARG_L2(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_i   = half * (three*rho(i  ,j,k) - rho(i  ,j+1,k))
          rho_ip1 = half * (three*rho(i+1,j,k) - rho(i+1,j+1,k))
          rhoExt  = half * (three*rho_i - rho_ip1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        j = ARG_H2(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_i   = half * (three*rho(i  ,j-1,k) - rho(i  ,j-2,k))
          rho_ip1 = half * (three*rho(i+1,j-1,k) - rho(i+1,j-2,k))
          rhoExt  = half * (three*rho_i - rho_ip1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        do j = ARG_L2(phi)+1,ARG_H2(phi)-1
          rhog = zero
          do k = ARG_H3(phi)-1,ARG_L3(phi),-1
            rho_i   = half * (rho(i  ,j,k) + rho(i  ,j-1,k))
            rho_ip1 = half * (rho(i+1,j,k) + rho(i+1,j-1,k))
            rhoExt  = half * (three*rho_i - rho_ip1 )
            rhog = rhog + gravity * rhoExt * dx(3)
            phi(i,j,k) = phi(i,j,k) + rhog
          end do
        end do

      else if (face .eq. XHI) then

        i = ARG_L1(phi)

        j = ARG_L2(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_i   = half * (three*rho(i-1,j,k) - rho(i-1,j+1,k))
          rho_im1 = half * (three*rho(i-2,j,k) - rho(i-2,j+1,k))
          rhoExt  = half * (three*rho_i - rho_im1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        j = ARG_H2(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_i   = half * (three*rho(i-1,j-1,k) - rho(i-1,j-2,k))
          rho_im1 = half * (three*rho(i-2,j-1,k) - rho(i-2,j-2,k))
          rhoExt  = half * (three*rho_i - rho_im1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        do j = ARG_L2(phi)+1,ARG_H2(phi)-1
          rhog = zero
          do k = ARG_H3(phi)-1,ARG_L3(phi),-1
            rho_i   = half * (rho(i-1,j,k) + rho(i-1,j-1,k))
            rho_im1 = half * (rho(i-2,j,k) + rho(i-2,j-1,k))
            rhoExt  = half * (three*rho_i - rho_im1 )
            rhog = rhog + gravity * rhoExt * dx(3)
            phi(i,j,k) = phi(i,j,k) + rhog
          end do
        end do

      else if (face .eq. YLO) then

        j = ARG_L2(phi)

        i = ARG_L1(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_j   = half * (three*rho(i,j  ,k) - rho(i+1,j  ,k))
          rho_jp1 = half * (three*rho(i,j+1,k) - rho(i+1,j+1,k))
          rhoExt  = half * (three*rho_j - rho_jp1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        i = ARG_H1(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_j   = half * (three*rho(i-1,j  ,k) - rho(i-2,j  ,k))
          rho_jp1 = half * (three*rho(i-1,j+1,k) - rho(i-2,j+1,k))
          rhoExt  = half * (three*rho_j - rho_jp1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        do i = ARG_L1(phi)+1,ARG_H1(phi)-1
          rhog = zero
          do k = ARG_H3(phi)-1,ARG_L3(phi),-1
            rho_j   = half * (rho(i,j  ,k) + rho(i-1,j  ,k))
            rho_jp1 = half * (rho(i,j+1,k) + rho(i-1,j+1,k))
            rhoExt  = half * (three*rho_j - rho_jp1 )
            rhog = rhog + gravity * rhoExt * dx(3)
            phi(i,j,k) = phi(i,j,k) + rhog
          end do
        end do

      else if (face .eq. YHI) then

        j = ARG_L2(phi)

        i = ARG_L1(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_j   = half * (three*rho(i,j-1,k) - rho(i+1,j-1,k))
          rho_jm1 = half * (three*rho(i,j-2,k) - rho(i+1,j-2,k))
          rhoExt  = half * (three*rho_j - rho_jm1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        i = ARG_H1(phi)
        rhog = zero
        do k = ARG_H3(phi)-1,ARG_L3(phi),-1
          rho_j   = half * (three*rho(i-1,j-1,k) - rho(i-2,j-1,k))
          rho_jm1 = half * (three*rho(i-1,j-2,k) - rho(i-2,j-2,k))
          rhoExt  = half * (three*rho_j - rho_jm1 )
          rhog = rhog + gravity * rhoExt * dx(3)
          phi(i,j,k) = phi(i,j,k) + rhog
        end do

        do i = ARG_L1(phi)+1,ARG_H1(phi)-1
          rhog = zero
          do k = ARG_H3(phi)-1,ARG_L3(phi),-1
            rho_j   = half * (rho(i,j-1,k) + rho(i-1,j-1,k))
            rho_jm1 = half * (rho(i,j-2,k) + rho(i-1,j-2,k))
            rhoExt  = half * (three*rho_j - rho_jm1 )
            rhog = rhog + gravity * rhoExt * dx(3)
            phi(i,j,k) = phi(i,j,k) + rhog
          end do
        end do

      endif

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI

      end

c *************************************************************************
c ** FILL_TWOD **
c *************************************************************************

      subroutine FORT_FILL_TWOD(lenx,leny,lenz,length,width,
     $                          faces,numOutFlowFaces,
     $                          cc0,cc1,cc2,cc3,cc4,cc5,conn)

      integer lenx,leny,lenz
      integer length,width
      integer faces(6)
      integer numOutFlowFaces
      REAL_T cc0(leny,lenz,4)
      REAL_T cc1(lenx,lenz,4)
      REAL_T cc2(leny,lenz,4)
      REAL_T cc3(lenx,lenz,4)
      REAL_T cc4(lenx,leny,4)
      REAL_T cc5(lenx,leny,4)
      REAL_T conn(length,width,4)

      integer xlo_outflow,ylo_outflow,zlo_outflow
      integer xhi_outflow,yhi_outflow,zhi_outflow
      integer i,k,ifinal,n

#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5

c     Want to find the single non-outflow face.
      xlo_outflow = 0
      ylo_outflow = 0
      zlo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0
      zhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. ZLO) zlo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
        if (faces(i) .eq. ZHI) zhi_outflow = 1
      enddo

c     Possible combinations of faces to come in here:
c       cc0 cc1 cc2 cc3 cc4 cc5
c       XLO YLO 
c       XLO             YHI 
c           YLO     XHI 
c           YLO     YHI 
c       XLO YLO     XHI
c       XLO         XHI YHI
c       XLO YLO     YHI
c           YLO     XHI YHI
c       XLO YLO     XHI YHI

c     We must remember here that the cc* arrays have already been
c       ordered so that the 3nd dimension is one cell wide.

      ifinal = 0
      if (numOutFlowFaces .eq. 4 .or. 
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 0) ) then
          do k = 1,lenz
          do i = 1,leny
            conn(i,k,1) = cc0(i,k,1)
            conn(i,k,2) = cc0(i,k,2)
            conn(i,k,3) = cc0(i,k,3)
            conn(i,k,4) = cc0(i,k,4)
          enddo
          enddo
          ifinal = leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    .not. (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
          do k = 1,lenz
          do i = 1,lenx
            conn(ifinal+i,k,1) = cc4(i,k,1)
            conn(ifinal+i,k,2) = cc4(i,k,2)
            conn(ifinal+i,k,3) = cc4(i,k,3)
            conn(ifinal+i,k,4) = cc4(i,k,4)
          enddo
          enddo
          ifinal = ifinal + lenx
      endif

      if (xhi_outflow .eq. 1) then
          do k = 1,lenz
          do i = 1,leny
            conn(ifinal+i,k,1) = cc3(leny+1-i,k,1)
            conn(ifinal+i,k,2) = cc3(leny+1-i,k,2)
            conn(ifinal+i,k,3) = cc3(leny+1-i,k,3)
            conn(ifinal+i,k,4) = cc3(leny+1-i,k,4)
          enddo
          enddo
          ifinal = ifinal + leny
      endif

      if (ylo_outflow .eq. 1) then
          do k = 1,lenz
          do i = 1,lenx
            conn(ifinal+i,k,1) = cc1(lenx+1-i,k,1)
            conn(ifinal+i,k,2) = cc1(lenx+1-i,k,2)
            conn(ifinal+i,k,3) = cc1(lenx+1-i,k,3)
            conn(ifinal+i,k,4) = cc1(lenx+1-i,k,4)
          enddo
          enddo
          ifinal = ifinal + lenx
      endif

      if (numOutFlowFaces .lt. 4 .and.
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 1) ) then
          do k = 1,lenz
          do i = 1,leny
            conn(ifinal+i,k,1) = cc0(i,k,1)
            conn(ifinal+i,k,2) = cc0(i,k,2)
            conn(ifinal+i,k,3) = cc0(i,k,3)
            conn(ifinal+i,k,4) = cc0(i,k,4)
          enddo
          enddo
          ifinal = ifinal + leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
          do k = 1,lenz
          do i = 1,lenx
            conn(ifinal+i,k,1) = cc4(i,k,1)
            conn(ifinal+i,k,2) = cc4(i,k,2)
            conn(ifinal+i,k,3) = cc4(i,k,3)
            conn(ifinal+i,k,4) = cc4(i,k,4)
          enddo
          enddo
          ifinal = ifinal + lenx
      endif

      length = ifinal

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI

      end

c *************************************************************************
c ** ALLPHI_FROM_X **
c *************************************************************************

      subroutine FORT_ALLPHI_FROM_X(lenx,leny,lenz,length,width,
     $                              faces,numOutFlowFaces,
     $                              phi0,phi1,phi2,phi3,phi4,phi5,x,DIMS(x))

      integer DIMDEC(x)
      integer lenx,leny,lenz,length,width
      integer numOutFlowFaces
      integer faces(6)
      REAL_T phi0(0:leny,0:lenz)
      REAL_T phi1(0:lenx,0:lenz)
      REAL_T phi2(0:leny,0:lenz)
      REAL_T phi3(0:lenx,0:lenz)
      REAL_T phi4(0:lenx,0:leny)
      REAL_T phi5(0:lenx,0:leny)
      REAL_T x(DIMV(x))

      integer xlo_outflow,ylo_outflow,zlo_outflow
      integer xhi_outflow,yhi_outflow,zhi_outflow
      integer i,j,k,ifinal,n

#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5

c     Want to find the single non-outflow face.
      xlo_outflow = 0
      ylo_outflow = 0
      zlo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0
      zhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. ZLO) zlo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
        if (faces(i) .eq. ZHI) zhi_outflow = 1
      enddo

c     Possible combinations of faces to come in here:
c       phi0 phi1 phi2 phi3 phi4 phi5
c       XLO  YLO 
c       XLO                 YHI 
c            YLO       XHI 
c            YLO            YHI 
c       XLO  YLO       XHI
c       XLO            XHI  YHI
c       XLO  YLO            YHI
c            YLO       XHI  YHI
c       XLO  YLO       XHI  YHI


c     We know that the faces are ordered: XLO,XHI,YLO,YHI
      
      ifinal = 0

      if (numOutFlowFaces .eq. 4 .or. 
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 0) ) then
        do k = 0,lenz
        do j = 0,leny
          phi0(j,k) = x(j,k,ARG_L3(x))
        enddo
        enddo
        ifinal = leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    .not. (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
        do k = 0,lenz
        do i = 0,lenx
          phi4(i,k) = x(i+ifinal,k,ARG_L3(x))
        enddo
        enddo
        ifinal = ifinal+lenx
      endif

      if (xhi_outflow .eq. 1) then
        do k = 0,lenz
        do j = 0,leny
          phi3(leny-j,k) = x(ifinal+j,k,ARG_L3(x))
        enddo
        enddo
        ifinal = ifinal+leny
      endif

      if (ylo_outflow .eq. 1) then
        if (numOutFlowFaces .eq. 4) then 
          do k = 0,lenz
          do i = 0,lenx-1
            phi1(lenx-i,k) = x(ifinal+i,k,ARG_L3(x))
          enddo
          phi1(0,k) = x(0,k,ARG_L3(x))
          enddo
        else
          do k = 0,lenz
          do i = 0,lenx
            phi1(lenx-i,k) = x(ifinal+i,k,ARG_L3(x))
          enddo
          enddo
        endif
        ifinal = ifinal+lenx
      endif

      if (numOutFlowFaces .lt. 4 .and.
     $    (xlo_outflow .eq. 1 .and. ylo_outflow .eq. 1) ) then
        do k = 0,lenz
        do j = 0,leny
          phi0(j,k) = x(j+ifinal,k,ARG_L3(x))
        enddo
        enddo
        ifinal = ifinal+leny
      endif

      if (yhi_outflow .eq. 1 .and. 
     $    (numOutFlowFaces .eq. 3 .and. xhi_outflow .eq. 0) ) then
        do k = 0,lenz
        do i = 0,lenx
          phi4(i,k) = x(i+ifinal,k,ARG_L3(x))
        enddo
        enddo
        ifinal = ifinal+lenx
      endif

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** MKADVVEL **
c ** Predict normal edge velocities to be MAC-projected and used
c **  for advection velocities
c ***************************************************************

      subroutine FORT_MKADVVEL(u,ux,uy,uz,v,vx,vy,vz,w,wx,wy,wz,
     $                         rho,force,px,py,pz,lapu,
     $                         dx,dt,DIMS,
     $                         stleft,strght,stbot,sttop,stdwn,stup,
     $                         uadv,vadv,wadv,utrans,vtrans,wtrans,
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,
     $                         visc_coef)

      implicit none

      integer DIMS

      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     ux(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     uy(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     uz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     vx(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     vy(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     vz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     wx(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     wy(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     wz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T     px(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     py(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     pz(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)

      REAL_T  stleft(lo_1-1:hi_1+1)
      REAL_T  strght(lo_1-1:hi_1+1)
      REAL_T   stbot(lo_2-1:hi_2+1)
      REAL_T   sttop(lo_2-1:hi_2+1)
      REAL_T   stdwn(lo_3-1:hi_3+1)
      REAL_T    stup(lo_3-1:hi_3+1)

      REAL_T   uadv(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T   vadv(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T   wadv(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T utrans(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T vtrans(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T wtrans(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T  dx(3)
      REAL_T  dt
      integer bcx_lo, bcx_hi, bcy_lo, bcy_hi, bcz_lo, bcz_hi
      REAL_T  visc_coef

c     Local variables
      REAL_T ubardth, vbardth, wbardth
      REAL_T hx,hy,hz,dth
      REAL_T uplus,uminus,vplus,vminus,wplus,wminus,ut,vt,wt
      REAL_T utr,vtr,wtr,savg
      REAL_T ulft,urgt
      REAL_T vtop,vbot
      REAL_T wtop,wbot
      REAL_T uptop,upbot,umtop,umbot,uplft,uprgt,umlft,umrgt
      REAL_T vptop,vpbot,vmtop,vmbot,vplft,vprgt,vmlft,vmrgt
      REAL_T wptop,wpbot,wmtop,wmbot,wplft,wprgt,wmlft,wmrgt
      REAL_T flgp,flgm

      REAL_T eps

      REAL_T umax,umin,vmax,vmin,wmax,wmin,rhomax,rhomin

      logical ltp,ltm,ltx,lty,ltz,ltm0,ltp0
      integer i,j,k,is,js,ks,ie,je,ke

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3
      dth = half*dt
      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      umax   = -1.e30
      vmax   = -1.e30
      wmax   = -1.e30
      rhomax = -1.e30
      umin   =  1.e30
      vmin   =  1.e30
      wmin   =  1.e30
      rhomin =  1.e30
      do k = lo_3, hi_3
      do j = lo_2, hi_2
      do i = lo_1, hi_1
         umax = max(u(i,j,k),umax)
         umin = min(u(i,j,k),umin)
         vmax = max(v(i,j,k),vmax)
         vmin = min(v(i,j,k),vmin)
         wmax = max(w(i,j,k),wmax)
         wmin = min(w(i,j,k),wmin)
         rhomax = max(rho(i,j,k),rhomax)
         rhomin = min(rho(i,j,k),rhomin)
      enddo
      enddo
      enddo

      write(6,1000) umax,umin
      write(6,1001) vmax,vmin
      write(6,1002) wmax,wmin
      write(6,1003) rhomax,rhomin

 1000 format(' U  MAX/MIN : ',e21.14,2x,e21.14)
 1001 format(' V  MAX/MIN : ',e21.14,2x,e21.14)
 1002 format(' W  MAX/MIN : ',e21.14,2x,e21.14)
 1003 format('RHO MAX/MIN : ',e21.14,2x,e21.14)

c     Create the z-velocity to be used for transverse derivatives.
      do k = ks,ke+1
        do j = js,je
        do i = is,ie

          wtop = w(i,j,k  ) - (half + dth*w(i,j,k  )/hz) * wz(i,j,k  )
c    $           + dth * lapu(i,j,k  ,3) / rho(i,j,k  )
          wbot = w(i,j,k-1) + (half - dth*w(i,j,k-1)/hz) * wz(i,j,k-1)
c    $           + dth * lapu(i,j,k-1,3) / rho(i,j,k-1)

          wtop = cvmgt(w(i,j,ks-1),wtop,k.eq.ks   .and. BCZ_LO .eq. INLET)
          wtop = cvmgt(w(i,j,ke+1),wtop,k.eq.ke+1 .and. BCZ_HI .eq. INLET)
          wtop = cvmgt(zero       ,wtop,k.eq.ks   .and. BCZ_LO .eq. WALL)
          wtop = cvmgt(zero       ,wtop,k.eq.ke+1 .and. BCZ_HI .eq. WALL)

          wbot = cvmgt(w(i,j,ks-1),wbot,k.eq.ks   .and. BCZ_LO .eq. INLET)
          wbot = cvmgt(w(i,j,ke+1),wbot,k.eq.ke+1 .and. BCZ_HI .eq. INLET)
          wbot = cvmgt(zero       ,wbot,k.eq.ks   .and. BCZ_LO .eq. WALL)
          wbot = cvmgt(zero       ,wbot,k.eq.ke+1 .and. BCZ_HI .eq. WALL)

          wtrans(i,j,k)=cvmgp(wbot,wtop,wbot+wtop)
          ltm = ( (wbot .le. zero  .and.  wtop .ge. zero)  .or.
     $             (abs(wbot+wtop) .lt. eps))
          wtrans(i,j,k) = cvmgt(zero,wtrans(i,j,k),ltm)

        enddo
        enddo
      enddo

c     Create the y-velocity to be used for transverse derivatives.
      do j = js,je+1
        do k = ks,ke
        do i = is,ie

          vtop = v(i,j ,k) - (half + dth*v(i,j,k)/hy) * vy(i,j,k)
c    $           + dth * lapu(i,j  ,k,2) / rho(i,j  ,k)
          vbot = v(i,j-1,k) + (half - dth*v(i,j-1,k)/hy) * vy(i,j-1,k)
c    $           + dth * lapu(i,j-1,k,2) / rho(i,j-1,k)

          vtop = cvmgt(v(i,js-1,k),vtop,j.eq.js   .and. BCY_LO .eq. INLET)
          vtop = cvmgt(v(i,je+1,k),vtop,j.eq.je+1 .and. BCY_HI .eq. INLET)
          vtop = cvmgt(zero       ,vtop,j.eq.js   .and. BCY_LO .eq. WALL)
          vtop = cvmgt(zero       ,vtop,j.eq.je+1 .and. BCY_HI .eq. WALL)

          vbot = cvmgt(v(i,js-1,k),vbot,j.eq.js   .and. BCY_LO .eq. INLET)
          vbot = cvmgt(v(i,je+1,k),vbot,j.eq.je+1 .and. BCY_HI .eq. INLET)
          vbot = cvmgt(zero       ,vbot,j.eq.js   .and. BCY_LO .eq. WALL)
          vbot = cvmgt(zero       ,vbot,j.eq.je+1 .and. BCY_HI .eq. WALL)

          vtrans(i,j,k)=cvmgp(vbot,vtop,vbot+vtop)
          ltm = ( (vbot .le. zero  .and.  vtop .ge. zero)  .or.
     $             (abs(vbot+vtop) .lt. eps))
          vtrans(i,j,k) = cvmgt(zero,vtrans(i,j,k),ltm)

        enddo
        enddo
      enddo

c     Create the x-velocity to be used for transverse derivatives.
      do k = ks,ke
      do j = js,je
        do i = is,ie+1

          urgt = u(i,j ,k) - (half + dth*u(i,j,k)/hx) * ux(i,j,k)
c    $           + dth * lapu(i  ,j,k,1) / rho(i  ,j,k)
          ulft = u(i-1,j,k) + (half - dth*u(i-1,j,k)/hx) * ux(i-1,j,k)
c    $           + dth * lapu(i-1,j,k,1) / rho(i-1,j,k)

          urgt = cvmgt(u(is-1,j,k),urgt,i.eq.is   .and. BCX_LO .eq. INLET)
          urgt = cvmgt(u(ie+1,j,k),urgt,i.eq.ie+1 .and. BCX_HI .eq. INLET)
          urgt = cvmgt(zero       ,urgt,i.eq.is   .and. BCX_LO .eq. WALL)
          urgt = cvmgt(zero       ,urgt,i.eq.ie+1 .and. BCX_HI .eq. WALL)

          ulft = cvmgt(u(is-1,j,k),ulft,i.eq.is   .and. BCX_LO .eq. INLET)
          ulft = cvmgt(u(ie+1,j,k),ulft,i.eq.ie+1 .and. BCX_HI .eq. INLET)
          ulft = cvmgt(zero       ,ulft,i.eq.is   .and. BCX_LO .eq. WALL)
          ulft = cvmgt(zero       ,ulft,i.eq.ie+1 .and. BCX_HI .eq. WALL)

          utrans(i,j,k) = cvmgp(ulft,urgt,ulft+urgt)
          ltm=( (ulft .le. zero  .and.  urgt .ge. zero)  .or.
     $          (abs(ulft+urgt) .lt. eps) )
          utrans(i,j,k) = cvmgt(zero,utrans(i,j,k),ltm)

        enddo
        enddo
      enddo

c ::: loop for x fluxes

      do k = ks,ke 
      do j = js,je 
        do i = is,ie 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Y-DIRECTION
c        ******************************************************************

          upbot = u(i,j  ,k) + (half - dth*v(i,j  ,k)/hy) * uy(i,j  ,k)
c    $            + dth * lapu(i,j  ,k,1) / rho(i,j  ,k)
          uptop = u(i,j+1,k) - (half + dth*v(i,j+1,k)/hy) * uy(i,j+1,k)
c    $            + dth * lapu(i,j+1,k,1) / rho(i,j+1,k)

          uptop = cvmgt(u(i,je+1,k),uptop,j.eq.je .and. bcy_hi.eq.INLET)
          upbot = cvmgt(u(i,je+1,k),upbot,j.eq.je .and. bcy_hi.eq.INLET)

          uptop = cvmgt(upbot,uptop,j.eq.je .and. bcy_hi.eq.WALL)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)

          flgp=cvmgt(zero,one,abs(vtrans(i,j+1,k)).lt.eps)
          uplus = cvmgp(upbot,uptop,vtrans(i,j+1,k))
          uplus = flgp * uplus + (one - flgp)*half*(uptop+upbot)

          umtop = u(i,j  ,k) - (half + dth*v(i,j  ,k)/hy) * uy(i,j,k)
c    $            + dth * lapu(i,j  ,k,1) / rho(i,j  ,k)
          umbot = u(i,j-1,k) + (half - dth*v(i,j-1,k)/hy) * uy(i,j-1,k)
c    $            + dth * lapu(i,j-1,k,1) / rho(i,j-1,k)

          umtop = cvmgt(u(i,js-1,k),umtop,j.eq.js .and. bcy_lo.eq.INLET)
          umbot = cvmgt(u(i,js-1,k),umbot,j.eq.js .and. bcy_lo.eq.INLET)

          umbot = cvmgt(umtop,umbot,j.eq.js .and. bcy_lo.eq.WALL)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL  .and.  visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)

          flgm=cvmgt(zero,one,abs(vtrans(i,j,k)).lt.eps)
          uminus = cvmgp(umbot,umtop,vtrans(i,j,k))
          uminus = flgm * uminus + (one - flgm)*half*(umtop+umbot)

          utr = half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(uplus - uminus) / hy

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Z-DIRECTION
c        ******************************************************************

          upbot = u(i,j,k  ) + (half - dth*w(i,j,k  )/hz) * uz(i,j,k  )
c    $            + dth * lapu(i,j,k  ,1) / rho(i,j,k  )
          uptop = u(i,j,k+1) - (half + dth*w(i,j,k+1)/hz) * uz(i,j,k+1)
c    $            + dth * lapu(i,j,k+1,1) / rho(i,j,k+1)

          uptop = cvmgt(u(i,j,ke+1),uptop,k.eq.ke .and. bcz_hi.eq.INLET)
          upbot = cvmgt(u(i,j,ke+1),upbot,k.eq.ke .and. bcz_hi.eq.INLET)

          uptop = cvmgt(upbot,uptop,k.eq.ke .and. bcz_hi.eq.WALL)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL  .and.  visc_coef .gt. zero)
          uptop = cvmgt(zero,uptop,ltp0)
          upbot = cvmgt(zero,upbot,ltp0)

          flgp=cvmgt(zero,one,abs(wtrans(i,j,k+1)).lt.eps)
          uplus = cvmgp(upbot,uptop,wtrans(i,j,k+1))
          uplus = flgp * uplus + (one - flgp)*half*(uptop+upbot)

          umtop = u(i,j,k  ) - (half + dth*w(i,j,k  )/hz) * uz(i,j,k)
c    $            + dth * lapu(i,j,k  ,1) / rho(i,j,k  )
          umbot = u(i,j,k-1) + (half - dth*w(i,j,k-1)/hz) * uz(i,j,k-1)
c    $            + dth * lapu(i,j,k-1,1) / rho(i,j,k-1)

          umtop = cvmgt(u(i,j,ks-1),umtop,k.eq.ks .and. bcz_lo.eq.INLET)
          umbot = cvmgt(u(i,j,ks-1),umbot,k.eq.ks .and. bcz_lo.eq.INLET)

          umbot = cvmgt(umtop,umbot,k.eq.ks .and. bcz_lo.eq.WALL)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL  .and.  visc_coef .gt. zero)
          umtop = cvmgt(zero,umtop,ltm0)
          umbot = cvmgt(zero,umbot,ltm0)

          flgm=cvmgt(zero,one,abs(wtrans(i,j,k)).lt.eps)
          uminus = cvmgp(umbot,umtop,wtrans(i,j,k))
          uminus = flgm * uminus + (one - flgm)*half*(umtop+umbot)

          utr = utr + half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(uplus - uminus) / hz

c        ******************************************************************
c        ******************************************************************

          ut = (lapu(i,j,k,1)-px(i,j,k))/rho(i,j,k) - utr + force(i,j,k,1)

          ubardth = dth*u(i,j,k)/hx

          stleft(i  )= u(i,j,k) + (half-ubardth)*ux(i,j,k) + dth*ut
          strght(i-1)= u(i,j,k) - (half+ubardth)*ux(i,j,k) + dth*ut

        enddo

        if (bcx_lo .eq. PERIODIC) then
          stleft(is-1) = stleft(ie  )
        elseif (bcx_lo .eq. WALL) then
          stleft(is-1) = zero
          strght(is-1) = zero
        elseif (bcx_lo .eq. INLET) then
          stleft(is-1) = u(is-1,j,k)
          strght(is-1) = u(is-1,j,k)
        elseif (bcx_lo .eq. OUTLET) then
          stleft(is-1) = strght(is-1)
        else
          print *,'bogus bcx_lo in mkadvvel ',bcx_lo
          stop
        endif

        if (bcx_hi .eq. PERIODIC) then
          strght(ie  ) = strght(is-1)
        elseif (bcx_hi .eq. WALL) then
          stleft(ie  ) = zero
          strght(ie  ) = zero
        elseif (bcx_hi .eq. INLET) then
          stleft(ie  ) = u(ie+1,j,k)
          strght(ie  ) = u(ie+1,j,k)
        elseif (bcx_hi .eq. OUTLET) then
          strght(ie  ) = stleft(ie)
        else
          print *,'bogus bcx_hi in mkadvvel ',bcx_hi
          stop
        endif

        do i = is-1, ie 

          savg = half*(strght(i) + stleft(i))
          ltx = ( (stleft(i) .le. zero  .and.  
     $             strght(i) .ge. zero)  .or.  
     $           (abs(stleft(i) + strght(i)) .lt. eps) )

          uadv(i+1,j,k)=cvmgp(stleft(i),strght(i),savg)
          uadv(i+1,j,k)=cvmgt(savg,uadv(i+1,j,k),ltx)

        enddo

        if (bcx_lo .eq. WALL) then
          uadv(is  ,j,k) = zero
        endif

        if (bcx_hi .eq. WALL) then
          uadv(ie+1,j,k) = zero
        endif

      enddo
      enddo

c        ******************************************************************
c        ******************************************************************
c        ******************************************************************

c ::: loop for y fluxes

      do k = ks, ke 
      do i = is, ie 
        do j = js, je 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN X-DIRECTION
c        ******************************************************************

          vplft = v(i  ,j,k) + (half - dth*u(i  ,j,k)/hx) * vx(i  ,j,k)
c    $            + dth * lapu(i  ,j,k,2) / rho(i  ,j,k)
          vprgt = v(i+1,j,k) - (half + dth*u(i+1,j,k)/hx) * vx(i+1,j,k)
c    $            + dth * lapu(i+1,j,k,2) / rho(i+1,j,k)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. INLET)
          vprgt = cvmgt(v(ie+1,j,k),vprgt,ltp0)
          vplft = cvmgt(v(ie+1,j,k),vplft,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL)
          vprgt = cvmgt(vplft,vprgt,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL  .and.  visc_coef .gt. zero)
          vprgt = cvmgt(zero,vprgt,ltp0)
          vplft = cvmgt(zero,vplft,ltp0)

          flgp=cvmgt(zero,one,abs(utrans(i+1,j,k)).lt.eps)
          vplus = cvmgp(vplft,vprgt,utrans(i+1,j,k))
          vplus = flgp * vplus + (one - flgp)*half*(vprgt+vplft)

          vmrgt = v(i  ,j,k) - (half + dth*u(i  ,j,k)/hx) * vx(i  ,j,k)
c    $            + dth * lapu(i  ,j,k,2) / rho(i  ,j,k)
          vmlft = v(i-1,j,k) + (half - dth*u(i-1,j,k)/hx) * vx(i-1,j,k)
c    $            + dth * lapu(i-1,j,k,2) / rho(i-1,j,k)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. INLET)
          vmrgt = cvmgt(v(is-1,j,k),vmrgt,ltm0)
          vmlft = cvmgt(v(is-1,j,k),vmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL)
          vmlft = cvmgt(vmrgt,vmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL  .and.  visc_coef .gt. zero)
          vmrgt = cvmgt(zero,vmrgt,ltm0)
          vmlft = cvmgt(zero,vmlft,ltm0)

          flgm=cvmgt(zero,one,abs(utrans(i,j,k)).lt.eps)
          vminus = cvmgp(vmlft,vmrgt,utrans(i,j,k))
          vminus = flgm * vminus + (one - flgm)*half*(vmrgt+vmlft)

          vtr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(vplus - vminus) / hx


c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Z-DIRECTION
c        ******************************************************************

          vplft = v(i,j,k  ) + (half - dth*w(i,j,k  )/hz) * vz(i,j,k  )
c    $            + dth * lapu(i,j,k  ,2) / rho(i,j,k  )
          vprgt = v(i,j,k+1) - (half + dth*w(i,j,k+1)/hz) * vz(i,j,k+1)
c    $            + dth * lapu(i,j,k+1,2) / rho(i,j,k+1)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. INLET)
          uptop = cvmgt(u(i,j,ke+1),uptop,ltp0)
          upbot = cvmgt(u(i,j,ke+1),upbot,ltp0)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL)
          vprgt = cvmgt(vplft,vprgt,ltp0)

          ltp0 = (k .eq. ke  .and.  bcz_hi .eq. WALL  .and.  visc_coef .gt. zero)
          vprgt = cvmgt(zero,vprgt,ltp0)
          vplft = cvmgt(zero,vplft,ltp0)

          flgp=cvmgt(zero,one,abs(wtrans(i,j,k+1)).lt.eps)
          vplus = cvmgp(vplft,vprgt,wtrans(i,j,k+1))
          vplus = flgp * vplus + (one - flgp)*half*(vprgt+vplft)

          vmrgt = v(i,j,k  ) - (half + dth*w(i,j,k  )/hz) * vz(i,j,k  )
c    $            + dth * lapu(i,j,k  ,2) / rho(i,j,k  )
          vmlft = v(i,j,k-1) + (half - dth*w(i,j,k-1)/hz) * vz(i,j,k-1)
c    $            + dth * lapu(i,j,k-1,2) / rho(i,j,k-1)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. INLET)
          vmrgt = cvmgt(v(i,j,ks-1),vmrgt,ltm0)
          vmlft = cvmgt(v(i,j,ks-1),vmlft,ltm0)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL)
          vmlft = cvmgt(vmrgt,vmlft,ltm0)

          ltm0 = (k .eq. ks  .and.  bcz_lo .eq. WALL  .and.  visc_coef .gt. zero)
          vmrgt = cvmgt(zero,vmrgt,ltm0)
          vmlft = cvmgt(zero,vmlft,ltm0)

          flgm=cvmgt(zero,one,abs(wtrans(i,j,k)).lt.eps)
          vminus = cvmgp(vmlft,vmrgt,wtrans(i,j,k))
          vminus = flgm * vminus + (one - flgm)*half*(vmrgt+vmlft)

          vtr = vtr + half * (wtrans(i,j,k)+wtrans(i,j,k+1))*(vplus - vminus) / hz

c        ******************************************************************

          vt = (lapu(i,j,k,2)-py(i,j,k))/rho(i,j,k) - vtr + force(i,j,k,2)
          vbardth = dth*v(i,j,k)/hy

          stbot(j  )= v(i,j,k) + (half-vbardth)*vy(i,j,k) + dth*vt
          sttop(j-1)= v(i,j,k) - (half+vbardth)*vy(i,j,k) + dth*vt

        enddo

        if (bcy_lo .eq. PERIODIC) then
          stbot(js-1) = stbot(je  )
        elseif (bcy_lo .eq. WALL) then
          stbot(js-1) = zero
          sttop(js-1) = zero
        elseif (bcy_lo .eq. INLET) then
          stbot(js-1) = v(i,js-1,k)
          sttop(js-1) = v(i,js-1,k)
        elseif (bcy_lo .eq. OUTLET) then
          stbot(js-1) = sttop(js-1)
        else
          print *,'bogus bcy_lo in mkadvvel ',bcy_lo
          stop
        endif

        if (bcy_hi .eq. PERIODIC) then
          sttop(je  ) = sttop(js-1)
        elseif (bcy_hi .eq. WALL) then
          stbot(je  ) = zero
          sttop(je  ) = zero
        elseif (bcy_hi .eq. INLET) then
          sttop(je  ) = v(i,je+1,k)
          sttop(je  ) = v(i,je+1,k)
        elseif (bcy_hi .eq. OUTLET) then
          sttop(je  ) = stbot(je)
        else
          print *,'bogus bcy_hi in mkadvvel ',bcy_hi
          stop
        endif

        do j = js-1, je 
          savg = half*(stbot(j)+sttop(j))
          lty = ( (stbot(j) .le. zero  .and.  sttop(j) .ge. zero) .or.
     $            (abs(stbot(j) + sttop(j)) .lt. eps) )

          vadv(i,j+1,k)=cvmgp(stbot(j),sttop(j),savg)
          vadv(i,j+1,k)=cvmgt(savg,vadv(i,j+1,k),lty)

        enddo

        if (bcy_lo .eq. WALL) then
          vadv(i,js  ,k) = zero
        endif

        if (bcy_hi .eq. WALL) then
          vadv(i,je+1,k) = zero
        endif

      enddo
      enddo

c        ******************************************************************
c        ******************************************************************
c        ******************************************************************

c ::: loop for z fluxes

      do j = js, je 
      do i = is, ie 
        do k = ks, ke 

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN X-DIRECTION
c        ******************************************************************

          wplft = w(i  ,j,k) + (half - dth*u(i  ,j,k)/hx) * wx(i  ,j,k)
c    $            + dth * lapu(i  ,j,k,3) / rho(i  ,j,k)
          wprgt = w(i+1,j,k) - (half + dth*u(i+1,j,k)/hx) * wx(i+1,j,k)
c    $            + dth * lapu(i+1,j,k,3) / rho(i+1,j,k)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. INLET)
          wprgt = cvmgt(w(ie+1,j,k),wprgt,ltp0)
          wplft = cvmgt(w(ie+1,j,k),wplft,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL)
          wprgt = cvmgt(wplft,wprgt,ltp0)

          ltp0 = (i .eq. ie  .and.  bcx_hi .eq. WALL  .and.  visc_coef .gt. zero)
          wprgt = cvmgt(zero,wprgt,ltp0)
          wplft = cvmgt(zero,wplft,ltp0)

          flgp=cvmgt(zero,one,abs(utrans(i+1,j,k)).lt.eps)
          wplus = cvmgp(wplft,wprgt,utrans(i+1,j,k))
          wplus = flgp * wplus + (one - flgp)*half*(wprgt+wplft)

          wmrgt = w(i  ,j,k) - (half + dth*u(i  ,j,k)/hx) * wx(i  ,j,k)
c    $            + dth * lapu(i  ,j,k,3) / rho(i  ,j,k)
          wmlft = w(i-1,j,k) + (half - dth*u(i-1,j,k)/hx) * wx(i-1,j,k)
c    $            + dth * lapu(i-1,j,k,3) / rho(i-1,j,k)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. INLET)
          wmrgt = cvmgt(w(is-1,j,k),wmrgt,ltm0)
          wmlft = cvmgt(w(is-1,j,k),wmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL)
          wmlft = cvmgt(wmrgt,wmlft,ltm0)

          ltm0 = (i .eq. is  .and.  bcx_lo .eq. WALL  .and.  visc_coef .gt. zero)
          wmrgt = cvmgt(zero,wmrgt,ltm0)
          wmlft = cvmgt(zero,wmlft,ltm0)

          flgm=cvmgt(zero,one,abs(utrans(i,j,k)).lt.eps)
          wminus = cvmgp(wmlft,wmrgt,utrans(i,j,k))
          wminus = flgm * wminus + (one - flgm)*half*(wmrgt+wmlft)

          wtr = half * (utrans(i,j,k)+utrans(i+1,j,k))*(wplus - wminus) / hx

c        ******************************************************************
c        MAKE TRANSVERSE DERIVATIVES IN Y-DIRECTION
c        ******************************************************************

          wpbot = w(i,j  ,k) + (half - dth*v(i,j  ,k)/hy) * wy(i,j  ,k)
c    $            + dth * lapu(i,j  ,k,3) / rho(i,j  ,k)
          wptop = w(i,j+1,k) - (half + dth*v(i,j+1,k)/hy) * wy(i,j+1,k)
c    $            + dth * lapu(i,j+1,k,3) / rho(i,j+1,k)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. INLET)
          wptop = cvmgt(w(i,je+1,k),wptop,ltp0)
          wpbot = cvmgt(w(i,je+1,k),wpbot,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL)
          wptop = cvmgt(wpbot,wptop,ltp0)

          ltp0 = (j .eq. je  .and.  bcy_hi .eq. WALL  .and.  visc_coef .gt. zero)
          wptop = cvmgt(zero,wptop,ltp0)
          wpbot = cvmgt(zero,wpbot,ltp0)

          flgp=cvmgt(zero,one,abs(vtrans(i,j+1,k)).lt.eps)
          wplus = cvmgp(wpbot,wptop,vtrans(i,j+1,k))
          wplus = flgp * wplus + (one - flgp)*half*(wptop+wpbot)

          wmtop = w(i,j  ,k) - (half + dth*v(i,j  ,k)/hy) * wy(i,j  ,k)
c    $            + dth * lapu(i,j  ,k,3) / rho(i,j  ,k)
          wmbot = w(i,j-1,k) + (half - dth*v(i,j-1,k)/hy) * wy(i,j-1,k)
c    $            + dth * lapu(i,j-1,k,3) / rho(i,j-1,k)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. INLET)
          wmtop = cvmgt(w(i,js-1,k),wmtop,ltm0)
          wmbot = cvmgt(w(i,js-1,k),wmbot,ltm0)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL)
          wmbot = cvmgt(wmtop,wmbot,ltm0)

          ltm0 = (j .eq. js  .and.  bcy_lo .eq. WALL  .and.  visc_coef .gt. zero)
          wmtop = cvmgt(zero,wmtop,ltm0)
          wmbot = cvmgt(zero,wmbot,ltm0)

          flgm=cvmgt(zero,one,abs(vtrans(i,j,k)).lt.eps)
          wminus = cvmgp(wmbot,wmtop,vtrans(i,j,k))
          wminus = flgm * wminus + (one - flgm)*half*(wmtop+wmbot)

          wtr = wtr + half * (vtrans(i,j,k)+vtrans(i,j+1,k))*(wplus - wminus) / hy

c        ******************************************************************

          wt = (lapu(i,j,k,3)-pz(i,j,k))/rho(i,j,k) - wtr + force(i,j,k,3)
          wbardth = dth*w(i,j,k)/hz

          stdwn(k  )= w(i,j,k) + (half-wbardth)*wz(i,j,k) + dth*wt
           stup(k-1)= w(i,j,k) - (half+wbardth)*wz(i,j,k) + dth*wt

        enddo

        if (bcz_lo .eq. PERIODIC) then
          stdwn(ks-1) = stdwn(ke  )
        elseif (bcz_lo .eq. WALL) then
          stdwn(ks-1) = zero
           stup(ks-1) = zero
        elseif (bcz_lo .eq. INLET) then
          stdwn(ks-1) = w(i,j,ks-1)
           stup(ks-1) = w(i,j,ks-1)
        elseif (bcz_lo .eq. OUTLET) then
          stdwn(ks-1) = stup(ks-1)
        else
          print *,'bogus bcz_lo in mkadvvel ',bcz_lo
          stop
        endif

        if (bcz_hi .eq. PERIODIC) then
           stup(ke  ) =  stup(ks-1)
        elseif (bcz_hi .eq. WALL) then
          stdwn(ke  ) = zero
           stup(ke  ) = zero
        elseif (bcz_hi .eq. INLET) then
          stdwn(ke  ) = w(i,j,ke+1)
           stup(ke  ) = w(i,j,ke+1)
        elseif (bcz_hi .eq. OUTLET) then
           stup(ke  ) = stdwn(ke)
        else
          print *,'bogus bcz_hi in mkadvvel ',bcz_hi
          stop
        endif

        do k = ks-1, ke 
          savg = half*(stdwn(k)+stup(k))
          ltz = ( (stdwn(k) .le. zero  .and.  stup(k) .ge. zero) .or.
     $            (abs(stdwn(k) + stup(k)) .lt. eps) )

          wadv(i,j,k+1)=cvmgp(stdwn(k),stup(k),savg)
          wadv(i,j,k+1)=cvmgt(savg,wadv(i,j,k+1),ltz)
        enddo

        if (bcz_lo .eq. WALL) then
          wadv(i,j,ks  ) = zero
        endif

        if (bcz_hi .eq. WALL) then
          wadv(i,j,ke+1) = zero
        endif

      enddo
      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** XINIT **
c ** Create the one-dimensional radius arrays for r-z geometry.
c *************************************************************************

      subroutine xinit(x,xhalf,hx,DIMS,irz)

      integer DIMS
      REAL_T     x(lo_1-1:hi_1+1)
      REAL_T xhalf(lo_1  :hi_1+2)
      REAL_T hx
      integer irz

c     Local variables
      integer i

      if (irz .eq. 0) then

        do i = lo_1-1,hi_1+1 
          x(i) = one
        enddo

        do i = lo_1,hi_1+2 
          xhalf(i) = one
        enddo

      elseif (irz .eq. 1) then

        do i = lo_1,hi_1+1 
              x(i) = ((i-lo_1) + half)*hx
          xhalf(i) = (i-lo_1)        *hx
        enddo

        xhalf(hi_1+2) = (hi_1-lo_1+2)*hx
            x(lo_1-1) = x(lo_1)

      else
        print *,' bogus irz in xinit ',irz
        stop
      endif
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: NAVIERSTOKES_2D.F,v 1.14 2003/01/30 07:16:29 almgren Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "NAVIERSTOKES_F.H"
#include "ArrayLim.H"

#define SDIM 2

      subroutine FORT_GRADP (
     &     p,DIMS(p),
     &     gp,DIMS(gp),
     &     lo,hi,dx,is_full)
c 
c     Compute a cell centered gradient from a node
c     centered field.  Returns all components of GRADP
c     
      integer    DIMDEC(p)
      integer    DIMDEC(gp)
      integer    lo(SDIM), hi(SDIM)
      REAL_T     dx(SDIM)
      REAL_T     p(DIMV(p))
      REAL_T     gp(DIMV(gp),SDIM)
      integer    is_full
      integer    i,j
      REAL_T     ddx, ddy

      ddx = half/dx(1)
      ddy = half/dx(2)

      if (is_full .eq. 0) then
        do j = lo(2), hi(2)
        do i = lo(1), hi(1)
          gp(i,j,1) = ddx*(p(i+1,j)-p(i,j)+p(i+1,j+1)-p(i,j+1))
          gp(i,j,2) = ddy*(p(i,j+1)-p(i,j)+p(i+1,j+1)-p(i+1,j))
        end do
        end do
      else
        do j = lo(2), hi(2)
        do i = lo(1), hi(1)
          gp(i,j,1) = (p(i+1,j)-p(i,j)+p(i+1,j+1)-p(i,j+1))
          gp(i,j,2) = (p(i,j+1)-p(i,j)+p(i+1,j+1)-p(i+1,j))
        end do
        end do
      endif

      end

      subroutine FORT_AVGDOWN (
     &     crse,DIMS(crse),nvar,
     &     fine,DIMS(fine),
     &     cv,DIMS(cv),
     &     fv,DIMS(fv),
     &     lo,hi,ratios)
c     ----------------------------------------------------------
c     Volume-weight average the fine grid data onto the coarse
c     grid.  Overlap is given in coarse grid coordinates.
c     
c     crse      =  coarse grid data
c     nvar	= number of components in arrays
c     fine      = fine grid data
c     cv        = coarse grid volume array
c     fv        = fine grid volume array
c     lo,hi     = index limits of overlap (crse grid)
c     ratios    = IntVect refinement ratio
c     ----------------------------------------------------------
      integer  DIMDEC(crse)
      integer  DIMDEC(cv)
      integer  DIMDEC(fine)
      integer  DIMDEC(fv)
      integer  lo(SDIM), hi(SDIM)
      integer  nvar
      integer  ratios(SDIM)
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T     cv(DIMV(cv))
      REAL_T   fine(DIMV(fine),nvar)
      REAL_T     fv(DIMV(fv))

      integer  i, j, n, ic, jc, ioff, joff
      integer  lratx,lraty

      lratx = ratios(1)
      lraty = ratios(2)

      do n = 1, nvar
c
c     set coarse grid to zero on overlap
c
         do jc = lo(2), hi(2)
            do ic = lo(1), hi(1)
               crse(ic,jc,n) = zero
            end do
         end do
c
c     sum fine data
c
         do joff = 0, lraty-1
            do jc = lo(2), hi(2)
               j = jc*lraty + joff
               do ioff = 0, lratx-1
                  do ic = lo(1), hi(1)
                     i = ic*lratx + ioff
                     crse(ic,jc,n) = crse(ic,jc,n) +
     &                    fv(i,j)*fine(i,j,n)
                  end do
               end do
            end do
         end do
c
c     divide out by volume weight
c
         do ic = lo(1), hi(1)
            do jc = lo(2), hi(2)
               crse(ic,jc,n) = crse(ic,jc,n)/cv(ic,jc)
            end do
         end do
      end do

      end

      subroutine FORT_TESTINJECT(
     &     crse,DIMS(crse),
     &     fine,DIMS(fine),lo,hi,ratios)
c
c     test for consistency of pressure nodes
c
      integer  DIMDEC(crse)
      integer  DIMDEC(fine)
      integer  lo(2), hi(2)
      integer  ratios(2)
      REAL_T   crse(DIMV(crse))
      REAL_T   fine(DIMV(fine))

      REAL_T diff
      integer ic, jc
      integer lratx, lraty

      lratx = ratios(1)
      lraty = ratios(2)

      diff = zero
      do jc = lo(2), hi(2)
         do ic = lo(1), hi(1)
            diff = max(diff,abs(crse(ic,jc)-fine(lratx*ic,lraty*jc)))
         end do
      end do

      if ( diff .gt. 1.0D-10 ) then
         call bl_abort('mismatch between fine and coarse nodes')
      end if

      end

c :: ----------------------------------------------------------
c :: Replace coarse grid pressure data with corresponding
c :: fine grid pressure data.
c ::
c :: INPUTS / OUTPUTS:
c ::  crse      <=  coarse grid data
c ::  DIMS(crse) => index limits of crse
c ::  fine       => fine grid data
c ::  DIMS(fine) => index limits of fine 
c ::  lo,hi      => index limits of overlap (crse grid)
c ::  ratios     => IntVect refinement ratio
c ::
c :: NOTE:
c ::  Assumes pressure fields are node based
c :: ----------------------------------------------------------
c ::
      subroutine FORT_PUTDOWN (crse,DIMS(crse),
     &			       fine,DIMS(fine),lo,hi,ratios)
      integer  DIMDEC(crse)
      integer  DIMDEC(fine)
      integer  lo(2), hi(2)
      integer  ratios(2)
      REAL_T   crse(DIMV(crse))
      REAL_T   fine(DIMV(fine))

      integer  ic, jc
      integer  lratx, lraty

      lratx = ratios(1)
      lraty = ratios(2)

      do jc = lo(2), hi(2)
         do ic = lo(1), hi(1)
            crse(ic,jc) = fine(lratx*ic,lraty*jc)
         end do
      end do

      end

c :: ----------------------------------------------------------
c :: UTILITY ROUTINE: compute:
c ::             A += alpha*B on subrange
c ::
c :: INPUTS / OUTPUTS:
c ::  a         <=  output array
c ::  b          => input array
c ::  DIMS(a)    => index limits of a array
c ::  DIMS(b)    => index limits of a array
c ::  lo,hi      => index limits of update region
c ::  alpha      => multiplicative factor
c :: ----------------------------------------------------------
c ::
       subroutine FORT_INCRMULT(a,DIMS(a),b,DIMS(b),lo,hi,alpha)

       integer    DIMDEC(a)
       integer    DIMDEC(b)
       integer    lo(2), hi(2)
       REAL_T     alpha
       REAL_T     a(DIMV(a))
       REAL_T     b(DIMV(b))

       integer i, j

       do j = lo(2), hi(2)
          do i = lo(1), hi(1)
             a(i,j) = a(i,j) + alpha*b(i,j)
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: SUMMASS
c ::             MASS = sum{ vol(i,j)*rho(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  rho        => density field
c ::  DIMS(rho)  => index limits of rho aray
c ::  lo,hi      => index limits of grid interior
c ::  dx	 => cell size
c ::  mass      <=  total mass
c ::  r		 => radius at cell center
c ::  irlo,hi    => index limits of r array
c ::  rz_flag    => == 1 if R_Z coords
c ::  tmp        => temp column array
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMMASS(rho,DIMS(rho),DIMS(grid),dx,mass,
     &                         r,irlo,irhi,rz_flag,tmp)

       integer irlo, irhi, rz_flag
       integer DIMDEC(rho)
       integer DIMDEC(grid)
       REAL_T  mass, dx(2)
       REAL_T  rho(DIMV(rho))
       REAL_T  r(irlo:irhi)
       REAL_T  tmp(DIM2(grid))

       integer i, j
       REAL_T  dr, dz, vol

       dr = dx(1)
       dz = dx(2)

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do i = ARG_L1(grid), ARG_H1(grid)
          vol = dr*dz
	  if (rz_flag .eq. 1) vol = vol*two*Pi*r(i)
          do j = ARG_L2(grid), ARG_H2(grid)
	     tmp(j) = tmp(j) + vol*rho(i,j)
	  end do
       end do

       mass = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          mass = mass + tmp(j)
       end do

       end

c :: ----------------------------------------------------------
c :: SUMMASSSQ
c ::             MASS = sum{ vol(i,j)*rho(i,j)*rho(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  rho        => density field
c ::  DIMS(rho)  => index limits of rho aray
c ::  lo,hi      => index limits of grid interior
c ::  ds   	 => cell size
c ::  mass      <=  total mass
c ::  r		 => radius at cell center
c ::  irlo,hi    => index limits of r array
c ::  rz_flag    => == 1 if R_Z coords
c ::  tmp        => temp column array
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMMASSSQ(rho,DIMS(rho),DIMS(grid),dx,mass,
     &                           r,irlo,irhi,rz_flag,tmp)

       integer irlo, irhi, rz_flag
       integer DIMDEC(rho)
       integer DIMDEC(grid)
       REAL_T  mass, dx(SDIM)
       REAL_T  rho(DIMV(rho))
       REAL_T  r(irlo:irhi)
       REAL_T  tmp(DIM2(grid))

       integer i, j
       REAL_T  dr, dz, vol

       dr = dx(1)
       dz = dx(2)

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do i = ARG_L1(grid), ARG_H1(grid)
          vol = dr*dz
	  if (rz_flag .eq. 1) vol = vol*two*Pi*r(i)
          do j = ARG_L2(grid), ARG_H2(grid)
             tmp(j) = tmp(j) + vol*rho(i,j)*rho(i,j)
          end do
       end do

       mass = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          mass = mass + tmp(j)
       end do

       end

c :: ----------------------------------------------------------
c :: SUMPRESS
c ::             SUM = sum{ press(i,j) * surroundingVolume(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  press      => pressure field on nodes
c ::  DIMS(press)=> index limits of press aray
c ::  vol        => volume field (zero-ed out under finer grids)
c ::  DIMS(vol)  => index limits of vol aray
c ::  lo,hi      => index limits of grid interior in nodal space
c ::  total_press<= sum of volume-weighted nodal pressures
c ::  total_vol  <= sum of volumes
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMPRESS(press,DIMS(press),vol,DIMS(vol),lo,hi,
     $                          total_press,total_vol)

       integer lo(2),hi(2)
       integer DIMDEC(press)
       integer DIMDEC(vol)
       REAL_T  press(DIMV(press))
       REAL_T  vol(DIMV(vol))
       REAL_T  total_press,total_vol

       integer i, j
       REAL_T  surroundingVolume

       do j = lo(2),hi(2)
          do i = lo(1),hi(1)

             surroundingVolume = vol(i,j) + vol(i-1,j) + vol(i,j-1) + vol(i-1,j-1)
             total_press = total_press + press(i,j) * surroundingVolume
             total_vol   = total_vol   +              surroundingVolume

          end do
       end do

       end


c ::
c :: ----------------------------------------------------------
c :: This routine fills an edge-centered fab from a cell-centered
c :: fab using simple linear interpolation.
c ::
c :: INPUTS / OUTPUTS:
c ::  lo,hi      => index limits of the of the cell-centered fab
c ::  DIMS(cfab) => index limits of the cell-centered fab
c ::  cfab       => cell-centered data
c ::  DIMS(efab) => index limits of the edge-centered fab
c ::  efab       => edge-centered fab to fill
c ::  nc         => Number of components in the fab to fill
c ::  dir        => direction data needs to be shifted to get to edges
c :: ----------------------------------------------------------
c ::
      subroutine FORT_CEN2EDG(lo, hi, 
     &     DIMS(cfab), cfab,
     &     DIMS(efab), efab, nc, dir,
     &     isharm)
      integer lo(SDIM), hi(SDIM), nc, dir, isharm
      integer DIMDEC(cfab)
      integer DIMDEC(efab)
      REAL_T  cfab(DIMV(cfab), nc)
      REAL_T  efab(DIMV(efab), nc)

      integer i,j,n

      if ( isharm .eq. 0 ) then
         if (dir .EQ. 0) then
            do n = 1,nc
               do j = lo(2), hi(2)
                  do i = lo(1)+1, hi(1)
                     efab(i,j,n) = half*(cfab(i,j,n) + cfab(i-1,j,n))
                  end do
               end do
            end do
         else
            do n = 1,nc
               do j = lo(2)+1, hi(2)
                  do i = lo(1), hi(1)
                     efab(i,j,n) = half*(cfab(i,j,n) + cfab(i,j-1,n))
                  end do
               end do
            end do
         end if
      else
         if (dir .EQ. 0) then
            do n = 1,nc
               do j = lo(2), hi(2)
                  do i = lo(1)+1, hi(1)
                     if((cfab(i,j,n) * cfab(i-1,j,n)).gt.0.d0)then
                        efab(i,j,n)
     &                       = 2.d0*(cfab(i,j,n) * cfab(i-1,j,n))/
     &                       (cfab(i,j,n) + cfab(i-1,j,n))
                     else
                        efab(i,j,n)=0.d0
                     endif
                  end do
               end do
            end do
         else
            do n = 1,nc
               do j = lo(2)+1, hi(2)
                  do i = lo(1), hi(1)
                     if((cfab(i,j,n) * cfab(i,j-1,n)).gt.0.d0)then
                        efab(i,j,n)
     &                       = 2.d0*(cfab(i,j,n) * cfab(i,j-1,n))/
     &                       (cfab(i,j,n) + cfab(i,j-1,n))
                     else
                        efab(i,j,n)=0.d0
                     endif
                  end do
               end do
            end do
         end if
      end if
      end

c-----------------------------------------------------------------------
      subroutine EDGE_INTERP(flo, fhi, nc, ratio, dir,
     &     fine, fine_l0, fine_l1, fine_h0, fine_h1)
      implicit none
      integer flo(0:2-1), fhi(0:2-1), nc, ratio(0:2-1), dir
      integer fine_l0, fine_l1, fine_h0, fine_h1
      DOUBLE PRECISION fine(fine_l0:fine_h0,fine_l1:fine_h1,nc)
      integer i,j,ii,jj,n,P,M,clo(0:2-1),chi(0:2-1)
      DOUBLE PRECISION val, df

c     Do linear in dir, pc transverse to dir, leave alone the fine values
c     lining up with coarse edges--assume these have been set to hold the 
c     values you want to interpolate to the rest.
      if (dir.eq.0) then
         do n=1,nc
            do j=flo(1),fhi(1),ratio(1)
               do i=flo(0),fhi(0)-ratio(dir),ratio(0)
                  df = fine(i+ratio(dir),j,n)-fine(i,j,n)
                  do M=1,ratio(dir)-1
                     val = fine(i,j,n) + df*dble(M)/dble(ratio(dir))
                     do P=MAX(j,flo(1)),MIN(j+ratio(1)-1,fhi(1))
                        fine(i+M,P,n) = val
                     enddo
                  enddo                     
               enddo
            enddo
         enddo
      else
         do n=1,nc
            do j=flo(1),fhi(1)-ratio(dir),ratio(1)
               do i=flo(0),fhi(0)
                  df = fine(i,j+ratio(dir),n)-fine(i,j,n)
                  do M=1,ratio(dir)-1
                     val = fine(i,j,n) + df*dble(M)/dble(ratio(dir))
                     do P=MAX(i,flo(0)),MIN(i+ratio(0)-1,fhi(0))
                        fine(P,j+M,n) = val
                     enddo
                  enddo
               enddo
            enddo
         enddo
      endif

      end
c-----------------------------------------------------------------------
      subroutine PC_EDGE_INTERP(lo, hi, nc, ratio, dir,
     &     crse, crse_l0, crse_l1, crse_h0, crse_h1,
     &     fine, fine_l0, fine_l1, fine_h0, fine_h1)
      implicit none
      integer lo(2),hi(2), nc, ratio(0:2-1), dir
      integer crse_l0, crse_l1, crse_h0, crse_h1
      integer fine_l0, fine_l1, fine_h0, fine_h1
      DOUBLE PRECISION crse(crse_l0:crse_h0,crse_l1:crse_h1,nc)
      DOUBLE PRECISION fine(fine_l0:fine_h0,fine_l1:fine_h1,nc)
      integer i,j,ii,jj,n,L
      DOUBLE PRECISION val, dc

c     For edge-based data, fill fine values with piecewise-constant interp of coarse data.
c     Operate only on faces that overlap--ie, only fill the fine faces that make up each
c     coarse face, leave the in-between faces alone.
      if (dir.eq.0) then
         do n=1,nc
            do j=lo(2),hi(2)
               jj = ratio(1)*j
               do i=lo(1),hi(1)
                  ii = ratio(0)*i
                  do L=0,ratio(1)-1
                     fine(ii,jj+L,n) = crse(i,j,n)
                  enddo
               enddo
            enddo
         enddo
      else
         do n=1,nc
            do j=lo(2),hi(2)
               jj = ratio(1)*j
               do i=lo(1),hi(1)
                  ii = ratio(0)*i
                  do L=0,ratio(0)-1
                     fine(ii+L,jj,n) = crse(i,j,n)
                  enddo
               enddo
            enddo
         enddo
      endif

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: HYPERCLAW_3D.F,v 1.2 1999/04/02 19:28:19 car Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "HYPERCLAW_F.H"
#include "ArrayLim.H"
#include "integrator.fh"

#define SDIM 3

c :: 
c :: ----------------------------------------------------------
c :: estimate the timestep for this grid r
c :: 
c :: INPUTS/OUTPUTS
c :: state      =>  state array
c :: slo,shi    =>  index limits of state array
c :: c          =>   c array 
c :: clo,chi    =>  index limits of c array
c :: delta      =>  cell size
c :: dt        <=   timestep estimate
c :: 
c :: ----------------------------------------------------------
c :: 

      subroutine FORT_ESTDT (state,DIMS(s),c,DIMS(c),lo,hi,delta,dt,nv)

      integer   nv
      integer lo(SDIM), hi(SDIM)
      integer   DIMDEC(s)
      integer   DIMDEC(c)
      REAL_T    dt
      REAL_T    delta(SDIM)
      REAL_T 	state(DIMV(s),nv)
      REAL_T 	c(DIMV(c))

      integer   i, j, k, is,ie,js,je, ks,ke
      REAL_T    ux,uy,uz,dt1,dt2,dt3,dx,dy, dz
      REAL_T    small,gdum,pdum,csdum
 
      is = lo(1)
      js = lo(2)
      ks = lo(3)
      ie = hi(1)
      je = hi(2)
      ke = hi(3)

      dx = delta(1)
      dy = delta(2)
      dz = delta(3)

      dt = bigreal
      do k = ks, ke         
         do j = js, je         
            do i = is, ie             
               ux = state(i,j,k,2)/state(i,j,k,1)
               uy = state(i,j,k,3)/state(i,j,k,1)
               uz = state(i,j,k,4)/state(i,j,k,1)
               state(i,j,k,5) = state(i,j,k,5)/state(i,j,k,1) -
     $              half*(ux**2 + uy**2 + uz**2)
               state(i,j,k,6) = state(i,j,k,6)/state(i,j,k,1)
            end do
         end do
      end do
      call eos(state(is,js,ks,1),state(is,js,ks,5),state(is,js,ks,6),
     $     DIMS(s),
     $     gdum,pdum,c,csdum,
     $     DIMS(c),
     $     lo, hi,0,0,1,0)
      do k = ks, ke           
         do j = js, je           
            do i = is, ie         
               ux = abs(state(i,j,k,2))/state(i,j,k,1)
               uy = abs(state(i,j,k,3))/state(i,j,k,1)
               uz = abs(state(i,j,k,4))/state(i,j,k,1)
               dt1 = dx/(c(i,j,k) + ux)
               dt2 = dy/(c(i,j,k) + uy)
               dt3 = dz/(c(i,j,k) + uz)
               dt = min(dt,dt1,dt2,dt3)
            end do
         end do
      end do

      end

c :: ----------------------------------------------------------
c :: Volume-weight average the fine grid data onto the coarse
c :: grid.  Overlap is given in coarse grid coordinates.
c ::
c :: INPUTS / OUTPUTS:
c ::  crse      <=  coarse grid data
c ::  clo,chi    => index limits of crse array interior
c ::  ngc        => number of ghost cells in coarse array
c ::  nvar	 => number of components in arrays
c ::  fine       => fine grid data
c ::  flo,fhi    => index limits of fine array interior
c ::  ngf        => number of ghost cells in fine array
c ::  rfine      => (ignore) used in 2-D RZ calc
c ::  lo,hi      => index limits of overlap (crse grid)
c ::  lrat       => refinement ratio
c ::
c :: NOTE:
c ::  Assumes all data cell centered
c :: ----------------------------------------------------------
c ::
      subroutine FORT_AVGDOWN (crse,DIMS(c),nvar,cv,DIMS(cv),
     &                         fine,DIMS(f),fv,DIMS(fv),lo,hi,lrat)
      integer  DIMDEC(c)
      integer  DIMDEC(cv)
      integer  DIMDEC(f)
      integer  DIMDEC(fv)
      integer  lo(SDIM), hi(SDIM)
      integer  nvar, lrat(SDIM)
      REAL_T   crse(DIMV(c),nvar)
      REAL_T   cv(DIMV(cv))
      REAL_T   fine(DIMV(f),nvar)
      REAL_T   fv(DIMV(fv))

      integer  i, j, k, n, ic, jc, kc, ioff, joff, koff
      integer  lenx, leny, lenz, mxlen
      integer  lratx, lraty, lratz

      REAL_T   volfrac

      lratx = lrat(1)
      lraty = lrat(2)
      lratz = lrat(3)
      lenx = hi(1)-lo(1)+1
      leny = hi(2)-lo(2)+1
      lenz = hi(3)-lo(3)+1
      mxlen = max(lenx,leny,lenz)
      volfrac = one/float(lrat(1)*lrat(2)*lrat(3))

      if (lenx .eq. mxlen) then
         do n = 1, nvar
c
c         ::::: set coarse grid to zero on overlap
c
            do kc = lo(3), hi(3)
               do jc = lo(2), hi(2)
                  do ic = lo(1), hi(1)
                     crse(ic,jc,kc,n) = zero
                  enddo
               enddo
            enddo
c
c         ::::: sum fine data
c
            do koff = 0, lratz-1
               do kc = lo(3),hi(3)
                  k = kc*lratz + koff
                  do joff = 0, lraty-1
                     do jc = lo(2), hi(2)
                        j = jc*lraty + joff
                        do ioff = 0, lratx-1
                           do ic = lo(1), hi(1)
                              i = ic*lratx + ioff
                              crse(ic,jc,kc,n) = crse(ic,jc,kc,n) + fine(i,j,k,n)
                           enddo
                        enddo
                     enddo
                  enddo
               enddo
            enddo
c            
c         ::::: divide out by volume weight
c
            do kc = lo(3), hi(3)
               do jc = lo(2), hi(2)
                  do ic = lo(1), hi(1)
                     crse(ic,jc,kc,n) = volfrac*crse(ic,jc,kc,n)
                  enddo
               enddo
            enddo
            
         end do

      else if (leny .eq. mxlen) then

         do n = 1, nvar
c
c         ::::: set coarse grid to zero on overlap
c
            do kc = lo(3), hi(3)
               do ic = lo(1), hi(1)
                  do jc = lo(2), hi(2)
                     crse(ic,jc,kc,n) = zero
                  enddo
               enddo
            enddo
c
c         ::::: sum fine data
c
            do koff = 0, lratz-1
               do kc = lo(3), hi(3)
                  k = kc*lratz + koff
                  do ioff = 0, lratx-1
                     do ic = lo(1), hi(1)
                        i = ic*lratx + ioff
                        do joff = 0, lraty-1
                           do jc = lo(2), hi(2)
                              j = jc*lraty + joff
                              crse(ic,jc,kc,n) = crse(ic,jc,kc,n) + fine(i,j,k,n)
                           enddo
                        enddo
                     enddo
                  enddo
               enddo
            enddo
c            
c         ::::: divide out by volume weight
c
            do kc = lo(3), hi(3)
               do ic = lo(1), hi(1)
                  do jc = lo(2), hi(2)
                     crse(ic,jc,kc,n) = volfrac*crse(ic,jc,kc,n)
                  enddo
               enddo
            enddo
            
         end do

      else

         do n = 1, nvar
c
c         ::::: set coarse grid to zero on overlap
c
            do ic = lo(1), hi(1)
               do jc = lo(2), hi(2)
                  do kc = lo(3), hi(3)
                     crse(ic,jc,kc,n) = zero
                  enddo
               enddo
            enddo
c
c         ::::: sum fine data
c
            do joff = 0, lraty-1
               do jc = lo(2), hi(2)
                  j = jc*lraty + joff
                  do ioff = 0, lratx-1
                     do ic = lo(1), hi(1)
                        i = ic*lratx + ioff
                        do koff = 0, lratz-1
                           do kc = lo(3), hi(3)
                              k = kc*lratz + koff
                              crse(ic,jc,kc,n) = crse(ic,jc,kc,n) + fine(i,j,k,n)
                           enddo
                        enddo
                     enddo
                  enddo
               enddo
            enddo
c            
c         ::::: divide out by volume weight
c
            do jc = lo(2), hi(2)
               do ic = lo(1), hi(1)
                  do kc = lo(3), hi(3)
                     crse(ic,jc,kc,n) = volfrac*crse(ic,jc,kc,n)
                  enddo
               enddo
            enddo
            
         end do

      end if

      end


c :: ----------------------------------------------------------
c :: SUMMASS
c ::             MASS = sum{ vol(i,j)*rho(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  rho        => density field
c ::  rlo,rhi    => index limits of rho aray
c ::  lo,hi      => index limits of grid interior
c ::  delta      => cell size
c ::  mass      <=  total mass
c ::  r          => radius at cell center
c ::  irlo,hi    => index limits of r array
c ::  rz_flag    => == 1 if R_Z coords
c ::  tmp        => temp column array
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMMASS(rho,DIMS(r),lo,hi,delta,mass,
     &                         r,irlo,irhi,rz_flag,tmp, tlo, thi)
       integer irlo, irhi, rz_flag
       integer DIMDEC(r)
       integer lo(SDIM), hi(SDIM)
       REAL_T  mass, delta(SDIM)
       REAL_T  rho(DIMV(r))
       REAL_T  r(irlo:irhi)
       integer tlo, thi
       REAL_T  tmp(tlo:thi)

       integer i, j, k
       REAL_T  dx, dy, dz, vol

       dx = delta(1)
       dy = delta(2)
       dz = delta(3)
       vol = dx*dy*dz

       do j = lo(2),hi(2)
          tmp(j) = zero
       enddo

       do k = lo(3), hi(3)
          do i = lo(1), hi(1)
             do j = lo(2), hi(2)
                tmp(j) = tmp(j) + vol*rho(i,j,k)
             enddo
          enddo
       enddo

       mass = zero
       do j = lo(2), hi(2)
          mass = mass + tmp(j)
       enddo

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: FLUXREG_1D.F,v 1.2 2002/11/14 23:04:56 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "FLUXREG_F.H"
#include "ArrayLim.H"

#define SDIM 1

c ::: -----------------------------------------------------------
c ::: Init coarse grid flux into flux register
c :::
c ::: INPUTS/OUTPUTS:
c ::: flx        => flux array
c ::: DIMS(flx)  => index limits for flx
c ::: reg       <=  flux register
c ::: DIMS(reg)  => index limits for reg
c ::: lo,hi      => region of update
c ::: mult       => scalar multiplicative factor
c ::: -----------------------------------------------------------

      subroutine FORT_FRCRSEINIT (reg,DIMS(reg),flx,DIMS(flx),lo,hi,
     &                            numcomp,dir,mult)
      integer    DIMDEC(reg)
      integer    DIMDEC(flx)
      integer    lo(SDIM), hi(SDIM)
      integer    numcomp, dir
      REAL_T     mult
      REAL_T     reg(DIMV(reg),numcomp)
      REAL_T     flx(DIMV(flx),numcomp)

      integer    n, i, lenx

      lenx = hi(1)-lo(1)+1
      do n = 1, numcomp
         do i = lo(1), hi(1)
            reg(i,n) =  mult*flx(i,n)
         end do
      end do

      return
      end

c ::: -----------------------------------------------------------
c ::: Init coarse grid flux (times area) into flux register
c :::
c ::: INPUTS/OUTPUTS:
c ::: flx        => flux array
c ::: DIMS(flx)  => index limits for flx
c ::: reg       <=  flux register
c ::: DIMS(reg)  => index limits for reg
c ::: area       => aread of cell edge
c ::: DIMS(area) => index limits for area
c ::: lo,hi      => region of update
c ::: mult       => scalar multiplicative factor
c ::: -----------------------------------------------------------

      subroutine FORT_FRCAINIT (reg,DIMS(reg),flx,DIMS(flx),
     &                          area,DIMS(area),lo,hi,
     &                          numcomp,dir,mult)
      integer    DIMDEC(reg)
      integer    DIMDEC(flx)
      integer    DIMDEC(area)
      integer    lo(SDIM), hi(SDIM)
      integer    numcomp, dir
      REAL_T     mult
      REAL_T     reg(DIMV(reg),numcomp)
      REAL_T     flx(DIMV(flx),numcomp)
      REAL_T    area(DIMV(area))

      integer    n, i, lenx

      lenx = hi(1)-lo(1)+1
      do n = 1, numcomp
         do i = lo(1), hi(1)
            reg(i,n) = mult*area(i)*flx(i,n)
         end do
      end do

      return
      end

c ::: -----------------------------------------------------------
c ::: Add fine grid flux to flux register.  Flux array is a fine grid
c ::: edge based object, Register is a coarse grid edge based object.
c ::: It is assumed that the coarsened flux region contains the register
c ::: region.
c :::
c ::: INPUTS/OUTPUTS:
c ::: reg       <=> edge centered coarse grid flux register
c ::: DIMS(reg)  => index limits for reg
c ::: flx        => edge centered fine grid flux array
c ::: DIMS(flx)  => index limits for flx
c ::: numcomp    => number of components to update
c ::: dir        => direction normal to flux register
c ::: ratio(2)   => refinement ratios between coarse and fine
c ::: mult       => scalar multiplicative factor
c ::: -----------------------------------------------------------

      subroutine FORT_FRFINEADD(reg,DIMS(reg),flx,DIMS(flx),
     &                          numcomp,dir,ratio,mult)
      integer    DIMDEC(reg)
      integer    DIMDEC(flx)
      integer    ratio(1), dir, numcomp
      REAL_T     mult
      REAL_T     reg(DIMV(reg),numcomp)
      REAL_T     flx(DIMV(flx),numcomp)

      integer    n, i, ic
      integer    ratiox

      ratiox = ratio(1)

      if (dir .eq. 0) then
c        ::::: flux normal to X direction
         ic = ARG_L1(reg)
         i = ic*ratiox
         if (ARG_L1(reg) .ne. ARG_H1(reg)) then
            call bl_abort("FORT_FRFINEADD: bad register direction")
         end if
         if (i .lt. ARG_L1(flx) .or. i .gt. ARG_H1(flx)) then
            call bl_abort("FORT_FRFINEADD: index outside flux range")
         end if
         do n = 1, numcomp
            reg(ic,n) = reg(ic,n) + mult*flx(i,n)
         end do
      end if

      return
      end

c ::: -----------------------------------------------------------
c ::: Add fine grid flux times area to flux register.
c ::: Flux array is a fine grid edge based object, Register is a
c ::: coarse grid edge based object.
c ::: It is assumed that the coarsened flux region contains the register
c ::: region.
c :::
c ::: INPUTS/OUTPUTS:
c ::: reg       <=> edge centered coarse grid flux register
c ::: rlo,rhi    => index limits for reg
c ::: flx        => edge centered fine grid flux array
c ::: DIMS(flx)  => index limits for flx
c ::: area       => edge centered area array
c ::: DIMS(area) => index limits for area
c ::: numcomp    => number of components to update
c ::: dir        => direction normal to flux register
c ::: ratio(2)   => refinements ratio between coarse and fine
c ::: mult       => scalar multiplicative factor
c ::: -----------------------------------------------------------

      subroutine FORT_FRFAADD(reg,DIMS(reg),flx,DIMS(flx),area,DIMS(area),
     &                        numcomp,dir,ratio,mult)
      integer    DIMDEC(reg)
      integer    DIMDEC(flx)
      integer    DIMDEC(area)
      integer    ratio(1), dir, numcomp
      REAL_T     mult
      REAL_T     reg(DIMV(reg),numcomp)
      REAL_T     flx(DIMV(flx),numcomp)
      REAL_T     area(DIMV(area))

      integer    n, i, ic
      integer    ratiox

      ratiox = ratio(1)

      if (dir .eq. 0) then
c        ::::: flux normal to X direction
         ic = ARG_L1(reg)
         i = ic*ratiox
         if (ARG_L1(reg) .ne. ARG_H1(reg)) then
            call bl_abort("FORT_FRFAADD: bad register direction")
         end if
         if (i .lt. ARG_L1(flx) .or. i .gt. ARG_H1(flx)) then
            call bl_abort("FORT_FRFAADD: index outside flux range")
         end if
         do n = 1, numcomp
            reg(ic,n) = reg(ic,n) + mult*area(i)*flx(i,n)
         end do
      end if

      return
      end

c ::
c :: --------------------------------------------------------------
c :: reflux:   reflux the data on the outer boundary of
c ::           a fine grid.
c ::
c :: Inputs/Outputs
c :: s           <=>  state data array
c :: slo,shi      =>  index limits of s array
c :: vol          =>  volume array
c :: vlo,vhi      =>  index limits of vol array
c :: reg          =>  flux register
c :: rlo,rhi      =>  index limits of reg array
c :: lo,hi        =>  subregion of s array to be updated
c :: numcomp      =>  number of components to update
c :: mult         =>  multiplative factor (+1 or -1 depending on nomal)
c :: --------------------------------------------------------------
c ::
      subroutine FORT_FRREFLUX (s,DIMS(s),vol,DIMS(vol),reg,DIMS(reg),lo,hi,
     &                          numcomp,mult)
      integer    DIMDEC(s)
      integer    DIMDEC(vol)
      integer    DIMDEC(reg)
      integer    lo(SDIM), hi(SDIM)
      integer    numcomp
      REAL_T     mult
      REAL_T     reg(DIMV(reg),numcomp)
c :: For Multifluid reg is defined as: REAL_T reg(DIMV(reg),numcomp+FLUX_EXTRA)
      REAL_T       s(DIMV(s),numcomp)
      REAL_T     vol(DIMV(vol))

      integer n, i, lenx
      lenx = hi(1) - lo(1) + 1

      do n = 1, numcomp
         do i = lo(1), hi(1)
            s(i,n) = s(i,n) + mult*reg(i,n)/vol(i)
         end do
      end do

      return
      end

c ::
c :: --------------------------------------------------------------
c :: cvreflux:   constant volume version of reflux
c ::
c :: Inputs/Outputs
c :: s           <=>  state data array
c :: slo,shi      =>  index limits of s array
c :: dx           =>  cell size
c :: reg          =>  flux register
c :: rlo,rhi      =>  index limits of reg array
c :: lo,hi        =>  subregion of s array to be updated
c :: numcomp      =>  number of components to update
c :: mult         =>  multiplative factor (+1 or -1 depending on nomal)
c :: --------------------------------------------------------------
c ::
      subroutine FORT_FRCVREFLUX (s,DIMS(s),dx,reg,DIMS(reg),lo,hi,
     &                            numcomp,mult)
      integer    DIMDEC(s)
      integer    DIMDEC(reg)
      integer    lo(SDIM), hi(SDIM)
      integer    numcomp
      REAL_T     mult, dx(SDIM)
      REAL_T     reg(DIMV(reg),numcomp)
c :: For Multifluid reg is defined as: REAL_T reg(DIMV(reg),numcomp+FLUX_EXTRA)
      REAL_T       s(DIMV(s),numcomp)

      integer n, i, lenx
      REAL_T vol

      vol = dx(1)
      lenx = hi(1) - lo(1) + 1

      do n = 1, numcomp
         do i = lo(1), hi(1)
            s(i,n) = s(i,n) + mult*reg(i,n)/vol
         end do
      end do

      return
      end


c ::: -----------------------------------------------------------
c ::: Add flux register into coarse grid flux (opposite of standard reflux ops)
c :::
c ::: INPUTS/OUTPUTS:
c ::: flx        => flux array
c ::: DIMS(flx)  => index limits for flx
c ::: reg       <=  flux register
c ::: DIMS(reg)  => index limits for reg
c ::: lo,hi      => region of update
c ::: mult       => scalar multiplicative factor
c ::: -----------------------------------------------------------

      subroutine FORT_SCALADDTO (flx,DIMS(flx),area,DIMS(area),reg,DIMS(reg),
     $                           lo,hi,numcomp,mult)

      integer    DIMDEC(flx)
      integer    DIMDEC(area)
      integer    DIMDEC(reg)
      integer    lo(SDIM), hi(SDIM)
      integer    numcomp
      REAL_T     mult
      REAL_T     flx(DIMV(flx),numcomp)
      REAL_T     area(DIMV(area))
      REAL_T     reg(DIMV(reg),numcomp)

      integer    n, i, istart

      if (area(lo(1)) .lt. 1.d-8) then
        do n = 1, numcomp
           flx(lo(1),n) = flx(lo(1),n)
        end do
        istart = lo(1)+1
      else
        istart = lo(1)
      end if

      do n = 1, numcomp
        do i = istart, hi(1)
          flx(i,n) = flx(i,n) + mult*reg(i,numcomp)/area(i)
        end do
      end do

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "ArrayLim.H"

#define SDIM 3

      subroutine TRANSV(v,DIMS(v),dx,domnlo,
     &     avVR,avVT,avVZ,avC,Nbin,DIMS(av),maxbin,bsize,
     &     flVR,flVT,flVZ,flC)
      implicit none
      integer DIMDEC(v)
      integer DIMDEC(av)
      REAL_T  v(DIMV(v),SDIM+2)
      REAL_T avVR(DIMV(av))
      REAL_T avVT(DIMV(av))
      REAL_T avVZ(DIMV(av))
      REAL_T  avC(DIMV(av))
      REAL_T flVR(DIMV(av))
      REAL_T flVT(DIMV(av))
      REAL_T flVZ(DIMV(av))
      REAL_T  flC(DIMV(av))
      integer Nbin(DIMV(av))
      REAL_T dx(SDIM), domnlo(SDIM)
      integer i,j,k,n,bsize,maxbin,bin
      REAL_T x,y,vx,vy,vz,vr,vt,r,st,ct,kk

      kk = ARG_L3(av)
      do j=ARG_L2(v),ARG_H2(v)

         do n=0,maxbin
            Nbin(j,n,kk) = 0
            flVR(j,n,kk) = 0.d0
            flVT(j,n,kk) = 0.d0
            flVZ(j,n,kk) = 0.d0
            flC(j,n,kk)  = 0.d0
         enddo

         do k=ARG_L3(v),ARG_H3(v)
            y = (float(k)+0.5d0)*dx(3)+domnlo(3)
            do i=ARG_L1(v),ARG_H1(v)
               x = (float(i)+0.5d0)*dx(1)+domnlo(1)

               vx = v(i,j,k,1)*1.d-2
               vy = v(i,j,k,3)*1.d-2
               vz = v(i,j,k,2)*1.d-2

               r = SQRT(x*x + y*y)
               if (r.le.2.5d0) then

                  bin = INT(r/(bsize*dx(1)))

                  if (r.lt.1.d-10) then
                     print *,'PUKE! illdefined if r=0'
                     call bl_abort(" ")
                  else
                     st = y / r
                     ct = x / r
                     vr = vx*ct + vy*st
                     vt = vy*ct - vx*st
                  endif
                  
               else 

                  bin = -1
                  vr = 0.d0
                  vt = 0.d0

               endif

               if (bin.gt.maxbin) call bl_abort('...maxbin not enough!')

               if (bin.ge.0) then
                  flVR(j,bin,kk) = flVR(j,bin,kk) + (vr - avVR(j,bin,kk))**2
                  flVT(j,bin,kk) = flVT(j,bin,kk) + (vt - avVT(j,bin,kk))**2
                  flVZ(j,bin,kk) = flVZ(j,bin,kk) + (vz - avVZ(j,bin,kk))**2
                  flC(j,bin,kk) = flC(j,bin,kk)
     &                 + (v(i,j,k,5)/v(i,j,k,4) - avC(j,bin,kk))**2
                  Nbin(j,bin,kk) = Nbin(j,bin,kk) + 1
               endif

            enddo
         enddo

      enddo

      end


      subroutine NORMV(flVR,flVT,flVZ,flC,Nbin,DIMS(av))
      integer DIMDEC(av)
      REAL_T flVR(DIMV(av))
      REAL_T flVT(DIMV(av))
      REAL_T flVZ(DIMV(av))
      REAL_T flC(DIMV(av))
      integer Nbin(DIMV(av))

      
      kk = ARG_L3(av)
      do i=ARG_L1(av),ARG_H1(av)
         do n=ARG_L2(av),ARG_H2(av)
            flVR(i,n,kk) = SQRT(flVR(i,n,kk)/Nbin(i,n,kk))
            flVT(i,n,kk) = SQRT(flVT(i,n,kk)/Nbin(i,n,kk))
            flVZ(i,n,kk) = SQRT(flVZ(i,n,kk)/Nbin(i,n,kk))
            flC(i,n,kk)  = SQRT(flC(i,n,kk)/Nbin(i,n,kk))
         enddo
      enddo
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "BC_TYPES.H"
#include "REAL.H"
#include "CONSTANTS.H"
#include "MCINTERPBNDRYDATA_F.H"
#include "ArrayLim.H"

#define SDIM 3
#define NUMDERIV 9
#define DX    1
#define DY    2
#define DZ    3
#define D2X   4
#define D2Y   5
#define D2Z   6
#define DXY   7
#define DXZ   8
#define DYZ   9

c ::: CX,CY,CZ are the "component" number for storing derivative information
c ::: see the assignments to bdry at the bottom of each of the subroutines.
c ::: This should be more suggestive of how info is being stored than
c ::: writing plain numbers.
#define CX   1
#define CY   2
#define CZ   3




c ---------------------------------------------------------------
c ::  FORT_BDINTERPXLO : Interpolation on Xlo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),(1+3)*nvar)
      REAL_T   derives(DIM23(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine(BL_SPACEDIM-1)

      REAL_T   yy, zz
      integer  i, j, k, ic, jc, kc, joff, koff, n
      integer  jclo, jchi, kclo, kchi
      REAL_T   hc(3),hf(3)

c ::: ------------ functions ------------------------------
      logical notUsable,Usable
      REAL_T ddxcen,ddx2cen,ddxplus,ddxminus
      REAL_T ddycen,ddy2cen,ddyplus,ddyminus
      REAL_T ddzcen,ddz2cen,ddzplus,ddzminus
      REAL_T ddxdycen,ddxdypp,ddxdypm,ddxdymp,ddxdymm
      REAL_T ddxdzcen,ddxdzpp,ddxdzpm,ddxdzmp,ddxdzmm
      REAL_T ddydzcen,ddydzpp,ddydzpm,ddydzmp,ddydzmm
      logical okxypp,okxypm,okxymp,okxymm,okxycen
      logical okxzpp,okxzpm,okxzmp,okxzmm,okxzcen
      logical okyzpp,okyzpm,okyzmp,okyzmm,okyzcen
      REAL_T ddxlowp,ddxlowm
      REAL_T ddylowp,ddylowm
      REAL_T ddzlowp,ddzlowm

      notUsable(i,j,k) = (mask(i,j,k).ne.not_covered)
      Usable(i,j,k) = (mask(i,j,k).eq.not_covered)

      ddxcen(i,j,k,n) = (crse(i+1,j,k,n)-crse(i-1,j,k,n))/(2*hc(1))
      ddycen(i,j,k,n) = (crse(i,j+1,k,n)-crse(i,j-1,k,n))/(2*hc(2))
      ddzcen(i,j,k,n) = (crse(i,j,k+1,n)-crse(i,j,k-1,n))/(2*hc(3))

      ddx2cen(i,j,k,n)=(crse(i+1,j,k,n)-2*crse(i,j,k,n)+crse(i-1,j,k,n))
     &     /(hc(1)**2)
      ddy2cen(i,j,k,n)=(crse(i,j+1,k,n)-2*crse(i,j,k,n)+crse(i,j-1,k,n))
     &     /(hc(2)**2)
      ddz2cen(i,j,k,n)=(crse(i,j,k+1,n)-2*crse(i,j,k,n)+crse(i,j,k-1,n))
     &     /(hc(3)**2)

      ddxplus(i,j,k,n)=(-crse(i+2,j,k,n)+4*crse(i+1,j,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyplus(i,j,k,n)=(-crse(i,j+2,k,n)+4*crse(i,j+1,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzplus(i,j,k,n)=(-crse(i,j,k+2,n)+4*crse(i,j,k+1,n)-3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxminus(i,j,k,n)=(+crse(i-2,j,k,n)-4*crse(i-1,j,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyminus(i,j,k,n)=(+crse(i,j-2,k,n)-4*crse(i,j-1,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzminus(i,j,k,n)=(+crse(i,j,k-2,n)-4*crse(i,j,k-1,n)+3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxdycen(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i-1,j-1,k,n))/(4*hc(1)*hc(2))
      okxycen(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i-1,j-1,k))
      ddxdypp(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i,j+1,k,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(2))
      okxypp(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i,j+1,k)
     &     .and.Usable(i+1,j,k))
      ddxdypm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i,j-1,k,n))/(4*hc(1)*hc(2))
      okxypm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i,j-1,k))
      ddxdymp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(2))
      okxymp(i,j,k)=(Usable(i,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i-1,j,k))
      ddxdymm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j-1,k,n)+crse(i-1,j-1,k,n))/(hc(1)*hc(2))
      okxymm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j-1,k).and.Usable(i-1,j-1,k))

      ddxdzcen(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i+1,j,k-1,n)+crse(i-1,j,k-1,n))/(4*hc(1)*hc(3))
      okxzcen(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i+1,j,k-1).and.Usable(i-1,j,k-1))
      ddxdzpp(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(3))
      okxzpp(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i+1,j,k))
      ddxdzpm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j,k-1,n)+crse(i,j,k-1,n))/(4*hc(1)*hc(3))
      okxzpm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j,k-1).and.Usable(i,j,k-1))
      ddxdzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(3))
      okxzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i-1,j,k))
      ddxdzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j,k-1,n)+crse(i-1,j,k-1,n))/(hc(1)*hc(3))
      okxzmm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j,k-1).and.Usable(i-1,j,k-1))

      ddydzcen(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j-1,k-1,n))/(4*hc(2)*hc(3))
      okyzcen(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j-1,k-1))
      ddydzpp(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i,j+1,k,n)+crse(i,j,k,n))/(hc(2)*hc(3))
      okyzpp(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i,j+1,k))
      ddydzpm(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j,k-1,n))/(4*hc(2)*hc(3))
      okyzpm(i,j,k)=(Usable(i,j+1,k)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j,k-1))
      ddydzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j,k,n)+crse(i,j-1,k,n))/(hc(2)*hc(3))
      okyzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j-1,k))
      ddydzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i,j-1,k,n)
     &     -crse(i,j,k-1,n)+crse(i,j-1,k-1,n))/(hc(2)*hc(3))
      okyzmm(i,j,k)=(Usable(i,j-1,k)
     &     .and.Usable(i,j,k-1).and.Usable(i,j-1,k-1))

      ddxlowp(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n))/hc(1)
      ddylowp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n))/hc(2)
      ddzlowp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j,k,n))/hc(3)

      ddxlowm(i,j,k,n)=(-crse(i-1,j,k,n)+crse(i,j,k,n))/hc(1)
      ddylowm(i,j,k,n)=(-crse(i,j-1,k,n)+crse(i,j,k,n))/hc(2)
      ddzlowm(i,j,k,n)=(-crse(i,j,k-1,n)+crse(i,j,k,n))/hc(3)
c ::: ------------ functions ------------------------------

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_L1(cb)-1
      i    = lo(1)-1
c ::: :::
      hf(1) = 0
      hf(2) = hfine(1)
      hf(3) = hfine(2)
      hc(1) = 0
      hc(2) = hfine(1)*ratio
      hc(3) = hfine(2)*ratio
c ::: :::

      do n = 1, nvar
c     ::::: calculate derivatives for interpolation
         do kc = kclo, kchi
            k = ratio*kc
            do jc = jclo, jchi
               j = ratio*jc

               derives(jc,kc,DY) = ddycen(ic,jc,kc,n)
               derives(jc,kc,D2Y) = ddy2cen(ic,jc,kc,n)

               if( notUsable(i,j-1,k) .and. notUsable(i,j+ratio,k)  ) then
                  derives(jc,kc,DY)  = zero
                  derives(jc,kc,D2Y) = zero
               else if( notUsable(i,j-1,k) .and. Usable(i,j+ratio,k) ) then
c     :::: :::: : positive side usable
                  if( jc+2.le.jchi+1 ) then
                     if( Usable(i,j+2*ratio,k) ) then
                        derives(jc,kc,DY)=ddyplus(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=ddy2cen(ic,jc+1,kc,n)
                     else
                        derives(jc,kc,DY)=ddylowp(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=zero
                     endif
                  else
                     derives(jc,kc,DY)=ddylowp(ic,jc,kc,n)
                     derives(jc,kc,D2Y)=zero
                  endif
               else if( Usable(i,j-1,k) .and. notUsable(i,j+ratio,k) ) then
c     :::: :::: : negative side usable
                  if( jc-2.ge.jclo-1 ) then
                     if( Usable(i,j-1,k) ) then
                        derives(jc,kc,DY)=ddyminus(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=ddy2cen(ic,jc-1,kc,n)
                     else
                        derives(jc,kc,DY)=ddylowm(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=zero
                     endif
                  else
                     derives(jc,kc,DY)=ddylowm(ic,jc,kc,n)
                     derives(jc,kc,D2Y)=zero
                  endif
               endif

               derives(jc,kc,DZ)  = ddzcen(ic,jc,kc,n)
               derives(jc,kc,D2Z) = ddz2cen(ic,jc,kc,n)

               if( notUsable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
                  derives(jc,kc,DZ)  = zero
                  derives(jc,kc,D2Z) = zero
               else if( notUsable(i,j,k-1) .and. Usable(i,j,k+ratio)) then
c     :::: :::: : positive size usable
                  if( kc+2.le.kchi+1 ) then
                     if( Usable(i,j,k+2*ratio) ) then
                        derives(jc,kc,DZ)  = ddzplus(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  ddz2cen(ic,jc,kc+1,n)
                     else
                        derives(jc,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  zero
                     endif
                  else
                     derives(jc,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                     derives(jc,kc,D2Z) =  zero
                  endif
               else if( Usable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
c     :::: :::: : negative size usable
                  if( kc-2.ge.kclo-1 ) then
                     if( Usable(i,j,k-1) ) then
                        derives(jc,kc,DZ)  = ddzminus(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  ddz2cen(ic,jc,kc-1,n)
                     else
                        derives(jc,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  zero
                     endif
                  else
                     derives(jc,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                     derives(jc,kc,D2Z) =  zero
                  endif
               endif

               if( okyzcen(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzcen(ic,jc,kc,n)
               else if( okyzpp(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzpp(ic,jc,kc,n)
               else if( okyzpm(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzpm(ic,jc,kc,n)
               else if( okyzmp(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzmp(ic,jc,kc,n)
               else if( okyzmm(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzmm(ic,jc,kc,n)
               else
                  derives(jc,kc,DYZ) = zero
               endif

            enddo
         enddo

c     ::::: interpolate to fine grid
         do koff = 0, ratio - 1
            zz = (koff+half)*hf(3)-hc(3)/2
            do kc = kclo,kchi
               k = ratio*kc + koff
               do joff = 0, ratio - 1
                  yy = (joff+half)*hf(2)-hc(2)/2
                  do jc = jclo, jchi
                     j = ratio*jc + joff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + 
     &                    yy*derives(jc,kc,DY) +
     &                    half*yy**2*derives(jc,kc,D2Y) + 
     &                    zz*derives(jc,kc,DZ) +
     &                    half*zz**2*derives(jc,kc,D2Z) + 
     &                    yy*zz*derives(jc,kc,DYZ) 
                     bdry(i,j,k,n+CY*nvar) =
     &                    derives(jc,kc,DY)+
     &                    yy*derives(jc,kc,D2Y)+
     &                    zz*derives(jc,kc,DYZ)
                     bdry(i,j,k,n+CZ*nvar) =
     &                    derives(jc,kc,DZ)+
     &                    zz*derives(jc,kc,D2Z)+
     &                    yy*derives(jc,kc,DYZ)
                  enddo
               enddo
            enddo
         enddo

      enddo
            
      return
      end


c ---------------------------------------------------------------
c ::  FORT_BDINTERPXHI : Interpolation on Xhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),(1+3)*nvar)
      REAL_T   derives(DIM23(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine(BL_SPACEDIM-1)

      REAL_T   yy, zz
      integer  i, j, k, ic, jc, kc, joff, koff, n
      integer  jclo, jchi, kclo, kchi
      REAL_T   hc(3),hf(3)

c ::: ------------ functions ------------------------------
      logical notUsable,Usable
      REAL_T ddxcen,ddx2cen,ddxplus,ddxminus
      REAL_T ddycen,ddy2cen,ddyplus,ddyminus
      REAL_T ddzcen,ddz2cen,ddzplus,ddzminus
      REAL_T ddxdycen,ddxdypp,ddxdypm,ddxdymp,ddxdymm
      REAL_T ddxdzcen,ddxdzpp,ddxdzpm,ddxdzmp,ddxdzmm
      REAL_T ddydzcen,ddydzpp,ddydzpm,ddydzmp,ddydzmm
      logical okxypp,okxypm,okxymp,okxymm,okxycen
      logical okxzpp,okxzpm,okxzmp,okxzmm,okxzcen
      logical okyzpp,okyzpm,okyzmp,okyzmm,okyzcen
      REAL_T ddxlowp,ddxlowm
      REAL_T ddylowp,ddylowm
      REAL_T ddzlowp,ddzlowm

      notUsable(i,j,k) = (mask(i,j,k).ne.not_covered)
      Usable(i,j,k) = (mask(i,j,k).eq.not_covered)

      ddxcen(i,j,k,n) = (crse(i+1,j,k,n)-crse(i-1,j,k,n))/(2*hc(1))
      ddycen(i,j,k,n) = (crse(i,j+1,k,n)-crse(i,j-1,k,n))/(2*hc(2))
      ddzcen(i,j,k,n) = (crse(i,j,k+1,n)-crse(i,j,k-1,n))/(2*hc(3))

      ddx2cen(i,j,k,n)=(crse(i+1,j,k,n)-2*crse(i,j,k,n)+crse(i-1,j,k,n))
     &     /(hc(1)**2)
      ddy2cen(i,j,k,n)=(crse(i,j+1,k,n)-2*crse(i,j,k,n)+crse(i,j-1,k,n))
     &     /(hc(2)**2)
      ddz2cen(i,j,k,n)=(crse(i,j,k+1,n)-2*crse(i,j,k,n)+crse(i,j,k-1,n))
     &     /(hc(3)**2)

      ddxplus(i,j,k,n)=(-crse(i+2,j,k,n)+4*crse(i+1,j,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyplus(i,j,k,n)=(-crse(i,j+2,k,n)+4*crse(i,j+1,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzplus(i,j,k,n)=(-crse(i,j,k+2,n)+4*crse(i,j,k+1,n)-3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxminus(i,j,k,n)=(+crse(i-2,j,k,n)-4*crse(i-1,j,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyminus(i,j,k,n)=(+crse(i,j-2,k,n)-4*crse(i,j-1,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzminus(i,j,k,n)=(+crse(i,j,k-2,n)-4*crse(i,j,k-1,n)+3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxdycen(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i-1,j-1,k,n))/(4*hc(1)*hc(2))
      okxycen(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i-1,j-1,k))
      ddxdypp(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i,j+1,k,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(2))
      okxypp(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i,j+1,k)
     &     .and.Usable(i+1,j,k))
      ddxdypm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i,j-1,k,n))/(4*hc(1)*hc(2))
      okxypm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i,j-1,k))
      ddxdymp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(2))
      okxymp(i,j,k)=(Usable(i,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i-1,j,k))
      ddxdymm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j-1,k,n)+crse(i-1,j-1,k,n))/(hc(1)*hc(2))
      okxymm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j-1,k).and.Usable(i-1,j-1,k))

      ddxdzcen(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i+1,j,k-1,n)+crse(i-1,j,k-1,n))/(4*hc(1)*hc(3))
      okxzcen(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i+1,j,k-1).and.Usable(i-1,j,k-1))
      ddxdzpp(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(3))
      okxzpp(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i+1,j,k))
      ddxdzpm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j,k-1,n)+crse(i,j,k-1,n))/(4*hc(1)*hc(3))
      okxzpm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j,k-1).and.Usable(i,j,k-1))
      ddxdzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(3))
      okxzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i-1,j,k))
      ddxdzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j,k-1,n)+crse(i-1,j,k-1,n))/(hc(1)*hc(3))
      okxzmm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j,k-1).and.Usable(i-1,j,k-1))

      ddydzcen(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j-1,k-1,n))/(4*hc(2)*hc(3))
      okyzcen(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j-1,k-1))
      ddydzpp(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i,j+1,k,n)+crse(i,j,k,n))/(hc(2)*hc(3))
      okyzpp(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i,j+1,k))
      ddydzpm(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j,k-1,n))/(4*hc(2)*hc(3))
      okyzpm(i,j,k)=(Usable(i,j+1,k)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j,k-1))
      ddydzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j,k,n)+crse(i,j-1,k,n))/(hc(2)*hc(3))
      okyzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j-1,k))
      ddydzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i,j-1,k,n)
     &     -crse(i,j,k-1,n)+crse(i,j-1,k-1,n))/(hc(2)*hc(3))
      okyzmm(i,j,k)=(Usable(i,j-1,k)
     &     .and.Usable(i,j,k-1).and.Usable(i,j-1,k-1))

      ddxlowp(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n))/hc(1)
      ddylowp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n))/hc(2)
      ddzlowp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j,k,n))/hc(3)

      ddxlowm(i,j,k,n)=(-crse(i-1,j,k,n)+crse(i,j,k,n))/hc(1)
      ddylowm(i,j,k,n)=(-crse(i,j-1,k,n)+crse(i,j,k,n))/hc(2)
      ddzlowm(i,j,k,n)=(-crse(i,j,k-1,n)+crse(i,j,k,n))/hc(3)
c ::: ------------ functions ------------------------------

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_H1(cb)+1
      i    = hi(1)+1
c ::: :::
      hf(1) = 0
      hf(2) = hfine(1)
      hf(3) = hfine(2)
      hc(1) = 0
      hc(2) = hfine(1)*ratio
      hc(3) = hfine(2)*ratio
c ::: :::

      do n = 1, nvar
c     ::::: calculate derivatives for interpolation
         do kc = kclo, kchi
            k = ratio*kc
            do jc = jclo, jchi
               j = ratio*jc

               derives(jc,kc,DY) = ddycen(ic,jc,kc,n)
               derives(jc,kc,D2Y) = ddy2cen(ic,jc,kc,n)

               if( notUsable(i,j-1,k) .and. notUsable(i,j+ratio,k)  ) then
                  derives(jc,kc,DY)  = zero
                  derives(jc,kc,D2Y) = zero
               else if( notUsable(i,j-1,k) .and. Usable(i,j+ratio,k) ) then
c     :::: :::: : positive side usable
                  if( jc+2.le.jchi+1 ) then
                     if( Usable(i,j+2*ratio,k) ) then
                        derives(jc,kc,DY)=ddyplus(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=ddy2cen(ic,jc+1,kc,n)
                     else
                        derives(jc,kc,DY)=ddylowp(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=zero
                     endif
                  else
                     derives(jc,kc,DY)=ddylowp(ic,jc,kc,n)
                     derives(jc,kc,D2Y)=zero
                  endif
               else if( Usable(i,j-1,k) .and. notUsable(i,j+ratio,k) ) then
c     :::: :::: : negative side usable
                  if( jc-2.ge.jclo-1 ) then
                     if( Usable(i,j-1,k) ) then
                        derives(jc,kc,DY)=ddyminus(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=ddy2cen(ic,jc-1,kc,n)
                     else
                        derives(jc,kc,DY)=ddylowm(ic,jc,kc,n)
                        derives(jc,kc,D2Y)=zero
                     endif
                  else
                     derives(jc,kc,DY)=ddylowm(ic,jc,kc,n)
                     derives(jc,kc,D2Y)=zero
                  endif
               endif

               derives(jc,kc,DZ)  = ddzcen(ic,jc,kc,n)
               derives(jc,kc,D2Z) = ddz2cen(ic,jc,kc,n)

               if( notUsable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
                  derives(jc,kc,DZ)  = zero
                  derives(jc,kc,D2Z) = zero
               else if( notUsable(i,j,k-1) .and. Usable(i,j,k+ratio)) then
c     :::: :::: : positive size usable
                  if( kc+2.le.kchi+1 ) then
                     if( Usable(i,j,k+2*ratio) ) then
                        derives(jc,kc,DZ)  = ddzplus(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  ddz2cen(ic,jc,kc+1,n)
                     else
                        derives(jc,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  zero
                     endif
                  else
                     derives(jc,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                     derives(jc,kc,D2Z) =  zero
                  endif
               else if( Usable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
c     :::: :::: : negative size usable
                  if( kc-2.ge.kclo-1 ) then
                     if( Usable(i,j,k-1) ) then
                        derives(jc,kc,DZ)  = ddzminus(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  ddz2cen(ic,jc,kc-1,n)
                     else
                        derives(jc,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                        derives(jc,kc,D2Z) =  zero
                     endif
                  else
                     derives(jc,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                     derives(jc,kc,D2Z) =  zero
                  endif
               endif

               if( okyzcen(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzcen(ic,jc,kc,n)
               else if( okyzpp(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzpp(ic,jc,kc,n)
               else if( okyzpm(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzpm(ic,jc,kc,n)
               else if( okyzmp(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzmp(ic,jc,kc,n)
               else if( okyzmm(i,j,k) ) then
                  derives(jc,kc,DYZ) = ddydzmm(ic,jc,kc,n)
               else
                  derives(jc,kc,DYZ) = zero
               endif

            enddo
         enddo

c     ::::: interpolate to fine grid
         do koff = 0, ratio - 1
            zz = (koff+half)*hf(3)-hc(3)/2
            do kc = kclo,kchi
               k = ratio*kc + koff
               do joff = 0, ratio - 1
                  yy = (joff+half)*hf(2)-hc(2)/2
                  do jc = jclo, jchi
                     j = ratio*jc + joff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + 
     &                    yy*derives(jc,kc,DY) +
     &                    half*yy**2*derives(jc,kc,D2Y) + 
     &                    zz*derives(jc,kc,DZ) +
     &                    half*zz**2*derives(jc,kc,D2Z) + 
     &                    yy*zz*derives(jc,kc,DYZ) 
                     bdry(i,j,k,n+CY*nvar) =
     &                    derives(jc,kc,DY)+
     &                    yy*derives(jc,kc,D2Y)+
     &                    zz*derives(jc,kc,DYZ)
                     bdry(i,j,k,n+CZ*nvar) =
     &                    derives(jc,kc,DZ)+
     &                    zz*derives(jc,kc,D2Z)+
     &                    yy*derives(jc,kc,DYZ)
                  enddo
               enddo
            enddo
         enddo

      enddo
            
      return
      end





c ---------------------------------------------------------------
c ::  FORT_BDINTERPYLO : Interpolation on Ylo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),(1+3)*nvar)
      REAL_T   derives(DIM13(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine(BL_SPACEDIM-1)

      REAL_T   xx, zz
      integer  i, j, k, ic, jc, kc, ioff, koff, n
      integer  iclo, ichi, kclo, kchi
      REAL_T   hc(3),hf(3)

c ::: ------------ functions ------------------------------
      logical notUsable,Usable
      REAL_T ddxcen,ddx2cen,ddxplus,ddxminus
      REAL_T ddycen,ddy2cen,ddyplus,ddyminus
      REAL_T ddzcen,ddz2cen,ddzplus,ddzminus
      REAL_T ddxdycen,ddxdypp,ddxdypm,ddxdymp,ddxdymm
      REAL_T ddxdzcen,ddxdzpp,ddxdzpm,ddxdzmp,ddxdzmm
      REAL_T ddydzcen,ddydzpp,ddydzpm,ddydzmp,ddydzmm
      logical okxypp,okxypm,okxymp,okxymm,okxycen
      logical okxzpp,okxzpm,okxzmp,okxzmm,okxzcen
      logical okyzpp,okyzpm,okyzmp,okyzmm,okyzcen
      REAL_T ddxlowp,ddxlowm
      REAL_T ddylowp,ddylowm
      REAL_T ddzlowp,ddzlowm

      notUsable(i,j,k) = (mask(i,j,k).ne.not_covered)
      Usable(i,j,k) = (mask(i,j,k).eq.not_covered)

      ddxcen(i,j,k,n) = (crse(i+1,j,k,n)-crse(i-1,j,k,n))/(2*hc(1))
      ddycen(i,j,k,n) = (crse(i,j+1,k,n)-crse(i,j-1,k,n))/(2*hc(2))
      ddzcen(i,j,k,n) = (crse(i,j,k+1,n)-crse(i,j,k-1,n))/(2*hc(3))

      ddx2cen(i,j,k,n)=(crse(i+1,j,k,n)-2*crse(i,j,k,n)+crse(i-1,j,k,n))
     &     /(hc(1)**2)
      ddy2cen(i,j,k,n)=(crse(i,j+1,k,n)-2*crse(i,j,k,n)+crse(i,j-1,k,n))
     &     /(hc(2)**2)
      ddz2cen(i,j,k,n)=(crse(i,j,k+1,n)-2*crse(i,j,k,n)+crse(i,j,k-1,n))
     &     /(hc(3)**2)

      ddxplus(i,j,k,n)=(-crse(i+2,j,k,n)+4*crse(i+1,j,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyplus(i,j,k,n)=(-crse(i,j+2,k,n)+4*crse(i,j+1,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzplus(i,j,k,n)=(-crse(i,j,k+2,n)+4*crse(i,j,k+1,n)-3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxminus(i,j,k,n)=(+crse(i-2,j,k,n)-4*crse(i-1,j,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyminus(i,j,k,n)=(+crse(i,j-2,k,n)-4*crse(i,j-1,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzminus(i,j,k,n)=(+crse(i,j,k-2,n)-4*crse(i,j,k-1,n)+3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxdycen(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i-1,j-1,k,n))/(4*hc(1)*hc(2))
      okxycen(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i-1,j-1,k))
      ddxdypp(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i,j+1,k,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(2))
      okxypp(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i,j+1,k)
     &     .and.Usable(i+1,j,k))
      ddxdypm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i,j-1,k,n))/(4*hc(1)*hc(2))
      okxypm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i,j-1,k))
      ddxdymp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(2))
      okxymp(i,j,k)=(Usable(i,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i-1,j,k))
      ddxdymm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j-1,k,n)+crse(i-1,j-1,k,n))/(hc(1)*hc(2))
      okxymm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j-1,k).and.Usable(i-1,j-1,k))

      ddxdzcen(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i+1,j,k-1,n)+crse(i-1,j,k-1,n))/(4*hc(1)*hc(3))
      okxzcen(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i+1,j,k-1).and.Usable(i-1,j,k-1))
      ddxdzpp(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(3))
      okxzpp(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i+1,j,k))
      ddxdzpm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j,k-1,n)+crse(i,j,k-1,n))/(4*hc(1)*hc(3))
      okxzpm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j,k-1).and.Usable(i,j,k-1))
      ddxdzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(3))
      okxzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i-1,j,k))
      ddxdzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j,k-1,n)+crse(i-1,j,k-1,n))/(hc(1)*hc(3))
      okxzmm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j,k-1).and.Usable(i-1,j,k-1))

      ddydzcen(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j-1,k-1,n))/(4*hc(2)*hc(3))
      okyzcen(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j-1,k-1))
      ddydzpp(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i,j+1,k,n)+crse(i,j,k,n))/(hc(2)*hc(3))
      okyzpp(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i,j+1,k))
      ddydzpm(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j,k-1,n))/(4*hc(2)*hc(3))
      okyzpm(i,j,k)=(Usable(i,j+1,k)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j,k-1))
      ddydzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j,k,n)+crse(i,j-1,k,n))/(hc(2)*hc(3))
      okyzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j-1,k))
      ddydzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i,j-1,k,n)
     &     -crse(i,j,k-1,n)+crse(i,j-1,k-1,n))/(hc(2)*hc(3))
      okyzmm(i,j,k)=(Usable(i,j-1,k)
     &     .and.Usable(i,j,k-1).and.Usable(i,j-1,k-1))

      ddxlowp(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n))/hc(1)
      ddylowp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n))/hc(2)
      ddzlowp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j,k,n))/hc(3)

      ddxlowm(i,j,k,n)=(-crse(i-1,j,k,n)+crse(i,j,k,n))/hc(1)
      ddylowm(i,j,k,n)=(-crse(i,j-1,k,n)+crse(i,j,k,n))/hc(2)
      ddzlowm(i,j,k,n)=(-crse(i,j,k-1,n)+crse(i,j,k,n))/hc(3)
c ::: ------------ functions ------------------------------

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_L2(cb)-1
      j    = lo(2)-1
c ::: :::
      hf(1) = hfine(1)
      hf(2) = 0
      hf(3) = hfine(2)
      hc(1) = hfine(1)*ratio
      hc(2) = 0
      hc(3) = hfine(2)*ratio
c ::: :::

      do n = 1, nvar
c     ::::: calculate derivatives for interpolation
         do kc = kclo, kchi
            k = ratio*kc
            do ic = iclo, ichi
               i = ratio*ic

               derives(ic,kc,DX) = ddxcen(ic,jc,kc,n)
               derives(ic,kc,D2X) = ddx2cen(ic,jc,kc,n)

               if( notUsable(i-1,j,k) .and. notUsable(i+ratio,j,k)  ) then
                  derives(ic,kc,DX)  = zero
                  derives(ic,kc,D2X) = zero
               else if( notUsable(i-1,j,k) .and. Usable(i+ratio,j,k) ) then
c     :::: :::: : positive side usable
                  if( ic+2.le.ichi+1 ) then
                     if( Usable(i+2*ratio,j,k) ) then
                        derives(ic,kc,DX)=ddxplus(ic,jc,kc,n)
                        derives(ic,kc,D2X)=ddx2cen(ic+1,jc,kc,n)
                     else
                        derives(ic,kc,DX)=ddxlowp(ic,jc,kc,n)
                        derives(ic,kc,D2X)=zero
                     endif
                  else
                     derives(ic,kc,DX)=ddxlowp(ic,jc,kc,n)
                     derives(ic,kc,D2X)=zero
                  endif
               else if( Usable(i-1,j,k) .and. notUsable(i+ratio,j,k) ) then
c     :::: :::: : negative side usable
                  if( ic-2.ge.iclo-1 ) then
                     if( Usable(i-1,j,k) ) then
                        derives(ic,kc,DX)=ddxminus(ic,jc,kc,n)
                        derives(ic,kc,D2X)=ddx2cen(ic-1,jc,kc,n)
                     else
                        derives(ic,kc,DX)=ddxlowm(ic,jc,kc,n)
                        derives(ic,kc,D2X)=zero
                     endif
                  else
                     derives(ic,kc,DX)=ddxlowm(ic,jc,kc,n)
                     derives(ic,kc,D2X)=zero
                  endif
               endif

               derives(ic,kc,DZ)  = ddzcen(ic,jc,kc,n)
               derives(ic,kc,D2Z) = ddz2cen(ic,jc,kc,n)

               if( notUsable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
                  derives(ic,kc,DZ)  = zero
                  derives(ic,kc,D2Z) = zero
               else if( notUsable(i,j,k-1) .and. Usable(i,j,k+ratio)) then
c     :::: :::: : positive size usable
                  if( kc+2.le.kchi+1 ) then
                     if( Usable(i,j,k+2*ratio) ) then
                        derives(ic,kc,DZ)  = ddzplus(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  ddz2cen(ic,jc,kc+1,n)
                     else
                        derives(ic,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  zero
                     endif
                  else
                     derives(ic,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                     derives(ic,kc,D2Z) =  zero
                  endif
               else if( Usable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
c     :::: :::: : negative size usable
                  if( kc-2.ge.kclo-1 ) then
                     if( Usable(i,j,k-1) ) then
                        derives(ic,kc,DZ)  = ddzminus(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  ddz2cen(ic,jc,kc-1,n)
                     else
                        derives(ic,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  zero
                     endif
                  else
                     derives(ic,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                     derives(ic,kc,D2Z) =  zero
                  endif
               endif

               if( okxzcen(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzcen(ic,jc,kc,n)
               else if( okxzpp(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzpp(ic,jc,kc,n)
               else if( okxzpm(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzpm(ic,jc,kc,n)
               else if( okxzmp(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzmp(ic,jc,kc,n)
               else if( okxzmm(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzmm(ic,jc,kc,n)
               else
                  derives(ic,kc,DXZ) = zero
               endif

            enddo
         enddo

c     ::::: interpolate to fine grid
         do koff = 0, ratio - 1
            zz = (koff+half)*hf(3)-hc(3)/2
            do kc = kclo,kchi
               k = ratio*kc + koff
               do ioff = 0, ratio - 1
                  xx = (ioff+half)*hf(1)-hc(1)/2
                  do ic = iclo, ichi
                     i = ratio*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + 
     &                    xx*derives(ic,kc,DX) +
     &                    half*xx**2*derives(ic,kc,D2X) + 
     &                    zz*derives(ic,kc,DZ) +
     &                    half*zz**2*derives(ic,kc,D2Z) + 
     &                    xx*zz*derives(ic,kc,DXZ) 
                     bdry(i,j,k,n+CX*nvar) =
     &                    derives(ic,kc,DX)+
     &                    xx*derives(ic,kc,D2X)+
     &                    zz*derives(ic,kc,DXZ)
                     bdry(i,j,k,n+CZ*nvar) =
     &                    derives(ic,kc,DZ)+
     &                    zz*derives(ic,kc,D2Z)+
     &                    xx*derives(ic,kc,DXZ)
                  enddo
               enddo
            enddo
         enddo

      enddo
            
      return
      end


c ---------------------------------------------------------------
c ::  FORT_BDINTERPYHI : Interpolation on Yhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),(1+3)*nvar)
      REAL_T   derives(DIM13(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine(BL_SPACEDIM-1)

      REAL_T   xx, zz
      integer  i, j, k, ic, jc, kc, ioff, koff, n
      integer  iclo, ichi, kclo, kchi
      REAL_T   hc(3),hf(3)

c ::: ------------ functions ------------------------------
      logical notUsable,Usable
      REAL_T ddxcen,ddx2cen,ddxplus,ddxminus
      REAL_T ddycen,ddy2cen,ddyplus,ddyminus
      REAL_T ddzcen,ddz2cen,ddzplus,ddzminus
      REAL_T ddxdycen,ddxdypp,ddxdypm,ddxdymp,ddxdymm
      REAL_T ddxdzcen,ddxdzpp,ddxdzpm,ddxdzmp,ddxdzmm
      REAL_T ddydzcen,ddydzpp,ddydzpm,ddydzmp,ddydzmm
      logical okxypp,okxypm,okxymp,okxymm,okxycen
      logical okxzpp,okxzpm,okxzmp,okxzmm,okxzcen
      logical okyzpp,okyzpm,okyzmp,okyzmm,okyzcen
      REAL_T ddxlowp,ddxlowm
      REAL_T ddylowp,ddylowm
      REAL_T ddzlowp,ddzlowm

      notUsable(i,j,k) = (mask(i,j,k).ne.not_covered)
      Usable(i,j,k) = (mask(i,j,k).eq.not_covered)

      ddxcen(i,j,k,n) = (crse(i+1,j,k,n)-crse(i-1,j,k,n))/(2*hc(1))
      ddycen(i,j,k,n) = (crse(i,j+1,k,n)-crse(i,j-1,k,n))/(2*hc(2))
      ddzcen(i,j,k,n) = (crse(i,j,k+1,n)-crse(i,j,k-1,n))/(2*hc(3))

      ddx2cen(i,j,k,n)=(crse(i+1,j,k,n)-2*crse(i,j,k,n)+crse(i-1,j,k,n))
     &     /(hc(1)**2)
      ddy2cen(i,j,k,n)=(crse(i,j+1,k,n)-2*crse(i,j,k,n)+crse(i,j-1,k,n))
     &     /(hc(2)**2)
      ddz2cen(i,j,k,n)=(crse(i,j,k+1,n)-2*crse(i,j,k,n)+crse(i,j,k-1,n))
     &     /(hc(3)**2)

      ddxplus(i,j,k,n)=(-crse(i+2,j,k,n)+4*crse(i+1,j,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyplus(i,j,k,n)=(-crse(i,j+2,k,n)+4*crse(i,j+1,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzplus(i,j,k,n)=(-crse(i,j,k+2,n)+4*crse(i,j,k+1,n)-3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxminus(i,j,k,n)=(+crse(i-2,j,k,n)-4*crse(i-1,j,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyminus(i,j,k,n)=(+crse(i,j-2,k,n)-4*crse(i,j-1,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzminus(i,j,k,n)=(+crse(i,j,k-2,n)-4*crse(i,j,k-1,n)+3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxdycen(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i-1,j-1,k,n))/(4*hc(1)*hc(2))
      okxycen(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i-1,j-1,k))
      ddxdypp(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i,j+1,k,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(2))
      okxypp(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i,j+1,k)
     &     .and.Usable(i+1,j,k))
      ddxdypm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i,j-1,k,n))/(4*hc(1)*hc(2))
      okxypm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i,j-1,k))
      ddxdymp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(2))
      okxymp(i,j,k)=(Usable(i,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i-1,j,k))
      ddxdymm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j-1,k,n)+crse(i-1,j-1,k,n))/(hc(1)*hc(2))
      okxymm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j-1,k).and.Usable(i-1,j-1,k))

      ddxdzcen(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i+1,j,k-1,n)+crse(i-1,j,k-1,n))/(4*hc(1)*hc(3))
      okxzcen(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i+1,j,k-1).and.Usable(i-1,j,k-1))
      ddxdzpp(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(3))
      okxzpp(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i+1,j,k))
      ddxdzpm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j,k-1,n)+crse(i,j,k-1,n))/(4*hc(1)*hc(3))
      okxzpm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j,k-1).and.Usable(i,j,k-1))
      ddxdzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(3))
      okxzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i-1,j,k))
      ddxdzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j,k-1,n)+crse(i-1,j,k-1,n))/(hc(1)*hc(3))
      okxzmm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j,k-1).and.Usable(i-1,j,k-1))

      ddydzcen(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j-1,k-1,n))/(4*hc(2)*hc(3))
      okyzcen(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j-1,k-1))
      ddydzpp(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i,j+1,k,n)+crse(i,j,k,n))/(hc(2)*hc(3))
      okyzpp(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i,j+1,k))
      ddydzpm(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j,k-1,n))/(4*hc(2)*hc(3))
      okyzpm(i,j,k)=(Usable(i,j+1,k)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j,k-1))
      ddydzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j,k,n)+crse(i,j-1,k,n))/(hc(2)*hc(3))
      okyzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j-1,k))
      ddydzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i,j-1,k,n)
     &     -crse(i,j,k-1,n)+crse(i,j-1,k-1,n))/(hc(2)*hc(3))
      okyzmm(i,j,k)=(Usable(i,j-1,k)
     &     .and.Usable(i,j,k-1).and.Usable(i,j-1,k-1))

      ddxlowp(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n))/hc(1)
      ddylowp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n))/hc(2)
      ddzlowp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j,k,n))/hc(3)

      ddxlowm(i,j,k,n)=(-crse(i-1,j,k,n)+crse(i,j,k,n))/hc(1)
      ddylowm(i,j,k,n)=(-crse(i,j-1,k,n)+crse(i,j,k,n))/hc(2)
      ddzlowm(i,j,k,n)=(-crse(i,j,k-1,n)+crse(i,j,k,n))/hc(3)
c ::: ------------ functions ------------------------------

      kclo = ARG_L3(cb)
      kchi = ARG_H3(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_H2(cb)+1
      j    = hi(2)+1
c ::: :::
      hf(1) = hfine(1)
      hf(2) = 0
      hf(3) = hfine(2)
      hc(1) = hfine(1)*ratio
      hc(2) = 0
      hc(3) = hfine(2)*ratio
c ::: :::

      do n = 1, nvar
c     ::::: calculate derivatives for interpolation
         do kc = kclo, kchi
            k = ratio*kc
            do ic = iclo, ichi
               i = ratio*ic

               derives(ic,kc,DX) = ddxcen(ic,jc,kc,n)
               derives(ic,kc,D2X) = ddx2cen(ic,jc,kc,n)

               if( notUsable(i-1,j,k) .and. notUsable(i+ratio,j,k)  ) then
                  derives(ic,kc,DX)  = zero
                  derives(ic,kc,D2X) = zero
               else if( notUsable(i-1,j,k) .and. Usable(i+ratio,j,k) ) then
c     :::: :::: : positive side usable
                  if( ic+2.le.ichi+1 ) then
                     if( Usable(i+2*ratio,j,k) ) then
                        derives(ic,kc,DX)=ddxplus(ic,jc,kc,n)
                        derives(ic,kc,D2X)=ddx2cen(ic+1,jc,kc,n)
                     else
                        derives(ic,kc,DX)=ddxlowp(ic,jc,kc,n)
                        derives(ic,kc,D2X)=zero
                     endif
                  else
                     derives(ic,kc,DX)=ddxlowp(ic,jc,kc,n)
                     derives(ic,kc,D2X)=zero
                  endif
               else if( Usable(i-1,j,k) .and. notUsable(i+ratio,j,k) ) then
c     :::: :::: : negative side usable
                  if( ic-2.ge.iclo-1 ) then
                     if( Usable(i-1,j,k) ) then
                        derives(ic,kc,DX)=ddxminus(ic,jc,kc,n)
                        derives(ic,kc,D2X)=ddx2cen(ic-1,jc,kc,n)
                     else
                        derives(ic,kc,DX)=ddxlowm(ic,jc,kc,n)
                        derives(ic,kc,D2X)=zero
                     endif
                  else
                     derives(ic,kc,DX)=ddxlowm(ic,jc,kc,n)
                     derives(ic,kc,D2X)=zero
                  endif
               endif

               derives(ic,kc,DZ)  = ddzcen(ic,jc,kc,n)
               derives(ic,kc,D2Z) = ddz2cen(ic,jc,kc,n)

               if( notUsable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
                  derives(ic,kc,DZ)  = zero
                  derives(ic,kc,D2Z) = zero
               else if( notUsable(i,j,k-1) .and. Usable(i,j,k+ratio)) then
c     :::: :::: : positive size usable
                  if( kc+2.le.kchi+1 ) then
                     if( Usable(i,j,k+2*ratio) ) then
                        derives(ic,kc,DZ)  = ddzplus(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  ddz2cen(ic,jc,kc+1,n)
                     else
                        derives(ic,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  zero
                     endif
                  else
                     derives(ic,kc,DZ)  = ddzlowp(ic,jc,kc,n)
                     derives(ic,kc,D2Z) =  zero
                  endif
               else if( Usable(i,j,k-1) .and. notUsable(i,j,k+ratio)) then
c     :::: :::: : negative size usable
                  if( kc-2.ge.kclo-1 ) then
                     if( Usable(i,j,k-1) ) then
                        derives(ic,kc,DZ)  = ddzminus(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  ddz2cen(ic,jc,kc-1,n)
                     else
                        derives(ic,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                        derives(ic,kc,D2Z) =  zero
                     endif
                  else
                     derives(ic,kc,DZ)  = ddzlowm(ic,jc,kc,n)
                     derives(ic,kc,D2Z) =  zero
                  endif
               endif

               if( okxzcen(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzcen(ic,jc,kc,n)
               else if( okxzpp(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzpp(ic,jc,kc,n)
               else if( okxzpm(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzpm(ic,jc,kc,n)
               else if( okxzmp(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzmp(ic,jc,kc,n)
               else if( okxzmm(i,j,k) ) then
                  derives(ic,kc,DXZ) = ddxdzmm(ic,jc,kc,n)
               else
                  derives(ic,kc,DXZ) = zero
               endif

            enddo
         enddo

c     ::::: interpolate to fine grid
         do koff = 0, ratio - 1
            zz = (koff+half)*hf(3)-hc(3)/2
            do kc = kclo,kchi
               k = ratio*kc + koff
               do ioff = 0, ratio - 1
                  xx = (ioff+half)*hf(1)-hc(1)/2
                  do ic = iclo, ichi
                     i = ratio*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + 
     &                    xx*derives(ic,kc,DX) +
     &                    half*xx**2*derives(ic,kc,D2X) + 
     &                    zz*derives(ic,kc,DZ) +
     &                    half*zz**2*derives(ic,kc,D2Z) + 
     &                    xx*zz*derives(ic,kc,DXZ) 
                     bdry(i,j,k,n+CX*nvar) =
     &                    derives(ic,kc,DX)+
     &                    xx*derives(ic,kc,D2X)+
     &                    zz*derives(ic,kc,DXZ)
                     bdry(i,j,k,n+CZ*nvar) =
     &                    derives(ic,kc,DZ)+
     &                    zz*derives(ic,kc,D2Z)+
     &                    xx*derives(ic,kc,DXZ)
                  enddo
               enddo
            enddo
         enddo

      enddo
            
      return
      end






c ---------------------------------------------------------------
c ::  FORT_BDINTERPZLO : Interpolation on Zlo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPZLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),(1+3)*nvar)
      REAL_T   derives(DIM12(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine(BL_SPACEDIM-1)

      REAL_T   yy, xx 
      integer  i, j, k, ic, jc, kc, ioff, joff, n
      integer  iclo, ichi, jclo, jchi
      REAL_T   hc(3),hf(3)

c ::: ------------ functions ------------------------------
      logical notUsable,Usable
      REAL_T ddxcen,ddx2cen,ddxplus,ddxminus
      REAL_T ddycen,ddy2cen,ddyplus,ddyminus
      REAL_T ddzcen,ddz2cen,ddzplus,ddzminus
      REAL_T ddxdycen,ddxdypp,ddxdypm,ddxdymp,ddxdymm
      REAL_T ddxdzcen,ddxdzpp,ddxdzpm,ddxdzmp,ddxdzmm
      REAL_T ddydzcen,ddydzpp,ddydzpm,ddydzmp,ddydzmm
      logical okxypp,okxypm,okxymp,okxymm,okxycen
      logical okxzpp,okxzpm,okxzmp,okxzmm,okxzcen
      logical okyzpp,okyzpm,okyzmp,okyzmm,okyzcen
      REAL_T ddxlowp,ddxlowm
      REAL_T ddylowp,ddylowm
      REAL_T ddzlowp,ddzlowm

      notUsable(i,j,k) = (mask(i,j,k).ne.not_covered)
      Usable(i,j,k) = (mask(i,j,k).eq.not_covered)

      ddxcen(i,j,k,n) = (crse(i+1,j,k,n)-crse(i-1,j,k,n))/(2*hc(1))
      ddycen(i,j,k,n) = (crse(i,j+1,k,n)-crse(i,j-1,k,n))/(2*hc(2))
      ddzcen(i,j,k,n) = (crse(i,j,k+1,n)-crse(i,j,k-1,n))/(2*hc(3))

      ddx2cen(i,j,k,n)=(crse(i+1,j,k,n)-2*crse(i,j,k,n)+crse(i-1,j,k,n))
     &     /(hc(1)**2)
      ddy2cen(i,j,k,n)=(crse(i,j+1,k,n)-2*crse(i,j,k,n)+crse(i,j-1,k,n))
     &     /(hc(2)**2)
      ddz2cen(i,j,k,n)=(crse(i,j,k+1,n)-2*crse(i,j,k,n)+crse(i,j,k-1,n))
     &     /(hc(3)**2)

      ddxplus(i,j,k,n)=(-crse(i+2,j,k,n)+4*crse(i+1,j,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyplus(i,j,k,n)=(-crse(i,j+2,k,n)+4*crse(i,j+1,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzplus(i,j,k,n)=(-crse(i,j,k+2,n)+4*crse(i,j,k+1,n)-3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxminus(i,j,k,n)=(+crse(i-2,j,k,n)-4*crse(i-1,j,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyminus(i,j,k,n)=(+crse(i,j-2,k,n)-4*crse(i,j-1,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzminus(i,j,k,n)=(+crse(i,j,k-2,n)-4*crse(i,j,k-1,n)+3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxdycen(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i-1,j-1,k,n))/(4*hc(1)*hc(2))
      okxycen(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i-1,j-1,k))
      ddxdypp(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i,j+1,k,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(2))
      okxypp(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i,j+1,k)
     &     .and.Usable(i+1,j,k))
      ddxdypm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i,j-1,k,n))/(4*hc(1)*hc(2))
      okxypm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i,j-1,k))
      ddxdymp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(2))
      okxymp(i,j,k)=(Usable(i,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i-1,j,k))
      ddxdymm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j-1,k,n)+crse(i-1,j-1,k,n))/(hc(1)*hc(2))
      okxymm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j-1,k).and.Usable(i-1,j-1,k))

      ddxdzcen(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i+1,j,k-1,n)+crse(i-1,j,k-1,n))/(4*hc(1)*hc(3))
      okxzcen(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i+1,j,k-1).and.Usable(i-1,j,k-1))
      ddxdzpp(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(3))
      okxzpp(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i+1,j,k))
      ddxdzpm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j,k-1,n)+crse(i,j,k-1,n))/(4*hc(1)*hc(3))
      okxzpm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j,k-1).and.Usable(i,j,k-1))
      ddxdzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(3))
      okxzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i-1,j,k))
      ddxdzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j,k-1,n)+crse(i-1,j,k-1,n))/(hc(1)*hc(3))
      okxzmm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j,k-1).and.Usable(i-1,j,k-1))

      ddydzcen(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j-1,k-1,n))/(4*hc(2)*hc(3))
      okyzcen(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j-1,k-1))
      ddydzpp(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i,j+1,k,n)+crse(i,j,k,n))/(hc(2)*hc(3))
      okyzpp(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i,j+1,k))
      ddydzpm(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j,k-1,n))/(4*hc(2)*hc(3))
      okyzpm(i,j,k)=(Usable(i,j+1,k)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j,k-1))
      ddydzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j,k,n)+crse(i,j-1,k,n))/(hc(2)*hc(3))
      okyzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j-1,k))
      ddydzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i,j-1,k,n)
     &     -crse(i,j,k-1,n)+crse(i,j-1,k-1,n))/(hc(2)*hc(3))
      okyzmm(i,j,k)=(Usable(i,j-1,k)
     &     .and.Usable(i,j,k-1).and.Usable(i,j-1,k-1))

      ddxlowp(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n))/hc(1)
      ddylowp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n))/hc(2)
      ddzlowp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j,k,n))/hc(3)

      ddxlowm(i,j,k,n)=(-crse(i-1,j,k,n)+crse(i,j,k,n))/hc(1)
      ddylowm(i,j,k,n)=(-crse(i,j-1,k,n)+crse(i,j,k,n))/hc(2)
      ddzlowm(i,j,k,n)=(-crse(i,j,k-1,n)+crse(i,j,k,n))/hc(3)
c ::: ------------ functions ------------------------------

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      kc   = ARG_L3(cb)-1
      k    = lo(3)-1
c ::: :::
      hf(1) = hfine(1)
      hf(2) = hfine(2)
      hf(3) = 0
      hc(1) = hfine(1)*ratio
      hc(2) = hfine(2)*ratio
      hc(3) = 0
c ::: :::

      do n = 1, nvar
c     ::::: calculate derivatives for interpolation
         do jc = jclo, jchi
            j = ratio*jc
            do ic = iclo, ichi
               i = ratio*ic

               derives(ic,jc,DX) = ddxcen(ic,jc,kc,n)
               derives(ic,jc,D2X) = ddx2cen(ic,jc,kc,n)

               if( notUsable(i-1,j,k) .and. notUsable(i+ratio,j,k)  ) then
                  derives(ic,jc,DX)  = zero
                  derives(ic,jc,D2X) = zero
               else if( notUsable(i-1,j,k) .and. Usable(i+ratio,j,k) ) then
c     :::: :::: : positive side usable
                  if( ic+2.le.ichi+1 ) then
                     if( Usable(i+2*ratio,j,k) ) then
                        derives(ic,jc,DX)=ddxplus(ic,jc,kc,n)
                        derives(ic,jc,D2X)=ddx2cen(ic+1,jc,kc,n)
                     else
                        derives(ic,jc,DX)=ddxlowp(ic,jc,kc,n)
                        derives(ic,jc,D2X)=zero
                     endif
                  else
                     derives(ic,jc,DX)=ddxlowp(ic,jc,kc,n)
                     derives(ic,jc,D2X)=zero
                  endif
               else if( Usable(i-1,j,k) .and. notUsable(i+ratio,j,k) ) then
c     :::: :::: : negative side usable
                  if( ic-2.ge.iclo-1 ) then
                     if( Usable(i-1,j,k) ) then
                        derives(ic,jc,DX)=ddxminus(ic,jc,kc,n)
                        derives(ic,jc,D2X)=ddx2cen(ic-1,jc,kc,n)
                     else
                        derives(ic,jc,DX)=ddxlowm(ic,jc,kc,n)
                        derives(ic,jc,D2X)=zero
                     endif
                  else
                     derives(ic,jc,DX)=ddxlowm(ic,jc,kc,n)
                     derives(ic,jc,D2X)=zero
                  endif
               endif

               derives(ic,jc,DY) = ddycen(ic,jc,kc,n)
               derives(ic,jc,D2Y) = ddy2cen(ic,jc,kc,n)

               if( notUsable(i,j-1,k) .and. notUsable(i,j+ratio,k)  ) then
                  derives(ic,jc,DY)  = zero
                  derives(ic,jc,D2Y) = zero
               else if( notUsable(i,j-1,k) .and. Usable(i,j+ratio,k) ) then
c     :::: :::: : positive side usable
                  if( jc+2.le.jchi+1 ) then
                     if( Usable(i,j+2*ratio,k) ) then
                        derives(ic,jc,DY)=ddyplus(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=ddy2cen(ic,jc+1,kc,n)
                     else
                        derives(ic,jc,DY)=ddylowp(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=zero
                     endif
                  else
                     derives(ic,jc,DY)=ddylowp(ic,jc,kc,n)
                     derives(ic,jc,D2Y)=zero
                  endif
               else if( Usable(i,j-1,k) .and. notUsable(i,j+ratio,k) ) then
c     :::: :::: : negative side usable
                  if( jc-2.ge.jclo-1 ) then
                     if( Usable(i,j-1,k) ) then
                        derives(ic,jc,DY)=ddyminus(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=ddy2cen(ic,jc-1,kc,n)
                     else
                        derives(ic,jc,DY)=ddylowm(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=zero
                     endif
                  else
                     derives(ic,jc,DY)=ddylowm(ic,jc,kc,n)
                     derives(ic,jc,D2Y)=zero
                  endif
               endif


               if( okxycen(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdycen(ic,jc,kc,n)
               else if( okxypp(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdypp(ic,jc,kc,n)
               else if( okxypm(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdypm(ic,jc,kc,n)
               else if( okxymp(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdymp(ic,jc,kc,n)
               else if( okxymm(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdymm(ic,jc,kc,n)
               else
                  derives(ic,jc,DXY) = zero
               endif

            enddo
         enddo

c     ::::: interpolate to fine grid
         do joff = 0, ratio - 1
            yy = (joff+half)*hf(2)-hc(2)/2
            do jc = jclo,jchi
               j = ratio*jc + joff
               do ioff = 0, ratio - 1
                  xx = (ioff+half)*hf(1)-hc(1)/2
                  do ic = iclo, ichi
                     i = ratio*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + 
     &                    xx*derives(ic,jc,DX) +
     &                    half*xx**2*derives(ic,jc,D2X) + 
     &                    yy*derives(ic,jc,DY) +
     &                    half*yy**2*derives(ic,jc,D2Y) + 
     &                    xx*yy*derives(ic,jc,DXY) 
                     bdry(i,j,k,n+CX*nvar) =
     &                    derives(ic,jc,DX)+
     &                    xx*derives(ic,jc,D2X)+
     &                    yy*derives(ic,jc,DXY)
                     bdry(i,j,k,n+CY*nvar) =
     &                    derives(ic,jc,DY)+
     &                    yy*derives(ic,jc,D2Y)+
     &                    xx*derives(ic,jc,DXY)
                  enddo
               enddo
            enddo
         enddo

      enddo
            
      return
      end


c ---------------------------------------------------------------
c ::  FORT_BDINTERPZHI : Interpolation on Zhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array for derivatives
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPZHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(cb)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),(1+3)*nvar)
      REAL_T   derives(DIM12(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine(BL_SPACEDIM-1)

      REAL_T   yy, xx 
      integer  i, j, k, ic, jc, kc, ioff, joff, n
      integer  iclo, ichi, jclo, jchi
      REAL_T   hc(3),hf(3)

c ::: ------------ functions ------------------------------
      logical notUsable,Usable
      REAL_T ddxcen,ddx2cen,ddxplus,ddxminus
      REAL_T ddycen,ddy2cen,ddyplus,ddyminus
      REAL_T ddzcen,ddz2cen,ddzplus,ddzminus
      REAL_T ddxdycen,ddxdypp,ddxdypm,ddxdymp,ddxdymm
      REAL_T ddxdzcen,ddxdzpp,ddxdzpm,ddxdzmp,ddxdzmm
      REAL_T ddydzcen,ddydzpp,ddydzpm,ddydzmp,ddydzmm
      logical okxypp,okxypm,okxymp,okxymm,okxycen
      logical okxzpp,okxzpm,okxzmp,okxzmm,okxzcen
      logical okyzpp,okyzpm,okyzmp,okyzmm,okyzcen
      REAL_T ddxlowp,ddxlowm
      REAL_T ddylowp,ddylowm
      REAL_T ddzlowp,ddzlowm

      notUsable(i,j,k) = (mask(i,j,k).ne.not_covered)
      Usable(i,j,k) = (mask(i,j,k).eq.not_covered)

      ddxcen(i,j,k,n) = (crse(i+1,j,k,n)-crse(i-1,j,k,n))/(2*hc(1))
      ddycen(i,j,k,n) = (crse(i,j+1,k,n)-crse(i,j-1,k,n))/(2*hc(2))
      ddzcen(i,j,k,n) = (crse(i,j,k+1,n)-crse(i,j,k-1,n))/(2*hc(3))

      ddx2cen(i,j,k,n)=(crse(i+1,j,k,n)-2*crse(i,j,k,n)+crse(i-1,j,k,n))
     &     /(hc(1)**2)
      ddy2cen(i,j,k,n)=(crse(i,j+1,k,n)-2*crse(i,j,k,n)+crse(i,j-1,k,n))
     &     /(hc(2)**2)
      ddz2cen(i,j,k,n)=(crse(i,j,k+1,n)-2*crse(i,j,k,n)+crse(i,j,k-1,n))
     &     /(hc(3)**2)

      ddxplus(i,j,k,n)=(-crse(i+2,j,k,n)+4*crse(i+1,j,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyplus(i,j,k,n)=(-crse(i,j+2,k,n)+4*crse(i,j+1,k,n)-3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzplus(i,j,k,n)=(-crse(i,j,k+2,n)+4*crse(i,j,k+1,n)-3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxminus(i,j,k,n)=(+crse(i-2,j,k,n)-4*crse(i-1,j,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(1))
      ddyminus(i,j,k,n)=(+crse(i,j-2,k,n)-4*crse(i,j-1,k,n)+3*crse(i,j,k,n))
     &     /(2*hc(2))
      ddzminus(i,j,k,n)=(+crse(i,j,k-2,n)-4*crse(i,j,k-1,n)+3*crse(i,j,k,n))
     &     /(2*hc(3))

      ddxdycen(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i-1,j-1,k,n))/(4*hc(1)*hc(2))
      okxycen(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i-1,j-1,k))
      ddxdypp(i,j,k,n)=(crse(i+1,j+1,k,n)-crse(i,j+1,k,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(2))
      okxypp(i,j,k)=(Usable(i+1,j+1,k).and.Usable(i,j+1,k)
     &     .and.Usable(i+1,j,k))
      ddxdypm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j-1,k,n)+crse(i,j-1,k,n))/(4*hc(1)*hc(2))
      okxypm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j-1,k).and.Usable(i,j-1,k))
      ddxdymp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i-1,j+1,k,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(2))
      okxymp(i,j,k)=(Usable(i,j+1,k).and.Usable(i-1,j+1,k)
     &     .and.Usable(i-1,j,k))
      ddxdymm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j-1,k,n)+crse(i-1,j-1,k,n))/(hc(1)*hc(2))
      okxymm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j-1,k).and.Usable(i-1,j-1,k))

      ddxdzcen(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i+1,j,k-1,n)+crse(i-1,j,k-1,n))/(4*hc(1)*hc(3))
      okxzcen(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i+1,j,k-1).and.Usable(i-1,j,k-1))
      ddxdzpp(i,j,k,n)=(crse(i+1,j,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i+1,j,k,n)+crse(i,j,k,n))/(hc(1)*hc(3))
      okxzpp(i,j,k)=(Usable(i+1,j,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i+1,j,k))
      ddxdzpm(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n)
     &     -crse(i+1,j,k-1,n)+crse(i,j,k-1,n))/(4*hc(1)*hc(3))
      okxzpm(i,j,k)=(Usable(i+1,j,k)
     &     .and.Usable(i+1,j,k-1).and.Usable(i,j,k-1))
      ddxdzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i-1,j,k+1,n)
     &     -crse(i,j,k,n)+crse(i-1,j,k,n))/(hc(1)*hc(3))
      okxzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i-1,j,k+1)
     &     .and.Usable(i-1,j,k))
      ddxdzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i-1,j,k,n)
     &     -crse(i,j,k-1,n)+crse(i-1,j,k-1,n))/(hc(1)*hc(3))
      okxzmm(i,j,k)=(Usable(i-1,j,k)
     &     .and.Usable(i,j,k-1).and.Usable(i-1,j,k-1))

      ddydzcen(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j-1,k-1,n))/(4*hc(2)*hc(3))
      okyzcen(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j-1,k-1))
      ddydzpp(i,j,k,n)=(crse(i,j+1,k+1,n)-crse(i,j,k+1,n)
     &     -crse(i,j+1,k,n)+crse(i,j,k,n))/(hc(2)*hc(3))
      okyzpp(i,j,k)=(Usable(i,j+1,k+1).and.Usable(i,j,k+1)
     &     .and.Usable(i,j+1,k))
      ddydzpm(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n)
     &     -crse(i,j+1,k-1,n)+crse(i,j,k-1,n))/(4*hc(2)*hc(3))
      okyzpm(i,j,k)=(Usable(i,j+1,k)
     &     .and.Usable(i,j+1,k-1).and.Usable(i,j,k-1))
      ddydzmp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j-1,k+1,n)
     &     -crse(i,j,k,n)+crse(i,j-1,k,n))/(hc(2)*hc(3))
      okyzmp(i,j,k)=(Usable(i,j,k+1).and.Usable(i,j-1,k+1)
     &     .and.Usable(i,j-1,k))
      ddydzmm(i,j,k,n)=(crse(i,j,k,n)-crse(i,j-1,k,n)
     &     -crse(i,j,k-1,n)+crse(i,j-1,k-1,n))/(hc(2)*hc(3))
      okyzmm(i,j,k)=(Usable(i,j-1,k)
     &     .and.Usable(i,j,k-1).and.Usable(i,j-1,k-1))

      ddxlowp(i,j,k,n)=(crse(i+1,j,k,n)-crse(i,j,k,n))/hc(1)
      ddylowp(i,j,k,n)=(crse(i,j+1,k,n)-crse(i,j,k,n))/hc(2)
      ddzlowp(i,j,k,n)=(crse(i,j,k+1,n)-crse(i,j,k,n))/hc(3)

      ddxlowm(i,j,k,n)=(-crse(i-1,j,k,n)+crse(i,j,k,n))/hc(1)
      ddylowm(i,j,k,n)=(-crse(i,j-1,k,n)+crse(i,j,k,n))/hc(2)
      ddzlowm(i,j,k,n)=(-crse(i,j,k-1,n)+crse(i,j,k,n))/hc(3)
c ::: ------------ functions ------------------------------

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      kc   = ARG_H3(cb)+1
      k    = hi(3)+1
c ::: :::
      hf(1) = hfine(1)
      hf(2) = hfine(2)
      hf(3) = 0
      hc(1) = hfine(1)*ratio
      hc(2) = hfine(2)*ratio
      hc(3) = 0
c ::: :::

      do n = 1, nvar
c     ::::: calculate derivatives for interpolation
         do jc = jclo, jchi
            j = ratio*jc
            do ic = iclo, ichi
               i = ratio*ic

               derives(ic,jc,DX) = ddxcen(ic,jc,kc,n)
               derives(ic,jc,D2X) = ddx2cen(ic,jc,kc,n)

               if( notUsable(i-1,j,k) .and. notUsable(i+ratio,j,k)  ) then
                  derives(ic,jc,DX)  = zero
                  derives(ic,jc,D2X) = zero
               else if( notUsable(i-1,j,k) .and. Usable(i+ratio,j,k) ) then
c     :::: :::: : positive side usable
                  if( ic+2.le.ichi+1 ) then
                     if( Usable(i+2*ratio,j,k) ) then
                        derives(ic,jc,DX)=ddxplus(ic,jc,kc,n)
                        derives(ic,jc,D2X)=ddx2cen(ic+1,jc,kc,n)
                     else
                        derives(ic,jc,DX)=ddxlowp(ic,jc,kc,n)
                        derives(ic,jc,D2X)=zero
                     endif
                  else
                     derives(ic,jc,DX)=ddxlowp(ic,jc,kc,n)
                     derives(ic,jc,D2X)=zero
                  endif
               else if( Usable(i-1,j,k) .and. notUsable(i+ratio,j,k) ) then
c     :::: :::: : negative side usable
                  if( ic-2.ge.iclo-1 ) then
                     if( Usable(i-1,j,k) ) then
                        derives(ic,jc,DX)=ddxminus(ic,jc,kc,n)
                        derives(ic,jc,D2X)=ddx2cen(ic-1,jc,kc,n)
                     else
                        derives(ic,jc,DX)=ddxlowm(ic,jc,kc,n)
                        derives(ic,jc,D2X)=zero
                     endif
                  else
                     derives(ic,jc,DX)=ddxlowm(ic,jc,kc,n)
                     derives(ic,jc,D2X)=zero
                  endif
               endif

               derives(ic,jc,DY) = ddycen(ic,jc,kc,n)
               derives(ic,jc,D2Y) = ddy2cen(ic,jc,kc,n)

               if( notUsable(i,j-1,k) .and. notUsable(i,j+ratio,k)  ) then
                  derives(ic,jc,DY)  = zero
                  derives(ic,jc,D2Y) = zero
               else if( notUsable(i,j-1,k) .and. Usable(i,j+ratio,k) ) then
c     :::: :::: : positive side usable
                  if( jc+2.le.jchi+1 ) then
                     if( Usable(i,j+2*ratio,k) ) then
                        derives(ic,jc,DY)=ddyplus(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=ddy2cen(ic,jc+1,kc,n)
                     else
                        derives(ic,jc,DY)=ddylowp(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=zero
                     endif
                  else
                     derives(ic,jc,DY)=ddylowp(ic,jc,kc,n)
                     derives(ic,jc,D2Y)=zero
                  endif
               else if( Usable(i,j-1,k) .and. notUsable(i,j+ratio,k) ) then
c     :::: :::: : negative side usable
                  if( jc-2.ge.jclo-1 ) then
                     if( Usable(i,j-1,k) ) then
                        derives(ic,jc,DY)=ddyminus(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=ddy2cen(ic,jc-1,kc,n)
                     else
                        derives(ic,jc,DY)=ddylowm(ic,jc,kc,n)
                        derives(ic,jc,D2Y)=zero
                     endif
                  else
                     derives(ic,jc,DY)=ddylowm(ic,jc,kc,n)
                     derives(ic,jc,D2Y)=zero
                  endif
               endif


               if( okxycen(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdycen(ic,jc,kc,n)
               else if( okxypp(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdypp(ic,jc,kc,n)
               else if( okxypm(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdypm(ic,jc,kc,n)
               else if( okxymp(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdymp(ic,jc,kc,n)
               else if( okxymm(i,j,k) ) then
                  derives(ic,jc,DXY) = ddxdymm(ic,jc,kc,n)
               else
                  derives(ic,jc,DXY) = zero
               endif

            enddo
         enddo

c     ::::: interpolate to fine grid
         do joff = 0, ratio - 1
            yy = (joff+half)*hf(2)-hc(2)/2
            do jc = jclo,jchi
               j = ratio*jc + joff
               do ioff = 0, ratio - 1
                  xx = (ioff+half)*hf(1)-hc(1)/2
                  do ic = iclo, ichi
                     i = ratio*ic + ioff
                     bdry(i,j,k,n) = crse(ic,jc,kc,n) + 
     &                    xx*derives(ic,jc,DX) +
     &                    half*xx**2*derives(ic,jc,D2X) + 
     &                    yy*derives(ic,jc,DY) +
     &                    half*yy**2*derives(ic,jc,D2Y) + 
     &                    xx*yy*derives(ic,jc,DXY) 
                     bdry(i,j,k,n+CX*nvar) =
     &                    derives(ic,jc,DX)+
     &                    xx*derives(ic,jc,D2X)+
     &                    yy*derives(ic,jc,DXY)
                     bdry(i,j,k,n+CY*nvar) =
     &                    derives(ic,jc,DY)+
     &                    yy*derives(ic,jc,D2Y)+
     &                    xx*derives(ic,jc,DXY)
                  enddo
               enddo
            enddo
         enddo

      enddo
            
      return
      end

c ------------------------------------------------------------------------
c :: FORT_BDIDERIVXLO : copy from Xlo face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The following 3*nvar values
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.
c ::      NOTE: only the transverse derivs are computed, so one of the
c ::      derivs if filled with error values

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write (3+1) times as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVXLO( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine(3)
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),(3+1)*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,k,n
      REAL_T h(3)
c ::: ------ begin functions -------
      REAL_T ddxcen
      REAL_T ddycen
      REAL_T ddzcen
      REAL_T ddxplus,ddxminus,ddyplus,ddyminus,ddzplus,ddzminus

      ddxcen(i,j,k,n) = (fine(i+1,j,k,n)-fine(i-1,j,k,n))/(2*h(1))
      ddycen(i,j,k,n) = (fine(i,j+1,k,n)-fine(i,j-1,k,n))/(2*h(2))
      ddzcen(i,j,k,n) = (fine(i,j,k+1,n)-fine(i,j,k-1,n))/(2*h(3))

      ddxplus(i,j,k,n)=(-fine(i+2,j,k,n)+4*fine(i+1,j,k,n)-3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyplus(i,j,k,n)=(-fine(i,j+2,k,n)+4*fine(i,j+1,k,n)-3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzplus(i,j,k,n)=(-fine(i,j,k+2,n)+4*fine(i,j,k+1,n)-3*fine(i,j,k,n))
     &     /(2*h(3))

      ddxminus(i,j,k,n)=(+fine(i-2,j,k,n)-4*fine(i-1,j,k,n)+3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyminus(i,j,k,n)=(+fine(i,j-2,k,n)-4*fine(i,j-1,k,n)+3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzminus(i,j,k,n)=(+fine(i,j,k-2,n)-4*fine(i,j,k-1,n)+3*fine(i,j,k,n))
     &     /(2*h(3))
c ::: ------ end   functions -------

      i = lo(1)-1
      h(1) = 0
      h(2) = hfine(1)
      h(3) = hfine(2)

      do n=1,nvar
c ::: ::: copy boundary values over
         do k=lo(3),hi(3)
            do j=lo(2),hi(2)
               bdry(i,j,k,n) = fine(i,j,k,n)
            enddo
         enddo

c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.

c ::: ::: First, do y deriv
         do k=lo(3),hi(3)
            j=lo(2)
            bdry(i,j,k,n+CY*nvar) = ddyplus(i,j,k,n)
            do j=lo(2)+1,hi(2)-1
               bdry(i,j,k,n+CY*nvar) = ddycen(i,j,k,n)
            enddo
            j=hi(2)
            bdry(i,j,k,n+CY*nvar) = ddyminus(i,j,k,n)
         enddo
c ::: ::: next, do z deriv
         do j=lo(2),hi(2)
            k=lo(3)
            bdry(i,j,k,n+CZ*nvar) = ddzplus(i,j,k,n)
            do k=lo(3)+1,hi(3)-1
               bdry(i,j,k,n+CZ*nvar) = ddzcen(i,j,k,n)
            enddo
            k=hi(3)
            bdry(i,j,k,n+CZ*nvar) = ddzminus(i,j,k,n)
         enddo

      enddo

      return
      end
      

c ------------------------------------------------------------------------
c :: FORT_BDIDERIVXHI : copy from Xhi face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The following 3*nvar values
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.
c ::      NOTE: only the transverse derivs are computed, so one of the
c ::      derivs if filled with error values

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write (3+1) times as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVXHI( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine(3)
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),(3+1)*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,k,n
      REAL_T h(3)
c ::: ------ begin functions -------
      REAL_T ddxcen
      REAL_T ddycen
      REAL_T ddzcen
      REAL_T ddxplus,ddxminus,ddyplus,ddyminus,ddzplus,ddzminus

      ddxcen(i,j,k,n) = (fine(i+1,j,k,n)-fine(i-1,j,k,n))/(2*h(1))
      ddycen(i,j,k,n) = (fine(i,j+1,k,n)-fine(i,j-1,k,n))/(2*h(2))
      ddzcen(i,j,k,n) = (fine(i,j,k+1,n)-fine(i,j,k-1,n))/(2*h(3))

      ddxplus(i,j,k,n)=(-fine(i+2,j,k,n)+4*fine(i+1,j,k,n)-3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyplus(i,j,k,n)=(-fine(i,j+2,k,n)+4*fine(i,j+1,k,n)-3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzplus(i,j,k,n)=(-fine(i,j,k+2,n)+4*fine(i,j,k+1,n)-3*fine(i,j,k,n))
     &     /(2*h(3))

      ddxminus(i,j,k,n)=(+fine(i-2,j,k,n)-4*fine(i-1,j,k,n)+3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyminus(i,j,k,n)=(+fine(i,j-2,k,n)-4*fine(i,j-1,k,n)+3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzminus(i,j,k,n)=(+fine(i,j,k-2,n)-4*fine(i,j,k-1,n)+3*fine(i,j,k,n))
     &     /(2*h(3))
c ::: ------ end   functions -------

      i = hi(1)+1
      h(1) = 0
      h(2) = hfine(1)
      h(3) = hfine(2)
      do n=1,nvar
c ::: ::: copy boundary values over
         do k=lo(3),hi(3)
            do j=lo(2),hi(2)
               bdry(i,j,k,n) = fine(i,j,k,n)
            enddo
         enddo

c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.

c ::: ::: First, do y deriv
         do k=lo(3),hi(3)
            j=lo(2)
            bdry(i,j,k,n+CY*nvar) = ddyplus(i,j,k,n)
            do j=lo(2)+1,hi(2)-1
               bdry(i,j,k,n+CY*nvar) = ddycen(i,j,k,n)
            enddo
            j=hi(2)
            bdry(i,j,k,n+CY*nvar) = ddyminus(i,j,k,n)
         enddo
c ::: ::: next, do z deriv
         do j=lo(2),hi(2)
            k=lo(3)
            bdry(i,j,k,n+CZ*nvar) = ddzplus(i,j,k,n)
            do k=lo(3)+1,hi(3)-1
               bdry(i,j,k,n+CZ*nvar) = ddzcen(i,j,k,n)
            enddo
            k=hi(3)
            bdry(i,j,k,n+CZ*nvar) = ddzminus(i,j,k,n)
         enddo

      enddo

      return
      end
      

c ------------------------------------------------------------------------
c :: FORT_BDIDERIVYLO : copy from Ylo face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The following 3*nvar values
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.
c ::      NOTE: only the transverse derivs are computed, so one of the
c ::      derivs if filled with error values

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write (3+1) times as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVYLO( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine(3)
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),(3+1)*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,k,n
      REAL_T h(3)
c ::: ------ begin functions -------
      REAL_T ddxcen
      REAL_T ddycen
      REAL_T ddzcen
      REAL_T ddxplus,ddxminus,ddyplus,ddyminus,ddzplus,ddzminus

      ddxcen(i,j,k,n) = (fine(i+1,j,k,n)-fine(i-1,j,k,n))/(2*h(1))
      ddycen(i,j,k,n) = (fine(i,j+1,k,n)-fine(i,j-1,k,n))/(2*h(2))
      ddzcen(i,j,k,n) = (fine(i,j,k+1,n)-fine(i,j,k-1,n))/(2*h(3))

      ddxplus(i,j,k,n)=(-fine(i+2,j,k,n)+4*fine(i+1,j,k,n)-3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyplus(i,j,k,n)=(-fine(i,j+2,k,n)+4*fine(i,j+1,k,n)-3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzplus(i,j,k,n)=(-fine(i,j,k+2,n)+4*fine(i,j,k+1,n)-3*fine(i,j,k,n))
     &     /(2*h(3))

      ddxminus(i,j,k,n)=(+fine(i-2,j,k,n)-4*fine(i-1,j,k,n)+3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyminus(i,j,k,n)=(+fine(i,j-2,k,n)-4*fine(i,j-1,k,n)+3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzminus(i,j,k,n)=(+fine(i,j,k-2,n)-4*fine(i,j,k-1,n)+3*fine(i,j,k,n))
     &     /(2*h(3))
c ::: ------ end   functions -------

      j = lo(2)-1
      h(1) = hfine(1)
      h(2) = 0
      h(3) = hfine(2)
      do n=1,nvar
c ::: ::: copy boundary values over
         do k=lo(3),hi(3)
            do i=lo(1),hi(1)
               bdry(i,j,k,n) = fine(i,j,k,n)
            enddo
         enddo

c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.

c ::: ::: First, do x deriv
         do k=lo(3),hi(3)
            i=lo(1)
            bdry(i,j,k,n+CX*nvar) = ddxplus(i,j,k,n)
            do i=lo(1)+1,hi(1)-1
               bdry(i,j,k,n+CX*nvar) = ddxcen(i,j,k,n)
            enddo
            i=hi(1)
            bdry(i,j,k,n+CX*nvar) = ddxminus(i,j,k,n)
         enddo
c ::: ::: next, do z deriv
         do i=lo(1),hi(1)
            k=lo(3)
            bdry(i,j,k,n+CZ*nvar) = ddzplus(i,j,k,n)
            do k=lo(3)+1,hi(3)-1
               bdry(i,j,k,n+CZ*nvar) = ddzcen(i,j,k,n)
            enddo
            k=hi(3)
            bdry(i,j,k,n+CZ*nvar) = ddzminus(i,j,k,n)
         enddo

      enddo

      return
      end
      


c ------------------------------------------------------------------------
c :: FORT_BDIDERIVYHI : copy from Yhi face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The following 3*nvar values
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.
c ::      NOTE: only the transverse derivs are computed, so one of the
c ::      derivs if filled with error values

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write (3+1) times as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVYHI( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine(3)
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),(3+1)*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,k,n
      REAL_T h(3)
c ::: ------ begin functions -------
      REAL_T ddxcen
      REAL_T ddycen
      REAL_T ddzcen
      REAL_T ddxplus,ddxminus,ddyplus,ddyminus,ddzplus,ddzminus

      ddxcen(i,j,k,n) = (fine(i+1,j,k,n)-fine(i-1,j,k,n))/(2*h(1))
      ddycen(i,j,k,n) = (fine(i,j+1,k,n)-fine(i,j-1,k,n))/(2*h(2))
      ddzcen(i,j,k,n) = (fine(i,j,k+1,n)-fine(i,j,k-1,n))/(2*h(3))

      ddxplus(i,j,k,n)=(-fine(i+2,j,k,n)+4*fine(i+1,j,k,n)-3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyplus(i,j,k,n)=(-fine(i,j+2,k,n)+4*fine(i,j+1,k,n)-3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzplus(i,j,k,n)=(-fine(i,j,k+2,n)+4*fine(i,j,k+1,n)-3*fine(i,j,k,n))
     &     /(2*h(3))

      ddxminus(i,j,k,n)=(+fine(i-2,j,k,n)-4*fine(i-1,j,k,n)+3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyminus(i,j,k,n)=(+fine(i,j-2,k,n)-4*fine(i,j-1,k,n)+3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzminus(i,j,k,n)=(+fine(i,j,k-2,n)-4*fine(i,j,k-1,n)+3*fine(i,j,k,n))
     &     /(2*h(3))
c ::: ------ end   functions -------

      j = hi(2)+1
      h(1) = hfine(1)
      h(2) = 0
      h(3) = hfine(2)

      do n=1,nvar
c ::: ::: copy boundary values over
         do k=lo(3),hi(3)
            do i=lo(1),hi(1)
               bdry(i,j,k,n) = fine(i,j,k,n)
            enddo
         enddo

c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.

c ::: ::: First, do x deriv
         do k=lo(3),hi(3)
            i=lo(1)
            bdry(i,j,k,n+CX*nvar) = ddxplus(i,j,k,n)
            do i=lo(1)+1,hi(1)-1
               bdry(i,j,k,n+CX*nvar) = ddxcen(i,j,k,n)
            enddo
            i=hi(1)
            bdry(i,j,k,n+CX*nvar) = ddxminus(i,j,k,n)
         enddo
c ::: ::: next, do z deriv
         do i=lo(1),hi(1)
            k=lo(3)
            bdry(i,j,k,n+CZ*nvar) = ddzplus(i,j,k,n)
            do k=lo(3)+1,hi(3)-1
               bdry(i,j,k,n+CZ*nvar) = ddzcen(i,j,k,n)
            enddo
            k=hi(3)
            bdry(i,j,k,n+CZ*nvar) = ddzminus(i,j,k,n)
         enddo

      enddo

      return
      end
      

c ------------------------------------------------------------------------
c :: FORT_BDIDERIVZLO : copy from Zlo face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The following 3*nvar values
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.
c ::      NOTE: only the transverse derivs are computed, so one of the
c ::      derivs if filled with error values

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write (3+1) times as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVZLO( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine(3)
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),(3+1)*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,k,n
      REAL_T h(3)
c ::: ------ begin functions -------
      REAL_T ddxcen
      REAL_T ddycen
      REAL_T ddzcen
      REAL_T ddxplus,ddxminus,ddyplus,ddyminus,ddzplus,ddzminus

      ddxcen(i,j,k,n) = (fine(i+1,j,k,n)-fine(i-1,j,k,n))/(2*h(1))
      ddycen(i,j,k,n) = (fine(i,j+1,k,n)-fine(i,j-1,k,n))/(2*h(2))
      ddzcen(i,j,k,n) = (fine(i,j,k+1,n)-fine(i,j,k-1,n))/(2*h(3))

      ddxplus(i,j,k,n)=(-fine(i+2,j,k,n)+4*fine(i+1,j,k,n)-3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyplus(i,j,k,n)=(-fine(i,j+2,k,n)+4*fine(i,j+1,k,n)-3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzplus(i,j,k,n)=(-fine(i,j,k+2,n)+4*fine(i,j,k+1,n)-3*fine(i,j,k,n))
     &     /(2*h(3))

      ddxminus(i,j,k,n)=(+fine(i-2,j,k,n)-4*fine(i-1,j,k,n)+3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyminus(i,j,k,n)=(+fine(i,j-2,k,n)-4*fine(i,j-1,k,n)+3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzminus(i,j,k,n)=(+fine(i,j,k-2,n)-4*fine(i,j,k-1,n)+3*fine(i,j,k,n))
     &     /(2*h(3))
c ::: ------ end   functions -------

      k = lo(3)-1
      h(1) = hfine(1)
      h(2) = hfine(2)
      h(3) = 0

      do n=1,nvar
c ::: ::: copy boundary values over
         do j=lo(2),hi(2)
            do i=lo(1),hi(1)
               bdry(i,j,k,n) = fine(i,j,k,n)
            enddo
         enddo

c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.

c ::: ::: First, do y deriv
         do i=lo(1),hi(1)
            j=lo(2)
            bdry(i,j,k,n+CY*nvar) = ddyplus(i,j,k,n)
            do j=lo(2)+1,hi(2)-1
               bdry(i,j,k,n+CY*nvar) = ddycen(i,j,k,n)
            enddo
            j=hi(2)
            bdry(i,j,k,n+CY*nvar) = ddyminus(i,j,k,n)
         enddo
c ::: ::: next, do x deriv
         do j=lo(2),hi(2)
            i=lo(1)
            bdry(i,j,k,n+CX*nvar) = ddxplus(i,j,k,n)
            do i=lo(1)+1,hi(1)-1
               bdry(i,j,k,n+CX*nvar) = ddxcen(i,j,k,n)
            enddo
            i=hi(1)
            bdry(i,j,k,n+CX*nvar) = ddxminus(i,j,k,n)
         enddo

      enddo

      return
      end
      
      

c ------------------------------------------------------------------------
c :: FORT_BDIDERIVZHI : copy from Zhi face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The following 3*nvar values
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.
c ::      NOTE: only the transverse derivs are computed, so one of the
c ::      derivs if filled with error values

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write (3+1) times as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVZHI( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine(3)
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),(3+1)*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,k,n
      REAL_T h(3)
c ::: ------ begin functions -------
      REAL_T ddxcen
      REAL_T ddycen
      REAL_T ddzcen
      REAL_T ddxplus,ddxminus,ddyplus,ddyminus,ddzplus,ddzminus

      ddxcen(i,j,k,n) = (fine(i+1,j,k,n)-fine(i-1,j,k,n))/(2*h(1))
      ddycen(i,j,k,n) = (fine(i,j+1,k,n)-fine(i,j-1,k,n))/(2*h(2))
      ddzcen(i,j,k,n) = (fine(i,j,k+1,n)-fine(i,j,k-1,n))/(2*h(3))

      ddxplus(i,j,k,n)=(-fine(i+2,j,k,n)+4*fine(i+1,j,k,n)-3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyplus(i,j,k,n)=(-fine(i,j+2,k,n)+4*fine(i,j+1,k,n)-3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzplus(i,j,k,n)=(-fine(i,j,k+2,n)+4*fine(i,j,k+1,n)-3*fine(i,j,k,n))
     &     /(2*h(3))

      ddxminus(i,j,k,n)=(+fine(i-2,j,k,n)-4*fine(i-1,j,k,n)+3*fine(i,j,k,n))
     &     /(2*h(1))
      ddyminus(i,j,k,n)=(+fine(i,j-2,k,n)-4*fine(i,j-1,k,n)+3*fine(i,j,k,n))
     &     /(2*h(2))
      ddzminus(i,j,k,n)=(+fine(i,j,k-2,n)-4*fine(i,j,k-1,n)+3*fine(i,j,k,n))
     &     /(2*h(3))
c ::: ------ end   functions -------

      k = hi(3)+1
      h(1) = hfine(1)
      h(2) = hfine(2)
      h(3) = 0

      do n=1,nvar
c ::: ::: copy boundary values over
         do j=lo(2),hi(2)
            do i=lo(1),hi(1)
               bdry(i,j,k,n) = fine(i,j,k,n)
            enddo
         enddo

c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.

c ::: ::: First, do y deriv
         do i=lo(1),hi(1)
            j=lo(2)
            bdry(i,j,k,n+CY*nvar) = ddyplus(i,j,k,n)
            do j=lo(2)+1,hi(2)-1
               bdry(i,j,k,n+CY*nvar) = ddycen(i,j,k,n)
            enddo
            j=hi(2)
            bdry(i,j,k,n+CY*nvar) = ddyminus(i,j,k,n)
         enddo
c ::: ::: next, do x deriv
         do j=lo(2),hi(2)
            i=lo(1)
            bdry(i,j,k,n+CX*nvar) = ddxplus(i,j,k,n)
            do i=lo(1)+1,hi(1)-1
               bdry(i,j,k,n+CX*nvar) = ddxcen(i,j,k,n)
            enddo
            i=hi(1)
            bdry(i,j,k,n+CX*nvar) = ddxminus(i,j,k,n)
         enddo

      enddo

      return
      end
      




#undef SDIM
#undef NUMDERIV
#undef DX
#undef DY
#undef DZ
#undef D2X
#undef D2Y
#undef D2Z
#undef DXY
#undef DXZ
#undef DYZ

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "MACOUTFLOWBC_F.H"
#include "ArrayLim.H"

#define SDIM 3

#if defined(BL_USE_FLOAT) || defined(BL_T3E) || defined(BL_CRAY)
#define SMALL 1.0e-10
#else
#define SMALL 1.0d-10
#endif

      subroutine FORT_EXTRAP_MAC(DIMS(u0),u0,DIMS(u1),u1,DIMS(u2),u2,DIMS(div),
     &                           divu,DIMS(rho),rho,
     &                           DIMS(divuExt),divuExt,DIMS(rhoExt),rhoExt,
     &                           dx,lo,hi,face,per,zeroIt)
c
c     Compute the value of phi for macproj 
c     assuming that the tangential velocity on the edges of the outflow boundary
c     are either zero or periodic.
c     note that u is edge centered

c    compute divu_ave twice due to precision problems

      implicit none

      integer DIMDEC(u0)
      integer DIMDEC(u1)
      integer DIMDEC(u2)
      integer DIMDEC(div)
      integer DIMDEC(rho)
      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(divuExt)
      integer DIMDEC(rhoExt)
      REAL_T      u0(DIMV(u0))
      REAL_T      u1(DIMV(u1))
      REAL_T      u2(DIMV(u2))
      REAL_T divu(DIMV(div))
      REAL_T    rho(DIMV(rho))
      REAL_T   divuExt(DIMV(divuExt))
      REAL_T   rhoExt(DIMV(rhoExt))
      REAL_T   dx(3)
      integer per(2)
      integer zeroIt
      integer face

c     Local variables
      REAL_T small_pert
      REAL_T small_udiff
      parameter ( small_pert = SMALL)
      parameter (small_udiff = SMALL)
      REAL_T max_divu, min_divu, max_pert
      REAL_T divu_ave1,divu_ave2
      REAL_T hx,hy,hz  
      REAL_T diff
      integer i,j,k,neq,n
      integer ics,ice,jcs,jce,kcs,kce
      integer ifs,ife,jfs,jfe,kfs,kfe
      integer if,jf,kf,ic,jc,kc
c     NOTE: Assumes that rho at edge between i, i-1 = half*(rho(i)+rho(i-1))
c             (1) Linear fit of rho between nodes
c             (2) rho, divu on same boxes (box)
c             (3) phi is on box, shifted up one
c             (4) u is edge-based, on surroundingNodes(box)

c     Compute average of divu over outflow bc.  Set trivial solution if average
c     is zero, or if divu is constant
#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5
      ics = ARG_L1(rho)
      ice = ARG_H1(rho)
      jcs = ARG_L2(rho)
      jce = ARG_H2(rho)
      kcs = ARG_L3(rho)
      kce = ARG_H3(rho)

      ifs = lo(1)
      ife = hi(1)
      jfs = lo(2)
      jfe = hi(2)
      kfs = lo(3)
      kfe = hi(3)

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      zeroIt = 0

      if (face .eq. XLO) then
         if = ifs
         max_divu = divu(ics,jcs,kcs)
         min_divu = max_divu
         do k = kcs, kce
         do j = jcs, jce
            divuExt(j,k,if) = divu(ics,j,k)
            rhoExt(j,k,if)  = rho(ics,j,k)
            max_divu = max(max_divu,divuExt(j,k,if))
            min_divu = min(min_divu,divuExt(j,k,if))
         end do
         end do

c        Here we modify divuExt to include the velocity terms.
         do k = kcs, kce
         do j = jcs, jce
            divuExt(j,k,if) = divuExt(j,k,if) 
     $        - (u1(ics,j+1,k)-u1(ics,j,k))/hy 
     $        - (u2(ics,j,k+1)-u2(ics,j,k))/hz 
         end do
         end do

         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)

         max_pert = ABS(divuExt(jcs,kcs,if))
         do k = kcs, kce
         do j = jcs, jce
            max_pert = MAX(max_pert,ABS(divuExt(j,k,if)))
         end do
         end do

c        Make sure u_mac is periodic
         if (per(1) .eq. 1) then
           diff = abs(u1(ics,jcs,kcs)-u1(ics,jce+1,kcs))
           do k = kcs, kce
             diff = max(diff,abs(u1(ics,jcs,k)-u1(ics,jce+1,k)))
           enddo
           if (diff .gt. small_udiff) then
             write(6,*) 'EXTRAPMAC: FACE XLO : vmac not periodic'
             call bl_abort(" ")
           endif
         endif
         if (per(2) .eq. 1) then
           diff = abs(u2(ics,jcs,kcs)-u2(ics,jcs,kce+1))
           do j = jcs, jce
             diff = max(diff,abs(u1(ics,j,kcs)-u1(ics,j,kce+1)))
           enddo
           if (diff .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE XLO : wmac not periodic'
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. YLO) then
         jf = jfs
         max_divu = divu(ics,jcs,kcs)
         min_divu = max_divu
         do k = kcs, kce
         do i = ics, ice
            divuExt(i,k,jf) = divu(i,jcs,k)
            rhoExt(i,k,jf)  = rho(i,jcs,k)
            max_divu = max(max_divu,divuExt(i,k,jf))
            min_divu = min(min_divu,divuExt(i,k,jf))
         end do
         end do

c        Here we modify divuExt to include the velocity terms.
         do k = kcs, kce
         do i = ics, ice
            divuExt(i,k,jf) = divuExt(i,k,jf)
     $        - (u0(i+1,jcs,k)-u0(i,jcs,k))/hx
     $        - (u2(i,jcs,k+1)-u2(i,jcs,k))/hz
         end do
         end do

         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,kcs,jf))
         do k = kcs, kce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,k,jf)))
         end do
         end do

c        Make sure u_mac is periodic
         if (per(1) .eq. 1) then
           diff = abs(u0(ics,jcs,kcs)-u0(ice+1,jcs,kcs))
           do k = kcs, kce
             diff = max(diff,abs(u0(ics,jcs,k)-u1(ice+1,jcs,k)))
           enddo
           if (diff .gt. small_udiff) then
             write(6,*) 'EXTRAPMAC: FACE YLO : umac not periodic'
             call bl_abort(" ")
           endif
         endif
         if (per(2) .eq. 1) then
           diff = abs(u2(ics,jcs,kcs)-u2(ics,jcs,kce+1))
           do i = ics, ice
             diff = max(diff,abs(u1(i,jcs,kcs)-u1(i,jcs,kce+1)))
           enddo
           if (diff .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE YLO : wmac not periodic'
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. ZLO) then
         kf = kfs
         max_divu = divu(ics,jcs,kcs)
         min_divu = max_divu
         do j = jcs, jce
         do i = ics, ice
            divuExt(i,j,kf) = divu(i,j,kcs)
            rhoExt(i,j,kf)  = rho(i,j,kcs)
            max_divu = max(max_divu,divuExt(i,j,kf))
            min_divu = min(min_divu,divuExt(i,j,kf))
         end do
         end do

c        Here we modify divuExt to include the velocity terms.
         do j = jcs, jce
         do i = ics, ice
            divuExt(i,j,kf) = divuExt(i,j,kf)
     $        - (u0(i+1,j,kcs)-u0(i,j,kcs))/hx
     $        - (u1(i,j+1,kcs)-u1(i,j,kcs))/hy
         end do
         end do

         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jcs,kf))
         do j = jcs, jce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,j,kf)))
         end do
         end do

c        Make sure u_mac is periodic
         if (per(1) .eq. 1) then
           diff = abs(u0(ics,jcs,kcs)-u0(ice+1,jcs,kcs))
           do j = jcs, jce
             diff = max(diff,abs(u0(ics,j,kcs)-u1(ice+1,j,kcs)))
           enddo
           if (diff .gt. small_udiff) then
             write(6,*) 'EXTRAPMAC: FACE ZLO : umac not periodic'
             call bl_abort(" ")
           endif
         endif
         if (per(2) .eq. 1) then
           diff = abs(u1(ics,jcs,kcs)-u1(ics,jce+1,kcs))
           do i = ics, ice
             diff = max(diff,abs(u1(i,jcs,kcs)-u1(i,jce+1,kcs)))
           enddo
           if (diff .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE ZLO : vmac not periodic'
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. XHI) then
         if = ife
         max_divu = divu(ice,jcs,kcs)
         min_divu = max_divu

         do k = kcs, kce
         do j = jcs, jce
            divuExt(j,k,if) = divu(ice,j,k)
            rhoExt(j,k,if)  = rho(ice,j,k)
            max_divu = max(max_divu,divuExt(j,k,if))
            min_divu = min(min_divu,divuExt(j,k,if))
         end do
         end do

         do k = kcs, kce
         do j = jcs, jce
            divuExt(j,k,if) = divuExt(j,k,if) 
     $        - (u1(ice,j+1,k)-u1(ice,j,k))/hy 
     $        - (u2(ice,j,k+1)-u2(ice,j,k))/hz 
         end do
         end do

         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)

         max_pert = ABS(divuExt(jcs,kcs,if))
         do k = kcs, kce
         do j = jcs, jce
            max_pert = MAX(max_pert,ABS(divuExt(j,k,if)))
         end do
         end do

c        Make sure u_mac is periodic
         if (per(1) .eq. 1) then
           diff = abs(u1(ice,jcs,kcs)-u1(ice,jce+1,kcs))
           do k = kcs, kce
             diff = max(diff,abs(u1(ice,jcs,k)-u1(ice,jce+1,k)))
           enddo
           if (diff .gt. small_udiff) then
             write(6,*) 'EXTRAPMAC: FACE XLO : umac not periodic'
             call bl_abort(" ")
           endif
         endif
         if (per(2) .eq. 1) then
           diff = abs(u2(ice,jcs,kcs)-u2(ice,jcs,kce+1))
           do j = jcs, jce
             diff = max(diff,abs(u1(ice,j,kcs)-u1(ice,j,kce+1)))
           enddo
           if (diff .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE XLO : umac not periodic'
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. YHI) then
         jf = jfe
         max_divu = divu(ics,jce,kcs)
         min_divu = max_divu

         do k = kcs, kce
         do i = ics, ice
            divuExt(i,k,jf) = divu(i,jce,k)
            rhoExt(i,k,jf)  = rho(i,jce,k)
            max_divu = max(max_divu,divuExt(i,k,jf))
            min_divu = min(min_divu,divuExt(i,k,jf))
         end do
         end do

         do k = kcs, kce
         do i = ics, ice
            divuExt(i,k,jf) = divuExt(i,k,jf)
     $        - (u0(i+1,jce,k)-u0(i,jce,k))/hx
     $        - (u2(i,jce,k+1)-u2(i,jce,k))/hz
         end do
         end do

         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,kcs,jf))
         do k = kcs, kce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,k,jf)))
         end do
         end do

c        Make sure u_mac is periodic
         if (per(1) .eq. 1) then
           diff = abs(u0(ics,jce,kcs)-u0(ice+1,jce,kcs))
           do k = kcs, kce
             diff = max(diff,abs(u0(ics,jce,k)-u1(ice+1,jce,k)))
           enddo
           if (diff .gt. small_udiff) then
             write(6,*) 'EXTRAPMAC: FACE YLO : umac not periodic'
             call bl_abort(" ")
           endif
         endif
         if (per(2) .eq. 1) then
           diff = abs(u2(ics,jce,kcs)-u2(ics,jce,kce+1))
           do i = ics, ice
             diff = max(diff,abs(u1(i,jce,kcs)-u1(i,jce,kce+1)))
           enddo
           if (diff .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE YLO : wmac not periodic'
              call bl_abort(" ")
           endif
         endif

      else if (face .eq. ZHI) then
         kf = kfe
         max_divu = divu(ics,jcs,kce)
         min_divu = max_divu

         do j = jcs, jce
         do i = ics, ice
            divuExt(i,j,kf) = divu(i,j,kce)
            rhoExt(i,j,kf)  = rho(i,j,kce)
            max_divu = max(max_divu,divuExt(i,j,kf))
            min_divu = min(min_divu,divuExt(i,j,kf))
         end do
         end do

c        Here we modify divuExt to include the velocity terms.
         do j = jcs, jce
         do i = ics, ice
            divuExt(i,j,kf) = divuExt(i,j,kf)
     $        - (u0(i+1,j,kce)-u0(i,j,kce))/hx
     $        - (u1(i,j+1,kce)-u1(i,j,kce))/hy
         end do
         end do

         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave1,face)
         call subtractavg(DIMS(divuExt),divuExt,lo,hi,divu_ave2,face)
         max_pert = ABS(divuExt(ics,jcs,kf))
         do j = jcs, jce
         do i = ics, ice
            max_pert = MAX(max_pert,ABS(divuExt(i,j,kf)))
         end do
         end do

c        Make sure u_mac is periodic
         if (per(1) .eq. 1) then
           diff = abs(u0(ics,jcs,kce)-u0(ice+1,jcs,kce))
           do j = jcs, jce
             diff = max(diff,abs(u0(ics,j,kce)-u1(ice+1,j,kce)))
           enddo
           if (diff .gt. small_udiff) then
             write(6,*) 'EXTRAPMAC: FACE ZHI : umac not periodic'
             call bl_abort(" ")
           endif
         endif
         if (per(2) .eq. 1) then
           diff = abs(u1(ics,jcs,kce)-u1(ics,jce+1,kce))
           do i = ics, ice
             diff = max(diff,abs(u1(i,jcs,kce)-u1(i,jce+1,kce)))
           enddo
           if (diff .gt. small_udiff) then
              write(6,*) 'EXTRAPMAC: FACE ZHI : vmac not periodic'
              call bl_abort(" ")
           endif
         endif

      endif

c  check to see if we should zero phi
         max_pert = max_pert/(ABS(divu_ave1+divu_ave2)+small_pert)
      if ((max_divu.eq.zero.and.min_divu.eq.zero)
     &     .or.(max_pert.le.small_pert)) then
         zeroIt = 1
      end if

      end


      subroutine subtractavg(DIMS(divu),divu,lo,hi,divu_ave,face)
      implicit none
      integer DIMDEC(divu)
      integer lo(SDIM),hi(SDIM)
      REAL_T divu_ave
      REAL_T divu(DIMV(divu))
      integer face

      integer i,j,k
      REAL_T vtot

      divu_ave = zero
      vtot = zero

      if (face .eq. XLO .or. face .eq. XHI) then
         i = lo(1)
         do k = lo(3),hi(3)
            do j=lo(2),hi(2)
               vtot = vtot+one
               divu_ave = divu_ave+divu(j,k,i)
            enddo
         enddo
         divu_ave = divu_ave/vtot
         do k = lo(3),hi(3)
            do j=lo(2),hi(2)
               divu(j,k,i) = divu(j,k,i) - divu_ave
            enddo
         enddo
      elseif (face .eq. YLO .or. face .eq. YHI) then
         j = lo(2)
         do k = lo(3),hi(3)
            do i=lo(1),hi(1)
               vtot = vtot+one
               divu_ave = divu_ave+divu(i,k,j)
            enddo
         enddo
         divu_ave = divu_ave/vtot
         do k = lo(3),hi(3)
            do i=lo(1),hi(1)
               divu(i,k,j) = divu(i,k,j) - divu_ave
            enddo
         enddo
      elseif(face .eq. ZLO .or. face .eq. ZHI) then
         k = lo(3)
         do j=lo(2),hi(2)
            do i=lo(1),hi(1)
               vtot = vtot+one
               divu_ave = divu_ave+divu(i,j,k)
            enddo
         enddo
         divu_ave = divu_ave/vtot
         do j=lo(2),hi(2)
            do i=lo(1),hi(1)
               divu(i,j,k) = divu(i,j,k) - divu_ave
            enddo
         enddo
      else 
         print*, "bad length"
      endif

      end

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI

      subroutine FORT_COMPUTE_MACCOEFF(DIMS(rhs),rhs,
     &     DIMS(beta0),beta0,DIMS(beta1),beta1,
     &     DIMS(divuExt),divuExt,
     &     DIMS(rhoExt),rhoExt,lo,hi,h,isPeriodic)
      implicit none
      integer DIMDEC(rhs)
      integer DIMDEC(beta0)
      integer DIMDEC(beta1)
      integer DIMDEC(divuExt)
      integer DIMDEC(rhoExt)
      integer lo(SDIM),hi(SDIM)
      REAL_T divuExt(DIM12(divuExt))
      REAL_T rhoExt(DIM12(rhoExt))
      REAL_T beta0(DIM12(beta0))
      REAL_T beta1(DIM12(beta1))
      REAL_T rhs(DIM12(rhs))
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      
      integer i,j
      integer ics,jcs,ice,jce

      ics = lo(1)
      ice = hi(1)
      jcs = lo(2)
      jce = hi(2)

      do j=jcs,jce
        do i=ics,ice
           rhs(i,j) = -divuExt(i,j)
        enddo
      enddo

      do j=jcs,jce
         do i=ics+1,ice
            beta0(i,j) = two/(rhoExt(i,j)+rhoExt(i-1,j))
         enddo
      enddo

      do j=jcs+1,jce
         do i=ics,ice
            beta1(i,j) = two/(rhoExt(i,j)+rhoExt(i,j-1))
         enddo
      enddo
      
      if (isPeriodic(1) .eq. 1) then
         do j=jcs,jce
            beta0(ics  ,j) = two/(rhoExt(ics,j)+rhoExt(ice,j))
            beta0(ice+1,j) = two/(rhoExt(ics,j)+rhoExt(ice,j))
         enddo
      else
         do j=jcs,jce
            beta0(ics  ,j) = zero
            beta0(ice+1,j) = zero
         enddo
      endif
      if (isPeriodic(2) .eq. 1) then
         do i=ics,ice
            beta1(i,jcs  ) = two/(rhoExt(i,jcs)+rhoExt(i,jce))
            beta1(i,jce+1) = two/(rhoExt(i,jcs)+rhoExt(i,jce))
         enddo
      else
         do i=ics,ice
            beta1(i,jcs  ) = zero
            beta1(i,jce+1) = zero
         enddo
      endif

      end


#define DGXY (hxsqinv*(beta0(i+1,j)*(phi(i+1,j)-phi(i  ,j))      \
                      -beta0(i  ,j)*(phi(i  ,j)-phi(i-1,j))) +   \
              hysqinv*(beta1(i,j+1)*(phi(i,j+1)-phi(i,j))        \
                      -beta1(i,j  )*(phi(i,j  )-phi(i,j-1))))

      subroutine FORT_MACRELAX(DIMS(rhs),rhs,DIMS(beta0),beta0,
     &                         DIMS(beta1),beta1,DIMS(phi),phi,
     &                         lo,hi,h,isPeriodic,niter)
      implicit none
      integer DIMDEC(beta0)
      integer DIMDEC(beta1)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      REAL_T beta0(DIM12(beta0))
      REAL_T beta1(DIM12(beta1))
      REAL_T rhs(DIM12(rhs))
      REAL_T phi(DIM12(phi))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)

c Local variables
      integer ics,ice,jcs,jce
      logical setSingularPoint
      integer i,j,iter
      integer redblack
      REAL_T lam,dg
      REAL_T phitot, vtot
      REAL_T maxnorm
      REAL_T hxsqinv,hysqinv
      integer niter
      integer iinc

      hxsqinv = one/(h(1)*h(1))
      hysqinv = one/(h(2)*h(2))
      ics = lo(1)
      ice = hi(1)
      jcs = lo(2)
      jce = hi(2)

      if (h(2). gt. 1.5D0*h(1)) then
        call bl_abort("line solve for mac not yet implemented")
      else if (h(1) .gt. 1.5D0*h(2)) then
        call bl_abort("line solve for mac not yet implemented")
      endif

      setSingularPoint = .false.
      call setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)

      do iter = 1,niter
         do redblack = 0,1
            do j=jcs,jce
               iinc = mod(j+redblack,2)
               do i=ics+iinc,ice,2
                  dg = DGXY 
                  lam = -one/(hxsqinv*(beta0(i,j)+beta0(i+1,j))
     &                 +hysqinv*(beta1(i,j)+beta1(i,j+1)))
                  phi(i,j) = phi(i,j) + lam*(rhs(i,j)-dg)
               enddo
            end do
            call setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
         enddo
      end do
      
      end

      subroutine FORT_MACSUBTRACTAVGPHI(DIMS(phi),phi,lo,hi,isPeriodic)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM12(phi))
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)

      REAL_T phitot,vtot
      integer ics,ice,jcs,jce
      integer i,j
      logical setSingularPoint

      ics = lo(1)
      ice = hi(1)
      jcs = lo(2)
      jce = hi(2)
      setSingularPoint = .false.

      phitot = zero
      vtot   = zero

      do j=jcs,jce
      do i=ics,ice
         phitot = phitot+phi(i,j)
         vtot = vtot + one
      enddo
      enddo
      phitot = phitot/vtot

      do j=jcs,jce
      do i=ics,ice
         phi(i,j) = phi(i,j) - phitot
      enddo
      enddo

      call setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)

      end

      subroutine FORT_MACRESID(DIMS(rhs),rhs,DIMS(beta0),beta0,
     &                    DIMS(beta1),beta1,DIMS(phi),phi,
     &                    DIMS(resid),resid,lo,hi,h,isPeriodic,maxnorm)
      implicit none
      integer DIMDEC(beta0)
      integer DIMDEC(beta1)
      integer DIMDEC(rhs)
      integer DIMDEC(phi)
      integer DIMDEC(resid)
      REAL_T beta0(DIM12(beta0))
      REAL_T beta1(DIM12(beta1))
      REAL_T rhs(DIM12(rhs))
      REAL_T phi(DIM12(phi))
      REAL_T resid(DIM12(resid))
      integer isPeriodic(SDIM)
      REAL_T h(SDIM)
      integer lo(SDIM),hi(SDIM)

      REAL_T maxnorm
      integer i,j
      REAL_T hxsqinv,hysqinv

      hxsqinv = one/(h(1)*h(1))
      hysqinv = one/(h(2)*h(2))

      maxnorm = zero
      do j = lo(2),hi(2)
         do i = lo(1),hi(1)
            resid(i,j) = rhs(i,j) - (DGXY)
            maxnorm = max(maxnorm,ABS(resid(i,j)))
         enddo
      enddo

      end


      subroutine setmacbc(DIMS(phi),phi,lo,hi,isPeriodic,setSingularPoint)
      implicit none
      integer DIMDEC(phi)
      REAL_T phi(DIM12(phi))
      integer lo(SDIM),hi(SDIM)
      integer isPeriodic(SDIM)
      logical setSingularPoint
      
      integer ics,ice,jcs,jce
      integer i,j

      ics = lo(1)
      ice = hi(1)
      jcs = lo(2)
      jce = hi(2)

      if (isPeriodic(1) .NE. 1 .AND. isPeriodic(2) .NE. 1 .AND. setSingularPoint) then
         phi(ice,jce) = zero
      endif

      if (isPeriodic(1) .eq. 1) then
         do j=jcs,jce
            phi(ics-1,j) = phi(ice,j)
            phi(ice+1,j) = phi(ics,j)
         enddo
      else
         do j=jcs,jce
            phi(ics-1,j) = phi(ics,j)
            phi(ice+1,j) = phi(ice,j)
         enddo
      endif
      
      if (isPeriodic(2) .eq. 1) then
         do i=ics,ice
            phi(i,jcs-1) = phi(i,jce)
            phi(i,jce+1) = phi(i,jcs)
         enddo
      else
         do i=ics,ice
            phi(i,jcs-1) = phi(i,jcs)
            phi(i,jce+1) = phi(i,jce)
         enddo
      endif

      end

      subroutine FORT_MAC_SHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j,k
#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5
      if (face .eq. XLO .or. face .eq. XHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(k,i,j)
               enddo
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(i,k,j)
               enddo
            enddo
         enddo
      else if (face .eq. ZLO .or. face .eq. ZHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(i,j,k)
               enddo
            enddo
         enddo
      endif

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI

      end


      subroutine FORT_MAC_RESHIFT_PHI(DIMS(out),out,DIMS(in),in,face)
      implicit none
      integer face
      integer DIMDEC(in)
      integer DIMDEC(out)
      REAL_T in(DIMV(in))
      REAL_T out(DIMV(out))
      integer i,j,k
#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5
      if (face .eq. XLO .or. face .eq. XHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(j,k,i)
               enddo
            enddo
         enddo
      else if (face .eq. YLO .or. face .eq. YHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(i,k,j)
               enddo
            enddo
         enddo
      else if (face .eq. ZLO .or. face .eq. ZHI) then
         do k = ARG_L3(out), ARG_H3(out)
            do j= ARG_L2(out),ARG_H2(out)
               do i = ARG_L1(out),ARG_H1(out)
                  out(i,j,k) = in(i,j,k)
               enddo
            enddo
         enddo
      endif

#undef XLO
#undef YLO
#undef ZLO
#undef XHI
#undef YHI
#undef ZHI

      end

      subroutine FORT_SOLVEMAC(p, DIMS(p),dest0, DIMS(dest0),
     &                         source,DIMS(source), sigmax, DIMS(sigmax),
     &                         sigmay,DIMS(sigmay), cen, DIMS(cen),
     $                         r,DIMS(r), w, DIMS(w),z, DIMS(z),
     &                         x, DIMS(x),lo, hi, h,
     $                         isPeriodic, maxiter,tol, abs_tol,max_jump,norm)

      implicit none

      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(p)
      integer DIMDEC(dest0)
      integer DIMDEC(source)
      integer DIMDEC(sigmax)
      integer DIMDEC(sigmay)
      integer DIMDEC(cen)
      integer DIMDEC(r)
      integer DIMDEC(w)
      integer DIMDEC(z)
      integer DIMDEC(x)
      REAL_T      p(DIM12(p))
      REAL_T  dest0(DIM12(dest0))
      REAL_T source(DIM12(source))
      REAL_T sigmax(DIM12(sigmax))
      REAL_T sigmay(DIM12(sigmay))
      REAL_T    cen(DIM12(cen))
      REAL_T      r(DIM12(r))
      REAL_T      w(DIM12(w))
      REAL_T      z(DIM12(z))
      REAL_T      x(DIM12(x))
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      REAL_T norm
      REAL_T tol
      integer maxiter
      REAL_T abs_tol,max_jump

c     Local variables
      integer i,j,iter
      integer istart,iend,jstart,jend
      REAL_T alpha, beta, rho, rho_old
      REAL_T  goal
      REAL_T norm0
      logical setSingularPoint

      istart = lo(1)
      iend = hi(1)
      jstart = lo(2)
      jend = hi(2)

      setSingularPoint = .false.

      do j = lo(2)-1,hi(2)+1 
        do i = lo(1)-1,hi(1)+1 
           dest0(i,j) = p(i,j)
           p(i,j) = zero
        enddo
      enddo

      do j=ARG_L2(w),ARG_H2(w)
         do i=ARG_L1(w),ARG_H1(w)
            w(i,j) = zero
         enddo
      enddo

      call setmacbc(DIMS(dest0),dest0,lo,hi,isPeriodic,setSingularPoint)
      call makemacdgphi(dest0,DIMS(dest0),w,DIMS(w),sigmax,DIMS(sigmax),
     &               sigmay,DIMS(sigmay),lo,hi,h,isPeriodic,setSingularPoint)

      do j = jstart, jend 
        do i = istart, iend 
          r(i,j) = source(i,j) - w(i,j)
        enddo
      enddo

      rho = zero
      norm0 = zero
      do j = jstart, jend 
        do i = istart, iend 
          norm0 = max(norm0, abs(r(i,j)))
          z(i,j) = r(i,j) 
          rho = rho + z(i,j) * r(i,j)
        enddo
      enddo
      norm = norm0

      goal = max(tol*norm0,abs_tol)

      if (norm0 .le. goal) then
         do j = jstart, jend
            do i = istart, iend 
               p(i,j) = dest0(i,j)
            enddo
         enddo
         return
      endif

      do j = jstart, jend 
        do i = istart, iend 
          x(i,j) = zero
          p(i,j) = z(i,j)
        enddo
      enddo

      iter = 0

100   continue

      do j=ARG_L2(w),ARG_H2(w)
         do i=ARG_L1(w),ARG_H1(w)
            w(i,j) = zero
         enddo
      enddo

      call setmacbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
      call makemacdgphi(p,DIMS(p),w,DIMS(w),sigmax,DIMS(sigmax),
     &               sigmay,DIMS(sigmay),lo,hi,h,isPeriodic,setSingularPoint)

      alpha = zero
      do j = jstart, jend 
        do i = istart, iend 
          alpha = alpha + p(i,j)*w(i,j)
        enddo
      enddo

      alpha = rho / alpha
      rho_old = rho
      rho = zero
      norm = zero
      do j = jstart, jend 
        do i = istart, iend 
          x(i,j) = x(i,j) + alpha * p(i,j)
          r(i,j) = r(i,j) - alpha * w(i,j)
          z(i,j) = r(i,j) 
          rho = rho + z(i,j) * r(i,j)
          norm = max(norm,abs(r(i,j)))
        enddo
      enddo

      iter = iter+1
c      write(6,*) iter,norm

      if (iter .gt. maxiter .or. norm .gt. max_jump*norm0) then
         
         print *, "cg solve in mac failed to converge"
         do j = jstart, jend 
            do i = istart, iend 
               p(i,j) = dest0(i,j)
            enddo
         enddo
         call setmacbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)

      else if (norm .lt. goal) then

         do j = jstart, jend 
            do i = istart, iend 
               p(i,j) = x(i,j) + dest0(i,j)
            enddo
         enddo
         call setmacbc(DIMS(p),p,lo,hi,isPeriodic,setSingularPoint)
         
      else

        beta = rho / rho_old
        do j = jstart, jend 
           do i = istart, iend 
              p(i,j) = z(i,j) + beta * p(i,j)
           enddo
        enddo

        goto 100

      endif

      return
      end

      subroutine makemacdgphi(phi,DIMS(phi),dgphi,DIMS(dgphi),
     &                     beta0,DIMS(beta0),beta1,DIMS(beta1),
     &                     lo,hi,h,isPeriodic,setSingularPoint)
      implicit none

      integer DIMDEC(phi)
      integer DIMDEC(dgphi)
      integer DIMDEC(beta0)
      integer DIMDEC(beta1)
      REAL_T phi(DIM12(phi))
      REAL_T dgphi(DIM12(dgphi))
      REAL_T beta0(DIM12(beta0))
      REAL_T beta1(DIM12(beta1))
      integer lo(SDIM),hi(SDIM)
      REAL_T h(SDIM)
      integer isPeriodic(SDIM)
      logical setSingularPoint

      integer i,j
      REAL_T hxsqinv, hysqinv

      hxsqinv = one/(h(1)*h(1))
      hysqinv = one/(h(2)*h(2))

      do j = lo(2),hi(2)
        do i = lo(1),hi(1) 
          dgphi(i,j) = DGXY
        enddo
      enddo

      end



c *************************************************************************
c ** COARSIGMA **
c ** Coarsen the edge-based sigma coefficients
c *************************************************************************

      subroutine FORT_COARSIGMA(sigmax,DIMS(sigmax),sigmay,DIMS(sigmay),
     &                          sigmaxc,DIMS(sigmaxc),sigmayc,DIMS(sigmayc),
     &                          lo,hi,loc,hic)

      implicit none
      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(sigmax)
      integer DIMDEC(sigmay)
      integer DIMDEC(sigmaxc)
      integer DIMDEC(sigmayc)
      REAL_T  sigmax(DIM12(sigmax))
      REAL_T  sigmay(DIM12(sigmay))
      REAL_T sigmaxc(DIM12(sigmaxc))
      REAL_T sigmayc(DIM12(sigmayc))

c     Local variables
      integer i,j,twoi,twoj

      do j = loc(2),hic(2) 
        do i = loc(1),hic(1)+1 
          twoi = 2*(i-loc(1))+lo(1)
          twoj = 2*(j-loc(2))+lo(2)
          sigmaxc(i,j) = half*(sigmax(twoi,twoj) + sigmax(twoi,twoj+1))
        enddo
      enddo

      do j = loc(2),hic(2)+1 
        do i = loc(1),hic(1) 
          twoi = 2*(i-loc(1))+lo(1)
          twoj = 2*(j-loc(2))+lo(2)
          sigmayc(i,j) = half*(sigmay(twoi,twoj) + sigmay(twoi+1,twoj))
        enddo
      enddo


      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservatively average the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,DIMS(res),resc,DIMS(resc),
     &                         lo,hi,loc,hic)

      implicit none
      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(res)
      integer DIMDEC(resc)
      REAL_T  res(DIM12(res))
      REAL_T resc(DIM12(resc))

c     Local variables
      integer i,j,twoi,twoj

c ::: NOTE: dont need factor of r here for volume-weighting because
c ::: what were calling the residual is really already r*residual

      do j = loc(2),hic(2) 
        do i = loc(1),hic(1) 
          twoi = 2*(i-loc(1))+lo(1)
          twoj = 2*(j-loc(2))+lo(2)
          resc(i,j) = ((res(twoi  ,twoj) + res(twoi  ,twoj+1)) + 
     $                 (res(twoi+1,twoj) + res(twoi+1,twoj+1)))*fourth
        enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise constant interpolation
c *************************************************************************

      subroutine FORT_INTERPOLATE(phi,DIMS(phi),deltac,DIMS(deltac),
     &                            lo,hi,loc,hic)

      implicit none
      integer lo(SDIM),hi(SDIM)
      integer loc(SDIM),hic(SDIM)
      integer DIMDEC(phi)
      integer DIMDEC(deltac)
      REAL_T    phi(DIM12(phi))
      REAL_T deltac(DIM12(deltac))

c     Local variables
      integer i,j,twoi,twoj

      do j = loc(2), hic(2) 
        do i = loc(1), hic(1) 

          twoi = 2*(i-loc(1))+lo(1)
          twoj = 2*(j-loc(2))+lo(2)
          phi(twoi  ,twoj  ) = phi(twoi  ,twoj  ) + deltac(i,j)
          phi(twoi+1,twoj  ) = phi(twoi+1,twoj  ) + deltac(i,j)
          phi(twoi  ,twoj+1) = phi(twoi  ,twoj+1) + deltac(i,j)
          phi(twoi+1,twoj+1) = phi(twoi+1,twoj+1) + deltac(i,j)

        enddo
      enddo

      return
      end

c *************************************************************************
c ** MACFILL_TWOD **
c *************************************************************************

      subroutine FORT_MACFILL_TWOD(lenx,leny,length,width,faces,numOutFlowFaces,
     $                             cc0,cc1,cc2,cc3,cc4,cc5,conn)

      integer lenx,leny,length,width
      integer faces(4)
      integer numOutFlowFaces
      REAL_T cc0(lenx,leny,2)
      REAL_T cc1(lenx,leny,2)
      REAL_T cc2(lenx,leny,2)
      REAL_T cc3(lenx,leny,2)
      REAL_T cc4(lenx,leny,2)
      REAL_T cc5(lenx,leny,2)
      REAL_T conn(length,2)

      integer xlo_outflow,ylo_outflow,zlo_outflow
      integer xhi_outflow,yhi_outflow,zhi_outflow
      integer i,ifinal,n
      REAL_T sum 

#define XLO 0
#define YLO 1
#define ZLO 2
#define XHI 3
#define YHI 4
#define ZHI 5

c     Want to find any non-outflow faces.
      xlo_outflow = 0
      ylo_outflow = 0
      zlo_outflow = 0
      xhi_outflow = 0
      yhi_outflow = 0
      zhi_outflow = 0

      do i = 1, numOutFlowFaces
        if (faces(i) .eq. XLO) xlo_outflow = 1
        if (faces(i) .eq. YLO) ylo_outflow = 1
        if (faces(i) .eq. ZLO) zlo_outflow = 1
        if (faces(i) .eq. XHI) xhi_outflow = 1
        if (faces(i) .eq. YHI) yhi_outflow = 1
        if (faces(i) .eq. ZHI) zhi_outflow = 1
      enddo

c     Possible combinations of faces to come in here:
c       cc0 cc1 cc2 cc3
c       XLO YLO
c       XLO         YHI
c           YLO XHI
c           YLO     YHI
c       XLO YLO XHI
c       XLO     XHI YHI
c       XLO YLO     YHI
c           YLO XHI YHI
c       XLO YLO XHI YHI

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: INFL_FORCE_F.F,v 1.5 2002/10/17 20:36:40 marc Exp $
c

#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"
#include "infl_frc.H"
#include "FLUCTFILE.H"
#include "BC_TYPES.H"

#define SDIM BL_SPACEDIM

#define FF_UNIT       20

#if defined(BL_T3E)
#define OPEN_APPEND position='append'
#elif defined(BL_AIX)
#define OPEN_APPEND position='append'
#else
#define OPEN_APPEND access='append'
#endif

c ::: -----------------------------------------------------------
c ::: This routine is used by INITDATA and the fill routines to 
c ::: extrapolate the perturbations from the flct_file to 
c ::: fill the data required for forcing the inflow.  Mostly this 
c ::: routine manages the reading of the data from the flct_file
c ::: and then passes off to the XTR_DAT routine to actually
c ::: extrapolate the data and fill the arrays.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: fillComp       =>  Component to fill
c ::: DIMS(inflDat)  =>  Dimensions of inflDat
c ::: inflDat       <=   Array to fill
c ::: dx             =>  Grid spacing
c ::: time           =>  Time for the fill
c ::: -----------------------------------------------------------
c
      subroutine INFL_FILL(fillComp, DIMS(inflDat), inflDat, xlo, dx, time,
     $                     bc, probLo, probHi)
      
c
c     :::: Passed Variables ::::
c
      implicit none
      integer fillComp
      integer DIMDEC(inflDat)
      integer bc(SDIM,2)

      REAL_T time
      REAL_T xlo(SDIM), dx(SDIM)
      REAL_T inflDat(DIMV(inflDat))
      REAL_T probLo(SDIM), probHi(SDIM)

c
c     ::::: local variables
c
      integer lo(SDIM), hi(SDIM)
      integer n, npass, filePnt, storePnt, filePntOld, filePntReqd,
     $        maxFilePntChng, npassOld
      REAL_T dtFile, timeMaxFile, timeOffset, timePnt,
     $       dtEstimate
      logical is_periodic

c
c     The arrays below are dimensioned as 3-d no matter what the 
c     BL_SPACEDIM is.  This is to allow for the fact that the inflow forcing
c     data arrays are always 3-d.
c
      integer dimFile(3), loStoreDim(3), hiStoreDim(3)
      integer FF_DIMDEC(storDat)
      REAL_T dxFile(3), probSizeFile(3), xloFile(3), xhiFile(3)
      REAL_T storDat(:,:,:,:)
      allocatable storDat
      save loStoreDim, hiStoreDim, storDat,
     $     dimFile, xloFile, xhiFile, dxFile, dtFile, timeMaxFile, 
     $     storePnt, filePnt, maxFilePntChng, timePnt, timeOffset, npass

c
c     ::::: common blocks
c
#include "INFL_FORCE_F.H"


c
c     --------------------------------------------------------
c     :::: Allocate and Fill the Arrays on the First Call ::::
c     --------------------------------------------------------
c
      if (.NOT. ALLOCATED(storDat)) then
        open(FF_UNIT, file=flct_file, form='unformatted')
        call RD_FLCTHD(FF_UNIT, dimFile, probSizeFile, dxFile)
        close(FF_UNIT)

c 
c  do some size checking
c
        call SET_LOHI(DIMS(inflDat), lo, hi)

#if 0
        do n= 1,SDIM
          if (n .NE. strmwse_dir) then
            is_periodic = bc(n,1) .eq. INT_DIR .and. 
     $                    xlo(n) + dx(n)*half .lt. probLo(n)
            is_periodic = is_periodic .or. (bc(n,2) .eq. INT_DIR .and.
     $             xlo(n) + dx(n)*(float(hi(n)-lo(n)) + half) .gt. probHi(n))

            if (.NOT.is_periodic .AND.
     $          (probHi(n) - probLo(n) .lt. probSizeFile(n))) then
              print *, "turbFile is too big in dir ",n,probSizeFile(n),
     $                     probHi(n)-probLo(n)
              call BL_PD_ABORT()
            endif

            if (is_periodic .and. 
     $          probHi(n)-probLo(n) - (probSizeFile(n)-two*dxFile(n)) 
     $                                             .gt. 0.001d0*dxFile(n)) then
              print *, "size wrong in periodic dir",n,
     $                      probSizeFile(n)-two*dxFile(n), probHi(n)-probLo(n)
              call BL_PD_ABORT()
            endif
          endif
        enddo

#endif

        do n = 1, SDIM
          xloFile(n) = half * (probHi(n) + probLo(n)) - half * probSizeFile(n)
          xhiFile(n) = xloFile(n) + probSizeFile(n)
          if (n .ne. strmwse_dir) then
             write(6,1001) n,probLo(n),probHi(n),xloFile(n),xhiFile(n)
          endif
        enddo
 1001   format('dir: ',i2,' problem: ',f10.5,2x,f10.5,' file:',f10.5,2x,f10.5)
#if (BL_SPACEDIM==2)
        xloFile(3) = zero
        xhiFile(3) = zero
#endif

c
c       :::: Set the Dimensions for the inflow data array and allocate space
c
        do n = 1, 3
          loStoreDim(n) = 1
          hiStoreDim(n) = dimFile(n)
        enddo
        if (numInflPlanesStore .GT. 0 .AND.
     $      numInflPlanesStore .LT. hiStoreDim(strmwse_dir))
     $    hiStoreDim(strmwse_dir) = numInflPlanesStore

        call FF_SET_ARGS(FF_DIMS(storDat), loStoreDim, hiStoreDim)

        ALLOCATE(storDat(FF_DIMV(storDat),COMP_FLCTFILE))
        

c
c       ::::   Convert the streamwise direction lengths to times   ::::
c       :::: and set up the pointers into the data arrays and file ::::
c
        timeMaxFile = probSizeFile(strmwse_dir) / convVel
        dtFile = dxFile(strmwse_dir) / convVel

        npass = INT(time / timeMaxFile)
        timeOffset = FLOAT(npass) * timeMaxFile

        filePnt = INT((time - timeOffset) / dtFile) + 1
        timePnt = timeOffset + FLOAT(filePnt-1) * dtFile
        storePnt = 2
        maxFilePntChng = 0

c
c       ::: Fill the data Arrays :::
c
        call FILL_FRCARRYS(filePnt - 1, 1, dimFile, COMP_FLCTFILE,
     $                     FF_DIMS(storDat), storDat)
      endif

c
c     ------------------------------------------
c     :::: Find Correct Interpolation Point ::::
c     ------------------------------------------
c
      call FF_SET_ARGS(FF_DIMS(storDat), loStoreDim, hiStoreDim)

#ifdef INFL_FRC_DIAGS
      OPEN(12,file='LOG.Inflow_Forcing',OPEN_APPEND)
      if (fillComp .eq. FLCT_XVEL) then
        WRITE(12,2000) 'X',time, storePnt, filePnt, npass, timeOffset,
     $                 dimFile(strmwse_dir), numInflPlanesStore, maxFilePntChng
      else if (fillComp .eq. FLCT_YVEL) then
        WRITE(12,2000) 'Y',time, storePnt, filePnt, npass, timeOffset,
     $                 dimFile(strmwse_dir), numInflPlanesStore, maxFilePntChng
      else if (fillComp .eq. FLCT_ZVEL) then
        WRITE(12,2000) 'Z',time, storePnt, filePnt, npass, timeOffset,
     $                 dimFile(strmwse_dir), numInflPlanesStore, maxFilePntChng
      endif
      close(12)
#endif
      filePntOld = filePnt
      npassOld = npass
      do while ( (time .lt. timePnt - half*dtFile) .or.
     $           (time .gt. timePnt + half*dtFile) )
        if (time .gt. timePnt + half*dtFile) then
          filePnt = filePnt + 1
          storePnt = storePnt + 1

          if (filePnt .gt. dimFile(strmwse_dir) - 1) then
            npass = npass + 1
            timeOffset = FLOAT(npass) * timeMaxFile

            filePnt = filePnt - dimFile(strmwse_dir) + 1
          endif

        else if (time .lt. timePnt - half*dtFile) then
          filePnt = filePnt - 1
          storePnt = storePnt - 1

          if (filePnt .lt. 1) then
            npass = npass - 1
            timeOffset = FLOAT(npass) * timeMaxFile

            filePnt = filePnt + dimFile(strmwse_dir) - 1
          endif
        endif

        timePnt = timeOffset + FLOAT(filePnt-1) * dtFile
      enddo

      if (npass .eq. npassOld) 
     $  maxFilePntChng = MAX(maxFilePntChng, ABS(filePnt-filePntOld))

#ifdef INFL_FRC_DIAGS
      OPEN(12,file='LOG.Inflow_Forcing',OPEN_APPEND)
      if (fillComp .eq. FLCT_XVEL) then
        WRITE(12,2000) 'X',time, storePnt, filePnt, npass, timeOffset,
     $                 dimFile(strmwse_dir), numInflPlanesStore, maxFilePntChng
      else if (fillComp .eq. FLCT_YVEL) then
        WRITE(12,2000) 'Y',time, storePnt, filePnt, npass, timeOffset,
     $                 dimFile(strmwse_dir), numInflPlanesStore, maxFilePntChng
      else if (fillComp .eq. FLCT_ZVEL) then
        WRITE(12,2000) 'Z',time, storePnt, filePnt, npass, timeOffset,
     $                 dimFile(strmwse_dir), numInflPlanesStore, maxFilePntChng
      endif
 2000 FORMAT(A1,1xE11.3,1x,3(I3,1x),E11.3,1x,3(I3,1x))
      close(12)
#endif


c
c     -------------------------------------------
c     ::: Load Data if off end of stored data :::
c     -------------------------------------------
c
c     *** Stepped off the right edge of the stored data ***
c
      if (storePnt + 1 .gt. hiStoreDim(strmwse_dir)) then
        filePntReqd = filePnt - maxFilePntChng

        call FILL_FRCARRYS(filePntReqd - 1, 1, dimFile, COMP_FLCTFILE,
     $                     FF_DIMS(storDat), storDat)
        storePnt = 2 - filePntReqd + filePnt

#ifdef INFL_FRC_DIAGS
        OPEN(12,file='LOG.Inflow_Forcing',OPEN_APPEND)
        WRITE(12,2010) storePnt, filePnt, filePntReqd
        close(12)
 2010 FORMAT(12x,3(I3,1x))
#endif

c
c     *** Stepped off the left edge of the stored data ***
c
c     In this case we flush the data array and load it entirely from scratch.
c     I really should fix the shifting routine to allow the data to be right 
c     shifted as well as left shifted. SAS
c
      else if (storePnt - 1 .lt. 1) then
        open(11,file='WARNING.Inflow_Forcing',OPEN_APPEND)
        write(11,1000) storePnt, filePnt, timePnt, npass, timeOffset,
     $                 dtFile, dimFile(strmwse_dir), time
 1000   format('** Stepped off the left end of the stored data.  Reloading',
     $        /3x,'the entire data array.',
     $        /3x,'storePnt = ',I3,2x,'filePnt = ',I3,2x,'timePnt = ',E12.4,
     $        /3x,'npass = ',I3,2x,'timeOffset = ',E12.4,2x,'dtFile = ',E12.4,
     $        /3x,'dimFile = ',I3,2x,'time = ',E12.4)
        close(11)
        call FILL_FRCARRYS(filePnt - 1, 1, dimFile, COMP_FLCTFILE,
     $                     FF_DIMS(storDat), storDat)
        storePnt = 2

#ifdef INFL_FRC_DIAGS
        OPEN(12,file='LOG.Inflow_Forcing',OPEN_APPEND)
        WRITE(12,2020) storePnt, filePnt
        close(12)
 2020 FORMAT('BACK LOAD',3x,2(I3,1x))
#endif
      endif


c
c     -----------------------------------------
c     :::: Interpolate Data to Fill inflDat :::
c     -----------------------------------------
c
      call INTRP_DATA(time, xlo, dx, storePnt, fillComp, timePnt, dtFile,
     $                dxFile, xloFile, xhiFile, COMP_FLCTFILE, 
     $                FF_DIMS(storDat), storDat, DIMS(inflDat), inflDat,
     $                bc, probLo, probHi)

c
c
      return
      end

c
c ::: -----------------------------------------------------------
c ::: This routine fills the inflow forcing data array from the file.
c ::: A basepoint is specified for the array as well as for the file.
c ::: These are the points in the strmwse_dir at which reading from the
c ::: file is started and at which the array is filled from.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: baseFilePnt   => Basepoint in the file in the strmwse_dir to 
c :::                    start reading from.
c ::: baseArrayPnt  => Basepoint in the array in the strmwse_dir to 
c :::                    start filling from.  The array is filled from
c :::                    this point in strmwse_dir to the end of the 
c :::                    array.
c ::: dimFile       => Dimensions from the header of the fluctuations
c ::: nComp         => Number of components in the array
c ::: FF_DIMS(dat)  => Dimensions of the array dat
c ::: dat          <=  Array to fill
c ::: -----------------------------------------------------------
c
      subroutine FILL_FRCARRYS(baseFilePnt, baseArrayPnt, dimFile, 
     $                         nComp, FF_DIMS(dat), dat)

c
c     *****************************
c     *** Variable Declarations ***
c     *****************************
c
      implicit none

c
c     *** Passed Variables ***
c
      integer baseFilePnt, baseArrayPnt, nComp, dimFile(3)
      integer FF_DIMDEC(dat)
      REAL_T dat(FF_DIMV(dat),nComp)

c
c     *** Local Variables ***
c
      integer intDummy, n
      integer lo(3), hi(3), loRd(3), hiRd(3), filLo(3)
      REAL_T realDummy

c
c     ::: Common Blocks :::
c
#include "INFL_FORCE_F.H"

c
c     *** Define the LO and HI arrays ***
c
      call FF_SET_LOHI(FF_DIMS(dat), lo, hi)

c
c     ------------------------------------------------------
c     *** Wrap baseFilePnt into the box if it is outside ***
c     ------------------------------------------------------
c
c     Note: This assumes the first and last point in the file 
c           are the same.  This is the case for data generated with mkInitFlct.
c
      if (baseFilePnt .lt. 1) then
        baseFilePnt = dimFile(strmwse_dir) - (1 - baseFilePnt)
      endif

      if (baseFilePnt .gt. dimFile(strmwse_dir) - 1) then
        baseFilePnt = baseFilePnt - (dimFile(strmwse_dir) - 1)
      endif

c
c     ----------------------------------------------------
c     *** If the data can be filled in one pass, do so ***
c     ----------------------------------------------------
c
      if (hi(strmwse_dir) - baseArrayPnt + 1 
     $                        .LE. dimFile(strmwse_dir) - baseFilePnt + 1) then

        do n = 1, 3
          filLo(n) = 1
          loRd(n) = lo(n)
          hiRd(n) = hi(n)
        enddo
        loRd(strmwse_dir) = baseArrayPnt
        filLo(strmwse_dir) = baseFilePnt

        open(FF_UNIT, file=flct_file, form='unformatted')
        read(FF_UNIT) intDummy
        read(FF_UNIT) realDummy
        read(FF_UNIT) intDummy
        do n = 1, nComp
          call RD_FLCTREC(FF_UNIT, dimFile, loRd, hiRd, filLo, FF_DIMS(dat),
     $                    dat(lo(1),lo(2),lo(3),n))
        enddo
        close(FF_UNIT)


c
c     --------------------------------------------------------------
c     *** If the data can not be filled in one pass, fill in two ***
c     ***   passes wrapping around in the streamwise direction   ***
c     --------------------------------------------------------------
c
c     Note: In this case, we are guaranteed that the arrays can be filled 
c           in two passes since the array is guaranteed not to have 
c           dimensions larger than the data in the file.
c
      else
c
c       Fill as much data as can be read without reading beyond the end of
c       the file
c
        do n = 1, 3
          filLo(n) = 1
          loRd(n) = lo(n)
          hiRd(n) = hi(n)
        enddo
        filLo(strmwse_dir) = baseFilePnt
        loRd(strmwse_dir) = baseArrayPnt
        hiRd(strmwse_dir) = loRd(strmwse_dir) + dimFile(strmwse_dir) 
     $                                                         - baseFilePnt

        open(FF_UNIT, file=flct_file, form='unformatted')
        read(FF_UNIT) intDummy
        read(FF_UNIT) realDummy
        read(FF_UNIT) intDummy
        do n = 1, nComp
          call RD_FLCTREC(FF_UNIT, dimFile, loRd, hiRd, filLo, FF_DIMS(dat),
     $                    dat(lo(1),lo(2),lo(3),n))
        enddo
        close(FF_UNIT)

c
c       Now fill the rest of the array starting from the beginning of the file
c
c       Note: The first point in the file in the streamwise direction is 
c             skipped because it is identical to the last point in the file.
c
        filLo(strmwse_dir) = 2
        loRd(strmwse_dir) = hiRd(strmwse_dir) + 1
        hiRd(strmwse_dir) = hi(strmwse_dir)

        open(FF_UNIT, file=flct_file, form='unformatted')
        read(FF_UNIT) intDummy
        read(FF_UNIT) realDummy
        read(FF_UNIT) intDummy
        do n = 1, nComp
          call RD_FLCTREC(FF_UNIT, dimFile, loRd, hiRd, filLo, FF_DIMS(dat),
     $                    dat(lo(1),lo(2),lo(3),n))
        enddo
        close(FF_UNIT)
      endif

c
c
      RETURN
      END

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: INFL_FORCE_2D.F,v 1.1 2000/06/06 18:39:24 sstanley Exp $
c

#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "ArrayLim.H"
#include "infl_frc.H"
#include "FLUCTFILE.H"

#define SDIM 2

c ::: -----------------------------------------------------------
c ::: This routine does the interpolation of the inflow data
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: time              =>  Time at which to fill the data
c ::: xlo               =>  Lower physical location of the inflDat array
c ::: dx                =>  Grid spacing in the inflDat array
c ::: storePnt          =>  Interpolation point in the strmwse_dir direction
c ::: fillComp          =>  Component from the storDat array to use
c ::: timePnt           =>  Physical time corresponding to the storePnt point
c :::                         in the data in storDat
c ::: dtFile            =>  Time step in the array storDat
c ::: nCompStorDat      =>  Number of components in the storDat array
c ::: FF_DIMS(storDat)  =>  Dimensions of storDat
c ::: storDat           =>  Array to fill
c ::: DIMS(inflDat)     =>  Dimensions of the inflDat array
c ::: inflDat          <=   Array to fill by interpolating from the storDat 
c :::                         array
c ::: -----------------------------------------------------------
c :::
c ::: NOTE:  When x and y are calculated for each i and j index
c :::        in this routine, they are calculated based on formulaes
c :::        of the form,
c :::            x = probLo(1) + dx(1) * (FLOAT(i) + half)
c :::        rather than on the more common form,
c :::            x = xlo(1) + dx(1) * (FLOAT(i - lo(1)) + half)
c :::        In other words, they are calculated based on the origin
c :::        of the problem domain rather than the origin of the FAB
c :::        we are working on.  This forces the physical location for
c :::        some specified index to be identically the same no matter
c :::        which FAB we are working on.  Seems like a moot point, but
c :::        it isn't when we do an integer shift to force points outside 
c :::        of the domain in periodic directions.
c :::        
c :::        For instance if we have a domain from 0->63 in a periodic 
c :::        direction and pass in a FAB to fill with indices from -1 to 5,
c :::        the -1 index is integer shifted over to an index of 63 to do
c :::        the interpolation for the forcing.
c :::
      subroutine INTRP_DATA(time, xlo, dx, storePnt, fillComp, timePnt, dtFile,
     $                      dxFile, xloFile, xhiFile, nCompStorDat, 
     $                      FF_DIMS(storDat), storDat,
     $                      DIMS(inflDat), inflDat, bc, probLo, probHi)
      
c
c     :::: Passed Variables ::::
c
      implicit none
      integer storePnt, fillComp, nCompStorDat
      integer loStoreDim(3), hiStoreDim(3)
      integer DIMDEC(inflDat)
      integer FF_DIMDEC(storDat)
      integer bc(SDIM,2)

      REAL_T time, timePnt, dtFile
      REAL_T xlo(SDIM), dx(SDIM), dxFile(3), xloFile(3), xhiFile(3)
      REAL_T probLo(SDIM), probHi(SDIM)
      REAL_T inflDat(DIMV(inflDat))
      REAL_T storDat(FF_DIMV(storDat),nCompStorDat)

c
c     :::: local variables ::::
c
      integer i, j, iloc, jloc, kloc, ixcalc, jycalc
      integer lo(SDIM), hi(SDIM), n_lev_cells(SDIM)
      integer loStorDim(3), hiStorDim(3)
      REAL_T tm1, tp1, ctm1, ct0, ctp1, 
     $       x, xm1, x0, xp1, cxm1, cx0, cxp1,
     $       y, ym1, y0, yp1, cym1, cy0, cyp1,
     $       valm1, val0, valp1

c
c     :::: Common Blocks ::::
c
#include "INFL_FORCE_F.H"

c
c     ---------------------------------
c     ::: Fill the LO and HI arrays :::
c     ---------------------------------
c
      call SET_LOHI(DIMS(inflDat), lo, hi)
      call FF_SET_LOHI(FF_DIMS(storDat), loStorDim, hiStorDim)

      do i = 1, SDIM
        n_lev_cells(i) = (probHi(i) - probLo(i)) / dx(i)
      enddo

c
c     ----------------------------------------------
c     :::: Set the time interpolation constants ::::
c     ----------------------------------------------
c
      tm1 = timePnt - dtFile
      tp1 = timePnt + dtFile
      ctm1 = (time - timePnt) * (time - tp1) / (tm1 - timePnt) / (tm1 - tp1)
      ct0  = (time - tm1) * (time - tp1) / (timePnt - tm1) / (timePnt - tp1)
      ctp1 = (time - tm1) * (time - timePnt) / (tp1 - tm1) / (tp1 - timePnt)

c
c     ----------------------------------------------
c     :::: Interpolate to fill the inflow array ::::
c     ----------------------------------------------
c
      if (strmwse_dir .eq. FLCT_XVEL) then
c
c     :::: Streamwise X-direction ::::
c
        kloc = 1

        do j = lo(2), hi(2)
          jycalc = j
          if (bc(2,1) .eq. INT_DIR .and. j .lt. 0) then
            jycalc = j + n_lev_cells(2)
          else if (bc(2,2) .eq. INT_DIR .and. j .ge. n_lev_cells(2)) then
            jycalc = j - n_lev_cells(2)
          endif
          y = probLo(2) + dx(2)*(float(jycalc) + half)

          if ((xloFile(2) .le. y .and. y .le. xhiFile(2))) then
            jloc = (y - xloFile(2) + half*dxFile(2))/dxFile(2) + 1
            jloc = MAX(jloc, loStorDim(2)+1)
            jloc = MIN(jloc, hiStorDim(2)-1)
            y0 = FLOAT(jloc-1) * dxFile(2) + xloFile(2)
            ym1 = y0 - dxFile(2)
            yp1 = y0 + dxFile(2)
            cym1 = (y - y0)  * (y - yp1) / (ym1 - y0)  / (ym1 - yp1)
            cy0  = (y - ym1) * (y - yp1) / (y0  - ym1) / (y0  - yp1)
            cyp1 = (y - ym1) * (y - y0)  / (yp1 - ym1) / (yp1 - y0)

            val0 = cym1 * (ctm1 * storDat(storePnt-1,jloc-1,kloc,fillComp)
     $                   +  ct0 * storDat(storePnt,  jloc-1,kloc,fillComp)
     $                   + ctp1 * storDat(storePnt+1,jloc-1,kloc,fillComp))
     $           +  cy0 * (ctm1 * storDat(storePnt-1,jloc,  kloc,fillComp)
     $                   +  ct0 * storDat(storePnt,  jloc,  kloc,fillComp)
     $                   + ctp1 * storDat(storePnt+1,jloc,  kloc,fillComp))
     $           + cyp1 * (ctm1 * storDat(storePnt-1,jloc+1,kloc,fillComp)
     $                   +  ct0 * storDat(storePnt,  jloc+1,kloc,fillComp)
     $                   + ctp1 * storDat(storePnt+1,jloc+1,kloc,fillComp))

          else
            val0 = zero
          endif

          do i = lo(1), hi(1)
            inflDat(i,j) = val0
          enddo
        enddo
        
        elseif (strmwse_dir .eq. FLCT_YVEL) then
c
c     :::: Streamwise Y-direction ::::
c
        kloc = 1

        do i = lo(1), hi(1)
          ixcalc = i
          if (bc(1,1) .eq. INT_DIR .and. i .lt. 0) then
            ixcalc = i + n_lev_cells(1)
          else if (bc(1,2) .eq. INT_DIR .and. i .ge. n_lev_cells(1)) then
            ixcalc = i - n_lev_cells(1)
          endif
          x = probLo(1) + dx(1)*(float(ixcalc) + half)

          if (xloFile(1) .le. x .and. x .le. xhiFile(1)) then
            iloc = (x - xloFile(1) + half*dxFile(1))/dxFile(1) + 1
            iloc = MAX(iloc, loStorDim(1)+1)
            iloc = MIN(iloc, hiStorDim(1)-1)
            x0 = FLOAT(iloc-1) * dxFile(1) + xloFile(1)
            xm1 = x0 - dxFile(1)
            xp1 = x0 + dxFile(1)
            cxm1 = (x - x0)  * (x - xp1) / (xm1 - x0)  / (xm1 - xp1)
            cx0  = (x - xm1) * (x - xp1) / (x0  - xm1) / (x0  - xp1)
            cxp1 = (x - xm1) * (x - x0)  / (xp1 - xm1) / (xp1 - x0)

#ifdef INFL_FRC_DIAGS
      IF (.NOT.(x0-half*dxFile(1).LE.x.AND.x.LE.x0+half*dxFile(1))) THEN
        WRITE(33,*) i, iloc
        WRITE(33,*) '       ',x, x0, dxFile(1)
      ENDIF
#endif

            val0 = cxm1 * (ctm1 * storDat(iloc-1,storePnt-1,kloc,fillComp)
     $                   +  ct0 * storDat(iloc-1,storePnt,  kloc,fillComp)
     $                   + ctp1 * storDat(iloc-1,storePnt+1,kloc,fillComp))
     $           +  cx0 * (ctm1 * storDat(iloc,  storePnt-1,kloc,fillComp)
     $                   +  ct0 * storDat(iloc,  storePnt,  kloc,fillComp)
     $                   + ctp1 * storDat(iloc,  storePnt+1,kloc,fillComp))
     $           + cxp1 * (ctm1 * storDat(iloc+1,storePnt-1,kloc,fillComp)
     $                   +  ct0 * storDat(iloc+1,storePnt,  kloc,fillComp)
     $                   + ctp1 * storDat(iloc+1,storePnt+1,kloc,fillComp))

          else
            val0 = zero
          endif

          do j = lo(2), hi(2)
            inflDat(i,j) = val0
          enddo
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: LP_2D.F,v 1.5 2002/08/29 22:14:39 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <CONSTANTS.H>
#include <REAL.H>

#include "LP_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
c      
c     Gauss-Seidel Red-Black (GSRB):
c     Apply the GSRB relaxation to the state phi for the equation
c     L(phi) = Div(Grad(phi(x))) = rhs(x) central differenced, according
c     to the arrays of boundary masks (m#) and auxiliary data (f#).
c     
c     In general, if the linear operator L=gamma*y-rho, the GS relaxation
c     is y = (R - rho)/gamma.  Near a boundary, the ghost data is filled
c     using a polynomial interpolant based on the "old" phi values, so
c     L=(gamma-delta)*y - rho + delta*yOld.   The resulting iteration is
c     
c     y = (R - delta*yOld + rho)/(gamma - delta)
c     
c     This expression is valid additionally in the interior provided
c     delta->0 there.  delta is constructed by summing all the
c     contributions to the central stencil element coming from boundary 
c     interpolants.  The f#s contain the corresponding coefficient of 
c     the interpolating polynomial.  The masks are set > 0 if the boundary 
c     value was filled with an interpolant involving the central stencil 
c     element.
c     
c-----------------------------------------------------------------------
      subroutine FORT_GSRB (
     $     phi, DIMS(phi),
     $     rhs, DIMS(rhs),
     $     f0, DIMS(f0), m0, DIMS(m0),
     $     f1, DIMS(f1), m1, DIMS(m1),
     $     f2, DIMS(f2), m2, DIMS(m2),
     $     f3, DIMS(f3), m3, DIMS(m3),
     $     lo, hi, nc,
     $     h, redblack
     $     )
      integer nc
      integer DIMDEC(phi)
      REAL_T phi(DIMV(phi),nc)
      integer DIMDEC(rhs)
      REAL_T rhs(DIMV(rhs),nc)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      integer DIMDEC(f0)
      integer DIMDEC(f1)
      integer DIMDEC(f2)
      integer DIMDEC(f3)
      REAL_T f0(DIMV(f0))
      REAL_T f1(DIMV(f1))
      REAL_T f2(DIMV(f2))
      REAL_T f3(DIMV(f3))
      integer DIMDEC(m0)
      integer DIMDEC(m1)
      integer DIMDEC(m2)
      integer DIMDEC(m3)
      integer m0(DIMV(m0))
      integer m1(DIMV(m1))
      integer m2(DIMV(m2))
      integer m3(DIMV(m3))
      integer redblack
      REAL_T  h
c
      integer  i, j, ioff, n
c
      REAL_T cf0, cf1, cf2, cf3
      REAL_T delta, gamma, rho
c
      gamma = 4.0D0
      do n = 1, nc
         do j = lo(2), hi(2)
            ioff = MOD(j +  redblack,2)
            do i = lo(1) + ioff,hi(1),2
c     
               cf0 = cvmgt(f0(lo(1),j), 0.0D0,
     $              (i .eq. lo(1)) .and. (m0(lo(1)-1,j).gt.0))
               cf1 = cvmgt(f1(i,lo(2)), 0.0D0,
     $              (j .eq. lo(2)) .and. (m1(i,lo(2)-1).gt.0))
               cf2 = cvmgt(f2(hi(1),j), 0.0D0,
     $              (i .eq. hi(1)) .and. (m2(hi(1)+1,j).gt.0))
               cf3 = cvmgt(f3(i,hi(2)), 0.0D0,
     $              (j .eq. hi(2)) .and. (m3(i,hi(2)+1).gt.0))
c     
               delta = cf0 + cf1 + cf2 + cf3
c     
               rho =  phi(i-1,j,n) + phi(i+1,j,n)
     $              + phi(i,j-1,n) + phi(i,j+1,n)
c     
               phi(i,j,n) = (rhs(i,j,n)*h*h - rho + phi(i,j,n)*delta)
     $              /                (delta - gamma)
c     
            end do
         end do
      end do
      
      end
c-----------------------------------------------------------------------
c
c     Solve Preconditioned system here
c
      subroutine FORT_CGPRECND(
     $     zz, DIMS(zz),
     $     rho,
     $     rr, DIMS(rr),
     $     lo, hi, nc,
     $     h
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(zz)
      REAL_T zz(DIMV(zz),nc)
      integer DIMDEC(rr)
      REAL_T rr(DIMV(rr),nc)
      REAL_T h
      REAL_T rho
c
      integer i
      integer j
      integer n
      REAL_T denom
c
      rho = 0.0D0
      denom = -h**2/4.0D0
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               zz(i,j,n) = rr(i,j,n)*denom
               rho = rho + zz(i,j,n)*rr(i,j,n)
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
c
c     Fill in a matrix x vector operator here
c
      subroutine FORT_ADOTX(
     $     y, DIMS(y),
     $     x, DIMS(x),
     $     lo, hi, nc,
     $     h
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(y)
      REAL_T y(DIMV(y),nc)
      integer DIMDEC(x)
      REAL_T x(DIMV(x),nc)
      REAL_T h
c
      integer i, j, n
      REAL_T scal
c
      scal = 1.0D0/h**2
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               y(i,j,n) = scal*
     $              ( x(i-1,j,n) + x(i+1,j,n) 
     $              + x(i,j-1,n) + x(i,j+1,n)
     $              - 4*x(i,j,n) )
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_ESTANORM(
     &     lo, hi, nc,
     &     h
     &     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer i, j, n
      REAL_T h,res
c
      res = 8.0D0/h**2
      end
c-----------------------------------------------------------------------
c
c     Fill in fluxes
c
      subroutine FORT_FLUX(
     $     x,DIMS(x),
     $     lo,hi,nc,
     $     h,
     $     xflux,DIMS(xflux),
     $     yflux,DIMS(yflux)
     $     )
      implicit none
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(x)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      REAL_T  x(DIMV(x),nc)
      REAL_T xflux(DIMV(xflux),nc)
      REAL_T yflux(DIMV(yflux),nc)
      REAL_T h(BL_SPACEDIM)
c
      REAL_T dhx, dhy
      integer i,j,n
c
      dhx = one/h(1)
      dhy = one/h(2)
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)+1
               xflux(i,j,n) = - dhx*( x(i,j,n) - x(i-1,j,n) )
            end do
         end do
      end do
      do n = 1, nc
         do j = lo(2), hi(2)+1
            do i = lo(1), hi(1)
               yflux(i,j,n) = - dhy*( x(i,j,n) - x(i,j-1,n) )
            end do
         end do
      end do
      end

      

(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4973,        183]*)
(*NotebookOutlinePosition[      5749,        210]*)
(*  CellTagsIndexPosition[      5705,        206]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Evaluation of a 3-d Exact Solution for the Viscous, Incompressible \
Navier-Stokes Equations\
\>", "Title",
  TextAlignment->Center],

Cell[CellGroupData[{

Cell["Define Velocity, Pressure and Scalar Fields", "Section"],

Cell[BoxData[
    \(u\  = \ 
      \(-a\)\ \((
          Exp[a\ x]\ Sin[a\ y\  + \ d\ z]\  + \ 
            Exp[a\ z]\ Cos[a\ x\  + \ d\ y])\)\ Exp[\(-d^2\)\ nu\ t]\)], 
  "Input"],

Cell[BoxData[
    \(v\  = \ 
      \(-a\)\ \((\ 
          Exp[a\ y] Sin[a\ z\  + \ d\ x]\  + \ 
            Exp[a\ x]\ Cos[a\ y\  + \ d\ z])\)\ Exp[\(-d^2\)\ nu\ t]\)], 
  "Input"],

Cell[BoxData[
    \(w\  = \ 
      \(-a\)\ \((\ 
          Exp[a\ z]\ Sin[a\ x\  + \ d\ y]\  + \ 
            Exp[a\ y]\ Cos[a\ z\  + \ d\ x])\)\ Exp[\(-d^2\)\ nu\ t]\)], 
  "Input"],

Cell[BoxData[
    \(p\  = \ 
      \(-a^2\)/2\ 
        \((Exp[2\ a\ x]\  + \ Exp[2\ a\ y]\  + \ Exp[2\ a\ z]\  + \ 
            2\ Sin[a\ x\  + \ d\ y]\ Cos[a\ z\  + \ d\ x]\ 
              Exp[a\ \((y\  + \ z)\)]\  + \ 
            2\ Sin[a\ y\  + \ d\ z]\ Cos[a\ x\  + \ d\ y]\ 
              Exp[a\ \((z\  + \ x)\)]\  + \ 
            2\ Sin[a\ z\  + \ d\ x]\ Cos[a\ y\  + \ d\ z]\ 
              Exp[a\ \((x\  + \ y)\)])\)\ Exp[\(-2\)\ d^2\ nu\ t]\)], "Input"],

Cell[BoxData[
    \(Y\  = \ \.18\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check Governing Equations", "Section"],

Cell[BoxData[
    \(Simplify[D[u, x]\  + \ D[v, y]\  + \ D[w, z]\  == \ 0]\)], "Input"],

Cell[BoxData[
    \(Simplify[
      D[u, t]\  + \ u\ D[u, x]\  + \ v\ D[u, y]\  + \ w\ D[u, z]\  == \ 
        \(-\ D[p, x]\)\  + \ nu\ D[u, {x, 2}] + \ nu\ D[u, {y, 2}]\  + \ 
          nu\ D[u, {z, 2}]]\)], "Input"],

Cell[BoxData[
    \(Simplify[
      D[v, t]\  + \ u\ D[v, x]\  + \ v\ D[v, y]\  + \ w\ D[v, z]\  == \ 
        \(-\ D[p, y]\)\  + \ nu\ D[v, {x, 2}] + \ nu\ D[v, {y, 2}]\  + \ 
          nu\ D[v, {z, 2}]]\)], "Input"],

Cell[BoxData[
    \(Simplify[
      D[w, t]\  + \ u\ D[w, x]\  + \ v\ D[w, y]\  + \ w\ D[w, z]\  == \ 
        \(-\ D[p, z]\)\  + \ nu\ D[w, {x, 2}] + \ nu\ D[w, {y, 2}]\  + \ 
          nu\ D[w, {z, 2}]]\)], "Input"],

Cell[BoxData[
    \(Simplify[
      D[Y, t]\  + \ u\ D[Y, x]\  + \ v\ D[Y, y]\  + \ w\ D[Y, z]\  == \ 
        d\ D[Y, {x, 2}]\  + \ d\ D[Y, {y, 2}]\  + \ d\ D[Y, {z, 2}]]\)], 
  "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Evaluate the Fields for a=Pi, d=Pi", "Section"],

Cell[BoxData[
    \(a\  = \ Pi\)], "Input"],

Cell[BoxData[
    \(d\  = \ Pi\)], "Input"],

Cell[BoxData[
    \(u\)], "Input"],

Cell[BoxData[
    \(v\)], "Input"],

Cell[BoxData[
    \(w\)], "Input"],

Cell[BoxData[
    \(p\)], "Input"],

Cell[BoxData[
    \(t\  = \ 0\)], "Input"],

Cell[BoxData[
    \(z\  = \ 0\)], "Input"],

Cell[BoxData[
    \(Remove[a]\)], "Input"],

Cell[BoxData[
    \(Remove[d]\)], "Input"],

Cell[BoxData[
    \(Remove[z]\)], "Input"],

Cell[BoxData[
    \(Remove[t]\)], "Input"],

Cell[BoxData[
    \(ContourPlot[u, {x, 0, 2}, \ {y, 0, 2}]\)], "Input"],

Cell[BoxData[
    \(ContourPlot[v, {x, 0, 2}, \ {y, 0, 2}]\)], "Input"],

Cell[BoxData[
    \(ContourPlot[p, {x, 0, 2}, \ {y, 0, 2}]\)], "Input"],

Cell[BoxData[
    \(ContourPlot[Y, {x, 0, 2}, \ {y, 0, 2}]\)], "Input"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{520, 600},
WindowMargins->{{296, Automatic}, {Automatic, 88}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 142, 4, 90, "Title"],

Cell[CellGroupData[{
Cell[1898, 59, 62, 0, 47, "Section"],
Cell[1963, 61, 180, 5, 43, "Input"],
Cell[2146, 68, 181, 5, 43, "Input"],
Cell[2330, 75, 182, 5, 43, "Input"],
Cell[2515, 82, 465, 9, 91, "Input"],
Cell[2983, 93, 45, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3065, 99, 44, 0, 47, "Section"],
Cell[3112, 101, 87, 1, 27, "Input"],
Cell[3202, 104, 217, 4, 43, "Input"],
Cell[3422, 110, 217, 4, 43, "Input"],
Cell[3642, 116, 217, 4, 43, "Input"],
Cell[3862, 122, 187, 4, 43, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4086, 131, 53, 0, 47, "Section"],
Cell[4142, 133, 43, 1, 27, "Input"],
Cell[4188, 136, 43, 1, 27, "Input"],
Cell[4234, 139, 34, 1, 27, "Input"],
Cell[4271, 142, 34, 1, 27, "Input"],
Cell[4308, 145, 34, 1, 27, "Input"],
Cell[4345, 148, 34, 1, 27, "Input"],
Cell[4382, 151, 42, 1, 27, "Input"],
Cell[4427, 154, 42, 1, 27, "Input"],
Cell[4472, 157, 42, 1, 27, "Input"],
Cell[4517, 160, 42, 1, 27, "Input"],
Cell[4562, 163, 42, 1, 27, "Input"],
Cell[4607, 166, 42, 1, 27, "Input"],
Cell[4652, 169, 71, 1, 27, "Input"],
Cell[4726, 172, 71, 1, 27, "Input"],
Cell[4800, 175, 71, 1, 27, "Input"],
Cell[4874, 178, 71, 1, 27, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: DIFFUSION_2D.F,v 1.8 2002/08/29 22:14:52 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "DIFFUSION_F.H"
#include "ArrayLim.H"

#define SDIM 2

c ::
c :: ----------------------------------------------------------
c :: compute the time averaged viscous flux at the given edge
c ::  for variable transport coefficients
c ::
c :: NOTE:
c ::   These are only computed for a reflux operation, and require
c ::   that the ghost cells have been filled according to the 
c ::   diffusion operator (maybe this isn't such a good idea...)
c :: ----------------------------------------------------------
c ::

      subroutine FORT_VISCFLUX_VC (s_o,s_n,DIMS(s),lo,hi,
     $                             flux, DIMS(flux), area, DIMS(area),
     $                             bn, bnp1, DIMS(b),
     $                             dx,mult,theta,dir)

      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(s)
      integer DIMDEC(flux)
      integer DIMDEC(area)
      integer DIMDEC(b)
      REAL_T  s_o(DIMV(s))
      REAL_T  s_n(DIMV(s))
      REAL_T  flux(DIMV(flux))
      REAL_T  area(DIMV(area))
      REAL_T  bn(DIMV(b))
      REAL_T  bnp1(DIMV(b))
      REAL_T  dx
      REAL_T  mult,theta
      integer dir

      integer i, j
      REAL_T  sx1, sx2, sy1, sy2
      REAL_T  onemintheta

      onemintheta = one-theta
      if (dir .EQ. 0) then
c     ::::: compute X fluxes
         do j = lo(2), hi(2)
         do i = lo(1), hi(1)+1
            sx1 = (s_o(i,j) - s_o(i-1,j))*bn(i,j)
            sx2 = (s_n(i,j) - s_n(i-1,j))*bnp1(i,j)
            flux(i,j) = mult*(onemintheta*sx1 + theta*sx2)*area(i,j)/dx
         end do
         end do
      else
c     ::::: compute Y fluxes
         do j = lo(2), hi(2)+1
         do i = lo(1), hi(1)
            sy1 = (s_o(i,j) - s_o(i,j-1))*bn(i,j)
            sy2 = (s_n(i,j) - s_n(i,j-1))*bnp1(i,j)
            flux(i,j) = mult*(onemintheta*sy1 + theta*sy2)*area(i,j)/dx
         end do
         end do
      end if
      end

c ::
c :: ----------------------------------------------------------
c :: compute the time averaged viscous flux at the given edge
c ::  for constant transport coefficients
c ::
c :: NOTE:
c ::   These are only computed for a reflux operation, and require
c ::   that the ghost cells have been filled according to the 
c ::   diffusion operator (maybe this isn't such a good idea...)
c :: ----------------------------------------------------------
c ::

      subroutine FORT_VISCFLUX_CC (s_o,s_n,DIMS(s),lo,hi,
     $                             flux, DIMS(flux), area, DIMS(area),
     $                             dx,mult,theta,dir)

      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(s)
      integer DIMDEC(flux)
      integer DIMDEC(area)
      REAL_T  s_o(DIMV(s))
      REAL_T  s_n(DIMV(s))
      REAL_T  flux(DIMV(flux))
      REAL_T  area(DIMV(area))
      REAL_T  dx
      REAL_T  mult,theta
      integer dir

      integer i, j
      REAL_T  sx1, sx2, sy1, sy2
      REAL_T  onemintheta

      onemintheta = one-theta
      if (dir .EQ. 0) then
c     ::::: compute X fluxes
         do j = lo(2), hi(2)
         do i = lo(1), hi(1)+1
            sx1 = s_o(i,j) - s_o(i-1,j)
            sx2 = s_n(i,j) - s_n(i-1,j)
            flux(i,j) = mult*(onemintheta*sx1 + theta*sx2)*area(i,j)/dx
         end do
         end do
      else
c     ::::: compute Y fluxes
         do j = lo(2), hi(2)+1
         do i = lo(1), hi(1)
            sy1 = s_o(i,j) - s_o(i,j-1)
            sy2 = s_n(i,j) - s_n(i,j-1)
            flux(i,j) = mult*(onemintheta*sy1 + theta*sy2)*area(i,j)/dx
         end do
         end do
      end if
      end

      subroutine FORT_VISCSYNCFLUX (ssync,DIMS(ssync),lo,hi,
     $                              xflux,DIMS(xf),yflux,DIMS(yf),
     $                              xarea,DIMS(ax),yarea,DIMS(ay),dx,mult)

      integer lo(2), hi(2)
      integer DIMDEC(ssync)
      integer DIMDEC(xf)
      integer DIMDEC(yf)
      integer DIMDEC(ax)
      integer DIMDEC(ay)
      REAL_T  ssync(DIMV(ssync))
      REAL_T  xflux(DIMV(xf))
      REAL_T  yflux(DIMV(yf))
      REAL_T  xarea(DIMV(ax))
      REAL_T  yarea(DIMV(ay))
      REAL_T  dx(2)
      REAL_T  mult

      REAL_T  sx
      REAL_T  sy
      integer i, j
c
c     ::::: compute X fluxes
c
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)+1
	       sx = ssync(i,j) - ssync(i-1,j)
               xflux(i,j) = mult*sx*xarea(i,j)/dx(1)
            end do
         end do
c
c     ::::: compute Y fluxes
c
         do j = lo(2), hi(2)+1
            do i = lo(1), hi(1)
	       sy = ssync(i,j) - ssync(i,j-1)
               yflux(i,j) = mult*sy*yarea(i,j)/dx(2)
	    end do
         end do

      end

c :: ----------------------------------------------------------
c :: HOOPSRC
c ::             fab(i,j) = fab(i,j) - mu*u/(r(i)^2)
c ::
c :: INPUTS / OUTPUTS:
c ::  fab       <=  array to be modified
c ::  DIMS(fab)  => index limits of fab
c ::  mu         => viscous coefficient
c :: ----------------------------------------------------------
c ::
       subroutine FORT_HOOPSRC (DIMS(grid), fab, DIMS(fab), u, DIMS(u), r, mu)

       integer DIMDEC(grid)
       integer DIMDEC(fab)
       integer DIMDEC(u)
       REAL_T  fab(DIMV(fab))
       REAL_T  u(DIMV(u))
       REAL_T  r(DIM1(grid))
       REAL_T  mu

       integer i, j

c      if (ARG_L1(u) .lt. ARG_L1(fab) .or. ARG_H1(u) .gt. ARG_H1(fab)) then
c         write(6,*) "FORT_HOOPSRC: bad index limits"
c         stop
c      end if

       do j = ARG_L2(grid), ARG_H2(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             fab(i,j) = fab(i,j) - mu*u(i,j)/(r(i)*r(i))
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: HOOPRHS
c ::             rhs(i,j) = rhs(i,j) - (one-theta)*dt*u*mu*vol/(r(i)^2)
c ::
c :: INPUTS / OUTPUTS:
c ::  fab       <=  array to be modified
c ::  DIMS(fab)  => index limits of fab
c ::  u          => array to be modified
c ::  DIMS(u)    => index limits of u
c ::  r          => 1-D r array (in first coordinate direction)
c ::  mu         => scalar viscosity
c ::  dt         => time step
c ::  vol        => volume array
c ::  DIMS(vol)  => index limits of vol
c ::  b          => (one-theta)*dt
c :: ----------------------------------------------------------
c ::
       subroutine FORT_HOOPRHS (fab, DIMS(fab), u, DIMS(u), r, b,
     &                          vol, DIMS(vol))
       integer DIMDEC(fab)
       integer DIMDEC(u)
       integer DIMDEC(vol)
       REAL_T  fab(DIMV(fab))
       REAL_T  u(DIMV(u))
       REAL_T  vol(DIMV(vol))
       REAL_T  r(DIM1(fab))
       REAL_T  b

       integer i, j

       do j = ARG_L2(fab), ARG_H2(fab)
          do i = ARG_L1(fab), ARG_H1(fab)
             fab(i,j) = fab(i,j) - b*vol(i,j)*u(i,j)/(r(i)*r(i))
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: TENSOR_HOOPRHS
c ::             rhs(i,j) = rhs(i,j) - (1-theta)*dt*u*two*mu_cen*vol/(r(i)^2)
c ::                                                  ^^^ yes, that is correct
c ::                                                      for variable mu
c ::
c :: INPUTS / OUTPUTS:
c ::  fab       <=  array to be modified
c ::  DIMS(fab)  => index limits of fab
c ::  u          => array to be modified
c ::  DIMS(u)    => index limits of u
c ::  r          => 1-D r array (in first coordinate direction)
c ::  mu         => scalar viscosity
c ::  dt         => time step
c ::  vol        => volume array
c ::  DIMS(vol)  => index limits of vol
c ::  b          => (1-theta)*dt
c :: ----------------------------------------------------------
c ::
       subroutine FORT_TENSOR_HOOPRHS (xvelcomp, fab, DIMS(fab), u, DIMS(u), 
     &                          r, b,
     &                          vol, DIMS(vol), betax, DIMS(betax),
     &                          betay, DIMS(betay))
       integer xvelcomp
       integer DIMDEC(fab)
       integer DIMDEC(u)
       integer DIMDEC(vol)
       integer DIMDEC(betax)
       integer DIMDEC(betay)
       REAL_T  fab(DIMV(fab),2)
       REAL_T  u(DIMV(u),2)
       REAL_T  vol(DIMV(vol))
       REAL_T  r(DIM1(fab))
       REAL_T  betax(DIMV(betax))
       REAL_T  betay(DIMV(betay))
       REAL_T  b

       REAL_T  betacen
       integer i, j

       do j = ARG_L2(fab), ARG_H2(fab)
          do i = ARG_L1(fab), ARG_H1(fab)
             betacen = fourth*(betax(i,j)+betax(i+1,j)+
     &                           betay(i,j)+betay(i,j+1))
             fab(i,j,xvelcomp) = fab(i,j,xvelcomp) - 
     &           b*two*betacen*vol(i,j)*u(i,j,xvelcomp)/(r(i)*r(i))
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: TENSOR_HOOPSRC
c ::             fab(i,j) = fab(i,j) - two*mu*u/(r(i)^2)
c ::                                   ^^^ yes, that is correct
c ::                                       for variable mu
c ::
c :: INPUTS / OUTPUTS:
c ::  fab       <=  array to be modified
c ::  DIMS(fab)  => index limits of fab
c ::  mu         => viscous coefficient
c :: ----------------------------------------------------------
c ::
       subroutine FORT_TENSOR_HOOPSRC (comp, DIMS(grid), fab, DIMS(fab), u, 
     &      DIMS(u), r, betax, DIMS(betax), betay, DIMS(betay))

       integer comp
       integer DIMDEC(grid)
       integer DIMDEC(fab)
       integer DIMDEC(u)
       integer DIMDEC(betax)
       integer DIMDEC(betay)
       REAL_T  fab(DIMV(fab),2)
       REAL_T  u(DIMV(u),2)
       REAL_T  r(DIM1(grid))
       REAL_T  betax(DIMV(betax))
       REAL_T  betay(DIMV(betay))

       integer i, j
       REAL_T  betacen

       do j = ARG_L2(grid), ARG_H2(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             betacen  = fourth*(betax(i,j)+betax(i+1,j)+
     &                           betay(i,j)+betay(i,j+1))
             fab(i,j,comp) = fab(i,j,comp) - two*betacen*u(i,j,comp)/(r(i)*r(i))
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: SETALPHA
c ::             alpha(i,j) = vol*(1+b/(r(i)^2)) / density
c ::
c :: INPUTS / OUTPUTS:
c ::  fab       <=  array to be modified
c ::  DIMS(fab) => index limits of fab
c ::  lo,hi     => index limits of box
c ::  r         =>  1-d array of radius
c ::  b         =>  either theta*dt*mu or -(1-theta)*dt*mu
c ::  vol       =>  volume array
c ::  DIMS(vol) => index limits of fab
c ::  denfab    => array of density at time n+1/2
c ::  DIMS(den) => index limits of fab
c ::  usehoop   => do we add hoop stress?   (only if x-vel component)
c ::  useden    => do we divide by density? (only if velocity component)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETALPHA (fab, DIMS(fab), lo, hi, r, DIMS(r),
     $                           b, vol, DIMS(vol),
     &                           denfab,DIMS(den),usehoop,useden)

       integer DIMDEC(fab)
       integer lo(SDIM), hi(SDIM)
       integer DIMDEC(vol)
       integer DIMDEC(den)
       integer DIMDEC(r)
       REAL_T  fab(DIMV(fab))
       REAL_T  vol(DIMV(vol))
       REAL_T  denfab(DIMV(den))
       REAL_T  r(DIM1(r))
       REAL_T  b
       integer usehoop,useden

       integer i, j

       if (usehoop .eq. 0) then
          if (useden .eq. 0) then
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   fab(i,j) = vol(i,j)
                end do
             end do
          else 
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   fab(i,j) = vol(i,j) * denfab(i,j)
                end do
             end do
          end if
       else
          if (useden .eq. 0) then
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   fab(i,j) = vol(i,j) * (one + (b / (r(i)*r(i))))
                end do
             end do
          else
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   fab(i,j) = vol(i,j) * (denfab(i,j) + (b / (r(i)*r(i))))
                end do
             end do
          end if
       end if

       end

c :: ----------------------------------------------------------
c :: SET_TENSOR_ALPHA
c ::             alpha(i,j) = vol*density+b*dr*dz*two*mu_cen/r(i)
c ::                        = vol*(density+b*two*mu_cen*r(i)**2)
c ::                                         ^^^ yes, that is correct
c ::                                             for variable mu
c ::
c :: INPUTS / OUTPUTS:
c ::  fab       <=  array to be modified
c ::  DIMS(fab) => index limits of fab
c ::  lo,hi     => index limits of box
c ::  r         =>  1-d array of radius
c ::  b         =>  theta*dt or -(1-theta)*dt
c ::  vol       =>  volume array
c ::  DIMS(vol) => index limits of fab
c ::  denfab    => array of density at time n+1/2
c ::  DIMS(den) => index limits of fab
c ::  usehoop   => do we add hoop stress?   (only if x-vel component)
c ::  useden    => do we divide by density? (only if velocity component)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SET_TENSOR_ALPHA (alpha, DIMS(alpha), lo, hi, r, DIMS(r),
     $                           b, vol, DIMS(vol),
     &                           denfab,DIMS(den),betax,DIMS(betax),
     &                           betay,DIMS(betay),isrz)

       integer DIMDEC(alpha)
       integer lo(SDIM), hi(SDIM)
       integer DIMDEC(vol)
       integer DIMDEC(den)
       integer DIMDEC(betax)
       integer DIMDEC(betay)
       integer DIMDEC(r)
       REAL_T  alpha(DIMV(alpha),2)
       REAL_T  vol(DIMV(vol))
       REAL_T  denfab(DIMV(den))
       REAL_T  betax(DIMV(betax))
       REAL_T  betay(DIMV(betay))
       REAL_T  r(DIM1(r))
       REAL_T  b, betacen
       integer isrz

       integer i, j

       if (isrz .eq. 0) then
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                alpha(i,j,1) = vol(i,j) * denfab(i,j)
                alpha(i,j,2) = vol(i,j) * denfab(i,j)
             end do
          end do
       else
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                alpha(i,j,2) = vol(i,j) * denfab(i,j)
                betacen = fourth*(betax(i,j)+betax(i+1,j)+
     &               betay(i,j)+betay(i,j+1))
                alpha(i,j,1) = vol(i,j) * (denfab(i,j)+
     &               b*two*betacen/(r(i)**2))
             end do
          end do
       end if

       end

      subroutine FORT_DIV_MU_SI(lo, hi, dx, mu, DIMS(divu), divu,
     &     DIMS(divmusi), divmusi)

      implicit none
c
c ... inputs
c
      integer lo(SDIM), hi(SDIM)
      REAL_T  dx(SDIM)
      integer DIMDEC(divu)
      REAL_T  divu(DIMV(divu))      
      REAL_T  mu
c
c ... outputs
c
      integer DIMDEC(divmusi)
      REAL_T  divmusi(DIMV(divmusi),SDIM)
c
c ... local 
c
      integer i,j
      REAL_T sleft, sright, stop, sbot
c
c ... Note: the following IS correct for r-z. Terms from the hoop stress
c           cancel with terms from tau_rr to eliminate all r dependence.
c
      do j=lo(2),hi(2)
         do i=lo(1),hi(1)
            sleft = half*(divu(i-1,j)+divu(i,j))
            sright = half*(divu(i+1,j)+divu(i,j))

            divmusi(i,j,1) = mu*(sright-sleft)/dx(1)

            stop = half*(divu(i,j)+divu(i,j+1))
            sbot = half*(divu(i,j-1)+divu(i,j))

            divmusi(i,j,2) = mu*(stop-sbot)/dx(2)

         end do
      end do

      end

      subroutine FORT_DIV_VARMU_SI(lo, hi, dx, DIMS(divu), divu,
     &     DIMS(betax), betax, DIMS(betay), betay, DIMS(divmusi), divmusi)

      implicit none
c
c ... inputs
c
      integer lo(SDIM), hi(SDIM)
      REAL_T  dx(SDIM)
      integer DIMDEC(divu)
      REAL_T  divu(DIMV(divu))      
      integer DIMDEC(betax)
      REAL_T  betax(DIMV(betax))
      integer DIMDEC(betay)
      REAL_T  betay(DIMV(betay))
c
c ... outputs
c
      integer DIMDEC(divmusi)
      REAL_T  divmusi(DIMV(divmusi),SDIM)
c
c ... local 
c
      integer i,j
      REAL_T sleft, sright, stop, sbot
c
c ... Note: the following IS correct for r-z. Terms from the hoop stress
c           cancel with terms from tau_rr to eliminate all r dependence.
c
      do j=lo(2),hi(2)
         do i=lo(1),hi(1)
            sleft = half*(divu(i-1,j)+divu(i,j))
            sright = half*(divu(i+1,j)+divu(i,j))

            divmusi(i,j,1) = (betax(i+1,j)*sright-
     &           betax(i,j)*sleft)/dx(1)

            stop = half*(divu(i,j)+divu(i,j+1))
            sbot = half*(divu(i,j-1)+divu(i,j))

            divmusi(i,j,2) = (betay(i,j+1)*stop-
     &           betay(i,j)*sbot)/dx(2)

         end do
      end do

      end

      subroutine FORT_CCTOEDGE(lo, hi, DIMS(beta), beta,
     &   DIMS(betax), betax, DIMS(betay), betay)

      implicit none
c
c ... inputs
c
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(beta)
      REAL_T  beta(DIMV(beta))
      integer DIMDEC(betax)
      integer DIMDEC(betay)
c
c ... outputs
c
      REAL_T  betax(DIMV(betax))
      REAL_T  betay(DIMV(betay))
c
c ... local
c
      integer i,j

      do j=lo(2),hi(2)
         do i=lo(1),hi(1)+1
            betax(i,j) = .5D0*(beta(i-1,j)+beta(i,j))
         end do
      end do

      do j=lo(2),hi(2)+1
         do i=lo(1),hi(1)
            betay(i,j) = .5D0*(beta(i,j-1)+beta(i,j))
         end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: FILCC_2D.F,v 1.8 2002/07/31 22:32:02 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "ArrayLim.H"

#define SDIM 2

c ::: -----------------------------------------------------------
c ::: This routine is intended to be a generic fill function
c ::: for cell-centered data.  It knows how to extrapolate
c ::: and reflect data and is used to supplement the problem-specific
c ::: fill functions which call it.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: q           <=  array to fill
c ::: lo,hi        => index extent of q array
c ::: domlo,domhi  => index extent of problem domain
c ::: dx           => cell spacing
c ::: xlo          => physical location of lower left hand
c :::	              corner of q array
c ::: bc	   => array of boundary flags bc(SPACEDIM,lo:hi)
c ::: 
c ::: NOTE: all corner as well as edge data is filled if not EXT_DIR
c ::: -----------------------------------------------------------

      subroutine filcc(q,DIMS(q),domlo,domhi,dx,xlo,bc)

      integer    DIMDEC(q)
      integer    domlo(SDIM), domhi(SDIM)
      integer    bc(SDIM,2)
      REAL_T     xlo(SDIM), dx(SDIM)
      REAL_T     q(DIMV(q))

      integer    nlft, nrgt, nbot, ntop
      integer    ilo, ihi, jlo, jhi
      integer    i, j
      integer    is, ie, js, je

      nlft = max(0,domlo(1)-ARG_L1(q))
      nrgt = max(0,ARG_H1(q)-domhi(1))
      nbot = max(0,domlo(2)-ARG_L2(q))
      ntop = max(0,ARG_H2(q)-domhi(2))

      is = max(ARG_L1(q),domlo(1))
      ie = min(ARG_H1(q),domhi(1))
      js = max(ARG_L2(q),domlo(2))
      je = min(ARG_H2(q),domhi(2))

c     ::::: first fill sides
      if (nlft .gt. 0) then
         ilo = domlo(1)

	 if (bc(1,1) .eq. FOEXTRAP) then
	    do i = 1, nlft
	    do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-i,j) = q(ilo,j)
	    end do
	    end do
	 else if (bc(1,1) .eq. HOEXTRAP) then
	    do i = 2, nlft
	    do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-i,j) = q(ilo,j) 
	    end do 
	    end do 
            if (ilo+2 .le. ie) then 
	     do j = ARG_L2(q), ARG_H2(q)
		q(ilo-1,j) = (15*q(ilo,j) - 10*q(ilo+1,j) + 
     $                        3*q(ilo+2,j)) * eighth
	     end do 
            else 
	     do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-1,j) = half*(3*q(ilo,j) - q(ilo+1,j))
	     end do
            end if
	 else if (bc(1,1) .eq. REFLECT_EVEN) then
	    do i = 1, nlft
	     do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-i,j) = q(ilo+i-1,j)
	    end do
	    end do
	 else if (bc(1,1) .eq. REFLECT_ODD) then
	    do i = 1, nlft
	    do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-i,j) = -q(ilo+i-1,j)
	    end do
	    end do
	 end if
      end if

      if (nrgt .gt. 0) then
         ihi = domhi(1)

	 if (bc(1,2) .eq. FOEXTRAP) then
	    do i = 1, nrgt
	    do j = ARG_L2(q), ARG_H2(q)
	       q(ihi+i,j) = q(ihi,j)
	    end do
	    end do
         else if (bc(1,2) .eq. HOEXTRAP) then
            do i = 2, nrgt
	    do j = ARG_L2(q), ARG_H2(q)
               q(ihi+i,j) = q(ihi,j)
            end do
            end do
            if (ihi-2 .ge. is) then
	     do j = ARG_L2(q), ARG_H2(q)
	       q(ihi+1,j) = (15*q(ihi,j) - 10*q(ihi-1,j) + 
     $                        3*q(ihi-2,j)) * eighth
             end do
            else
	     do j = ARG_L2(q), ARG_H2(q)
	       q(ihi+1,j) = half*(3*q(ihi,j) - q(ihi-1,j))
             end do
            end if
	 else if (bc(1,2) .eq. REFLECT_EVEN) then
	    do i = 1, nrgt
            do j = ARG_L2(q), ARG_H2(q)
	       q(ihi+i,j) = q(ihi-i+1,j)
	    end do
	    end do
	 else if (bc(1,2) .eq. REFLECT_ODD) then
	    do i = 1, nrgt
            do j = ARG_L2(q), ARG_H2(q)
	       q(ihi+i,j) = -q(ihi-i+1,j)
	    end do
	    end do
	 end if
      end if

      if (nbot .gt. 0) then
         jlo = domlo(2)

	 if (bc(2,1) .eq. FOEXTRAP) then
	    do j = 1, nbot
	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jlo-j) = q(i,jlo)
	    end do
	    end do
         else if (bc(2,1) .eq. HOEXTRAP) then
            do j = 2, nbot
	    do i = ARG_L1(q), ARG_H1(q)
               q(i,jlo-j) = q(i,jlo)
            end do
            end do
            if (jlo+2 .le. je) then
 	     do i = ARG_L1(q), ARG_H1(q)
               q(i,jlo-1) = (15*q(i,jlo) - 10*q(i,jlo+1) + 
     $                        3*q(i,jlo+2)) * eighth
             end do
            else
 	     do i = ARG_L1(q), ARG_H1(q)
               q(i,jlo-1) = half*(3*q(i,jlo) - q(i,jlo+1))
             end do
            end if
	 else if (bc(2,1) .eq. REFLECT_EVEN) then
	    do j = 1, nbot
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jlo-j) = q(i,jlo+j-1)
	    end do
	    end do
	 else if (bc(2,1) .eq. REFLECT_ODD) then
	    do j = 1, nbot
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jlo-j) = -q(i,jlo+j-1)
	    end do
	    end do
	 end if
      end if

      if (ntop .gt. 0) then
         jhi = domhi(2)

	 if (bc(2,2) .eq. FOEXTRAP) then
	    do j = 1, ntop
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jhi+j) = q(i,jhi)
	    end do
	    end do
         else if (bc(2,2) .eq. HOEXTRAP) then
            do j = 2, ntop
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jhi+j) = q(i,jhi)
            end do
            end do
            if (jhi-2 .ge. js) then
 	    do i = ARG_L1(q), ARG_H1(q)
               q(i,jhi+1) = (15*q(i,jhi) - 10*q(i,jhi-1) + 
     $                         3*q(i,jhi-2)) * eighth
             end do
            else
 	     do i = ARG_L1(q), ARG_H1(q)
               q(i,jhi+1) = half*(3*q(i,jhi) - q(i,jhi-1))
             end do
            end if
	 else if (bc(2,2) .eq. REFLECT_EVEN) then
	    do j = 1, ntop
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jhi+j) = q(i,jhi-j+1)
	    end do
	    end do
	 else if (bc(2,2) .eq. REFLECT_ODD) then
	    do j = 1, ntop
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jhi+j) = -q(i,jhi-j+1)
	    end do
	    end do
	 end if
      end if

      if ((nlft .gt. 0 .and. bc(1,1) .eq. HOEXTRAP) .and.
     $    (nbot .gt. 0 .and. bc(2,1) .eq. HOEXTRAP) ) then
      
        if (jlo+2 .le. je) then 
          q(ilo-1,jlo-1) = half * eighth * 
     $    (15*q(ilo-1,jlo) - 10*q(ilo-1,jlo+1) + 3*q(ilo-1,jlo+2))
        else
          q(ilo-1,jlo-1) = half * half * 
     $    (3*q(ilo-1,jlo) - q(ilo-1,jlo+1))
        end if

        if (ilo+2 .le. ie) then 
          q(ilo-1,jlo-1) =  q(ilo-1,jlo-1) + half * eighth * 
     $    (15*q(ilo,jlo-1) - 10*q(ilo+1,jlo-1) + 3*q(ilo+2,jlo-1)) 
        else
          q(ilo-1,jlo-1) =  q(ilo-1,jlo-1) + half * half * 
     $    (3*q(ilo,jlo-1) - q(ilo+1,jlo-1))
        end if


      end if

      if ((nlft .gt. 0 .and. bc(1,1) .eq. HOEXTRAP) .and.
     $    (ntop .gt. 0 .and. bc(2,2) .eq. HOEXTRAP) ) then

        if (jhi-2 .ge. js) then 
          q(ilo-1,jhi+1) = half * eighth * 
     $    (15*q(ilo-1,jhi) - 10*q(ilo-1,jhi-1) + 3*q(ilo-1,jhi-2))
        else
          q(ilo-1,jhi+1) = half * half * 
     $    (3*q(ilo-1,jhi) - q(ilo-1,jhi-1))
        end if

        if (ilo+2 .le. ie) then 
          q(ilo-1,jhi+1) = q(ilo-1,jhi+1) + half * eighth * 
     $    (15*q(ilo,jhi+1) - 10*q(ilo+1,jhi+1) + 3*q(ilo+2,jhi+1))
        else
          q(ilo-1,jhi+1) = q(ilo-1,jhi+1) + half * half * 
     $    (3*q(ilo,jhi+1) - q(ilo+1,jhi+1))
        end if
      end if

      if ((nrgt .gt. 0 .and. bc(1,2) .eq. HOEXTRAP) .and.
     $    (nbot .gt. 0 .and. bc(2,1) .eq. HOEXTRAP) ) then
        if (jlo+2 .le. je) then 
          q(ihi+1,jlo-1) = half * eighth * 
     $    (15*q(ihi+1,jlo) - 10*q(ihi+1,jlo+1) + 3*q(ihi+1,jlo+2))
        else
          q(ihi+1,jlo-1) = half * half * 
     $    (3*q(ihi+1,jlo) - q(ihi+1,jlo+1))
        end if

        if (ihi-2 .ge. is) then 
          q(ihi+1,jlo-1) = q(ihi+1,jlo-1) + half * eighth * 
     $    (15*q(ihi,jlo-1) - 10*q(ihi-1,jlo-1) + 3*q(ihi-2,jlo-1))
        else
          q(ihi+1,jlo-1) = q(ihi+1,jlo-1) + half * half * 
     $    (3*q(ihi,jlo-1) - q(ihi-1,jlo-1))
        end if
      end if

      if ((nrgt .gt. 0 .and. bc(1,2) .eq. HOEXTRAP) .and.
     $    (ntop .gt. 0 .and. bc(2,2) .eq. HOEXTRAP) ) then

        if (jhi-2 .ge. js) then 
          q(ihi+1,jhi+1) = half * eighth * 
     $    (15*q(ihi+1,jhi) - 10*q(ihi+1,jhi-1) + 3*q(ihi+1,jhi-2))
        else
          q(ihi+1,jhi+1) = half * half * 
     $    (3*q(ihi+1,jhi) - q(ihi+1,jhi-1))
        end if

        if (ihi-2 .ge. is) then 
          q(ihi+1,jhi+1) = q(ihi+1,jhi+1) + half * eighth * 
     $    (15*q(ihi,jhi+1) - 10*q(ihi-1,jhi+1) + 3*q(ihi-2,jhi+1))
        else
          q(ihi+1,jhi+1) = q(ihi+1,jhi+1) + half * half * 
     $    (3*q(ihi,jhi+1) - q(ihi-1,jhi+1))
        end if

      end if

      return
      end

      subroutine hoextraptocc(q,DIMS(q),domlo,domhi,dx,xlo)

      integer    DIMDEC(q)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     xlo(SDIM), dx(SDIM)
      REAL_T     q(DIMV(q))

      integer    nlft, nrgt, nbot, ntop
      integer    ilo, ihi, jlo, jhi
      integer    i, j
      integer    is, ie, js, je

      nlft = max(0,domlo(1)-ARG_L1(q))
      nrgt = max(0,ARG_H1(q)-domhi(1))
      nbot = max(0,domlo(2)-ARG_L2(q))
      ntop = max(0,ARG_H2(q)-domhi(2))

      is = max(ARG_L1(q),domlo(1))
      ie = min(ARG_H1(q),domhi(1))
      js = max(ARG_L2(q),domlo(2))
      je = min(ARG_H2(q),domhi(2))
c
c     First fill sides.
c
      if (nlft .gt. 0) then
         ilo = domlo(1)
         do i = 2, nlft
	    do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-i,j) = q(ilo,j) 
	    end do 
         end do 
         if (ilo+2 .le. ie) then 
            do j = ARG_L2(q), ARG_H2(q)
               q(ilo-1,j) = 3*q(ilo,j) - 3*q(ilo+1,j) + q(ilo+2,j)
            end do 
         else 
            do j = ARG_L2(q), ARG_H2(q)
	       q(ilo-1,j) = 2*q(ilo,j) - q(ilo+1,j)
            end do
         end if
      end if

      if (nrgt .gt. 0) then
         ihi = domhi(1)
         do i = 2, nrgt
	    do j = ARG_L2(q), ARG_H2(q)
               q(ihi+i,j) = q(ihi,j)
            end do
         end do
         if (ihi-2 .ge. is) then
            do j = ARG_L2(q), ARG_H2(q)
               q(ihi+1,j) = 3*q(ihi,j) - 3*q(ihi-1,j) + q(ihi-2,j)
            end do
         else
            do j = ARG_L2(q), ARG_H2(q)
               q(ihi+1,j) = 2*q(ihi,j) - q(ihi-1,j)
            end do
         end if
      end if

      if (nbot .gt. 0) then
         jlo = domlo(2)
         do j = 2, nbot
	    do i = ARG_L1(q), ARG_H1(q)
               q(i,jlo-j) = q(i,jlo)
            end do
         end do
         if (jlo+2 .le. je) then
            do i = ARG_L1(q), ARG_H1(q)
               q(i,jlo-1) = 3*q(i,jlo) - 3*q(i,jlo+1) + q(i,jlo+2)
            end do
         else
            do i = ARG_L1(q), ARG_H1(q)
               q(i,jlo-1) = 2*q(i,jlo) - q(i,jlo+1)
            end do
         end if
      end if

      if (ntop .gt. 0) then
         jhi = domhi(2)
         do j = 2, ntop
 	    do i = ARG_L1(q), ARG_H1(q)
	       q(i,jhi+j) = q(i,jhi)
            end do
         end do
         if (jhi-2 .ge. js) then
 	    do i = ARG_L1(q), ARG_H1(q)
               q(i,jhi+1) = 3*q(i,jhi) - 3*q(i,jhi-1) + q(i,jhi-2)
            end do
         else
            do i = ARG_L1(q), ARG_H1(q)
               q(i,jhi+1) = 2*q(i,jhi) - q(i,jhi-1)
            end do
         end if
      end if

      if (jlo+2 .le. je) then 
         q(ilo-1,jlo-1) = half *
     $      (3*q(ilo-1,jlo) - 3*q(ilo-1,jlo+1) + q(ilo-1,jlo+2))
      else
         q(ilo-1,jlo-1) = half * (2*q(ilo-1,jlo) - q(ilo-1,jlo+1))
      end if
      
      if (ilo+2 .le. ie) then 
         q(ilo-1,jlo-1) =  q(ilo-1,jlo-1) + half *
     $      (3*q(ilo,jlo-1) - 3*q(ilo+1,jlo-1) + q(ilo+2,jlo-1)) 
      else
         q(ilo-1,jlo-1) =  q(ilo-1,jlo-1) + half *
     $        (2*q(ilo,jlo-1) - q(ilo+1,jlo-1))
      end if

      if (jhi-2 .ge. js) then 
         q(ilo-1,jhi+1) = half *
     $      (3*q(ilo-1,jhi) - 3*q(ilo-1,jhi-1) + q(ilo-1,jhi-2))
      else
         q(ilo-1,jhi+1) = half * (2*q(ilo-1,jhi) - q(ilo-1,jhi-1))
      end if
      
      if (ilo+2 .le. ie) then 
         q(ilo-1,jhi+1) = q(ilo-1,jhi+1) + half *
     $      (3*q(ilo,jhi+1) - 3*q(ilo+1,jhi+1) + q(ilo+2,jhi+1))
      else
         q(ilo-1,jhi+1) = q(ilo-1,jhi+1) + half *
     $        (2*q(ilo,jhi+1) - q(ilo+1,jhi+1))
      end if

      if (jlo+2 .le. je) then 
         q(ihi+1,jlo-1) = half *
     $      (3*q(ihi+1,jlo) - 3*q(ihi+1,jlo+1) + q(ihi+1,jlo+2))
      else
         q(ihi+1,jlo-1) = half * (2*q(ihi+1,jlo) - q(ihi+1,jlo+1))
      end if
      
      if (ihi-2 .ge. is) then 
         q(ihi+1,jlo-1) = q(ihi+1,jlo-1) + half *
     $      (3*q(ihi,jlo-1) - 3*q(ihi-1,jlo-1) + q(ihi-2,jlo-1))
      else
         q(ihi+1,jlo-1) = q(ihi+1,jlo-1) + half *
     $        (2*q(ihi,jlo-1) - q(ihi-1,jlo-1))
      end if

      if (jhi-2 .ge. js) then 
         q(ihi+1,jhi+1) = half *
     $      (3*q(ihi+1,jhi) - 3*q(ihi+1,jhi-1) + q(ihi+1,jhi-2))
      else
         q(ihi+1,jhi+1) = half * (2*q(ihi+1,jhi) - q(ihi+1,jhi-1))
      end if
      
      if (ihi-2 .ge. is) then 
         q(ihi+1,jhi+1) = q(ihi+1,jhi+1) + half *
     $      (3*q(ihi,jhi+1) - 3*q(ihi-1,jhi+1) + q(ihi-2,jhi+1))
      else
         q(ihi+1,jhi+1) = q(ihi+1,jhi+1) + half *
     $        (2*q(ihi,jhi+1) - q(ihi-1,jhi+1))
      end if
      
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: SLABSTAT_NS_3D.F,v 1.5 2002/11/14 23:04:56 lijewski Exp $
c
#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"
#include "SLABSTAT_NS_F.H"

#define SDIM 3

c
c ::: -----------------------------------------------------------
c ::: This is a general routine to calculate the basic running statistics
c ::: based on the velocity, density, tracer and pressure.  The tracer
c ::: passed in to this routine is not a conserved quantity.  The data
c ::: saved by this routine are sufficient to calculate a core set of
c ::: statistics on these fields using both Reynolds and Favre averages.
c ::: The state should be passed in to this routine in the order,
c :::   Rho, U, V, W, Tr, P
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: runStats      <=  Array to contain the running statistics
c ::: DIMS(runStats) => Dimensions of the running statistics array
c ::: nStats         => Number of components in the statistics array
c ::: state          =) Array containing the state data
c ::: DIMS(state)    => Dimensions of the state data array
c ::: nStateComp     => Number of components in the state array
c ::: dt             => Time step
c ::: delta          => Grid spacing
c ::: -----------------------------------------------------------
c
      subroutine FORT_NS_BASICSTATS_NCTRAC(state, DIMS(state), nStateComp,
     $                                     runStats, DIMS(runStats), nStats,
     $                                     dt, delta)

      implicit none

c
c     ::::: passed variables
c
      integer nStats, nStateComp
      integer DIMDEC(state)
      integer DIMDEC(runStats)
      REAL_T dt
      REAL_T delta(SDIM)
      REAL_T runStats(DIMV(runStats),nStats)
      REAL_T state(DIMV(state),nStateComp)

c
c     ::::: local variables
c
      integer i, j, k, n, Rho, xVel, yVel, zVel, Trac, Pres,
     $        nStateExpect, nStatsExpect, nGhostExpect, num
      integer loStats(SDIM), hiStats(SDIM)
      integer loState(SDIM), hiState(SDIM)

      PARAMETER (nStateExpect = 6, nStatsExpect = 35, nGhostExpect = 0)

c
c     ===================================
c     ::: Set the Values of LO and HI :::
c     ===================================
c
      call SET_LOHI(DIMS(runStats), loStats, hiStats)
      call SET_LOHI(DIMS(state), loState, hiState)

#ifndef NDEBUG
      if (nStats .NE. nStatsExpect .or. nStateComp .ne. nStateExpect) then
        write(*,1000) nStatsExpect, nStateExpect, nStats, nStateComp
 1000   format('Incorrect number of statistic and/or state components',
     $        /'FORT_NS_BASICSTATS_NCTRAC.  Should have nStats = ',I5,'and',
     $        /'nStateComp = ',I5,
     $        /'   nStats = ', I5, 5x, 'nStateComp = ', I5)
        call bl_abort(" ")
      endif

      do n = 1, SDIM
        if (loState(n) .GT. loStats(n) - nGhostExpect .OR.
     $      hiState(n) .LT. hiStats(n) + nGhostExpect) then
          write(*,1010) n, nGhostExpect, loStats, hiStats, loState, hiState
 1010     format('Incorrect number of ghost cells in the state date in',
     $          /'FORT_NS_BASICSTATS_NCTRAC.',
     $          /'   Direction = ', I2, 5x, 'nGhostExpect = ', I2,
     $          /'   loStats = ', SDIM (I2,1x), 5x, 'hiStats = ', SDIM (I2,1x),
     $          /'   loState = ', SDIM (I2,1x), 5x, 'hiState = ', SDIM (I2,1x))
          call bl_abort(" ")
        endif
      enddo
#endif


c
c     =========================
c     ::: Set State Indices :::
c     =========================
c
      Rho  = 1
      xVel = 2
      yVel = 3
      zVel = 4
      Trac = 5
      Pres = 6

c
c     ====================================
c     ::: Calculate Running Statistics :::
c     ====================================
c
      do k = loStats(3), hiStats(3)
        do j = loStats(2), hiStats(2)
          do i = loStats(1), hiStats(1)
            num = 1
            do n = 1, 2
              runStats(i,j,k,num) = runStats(i,j,k,num) 
     $                                              + dt * state(i,j,k,Rho)**n
              runStats(i,j,k,num+1) = runStats(i,j,k,num+1) 
     $                                              + dt * state(i,j,k,xVel)**n
              runStats(i,j,k,num+2) = runStats(i,j,k,num+2) 
     $                           + dt * state(i,j,k,Rho) * state(i,j,k,xVel)**n
              runStats(i,j,k,num+3) = runStats(i,j,k,num+3) 
     $                                              + dt * state(i,j,k,yVel)**n
              runStats(i,j,k,num+4) = runStats(i,j,k,num+4) 
     $                           + dt * state(i,j,k,Rho) * state(i,j,k,yVel)**n
              runStats(i,j,k,num+5) = runStats(i,j,k,num+5) 
     $                                              + dt * state(i,j,k,zVel)**n
              runStats(i,j,k,num+6) = runStats(i,j,k,num+6) 
     $                           + dt * state(i,j,k,Rho) * state(i,j,k,zVel)**n
              runStats(i,j,k,num+7) = runStats(i,j,k,num+7) 
     $                                              + dt * state(i,j,k,Trac)**n
              runStats(i,j,k,num+8) = runStats(i,j,k,num+8) 
     $                           + dt * state(i,j,k,Rho) * state(i,j,k,Trac)**n
              runStats(i,j,k,num+9) = runStats(i,j,k,num+9) 
     $                                              + dt * state(i,j,k,Pres)**n
              num = num + 10
            enddo

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt
     $                                  * state(i,j,k,xVel) * state(i,j,k,yVel)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt
     $                                  * state(i,j,k,xVel) * state(i,j,k,zVel)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt
     $                                  * state(i,j,k,yVel) * state(i,j,k,zVel)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt * state(i,j,k,Rho)
     $                                  * state(i,j,k,xVel) * state(i,j,k,yVel)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt *state(i,j,k,Rho)
     $                                  * state(i,j,k,xVel) * state(i,j,k,zVel)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt *state(i,j,k,Rho)
     $                                  * state(i,j,k,yVel) * state(i,j,k,zVel)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) 
     $                         + dt * state(i,j,k,xVel) * state(i,j,k,Trac)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) 
     $                         + dt * state(i,j,k,yVel) * state(i,j,k,Trac)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) 
     $                         + dt * state(i,j,k,zVel) * state(i,j,k,Trac)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) 
     $                         + dt * state(i,j,k,Rho) * state(i,j,k,xVel) 
     $                                                 * state(i,j,k,Trac)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) 
     $                         + dt * state(i,j,k,Rho) * state(i,j,k,yVel) 
     $                                                 * state(i,j,k,Trac)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) 
     $                         + dt * state(i,j,k,Rho) * state(i,j,k,zVel) 
     $                                                 * state(i,j,k,Trac)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) 
     $                         + dt * state(i,j,k,xVel) * state(i,j,k,Pres)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) 
     $                         + dt * state(i,j,k,yVel) * state(i,j,k,Pres)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) 
     $                         + dt * state(i,j,k,zVel) * state(i,j,k,Pres)
            num = num + 3
          enddo
        enddo
      enddo

c
c
      return
      end



c
c ::: -----------------------------------------------------------
c ::: This is a general routine to calculate the basic running statistics
c ::: based on the velocity, density, tracer and pressure.  The tracer
c ::: passed in to this routine is a conserved quantity.  The data
c ::: saved by this routine are sufficient to calculate a core set of
c ::: statistics on these fields using both Reynolds and Favre averages.
c ::: The state should be passed in to this routine in the order,
c :::   Rho, U, V, W, Tr, P
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: runStats      <=  Array to contain the running statistics
c ::: DIMS(runStats) => Dimensions of the running statistics array
c ::: nStats         => Number of components in the statistics array
c ::: state          =) Array containing the state data
c ::: DIMS(state)    => Dimensions of the state data array
c ::: nStateComp     => Number of components in the state array
c ::: dt             => Time step
c ::: delta          => Grid spacing
c ::: -----------------------------------------------------------
c
      subroutine FORT_NS_BASICSTATS_CTRAC(state, DIMS(state), nStateComp,
     $                                    runStats, DIMS(runStats), nStats,
     $                                    dt, delta)

      implicit none

c
c     ::::: passed variables
c
      integer nStats, nStateComp
      integer DIMDEC(state)
      integer DIMDEC(runStats)
      REAL_T dt
      REAL_T delta(SDIM)
      REAL_T runStats(DIMV(runStats),nStats)
      REAL_T state(DIMV(state),nStateComp)

c
c     ::::: local variables
c
      integer i, j, k, n, Rho, xVel, yVel, zVel, RhoTrac, Pres,
     $        nStateExpect, nStatsExpect, nGhostExpect, num
      integer loStats(SDIM), hiStats(SDIM)
      integer loState(SDIM), hiState(SDIM)
      REAL_T  tracer

      PARAMETER (nStateExpect = 6, nStatsExpect = 35, nGhostExpect = 0)

c
c     ===================================
c     ::: Set the Values of LO and HI :::
c     ===================================
c
      call SET_LOHI(DIMS(runStats), loStats, hiStats)
      call SET_LOHI(DIMS(state), loState, hiState)

#ifndef NDEBUG
      if (nStats .NE. nStatsExpect .or. nStateComp .ne. nStateExpect) then
        write(*,1000) nStatsExpect, nStateExpect, nStats, nStateComp
 1000   format('Incorrect number of statistic and/or state components',
     $        /'FORT_NS_BASICSTATS_NCTRAC.  Should have nStats = ',I5,'and',
     $        /'nStateComp = ',I5,
     $        /'   nStats = ', I5, 5x, 'nStateComp = ', I5)
        call bl_abort(" ")
      endif

      do n = 1, SDIM
        if (loState(n) .GT. loStats(n) - nGhostExpect .OR.
     $      hiState(n) .LT. hiStats(n) + nGhostExpect) then
          write(*,1010) n, nGhostExpect, loStats, hiStats, loState, hiState
 1010     format('Incorrect number of ghost cells in the state date in',
     $          /'FORT_NS_BASICSTATS_NCTRAC.',
     $          /'   Direction = ', I2, 5x, 'nGhostExpect = ', I2,
     $          /'   loStats = ', SDIM (I2,1x), 5x, 'hiStats = ', SDIM (I2,1x),
     $          /'   loState = ', SDIM (I2,1x), 5x, 'hiState = ', SDIM (I2,1x))
          call bl_abort(" ")
        endif
      enddo
#endif


c
c     =========================
c     ::: Set State Indices :::
c     =========================
c
      Rho  = 1
      xVel = 2
      yVel = 3
      zVel = 4
      RhoTrac = 5
      Pres = 6

c
c     ====================================
c     ::: Calculate Running Statistics :::
c     ====================================
c
      do k = loStats(3), hiStats(3)
        do j = loStats(2), hiStats(2)
          do i = loStats(1), hiStats(1)
            num = 1

            tracer = state(i,j,k,RhoTrac) / state(i,j,k,Rho)
            do n = 1, 2
              runStats(i,j,k,num) = runStats(i,j,k,num) + dt
     $                                                   * state(i,j,k,Rho)**n
              runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt
     $                                                   * state(i,j,k,xVel)**n
              runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt
     $                                * state(i,j,k,Rho) * state(i,j,k,xVel)**n
              runStats(i,j,k,num+3) = runStats(i,j,k,num+3) + dt
     $                                                   * state(i,j,k,yVel)**n
              runStats(i,j,k,num+4) = runStats(i,j,k,num+4) + dt
     $                                * state(i,j,k,Rho) * state(i,j,k,yVel)**n
              runStats(i,j,k,num+5) = runStats(i,j,k,num+5) + dt
     $                                                   * state(i,j,k,zVel)**n
              runStats(i,j,k,num+6) = runStats(i,j,k,num+6) + dt
     $                                * state(i,j,k,Rho) * state(i,j,k,zVel)**n
              runStats(i,j,k,num+7) = runStats(i,j,k,num+7) + dt * tracer**n
              runStats(i,j,k,num+8) = runStats(i,j,k,num+8) + dt
     $                                           * state(i,j,k,Rho) * tracer**n
              runStats(i,j,k,num+9) = runStats(i,j,k,num+9) + dt
     $                                                   * state(i,j,k,Pres)**n
              num = num + 10
            enddo

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt
     $                                  * state(i,j,k,xVel) * state(i,j,k,yVel)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt
     $                                  * state(i,j,k,xVel) * state(i,j,k,zVel)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt
     $                                  * state(i,j,k,yVel) * state(i,j,k,zVel)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt * state(i,j,k,Rho)
     $                                  * state(i,j,k,xVel) * state(i,j,k,yVel)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt *state(i,j,k,Rho)
     $                                  * state(i,j,k,xVel) * state(i,j,k,zVel)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt *state(i,j,k,Rho)
     $                                  * state(i,j,k,yVel) * state(i,j,k,zVel)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt
     $                                * state(i,j,k,xVel) * tracer
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt
     $                                * state(i,j,k,yVel) * tracer
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt
     $                                * state(i,j,k,zVel) * tracer
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt
     $                                * state(i,j,k,xVel) * state(i,j,k,RhoTrac)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt
     $                                * state(i,j,k,yVel) * state(i,j,k,RhoTrac)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt
     $                                * state(i,j,k,zVel) * state(i,j,k,RhoTrac)
            num = num + 3

            runStats(i,j,k,num) = runStats(i,j,k,num) + dt
     $                                * state(i,j,k,xVel) * state(i,j,k,Pres)
            runStats(i,j,k,num+1) = runStats(i,j,k,num+1) + dt
     $                                * state(i,j,k,yVel) * state(i,j,k,Pres)
            runStats(i,j,k,num+2) = runStats(i,j,k,num+2) + dt
     $                                * state(i,j,k,zVel) * state(i,j,k,Pres)
            num = num + 3
          enddo
        enddo
      enddo

c
c
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

#if BL_USE_FLOAT
#define twentyfive 25.e0
#define fifth 0.2
#else
#define twentyfive 25.d0
#define fifth 0.2d0
#endif

c *************************************************************************
c ** LAPLAC **
c ** Compute the viscous/diffusive terms for the momentum and scalar update
c ** equations
c ********************************************************************

      subroutine laplac(u,lapu,DIMS,dx,diff_coef,
     $                  bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  dx(3)
      REAL_T  diff_coef
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T facx,facy,facz
      REAL_T uxx, uxx_lo, uxx_hi
      REAL_T uyy, uyy_lo, uyy_hi
      REAL_T uzz, uzz_lo, uzz_hi
      integer is, ie, js, je, ks, ke
      integer i,j,k

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3
      facx = one / (dx(1)*dx(1))
      facy = one / (dx(2)*dx(2))
      facz = one / (dx(3)*dx(3))

      if (diff_coef .gt. zero) then

        do k = ks, ke 
        do j = js, je 
        do i = is, ie 

            uxx = ( u(i+1,j,k) - two * u(i,j,k) + u(i-1,j,k) )
            uyy = ( u(i,j+1,k) - two * u(i,j,k) + u(i,j-1,k) )
            uzz = ( u(i,j,k+1) - two * u(i,j,k) + u(i,j,k-1) )

            uxx_hi = (sixteen * u(ie+1,j,k) - twentyfive * u(ie,j,k) +
     $                    ten * u(ie-1,j,k) - u(ie-2,j,k) ) * fifth
            uxx_lo = (sixteen * u(is-1,j,k) - twentyfive * u(is,j,k) +
     $                    ten * u(is+1,j,k) - u(is+2,j,k) ) * fifth

            uxx = cvmgt(uxx_hi, uxx, i .eq. ie .and. 
     $                  (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) )
            uxx = cvmgt(uxx_lo, uxx, i .eq. is .and.
     $                  (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) )

            uyy_hi = (sixteen * u(i,je+1,k) - twentyfive * u(i,je,k) +
     $                    ten * u(i,je-1,k) - u(i,je-2,k) ) * fifth
            uyy_lo = (sixteen * u(i,js-1,k) - twentyfive * u(i,js,k) +
     $                    ten * u(i,js+1,k) - u(i,js+2,k) ) * fifth

            uyy = cvmgt(uyy_hi, uyy, j .eq. je .and. 
     $                  (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) )
            uyy = cvmgt(uyy_lo, uyy, j .eq. js .and. 
     $                  (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) )

            uzz_hi = (sixteen * u(i,j,ke+1) - twentyfive * u(i,j,ke) +
     $                    ten * u(i,j,ke-1) - u(i,j,ke-2) ) * fifth
            uzz_lo = (sixteen * u(i,j,ks-1) - twentyfive * u(i,j,ks) +
     $                    ten * u(i,j,ks+1) - u(i,j,ks+2) ) * fifth

            uzz = cvmgt(uzz_hi, uzz, k .eq. ke .and.
     $                  (bcz_hi .eq. WALL .or. bcz_hi .eq. INLET) )
            uzz = cvmgt(uzz_lo, uzz, k .eq. ks .and.
     $                  (bcz_lo .eq. WALL .or. bcz_lo .eq. INLET) )

            lapu(i,j,k) = (uxx*facx + uyy*facy + uzz*facz) * diff_coef

        enddo
        enddo
        enddo

      else

        do k = ks, ke 
        do j = js, je 
        do i = is, ie 
            lapu(i,j,k) = zero
        enddo
        enddo
        enddo

      endif

      if (bcx_lo .eq. PERIODIC) then
        do k = ks,ke
        do j = js,je
          lapu(is-1,j,k) = lapu(ie,j,k)
          lapu(ie+1,j,k) = lapu(is,j,k)
        enddo
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do k = ks,ke
        do i = is,ie
          lapu(i,js-1,k) = lapu(i,je,k)
          lapu(i,je+1,k) = lapu(i,js,k)
        enddo
        enddo
      endif

      if (bcz_lo .eq. PERIODIC) then
        do j = js,je
        do i = is,ie
          lapu(i,j,ks-1) = lapu(i,j,ke)
          lapu(i,j,ke+1) = lapu(i,j,ks)
        enddo
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC) then
        do k = ks,ke
          lapu(is-1,js-1,k) = lapu(ie,je,k)
          lapu(is-1,je+1,k) = lapu(ie,js,k)
          lapu(ie+1,js-1,k) = lapu(is,je,k)
          lapu(ie+1,je+1,k) = lapu(is,js,k)
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
        do j = js,je
          lapu(is-1,j,ks-1) = lapu(ie,j,ke)
          lapu(is-1,j,ke+1) = lapu(ie,j,ks)
          lapu(ie+1,j,ks-1) = lapu(is,j,ke)
          lapu(ie+1,j,ke+1) = lapu(is,j,ks)
        enddo
      endif

      if (bcy_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
        do i = is,ie
          lapu(i,js-1,ks-1) = lapu(i,je,ke)
          lapu(i,js-1,ke+1) = lapu(i,je,ks)
          lapu(i,je+1,ks-1) = lapu(i,js,ke)
          lapu(i,je+1,ke+1) = lapu(i,js,ks)
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
          lapu(is-1,js-1,ks-1) = lapu(ie,je,ke)
          lapu(ie+1,js-1,ks-1) = lapu(is,je,ke)
          lapu(is-1,je+1,ks-1) = lapu(ie,js,ke)
          lapu(ie+1,je+1,ks-1) = lapu(is,js,ke)
          lapu(is-1,js-1,ke+1) = lapu(ie,je,ks)
          lapu(ie+1,js-1,ke+1) = lapu(is,je,ks)
          lapu(is-1,je+1,ke+1) = lapu(ie,js,ks)
          lapu(ie+1,je+1,ke+1) = lapu(is,js,ks)
      endif


      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** MKSCAFLUX **
c ** Create the time-centered edge states for scalars
c ***************************************************************

      subroutine FORT_MKSCAFLUX(s,sedgex,sedgey,sedgez,slopex,slopey,slopez,
     $                          uadv,vadv,wadv,utrans,vtrans,wtrans,u,diff,force,
     $                          s_l,s_r,s_b,s_t,s_d,s_u,DIMS,
     $                          dx,dt,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,numqty)

      implicit none

      integer DIMS
      integer numqty

      REAL_T       s(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T  sedgex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T  sedgey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T  sedgez(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T  slopex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T  slopey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T  slopez(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T    uadv(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T    vadv(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T    wadv(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T  utrans(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T  vtrans(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T  wtrans(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T       u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T    diff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,numqty)
      REAL_T     s_l(lo_1:hi_1+1)
      REAL_T     s_r(lo_1:hi_1+1)
      REAL_T     s_b(lo_2:hi_2+1)
      REAL_T     s_t(lo_2:hi_2+1)
      REAL_T     s_d(lo_3:hi_3+1)
      REAL_T     s_u(lo_3:hi_3+1)
      REAL_T dx(3)
      REAL_T dt
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T savg
      REAL_T sUpx1,sUpx2
      REAL_T sUpy1,sUpy2
      REAL_T sUpz1,sUpz2
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer i,j,k,n,is,ie,js,je,ks,ke

      REAL_T eps
      eps = 1.0e-8

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)
      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

c ::: First do s^(n+1/2) on the (i+1/2) boundaries.

      do n = 1, numqty
      do k = ks,ke 
      do j = js,je 
        do i = is,ie 

          sUpy1 = cvmgp(  s(i,j,k,n) , s(i,j+1,k,n), vtrans(i,j+1,k))
          savg = half * (s(i,j,k,n) + s(i,j+1,k,n))
          sUpy1 = cvmgt(sUpy1, savg, abs(vtrans(i,j+1,k)) .gt. eps)

          sUpy2 = cvmgp(  s(i,j-1,k,n) , s(i,j,k,n), vtrans(i,j  ,k))
          savg = half * (s(i,j-1,k,n) + s(i,j,k,n))
          sUpy2 = cvmgt(sUpy2, savg, abs(vtrans(i,j  ,k)) .gt. eps)

          sUpz1 = cvmgp(  s(i,j,k,n) , s(i,j,k+1,n), wtrans(i,j,k+1))
          savg = half * (s(i,j,k,n) + s(i,j,k+1,n))
          sUpz1 = cvmgt(sUpz1, savg, abs(wtrans(i,j,k+1)) .gt. eps)

          sUpz2 = cvmgp(  s(i,j,k-1,n) , s(i,j,k,n), wtrans(i,j,k  ))
          savg = half * (s(i,j,k-1,n) + s(i,j,k,n))
          sUpz2 = cvmgt(sUpz2, savg, abs(wtrans(i,j,k  )) .gt. eps)

          s_l(i+1) = s(i,j,k,n) + 
     $      half*(one - u(i,j,k,1)*dt/hx)*slopex(i,j,k,n) - 
     $      half*dt*u(i,j,k,2)*(sUpy1 - sUpy2)/hy -
     $      half*dt*u(i,j,k,3)*(sUpz1 - sUpz2)/hz +
     $      half*dt*(diff(i,j,k,n) + force(i,j,k,n))

          s_r(i  ) = s(i,j,k,n) - 
     $      half*(one + u(i,j,k,1)*dt/hx)*slopex(i,j,k,n) -
     $      half*dt*u(i,j,k,2)*(sUpy1 - sUpy2)/hy -
     $      half*dt*u(i,j,k,3)*(sUpz1 - sUpz2)/hz +
     $      half*dt*(diff(i,j,k,n) + force(i,j,k,n))

        enddo

        if (bcx_lo .eq. PERIODIC) then
          s_l(is  ) = s_l(ie+1)
        elseif (bcx_lo .eq. WALL) then
          s_l(is  ) = s_r(is  )
        elseif (bcx_lo .eq. INLET ) then
          s_l(is  ) = s(is-1,j,k,n)
        elseif (bcx_lo .eq. OUTLET ) then
          s_l(is  ) = s_r(is  )
        endif

        if (bcx_hi .eq. PERIODIC) then
          s_r(ie+1) = s_r(is  )
        elseif (bcx_hi .eq. WALL) then
          s_r(ie+1) = s_l(ie+1)
        elseif (bcx_hi .eq. INLET ) then
          s_r(ie+1) = s(ie+1,j,k,n)
        elseif (bcx_hi .eq. OUTLET ) then
          s_r(ie+1) = s_l(ie+1)
        endif

        do i = is,ie+1 

          sedgex(i,j,k,n)= cvmgp(s_l(i),s_r(i),uadv(i,j,k))
          savg = half*(s_l(i) + s_r(i))
          sedgex(i,j,k,n) = cvmgp(savg,sedgex(i,j,k,n),eps-abs(uadv(i,j,k)))

        enddo
      enddo
      enddo

c ::: Now do s^(n+1/2) on the (j+1/2) boundaries.

      do k = ks,ke 
      do i = is,ie 
        do j = js,je 

          sUpx1 = cvmgp(  s(i,j,k,n) , s(i+1,j,k,n),utrans(i+1,j,k))
          savg = half * (s(i,j,k,n) + s(i+1,j,k,n))
          sUpx1 = cvmgt(sUpx1, savg, abs(utrans(i+1,j,k)) .gt. eps)

          sUpx2 = cvmgp(  s(i-1,j,k,n) , s(i,j,k,n),utrans(i  ,j,k))
          savg = half * (s(i-1,j,k,n) + s(i,j,k,n))
          sUpx2 = cvmgt(sUpx2, savg, abs(utrans(i,j,k)) .gt. eps)

          sUpz1 = cvmgp(  s(i,j,k,n) , s(i,j,k+1,n),wtrans(i,j,k+1))
          savg = half * (s(i,j,k,n) + s(i,j,k+1,n))
          sUpz1 = cvmgt(sUpz1, savg, abs(wtrans(i,j,k+1)) .gt. eps)

          sUpz2 = cvmgp(  s(i,j,k-1,n) , s(i,j,k,n),wtrans(i,j,k  ))
          savg = half * (s(i,j,k-1,n) + s(i,j,k,n))
          sUpz2 = cvmgt(sUpz2, savg, abs(wtrans(i,j,k)) .gt. eps)

          s_b(j+1) = s(i,j,k,n) + 
     $       half*(one - u(i,j,k,2)*dt/hy)*slopey(i,j,k,n) - 
     $       half*dt*u(i,j,k,1)*(sUpx1 - sUpx2)/hx -
     $       half*dt*u(i,j,k,3)*(sUpz1 - sUpz2)/hz +
     $       half*dt*(diff(i,j,k,n) + force(i,j,k,n))

          s_t(j  ) = s(i,j,k,n) - 
     $       half*(one + u(i,j,k,2)*dt/hy)*slopey(i,j,k,n) -
     $       half*dt*u(i,j,k,1)*(sUpx1 - sUpx2)/hx -
     $       half*dt*u(i,j,k,3)*(sUpz1 - sUpz2)/hz +
     $       half*dt*(diff(i,j,k,n) + force(i,j,k,n))

        enddo

        if (bcy_lo .eq. PERIODIC) then
          s_b(js  ) = s_b(je+1)
        elseif (bcy_lo .eq. WALL ) then
          s_b(js  ) = s_t(js  )
        elseif (bcy_lo .eq. INLET ) then
          s_b(js  ) = s(i,js-1,k,n)
        elseif (bcy_lo .eq. OUTLET ) then
          s_b(js  ) = s_t(js  )
        endif

        if (bcy_hi .eq. PERIODIC) then
          s_t(je+1) = s_t(js  )
        elseif (bcy_hi .eq. WALL ) then
          s_t(je+1) = s_b(je+1)
        elseif (bcy_hi .eq. INLET ) then
          s_t(je+1) = s(i,je+1,k,n)
        elseif (bcy_hi .eq. OUTLET ) then
          s_t(je+1) = s_b(je+1)
        endif


        do j = js, je+1 

          sedgey(i,j,k,n) = cvmgp(s_b(j),s_t(j),vadv(i,j,k))
          savg = half*(s_b(j) + s_t(j))
          sedgey(i,j,k,n) = cvmgp(savg,sedgey(i,j,k,n),eps-abs(vadv(i,j,k)))

        enddo
      enddo
      enddo

c ::: Now do s^(n+1/2) on the (k+1/2) boundaries.

      do j = js,je 
      do i = is,ie 
        do k = ks,ke 

          sUpx1 = cvmgp(  s(i,j,k,n) , s(i+1,j,k,n),utrans(i+1,j,k))
          savg = half * (s(i,j,k,n) + s(i+1,j,k,n))
          sUpx1 = cvmgt(sUpx1, savg, abs(utrans(i+1,j,k)) .gt. eps)

          sUpx2 = cvmgp(  s(i-1,j,k,n) , s(i,j,k,n),utrans(i  ,j,k))
          savg = half * (s(i-1,j,k,n) + s(i,j,k,n))
          sUpx2 = cvmgt(sUpx2, savg, abs(utrans(i,j,k)) .gt. eps)

          sUpy1 = cvmgp(  s(i,j,k,n) , s(i,j+1,k,n), vtrans(i,j+1,k))
          savg = half * (s(i,j,k,n) + s(i,j+1,k,n))
          sUpy1 = cvmgt(sUpy1, savg, abs(vtrans(i,j+1,k)) .gt. eps)

          sUpy2 = cvmgp(  s(i,j-1,k,n) , s(i,j,k,n), vtrans(i,j  ,k))
          savg = half * (s(i,j-1,k,n) + s(i,j,k,n))
          sUpy2 = cvmgt(sUpy2, savg, abs(vtrans(i,j  ,k)) .gt. eps)

          s_d(k+1) = s(i,j,k,n) + 
     $       half*(one - u(i,j,k,3)*dt/hz)*slopez(i,j,k,n) - 
     $       half*dt*u(i,j,k,1)*(sUpx1 - sUpx2)/hx -
     $       half*dt*u(i,j,k,2)*(sUpy1 - sUpy2)/hy +
     $       half*dt*(diff(i,j,k,n) + force(i,j,k,n))

          s_u(k  ) = s(i,j,k,n) - 
     $       half*(one + u(i,j,k,3)*dt/hz)*slopez(i,j,k,n) -
     $       half*dt*u(i,j,k,1)*(sUpx1 - sUpx2)/hx -
     $       half*dt*u(i,j,k,2)*(sUpy1 - sUpy2)/hy +
     $       half*dt*(diff(i,j,k,n) + force(i,j,k,n))

        enddo

        if (bcz_lo .eq. PERIODIC) then
          s_d(ks  ) = s_d(ke+1)
        elseif (bcz_lo .eq. WALL ) then
          s_d(ks  ) = s_u(ks  )
        elseif (bcz_lo .eq. INLET ) then
          s_d(ks  ) = s(i,j,ks-1,n)
        elseif (bcz_lo .eq. OUTLET ) then
          s_d(ks  ) = s_u(ks  )
        endif

        if (bcz_hi .eq. PERIODIC) then
          s_u(ke+1) = s_u(ks  )
        elseif (bcz_hi .eq. WALL ) then
          s_u(ke+1) = s_d(ke+1)
        elseif (bcz_hi .eq. INLET ) then
          s_u(ke+1) = s(i,j,ke+1,n)
        elseif (bcz_hi .eq. OUTLET ) then
          s_u(ke+1) = s_d(ke+1)
        endif

        do k = ks, ke+1 

          sedgez(i,j,k,n) = cvmgp(s_d(k),s_u(k),wadv(i,j,k))
          savg = half*(s_d(k) + s_u(k))
          sedgez(i,j,k,n) = cvmgp(savg,sedgez(i,j,k,n),eps-abs(wadv(i,j,k)))

        enddo
      enddo
      enddo

      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: GODUNOV_2D.F,v 1.1 2002/04/11 22:36:43 marc Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "GODUNOV_F.H"
#include "ArrayLim.H"
      
#define SDIM 2
#define NGHOST 3
#define LEFT	 0
#define RIGHT	 1
#define BOTTOM	 2
#define TOP 	 3
#define INTERIOR -1
#define ON_PHYS_B 0
#define NQ	 (5+NADV)

#if __STDC__==1
#define BL_ARGL1(u) u##_l1
#define BL_ARGL2(u) u##_l2
#define BL_ARGH1(u) u##_h1
#define BL_ARGH2(u) u##_h2
#define BL_IARG(u) u##_l1, u##_l2, u##_h1, u##_h2
#define BL_UVAR(u,v) REAL_T u(v##_l1:v##_h1, v##_l2:v##_h2)
#else
#define BL_ARGL1(u) u/**/_l1
#define BL_ARGL2(u) u/**/_l2
#define BL_ARGH1(u) u/**/_h1
#define BL_ARGH2(u) u/**/_h2
#define BL_IARG(u) u/**/_l1, u/**/_l2, u/**/_h1, u/**/_h2
#define BL_UVAR(u,v) REAL_T u(v/**/_l1:v/**/_h1, v/**/_l2:v/**/_h2)
#endif


c
c From ArrayLim.H ...
c
#define BL_FARG(u) u, DIMS(u)
#define BL_FBOUNDS(u) integer DIMDEC(u)
#define BL_FARRAY(u,n) REAL_T u(DIMV(u), n)
#define BL_FARRAY1(u) REAL_T u(DIMV(u))

#if __STDC__==1
#define BL_BARG(b) b##lo, b##hi
#define BL_BBOUNDS(b) integer b##lo(2), b##hi(2)
#else
#define BL_BARG(b) b/**/lo, b/**/hi
#define BL_BBOUNDS(b) integer b/**/lo(2), b/**/hi(2)
#endif

c 
c ---------------------------------------------------------------
c::  Characteristic tracing for hyperbolic conservation law
c::  Arguments:
c::  q         => field of primitive variables
c::  qx        => x-slopes of primitive variables
c::  c         => sound speed                         
c::  enth     <=  enthalpy
c::  qbarl    <=  left-edge traced state     
c::  qbarr    <=  right-edge traced state   
c::  bxlo,bxhi => index limits of grid interior
c::  bc        => array of bndry condition flags
c::  delta     => cell size
c::  dt        => timestep size
c::  nvar      => number of characteristic variables
c ---------------------------------------------------------------
c ::: these give meaning to the primitive variable components
#define  QRHO    1
#define  QVEL1   2
#define  QVEL2   3
#define  QPRES   4
#define  QRHOE   5
#if(NADV>0)
#define  QADV    6
#endif

      subroutine FORT_XTRACE(
     $		BL_FARG(q),
     $		BL_FARG(qx),
     $		BL_FARG(c), BL_FARG(enth), BL_FARG(qbarl), BL_FARG(qbarr),
     $		BL_FARG(dloga), BL_FARG(courno),
     &          BL_BARG(bx),
     &          delta, dt, bc, gBndry, nvar
     &		)

      integer nvar, gBndry(0:SDIM*SDIM-1)
      integer bc(SDIM,2,nvar-1),qbc(SDIM,2,NQ)
      REAL_T  delta(SDIM), dt

      BL_FBOUNDS(q)
      BL_FBOUNDS(qx)
      BL_FBOUNDS(c)
      BL_FBOUNDS(enth)
      BL_FBOUNDS(qbarl)
      BL_FBOUNDS(qbarr)
      BL_FBOUNDS(dloga)
      BL_FBOUNDS(courno)
      BL_BBOUNDS(bx)

      BL_FARRAY(q,nvar)
      BL_FARRAY(qx,nvar)
      BL_FARRAY(qbarl,nvar)
      BL_FARRAY(qbarr,nvar)
      BL_FARRAY1(c)
      BL_FARRAY1(enth)
      BL_FARRAY1(dloga)
      BL_FARRAY1(courno)

      integer i, j, n, nbc
      integer is, ie, js, je, isedg, ieedg,jsedg,jeedg
      REAL_T  dx, dy
      REAL_T spvol, dtbydx, scr, eken, eta, dthalf
      REAL_T sourcp, sourcr, source, avgarea
      REAL_T alpham, alphap, alpha0r, alpha0e
      REAL_T alpha0v1
      REAL_T spminus, spplus, spzero
      REAL_T apright, amright
      REAL_T apleft, amleft
      REAL_T azrright, azeright, azv1rght
      REAL_T azrleft, azeleft, azv1left
      REAL_T smallr
      REAL_T reflect
      
      REAL_T gdum,csdum,pdum

c     ::: some useful macro definitions
#     define U(i,j) 	q(i,j,QVEL1)
#     define V(i,j) 	q(i,j,QVEL2)
#     define P(i,j) 	q(i,j,QPRES)
#     define RHO(i,j) 	q(i,j,QRHO)
#     define RHOE(i,j) 	q(i,j,QRHOE)
#if(NADV>0)
#     define ADV(i,j) 	q(i,j,QADV)
#endif
#     define DU(i,j) 	qx(i,j,QVEL1)
#     define DV(i,j) 	qx(i,j,QVEL2)
#     define DP(i,j) 	qx(i,j,QPRES)
#     define DRHO(i,j) 	qx(i,j,QRHO)
#     define DRHOE(i,j)	qx(i,j,QRHOE)
#if(NADV>0)
#     define DADV(i,j)	qx(i,j,QADV)
#endif
        
      dx = delta(1)
      dy = delta(2)
      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      isedg = qbarl_l1
      ieedg = qbarl_h1
      jsedg = qbarl_l2
      jeedg = qbarl_h2

      smallr = 1.0d-6
      dtbydx = dt/dx

#if 0
c ::: convert energy to intensive form for eos call
      do j = js,je
        do i =is,ie
	  RHOE(i,j) = RHOE(i,j)/RHO(i,j)
        end do
      end do

      call eos(RHO(is,js),RHOE(is,js),
     $         gdum,pdum,c,csdum,bxlo,bxhi,0,0,1,0)

#endif
c     convert energy to extensive form and compute courant number
      do j = js,je
        do i =is,ie
c	  RHOE(i,j) = RHOE(i,j)*RHO(i,j)
          courno(i,j) = dtbydx*(c(i,j)+abs(U(i,j)))       
        end do
      end do

c     characteristic analysis
      do j = jsedg,jeedg
        do i = isedg,ieedg-1
          enth(i,j) = (RHOE(i,j)/RHO(i,j) +
     $                 P(i,j)/RHO(i,j))/c(i,j)**2
          alpham = half*(DP(i,j)/(RHO(i,j)*c(i,j)) - DU(i,j))*RHO(i,j)
     $    /c(i,j)
          alphap = half*(DP(i,j)/(RHO(i,j)*c(i,j)) + DU(i,j))*RHO(i,j)
     $    /c(i,j)
          alpha0r = DRHO(i,j) - DP(i,j)/c(i,j)**2
          alpha0e = DRHOE(i,j) - DP(i,j)*enth(i,j)
          alpha0v1 = DV(i,j)

c ::: :::::  Right state of edge at left
          spminus = cvmgp(-one,(U(i,j) - c(i,j))*dtbydx,U(i,j) - c(i,j))
          spplus = cvmgp(-one,(U(i,j) + c(i,j))*dtbydx,U(i,j) + c(i,j))
          spzero = cvmgp(-one, U(i,j) *dtbydx,U(i,j) )
          apright = half*(-one - spplus )*alphap
          amright = half*(-one - spminus)*alpham
          azrright= half*(-one - spzero )*alpha0r
          azeright= half*(-one - spzero )*alpha0e
          azv1rght= half*(-one - spzero )*alpha0v1
          qbarr(i,j,QRHO) = q(i,j,QRHO) + apright + amright + azrright
          qbarr(i,j,QRHO) = max(smallr, qbarr(i,j,QRHO))
          qbarr(i,j,QVEL1) = q(i,j,QVEL1) +
     $                      (apright - amright)*c(i,j)/RHO(i,j)
          qbarr(i,j,QVEL2) = q(i,j,QVEL2) + azv1rght
          qbarr(i,j,QPRES) = q(i,j,QPRES) +
     $                      (apright + amright)*c(i,j)**2
          qbarr(i,j,QRHOE) = q(i,j,QRHOE) + (apright +
     $                       amright)*enth(i,j)*c(i,j)**2 + azeright
#if(NADV>0)
          qbarr(i,j,QADV) = q(i,j,QADV)+half*(-one-spzero)*DADV(i,j)
#endif

c ::: :::::  Left state of edge at right

          spminus = cvmgp((U(i,j) - c(i,j))*dtbydx,one,U(i,j) - c(i,j))
          spplus = cvmgp((U(i,j) + c(i,j))*dtbydx,one,U(i,j) + c(i,j))
          spzero = cvmgp( U(i,j) *dtbydx,one,U(i,j) )
          apleft = half*(one - spplus )*alphap
          amleft = half*(one - spminus)*alpham
          azrleft= half*(one - spzero )*alpha0r
          azeleft= half*(one - spzero )*alpha0e
          azv1left= half*(one - spzero )*alpha0v1
          qbarl(i+1,j,QRHO) = q(i,j,QRHO) + apleft + amleft + azrleft
          qbarl(i+1,j,QRHO) = max(smallr, qbarl(i+1,j,QRHO))
          qbarl(i+1,j,QVEL1) = q(i,j,QVEL1) +
     $                         (apleft - amleft)*c(i,j)/RHO(i,j)
          qbarl(i+1,j,QVEL2) = q(i,j,QVEL2) + azv1left
          qbarl(i+1,j,QPRES) = q(i,j,QPRES) +
     $                         (apleft + amleft)*c(i,j)**2
          qbarl(i+1,j,QRHOE) = q(i,j,QRHOE) + (apleft + amleft)*
     $                         enth(i,j)*c(i,j)**2 + azeleft
#if(NADV>0)
          qbarl(i+1,j,QADV) = q(i,j,QADV)+half*(one-spzero)*DADV(i,j)
#endif
        end do
      end do
          

c ::: Colella hack near R=0 singularity
      do j = js,je
        do i = is,ie
          if (dloga(i,j) .ne. zero) then
              eta = (one-courno(i,j))/(c(i,j)*dt*dloga(i,j))
              eta = min(one, eta)
              dloga(i,j) = dloga(i,j) * eta
          end if
        end do
      end do

      dthalf = half*dt
c ::: add geometric source terms to traced states
      do j = jsedg,jeedg
        do i = isedg,ieedg-1
          sourcr = -RHO(i,j)*dloga(i,j)*U(i,j)*dthalf
          sourcp = sourcr*c(i,j)**2
          source = sourcp*enth(i,j)
          qbarl(i+1,j,QRHO) = qbarl(i+1,j,QRHO) + sourcr
          qbarl(i+1,j,QRHO) = max(smallr, qbarl(i+1,j,QRHO))
          qbarl(i+1,j,QPRES) = qbarl(i+1,j,QPRES) + sourcp
          qbarl(i+1,j,QRHOE) = qbarl(i+1,j,QRHOE) + source
          qbarr(i,j ,QRHO) = qbarr(i,j ,QRHO) + sourcr
          qbarr(i,j ,QRHO) = max(smallr, qbarr(i,j,QRHO))
          qbarr(i,j ,QPRES) = qbarr(i,j ,QPRES) + sourcp
          qbarr(i,j ,QRHOE) = qbarr(i,j ,QRHOE) + source
        end do
      end do
#if 0
c ::: convert energy back to intensive form 
c ::: for eos call in RIEMANN
      do j = js,je
        do i =is,ie
	  RHOE(i,j) = RHOE(i,j)/RHO(i,j)
        end do
      end do
#endif
#if 0
c     warning: nqvar = nstatevar+1
      do n = 1, nvar-1
       qbc(1,1,n) = bc(1,1,n)
       qbc(1,2,n) = bc(1,2,n)
       qbc(2,1,n) = bc(2,1,n)
       qbc(2,2,n) = bc(2,2,n)
      end do
       qbc(1,1,nvar) = qbc(1,1,nvar-1)
       qbc(1,2,nvar) = qbc(1,2,nvar-1)
       qbc(2,1,nvar) = qbc(2,1,nvar-1)
       qbc(2,2,nvar) = qbc(2,2,nvar-1)
      
      do n = 1,nvar
        do j = jsedg,jeedg
         reflect = cvmgt(-one,one,qbc(1,1,n).eq.REFLECT_ODD)
           i = isedg
            qbarl(i,j,n) = reflect*qbarr(i,j,n)
         reflect = cvmgt(-one,one,qbc(1,2,n).eq.REFLECT_ODD)
          i = ieedg
           qbarr(i,j,n) = reflect*qbarl(i,j,n)
        end do
      end do

#endif

#undef U
#undef V
#undef P
#undef RHO
#undef RHOE
#undef DU
#undef DV
#undef DP
#undef DRHO
#undef DRHOE
#if(NADV>0)
#undef DADV
#endif

      return
      end


c 
c ---------------------------------------------------------------
c::  Y characteristic tracing for hyperbolic conservation law
c::  Arguments:
c::  q         => field of primitive variables
c::  qy        => x-slopes of primitive variables
c::  c         => sound speed                         
c::  enth     <=  enthalpy
c::  qbarl    <=  bottom-edge traced state     
c::  qbarr    <=  top-edge traced state   
c::  bxlo,bxhi => index limits of grid interior
c::  bc        => array of bndry condition flags
c::  delta     => cell size
c::  dt        => timestep size
c::  nvar      => number of characteristic variables
c ---------------------------------------------------------------
c ::: these give meaning to the primitive variable components
#define  QRHO    1
#define  QVEL1   2
#define  QVEL2   3
#define  QPRES   4
#define  QRHOE   5
#if(NADV>0)
#define  QADV    6
#endif


      subroutine FORT_YTRACE(
     &          BL_FARG(q),
     &          BL_FARG(qy),
     &          BL_FARG(c),
     &          BL_FARG(enth),
     &          BL_FARG(qbarl),
     &          BL_FARG(qbarr),
     &          BL_FARG(dloga),
     &          BL_FARG(courno),
     &          BL_BARG(bx),
     &          delta, dt, bc, gBndry, nvar
     &		)

      integer nvar, gBndry(0:SDIM*SDIM-1)
      integer bc(SDIM,2,nvar-1),qbc(SDIM,2,NQ)
      REAL_T  delta(SDIM), dt

      BL_FBOUNDS(q)
      BL_FBOUNDS(qy)
      BL_FBOUNDS(qbarl)
      BL_FBOUNDS(qbarr)
      BL_FBOUNDS(c)
      BL_FBOUNDS(enth)
      BL_FBOUNDS(dloga)
      BL_FBOUNDS(courno)
      BL_BBOUNDS(bx)

      BL_FARRAY(q,nvar)
      BL_FARRAY(qy,nvar)
      BL_FARRAY(qbarl,nvar)
      BL_FARRAY(qbarr,nvar)
      BL_FARRAY1(c)
      BL_FARRAY1(enth)
      BL_FARRAY1(dloga)
      BL_FARRAY1(courno)

      integer i, j, n, nbc
      integer is, ie, js, je, isedg, ieedg,jsedg,jeedg
      REAL_T  dx, dy
      REAL_T spvol, dtbydx, scr, eken, eta, dthalf
      REAL_T sourcp, sourcr, source, avgarea
      REAL_T alpham, alphap, alpha0r, alpha0e
      REAL_T alpha0v1
      REAL_T spminus, spplus, spzero
      REAL_T apright, amright
      REAL_T apleft, amleft
      REAL_T azrright, azeright, azv1rght
      REAL_T azrleft, azeleft, azv1left
      REAL_T smallr
      REAL_T reflect

      REAL_T gdum,csdum,pdum

c     ::: some useful macro definitions
#     define U(i,j) 	q(i,j,QVEL1)
#     define V(i,j) 	q(i,j,QVEL2)
#     define P(i,j) 	q(i,j,QPRES)
#     define RHO(i,j) 	q(i,j,QRHO)
#     define RHOE(i,j) 	q(i,j,QRHOE)
#if(NADV>0)
#     define ADV(i,j) 	q(i,j,QADV)
#endif
#     define DU(i,j) 	qy(i,j,QVEL1)
#     define DV(i,j) 	qy(i,j,QVEL2)
#     define DP(i,j) 	qy(i,j,QPRES)
#     define DRHO(i,j) 	qy(i,j,QRHO)
#     define DRHOE(i,j)	qy(i,j,QRHOE)
#if(NADV>0)
#     define DADV(i,j)	qy(i,j,QADV)
#endif
        
      dx = delta(1)
      dy = delta(2)
      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)

      isedg = qbarl_l1
      ieedg = qbarl_h1
      jsedg = qbarl_l2
      jeedg = qbarl_h2


      smallr = 1.0d-6
      dtbydx = dt/dx

c ::: convert energy to intensive form for eos call
#if 0
      do j = js,je
        do i =is,ie
	  RHOE(i,j) = RHOE(i,j)/RHO(i,j)
        end do
      end do

      call eos(RHO(is,js),RHOE(is,js),
     $         gdum,pdum,c,csdum,bxlo,bxhi,0,0,1,0)

#endif
c     convert energy back to extensive form and compute courant number
      do j = js,je
        do i =is,ie
c	  RHOE(i,j) = RHOE(i,j)*RHO(i,j)
          courno(i,j) = dtbydx*(c(i,j)+abs(V(i,j)))       
        end do
      end do

c     characteristic analysis
      do j = jsedg,jeedg-1
        do i = isedg,ieedg
          enth(i,j) = (RHOE(i,j)/RHO(i,j) +
     $                 P(i,j)/RHO(i,j))/c(i,j)**2
          alpham = half*(DP(i,j)/(RHO(i,j)*c(i,j)) - DV(i,j))*RHO(i,j)
     $    /c(i,j)
          alphap = half*(DP(i,j)/(RHO(i,j)*c(i,j)) + DV(i,j))*RHO(i,j)
     $    /c(i,j)
          alpha0r = DRHO(i,j) - DP(i,j)/c(i,j)**2
          alpha0e = DRHOE(i,j) - DP(i,j)*enth(i,j)
          alpha0v1 = DU(i,j)

c ::: :::::  Top state of edge at bottom
          spminus = cvmgp(-one,(V(i,j) - c(i,j))*dtbydx,V(i,j) - c(i,j))
          spplus = cvmgp(-one,(V(i,j) + c(i,j))*dtbydx,V(i,j) + c(i,j))
          spzero = cvmgp(-one, V(i,j) *dtbydx,V(i,j) )
          apright = half*(-one - spplus )*alphap
          amright = half*(-one - spminus)*alpham
          azrright= half*(-one - spzero )*alpha0r
          azeright= half*(-one - spzero )*alpha0e
          azv1rght= half*(-one - spzero )*alpha0v1
          qbarr(i,j,QRHO) = q(i,j,QRHO) + apright + amright + azrright
          qbarr(i,j,QRHO) = max(smallr, qbarr(i,j,QRHO))
          qbarr(i,j,QVEL2) = q(i,j,QVEL2) +
     $                      (apright - amright)*c(i,j)/RHO(i,j)
          qbarr(i,j,QVEL1) = q(i,j,QVEL1) + azv1rght
          qbarr(i,j,QPRES) = q(i,j,QPRES) +
     $                      (apright + amright)*c(i,j)**2
          qbarr(i,j,QRHOE) = q(i,j,QRHOE) + (apright +
     $                       amright)*enth(i,j)*c(i,j)**2 + azeright
#if(NADV>0)
          qbarr(i,j,QADV) = q(i,j,QADV)+half*(-one-spzero)*DADV(i,j)
#endif

c ::: :::::  Bottom state of edge at top

          spminus = cvmgp((V(i,j) - c(i,j))*dtbydx,one,V(i,j) - c(i,j))
          spplus = cvmgp((V(i,j) + c(i,j))*dtbydx,one,V(i,j) + c(i,j))
          spzero = cvmgp( V(i,j) *dtbydx,one,V(i,j) )
          apleft = half*(one - spplus )*alphap
          amleft = half*(one - spminus)*alpham
          azrleft= half*(one - spzero )*alpha0r
          azeleft= half*(one - spzero )*alpha0e
          azv1left= half*(one - spzero )*alpha0v1
          qbarl(i,j+1,QRHO) = q(i,j,QRHO) + apleft + amleft + azrleft
          qbarl(i,j+1,QRHO) = max(smallr, qbarl(i,j+1,QRHO))
          qbarl(i,j+1,QVEL2) = q(i,j,QVEL2) +
     $                         (apleft - amleft)*c(i,j)/RHO(i,j)
          qbarl(i,j+1,QVEL1) = q(i,j,QVEL1) + azv1left
          qbarl(i,j+1,QPRES) = q(i,j,QPRES) +
     $                         (apleft + amleft)*c(i,j)**2
          qbarl(i,j+1,QRHOE) = q(i,j,QRHOE) + (apleft + amleft)*
     $                         enth(i,j)*c(i,j)**2 + azeleft
#if(NADV>0)
          qbarl(i,j+1,QADV) = q(i,j,QADV)+half*(one-spzero)*DADV(i,j)
#endif
        end do
      end do
          

c ::: Colella hack near R=0 singularity
      do j = js,je
        do i = is,ie
          if (dloga(i,j) .ne. zero) then
              eta = (one-courno(i,j))/(c(i,j)*dt*dloga(i,j))
              eta = min(one, eta)
              dloga(i,j) = dloga(i,j) * eta
          end if
        end do
      end do

      dthalf = half*dt
c ::: add geometric source terms to traced states
      do j = jsedg,jeedg-1
        do i = isedg,ieedg
          sourcr = -RHO(i,j)*dloga(i,j)*V(i,j)*dthalf
          sourcp = sourcr*c(i,j)**2
          source = sourcp*enth(i,j)
          qbarl(i,j+1,QRHO) = qbarl(i,j+1,QRHO) + sourcr
          qbarl(i,j+1,QRHO) = max(smallr, qbarl(i,j+1,QRHO))
          qbarl(i,j+1,QPRES) = qbarl(i,j+1,QPRES) + sourcp
          qbarl(i,j+1,QRHOE) = qbarl(i,j+1,QRHOE) + source
          qbarr(i,j ,QRHO) = qbarr(i,j ,QRHO) + sourcr
          qbarr(i,j ,QRHO) = max(smallr, qbarr(i,j,QRHO))
          qbarr(i,j ,QPRES) = qbarr(i,j ,QPRES) + sourcp
          qbarr(i,j ,QRHOE) = qbarr(i,j ,QRHOE) + source
        end do
      end do
#if 0
c ::: convert energy back to intensive form 
c ::: for eos call in RIEMANN
      do j = js,je
        do i =is,ie
	  RHOE(i,j) = RHOE(i,j)/RHO(i,j)
        end do
      end do
#endif

#if 0
c     warning: nqvar = nstatevar+1
      do n = 1, nvar-1
       qbc(1,1,n) = bc(1,1,n)
       qbc(1,2,n) = bc(1,2,n)
       qbc(2,1,n) = bc(2,1,n)
       qbc(2,2,n) = bc(2,2,n)
      end do
       qbc(1,1,nvar) = qbc(1,1,nvar-1)
       qbc(1,2,nvar) = qbc(1,2,nvar-1)
       qbc(2,1,nvar) = qbc(2,1,nvar-1)
       qbc(2,2,nvar) = qbc(2,2,nvar-1)
      
      
      do n = 1,nvar
        do i = isedg,ieedg
         j = jsedg
         reflect = cvmgt(-one,one,qbc(2,1,n).eq.REFLECT_ODD)
c        reflect = one
          qbarl(i,j,n) = reflect*qbarr(i,j,n)
         j = jeedg
         reflect = cvmgt(-one,one,qbc(2,2,n).eq.REFLECT_ODD)
c        reflect = one
          qbarr(i,j,n) = reflect*qbarl(i,j,n)
        end do
      end do

#endif

#undef U
#undef V
#undef P
#undef RHO
#undef RHOE
#undef DU
#undef DV
#undef DP
#undef DRHO
#undef DRHOE
#if(NADV>0)
#undef DADV
#endif
      return
      end

#define SRHO 1
#define SXMOM 2
#define SYMOM 3
#define SRHOE 4
#if(NADV>0)
#define  SADV 5
#endif

      subroutine FORT_RIEMANN(
     &		BL_FARG(qbarm),
     &		BL_FARG(qbarp),
     &		BL_FARG(flux),
     &          BL_FARG(rho),
     &          BL_FARG(e),
     &          BL_FARG(adv),
     &		BL_FARG(c),
     &		BL_FARG(csml),
     &		BL_FARG(gamc),
     &		BL_FARG(rgdnv),
     &		BL_FARG(ugdnv),
     &		BL_FARG(pgdnv),
     &		BL_FARG(egdnv),
     &		BL_FARG(utgdnv),
#if(NADV>0)
     &          BL_FARG(advgdnv),
#endif
     &		BL_FARG(ustar),
     &          BL_BARG(bx),
     &		sweep, npvar, nsvar)   

      integer sweep, npvar, nsvar
      BL_FBOUNDS(qbarm)
      BL_FBOUNDS(qbarp)
      BL_FBOUNDS(c)
      BL_FBOUNDS(rho)
      BL_FBOUNDS(e)
      BL_FBOUNDS(adv)
      BL_FBOUNDS(csml)
      BL_FBOUNDS(gamc)
      BL_FBOUNDS(rgdnv)
      BL_FBOUNDS(ugdnv)
      BL_FBOUNDS(pgdnv)
      BL_FBOUNDS(egdnv)
      BL_FBOUNDS(utgdnv)
#if(NADV>0)
      BL_FBOUNDS(advgdnv)
#endif
      BL_FBOUNDS(ustar)
      BL_FBOUNDS(flux)
      BL_BBOUNDS(bx)

      BL_FARRAY(qbarm,npvar)
      BL_FARRAY(qbarp,npvar)
      BL_FARRAY1(c)
      BL_FARRAY1(rho)
      BL_FARRAY1(e)
      BL_FARRAY1(adv)
      BL_FARRAY1(csml)
      BL_FARRAY1(gamc)
      BL_FARRAY1(rgdnv)
      BL_FARRAY1(ugdnv)
      BL_FARRAY1(pgdnv)
      BL_FARRAY1(egdnv)
      BL_FARRAY1(utgdnv)
#if(NADV>0)
      BL_FARRAY1(advgdnv)
#endif
      BL_FARRAY1(ustar)
      BL_FARRAY(flux,nsvar)

      REAL_T wl, wr, cav, pstar
      REAL_T ro, uo, po, eo, gamco, co, entho
      REAL_T rstar, estar, cstar
      REAL_T sgnm, spin, spout, ushock, frac, divuvs
      REAL_T scr

      REAL_T csmall, wsmall, smallr,pdum, small

      integer qvnrml, qvtrns
      integer is,ie,js,je, i,j
      integer    lo(2), hi(2)

      
      if(sweep.eq.0)then
c     ::: x-direction
        qvnrml = QVEL1
        qvtrns = QVEL2
      else if(sweep.eq.1)then
c     ::: y-direction
        qvnrml = QVEL2
        qvtrns = QVEL1
      else
        print *,'Abort: Bogus sweep value passed to RIEMANN'
        write(6,*) 'sweep = ', sweep
        stop
      end if

      smallr = 1.0d-6
      small = 1.0d-6

      is = flux_l1
      ie = flux_h1
      js = flux_l2
      je = flux_h2
      
#if 0
      call eos(rho,e,gamc,pdum,c,csml,bxlo,bxhi,1,0,1,1)
#endif

      do j = js,je          
        do i = is,ie          

          if(sweep.eq.0)then
            csmall = max(csml(i-1,j),csml(i,j))
            cav = half*(c(i,j) + c(i-1,j))
            wsmall = smallr*csmall
            wl = max(wsmall,sqrt(abs(gamc(i-1,j)*
     $           qbarm(i,j,QPRES)*qbarm(i,j,QRHO))))
          else
            csmall = max(csml(i,j-1),csml(i,j))
            cav = half*(c(i,j) + c(i,j-1))
            wsmall = smallr*csmall
            wl = max(wsmall,sqrt(abs(gamc(i,j-1)*
     $           qbarm(i,j,QPRES)*qbarm(i,j,QRHO))))
          end if


          wr = max(wsmall,sqrt(abs(gamc(i,j )*qbarp(i,j,QPRES)*
     $         qbarp(i,j,QRHO))))

          pstar = ((wr*qbarm(i,j,QPRES) + wl*qbarp(i,j,QPRES)) + wl*wr*
     $    (qbarm(i,j,qvnrml) - qbarp(i,j,qvnrml)))/(wl + wr)

          ustar(i,j) = ((wl*qbarm(i,j,qvnrml) + wr*qbarp(i,j,qvnrml)) +
     $    (qbarm(i,j,QPRES) - qbarp(i,j,QPRES)))/(wl + wr)

          ro = cvmgp(qbarm(i,j,QRHO),qbarp(i,j,QRHO),ustar(i,j))
          uo = cvmgp(qbarm(i,j,qvnrml),qbarp(i,j,qvnrml),ustar(i,j))
          po = cvmgp(qbarm(i,j,QPRES),qbarp(i,j,QPRES),ustar(i,j))
          eo = cvmgp(qbarm(i,j,QRHOE),qbarp(i,j,QRHOE),ustar(i,j))

          if(sweep.eq.0)then
            gamco = cvmgp(gamc(i-1,j),gamc(i,j),ustar(i,j))
          else
            gamco = cvmgp(gamc(i,j-1),gamc(i,j),ustar(i,j))
          end if

          co = max(csmall,sqrt(abs(gamco*po/ro)))
          entho = (eo/ro + po/ro)/co**2
          rstar = ro + (pstar - po)/co**2
          rstar = max(rstar,smallr)
          estar = eo + (pstar - po)*entho
          cstar = max(csmall,sqrt(abs(gamco*pstar/rstar)))

          sgnm = sign(one,ustar(i,j))
          spout = co - sgnm*uo
          spin = cstar - sgnm*ustar(i,j)
          ushock = half*(spin + spout)
          spin = cvmgp(ushock,spin,pstar - po)
          spout = cvmgp(ushock,spout,pstar - po)
          scr = cvmgz(small*cav,spout - spin,spout - spin)
          frac = (one + (spout + spin)/scr)*half
          frac = max(zero,min(one,frac))

          utgdnv(i,j) = cvmgp(qbarm(i,j,qvtrns),qbarp(i,j,qvtrns),ustar(i,j))
#if(NADV>0)
          advgdnv(i,j) = cvmgp(qbarm(i,j,QADV),qbarp(i,j,QADV), ustar(i,j))
#endif
          rgdnv(i,j) = frac*rstar + (one - frac)*ro
          ugdnv(i,j) = frac*ustar(i,j) + (one - frac)*uo
          pgdnv(i,j) = frac*pstar + (one - frac)*po
          egdnv(i,j) = frac*estar + (one - frac)*eo

          rgdnv(i,j) = cvmgp(rgdnv(i,j),ro,spout)
          ugdnv(i,j) = cvmgp(ugdnv(i,j),uo,spout)
          pgdnv(i,j) = cvmgp(pgdnv(i,j),po,spout)
          egdnv(i,j) = cvmgp(egdnv(i,j),eo,spout)

          rgdnv(i,j) = cvmgp(rstar,rgdnv(i,j),spin)
          ugdnv(i,j) = cvmgp(ustar(i,j),ugdnv(i,j),spin)
          pgdnv(i,j) = cvmgp(pstar,pgdnv(i,j),spin)
          egdnv(i,j) = cvmgp(estar,egdnv(i,j),spin)

        end do
      end do

c ::: ::::: compute fluxes
      do j = js,je
        do i = is,ie

          flux(i,j,SRHO) = ugdnv(i,j)*rgdnv(i,j)
          flux(i,j,qvnrml) = ugdnv(i,j)*flux(i,j,SRHO)
          flux(i,j,qvtrns) = utgdnv(i,j)*flux(i,j,SRHO)
          flux(i,j,SRHOE) = flux(i,j,SRHO)*          
     $       (half*(ugdnv(i,j)**2+utgdnv(i,j)**2)+       
     $       egdnv(i,j)/rgdnv(i,j)) + ugdnv(i,j)*pgdnv(i,j)
#if(NADV>0)
          flux(i,j,SADV) = flux(i,j,SRHO)*advgdnv(i,j)
#endif

        end do
      end do

      return
      end



      subroutine FORT_DIVF(
     &          BL_FARG(state),
     &          BL_FARG(div_f),
     &          BL_FARG(xflux),
     &          BL_FARG(yflux),
     &          BL_BARG(bx),
     &          delta, dt, nvar
     &		)

        integer nvar
        REAL_T  delta(SDIM), dt

	BL_FBOUNDS(state)
	BL_FBOUNDS(div_f)
	BL_FBOUNDS(xflux)
	BL_FBOUNDS(yflux)
	BL_BBOUNDS(bx)

	BL_FARRAY(state,nvar)
	BL_FARRAY(div_f,nvar)
	BL_FARRAY(xflux,nvar)
	BL_FARRAY(yflux,nvar)

        integer i, j, n
        integer is, ie, js, je
        REAL_T  hx, hy, vol
        
        hx = delta(1)
        hy = delta(2)
        vol = hx*hy
        is = bxlo(1)
        ie = bxhi(1)
        js = bxlo(2)
        je = bxhi(2)



c	::::: Compute div(u*s). Note the sign.
	do n = 1,nvar
        do i = is, ie
           do j = js, je
              div_f(i,j,n) = 
     &                -    (xflux(i,j,n) - xflux(i+1,j,n)
     &                +     yflux(i,j,n) - yflux(i,j+1,n))/vol
           end do
        end do

        end do
	
      return
      end

      subroutine FORT_COPYSTATE(
     &          BL_FARG(state),
     &          BL_FARG(xflux),
     &          BL_FARG(yflux),
     &          BL_FARG(gstate),
     &          BL_BARG(bx),
     &          nvar
     &		)

        integer nvar
        REAL_T  delta(SDIM), dt

	BL_FBOUNDS(state)
	BL_FBOUNDS(xflux)
	BL_FBOUNDS(yflux)
	BL_FBOUNDS(gstate)
	BL_BBOUNDS(bx)

	BL_FARRAY(state,nvar)
	BL_FARRAY(xflux,nvar)
	BL_FARRAY(yflux,nvar)
	BL_FARRAY(gstate,nvar)

        integer i, j, n
        integer is, ie, js, je
        
        is = bxlo(1)
        ie = bxhi(1)
        js = bxlo(2)
        je = bxhi(2)


	do n = 1,nvar
        do i = is, ie
           do j = js, je
              gstate(i,j,n) = state(i,j,n)
           end do
        end do
        end do
	
      return
      end

c 
c ---------------------------------------------------------------
c Node-based divergence for artificial viscosity calculation
c ---------------------------------------------------------------
c       
        subroutine FORT_DIVUNODE (
     &                  BL_FARG(state),
     &                  BL_FARG(div),
     &                  delta, nvar, gbndry)

        integer nvar, gbndry(0:SDIM*SDIM-1)
        REAL_T delta(SDIM)

        BL_FBOUNDS(state)
        BL_FBOUNDS(div)

        BL_FARRAY(state,nvar)
        BL_FARRAY1(div)

	integer i,j
	REAL_T ux,vy,uij,vij,uimj,vimj,uijm,vijm,uimjm,vimjm


      
      do j = div_l2,div_h2
	 do i = div_l1, div_h1

         uij = state(i,j,2)/state(i,j,1)  
         vij = state(i,j,3)/state(i,j,1)  
         uimj = state(i-1,j,2)/state(i-1,j,1)
         vimj = state(i-1,j,3)/state(i-1,j,1)
         uijm = state(i,j-1,2)/state(i,j-1,1)
         vijm = state(i,j-1,3)/state(i,j-1,1)
         uimjm = state(i-1,j-1,2)/state(i-1,j-1,1)
         vimjm = state(i-1,j-1,3)/state(i-1,j-1,1)

         ux = half* (uij - uimj + uijm - uimjm)/delta(1)
         vy = half* (vij - vijm + vimj - vimjm)/delta(2)

         div(i,j) = ux + vy

         end do
      end do

      return
      end
c
c---------------------------------------------------------------
c::  X-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEX2(BL_FARG(s),BL_FARG(slx),nv,gBndry)
      integer nv,gBndry(0:SDIM*SDIM-1)

      BL_FBOUNDS(s)
      BL_FBOUNDS(slx)

      BL_FARRAY(s,nv)
      BL_FARRAY(slx,nv)

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag

      integer is,js,ie,je,i,j,iv

      is = slx_l1
      js = slx_l2
      ie = slx_h1
      je = slx_h2


      do 100 iv = 1,nv

          do 160 j = js,je
            do 170 i = is,ie
              del = half*(s(i+1,j,iv)-s(i-1,j,iv))
              dpls = two*(s(i+1,j,iv) - s(i ,j,iv))
              dmin = two*(s(i ,j,iv) - s(i-1,j,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(i,j,iv)= sflag*min(slim,abs(del))
170         continue
160       continue

100       continue

          return
          end

	subroutine FORT_FLATENX(BL_FARG(q),BL_FARG(flatn),
     $		BL_FARG(dp), BL_FARG(z), BL_FARG(chi),
     $		BL_FARG(p), BL_FARG(c),nv)
	integer nv
	BL_FBOUNDS(q)
	BL_FBOUNDS(flatn)
	BL_FBOUNDS(dp)
	BL_FBOUNDS(z)
	BL_FBOUNDS(chi)
	BL_FBOUNDS(p)
	BL_FBOUNDS(c)

	BL_FARRAY(q,nv)
	BL_FARRAY1(flatn)
	BL_FARRAY1(dp)
	BL_FARRAY1(z)
	BL_FARRAY1(chi)
	BL_FARRAY1(p)
	BL_FARRAY1(c)

	integer is,js,ie,je, i,j
	REAL_T shktst, zcut1, zcut2, dzcut
	REAL_T denom, zeta, tst, tmp

#include "xxmeth.fh"

c ::: ::::: knobs for detection of strong shock
#ifdef  BL_USE_FLOAT
      data shktst /0.33/
      data zcut1 /0.75/
      data zcut2 /0.85/
#endif
#ifdef  BL_USE_DOUBLE
      data shktst /0.33d0/
      data zcut1 /0.75d0/
      data zcut2 /0.85d0/
#endif

	dzcut = one/(zcut2-zcut1)

c
c  this is a hack.  need to compute the pressure from the state in 
c  a general way.
c

	if(iorder .eq. 3) then
	  return
	else
c
c  could use z or chi limits equivalently
c
        is = dp_l1
        ie = dp_h1
        js = dp_l2
        je = dp_h2
	
	do j = js,je
	  do i = is,ie
	    dp(i,j) =  p(i+1,j)-p(i-1,j)
	    denom = max(smallp,abs(p(i+2,j)-p(i-2,j)))
	    zeta = abs(dp(i,j))/denom
	    z(i,j) = min(one,max(zero, dzcut*(zeta-zcut1)))
	    tst = cvmgp(one,zero,q(i-1,j,QVEL1)-q(i+1,j,QVEL1))
	    tmp = min(q(i+1,j,QRHO)*c(i+1,j)**2,q(i-1,j,QRHO)*c(i-1,j)**2)
	    chi(i,j) = cvmgt(tst,zero,(abs(dp(i,j))/tmp).gt.shktst)
	  end do
	end do

        is = flatn_l1
        ie = flatn_h1
        js = flatn_l2
        je = flatn_h2

        do j = js,je
          do i = is,ie
	    flatn(i,j) = one-max(chi(i-1,j)*z(i-1,j),chi(i,j)*z(i,j),
     $		chi(i+1,j)*z(i+1,j))
          end do
        end do

	end if

	return
	end

	subroutine FORT_FLATENY(BL_FARG(q),BL_FARG(flatn),
     $		BL_FARG(dp), BL_FARG(z), BL_FARG(chi),
     $		BL_FARG(p), BL_FARG(c), nv)
	integer nv
	BL_FBOUNDS(q)
	BL_FBOUNDS(flatn)
	BL_FBOUNDS(dp)
	BL_FBOUNDS(z)
	BL_FBOUNDS(chi)
	BL_FBOUNDS(p)
	BL_FBOUNDS(c)

	BL_FARRAY(q,nv)
	BL_FARRAY1(flatn)
	BL_FARRAY1(dp)
	BL_FARRAY1(z)
	BL_FARRAY1(chi)
	BL_FARRAY1(p)
	BL_FARRAY1(c)

	integer is,js,ie,je, i,j
	REAL_T shktst, zcut1, zcut2, dzcut
	REAL_T denom, zeta, tst, tmp

#include "xxmeth.fh"

c ::: ::::: knobs for detection of strong shock
#ifdef  BL_USE_FLOAT
      data shktst /0.33/
      data zcut1 /0.75/
      data zcut2 /0.85/
#endif
#ifdef  BL_USE_DOUBLE
      data shktst /0.33d0/
      data zcut1 /0.75d0/
      data zcut2 /0.85d0/
#endif

	dzcut = one/(zcut2-zcut1)

	if(iorder .eq. 3) then
	  return
	else
c
c  could use z or chi limits equivalently
c
        is = dp_l1
        ie = dp_h1
        js = dp_l2
        je = dp_h2
	
	do j = js,je
	  do i = is,ie
	    dp(i,j) = p(i,j+1)-p(i,j-1)
	    denom = max(smallp,abs(p(i,j+2)-p(i,j-2)))
	    zeta = abs(dp(i,j))/denom
	    z(i,j) = min(one,max(zero, dzcut*(zeta-zcut1)))
	    tst = cvmgp(one,zero,q(i,j-1,QVEL2)-q(i,j+1,QVEL2))
	    tmp = min(q(i,j+1,QRHO)*c(i,j+1)**2,q(i,j-1,QRHO)*c(i,j-1)**2)
	    chi(i,j) = cvmgt(tst,zero,(abs(dp(i,j))/tmp).gt.shktst)
	  end do
	end do

        is = flatn_l1
        ie = flatn_h1
        js = flatn_l2
        je = flatn_h2

        do j = js,je
          do i = is,ie
	    flatn(i,j) = one-max(chi(i,j-1)*z(i,j-1),chi(i,j)*z(i,j),
     $		chi(i,j+1)*z(i,j+1))
          end do
        end do

	end if

	return
	end

c
c---------------------------------------------------------------
c::  X-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes                            
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEX(BL_FARG(s),BL_FARG(slx),BL_FARG(flatn),
     $	BL_FARG(scen),BL_FARG(ssgn),BL_FARG(slim),BL_FARG(dsf),nv,gBndry)
      integer nv,gBndry(0:SDIM*SDIM-1)

      BL_FBOUNDS(s)                  
      BL_FBOUNDS(slx)
      BL_FBOUNDS(flatn)
      BL_FBOUNDS(scen)
      BL_FBOUNDS(ssgn)
      BL_FBOUNDS(slim)
      BL_FBOUNDS(dsf)

      BL_FARRAY(s,nv)
      BL_FARRAY(slx,nv)
      BL_FARRAY1(flatn)
      BL_FARRAY1(scen)
      BL_FARRAY1(ssgn)
      BL_FARRAY1(slim)
      BL_FARRAY1(dsf)
      

      REAL_T dpls,dmin,ds
      REAL_T del,sflag, dq4

      integer is,js,ie,je,i,j,iv

#include "xxmeth.fh"


      if(iorder .eq. 1) then
	return
      else

      do 100 iv = 1,nv
 
          is = dsf_l1
          js = dsf_l2
          ie = dsf_h1
          je = dsf_h2

          do 160 j = js,je
            do 170 i = is,ie
              scen(i,j) = (s(i+1,j,iv)-s(i-1,j,iv))
              dpls = (s(i+1,j,iv) - s(i ,j,iv))
              dmin = (s(i ,j,iv) - s(i-1,j,iv))
	      ssgn(i,j) = sign(one,scen(i,j))
	      slim(i,j) = two*min(abs(dpls),abs(dmin))
	      slim(i,j) = cvmgp(slim(i,j),zero,dpls*dmin)
	      dsf(i,j) = ssgn(i,j)*min(half*abs(scen(i,j)),slim(i,j))
170         continue
160       continue

	  is = slx_l1
	  ie = slx_h1
	  js = slx_l2
	  je = slx_h2

	  do j = js,je
	    do i = is,ie
	      dq4 = two3rd*(scen(i,j) - forth*(dsf(i+1,j)+dsf(i-1,j))) 
	      slx(i,j,iv) = ssgn(i,j)*flatn(i,j)*min(abs(dq4),slim(i,j))
c	      slx(i,j,iv) = ssgn(i,j)*min(abs(dq4),slim(i,j))
c	slx(i,j,iv) = ssgn(i,j)*min(slim(i,j),half*abs(scen(i,j)))
	    end do
	  end do

100       continue
	end if

          return
	  end

c
c---------------------------------------------------------------
c::  Y-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes                            
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEY(BL_FARG(s),BL_FARG(sly),BL_FARG(flatn),
     $	BL_FARG(scen),BL_FARG(ssgn),BL_FARG(slim),BL_FARG(dsf),nv,gBndry)
      integer nv,gBndry(0:SDIM*SDIM-1)

      BL_FBOUNDS(s)                  
      BL_FBOUNDS(sly)
      BL_FBOUNDS(flatn)
      BL_FBOUNDS(scen)
      BL_FBOUNDS(ssgn)
      BL_FBOUNDS(slim)
      BL_FBOUNDS(dsf)

      BL_FARRAY(s,nv)
      BL_FARRAY(sly,nv)
      BL_FARRAY1(flatn)
      BL_FARRAY1(scen)
      BL_FARRAY1(ssgn)
      BL_FARRAY1(slim)
      BL_FARRAY1(dsf)
      

      REAL_T dpls,dmin,ds
      REAL_T del,sflag, dq4

      integer is,js,ie,je,i,j,iv

#include "xxmeth.fh"



      if(iorder .eq. 1) then
	 return
      else
      do 100 iv = 1,nv
 
          is = dsf_l1
          js = dsf_l2
          ie = dsf_h1
          je = dsf_h2

          do 160 j = js,je
            do 170 i = is,ie
              scen(i,j) = (s(i,j+1,iv)-s(i,j-1,iv))
              dpls = (s(i,j+1,iv) - s(i ,j,iv))
              dmin = (s(i ,j,iv) - s(i,j-1,iv))
	      ssgn(i,j) = sign(one,scen(i,j))
	      slim(i,j) = two*min(abs(dpls),abs(dmin))
	      slim(i,j) = cvmgp(slim(i,j),zero,dpls*dmin)
	      dsf(i,j) = ssgn(i,j)*min(half*abs(scen(i,j)),slim(i,j))
170         continue
160       continue

	  is = sly_l1
	  ie = sly_h1
	  js = sly_l2
	  je = sly_h2

	  do j = js,je
	    do i = is,ie
	      dq4 = two3rd*(scen(i,j) - forth*(dsf(i,j+1)+dsf(i,j-1))) 
	      sly(i,j,iv) = ssgn(i,j)*flatn(i,j)*min(abs(dq4),slim(i,j))
c	      sly(i,j,iv) = ssgn(i,j)*min(abs(dq4),slim(i,j))
c	sly(i,j,iv) = ssgn(i,j)*min(slim(i,j),half*abs(scen(i,j)))
	    end do
	  end do

100   continue
      end if

          return
	  end
c
c ---------------------------------------------------------------
c
c ---------------------------------------------------------------
c::  Y-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  sly      <= slopes                                    
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEY2(BL_FARG(s),BL_FARG(sly),nv,gBndry)
      integer nv,gBndry(0:SDIM*SDIM-1)

      BL_FBOUNDS(s)                  
      BL_FBOUNDS(sly)

      BL_FARRAY(s,nv)
      BL_FARRAY(sly,nv)

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag


      integer is,js,ie,je,i,j,iv

      is = sly_l1
      js = sly_l2
      ie = sly_h1
      je = sly_h2


      do 150 iv = 1,nv
 
          do 180 j = js,je
            do 190 i = is,ie

              del = half*(s(i,j+1,iv)-s(i,j-1,iv))
              dpls = two*(s(i,j+1,iv) - s(i,j,iv ))
              dmin = two*(s(i,j,iv ) - s(i,j-1,iv))
              slim = min(abs(dpls),abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              sly(i,j,iv)= sflag*min(slim,abs(del))
190         continue
180       continue

150      continue

      return
      end


c
c ---------------------------------------------------------------
c::  Calculate metric coefficients
c ---------------------------------------------------------------
c
      subroutine FORT_METRICS(BL_FARG(vol),BL_FARG(dloga),BL_FARG(area),
     $                       BL_BARG(bx),delta, coordsys)
      REAL_T  delta(SDIM)

      BL_FBOUNDS(vol)                  
      BL_FBOUNDS(dloga)                  
      BL_FBOUNDS(area)                  
      BL_BBOUNDS(bx)

      BL_FARRAY1(vol)
      BL_FARRAY1(dloga)
      BL_FARRAY(area,SDIM)

      integer i,j,is,ie,js,je,coordsys
      REAL_T dx,dy

      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)

      dx = delta(1)
      dy = delta(2)

      if (coordsys.eq.0) then
	do j = js, je
	  do i = is, ie
	    vol(i,j) = dx*dy
	    dloga(i,j) = zero
	    area(i,j,1) = dy
	    area(i,j,2) = dx
          end do
        end do
       else
        print *,'Abort: Not wired for r-z yet.'
        stop
       end if

      return
      end

c
c--------------------------------------------------------------
c     Conservative update and other final stuff -- x direction
c---------------------------------------------------------------
c


      subroutine FORT_UPDATEX(
     &  		BL_FARG(s),
     &                  BL_FARG(flux),
     &                  BL_FARG(pgdnv),
     &                  BL_FARG(div),
     &                  BL_FARG(area),
     &                  BL_FARG(vol),
     &                  BL_BARG(bx),
     &                  delta, dt, nv, sweep, bc, gBndry)
      integer nv, gBndry(0:SDIM*SDIM-1)
      integer bc(SDIM,2,nv)

      BL_FBOUNDS(s)                  
      BL_FBOUNDS(flux)
      BL_FBOUNDS(pgdnv)
      BL_FBOUNDS(div)
      BL_FBOUNDS(area)
      BL_FBOUNDS(vol)
      BL_BBOUNDS(bx)

      BL_FARRAY(s,nv)
      BL_FARRAY(flux,nv)
      BL_FARRAY1(pgdnv)
      BL_FARRAY1(div)
      BL_FARRAY1(area)
      BL_FARRAY1(vol)

      REAL_T dt
      REAL_T delta(SDIM)
      integer sweep, vnrml
      integer is, ie, js, je, i, j, iv, ivbc
      integer isflx, ieflx, jsflx, jeflx
      REAL_T dx, dy,trandiv, divuvs
      REAL_T avgarea
      REAL_T leftbc, rightbc

#include "xxmeth.fh"

      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      isflx = flux_l1
      ieflx = flux_h1
      jsflx = flux_l2
      jeflx = flux_h2

      dx = delta(1)
      dy = delta(2)

      if(sweep.eq.0)then
	vnrml = 2
      else
	print *,'Abort: bogus sweep value in UPDATEX'
	stop
      end if


c
c ::: add artifical viscosity and convert to extensive quantities
c

      do iv = 1, nv
      do j = jsflx,jeflx
        do i = isflx, ieflx

          trandiv = half*(div(i,j) + div(i,j+1))
          divuvs = difmag*dx*trandiv
          divuvs = min(zero,divuvs)
          flux(i,j, iv)= flux(i,j, iv) +
     $                  divuvs*(s(i,j, iv) - s(i-1,j,iv)) 

          flux(i,j,iv) = flux(i,j,iv)*dt*area(i,j)
        
        end do
      end do
      end do

c
c ::: conservsative update
c
 
      do iv = 1, nv
      do j = js, je
        do i = is, ie
          s(i,j,iv) = s(i,j,iv) + 
     $               (flux(i,j,iv) - flux(i+1,j,iv))/vol(i,j)
        end do
      end do
      end do


c
c ::: add pressure term to normal momnentum
c

      do j = js, je
        do i = is, ie
          avgarea = half*(area(i,j) + area(i+1,j))
          s(i,j,vnrml) = s(i,j,vnrml) + dt*avgarea*
     $                 (pgdnv(i,j) - pgdnv(i+1,j))/vol(i,j)
        end do
      end do

c
c ::: add pressure term to normal momnentum flux
c
      do j = jsflx,jeflx
        do i = isflx,ieflx
          flux(i,j,vnrml) = flux(i,j,vnrml) + dt*area(i,j)*pgdnv(i,j)
        end do
      end do

c     if(onBndry .eq. 1) then

#if 0
      do iv = 1,nv
c ::: left face
        ivbc = bc(1,1,iv)
        do j = js, je
          do i = is-2,is-1
          if (ivbc .eq. EXT_DIR) then
            s(i,j,iv) = leftbc 
          else if(ivbc .eq. FOEXTRAP .or. ivbc .eq. HOEXTRAP .or. 
     $         ivbc .eq. REFLECT_EVEN) then
            s(i,j,iv) = s(is,j,iv)
          else if(ivbc .eq. REFLECT_ODD) then
            s(i,j,iv) = -s(is,j,iv)
          end if
         end do
        end do
c ::: right face
        ivbc = bc(1,2,iv)
        do j = js-1, je+1
         do i = ie+1,ie+2
          if (ivbc .eq. EXT_DIR) then
            s(i,j,iv) = rightbc
          else if(ivbc .eq. FOEXTRAP .or. ivbc .eq. HOEXTRAP .or. 
     $         ivbc .eq. REFLECT_EVEN) then
            s(i,j,iv) = s(ie,j,iv)
          else if(ivbc .eq. REFLECT_ODD) then
            s(i,j,iv) = -s(ie,j,iv)
          end if
         end do
        end do

      end do
c     else
c     end if
#endif
      
      return
      end

c
c--------------------------------------------------------------
c     Conservative update and other final stuff -- y direction
c---------------------------------------------------------------
c


      subroutine FORT_UPDATEY(
     &  		BL_FARG(s),
     &                  BL_FARG(flux),
     &                  BL_FARG(pgdnv),
     &                  BL_FARG(div),
     &                  BL_FARG(area),
     &                  BL_FARG(vol),
     &                  BL_BARG(bx),
     &                  delta, dt, nv, sweep, bc, gBndry)
      integer nv, gBndry(0:SDIM*SDIM-1)
      integer bc(SDIM,2,nv)

      BL_FBOUNDS(s)                  
      BL_FBOUNDS(flux)
      BL_FBOUNDS(pgdnv)
      BL_FBOUNDS(div)
      BL_FBOUNDS(area)
      BL_FBOUNDS(vol)
      BL_BBOUNDS(bx)

      BL_FARRAY(s,nv)
      BL_FARRAY(flux,nv)
      BL_FARRAY1(pgdnv)
      BL_FARRAY1(div)
      BL_FARRAY1(area)
      BL_FARRAY1(vol)

      REAL_T dt
      REAL_T delta(SDIM)
      integer vnrml,sweep
      integer  is, ie, js, je, i, j, iv, ivbc
      integer isflx, ieflx, jsflx, jeflx
      REAL_T dx, dy,trandiv, divuvs
      REAL_T avgarea
      REAL_T botbc, topbc

#include "xxmeth.fh"

      if(sweep.eq.1)then
        vnrml = 3
      else
	print *,'Abort: bogus sweep value in UPDATEY'
	stop
      end if

      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      isflx = flux_l1
      ieflx = flux_h1
      jsflx = flux_l2
      jeflx = flux_h2

      dx = delta(1)
      dy = delta(2)

c
c ::: add artifical viscosity and convert to extensive quantities
c

      do iv = 1, nv
      do j = jsflx,jeflx
        do i = isflx,ieflx

          trandiv = half*(div(i,j) + div(i+1,j))
          divuvs = difmag*dx*trandiv
          divuvs = min(zero,divuvs)
          flux(i,j, iv)= flux(i,j, iv) +
     $                  divuvs*(s(i,j, iv) - s(i,j-1,iv)) 

          flux(i,j,iv) = flux(i,j,iv)*dt*area(i,j)
        
        end do
      end do
      end do

c
c ::: conservsative update
c
 
      do iv = 1, nv
      do j = js, je
        do i = is, ie
          s(i,j,iv) = s(i,j,iv) + 
     $               (flux(i,j,iv) - flux(i,j+1,iv))/vol(i,j)
        end do
      end do
      end do


c
c ::: add pressure term to normal momnentum
c

      do j = js, je
        do i = is, ie
          avgarea = half*(area(i,j) + area(i,j+1))
          s(i,j,vnrml) = s(i,j,vnrml) + dt*avgarea*
     $                 (pgdnv(i,j) - pgdnv(i,j+1))/vol(i,j)
        end do
      end do

c
c ::: add pressure term to normal momnentum flux
c
      do j = jsflx, jeflx
        do i = isflx, ieflx
          flux(i,j,vnrml) = flux(i,j,vnrml) + dt*area(i,j)*pgdnv(i,j)
        end do
      end do

c     if(onBndry .eq. 1) then

#if 0
      do iv = 1,nv
c ::: bottom face
        ivbc = bc(2,1,iv)
        do i = is, ie
         do j = js-2,js-1
          if (ivbc .eq. EXT_DIR) then
            s(i,j,iv) = botbc 
          else if(ivbc .eq. FOEXTRAP .or. ivbc .eq. HOEXTRAP .or. 
     $         ivbc .eq. REFLECT_EVEN) then
            s(i,j,iv) = s(i,js,iv)
          else if(ivbc .eq. REFLECT_ODD) then
            s(i,j,iv) = -s(i,js,iv)
          end if
        end do
        end do
c ::: top face
        ivbc = bc(2,2,iv)
        do i = is, ie
         do j = je+1,je+2
          if (ivbc .eq. EXT_DIR) then
            s(i,j,iv) = topbc
          else if(ivbc .eq. FOEXTRAP .or. ivbc .eq. HOEXTRAP .or. 
     $         ivbc .eq. REFLECT_EVEN) then
            s(i,j,iv) = s(i,je,iv)
          else if(ivbc .eq. REFLECT_ODD) then
            s(i,j,iv) = -s(i,je,iv)
          end if
        end do
      end do
      end do

c     else
c     end if

#endif
      return
      end


#if 1
      subroutine FORT_PRIMITIVES(
     &                  BL_FARG(s),
     &                  BL_FARG(q),
     &                  BL_FARG(p),
     &                  BL_FARG(c),
     &                  BL_FARG(csml),
     &                  BL_FARG(gamc),
     &                  BL_BARG(bx),
     &                  bc, ns, nq, sweep)
      integer ns, nq, sweep
      integer bc(SDIM,2,ns)

      BL_FBOUNDS(s)
      BL_FBOUNDS(q)
      BL_FBOUNDS(p)
      BL_FBOUNDS(c)
      BL_FBOUNDS(csml)
      BL_FBOUNDS(gamc)
      BL_BBOUNDS(bx)

      BL_FARRAY(s,ns)
      BL_FARRAY(q,nq)
        BL_FARRAY1(p)
        BL_FARRAY1(c)
        BL_FARRAY1(csml)
      BL_FARRAY1(gamc)

      integer is,ie,js,je,i,j
      REAL_T u,v,w,rho,e
      REAL_T gdum,cdum,csdum, reflect

#include "xxmeth.fh"

       is = bxlo(1)
       js = bxlo(2)
       ie = bxhi(1)
       je = bxhi(2)


       do j = js, je
        do i = is, ie

          rho = max(s(i,j,SRHO),smallr)
          u = s(i,j,SXMOM)/s(i,j,SRHO)
          v = s(i,j,SYMOM)/s(i,j,SRHO)
          e = s(i,j,SRHOE)/rho - half*(u**2 + v**2)
    
          q(i,j,QRHO) = rho       
          q(i,j,QVEL1) = u
          q(i,j,QVEL2) = v
          q(i,j,QRHOE) = e
#if(NADV>0)
          q(i,j,QADV) = S(i,j,SADV)/s(i,j,SRHO)
#endif
        
        enddo
       enddo


      call eos(q(BL_ARGL1(q),BL_ARGL2(q),QRHO),
     $         q(BL_ARGL1(q),BL_ARGL2(q),QRHOE),
     $         q(BL_ARGL1(q),BL_ARGL2(q),QADV),
     $         BL_IARG(q),
     $         gamc(BL_ARGL1(c),BL_ARGL2(c)),
     $         q(BL_ARGL1(c),BL_ARGL2(c),QPRES),
     $         c(BL_ARGL1(c),BL_ARGL2(c)),
     $         csml(BL_ARGL1(c),BL_ARGL2(c)),
     $         BL_IARG(c),
     $         bxlo,bxhi,1,1,1,1)
       do j = js, je
        do i = is, ie
          q(i,j,QPRES) = max(smallp,q(i,j,QPRES))
          p(i,j) = q(i,j,QPRES)
          q(i,j,QRHOE) = q(i,j,QRHOE)*q(i,j,QRHO)
c         c(i,j) = sqrt(gamc(i,j)*q(i,j,QPRES)/q(i,j,QRHO))
c         csml(i,j) = max(small,small*c(i,j))

        enddo
       enddo

      end
      
#else
      subroutine FORT_PRIMITIVES(
     &                  BL_FARG(s),
     &                  BL_FARG(q),
     &                  BL_FARG(p),
     &                  BL_FARG(c),
     &                  BL_FARG(csml),
     $			BL_FARG(gamc),
     &                  BL_BARG(bx),
     &                  bc, ns, nq, sweep)
      integer ns, nq, sweep
      integer bc(SDIM,2,ns)

      BL_FBOUNDS(s)        
      BL_FBOUNDS(q)        
      BL_FBOUNDS(p)        
      BL_FBOUNDS(c)        
      BL_FBOUNDS(csml)        
      BL_FBOUNDS(gamc)        
      BL_BBOUNDS(bx)

      BL_FARRAY(s,ns)
      BL_FARRAY(q,nq)
     	BL_FARRAY1(p)
     	BL_FARRAY1(c)
     	BL_FARRAY1(csml)
      BL_FARRAY1(gamc)

      integer is,ie,js,je,i,j
      REAL_T u,v,rho,e
      REAL_T gdum,cdum,csdum, reflect

#include "xxmeth.fh"

       is = bxlo(1)
       js = bxlo(2)
       ie = bxhi(1)
       je = bxhi(2)

      do j = js, je
        do i = is, ie

          rho = max(s(i,j,SRHO),smallr)
          u = s(i,j,SXMOM)/rho
          v = s(i,j,SYMOM)/rho
          e = s(i,j,SRHOE)/rho - half*(u**2 + v**2)
    
          q(i,j,QRHO) = rho
          q(i,j,QVEL1) = u
          q(i,j,QVEL2) = v
          q(i,j,QRHOE) = e
        
        end do
      end do


      call eos(q(is,js,QRHO),q(is,js,QRHOE),
     $         gamc(is,js),q(is,js,QPRES),cdum,csdum,
     $         bxlo,bxhi,1,1,0,0)

      do j = js, je
        do i = is, ie
	  q(i,j,QPRES) = max(smallp,q(i,j,QPRES))
	  p(i,j) = q(i,j,QPRES)
          q(i,j,QRHOE) = q(i,j,QRHOE)*q(i,j,QRHO)
c	  c(i,j) = sqrt(gamc(i,j)*q(i,j,QPRES)/q(i,j,QRHO))
c	  csml(i,j) = max(small,small*c(i,j))
        end do
      end do

      return
      end
#endif

c-----------------------------------------------------------------------
      subroutine bl_error(str)
      character*(*) str
      integer NSTR
      parameter (NSTR = 128)
      integer istr(NSTR)
      call blstr2int(istr, NSTR, str)
      call bl_error_cpp(istr, NSTR)
      end
c-----------------------------------------------------------------------
      subroutine bl_warning(str)
      character*(*) str
      integer NSTR
      parameter (NSTR = 128)
      integer istr(NSTR)
      call blstr2int(istr, NSTR, str)
      call bl_warning_cpp(istr, NSTR)
      end
c-----------------------------------------------------------------------
      subroutine bl_abort(str)
      character*(*) str
      integer NSTR
      parameter (NSTR = 128)
      integer istr(NSTR)
      call blstr2int(istr, NSTR, str)
      call bl_abort_cpp(istr, NSTR)
      end

c twenty-seven point terrain version:

c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along face
      subroutine hgfres_terrain(
     & res,    resl0,resh0,resl1,resh1,resl2,resh2,
     & src,    srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & fdst,   fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2,
     & cdst,   cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2,
     & sigmaf, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & sigmac, scl0,sch0,scl1,sch1,scl2,sch2,
     &         regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz, ir, jr, kr, idim, idir)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2
      integer cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision hx, hy, hz
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1,fdstl2:fdsth2)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1,cdstl2:cdsth2)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2, 5)
      double precision sigmac(scl0:sch0,scl1:sch1,scl2:sch2, 5)
      integer ir, jr, kr, idim, idir
      double precision fac00, fac0, fac1, fac2, tmp, cen
      integer i, j, k, is, js, ks, l, m, n
      integer ii, jj, kk, i1, j1, k1
      double precision MXXC, MYYC, MZZC, MXZC, MYZC
      double precision MXXF, MYYF, MZZF, MXZF, MYZF

      MXXC(ii,jj,kk) = (4.0D0 *  cdst(ii,j,k)   +
     &                   2.0D0 * (cdst(ii,jj,k)  - cdst(i,jj,k) +
     &                           cdst(ii,j,kk)  - cdst(i,j,kk)) +
     &                          (cdst(ii,jj,kk) - cdst(i,jj,kk)))

      MYYC(ii,jj,kk) = (4.0D0 *  cdst(i,jj,k)   +
     &                   2.0D0 * (cdst(ii,jj,k)  - cdst(ii,j,k) +
     &                           cdst(i,jj,kk)  - cdst(i,j,kk)) +
     &                          (cdst(ii,jj,kk) - cdst(ii,j,kk)))

      MZZC(ii,jj,kk) = (4.0D0 *  cdst(i,j,kk)   +
     &                   2.0D0 * (cdst(ii,j,kk)  - cdst(ii,j,k) +
     &                           cdst(i,jj,kk)  - cdst(i,jj,k)) +
     &                          (cdst(ii,jj,kk) - cdst(ii,jj,k)))

      MXZC(ii,jj,kk) = (6.0D0 *  cdst(ii,j,kk)  +
     &                   3.0D0 * (cdst(ii,jj,kk) - cdst(i,jj,k)))

      MYZC(ii,jj,kk) = (6.0D0 *  cdst(i,jj,kk)  +
     &                   3.0D0 * (cdst(ii,jj,kk) - cdst(ii,j,k)))

      MXXF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(ii,j1,k1)   +
     &                       2.0D0 * (fdst(ii,jj,k1) - fdst(i1,jj,k1) +
     &                                fdst(ii,j1,kk) - fdst(i1,j1,kk)) +
     &                                (fdst(ii,jj,kk) - fdst(i1,jj,kk)))

      MYYF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(i1,jj,k1)   +
     &                       2.0D0 * (fdst(ii,jj,k1) - fdst(ii,j1,k1) +
     &                                fdst(i1,jj,kk) - fdst(i1,j1,kk)) +
     &                                (fdst(ii,jj,kk) - fdst(ii,j1,kk)))

      MZZF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(i1,j1,kk)   +
     &                       2.0D0 * (fdst(ii,j1,kk) - fdst(ii,j1,k1) +
     &                                fdst(i1,jj,kk) - fdst(i1,jj,k1)) +
     &                                (fdst(ii,jj,kk) - fdst(ii,jj,k1)))

      MXZF(i1,j1,k1,ii,jj,kk) = (6.0D0 *  fdst(ii,j1,kk)  +
     &                        3.0D0 * (fdst(ii,jj,kk) - fdst(i1,jj,k1)))

      MYZF(i1,j1,k1,ii,jj,kk) = (6.0D0 *  fdst(i1,jj,kk)  +
     &                        3.0D0 * (fdst(ii,jj,kk) - fdst(ii,j1,k1)))


      fac00 = 1.0D0 / 36

      if (idim .eq. 0) then
         i = regl0
         if (idir .eq. 1) then
            is = i - 1
         else
            is = i
         end if
         do k = regl2, regh2
            do j = regl1, regh1

                  tmp = sigmac(is ,j-1,k-1,1) * MXXC(i-idir,j-1,k-1)
     &                 +sigmac(is ,j-1,k  ,1) * MXXC(i-idir,j-1,k+1)
     &                 +sigmac(is ,j  ,k-1,1) * MXXC(i-idir,j+1,k-1)
     &                 +sigmac(is ,j  ,k  ,1) * MXXC(i-idir,j+1,k+1)
                  tmp = tmp
     &                 +sigmac(is ,j-1,k-1,2) * MYYC(i-idir,j-1,k-1)
     &                 +sigmac(is ,j-1,k  ,2) * MYYC(i-idir,j-1,k+1)
     &                 +sigmac(is ,j  ,k-1,2) * MYYC(i-idir,j+1,k-1)
     &                 +sigmac(is ,j  ,k  ,2) * MYYC(i-idir,j+1,k+1)
                  tmp = tmp
     &                 +sigmac(is ,j-1,k-1,3) * MZZC(i-idir,j-1,k-1)
     &                 +sigmac(is ,j-1,k  ,3) * MZZC(i-idir,j-1,k+1)
     &                 +sigmac(is ,j  ,k-1,3) * MZZC(i-idir,j+1,k-1)
     &                 +sigmac(is ,j  ,k  ,3) * MZZC(i-idir,j+1,k+1)
                  tmp = tmp + idir * (
     &                 -sigmac(is ,j-1,k-1,4) * MXZC(i-idir,j-1,k-1)
     &                 +sigmac(is ,j-1,k  ,4) * MXZC(i-idir,j-1,k+1)
     &                 -sigmac(is ,j  ,k-1,4) * MXZC(i-idir,j+1,k-1)
     &                 +sigmac(is ,j  ,k  ,4) * MXZC(i-idir,j+1,k+1) )
                  tmp = tmp
     &                 -sigmac(is ,j-1,k-1,5) * MYZC(i-idir,j-1,k-1)
     &                 +sigmac(is ,j-1,k  ,5) * MYZC(i-idir,j-1,k+1)
     &                 +sigmac(is ,j  ,k-1,5) * MYZC(i-idir,j+1,k-1)
     &                 -sigmac(is ,j  ,k  ,5) * MYZC(i-idir,j+1,k+1)

              cen        =
     &            4.0D0 * ( sigmac(is,j-1,k-1,1) + sigmac(is,j-1,k,1)
     &                    +sigmac(is,j  ,k-1,1) + sigmac(is,j  ,k,1)
     &                    +sigmac(is,j-1,k-1,2) + sigmac(is,j-1,k,2)
     &                    +sigmac(is,j  ,k-1,2) + sigmac(is,j  ,k,2)
     &                    +sigmac(is,j-1,k-1,3) + sigmac(is,j-1,k,3)
     &                    +sigmac(is,j  ,k-1,3) + sigmac(is,j  ,k,3))
     &   + idir * 6.0D0 * (-sigmac(is,j-1,k-1,4) + sigmac(is,j-1,k,4)
     &                    -sigmac(is,j  ,k-1,4) + sigmac(is,j  ,k,4))
     &          + 6.0D0 * ( sigmac(is,j-1,k  ,5) - sigmac(is,j-1,k-1,5)
     &                    +sigmac(is,j  ,k-1,5) - sigmac(is,j  ,k,5))

               res(i*ir,j*jr,k*kr) =
     &          src(i*ir,j*jr,k*kr) - fac00 * (tmp - cen * cdst(i,j,k))
            end do
         end do

         fac0 = fac00 / (jr * kr)
         i = i * ir
         if (idir .eq. 1) then
            is = i
         else
            is = i - 1
         end if
         do l = -(kr-1), kr-1
            fac2 = (kr-abs(l)) * fac0
            do n = -(jr-1), jr-1
               fac1 = (jr-abs(n)) * fac2
               do k = kr*regl2, kr*regh2, kr
                  do j = jr*regl1, jr*regh1, jr

            tmp = sigmaf(is,j+n-1,k+l-1,1)
     &                * MXXF(i,j+n,k+l,i+idir,j+n-1,k+l-1)
     &           +sigmaf(is,j+n-1,k+l  ,1)
     &                * MXXF(i,j+n,k+l,i+idir,j+n-1,k+l+1)
     &           +sigmaf(is,j+n  ,k+l-1,1)
     &                * MXXF(i,j+n,k+l,i+idir,j+n+1,k+l-1)
     &           +sigmaf(is,j+n  ,k+l  ,1)
     &                * MXXF(i,j+n,k+l,i+idir,j+n+1,k+l+1)
            tmp = tmp
     &           +sigmaf(is,j+n-1,k+l-1,2)
     &                * MYYF(i,j+n,k+l,i+idir,j+n-1,k+l-1)
     &           +sigmaf(is,j+n-1,k+l  ,2)
     &                * MYYF(i,j+n,k+l,i+idir,j+n-1,k+l+1)
     &           +sigmaf(is,j+n  ,k+l-1,2)
     &                * MYYF(i,j+n,k+l,i+idir,j+n+1,k+l-1)
     &           +sigmaf(is,j+n  ,k+l  ,2)
     &                * MYYF(i,j+n,k+l,i+idir,j+n+1,k+l+1)
            tmp = tmp
     &           +sigmaf(is,j+n-1,k+l-1,3)
     &                * MZZF(i,j+n,k+l,i+idir,j+n-1,k+l-1)
     &           +sigmaf(is,j+n-1,k+l  ,3)
     &                * MZZF(i,j+n,k+l,i+idir,j+n-1,k+l+1)
     &           +sigmaf(is,j+n  ,k+l-1,3)
     &                * MZZF(i,j+n,k+l,i+idir,j+n+1,k+l-1)
     &           +sigmaf(is,j+n  ,k+l  ,3)
     &                * MZZF(i,j+n,k+l,i+idir,j+n+1,k+l+1)
            tmp = tmp + idir * (
     &            sigmaf(is,j+n-1,k+l-1,4)
     &                * MXZF(i,j+n,k+l,i+idir,j+n-1,k+l-1)
     &           -sigmaf(is,j+n-1,k+l  ,4)
     &                * MXZF(i,j+n,k+l,i+idir,j+n-1,k+l+1)
     &           +sigmaf(is,j+n  ,k+l-1,4)
     &                * MXZF(i,j+n,k+l,i+idir,j+n+1,k+l-1)
     &           -sigmaf(is,j+n  ,k+l  ,4)
     &                * MXZF(i,j+n,k+l,i+idir,j+n+1,k+l+1))
            tmp = tmp
     &           -sigmaf(is,j+n-1,k+l-1,5)
     &                * MYZF(i,j+n,k+l,i+idir,j+n-1,k+l-1)
     &           +sigmaf(is,j+n-1,k+l  ,5)
     &                * MYZF(i,j+n,k+l,i+idir,j+n-1,k+l+1)
     &           +sigmaf(is,j+n  ,k+l-1,5)
     &                * MYZF(i,j+n,k+l,i+idir,j+n+1,k+l-1)
     &           -sigmaf(is,j+n  ,k+l  ,5)
     &                * MYZF(i,j+n,k+l,i+idir,j+n+1,k+l+1)

            cen =
     &       4.0D0 *(sigmaf(is,j+n-1,k+l-1,1) + sigmaf(is,j+n-1,k+l  ,1)
     &             +sigmaf(is,j+n  ,k+l-1,1) + sigmaf(is,j+n  ,k+l  ,1)
     &             +sigmaf(is,j+n-1,k+l-1,2) + sigmaf(is,j+n-1,k+l  ,2)
     &             +sigmaf(is,j+n  ,k+l-1,2) + sigmaf(is,j+n  ,k+l  ,2)
     &             +sigmaf(is,j+n-1,k+l-1,3) + sigmaf(is,j+n-1,k+l  ,3)
     &             +sigmaf(is,j+n  ,k+l-1,3) + sigmaf(is,j+n  ,k+l  ,3))
     &     + idir *
     &      6.0D0 *(-sigmaf(is,j+n-1,k+l  ,4) + sigmaf(is,j+n-1,k+l-1,4)
     &             -sigmaf(is,j+n  ,k+l  ,4) + sigmaf(is,j+n  ,k+l-1,4))
     &    + 6.0D0 *( sigmaf(is,j+n-1,k+l  ,5) - sigmaf(is,j+n-1,k+l-1,5)
     &             +sigmaf(is,j+n  ,k+l-1,5) - sigmaf(is,j+n  ,k+l  ,5))

             res(i,j,k) = res(i,j,k)
     &            - fac1 * (tmp - cen * fdst(i,j+n,k+l))
                  end do
               end do
            end do
         end do

      else if (idim .eq. 1) then
         j = regl1
         if (idir .eq. 1) then
            js = j - 1
         else
            js = j
         end if
         do k = regl2, regh2
            do i = regl0, regh0

                  tmp = sigmac(i-1,js,k-1,1) * MXXC(i-1,j-idir,k-1)
     &                 +sigmac(i-1,js,k  ,1) * MXXC(i-1,j-idir,k+1)
     &                 +sigmac(i  ,js,k-1,1) * MXXC(i+1,j-idir,k-1)
     &                 +sigmac(i  ,js,k  ,1) * MXXC(i+1,j-idir,k+1)
                  tmp = tmp
     &                 +sigmac(i-1,js,k-1,2) * MYYC(i-1,j-idir,k-1)
     &                 +sigmac(i-1,js,k  ,2) * MYYC(i-1,j-idir,k+1)
     &                 +sigmac(i  ,js,k-1,2) * MYYC(i+1,j-idir,k-1)
     &                 +sigmac(i  ,js,k  ,2) * MYYC(i+1,j-idir,k+1)
                  tmp = tmp
     &                 +sigmac(i-1,js,k-1,3) * MZZC(i-1,j-idir,k-1)
     &                 +sigmac(i-1,js,k  ,3) * MZZC(i-1,j-idir,k+1)
     &                 +sigmac(i  ,js,k-1,3) * MZZC(i+1,j-idir,k-1)
     &                 +sigmac(i  ,js,k  ,3) * MZZC(i+1,j-idir,k+1)
                  tmp = tmp
     &                 -sigmac(i-1,js,k-1,4) * MXZC(i-1,j-idir,k-1)
     &                 +sigmac(i-1,js,k  ,4) * MXZC(i-1,j-idir,k+1)
     &                 +sigmac(i  ,js,k-1,4) * MXZC(i+1,j-idir,k-1)
     &                 -sigmac(i  ,js,k  ,4) * MXZC(i+1,j-idir,k+1)
                  tmp = tmp + idir * (
     &                 -sigmac(i-1,js,k-1,5) * MYZC(i-1,j-idir,k-1)
     &                 +sigmac(i-1,js,k  ,5) * MYZC(i-1,j-idir,k+1)
     &                 -sigmac(i  ,js,k-1,5) * MYZC(i+1,j-idir,k-1)
     &                 +sigmac(i  ,js,k  ,5) * MYZC(i+1,j-idir,k+1) )

               cen =
     &            4.0D0 * (sigmac(i-1,js,k-1,1) + sigmac(i-1,js,k,1)
     &                   +sigmac(i  ,js,k-1,1) + sigmac(i  ,js,k,1)
     &                   +sigmac(i-1,js,k-1,2) + sigmac(i-1,js,k,2)
     &                   +sigmac(i  ,js,k-1,2) + sigmac(i  ,js,k,2)
     &                   +sigmac(i-1,js,k-1,3) + sigmac(i-1,js,k,3)
     &                   +sigmac(i  ,js,k-1,3) + sigmac(i  ,js,k,3))
     &          + 6.0D0 * (sigmac(i-1,js,k  ,4) - sigmac(i-1,js,k-1,4)
     &                   +sigmac(i  ,js,k-1,4) - sigmac(i  ,js,k  ,4))
     &   + idir * 6.0D0 * (-sigmac(i-1,js,k-1,5) + sigmac(i-1,js,k,5)
     &                    -sigmac(i  ,js,k-1,5) + sigmac(i  ,js,k,5))

               res(i*ir,j*jr,k*kr) =
     &          src(i*ir,j*jr,k*kr) - fac00 * (tmp - cen * cdst(i,j,k))
            end do
         end do

         fac0 = fac00 / (ir * kr)
         j = j * jr
         if (idir .eq. 1) then
            js = j
         else
            js = j - 1
         end if
         do l = -(kr-1), kr-1
            fac2 = (kr-abs(l)) * fac0
            do m = -(ir-1), ir-1
               fac1 = (ir-abs(m)) * fac2
               do k = kr*regl2, kr*regh2, kr
                  do i = ir*regl0, ir*regh0, ir

            tmp = sigmaf(i+m-1,js,k+l-1,1)
     &                    * MXXF(i+m,j,k+l,i+m-1,j+idir,k+l-1)
     &           +sigmaf(i+m-1,js,k+l  ,1)
     &                    * MXXF(i+m,j,k+l,i+m-1,j+idir,k+l+1)
     &           +sigmaf(i+m  ,js,k+l-1,1)
     &                    * MXXF(i+m,j,k+l,i+m+1,j+idir,k+l-1)
     &           +sigmaf(i+m  ,js,k+l  ,1)
     &                    * MXXF(i+m,j,k+l,i+m+1,j+idir,k+l+1)
            tmp = tmp
     &           +sigmaf(i+m-1,js,k+l-1,2)
     &                    * MYYF(i+m,j,k+l,i+m-1,j+idir,k+l-1)
     &           +sigmaf(i+m-1,js,k+l  ,2)
     &                    * MYYF(i+m,j,k+l,i+m-1,j+idir,k+l+1)
     &           +sigmaf(i+m  ,js,k+l-1,2)
     &                    * MYYF(i+m,j,k+l,i+m+1,j+idir,k+l-1)
     &           +sigmaf(i+m  ,js,k+l  ,2)
     &                    * MYYF(i+m,j,k+l,i+m+1,j+idir,k+l+1)
            tmp = tmp
     &           +sigmaf(i+m-1,js,k+l-1,3)
     &                    * MZZF(i+m,j,k+l,i+m-1,j+idir,k+l-1)
     &           +sigmaf(i+m-1,js,k+l  ,3)
     &                    * MZZF(i+m,j,k+l,i+m-1,j+idir,k+l+1)
     &           +sigmaf(i+m  ,js,k+l-1,3)
     &                    * MZZF(i+m,j,k+l,i+m+1,j+idir,k+l-1)
     &           +sigmaf(i+m  ,js,k+l  ,3)
     &                    * MZZF(i+m,j,k+l,i+m+1,j+idir,k+l+1)
            tmp = tmp
     &           -sigmaf(i+m-1,js,k+l-1,4)
     &                    * MXZF(i+m,j,k+l,i+m-1,j+idir,k+l-1)
     &           +sigmaf(i+m-1,js,k+l  ,4)
     &                    * MXZF(i+m,j,k+l,i+m-1,j+idir,k+l+1)
     &           +sigmaf(i+m  ,js,k+l-1,4)
     &                    * MXZF(i+m,j,k+l,i+m+1,j+idir,k+l-1)
     &           -sigmaf(i+m  ,js,k+l  ,4)
     &                    * MXZF(i+m,j,k+l,i+m+1,j+idir,k+l+1)
            tmp = tmp + idir * (
     &            sigmaf(i+m-1,js,k+l-1,5)
     &                    * MYZF(i+m,j,k+l,i+m-1,j+idir,k+l-1)
     &           -sigmaf(i+m-1,js,k+l  ,5)
     &                    * MYZF(i+m,j,k+l,i+m-1,j+idir,k+l+1)
     &           +sigmaf(i+m  ,js,k+l-1,5)
     &                    * MYZF(i+m,j,k+l,i+m+1,j+idir,k+l-1)
     &           -sigmaf(i+m  ,js,k+l  ,5)
     &                    * MYZF(i+m,j,k+l,i+m+1,j+idir,k+l+1))

         cen =
     &    4.0D0 * (sigmaf(i+m-1,js,k+l-1,1) + sigmaf(i+m-1,js,k+l  ,1)
     &           +sigmaf(i+m  ,js,k+l-1,1) + sigmaf(i+m  ,js,k+l  ,1)
     &           +sigmaf(i+m-1,js,k+l-1,2) + sigmaf(i+m-1,js,k+l  ,2)
     &           +sigmaf(i+m  ,js,k+l-1,2) + sigmaf(i+m  ,js,k+l  ,2)
     &           +sigmaf(i+m-1,js,k+l-1,3) + sigmaf(i+m-1,js,k+l  ,3)
     &           +sigmaf(i+m  ,js,k+l-1,3) + sigmaf(i+m  ,js,k+l  ,3))
     &   +6.0D0 * (sigmaf(i+m-1,js,k+l  ,4) - sigmaf(i+m-1,js,k+l-1,4)
     &           +sigmaf(i+m  ,js,k+l-1,4) - sigmaf(i+m  ,js,k+l  ,4))
     &   + idir *
     &    6.0D0 * (-sigmaf(i+m-1,js,k+l  ,5) + sigmaf(i+m-1,js,k+l-1,5)
     &            -sigmaf(i+m  ,js,k+l  ,5) + sigmaf(i+m  ,js,k+l-1,5))

          res(i,j,k) = res(i,j,k) - fac1 * (tmp - cen * fdst(i+m,j,k+l))
                  end do
               end do
            end do
         end do
      else
         k = regl2
         if (idir .eq. 1) then
            ks = k - 1
         else
            ks = k
         end if
         do j = regl1, regh1
            do i = regl0, regh0

                  tmp = sigmac(i-1,j-1,ks,1) * MXXC(i-1,j-1,k-idir)
     &                 +sigmac(i-1,j  ,ks,1) * MXXC(i-1,j+1,k-idir)
     &                 +sigmac(i  ,j-1,ks,1) * MXXC(i+1,j-1,k-idir)
     &                 +sigmac(i  ,j  ,ks,1) * MXXC(i+1,j+1,k-idir)
                  tmp = tmp
     &                 +sigmac(i-1,j-1,ks,2) * MYYC(i-1,j-1,k-idir)
     &                 +sigmac(i-1,j  ,ks,2) * MYYC(i-1,j+1,k-idir)
     &                 +sigmac(i  ,j-1,ks,2) * MYYC(i+1,j-1,k-idir)
     &                 +sigmac(i  ,j  ,ks,2) * MYYC(i+1,j+1,k-idir)
                  tmp = tmp
     &                 +sigmac(i-1,j-1,ks,3) * MZZC(i-1,j-1,k-idir)
     &                 +sigmac(i-1,j  ,ks,3) * MZZC(i-1,j+1,k-idir)
     &                 +sigmac(i  ,j-1,ks,3) * MZZC(i+1,j-1,k-idir)
     &                 +sigmac(i  ,j  ,ks,3) * MZZC(i+1,j+1,k-idir)
                  tmp = tmp + idir * (
     &                 -sigmac(i-1,j-1,ks,4) * MXZC(i-1,j-1,k-idir)
     &                 -sigmac(i-1,j  ,ks,4) * MXZC(i-1,j+1,k-idir)
     &                 +sigmac(i  ,j-1,ks,4) * MXZC(i+1,j-1,k-idir)
     &                 +sigmac(i  ,j  ,ks,4) * MXZC(i+1,j+1,k-idir) )
                  tmp = tmp + idir * (
     &                 -sigmac(i-1,j-1,ks,5) * MYZC(i-1,j-1,k-idir)
     &                 +sigmac(i-1,j  ,ks,5) * MYZC(i-1,j+1,k-idir)
     &                 -sigmac(i  ,j-1,ks,5) * MYZC(i+1,j-1,k-idir)
     &                 +sigmac(i  ,j  ,ks,5) * MYZC(i+1,j+1,k-idir) )

               cen =
     &            4.0D0 * ( sigmac(i-1,j-1,ks,1)
     &                    +sigmac(i-1,j  ,ks,1)
     &                    +sigmac(i  ,j-1,ks,1)
     &                    +sigmac(i  ,j  ,ks,1)
     &                    +sigmac(i-1,j-1,ks,2)
     &                    +sigmac(i-1,j  ,ks,2)
     &                    +sigmac(i  ,j-1,ks,2)
     &                    +sigmac(i  ,j  ,ks,2)
     &                    +sigmac(i-1,j-1,ks,3)
     &                    +sigmac(i-1,j  ,ks,3)
     &                    +sigmac(i  ,j-1,ks,3)
     &                    +sigmac(i  ,j  ,ks,3))
     &   + idir * 6.0D0 * (-sigmac(i-1,j-1,ks,4)
     &                    -sigmac(i-1,j  ,ks,4)
     &                    +sigmac(i  ,j-1,ks,4)
     &                    +sigmac(i  ,j  ,ks,4) )
     &   + idir * 6.0D0 * (-sigmac(i-1,j-1,ks,5)
     &                    +sigmac(i-1,j,ks,5)
     &                    -sigmac(i  ,j-1,ks,5)
     &                    +sigmac(i  ,j,ks,5))

               res(i*ir,j*jr,k*kr) =
     &          src(i*ir,j*jr,k*kr) - fac00 * (tmp - cen * cdst(i,j,k))
            end do
         end do

         fac0 = fac00 / (ir * jr)
         k = k * kr
         if (idir .eq. 1) then
            ks = k
         else
            ks = k - 1
         end if
         do n = -(jr-1), jr-1
            fac2 = (jr-abs(n)) * fac0
            do m = -(ir-1), ir-1
               fac1 = (ir-abs(m)) * fac2
               do j = jr*regl1, jr*regh1, jr
                  do i = ir*regl0, ir*regh0, ir

            tmp = sigmaf(i+m-1,j+n-1,ks,1)
     &                * MXXF(i+m,j+n,k,i+m-1,j+n-1,k+idir)
     &           +sigmaf(i+m-1,j+n  ,ks,1)
     &                * MXXF(i+m,j+n,k,i+m-1,j+n+1,k+idir)
     &           +sigmaf(i+m  ,j+n-1,ks,1)
     &                * MXXF(i+m,j+n,k,i+m+1,j+n-1,k+idir)
     &           +sigmaf(i+m  ,j+n  ,ks,1)
     &                * MXXF(i+m,j+n,k,i+m+1,j+n+1,k+idir)
            tmp = tmp
     &           +sigmaf(i+m-1,j+n-1,ks,2)
     &                * MYYF(i+m,j+n,k,i+m-1,j+n-1,k+idir)
     &           +sigmaf(i+m-1,j+n  ,ks,2)
     &                * MYYF(i+m,j+n,k,i+m-1,j+n+1,k+idir)
     &           +sigmaf(i+m  ,j+n-1,ks,2)
     &                * MYYF(i+m,j+n,k,i+m+1,j+n-1,k+idir)
     &           +sigmaf(i+m  ,j+n  ,ks,2)
     &                * MYYF(i+m,j+n,k,i+m+1,j+n+1,k+idir)
            tmp = tmp
     &           +sigmaf(i+m-1,j+n-1,ks,3)
     &                * MZZF(i+m,j+n,k,i+m-1,j+n-1,k+idir)
     &           +sigmaf(i+m-1,j+n  ,ks,3)
     &                * MZZF(i+m,j+n,k,i+m-1,j+n+1,k+idir)
     &           +sigmaf(i+m  ,j+n-1,ks,3)
     &                * MZZF(i+m,j+n,k,i+m+1,j+n-1,k+idir)
     &           +sigmaf(i+m  ,j+n  ,ks,3)
     &                * MZZF(i+m,j+n,k,i+m+1,j+n+1,k+idir)
            tmp = tmp + idir * (
     &            sigmaf(i+m-1,j+n-1,ks,4)
     &                * MXZF(i+m,j+n,k,i+m-1,j+n-1,k+idir)
     &           +sigmaf(i+m-1,j+n  ,ks,4)
     &                * MXZF(i+m,j+n,k,i+m-1,j+n+1,k+idir)
     &           -sigmaf(i+m  ,j+n-1,ks,4)
     &                * MXZF(i+m,j+n,k,i+m+1,j+n-1,k+idir)
     &           -sigmaf(i+m  ,j+n  ,ks,4)
     &                * MXZF(i+m,j+n,k,i+m+1,j+n+1,k+idir))
            tmp = tmp + idir * (
     &            sigmaf(i+m-1,j+n-1,ks,5)
     &                * MYZF(i+m,j+n,k,i+m-1,j+n-1,k+idir)
     &           -sigmaf(i+m-1,j+n  ,ks,5)
     &                * MYZF(i+m,j+n,k,i+m-1,j+n+1,k+idir)
     &           +sigmaf(i+m  ,j+n-1,ks,5)
     &                * MYZF(i+m,j+n,k,i+m+1,j+n-1,k+idir)
     &           -sigmaf(i+m  ,j+n  ,ks,5)
     &                * MYZF(i+m,j+n,k,i+m+1,j+n+1,k+idir))

         cen =
     &      4.0D0 * (sigmaf(i+m-1,j+n-1,ks,1)
     &             +sigmaf(i+m-1,j+n  ,ks,1)
     &             +sigmaf(i+m  ,j+n-1,ks,1)
     &             +sigmaf(i+m  ,j+n  ,ks,1)
     &             +sigmaf(i+m-1,j+n-1,ks,2)
     &             +sigmaf(i+m-1,j+n  ,ks,2)
     &             +sigmaf(i+m  ,j+n-1,ks,2)
     &             +sigmaf(i+m  ,j+n  ,ks,2)
     &             +sigmaf(i+m-1,j+n-1,ks,3)
     &             +sigmaf(i+m-1,j+n  ,ks,3)
     &             +sigmaf(i+m  ,j+n-1,ks,3)
     &             +sigmaf(i+m  ,j+n  ,ks,3))
     &    + idir *
     &      6.0D0 * (sigmaf(i+m-1,j+n-1,ks,4)
     &             +sigmaf(i+m-1,j+n  ,ks,4)
     &             -sigmaf(i+m  ,j+n-1,ks,4)
     &             -sigmaf(i+m  ,j+n  ,ks,4))
     &    + idir *
     &      6.0D0 * (sigmaf(i+m-1,j+n-1,ks,5)
     &             -sigmaf(i+m-1,j+n  ,ks,5)
     &             +sigmaf(i+m  ,j+n-1,ks,5)
     &             -sigmaf(i+m  ,j+n  ,ks,5))

          res(i,j,k) = res(i,j,k) - fac1 * (tmp - cen * fdst(i+m,j+n,k))
                  end do
               end do
            end do
         end do

      end if
      end
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along face
      subroutine hgeres_terrain(
     & res,    resl0,resh0,resl1,resh1,resl2,resh2,
     & src,    srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & fdst,   fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2,
     & cdst,   cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2,
     & sigmaf, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & sigmac, scl0,sch0,scl1,sch1,scl2,sch2,
     &         regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz, ir, jr, kr, ga, ivect)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2
      integer cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision hx, hy, hz
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1,fdstl2:fdsth2)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1,cdstl2:cdsth2)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2,5)
      double precision sigmac(scl0:sch0,scl1:sch1,scl2:sch2,5)
      integer ir, jr, kr, ivect(0:2), ga(0:1,0:1,0:1)
      double precision fac00, fac0, fac1, fac, tmp, cen
      integer ic, jc, kc, if, jf, kf, ji, ki, idir, jdir, kdir
      integer l, m, n
      integer i1, j1, k1, ii, jj, kk
      double precision MXXC, MYYC, MZZC, MXZC, MYZC
      double precision MXXF, MYYF, MZZF, MXZF, MYZF
      MXXC(ii,jj,kk) = (4.0D0 *  cdst(ii,jc,kc) +
     &                   2.0D0 * (cdst(ii,jj,kc) - cdst(ic,jj,kc) +
     &                           cdst(ii,jc,kk) - cdst(ic,jc,kk)) +
     &                          (cdst(ii,jj,kk) - cdst(ic,jj,kk)))

      MYYC(ii,jj,kk) = (4.0D0 *  cdst(ic,jj,kc) +
     &                   2.0D0 * (cdst(ii,jj,kc) - cdst(ii,jc,kc) +
     &                           cdst(ic,jj,kk) - cdst(ic,jc,kk)) +
     &                          (cdst(ii,jj,kk) - cdst(ii,jc,kk)))

      MZZC(ii,jj,kk) = (4.0D0 *  cdst(ic,jc,kk) +
     &                   2.0D0 * (cdst(ii,jc,kk) - cdst(ii,jc,kc) +
     &                           cdst(ic,jj,kk) - cdst(ic,jj,kc)) +
     &                          (cdst(ii,jj,kk) - cdst(ii,jj,kc)))

      MXZC(ii,jj,kk) = (6.0D0 *  cdst(ii,jc,kk) +
     &                   3.0D0 * (cdst(ii,jj,kk) - cdst(ic,jj,kc)))

      MYZC(ii,jj,kk) = (6.0D0 *  cdst(ic,jj,kk) +
     &                   3.0D0 * (cdst(ii,jj,kk) - cdst(ii,jc,kc)))

      MXXF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(ii,j1,k1)   +
     &                        2.0D0 * (fdst(ii,jj,k1) - fdst(i1,jj,k1) +
     &                                fdst(ii,j1,kk) - fdst(i1,j1,kk)) +
     &                                (fdst(ii,jj,kk) - fdst(i1,jj,kk)))

      MYYF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(i1,jj,k1)   +
     &                        2.0D0 * (fdst(ii,jj,k1) - fdst(ii,j1,k1) +
     &                                fdst(i1,jj,kk) - fdst(i1,j1,kk)) +
     &                                (fdst(ii,jj,kk) - fdst(ii,j1,kk)))

      MZZF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(i1,j1,kk)   +
     &                        2.0D0 * (fdst(ii,j1,kk) - fdst(ii,j1,k1) +
     &                                fdst(i1,jj,kk) - fdst(i1,jj,k1)) +
     &                                (fdst(ii,jj,kk) - fdst(ii,jj,k1)))

      MXZF(i1,j1,k1,ii,jj,kk) = (6.0D0 *  fdst(ii,j1,kk)  +
     &                        3.0D0 * (fdst(ii,jj,kk) - fdst(i1,jj,k1)))

      MYZF(i1,j1,k1,ii,jj,kk) = (6.0D0 *  fdst(i1,jj,kk)  +
     &                        3.0D0 * (fdst(ii,jj,kk) - fdst(ii,j1,k1)))


      ic = regl0
      jc = regl1
      kc = regl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr

      fac00 = 1.0D0 / 36

      if (ivect(0) .eq. 0) then
         do if = ir*regl0, ir*regh0, ir
            res(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac0 = 1.0D0 / ir
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) .eq. 1) then
                  do m = -(ir-1), ir-1
                     fac = (ir-abs(m)) * fac0
                     do if = ir*regl0, ir*regh0, ir

                  tmp = sigmaf(if+m-1,jf+ji-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+ji-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+ji-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir)
                  tmp = tmp + kdir * (
     &                  sigmaf(if+m-1,jf+ji-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )
                  tmp = tmp + jdir * kdir * (
     &                 -sigmaf(if+m-1,jf+ji-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )

                  cen =
     &               4.0D0 * ( sigmaf(if+m-1,jf+ji-1,kf+ki-1,1)
     &                       +sigmaf(if+m  ,jf+ji-1,kf+ki-1,1)
     &                       +sigmaf(if+m-1,jf+ji-1,kf+ki-1,2)
     &                       +sigmaf(if+m  ,jf+ji-1,kf+ki-1,2)
     &                       +sigmaf(if+m-1,jf+ji-1,kf+ki-1,3)
     &                       +sigmaf(if+m  ,jf+ji-1,kf+ki-1,3))
     &             + 6.0D0 * ( sigmaf(if+m-1,jf+ji-1,kf+ki-1,4)
     &                       -sigmaf(if+m  ,jf+ji-1,kf+ki-1,4)) * kdir
     &             + 6.0D0 * (-sigmaf(if+m-1,jf+ji-1,kf+ki-1,5)
     &                  -sigmaf(if+m  ,jf+ji-1,kf+ki-1,5)) * jdir * kdir

                  tmp = tmp - cen * fdst(if+m,jf,kf)

                        res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                     end do
                  end do

               else
                  do ic = regl0, regh0
                     if = ic * ir

                  tmp = sigmac(ic-1,jc+ji-1,kc+ki-1,1) *
     &                    MXXC(ic-1,jc+jdir,kc+kdir)
     &                 +sigmac(ic  ,jc+ji-1,kc+ki-1,1) *
     &                    MXXC(ic+1,jc+jdir,kc+kdir)
                  tmp = tmp
     &                 +sigmac(ic-1,jc+ji-1,kc+ki-1,2) *
     &                    MYYC(ic-1,jc+jdir,kc+kdir)
     &                 +sigmac(ic  ,jc+ji-1,kc+ki-1,2) *
     &                    MYYC(ic+1,jc+jdir,kc+kdir)
                  tmp = tmp
     &                 +sigmac(ic-1,jc+ji-1,kc+ki-1,3) *
     &                    MZZC(ic-1,jc+jdir,kc+kdir)
     &                 +sigmac(ic  ,jc+ji-1,kc+ki-1,3) *
     &                    MZZC(ic+1,jc+jdir,kc+kdir)
                  tmp = tmp + kdir * (
     &                  sigmac(ic-1,jc+ji-1,kc+ki-1,4) *
     &                    MXZC(ic-1,jc+jdir,kc+kdir)
     &                 -sigmac(ic  ,jc+ji-1,kc+ki-1,4) *
     &                    MXZC(ic+1,jc+jdir,kc+kdir) )
                  tmp = tmp + jdir * kdir * (
     &                 -sigmac(ic-1,jc+ji-1,kc+ki-1,5) *
     &                    MYZC(ic-1,jc+jdir,kc+kdir)
     &                 -sigmac(ic  ,jc+ji-1,kc+ki-1,5) *
     &                    MYZC(ic+1,jc+jdir,kc+kdir) )
                   cen =
     &               4.0D0 * ( sigmac(ic-1,jc+ji-1,kc+ki-1,1)
     &                       +sigmac(ic  ,jc+ji-1,kc+ki-1,1)
     &                       +sigmac(ic-1,jc+ji-1,kc+ki-1,2)
     &                       +sigmac(ic  ,jc+ji-1,kc+ki-1,2)
     &                       +sigmac(ic-1,jc+ji-1,kc+ki-1,3)
     &                       +sigmac(ic  ,jc+ji-1,kc+ki-1,3))
     &             + 6.0D0 * ( sigmac(ic-1,jc+ji-1,kc+ki-1,4)
     &                       -sigmac(ic  ,jc+ji-1,kc+ki-1,4)) * kdir
     &             + 6.0D0 * (-sigmac(ic-1,jc+ji-1,kc+ki-1,5)
     &                    -sigmac(ic  ,jc+ji-1,kc+ki-1,5)) * jdir * kdir

                     tmp = tmp - cen * cdst(ic,jc,kc)
                     res(if,jf,kf) = res(if,jf,kf) + tmp
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1

               if (ga(0,ji,ki) - ga(0,ji,1-ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * jr)
                  do  n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = -(ir-1), ir-1
                        fac = (ir-abs(m)) * fac1
                        do if = ir*regl0, ir*regh0, ir

                  tmp = sigmaf(if+m-1,jf+n-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n  ,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+n-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n  ,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+n-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n  ,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir)
                  tmp = tmp + kdir * (
     &                 +sigmaf(if+m-1,jf+n-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 -sigmaf(if+m  ,jf+n-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 -sigmaf(if+m  ,jf+n  ,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir) )
                  tmp = tmp + kdir * (
     &                 +sigmaf(if+m-1,jf+n-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 -sigmaf(if+m-1,jf+n  ,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 -sigmaf(if+m  ,jf+n  ,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir) )

         cen =
     &      4.0D0 * (sigmaf(if+m-1,jf+n-1,kf+ki-1,1)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,1)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,1)
     &             +sigmaf(if+m  ,jf+n  ,kf+ki-1,1)
     &             +sigmaf(if+m-1,jf+n-1,kf+ki-1,2)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,2)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,2)
     &             +sigmaf(if+m  ,jf+n  ,kf+ki-1,2)
     &             +sigmaf(if+m-1,jf+n-1,kf+ki-1,3)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,3)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,3)
     &             +sigmaf(if+m  ,jf+n  ,kf+ki-1,3))
     &    + 6.0D0 * (sigmaf(if+m-1,jf+n-1,kf+ki-1,4)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,4)
     &             -sigmaf(if+m  ,jf+n-1,kf+ki-1,4)
     &             -sigmaf(if+m  ,jf+n  ,kf+ki-1,4)) * kdir
     &    + 6.0D0 * (sigmaf(if+m-1,jf+n-1,kf+ki-1,5)
     &             -sigmaf(if+m-1,jf+n  ,kf+ki-1,5)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,5)
     &             -sigmaf(if+m  ,jf+n  ,kf+ki-1,5)) * kdir

                  tmp = tmp - cen * fdst(if+m,jf+n,kf)
                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                        end do
                     end do
                  end do
               end if

               if (ga(0,ji,ki) - ga(0,1-ji,ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = -(ir-1), ir-1
                        fac = (ir-abs(m)) * fac1
                        do if = ir*regl0, ir*regh0, ir

                  tmp = sigmaf(if+m-1,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1)
                  tmp = tmp + (
     &                 -sigmaf(if+m-1,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
                  tmp = tmp + jdir * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m-1,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
         cen =
     &      4.0D0 * (
     &             +sigmaf(if+m-1,jf+ji-1,kf+l-1,1)
     &             +sigmaf(if+m-1,jf+ji-1,kf+l  ,1)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l-1,1)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l  ,1)
     &             +sigmaf(if+m-1,jf+ji-1,kf+l-1,2)
     &             +sigmaf(if+m-1,jf+ji-1,kf+l  ,2)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l-1,2)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l  ,2)
     &             +sigmaf(if+m-1,jf+ji-1,kf+l-1,3)
     &             +sigmaf(if+m-1,jf+ji-1,kf+l  ,3)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l-1,3)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l  ,3))
     &    + 6.0D0 * (sigmaf(if+m-1,jf+ji-1,kf+l  ,4)
     &             -sigmaf(if+m-1,jf+ji-1,kf+l-1,4)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l-1,4)
     &             -sigmaf(if+m  ,jf+ji-1,kf+l  ,4))
     &    + 6.0D0 * (sigmaf(if+m-1,jf+ji-1,kf+l-1,5)
     &             -sigmaf(if+m-1,jf+ji-1,kf+l  ,5)
     &             +sigmaf(if+m  ,jf+ji-1,kf+l-1,5)
     &             -sigmaf(if+m  ,jf+ji-1,kf+l  ,5)) * jdir

                  tmp = tmp - cen * fdst(if+m,jf,kf+l)
                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do if = ir*regl0, ir*regh0, ir
            res(if,jf,kf) = src(if,jf,kf) - res(if,jf,kf) * fac00
         end do

      else if (ivect(1) .eq. 0) then
         do jf = jr*regl1, jr*regh1, jr
            res(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac0 = 1.0D0 / jr
         do  ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) .eq. 1) then
                  do n = -(jr-1), jr-1
                     fac = (jr-abs(n)) * fac0
                     do jf = jr*regl1, jr*regh1, jr

                  tmp = sigmaf(if+ii-1,jf+n-1,kf+ki-1,1) *
     &                    MXXF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+ki-1,1) *
     &                    MXXF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,2) *
     &                    MYYF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+ki-1,2) *
     &                    MYYF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,3) *
     &                    MZZF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+ki-1,3) *
     &                    MZZF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir)
                  tmp = tmp + idir * kdir * (
     &                 -sigmaf(if+ii-1,jf+n-1,kf+ki-1,4) *
     &                    MXZF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+ki-1,4) *
     &                    MXZF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  tmp = tmp + kdir * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,5) *
     &                    MYZF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+ki-1,5) *
     &                    MYZF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  cen =
     &                  4.0D0 * ( sigmaf(if+ii-1,jf+n-1,kf+ki-1,1)
     &                          +sigmaf(if+ii-1,jf+n  ,kf+ki-1,1)
     &                          +sigmaf(if+ii-1,jf+n-1,kf+ki-1,2)
     &                          +sigmaf(if+ii-1,jf+n  ,kf+ki-1,2)
     &                          +sigmaf(if+ii-1,jf+n-1,kf+ki-1,3)
     &                          +sigmaf(if+ii-1,jf+n  ,kf+ki-1,3))
     &                + 6.0D0 * (-sigmaf(if+ii-1,jf+n-1,kf+ki-1,4)
     &                  -sigmaf(if+ii-1,jf+n  ,kf+ki-1,4)) * idir * kdir
     &                + 6.0D0 * ( sigmaf(if+ii-1,jf+n-1,kf+ki-1,5)
     &                         -sigmaf(if+ii-1,jf+n  ,kf+ki-1,5)) * kdir

                  tmp = tmp - cen * fdst(if,jf+n,kf)

                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                     end do
                  end do
               else
                  do jc = regl1, regh1
                     jf = jc * jr

                  tmp = sigmac(ic+ii-1,jc-1,kc+ki-1,1) *
     &                    MXXC(ic+idir,jc-1,kc+kdir)
     &                 +sigmac(ic+ii-1,jc  ,kc+ki-1,1) *
     &                    MXXC(ic+idir,jc+1,kc+kdir)
                  tmp = tmp
     &                 +sigmac(ic+ii-1,jc-1,kc+ki-1,2) *
     &                    MYYC(ic+idir,jc-1,kc+kdir)
     &                 +sigmac(ic+ii-1,jc  ,kc+ki-1,2) *
     &                    MYYC(ic+idir,jc+1,kc+kdir)
                  tmp = tmp
     &                 +sigmac(ic+ii-1,jc-1,kc+ki-1,3) *
     &                    MZZC(ic+idir,jc-1,kc+kdir)
     &                 +sigmac(ic+ii-1,jc  ,kc+ki-1,3) *
     &                    MZZC(ic+idir,jc+1,kc+kdir)
                  tmp = tmp + idir * kdir * (
     &                 -sigmac(ic+ii-1,jc-1,kc+ki-1,4) *
     &                    MXZC(ic+idir,jc-1,kc+kdir)
     &                 -sigmac(ic+ii-1,jc  ,kc+ki-1,4) *
     &                    MXZC(ic+idir,jc+1,kc+kdir) )
                  tmp = tmp + kdir * (
     &                 +sigmac(ic+ii-1,jc-1,kc+ki-1,5) *
     &                    MYZC(ic+idir,jc-1,kc+kdir)
     &                 -sigmac(ic+ii-1,jc  ,kc+ki-1,5) *
     &                    MYZC(ic+idir,jc+1,kc+kdir) )
                  cen =
     &               4.0D0 * (
     &                       +sigmac(ic+ii-1,jc-1,kc+ki-1,1)
     &                       +sigmac(ic+ii-1,jc  ,kc+ki-1,1)
     &                       +sigmac(ic+ii-1,jc-1,kc+ki-1,2)
     &                       +sigmac(ic+ii-1,jc  ,kc+ki-1,2)
     &                       +sigmac(ic+ii-1,jc-1,kc+ki-1,3)
     &                       +sigmac(ic+ii-1,jc  ,kc+ki-1,3))
     &             + 6.0D0 * (-sigmac(ic+ii-1,jc-1,kc+ki-1,4)
     &                    -sigmac(ic+ii-1,jc  ,kc+ki-1,4)) * idir * kdir
     &             + 6.0D0 * ( sigmac(ic+ii-1,jc-1,kc+ki-1,5)
     &                       -sigmac(ic+ii-1,jc  ,kc+ki-1,5)) * kdir

                     tmp = tmp - cen * cdst(ic,jc,kc)
                     res(if,jf,kf) = res(if,jf,kf) + tmp
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) - ga(ii,0,1-ki) .eq. 1) then
                  fac0 = 1.0D0 / (ir * jr)
                  do n = -(jr-1), jr-1
                     fac1 = (jr-abs(n)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do jf = jr*regl1, jr*regh1, jr

                  tmp = sigmaf(if+m-1,jf+n-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n  ,kf+ki-1,1) *
     &                    MXXF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+n-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n  ,kf+ki-1,2) *
     &                    MYYF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+n-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n  ,kf+ki-1,3) *
     &                    MZZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir)
                  tmp = tmp + kdir * (
     &                  sigmaf(if+m-1,jf+n-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 +sigmaf(if+m-1,jf+n  ,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 -sigmaf(if+m  ,jf+n-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 -sigmaf(if+m  ,jf+n  ,kf+ki-1,4) *
     &                    MXZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir) )
                  tmp = tmp + kdir * (
     &                  sigmaf(if+m-1,jf+n-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &                 -sigmaf(if+m-1,jf+n  ,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &                 +sigmaf(if+m  ,jf+n-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &                 -sigmaf(if+m  ,jf+n  ,kf+ki-1,5) *
     &                    MYZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir) )

         cen =
     &      4.0D0 * (sigmaf(if+m-1,jf+n-1,kf+ki-1,1)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,1)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,1)
     &             +sigmaf(if+m  ,jf+n  ,kf+ki-1,1)
     &             +sigmaf(if+m-1,jf+n-1,kf+ki-1,2)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,2)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,2)
     &             +sigmaf(if+m  ,jf+n  ,kf+ki-1,2)
     &             +sigmaf(if+m-1,jf+n-1,kf+ki-1,3)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,3)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,3)
     &             +sigmaf(if+m  ,jf+n  ,kf+ki-1,3))
     &    + 6.0D0 * (sigmaf(if+m-1,jf+n-1,kf+ki-1,4)
     &             +sigmaf(if+m-1,jf+n  ,kf+ki-1,4)
     &             -sigmaf(if+m  ,jf+n-1,kf+ki-1,4)
     &             -sigmaf(if+m  ,jf+n  ,kf+ki-1,4)) * kdir
     &    + 6.0D0 * (sigmaf(if+m-1,jf+n-1,kf+ki-1,5)
     &             -sigmaf(if+m-1,jf+n  ,kf+ki-1,5)
     &             +sigmaf(if+m  ,jf+n-1,kf+ki-1,5)
     &             -sigmaf(if+m  ,jf+n  ,kf+ki-1,5)) * kdir

                  tmp = tmp - cen * fdst(if+m,jf+n,kf)
                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                        end do
                     end do
                  end do
               end if
               if (ga(ii,0,ki) - ga(1-ii,0,ki) .eq. 1) then
                  fac0 = 1.0D0 / (jr * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = -(jr-1), jr-1
                        fac = (jr-abs(n)) * fac1
                        do jf = jr*regl1, jr*regh1, jr

                  tmp = sigmaf(if+ii-1,jf+n-1,kf+l-1,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1)
                  tmp = tmp + idir * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n-1,kf+l  ,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+l  ,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )
                  tmp = tmp + (
     &                 -sigmaf(if+ii-1,jf+n-1,kf+l-1,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+l  ,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )

                  cen =
     &               4.0D0 * (sigmaf(if+ii-1,jf+n-1,kf+l-1,1)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l  ,1)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,1)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l  ,1)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l-1,2)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l  ,2)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,2)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l  ,2)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l-1,3)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l  ,3)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,3)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l  ,3))
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+n-1,kf+l-1,4)
     &                      -sigmaf(if+ii-1,jf+n-1,kf+l  ,4)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,4)
     &                      -sigmaf(if+ii-1,jf+n  ,kf+l  ,4)) * idir
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+n-1,kf+l  ,5)
     &                      -sigmaf(if+ii-1,jf+n-1,kf+l-1,5)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,5)
     &                      -sigmaf(if+ii-1,jf+n  ,kf+l  ,5))

                  tmp = tmp - cen * fdst(if,jf+n,kf+l)
                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do  jf = jr*regl1, jr*regh1, jr
            res(if,jf,kf) = src(if,jf,kf) - res(if,jf,kf) * fac00
         end do
      else
         do kf = kr*regl2, kr*regh2, kr
            res(if,jf,kf) = 0.0D0
         end do
c quadrants
c each quadrant is two octants and their share of the two central edges
         fac0 = 1.0D0 / kr
         do  ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) .eq. 1) then
                  do l = -(kr-1), kr-1
                     fac = (kr-abs(l)) * fac0
                     do kf = kr*regl2, kr*regh2, kr

                  tmp = sigmaf(if+ii-1,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1)
                  tmp = tmp + idir * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  tmp = tmp + jdir * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  cen =
     &               4.0D0 * (sigmaf(if+ii-1,jf+ji-1,kf+l-1,1)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l  ,1)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l-1,2)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l  ,2)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l-1,3)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l  ,3))
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+ji-1,kf+l-1,4)
     &                      -sigmaf(if+ii-1,jf+ji-1,kf+l  ,4)) * idir
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+ji-1,kf+l-1,5)
     &                      -sigmaf(if+ii-1,jf+ji-1,kf+l  ,5)) * jdir

                  tmp = tmp - cen * fdst(if,jf,kf+l)

                        res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                     end do
                  end do
               else
                  do kc = regl2, regh2
                     kf = kc * kr

                  tmp = sigmac(ic+ii-1,jc+ji-1,kc-1,1) *
     &                    MXXC(ic+idir,jc+jdir,kc-1)
     &                 +sigmac(ic+ii-1,jc+ji-1,kc  ,1) *
     &                    MXXC(ic+idir,jc+jdir,kc+1)
                  tmp = tmp
     &                 +sigmac(ic+ii-1,jc+ji-1,kc-1,2) *
     &                    MYYC(ic+idir,jc+jdir,kc-1)
     &                 +sigmac(ic+ii-1,jc+ji-1,kc  ,2) *
     &                    MYYC(ic+idir,jc+jdir,kc+1)
                  tmp = tmp
     &                 +sigmac(ic+ii-1,jc+ji-1,kc-1,3) *
     &                    MZZC(ic+idir,jc+jdir,kc-1)
     &                 +sigmac(ic+ii-1,jc+ji-1,kc  ,3) *
     &                    MZZC(ic+idir,jc+jdir,kc+1)
                  tmp = tmp + idir * (
     &                 +sigmac(ic+ii-1,jc+ji-1,kc-1,4) *
     &                    MXZC(ic+idir,jc+jdir,kc-1)
     &                 -sigmac(ic+ii-1,jc+ji-1,kc  ,4) *
     &                    MXZC(ic+idir,jc+jdir,kc+1) )
                  tmp = tmp + jdir * (
     &                 +sigmac(ic+ii-1,jc+ji-1,kc-1,5) *
     &                    MYZC(ic+idir,jc+jdir,kc-1)
     &                 -sigmac(ic+ii-1,jc+ji-1,kc  ,5) *
     &                    MYZC(ic+idir,jc+jdir,kc+1) )
                  cen =
     &               4.0D0 * (sigmac(ic+ii-1,jc+ji-1,kc-1,1)
     &                      +sigmac(ic+ii-1,jc+ji-1,kc  ,1)
     &                      +sigmac(ic+ii-1,jc+ji-1,kc-1,2)
     &                      +sigmac(ic+ii-1,jc+ji-1,kc  ,2)
     &                      +sigmac(ic+ii-1,jc+ji-1,kc-1,3)
     &                      +sigmac(ic+ii-1,jc+ji-1,kc  ,3) )
     &             + 6.0D0 * (sigmac(ic+ii-1,jc+ji-1,kc-1,4)
     &                      -sigmac(ic+ii-1,jc+ji-1,kc  ,4) ) * idir
     &             + 6.0D0 * (sigmac(ic+ii-1,jc+ji-1,kc-1,5)
     &                      -sigmac(ic+ii-1,jc+ji-1,kc  ,5) ) * jdir

                     tmp = tmp - cen * cdst(ic,jc,kc)
                     res(if,jf,kf) = res(if,jf,kf) + tmp
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) - ga(ii,1-ji,0) .eq. 1) then
                  fac0 = 1.0D0 / (ir * kr)
                  do l = -(kr-1), kr-1
                     fac1 = (kr-abs(l)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do kf = kr*regl2, kr*regh2, kr

                  tmp = sigmaf(if+m-1,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1)
                  tmp = tmp + (
     &                 -sigmaf(if+m-1,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
                  tmp = tmp + jdir * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m-1,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
                  cen =
     &               4.0D0 * (sigmaf(if+m-1,jf+ji-1,kf+l-1,1)
     &                      +sigmaf(if+m-1,jf+ji-1,kf+l  ,1)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l-1,1)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l  ,1)
     &                      +sigmaf(if+m-1,jf+ji-1,kf+l-1,2)
     &                      +sigmaf(if+m-1,jf+ji-1,kf+l  ,2)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l-1,2)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l  ,2)
     &                      +sigmaf(if+m-1,jf+ji-1,kf+l-1,3)
     &                      +sigmaf(if+m-1,jf+ji-1,kf+l  ,3)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l-1,3)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l  ,3))
     &             + 6.0D0 * (sigmaf(if+m-1,jf+ji-1,kf+l  ,4)
     &                      -sigmaf(if+m-1,jf+ji-1,kf+l-1,4)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l-1,4)
     &                      -sigmaf(if+m  ,jf+ji-1,kf+l  ,4))
     &             + 6.0D0 * (sigmaf(if+m-1,jf+ji-1,kf+l-1,5)
     &                      -sigmaf(if+m-1,jf+ji-1,kf+l  ,5)
     &                      +sigmaf(if+m  ,jf+ji-1,kf+l-1,5)
     &                      -sigmaf(if+m  ,jf+ji-1,kf+l  ,5)) * jdir
                  tmp = tmp - cen * fdst(if+m,jf,kf+l)
                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                        end do
                     end do
                  end do
               end if
               if (ga(ii,ji,0) - ga(1-ii,ji,0) .eq. 1) then
                  fac0 = 1.0D0 / (jr * kr)
                  do l = -(kr-1), kr-1
                     fac1 = (kr-abs(l)) * fac0
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        do kf = kr*regl2, kr*regh2, kr
                  tmp = sigmaf(if+ii-1,jf+n-1,kf+l-1,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1)
                  tmp = tmp
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1)
                  tmp = tmp + idir * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n-1,kf+l  ,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+l  ,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )
                  tmp = tmp + (
     &                 -sigmaf(if+ii-1,jf+n-1,kf+l-1,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+l  ,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )

                  cen =
     &               4.0D0 * (sigmaf(if+ii-1,jf+n-1,kf+l-1,1)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l  ,1)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,1)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l  ,1)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l-1,2)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l  ,2)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,2)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l  ,2)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l-1,3)
     &                      +sigmaf(if+ii-1,jf+n-1,kf+l  ,3)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,3)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l  ,3))
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+n-1,kf+l-1,4)
     &                      -sigmaf(if+ii-1,jf+n-1,kf+l  ,4)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,4)
     &                      -sigmaf(if+ii-1,jf+n  ,kf+l  ,4)) * idir
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+n-1,kf+l  ,5)
     &                      -sigmaf(if+ii-1,jf+n-1,kf+l-1,5)
     &                      +sigmaf(if+ii-1,jf+n  ,kf+l-1,5)
     &                      -sigmaf(if+ii-1,jf+n  ,kf+l  ,5))
                  tmp = tmp - cen * fdst(if,jf+n,kf+l)
                  res(if,jf,kf) = res(if,jf,kf) + fac * tmp
                        end do
                     end do
                  end do
               end if
            end do
         end do
c weighting
         do kf = kr*regl2, kr*regh2, kr
            res(if,jf,kf) = src(if,jf,kf) - res(if,jf,kf) * fac00
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along face
      subroutine hgcres_terrain(
     & res,    resl0,resh0,resl1,resh1,resl2,resh2,
     & src,    srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & fdst,   fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2,
     & cdst,   cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2,
     & sigmaf, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & sigmac, scl0,sch0,scl1,sch1,scl2,sch2,
     &         regl0,regh0,regl1,regh1,regl2,regh2,
     & hx, hy, hz, ir, jr, kr, ga, idd)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fdstl0,fdsth0,fdstl1,fdsth1,fdstl2,fdsth2
      integer cdstl0,cdsth0,cdstl1,cdsth1,cdstl2,cdsth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer scl0,sch0,scl1,sch1,scl2,sch2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision hx, hy, hz
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1,fdstl2:fdsth2)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1,cdstl2:cdsth2)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2,5)
      double precision sigmac(scl0:sch0,scl1:sch1,scl2:sch2,5)
      integer ir, jr, kr, ga(0:1,0:1,0:1), idd
      double precision cen, sum, fac00, fac1, fac2, fac
      integer ic, jc, kc, if, jf, kf, ji, ki, idir, jdir, kdir
      integer l, m, n
      integer ii, jj, kk, i1, j1, k1
      double precision MXXC, MYYC, MZZC, MXZC, MYZC
      double precision MXXF, MYYF, MZZF, MXZF, MYZF
      MXXC(ii,jj,kk) = (4.0D0 *  cdst(ii,jc,kc) +
     &                   2.0D0 * (cdst(ii,jj,kc) - cdst(ic,jj,kc) +
     &                           cdst(ii,jc,kk) - cdst(ic,jc,kk)) +
     &                          (cdst(ii,jj,kk) - cdst(ic,jj,kk)))

      MYYC(ii,jj,kk) = (4.0D0 *  cdst(ic,jj,kc) +
     &                   2.0D0 * (cdst(ii,jj,kc) - cdst(ii,jc,kc) +
     &                           cdst(ic,jj,kk) - cdst(ic,jc,kk)) +
     &                          (cdst(ii,jj,kk) - cdst(ii,jc,kk)))

      MZZC(ii,jj,kk) = (4.0D0 *  cdst(ic,jc,kk) +
     &                   2.0D0 * (cdst(ii,jc,kk) - cdst(ii,jc,kc) +
     &                           cdst(ic,jj,kk) - cdst(ic,jj,kc)) +
     &                          (cdst(ii,jj,kk) - cdst(ii,jj,kc)))

      MXZC(ii,jj,kk) = (6.0D0 *  cdst(ii,jc,kk) +
     &                   3.0D0 * (cdst(ii,jj,kk) - cdst(ic,jj,kc)))

      MYZC(ii,jj,kk) = (6.0D0 *  cdst(ic,jj,kk) +
     &                   3.0D0 * (cdst(ii,jj,kk) - cdst(ii,jc,kc)))

      MXXF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(ii,j1,k1)   +
     &                        2.0D0 * (fdst(ii,jj,k1) - fdst(i1,jj,k1) +
     &                               fdst(ii,j1,kk) - fdst(i1,j1,kk)) +
     &                                (fdst(ii,jj,kk) - fdst(i1,jj,kk)))

      MYYF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(i1,jj,k1)   +
     &                        2.0D0 * (fdst(ii,jj,k1) - fdst(ii,j1,k1) +
     &                                fdst(i1,jj,kk) - fdst(i1,j1,kk)) +
     &                                (fdst(ii,jj,kk) - fdst(ii,j1,kk)))

      MZZF(i1,j1,k1,ii,jj,kk) = (4.0D0 *  fdst(i1,j1,kk)   +
     &                        2.0D0 * (fdst(ii,j1,kk) - fdst(ii,j1,k1) +
     &                                fdst(i1,jj,kk) - fdst(i1,jj,k1)) +
     &                                (fdst(ii,jj,kk) - fdst(ii,jj,k1)))

      MXZF(i1,j1,k1,ii,jj,kk) = (6.0D0 *  fdst(ii,j1,kk)  +
     &                        3.0D0 * (fdst(ii,jj,kk) - fdst(i1,jj,k1)))

      MYZF(i1,j1,k1,ii,jj,kk) = (6.0D0 *  fdst(i1,jj,kk)  +
     &                        3.0D0 * (fdst(ii,jj,kk) - fdst(ii,j1,k1)))
      ic = regl0
      jc = regl1
      kc = regl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      sum = 0.0D0

      fac00 = 1.0D0 / 36

c octants
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) .eq. 1) then

                  sum = sum
     &             +sigmaf(if+ii-1,jf+ji-1,kf+ki-1,1) *
     &                MXXF(if,jf,kf,if+idir,jf+jdir,kf+kdir)
     &             +sigmaf(if+ii-1,jf+ji-1,kf+ki-1,2) *
     &                MYYF(if,jf,kf,if+idir,jf+jdir,kf+kdir)
     &             +sigmaf(if+ii-1,jf+ji-1,kf+ki-1,3) *
     &                MZZF(if,jf,kf,if+idir,jf+jdir,kf+kdir)
     &             -sigmaf(if+ii-1,jf+ji-1,kf+ki-1,4) *
     &              MXZF(if,jf,kf,if+idir,jf+jdir,kf+kdir) * idir * kdir
     &             -sigmaf(if+ii-1,jf+ji-1,kf+ki-1,5) *
     &              MYZF(if,jf,kf,if+idir,jf+jdir,kf+kdir) * jdir * kdir

         cen =
     &      4.0D0 * ( sigmaf(if+ii-1,jf+ji-1,kf+ki-1,1)
     &              +sigmaf(if+ii-1,jf+ji-1,kf+ki-1,2)
     &              +sigmaf(if+ii-1,jf+ji-1,kf+ki-1,3))
     &    + 6.0D0 * (-sigmaf(if+ii-1,jf+ji-1,kf+ki-1,4)) * idir * kdir
     &    + 6.0D0 * (-sigmaf(if+ii-1,jf+ji-1,kf+ki-1,5)) * jdir * kdir

                   sum = sum - cen * fdst(if,jf,kf)

               else

                  sum = sum
     &             +sigmac(ic+ii-1,jc+ji-1,kc+ki-1,1) *
     &                MXXC(ic+idir,jc+jdir,kc+kdir)
     &             +sigmac(ic+ii-1,jc+ji-1,kc+ki-1,2) *
     &                MYYC(ic+idir,jc+jdir,kc+kdir)
     &             +sigmac(ic+ii-1,jc+ji-1,kc+ki-1,3) *
     &                MZZC(ic+idir,jc+jdir,kc+kdir)
     &             -sigmac(ic+ii-1,jc+ji-1,kc+ki-1,4) *
     &                MXZC(ic+idir,jc+jdir,kc+kdir) * idir * kdir
     &             -sigmac(ic+ii-1,jc+ji-1,kc+ki-1,5) *
     &                MYZC(ic+idir,jc+jdir,kc+kdir) * jdir * kdir

         cen =
     &      4.0D0 * ( sigmac(ic+ii-1,jc+ji-1,kc+ki-1,1)
     &              +sigmac(ic+ii-1,jc+ji-1,kc+ki-1,2)
     &              +sigmac(ic+ii-1,jc+ji-1,kc+ki-1,3))
     &    + 6.0D0 * (-sigmac(ic+ii-1,jc+ji-1,kc+ki-1,4)) * idir * kdir
     &    + 6.0D0 * (-sigmac(ic+ii-1,jc+ji-1,kc+ki-1,5)) * jdir * kdir

                   sum = sum - cen * cdst(ic,jc,kc)

               end if
            end do
         end do
      end do
c faces
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) - ga(ii,ji,1-ki) .eq. 1) then
                  fac2 = 1.0D0 / (ir * jr)
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac2
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1

         sum = sum + fac * (
     &     +sigmaf(if+m-1,jf+n-1,kf+ki-1,1) *
     &        MXXF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m-1,jf+n  ,kf+ki-1,1) *
     &        MXXF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n-1,kf+ki-1,1) *
     &        MXXF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n  ,kf+ki-1,1) *
     &        MXXF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir))
         sum = sum + fac * (
     &     +sigmaf(if+m-1,jf+n-1,kf+ki-1,2) *
     &        MYYF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m-1,jf+n  ,kf+ki-1,2) *
     &        MYYF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n-1,kf+ki-1,2) *
     &        MYYF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n  ,kf+ki-1,2) *
     &        MYYF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir))
         sum = sum + fac * (
     &     +sigmaf(if+m-1,jf+n-1,kf+ki-1,3) *
     &        MZZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m-1,jf+n  ,kf+ki-1,3) *
     &        MZZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n-1,kf+ki-1,3) *
     &        MZZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n  ,kf+ki-1,3) *
     &        MZZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir))
         sum = sum + fac * kdir * (
     &     +sigmaf(if+m-1,jf+n-1,kf+ki-1,4) *
     &        MXZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &     +sigmaf(if+m-1,jf+n  ,kf+ki-1,4) *
     &        MXZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &     -sigmaf(if+m  ,jf+n-1,kf+ki-1,4) *
     &        MXZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &     -sigmaf(if+m  ,jf+n  ,kf+ki-1,4) *
     &        MXZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir))
         sum = sum + fac * kdir * (
     &     +sigmaf(if+m-1,jf+n-1,kf+ki-1,5) *
     &        MYZF(if+m,jf+n,kf,if+m-1,jf+n-1,kf+kdir)
     &     -sigmaf(if+m-1,jf+n  ,kf+ki-1,5) *
     &        MYZF(if+m,jf+n,kf,if+m-1,jf+n+1,kf+kdir)
     &     +sigmaf(if+m  ,jf+n-1,kf+ki-1,5) *
     &        MYZF(if+m,jf+n,kf,if+m+1,jf+n-1,kf+kdir)
     &     -sigmaf(if+m  ,jf+n  ,kf+ki-1,5) *
     &        MYZF(if+m,jf+n,kf,if+m+1,jf+n+1,kf+kdir))

         cen =
     &      4.0D0 * ( sigmaf(if+m-1,jf+n-1,kf+ki-1,1)
     &              +sigmaf(if+m-1,jf+n  ,kf+ki-1,1)
     &              +sigmaf(if+m  ,jf+n-1,kf+ki-1,1)
     &              +sigmaf(if+m  ,jf+n  ,kf+ki-1,1)
     &              +sigmaf(if+m-1,jf+n-1,kf+ki-1,2)
     &              +sigmaf(if+m-1,jf+n  ,kf+ki-1,2)
     &              +sigmaf(if+m  ,jf+n-1,kf+ki-1,2)
     &              +sigmaf(if+m  ,jf+n  ,kf+ki-1,2)
     &              +sigmaf(if+m-1,jf+n-1,kf+ki-1,3)
     &              +sigmaf(if+m-1,jf+n  ,kf+ki-1,3)
     &              +sigmaf(if+m  ,jf+n-1,kf+ki-1,3)
     &              +sigmaf(if+m  ,jf+n  ,kf+ki-1,3))
     &    + 6.0D0 * ( sigmaf(if+m-1,jf+n-1,kf+ki-1,4)
     &              +sigmaf(if+m-1,jf+n  ,kf+ki-1,4)
     &              -sigmaf(if+m  ,jf+n-1,kf+ki-1,4)
     &              -sigmaf(if+m  ,jf+n  ,kf+ki-1,4)) * kdir
     &    + 6.0D0 * ( sigmaf(if+m-1,jf+n-1,kf+ki-1,5)
     &              -sigmaf(if+m-1,jf+n  ,kf+ki-1,5)
     &              +sigmaf(if+m  ,jf+n-1,kf+ki-1,5)
     &              -sigmaf(if+m  ,jf+n  ,kf+ki-1,5)) * kdir

          sum = sum - fac * cen * fdst(if+m,jf+n,kf)
                     end do
                  end do
               end if

               if (ga(ii,ji,ki) - ga(ii,1-ji,ki) .eq. 1) then
                  fac2 = 1.0D0 / (ir * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac2
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1

         sum = sum + fac * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
         sum = sum + fac * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
         sum = sum + fac * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
         sum = sum + fac * (
     &                 -sigmaf(if+m-1,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )
         sum = sum + fac * jdir * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m-1,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if+m,jf,kf+l,if+m-1,jf+jdir,kf+l+1)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l-1)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if+m,jf,kf+l,if+m+1,jf+jdir,kf+l+1) )

         cen =
     &      4.0D0 * (
     &            + sigmaf(if+m-1,jf+ji-1,kf+l-1,1)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l,1)
     &            + sigmaf(if+m  ,jf+ji-1,kf+l-1,1)
     &            + sigmaf(if+m  ,jf+ji-1,kf+l,1)
     &        +sigmaf(if+m-1,jf+ji-1,kf+l-1,2)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l,2)
     &        +sigmaf(if+m  ,jf+ji-1,kf+l-1,2)
     &            + sigmaf(if+m  ,jf+ji-1,kf+l,2)
     &        +sigmaf(if+m-1,jf+ji-1,kf+l-1,3)
     &            + sigmaf(if+m-1,jf+ji-1,kf+l,3)
     &        +sigmaf(if+m  ,jf+ji-1,kf+l-1,3)
     &            + sigmaf(if+m  ,jf+ji-1,kf+l,3))
     &     +6.0D0 * (
     &         sigmaf(if+m-1,jf+ji-1,kf+l  ,4)
     &            - sigmaf(if+m-1,jf+ji-1,kf+l-1,4)
     &        +sigmaf(if+m  ,jf+ji-1,kf+l-1,4)
     &            - sigmaf(if+m  ,jf+ji-1,kf+l,4))
     &     +6.0D0 * jdir * (
     &         sigmaf(if+m-1,jf+ji-1,kf+l-1,5)
     &            - sigmaf(if+m-1,jf+ji-1,kf+l,5)
     &        +sigmaf(if+m  ,jf+ji-1,kf+l-1,5)
     &            - sigmaf(if+m  ,jf+ji-1,kf+l,5))

          sum = sum - fac * cen * fdst(if+m,jf,kf+l)
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(1-ii,ji,ki) .eq. 1) then
                  fac2 = 1.0D0 / (jr * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac2
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1

         sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,1) *
     &                    MXXF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )
         sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,2) *
     &                    MYYF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )
         sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l  ,3) *
     &                    MZZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )
         sum = sum + fac * idir * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l-1,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n-1,kf+l  ,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+l  ,4) *
     &                    MXZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )
         sum = sum + fac * (
     &                 -sigmaf(if+ii-1,jf+n-1,kf+l-1,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+n-1,kf+l  ,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n-1,kf+l+1)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+l-1,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+l  ,5) *
     &                    MYZF(if,jf+n,kf+l,if+idir,jf+n+1,kf+l+1) )

         cen =
     &      4.0D0 * (
     &        sigmaf(if+ii-1,jf+n-1,kf+l-1,1)
     &        + sigmaf(if+ii-1,jf+n-1,kf+l  ,1)
     &       +sigmaf(if+ii-1,jf+n  ,kf+l-1,1)
     &        + sigmaf(if+ii-1,jf+n  ,kf+l  ,1)
     &       +sigmaf(if+ii-1,jf+n-1,kf+l-1,2)
     &        + sigmaf(if+ii-1,jf+n-1,kf+l  ,2)
     &       +sigmaf(if+ii-1,jf+n  ,kf+l-1,2)
     &        + sigmaf(if+ii-1,jf+n  ,kf+l  ,2)
     &       +sigmaf(if+ii-1,jf+n-1,kf+l-1,3)
     &        + sigmaf(if+ii-1,jf+n-1,kf+l  ,3)
     &       +sigmaf(if+ii-1,jf+n  ,kf+l-1,3)
     &        + sigmaf(if+ii-1,jf+n  ,kf+l  ,3))
     &    + 6.0D0 * idir * (
     &        sigmaf(if+ii-1,jf+n-1,kf+l-1,4)
     &        - sigmaf(if+ii-1,jf+n-1,kf+l  ,4)
     &       +sigmaf(if+ii-1,jf+n  ,kf+l-1,4)
     &        - sigmaf(if+ii-1,jf+n  ,kf+l  ,4))
     &    + 6.0D0 * (
     &        sigmaf(if+ii-1,jf+n-1,kf+l  ,5)
     &        - sigmaf(if+ii-1,jf+n-1,kf+l-1,5)
     &       +sigmaf(if+ii-1,jf+n  ,kf+l-1,5)
     &        - sigmaf(if+ii-1,jf+n  ,kf+l  ,5))

          sum = sum - fac * cen * fdst(if,jf+n,kf+l)
                     end do
                  end do
               end if
            end do
         end do
      end do
c edges
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1

               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(ii,1-ji,ki), ga(ii,1-ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / ir
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1

                  sum = sum + fac * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+ki-1,1) *
     &                    MXXF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )
                  sum = sum + fac * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+ki-1,2) *
     &                    MYYF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )
                  sum = sum + fac * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 +sigmaf(if+m  ,jf+ji-1,kf+ki-1,3) *
     &                    MZZF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )
                  sum = sum + fac * kdir * (
     &                 +sigmaf(if+m-1,jf+ji-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+ki-1,4) *
     &                    MXZF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )
                  sum = sum  + fac * jdir * kdir * (
     &                 -sigmaf(if+m-1,jf+ji-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf,kf,if+m-1,jf+jdir,kf+kdir)
     &                 -sigmaf(if+m  ,jf+ji-1,kf+ki-1,5) *
     &                    MYZF(if+m,jf,kf,if+m+1,jf+jdir,kf+kdir) )

                  cen =
     &               4.0D0 * ( sigmaf(if+m-1,jf+ji-1,kf+ki-1,1)
     &                       +sigmaf(if+m  ,jf+ji-1,kf+ki-1,1)
     &                       +sigmaf(if+m-1,jf+ji-1,kf+ki-1,2)
     &                       +sigmaf(if+m  ,jf+ji-1,kf+ki-1,2)
     &                       +sigmaf(if+m-1,jf+ji-1,kf+ki-1,3)
     &                       +sigmaf(if+m  ,jf+ji-1,kf+ki-1,3))
     &             + 6.0D0 * ( sigmaf(if+m-1,jf+ji-1,kf+ki-1,4)
     &                       -sigmaf(if+m  ,jf+ji-1,kf+ki-1,4)) * kdir
     &             + 6.0D0 * (-sigmaf(if+m-1,jf+ji-1,kf+ki-1,5)
     &                  -sigmaf(if+m  ,jf+ji-1,kf+ki-1,5)) * jdir * kdir

                  sum = sum - fac * cen * fdst(if+m,jf,kf)
                  end do
               end if

               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(1-ii,ji,ki), ga(1-ii,ji,1-ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / jr
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1

                  sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,1) *
     &                    MXXF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+ki-1,1) *
     &                    MXXF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,2) *
     &                    MYYF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+ki-1,2) *
     &                    MYYF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,3) *
     &                    MZZF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 +sigmaf(if+ii-1,jf+n  ,kf+ki-1,3) *
     &                    MZZF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  sum = sum + fac * idir * kdir * (
     &                 -sigmaf(if+ii-1,jf+n-1,kf+ki-1,4) *
     &                    MXZF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+ki-1,4) *
     &                    MXZF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  sum = sum  + fac * kdir * (
     &                 +sigmaf(if+ii-1,jf+n-1,kf+ki-1,5) *
     &                    MYZF(if,jf+n,kf,if+idir,jf+n-1,kf+kdir)
     &                 -sigmaf(if+ii-1,jf+n  ,kf+ki-1,5) *
     &                    MYZF(if,jf+n,kf,if+idir,jf+n+1,kf+kdir) )
                  cen =
     &                  4.0D0 * ( sigmaf(if+ii-1,jf+n-1,kf+ki-1,1)
     &                          +sigmaf(if+ii-1,jf+n  ,kf+ki-1,1)
     &                          +sigmaf(if+ii-1,jf+n-1,kf+ki-1,2)
     &                          +sigmaf(if+ii-1,jf+n  ,kf+ki-1,2)
     &                          +sigmaf(if+ii-1,jf+n-1,kf+ki-1,3)
     &                          +sigmaf(if+ii-1,jf+n  ,kf+ki-1,3))
     &                + 6.0D0 * (-sigmaf(if+ii-1,jf+n-1,kf+ki-1,4)
     &                  -sigmaf(if+ii-1,jf+n  ,kf+ki-1,4)) * idir * kdir
     &                + 6.0D0 * ( sigmaf(if+ii-1,jf+n-1,kf+ki-1,5)
     &                         -sigmaf(if+ii-1,jf+n  ,kf+ki-1,5)) * kdir
                  sum = sum - fac * cen * fdst(if,jf+n,kf)

               end do

               end if

               if (ga(ii,ji,ki) -
     &             min(ga(ii,1-ji,ki), ga(1-ii,ji,ki), ga(1-ii,1-ji,ki))
     &             .eq. 1) then
                  fac1 = 1.0D0 / kr
                  do l = kdir, kdir*(kr-1), kdir
                     fac = (kr-abs(l)) * fac1

                  sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,1) *
     &                    MXXF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l  ,1) *
     &                    MXXF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,2) *
     &                    MYYF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l  ,2) *
     &                    MYYF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  sum = sum + fac * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,3) *
     &                    MZZF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l  ,3) *
     &                    MZZF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  sum = sum + fac * idir * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,4) *
     &                    MXZF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+ji-1,kf+l  ,4) *
     &                    MXZF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  sum = sum + fac * jdir * (
     &                 +sigmaf(if+ii-1,jf+ji-1,kf+l-1,5) *
     &                    MYZF(if,jf,kf+l,if+idir,jf+jdir,kf+l-1)
     &                 -sigmaf(if+ii-1,jf+ji-1,kf+l  ,5) *
     &                    MYZF(if,jf,kf+l,if+idir,jf+jdir,kf+l+1) )
                  cen =
     &               4.0D0 * (sigmaf(if+ii-1,jf+ji-1,kf+l-1,1)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l  ,1)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l-1,2)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l  ,2)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l-1,3)
     &                      +sigmaf(if+ii-1,jf+ji-1,kf+l  ,3))
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+ji-1,kf+l-1,4)
     &                      -sigmaf(if+ii-1,jf+ji-1,kf+l  ,4)) * idir
     &             + 6.0D0 * (sigmaf(if+ii-1,jf+ji-1,kf+l-1,5)
     &                      -sigmaf(if+ii-1,jf+ji-1,kf+l  ,5)) * jdir

                  sum = sum - fac * cen * fdst(if,jf,kf+l)

                  end do
               end if
            end do
         end do
      end do
c weighting
      res(if,jf,kf) = src(if,jf,kf) - sum * fac00
      end
c twenty-seven-point terrain stencils
c-----------------------------------------------------------------------
      subroutine hgcen_terrain(
     & cen, cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     & sig, sbl0,sbh0,sbl1,sbh1,sbl2,sbh2,
     &      regl0,regh0,regl1,regh1,regl2,regh2)
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer sbl0,sbh0,sbl1,sbh1,sbl2,sbh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      double precision sig(sbl0:sbh0,sbl1:sbh1,sbl2:sbh2, 5)
      double precision tmp
      integer i, j, k
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               tmp = (4.0D0 * (sig(i-1,j-1,k-1,1) + sig(i-1,j-1,k,1) +
     &                    sig(i-1,j,k-1,1)   + sig(i-1,j,k,1) +
     &                    sig(i,j-1,k-1,1)   + sig(i,j-1,k,1) +
     &                    sig(i,j,k-1,1)     + sig(i,j,k,1) +
     &                    sig(i-1,j-1,k-1,2) + sig(i-1,j-1,k,2) +
     &                    sig(i-1,j,k-1,2)   + sig(i-1,j,k,2) +
     &                    sig(i,j-1,k-1,2)   + sig(i,j-1,k,2) +
     &                    sig(i,j,k-1,2)     + sig(i,j,k,2) +
     &                    sig(i-1,j-1,k-1,3) + sig(i-1,j-1,k,3) +
     &                    sig(i-1,j,k-1,3)   + sig(i-1,j,k,3) +
     &                    sig(i,j-1,k-1,3)   + sig(i,j-1,k,3) +
     &                    sig(i,j,k-1,3)     + sig(i,j,k,3)) +
     &            6.0D0 * (sig(i-1,j-1,k,4)   - sig(i-1,j-1,k-1,4) +
     &                    sig(i-1,j,k,4)     - sig(i-1,j,k-1,4) +
     &                    sig(i,j-1,k-1,4)   - sig(i,j-1,k,4) +
     &                    sig(i,j,k-1,4)     - sig(i,j,k,4) +
     &                    sig(i-1,j-1,k,5)   - sig(i-1,j-1,k-1,5) +
     &                    sig(i-1,j,k-1,5)   - sig(i-1,j,k,5) +
     &                    sig(i,j-1,k,5)     - sig(i,j-1,k-1,5) +
     &                    sig(i,j,k-1,5)     - sig(i,j,k,5)))
               if ( tmp .eq. 0.0 ) then
                  cen(i,j,k) = 0.0D0
               else
                  cen(i,j,k) = 36.0D0 / tmp
               end if
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlx_terrain(
     & cor, corl0,corh0,corl1,corh1,corl2,corh2,
     & res, resl0,resh0,resl1,resh1,resl2,resh2,
     & sig, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & cen, cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     &      regl0,regh0,regl1,regh1,regl2,regh2)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision sig(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2, 5)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      double precision fac, tmp
      integer i, j, k
      integer ii, jj, kk
      double precision MXX, MYY, MZZ, MXZ, MYZ
      MXX(ii,jj,kk) = (4.0D0 *  cor(ii,j,k)   +
     &                  2.0D0 * (cor(ii,jj,k)  - cor(i,jj,k) +
     &                          cor(ii,j,kk)  - cor(i,j,kk)) +
     &                         (cor(ii,jj,kk) - cor(i,jj,kk)))

      MYY(ii,jj,kk) = (4.0D0 *  cor(i,jj,k)   +
     &                  2.0D0 * (cor(ii,jj,k)  - cor(ii,j,k) +
     &                          cor(i,jj,kk)  - cor(i,j,kk)) +
     &                         (cor(ii,jj,kk) - cor(ii,j,kk)))

      MZZ(ii,jj,kk) = (4.0D0 *  cor(i,j,kk)   +
     &                  2.0D0 * (cor(ii,j,kk)  - cor(ii,j,k) +
     &                          cor(i,jj,kk)  - cor(i,jj,k)) +
     &                         (cor(ii,jj,kk) - cor(ii,jj,k)))

      MXZ(ii,jj,kk) = (6.0D0 *  cor(ii,j,kk)  +
     &                  3.0D0 * (cor(ii,jj,kk) - cor(i,jj,k)))

      MYZ(ii,jj,kk) = (6.0D0 *  cor(i,jj,kk)  +
     &                  3.0D0 * (cor(ii,jj,kk) - cor(ii,j,k)))
      fac = 1.0D0 / 36
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
cdir$ ivdep
                  tmp = sig(i-1,j-1,k-1,1) * MXX(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,1) * MXX(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,1) * MXX(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,1) * MXX(i-1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i  ,j-1,k-1,1) * MXX(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,1) * MXX(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,1) * MXX(i+1,j+1,k-1) +
     &                  sig(i  ,j  ,k  ,1) * MXX(i+1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i-1,j-1,k-1,2) * MYY(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,2) * MYY(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,2) * MYY(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,2) * MYY(i-1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i  ,j-1,k-1,2) * MYY(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,2) * MYY(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,2) * MYY(i+1,j+1,k-1) +
     &                  sig(i  ,j  ,k  ,2) * MYY(i+1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i-1,j-1,k-1,3) * MZZ(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,3) * MZZ(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,3) * MZZ(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,3) * MZZ(i-1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i  ,j-1,k-1,3) * MZZ(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,3) * MZZ(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,3) * MZZ(i+1,j+1,k-1) +
     &                  sig(i  ,j  ,k  ,3) * MZZ(i+1,j+1,k+1)
                  tmp = tmp -
     &                  sig(i-1,j-1,k-1,4) * MXZ(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,4) * MXZ(i-1,j-1,k+1) -
     &                  sig(i-1,j  ,k-1,4) * MXZ(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,4) * MXZ(i-1,j+1,k+1) +
     &                  sig(i  ,j-1,k-1,4) * MXZ(i+1,j-1,k-1) -
     &                  sig(i  ,j-1,k  ,4) * MXZ(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,4) * MXZ(i+1,j+1,k-1) -
     &                  sig(i  ,j  ,k  ,4) * MXZ(i+1,j+1,k+1)
                  tmp = tmp -
     &                  sig(i-1,j-1,k-1,5) * MYZ(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,5) * MYZ(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,5) * MYZ(i-1,j+1,k-1) -
     &                  sig(i-1,j  ,k  ,5) * MYZ(i-1,j+1,k+1) -
     &                  sig(i  ,j-1,k-1,5) * MYZ(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,5) * MYZ(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,5) * MYZ(i+1,j+1,k-1) -
     &                  sig(i  ,j  ,k  ,5) * MYZ(i+1,j+1,k+1)
                  cor(i,j,k) = (fac * tmp - res(i,j,k)) * cen(i,j,k)
               end do
            end do
         end do
      end
c cor substituted for dest to use same macro:
c-----------------------------------------------------------------------
      subroutine hgres_terrain(
     & res, resl0,resh0,resl1,resh1,resl2,resh2,
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & cor, destl0,desth0,destl1,desth1,destl2,desth2,
     & sig, sfl0,sfh0,sfl1,sfh1,sfl2,sfh2,
     & cen, cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     &      regl0,regh0,regl1,regh1,regl2,regh2)
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer sfl0,sfh0,sfl1,sfh1,sfl2,sfh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision cor(destl0:desth0,destl1:desth1,destl2:desth2)
      double precision sig(sfl0:sfh0,sfl1:sfh1,sfl2:sfh2, 5)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      double precision fac, tmp
      integer i, j, k
      integer ii, jj, kk
      double precision MXX, MYY, MZZ, MXZ, MYZ
      MXX(ii,jj,kk) = (4.0D0 *  cor(ii,j,k)   +
     &                  2.0D0 * (cor(ii,jj,k)  - cor(i,jj,k) +
     &                          cor(ii,j,kk)  - cor(i,j,kk)) +
     &                         (cor(ii,jj,kk) - cor(i,jj,kk)))

      MYY(ii,jj,kk) = (4.0D0 *  cor(i,jj,k)   +
     &                  2.0D0 * (cor(ii,jj,k)  - cor(ii,j,k) +
     &                          cor(i,jj,kk)  - cor(i,j,kk)) +
     &                         (cor(ii,jj,kk) - cor(ii,j,kk)))

      MZZ(ii,jj,kk) = (4.0D0 *  cor(i,j,kk)   +
     &                  2.0D0 * (cor(ii,j,kk)  - cor(ii,j,k) +
     &                          cor(i,jj,kk)  - cor(i,jj,k)) +
     &                         (cor(ii,jj,kk) - cor(ii,jj,k)))

      MXZ(ii,jj,kk) = (6.0D0 *  cor(ii,j,kk)  +
     &                  3.0D0 * (cor(ii,jj,kk) - cor(i,jj,k)))

      MYZ(ii,jj,kk) = (6.0D0 *  cor(i,jj,kk)  +
     &                  3.0D0 * (cor(ii,jj,kk) - cor(ii,j,k)))
      fac = 1.0D0 / 36
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  tmp = sig(i-1,j-1,k-1,1) * MXX(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,1) * MXX(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,1) * MXX(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,1) * MXX(i-1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i  ,j-1,k-1,1) * MXX(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,1) * MXX(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,1) * MXX(i+1,j+1,k-1) +
     &                  sig(i  ,j  ,k  ,1) * MXX(i+1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i-1,j-1,k-1,2) * MYY(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,2) * MYY(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,2) * MYY(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,2) * MYY(i-1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i  ,j-1,k-1,2) * MYY(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,2) * MYY(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,2) * MYY(i+1,j+1,k-1) +
     &                  sig(i  ,j  ,k  ,2) * MYY(i+1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i-1,j-1,k-1,3) * MZZ(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,3) * MZZ(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,3) * MZZ(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,3) * MZZ(i-1,j+1,k+1)
                  tmp = tmp +
     &                  sig(i  ,j-1,k-1,3) * MZZ(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,3) * MZZ(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,3) * MZZ(i+1,j+1,k-1) +
     &                  sig(i  ,j  ,k  ,3) * MZZ(i+1,j+1,k+1)
                  tmp = tmp -
     &                  sig(i-1,j-1,k-1,4) * MXZ(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,4) * MXZ(i-1,j-1,k+1) -
     &                  sig(i-1,j  ,k-1,4) * MXZ(i-1,j+1,k-1) +
     &                  sig(i-1,j  ,k  ,4) * MXZ(i-1,j+1,k+1) +
     &                  sig(i  ,j-1,k-1,4) * MXZ(i+1,j-1,k-1) -
     &                  sig(i  ,j-1,k  ,4) * MXZ(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,4) * MXZ(i+1,j+1,k-1) -
     &                  sig(i  ,j  ,k  ,4) * MXZ(i+1,j+1,k+1)
                  tmp = tmp -
     &                  sig(i-1,j-1,k-1,5) * MYZ(i-1,j-1,k-1) +
     &                  sig(i-1,j-1,k  ,5) * MYZ(i-1,j-1,k+1) +
     &                  sig(i-1,j  ,k-1,5) * MYZ(i-1,j+1,k-1) -
     &                  sig(i-1,j  ,k  ,5) * MYZ(i-1,j+1,k+1) -
     &                  sig(i  ,j-1,k-1,5) * MYZ(i+1,j-1,k-1) +
     &                  sig(i  ,j-1,k  ,5) * MYZ(i+1,j-1,k+1) +
     &                  sig(i  ,j  ,k-1,5) * MYZ(i+1,j+1,k-1) -
     &                  sig(i  ,j  ,k  ,5) * MYZ(i+1,j+1,k+1)
c
c NOTE:  The logic below to allow for cen=0, matches a set of logic in
c        hgcen where cen is calculated as cen=C/(sum of sigmas).  If the 
c        sum of the sigmas is zero, then cen is set to zero.  So, the 
c        logic here allows for the case of zero sigmas by eliminating the 
c
                  if (cen(i,j,k) .ne. 0.0D0) then
                     res(i,j,k) = src(i,j,k)
     &                  - fac * tmp + cor(i,j,k) / cen(i,j,k)
                  else
                     res(i,j,k) = src(i,j,k) - fac * tmp
                  end if
               end do
            end do
         end do
      end
c-----------------------------------------------------------------------
      subroutine hgrlnf_terrain(
     & cor,   corl0,corh0,corl1,corh1,corl2,corh2,
     & res,   resl0,resh0,resl1,resh1,resl2,resh2,
     & wrk,   wrkl0,wrkh0,wrkl1,wrkh1,wrkl2,wrkh2,
     & signd, snl0,snh0,snl1,snh1,snl2,snh2,
     & cen,   cenl0,cenh0,cenl1,cenh1,cenl2,cenh2,
     &        regl0,regh0,regl1,regh1,regl2,regh2,
     &        doml0,domh0,doml1,domh1,doml2,domh2,
     & lsd, ipass)
      integer corl0,corh0,corl1,corh1,corl2,corh2
      integer resl0,resh0,resl1,resh1,resl2,resh2
      integer wrkl0,wrkh0,wrkl1,wrkh1,wrkl2,wrkh2
      integer snl0,snh0,snl1,snh1,snl2,snh2
      integer cenl0,cenh0,cenl1,cenh1,cenl2,cenh2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer doml0,domh0,doml1,domh1,doml2,domh2
      double precision cor(corl0:corh0,corl1:corh1,corl2:corh2)
      double precision res(resl0:resh0,resl1:resh1,resl2:resh2)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1,wrkl2:wrkh2)
      double precision signd(snl0:snh0,snl1:snh1,snl2:snh2, 3)
      double precision cen(cenl0:cenh0,cenl1:cenh1,cenl2:cenh2)
      integer lsd, ipass
      stop 'hgrlnf_terrain: no code'
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include <REAL.H>

#include "DivVis_F.H"
#include <LO_BCTYPES.H>
#include "ArrayLim.H"

c :::: usage:
c :::: this .mF file is meant to be run through Mathematica.  This converts
c :::: compact symbolic expressions into fortran which is stored in a .F
c :::: file.

c----------------------------------------------------------------
c     this is the fortran support file for the the operator 
c     L(U) = alpha*a(x)*U - beta*Div( tau )
c
c     where U is the two component vector (u,v) and
c     tau is a two by two tensor
c     tau = | t_xx     t_xy |
c           | t_xy     t_yy |
c
c     t_xx = 2*mu * u_x
c     t_xy = mu*(u_y + v_x)
c     t_yy = 2*mu * v_y

c     and alpha is a diagonal 2x2 matrix, says rick

c ::: define standard replacements used by Mathematica
c ::: see file visc2d.ma
c ::: Null

c ::: interface notes:
c ::: 1) trander* ALWAYS have values in them, even if the cells are
c :::    all covered.  Might as well.  These are edge located derivative
c :::    values.  In index space, they are located the same as the mask
c :::    cells.  Which is somewhat anomalous.  These are edge values, after
c :::    all.  While the masks are cell-centered.  But it seems easier
c :::    at the moment.
c ::: 2) the normal derivatives are evaluated in the normal fashion.
c ::: 3) tangential derivatives which reach outside the rectangle DO have
c :::    to check the masks.  

      subroutine FORT_DVAPPLY(
     $     u, DIMS(u),
     $     alpha, beta,
     $     a, DIMS(a),
     $     muX, DIMS(muX),
     $     muY, DIMS(muY),
     $     out, DIMS(out),
     $     maskn,DIMS(maskn),
     $     maske,DIMS(maske),
     $     maskw,DIMS(maskw),
     $     masks,DIMS(masks),
     $     trandern,DIMS(trandern),
     $     trandere,DIMS(trandere),
     $     tranderw,DIMS(tranderw),
     $     tranders,DIMS(tranders),
     $     lo,hi,h
     $     )
      REAL_T alpha, beta
      integer DIMDEC(u)
      integer DIMDEC(a)
      integer DIMDEC(muX)
      integer DIMDEC(muY)
      integer DIMDEC(out)
      integer DIMDEC(maskn)
      integer DIMDEC(maske)
      integer DIMDEC(maskw)
      integer DIMDEC(masks)
      integer DIMDEC(trandern)
      integer DIMDEC(trandere)
      integer DIMDEC(tranderw)
      integer DIMDEC(tranders)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      REAL_T h(BL_SPACEDIM)
      REAL_T u(DIMV(u),2)
      REAL_T a(DIMV(a),2)
      REAL_T muX(DIMV(muX))
      REAL_T muY(DIMV(muY))
      REAL_T out(DIMV(out),2)
      integer  maskn(DIMV(maskn))
      integer  maske(DIMV(maske))
      integer  maskw(DIMV(maskw))
      integer  masks(DIMV(masks))

      REAL_T trandern(DIMV(trandern),2)
      REAL_T trandere(DIMV(trandere),2)
      REAL_T tranderw(DIMV(tranderw),2)
      REAL_T tranders(DIMV(tranders),2)

      integer i,j
      REAL_T tauxxw,tauxxe,tauyyn,tauyys
      REAL_T tauxye,tauxyw,tauxyn,tauxys
      REAL_T hx,hy
      REAL_T dudxe,dudxw
      REAL_T dvdyn,dvdys
      REAL_T dudye,dudyw,dudyn,dudys
      REAL_T dvdxe,dvdxw,dvdxn,dvdxs
      logical False, True
      parameter( False=.false.)
      parameter( True=.true. )

      hx = h(1)
      hy = h(2)

c ::: make some mathematica definitions
c ::: allDerivAllUV makes replacements for the deriv expressions and
c ::: maps U and V to the correct values
c ::: Null

c ::: cases:
c     ::: 1) interior.  All normal derivative expressions
c     ::: 2) edge but not on corner.  check mask value to see if use outside
c     :::    value or use interpolations
c     ::: 3) corners.  Must check mask values to see if use outside values
c     :::    values or use interpolations ON TWO SIDES.  But must also
c     :::    check to see if need to do one-sided derivs for tangential
c     :::    derivatives.

c ::: case 1
      do j=lo(2)+1,hi(2)-1
         do i=lo(1)+1,hi(1)-1
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)

            dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
         enddo
      enddo

c ::: ::: case 2a: north side
c ::: Null
c ::: Null
c :::
      j = hi(2)
         do i=lo(1)+1,hi(1)-1
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( maskn(i,1 + j).gt.0.or.maskn(1 + i,1 + j).gt.0 ) then
               dudye =         ((U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy) + 
     -    (U(1 + i,-2 + j,1) - 4*U(1 + i,-1 + j,1) + 3*U(1 + i,j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            if( maskn(-1 + i,1 + j).gt.0.or.maskn(i,1 + j).gt.0 ) then
               dudyw =         ((U(-1 + i,-2 + j,1) - 4*U(-1 + i,-1 + j,1) + 3*U(-1 + i,j,1))/
     -     (2.*hy) + (U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy))/
     -  2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn = trandern(i,j+1,2)
            dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
         enddo

c ::: case 2b south side
c ::: Null
c ::: Null
      j=lo(2)
         do i=lo(1)+1,hi(1)-1
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( masks(i,-1 + j).gt.0.or.masks(1 + i,-1 + j).gt.0 ) then
               dudye =         ((-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy) + 
     -    (-3*U(1 + i,j,1) + 4*U(1 + i,1 + j,1) - U(1 + i,2 + j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            if( masks(-1 + i,-1 + j).gt.0.or.masks(i,-1 + j).gt.0 ) then
               dudyw =         ((-3*U(-1 + i,j,1) + 4*U(-1 + i,1 + j,1) - U(-1 + i,2 + j,1))/
     -     (2.*hy) + (-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy))/2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
         enddo


c ::: case 2c: west side story
c ::: Null
c ::: Null
      i=lo(1)
      do j=lo(2)+1,hi(2)-1
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            dudyw = tranderw(i-1,j,1)

            if( maskw(-1 + i,j).gt.0.or.maskw(-1 + i,1 + j).gt.0 ) then
               dvdxn =         ((-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx) + 
     -    (-3*U(i,1 + j,2) + 4*U(1 + i,1 + j,2) - U(2 + i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            if( maskw(-1 + i,-1 + j).gt.0.or.maskw(-1 + i,j).gt.0 ) then
               dvdxs =         ((-3*U(i,-1 + j,2) + 4*U(1 + i,-1 + j,2) - U(2 + i,-1 + j,2))/
     -     (2.*hx) + (-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx))/2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
      enddo

c ::: case 2d: east side story
c ::: Null
c ::: Null
      i=hi(1)
      do j=lo(2)+1,hi(2)-1
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)

            if( maske(1 + i,j).gt.0.or.maske(1 + i,1 + j).gt.0 ) then
               dvdxn =         ((U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx) + 
     -    (U(-2 + i,1 + j,2) - 4*U(-1 + i,1 + j,2) + 3*U(i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            if( maske(1 + i,-1 + j).gt.0.or.maske(1 + i,j).gt.0 ) then
               dvdxs =         ((U(-2 + i,-1 + j,2) - 4*U(-1 + i,-1 + j,2) + 3*U(i,-1 + j,2))/
     -     (2.*hx) + (U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx))/
     -  2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
         enddo

c ::: case 3a: north-east corner
c ::: Null
c ::: Null
      j=hi(2)
      i=hi(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            if( maskn(-1 + i,1 + j).gt.0.or.maskn(i,1 + j).gt.0 ) then
               dudyw =         ((U(-1 + i,-2 + j,1) - 4*U(-1 + i,-1 + j,1) + 3*U(-1 + i,j,1))/
     -     (2.*hy) + (U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy))/
     -  2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn = trandern(i,j+1,2)
            if( maske(1 + i,-1 + j).gt.0.or.maske(1 + i,j).gt.0 ) then
               dvdxs =         ((U(-2 + i,-1 + j,2) - 4*U(-1 + i,-1 + j,2) + 3*U(i,-1 + j,2))/
     -     (2.*hx) + (U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx))/
     -  2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)

c ::: case 3b: south-east corner, plus i, minus j, plus i, plus j
c ::: Null
      j=lo(2)
      i=hi(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            if( masks(-1 + i,-1 + j).gt.0.or.masks(i,-1 + j).gt.0 ) then 
               dudyw =         ((-3*U(-1 + i,j,1) + 4*U(-1 + i,1 + j,1) - U(-1 + i,2 + j,1))/
     -     (2.*hy) + (-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy))/2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            if( maske(1 + i,j).gt.0.or.maske(1 + i,1 + j).gt.0 ) then
               dvdxn =         ((U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx) + 
     -    (U(-2 + i,1 + j,2) - 4*U(-1 + i,1 + j,2) + 3*U(i,1 + j,2))/(2.*hx))/
     -  2. 
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)

c ::: case 3c: south-west corner, minus i, minus j
c ::: Null
      j=lo(2)
      i=lo(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( masks(i,-1 + j).gt.0.or.masks(1 + i,-1 + j).gt.0 ) then
               dudye =         ((-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy) + 
     -    (-3*U(1 + i,j,1) + 4*U(1 + i,1 + j,1) - U(1 + i,2 + j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            dudyw = tranderw(i-1,j,1)

            if( maskw(-1 + i,j).gt.0.or.maskw(-1 + i,1 + j).gt.0 ) then
               dvdxn =         ((-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx) + 
     -    (-3*U(i,1 + j,2) + 4*U(1 + i,1 + j,2) - U(2 + i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)

c ::: case 3d: north-west corner, minus i, plus j
c ::: Null
      j=hi(2)
      i=lo(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( maskn(i,1 + j).gt.0.or.maskn(1 + i,1 + j).gt.0 ) then
               dudye =         ((U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy) + 
     -    (U(1 + i,-2 + j,1) - 4*U(1 + i,-1 + j,1) + 3*U(1 + i,j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            dudyw = tranderw(i-1,j,1)

            dvdxn = trandern(i,j+1,2)
            if( maskw(-1 + i,-1 + j).gt.0.or.maskw(-1 + i,j).gt.0 ) then
               dvdxs =         ((-3*U(i,-1 + j,2) + 4*U(1 + i,-1 + j,2) - U(2 + i,-1 + j,2))/
     -     (2.*hx) + (-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx))/2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            out(i,j,1) =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            out(i,j,2) =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)



      return
      end


c -------------------------------------------------------------------
c ... a point of interpretation here: lo and hi are the covered area in
c ... cell centered coordinates.  The dimension of the x and y fluxes have
c ... to be at least one larger in the appropriate direction.
c ... we use the "usual" interpretation of fluxes: cell i has a left flux
c ... numbered i and a right flux numbered i+1

      subroutine FORT_DVFLUX(
     $     u, DIMS(u),
     $     alpha, beta,
     $     a, DIMS(a),
     $     muX, DIMS(muX),
     $     muY, DIMS(muY),
     $     xflux,DIMS(xflux),
     $     yflux,DIMS(yflux),
     $     maskn,DIMS(maskn),
     $     maske,DIMS(maske),
     $     maskw,DIMS(maskw),
     $     masks,DIMS(masks),
     $     trandern,DIMS(trandern),
     $     trandere,DIMS(trandere),
     $     tranderw,DIMS(tranderw),
     $     tranders,DIMS(tranders),
     $     lo,hi,h
     $     )
      REAL_T alpha, beta
      integer DIMDEC(u)
      integer DIMDEC(a)
      integer DIMDEC(muX)
      integer DIMDEC(muY)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(maskn)
      integer DIMDEC(maske)
      integer DIMDEC(maskw)
      integer DIMDEC(masks)
      integer DIMDEC(trandern)
      integer DIMDEC(trandere)
      integer DIMDEC(tranderw)
      integer DIMDEC(tranders)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      REAL_T h(BL_SPACEDIM)
      REAL_T u(DIMV(u),2)
      REAL_T a(DIMV(a),2)
      REAL_T muX(DIMV(muX))
      REAL_T muY(DIMV(muY))
      REAL_T xflux(DIMV(xflux),2)
      REAL_T yflux(DIMV(yflux),2)
      integer  maskn(DIMV(maskn))
      integer  maske(DIMV(maske))
      integer  maskw(DIMV(maskw))
      integer  masks(DIMV(masks))

      REAL_T trandern(DIMV(trandern),2)
      REAL_T trandere(DIMV(trandere),2)
      REAL_T tranderw(DIMV(tranderw),2)
      REAL_T tranders(DIMV(tranders),2)

      integer i,j
      REAL_T tauxxw,tauxxe,tauyyn,tauyys
      REAL_T tauxye,tauxyw,tauxyn,tauxys
      REAL_T hx,hy
      REAL_T dudxe,dudxw
      REAL_T dvdyn,dvdys
      REAL_T dudye,dudyw,dudyn,dudys
      REAL_T dvdxe,dvdxw,dvdxn,dvdxs
      logical False, True
      parameter( False=.false.)
      parameter( True=.true. )

      hx = h(1)
      hy = h(2)

c ::: make some mathematica definitions
c ::: allDerivAllUV makes replacements for the deriv expressions and
c ::: maps U and V to the correct values
c ::: Null

c ::: cases:
c     ::: 1) interior.  All normal derivative expressions
c     ::: 2) edge but not on corner.  check mask value to see if use outside
c     :::    value or use interpolations
c     ::: 3) corners.  Must check mask values to see if use outside values
c     :::    values or use interpolations ON TWO SIDES.  But must also
c     :::    check to see if need to do one-sided derivs for tangential
c     :::    derivatives.

c ::: case 1
      do j=lo(2)+1,hi(2)
         do i=lo(1)+1,hi(1)
c     :::  get expressions for appropriate derivatives
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)

            dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
         enddo
      enddo

c ::: ::: case 2a: north side
c ::: Null
c ::: Null
c :::
      j = hi(2)
         do i=lo(1)+1,hi(1)-1
c     :::  get expressions for appropriate derivatives
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            if( maskn(-1 + i,1 + j).gt.0.or.maskn(i,1 + j).gt.0 ) then
               dudyw =         ((U(-1 + i,-2 + j,1) - 4*U(-1 + i,-1 + j,1) + 3*U(-1 + i,j,1))/
     -     (2.*hy) + (U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy))/
     -  2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn = trandern(i,j+1,2)
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            yflux(i,j+1,1) = -((dudyn + dvdxn)*muY(i,1 + j))
            yflux(i,j+1,2) = -(2*dvdyn*muY(i,1 + j))
         enddo

c ::: case 2b south side
c ::: Null
c ::: Null
      j=lo(2)
         do i=lo(1)+1,hi(1)-1
c     :::  get expressions for appropriate derivatives
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( masks(-1 + i,-1 + j).gt.0.or.masks(i,-1 + j).gt.0 ) then
               dudyw =         ((-3*U(-1 + i,j,1) + 4*U(-1 + i,1 + j,1) - U(-1 + i,2 + j,1))/
     -     (2.*hy) + (-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy))/2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxs = tranders(i,j-1,2)
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
         enddo


c ::: case 2c: west side story
c ::: Null
c ::: Null
      i=lo(1)
      do j=lo(2)+1,hi(2)-1
c     :::  get expressions for appropriate derivatives
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudyw = tranderw(i-1,j,1)

            if( maskw(-1 + i,-1 + j).gt.0.or.maskw(-1 + i,j).gt.0 ) then
               dvdxs =         ((-3*U(i,-1 + j,2) + 4*U(1 + i,-1 + j,2) - U(2 + i,-1 + j,2))/
     -     (2.*hx) + (-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx))/2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
      enddo

c ::: case 2d: east side story
c ::: Null
c ::: Null
      i=hi(1)
      do j=lo(2)+1,hi(2)-1
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx

            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)

            if( maske(1 + i,-1 + j).gt.0.or.maske(1 + i,j).gt.0 ) then
               dvdxs =         ((U(-2 + i,-1 + j,2) - 4*U(-1 + i,-1 + j,2) + 3*U(i,-1 + j,2))/
     -     (2.*hx) + (U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx))/
     -  2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
c     :::  evaluate expression
            xflux(i+1,j,1) = -(2*dudxe*muX(1 + i,j))
            xflux(i+1,j,2) = -((dudye + dvdxe)*muX(1 + i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
         enddo

c ::: case 3a: north-east corner
c ::: Null
c ::: Null
      j=hi(2)
      i=hi(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            if( maskn(-1 + i,1 + j).gt.0.or.maskn(i,1 + j).gt.0 ) then
               dudyw =         ((U(-1 + i,-2 + j,1) - 4*U(-1 + i,-1 + j,1) + 3*U(-1 + i,j,1))/
     -     (2.*hy) + (U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy))/
     -  2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn = trandern(i,j+1,2)
            if( maske(1 + i,-1 + j).gt.0.or.maske(1 + i,j).gt.0 ) then
               dvdxs =         ((U(-2 + i,-1 + j,2) - 4*U(-1 + i,-1 + j,2) + 3*U(i,-1 + j,2))/
     -     (2.*hx) + (U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx))/
     -  2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            xflux(i+1,j,1) = -(2*dudxe*muX(1 + i,j))
            xflux(i+1,j,2) = -((dudye + dvdxe)*muX(1 + i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
            yflux(i,j+1,1) = -((dudyn + dvdxn)*muY(i,1 + j))
            yflux(i,j+1,2) = -(2*dvdyn*muY(i,1 + j))

c ::: case 3b: south-east corner, plus i, minus j, plus i, plus j
c ::: Null
      j=lo(2)
      i=hi(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            if( masks(-1 + i,-1 + j).gt.0.or.masks(i,-1 + j).gt.0 ) then 
               dudyw =         ((-3*U(-1 + i,j,1) + 4*U(-1 + i,1 + j,1) - U(-1 + i,2 + j,1))/
     -     (2.*hy) + (-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy))/2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            if( maske(1 + i,j).gt.0.or.maske(1 + i,1 + j).gt.0 ) then
               dvdxn =         ((U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx) + 
     -    (U(-2 + i,1 + j,2) - 4*U(-1 + i,1 + j,2) + 3*U(i,1 + j,2))/(2.*hx))/
     -  2. 
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            xflux(i+1,j,1) = -(2*dudxe*muX(1 + i,j))
            xflux(i+1,j,2) = -((dudye + dvdxe)*muX(1 + i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
            yflux(i,j+1,1) = -((dudyn + dvdxn)*muY(i,1 + j))
            yflux(i,j+1,2) = -(2*dvdyn*muY(i,1 + j))

c ::: case 3c: south-west corner, minus i, minus j
c ::: Null
      j=lo(2)
      i=lo(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( masks(i,-1 + j).gt.0.or.masks(1 + i,-1 + j).gt.0 ) then
               dudye =         ((-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy) + 
     -    (-3*U(1 + i,j,1) + 4*U(1 + i,1 + j,1) - U(1 + i,2 + j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            dudyw = tranderw(i-1,j,1)

            if( maskw(-1 + i,j).gt.0.or.maskw(-1 + i,1 + j).gt.0 ) then
               dvdxn =         ((-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx) + 
     -    (-3*U(i,1 + j,2) + 4*U(1 + i,1 + j,2) - U(2 + i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            xflux(i+1,j,1) = -(2*dudxe*muX(1 + i,j))
            xflux(i+1,j,2) = -((dudye + dvdxe)*muX(1 + i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
            yflux(i,j+1,1) = -((dudyn + dvdxn)*muY(i,1 + j))
            yflux(i,j+1,2) = -(2*dvdyn*muY(i,1 + j))

c ::: case 3d: north-west corner, minus i, plus j
c ::: Null
      j=hi(2)
      i=lo(1)
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( maskn(i,1 + j).gt.0.or.maskn(1 + i,1 + j).gt.0 ) then
               dudye =         ((U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy) + 
     -    (U(1 + i,-2 + j,1) - 4*U(1 + i,-1 + j,1) + 3*U(1 + i,j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            dudyw = tranderw(i-1,j,1)

            dvdxn = trandern(i,j+1,2)
            if( maskw(-1 + i,-1 + j).gt.0.or.maskw(-1 + i,j).gt.0 ) then
               dvdxs =         ((-3*U(i,-1 + j,2) + 4*U(1 + i,-1 + j,2) - U(2 + i,-1 + j,2))/
     -     (2.*hx) + (-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx))/2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  evaluate expression
            xflux(i,j,1) = -(2*dudxw*muX(i,j))
            xflux(i,j,2) = -((dudyw + dvdxw)*muX(i,j))
            xflux(i+1,j,1) = -(2*dudxe*muX(1 + i,j))
            xflux(i+1,j,2) = -((dudye + dvdxe)*muX(1 + i,j))
            yflux(i,j,1) = -((dudys + dvdxs)*muY(i,j))
            yflux(i,j,2) = -(2*dvdys*muY(i,j))
            yflux(i,j+1,1) = -((dudyn + dvdxn)*muY(i,1 + j))
            yflux(i,j+1,2) = -(2*dvdyn*muY(i,1 + j))



      return
      end



c-----------------------------------------------------------------------
      subroutine FORT_APPLYBC (
     $     flagden, flagbc, maxorder,
     $     u,   DIMS(u),
     $     cdir, bct, bcl,
     $     bcval, DIMS(bcval),
     $     mask,  DIMS(mask),
     $     maskp, DIMS(maskp),
     $     maskm, DIMS(maskm),
     $     den,   DIMS(den),
     $     exttd, DIMS(exttd),
     $     tander,DIMS(tander),
     $     lo, hi, nc,
     $     h
     $     )
c
c     If the boundary is of Neumann type, set the ghost cell value to
c     that of the outermost point in the valid data (2nd order accurate)
c     and then fill the "den" array with the value "1"
c     
c     
c     If flagbc==1:
c     
c     If the boundary is of Dirichlet type, construct a polynomial
c     interpolation through the boundary location and internal points
c     (at locations x(-1:len-2) that generates the ghost cell value (at
c     location xInt).  Then fill the ghost cell with the interpolated value.
c     If flagden==1, load the "den" array with the interpolation
c     coefficient corresponding to outermost point in the valid region
c     ( the coef(0) corresponding to the location x(0) )
c      
c     Note: 
c     The bc type = LO_REFLECT_ODD is a special type of boundary condition.

c ::: the old FORT_APPLYBC put values out in ghost cells.  The new
c ::: FORT_APPLYBC makes a distinction between normal and tangential derivs.
c ::: the normal derivatives are still evaluated with ghost cells ( and
c ::: the den array for adjusting the diagonal element).  Tangential
c ::: derivatives are NOT computed from the ghost cells (note: we are
c ::: discussing here the tangential derivates which are centered on the
c ::: external cells walls of the rectangular domain.  Internal tangential
c ::: derivatives whose stencil extends outside the rectangular domain have
c ::: still ANOTHER calculational trick, one sided derivatives, which is 
c ::: implemented in the apply operator).  For these tangential derivatives,
c ::: if some of the cells in the stencil are uncovered, the derivative is
c ::: computed half from cells which are internal, plus an externally supplied
c ::: tangential derivative centered at location bcl.
c ??? exttd is the externally supplied tangential derivative which is
c ??? centered at bcl from wall.  Since the location of exttd is
c ??? indeterminate (determined by bcl), we arbitrarily index it in the
c ??? cell just outside the wall.
c ??? tander is the calculated tangential derivative which is centered at
c ??? at the wall.  It is indexed as if it were a cell centered quantity
c ??? just outside the wall.  This is anomalous since it is really edge
c ??? centered on the outer wall.
c      
c ::: other notes since previous developers didn't bother to document
c ::: cdir is mnemonic for coordinate direction, i.e. which side this is
c ::: cdir==0 -> left wall
c ::: cdir==2 -> right
c ::: cdir==1 -> bottom
c ::: cdir==3 -> top

c ::: notes about mask
c ::: since we now require other masks, there are 3.
c ::: 1) mask -- the main one covering the cells off the side of valid domain.
c ::: 2) maskp -- the plus end of transverse direction
c ::: 3) maskn -- the minus end of transverse direction

      integer maxorder
      integer nc, cdir, flagden, flagbc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(u)
      REAL_T u(DIMV(u),nc)
      integer DIMDEC(den)
      REAL_T den(DIMV(den),nc)
      integer DIMDEC(exttd)
      REAL_T exttd(DIMV(exttd),nc)
      integer DIMDEC(tander)
      REAL_T tander(DIMV(tander),nc)
      integer DIMDEC(bcval)
      REAL_T bcval(DIMV(bcval),nc)
      integer DIMDEC(mask)
      integer mask(DIMV(mask))
      integer DIMDEC(maskp)
      integer maskp(DIMV(maskp))
      integer DIMDEC(maskm)
      integer maskm(DIMV(maskm))
      integer bct(nc)
      REAL_T bcl
      REAL_T h(BL_SPACEDIM)
c
      REAL_T hx,hy,lambda
      REAL_T innder,outder
      REAL_T innloc,outloc,edgloc
      integer i
      integer j
      integer n
      logical is_dirichlet
      logical is_neumann
      logical is_odd
      REAL_T xb
c
      integer lenx
      integer leny
      integer m
c
      integer Lmaxorder
      integer maxmaxorder
      parameter(maxmaxorder=4)
      REAL_T x(-1:maxmaxorder-2)
      REAL_T coef(-1:maxmaxorder-2)
      REAL_T xInt
c
      logical False, True
      parameter( False=.false.)
      parameter( True=.true. )
c
      is_dirichlet(i) = ( i .eq. LO_DIRICHLET   )
      is_neumann(i)   = ( i .eq. LO_NEUMANN )
      hx = h(1)
      hy = h(2)
c
      if ( maxorder .eq. -1 ) then
         Lmaxorder = maxmaxorder
      else
         Lmaxorder = MIN(maxorder,maxmaxorder)
      endif
      lenx = MIN(hi(1)-lo(1), Lmaxorder-2)
      leny = MIN(hi(2)-lo(2), Lmaxorder-2)
c
c     TODO:
c     In order for this to work with growing multigrid, must
c     sort xa[] because it is possible for the xb value to lay
c     within this range.
c     
c     The Left face of the grid
c
      if(cdir .eq. 0) then
         do n = 1, nc
            if (is_neumann(bct(n))) then
               do j = lo(2), hi(2)
                  u(lo(1)-1,j,n) = cvmgt(
     $                 u(lo(1),j,n),
     $                 u(lo(1)-1,j,n),
     $                 mask(lo(1)-1,j) .gt. 0)
               enddo
               if ( flagden .eq. 1) then
                  do j = lo(2), hi(2)
                     den(lo(1),j,n) = 1.0
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: Null
c     :::::: interior part of left side
               i = lo(1)
               do j=lo(2)+1,hi(2)-1
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
                  tander(i-1,j,n) = innder
               enddo
c     :::::: now end points
c     :::::: lower leftside
               j = lo(2)
               if( maskm(i,-1 + j).gt.0 ) then
                    innder = (-3*U(i,j,n) + 4*U(i,1 + j,n) - U(i,2 + j,n))/(2.*hy)
               else
                   innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
               endif
               tander(i-1,j,n) = innder
c     :::::: upper left side
                j = hi(2)
                if( maskp(i,1 + j).gt.0 ) then
                   innder = (U(i,-2 + j,n) - 4*U(i,-1 + j,n) + 3*U(i,j,n))/(2.*hy)
                else
                   innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
                endif
                tander(i-1,j,n) = innder
            else if (is_dirichlet(bct(n))) then
               do m=0,lenx
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(1)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, lenx+2, coef)
               if ( flagbc .eq. 1 ) then
                  do j = lo(2), hi(2)
                     u(lo(1)-1, j, n) = cvmgt(
     $                    bcval(lo(1)-1,j,n)*coef(-1),
     $                    u(lo(1)-1, j, n),
     $                    mask(lo(1)-1,j) .gt. 0)
                  enddo
               else
                  do j = lo(2), hi(2)
                     u(lo(1)-1, j, n) = cvmgt(
     $                    0.0,
     $                    u(lo(1)-1, j, n),
     $                    mask(lo(1)-1,j) .gt. 0)
                  enddo
               endif
               do m = 0, lenx
                  do j = lo(2), hi(2)
                     u(lo(1)-1,j,n) = cvmgt(
     $                    u(lo(1)-1,j,n)
     $                    + u(lo(1)+m, j, n)*coef(m),
     $                    u(lo(1)-1,j,n),
     $                    mask(lo(1)-1,j) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     den(lo(1),j,n) = cvmgt(coef(0), 0.0,
     $                    mask(lo(1)-1,j) .gt. 0)
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: Null
c     :::::: interior part of left side
               edgloc = 0.
               i = lo(1)
               do j=lo(2)+1,hi(2)-1
                  if( mask(-1 + i,-1 + j).eq.0.and.mask(-1 + i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-U(-1 + i,-1 + j,n) + U(-1 + i,1 + j,n))/(2.*hy)
                  elseif( mask(-1 + i,j).eq.0.and.mask(-1 + i,1 + j).eq.0.and.mask(-1 + i,2 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-3*U(-1 + i,j,n) + 4*U(-1 + i,1 + j,n) - U(-1 + i,2 + j,n))/(2.*hy)
                  elseif( mask(-1 + i,-2 + j).eq.0.and.mask(-1 + i,-1 + j).eq.0.and.mask(-1 + i,j).eq.0 ) then
                     outloc = -0.5
                     outder = (U(-1 + i,-2 + j,n) - 4*U(-1 + i,-1 + j,n) + 3*U(-1 + i,j,n))/(2.*hy)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i-1,j,n)
                     else
                        outder = 0.
                     endif
                  endif
                  innloc = 0.5
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
            
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  tander(i-1,j,n) = lambda*innder+(1-lambda)*outder
               enddo
c     :::::: now end points
c     :::::: lower leftside
               j = lo(2)
               if( mask(-1 + i,-1 + j).eq.0.and.mask(-1 + i,1 + j).eq.0 ) then
                   outloc = -0.5
                   outder = (-U(-1 + i,-1 + j,n) + U(-1 + i,1 + j,n))/(2.*hy)
               elseif( mask(-1 + i,j).eq.0.and.mask(-1 + i,1 + j).eq.0.and.mask(-1 + i,2 + j).eq.0 ) then
                   outloc = -0.5
                   outder = (-3*U(-1 + i,j,n) + 4*U(-1 + i,1 + j,n) - U(-1 + i,2 + j,n))/(2.*hy)
               else
                   outloc = x(-1)
                   if( flagbc .eq. 1) then
                      outder = exttd(i-1,j,n)
                   else
                      outder = 0.
                   endif
               endif
               if( maskm(i,-1 + j).gt.0 ) then
                    innder = (-3*U(i,j,n) + 4*U(i,1 + j,n) - U(i,2 + j,n))/(2.*hy)
               else
                   innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i-1,j,n) = lambda*innder+(1-lambda)*outder
c     :::::: upper left side
                j = hi(2)
                if( mask(-1 + i,-1 + j).eq.0.and.mask(-1 + i,1 + j).eq.0 ) then
                   outloc = -0.5
                   outder = (-U(-1 + i,-1 + j,n) + U(-1 + i,1 + j,n))/(2.*hy)
                elseif( mask(-1 + i,-2 + j).eq.0.and.mask(-1 + i,-1 + j).eq.0.and.mask(-1 + i,j).eq.0 ) then
                   outloc = -0.5
                   outder = (U(-1 + i,-2 + j,n) - 4*U(-1 + i,-1 + j,n) + 3*U(-1 + i,j,n))/(2.*hy)
                else
                   outloc = x(-1)
                   if( flagbc .eq. 1) then
                      outder = exttd(i-1,j,n)
                   else
                      outder = 0.
                   endif
                endif
                if( maskp(i,1 + j).gt.0 ) then
                   innder = (U(i,-2 + j,n) - 4*U(i,-1 + j,n) + 3*U(i,j,n))/(2.*hy)
                else
                   innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
                endif
                innloc = 0.5
                lambda = (edgloc-outloc)/(innloc-outloc)
                tander(i-1,j,n) = lambda*innder+(1-lambda)*outder
               
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               
               do j = lo(2), hi(2)
                  u(lo(1)-1, j, n) = cvmgt(
     $                 -u(lo(1),j,n),
     $                 u(lo(1)-1, j, n),
     $                 mask(lo(1)-1,j) .gt. 0)
                  tander(lo(1)-1,j,n) = 0.0
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     den(lo(1),j,n) = cvmgt(-1.0, 0.0,
     $                    mask(lo(1)-1,j) .gt. 0)
                  enddo
               endif
               
            else 
               print *,'UNKNOWN BC ON LEFT FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c     
c     The Right face of the grid
c
      if(cdir .eq. 2) then
         do n = 1, nc
            if(is_neumann(bct(n))) then
               do j = lo(2), hi(2)
                  u(hi(1)+1,j,n) = cvmgt(
     $                 u(hi(1), j, n),
     $                 u(hi(1)+1, j, n),
     $                 mask(hi(1)+1,j) .gt. 0)
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     den(hi(1),j,n) = 1.0
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: Null
c     :::::: interior part of right side
               i = hi(1)
               do j=lo(2)+1,hi(2)-1
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
                  tander(i+1,j,n) = innder
               enddo
c :::::: now end points
c :::::: lower right side
               j = lo(2)
               if( maskm(i,-1 + j).gt.0 ) then
                  innder = (-3*U(i,j,n) + 4*U(i,1 + j,n) - U(i,2 + j,n))/(2.*hy)
               else
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
               endif
               tander(i+1,j,n) = innder
c     :::::: upper right side
               j = hi(2)
               if( maskp(i,1 + j).gt.0 ) then
                  innder = (U(i,-2 + j,n) - 4*U(i,-1 + j,n) + 3*U(i,j,n))/(2.*hy)
               else
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
               endif
               tander(i+1,j,n) = innder
            else if (is_dirichlet(bct(n))) then
               do m=0,lenx
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(1)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, lenx+2, coef)
               if ( flagbc .eq. 1 ) then
                  do j = lo(2), hi(2)
                     u(hi(1)+1,j,n) = cvmgt(
     $                    bcval(hi(1)+1,j,n)*coef(-1),
     $                    u(hi(1)+1,j,n),
     $                    mask(hi(1)+1,j) .gt. 0)
                  enddo
               else
                  do j = lo(2), hi(2)
                     u(hi(1)+1,j,n) = cvmgt(
     $                    0.0,
     $                    u(hi(1)+1,j,n),
     $                    mask(hi(1)+1,j) .gt. 0)
                  enddo
               endif
               do m = 0, lenx
                  do j = lo(2), hi(2)
                     u(hi(1)+1,j,n) = cvmgt(
     $                    u(hi(1)+1,j,n)
     $                    + u(hi(1)-m,j,n)*coef(m),
     $                    u(hi(1)+1,j,n),
     $                    mask(hi(1)+1,j) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     den(hi(1),j,n)   = cvmgt(coef(0), 0.0,
     $                    mask(hi(1)+1,j) .gt. 0)
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: Null
c     :::::: interior part of right side
               edgloc = 0.
               i = hi(1)
               do j=lo(2)+1,hi(2)-1
                  if( mask(1 + i,-1 + j).eq.0.and.mask(1 + i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-U(1 + i,-1 + j,n) + U(1 + i,1 + j,n))/(2.*hy)
                  elseif( mask(1 + i,j).eq.0.and.mask(1 + i,1 + j).eq.0.and.mask(1 + i,2 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-3*U(1 + i,j,n) + 4*U(1 + i,1 + j,n) - U(1 + i,2 + j,n))/(2.*hy)
                  elseif( mask(1 + i,-2 + j).eq.0.and.mask(1 + i,-1 + j).eq.0.and.mask(1 + i,j).eq.0 ) then
                     outloc = -0.5
                     outder = (U(1 + i,-2 + j,n) - 4*U(1 + i,-1 + j,n) + 3*U(1 + i,j,n))/(2.*hy)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i+1,j,n)
                     else
                        outder = 0.
                     endif
                  endif
                  innloc = 0.5
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)

                  lambda = (edgloc-outloc)/(innloc-outloc)
                  tander(i+1,j,n) = lambda*innder+(1-lambda)*outder
               enddo
c :::::: now end points
c :::::: lower right side
               j = lo(2)
               if( mask(1 + i,-1 + j).eq.0.and.mask(1 + i,1 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-U(1 + i,-1 + j,n) + U(1 + i,1 + j,n))/(2.*hy)
               elseif( mask(1 + i,j).eq.0.and.mask(1 + i,1 + j).eq.0.and.mask(1 + i,2 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-3*U(1 + i,j,n) + 4*U(1 + i,1 + j,n) - U(1 + i,2 + j,n))/(2.*hy)
               else
                  outloc = x(-1)
                  if( flagbc .eq. 1) then
                     outder = exttd(i+1,j,n)
                  else
                     outder = 0.
                  endif
               endif
               if( maskm(i,-1 + j).gt.0 ) then
                  innder = (-3*U(i,j,n) + 4*U(i,1 + j,n) - U(i,2 + j,n))/(2.*hy)
               else
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i+1,j,n) = lambda*innder+(1-lambda)*outder
c     :::::: upper right side
               j = hi(2)
               if( mask(1 + i,-1 + j).eq.0.and.mask(1 + i,1 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-U(1 + i,-1 + j,n) + U(1 + i,1 + j,n))/(2.*hy)
               elseif( mask(1 + i,-2 + j).eq.0.and.mask(1 + i,-1 + j).eq.0.and.mask(1 + i,j).eq.0 ) then
                  outloc = -0.5
                  outder = (U(1 + i,-2 + j,n) - 4*U(1 + i,-1 + j,n) + 3*U(1 + i,j,n))/(2.*hy)
               else
                  outloc = x(-1)
                  if( flagbc .eq. 1) then
                     outder = exttd(i+1,j,n)
                  else
                     outder = 0.
                  endif
               endif
               if( maskp(i,1 + j).gt.0 ) then
                  innder = (U(i,-2 + j,n) - 4*U(i,-1 + j,n) + 3*U(i,j,n))/(2.*hy)
               else
                  innder = (-U(i,-1 + j,n) + U(i,1 + j,n))/(2.*hy)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i+1,j,n) = lambda*innder+(1-lambda)*outder
               
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               
               do j = lo(2), hi(2)
                  u(hi(1)+1, j, n) = cvmgt(
     $                 -u(hi(1),j,n),
     $                 u(hi(1)+1, j, n),
     $                 mask(hi(1)+1,j) .gt. 0)
c                 ::: tangential der is trivial
                  tander(hi(1)+1,j,n) = 0.0
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     den(hi(1),j,n) = cvmgt(-1.0, 0.0,
     $                    mask(hi(1)+1,j) .gt. 0)
                  enddo
               endif
               
            else
               print *,'UNKNOWN BC ON RIGHT FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c
c     The Bottom of the Grid
c
      if(cdir .eq. 1) then
         do n = 1, nc
            if(is_neumann(bct(n))) then
               do i = lo(1),hi(1)
                  u(i,lo(2)-1,n) = cvmgt(
     $                 u(i,lo(2),n),
     $                 u(i,lo(2)-1,n),
     $                 mask(i,lo(2)-1) .gt. 0)
               enddo
               if ( flagden .eq. 1 ) then
                  do i = lo(1),hi(1)
                     den(i,lo(2),n)   = 1.0
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: interior part of bottom side
               j = lo(2)
               do i=lo(1)+1,hi(1)-1
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
                  tander(i,j-1,n) = innder
               enddo
c :::::: now end points
c :::::: left bottom side
               i = lo(1)
               if( maskm(-1 + i,j).gt.0 ) then
                  innder = (-3*U(i,j,n) + 4*U(1 + i,j,n) - U(2 + i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               tander(i,j-1,n) = innder
c :::::: right bottom side
               i = hi(1)
               if( maskp(1 + i,j).gt.0 ) then
                  innder = (U(-2 + i,j,n) - 4*U(-1 + i,j,n) + 3*U(i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               tander(i,j-1,n) = innder
            else if (is_dirichlet(bct(n))) then
               do m=0,leny
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(2)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, leny+2, coef)
               if ( flagbc .eq. 1 ) then
                  do i = lo(1), hi(1)
                     u(i,lo(2)-1,n) = cvmgt(
     $                    bcval(i,lo(2)-1,n)*coef(-1),
     $                    u(i,lo(2)-1,n),
     $                    mask(i,lo(2)-1) .gt. 0)
                  enddo
               else
                  do i = lo(1), hi(1)
                     u(i,lo(2)-1,n) = cvmgt(
     $                    0.0,
     $                    u(i,lo(2)-1,n),
     $                    mask(i,lo(2)-1) .gt. 0)
                  enddo
               endif
               do m = 0, leny
                  do i = lo(1), hi(1)
                     u(i, lo(2)-1, n) = cvmgt(
     $                    u(i, lo(2)-1,n)
     $                    + u(i, lo(2)+m,n)*coef(m),
     $                    u(i, lo(2)-1, n),
     $                    mask(i, lo(2)-1) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do i = lo(1), hi(1)
                     den(i, lo(2),n)   = cvmgt(coef(0), 0.0,
     $                    mask(i, lo(2)-1) .gt. 0)
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: interior part of bottom side
               edgloc = 0.
               j = lo(2)
               do i=lo(1)+1,hi(1)-1
                  if(  mask(-1 + i,-1 + j).eq.0.and.mask(1 + i,-1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-U(-1 + i,-1 + j,n) + U(1 + i,-1 + j,n))/(2.*hx)
                  else if(  mask(i,-1 + j).eq.0.and.mask(1 + i,-1 + j).eq.0.and.mask(2 + i,-1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-3*U(i,-1 + j,n) + 4*U(1 + i,-1 + j,n) - U(2 + i,-1 + j,n))/(2.*hx)
                  else if(  mask(-2 + i,-1 + j).eq.0.and.mask(-1 + i,-1 + j).eq.0.and.mask(i,-1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (U(-2 + i,-1 + j,n) - 4*U(-1 + i,-1 + j,n) + 3*U(i,-1 + j,n))/(2.*hx)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i,j-1,n)
                     else
                        outder = 0.
                     endif
                  endif
                  innloc = 0.5
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)

                  lambda = (edgloc-outloc)/(innloc-outloc)
                  tander(i,j-1,n) = lambda*innder+(1-lambda)*outder
               enddo
c :::::: now end points
c :::::: left bottom side
               i = lo(1)
               if(  mask(-1 + i,-1 + j).eq.0.and.mask(1 + i,-1 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-U(-1 + i,-1 + j,n) + U(1 + i,-1 + j,n))/(2.*hx)
               else if( mask(i,-1 + j).eq.0.and.mask(1 + i,-1 + j).eq.0.and.mask(2 + i,-1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-3*U(i,-1 + j,n) + 4*U(1 + i,-1 + j,n) - U(2 + i,-1 + j,n))/(2.*hx)
               else
                  outloc = x(-1)
                  if( flagbc .eq. 1) then
                     outder = exttd(i,j-1,n)
                  else
                     outder = 0.
                  endif
               endif
               if( maskm(-1 + i,j).gt.0 ) then
                  innder = (-3*U(i,j,n) + 4*U(1 + i,j,n) - U(2 + i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i,j-1,n) = lambda*innder+(1-lambda)*outder
c :::::: right bottom side
               i = hi(1)
               if( mask(-1 + i,-1 + j).eq.0.and.mask(1 + i,-1 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-U(-1 + i,-1 + j,n) + U(1 + i,-1 + j,n))/(2.*hx)
               else if( mask(-2 + i,-1 + j).eq.0.and.mask(-1 + i,-1 + j).eq.0.and.mask(i,-1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (U(-2 + i,-1 + j,n) - 4*U(-1 + i,-1 + j,n) + 3*U(i,-1 + j,n))/(2.*hx)
               else
                  outloc = x(-1)
                  if( flagbc .eq. 1) then
                     outder = exttd(i,j-1,n)
                  else
                     outder = 0.
                  endif
               endif
               if( maskp(1 + i,j).gt.0 ) then
                  innder = (U(-2 + i,j,n) - 4*U(-1 + i,j,n) + 3*U(i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i,j-1,n) = lambda*innder+(1-lambda)*outder
               
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               
               do i = lo(1), hi(1)
                  u(i,lo(2)-1,n) = cvmgt(
     $                 -u(i,lo(2),n),
     $                 u(i,lo(2)-1,n),
     $                 mask(i,lo(2)-1) .gt. 0)
                  tander(i,lo(2)-1,n) = 0.0
               enddo
               if ( flagden .eq. 1 ) then
                  do i = lo(1), hi(1)
                     den(i,lo(2),n) = cvmgt(-1.0, 0.0,
     $                    mask(i,lo(2)-1) .gt. 0)
                  enddo
               endif
               
            else
               print *,'UNKNOWN BC ON BOTTOM FACE IN APPLYBC'
               stop
            endif
        enddo
      endif
c     
c     The top of the grid
c
      if (cdir .eq. 3) then
         do n = 1, nc
            if(is_neumann(bct(n))) then
               do i = lo(1), hi(1)
                  u(i,hi(2)+1,n) = cvmgt(
     $                 u(i,hi(2),n),
     $                 u(i,hi(2)+1,n),
     $                 mask(i,hi(2)+1) .gt. 0)
               enddo
               if ( flagden .eq. 1 ) then
                  do i = lo(1), hi(1)
                     den(i,hi(2),n)   = 1.0
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: interior part of top side
               j = hi(2)
               do i=lo(1)+1,hi(1)-1
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
                  tander(i,j+1,n) = innder
               enddo
c     :::::: now end points
c     :::::: left top side
               i = lo(1)
               if( maskm(-1 + i,j).gt.0 ) then
                  innder = (-3*U(i,j,n) + 4*U(1 + i,j,n) - U(2 + i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               tander(i,j+1,n) = innder
c     :::::: right top side
               i = hi(1)
               if( maskp(1 + i,j).gt.0 ) then
                  innder = (U(-2 + i,j,n) - 4*U(-1 + i,j,n) + 3*U(i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               tander(i,j+1,n) = innder
            else if (is_dirichlet(bct(n))) then
               if ( bct(n) .eq. LO_REFLECT_ODD ) leny = 0
               do m=0,leny
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(2)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, leny+2, coef)
               if ( flagbc .eq. 1 ) then
                  do i = lo(1), hi(1)
                     u(i,hi(2)+1,n) = cvmgt(
     $                    bcval(i,hi(2)+1,n)*coef(-1),
     $                    u(i,hi(2)+1,n),
     $                    mask(i,hi(2)+1) .gt. 0)
                  enddo
               else
                  do i = lo(1), hi(1)
                     u(i,hi(2)+1,n) = cvmgt(
     $                    0.0,
     $                    u(i,hi(2)+1,n),
     $                    mask(i,hi(2)+1) .gt. 0)
                  enddo
               endif
               do m = 0, leny
                  do i = lo(1), hi(1)
                     u(i, hi(2)+1,n) = cvmgt(
     $                    u(i,hi(2)+1,n)
     $                    + u(i, hi(2)-m,n)*coef(m),
     $                    u(i,hi(2)+1,n),
     $                    mask(i,hi(2)+1) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do i = lo(1), hi(1)
                     den(i,hi(2),n)   = cvmgt(coef(0), 0.0,
     $                    mask(i,hi(2)+1) .gt. 0)
                  enddo
               endif
c     :::::: now do the tangential derivative part
c     :::::: interior part of top side
               edgloc = 0.
               j = hi(2)
               do i=lo(1)+1,hi(1)-1
                  if(  mask(-1 + i,1 + j).eq.0.and.mask(1 + i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-U(-1 + i,1 + j,n) + U(1 + i,1 + j,n))/(2.*hx)
                  else if(  mask(i,1 + j).eq.0.and.mask(1 + i,1 + j).eq.0.and.mask(2 + i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-3*U(i,1 + j,n) + 4*U(1 + i,1 + j,n) - U(2 + i,1 + j,n))/(2.*hx)
                  else if( mask(-2 + i,1 + j).eq.0.and.mask(-1 + i,1 + j).eq.0.and.mask(i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (U(-2 + i,1 + j,n) - 4*U(-1 + i,1 + j,n) + 3*U(i,1 + j,n))/(2.*hx)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i,j+1,n)
                     else
                        outder = 0.
                     endif
                  endif
                  innloc = 0.5
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
                  
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  tander(i,j+1,n) = lambda*innder+(1-lambda)*outder
               enddo
c     :::::: now end points
c     :::::: left top side
               i = lo(1)
               if( mask(-1 + i,1 + j).eq.0.and.mask(1 + i,1 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-U(-1 + i,1 + j,n) + U(1 + i,1 + j,n))/(2.*hx)
               else if( mask(i,1 + j).eq.0.and.mask(1 + i,1 + j).eq.0.and.mask(2 + i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (-3*U(i,1 + j,n) + 4*U(1 + i,1 + j,n) - U(2 + i,1 + j,n))/(2.*hx)
               else
                  outloc = x(-1)
                  if( flagbc .eq. 1) then
                     outder = exttd(i,j+1,n)
                  else
                     outder = 0.
                  endif
               endif
               if( maskm(-1 + i,j).gt.0 ) then
                  innder = (-3*U(i,j,n) + 4*U(1 + i,j,n) - U(2 + i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i,j+1,n) = lambda*innder+(1-lambda)*outder
c     :::::: right top side
               i = hi(1)
               if( mask(-1 + i,1 + j).eq.0.and.mask(1 + i,1 + j).eq.0 ) then
                  outloc = -0.5
                  outder = (-U(-1 + i,1 + j,n) + U(1 + i,1 + j,n))/(2.*hx)
               else if(  mask(-2 + i,1 + j).eq.0.and.mask(-1 + i,1 + j).eq.0.and.mask(i,1 + j).eq.0 ) then
                     outloc = -0.5
                     outder = (U(-2 + i,1 + j,n) - 4*U(-1 + i,1 + j,n) + 3*U(i,1 + j,n))/(2.*hx)
               else
                  outloc = x(-1)
                  if( flagbc .eq. 1) then
                     outder = exttd(i,j+1,n)
                  else
                     outder = 0.
                  endif
               endif
               if( maskp(1 + i,j).gt.0 ) then
                  innder = (U(-2 + i,j,n) - 4*U(-1 + i,j,n) + 3*U(i,j,n))/(2.*hx)
               else
                  innder = (-U(-1 + i,j,n) + U(1 + i,j,n))/(2.*hx)
               endif
               innloc = 0.5
               lambda = (edgloc-outloc)/(innloc-outloc)
               tander(i,j+1,n) = lambda*innder+(1-lambda)*outder
               
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               
               do i = lo(1), hi(1)
                  u(i,hi(2)+1,n) = cvmgt(
     $                 -u(i,hi(2),n),
     $                 u(i,hi(2)+1,n),
     $                 mask(i,hi(2)+1) .gt. 0)
                  tander(i,hi(2)+1,n) = 0.0
               enddo
               if ( flagden .eq. 1 ) then
                  do i = lo(1), hi(1)
                     den(i,hi(2),n) = cvmgt(-1.0, 0.0,
     $                    mask(i,hi(2)+1) .gt. 0)
                  enddo
               endif
               
            else
               print *,'UNKNOWN BC ON TOP FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c
      end


      subroutine FORT_GSRB (
     $     u, DIMS(u),
     $     rhs, DIMS(rhs),
     $     alpha, beta,
     $     a, DIMS(a),
     $     muX, DIMS(muX),
     $     muY, DIMS(muY),
     $     maskn,DIMS(maskn),
     $     fn, DIMS(fn),
     $     maske,DIMS(maske),
     $     fe, DIMS(fe),
     $     maskw,DIMS(maskw),
     $     fw, DIMS(fw),
     $     masks,DIMS(masks),
     $     fs, DIMS(fs),
     $     trandern,DIMS(trandern),
     $     trandere,DIMS(trandere),
     $     tranderw,DIMS(tranderw),
     $     tranders,DIMS(tranders),
     $     lo,hi,h,nc,phaseflag
     $     )

      REAL_T alpha, beta
      integer DIMDEC(u)
      integer DIMDEC(rhs)
      integer DIMDEC(a)
      integer DIMDEC(muX)
      integer DIMDEC(muY)
      integer DIMDEC(maskn)
      integer DIMDEC(maske)
      integer DIMDEC(maskw)
      integer DIMDEC(masks)
      integer DIMDEC(fn)
      integer DIMDEC(fe)
      integer DIMDEC(fw)
      integer DIMDEC(fs)
      integer DIMDEC(trandern)
      integer DIMDEC(trandere)
      integer DIMDEC(tranderw)
      integer DIMDEC(tranders)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      REAL_T h(BL_SPACEDIM)
      integer nc,phaseflag

      REAL_T u(DIMV(u),2)
      REAL_T rhs(DIMV(rhs),2)
      REAL_T a(DIMV(a),2)
      REAL_T muX(DIMV(muX))
      REAL_T muY(DIMV(muY))
      integer maskn(DIMV(maskn))
      integer maske(DIMV(maske))
      integer maskw(DIMV(maskw))
      integer masks(DIMV(masks))
      REAL_T fn(DIMV(fn),nc)
      REAL_T fe(DIMV(fe),nc)
      REAL_T fw(DIMV(fw),nc)
      REAL_T fs(DIMV(fs),nc)
      REAL_T trandern(DIMV(trandern),2)
      REAL_T trandere(DIMV(trandere),2)
      REAL_T tranderw(DIMV(tranderw),2)
      REAL_T tranders(DIMV(tranders),2)

      integer i,j,modx,mody
      integer istart,jstart
      REAL_T tauxxw,tauxxe,tauyyn,tauyys
      REAL_T tauxye,tauxyw,tauxyn,tauxys
      REAL_T hx,hy
      REAL_T dudxe,dudxw
      REAL_T dvdyn,dvdys
      REAL_T dudye,dudyw,dudyn,dudys
      REAL_T dvdxe,dvdxw,dvdxn,dvdxs
      REAL_T diagu, diagv
      REAL_T operu, operv
      logical False, True
      parameter( False=.false.)
      parameter( True=.true. )

      hx = h(1)
      hy = h(2)
      if( nc .ne. 2 ) then
         write(6,*)'FORT_GSRB: bad nc',nc
         stop
      endif

c ::: convert phase flag into modx and mody
      if(    phaseflag.eq.0 ) then
         modx = 0
         mody = 0
      elseif(phaseflag.eq.1) then
         modx = 1
         mody = 0
      elseif(phaseflag.eq.2) then
         modx = 0
         mody = 1
      elseif(phaseflag.eq.3) then
         modx = 1
         mody = 1
      else
         write(6,*)'FORT_GSRB: bad phaseflag', phaseflag
         stop
      endif


c ::: cases:
c     ::: 1) interior.  All normal derivative expressions
c     ::: 2) edge but not on corner.  check mask value to see if use outside
c     :::    value or use interpolations
c     ::: 3) corners.  Must check mask values to see if use outside values
c     :::    values or use interpolations ON TWO SIDES.  But must also
c     :::    check to see if need to do one-sided derivs for tangential
c     :::    derivatives.

c ::: case 1
      istart = lo(1)+1
      if( mod(istart,2) .ne. modx ) istart = istart+1
      jstart = lo(2)+1
      if( mod(jstart,2) .ne. mody ) jstart = jstart+1
      do j = jstart,hi(2)-1,2
         do i = istart,hi(1)-1,2
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)

            dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
         enddo
      enddo

c ::: case 2a) north side
c ::: Null
c ::: Null
      j = hi(2)
      if( mod(j,2) .eq. mody ) then
         do i = istart,hi(1)-1,2
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( maskn(i,1 + j).gt.0.or.maskn(1 + i,1 + j).gt.0 ) then
               dudye =         ((U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy) + 
     -    (U(1 + i,-2 + j,1) - 4*U(1 + i,-1 + j,1) + 3*U(1 + i,j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            if( maskn(-1 + i,1 + j).gt.0.or.maskn(i,1 + j).gt.0 ) then
               dudyw =         ((U(-1 + i,-2 + j,1) - 4*U(-1 + i,-1 + j,1) + 3*U(-1 + i,j,1))/
     -     (2.*hy) + (U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy))/
     -  2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn = trandern(i,j+1,2)
            dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maskn(i,j+1).gt. 0) then
	       diagu = diagu - fn(i,j,1)*beta*muY(i,j+1)/hy**2
	       diagv = diagv - fn(i,j,2)*2*beta*muY(i,j+1)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
         enddo
      endif



c ::: case 2b south side
c ::: Null
c ::: Null

      j=lo(2)
      if( mod(j,2) .eq. mody ) then
         do i=istart,hi(1)-1,2
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( masks(i,-1 + j).gt.0.or.masks(1 + i,-1 + j).gt.0 ) then
               dudye =         ((-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy) + 
     -    (-3*U(1 + i,j,1) + 4*U(1 + i,1 + j,1) - U(1 + i,2 + j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            if( masks(-1 + i,-1 + j).gt.0.or.masks(i,-1 + j).gt.0 ) then
               dudyw =         ((-3*U(-1 + i,j,1) + 4*U(-1 + i,1 + j,1) - U(-1 + i,2 + j,1))/
     -     (2.*hy) + (-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy))/2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( masks(i,j-1).gt. 0) then
	       diagu = diagu - fs(i,j,1)*beta*muY(i,j)/hy**2
	       diagv = diagv - fs(i,j,2)*2*beta*muY(i,j)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
         enddo
      endif


c ::: case 2c: west side story
c ::: Null
c ::: Null
      i=lo(1)
      if( mod(i,2) .eq. modx ) then
         do j=jstart,hi(2)-1,2
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx
            
            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy
            
            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            dudyw = tranderw(i-1,j,1)
            
            if( maskw(-1 + i,j).gt.0.or.maskw(-1 + i,1 + j).gt.0 ) then
               dvdxn =         ((-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx) + 
     -    (-3*U(i,1 + j,2) + 4*U(1 + i,1 + j,2) - U(2 + i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            if( maskw(-1 + i,-1 + j).gt.0.or.maskw(-1 + i,j).gt.0 ) then
               dvdxs =         ((-3*U(i,-1 + j,2) + 4*U(1 + i,-1 + j,2) - U(2 + i,-1 + j,2))/
     -     (2.*hx) + (-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx))/2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maskw(i-1,j).gt. 0) then
	       diagu = diagu - fw(i,j,1)*2*beta*muX(i,j)/hx**2
	       diagv = diagv - fw(i,j,2)*  beta*muX(i,j)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
         enddo
      endif


c ::: case 2d: east side story
c ::: Null
c ::: Null
      i=hi(1)
      if( mod(i,2) .eq. modx ) then
         do j=jstart,hi(2)-1,2
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)

            if( maske(1 + i,j).gt.0.or.maske(1 + i,1 + j).gt.0 ) then
               dvdxn =         ((U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx) + 
     -    (U(-2 + i,1 + j,2) - 4*U(-1 + i,1 + j,2) + 3*U(i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            if( maske(1 + i,-1 + j).gt.0.or.maske(1 + i,j).gt.0 ) then
               dvdxs =         ((U(-2 + i,-1 + j,2) - 4*U(-1 + i,-1 + j,2) + 3*U(i,-1 + j,2))/
     -     (2.*hx) + (U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx))/
     -  2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maske(i+1,j).gt. 0) then
	       diagu = diagu - fe(i,j,1)*2*beta*muX(i+1,j)/hx**2
	       diagv = diagv - fe(i,j,2)*  beta*muX(i+1,j)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
         enddo
      endif

c ::: case 3a: north-east corner, plus i, plus j
c ::: Null
c ::: Null
      j=hi(2)
      i=hi(1)
      if( mod(i,2).eq.modx .and. mod(j,2).eq.mody) then
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            if( maskn(-1 + i,1 + j).gt.0.or.maskn(i,1 + j).gt.0 ) then
               dudyw =         ((U(-1 + i,-2 + j,1) - 4*U(-1 + i,-1 + j,1) + 3*U(-1 + i,j,1))/
     -     (2.*hy) + (U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy))/
     -  2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            dvdxn = trandern(i,j+1,2)
            if( maske(1 + i,-1 + j).gt.0.or.maske(1 + i,j).gt.0 ) then
               dvdxs =         ((U(-2 + i,-1 + j,2) - 4*U(-1 + i,-1 + j,2) + 3*U(i,-1 + j,2))/
     -     (2.*hx) + (U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx))/
     -  2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maske(i+1,j).gt. 0) then
	       diagu = diagu - fe(i,j,1)*2*beta*muX(i+1,j)/hx**2
	       diagv = diagv - fe(i,j,2)*  beta*muX(i+1,j)/hy**2
	    endif
	    if( maskn(i,j+1).gt. 0) then
	       diagu = diagu - fn(i,j,1)*beta*muY(i,j+1)/hy**2
	       diagv = diagv - fn(i,j,2)*2*beta*muY(i,j+1)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
      endif


c ::: case 3b: south-east corner, plus i, minus j, plus i, plus j
c ::: Null
      j=lo(2)
      i=hi(1)
      
      if( mod(i,2).eq.modx .and. mod(j,2).eq.mody) then
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            dudye = trandere(i+1,j,1)
            if( masks(-1 + i,-1 + j).gt.0.or.masks(i,-1 + j).gt.0 ) then 
               dudyw =         ((-3*U(-1 + i,j,1) + 4*U(-1 + i,1 + j,1) - U(-1 + i,2 + j,1))/
     -     (2.*hy) + (-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy))/2.
            else
               dudyw =         (-U(-1 + i,-1 + j,1) + U(-1 + i,1 + j,1) - U(i,-1 + j,1) + 
     -    U(i,1 + j,1))/(4.*hy)
            endif

            if( maske(1 + i,j).gt.0.or.maske(1 + i,1 + j).gt.0 ) then
               dvdxn =         ((U(-2 + i,j,2) - 4*U(-1 + i,j,2) + 3*U(i,j,2))/(2.*hx) + 
     -    (U(-2 + i,1 + j,2) - 4*U(-1 + i,1 + j,2) + 3*U(i,1 + j,2))/(2.*hx))/
     -  2. 
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maske(i+1,j).gt. 0) then
	       diagu = diagu - fe(i,j,1)*2*beta*muX(i+1,j)/hx**2
	       diagv = diagv - fe(i,j,2)*  beta*muX(i+1,j)/hy**2
	    endif
	    if( masks(i,j-1).gt. 0) then
	       diagu = diagu - fs(i,j,1)*beta*muY(i,j)/hy**2
	       diagv = diagv - fs(i,j,2)*2*beta*muY(i,j)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
      endif

c ::: case 3c: south-west corner, minus i, minus j
c ::: Null
      j=lo(2)
      i=lo(1)

      if( mod(i,2).eq.modx .and. mod(j,2).eq.mody) then
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( masks(i,-1 + j).gt.0.or.masks(1 + i,-1 + j).gt.0 ) then
               dudye =         ((-3*U(i,j,1) + 4*U(i,1 + j,1) - U(i,2 + j,1))/(2.*hy) + 
     -    (-3*U(1 + i,j,1) + 4*U(1 + i,1 + j,1) - U(1 + i,2 + j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            dudyw = tranderw(i-1,j,1)

            if( maskw(-1 + i,j).gt.0.or.maskw(-1 + i,1 + j).gt.0 ) then
               dvdxn =         ((-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx) + 
     -    (-3*U(i,1 + j,2) + 4*U(1 + i,1 + j,2) - U(2 + i,1 + j,2))/(2.*hx))/
     -  2.
            else
               dvdxn =         (-U(-1 + i,j,2) - U(-1 + i,1 + j,2) + U(1 + i,j,2) + 
     -    U(1 + i,1 + j,2))/(4.*hx)
            endif
            dvdxs = tranders(i,j-1,2)
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maskw(i-1,j).gt. 0) then
	       diagu = diagu - fw(i,j,1)*2*beta*muX(i,j)/hx**2
	       diagv = diagv - fw(i,j,2)*  beta*muX(i,j)/hy**2
	    endif
	    if( masks(i,j-1).gt. 0) then
	       diagu = diagu - fs(i,j,1)*beta*muY(i,j)/hy**2
	       diagv = diagv - fs(i,j,2)*2*beta*muY(i,j)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
      endif



c ::: case 3d: north-west corner, minus i, plus j
c ::: Null
      j=hi(2)
      i=lo(1)
      if( mod(i,2).eq.modx .and. mod(j,2).eq.mody) then
c     :::  get expressions for appropriate derivatives
            dudxe = (-U(i,j,1) + U(1 + i,j,1))/hx
            dudxw = (-U(-1 + i,j,1) + U(i,j,1))/hx

            dvdyn = (-U(i,j,2) + U(i,1 + j,2))/hy
            dvdys = (-U(i,-1 + j,2) + U(i,j,2))/hy

            dudyn = (-U(i,j,1) + U(i,1 + j,1))/hy
            dudys = (-U(i,-1 + j,1) + U(i,j,1))/hy
            if( maskn(i,1 + j).gt.0.or.maskn(1 + i,1 + j).gt.0 ) then
               dudye =         ((U(i,-2 + j,1) - 4*U(i,-1 + j,1) + 3*U(i,j,1))/(2.*hy) + 
     -    (U(1 + i,-2 + j,1) - 4*U(1 + i,-1 + j,1) + 3*U(1 + i,j,1))/(2.*hy))/
     -  2.
            else
               dudye =         (-U(i,-1 + j,1) + U(i,1 + j,1) - U(1 + i,-1 + j,1) + 
     -    U(1 + i,1 + j,1))/(4.*hy)
            endif
            dudyw = tranderw(i-1,j,1)

            dvdxn = trandern(i,j+1,2)
            if( maskw(-1 + i,-1 + j).gt.0.or.maskw(-1 + i,j).gt.0 ) then
               dvdxs =         ((-3*U(i,-1 + j,2) + 4*U(1 + i,-1 + j,2) - U(2 + i,-1 + j,2))/
     -     (2.*hx) + (-3*U(i,j,2) + 4*U(1 + i,j,2) - U(2 + i,j,2))/(2.*hx))/2.
            else
               dvdxs =         (-U(-1 + i,-1 + j,2) - U(-1 + i,j,2) + U(1 + i,-1 + j,2) + 
     -    U(1 + i,j,2))/(4.*hx)
            endif
            dvdxe = (-U(i,j,2) + U(1 + i,j,2))/hx
            dvdxw = (-U(-1 + i,j,2) + U(i,j,2))/hx
c     :::  get diagonal element
            diagu = alpha*a(i,j,1) + 
     $           2*beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $             beta*(muY(i,j)+muY(i,j+1))/(hy**2)
            diagv = alpha*a(i,j,2) +
     $             beta*(muX(i,j)+muX(i+1,j))/(hx**2)+
     $           2*beta*(muY(i,j)+muY(i,j+1))/(hy**2)
	    if( maskw(i-1,j).gt. 0) then
	       diagu = diagu - fw(i,j,1)*2*beta*muX(i,j)/hx**2
	       diagv = diagv - fw(i,j,2)*  beta*muX(i,j)/hy**2
	    endif
	    if( maskn(i,j+1).gt. 0) then
	       diagu = diagu - fn(i,j,1)*beta*muY(i,j+1)/hy**2
	       diagv = diagv - fn(i,j,2)*2*beta*muY(i,j+1)/hy**2
	    endif
c     :::  evaluate operator
            operu =         -((beta*(hy*(-2*dudxw*muX(i,j) + 2*dudxe*muX(1 + i,j)) + 
     -         hx*(-((dudys + dvdxs)*muY(i,j)) + (dudyn + dvdxn)*muY(i,1 + j))
     -         ))/(hx*hy)) + alpha*a(i,j,1)*u(i,j,1)
            operv =         -((beta*(hy*(-((dudyw + dvdxw)*muX(i,j)) + 
     -            (dudye + dvdxe)*muX(1 + i,j)) + 
     -         hx*(-2*dvdys*muY(i,j) + 2*dvdyn*muY(i,1 + j))))/(hx*hy)) + 
     -  alpha*a(i,j,2)*u(i,j,2)
c     :::  do relaxation
            u(i,j,1) = (rhs(i,j,1)-operu)/diagu + u(i,j,1)
            u(i,j,2) = (rhs(i,j,2)-operv)/diagv + u(i,j,2)
      endif


      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** CMPDT **
c ** Compute the new time step
c ********************************************************************

      subroutine FORT_CMPDT(u,rho,gp,force,dx,dtold,dt,cflfac,DIMS)

      implicit none

      integer DIMS
      REAL_T     u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      REAL_T   rho(lo_1-3:hi_1+3,lo_2-3:hi_2+3)
      REAL_T    gp(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T dx(2)
      REAL_T dt, dtold
      REAL_T cflfac

c     Local variables
      REAL_T spdx,spdy
      REAL_T pforcex,pforcey
      REAL_T dtchange
      integer i, j

      REAL_T eps
      
      dtchange = 1.1d0
      eps = 1.0e-8

      spdx  = zero
      spdy  = zero
      pforcex = zero
      pforcey = zero

      do j = lo_2, hi_2
        do i = lo_1, hi_1
          spdx    = max(spdx ,abs(u(i,j,1))/dx(1))
          spdy    = max(spdy ,abs(u(i,j,2))/dx(2))
          pforcex = max(pforcex,abs(gp(i,j,1)/rho(i,j)-force(i,j,1)))
          pforcey = max(pforcey,abs(gp(i,j,2)/rho(i,j)-force(i,j,2)))
        enddo
      enddo

      if (spdx.lt.eps .and. spdy.lt.eps) then

        dt = min(dx(1),dx(2))

      else

        dt = one / max(spdx,spdy)

      endif

      if (pforcex .gt. eps) then
        dt = min(dt,sqrt(two*dx(1)/pforcex))
      endif

      if (pforcey .gt. eps) then
        dt = min(dt,sqrt(two*dx(2)/pforcey))
      endif

      dt = dt * cflfac

      if (dtold .gt. zero) dt = min(dt,dtchange*dtold)

      return
      end

      program dummydata

      implicit none

      integer imax, jmax, kmax
      parameter (imax=49, jmax=25, kmax=1)

      integer ibc, jbc, kbc, i, j, k
      real*8 scalex, scaley, scalez, convVel, dt, t, pi, tMax, dx, x
      real*8 udat(imax,jmax,kmax), vdat(imax,jmax,kmax), 
     $       wdat(imax,jmax,kmax)

c
c
c
      convVel = 1.5d0
      scalex = 0.7500d+01
      scaley = convVel
      scalez = 0.0000d+00
      ibc = 1
      jbc = 1
      kbc = 1

      dt = scaley / FLOAT(jmax-1) / convVel
      dx = scalex / FLOAT(imax-1)
      tMax = scaley / convVel
      pi = ACOS(-1.0d0)

      do k = 1, kmax
        do j = 1, jmax
          do i = 1, imax
            x = FLOAT(i-1) * dx
            t = FLOAT(j-1) * dt

c           udat(i,j,k) = SIN(2.0d0 * pi * t / tMax)
c           vdat(i,j,k) = COS(2.0d0 * pi * t / tMax)
c           wdat(i,j,k) = 0.0d0
            udat(i,j,k) = SIN(2.0d0 * pi * x / scalex)
            vdat(i,j,k) = COS(2.0d0 * pi * x / scalex)
            wdat(i,j,k) = 0.0d0
          enddo
        enddo
      enddo
c
c
      open(1,file='DummyData',form='unformatted')
      write(1) imax, jmax, kmax
      write(1) scalex, scaley, scalez
      write(1) ibc, jbc, kbc

      do k=1, kmax
        WRITE(1) ((udat(i,j,k), i=1,imax), j=1,jmax)
      enddo
      do k=1, kmax
        WRITE(1) ((vdat(i,j,k), i=1,imax), j=1,jmax)
      enddo
      do k=1, kmax
        WRITE(1) ((wdat(i,j,k), i=1,imax), j=1,jmax)
      enddo

      close(1)

c
c
      stop
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: SYNCREG_2D.F,v 1.16 2002/08/29 22:14:52 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "SYNCREG_F.H"
#include "ArrayLim.H"

#define SDIM 2

c ::: -----------------------------------------------------------
c ::: coarsen fine grid node centered data along edge of node
c ::: centered fine grid array.
c :::
c ::: INPUTS/OUTPUTS:
c ::: crse      <=  node centered coarse data
c ::: DIMS(crse) => index limits for crse
c ::: fine       => node centered fine data
c ::: DIMS(fine) => index limits for fine
c ::: lo,hi      => node centered subregion of crse to define
c ::: dir        => index direction of normal (0 based)
c ::: ratio      => refinement ratio      
c ::: -----------------------------------------------------------

      subroutine FORT_SRCRSEREG(fine,DIMS(fine),crse,DIMS(crse),lo,hi,dir,
     &                          ratios)

      integer    DIMDEC(fine)
      integer    DIMDEC(crse)
      integer    lo(SDIM) 
      integer    hi(SDIM)
      integer    dir
      integer    ratios(0:1)
      REAL_T     fine(DIMV(fine))
      REAL_T     crse(DIMV(crse))
      
      integer    i, j, ic, jc
      integer    m, n
      integer    ratiox, ratioy
      REAL_T     coeff, denom

c     NOTE: the reason that the coefficients add up to 1/ratio and NOT to 1
c           is because the divergences and DGphi were computed using the
c           local dx, so in order to add the fine contribution to the
c           coarse contribution the fine contribution must be weighted
c           by dx_fine/dx_coarse = 1/ratio
      
      ratiox = ratios(0)
      ratioy = ratios(1)

c     NOTE: we halve fine on the corners since the corners are
c           counted in both directions; later we double them to restore
c           them to their previous values.

      if (dir .eq. 0) then

c        ::::: sum in j direction
         ic = lo(1)
         i = ratiox*ic

         do jc = lo(2), hi(2)
           crse(ic,jc) = zero
         end do

         j = ratioy*lo(2)
         fine(i,j) = half*fine(i,j)

         j = ratioy*hi(2)
         fine(i,j) = half*fine(i,j)

         denom = one / (ratiox * ratioy**2)
         do m = 0, (ratioy-1)
           coeff = (ratioy - m) * denom
           if (m .eq. 0) coeff = half * coeff
           do jc = lo(2), hi(2)
             j = ratioy*jc
             crse(ic,jc) = crse(ic,jc) + coeff *
     $            ( fine(i,j+m) + fine(i,j-m) )
           end do
         end do

         j = ratioy*lo(2)
         fine(i,j) = two*fine(i,j)

         j = ratioy*hi(2)
         fine(i,j) = two*fine(i,j)

      else

c        ::::: sum in i direction
         jc = lo(2)
         j = ratioy*jc

         do ic = lo(1), hi(1)
           crse(ic,jc) = zero
         end do

         i = ratiox*lo(1)
         fine(i,j) = half*fine(i,j)

         i = ratiox*hi(1)
         fine(i,j) = half*fine(i,j)

         denom = one / (ratioy * ratiox**2)
         do m = 0, (ratiox-1)
           coeff = (ratiox - m) * denom
           if (m .eq. 0) coeff = half * coeff
           do ic = lo(1), hi(1)
             i = ratiox*ic
             crse(ic,jc) = crse(ic,jc) + coeff *
     $            ( fine(i+m,j) + fine(i-m,j) )
           end do
         end do

         i = ratiox*lo(1)
         fine(i,j) = two*fine(i,j)

         i = ratiox*hi(1)
         fine(i,j) = two*fine(i,j)

      end if
      
      end


c ::: -----------------------------------------------------------
c ::: create mask at nodes using values at surrounding cells
c :::
c ::: INPUTS/OUTPUTS:
c ::: mask       <=  node-centered mask array
c ::: DIMS(mask)  => index limits for mask
c ::: cells       => cell-centered array (each value is 0. or 1.)
c ::: DIMS(cells) => index limits for cells
c ::: -----------------------------------------------------------

      subroutine FORT_MAKEMASK(mask,DIMS(mask),cells,DIMS(cells))

      integer    DIMDEC(mask)
      integer    DIMDEC(cells)
      REAL_T     mask(DIMV(mask))
      REAL_T     cells(DIMV(cells))
      
      integer    i, j

      do j = ARG_L2(mask), ARG_H2(mask)
        do i = ARG_L1(mask), ARG_H1(mask)
 
          mask(i,j) = cells(i,j  ) + cells(i-1,j  ) 
     $              + cells(i,j-1) + cells(i-1,j-1)

        end do
      end do
      
      end

c ::: -----------------------------------------------------------
c ::: modify mask from values 0. through 4. to values 0. or 1.
c :::
c ::: INPUTS/OUTPUTS:
c ::: mask       <=  node-centered mask array
c ::: DIMS(mask)  => index limits for mask
c ::: -----------------------------------------------------------

      subroutine FORT_CONVERTMASK(mask,DIMS(mask))

      integer    DIMDEC(mask)
      REAL_T     mask(DIMV(mask))
      
      integer    i, j

      do j = ARG_L2(mask), ARG_H2(mask)
        do i = ARG_L1(mask), ARG_H1(mask)
      
          if (mask(i,j) .gt. 3.5D0) then
            mask(i,j) = zero
          else
            mask(i,j) = one
          end if

        end do
      end do
      
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: HYPERCLAW_2D.F,v 1.1 2002/04/11 22:36:43 marc Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "HYPERCLAW_F.H"
#include "ArrayLim.H"

#define SDIM 2

c :: 
c :: ----------------------------------------------------------
c :: estimate the timestep for this grid r
c :: 
c :: INPUTS/OUTPUTS
c :: state      =>  state array
c :: slo,shi    =>  index limits of state array
c :: c          =>   c array 
c :: clo,chi    =>  index limits of c array
c :: delta      =>  cell size
c :: dt        <=   timestep estimate
c :: 
c :: ----------------------------------------------------------
c :: 
#if 1
      subroutine FORT_ESTDT (state,DIMS(s),c,DIMS(c),lo,hi,delta,dt,nv)

      integer   nv
      integer lo(SDIM), hi(SDIM)
      integer   DIMDEC(s)
      integer   DIMDEC(c)
      REAL_T    dt
      REAL_T    delta(SDIM)
      REAL_T 	state(DIMV(s),nv)
      REAL_T 	c(DIMV(c))

      integer   i, j, is,ie,js,je
      REAL_T    ux,uy,dt1,dt2,dx,dy
      REAL_T    small,gdum,pdum,csdum
 
      is = lo(1)
      js = lo(2)
      ie = hi(1)
      je = hi(2)

      dx = delta(1)
      dy = delta(2)

      dt = bigreal
         do j = js, je         
            do i = is, ie             
               ux = state(i,j,2)/state(i,j,1)
               uy = state(i,j,3)/state(i,j,1)
               state(i,j,4) = state(i,j,4)/state(i,j,1) -
     $              half*(ux**2 + uy**2)
               state(i,j,5) = state(i,j,5)/state(i,j,1)
            end do
         end do
      call eos(state(is,js,1),state(is,js,4),state(is,js,5),
     $     DIMS(s),
     $     gdum,pdum,c,csdum,
     $     DIMS(c),
     $     lo, hi,0,0,1,0)
         do j = js, je           
            do i = is, ie         
               ux = abs(state(i,j,2))/state(i,j,1)
               uy = abs(state(i,j,3))/state(i,j,1)
               dt1 = dx/(c(i,j) + ux)
               dt2 = dy/(c(i,j) + uy)
               dt = min(dt,dt1,dt2)
            end do
         end do

      end
#else
      subroutine FORT_ESTDT (state,DIMS(s),c,DIMS(c),lo,hi,delta,dt,nv)

      integer   nv
      integer lo(SDIM), hi(SDIM)
      integer   DIMDEC(s)
      integer   DIMDEC(c)
      REAL_T    dt
      REAL_T    delta(SDIM)
      REAL_T 	state(DIMV(s),nv)
      REAL_T 	c(DIMV(c))

      integer   i, j, is,ie,js,je
      REAL_T    ux,uy,dt1,dt2,dx,dy
      REAL_T    small,gdum,pdum,csdum
 
      is = lo(1)
      js = lo(2)
      ie = hi(1)
      je = hi(2)

      dx = delta(1)
      dy = delta(2)

      dt = bigreal

      do j = js, je         
          do i = is, ie             
              ux = state(i,j,2)/state(i,j,1)
              uy = state(i,j,3)/state(i,j,1)
              state(i,j,4) = state(i,j,4)/state(i,j,1) -
     $                       half*(ux**2 + uy**2)
           end do
        end do
        
        call eos(state(is,js,1),state(is,js,4),gdum,pdum,
     $       c,csdum,lo,hi,0,0,1,0)
       do j = js, je           
          do i = is, ie         
              ux = abs(state(i,j,2))/state(i,j,1)
              uy = abs(state(i,j,3))/state(i,j,1)
              dt1 = dx/(c(i,j) + ux)
              dt2 = dy/(c(i,j) + uy)
              dt = min(dt,dt1,dt2)
           end do
        end do

      end
#endif
c :: ----------------------------------------------------------
c :: Volume-weight average the fine grid data onto the coarse
c :: grid.  Overlap is given in coarse grid coordinates.
c ::
c :: INPUTS / OUTPUTS:
c ::  crse      <=  coarse grid data
c ::  clo,chi    => index limits of crse array 
c ::  nvar	 => number of components in arrays
c ::  cv         => coarse grid volume array   
c ::  cvlo,cvhi  => index limits of cv   
c ::  fine       => fine grid data
c ::  flo,fhi    => index limits of fine array 
c ::  fv         => fine grid volume array
c ::  fvlo,fvhi  => index limits of fv array
c ::  lo,hi      => index limits of overlap (crse grid)
c ::  lrat       => refinement ratio
c :: ----------------------------------------------------------
c ::
      subroutine FORT_AVGDOWN (crse,DIMS(c),nvar,cv,DIMS(cv),
     &			       fine,DIMS(f),fv,DIMS(fv),lo,hi,lrat)
      integer  DIMDEC(c)
      integer  DIMDEC(cv)
      integer  DIMDEC(f)
      integer  DIMDEC(fv)
      integer  lo(SDIM), hi(SDIM)
      integer  nvar, lrat
      REAL_T   crse(DIMV(c),nvar)
      REAL_T   cv(DIMV(cv))
      REAL_T   fine(DIMV(f),nvar)
      REAL_T   fv(DIMV(fv))
      
      integer  i, j, n, ic, jc, ioff, joff
      integer  lenx, leny

      lenx = hi(1)-lo(1)+1
      leny = hi(2)-lo(2)+1

      if (lenx .ge. leny) then
         do n = 1, nvar
c
c         ::::: set coarse grid to zero on overlap
c
            do jc = lo(2), hi(2)
               do ic = lo(1), hi(1)
                  crse(ic,jc,n) = zero
               end do
            end do
c
c         ::::: sum fine data
c
            do joff = 0, lrat-1
               do jc = lo(2), hi(2)
                  j = jc*lrat + joff
                  do ioff = 0, lrat-1
                     do ic = lo(1), hi(1)
                        i = ic*lrat + ioff
                        crse(ic,jc,n) = crse(ic,jc,n) + fv(i,j)*fine(i,j,n)
                     end do
                  end do
               end do
            end do
c            
c         ::::: divide out by volume weight
c
            do jc = lo(2), hi(2)
               do ic = lo(1), hi(1)
                  crse(ic,jc,n) = crse(ic,jc,n)/cv(ic,jc)
               end do
            end do
            
         end do

      else

         do n = 1, nvar
c
c         ::::: set coarse grid to zero on overlap
c
            do ic = lo(1), hi(1)
               do jc = lo(2), hi(2)
                  crse(ic,jc,n) = zero
               end do
            end do
c
c         ::::: sum fine data
c
            do ioff = 0, lrat-1
               do ic = lo(1), hi(1)
                  i = ic*lrat + ioff
                  do joff = 0, lrat-1
                     do jc = lo(2), hi(2)
                        j = jc*lrat + joff
                        crse(ic,jc,n) = crse(ic,jc,n) + fv(i,j)*fine(i,j,n)
                     end do
                  end do
               end do
            end do
c	 	 
c         ::::: divide out by volume weight
c
            do ic = lo(1), hi(1)
               do jc = lo(2), hi(2)
                  crse(ic,jc,n) = crse(ic,jc,n)/cv(ic,jc)
               end do
            end do
            
         end do
      end if

      end

c :: ----------------------------------------------------------
c :: SUMMASS
c ::             MASS = sum{ vol(i,j)*rho(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  rho        => density field
c ::  rlo,rhi    => index limits of rho aray
c ::  lo,hi      => index limits of grid interior
c ::  delta	 => cell size
c ::  mass      <=  total mass
c ::  r		 => radius at cell center
c ::  irlo,hi    => index limits of r array
c ::  rz_flag    => == 1 if R_Z coords
c ::  tmp        => temp column array
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMMASS(rho,DIMS(r),lo,hi,delta,mass,
     &                         r,irlo,irhi,rz_flag,tmp,tlo,thi)
       integer irlo, irhi, rz_flag
       integer DIMDEC(r)
       integer lo(2), hi(2)
       REAL_T  mass, delta(2)
       REAL_T  rho(DIMV(r))
       REAL_T  r(irlo:irhi)
       integer tlo,thi
       REAL_T  tmp(tlo:thi)

       integer i, j
       REAL_T  dr, dz, vol

       dr = delta(1)
       dz = delta(2)

       do j = lo(2),hi(2)
          tmp(j) = zero
       end do

       do i = lo(1), hi(1)
          vol = dr*dz
	  if (rz_flag .eq. 1) vol = vol*two*Pi*r(i)
          do j = lo(2), hi(2)
	     tmp(j) = tmp(j) + vol*rho(i,j)
	  end do
       end do

       mass = zero

       do j = lo(2), hi(2)
          mass = mass + tmp(j)
       end do

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "MACPROJ_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2
#define CDIMS loc_1,loc_2,hic_1,hic_2

c *************************************************************************
c ** INITSIGMA **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIGMA(sigmax,sigmay,rho,areax,areay,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T sigmax(lo_1-ng+1:hi_1+ng  ,lo_2-ng+1:hi_2+ng-1)
      REAL_T sigmay(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng  )
      REAL_T    rho(lo_1-3   :hi_1+3   ,lo_2-3   :hi_2+3)
      REAL_T  areax(lo_1     :hi_1+1   ,lo_2     :hi_2  )
      REAL_T  areay(lo_1     :hi_1     ,lo_2     :hi_2+1)
      integer bc(2,2)

c     Local variables
      integer i,j

      do j = lo_2,hi_2 
        do i = lo_1,hi_1+1 
          sigmax(i,j) = two*areax(i,j)/(rho(i,j) + rho(i-1,j))
        enddo

        if (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) then
          sigmax(lo_1,j) = areax(lo_1,j) / rho(lo_1-1,j)
        else if (BCX_LO .eq. OUTLET) then
          sigmax(lo_1,j) = areax(lo_1,j) / rho(lo_1,j)
        endif

        if (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) then
          sigmax(hi_1+1,j) = areax(hi_1+1,j) / rho(hi_1+1,j)
        else if (BCX_HI .eq. OUTLET) then
          sigmax(hi_1+1,j) = areax(hi_1+1,j) / rho(hi_1,j)
        endif
      enddo

      do i = lo_1,hi_1 
        do j = lo_2,hi_2+1 
          sigmay(i,j) = two * areay(i,j) /
     $                  (rho(i,j) + rho(i,j-1))
        enddo

        if (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) then
          sigmay(i,lo_2) = areay(i,lo_2) / rho(i,lo_2-1)
        else if (BCY_LO .eq. OUTLET) then
          sigmay(i,lo_2) = areay(i,lo_2) / rho(i,lo_2)
        endif

        if (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) then
          sigmay(i,hi_2+1) = areay(i,hi_2+1) / rho(i,hi_2+1)
        else if (BCY_HI .eq. OUTLET) then
          sigmay(i,hi_2+1) = areay(i,hi_2+1) / rho(i,hi_2)
        endif
      enddo

      return
      end

c *************************************************************************
c ** PROJUMAC **
c ** Update the edge-based velocities
c *************************************************************************

      subroutine FORT_PROJUMAC(uadv,vadv,sigmax,sigmay,phi,
     $                         areax,areay,dx,DIMS,bc,is_rz,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   uadv(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T   vadv(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T sigmax(lo_1-ng+1:hi_1  +ng,lo_2-ng+1:hi_2-1+ng)
      REAL_T sigmay(lo_1-ng+1:hi_1-1+ng,lo_2-ng+1:hi_2  +ng)
      REAL_T    phi(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2  +ng)
      REAL_T  areax(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T  areay(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T     dx(2)
      integer is_rz
      integer bc(2,2)

c     Local variables
      integer i,j
      integer istart

      call setbc(phi,DIMS,bc,ng)

      istart = cvmgt(lo_1+1,lo_1,is_rz .eq. 1 .and. lo_1 .eq. 0)

      do j = lo_2,hi_2
        do i = istart,hi_1+1
          uadv(i,j) = uadv(i,j) - sigmax(i,j) / areax(i,j) * 
     $                (phi(i,j)-phi(i-1,j))/dx(1)
        enddo
      enddo

      do j = lo_2,hi_2+1
        do i = lo_1,hi_1
          vadv(i,j) = vadv(i,j) - sigmay(i,j) / areay(i,j) * 
     $                (phi(i,j)-phi(i,j-1))/dx(2)
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D( sig G(phi) )
c *************************************************************************

      subroutine FORT_RESIDUAL(resid,phi,f,sigmax,sigmay,DIMS,dx,resnorm,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  resid(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T    phi(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T sigmax(lo_1-ng+1:hi_1  +ng,lo_2-ng+1:hi_2-1+ng)
      REAL_T sigmay(lo_1-ng+1:hi_1-1+ng,lo_2-ng+1:hi_2  +ng)
      REAL_T dx(2)
      REAL_T resnorm
      integer bc(2,2)

c     Local variables
      REAL_T hxinv, hyinv
      REAL_T rfac, corr
      integer i,j

      hxinv = one/dx(1)
      hyinv = one/dx(2)

      resnorm = zero

      call setbc(phi,DIMS,bc,ng)

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 

          rfac = ((sigmax(i+1,j) + sigmax(i,j))*hxinv + 
     $            (sigmay(i,j+1) + sigmay(i,j))*hyinv )
          corr =  
     $      ( sigmax(i+1,j)*phi(i+1,j) + sigmax(i,j)*phi(i-1,j))*hxinv + 
     $      ( sigmay(i,j+1)*phi(i,j+1) + sigmay(i,j)*phi(i,j-1))*hyinv 

          resid(i,j) = f(i,j) - (corr - rfac*phi(i,j))

          resnorm = max(resnorm, abs(resid(i,j)))

        enddo
      enddo

      return
      end

c *************************************************************************
c ** RELAX **
c ** Gauss-Seidel or line solve relaxation (depending on hy/hx)
c *************************************************************************

      subroutine FORT_RELAX(phi,f,sigmax,sigmay,
     $                      DIMS,dx,bc,nnrelax,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    phi(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T sigmax(lo_1-ng+1:hi_1  +ng,lo_2-ng+1:hi_2-1+ng)
      REAL_T sigmay(lo_1-ng+1:hi_1-1+ng,lo_2-ng+1:hi_2  +ng)
      REAL_T dx(2)
      integer bc(2,2)
      integer nnrelax

c     Local variables
      REAL_T rfac, corr
      integer i, j, iinc
      integer iter
      integer extra_xlo, extra_ylo
      integer extra_xhi, extra_yhi

      if (ng .lt. 2*nnrelax) then
        print *,'NOT ENOUGH GHOST CELLS FOR RELAX '
        print *,'NG ',ng
        print *,'NNRELAX ',nnrelax
        stop
      endif

      call setbc(phi,DIMS,bc,ng)

      do iter = 1, 2*nnrelax

          extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
          extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
          extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
          extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)

          do j = lo_2-extra_ylo,hi_2+extra_yhi 
           iinc = mod(j+iter+1+extra_xlo+2*ng,2)
           do i = lo_1-extra_xlo+iinc,hi_1+extra_xhi,2

              rfac = ( (sigmax(i+1,j) + sigmax(i,j))/dx(1) +
     $                 (sigmay(i,j+1) + sigmay(i,j))/dx(2) )

              corr =
     $        ( sigmax(i+1,j)*phi(i+1,j) + sigmax(i,j)*phi(i-1,j))/dx(1) +
     $        ( sigmay(i,j+1)*phi(i,j+1) + sigmay(i,j)*phi(i,j-1))/dx(2)

              rfac = one / rfac

              phi(i,j) = (corr - f(i,j)) * rfac

           enddo
         enddo

         call setbc(phi,DIMS,bc,ng)

      enddo

      return
      end


c *************************************************************************
c ** BC **
c ** Impose boundary conditions
c *************************************************************************

      subroutine setbc(phi,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  phi(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng)
      integer bc(2,2)

c     Local variables
      integer i, j, is, ie, js, je

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (BCY_LO .eq. OUTLET) then
        do i = is-ng,ie+ng 
          phi(i,js-1) = -phi(i,js)
        enddo
      elseif (BCY_LO .eq. INLET .or. BCY_LO .eq. WALL) then
        do i = is-ng,ie+ng 
          phi(i,js-1) =  phi(i,js)
        enddo
      endif

      if (BCY_HI .eq. OUTLET) then
        do i = is-ng,ie+ng 
          phi(i,je+1) = -phi(i,je)
        enddo
      elseif (BCY_HI .eq. INLET .or. BCY_HI .eq. WALL) then
        do i = is-ng,ie+ng 
          phi(i,je+1) = phi(i,je)
        enddo
      endif

      if (BCX_LO .eq. OUTLET) then
        do j = js-ng,je+ng 
          phi(is-1,j) = -phi(is,j)
        enddo
      elseif (BCX_LO .eq. INLET .or. BCX_LO .eq. WALL) then
        do j = js-ng,je+ng 
          phi(is-1,j) =  phi(is,j)
        enddo
      endif

      if (BCX_HI .eq. OUTLET) then
        do j = js-ng,je+ng 
          phi(ie+1,j) = -phi(ie,j)
        enddo
      elseif (BCX_HI .eq. INLET .or. BCX_HI .eq. WALL) then
        do j = js-ng,je+ng 
          phi(ie+1,j) = phi(ie,j)
        enddo
      endif

      return
      end

c *************************************************************************
c ** RHSMAC **
c ** Compute the right-hand-side D(U) for the MAC projection
c *************************************************************************

      subroutine FORT_RHSMAC(uadv,vadv,divu_src,rhs,
     $                       areax,areay,vol,DIMS,rhsnorm,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T     uadv(lo_1   :hi_1+1 ,lo_2   :hi_2   )
      REAL_T     vadv(lo_1   :hi_1   ,lo_2   :hi_2+1 )
      REAL_T divu_src(lo_1   :hi_1   ,lo_2   :hi_2   )
      REAL_T      rhs(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T    areax(lo_1   :hi_1+1 ,lo_2   :hi_2   )
      REAL_T    areay(lo_1   :hi_1   ,lo_2   :hi_2+1 )
      REAL_T      vol(lo_1-1 :hi_1+1 ,lo_2-1 :hi_2+1 )
      REAL_T  rhsnorm

c     Local variables
      integer i,j

      rhsnorm = zero
      do j = lo_2,hi_2
        do i = lo_1,hi_1

          rhs(i,j) = areax(i+1,j)*uadv(i+1,j) - areax(i,j)*uadv(i,j) +
     $               areay(i,j+1)*vadv(i,j+1) - areay(i,j)*vadv(i,j)

          rhs(i,j) = rhs(i,j) - vol(i,j)*divu_src(i,j)

          rhsnorm = max(rhsnorm,abs(rhs(i,j)))

        enddo
      enddo

      return
      end

c *************************************************************************
c ** COARSIGMA **
c ** Coarsen the edge-based sigma coefficients
c *************************************************************************

      subroutine FORT_COARSIGMA(sigmax,sigmay,sigmaxc,sigmayc,DIMS,CDIMS,ng)

      implicit none
      integer DIMS
      integer CDIMS
      integer ng
      REAL_T  sigmax(lo_1 -ng+1:hi_1   +ng,lo_2 -ng+1:hi_2 -1+ng)
      REAL_T  sigmay(lo_1 -ng+1:hi_1 -1+ng,lo_2 -ng+1:hi_2   +ng)
      REAL_T sigmaxc(loc_1-ng+1:hic_1  +ng,loc_2-ng+1:hic_2-1+ng)
      REAL_T sigmayc(loc_1-ng+1:hic_1-1+ng,loc_2-ng+1:hic_2  +ng)

c     Local variables
      integer i,j

      do j = lo_2,hi_2,2
        do i = lo_1,hi_1+1,2
          sigmaxc(i/2,j/2) = (sigmax(i,j) + sigmax(i,j+1)) * fourth
        enddo
      enddo

      do j = lo_2,hi_2+1,2
        do i = lo_1,hi_1,2
          sigmayc(i/2,j/2) = (sigmay(i,j) + sigmay(i+1,j)) * fourth
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservatively average the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,nextra)

      implicit none
      integer DIMS
      integer CDIMS
      integer nextra
      REAL_T  res(lo_1 -nextra:hi_1 +nextra,lo_2 -nextra:hi_2 +nextra)
      REAL_T resc(loc_1-nextra:hic_1+nextra,loc_2-nextra:hic_2+nextra)

c     Local variables
      integer i,j

      do j = lo_2,hi_2,2
        do i = lo_1,hi_1,2
          resc(i/2,j/2) =  (res(i  ,j) + res(i  ,j+1) +
     $                      res(i+1,j) + res(i+1,j+1) ) * fourth

        enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise constant interpolation
c *************************************************************************

      subroutine FORT_INTERPOLATE(phi,deltac,DIMS,CDIMS,ng)

      implicit none
      integer DIMS
      integer CDIMS
      integer ng
      REAL_T    phi(lo_1 -ng:hi_1 +ng,lo_2 -ng:hi_2 +ng)
      REAL_T deltac(loc_1-ng:hic_1+ng,loc_2-ng:hic_2+ng)

c     Local variables
      integer i,j

      do j = lo_2,hi_2
        do i = lo_1,hi_1
          phi(i,j) = phi(i,j) + deltac(i/2,j/2)
        enddo
      enddo

      return
      end

c *************************************************************************
c ** SOLVEMAC **
c ** Conjugate gradient bottom-solver
c *************************************************************************

      subroutine FORT_SOLVEMAC(dest, dest0, source, sigmax, sigmay, sum, 
     $                         r, w, z, work, DIMS, dx, bc, norm, prob_norm, ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng)
      REAL_T  dest0(lo_1-1 :hi_1+ 1,lo_2-1 :hi_2+1)
      REAL_T source(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1)
      REAL_T sigmax(lo_1-ng+1:hi_1  +ng,lo_2-ng+1:hi_2-1+ng)
      REAL_T sigmay(lo_1-ng+1:hi_1-1+ng,lo_2-ng+1:hi_2  +ng)
      REAL_T    sum(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      r(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      w(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T      z(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   work(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T dx(2)
      integer bc(2,2)
      REAL_T norm
      REAL_T prob_norm

c     Local variables
      integer i,j,iter,is,ie,js,je
      REAL_T alpha, beta, rho, rhol
      REAL_T  tol,tolfac
      REAL_T local_norm
      REAL_T sum_src
      logical is_singular

      tolfac = 1.0d-3

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      call macperiodic(dest,DIMS,bc,ng)
      call       setbc(dest,DIMS,bc,ng)

      do j = js-1,je+1 
        do i = is-1,ie+1 
          dest0(i,j) = dest(i,j)
           dest(i,j) = zero
        enddo
      enddo

      is_singular = (BCX_LO .ne. OUTLET .and. BCX_HI .ne. OUTLET .and.
     $               BCY_LO .ne. OUTLET .and. BCY_HI .ne. OUTLET)

      sum_src = zero
      if (is_singular) then
        do j = js, je 
        do i = is, ie 
          sum_src = sum_src + source(i,j)
        enddo
        enddo
        sum_src = sum_src / float((je-js+1)*(ie-is+1))
        do j = js, je 
        do i = is, ie 
          source(i,j) = source(i,j) - sum_src
        enddo
        enddo
      endif


 10   do j = js,je 
        do i = is,ie 
          w(i,j) = 
     $     ( sigmax(i+1,j)*dest0(i+1,j) + 
     $       sigmax(i  ,j)*dest0(i-1,j) )/dx(1)
     $    +( sigmay(i,j+1)*dest0(i,j+1) + 
     $       sigmay(i,j  )*dest0(i,j-1) )/dx(2)
     $    -((sigmax(i+1,j) + sigmax(i,j))/dx(1)
     $     +(sigmay(i,j+1) + sigmay(i,j))/dx(2) ) * dest0(i,j)
        enddo
      enddo

      do j = js, je 
        do i = is, ie 
          r(i,j) = source(i,j) - w(i,j)
        enddo
      enddo

      rho        = zero
      norm       = zero
      local_norm = zero

      do j = js, je 
        do i = is, ie 
          z(i,j) = r(i,j) 
          rho = rho + z(i,j) * r(i,j)
          local_norm = max(local_norm,abs(r(i,j)))
          norm       = max(norm      ,abs(r(i,j)))
        enddo
      enddo

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)

      if (norm .le. tol) then
        if (tolfac .gt. 1.0d-3) then
          do j = js-1,je+1 
          do i = is-1,ie+1 
            dest(i,j) = zero
          enddo
          enddo
        endif
        return
      endif

      do j = js, je 
        do i = is, ie 
          work(i,j) = zero
          dest(i,j) = z(i,j)
        enddo
      enddo

      iter = 0

c     write(6,1000) iter, norm/prob_norm

 100  call macperiodic(dest,DIMS,bc,ng)
      call       setbc(dest,DIMS,bc,ng)

      do j = js,je 
        do i = is,ie 
          w(i,j) = 
     $     ( sigmax(i+1,j)*dest(i+1,j) + 
     $       sigmax(i  ,j)*dest(i-1,j) )/dx(1)
     $    +( sigmay(i,j+1)*dest(i,j+1) + 
     $       sigmay(i,j  )*dest(i,j-1) )/dx(2)
     $    -((sigmax(i+1,j) + sigmax(i,j))/dx(1) + 
     $      (sigmay(i,j+1) + sigmay(i,j))/dx(2) ) * dest(i,j)
        enddo
      enddo


      alpha = zero
      do j = js, je 
        do i = is, ie 
          alpha = alpha + dest(i,j)*w(i,j)
        enddo
      enddo

      alpha = rho / alpha
      rhol = rho
      rho = zero
      norm = zero

      do j = js, je 
        do i = is, ie 
          work(i,j) = work(i,j) + alpha * dest(i,j)
          r(i,j) = r(i,j) - alpha * w(i,j)
          z(i,j) = r(i,j)
          rho = rho + z(i,j) * r(i,j)
          norm = max(norm,abs(r(i,j)))
        enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then
         
         do j = js, je 
            do i = is, ie 
               dest(i,j) = work(i,j) + dest0(i,j)
            enddo
         enddo

         call setbc(dest,DIMS,bc,ng)

      else if (iter .ge. 100  .or.  norm .ge. 100.d0 * local_norm) then

         tolfac = 10.d0 * tolfac
         iter = 1
         do j = js, je 
            do i = is, ie 
               dest(i,j) = work(i,j) + dest0(i,j)
            enddo
         enddo
         goto 10

      else

        beta = rho / rhol
        do j = js, je 
          do i = is, ie 
            dest(i,j) = z(i,j) + beta * dest(i,j)
          enddo
        enddo
        goto 100
      endif

c      call flush(6)

1000  format('Res/Res0 in solve: ',i4,2x,e12.5)
c     call flush(6)

      return
      end

c *************************************************************************
c ** MKSUMMAC **
c ** Pre-compute the sum of coefficients for the conjugate gradient solver
c *************************************************************************

      subroutine FORT_MKSUMMAC(sum,sigmax,sigmay,DIMS,dx,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    sum(lo_1-1   :hi_1+1   ,lo_2-1   :hi_2+1   )
      REAL_T sigmax(lo_1-ng+1:hi_1  +ng,lo_2-ng+1:hi_2-1+ng)
      REAL_T sigmay(lo_1-ng+1:hi_1-1+ng,lo_2-ng+1:hi_2  +ng)
      REAL_T dx(2)

c     Local variables
      integer i,j

      do j = lo_2,hi_2
        do i = lo_1,hi_1
          sum(i,j) = ( (sigmax(i+1,j) + sigmax(i,j))/dx(1)
     $                +(sigmay(i,j+1) + sigmay(i,j))/dx(2) )
          sum(i,j) = -fourth*sum(i,j)
        enddo
      enddo

      return
      end



c *************************************************************************
c ** TRIDIAG **
c ** Do a tridiagonal solve 
c *************************************************************************

      subroutine tridiag(a,b,c,r,u,n)

      integer n
      integer nmax

      REAL_T a(n)
      REAL_T b(n)
      REAL_T c(n)
      REAL_T r(n)
      REAL_T u(n)

      parameter (nmax = 4098)

      integer j
      REAL_T bet
      REAL_T gam(nmax)
      if (b(1) .eq. 0) print *,'CANT HAVE B(1) = ZERO'

      bet = b(1)
      u(1) = r(1)/bet

      do j = 2,n
        gam(j) = c(j-1)/bet
        bet = b(j) - a(j)*gam(j)
        if (bet .eq. 0) then
          print *,'TRIDIAG FAILED '
          stop
        endif
        u(j) = (r(j)-a(j)*u(j-1))/bet
      enddo

      do j = n-1,1,-1
        u(j) = u(j) - gam(j+1)*u(j+1)
      enddo

      return
      end

c *************************************************************************
c ** MACPERIODIC **
c  Impose periodic boundary conditions on the single grid data in the
c   conjugate gradient bottom solver.
c *************************************************************************

      subroutine macperiodic(dest,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng)
      integer bc(2,2)

      integer i,j

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC) then
        do j = lo_2,hi_2
          dest(lo_1-1,j) = dest(hi_1,j)
          dest(hi_1+1,j) = dest(lo_1,j)
        enddo
      endif
      if (BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC) then
        do i = lo_1,hi_1
          dest(i,lo_2-1) = dest(i,hi_2)
          dest(i,hi_2+1) = dest(i,lo_2)
        enddo
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2
#define SDIMS slo_1,slo_2,shi_1,shi_2

c *************************************************************************
c ** PROBINIT **
c ** Read in the problem-dependent parameters for the FORTRAN common blocks
c *************************************************************************

      subroutine FORT_PROBINIT (name,namlen)
      integer namlen
      integer name(namlen)
      integer untin, i

#include "probdata.H"

      namelist /fortin/ prob_type, zero_dir,
     $                  in_xvel, in_yvel, in_zvel, in_density, in_tracer,
     $                  xblob, yblob, zblob, radblob, denblob, velfact

c      Build `probin' filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      character probin*(maxlen)

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      untin = 9
      if (namlen .eq. 0) then
         open(untin,file='probin',form='formatted',status='old')
      else
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if

      read(untin,fortin)
      close(unit=untin)

      end

c *************************************************************************
c ** INITDATA **
c ** Call the appropriate subroutine to initialize the data
c *************************************************************************

      subroutine FORT_INITDATA(state,DIMS,dx,time,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T  state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)
      REAL_T  time

      print *,' '

      if (prob_type .eq. 1) then

        call initspin(state,dx,DIMS,numscal)

      else if (prob_type .eq. 2) then

        call initbubble(state,dx,DIMS,numscal)

      else if (prob_type .eq. 3) then

        call initshear(state,dx,DIMS,numscal)

      else if (prob_type .eq. 4) then

        call initchannel(state,dx,DIMS,numscal)

      else if (prob_type .eq. 5) then

        call initxypoiseuille(state,dx,DIMS,numscal)

      else if (prob_type .eq. 6) then

        call initrzpoiseuille(state,dx,DIMS,numscal)

      else 

        print *,'DONT KNOW THIS PROBLEM TYPE: ',prob_type
        stop
 
      endif

      return
      end

c *************************************************************************
c ** INITSPIN **
c ** Initialize the constant density flow-in-a-box problem
c *************************************************************************

      subroutine initspin(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y
      REAL_T spx, spy, cpx, cpy
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        spx = sin(Pi*x)
        cpx = cos(Pi*x)
        spy = sin(Pi*y)
        cpy = cos(Pi*y)

        state(i,j,1) =  velfact*two*spy*cpy*spx**2
        state(i,j,2) = -velfact*two*spx*cpx*spy**2

        state(i,j,3) = one

      enddo
      enddo

      do n = 2, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        x = dx(1)*(float(i) + half) - 0.5d0
        y = dx(2)*(float(j) + half) - 0.5d0
        state(i,j,2+n) = sqrt(x*x+y*y)
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITBUBBLE **
c ** Initialize the bubble-drop in a box problem
c *************************************************************************

      subroutine initbubble(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        state(i,j,1) = zero
        state(i,j,2) = zero

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2)

        state(i,j,3) = one+(denblob-one)*(half+half*tanh(100.d0*(radblob-r)))
c       state(i,j,3) = cvmgt(denblob,one,r .lt. radblob)

      enddo
      enddo

      do n = 2, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,2+n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITSHEAR **
c ** Initialize a constant density doubly-periodic shear problem
c *************************************************************************

      subroutine initshear(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        state(i,j,1) = tanh(30.d0*(fourth - abs(y-half)))
        state(i,j,2) = 0.05d0 * sin(two*Pi*x)

        state(i,j,3) = one

      enddo
      enddo

      do n = 2, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        x = dx(1)*(float(i) + half) - 0.5d0
        y = dx(2)*(float(j) + half) - 0.5d0
        state(i,j,2+n) = sqrt(x*x+y*y)
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITCHANNEL **
c ** Initialize the channel inflow problem
c *************************************************************************

      subroutine initchannel(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      if (numscal .lt. 2) then
        print *,"CHANNEL FLOW NEEDS MORE SCALARS"
        stop
      endif

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2)

c       state(i,j,1) = in_xvel
c       state(i,j,2) = in_yvel

        state(i,j,1) = zero
        state(i,j,2) = zero

        state(i,j,3) = cvmgt(denblob,in_density,r .lt. radblob)
        state(i,j,4) = cvmgt(one    ,in_tracer ,r .lt. radblob)

      enddo
      enddo

      do n = 3, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,2+n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITXYPOISEUILLE **
c ** Initialize the Poiseuille (viscous flow in an x-y pipe) problem
c *************************************************************************

      subroutine initxypoiseuille(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2)

        state(i,j,1) = zero
        state(i,j,2) = one-(x-one)*(x-one)
        state(i,j,3) = one

      enddo
      enddo

      if (numscal .ge. 2) then
        do j = lo_2,hi_2
        do i = lo_1,hi_1
          x = dx(1)*(float(i) + half)
          y = dx(2)*(float(j) + half)
          r = sqrt((x-xblob)**2 + (y-yblob)**2)
          state(i,j,4) = cvmgt(one    ,in_tracer ,r .lt. radblob)
        enddo
        enddo
      endif

      do n = 3, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,2+n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITRZPOISEUILLE **
c ** Initialize the Poiseuille (viscous flow in an r-z pipe) problem
c *************************************************************************

      subroutine initrzpoiseuille(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,numscal+BL_SPACEDIM)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        state(i,j,1) = zero
        state(i,j,2) = one-x*x
        state(i,j,3) = one

      enddo
      enddo

      if (numscal .ge. 2) then
        do j = lo_2,hi_2
        do i = lo_1,hi_1
          x = dx(1)*(float(i) + half)
          y = dx(2)*(float(j) + half)
          r = sqrt((x-xblob)**2 + (y-yblob)**2)
          state(i,j,4) = cvmgt(one    ,in_tracer ,r .lt. radblob)
        enddo
        enddo
      endif

      do n = 3, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,2+n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** DERVORT **
c ** Derive a cell-centered vorticity
c *************************************************************************

      subroutine FORT_DERVORT(state,derval,derlo_1,derlo_2,derhi_1,derhi_2,
     $                        DIMS,dx)

      implicit none

      integer derlo_1, derlo_2
      integer derhi_1, derhi_2
      integer DIMS
      REAL_T   state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      REAL_T  derval(derlo_1:derhi_1,derlo_2:derhi_2)
      REAL_T  dx(2)

c     Local variables
      integer i, j

      do j = lo_2, hi_2 
      do i = lo_1, hi_1 
          derval(i,j) = fourth*(state(i+1,j+1,2)+state(i+1,j-1,2)- 
     $                          state(i-1,j+1,2)-state(i-1,j-1,2)) / dx(1) -
     $                  fourth*(state(i+1,j+1,1)+state(i-1,j+1,1)- 
     $                          state(i+1,j-1,1)-state(i-1,j-1,1)) / dx(2)
      enddo
      enddo

      return
      end

c *************************************************************************
c ** DERAVGP **
c ** Average nodal pressure onto cell centers for plotting purposes
c *************************************************************************

      subroutine FORT_DERAVGP(pressure,dat,DIMS)

      implicit none

      integer DIMS
      REAL_T  pressure(lo_1:hi_1+1,lo_2:hi_2+1)
      REAL_T       dat(lo_1:hi_1  ,lo_2:hi_2  )

c     Local variables
      integer i, j

      do j = lo_2, hi_2
        do i = lo_1, hi_1
          dat(i,j) = (pressure(i,j  ) + pressure(i+1,j  ) +
     $                pressure(i,j+1) + pressure(i+1,j+1) ) * fourth
      enddo
      enddo

      return
      end

c *************************************************************************
c ** FORT_SET_CELL_VELBC **
c ** set velocity bc for computation of derived variables
c *************************************************************************

      subroutine FORT_SET_CELL_VELBC(u,DIMS,bc,irz,visc_coef,dx,time)
      
      implicit none

#include "probdata.H"      

      integer DIMS
      REAL_T     u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      integer bc(2,2)
      integer irz
      REAL_T visc_coef
      REAL_T dx(2)
      REAL_T time

c     Local variables
      integer i, j, is, ie, js, je
      REAL_T  x

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (BCY_LO .eq. OUTLET) then
        do i = is-1,ie+1
          u(i,js-1,2) = u(i,js,2)
          u(i,js-1,1) = u(i,js,1)
        enddo
      elseif (BCY_LO .eq. INLET) then
        if (prob_type .eq. 5) then
          do i = is-1,ie+1
            x = (float(i)+half)*dx(1)
            u(i,js-1,2) =  one - (x-one)*(x-one)
            u(i,js-1,1) =  -u(i,js,1)
          enddo
        else if (prob_type .eq. 6) then
          do i = is-1,ie+1
            x = (float(i)+half)*dx(1)
            u(i,js-1,2) = one - x*x
            u(i,js-1,1) =  -u(i,js,1)
          enddo
        else
          do i = is-1,ie+1
            u(i,js-1,2) =  two* in_yvel - u(i,js,2)
            u(i,js-1,1) =  -u(i,js,1)
          enddo
        endif
      elseif (BCY_LO .eq. WALL) then
        do i = is-1,ie+1
           u(i,js-1,2) =  -u(i,js,2)
           u(i,js-1,1) =  three*u(i,js,1) - three*u(i,js+1,1)+u(i,js+2,1)
        enddo
        if (visc_coef .gt. zero) then
           do i = is-1,ie+1
           u(i,js-1,2) =  -u(i,js,2)
              u(i,js-1,1) =  -u(i,js,1)
           enddo
        endif
      endif

      if (BCY_HI .eq. OUTLET) then
        do i = is-1,ie+1
          u(i,je+1,2) = u(i,je,2)
          u(i,je+1,1) = u(i,je,1)
        enddo
      elseif (BCY_HI .eq. INLET) then 
        do i = is-1,ie+1
          u(i,je+1,2) = two*in_yvel - u(i,je,2)
          u(i,je+1,1) = - u(i,je,1)
        enddo
      elseif (BCY_HI .eq. WALL) then
        do i = is-1,ie+1
          u(i,je+1,2) = -u(i,je,2)
          u(i,je+1,1) =  three*u(i,je,1) - three*u(i,je-1,1)+u(i,je-2,1)
        enddo
        if (visc_coef .gt. zero) then
           do i = is-1,ie+1
              u(i,je+1,1) = -u(i,je,1)
           enddo
        endif
      endif

      if (BCX_LO .eq. OUTLET) then
        do j = js-1,je+1
          u(is-1,j,1) = u(is,j,1)
          u(is-1,j,2) = u(is,j,2)
        enddo
      elseif (BCX_LO .eq. INLET) then 
        do j = js-1,je+1
          u(is-1,j,1) =  two*in_xvel - u(is,j,1)
          u(is-1,j,2) =  - u(is,j,2)
        enddo
      elseif (BCX_LO .eq. WALL) then
        do j = js-1,je+1
          u(is-1,j,1) =  -u(is,j,1)
          u(is-1,j,2) =  three*u(is,j,2)-three*u(is+1,j,2)+u(is+2,j,2)
        enddo
        if (irz .eq. 0 .and. visc_coef .gt. zero) then
           do j = js-1,je+1
              u(is-1,j,2) =  -u(is,j,2)
           enddo
        endif
      endif

      if (BCX_HI .eq. OUTLET) then
        do j = js-1,je+1
          u(ie+1,j,1) = u(ie,j,1)
          u(ie+1,j,2) = u(ie,j,2)
        enddo
      elseif (BCX_HI .eq. INLET) then
        do j = js-1,je+1
          u(ie+1,j,1) = two *in_xvel - u(ie,j,1)
          u(ie+1,j,2) = - u(ie,j,2)
        enddo
      elseif (BCX_HI .eq. WALL) then
        do j = js-1,je+1
          u(ie+1,j,1) = - u(ie,j,1)
          u(ie+1,j,2) =  three*u(ie,j,2)-three*u(ie-1,j,2)+u(ie-2,j,2)
        enddo
        if (visc_coef .gt. zero) then
           do j = js-1,je+1
              u(ie+1,j,2) = - u(ie,j,2)
           enddo
        endif
      endif

      return
      end

c *************************************************************************
c ** VELINFLOW **
c ** Impose the inflow boundary conditions on velocity
c *************************************************************************

      subroutine velinflow(u,DIMS,time,dx,idir,is_hi)

      implicit none

#include "probdata.H"

      integer DIMS
      REAL_T u(lo_1-3:hi_1+3,lo_2-3:hi_2+3)
      REAL_T time
      REAL_T dx(2)
      integer idir
      integer is_hi

c     Local variables
      integer i,j
      REAL_T x

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do j = lo_2-3,hi_2+3 
            u(lo_1-1,j) = in_xvel
            u(lo_1-2,j) = in_xvel
            u(lo_1-3,j) = in_xvel
          enddo
        else
          do j = lo_2-3,hi_2+3 
            u(hi_1+1,j) = in_xvel
            u(hi_1+2,j) = in_xvel
            u(hi_1+3,j) = in_xvel
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          if (prob_type .eq. 5) then
            do i = lo_1-3,hi_1+3 
              x = (float(i)+half)*dx(1)
              u(i,lo_2-1) = one-(x-one)*(x-one)
              u(i,lo_2-2) = one-(x-one)*(x-one)
              u(i,lo_2-3) = one-(x-one)*(x-one)
            enddo
          elseif (prob_type .eq. 6) then
            do i = lo_1-3,hi_1+3 
              x = (float(i)+half)*dx(1)
              u(i,lo_2-1) = one-x*x
              u(i,lo_2-2) = one-x*x
              u(i,lo_2-3) = one-x*x
            enddo
          else
            do i = lo_1-3,hi_1+3 
              u(i,lo_2-1) = in_yvel
              u(i,lo_2-2) = in_yvel
              u(i,lo_2-3) = in_yvel
            enddo
          endif
        else
          do i = lo_1-3,hi_1+3 
            u(i,hi_2+1) = in_yvel
            u(i,lo_2-2) = in_yvel
            u(i,lo_2-3) = in_yvel
          enddo
        endif

      else
        print *,'bogus idir in velinflow ',idir
        stop
      endif

      return
      end

c *************************************************************************
c ** SCALINFLOW **
c ** Impose the inflow boundary conditions on scalars
c *************************************************************************

      subroutine scalinflow(s,DIMS,SDIMS,time,dx,idir,is_hi,which_scal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer SDIMS
      REAL_T  s(slo_1:shi_1,slo_2:shi_2)
      REAL_T  time
      REAL_T  dx(2)
      integer idir
      integer is_hi
      integer which_scal

c     Local variables
      integer i,j
      integer ng,ngmax
      REAL_T  inflow_val

      ngmax = lo_1-slo_1
    
      if (which_scal .eq. 0) then
        inflow_val = in_density
      elseif (which_scal .eq. 1) then
        inflow_val = in_tracer
      else
        print *,"STOP IN SCALINFLOW "
        print *," --  DONT HAVE VALUE FOR THIS VARIABLE "
        stop
      endif

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do ng=1,ngmax
          do j = slo_2,shi_2
            s(lo_1-ng,j) = inflow_val
          enddo
          enddo
        else 
          do ng=1,ngmax
          do j = slo_2,shi_2
            s(hi_1+ng,j) = inflow_val
          enddo
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          do ng=1,ngmax
          do i = slo_1,shi_1
            s(i,lo_2-ng) = inflow_val
          enddo
          enddo
        else
          do ng=1,ngmax
          do i = slo_1,shi_1
            s(i,hi_2+ng) = inflow_val
          enddo
          enddo
        endif

      else

        print *,'bogus idir in scalinflow ',idir
        stop

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** SLOPEY **
c ** Compute the slope of nvar components of s in the y-direction
c *************************************************************************

      subroutine FORT_SLOPEY(s,sly,dyscr,DIMS,nvar,bc,slope_order)

      implicit none

      integer DIMS
      integer nvar
      integer bc(2,2)
      integer slope_order

      REAL_T      s(lo_1-3:hi_1+3,lo_2-3:hi_2+3,nvar)
      REAL_T    sly(lo_1-1:hi_1+1,lo_2-1:hi_2+1,nvar)
      REAL_T  dyscr(lo_2-2:hi_2+2,4)

      integer cen,lim,flag,fromm

      parameter( cen = 1 )
      parameter( lim = 2 )
      parameter( flag = 3 )
      parameter( fromm = 4 )

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag

      integer is,js,ie,je,i,j,iv

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

c ::: HERE DOING 1ST ORDER
      if (slope_order .eq. 0) then
        do iv = 1,nvar 
          do j = js-1,je+1 
            do i = is-1,ie+1 
              sly(i,j,iv) = zero
            enddo
          enddo
        enddo

c ::: HERE DOING 2ND ORDER
      else if (slope_order .eq. 2) then

        do iv=1,nvar 
          do j = js-1,je+1 
            do i = is-1,ie+1 

              del  = half*(s(i,j+1,iv) - s(i,j-1,iv))
              dpls = two *(s(i,j+1,iv) - s(i,j  ,iv))
              dmin = two *(s(i,j  ,iv) - s(i,j-1,iv))
              slim = min(abs(dpls),abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              sly(i,j,iv)= sflag*min(slim,abs(del))

            enddo
          enddo

          if (BCY_LO .eq. WALL  .or.  BCY_LO .eq. INLET) then

            do i = is-1,ie+1 
              sly(i,js-1,iv) = zero
              del = (s(i,js+1,iv)+three*s(i,js,iv)-
     $               four*s(i,js-1,iv)) * third
              dpls = two*(s(i,js+1,iv) - s(i,js  ,iv))
              dmin = two*(s(i,js  ,iv) - s(i,js-1,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              sly(i,js,iv)= sflag*min(slim,abs(del))
            enddo

          else if (BCY_LO .eq. OUTLET) then

            do i = is-1, ie+1 
              sly(i,js-1,iv) = zero
            enddo

          endif

          if (BCY_HI .eq. WALL  .or.  BCY_HI .eq. INLET) then

            do i = is-1, ie+1 
              sly(i,je+1,iv) = zero
              del = -(s(i,je-1,iv)+three*s(i,je,iv)-
     $                four*s(i,je+1,iv)) * third
              dpls = two*(s(i,je+1,iv) - s(i,je ,iv))
              dmin = two*(s(i,je  ,iv) - s(i,je-1,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              sly(i,je,iv)= sflag*min(slim,abs(del))
            enddo

          else if (BCY_HI .eq. OUTLET) then

            do i = is-1, ie+1 
              sly(i,je+1,iv) = zero
            enddo

          endif
        enddo

      else 

c ::: HERE DOING 4TH ORDER

      do iv=1,nvar 
        do i = is-1,ie+1 
          do j = js-2,je+2 
            dyscr(j,cen) = half*(s(i,j+1,iv)-s(i,j-1,iv))
            dmin = two*(s(i,j  ,iv)-s(i,j-1,iv))
            dpls = two*(s(i,j+1,iv)-s(i,j  ,iv))
            dyscr(j,lim)  = min(abs(dmin),abs(dpls))
            dyscr(j,lim)  = cvmgp(dyscr(j,lim),zero,dpls*dmin)
            dyscr(j,flag) = sign(one,dyscr(j,cen))
            dyscr(j,fromm)= dyscr(j,flag)*min(dyscr(j,lim),abs(dyscr(j,cen)))
          enddo

          do j = js-1,je+1 
            ds = two * two3rd * dyscr(j,cen) - 
     $           sixth * (dyscr(j+1,fromm) + dyscr(j-1,fromm))
            sly(i,j,iv) = dyscr(j,flag)*min(abs(ds),dyscr(j,lim))
          enddo


          if (BCY_LO .eq. WALL  .or.  BCY_LO .eq. INLET) then

            sly(i,js-1,iv) = zero
            del = -sixteen/fifteen*s(i,js-1,iv) +  half*s(i,js ,iv) + 
     $                      two3rd*s(i,js+1,iv) - tenth*s(i,js+2,iv)
            dmin = two*(s(i,js  ,iv)-s(i,js-1,iv))
            dpls = two*(s(i,js+1,iv)-s(i,js  ,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            sly(i,js,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at js+1 using the revised dyscr(js,fromm)
            dyscr(js,fromm) = sly(i,js,iv)
            ds = two * two3rd * dyscr(js+1,cen) - 
     $           sixth * (dyscr(js+2,fromm) + dyscr(js,fromm))
            sly(i,js+1,iv) = dyscr(js+1,flag)*min(abs(ds),dyscr(js+1,lim))

          elseif (BCY_LO .eq. OUTLET) then

            sly(i,js-1,iv) = zero

          endif

          if (BCY_HI .eq. WALL  .or.  BCY_HI .eq. INLET) then

            sly(i,je+1,iv) = zero
            del = -( -sixteen/fifteen*s(i,je+1,iv) +  half*s(i,je  ,iv) +
     $                         two3rd*s(i,je-1,iv) - tenth*s(i,je-2,iv) )
            dmin = two*(s(i,je ,iv)-s(i,je-1,iv))
            dpls = two*(s(i,je+1,iv)-s(i,je ,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            sly(i,je,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at js+1 using the revised dyscr(js,fromm)
            dyscr(je,fromm) = sly(i,je,iv)
            ds = two * two3rd * dyscr(je-1,cen) - 
     $           sixth * (dyscr(je-2,fromm) + dyscr(je,fromm))
            sly(i,je-1,iv) = dyscr(je-1,flag)*min(abs(ds),dyscr(je-1,lim))

          elseif (BCY_HI .eq. OUTLET) then

            sly(i,je+1,iv) = zero

          endif
        enddo
      enddo

      endif
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#undef  BL_LANG_CC
#define BL_LANG_FORT

#include "REAL.H"
#include "CONSTANTS.H"
#include "COORDSYS_F.H"
#include "DIMS.H"

#define SDIM 1

c :: ----------------------------------------------------------
c :: SETVOL
c ::             Compute the volume of each cell
c ::
c :: INPUTS / OUTPUTS:
c ::  vol         <=  volume array
c ::  vlo,vhi      => index limits of vol array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 = cartesian, 1 = RZ, 2 = spherical)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETVOL(vol,DIMS(vol),offset,dx,coord)
       integer    DIMDEC(vol)
       integer    coord
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     vol(DIMV(vol))
       
       integer    i, j
       REAL_T     ri, ro, v
       REAL_T     RZFACTOR
       parameter (RZFACTOR = 2.d0*3.14159265358979323846d0)
       
       if (coord .eq. 0) then
c         ::::: cartesian
          v = dx(1)
             do i = ARG_L1(vol), ARG_H1(vol)
                vol(i) = v
             enddo
       else
	 if(coord .eq. 1) then
c  ::: 1D cylindrical
           do i = ARG_L1(vol), ARG_H1(vol)
              ri = offset(1) + dx(1)*i
              ro = ri + dx(1)
              v = half*(RZFACTOR)*(ro**2 - ri**2)
              vol(i) = abs(v)
           enddo
	 else
	    if(coord .eq. 2) then
c         ::::: 1D spherical
               do i = ARG_L1(vol), ARG_H1(vol)
                  ri = offset(1) + dx(1)*i
                  ro = ri + dx(1)
                  v = (two3rd*RZFACTOR)*(ro**3 - ri**3)
                  vol(i) = abs(v)
               enddo
	     else
	        call bl_abort('bogus value of coord... bndrylib::SETVOL')
	     endif
	 endif
       endif
       
       return
       end
	
	subroutine FORT_SETVOLPT(vol, volloi1, volhii1, 
     $		ro, roloi1, rohii1, ri, riloi1, rihii1, dx, coord)
	integer volloi1, volhii1
	integer roloi1, rohii1, riloi1, rihii1
	integer coord
	REAL_T dx(SDIM)
	REAL_T vol(volloi1:volhii1)
	REAL_T ro(roloi1:rohii1)
	REAL_T ri(riloi1:rihii1)
	
	integer i,j
        REAL_T     RZFACTOR
        parameter (RZFACTOR = 2.d0*3.14159265358979323846d0)

c
c  note that dx is usually unity.  dx not unity is used by the nfluid
c  slic reconstruction
c

	if(coord .eq. 0) then
	   do i = roloi1, rohii1
	      vol(i) = (ro(i)-ri(i))
	   enddo

	else
	   if(coord .eq. 1) then
	      do i = roloi1, rohii1
	         vol(i) = half*RZFACTOR*(ro(i)**2 - ri(i)**2)
	 	 vol(i) = abs(vol(i))
	      enddo
	   else
	      if (coord .eq. 2) then
	         do i = roloi1, rohii1
	            vol(i) = two3rd*RZFACTOR*(ro(i)**3-ri(i)**3)
	 	 vol(i) = abs(vol(i))
	         enddo
	      else
	         call bl_abort('bogus value of coord ... bndrylib::SETVOLPT')
	      endif
	   endif
	endif

	return
	end

c :: ----------------------------------------------------------
c :: SETDLOGA
c ::             Compute  d(log(A))/dr in each cell
c ::
c :: INPUTS / OUTPUTS:
c ::  dloga        <=  dloga array
c ::  dlo,dhi      => index limits of dloga array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 = cartesian, 1 = RZ)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETDLOGA(dloga,DIMS(dloga),offset,dx,dir,coord)

       integer    DIMDEC(dloga)
       integer    coord
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     dloga(DIMV(dloga))
       integer dir
       
       integer    i, j
       REAL_T     ri, ro, dlga
       
       if (coord .eq. 0) then

c         ::::: cartesian
             do i = ARG_L1(dloga), ARG_H1(dloga)
                dloga(i) = zero
             enddo

       else 
c  :::  1D cylindrical
	  if(coord .eq. 1) then
            do i = ARG_L1(dloga), ARG_H1(dloga)
               ri = offset(1) + dx(1)*i
	       ri = abs(ri)
               ro = ri + dx(1)
	       ro = abs(ro)
               dlga = two/(ro+ri)                                        
               dloga(i) = dlga
            enddo
	  else
	     if( coord .eq. 2 ) then
c         ::::: 1d spherical
                do i = ARG_L1(dloga), ARG_H1(dloga)
                   ri = offset(1) + dx(1)*i
	           ri = abs(ri)
                   ro = ri + dx(1)
	           ro = abs(ro)
                   dlga = four/(ro+ri)                                        
                   dloga(i) = dlga
                enddo
             else
                call abort('setdloga: illegal coordinate system')
             endif
	  endif
       endif
       return
       end

c :: ----------------------------------------------------------
c :: SETAREA
c ::             Compute the area of given cell face
c ::
c :: INPUTS / OUTPUTS:
c ::  area        <=  area array
c ::  alo,ahi      => index limits of area array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 =cartesian, 1 = RZ, 2 = spherical)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETAREA(area,DIMS(area),offset,dx,dir,coord)

       integer    DIMDEC(area)
       integer    coord, dir
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     area(DIMV(area))
       
       integer    i, j
       REAL_T     ri, ro, a
       REAL_T     RZFACTOR
       parameter (RZFACTOR = 2.d0*3.14159265358979323846d0)
       
       if (coord .eq. 0) then
c         ::::: cartesian
            do i = ARG_L1(area), ARG_H1(area)
               area(i) = one
            enddo
       else
c         ::::: 1d spherical

	  if(coord .eq. 1) then
            do i = ARG_L1(area), ARG_H1(area)
               ri = offset(1) + dx(1)*i
	       a = RZFACTOR*ri
	       area(i) = abs(a)
            enddo
	  else
	      if( coord .eq. 2) then
                do i = ARG_L1(area), ARG_H1(area)
                   ri = offset(1) + dx(1)*i
	           a = two*RZFACTOR*ri*ri
	           area(i) = abs(a)
                enddo
	      else
	        call bl_abort('bogus value for coord... SETAREA')
	      endif
	  endif
       endif
       
       return
       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "VISC_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define CDIMS loc_1,loc_2,loc_3,hic_1,hic_2,hic_3

#if BL_USE_FLOAT
#define twentyfive 25.e0
#define fifth 0.2
#else
#define twentyfive 25.d0
#define fifth 0.2d0
#endif

c *************************************************************************
c ** INITSIG **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIGV(sigma,rho,rmu,DIMS)

      implicit none

      integer DIMS
      REAL_T sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T rmu

c     Local variables
      integer i,j,k

      do k = lo_3-1,hi_3+1 
       do j = lo_2-1,hi_2+1 
        do i = lo_1-1,hi_1+1 
          sigma(i,j,k) = rmu/rho(i,j,k)
        enddo
       enddo
      enddo

      return
      end

c *************************************************************************
c ** RHSNORM **
c ** Take the norm of the right-hand-side and fill the inflow registers
c *************************************************************************

      subroutine FORT_RHSNORM(rhs,source,DIMS,rnorm,
     $                        uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi)

      implicit none
      integer DIMS
      REAL_T     rhs(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  source(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T    uinx_lo(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uinz_lo(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinz_hi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T rnorm

c     Local variables
      integer i,j,k

      rnorm = zero

      do k = lo_3,hi_3 
       do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          rnorm = max(rnorm,abs(rhs(i,j,k)))
          source(i,j,k) = rhs(i,j,k)
        enddo
       enddo
      enddo

      do k = lo_3-1,hi_3+1
      do j = lo_2-1,hi_2+1
        uinx_lo(j,k) = rhs(lo_1-1,j,k)
        uinx_hi(j,k) = rhs(hi_1+1,j,k)
      enddo
      enddo

      do k = lo_3-1,hi_3+1
      do i = lo_1-1,hi_1+1 
        uiny_lo(i,k) = rhs(i,lo_2-1,k)
        uiny_hi(i,k) = rhs(i,hi_2+1,k)
      enddo
      enddo

      do j = lo_2-1,hi_2+1 
      do i = lo_1-1,hi_1+1 
        uinz_lo(i,j) = rhs(i,j,lo_3-1)
        uinz_hi(i,j) = rhs(i,j,hi_3+1)
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RESID **
c ** Compute the residual
c *************************************************************************

      subroutine FORT_RESID(res,u,f,sigma,
     $                      uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi,
     $                      DIMS,hx,hy,hz,resnorm,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,level)

      implicit none

      integer DIMS
      REAL_T    res(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_lo(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uinz_lo(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinz_hi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      REAL_T resnorm
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      integer level

c     Local variables
      REAL_T rlu
      REAL_T dgu
      REAL_T hxsqinv
      REAL_T hysqinv
      REAL_T hzsqinv
      REAL_T uxx, uxx_lo, uxx_hi
      REAL_T uyy, uyy_lo, uyy_hi
      REAL_T uzz, uzz_lo, uzz_hi
      integer is,ie,js,je,ks,ke
      integer i,j,k

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)
      hzsqinv = one/(hz*hz)

      if (level .eq. 0) then
        call gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi,
     $               DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)
      endif

      do k = lo_3,hi_3 
       do j = lo_2,hi_2 
        do i = lo_1,hi_1 

            uxx = ( u(i+1,j,k) - two * u(i,j,k) + u(i-1,j,k) )
            uxx_hi = (sixteen * u(ie+1,j,k) - twentyfive * u(ie,j,k) +
     $                ten * u(ie-1,j,k) - u(ie-2,j,k) ) * fifth
            uxx_lo = (sixteen * u(is-1,j,k) - twentyfive * u(is,j,k) +
     $                ten * u(is+1,j,k) - u(is+2,j,k) ) * fifth
            uxx = cvmgt(uxx_hi, uxx, i .eq. ie .and. 
     $                  (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) )
            uxx = cvmgt(uxx_lo, uxx, i .eq. is .and. 
     $                  (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) )

            uyy = ( u(i,j+1,k) - two * u(i,j,k) + u(i,j-1,k) )
            uyy_hi = (sixteen * u(i,je+1,k) - twentyfive * u(i,je,k) +
     $                ten * u(i,je-1,k) - u(i,je-2,k) ) * fifth
            uyy_lo = (sixteen * u(i,js-1,k) - twentyfive * u(i,js,k) +
     $                ten * u(i,js+1,k) - u(i,js+2,k) ) * fifth
            uyy = cvmgt(uyy_hi, uyy, j .eq. je .and.
     $                  (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) )
            uyy = cvmgt(uyy_lo, uyy, j .eq. js .and.
     $                  (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) )

            uzz = ( u(i,j,k+1) - two * u(i,j,k) + u(i,j,k-1) )
            uzz_hi = (sixteen * u(i,j,ke+1) - twentyfive * u(i,j,ke) +
     $                ten * u(i,j,ke-1) - u(i,j,ke-2) ) * fifth
            uzz_lo = (sixteen * u(i,j,ks-1) - twentyfive * u(i,j,ks) +
     $                ten * u(i,j,ks+1) - u(i,j,ks+2) ) * fifth
            uzz = cvmgt(uzz_hi, uzz, k .eq. ke .and.
     $                  (bcz_hi .eq. WALL .or. bcz_hi .eq. INLET) )
            uzz = cvmgt(uzz_lo, uzz, k .eq. ks .and.
     $                  (bcz_lo .eq. WALL .or. bcz_lo .eq. INLET) )

            dgu = uxx*hxsqinv + uyy*hysqinv + uzz*hzsqinv 
            rlu = u(i,j,k) - dgu*sigma(i,j,k)
            res(i,j,k) = f(i,j,k) - rlu

        enddo
       enddo
      enddo

      resnorm = zero

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 
      do i = lo_1,hi_1 
          resnorm = max(resnorm,abs(res(i,j,k)))
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRBV **
c ** Gauss-Seidel red-black relaxation 
c *************************************************************************

      subroutine FORT_GSRBV(u,f,sigma,
     $                      uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi,
     $                      DIMS,hx,hy,hz,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,
     $                      level,nngsrb)

      implicit none

      integer DIMS
      REAL_T      u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_lo(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uinz_lo(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinz_hi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      integer level
      integer nngsrb

c     Local variables
      REAL_T rlam,rlu
      REAL_T hxsqinv, hysqinv, hzsqinv
      REAL_T facx, facy, facz
      REAL_T uxx, uxx_lo, uxx_hi
      REAL_T uyy, uyy_lo, uyy_hi
      REAL_T uzz, uzz_lo, uzz_hi
      integer i,j,k,iter,ioff,iinc
      integer is,ie,js,je,ks,ke
      logical ltestx,ltesty,ltestz

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      hxsqinv = one / (hx*hx)
      hysqinv = one / (hy*hy)
      hzsqinv = one / (hz*hz)

      do iter = 1, nngsrb 

        do ioff = 0,1 

         if (level .eq. 0) then
          call gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi,
     $                 DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)
         else
          if (bcx_lo .eq. PERIODIC) then
            do k = ks,ke
            do j = js,je
              u(is-1,j,k) = u(ie,j,k)
            enddo
            enddo
          elseif (bcx_lo .eq. OUTLET) then
            do k = ks,ke
            do j = js,je
              u(is-1,j,k) = u(is,j,k)
            enddo
            enddo
          endif

          if (bcx_hi .eq. PERIODIC) then
            do k = ks,ke
            do j = js,je
              u(ie+1,j,k) = u(is,j,k)
            enddo
            enddo
          elseif (bcx_hi .eq. OUTLET) then
            do k = ks,ke
            do j = js,je
              u(ie+1,j,k) = u(ie,j,k)
            enddo
            enddo
          endif

          if (bcy_lo .eq. PERIODIC) then
            do k = ks,ke
            do i = is,ie 
              u(i,js-1,k) = u(i,je,k)
            enddo
            enddo
          elseif (bcy_lo .eq. OUTLET) then
            do k = ks,ke
            do i = is,ie
              u(i,js-1,k) = u(i,js,k)
            enddo
            enddo
          endif

          if (bcy_hi .eq. PERIODIC) then
            do k = ks,ke
            do i = is,ie 
              u(i,je+1,k) = u(i,js,k)
            enddo
            enddo
          elseif (bcy_hi .eq. OUTLET) then
            do k = ks,ke
            do i = is,ie
              u(i,je+1,k) = u(i,je,k)
            enddo
            enddo
          endif

          if (bcz_lo .eq. PERIODIC) then
            do j = js,je
            do i = is,ie 
              u(i,j,ks-1) = u(i,j,ke)
            enddo
            enddo
          elseif (bcz_lo .eq. OUTLET) then
            do j = js,je
            do i = is,ie
              u(i,j,ks-1) = u(i,j,ks)
            enddo
            enddo
          endif

          if (bcz_hi .eq. PERIODIC) then
            do j = js,je
            do i = is,ie 
              u(i,j,ke+1) = u(i,j,ks)
            enddo
            enddo
          elseif (bcz_hi .eq. OUTLET) then
            do j = js,je
            do i = is,ie
              u(i,j,ke+1) = u(i,j,ke)
            enddo
            enddo
          endif

         endif

          do k = ks,ke 

           ltestz = ( (k .eq. ks .and. (bcz_lo .eq. WALL .or. bcz_lo .eq. INLET) ) .or.
     $                (k .eq. ke .and. (bcz_hi .eq. WALL .or. bcz_hi .eq. INLET) ) )
           ltestz = (ltestz .and. level .eq. 0)
           facz = cvmgt(five,two,ltestz)

           do j = js,je 

            ltesty = ( (j .eq. js .and. (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) ) .or.
     $                 (j .eq. je .and. (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) ) )
            ltesty = (ltesty .and. level .eq. 0)
            facy = cvmgt(five,two,ltesty)

            iinc = mod(j+k+ioff,2)
            do i = is+iinc,ie,2 

              ltestx = ( (i .eq. is .and. (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) ) .or.
     $                   (i .eq. ie .and. (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) ) )
              ltestx = (ltestx .and. level .eq. 0)
              facx = cvmgt(five,two,ltestx)

              rlam = one + sigma(i,j,k)*(facx * hxsqinv +
     $                                   facy * hysqinv +
     $                                   facz * hzsqinv )
              rlam = one/rlam

              uxx = (u(i+1,j,k) - two*u(i,j,k) + u(i-1,j,k))
              uxx_lo = (sixteen*u(is-1,j,k) - twentyfive*u(is,j,k) + 
     $                  ten*u(is+1,j,k) - u(is+2,j,k)) * fifth
              uxx_hi = (sixteen*u(ie+1,j,k) - twentyfive*u(ie,j,k) + 
     $                  ten*u(ie-1,j,k) - u(ie-2,j,k)) * fifth
              uxx = cvmgt(uxx_lo,uxx,i .eq. is .and. ltestx)
              uxx = cvmgt(uxx_hi,uxx,i .eq. ie .and. ltestx)

              uyy = (u(i,j+1,k) - two*u(i,j,k) + u(i,j-1,k))
              uyy_lo = (sixteen*u(i,js-1,k) - twentyfive*u(i,js,k) + 
     $                  ten*u(i,js+1,k) - u(i,js+2,k)) * fifth
              uyy_hi = (sixteen*u(i,je+1,k) - twentyfive*u(i,je,k) + 
     $                  ten*u(i,je-1,k) - u(i,je-2,k)) * fifth
              uyy = cvmgt(uyy_lo,uyy,j .eq. js .and. ltesty)
              uyy = cvmgt(uyy_hi,uyy,j .eq. je .and. ltesty)

              uzz = (u(i,j,k+1) - two*u(i,j,k) + u(i,j,k-1))
              uzz_lo = (sixteen*u(i,j,ks-1) - twentyfive*u(i,j,ks) + 
     $                  ten*u(i,j,ks+1) - u(i,j,ks+2)) * fifth
              uzz_hi = (sixteen*u(i,j,ke+1) - twentyfive*u(i,j,ke) + 
     $                  ten*u(i,j,ke-1) - u(i,j,ke-2)) * fifth
              uzz = cvmgt(uzz_lo,uzz,k .eq. ks .and. ltestz)
              uzz = cvmgt(uzz_hi,uzz,k .eq. ke .and. ltestz)

              rlu = u(i,j,k) - sigma(i,j,k)*(uxx * hxsqinv + 
     $                                       uyy * hysqinv + 
     $                                       uzz * hzsqinv )
              u(i,j,k) = u(i,j,k) - rlam*(rlu - f(i,j,k))

            enddo
           enddo
          enddo
        enddo

        if (level .eq. 0) then
          call gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi,
     $                 DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)
        else

          if (bcx_lo .eq. PERIODIC) then
            do k = ks,ke
            do j = js,je
              u(is-1,j,k) = u(ie,j,k)
            enddo
            enddo
          elseif (bcx_lo .eq. OUTLET) then
            do k = ks,ke
            do j = js,je
              u(is-1,j,k) = u(is,j,k)
            enddo
            enddo
          endif

          if (bcx_hi .eq. PERIODIC) then
            do k = ks,ke
            do j = js,je
              u(ie+1,j,k) = u(is,j,k)
            enddo
            enddo
          elseif (bcx_hi .eq. OUTLET) then
            do k = ks,ke
            do j = js,je
              u(ie+1,j,k) = u(ie,j,k)
            enddo
            enddo
          endif

          if (bcy_lo .eq. PERIODIC) then
            do k = ks,ke
            do i = is,ie 
              u(i,js-1,k) = u(i,je,k)
            enddo
            enddo
          elseif (bcy_lo .eq. OUTLET) then
            do k = ks,ke
            do i = is,ie
              u(i,js-1,k) = u(i,js,k)
            enddo
            enddo
          endif

          if (bcy_hi .eq. PERIODIC) then
            do k = ks,ke
            do i = is,ie 
              u(i,je+1,k) = u(i,js,k)
            enddo
            enddo
          elseif (bcy_hi .eq. OUTLET) then
            do k = ks,ke
            do i = is,ie
              u(i,je+1,k) = u(i,je,k)
            enddo
            enddo
          endif

          if (bcz_lo .eq. PERIODIC) then
            do j = js,je
            do i = is,ie 
              u(i,j,ks-1) = u(i,j,ke)
            enddo
            enddo
          elseif (bcz_lo .eq. OUTLET) then
            do j = js,je
            do i = is,ie
              u(i,j,ks-1) = u(i,j,ks)
            enddo
            enddo
          endif

          if (bcz_hi .eq. PERIODIC) then
            do j = js,je
            do i = is,ie 
              u(i,j,ke+1) = u(i,j,ks)
            enddo
            enddo
          elseif (bcz_hi .eq. OUTLET) then
            do j = js,je
            do i = is,ie
              u(i,j,ke+1) = u(i,j,ke)
            enddo
            enddo
          endif

        endif
      enddo

      return
      end

c *************************************************************************
c ** GSRBVBC **
c ** Impose phyical boundary conditions
c *************************************************************************

      subroutine gsrbvbc(u,uinx_lo,uinx_hi,uiny_lo,uiny_hi,uinz_lo,uinz_hi,
     $                   DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_lo(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uinx_hi(lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T    uiny_lo(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uiny_hi(lo_1-1:hi_1+1,lo_3-1:hi_3+1)
      REAL_T    uinz_lo(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    uinz_hi(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i,j,k,is,ie,js,je,ks,ke

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

c     NOTE: WHEN BC = 2 or 3, THE STENCILS ASSUME THE GHOST CELL VALUES
c           APPLY AT THE EDGE, NOT AT THE CELL OUTSIDE!!!

      if (bcz_lo .eq. OUTLET) then
        do j = js,je 
        do i = is,ie
          u(i,j,ks-1) = u(i,j,ks)
        enddo
        enddo
      elseif (bcz_lo .eq. INLET) then
        do j = js,je 
        do i = is,ie
          u(i,j,ks-1) = uinz_lo(i,j)
        enddo
        enddo
      elseif (bcz_lo .eq. WALL) then
        do j = js,je 
        do i = is,ie 
          u(i,j,ks-1) = zero
        enddo
        enddo
      elseif (bcz_lo .eq. PERIODIC) then
        do j = js,je 
        do i = is,ie 
          u(i,j,ks-1) = u(i,j,ke)
        enddo
        enddo
      else
        print *,'bogus bcz_lo in gsrbvbc ',bcz_lo
        stop
      endif

      if (bcz_hi .eq. OUTLET) then
        do j = js,je 
        do i = is,ie
          u(i,j,ke+1) = u(i,j,ke)
        enddo
        enddo
      elseif (bcz_hi .eq. INLET) then
        do j = js,je 
        do i = is,ie
          u(i,j,ke+1) = uinz_hi(i,j)
        enddo
        enddo
      elseif (bcz_hi .eq. WALL) then
        do j = js,je 
        do i = is,ie 
          u(i,j,ke+1) = zero
        enddo
        enddo
      elseif (bcz_hi .eq. PERIODIC) then
        do j = js,je 
        do i = is,ie 
          u(i,j,ke+1) = u(i,j,ks)
        enddo
        enddo
      else
        print *,'bogus bcz_hi in gsrbvbc ',bcz_hi
        stop
      endif

      if (bcy_lo .eq. OUTLET) then
        do k = ks,ke 
        do i = is,ie
          u(i,js-1,k) = u(i,js,k)
        enddo
        enddo
      elseif (bcy_lo .eq. INLET) then
        do k = ks,ke 
        do i = is,ie
          u(i,js-1,k) = uiny_lo(i,k)
        enddo
        enddo
      elseif (bcy_lo .eq. WALL) then
        do k = ks,ke 
        do i = is,ie
            u(i,js-1,k) = zero
        enddo
        enddo
      elseif (bcy_lo .eq. PERIODIC) then
        do k = ks,ke 
        do i = is,ie 
          u(i,js-1,k) = u(i,je,k)
        enddo
        enddo
      else
        print *,'bogus bcy_lo in gsrbvbc ',bcy_lo
        stop
      endif

      if (bcy_hi .eq. OUTLET) then
        do k = ks,ke 
        do i = is,ie
          u(i,je+1,k) = u(i,je,k)
        enddo
        enddo
      elseif (bcy_hi .eq. INLET) then
        do k = ks,ke 
        do i = is,ie
          u(i,je+1,k) = uiny_hi(i,k)
        enddo
        enddo
      elseif (bcy_hi .eq. WALL) then
        do k = ks,ke 
        do i = is,ie
            u(i,je+1,k) = zero
        enddo
        enddo
      elseif (bcy_hi .eq. PERIODIC) then
        do k = ks,ke 
        do i = is,ie 
          u(i,je+1,k) = u(i,js,k)
        enddo
        enddo
      else
        print *,'bogus bcy_hi in gsrbvbc ',bcy_hi
        stop
      endif


      if (bcx_lo .eq. OUTLET) then
        do k = ks,ke 
        do j = js,je 
          u(is-1,j,k) = u(is,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. INLET) then
        do k = ks,ke 
        do j = js,je 
          u(is-1,j,k) = uinx_lo(j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. WALL) then
        do k = ks,ke 
        do j = js,je 
            u(is-1,j,k) = zero
        enddo
        enddo
      elseif (bcx_lo .eq. PERIODIC) then
        do k = ks,ke 
        do j = js,je 
          u(is-1,j,k) = u(ie,j,k)
        enddo
        enddo
      else
        print *,'bogus bcx_lo in gsrbvbc ',bcx_lo
        stop
      endif

      if (bcx_hi .eq. OUTLET) then
        do k = ks,ke 
        do j = js,je 
          u(ie+1,j,k) = u(ie,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. INLET) then
        do k = ks,ke 
        do j = js,je 
          u(ie+1,j,k) = uinx_hi(j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. WALL) then
        do k = ks,ke 
        do j = js,je 
            u(ie+1,j,k) = zero
        enddo
        enddo
      elseif (bcx_hi .eq. PERIODIC) then
        do k = ks,ke 
        do j = js,je 
          u(ie+1,j,k) = u(is,j,k)
        enddo
        enddo
      else
        print *,'bogus bcx_hi in gsrbvbc ',bcx_hi
        stop
      endif


      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T   res(lo_1 :hi_1 ,lo_2 :hi_2 ,lo_3 :hi_3 )
      REAL_T  resc(loc_1:hic_1,loc_2:hic_2,loc_3:hic_3)

c     Local variables
      integer i,j,k
      integer twoi,twoj,twok

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+ lo_3

        do j = loc_2,hic_2 
          twoj = 2*(j-loc_2)+ lo_2

          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+ lo_1
            resc(i,j,k) = (res(twoi  ,twoj  ,twok  ) +
     $                     res(twoi+1,twoj  ,twok  ) +
     $                     res(twoi  ,twoj+1,twok  ) +
     $                     res(twoi+1,twoj+1,twok  ) +
     $                     res(twoi  ,twoj  ,twok+1) +
     $                     res(twoi+1,twoj  ,twok+1) +
     $                     res(twoi  ,twoj+1,twok+1) +
     $                     res(twoi+1,twoj+1,twok+1) ) * eighth
          enddo
        enddo
      enddo

      return
      end

c *************************************************************************
c ** COARSIGV **
c ** Coarsending of the coefficients
c *************************************************************************

      subroutine FORT_COARSIGV(sigma,sigmac,DIMS,CDIMS)

      implicit none
      integer DIMS
      integer CDIMS
      REAL_T   sigma(lo_1 -1:hi_1 +1,lo_2 -1:hi_2+1 ,lo_3 -1:hi_3 +1)
      REAL_T  sigmac(loc_1-1:hic_1+1,loc_2-1:hic_2+1,loc_3-1:hic_3+1)

c     Local variables
      integer i,j,k
      integer twoi,twoj,twok

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+ lo_3

        do j = loc_2,hic_2 
          twoj = 2*(j-loc_2)+ lo_2

          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+ lo_1
            sigmac(i,j,k) = (sigma(twoi  ,twoj  ,twok  ) +
     $                       sigma(twoi+1,twoj  ,twok  ) +
     $                       sigma(twoi  ,twoj+1,twok  ) +
     $                       sigma(twoi+1,twoj+1,twok  ) +
     $                       sigma(twoi  ,twoj  ,twok+1) +
     $                       sigma(twoi+1,twoj  ,twok+1) +
     $                       sigma(twoi  ,twoj+1,twok+1) +
     $                       sigma(twoi+1,twoj+1,twok+1) ) * eighth

          enddo
        enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise-constant interpolation 
c *************************************************************************

      subroutine FORT_INTERPOLATE(u,deltac,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T       u(lo_1 -1:hi_1 +1,lo_2 -1:hi_2 +1,lo_3 -1:hi_3 +1)
      REAL_T  deltac(loc_1-1:hic_1+1,loc_2-1:hic_2+1,loc_3-1:hic_3+1)

c     Local variables
      integer i,j,k
      integer twoi,twoj,twok

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+ lo_3

        do j = loc_2,hic_2 
          twoj = 2*(j-loc_2)+ lo_2

          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+ lo_1

            u(twoi  ,twoj  ,twok  ) = u(twoi  ,twoj  ,twok  ) + deltac(i,j,k)
            u(twoi+1,twoj  ,twok  ) = u(twoi+1,twoj  ,twok  ) + deltac(i,j,k)
            u(twoi  ,twoj+1,twok  ) = u(twoi  ,twoj+1,twok  ) + deltac(i,j,k)
            u(twoi+1,twoj+1,twok  ) = u(twoi+1,twoj+1,twok  ) + deltac(i,j,k)
            u(twoi  ,twoj  ,twok+1) = u(twoi  ,twoj  ,twok+1) + deltac(i,j,k)
            u(twoi+1,twoj  ,twok+1) = u(twoi+1,twoj  ,twok+1) + deltac(i,j,k)
            u(twoi  ,twoj+1,twok+1) = u(twoi  ,twoj+1,twok+1) + deltac(i,j,k)
            u(twoi+1,twoj+1,twok+1) = u(twoi+1,twoj+1,twok+1) + deltac(i,j,k)

          enddo
        enddo
      enddo


      return
      end

c-----------------------------------------------------------------------
c Works for CELL-based data.
      subroutine iprodc(
     & v0, v0l0,v0h0,v0l1,v0h1,v0l2,v0h2,
     & v1, v1l0,v1h0,v1l1,v1h1,v1l2,v1h2,
     &     regl0,regh0,regl1,regh1,regl2,regh2,
     & sum)
      integer v0l0,v0h0,v0l1,v0h1,v0l2,v0h2
      integer v1l0,v1h0,v1l1,v1h1,v1l2,v1h2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision v0(v0l0:v0h0,v0l1:v0h1,v0l2:v0h2)
      double precision v1(v1l0:v1h0,v1l1:v1h1,v1l2:v1h2)
      double precision sum
      integer i, j, k
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               sum = sum + v0(i,j,k) * v1(i,j,k)
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine iprodn(
     & v0, v0l0,v0h0,v0l1,v0h1,v0l2,v0h2,
     & v1, v1l0,v1h0,v1l1,v1h1,v1l2,v1h2,
     &     regl0,regh0,regl1,regh1,regl2,regh2,
     & sum)
      integer v0l0,v0h0,v0l1,v0h1,v0l2,v0h2
      integer v1l0,v1h0,v1l1,v1h1,v1l2,v1h2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      double precision v0(v0l0:v0h0,v0l1:v0h1,v0l2:v0h2)
      double precision v1(v1l0:v1h0,v1l1:v1h1,v1l2:v1h2)
      double precision sum
      integer i, j, k
      sum = sum + 0.1250D0 *
     &            (v0(regl0,regl1,regl2) * v1(regl0,regl1,regl2) +
     &             v0(regl0,regl1,regh2) * v1(regl0,regl1,regh2) +
     &             v0(regl0,regh1,regl2) * v1(regl0,regh1,regl2) +
     &             v0(regl0,regh1,regh2) * v1(regl0,regh1,regh2) +
     &             v0(regh0,regl1,regl2) * v1(regh0,regl1,regl2) +
     &             v0(regh0,regl1,regh2) * v1(regh0,regl1,regh2) +
     &             v0(regh0,regh1,regl2) * v1(regh0,regh1,regl2) +
     &             v0(regh0,regh1,regh2) * v1(regh0,regh1,regh2))
      do i = regl0 + 1, regh0 - 1
         sum = sum + 0.25D0 *
     &               (v0(i,regl1,regl2) * v1(i,regl1,regl2) +
     &                v0(i,regl1,regh2) * v1(i,regl1,regh2) +
     &                v0(i,regh1,regl2) * v1(i,regh1,regl2) +
     &                v0(i,regh1,regh2) * v1(i,regh1,regh2))
      end do
      do j = regl1 + 1, regh1 - 1
          sum = sum + 0.25D0 *
     &               (v0(regl0,j,regl2) * v1(regl0,j,regl2) +
     &                v0(regl0,j,regh2) * v1(regl0,j,regh2) +
     &                v0(regh0,j,regl2) * v1(regh0,j,regl2) +
     &                v0(regh0,j,regh2) * v1(regh0,j,regh2))
      end do
      do k = regl2 + 1, regh2 - 1
          sum = sum + 0.25D0 *
     &               (v0(regl0,regl1,k) * v1(regl0,regl1,k) +
     &                v0(regl0,regh1,k) * v1(regl0,regh1,k) +
     &                v0(regh0,regl1,k) * v1(regh0,regl1,k) +
     &                v0(regh0,regh1,k) * v1(regh0,regh1,k))
      end do
      do j = regl1 + 1, regh1 - 1
         do i = regl0 + 1, regh0 - 1
             sum = sum + 0.5D0 *
     &                  (v0(i,j,regl2) * v1(i,j,regl2) +
     &                   v0(i,j,regh2) * v1(i,j,regh2))
         end do
      end do
      do k = regl2 + 1, regh2 - 1
         do i = regl0 + 1, regh0 - 1
            sum = sum + 0.5D0 *
     &                  (v0(i,regl1,k) * v1(i,regl1,k) +
     &                   v0(i,regh1,k) * v1(i,regh1,k))
         end do
      end do
      do k = regl2 + 1, regh2 - 1
         do j = regl1 + 1, regh1 - 1
             sum = sum + 0.5D0 *
     &                  (v0(regl0,j,k) * v1(regl0,j,k) +
     &                   v0(regh0,j,k) * v1(regh0,j,k))
         end do
      end do
      do  k = regl2 + 1, regh2 - 1
         do  j = regl1 + 1, regh1 - 1
            do  i = regl0 + 1, regh0 - 1
               sum = sum + v0(i,j,k) * v1(i,j,k)
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c     These routines implement boundary conditions
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine bref(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & idir, ncomp)
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer idir, ncomp
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, nc
      do nc = 1, ncomp
      if (idir .eq. 0) then
         do i = regl0, regh0
            do k = regl2, regh2
               do j = regl1, regh1
                  dest(i,j,k,nc) = src(bbh0-(i-regl0),j,k,nc)
               end do
            end do
         end do
      else if (idir .eq. 1) then
         do j = regl1, regh1
            do k = regl2, regh2
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(i,bbh1-(j-regl1),k, nc)
               end do
            end do
         end do
      else
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(i,j,bbh2-(k-regl2),nc)
               end do
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine brefm(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & ra, ncomp)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer ra(0:2)
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, nc
      do nc = 1, ncomp
      if (ra(0) .eq. 0 .and. ra(1) .eq. 0 .and. ra(2) .eq. 0) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(bbl0+(i-regl0),
     &                              bbl1+(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 0 .and. ra(2) .eq. 1) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(bbl0+(i-regl0),
     &                              bbl1+(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 1 .and. ra(2) .eq. 0) then
         do j = regl1, regh1
            do k = regl2, regh2
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(bbl0+(i-regl0),
     &                              bbh1-(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 1 .and. ra(2) .eq. 1) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(bbl0+(i-regl0),
     &                              bbh1-(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 0 .and. ra(2) .eq. 0) then
         do i = regl0, regh0
            do k = regl2, regh2
               do j = regl1, regh1
                  dest(i,j,k,nc) = src(bbh0-(i-regl0),
     &                              bbl1+(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 0 .and. ra(2) .eq. 1) then
         do k = regl2, regh2
            do i = regl0, regh0
               do j = regl1, regh1
                  dest(i,j,k,nc) = src(bbh0-(i-regl0),
     &                              bbl1+(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 1 .and. ra(2) .eq. 0) then
         do j = regl1, regh1
            do i = regl0, regh0
               do k = regl2, regh2
                  dest(i,j,k,nc) = src(bbh0-(i-regl0),
     &                              bbh1-(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = src(bbh0-(i-regl0),
     &                              bbh1-(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine bneg(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & idir, ncomp)
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer idir,ncomp
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, nc
      do nc = 1, ncomp
      if (idir .eq. 0) then
         do i = regl0, regh0
            do k = regl2, regh2
               do j = regl1, regh1
                  dest(i,j,k,nc) = -src(bbh0-(i-regl0),j,k,nc)
               end do
            end do
         end do
      else if (idir .eq. 1) then
         do j = regl1, regh1
            do k = regl2, regh2
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(i,bbh1-(j-regl1),k,nc)
               end do
            end do
         end do
      else
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(i,j,bbh2-(k-regl2),nc)
               end do
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL- or NODE-based data.
      subroutine bnegm(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & ra, ncomp)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer ra(0:2)
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, nc
      do nc = 1, ncomp
      if (ra(0) .eq. 0 .and. ra(1) .eq. 0 .and. ra(2) .eq. 0) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(bbl0+(i-regl0),
     &                            bbl1+(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 0 .and. ra(2) .eq. 1) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(bbl0+(i-regl0),
     &                               bbl1+(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 1 .and. ra(2) .eq. 0) then
         do j = regl1, regh1
            do k = regl2, regh2
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(bbl0+(i-regl0),
     &                               bbh1-(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 0 .and. ra(1) .eq. 1 .and. ra(2) .eq. 1) then
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(bbl0+(i-regl0),
     &                               bbh1-(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 0 .and. ra(2) .eq. 0) then
         do i = regl0, regh0
            do k = regl2, regh2
               do j = regl1, regh1
                  dest(i,j,k,nc) = -src(bbh0-(i-regl0),
     &                               bbl1+(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 0 .and. ra(2) .eq. 1) then
         do k = regl2, regh2
            do i = regl0, regh0
               do j = regl1, regh1
                  dest(i,j,k,nc) = -src(bbh0-(i-regl0),
     &                               bbl1+(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      else if (ra(0) .eq. 1 .and. ra(1) .eq. 1 .and. ra(2) .eq. 0) then
         do j = regl1, regh1
            do i = regl0, regh0
               do k = regl2, regh2
                  dest(i,j,k,nc) = -src(bbh0-(i-regl0),
     &                               bbh1-(j-regl1), bbl2+(k-regl2),nc)
               end do
            end do
         end do
      else
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = -src(bbh0-(i-regl0),
     &                               bbh1-(j-regl1), bbh2-(k-regl2),nc)
               end do
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL-based velocity data.
c This routine assumes that the inflow face velocity data has not yet
c been altered.  Running fill_borders should call this routine on every
c inflow face, so that binfil can be run for subsequent fills
      subroutine binflo(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & idir, ncomp)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer idir
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, nc
c
      do nc = 1, ncomp
      if (idir .eq. 0) then
         if (regl0 .lt. bbh0) then
            do i = regl0, regh0
               do k = regl2, regh2
                  do j = regl1, regh1
                     dest(i,j,k,nc) = 2.0D0 * dest(regh0,j,k,nc) -
     &                             src(bbh0-(i-regl0),j,k,nc)
                  end do
               end do
            end do
         else
            do i = regh0, regl0, -1
               do k = regl2, regh2
                  do j = regl1, regh1
                     dest(i,j,k,nc) = 2.0D0 * dest(regh0,j,k, nc) -
     &                             src(bbh0-(i-regl0),j,k, nc)
                  end do
               end do
            end do
         end if
      else if (idir .eq. 1) then
         if (regl1 .lt. bbh1) then
            do j = regl1, regh1
               do k = regl2, regh2
                  do i = regl0, regh0
                     dest(i,j,k,nc) = 2.0D0 * dest(i,regh1,k,nc) -
     &                             src(i,bbh1-(j-regl1),k,nc)
                  end do
               end do
            end do
         else
            do j = regh1, regl1, -1
               do k = regl2, regh2
                  do i = regl0, regh0
                     dest(i,j,k,nc) = 2.0D0 * dest(i,regh1,k,nc) -
     &                             src(i,bbh1-(j-regl1),k,nc)
                  end do
               end do
            end do
         end if
      else
         if (regl2 .lt. bbh2) then
            do k = regl2, regh2
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,k,nc) = 2.0D0 * dest(i,j,regh2,nc) -
     &                             src(i,j,bbh2-(k-regl2),nc)
                  end do
               end do
            end do
         else
            do k = regh2, regl2, -1
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,k,nc) = 2.0D0 * dest(i,j,regh2,nc) -
     &                             src(i,j,bbh2-(k-regl2),nc)
                  end do
               end do
            end do
         end if
      end if
      end do
      end
c-----------------------------------------------------------------------
c Works for CELL-based velocity data.
c This routine is called when the inflow face velocity data has already
c been altered by a call to fill_borders.
      subroutine binfil(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & idir, ncomp)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer idir
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, nc
c
      do nc = 1, ncomp
      if (idir .eq. 0) then
         if (regl0 .lt. bbh0) then
            do  i = regl0, regh0
               do k = regl2, regh2
                  do j = regl1, regh1
                     dest(i,j,k,nc) = src(bbl0,j,k,nc)
     &                           + src(bbl0+1,j,k,nc) -
     &                             src(bbh0-(i-regl0),j,k,nc)
                  end do
               end do
            end do
         else
            do i = regh0, regl0, -1
               do k = regl2, regh2
                  do j = regl1, regh1
                     dest(i,j,k,nc) = src(bbh0-1,j,k,nc)
     &                + src(bbh0,j,k,nc) -
     &                             src(bbl0+(regh0-i),j,k,nc)
                  end do
               end do
            end do
         end if
      else if (idir .eq. 1) then
         if (regl1 .lt. bbh1) then
            do j = regl1, regh1
               do k = regl2, regh2
                  do i = regl0, regh0
                     dest(i,j,k,nc) = src(i,bbl1,k,nc)
     &                 + src(i,bbl1+1,k,nc) -
     &                             src(i,bbh1-(j-regl1),k,nc)
                  end do
               end do
            end do
         else
            do j = regh1, regl1, -1
               do k = regl2, regh2
                  do i = regl0, regh0
                     dest(i,j,k,nc) = src(i,bbh1-1,k,nc)
     &                 + src(i,bbh1,k,nc) -
     &                             src(i,bbl1+(regh1-j),k,nc)
                  end do
               end do
            end do
         end if
      else
         if (regl2 .lt. bbh2) then
            do k = regl2, regh2
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,k,nc) = src(i,j,bbl2,nc)
     &                     + src(i,j,bbl2+1,nc) -
     &                             src(i,j,bbh2-(k-regl2),nc)
                  end do
               end do
            end do
         else
            do k = regh2, regl2, -1
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,k,nc) = src(i,j,bbh2-1,nc)
     &                      + src(i,j,bbh2,nc) -
     &                             src(i,j,bbl2+(regh2-k),nc)
                  end do
               end do
            end do
         end if
      end if
      end do
      end
c-----------------------------------------------------------------------
c     Interpolation routines
c-----------------------------------------------------------------------
c CELL-based data only.
      subroutine acint2(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & ir, jr, kr, ncomp)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer ir, jr, kr
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &    ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      double precision xoff, yoff, zoff, sx, sy, sz
      integer ic, jc, kc, i, j, k, nc
      do nc = 1, ncomp
      do k = regl2, regh2
         kc = k/kr
         zoff = (mod(k,kr) + 0.5D0) / kr - 0.5D0
         do j = regl1, regh1
            jc = j/jr
            yoff = (mod(j,jr) + 0.5D0) / jr - 0.5D0
            do i = regl0, regh0
               ic = i/ir
               xoff = (mod(i,ir) + 0.5D0) / ir - 0.5D0
               sz = 0.5D0 * (src(ic,jc,kc+1,nc) - src(ic,jc,kc-1,nc))
               sy = 0.5D0 * (src(ic,jc+1,kc,nc) - src(ic,jc-1,kc,nc))
               sx = 0.5D0 * (src(ic+1,jc,kc,nc) - src(ic-1,jc,kc,nc))
               dest(i,j,k,nc) = src(ic,jc,kc,nc)
     &          + xoff*sx + yoff*sy + zoff*sz
            end do
         end do
      end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
      subroutine anint2(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     &       bbl0,bbh0,bbl1,bbh1,bbl2,bbh2,
     & ir, jr, kr, ncomp)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer bbl0,bbh0,bbl1,bbh1,bbl2,bbh2
      integer ir, jr, kr
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      double precision p, q
      integer ic, jc, kc, j, k, m, nc
      do nc = 1, ncomp
      do kc = bbl2, bbh2
         do jc = bbl1, bbh1
            do ic = bbl0, bbh0
               dest(ir*ic,jr*jc,kr*kc, nc) = src(ic,jc,kc, nc)
            end do
         end do
      end do
         do m = 1, kr-1
            q = dble(m)/kr
            p = 1.0D0 - q
            do kc = bbl2, bbh2-1
               do jc = bbl1, bbh1
                  do ic = bbl0, bbh0
                     dest(ir*ic,jr*jc,kr*kc+m,nc) =
     &                  p * src(ic,jc,kc,nc) + q * src(ic,jc,kc+1,nc)
                  end do
               end do
            end do
         end do
         do m = 1, jr-1
            q = dble(m)/jr
            p = 1.0D0 - q
            do jc = bbl1, bbh1-1
               do ic = bbl0, bbh0
cdir$ ivdep
                  do k = regl2, regh2
                     dest(ir*ic,jr*jc+m,k,nc) =
     &                  p * dest(ir*ic,jr*jc,k,nc) +
     &                  q * dest(ir*ic,jr*(jc+1),k,nc)
                  end do
               end do
            end do
         end do
            do  m = 1, ir-1
               q = dble(m)/ir
               p = 1.0D0 - q
               do ic = bbl0, bbh0-1
                  do k = regl2, regh2
cdir$ ivdep
                     do j = regl1, regh1
                        dest(ir*ic+m,j,k,nc) =
     &                     p * dest(ir*ic,j,k,nc) +
     &                     q * dest(ir*(ic+1),j,k,nc)
                     end do
                  end do
               end do
            end do
      end do
      end
c-----------------------------------------------------------------------
c     Restrictions
c-----------------------------------------------------------------------
c CELL-based data only.
      subroutine acrst1(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr, ncomp, integ, i1, i2)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr, integ, i1, i2
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      double precision fac
      integer i, j, k, l, m, n,nc
      do nc = 1, ncomp
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,k,nc) = 0.0D0
            end do
         end do
      end do
      do l = 0, kr-1
         do n = 0, jr-1
            do m = 0, ir-1
               do k = regl2, regh2
                  do j = regl1, regh1
                     do i = regl0, regh0
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    src(i*ir+m, j*jr+n, k*kr+l,nc)
                     end do
                  end do
               end do
            end do
         end do
      end do
      if (integ .eq. 0) then
         fac = 1.0D0 / (ir*jr*kr)
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = dest(i,j,k,nc) * fac
               end do
            end do
         end do
      end if
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
      subroutine anrst1(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr, ncomp, integ, i1, i2)
      integer ncomp, integ
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr
      integer nc
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      integer i, j, k, i1, i2
      do nc = 1, ncomp
      do k = regl2, regh2
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,k,nc) = src(i*ir, j*jr, k*kr, nc)
            end do
         end do
      end do
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data only.
      subroutine anrst2(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr, ncomp, integ, i1, i2)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr, integ, i1, i2
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      double precision fac0, fac1, fac2, fac
      integer i, j, k, l, m, n, nc
      do nc = 1, ncomp
         do k = regl2, regh2
            do j = regl1, regh1
               do i = regl0, regh0
                  dest(i,j,k,nc) = 0.0D0
               end do
            end do
         end do
         fac0 = 1.0D0 / (ir*ir * jr*jr * kr*kr)
         do l = 0, kr-1
            fac2 = (kr-l) * fac0
            if (l .eq. 0) fac2 = 0.5D0 * fac2
            do n = 0, jr-1
               fac1 = (jr-n) * fac2
               if (n .eq. 0) fac1 = 0.5D0 * fac1
               do m = 0, ir-1
                  fac = (ir-m) * fac1
                  if (m .eq. 0) fac = 0.5D0 * fac
                  do k = regl2, regh2
                     do j = regl1, regh1
                        do i = regl0, regh0
                           dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                  fac * (src(i*ir-m,j*jr-n,k*kr-l,nc)+
     &                         src(i*ir-m,j*jr-n,k*kr+l,nc)+
     &                         src(i*ir-m,j*jr+n,k*kr-l,nc)+
     &                         src(i*ir-m,j*jr+n,k*kr+l,nc)+
     &                         src(i*ir+m,j*jr-n,k*kr-l,nc)+
     &                         src(i*ir+m,j*jr-n,k*kr+l,nc)+
     &                         src(i*ir+m,j*jr+n,k*kr-l,nc)+
     &                         src(i*ir+m,j*jr+n,k*kr+l,nc))
                        end do
                     end do
                  end do
               end do
            end do
         end do
         if (integ .eq. 1) then
            fac = ir * jr * kr
            do k = regl2, regh2
               do j = regl1, regh1
                  do i = regl0, regh0
                     dest(i,j,k,nc) = fac * dest(i,j,k,nc)
                  end do
                end do
            end do
         end if
      end do
      if ( .FALSE. ) then
         print *, 'anrst2'
         print *, destl0, desth0, destl1, desth1, destl2, desth2
         print *, regl0,  regh0,  regl1,  regh1,  regl2,  regh2
         print *, srcl0,  srch0,  srcl1,  srch1,  srcl2,  srch2
         print *, ir, jr, kr, integ
         print *, dest
      end if
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse region defined by reg.
c Handles coarse-fine face, with orientation determined by idim and idir
      subroutine anfr2(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr, ncomp, integ, idim, idir)
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr, idim, idir, integ
      integer ncomp
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      double precision fac0, fac1, fac2, fac
      integer i, j, k, l, m, n, nc
      if (idim .eq. 0) then
         if (integ .eq. 0) then
            fac = (0.5D0 + 0.5D0 / ir)
            fac0 = 1.0D0 / (ir*ir * jr*jr * kr*kr)
         else
            fac = 1.0D0
            fac0 = 1.0D0 / (ir * jr * kr)
         end if
         i = regl0
         do nc = 1, ncomp
         do k = regl2, regh2
            do j = regl1, regh1
               dest(i,j,k,nc) = fac * src(i*ir,j*jr,k*kr,nc)
            end do
         end do
         end do
         do nc = 1, ncomp
         do l = 0, kr-1
            fac2 = (kr-l) * fac0
            if (l .eq. 0) fac2 = 0.5D0 * fac2
            do n = 0, jr-1
               fac1 = (jr-n) * fac2
               if (n .eq. 0) fac1 = 0.5D0 * fac1
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  do k = regl2, regh2
                     do j = regl1, regh1
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                       fac * (src(i*ir+m,j*jr-n,k*kr-l,nc) +
     &                              src(i*ir+m,j*jr-n,k*kr+l,nc) +
     &                              src(i*ir+m,j*jr+n,k*kr-l,nc) +
     &                              src(i*ir+m,j*jr+n,k*kr+l,nc))
                     end do
                  end do
               end do
            end do
         end do
         end do
      else if (idim .eq. 1) then
         if (integ .eq. 0) then
            fac = (0.5D0 + 0.5D0 / jr)
            fac0 = 1.0D0 / (ir*ir * jr*jr * kr*kr)
         else
            fac = 1.0D0
            fac0 = 1.0D0 / (ir * jr * kr)
         end if
         j = regl1
         do nc = 1, ncomp
         do k = regl2, regh2
            do i = regl0, regh0
               dest(i,j,k,nc) = fac * src(i*ir,j*jr,k*kr,nc)
            end do
         end do
         end do
         fac0 = 1.0D0 / (ir*ir * jr*jr * kr*kr)
         do nc = 1, ncomp
         do l = 0, kr-1
            fac2 = (kr-l) * fac0
            if (l .eq. 0) fac2 = 0.5D0 * fac2
            do n = idir, idir*(jr-1), idir
               fac1 = (jr-abs(n)) * fac2
               do m = 0, ir-1
                  fac = (ir-m) * fac1
                  if (m .eq. 0) fac = 0.5D0 * fac
                  do k = regl2, regh2
                     do i = regl0, regh0
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                       fac * (src(i*ir-m,j*jr+n,k*kr-l,nc) +
     &                              src(i*ir-m,j*jr+n,k*kr+l,nc) +
     &                              src(i*ir+m,j*jr+n,k*kr-l,nc) +
     &                              src(i*ir+m,j*jr+n,k*kr+l,nc))
                     end do
                  end do
               end do
            end do
         end do
         end do
      else
         if (integ .eq. 0) then
            fac = (0.5D0 + 0.5D0 / kr)
            fac0 = 1.0D0 / (ir*ir * jr*jr * kr*kr)
         else
            fac = 1.0D0
            fac0 = 1.0D0 / (ir * jr * kr)
         end if
         k = regl2
         do nc = 1, ncomp
         do j = regl1, regh1
            do i = regl0, regh0
               dest(i,j,k,nc) = fac * src(i*ir,j*jr,k*kr,nc)
            end do
         end do
         end do
         fac0 = 1.0D0 / (ir*ir * jr*jr * kr*kr)
         do nc = 1, ncomp
         do l = idir, idir*(kr-1), idir
            fac2 = (kr-abs(l)) * fac0
            do n = 0, jr-1
               fac1 = (jr-n) * fac2
               if (n .eq. 0) fac1 = 0.5D0 * fac1
               do m = 0, ir-1
                  fac = (ir-m) * fac1
                  if (m .eq. 0) fac = 0.5D0 * fac
                  do j = regl1, regh1
                     do i = regl0, regh0
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                       fac * (src(i*ir-m,j*jr-n,k*kr+l,nc) +
     &                              src(i*ir-m,j*jr+n,k*kr+l,nc) +
     &                              src(i*ir+m,j*jr-n,k*kr+l,nc) +
     &                              src(i*ir+m,j*jr+n,k*kr+l,nc))
                     end do
                  end do
               end do
            end do
         end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse region defined by reg.
c Handles any edge geometry except all-coarse or all-fine.
      subroutine aner2(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr, ncomp, integ, ivect, ga)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr, ivect(0:2), ga(0:1,0:1,0:1), integ
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2,ncomp)
      double precision cube, center, cfac, fac0, fac1, fac2, fac
      integer i, j, k, ii, ji, ki, idir, jdir, kdir, l, m, n, nc
      cube = ir * jr * kr
      if (ivect(0) .eq. 0) then
         j = regl1
         k = regl2
         do nc = 1, ncomp
         do i = regl0, regh0
            dest(i,j,k,nc) = 0.0D0
         end do
c center gets center plus two edges
         if (integ .eq. 0) then
            center = ir / cube
            fac0 = 1.0D0 / (cube**2)
            cfac = 0.25D0 * cube * fac0 * ir * (jr-1) * (kr-1)
         else
            center = 1.0D0
            fac0 = 1.0D0 / cube
         end if
c quadrants
c each quadrant is two octants and a face
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) .eq. 1) then
                  do l = kdir, kdir*(kr-1), kdir
                     fac2 = (kr-abs(l)) * fac0
                     do n = jdir, jdir*(jr-1), jdir
                        fac1 = (jr-abs(n)) * fac2
                        do m = 0, ir-1
                           fac = (ir-m) * fac1
                           if (m .eq. 0) fac = 0.5D0 * fac
                           do i = regl0, regh0
                              dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                          fac * (src(i*ir-m,j*jr+n,k*kr+l,nc) +
     &                                 src(i*ir+m,j*jr+n,k*kr+l,nc))
                           end do
                        end do
                     end do
                  end do
               else if (integ .eq. 0) then
                  center = center + cfac
               end if
            end do
         end do
c faces
c each face is two faces and an edge
         fac2 = kr * fac0
         cfac = 0.5D0 * cube * fac0 * ir * (jr-1)
         do ji = 0, 1
            jdir = 2 * ji - 1
            if (ga(0,ji,0) + ga(0,ji,1) .eq. 2) then
               do n = jdir, jdir*(jr-1), jdir
                  fac1 = (jr-abs(n)) * fac2
                  do m = 0, ir-1
                     fac = (ir-m) * fac1
                     if (m .eq. 0) fac = 0.5D0 * fac
                     do i = regl0, regh0
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    fac * (src(i*ir-m,j*jr+n,k*kr,nc) +
     &                           src(i*ir+m,j*jr+n,k*kr,nc))
                     end do
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
         fac2 = jr * fac0
         cfac = 0.5D0 * cube * fac0 * ir * (kr-1)
         do ki = 0, 1
            kdir = 2 * ki - 1
            if (ga(0,0,ki) + ga(0,1,ki) .eq. 2) then
               do l = kdir, kdir*(kr-1), kdir
                  fac1 = (kr-abs(l)) * fac2
                  do m = 0, ir-1
                     fac = (ir-m) * fac1
                     if (m .eq. 0) fac = 0.5D0 * fac
                     do i = regl0, regh0
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    fac * (src(i*ir-m,j*jr,k*kr+l,nc) +
     &                           src(i*ir+m,j*jr,k*kr+l,nc))
                     end do
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
c center
         do i = regl0, regh0
            dest(i,j,k,nc) = dest(i,j,k,nc) +
     &        center * src(i*ir,j*jr,k*kr,nc)
         end do
         end do
      else if (ivect(1) .eq. 0) then
         i = regl0
         k = regl2
         do nc = 1, ncomp
         do  j = regl1, regh1
            dest(i,j,k,nc) = 0.0D0
         end do
c center gets center plus two edges
         if (integ .eq. 0) then
            center = jr / cube
            fac0 = 1.0D0 / (cube**2)
            cfac = 0.25D0 * cube * fac0 * jr * (ir-1) * (kr-1)
         else
            center = 1.0D0
            fac0 = 1.0D0 / cube
         end if
c quadrants
c each quadrant is two octants and a face
         do  ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) .eq. 1) then
                  do l = kdir, kdir*(kr-1), kdir
                     fac2 = (kr-abs(l)) * fac0
                     do n = 0, jr-1
                        fac1 = (jr-n) * fac2
                        if (n .eq. 0) fac1 = 0.5D0 * fac1
                        do m = idir, idir*(ir-1), idir
                           fac = (ir-abs(m)) * fac1
                           do j = regl1, regh1
                              dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                          fac * (src(i*ir+m,j*jr-n,k*kr+l,nc) +
     &                                 src(i*ir+m,j*jr+n,k*kr+l,nc))
                           end do
                        end do
                     end do
                  end do
               else if (integ .eq. 0) then
                  center = center + cfac
               end if
            end do
         end do
c faces
c each face is two faces and an edge
         fac2 = kr * fac0
         cfac = 0.5D0 * cube * fac0 * jr * (ir-1)
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,0,0) + ga(ii,0,1) .eq. 2) then
               do n = 0, jr-1
                  fac1 = (jr-n) * fac2
                  if (n .eq. 0) fac1 = 0.5D0 * fac1
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     do j = regl1, regh1
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    fac * (src(i*ir+m,j*jr-n,k*kr,nc) +
     &                           src(i*ir+m,j*jr+n,k*kr,nc))
                     end do
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
         fac2 = ir * fac0
         cfac = 0.5D0 * cube * fac0 * jr * (kr-1)
         do ki = 0, 1
            kdir = 2 * ki - 1
            if (ga(0,0,ki) + ga(1,0,ki) .eq. 2) then
               do  l = kdir, kdir*(kr-1), kdir
                  fac1 = (kr-abs(l)) * fac2
                  do n = 0, jr-1
                     fac = (jr-n) * fac1
                     if (n .eq. 0) fac = 0.5D0 * fac
                     do j = regl1, regh1
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    fac * (src(i*ir,j*jr-n,k*kr+l,nc) +
     &                           src(i*ir,j*jr+n,k*kr+l,nc))
                     end do
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
c center
         do j = regl1, regh1
            dest(i,j,k,nc) = dest(i,j,k,nc) +
     &        center * src(i*ir,j*jr,k*kr,nc)
         end do
         end do
      else
         i = regl0
         j = regl1
         do nc = 1, ncomp
         do k = regl2, regh2
            dest(i,j,k,nc) = 0.0D0
         end do
c center gets center plus two edges
         if (integ .eq. 0) then
            center = kr / cube
            fac0 = 1.0D0 / (cube**2)
            cfac = 0.25D0 * cube * fac0 * kr * (ir-1) * (jr-1)
         else
            center = 1.0D0
            fac0 = 1.0D0 / cube
         end if
c quadrants
c each quadrant is two octants and a face
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) .eq. 1) then
                  do l = 0, kr-1
                     fac2 = (kr-l) * fac0
                     if (l .eq. 0) fac2 = 0.5D0 * fac2
                     do n = jdir, jdir*(jr-1), jdir
                        fac1 = (jr-abs(n)) * fac2
                        do m = idir, idir*(ir-1), idir
                           fac = (ir-abs(m)) * fac1
                           do k = regl2, regh2
                              dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                          fac * (src(i*ir+m,j*jr+n,k*kr-l,nc) +
     &                                 src(i*ir+m,j*jr+n,k*kr+l,nc))
                           end do
                        end do
                     end do
                  end do
               else if (integ .eq. 0) then
                  center = center + cfac
               end if
            end do
         end do
c faces
c each face is two faces and an edge
         fac2 = jr * fac0
         cfac = 0.5D0 * cube * fac0 * kr * (ir-1)
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,0,0) + ga(ii,1,0) .eq. 2) then
               do l = 0, kr-1
                  fac1 = (kr-l) * fac2
                  if (l .eq. 0) fac1 = 0.5D0 * fac1
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     do k = regl2, regh2
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    fac * (src(i*ir+m,j*jr,k*kr-l,nc) +
     &                           src(i*ir+m,j*jr,k*kr+l,nc))
                     end do
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
         fac2 = ir * fac0
         cfac = 0.5D0 * cube * fac0 * kr * (jr-1)
         do ji = 0, 1
            jdir = 2 * ji - 1
            if (ga(0,ji,0) + ga(1,ji,0) .eq. 2) then
               do l = 0, kr-1
                  fac1 = (kr-l) * fac2
                  if (l .eq. 0) fac1 = 0.5D0 * fac1
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     do k = regl2, regh2
                        dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                    fac * (src(i*ir,j*jr+n,k*kr-l,nc) +
     &                           src(i*ir,j*jr+n,k*kr+l,nc))
                     end do
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
            end do
c center
         do k = regl2, regh2
            dest(i,j,k,nc) = dest(i,j,k,nc) +
     &        center * src(i*ir,j*jr,k*kr,nc)
         end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c NODE-based data only.
c Fills coarse region defined by reg.
c Handles any corner geometry except all-coarse.
      subroutine ancr2(
     & dest, destl0,desth0,destl1,desth1,destl2,desth2,
     &       regl0,regh0,regl1,regh1,regl2,regh2,
     & src,  srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & ir, jr, kr, ncomp, integ, ga, i2)
      integer ncomp
      integer destl0,desth0,destl1,desth1,destl2,desth2
      integer regl0,regh0,regl1,regh1,regl2,regh2
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer ir, jr, kr, ga(0:1,0:1,0:1), integ
      double precision dest(destl0:desth0,destl1:desth1,destl2:desth2,
     &   ncomp)
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2, ncomp)
      double precision cube, center, cfac, fac0, fac1, fac2, fac
      integer i, j, k, ii, ji, ki, idir, jdir, kdir, l, m, n,nc, i2
      i = regl0
      j = regl1
      k = regl2
      do nc = 1, ncomp
      dest(i,j,k,nc) = 0.0D0
      cube = ir * jr * kr
      if (integ .eq. 0) then
         center = 1.0D0 / cube
         fac0 = 1.0D0 / (cube**2)
         cfac = 0.1250D0 * cube * fac0 * (ir-1) * (jr-1) * (kr-1)
      else
         center = 1.0D0
         fac0 = 1.0D0 / cube
      end if
c octants
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,ki) .eq. 1) then
                  do l = kdir, kdir*(kr-1), kdir
                     fac2 = (kr-abs(l)) * fac0
                     do n = jdir, jdir*(jr-1), jdir
                        fac1 = (jr-abs(n)) * fac2
                        do m = idir, idir*(ir-1), idir
                           fac = (ir-abs(m)) * fac1
                           dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                       fac * src(i*ir+m,j*jr+n,k*kr+l,nc)
                        end do
                     end do
                  end do
               else if (integ .eq. 0) then
                  center = center + cfac
               end if
            end do
         end do
      end do
c faces
      fac2 = kr * fac0
      cfac = 0.25D0 * cube * fac0 * (ir-1) * (jr-1)
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji,0) + ga(ii,ji,1) .eq. 2) then
               do n = jdir, jdir*(jr-1), jdir
                  fac1 = (jr-abs(n)) * fac2
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                 fac * src(i*ir+m,j*jr+n,k*kr,nc)
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
      end do
      fac2 = jr * fac0
      cfac = 0.25D0 * cube * fac0 * (ir-1) * (kr-1)
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,0,ki) + ga(ii,1,ki) .eq. 2) then
               do l = kdir, kdir*(kr-1), kdir
                  fac1 = (kr-abs(l)) * fac2
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                 fac * src(i*ir+m,j*jr,k*kr+l,nc)
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
      end do
      fac2 = ir * fac0
      cfac = 0.25D0 * cube * fac0 * (jr-1) * (kr-1)
      do ki = 0, 1
         kdir = 2 * ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            if (ga(0,ji,ki) + ga(1,ji,ki) .eq. 2) then
               do l = kdir, kdir*(kr-1), kdir
                  fac1 = (kr-abs(l)) * fac2
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     dest(i,j,k,nc) = dest(i,j,k,nc) +
     &                 fac * src(i*ir,j*jr+n,k*kr+l,nc)
                  end do
               end do
            else if (integ .eq. 0) then
               center = center + cfac
            end if
         end do
      end do
c edges
      fac1 = jr * kr * fac0
      cfac = 0.5D0 * cube * fac0 * (ir-1)
      do ii = 0, 1
         idir = 2 * ii - 1
         if (ga(ii,0,0) + ga(ii,0,1) +
     &       ga(ii,1,0) + ga(ii,1,1) .eq. 4) then
            do m = idir, idir*(ir-1), idir
               fac = (ir-abs(m)) * fac1
               dest(i,j,k,nc) = dest(i,j,k,nc) +
     &           fac * src(i*ir+m,j*jr,k*kr,nc)
            end do
         else if (integ .eq. 0) then
            center = center + cfac
         end if
      end do
      fac1 = ir * kr * fac0
      cfac = 0.5D0 * cube * fac0 * (jr-1)
      do ji = 0, 1
         jdir = 2 * ji - 1
         if (ga(0,ji,0) + ga(0,ji,1) +
     &       ga(1,ji,0) + ga(1,ji,1) .eq. 4) then
            do n = jdir, jdir*(jr-1), jdir
               fac = (jr-abs(n)) * fac1
               dest(i,j,k,nc) = dest(i,j,k,nc) +
     &            fac * src(i*ir,j*jr+n,k*kr,nc)
            end do
         else if (integ .eq. 0) then
            center = center + cfac
         end if
      end do
      fac1 = ir * jr * fac0
      cfac = 0.5D0 * cube * fac0 * (kr-1)
      do ki = 0, 1
         kdir = 2 * ki - 1
         if (ga(0,0,ki) + ga(0,1,ki) +
     &       ga(1,0,ki) + ga(1,1,ki) .eq. 4) then
            do l = kdir, kdir*(kr-1), kdir
               fac = (kr-abs(l)) * fac1
               dest(i,j,k,nc) = dest(i,j,k,nc) +
     &           fac * src(i*ir,j*jr,k*kr+l,nc)
            end do
         else if (integ .eq. 0) then
            center = center + cfac
         end if
      end do
c center
      dest(i,j,k,nc) = dest(i,j,k,nc) +
     &  center * src(i*ir,j*jr,k*kr,nc)
      end do
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define threehalves    1.5e0
#else
#define threehalves    1.5d0
#endif

#define DIMS lo_1,lo_2,hi_1,hi_2
#define SDIMS slo_1,slo_2,shi_1,shi_2

c *************************************************************************
c ** SETSCALBC **
c ** Impose the physical boundary conditions on scalars s
c *************************************************************************

      subroutine setscalbc(s,DIMS,SDIMS,bc,irz,which_scal,dx,time)

      implicit none

      integer DIMS
      integer SDIMS
      integer which_scal
      integer bc(2,2)
      integer irz
      REAL_T  dx(2)
      REAL_T  time
      REAL_T  s(slo_1:shi_1,slo_2:shi_2)

c     Local variables
      integer is,ie,js,je,i,j
      integer ilo,ihi
      integer ng,ngmax

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      ilo = cvmgt(slo_1,lo_1,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(shi_1,hi_1,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)

      ngmax = lo_1-slo_1

c     NOTE: IF BC == WALL, THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL 
c           BOUNDARY, NOT IN THE GHOST CELL

      if (BCY_LO .eq. WALL) then

        do ng = 1,ngmax
        do i = ilo,ihi
c         s(i,js-1 ) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-ng) = s(i,js)
        enddo
        enddo

      elseif (BCY_LO .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,1,0,which_scal)
        if (ngmax .gt. 1) then
          do ng = 2,ngmax
          do i = slo_1,shi_1
            s(i,js-ng) = s(i,js-1)
          enddo
          enddo
        endif

      elseif (BCY_LO .eq. OUTLET) then

        do ng = 1,ngmax
        do i = ilo,ihi
c         s(i,js-1) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-ng) = s(i,js)
        enddo
        enddo

      endif

      if (BCY_HI .eq. WALL) then

        do ng = 1,ngmax
        do i = ilo,ihi
c         s(i,je+1 ) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+ng) = s(i,je)
        enddo
        enddo

      elseif (BCY_HI .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,1,1,which_scal)
        if (ngmax .gt. 1) then
          do ng = 2,ngmax
          do i = slo_1,shi_1
            s(i,je+ng) = s(i,je+1)
          enddo
          enddo
        endif

      elseif (BCY_HI .eq. OUTLET) then

        do ng = 1,ngmax
        do i = ilo,ihi
c         s(i,je+1) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+ng) = s(i,je)
        enddo
        enddo

      endif

      if (BCX_LO .eq. WALL) then

        if (irz .eq. 1) then

          do ng = 1,ngmax
          do j = js-ngmax,je+ngmax 
            s(is-ng,j) = s(is+ng-1,j)
          enddo
          enddo

        else

          do ng = 1,ngmax
          do j = js-ngmax,je+ngmax 
c           s(is-1,j) = threehalves*s(is,j) - half*s(is+1,j)
            s(is-ng,j) = s(is,j)
          enddo
          enddo

        endif

      elseif (BCX_LO .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,0,0,which_scal)
        if (ngmax .gt. 2) then
          do ng = 2,ngmax
           do j = js-ngmax,je+ngmax
            s(is-ng,j) = s(is-1,j)
          enddo
         enddo
        endif

      elseif (BCX_LO .eq. OUTLET) then

        do ng = 1,ngmax
        do j = js-ngmax,je+ngmax 
c         s(is-1,j) = threehalves*s(is,j) - half*s(is+1,j)
          s(is-ng,j) = s(is,j)
        enddo
        enddo

      endif

      if (BCX_HI .eq. WALL) then

        do ng = 1,ngmax
        do j = js-ngmax,je+ngmax
c         s(ie+1,j) = threehalves*s(ie,j) - half*s(ie-1,j)
          s(ie+ng,j) = s(ie,j)
        enddo
        enddo

      elseif (BCX_HI .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,0,1,which_scal)
        if (ngmax .gt. 2) then
         do ng = 2,ngmax
          do j = js-ngmax,je+ngmax
            s(ie+ng,j) = s(ie+1,j)
          enddo
         enddo
        endif

      elseif (BCX_HI .eq. OUTLET) then

        do ng = 1,ngmax
        do j = js-ngmax,je+ngmax 
c         s(ie+1,j) = threehalves*s(ie,j) - half*s(ie-1,j)
          s(ie+ng,j) = s(ie,j)
        enddo
        enddo

      endif

c     We return to these to get the corner regions which are
c      part INTERIOR and part WALL / OUTFLOW

      if (BCY_LO .eq. WALL) then

        do ng = 1,ngmax
        do i = is-ngmax,is-1
c         s(i,js-1 ) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-ng) = s(i,js)
        enddo
        do i = ie+1,ie+ngmax
c         s(i,js-1 ) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-ng) = s(i,js)
        enddo
        enddo

      elseif (BCY_LO .eq. OUTLET) then

        do ng = 1,ngmax
        do i = is-ngmax,is-1
c         s(i,js-1) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-ng) = s(i,js)
        enddo
        do i = ie+1,ie+ngmax
c         s(i,js-1) = threehalves*s(i,js) - half*s(i,js+1)
          s(i,js-ng) = s(i,js)
        enddo
        enddo

      endif

      if (BCY_HI .eq. WALL) then

        do ng = 1,ngmax
        do i = is-ngmax,is-1
c         s(i,je+1 ) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+ng) = s(i,je)
        enddo
        do i = ie+1,ie+ngmax
c         s(i,je+1 ) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+ng) = s(i,je)
        enddo
        enddo

      elseif (BCY_HI .eq. OUTLET) then

        do ng = 1,ngmax
        do i = is-ngmax,is-1
c         s(i,je+1) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+ng) = s(i,je)
        enddo
        do i = ie+1,ie+ngmax 
c         s(i,je+1) = threehalves*s(i,je) - half*s(i,je-1)
          s(i,je+ng) = s(i,je)
        enddo
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: DERIVE_3D.F,v 1.17 2002/11/14 23:04:56 lijewski Exp $
c
#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "DERIVE_F.H"
#include "PROB_NS_F.H"
#include "ArrayLim.H"

#define SDIM 3

c     -----------------------------------------------------------
c     This file contains functions which compute derived quantities.  
c     All of the argument lists have the same template, shown below
c     
c     INPUTS/OUTPUTS:
c     
c     e         <= the quantity derived
c     DIMS(e)   => index extent of e array
c     nv        => number of components in e array (should be 1)
c     dat       => data neded to derive e
c     DIMS(dat) => index limits of dat array
c     ncomp     => number of components of dat array (3)
c     lo,hi     => subrange of e array where result is requested
c     domlo,hi  => index extent of problem domain (cell centered)
c     delta     => cell spacing
c     xlo       => physical location of lower left hand
c 	           corner of e array
c     time      => problem evolution time
c     bc        => array of bndry types for component values
c                  valid only if component touches bndry
c     -----------------------------------------------------------

      subroutine FORT_DERKENG (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                         bc,level,grid_no)
c
c     This routine will derive kinetic energy from density
c     and the velocity field.
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j,k
      REAL_T     rho, u, v, w

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               rho = dat(i,j,k,1)
               u   = dat(i,j,k,2)
               v   = dat(i,j,k,3)
               w   = dat(i,j,k,4)
               e(i,j,k,1) = half*rho*(u**2 + v**2 + w**2)
            end do
         end do
      end do

      end

      subroutine FORT_DERLOGS (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                         bc,level, grid_no)
c
c     This routine will derive log of given scalar quantity
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j,k
      REAL_T     rho
      REAL_T     sml

      parameter (sml = 1.0D-10)

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               rho = max(dat(i,j,k,1),sml)
               e(i,j,k,1) = log10(rho)
            end do
         end do
      end do

      end

      subroutine FORT_DERMVEL (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                         lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                         bc,level, grid_no)
c
c ::: This routine will derive the magnitude of the velocity field
c ::: from the velocity field
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j,k
      REAL_T     u, v, w

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               u   = dat(i,j,k,1)
               v   = dat(i,j,k,2)
               w   = dat(i,j,k,3)
               e(i,j,k,1) = sqrt(u**2 + v**2 + w**2)
            end do
         end do
      end do

      end

      subroutine FORT_DERDVRHO (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                          bc,level, grid_no)
c
c ::: This routine will derive C/RHO
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j,k
      
      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               e(i,j,k,1) = dat(i,j,k,2)/dat(i,j,k,1)
            end do
         end do
      end do

      end

      subroutine FORT_DERMPRHO (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                          bc,level, grid_no)
c
c ::: This routine will derive RHO*C
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j,k

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               e(i,j,k,1) = dat(i,j,k,2)*dat(i,j,k,1)
            end do
         end do
      end do

      end

      subroutine FORT_DERLGRHODUST (e,DIMS(e),nv,dat,DIMS(dat),ncomp,
     &                              lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                              bc,level,grid_no)
c
c ::: This routine will derive log(RHO*C)
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(e)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     e(DIMV(e),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer    i,j,k
      REAL_T     dust, small

      parameter (small = 1.0D-10)

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               dust = max(small,dat(i,j,k,2)*dat(i,j,k,1))
               e(i,j,k,1) = log10(dust)
            end do
         end do
      end do

      end

      subroutine FORT_DERMGVORT (vort,DIMS(vort),nv,dat,DIMS(dat),ncomp,
     &                           lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                           bc,level,grid_no)
c
c ::: This routine will derive magnitude of vorticity from
c ::: the velocity field
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(vort)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     vort(DIMV(vort),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer   i,j,k
      REAL_T    uy, uz, vx, vz, wx, wy, dx, dy, dz
      REAL_T    uycen, uzcen, uylo, uyhi, uzlo, uzhi
      REAL_T    vxcen, vzcen, vxlo, vxhi, vzlo, vzhi
      REAL_T    wxcen, wycen, wxlo, wxhi, wylo, wyhi
      REAL_T    vorfun

      logical   fixvlo_x, fixwlo_x, fixvhi_x, fixwhi_x
      logical   fixulo_y, fixwlo_y, fixuhi_y, fixwhi_y
      logical   fixulo_z, fixvlo_z, fixuhi_z, fixvhi_z
c
c     ::::: some useful macro definitions
c
#     define U(i,j,k) dat(i,j,k,1)
#     define V(i,j,k) dat(i,j,k,2)
#     define W(i,j,k) dat(i,j,k,3)

#     define ULOY bc(2,1,1)
#     define UHIY bc(2,2,1)
#     define ULOZ bc(3,1,1)
#     define UHIZ bc(3,2,1)

#     define VLOX bc(1,1,2)
#     define VHIX bc(1,2,2)
#     define VLOZ bc(3,1,2)
#     define VHIZ bc(3,2,2)

#     define WLOX bc(1,1,3)
#     define WHIX bc(1,2,3)
#     define WLOY bc(2,1,3)
#     define WHIY bc(2,2,3)
c
c     ::::: statement functions that implement stencil
c
      uycen(i,j,k) = half*(U(i,j+1,k)-U(i,j-1,k))/dy
      uylo(i,j,k)  = (U(i,j+1,k)+three*U(i,j,k)-four*U(i,j-1,k))/(three*dy)
      uyhi(i,j,k)  =-(U(i,j-1,k)+three*U(i,j,k)-four*U(i,j+1,k))/(three*dy)

      uzcen(i,j,k) = half*(U(i,j,k+1)-U(i,j,k-1))/dz
      uzlo(i,j,k)  = (U(i,j,k+1)+three*U(i,j,k)-four*U(i,j,k-1))/(three*dz)
      uzhi(i,j,k)  =-(U(i,j,k-1)+three*U(i,j,k)-four*U(i,j,k+1))/(three*dz)

      vxcen(i,j,k) = half*(V(i+1,j,k)-V(i-1,j,k))/dx
      vxlo(i,j,k)  = (V(i+1,j,k)+three*V(i,j,k)-four*V(i-1,j,k))/(three*dx)
      vxhi(i,j,k)  =-(V(i-1,j,k)+three*V(i,j,k)-four*V(i+1,j,k))/(three*dx)

      vzcen(i,j,k) = half*(V(i,j,k+1)-V(i,j,k-1))/dz
      vzlo(i,j,k)  = (V(i,j,k+1)+three*V(i,j,k)-four*V(i,j,k-1))/(three*dz)
      vzhi(i,j,k)  =-(V(i,j,k-1)+three*V(i,j,k)-four*V(i,j,k+1))/(three*dz)

      wxcen(i,j,k) = half*(W(i+1,j,k)-W(i-1,j,k))/dx
      wxlo(i,j,k)  = (W(i+1,j,k)+three*W(i,j,k)-four*W(i-1,j,k))/(three*dx)
      wxhi(i,j,k)  =-(W(i-1,j,k)+three*W(i,j,k)-four*W(i+1,j,k))/(three*dx)

      wycen(i,j,k) = half*(W(i,j+1,k)-W(i,j-1,k))/dy
      wylo(i,j,k)  = (W(i,j+1,k)+three*W(i,j,k)-four*W(i,j-1,k))/(three*dy)
      wyhi(i,j,k)  =-(W(i,j-1,k)+three*W(i,j,k)-four*W(i,j+1,k))/(three*dy)

      vorfun(uy,uz,vx,vz,wx,wy) = sqrt((wy-vz)**2+(uz-wx)**2+(vx-uy)**2)

      dx = delta(1)
      dy = delta(2)
      dz = delta(3)
      
      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               uy = uycen(i,j,k)
               uz = uzcen(i,j,k)
               vx = vxcen(i,j,k)
               vz = vzcen(i,j,k)
               wx = wxcen(i,j,k)
               wy = wycen(i,j,k)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end do

      fixvlo_x = ( (lo(1) .eq. domlo(1)) .and.
     &             (VLOX .eq. EXT_DIR .or. VLOX .eq. HOEXTRAP) )
      fixvhi_x = ( (hi(1) .eq. domhi(1)) .and.
     &             (VHIX .eq. EXT_DIR .or. VHIX .eq. HOEXTRAP) )
      fixwlo_x = ( (lo(1) .eq. domlo(1)) .and.
     &             (WLOX .eq. EXT_DIR .or. WLOX .eq. HOEXTRAP) )
      fixwhi_x = ( (hi(1) .eq. domhi(1)) .and.
     &             (WHIX .eq. EXT_DIR .or. WHIX .eq. HOEXTRAP) )

      fixulo_y = ( (lo(2) .eq. domlo(2)) .and.
     &             (ULOY .eq. EXT_DIR .or. ULOY .eq. HOEXTRAP) )
      fixuhi_y = ( (hi(2) .eq. domhi(2)) .and.
     &             (UHIY .eq. EXT_DIR .or. UHIY .eq. HOEXTRAP) )
      fixwlo_y = ( (lo(2) .eq. domlo(2)) .and.
     &             (WLOY .eq. EXT_DIR .or. WLOY .eq. HOEXTRAP) )
      fixwhi_y = ( (hi(2) .eq. domhi(2)) .and.
     &             (WHIY .eq. EXT_DIR .or. WHIY .eq. HOEXTRAP) )

      fixulo_z = ( (lo(3) .eq. domlo(3)) .and.
     &             (ULOZ .eq. EXT_DIR .or. ULOZ .eq. HOEXTRAP) )
      fixuhi_z = ( (hi(3) .eq. domhi(3)) .and.
     &             (UHIZ .eq. EXT_DIR .or. UHIZ .eq. HOEXTRAP) )
      fixvlo_z = ( (lo(3) .eq. domlo(3)) .and.
     &             (VLOZ .eq. EXT_DIR .or. VLOZ .eq. HOEXTRAP) )
      fixvhi_z = ( (hi(3) .eq. domhi(3)) .and.
     &             (VHIZ .eq. EXT_DIR .or. VHIZ .eq. HOEXTRAP) )
c
c     First do all the faces
c
      if (fixvlo_x .or. fixwlo_x) then
         i = lo(1)
         do k = lo(3),hi(3)
            do j = lo(2),hi(2)
               vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
               wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
               uy = uycen(i,j,k)
               wy = wycen(i,j,k)
               uz = uzcen(i,j,k)
               vz = vzcen(i,j,k)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end if

      if (fixvhi_x .or. fixwhi_x) then
         i = hi(1)
         do k = lo(3),hi(3)
            do j = lo(2),hi(2)
               vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
               wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
               uy = uycen(i,j,k)
               wy = wycen(i,j,k)
               uz = uzcen(i,j,k)
               vz = vzcen(i,j,k)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end if

      if (fixulo_y .or. fixwlo_y) then
         j = lo(2)
         do k = lo(3),hi(3)
            do i = lo(1),hi(1)
               vx = vxcen(i,j,k)
               wx = wxcen(i,j,k)
               uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
               wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
               uz = uzcen(i,j,k)
               vz = vzcen(i,j,k)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end if

      if (fixuhi_y .or. fixwhi_y) then
         j = hi(2)
         do k = lo(3),hi(3)
            do i = lo(1),hi(1)
               vx = vxcen(i,j,k)
               wx = wxcen(i,j,k)
               uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
               wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
               uz = uzcen(i,j,k)
               vz = vzcen(i,j,k)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end if

      if (fixulo_z .or. fixvlo_z) then
         k = lo(3)
         do j = lo(2),hi(2)
            do i = lo(1),hi(1)
               vx = vxcen(i,j,k)
               wx = wxcen(i,j,k)
               uy = uycen(i,j,k)
               wy = wycen(i,j,k)
               uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
               vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end if

      if (fixuhi_z .or. fixvhi_z) then
         k = hi(3)
         do j = lo(2),hi(2)
            do i = lo(1),hi(1)
               vx = vxcen(i,j,k)
               wx = wxcen(i,j,k)
               uy = uycen(i,j,k)
               wy = wycen(i,j,k)
               uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
               vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
               vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
            end do
         end do
      end if
c
c     Next do all the edges
c
      if ((fixvlo_x .or. fixwlo_x) .and. (fixulo_y .or. fixwlo_y)) then
         i = lo(1)
         j = lo(2)
         do k = lo(3),hi(3)
            vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
            wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
            uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
            wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
            uz = uzcen(i,j,k)
            vz = vzcen(i,j,k)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixulo_y .or. fixwlo_y)) then
         i = hi(1)
         j = lo(2)
         do k = lo(3),hi(3)
            vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
            wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
            uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
            wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
            uz = uzcen(i,j,k)
            vz = vzcen(i,j,k)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvlo_x .or. fixwlo_x) .and. (fixuhi_y .or. fixwhi_y)) then
         i = lo(1)
         j = hi(2)
         do k = lo(3),hi(3)
            vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
            wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
            uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
            wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
            uz = uzcen(i,j,k)
            vz = vzcen(i,j,k)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixuhi_y .or. fixwhi_y)) then
         i = hi(1)
         j = hi(2)
         do k = lo(3),hi(3)
            vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
            wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
            uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
            wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
            uz = uzcen(i,j,k)
            vz = vzcen(i,j,k)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvlo_x .or. fixwlo_x) .and. (fixulo_z .or. fixvlo_z)) then
         i = lo(1)
         k = lo(3)
         do j = lo(2),hi(2)
            vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
            wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
            uy = uycen(i,j,k)
            wy = wycen(i,j,k)
            uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
            vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixulo_z .or. fixvlo_z)) then
         i = hi(1)
         k = lo(3)
         do j = lo(2),hi(2)
            vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
            wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
            uy = uycen(i,j,k)
            wy = wycen(i,j,k)
            uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
            vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvlo_x .or. fixwlo_x) .and. (fixuhi_z .or. fixvhi_z)) then
         i = lo(1)
         k = hi(3)
         do j = lo(2),hi(2)
            vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
            wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
            uy = uycen(i,j,k)
            wy = wycen(i,j,k)
            uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
            vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixuhi_z .or. fixvhi_z)) then
         i = hi(1)
         k = hi(3)
         do j = lo(2),hi(2)
            vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
            wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
            uy = uycen(i,j,k)
            wy = wycen(i,j,k)
            uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
            vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixulo_y .or. fixwlo_y) .and. (fixulo_z .or. fixvlo_z)) then
         j = lo(2)
         k = lo(3)
         do i = lo(1),hi(1)
            vx = vxcen(i,j,k)
            wx = wxcen(i,j,k)
            uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
            wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
            uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
            vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixuhi_y .or. fixwhi_y) .and. (fixulo_z .or. fixvlo_z)) then
         j = hi(2)
         k = lo(3)
         do i = lo(1),hi(1)
            vx = vxcen(i,j,k)
            wx = wxcen(i,j,k)
            uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
            wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
            uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
            vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixulo_y .or. fixwlo_y) .and. (fixuhi_z .or. fixvhi_z)) then
         j = lo(2)
         k = hi(3)
         do i = lo(1),hi(1)
            vx = vxcen(i,j,k)
            wx = wxcen(i,j,k)
            uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
            wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
            uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
            vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if

      if ((fixuhi_y .or. fixwhi_y) .and. (fixuhi_z .or. fixvhi_z)) then
         j = hi(2)
         k = hi(3)
         do i = lo(1),hi(1)
            vx = vxcen(i,j,k)
            wx = wxcen(i,j,k)
            uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
            wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
            uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
            vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
            vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
         end do
      end if
c
c     Finally do all the corners
c
      if ((fixvlo_x .or. fixwlo_x) .and. (fixulo_y .or. fixwlo_y) .and. 
     $     (fixulo_z .or. fixvlo_z)) then
         i = lo(1)
         j = lo(2)
         k = lo(3)
         vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
         wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
         uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
         wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
         uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
         vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixulo_y .or. fixwlo_y) .and. 
     $     (fixulo_z .or. fixvlo_z)) then
         i = hi(1)
         j = lo(2)
         k = lo(3)
         vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
         wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
         uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
         wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
         uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
         vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvlo_x .or. fixwlo_x) .and. (fixuhi_y .or. fixwhi_y) .and. 
     $     (fixulo_z .or. fixvlo_z)) then
         i = lo(1)
         j = hi(2)
         k = lo(3)
         vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
         wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
         uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
         wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
         uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
         vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixuhi_y .or. fixwhi_y) .and. 
     $     (fixulo_z .or. fixvlo_z)) then
         i = hi(1)
         j = hi(2)
         k = lo(3)
         vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
         wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
         uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
         wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
         uz = cvmgt(uzlo(i,j,k),uzcen(i,j,k),fixulo_z)
         vz = cvmgt(vzlo(i,j,k),vzcen(i,j,k),fixvlo_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvlo_x .or. fixwlo_x) .and. (fixulo_y .or. fixwlo_y) .and. 
     $     (fixuhi_z .or. fixvhi_z)) then
         i = lo(1)
         j = lo(2)
         k = hi(3)
         vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
         wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
         uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
         wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
         uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
         vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixulo_y .or. fixwlo_y) .and. 
     $     (fixuhi_z .or. fixvhi_z)) then
         i = hi(1)
         j = lo(2)
         k = hi(3)
         vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
         wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
         uy = cvmgt(uylo(i,j,k),uycen(i,j,k),fixulo_y)
         wy = cvmgt(wylo(i,j,k),wycen(i,j,k),fixwlo_y)
         uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
         vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvlo_x .or. fixwlo_x) .and. (fixuhi_y .or. fixwhi_y) .and. 
     $     (fixuhi_z .or. fixvhi_z)) then
         i = lo(1)
         j = hi(2)
         k = hi(3)
         vx = cvmgt(vxlo(i,j,k),vxcen(i,j,k),fixvlo_x)
         wx = cvmgt(wxlo(i,j,k),wxcen(i,j,k),fixwlo_x)
         uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
         wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
         uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
         vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

      if ((fixvhi_x .or. fixwhi_x) .and. (fixuhi_y .or. fixwhi_y) .and. 
     $     (fixuhi_z .or. fixvhi_z)) then
         i = hi(1)
         j = hi(2)
         k = hi(3)
         vx = cvmgt(vxhi(i,j,k),vxcen(i,j,k),fixvhi_x)
         wx = cvmgt(wxhi(i,j,k),wxcen(i,j,k),fixwhi_x)
         uy = cvmgt(uyhi(i,j,k),uycen(i,j,k),fixuhi_y)
         wy = cvmgt(wyhi(i,j,k),wycen(i,j,k),fixwhi_y)
         uz = cvmgt(uzhi(i,j,k),uzcen(i,j,k),fixuhi_z)
         vz = cvmgt(vzhi(i,j,k),vzcen(i,j,k),fixvhi_z)
         vort(i,j,k,1) = vorfun(uy,uz,vx,vz,wx,wy)
      end if

#     undef U
#     undef V      
#     undef W
#     undef ULOY
#     undef UHIY
#     undef ULOZ
#     undef UHIZ
#     undef VLOX
#     undef VHIX
#     undef VLOZ
#     undef VHIZ
#     undef WLOX
#     undef WHIX
#     undef WLOY
#     undef WHIY

      end

      subroutine FORT_DERMGDIVU (divu,DIMS(divu),nv,dat,DIMS(dat),ncomp,
     &                           lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                           bc,level,grid_no)
c
c ::: This routine will derive magnitude of the divergence of velocity
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(divu)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     divu(DIMV(divu),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no

      integer   i,j,k
      REAL_T    ux, vy, wz, dx, dy, dz
      REAL_T    uxcen, uxlo, uxhi
      REAL_T    vycen, vylo, vyhi
      REAL_T    wzcen, wzlo, wzhi
c
c     ::::: some useful macro definitions
c
#     define U(i,j,k) dat(i,j,k,1)
#     define V(i,j,k) dat(i,j,k,2)
#     define W(i,j,k) dat(i,j,k,3)

#     define ULOX bc(1,1,1)
#     define UHIX bc(1,2,1)
#     define VLOY bc(2,1,2)
#     define VHIY bc(2,2,2)
#     define WLOZ bc(3,1,2)
#     define WHIZ bc(3,2,2)
c
c     ::::: statement functions that implement stencil
c
      uxcen(i,j,k) = half*(U(i+1,j,k)-U(i-1,j,k))/dx
      uxlo(i,j,k) = (eight*U(i,j,k)-six*U(i+1,j,k)+U(i+2,j,k))/(three*dx)
      uxhi(i,j,k) = (eight*U(i,j,k)-six*U(i-1,j,k)+U(i-2,j,k))/(three*dx)

      vycen(i,j,k) = half*(V(i,j+1,k)-V(i,j-1,k))/dy
      vylo(i,j,k) = (eight*V(i,j,k)-six*V(i,j+1,k)+V(i,j+2,k))/(three*dy)
      vyhi(i,j,k) = (eight*V(i,j,k)-six*V(i,j-1,k)+V(i,j-2,k))/(three*dy)

      wzcen(i,j,k) = half*(W(i,j,k+1)-W(i,j,k-1))/dz
      wzlo(i,j,k) = (eight*W(i,j,k)-six*W(i,j,k+1)+W(i,j,k+2))/(three*dz)
      wzhi(i,j,k) = (eight*W(i,j,k)-six*W(i,j,k-1)+W(i,j,k-2))/(three*dz)

      call FORT_XVELFILL(dat(ARG_L1(dat),ARG_L2(dat),ARG_L3(dat),1),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,1))
      call FORT_YVELFILL(dat(ARG_L1(dat),ARG_L2(dat),ARG_L3(dat),2),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,2))
      call FORT_ZVELFILL(dat(ARG_L1(dat),ARG_L2(dat),ARG_L3(dat),3),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,3))

      dx = delta(1)
      dy = delta(2)
      dz = delta(3)
c
c     :: at physical bndries where an edge value is prescribed,
c     :: set the value in the outside cell so that a central
c     :: difference formula is equivalent to the higher order
c     :: one sided formula
c
      if (lo(1) .eq. domlo(1)) then
         i = lo(1)
         if (ULOX.eq.EXT_DIR) then
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  U(i-1,j,k) = two*U(i-1,j,k) - U(i,j,k)
               end do
            end do
         else if (ULOX.eq.HOEXTRAP) then
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  U(i-1,j,k) = uxlo(i,j,k)
               end do
            end do
	 end if
      end if
      if (hi(1) .eq. domhi(1)) then
         i = hi(1)
         if (UHIX.eq.EXT_DIR) then
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  U(i+1,j,k) = two*U(i+1,j,k) - U(i,j,k)
               end do
            end do
         else if (UHIX.eq.HOEXTRAP) then
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  U(i+1,j,k) = uxhi(i,j,k)
               end do
            end do
	 end if
      end if
      if (lo(2) .eq. domlo(2)) then
         j = lo(2)
	 if (VLOY.eq.EXT_DIR) then
            do k = lo(3), hi(3)
               do i = lo(1), hi(1)
                  V(i,j-1,k) = two*V(i,j-1,k) - V(i,j,k)
               end do
            end do
         else if (VLOY.eq.HOEXTRAP) then
            do k = lo(3), hi(3)
               do i = lo(1), hi(1)
                  V(i,j-1,k) = vylo(i,j,k)
               end do
            end do
	 end if
      end if
      if (hi(2) .eq. domhi(2)) then
         j = hi(2)
	 if (VHIY.eq.EXT_DIR) then
            do k = lo(3), hi(3)
               do i = lo(1), hi(1)
                  V(i,j+1,k) = two*V(i,j+1,k) - V(i,j,k)
               end do
            end do
	 else if (VHIY.eq.HOEXTRAP) then
            do k = lo(3), hi(3)
               do i = lo(1), hi(1)
                  V(i,j+1,k) = vyhi(i,j,k)
               end do
            end do
	 end if
      end if
      if (lo(3) .eq. domlo(3)) then
         k = lo(3)
	 if (WLOZ.eq.EXT_DIR) then
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  W(i,j,k-1) = two*W(i,j,k-1) - W(i,j,k)
               end do
            end do
	 else if (WLOZ.eq.HOEXTRAP) then
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  W(i,j,k-1) = wzlo(i,j,k)
               end do
            end do
	 end if
      end if
      if (hi(3) .eq. domhi(3)) then
         k = hi(3)
	 if (WHIZ.eq.EXT_DIR) then
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  W(i,j,k+1) = two*W(i,j,k+1) - W(i,j,k)
               end do
            end do
	 else if (WHIZ.eq.HOEXTRAP) then
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  W(i,j,k+1) = wzhi(i,j,k)
               end do
            end do
	 end if
      end if

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               ux = uxcen(i,j,k)
               vy = vycen(i,j,k)
               wz = wzcen(i,j,k)
               divu(i,j,k,1) = ux + vy + wz
            end do
         end do
      end do
c
c we overwrote the ghost cells above, so set them back below
c
      call FORT_XVELFILL(dat(ARG_L1(dat),ARG_L2(dat),ARG_L3(dat),1),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,1))
      call FORT_YVELFILL(dat(ARG_L1(dat),ARG_L2(dat),ARG_L3(dat),1),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,2))
      call FORT_ZVELFILL(dat(ARG_L1(dat),ARG_L2(dat),ARG_L3(dat),1),DIMS(dat),
     $                   domlo,domhi,delta,xlo,time,bc(1,1,3))

#     undef U
#     undef V      
#     undef W
#     undef ULOX
#     undef UHIX
#     undef VLOY
#     undef VHIY
#     undef WLOZ
#     undef WHIZ

      end

      subroutine FORT_GRADP_DIR (
     &     p,DIMS(p),
     &     gp,DIMS(gp),
     &     lo,hi,dir,dx)
c
c     compute a node centered pressure gradient in direction (dir)
c
      integer    DIMDEC(p)
      integer    DIMDEC(gp)
      integer     lo(SDIM),  hi(SDIM)
      integer    dir
      REAL_T     dx
      REAL_T   p(DIMV(p))
      REAL_T  gp(DIMV(gp))

      logical    invalid
      integer    i,j,k
      REAL_T     d
      integer    ilo, ihi, jlo, jhi, klo, khi

      d = fourth/dx
c
c     ::::: compute gradient on interior
c
      if (dir .eq. 0) then
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  gp(i,j,k) = d*(
     &                 p(i+1,j,k  )-p(i,j,k  )+p(i+1,j+1,k  )-p(i,j+1,k  )+
     $                 p(i+1,j,k+1)-p(i,j,k+1)+p(i+1,j+1,k+1)-p(i,j+1,k+1))
               end do
            end do
         end do
      else if (dir .eq. 1) then
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  gp(i,j,k) = d*(
     &                 p(i,j+1,k  )-p(i,j,k  )+p(i+1,j+1,k  )-p(i+1,j,k  )+
     $                 p(i,j+1,k+1)-p(i,j,k+1)+p(i+1,j+1,k+1)-p(i+1,j,k+1))
               end do
            end do
         end do
      else if (dir .eq. 2) then
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  gp(i,j,k) = d*(
     &                 p(i,  j,k+1)-p(i,  j,k)+p(i,  j+1,k+1)-p(i,  j+1,k)+
     $                 p(i+1,j,k+1)-p(i+1,j,k)+p(i+1,j+1,k+1)-p(i+1,j+1,k))
               end do
            end do
         end do
      else
	 call bl_abort("FORT_GRADP_DIR: invalid dir = ")
      end if

      end

      subroutine FORT_DERGRDPX (grdpx,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                          bc,level,grid_no)
c
c     This routine computes pressure gradient in x direciton
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(gp)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     grdpx(DIMV(gp),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no
c
      call FORT_GRADP_DIR (
     &     dat,DIMS(dat),grdpx,DIMS(gp),
     &     lo,hi,0,delta(1))

      end

      subroutine FORT_DERGRDPY (grdpy,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                          bc,level,grid_no)
c
c     This routine computes pressure gradient in Y direciton
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(gp)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     grdpy(DIMV(gp),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no
c
      call FORT_GRADP_DIR (
     &     dat,DIMS(dat),grdpy,DIMS(gp),
     &     lo,hi,1,delta(2))

      end

      subroutine FORT_DERGRDPZ (grdpz,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                          lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                          bc,level,grid_no)
c
c     This routine computes pressure gradient in Z direciton
c
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(gp)
      integer    DIMDEC(dat)
      integer    domlo(SDIM), domhi(SDIM)
      integer    nv, ncomp
      integer    bc(SDIM,2,ncomp)
      REAL_T     delta(SDIM), xlo(SDIM)
      REAL_T     time, dt
      REAL_T     grdpz(DIMV(gp),nv)
      REAL_T     dat(DIMV(dat),ncomp)
      integer    level, grid_no
c
      call FORT_GRADP_DIR (
     &     dat,DIMS(dat),grdpz,DIMS(gp),
     &     lo,hi,2,delta(3))

      end


      subroutine FORT_DERAVGPRES (avgpres,DIMS(gp),nv,dat,DIMS(dat),ncomp,
     &                            lo,hi,domlo,domhi,delta,xlo,time,dt,
     &                            bc,level,grid_no)
c
c     This routine computes cell-centered pressure as average of the eight
c       surrounding nodal values.
c
      integer DIMDEC(gp)
      integer DIMDEC(dat)
      REAL_T  avgpres(DIMV(gp))
      REAL_T  dat(DIMV(dat))
      integer nv, ncomp
      integer lo(SDIM), hi(SDIM)
      integer domlo(SDIM), domhi(SDIM)
      REAL_T  delta(SDIM)
      REAL_T  xlo(SDIM)
      REAL_T  time, dt
      integer bc(SDIM,2,ncomp)
      integer level
      integer grid_no

      integer i,j,k

      do k = lo(3), hi(3)
        do j = lo(2), hi(2)
          do i = lo(1), hi(1)
            avgpres(i,j,k) = eighth*( 
     $                     dat(i+1,j,k)     + dat(i,j,k) 
     $                   + dat(i+1,j+1,k)   + dat(i,j+1,k)
     $                   + dat(i+1,j,k+1)   + dat(i,j,k+1) 
     $                   + dat(i+1,j+1,k+1) + dat(i,j+1,k+1) )
          end do
        end do
      end do

      end

c=========================================================

      subroutine FORT_DERGRDP (grdp,DIMS(gp),nv,p,DIMS(p),ncomp,
     &                         lo,hi,domlo,domhi,dx,xlo,time,dt,
     $                         bc,level,grid_no)
c
c     This routine computes the magnitude of pressure gradient 
c
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(gp)
      integer DIMDEC(p)
      integer domlo(SDIM), domhi(SDIM)
      integer nv, ncomp
      integer bc(SDIM,2,ncomp)
      REAL_T  dx(SDIM), xlo(SDIM), time, dt
      REAL_T  grdp(DIMV(gp),nv)
      REAL_T  p(DIMV(p),ncomp)
      integer level, grid_no

      REAL_T     gpx, gpy, gpz
      integer    i,j,k
c
      do k = lo(3), hi(3)
        do j = lo(2), hi(2)
          do i = lo(1), hi(1)
            gpx = fourth * (p(i+1,j,k  ,1)-p(i,j,k  ,1)+p(i+1,j+1,k  ,1)-p(i,j+1,k  ,1)+
     $                      p(i+1,j,k+1,1)-p(i,j,k+1,1)+p(i+1,j+1,k+1,1)-p(i,j+1,k+1,1))/dx(1)
            gpy = fourth * (p(i,j+1,k  ,1)-p(i,j,k  ,1)+p(i+1,j+1,k  ,1)-p(i+1,j,k  ,1)+
     $                      p(i,j+1,k+1,1)-p(i,j,k+1,1)+p(i+1,j+1,k+1,1)-p(i+1,j,k+1,1))/dx(2)
            gpz = fourth * (p(i,  j,k+1,1)-p(i,  j,k,1)+p(i,  j+1,k+1,1)-p(i,  j+1,k,1)+
     $                      p(i+1,j,k+1,1)-p(i+1,j,k,1)+p(i+1,j+1,k+1,1)-p(i+1,j+1,k,1))/dx(3)
            grdp(i,j,k,1) = sqrt(gpx**2 + gpy**2 + gpz**2)
          end do
        end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define N_STATE 4
#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** MKFLUX **
c ** If (velpred == 1), then predict normal edge velocities to be
c **    MAC_projected and used for advection velocities
c ** If (velpred == 0), then create the time-centered edge states to
c **    be used in defining the velocity and scalar fluxes.
c ***************************************************************

      subroutine FORT_MKFLUX(s,sedgex,sedgey,slopex,slopey,
     $                       uadv,vadv,utrans,vtrans,force,
     $                       s_l,s_r,s_b,s_t,DIMS,
     $                       dx,dt,visc_coef,irz,bc,velpred,
     $                       nstart,nend)

      implicit none

      integer DIMS
      integer nstart,nend

      REAL_T       s(lo_1-3:hi_1+3,lo_2-3:hi_2+3,N_STATE)
      REAL_T  sedgex(lo_1  :hi_1+1,lo_2  :hi_2  ,N_STATE)
      REAL_T  sedgey(lo_1  :hi_1  ,lo_2  :hi_2+1,N_STATE)
      REAL_T  slopex(lo_1-1:hi_1+1,lo_2-1:hi_2+1,N_STATE)
      REAL_T  slopey(lo_1-1:hi_1+1,lo_2-1:hi_2+1,N_STATE)
      REAL_T    uadv(lo_1  :hi_1+1,lo_2  :hi_2  )
      REAL_T    vadv(lo_1  :hi_1  ,lo_2  :hi_2+1)
      REAL_T  utrans(lo_1-1:hi_1+2,lo_2-1:hi_2+1)
      REAL_T  vtrans(lo_1-1:hi_1+1,lo_2-1:hi_2+2)
      REAL_T   force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,nstart:nend)

      REAL_T    s_l(lo_1-1:hi_1+2)
      REAL_T    s_r(lo_1-1:hi_1+2)
      REAL_T    s_b(lo_2-1:hi_2+2)
      REAL_T    s_t(lo_2-1:hi_2+2)

      REAL_T  dx(2)
      REAL_T  dt
      REAL_T  visc_coef
      integer irz
      integer bc(2,2)
      integer velpred

c     Local variables
      REAL_T ubardth, vbardth
      REAL_T hx, hy, dth
      REAL_T splus,sminus
      REAL_T savg,st
      REAL_T sptop,spbot,smtop,smbot,splft,sprgt,smlft,smrgt
      integer n
      logical test

      REAL_T eps

      integer i,j,is,js,ie,je
      integer ii

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      dth = half*dt

      hx = dx(1)
      hy = dx(2)

c
c     Loop for fluxes on x-edges.
c
      do n = nstart,nend
       do j = js,je 
        if (velpred .eq. 0 .or. n .eq. 1) then
        do i = is-1,ie+1 

          spbot = s(i,j  ,n) + (half - dth*s(i,j  ,2)/hy) * slopey(i,j  ,n)
c    $            + dth * force(i,  j,n)
          sptop = s(i,j+1,n) - (half + dth*s(i,j+1,2)/hy) * slopey(i,j+1,n)
c    $            + dth * force(i,j+1,n)

          sptop = cvmgt(s(i,je+1,n),sptop,j.eq.je .and. BCY_HI .eq. INLET)
          spbot = cvmgt(s(i,je+1,n),spbot,j.eq.je .and. BCY_HI .eq. INLET)

          if (j .eq. je .and. BCY_HI .eq. WALL) then
            if (n .eq. 2) then
              sptop = zero
              spbot = zero
            elseif (n .eq. 1) then
              sptop = cvmgt(zero,spbot,visc_coef .gt. zero)
              spbot = cvmgt(zero,spbot,visc_coef .gt. zero)
            else
              sptop = spbot
            endif
          endif

          splus = cvmgp(spbot,sptop,vtrans(i,j+1))
          savg  = half * (spbot + sptop)
          splus = cvmgt(splus, savg, abs(vtrans(i,j+1)) .gt. eps)

          smtop = s(i,j  ,n) - (half + dth*s(i,j  ,2)/hy) * slopey(i,j  ,n)
c    $            + dth * force(i,j  ,n)
          smbot = s(i,j-1,n) + (half - dth*s(i,j-1,2)/hy) * slopey(i,j-1,n)
c    $            + dth * force(i,j-1,n)

          smtop = cvmgt(s(i,js-1,n),smtop,j.eq.js .and. BCY_LO .eq. INLET)
          smbot = cvmgt(s(i,js-1,n),smbot,j.eq.js .and. BCY_LO .eq. INLET)

          if (j .eq. js .and. BCY_LO .eq. WALL) then
            if (n .eq. 2) then
              smtop = zero
              smbot = zero
            elseif (n .eq. 1) then
              smbot = cvmgt(zero,smtop,visc_coef .gt. zero)
              smtop = cvmgt(zero,smtop,visc_coef .gt. zero)
            else
              smbot = smtop
            endif
          endif

          sminus = cvmgp(smbot,smtop,vtrans(i,j))
          savg   = half * (smbot + smtop)
          sminus = cvmgt(sminus, savg, abs(vtrans(i,j)) .gt. eps)

          st = force(i,j,n) -
     $          half * (vtrans(i,j)+vtrans(i,j+1))*(splus - sminus) / hy

          ubardth = dth*s(i,j,1)/hx

          s_l(i+1)= s(i,j,n) + (half-ubardth)*slopex(i,j,n) + dth*st
          s_r(i  )= s(i,j,n) - (half+ubardth)*slopex(i,j,n) + dth*st

         enddo

         if (velpred .eq. 1) then
           do i = is, ie+1 
             savg = half*(s_r(i) + s_l(i))
             test = ( (s_l(i) .le. zero  .and.
     $                 s_r(i) .ge. zero)  .or.
     $               (abs(s_l(i) + s_r(i)) .lt. eps) )
             sedgex(i,j,n)=cvmgp(s_l(i),s_r(i),savg)
             sedgex(i,j,n)=cvmgt(savg,sedgex(i,j,n),test)
           enddo
         else
           do i = is, ie+1 
             sedgex(i,j,n)=cvmgp(s_l(i),s_r(i),uadv(i,j))
             savg = half*(s_r(i) + s_l(i))
             sedgex(i,j,n)=cvmgt(savg,sedgex(i,j,n),abs(uadv(i,j)) .lt. eps)
           enddo
         endif

         if (BCX_LO .eq. WALL) then
           if (n .eq. 1) then
             sedgex(is,j,n) = zero
           elseif (n .eq. 2) then
             sedgex(is,j,n) = cvmgt(zero,s_r(is),visc_coef.gt.0.0.and.irz.eq.0)
           else 
             sedgex(is,j,n) = s_r(is)
           endif
         elseif (BCX_LO .eq. INLET) then
           sedgex(is,j,n) = s(is-1,j,n)
         elseif (BCX_LO .eq. OUTLET) then
           sedgex(is,j,n) = s_r(is)
         endif
         if (BCX_HI .eq. WALL) then
           if (n .eq. 1) then
             sedgex(ie+1,j,n) = zero
           else if (n .eq. 2) then
             sedgex(ie+1,j,n) = cvmgt(zero,s_l(ie+1),visc_coef .gt. 0.0)
           else 
             sedgex(ie+1,j,n) = s_l(ie+1)
           endif
         elseif (BCX_HI .eq. INLET) then
           sedgex(ie+1,j,n) = s(ie+1,j,n)
         elseif (BCX_HI .eq. OUTLET) then
           sedgex(ie+1,j,n) = s_l(ie+1)
         endif

         if (velpred .eq. 1) then
           do i = is, ie+1 
             uadv(i,j) = sedgex(i,j,1)
           enddo
         endif
         endif
       enddo

      enddo

c
c     Loop for fluxes on y-edges.
c
      do n = nstart,nend
       do i = is, ie 
        if (velpred .eq. 0 .or. n .eq. 2) then
        do j = js-1, je+1 

          splft = s(i,j  ,n) + (half - dth*s(i  ,j,1)/hx) * slopex(i  ,j,n)
c    $            + dth * force(i  ,j,n)
          sprgt = s(i+1,j,n) - (half + dth*s(i+1,j,1)/hx) * slopex(i+1,j,n)
c    $            + dth * force(i+1,j,n)

          sprgt = cvmgt(s(ie+1,j,n),sprgt,i.eq.ie .and. BCX_HI .eq. INLET)
          splft = cvmgt(s(ie+1,j,n),splft,i.eq.ie .and. BCX_HI .eq. INLET)

          if (i .eq. ie .and. BCX_HI .eq. WALL) then
            if (n .eq. 1) then
              splft = zero
              sprgt = zero
            elseif (n .eq. 2) then
              sprgt = cvmgt(zero,splft,visc_coef .gt. zero)
              splft = cvmgt(zero,splft,visc_coef .gt. zero)
            else
              sprgt = splft
            endif
          endif

          splus = cvmgp(splft,sprgt,utrans(i+1,j))
          savg  = half * (splft + sprgt)
          splus = cvmgt(splus, savg, abs(utrans(i+1,j)) .gt. eps)

          smrgt = s(i  ,j,n) - (half + dth*s(i  ,j,1)/hx) * slopex(i  ,j,n)
c    $            + dth * force(i  ,j,n)
          smlft = s(i-1,j,n) + (half - dth*s(i-1,j,1)/hx) * slopex(i-1,j,n)
c    $            + dth * force(i-1,j,n)

          smrgt = cvmgt(s(is-1,j,n),smrgt,i.eq.is .and. BCX_LO .eq. INLET)
          smlft = cvmgt(s(is-1,j,n),smlft,i.eq.is .and. BCX_LO .eq. INLET)

          if (i .eq. is .and. BCX_LO .eq. WALL) then
            if (n .eq. 1) then
              smlft = zero
              smrgt = zero
            elseif (n .eq. 2) then
              smlft = cvmgt(zero,smrgt,visc_coef.gt.zero.and.irz.eq.0)
              smrgt = cvmgt(zero,smrgt,visc_coef.gt.zero.and.irz.eq.0)
            else
              smlft = smrgt
            endif
          endif

          sminus = cvmgp(smlft,smrgt,utrans(i,j))
          savg   = half * (smlft + smrgt)
          sminus = cvmgt(sminus, savg, abs(utrans(i,j)) .gt. eps)

          st = force(i,j,n) -
     $         half * (utrans(i,j)+utrans(i+1,j))*(splus - sminus) / hx

          vbardth = dth*s(i,j,2)/hy

          s_b(j+1)= s(i,j,n) + (half-vbardth)*slopey(i,j,n) + dth*st
          s_t(j  )= s(i,j,n) - (half+vbardth)*slopey(i,j,n) + dth*st

        enddo

        if (velpred .eq. 1) then
          do j = js, je+1 
            savg = half*(s_b(j) + s_t(j))
            test = ( (s_b(j) .le. zero  .and.
     $                s_t(j) .ge. zero)  .or.
     $             (abs(s_b(j) + s_t(j)) .lt. eps) )
            sedgey(i,j,n)=cvmgp(s_b(j),s_t(j),savg)
            sedgey(i,j,n)=cvmgt(savg,sedgey(i,j,n),test)
          enddo
        else

          do j = js, je+1 
            sedgey(i,j,n)=cvmgp(s_b(j),s_t(j),vadv(i,j))
            savg = half*(s_b(j) + s_t(j))
            sedgey(i,j,n)=cvmgt(savg,sedgey(i,j,n),abs(vadv(i,j)) .lt. eps)
          enddo
        endif

        if (BCY_LO .eq. WALL) then
          if (n .eq. 2) then
            sedgey(i,js,n) = zero
          else if (n .eq. 1) then
            sedgey(i,js,n) = cvmgt(zero,s_t(js),visc_coef .gt. 0.0)
          else 
            sedgey(i,js,n) = s_t(js)
          endif
        elseif (BCY_LO .eq. INLET) then
          sedgey(i,js,n) = s(i,js-1,n)
        elseif (BCY_LO .eq. OUTLET) then
          sedgey(i,js,n) = s_t(js)
        endif

        if (BCY_HI .eq. WALL) then
          if (n .eq. 2) then
            sedgey(i,je+1,n) = zero
          else if (n .eq. 1) then
            sedgey(i,je+1,n) = cvmgt(zero,s_b(je+1),visc_coef .gt. 0.0)
          else 
            sedgey(i,je+1,n) = s_b(je+1)
          endif
        elseif (BCY_HI .eq. INLET) then
          sedgey(i,je+1,n) = s(i,je+1,n)
        elseif (BCY_HI .eq. OUTLET) then
          sedgey(i,je+1,n) = s_b(je+1)
        endif

        if (velpred .eq. 1) then
          do j = js, je+1 
            vadv(i,j) = sedgey(i,j,2)
          enddo
        endif
        endif
       enddo
      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "HGPROJ_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define CDIMS loc_1,loc_2,loc_3,hic_1,hic_2,hic_3
#define GDIMS g_lo_1,g_lo_2,g_lo_3,g_hi_1,g_hi_2,g_hi_3
#define PDIMS p_lo_1,p_lo_2,p_lo_3,p_hi_1,p_hi_2,p_hi_3

#if BL_USE_FLOAT
#define sixteenth  .0625e0
#else
#define sixteenth  .0625d0
#endif

c *************************************************************************
c ** INITSIG **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIG(sig,rho,DIMS,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T   sig(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T   rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i,j,k

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          sig(i,j,k) = one / rho(i,j,k)
        enddo
      enddo
      enddo

      if (bcx_lo .eq. PERIODIC) then

        do k = lo_3-1,hi_3+1 
        do j = lo_2-1,hi_2+1 
          sig(lo_1-1,j,k) = sig(hi_1,j,k)
          sig(hi_1+1,j,k) = sig(lo_1,j,k)
        enddo
        enddo

      else 

        do k = lo_3-1,hi_3+1 
        do j = lo_2-1,hi_2+1 
          sig(lo_1-1,j,k) = zero
          sig(hi_1+1,j,k) = zero
        enddo
        enddo

      endif 

      if (bcy_lo .eq. PERIODIC) then

        do k = lo_3-1,hi_3+1 
        do i = lo_1-1,hi_1+1 
          sig(i,lo_2-1,k) = sig(i,hi_2,k)
          sig(i,hi_2+1,k) = sig(i,lo_2,k)
        enddo
        enddo

      else

        do k = lo_3-1,hi_3+1 
        do i = lo_1-1,hi_1+1 
          sig(i,lo_2-1,k) = zero
          sig(i,hi_2+1,k) = zero
        enddo
        enddo

      endif

      if (bcz_lo .eq. PERIODIC) then

        do j = lo_2-1,hi_2+1 
        do i = lo_1-1,hi_1+1 
          sig(i,j,lo_3-1) = sig(i,j,hi_3)
          sig(i,j,hi_3+1) = sig(i,j,lo_3)
        enddo
        enddo

      else

        do j = lo_2-1,hi_2+1 
        do i = lo_1-1,hi_1+1 
          sig(i,j,lo_3-1) = zero
          sig(i,j,hi_3+1) = zero
        enddo
        enddo

      endif

      return
      end

c *************************************************************************
c ** MKCOEFF **
c ** Define the coefficients along the axis as averages of sig.
c *************************************************************************

      subroutine FORT_MKCOEFF(coeff,sig,DIMS)

      implicit none

      integer DIMS
      REAL_T   sig(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T coeff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)

c     Local variables
      integer i,j,k

      do k = lo_3  ,hi_3+1
      do j = lo_2  ,hi_2+1
      do i = lo_1-1,hi_1+1 
          coeff(i,j,k,1) = ( sig(i,j,k  ) + sig(i,j-1,k  ) +
     $                       sig(i,j,k-1) + sig(i,j-1,k-1) ) * fourth
      enddo
      enddo
      enddo

      do k = lo_3  ,hi_3+1
      do j = lo_2-1,hi_2+1 
      do i = lo_1  ,hi_1+1
          coeff(i,j,k,2) = ( sig(i,j,k  ) + sig(i-1,j,k  ) +
     $                       sig(i,j,k-1) + sig(i-1,j,k-1) ) * fourth
      enddo
      enddo
      enddo

      do k = lo_3-1,hi_3+1 
      do j = lo_2  ,hi_2+1
      do i = lo_1  ,hi_1+1   
          coeff(i,j,k,3) = ( sig(i  ,j,k) + sig(i  ,j-1,k) +
     $                       sig(i-1,j,k) + sig(i-1,j-1,k) ) * fourth
      enddo
      enddo
      enddo

      return
      end


c *************************************************************************
c ** GRADHG **
c ** Compute the cell-centered gradient of the nodal pressure field
c *************************************************************************

      subroutine FORT_GRADHG(gphi,GDIMS,phi,PDIMS,DIMS,hx,hy,hz,
     &                       bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      integer g_lo_1, g_lo_2, g_lo_3
      integer g_hi_1, g_hi_2, g_hi_3
      integer p_lo_1, p_lo_2, p_lo_3
      integer p_hi_1, p_hi_2, p_hi_3
      REAL_T  gphi(g_lo_1:g_hi_1,g_lo_2:g_hi_2,g_lo_3:g_hi_3,3)
      REAL_T   phi(p_lo_1:p_hi_1,p_lo_2:p_hi_2,p_lo_3:p_hi_3)
      REAL_T  hx
      REAL_T  hy
      REAL_T  hz
      integer bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi
      
c     Local variables
      integer i, j, k,n

      do k = lo_3,hi_3
         do j = lo_2,hi_2
            do i = lo_1,hi_1
               
               gphi(i,j,k,1) = fourth*(phi(i+1,j,k  ) + phi(i+1,j+1,k  ) +
     $              phi(i+1,j,k+1) + phi(i+1,j+1,k+1) -
     $              phi(i  ,j,k  ) - phi(i  ,j+1,k  ) -
     $              phi(i  ,j,k+1) - phi(i  ,j+1,k+1) ) /hx
               
               gphi(i,j,k,2) = fourth*(phi(i,j+1,k  ) + phi(i+1,j+1,k  ) +
     $              phi(i,j+1,k+1) + phi(i+1,j+1,k+1) -
     $              phi(i,j  ,k  ) - phi(i+1,j  ,k  ) -
     $              phi(i,j  ,k+1) - phi(i+1,j  ,k+1) ) /hy
               
               gphi(i,j,k,3) = fourth*(phi(i,j  ,k+1) + phi(i+1,j  ,k+1) + 
     $              phi(i,j+1,k+1) + phi(i+1,j+1,k+1) -
     $              phi(i,j  ,k  ) - phi(i+1,j  ,k  ) -
     $              phi(i,j+1,k  ) - phi(i+1,j+1,k  ) ) /hz
            enddo
         enddo
      enddo

      if (g_lo_1 .le. lo_1-1 .and. g_hi_1 .ge. hi_1+1) then
         if (bcx_lo .eq. PERIODIC) then
            do k = lo_3,hi_3
            do j = lo_2,hi_2
               gphi(lo_1-1,j,k,1) = gphi(hi_1,j,k,1)
               gphi(lo_1-1,j,k,2) = gphi(hi_1,j,k,2)
               gphi(lo_1-1,j,k,3) = gphi(hi_1,j,k,3)
            enddo
            enddo
         endif
         if (bcx_hi .eq. PERIODIC) then
            do k = lo_3,hi_3
            do j = lo_2,hi_2
               gphi(hi_1+1,j,k,1) = gphi(lo_1,j,k,1)
               gphi(hi_1+1,j,k,2) = gphi(lo_1,j,k,2)
               gphi(hi_1+1,j,k,3) = gphi(lo_1,j,k,3)
            enddo
            enddo
         endif
      endif

      if (g_lo_2 .le. lo_2-1 .and. g_hi_2 .ge. hi_2+1) then
          if (bcy_lo .eq. PERIODIC) then
            do k = lo_3,hi_3
            do i = lo_1,hi_1
                gphi(i,lo_2-1,k,1) = gphi(i,hi_2,k,1)
                gphi(i,lo_2-1,k,2) = gphi(i,hi_2,k,2)
                gphi(i,lo_2-1,k,3) = gphi(i,hi_2,k,3)
            enddo
            enddo
          endif
          if (bcy_hi .eq. PERIODIC) then
            do k = lo_3,hi_3
            do i = lo_1,hi_1
                gphi(i,hi_2+1,k,1) = gphi(i,lo_2,k,1)
                gphi(i,hi_2+1,k,2) = gphi(i,lo_2,k,2)
                gphi(i,hi_2+1,k,3) = gphi(i,lo_2,k,3)
            enddo
            enddo
          endif
       endif

      if (g_lo_3 .le. lo_3-1 .and. g_hi_3 .ge. hi_3+1) then
          if (bcz_lo .eq. PERIODIC) then
            do j = lo_2,hi_2
            do i = lo_1,hi_1
                gphi(i,j,lo_3-1,1) = gphi(i,j,hi_3,1)
                gphi(i,j,lo_3-1,2) = gphi(i,j,hi_3,2)
                gphi(i,j,lo_3-1,3) = gphi(i,j,hi_3,3)
            enddo
            enddo
          endif
          if (bcz_hi .eq. PERIODIC) then
            do j = lo_2,hi_2
            do i = lo_1,hi_1
                gphi(i,j,hi_3+1,1) = gphi(i,j,lo_3,1)
                gphi(i,j,hi_3+1,2) = gphi(i,j,lo_3,2)
                gphi(i,j,hi_3+1,3) = gphi(i,j,lo_3,3)
            enddo
            enddo
          endif
       endif

      if (g_lo_1 .le. lo_1-1 .and. g_hi_1 .ge. hi_1+1 .and.
     &    g_lo_2 .le. lo_2-1 .and. g_hi_2 .ge. hi_2+1) then
         if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC) then
            do n=1,3
               do k = lo_3,hi_3
                  gphi(lo_1-1,lo_2-1,k,n) = gphi(hi_1,hi_2,k,n)
                  gphi(hi_1+1,lo_2-1,k,n) = gphi(lo_1,hi_2,k,n)
                  gphi(lo_1-1,hi_2+1,k,n) = gphi(hi_1,lo_2,k,n)
                  gphi(hi_1+1,hi_2+1,k,n) = gphi(lo_1,lo_2,k,n)
               enddo
            enddo
         endif
      endif
      
      if (g_lo_1 .le. lo_1-1 .and. g_hi_1 .ge. hi_1+1 .and.
     &     g_lo_3 .le. lo_3-1 .and. g_hi_3 .ge. hi_3+1) then
         if (bcx_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
            do n= 1,3
               do j = lo_2,hi_2
                  gphi(lo_1-1,j,lo_3-1,n) = gphi(hi_1,j,hi_3,n)
                  gphi(hi_1+1,j,lo_3-1,n) = gphi(lo_1,j,hi_3,n)
                  gphi(lo_1-1,j,hi_3+1,n) = gphi(hi_1,j,lo_3,n)
                  gphi(hi_1+1,j,hi_3+1,n) = gphi(lo_1,j,lo_3,n)
               enddo
            enddo
         endif
      endif
      
      if (g_lo_2 .le. lo_2-1 .and. g_hi_2 .ge. hi_2+1 .and.
     &     g_lo_3 .le. lo_3-1 .and. g_hi_3 .ge. hi_3+1) then
         if (bcy_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
            do n= 1,3
               do i = lo_1,hi_1
                  gphi(i,lo_2-1,lo_3-1,n) = gphi(i,hi_2,hi_3,n)
                  gphi(i,hi_2+1,lo_3-1,n) = gphi(i,lo_2,hi_3,n)
                  gphi(i,lo_2-1,hi_3+1,n) = gphi(i,hi_2,lo_3,n)
                  gphi(i,hi_2+1,hi_3+1,n) = gphi(i,lo_2,lo_3,n)
               enddo
            enddo
         endif
      endif
      
      if (g_lo_1 .le. lo_1-1 .and. g_hi_1 .ge. hi_1+1 .and.
     &     g_lo_2 .le. lo_2-1 .and. g_hi_2 .ge. hi_2+1 .and.
     &     g_lo_3 .le. lo_3-1 .and. g_hi_3 .ge. hi_3+1) then
         if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC 
     &        .and. bcz_lo .eq. PERIODIC) then
            do n=1,3
               gphi(lo_2-1,lo_2-1,lo_3-1,n) = gphi(hi_1,hi_2,hi_3,n)
               gphi(lo_2-1,hi_2+1,lo_3-1,n) = gphi(hi_1,lo_2,hi_3,n)
               gphi(lo_2-1,lo_2-1,hi_3+1,n) = gphi(hi_1,hi_2,lo_3,n)
               gphi(lo_2-1,hi_2+1,hi_3+1,n) = gphi(hi_1,lo_2,lo_3,n)
               gphi(hi_2+1,lo_2-1,lo_3-1,n) = gphi(lo_1,hi_2,hi_3,n)
               gphi(hi_2+1,hi_2+1,lo_3-1,n) = gphi(lo_1,lo_2,hi_3,n)
               gphi(hi_2+1,lo_2-1,hi_3+1,n) = gphi(lo_1,hi_2,lo_3,n)
               gphi(hi_2+1,hi_2+1,hi_3+1,n) = gphi(lo_1,lo_2,lo_3,n)
            enddo
         endif
      endif

      return
      end

c *************************************************************************
c ** RHSHG **
c ** Compute the right-hand-side D(V) for the projection
c *************************************************************************

      subroutine FORT_RHSHG(du,u,divu_src,DIMS,hx,hy,hz,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,
     $                      norm,time,dt,un,ustar)

      implicit none

      integer DIMS
      REAL_T        du(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  divu_src(lo_1  :hi_1+1,lo_2  :hi_2+1,lo_3  :hi_3+1)
      REAL_T         u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  hx
      REAL_T  hy
      REAL_T  hz
      REAL_T  time
      REAL_T  dt
      REAL_T     un(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  ustar(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T fac,facx,facy,facz,norm
      REAL_T factor, sum_src, sum_fac
      integer i, j, k, n
      integer is,ie,js,je,ks,ke
      integer istrt,iend
      integer jstrt,jend
      integer kstrt,kend
      logical is_singular

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      is_singular = .true.
      if (BCX_LO .eq. OUTLET .or. BCX_HI .eq. OUTLET .or.
     $    BCY_LO .eq. OUTLET .or. BCY_HI .eq. OUTLET .or.
     $    BCZ_LO .eq. OUTLET .or. BCZ_HI .eq. OUTLET) is_singular = .false.


c note: originally, we set inflow bc here, but this was found to be
c  redundant, so it was deleted

      if (bcx_lo .eq. PERIODIC) then
        do n = 1,3
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k,n) = u(ie,j,k,n)
        enddo
        enddo
        enddo

      else if (bcx_lo .eq. WALL) then

        do n = 1,3
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k,n) = zero
        enddo
        enddo
        enddo

      endif

      if (bcx_hi .eq. PERIODIC) then
        do n = 1,3
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k,n) = u(is,j,k,n)
        enddo
        enddo
        enddo

      else if (bcx_hi .eq. WALL) then

        do n = 1,3
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k,n) = zero
        enddo
        enddo
        enddo

      endif

      if (bcy_lo .eq. PERIODIC) then
        do n = 1,3
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,js-1,k,n) = u(i,je,k,n)
        enddo
        enddo
        enddo

      else if (bcy_lo .eq. WALL) then

        do n = 1,3
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,js-1,k,n) = zero
        enddo
        enddo
        enddo

      endif

      if (bcy_hi .eq. PERIODIC) then
        do n = 1,3
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,je+1,k,n) = u(i,js,k,n)
        enddo
        enddo
        enddo

      else if (bcy_hi .eq. WALL) then

        do n = 1,3
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,je+1,k,n) = zero
        enddo
        enddo
        enddo

      endif

      if (bcz_lo .eq. PERIODIC) then

        do n = 1,3
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ks-1,n) = u(i,j,ke,n)
        enddo
        enddo
        enddo

      else if (bcz_lo .eq. WALL) then

        do n = 1,3
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ks-1,n) = zero
        enddo
        enddo
        enddo

      endif

      if (bcz_hi .eq. PERIODIC) then

        do n = 1,3
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ke+1,n) = u(i,j,ks,n)
        enddo
        enddo
        enddo

      else if (bcz_hi .eq. WALL) then

        do n = 1,3
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ke+1,n) = zero
        enddo
        enddo
        enddo

      endif
 
      facx = fourth / hx
      facy = fourth / hx
      facz = fourth / hx

      do k = kstrt,kend 
      do j = jstrt,jend 
      do i = istrt,iend 
          du(i,j,k) = ((u(i  ,j-1,k  ,1) + u(i  ,j,k  ,1) +
     $                  u(i  ,j-1,k-1,1) + u(i  ,j,k-1,1)) - 
     $                 (u(i-1,j-1,k  ,1) + u(i-1,j,k  ,1)  +
     $                  u(i-1,j-1,k-1,1) + u(i-1,j,k-1,1)) ) * facx
     $              + ((u(i-1,j  ,k  ,2) + u(i,j  ,k  ,2) +
     $                  u(i-1,j  ,k-1,2) + u(i,j  ,k-1,2)) - 
     $                 (u(i-1,j-1,k  ,2) + u(i,j-1,k  ,2) +
     $                  u(i-1,j-1,k-1,2) + u(i,j-1,k-1,2)) ) * facy
     $              + ((u(i-1,j  ,k  ,3) + u(i,j  ,k  ,3) +
     $                  u(i-1,j-1,k  ,3) + u(i,j-1,k  ,3)) - 
     $                 (u(i-1,j  ,k-1,3) + u(i,j  ,k-1,3) +
     $                  u(i-1,j-1,k-1,3) + u(i,j-1,k-1,3)) ) * facz

          du(i,j,k) = du(i,j,k) - divu_src(i,j,k)

      enddo
      enddo
      enddo

      norm = zero

      do k = kstrt,kend 
      do j = jstrt,jend 
      do i = istrt,iend 
        
         fac = one
         fac = cvmgt(two*fac,fac,(i .eq. is  ) .and. bcx_lo .eq. WALL)
         fac = cvmgt(two*fac,fac,(i .eq. ie+1) .and. bcx_hi .eq. WALL)
         fac = cvmgt(two*fac,fac,(j .eq. js  ) .and. bcy_lo .eq. WALL)
         fac = cvmgt(two*fac,fac,(j .eq. je+1) .and. bcy_hi .eq. WALL)
         fac = cvmgt(two*fac,fac,(k .eq. ks  ) .and. bcz_lo .eq. WALL)
         fac = cvmgt(two*fac,fac,(k .eq. ke+1) .and. bcz_hi .eq. WALL)

         du(i,j,k) = du(i,j,k) * fac

      enddo
      enddo
      enddo

      if (is_singular) then
        sum_src  = zero
        sum_fac  = zero
        do k = kstrt, kend 
        do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(half*factor,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(half*factor,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(half*factor,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          sum_src = sum_src + factor * du(i,j,k)
          sum_fac = sum_fac + factor
        enddo
        enddo
        enddo

        sum_src = sum_src / sum_fac

c       write(6,999) sum_src

        do k = kstrt, kend 
        do j = jstrt, jend 
        do i = istrt, iend 
          du(i,j,k) = du(i,j,k) - sum_src
          norm = max(norm, abs(du(i,j,k)))
        enddo
        enddo
        enddo
      endif

 999  format('Singular adjustment is ',e12.5)

      return
      end

c *************************************************************************
c ** PROJUHG **
c ** Define the updated pressure and vector field
c *************************************************************************

      subroutine FORT_PROJUHG(u,pressure,phi,gradphi,rhonph,DIMS)

      implicit none

      integer DIMS
      REAL_T         u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  pressure(lo_1  :hi_1+1,lo_2  :hi_2+1,lo_3  :hi_3+1)
      REAL_T       phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T   gradphi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T    rhonph(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)

c     Local variables
      integer i, j, k

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          u(i,j,k,1) = u(i,j,k,1) - gradphi(i,j,k,1)/rhonph(i,j,k)
          u(i,j,k,2) = u(i,j,k,2) - gradphi(i,j,k,2)/rhonph(i,j,k)
          u(i,j,k,3) = u(i,j,k,3) - gradphi(i,j,k,3)/rhonph(i,j,k)
        enddo
      enddo
      enddo

      do k = lo_3,hi_3+1
      do j = lo_2,hi_2+1
        do i = lo_1,hi_1+1 
c          pressure(i,j,k) = pressure(i,j,k) + phi(i,j,k)
           pressure(i,j,k) = phi(i,j,k)
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D(sig G(phi))
c *************************************************************************

      subroutine FORT_RESIDUAL(residual,phi,source,coeff,dgphi,
     $                         DIMS,hx,hy,hz,resnorm,
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T  residual(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T       phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T    source(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T     coeff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     dgphi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  hx
      REAL_T  hy
      REAL_T  hz
      REAL_T  resnorm
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i,j,k
      integer istrt,jstrt,kstrt
      integer iend,jend,kend

      resnorm = zero

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      call makedgphi(phi,dgphi,coeff,DIMS,hx,hy,hz,
     $               bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      do k = kstrt,kend
      do j = jstrt,jend
        do i = istrt,iend
          residual(i,j,k) = source(i,j,k) - dgphi(i,j,k)
        enddo
      enddo
      enddo

      do k = kstrt,kend 
      do j = jstrt,jend 
        do i = istrt,iend 
          resnorm = max(resnorm,abs(residual(i,j,k)))
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** RELAX **
c ** Gauss-Seidel relaxation
c *************************************************************************

      subroutine FORT_RELAX(phi,source,coeff,dgphi,DIMS,hx,hy,hz,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,nnrelax)

      implicit none

      integer DIMS
      REAL_T     phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  source(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T   coeff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T   dgphi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      integer nnrelax

c     Local variables
      REAL_T  facx, facy, facz
      REAL_T  rfac
      integer i,j,k
      integer iter, ioff, iinc
      integer is,ie,js,je,ks,ke
      integer istrt, jstrt, kstrt
      integer iend, jend, kend

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      facx = one/(hx*hx)
      facy = one/(hy*hy)
      facz = one/(hz*hz)

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      do iter = 1, nnrelax 
c      do ioff = 0,1

          if (bcx_lo .eq. PERIODIC) then
            do k = ks-1,ke+2
            do j = js-1,je+2
              phi(ie+1,j,k) = phi(is  ,j,k)
              phi(ie+2,j,k) = phi(is+1,j,k)
              phi(is-1,j,k) = phi(ie  ,j,k)
            enddo
            enddo
          endif

          if (bcy_lo .eq. PERIODIC) then
            do k = ks-1,ke+2
            do i = is-1,ie+2
              phi(i,je+1,k) = phi(i,js  ,k)
              phi(i,je+2,k) = phi(i,js+1,k)
              phi(i,js-1,k) = phi(i,je  ,k)
            enddo
            enddo
          endif

          if (bcz_lo .eq. PERIODIC) then
            do j = js-1,je+2
            do i = is-1,ie+2
              phi(i,j,ke+1) = phi(i,j,ks  )
              phi(i,j,ke+2) = phi(i,j,ks+1)
              phi(i,j,ks-1) = phi(i,j,ke  )
            enddo
            enddo
          endif

c         call makedgphi(phi,dgphi,coeff,DIMS,hx,hy,hz,
c    $                   bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

          do k = kstrt,kend
           do j = jstrt,jend
c           iinc = mod(j+k+ioff,2)
c           do i = istrt+iinc,iend,2
            do i = istrt,iend

              dgphi(i,j,k) = 
     $         (coeff(i  ,j,k,1) * (phi(i+1,j,k) - phi(i,j,k)) +
     $          coeff(i-1,j,k,1) * (phi(i-1,j,k) - phi(i,j,k)) ) * facx +
     $         (coeff(i,j  ,k,2) * (phi(i,j+1,k) - phi(i,j,k)) +
     $          coeff(i,j-1,k,2) * (phi(i,j-1,k) - phi(i,j,k)) ) * facy +
     $         (coeff(i,j,k  ,3) * (phi(i,j,k+1) - phi(i,j,k)) +
     $          coeff(i,j,k-1,3) * (phi(i,j,k-1) - phi(i,j,k)) ) * facz

              rfac =  (coeff(i,j,k,1) + coeff(i-1,j,k,1)) * facx +
     $                (coeff(i,j,k,2) + coeff(i,j-1,k,2)) * facy +
     $                (coeff(i,j,k,3) + coeff(i,j,k-1,3)) * facz 

              if ( (i .eq. is .or. i .eq. ie+1) .and. bcx_lo .ne. PERIODIC) then 
                 dgphi(i,j,k) = two*dgphi(i,j,k)
                 rfac = two * rfac
              endif

              if ( (j .eq. js .or. j .eq. je+1) .and. bcy_lo .ne. PERIODIC) then
                 dgphi(i,j,k) = two*dgphi(i,j,k)
                 rfac = two * rfac
              endif

              if ( (k .eq. ks .or. k .eq. ke+1) .and. bcz_lo .ne. PERIODIC) then
                 dgphi(i,j,k) = two*dgphi(i,j,k)
                 rfac = two * rfac
              endif

              rfac = one/rfac

              phi(i,j,k) = phi(i,j,k) + rfac*(dgphi(i,j,k) - source(i,j,k))

            enddo
           enddo
           if (k .eq. ks+1 .and. bcz_lo .eq. PERIODIC) then
             do j = js-1,je+2
             do i = is-1,ie+2
               phi(i,j,ke+1) = phi(i,j,ks  )
               phi(i,j,ke+2) = phi(i,j,ks+1)
             enddo
             enddo
           endif
          enddo

c      enddo

       if (bcx_lo .eq. PERIODIC) then
        do k = ks-1,ke+2
        do j = js-1,je+2
          phi(ie+1,j,k) = phi(is  ,j,k)
          phi(ie+2,j,k) = phi(is+1,j,k)
          phi(is-1,j,k) = phi(ie  ,j,k)
        enddo
        enddo
       endif

       if (bcy_lo .eq. PERIODIC) then
        do k = ks-1,ke+2
        do i = is-1,ie+2
          phi(i,je+1,k) = phi(i,js  ,k)
          phi(i,je+2,k) = phi(i,js+1,k)
          phi(i,js-1,k) = phi(i,je  ,k)
        enddo
        enddo
       endif

       if (bcz_lo .eq. PERIODIC) then
        do j = js-1,je+2
        do i = is-1,ie+2
          phi(i,j,ke+1) = phi(i,j,ks  )
          phi(i,j,ke+2) = phi(i,j,ks+1)
          phi(i,j,ks-1) = phi(i,j,ke  )
        enddo
        enddo
       endif

      enddo

      return
      end

c *************************************************************************
c ** COARSIG **
c ** Coarsening of the sig coefficients
c *************************************************************************

      subroutine FORT_COARSIG(sig,sigc,DIMS,CDIMS,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T  sig(lo_1 -1:hi_1 +1,lo_2 -1:hi_2 +1,lo_3 -1:hi_3 +1)
      REAL_T sigc(loc_1-1:hic_1+1,loc_2-1:hic_2+1,loc_3-1:hic_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i ,j, k
      integer i2,j2,k2

      do k = loc_3,hic_3 
      do j = loc_2,hic_2 
        do i = loc_1,hic_1 
          i2 = 2*(i-loc_1)+lo_1
          j2 = 2*(j-loc_2)+lo_2
          k2 = 2*(k-loc_3)+lo_3
          sigc(i,j,k) = ( sig(i2  ,j2,k2  ) + sig(i2  ,j2+1,k2  )+ 
     $                    sig(i2+1,j2,k2  ) + sig(i2+1,j2+1,k2  )+
     $                    sig(i2  ,j2,k2+1) + sig(i2  ,j2+1,k2+1)+
     $                    sig(i2+1,j2,k2+1) + sig(i2+1,j2+1,k2+1) ) * eighth

        enddo
      enddo
      enddo

      if (bcx_lo .eq. PERIODIC) then

        do k = loc_3-1,hic_3+1 
        do j = loc_2-1,hic_2+1 
          sigc(loc_1-1,j,k) = sigc(hic_1,j,k)
          sigc(hic_1+1,j,k) = sigc(loc_1,j,k)
        enddo
        enddo

      endif

      if (bcy_lo .eq. PERIODIC) then

        do k = loc_3-1,hic_3+1 
        do i = loc_1-1,hic_1+1 
          sigc(i,loc_2-1,k) = sigc(i,hic_2,k)
          sigc(i,hic_2+1,k) = sigc(i,loc_2,k)
        enddo
        enddo

      endif

      if (bcz_lo .eq. PERIODIC) then

        do j = loc_2-1,hic_2+1 
        do i = loc_1-1,hic_1+1 
          sigc(i,j,loc_3-1) = sigc(i,j,hic_3)
          sigc(i,j,hic_3+1) = sigc(i,j,loc_3)
        enddo
        enddo

      endif

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T   res(lo_1 -1:hi_1 +2,lo_2 -1:hi_2 +2,lo_3 -1:hi_3 +2)
      REAL_T  resc(loc_1-1:hic_1+2,loc_2-1:hic_2+2,loc_3-1:hic_3+2)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i,j,k,ii,jj,kk
      integer istrt,jstrt,kstrt
      integer iend,jend,kend
      REAL_T cen, faces, sides, corners

      istrt = cvmgt(loc_1+1,loc_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hic_1  ,hic_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(loc_2+1,loc_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hic_2  ,hic_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(loc_3+1,loc_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hic_3  ,hic_3+1,BCZ_HI .eq. OUTLET)

      if (bcx_lo .eq. PERIODIC) then
        do k = lo_3-1,hi_3+2
        do j = lo_2-1,hi_2+2
          res(hi_1+1,j,k) = res(lo_1  ,j,k)
          res(hi_1+2,j,k) = res(lo_1+1,j,k)
          res(lo_1-1,j,k) = res(hi_1  ,j,k)
        enddo
        enddo
      else 
        do k = lo_3-1,hi_3+2
        do j = lo_2-1,hi_2+2
          res(hi_1+2,j,k) = res(hi_1  ,j,k)
          res(lo_1-1,j,k) = res(lo_1+1,j,k)
        enddo
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do k = lo_3-1,hi_3+2
        do i = lo_1-1,hi_1+2
          res(i,hi_2+1,k) = res(i,lo_2  ,k)
          res(i,hi_2+2,k) = res(i,lo_2+1,k)
          res(i,lo_2-1,k) = res(i,hi_2  ,k)
        enddo
        enddo
      else
        do k = lo_3-1,hi_3+2
        do i = lo_1-1,hi_1+2
          res(i,hi_2+2,k) = res(i,hi_2  ,k)
          res(i,lo_2-1,k) = res(i,lo_2+1,k)
        enddo
        enddo
      endif

      if (bcz_lo .eq. PERIODIC) then
        do j = lo_2-1,hi_2+2
        do i = lo_1-1,hi_1+2
          res(i,j,hi_3+1) = res(i,j,lo_3  )
          res(i,j,hi_3+2) = res(i,j,lo_3+1)
          res(i,j,lo_3-1) = res(i,j,hi_3  )
        enddo
        enddo
      else
        do j = lo_2-1,hi_2+2
        do i = lo_1-1,hi_1+2
          res(i,j,hi_3+2) = res(i,j,hi_3  )
          res(i,j,lo_3-1) = res(i,j,lo_3+1)
        enddo
        enddo
      endif

      do k = kstrt,kend
      do j = jstrt,jend
      do i = istrt,iend

          ii = 2*(i-loc_1)+lo_1
          jj = 2*(j-loc_2)+lo_2
          kk = 2*(k-loc_3)+lo_3

          cen = res(ii,jj,kk)

          faces = res(ii+1,jj,kk) + res(ii-1,jj,kk) +
     $            res(ii,jj+1,kk) + res(ii,jj-1,kk) +
     $            res(ii,jj,kk+1) + res(ii,jj,kk-1)

          sides = res(ii+1,jj+1,kk) + res(ii-1,jj+1,kk) +
     $            res(ii+1,jj-1,kk) + res(ii-1,jj-1,kk) +
     $            res(ii+1,jj,kk+1) + res(ii-1,jj,kk+1) +
     $            res(ii+1,jj,kk-1) + res(ii-1,jj,kk-1) +
     $            res(ii,jj+1,kk+1) + res(ii,jj-1,kk+1) +
     $            res(ii,jj+1,kk-1) + res(ii,jj-1,kk-1)

          corners = res(ii+1,jj+1,kk+1) + res(ii-1,jj+1,kk+1) +
     $              res(ii+1,jj-1,kk+1) + res(ii-1,jj-1,kk+1) +
     $              res(ii+1,jj+1,kk-1) + res(ii-1,jj+1,kk-1) +
     $              res(ii+1,jj-1,kk-1) + res(ii-1,jj-1,kk-1)

          resc(i,j,k) = eighth * (cen + half   * faces + 
     $                                  fourth * sides + 
     $                                  eighth * corners)

      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERP **
c ** Simple bilinear interpolation
c *************************************************************************

      subroutine FORT_INTERP(phi,deltac,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T     phi(lo_1 -1:hi_1 +2,lo_2 -1:hi_2 +2,lo_3 -1:hi_3 +2)
      REAL_T  deltac(loc_1-1:hic_1+2,loc_2-1:hic_2+2,loc_3-1:hic_3+2)

c     Local variables
      integer i,j,k,ii,jj,kk
      integer is,ie,js,je,ks,ke,isc,iec,jsc,jec,ksc,kec

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

      isc = loc_1
      jsc = loc_2
      ksc = loc_3
      iec = hic_1
      jec = hic_2
      kec = hic_3

      do k = ksc, kec+1 
      do j = jsc, jec+1 
      do i = isc, iec+1

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii,jj,kk) = deltac(i,j,k)

      enddo
      enddo
      enddo

      do k = ksc, kec+1
      do j = jsc, jec
      do i = isc, iec+1

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii,jj+1,kk) = half*(deltac(i,j,k) + deltac(i,j+1,k)) 

      enddo
      enddo
      enddo

      do j = jsc, jec+1 
      do k = ksc, kec+1
      do i = isc, iec

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii+1,jj,kk) = half*(deltac(i,j,k) + deltac(i+1,j,k))

      enddo
      enddo
      enddo

      do j = jsc, jec+1 
      do i = isc, iec+1
      do k = ksc, kec

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii,jj,kk+1) = half*(deltac(i,j,k) + deltac(i,j,k+1))

      enddo
      enddo
      enddo

      do k = ksc, kec+1
      do j = jsc, jec 
      do i = isc, iec 

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii+1,jj+1,kk) = fourth*(deltac(i,j  ,k) + deltac(i+1,j  ,k) + 
     $                                deltac(i,j+1,k) + deltac(i+1,j+1,k) )
      enddo
      enddo
      enddo

      do j = jsc, jec+1 
      do k = ksc, kec
      do i = isc, iec 

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii+1,jj,kk+1) = fourth*(deltac(i,j,k  ) + deltac(i+1,j,k  ) + 
     $                                deltac(i,j,k+1) + deltac(i+1,j,k+1) )
      enddo
      enddo
      enddo

      do j = jsc, jec 
      do k = ksc, kec
      do i = isc, iec+1 

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii,jj+1,kk+1) = fourth*(deltac(i,j,k  ) + deltac(i,j+1,k  ) + 
     $                                deltac(i,j,k+1) + deltac(i,j+1,k+1) )
      enddo
      enddo
      enddo


      do j = jsc, jec
      do k = ksc, kec
      do i = isc, iec 

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js
          kk = 2*(k-ksc)+ks

          phi(ii+1,jj+1,kk+1) = eighth*(deltac(i,j  ,k  ) + deltac(i+1,j  ,k  ) + 
     $                                  deltac(i,j  ,k+1) + deltac(i+1,j  ,k+1) +
     $                                  deltac(i,j+1,k  ) + deltac(i+1,j+1,k  ) +
     $                                  deltac(i,j+1,k+1) + deltac(i+1,j+1,k+1) )
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** MAKEDGPHI **
c ** Compute D(sig G(phi))
c *************************************************************************

      subroutine makedgphi(phi,dgphi,coeff,DIMS,hx,hy,hz,
     $                     bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T    phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  dgphi(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  coeff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  hx
      REAL_T  hy
      REAL_T  hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T facx, facy, facz
      integer is,ie,js,je,ks,ke
      integer i,j,k

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

      if (bcx_lo .eq. PERIODIC) then
        do k = ks,ke+1 
        do j = js,je+1 
          phi(ie+2,j,k) = phi(is+1,j,k)
          phi(is-1,j,k) = phi(ie  ,j,k)
        enddo
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do k = ks,ke+1 
        do i = is,ie+1 
          phi(i,je+2,k) = phi(i,js+1,k)
          phi(i,js-1,k) = phi(i,je  ,k)
        enddo
        enddo
      endif

      if (bcz_lo .eq. PERIODIC) then
        do j = js,je+1 
        do i = is,ie+1 
          phi(i,j,ke+2) = phi(i,j,ks+1)
          phi(i,j,ks-1) = phi(i,j,ke  )
        enddo
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC) then
        do k = ks,ke+1
          phi(is-1,js-1,k) = phi(ie,je,k)
          phi(is-1,je+2,k) = phi(ie,js+1,k)
          phi(ie+2,js-1,k) = phi(is+1,je,k)
          phi(ie+2,je+2,k) = phi(is+1,js+1,k)
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
        do j = js,je+1
          phi(is-1,j,ks-1) = phi(ie,j,ke)
          phi(is-1,j,ke+2) = phi(ie,j,ks+1)
          phi(ie+2,j,ks-1) = phi(is+1,j,ke)
          phi(ie+2,j,ke+2) = phi(is+1,j,ks+1)
        enddo
      endif

      if (bcy_lo .eq. PERIODIC .and. bcz_lo .eq. PERIODIC) then
        do i = is,ie+1
          phi(i,js-1,ks-1) = phi(i,je,ke)
          phi(i,js-1,ke+2) = phi(i,je,ks+1)
          phi(i,je+2,ks-1) = phi(i,js+1,ke)
          phi(i,je+2,ke+2) = phi(i,js+1,ks+1)
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC 
     &     .and. bcz_lo .eq. PERIODIC) then
          phi(is-1,js-1,ks-1) = phi(ie  ,je  ,ke)
          phi(ie+2,js-1,ks-1) = phi(is+1,je  ,ke)
          phi(is-1,je+2,ks-1) = phi(ie  ,js+1,ke)
          phi(ie+2,je+2,ks-1) = phi(is+1,js+1,ke)
          phi(is-1,js-1,ke+2) = phi(ie  ,je  ,ks+1)
          phi(ie+2,js-1,ke+2) = phi(is+1,je  ,ks+1)
          phi(is-1,je+2,ke+2) = phi(ie  ,js+1,ks+1)
          phi(ie+2,je+2,ke+2) = phi(is+1,js+1,ks+1)
      endif

      facx = one / (hx*hx)
      facy = one / (hy*hy)
      facz = one / (hz*hz)

      do k = ks,ke+1
      do j = js,je+1
        do i = is,ie+1

            dgphi(i,j,k) = 
     $         (coeff(i  ,j,k,1) * (phi(i+1,j,k) - phi(i,j,k)) +
     $          coeff(i-1,j,k,1) * (phi(i-1,j,k) - phi(i,j,k)) ) * facx +
     $         (coeff(i,j  ,k,2) * (phi(i,j+1,k) - phi(i,j,k)) +
     $          coeff(i,j-1,k,2) * (phi(i,j-1,k) - phi(i,j,k)) ) * facy +
     $         (coeff(i,j,k  ,3) * (phi(i,j,k+1) - phi(i,j,k)) +
     $          coeff(i,j,k-1,3) * (phi(i,j,k-1) - phi(i,j,k)) ) * facz
        enddo
      enddo
      enddo

      if (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) then
         do k = ks,ke+1 
         do j = js,je+1
            dgphi(is  ,j,k) = two * dgphi(is  ,j,k)
         enddo
         enddo
      else if (bcx_lo .eq. OUTLET) then
         do k = ks,ke+1 
         do j = js,je+1
            dgphi(is  ,j,k) = zero
         enddo
         enddo
      endif

      if (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) then
         do k = ks,ke+1 
         do j = js,je+1
            dgphi(ie+1,j,k) = two * dgphi(ie+1,j,k)
         enddo
         enddo
      else if (bcx_hi .eq. OUTLET) then
         do k = ks,ke+1 
         do j = js,je+1
            dgphi(ie+1,j,k) = zero
         enddo
         enddo
      endif

      if (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) then
         do k = ks,ke+1 
         do i = is,ie+1
            dgphi(i,js  ,k) = two * dgphi(i,js  ,k) 
         enddo
         enddo
      else if (bcy_lo .eq. OUTLET) then
         do k = ks,ke+1 
         do i = is,ie+1
            dgphi(i,js  ,k) = zero
         enddo
         enddo
      endif

      if (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) then
         do k = ks,ke+1 
         do i = is,ie+1
            dgphi(i,je+1,k) = two * dgphi(i,je+1,k) 
         enddo
         enddo
      else if (bcy_hi .eq. OUTLET) then
         do k = ks,ke+1 
         do i = is,ie+1
            dgphi(i,je+1,k) = zero
         enddo
         enddo
      endif

      if (bcz_lo .eq. WALL .or. bcz_lo .eq. INLET) then
         do j = js,je+1 
         do i = is,ie+1
            dgphi(i,j,ks  ) = two * dgphi(i,j,ks  ) 
         enddo
         enddo
      else if (bcz_lo .eq. OUTLET) then
         do j = js,je+1 
         do i = is,ie+1
            dgphi(i,j,ks  ) = zero
         enddo
         enddo
      endif

      if (bcz_hi .eq. WALL .or. bcz_hi .eq. INLET) then
         do j = js,je+1 
         do i = is,ie+1
            dgphi(i,j,ke+1) = two * dgphi(i,j,ke+1) 
         enddo
         enddo
      else if (bcz_hi .eq. OUTLET) then
         do j = js,je+1 
         do i = is,ie+1
            dgphi(i,j,ke+1) = zero
         enddo
         enddo
      endif

      return
      end

c *************************************************************************
c ** SOLVEHG **
c *************************************************************************

      subroutine FORT_SOLVEHG(dest,dest0,source,coeff,sum,r,w,z,work,
     $                        DIMS,hx,hy,hz,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,
     $                        maxiter,norm,prob_norm)

      implicit none

      integer DIMS
      REAL_T   dest(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  dest0(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T source(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  coeff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T    sum(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T      r(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T      w(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T      z(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T   work(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      integer maxiter
      REAL_T norm
      REAL_T prob_norm
      REAL_T sum0

c     Local variables
      REAL_T  factor
      REAL_T  alpha
      REAL_T  beta
      REAL_T  rho
      REAL_T  rhol
      REAL_T  tol, tolfac
      REAL_T local_norm
      integer i,j,k
      integer iter
      integer istrt,iend
      integer jstrt,jend
      integer kstrt,kend

      tolfac = 1.0d-3

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)
      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      do k = lo_3-1,hi_3+2
      do j = lo_2-1,hi_2+2
         do i = lo_1-1,hi_1+2
            dest0(i,j,k) = dest(i,j,k)
            dest(i,j,k) = zero
         enddo
      enddo
      enddo

  10  call makedgphi(dest0,w,coeff,DIMS,hx,hy,hz,
     $               bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      rho = zero
      norm = zero

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          r(i,j,k) = source(i,j,k) - w(i,j,k)
        enddo
      enddo
      enddo

      local_norm = zero
      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(factor*half,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(factor*half,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(factor*half,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          local_norm  = max(local_norm, abs(r(i,j,k)))
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho    = rho + z(i,j,k) * r(i,j,k) * factor
          norm   = max(norm,abs(r(i,j,k)))
        enddo
      enddo
      enddo

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          work(i,j,k) = zero
          dest(i,j,k) = z(i,j,k)
        enddo
      enddo
      enddo

      iter = 1
c     write(6,1000) iter, norm/prob_norm

100   continue  

      call makedgphi(dest,w,coeff,DIMS,hx,hy,hz,
     $               bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      alpha = zero
      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(factor*half,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(factor*half,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(factor*half,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          alpha  = alpha + dest(i,j,k)*w(i,j,k) * factor
        enddo
      enddo
      enddo

      alpha = rho / alpha
      rhol  = rho
      rho   = zero
      norm  = zero

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          factor = one
          factor = cvmgt(factor*half,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(factor*half,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          factor = cvmgt(factor*half,factor,k.eq.lo_3 .or. k.eq.hi_3+1)
          work(i,j,k) = work(i,j,k) + alpha * dest(i,j,k)
          r(i,j,k) = r(i,j,k) - alpha * w(i,j,k)
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho    = rho + z(i,j,k) * r(i,j,k) * factor
          norm   = max(norm,abs(r(i,j,k)))
        enddo
      enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then

        do k = kstrt, kend 
        do j = jstrt, jend 
          do i = istrt, iend 
            dest(i,j,k) = work(i,j,k) + dest0(i,j,k)
          enddo
        enddo
        enddo

      else if (iter .ge. maxiter  .or.  norm .ge. 100.d0*local_norm) then

        tolfac = 10.d0 * tolfac
        iter = 1
        do k = kstrt, kend 
        do j = jstrt, jend 
          do i = istrt, iend 
            dest(i,j,k) = zero
          enddo
        enddo
        enddo
        goto 10

      else

        beta = rho / rhol
        do k = kstrt, kend 
        do j = jstrt, jend 
          do i = istrt, iend 
            dest(i,j,k) = z(i,j,k) + beta * dest(i,j,k)
          enddo
        enddo
        enddo
        goto 100

      endif

1000  format('Res/Res0 in solve: ',i4,2x,e12.5)

      return
      end

c *************************************************************************
c ** MAKESUM **
c *************************************************************************

      subroutine FORT_MAKESUM(sum,coeff,DIMS,hx,hy,hz,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T    sum(lo_1-1:hi_1+2,lo_2-1:hi_2+2,lo_3-1:hi_3+2)
      REAL_T  coeff(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,3)
      REAL_T  hx
      REAL_T  hy
      REAL_T  hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i, j, k
      integer is, ie, js, je, ks, ke
      integer istrt,iend
      integer jstrt,jend
      integer kstrt,kend
      REAL_T  facx, facy, facz

      facx = one/(hx*hx)
      facy = one/(hy*hy)
      facz = one/(hz*hz)

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

      istrt = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend  = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)

      jstrt = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend  = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      kstrt = cvmgt(lo_3+1,lo_3  ,BCZ_LO .eq. OUTLET)
      kend  = cvmgt(hi_3  ,hi_3+1,BCZ_HI .eq. OUTLET)

      do k = kstrt, kend 
      do j = jstrt, jend 
        do i = istrt, iend 
          sum(i,j,k) = - (
     $                (coeff(i,j,k,1) + coeff(i-1,j,k,1)) * facx +
     $                (coeff(i,j,k,2) + coeff(i,j-1,k,2)) * facy +
     $                (coeff(i,j,k,3) + coeff(i,j,k-1,3)) * facz )
        enddo
      enddo
      enddo

      if (bcx_lo .eq. WALL) then
        do k = kstrt, kend
        do j = jstrt, jend
          sum(is  ,j,k) = two * sum(is  ,j,k)
        enddo
        enddo
      endif
      if (bcx_hi .eq. WALL) then
        do k = kstrt, kend
        do j = jstrt, jend
          sum(ie+1,j,k) = two * sum(ie+1,j,k)
        enddo
        enddo
      endif

      if (bcy_lo .eq. WALL) then
        do k = kstrt, kend
        do i = istrt, iend 
          sum(i,js  ,k) = two * sum(i,js  ,k)
        enddo
        enddo
      endif
      if (bcy_hi .eq. WALL) then
        do k = kstrt, kend
        do i = istrt, iend 
          sum(i,je+1,k) = two * sum(i,je+1,k)
        enddo
        enddo
      endif

      if (bcz_lo .eq. WALL) then
        do j = jstrt, jend
        do i = istrt, iend 
          sum(i,j,ks  ) = two * sum(i,j,ks  )
        enddo
        enddo
      endif
      if (bcz_hi .eq. WALL) then
        do j = jstrt, jend
        do i = istrt, iend 
          sum(i,j,ke+1) = two * sum(i,j,ke+1)
        enddo
        enddo
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: INTERP_2D.F,v 1.23 2002/12/11 20:43:22 almgren Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "INTERP_F.H"
#include <ArrayLim.H>

#define IX_PROJ(A,B) (A+B*iabs(A))/B-iabs(A)
#define SDIM 2


c ::: --------------------------------------------------------------
c ::: nbinterp:  node based bilinear interpolation
c :::
c ::: INPUTS/OUTPUTS
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c :::
c ::: crse         =>  (const)  coarse grid data widened by 1 zone
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c :::
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: num_slp      =>  (const)  number of types of slopes
c :::
c ::: TEMPORARY ARRAYS
c ::: sl           =>  num_slp 1-D slope arrays
c ::: --------------------------------------------------------------
c :::
      subroutine FORT_NBINTERP (crse, DIMS(crse), DIMS(cb),
     $                          fine, DIMS(fine), DIMS(fb),
     $                          lratiox, lratioy, nvar,
     $                          sl, num_slp)

      integer DIMDEC(crse)
      integer DIMDEC(cb)
      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer lratiox, lratioy, nvar
      integer num_slp
      REAL_T  fine(DIMV(fine),nvar)
      REAL_T  crse(DIMV(crse),nvar)
      REAL_T  sl(DIM1(cb),num_slp)

#define  SLX 1
#define  SLY 2
#define  SLXY 3

c ::: local var
      integer lx, ly
      integer i, j, ifn, jfn, n
      integer ilo, ihi, jlo, jhi
      integer jstrtFine, jstopFine, istrtFine, istopFine

      REAL_T fx, fy
      REAL_T RX, RY, RXY
      REAL_T dx0, d0x, dx1
      REAL_T slope

      slope(i,j,n,fx,fy) = crse(i,j,n) +
     &                     fx*sl(i,SLX) + fy*sl(i,SLY) + fx*fy*sl(i,SLXY)

      RX = one/dble(lratiox)
      RY = one/dble(lratioy)
      RXY = RX*RY

c
c     NOTES:
c         1) (i, j) loop over the coarse cells
c         2) ?strtFine and ?stopFine are the beginning and ending fine cell
c            indices corresponding to the current coarse cell.  ?stopFine
c            is restricted for the last coarse cell in each direction since
c            for this cell we only need to do the face and not the fine nodes
c            inside this cell.
c         3) (lx, ly) as well as ?lo and ?hi refer to the fine node indices
c            as an offset from ?strtFine.
c
      do 100 n = 1, nvar
        do 120 j = ARG_L2(cb), ARG_H2(cb)
          jstrtFine = j * lratioy
          jstopFine = jstrtFine + lratioy - 1
          if (j .eq. ARG_H2(cb)) jstopFine = jstrtFine

          jlo = max(ARG_L2(fb),jstrtFine) - jstrtFine
          jhi = min(ARG_H2(fb),jstopFine) - jstrtFine


c
c         ::::: compute slopes :::::
c
c         NOTE: The IF logic in the calculation of the slopes is to
c               prevent stepping out of bounds on the coarse data when
c               computing the slopes on the ARG_H?(cb) cells.  These
c               slopes actually are not used since they are multiplied by
c               zero.
c
          do i = ARG_L1(cb), ARG_H1(cb)
            dx0 = zero
            if (i .NE. ARG_H1(cb)) dx0 = crse(i+1,j,n) - crse(i,j,n)

            d0x = zero
            if (j .NE. ARG_H2(cb)) d0x = crse(i,j+1,n) - crse(i,j,n)

            dx1 = zero
            if (i .NE. ARG_H1(cb) .and. j .NE. ARG_H2(cb))
     $        dx1 = crse(i+1,j+1,n) - crse(i,j+1,n)

            sl(i,SLX) = RX*dx0
            sl(i,SLY) = RY*d0x
            sl(i,SLXY) = RXY*(dx1 - dx0)
          end do

c
c         ::::: compute fine strip of interpolated data
c
          do ly = jlo, jhi
            jfn = lratioy * j + ly
            fy = dble(ly)

            do i = ARG_L1(cb), ARG_H1(cb)
              istrtFine = i * lratiox
              istopFine = istrtFine + lratiox - 1
              if (i .eq. ARG_H1(cb)) istopFine = istrtFine

              ilo = max(ARG_L1(fb),istrtFine) - istrtFine
              ihi = min(ARG_H1(fb),istopFine) - istrtFine

              do lx = ilo, ihi
                ifn = lratiox * i + lx
                fx = dble(lx)

                fine(ifn,jfn,n) = slope(i,j,n,fx,fy)
              end do
            end do
          end do

c       ::::: end of do j
120     continue
c     ::::: end of do n
100   continue

#undef  SLX
#undef  SLY
#undef  SLXY

      end


c ::: 
c ::: --------------------------------------------------------------
c ::: cbinterp:  cell centered bilinear interpolation
c ::: 
c ::: NOTE: it is assumed that the coarse grid array is
c ::: large enough to define interpolated values
c ::: in the region fblo:fbhi on the fine grid
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: DIMS(fine)   =>  (const)  index limits of fine grid
c ::: DIMS(fb)     =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data 
c ::: DIMS(crse)   =>  (const)  index limits of coarse grid
c ::: 
c ::: lratio(2)    =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: 
c ::: TEMPORARY ARRAYS
c ::: slx,sly,slxy =>  1-D slope arrays
c ::: strip        =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_CBINTERP (crse, DIMS(crse), DIMS(cb),
     $                          fine, DIMS(fine), DIMS(fb),
     $		                lratiox, lratioy, nvar,
     $                          sl, num_slp, strip, strip_lo, strip_hi)

      integer DIMDEC(crse)
      integer DIMDEC(cb)
      integer DIMDEC(fine)
      integer DIMDEC(fb)
      integer lratiox, lratioy, nvar
      integer num_slp
      integer strip_lo, strip_hi
      REAL_T  fine(DIMV(fine), nvar)
      REAL_T  crse(DIMV(crse), nvar)
      REAL_T  sl(DIM1(cb),num_slp)
      REAL_T  strip(strip_lo:strip_hi)

#define SLX 1
#define SLY 2
#define SLXY 3

c ::: local var
      integer lx, ly, hratx, hraty, ic, jc, jfn, jfc, i, j, n
      REAL_T x, y, denomx, denomy

      denomx = one/dble(2*lratiox)
      denomy = one/dble(2*lratioy)

      hratx = lratiox/2
      hraty = lratioy/2

      do n = 1, nvar 
         do jc = ARG_L2(cb), ARG_H2(cb)-1 

c ::: first fill a strip that will fit

            do ic = ARG_L1(cb), ARG_H1(cb)-1
               sl(ic,SLX) = crse(ic+1,jc,n)-crse(ic,jc,n)
               sl(ic,SLY) = crse(ic,jc+1,n)-crse(ic,jc,n)
               sl(ic,SLXY) = crse(ic+1,jc+1,n)-crse(ic+1,jc,n)
     $              - crse(ic  ,jc+1,n)+crse(ic  ,jc,n)
            end do

            do ly = 0, lratioy-1 
               jfn = jc*lratioy + ly
               jfc = jfn + hraty
               if (jfc .ge. ARG_L2(fb)  .and.  jfc .le. ARG_H2(fb)) then
                  y = denomy*(two*ly + one)
                  do lx = 0, lratiox-1
                     do ic = ARG_L1(cb), ARG_H1(cb)-1
                        i = ic*lratiox + lx
                        x = denomx*(two*lx + one)
                        strip(i) = crse(ic,jc,n) + x*sl(ic,SLX) +
     $                             y*sl(ic,SLY) + x*y*sl(ic,SLXY)
                     end do
                  end do

c ::: stuff into output array

                  do i = ARG_L1(fb), ARG_H1(fb) 
                     fine(i,jfc,n) = strip(i-hratx)
                  end do
               end if
            end do
         end do
      end do

      end

#undef  SLX
#undef  SLY
#undef  SLXY

c ::: 
c ::: --------------------------------------------------------------
c ::: ccinterp:   conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio(2)    =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: and unrolled
c ::: clo,chi      =>  (const)  one dimensional limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c :::				slopes are to be defined. This is
c :::				the projection of (fblo,fbhi) down
c :::				to the coarse level 
c ::: fslo,fshi    =>  (const)  fine grid index limits where
c :::				slopes are needed.  This is the
c :::				refinement of (cslo,cshi) and
c :::				contains but may not be identical
c :::				to (fblo,fbhi).
c ::: cslope       =>  (modify) temp array coarse grid slopes
c ::: clen         =>  (const)  length of coarse gtid slopes
c ::: fslope       =>  (modify) temp array for fine grid slope
c ::: flen         =>  (const)  length of fine grid slope array
c ::: fdat         =>  (const)  temp array for fine grid data
c ::: limslope     =>  (const)  != 0 => limit slopes
c :::
c ::: NOTE: data must be sent in so that 
c :::	    cslope(1,*) and crse(1,*) are associated with
c :::	    the same cell
c :::
c ::: EXAMPLE:
c ::: Suppose the patch called "fine" has index extent:
c ::: 
c ::: floi1 = 3, fhii1 = 12
c ::: floi2 = 8, fhii2 = 20
c ::: 
c ::: suppose the subergion of this patch that is to be filled 
c ::: by interpolation has index extent:
c ::: 
c ::: fblo(1) = 5, fbhi(1) = 10
c ::: fblo(2) = 13, fbhi(2) = 20
c ::: 
c ::: suppose the refinement ratio is 2
c ::: 
c ::: Then the coarsening of this subregion (to level 0) is
c ::: 
c ::: cb_l1 = 2  cb_h1 = 5         (ncbx = 4)
c ::: cb_l2 = 6  cb_h2 = 10        (ncby = 5)
c ::: 
c ::: In order to compute slopes, we need one extra row of
c ::: coarse grid zones:
c ::: 
c ::: cslo(1) = 1  cshi(1) = 6         (ncsx = 6)
c ::: cslo(2) = 5  cshi(2) = 11        (ncsy = 7)
c ::: 
c ::: This is the size of the coarse grid array of data that filpatch 
c ::: has filled at level 0.
c ::: The "cslope" and "crse" arrays are this size.
c ::: 
c ::: In order to unroll the slope calculation we make these arrays look
c ::: like 1-D arrays.  The mapping from 2-D to 1-D is as fillows:
c ::: 
c ::: The point (cb_l(1),cb_l(2)) -> 1
c ::: The point (cslo(1),cslo(2)) -> clo = 1 - 1 - ncsx = -6
c ::: 
c ::: The point (cb_h1,cb_h2) -> clen = ncby*ncsx - 2 = 5*6-2 = 28
c ::: The point (cshi(1),cshi(2)) -> chi = clo + ncsx*ncsy - 1 
c :::                                    =  -6 +    6*7    - 1 = 35
c ::: 
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |  chi  |  
c :::  11  |   30  |   31  |   32  |   33  |   34  |   35  |   cshi(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |  clen |       |  
c :::  10  |   24  |   25  |   26  |   27  |   28  |   29  |   cb_h(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   9  |   18  |   19  |   20  |   21  |   22  |   23  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   8  |   12  |   13  |   14  |   15  |   16  |   17  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   7  |    6  |    7  |    8  |    9  |   10  |   11  |  
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |       |       |       |       |       |       |  
c :::   6  |    0  |    1  |    2  |    3  |    4  |    5  |   cb_l(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::      |  clo  |       |       |       |       |       |  
c :::   5  |   -6  |   -5  |   -4  |   -3  |   -2  |   -1  |   cslo(2)
c :::      |       |       |       |       |       |       |
c :::      -------------------------------------------------
c :::          1       2       3       4       5       6
c :::               cb_l1                   cb_h1
c :::       cslo(1)                                 cshi(1)
c ::: 
c ::: 
c ::: In the 1-D coordinates:
c :::    ist = 1    = stride in I direction
c :::    jst = 6    = stride in J direction  (ncsx)
c ::: 
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_CCINTERP (fine, DIMS(fine), 
     $                          fb_l1, fb_l2, fb_h1, fb_h2,
     $                          nvar, lratiox, lratioy, crse, clo, chi, 
     $                          cb_l1, cb_l2, cb_h1, cb_h2,
     $		                fslo, fshi, cslope, clen, fslope, fdat,
     $                          flen, voff, bc, limslope,
     $                          fvcx, fvcy, cvcx, cvcy, 
     $                          cmax, cmin, alpha)

      integer DIMDEC(fine)
      integer fslo(2), fshi(2)
      integer fb_l1, fb_l2, fb_h1, fb_h2
      integer cb_l1, cb_l2, cb_h1, cb_h2
      integer clo, chi
      integer lratiox, lratioy, nvar, clen, flen, limslope
      integer bc(2,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 2)
      REAL_T cmax(clo:chi)
      REAL_T cmin(clo:chi)
      REAL_T alpha(clo:chi)
      REAL_T fslope(flen, 2)
      REAL_T fdat(flen)
      REAL_T voff(flen)
      REAL_T fvcx(fb_l1:fb_h1+1)
      REAL_T fvcy(fb_l2:fb_h2+1)
      REAL_T cvcx(cb_l1:cb_h1+1)
      REAL_T cvcy(cb_l2:cb_h2+1)

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer ist, jst
      integer cslo(2),cshi(2)
      REAL_T cen, forw, back, slp, sgn
      REAL_T fcen, ccen
      REAL_T xoff, yoff
      REAL_T corr_fact
      REAL_T orig_corr_fact
      integer ncbx, ncby
      integer ncsx, ncsy
      integer islo, jslo
      integer icc, istart, iend
      logical xok, yok

c ::: helpful statement function
      integer sloc
      sloc(i,j) = clo+i-cslo(1) + ncsx*(j-cslo(2))

      cslo(1) = cb_l1-1
      cslo(2) = cb_l2-1
      cshi(1) = cb_h1+1
      cshi(2) = cb_h2+1
      ncbx = cb_h1-cb_l1+1
      ncby = cb_h2-cb_l2+1
      xok = (ncbx .ge. 2)
      yok = (ncby .ge. 2)
      ncsx = ncbx+2
      ncsy = ncby+2
      ist = 1
      jst = ncsx
      islo = cb_l1-1
      jslo = cb_l2-1

      do i = fb_l1, fb_h1 
         fn = i-fslo(1)+1
         ic = IX_PROJ(i,lratiox)
         fcen = half*(fvcx(i)+fvcx(i+1))
         ccen = half*(cvcx(ic)+cvcx(ic+1))
         voff(fn) = (fcen-ccen)/(cvcx(ic+1)-cvcx(ic))
      end do

c ::: ::::: added to prevent underflow for small crse values
      do n = 1, nvar 
        do i = clo, chi 
          crse(i,n) = cvmgt(crse(i,n),zero,abs(crse(i,n)).gt.1.0D-20)
        end do
      end do

      do 290 n = 1, nvar 

          do i = 1,clen

            alpha(i) = 1.d0

            cmax(i) = crse(i,n)
            cmin(i) = crse(i,n)

            do joff = -jst,jst,jst
            do ioff = -ist,ist,ist
              cmax(i) = max(cmax(i),crse(i+ioff+joff,n))
              cmin(i) = min(cmin(i),crse(i+ioff+joff,n))
            enddo
            enddo

          end do

c ::: ::::: compute slopes in x direction
         if (limslope .ne. 0) then
            do i = 1, clen 
               cen = half*(crse(i+ist,n)-crse(i-ist,n))
               forw = two*(crse(i+ist,n)-crse(i,n))
               back = two*(crse(i,n)-crse(i-ist,n))
               slp  = min(abs(forw),abs(back))
               slp  = cvmgp(slp,zero,forw*back)
               cslope(i,1)=sign(one,cen)*min(slp,abs(cen))
            end do
            if (xok) then
               if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
                  do i = 1, clen, jst 
                     cen  = -sixteen/fifteen*crse(i-ist,n) + half*crse(i,n)
     $                    + two3rd*crse(i+ist,n) - tenth*crse(i+2*ist,n)
                     sgn  = sign(one,cen)
                     forw = two*(crse(i+ist,n)-crse(i,n))
                     back = two*(crse(i,n)-crse(i-ist,n))
                     slp  = min(abs(forw),abs(back))
                     slp  = cvmgp(slp,zero,forw*back)
                     cslope(i,1)=sgn*min(slp,abs(cen))
                  end do
               end if
               if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
                  do i = ncbx, clen, jst 
                     cen = sixteen/fifteen*crse(i+ist,n) - half*crse(i,n)
     $                    - two3rd*crse(i-ist,n) + tenth*crse(i-2*ist,n)
                     sgn  = sign(one,cen)
                     forw = two*(crse(i+ist,n)-crse(i,n))
                     back = two*(crse(i,n)-crse(i-ist,n))
                     slp  = min(abs(forw),abs(back))
                     slp  = cvmgp(slp,zero,forw*back)
                     cslope(i,1)=sgn*min(slp,abs(cen))
                  end do
               end if
            end if
         else
            do i = 1, clen 
               cen = half*(crse(i+ist,n)-crse(i-ist,n))
               cslope(i,1)=cen
            end do
            if (xok) then
               if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
                  do i = 1, clen, jst 
                     cen  = -sixteen/fifteen*crse(i-ist,n) + half*crse(i,n)
     $                    + two3rd*crse(i+ist,n) - tenth*crse(i+2*ist,n)
                     cslope(i,1)=cen
                  end do
               end if
               if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
                  do i = ncbx, clen, jst 
                     cen = sixteen/fifteen*crse(i+ist,n) - half*crse(i,n)
     $                    - two3rd*crse(i-ist,n) + tenth*crse(i-2*ist,n)
                     cslope(i,1)=cen
                  end do
               end if
            end if
         end if

c ::: ::::: compute slopes in y direction
         if (limslope .ne. 0) then
            do i = 1, clen 
               cen  = half*(crse(i+jst,n)-crse(i-jst,n))
               forw = two*(crse(i+jst,n)-crse(i,n))
               back = two*(crse(i,n)-crse(i-jst,n))
               slp  = min(abs(forw),abs(back))
               slp  = cvmgp(slp,zero,forw*back)
               cslope(i,2)=sign(one,cen)*min(slp,abs(cen))
            end do
            if (yok) then
               if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
                  do i = 1, ncbx 
                     cen  = -sixteen/fifteen*crse(i-jst,n) + half*crse(i,n)
     $                    + two3rd*crse(i+jst,n) - tenth*crse(i+2*jst,n)
                     sgn  = sign(one,cen)
                     forw = two*(crse(i+jst,n)-crse(i,n))
                     back = two*(crse(i,n)-crse(i-jst,n))
                     slp  = min(abs(forw),abs(back))
                     slp  = cvmgp(slp,zero,forw*back)
                     cslope(i,2)=sgn*min(slp,abs(cen))
                  end do
               end if
               if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
                  do i = clen-ncbx,clen 
                     cen = sixteen/fifteen*crse(i+jst,n) - half*crse(i,n)
     $                    - two3rd*crse(i-jst,n) + tenth*crse(i-2*jst,n)
                     sgn  = sign(one,cen)
                     forw = two*(crse(i+jst,n)-crse(i,n))
                     back = two*(crse(i,n)-crse(i-jst,n))
                     slp  = min(abs(forw),abs(back))
                     slp  = cvmgp(slp,zero,forw*back)
                     cslope(i,2)=sgn*min(slp,abs(cen))
                  end do
               end if
            end if
         else
            do i = 1, clen 
               cen  = half*(crse(i+jst,n)-crse(i-jst,n))
               cslope(i,2)=cen
            end do
            if (yok) then
               if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
                  do i = 1, ncbx 
                     cen  = -sixteen/fifteen*crse(i-jst,n) + half*crse(i,n)
     $                    + two3rd*crse(i+jst,n) - tenth*crse(i+2*jst,n)
                     cslope(i,2)=cen
                  end do
               end if
               if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
                  do i = clen-ncbx,clen 
                     cen = sixteen/fifteen*crse(i+jst,n) - half*crse(i,n)
     $                    - two3rd*crse(i-jst,n) + tenth*crse(i-2*jst,n)
                     cslope(i,2)=cen
                  end do
               end if
            end if
         end if

         do 360 jc = cb_l2, cb_h2 
c           ::::: strip out a fine grid slope vector
            do 370 ioff = 1, lratiox 
               icc = clo + ist + jst*(jc-jslo)
               istart = ioff
               iend = ioff + (ncbx-1)*lratiox
               do 380 fn = istart, iend, lratiox 
                  fslope(fn,1) = cslope(icc,1)
                  fslope(fn,2) = cslope(icc,2)
                  fdat(fn) = crse(icc,n)
                  icc = icc + ist
380            continue
370         continue

c           Limit slopes so as to not introduce new maxs or mins.
            do 385 joff = 0, lratioy-1 
               j = lratioy*jc + joff
               if ((j.lt.fb_l2).or.(j.gt.fb_h2)) goto 385
               fcen = half*(fvcy(j)+fvcy(j+1))
               ccen = half*(cvcy(jc)+cvcy(jc+1))
               yoff = (fcen-ccen)/(cvcy(jc+1)-cvcy(jc))

               do 387 i = fb_l1, fb_h1 
                  fn = i-fslo(1)+1
                  orig_corr_fact = voff(fn)*fslope(fn,1)
     &                           + yoff    *fslope(fn,2)
                  fine(i,j,n) = fdat(fn) + orig_corr_fact

                  ic = IX_PROJ(i,lratiox)
                  icc = sloc(ic,jc)
                  if ((fine(i,j,n) .gt. cmax(icc)) .and. 
     $                (abs(orig_corr_fact) .gt. 1.e-10*abs(fdat(fn)))) then
                    corr_fact = (cmax(icc) - fdat(fn)) / orig_corr_fact
                    alpha(icc) = min(alpha(icc),corr_fact)
                  endif
                  if ((fine(i,j,n) .lt. cmin(icc)) .and. 
     $                (abs(orig_corr_fact) .gt. 1.e-10*abs(fdat(fn)))) then
                    corr_fact = (cmin(icc) - fdat(fn)) / orig_corr_fact
                    alpha(icc) = min(alpha(icc),corr_fact)
                  endif

#ifndef NDEBUG
                  if (alpha(icc) .lt. 0.d0) then
                    print *,'OOPS - ALPHA SHOULD BE POSITIVE IN CCINTERP '
                    print *,'ICC = ',icc
                    print *,'ALPHA = ',alpha(icc)
                    print *,'ORIG_CORR_FACT = ',orig_corr_fact
                    call bl_abort(" ")
                  endif
                  if (alpha(icc) .gt. 1.d0) then
                    print *,'OOPS - ALPHA SHOULD BE <= 1.0 IN CCINTERP '
                    print *,'ICC = ',icc
                    print *,'ALPHA = ',alpha(icc)
                    print *,'ORIG_CORR_FACT = ',orig_corr_fact
                    call bl_abort(" ")
                  endif
#endif

387            continue
385         continue

c           Now interpolate to fine grid for real.
            do 390 joff = 0, lratioy-1 
               j = lratioy*jc + joff
               if ((j.lt.fb_l2).or.(j.gt.fb_h2)) goto 390
               fcen = half*(fvcy(j)+fvcy(j+1))
               ccen = half*(cvcy(jc)+cvcy(jc+1))
               yoff = (fcen-ccen)/(cvcy(jc+1)-cvcy(jc))

               do 400 i = fb_l1, fb_h1 
                  fn = i-fslo(1)+1
                  ic = IX_PROJ(i,lratiox)
                  icc = sloc(ic,jc)
                  fine(i,j,n) = fdat(fn) + alpha(icc) * 
     &                   ( voff(fn)*fslope(fn,1)
     &                    +yoff    *fslope(fn,2) )
400            continue
390         continue
360      continue

290   continue

      end
c ::: 
c ::: --------------------------------------------------------------
c ::: linccinterp:   linear conservative interpolation from coarse grid to
c ::: subregion of fine grid defined by (fblo,fbhi)
c ::: 
c ::: The interpolation is linear in that it uses a
c ::: a limiting scheme that preserves the value of 
c ::: any linear combination of the
c ::: coarse grid data components--e.g.,
c ::: if sum_ivar a(ic,jc,ivar)*fab(ic,jc,ivar) = 0, then
c ::: sum_ivar a(ic,jc,ivar)*fab(if,jf,ivar) = 0 is satisfied
c ::: in all fine cells if,jf covering coarse cell ic,jc.
c ::: 
c ::: If lin_limit = 0, the interpolation scheme is identical to
c ::: the used in ccinterp for limslope=1; the results should
c ::: be exactly the same -- difference = hard 0.
c :::
c ::: Unlike FORT_CCINTERP, this routine does not do any clever unrolling
c ::: and it does not use any 1-d strip--all calculations are done
c ::: on full 2-d arrays.  The onlu concession to vectorization
c ::: is that the innermost loops are longest.
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio(2)    =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: clo,chi      =>  (const)  index limits of crse grid
c ::: cslo,cshi    =>  (const)  coarse grid index limits where
c :::				slopes are to be defined. This is
c :::				the projection of (fblo,fbhi) down
c :::				to the coarse level 
c ::: ucslope      =>  (modify) temp array of unlimited coarse grid slopes
c ::: lcslope      =>  (modify) temp array of limited coarse grid slopes
c ::: slope_factor =>  (modify) temp array of slope limiting factors
c ::: lin_limit    =>  (const)  != 0 => do linear slope limiting scheme
c :::
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_LINCCINTERP (fine, DIMS(fine), fblo, fbhi, 
     &                          DIMS(fvcb), 
     &                          crse, DIMS(crse), DIMS(cvcb),
     &                          uc_xslope, lc_xslope, xslope_factor,
     &                          uc_yslope, lc_yslope, yslope_factor,
     &                          DIMS(cslope),
     &                          cslopelo, cslopehi,
     $                          nvar, lratiox, lratioy, 
     $                          bc, lin_limit,
     $                          fvcx, fvcy, cvcx, cvcy,
     &                          voffx, voffy)

      implicit none

      integer DIMDEC(fine)
      integer DIMDEC(crse)
      integer DIMDEC(fvcb)
      integer DIMDEC(cvcb)
      integer DIMDEC(cslope)
      integer fblo(2), fbhi(2)
      integer cslopelo(2), cslopehi(2)
      integer lratiox, lratioy, nvar, lin_limit
      integer bc(2,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(DIMV(crse), nvar)
      REAL_T uc_xslope(DIMV(cslope),nvar)
      REAL_T lc_xslope(DIMV(cslope),nvar)
      REAL_T xslope_factor(DIMV(cslope))
      REAL_T uc_yslope(DIMV(cslope),nvar)
      REAL_T lc_yslope(DIMV(cslope),nvar)
      REAL_T yslope_factor(DIMV(cslope))
      REAL_T fvcx(DIM1(fvcb))
      REAL_T fvcy(DIM2(fvcb))
      REAL_T voffx(DIM1(fvcb))
      REAL_T voffy(DIM2(fvcb))
      REAL_T cvcx(DIM1(cvcb))
      REAL_T cvcy(DIM2(cvcb))

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
      integer n 
      integer i, ic
      integer j, jc
      REAL_T cen, forw, back, slp, sgn
      REAL_T factorn, denom, slope_factor, dummy
      REAL_T fxcen, cxcen, fycen, cycen
      logical xok, yok
      integer ncbx, ncby

      ncbx = cslopehi(1)-cslopelo(1)+1
      ncby = cslopehi(2)-cslopelo(2)+1

      xok = (ncbx .ge. 2)
      yok = (ncby .ge. 2)

      do j = fblo(2), fbhi(2)
        jc = IX_PROJ(j,lratioy)
        fycen = half*(fvcy(j)+fvcy(j+1))
        cycen = half*(cvcy(jc)+cvcy(jc+1))
        voffy(j) = (fycen-cycen)/(cvcy(jc+1)-cvcy(jc))
      end do
      do i = fblo(1), fbhi(1)
         ic = IX_PROJ(i,lratiox)
         fxcen = half*(fvcx(i)+fvcx(i+1))
         cxcen = half*(cvcx(ic)+cvcx(ic+1))
         voffx(i) = (fxcen-cxcen)/(cvcx(ic+1)-cvcx(ic))
      end do

      if(ncbx.gt.ncby)then

c=============== CASE 1: x direction is long direction ===================

c ... added to prevent underflow for small crse values

        do n = 1, nvar 
          do j = cslopelo(2)-1,cslopehi(2)+1
            do i = cslopelo(1)-1, cslopehi(1)+1 
              crse(i,j,n) = cvmgt(crse(i,j,n),zero,abs(crse(i,j,n)).gt.1.0e-20)
            end do
          end do
        end do

c ... computed unlimited and limited slopes

        do n = 1, nvar 

c ... --> in x direction

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              uc_xslope(i,j,n) = half*(crse(i+1,j,n)-crse(i-1,j,n))

c ... note: the following 6 lines of code is repeated in two other places.
c           A similar code snippet appears three times in the y slope
c           calculation.  Although it looks wasteful, writing the code
c           this way sped up the routine by ~10% (on DEC-alpha). So leave 
c           it alone unless you can make it faster -- rbp

              cen  = uc_xslope(i,j,n)
              forw = two*(crse(i+1,j,n)-crse(i,j,n))
              back = two*(crse(i,j,n)-crse(i-1,j,n))
              slp  = min(abs(forw),abs(back))
              slp  = cvmgp(slp,zero,forw*back)
              lc_xslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

             end do
          end do
          if (xok) then
            if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
              i = cslopelo(1)
              do j=cslopelo(2), cslopehi(2)
                uc_xslope(i,j,n)  = -sixteen/fifteen*crse(i-1,j,n) 
     &                      + half*crse(i,j,n)
     $                      + two3rd*crse(i+1,j,n) - tenth*crse(i+2,j,n)

                cen  = uc_xslope(i,j,n)
                forw = two*(crse(i+1,j,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i-1,j,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end if
            if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
              i = cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                uc_xslope(i,j,n) = sixteen/fifteen*crse(i+1,j,n) 
     &                      - half*crse(i,j,n)
     $                      - two3rd*crse(i-1,j,n) + tenth*crse(i-2,j,n)

                cen  = uc_xslope(i,j,n)
                forw = two*(crse(i+1,j,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i-1,j,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end if
          end if

c ... --> in y direction

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              uc_yslope(i,j,n) = half*(crse(i,j+1,n)-crse(i,j-1,n))

              cen  = uc_yslope(i,j,n)
              forw = two*(crse(i,j+1,n)-crse(i,j,n))
              back = two*(crse(i,j,n)-crse(i,j-1,n))
              slp  = min(abs(forw),abs(back))
              slp  = cvmgp(slp,zero,forw*back)
              lc_yslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

             end do
          end do
          if (yok) then
            if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
              j = cslopelo(2)
              do i=cslopelo(1), cslopehi(1)
                uc_yslope(i,j,n)  = -sixteen/fifteen*crse(i,j-1,n) 
     &                      + half*crse(i,j,n)
     $                      + two3rd*crse(i,j+1,n) - tenth*crse(i,j+2,n)

                cen  = uc_yslope(i,j,n)
                forw = two*(crse(i,j+1,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i,j-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end if
            if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
              j = cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                uc_yslope(i,j,n) = sixteen/fifteen*crse(i,j+1,n) 
     &                    - half*crse(i,j,n)
     $                    - two3rd*crse(i,j-1,n) + tenth*crse(i,j-2,n)

                cen  = uc_yslope(i,j,n)
                forw = two*(crse(i,j+1,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i,j-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end if
          end if
        end do

        if (lin_limit.eq.1)then

c ... compute linear limited slopes
c     Note that the limited and the unlimited slopes
c     have the same sign, and it is assumed that they do.

c ... --> compute slope factors

          do j=cslopelo(2), cslopehi(2)
            do i=cslopelo(1), cslopehi(1)
              xslope_factor(i,j) = one
              yslope_factor(i,j) = one
            end do
          end do

          do n = 1, nvar 
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                denom = uc_xslope(i,j,n)
                denom = cvmgt(denom,one,denom.ne.zero)
                factorn = lc_xslope(i,j,n)/denom
                factorn = cvmgt(one,factorn,denom.eq.zero)
                xslope_factor(i,j) = min(xslope_factor(i,j),factorn)

                denom = uc_yslope(i,j,n)
                denom = cvmgt(denom,one,denom.ne.zero)
                factorn = lc_yslope(i,j,n)/denom
                factorn = cvmgt(one,factorn,denom.eq.zero)
                yslope_factor(i,j) = min(yslope_factor(i,j),factorn)
              end do
            end do
          end do

c ... --> compute linear limited slopes

          do n = 1, nvar 
            do j=cslopelo(2), cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                lc_xslope(i,j,n) = xslope_factor(i,j)*uc_xslope(i,j,n)
                lc_yslope(i,j,n) = yslope_factor(i,j)*uc_yslope(i,j,n)
              end do
            end do
          end do
        end if

c ... do the interpolation

        do n = 1, nvar
          do j = fblo(2), fbhi(2)
            jc = IX_PROJ(j,lratioy)
            do i = fblo(1), fbhi(1)
              ic = IX_PROJ(i,lratiox)
              fine(i,j,n) = crse(ic,jc,n) + voffx(i)*lc_xslope(ic,jc,n)
     &                                    + voffy(j)*lc_yslope(ic,jc,n)
            end do
          end do
        end do

      else

c=============== CASE 2: y direction is long direction ===================

c ... added to prevent underflow for small crse values

        do n = 1, nvar 
          do i = cslopelo(1)-1, cslopehi(1)+1 
            do j = cslopelo(2)-1,cslopehi(2)+1
              crse(i,j,n) = cvmgt(crse(i,j,n),zero,abs(crse(i,j,n)).gt.1.0e-20)
            end do
          end do
        end do

c ... computed unlimited and limited slopes

        do n = 1, nvar 

c ... --> in x direction

          do i=cslopelo(1), cslopehi(1)
            do j=cslopelo(2), cslopehi(2)
              uc_xslope(i,j,n) = half*(crse(i+1,j,n)-crse(i-1,j,n))

              cen  = uc_xslope(i,j,n)
              forw = two*(crse(i+1,j,n)-crse(i,j,n))
              back = two*(crse(i,j,n)-crse(i-1,j,n))
              slp  = min(abs(forw),abs(back))
              slp  = cvmgp(slp,zero,forw*back)
              lc_xslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

             end do
          end do
          if (xok) then
            if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
              i = cslopelo(1)
              do j=cslopelo(2), cslopehi(2)
                uc_xslope(i,j,n)  = -sixteen/fifteen*crse(i-1,j,n) 
     &                      + half*crse(i,j,n)
     $                      + two3rd*crse(i+1,j,n) - tenth*crse(i+2,j,n)

                cen  = uc_xslope(i,j,n)
                forw = two*(crse(i+1,j,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i-1,j,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end if
            if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
              i = cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                uc_xslope(i,j,n) = sixteen/fifteen*crse(i+1,j,n) 
     &                      - half*crse(i,j,n)
     $                      - two3rd*crse(i-1,j,n) + tenth*crse(i-2,j,n)

                cen  = uc_xslope(i,j,n)
                forw = two*(crse(i+1,j,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i-1,j,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_xslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

               end do
            end if
          end if

c ... --> in y direction

          do i=cslopelo(1), cslopehi(1)
            do j=cslopelo(2), cslopehi(2)
              uc_yslope(i,j,n) = half*(crse(i,j+1,n)-crse(i,j-1,n))

              cen  = uc_yslope(i,j,n)
              forw = two*(crse(i,j+1,n)-crse(i,j,n))
              back = two*(crse(i,j,n)-crse(i,j-1,n))
              slp  = min(abs(forw),abs(back))
              slp  = cvmgp(slp,zero,forw*back)
              lc_yslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

            end do
          end do
          if (yok) then
            if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
              j = cslopelo(2)
              do i=cslopelo(1), cslopehi(1)
                uc_yslope(i,j,n)  = -sixteen/fifteen*crse(i,j-1,n) 
     &                      + half*crse(i,j,n)
     $                      + two3rd*crse(i,j+1,n) - tenth*crse(i,j+2,n)

                cen  = uc_yslope(i,j,n)
                forw = two*(crse(i,j+1,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i,j-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

              end do
            end if
            if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
              j = cslopehi(2)
              do i=cslopelo(1), cslopehi(1)
                uc_yslope(i,j,n) = sixteen/fifteen*crse(i,j+1,n) 
     &                    - half*crse(i,j,n)
     $                    - two3rd*crse(i,j-1,n) + tenth*crse(i,j-2,n)

                cen  = uc_yslope(i,j,n)
                forw = two*(crse(i,j+1,n)-crse(i,j,n))
                back = two*(crse(i,j,n)-crse(i,j-1,n))
                slp  = min(abs(forw),abs(back))
                slp  = cvmgp(slp,zero,forw*back)
                lc_yslope(i,j,n)=sign(one,cen)*min(slp,abs(cen))

              end do
            end if
          end if
        end do

        if (lin_limit.eq.1)then

c ... compute linear limited slopes
c     Note that the limited and the unlimited slopes
c     have the same sign, and it is assumed that they do.

c ... --> compute slope factors

          do i=cslopelo(1), cslopehi(1)
            do j=cslopelo(2), cslopehi(2)
              xslope_factor(i,j) = 1.0
              yslope_factor(i,j) = 1.0
            end do
          end do

          do n = 1, nvar 
            do i=cslopelo(1), cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                denom = uc_xslope(i,j,n)
                denom = cvmgt(denom,one,denom.ne.zero)
                factorn = lc_xslope(i,j,n)/denom
                factorn = cvmgt(one,factorn,denom.eq.zero)
                xslope_factor(i,j) = min(xslope_factor(i,j),factorn)

                denom = uc_yslope(i,j,n)
                denom = cvmgt(denom,one,denom.ne.zero)
                factorn = lc_yslope(i,j,n)/denom
                factorn = cvmgt(one,factorn,denom.eq.zero)
                yslope_factor(i,j) = min(yslope_factor(i,j),factorn)
              end do
            end do
          end do

c ... --> compute linear limited slopes

          do n = 1, nvar 
            do i=cslopelo(1), cslopehi(1)
              do j=cslopelo(2), cslopehi(2)
                lc_xslope(i,j,n) = xslope_factor(i,j)*uc_xslope(i,j,n)
                lc_yslope(i,j,n) = yslope_factor(i,j)*uc_yslope(i,j,n)
              end do
            end do
          end do
        end if

c ... do the interpolation

        do n = 1, nvar
          do i = fblo(1), fbhi(1)
            ic = IX_PROJ(i,lratiox)
            do j = fblo(2), fbhi(2)
              jc = IX_PROJ(j,lratioy)
              fine(i,j,n) = crse(ic,jc,n) + voffx(i)*lc_xslope(ic,jc,n)
     &                                    + voffy(j)*lc_yslope(ic,jc,n)
            end do
          end do
        end do

      end if
      end
c ::: 
c ::: --------------------------------------------------------------
c ::: 

      subroutine FORT_CQINTERP (fine, DIMS(fine), 
     $                          fb_l1, fb_l2, fb_h1, fb_h2,
     $                          nvar, lratiox, lratioy, crse, clo, chi, 
     $                          cb_l1, cb_l2, cb_h1, cb_h2,
     $		                fslo, fshi, cslope, clen, fslope, fdat,
     $                          flen, voff, bc, limslope,
     $                          fvcx, fvcy, cvcx, cvcy)

      integer DIMDEC(fine)
      integer fslo(2), fshi(2)
      integer fb_l1, fb_l2, fb_h1, fb_h2
      integer cb_l1, cb_l2, cb_h1, cb_h2
      integer clo, chi
      integer lratiox, lratioy, nvar, clen, flen, limslope
      integer bc(2,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(clo:chi, nvar)
      REAL_T cslope(clo:chi, 5)
      REAL_T fslope(flen, 5)
      REAL_T fdat(flen)
      REAL_T voff(flen)
      REAL_T fvcx(fb_l1:fb_h1+1)
      REAL_T fvcy(fb_l2:fb_h2+1)
      REAL_T cvcx(cb_l1:cb_h1+1)
      REAL_T cvcy(cb_l2:cb_h2+1)

#define bclo(i,n) bc(i,1,n)
#define bchi(i,n) bc(i,2,n)

c ::: local var
      integer n, fn
      integer i, ic, ioff
      integer j, jc, joff
      integer ist, jst
      REAL_T cen, forw, back, slp, sgn
      REAL_T fcen, ccen
      REAL_T diffxy,diffxx,diffyy
      REAL_T xoff, yoff
      integer ncbx, ncby
      integer ncsx, ncsy
      integer islo, jslo
      integer icc, istart, iend
      logical xok, yok

      ncbx = cb_h1-cb_l1+1
      ncby = cb_h2-cb_l2+1
      xok = (ncbx .ge. 2)
      yok = (ncby .ge. 2)
      ncsx = ncbx+2
      ncsy = ncby+2
      ist = 1
      jst = ncsx
      islo = cb_l1-1
      jslo = cb_l2-1

      do i = fb_l1, fb_h1 
         fn = i-fslo(1)+1
         ic = IX_PROJ(i,lratiox)
         fcen = half*(fvcx(i)+fvcx(i+1))
         ccen = half*(cvcx(ic)+cvcx(ic+1))
         voff(fn) = (fcen-ccen)/(cvcx(ic+1)-cvcx(ic))
      end do   

c ::: ::::: added to prevent underflow for small crse values
      do n = 1, nvar 
        do i = clo, chi 
          crse(i,n) = cvmgt(crse(i,n),zero,abs(crse(i,n)).gt.1.0e-20)
        end do
      end do

      do 290 n = 1, nvar 

c ::: ::::: compute slopes in x direction
            do i = 1, clen 
               cen = half*(crse(i+ist,n)-crse(i-ist,n))
               diffxy = fourth*(crse(i+ist+jst,n)+crse(i-ist-jst,n)
     $                         -crse(i-ist+jst,n)-crse(i+ist-jst,n))
               diffxx = crse(i+ist,n)-two*crse(i,n)+crse(i-ist,n)
               cslope(i,1)=cen
               cslope(i,3)=diffxx
               cslope(i,5)=diffxy
            end do
            if (xok) then
               if (bclo(1,n) .eq. EXT_DIR .or. bclo(1,n).eq.HOEXTRAP) then
                  do i = 1, clen, jst 
                     cen  = -sixteen/fifteen*crse(i-ist,n) + half*crse(i,n)
     $                    + two3rd*crse(i+ist,n) - tenth*crse(i+2*ist,n)
                     cslope(i,1)=cen
                     cslope(i,3)=zero
                     cslope(i,5)=zero
                  end do
               end if
               if (bchi(1,n) .eq. EXT_DIR .or. bchi(1,n).eq.HOEXTRAP) then
                  do i = ncbx, clen, jst 
                     cen = sixteen/fifteen*crse(i+ist,n) - half*crse(i,n)
     $                    - two3rd*crse(i-ist,n) + tenth*crse(i-2*ist,n)
                     cslope(i,1)=cen
                     cslope(i,3)=zero
                     cslope(i,5)=zero
                  end do
               end if
            end if

c ::: ::::: compute slopes in y direction
            do i = 1, clen 
               cen  = half*(crse(i+jst,n)-crse(i-jst,n))
               diffyy = crse(i+jst,n)-two*crse(i,n)+crse(i-jst,n)
               cslope(i,2)=cen
               cslope(i,4)=diffyy
            end do
            if (yok) then
               if (bclo(2,n) .eq. EXT_DIR .or. bclo(2,n).eq.HOEXTRAP) then
                  do i = 1, ncbx 
                     cen  = -sixteen/fifteen*crse(i-jst,n) + half*crse(i,n)
     $                    + two3rd*crse(i+jst,n) - tenth*crse(i+2*jst,n)
                     cslope(i,2)=cen
                     cslope(i,4)=zero
                     cslope(i,5)=zero
                  end do
               end if
               if (bchi(2,n) .eq. EXT_DIR .or. bchi(2,n).eq.HOEXTRAP) then
                  do i = clen-ncbx,clen 
                     cen = sixteen/fifteen*crse(i+jst,n) - half*crse(i,n)
     $                    - two3rd*crse(i-jst,n) + tenth*crse(i-2*jst,n)
                     cslope(i,2)=cen
                     cslope(i,4)=zero
                     cslope(i,5)=zero
                  end do
               end if
            end if

            do 360 jc = cb_l2, cb_h2 
c           ::::: strip out a fine grid slope vector
               do 370 ioff = 1, lratiox 
                  icc = clo + ist + jst*(jc-jslo)
                  istart = ioff
                  iend = ioff + (ncbx-1)*lratiox
                  do 380 fn = istart, iend, lratiox 
                     fslope(fn,1) = cslope(icc,1)
                     fslope(fn,2) = cslope(icc,2)
                     fslope(fn,3) = cslope(icc,3)
                     fslope(fn,4) = cslope(icc,4)
                     fslope(fn,5) = cslope(icc,5)
                     fdat(fn) = crse(icc,n)
                     icc = icc + ist
380               continue
370            continue

               do 390 joff = 0, lratioy-1 
                  j = lratioy*jc + joff
                  if ((j.lt.fb_l2).or.(j.gt.fb_h2)) goto 390
                  fcen = half*(fvcy(j)+fvcy(j+1))
                  ccen = half*(cvcy(jc)+cvcy(jc+1))
                  yoff = (fcen-ccen)/(cvcy(jc+1)-cvcy(jc))

                  do 400 i = fb_l1, fb_h1 
                     fn = i-fslo(1)+1
                     fine(i,j,n) = fdat(fn) + voff(fn)*fslope(fn,1)
     &                    + voff(fn)*voff(fn)*fslope(fn,3)
     &                    + yoff*fslope(fn,2)
     &                    + yoff*yoff*fslope(fn,4)
     &                    + voff(fn)*yoff*fslope(fn,5)
400               continue
390            continue
360         continue

290   continue

      end

c ::: 
c ::: --------------------------------------------------------------
c ::: pcinterp:  cell centered piecewise constant interpolation
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: 
c ::: crse         =>  (const)  coarse grid data 
c ::: clo,chi      =>  (const)  index limits of coarse grid
c ::: cblo,cbhi    =>  (const) coarse grid region containing fblo,fbhi
c ::: 
c ::: longdir      =>  (const)  which index direction is longest (1 or 2)
c ::: lratio(2)    =>  (const)  refinement ratio between levels
c ::: nvar         =>  (const)  number of components in array
c ::: 
c ::: TEMPORARY ARRAYS
c ::: ftmp         =>  1-D temp array
c ::: --------------------------------------------------------------
c ::: 
      subroutine FORT_PCINTERP (crse,DIMS(crse),cblo,cbhi,
     &                          fine,DIMS(fine),fblo,fbhi,
     &                          longdir,lratiox,lratioy,nvar,
     &                          ftmp,ftmp_lo,ftmp_hi)
      integer DIMDEC(crse)
      integer cblo(2), cbhi(2)
      integer DIMDEC(fine)
      integer fblo(2), fbhi(2)
      integer ftmp_lo, ftmp_hi
      integer nvar, lratiox, lratioy, longdir
      REAL_T  crse(DIMV(crse), nvar)
      REAL_T  fine(DIMV(fine), nvar)
      REAL_T  ftmp(ftmp_lo:ftmp_hi)

      integer i, j, ic, jc, ioff, joff, n

      if (longdir .eq. 1) then
         do n = 1, nvar
         do jc = cblo(2), cbhi(2)
	    j = jc*lratioy
	    do ioff = 0, lratiox-1
	       do ic = cblo(1), cbhi(1)
	          i = lratiox*ic + ioff
	          ftmp(i) = crse(ic,jc,n)
               end do
	    end do
	    do joff = 0, lratioy-1
	       j = lratioy*jc + joff
	       if (j.ge.fblo(2).and.j.le.fbhi(2)) then
	          do i = fblo(1), fbhi(1)
		     fine(i,j,n) = ftmp(i)
		  end do
	       end if
	    end do
	 end do
	 end do
      else
         do n = 1, nvar
         do ic = cblo(1), cbhi(1)
	    i = ic*lratiox
	    do joff = 0, lratioy-1
	       do jc = cblo(2), cbhi(2)
	          j = lratioy*jc + joff
	          ftmp(j) = crse(ic,jc,n)
               end do
	    end do
	    do ioff = 0, lratiox-1
	       i = lratiox*ic + ioff
	       if (i.ge.fblo(1).and.i.le.fbhi(1)) then
	          do j = fblo(2), fbhi(2)
		     fine(i,j,n) = ftmp(j)
		  end do
	       end if
	    end do
	 end do
	 end do
      end if

      end

c ::: 
c ::: --------------------------------------------------------------
c ::: protect_interp:   redo interpolation if the result of linccinterp
c ::: generates under- or overshoots.
c ::: 
c ::: 
c ::: Inputs/Outputs
c ::: fine        <=>  (modify) fine grid array
c ::: flo,fhi      =>  (const)  index limits of fine grid
c ::: fblo,fbhi    =>  (const)  subregion of fine grid to get values
c ::: cblo,cbhi    =>  (const)  coarse equivalent of fblo,fbhi
c ::: nvar         =>  (const)  number of variables in state vector
c ::: lratio(3)    =>  (const)  refinement ratio between levels
c ::: 
c ::: crse         =>  (const)  coarse grid data widended by 1 zone
c ::: clo,chi      =>  (const)  index limits of crse grid
c :::
c ::: --------------------------------------------------------------
c ::: 

      subroutine FORT_PROTECT_INTERP (fine, DIMS(fine), fblo, fbhi, 
     &                                crse, DIMS(crse), cblo, cbhi,
     &                                fvcx, fvcy, 
     &                                fb_l1, fb_l2, fb_h1, fb_h2,
     &                                cvcx, cvcy, 
     &                                cb_l1, cb_l2, cb_h1, cb_h2,
     &                                fine_state, DIMS(state), 
     &                                nvar, lratiox, lratioy, bc)

      implicit none

      integer DIMDEC(fine)
      integer DIMDEC(crse)
      integer DIMDEC(state)
      integer fblo(2), fbhi(2)
      integer cblo(2), cbhi(2)
      integer fb_l1, fb_l2, fb_h1, fb_h2
      integer cb_l1, cb_l2, cb_h1, cb_h2
      integer lratiox, lratioy, nvar
      integer bc(2,2,nvar)
      REAL_T fine(DIMV(fine),nvar)
      REAL_T crse(DIMV(crse), nvar)
      REAL_T fine_state(DIMV(state), nvar)
      REAL_T fvcx(fb_l1:fb_h1)
      REAL_T fvcy(fb_l2:fb_h2)
      REAL_T cvcx(cb_l1:cb_h1)
      REAL_T cvcy(cb_l2:cb_h2)

      REAL_T alpha, sumN, sumP, negVal, posVal
      REAL_T crseTot, crseTotnew
      REAL_T orig_fine(0:15,0:15)
      REAL_T fvol,cvol
      integer redo_me
      integer ilo,ihi,jlo,jhi
      integer i,j,ic,jc,n,nn
      integer icase

      do jc = cblo(2), cbhi(2)
      do ic = cblo(1), cbhi(1)

         ilo = max(lratiox*ic            ,fine_l1)
         ihi = min(lratiox*ic+(lratiox-1),fine_h1)
         jlo = max(lratioy*jc            ,fine_l2)
         jhi = min(lratioy*jc+(lratioy-1),fine_h2)

         do n = 2, nvar-1

            redo_me = 0
            do j = jlo,jhi
            do i = ilo,ihi
               if ((fine_state(i,j,n)+fine(i,j,n)) .lt. 0.d0) redo_me = 1
            enddo
            enddo
c
c ****************************************************************************************
c
c           If all the fine values are non-negative after the original interpolated 
c            correction, then we do nothing here.
c
c           If any of the fine values are negative after the original interpolated
c            correction, then we do our best.
c
c           Special cases:
c
c             1) Coarse correction > 0, and fine_state has some cells with 
c                negative values which will be filled before adding to the other cells.
c                Use the correction to bring negative cells to zero, then
c                distribute the remaining positive proportionally.
c
c             2) Coarse correction > 0, and correction can not make them all
c                positive.  Add correction only to the negative cells, in proportion
c                to their magnitude.
c
c             3) Coarse correction < 0, and fine_state DOES NOT have enough
c                  have enough positive state to absorb it.  Here we bring
c                  all the positive fine cells to zero then distribute the remaining
c                  negative amount in such a way as to make them all as close to the
c                  same negative value as possible.
c
c             4) Coarse correction < 0, fine_state has enough
c                  positive state to absorb it without making any fine 
c                  cells negative, BUT fine_state+fine is currently negative
c                  in at least one fine cell.  Here just take a constant percentage
c                  away from each positive and don't touch the negatives.
c
c             crseTot = volume-weighted sum of all interpolated values of the correction,
c                       which is equivalent to the total volume-weighted coarse correction
c             SumN = volume-weighted sum of all negative values of fine_state
c             SumP = volume-weighted sum of all positive values of fine_state
c
c ****************************************************************************************
c

            if (redo_me .eq. 1) then

               icase = 0

               do j = jlo,jhi
               do i = ilo,ihi
                  orig_fine(i-ilo,j-jlo) = fine(i,j,n)
               enddo
               enddo

               crseTot = 0.d0
               do j = jlo,jhi
               do i = ilo,ihi
                  fvol = (fvcx(i+1)-fvcx(i)) * (fvcy(j+1)-fvcy(j))
                  crseTot = crseTot + fvol * fine(i,j,n)
               enddo
               enddo

               cvol = (cvcx(ic+1)-cvcx(ic)) * (cvcy(jc+1)-cvcy(jc))

               sumN = zero
               sumP = zero
               do j = jlo,jhi
               do i = ilo,ihi
                  fvol = (fvcx(i+1)-fvcx(i)) * (fvcy(j+1)-fvcy(j))
                  if (fine_state(i,j,n) .le. 0.d0) then
                    sumN = SumN + fvol * fine_state(i,j,n)
                  else
                    sumP = sumP + fvol * fine_state(i,j,n)
                  endif
               enddo
               enddo

               if (crseTot .gt. 0.d0 .and. crseTot .ge. abs(sumN)) then
c              Here we want to fill in the negative values first, then add
c                the remaining positive proportionally.

                   icase = 1
                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,n) .le. 0.d0) then
                        fine(i,j,n) = -fine_state(i,j,n)
                      endif
                   enddo
                   enddo

                   if (sumP > 0.d0) then

                     alpha = (crseTot - abs(sumN)) / sumP

                     do j = jlo,jhi
                     do i = ilo,ihi
                       if (fine_state(i,j,n) .ge. 0.d0) then
                         fine(i,j,n) = alpha * fine_state(i,j,n)
                       endif
                     enddo
                     enddo

                   else

                     posVal = (crseTot - abs(sumN)) / cvol

                     do j = jlo,jhi
                     do i = ilo,ihi
                       fine(i,j,n) = fine(i,j,n) + posVal
                     enddo
                     enddo

                   endif
            
                 endif

               if (crseTot .gt. 0.d0. and. crseTot .lt. abs(sumN)) then
c              Here we don't have enough positive correction to fill all the
c                negative values of state, so we just try to fill them proportionally
c                and don't add any correction to the states already positive.

                   icase = 2
                   alpha = crseTot / abs(sumN)

                   do j = jlo,jhi
                   do i = ilo,ihi
                     if (fine_state(i,j,n) .lt. 0.d0) then
                       fine(i,j,n) = alpha * abs(fine_state(i,j,n))
                     else 
                       fine(i,j,n) = 0.d0
                     endif
                   enddo
                   enddo

               endif

               if (crseTot .lt. 0.d0. and. abs(crseTot) .gt. sumP) then
c              Here we don't have enough positive states to absorb all the
c                negative correction, so we want to end up with all the fine
c                cells having the same negative value.

                   icase = 3
                   negVal = (sumP + sumN + crseTot)/cvol

                   do j = jlo,jhi
                   do i = ilo,ihi
                      fine(i,j,n) = negVal - fine_state(i,j,n)
                   enddo
                   enddo

               endif

               if (crseTot .lt. 0.d0 .and. abs(crseTot) .lt. sumP
     $                               .and. (sumP+sumN+crseTot) .gt. 0.d0) then
c              Here we have enough positive states to absorb all the
c                negative correction *and* redistribute to make negative cells
c                positive. 

                   icase = 4
                   alpha = (crseTot + sumN) / sumP

                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,n) .lt. 0.d0) then
                        fine(i,j,n) = -fine_state(i,j,n)
                      else
                        fine(i,j,n) = alpha * fine_state(i,j,n)
                      endif  
                   enddo
                   enddo

               endif

               if (crseTot .lt. 0.d0. and. abs(crseTot) .lt. sumP
     $                               .and. (sumP+sumN+crseTot) .le. 0.d0) then
c              Here we have enough positive states to absorb all the
c                negative correction, but not to fix the states already negative. 
c                We bring all the positive states to zero, and use whatever 
c                remaining positiveness from the states to help the negative states.

                   icase = 5
                   alpha = (crseTot + sumP) / sumN

                   do j = jlo,jhi
                   do i = ilo,ihi
                      if (fine_state(i,j,n) .gt. 0.d0) then
                        fine(i,j,n) = -fine_state(i,j,n)
                      else 
                        fine(i,j,n) = alpha * fine_state(i,j,n)
                      endif
                   enddo
                   enddo

               endif

               crseTotnew   = 0.d0
               do j = jlo,jhi
               do i = ilo,ihi
                  fvol = (fvcx(i+1)-fvcx(i)) * (fvcy(j+1)-fvcy(j))
                  crseTotnew   = crseTotnew   + fvol * fine(i,j,n)
               enddo
               enddo

               if (abs(crseTotnew - crseTot)/cvol .gt. 1.e-8) then
                  print *,' '
                  print *,'BLEW CONSERVATION with ICASE = ',icase
                  print *,'AT COARSE CELL ',ic,jc,' AND COMPONENT ',n
                  print *,'CRSETOT NEW OLD ',crseTotnew, crseTot
                  print *,'CVOL ',cvol
                  print *,'SUMP SUMN ',sumP,sumN
                  do j = jlo,jhi
                  do i = ilo,ihi
                     fvol = (fvcx(i+1)-fvcx(i)) * (fvcy(j+1)-fvcy(j))
                     print *,'FINE OLD NEW ',i,j,orig_fine(i-ilo,j-jlo),
     $                                       fine(i,j,n), fine_state(i,j,n),
     $                                       fvol
                     if (abs(fvol) .lt. 1.e-20) then
                       print *,'MAKING FVOL ',fvcx(i+1),fvcx(i),fvcy(j+1),fvcy(j)
                     endif
                  enddo
                  enddo
               endif

c              do j = jlo,jhi
c              do i = ilo,ihi
c                 if ((fine_state(i,j,n) + fine(i,j,n)) .lt. 0.d0) then
c                    print *,'STILL NEGATIVE AT ',i,j,n
c                    print *,'AT COARSE CELL ',ic,jc
c                    print *,'FINE STATE ',fine_state(i,j,n)
c                    print *,'FINE CORRECTION ',fine(i,j,n)
c                    print *,'CRSETOT ',crseTot
c                    print *,'SUMN / SUMP ',sumN, sumP
c                    print *,' '
c                 endif
c              enddo
c              enddo
c              enddo

c           End (if redo .eq. 1)
            endif

         enddo

c     Set sync for density (n=1) to sum of spec sync (2:nvar-1)
         do j = jlo,jhi
         do i = ilo,ihi
            fine(i,j,1) = 0.d0
            do n = 2,nvar-1
               fine(i,j,1) = fine(i,j,1) + fine(i,j,n)
            enddo
         enddo
         enddo

c     End of coarse index loops
      enddo
      enddo
      end

c-----------------------------------------------------------------------
      subroutine hgavg(
     &     src,   srcl0, srch0, srcl1, srch1,
     &     rf,    fl0, fh0, fl1, fh1,
     &     fregl0, fregh0, fregl1, fregh1,
     &     hx, irz, imax, idense)
      integer srcl0, srch0, srcl1, srch1
      integer fl0, fh0, fl1, fh1
      integer fregl0, fregh0, fregl1, fregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision rf(fl0:fh0,fl1:fh1)
      double precision hx
      integer irz, imax
      double precision fac, r1, r0m, r1m
      integer i, j
      integer idense

c     Need to modify the weighting of the RHS for the dense stencil
      if (idense .eq. 1) then
        fac = 0.25d0 * hx
      else
        fac = 0.25d0
      endif

      do j = fregl1, fregh1
         do i = fregl0, fregh0
c     We want only this modification for the cross stencil
            if (irz .eq. 1 .and. i .eq. 0) then
               src(i,j) = src(i,j) + fac * (rf(i,j-1) + rf(i,j))
            else
               src(i,j) = src(i,j) + fac * (rf(i-1,j-1) + rf(i-1,j) +
     &              rf(i,j-1)   + rf(i,j))
            endif
         end do
      end do

      if ( idense .eq. 1 .and. irz .eq. 1) then
c     We dont want these extra terms for the cross stencil
         fac = hx / 24.d0 * hx
         r1  = (fregl0 - 0.5d0) * hx
         r1m = 1.d0 / r1
         do i = fregl0, fregh0
            r0m = r1m
            r1  = r1 + hx
            if (i .lt. imax) then
               r1m = 1.d0 / r1
            else
               r1m = -r0m
            end if
            do j = fregl1, fregh1
               src(i,j) = src(i,j) + fac *
     &              (r0m * (rf(i-1,j) + rf(i-1,j-1)) -
     &              r1m * (rf(i,j-1) + rf(i,j)))
            end do
         end do
      end if

      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfavg(
     & src,   srcl0, srch0, srcl1, srch1,
     & rc,    cl0, ch0, cl1, ch1,
     & rf,    fl0, fh0, fl1, fh1,
     &        cregl0, cregh0, cregl1, cregh1,
     & ir, jr, idim, idir,
     & hx, irz, imax, idense)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision rc(cl0:ch0,cl1:ch1)
      double precision rf(fl0:fh0,fl1:fh1)
      double precision hx
      integer ir, jr, idim, idir, irz, imax
      double precision fac0, fac, r, rfac, rfac0, rfac1
      double precision rfac0m, rfac1m, rfac0p, rfac1p
      integer i, j, irc, jrc, irf, jrf, m, n
      integer idense

c     Need to modify the weighting of the RHS for the dense stencil

      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            irc = i - 1
            irf = i * ir
         else
            irc = i
            irf = i * ir - 1
         end if
         fac0 = 0.5d0 * ir / (ir+1)
         if ( idense .eq. 1 ) fac0 = fac0 * hx
         do j = cregl1, cregh1
          src(i*ir,j*jr) = src(i*ir,j*jr) + fac0 *
     &         (rc(irc,j) + rc(irc,j-1))
         end do
         if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
            if (irz .eq. 1) then
               r = (irc + 0.5d0) * (hx * ir)
            rfac = (hx * ir) / (6.d0 * r)
            do j = cregl1, cregh1
               src(i*ir,j*jr) = src(i*ir,j*jr) + fac0 *
     &           (rfac * idir * (rc(irc,j) + rc(irc,j-1)))
            end do
            r = (irf + 0.5d0) * hx
            rfac = hx / (6.d0 * r)
         end if
         end if
         fac0 = fac0 / (ir * jr * jr)
         if ( idense .eq. 1 ) fac0 = fac0 * hx
         i = i * ir
         do n = 0, jr-1
            fac = (jr-n) * fac0
            if (n .eq. 0) fac = 0.5d0 * fac
            do j = jr*cregl1, jr*cregh1, jr
               src(i,j) = src(i,j) + fac *
     &           (rf(irf,j-n) + rf(irf,j-n-1) +
     &            rf(irf,j+n) + rf(irf,j+n-1))
            end do
            if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
            if (irz .eq. 1) then
               do j = jr*cregl1, jr*cregh1, jr
                  src(i,j) = src(i,j) - fac *
     &              (rfac * idir * (rf(irf,j-n) + rf(irf,j-n-1) +
     &                              rf(irf,j+n) + rf(irf,j+n-1)))
               end do
            end if
            end if
         end do
      else if (idim .eq. 1) then
         j = cregl1
         if (idir .eq. 1) then
            jrc = j - 1
            jrf = j * jr
         else
            jrc = j
            jrf = j * jr - 1
         end if
         fac0 = 0.5d0 * jr / (jr+1)
         if ( idense .eq. 1 ) fac0 = fac0 * hx
         do i = cregl0, cregh0
            src(i*ir,j*jr) = src(i*ir,j*jr) + fac0 *
     &        (rc(i,jrc) + rc(i-1,jrc))
         end do

         if (irz .eq. 1 .and. cregl0 .le. 0 .and. cregh0 .ge. 0) then
            i = 0
            src(i*ir,j*jr) = src(i*ir,j*jr) - fac0 * rc(i-1,jrc)
         endif

         if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
         if (irz .eq. 1 .and. cregh0 .lt. imax) then
            do i = cregl0, cregh0
               r = (i + 0.5d0) * (hx * ir)
               rfac0 = (hx * ir) / (6.d0 * (r - hx * ir))
               rfac1 = (hx * ir) / (6.d0 * r)
               src(i*ir,j*jr) = src(i*ir,j*jr) + fac0 *
     &           (rfac0 * rc(i-1,jrc) - rfac1 * rc(i,jrc))
            end do
         else if (irz .eq. 1) then
c This should only occur with a corner at the outer boundary, which
c should be handled by the cavg routine instead:
            i = cregh0
            r = (i - 0.5d0) * (hx * ir)
            rfac0 = (hx * ir) / (6.d0 * r)
            rfac1 = -rfac0
            src(i*ir,j*jr) = src(i*ir,j*jr) + fac0 *
     &           (rfac0 * rc(i-1,jrc) - rfac1 * rc(i,jrc))
         end if
         end if
         fac0 = fac0 / (ir * ir * jr)
         if ( idense .eq. 1 ) fac0 = fac0 * hx
         j = j * jr
         do m = 0, ir-1
            fac = (ir-m) * fac0
            if (m .eq. 0) fac = 0.5d0 * fac
            do i = ir*cregl0, ir*cregh0, ir
               src(i,j) = src(i,j) + fac *
     &           (rf(i-m,jrf) + rf(i-m-1,jrf) +
     &            rf(i+m,jrf) + rf(i+m-1,jrf))
            end do

            if (irz .eq. 1 .and. m .eq. 0 .and.
     &          cregl0 .le. 0 .and. cregh0 .ge. 0) then
               i = 0
               src(i*ir,j*jr) = src(i*ir,j*jr) - fac *
     &              (rf(i-m-1,jrf) + rf(i+m-1,jrf))
            endif
            if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
            if (irz .eq. 1 .and. cregh0 .lt. imax) then
               do i = ir*cregl0, ir*cregh0, ir
                  r = (i + 0.5d0) * hx
                  rfac0m = hx / (6.d0 * (r - (m + 1) * hx))
                  rfac1m = hx / (6.d0 * (r - m * hx))
                  rfac0p = hx / (6.d0 * (r + (m - 1) * hx))
                  rfac1p = hx / (6.d0 * (r + m * hx))
                  src(i,j) = src(i,j) + fac *
     &              (rfac0m * rf(i-m-1,jrf) - rfac1m * rf(i-m,jrf) +
     &               rfac0p * rf(i+m-1,jrf) - rfac1p * rf(i+m,jrf))
               end do
            else if (irz .eq. 1) then
c This should only occur with a corner at the outer boundary, which
c should be handled by the cavg routine instead:
               i = ir*cregh0
               r = (i + 0.5d0) * hx
               rfac0m = hx / (6.d0 * (r - (m + 1) * hx))
               if (m .eq. 0) then
                  rfac1m = -rfac0m
               else
                  rfac1m = hx / (6.d0 * (r - m * hx))
               end if
               rfac0p = -rfac1m
               rfac1p = -rfac0m
               src(i,j) = src(i,j) + fac *
     &              (rfac0m * rf(i-m-1,jrf) - rfac1m * rf(i-m,jrf) +
     &               rfac0p * rf(i+m-1,jrf) - rfac1p * rf(i+m,jrf))
            end if
            end if
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcavg(
     & src,   srcl0, srch0, srcl1, srch1,
     & rc,    cl0, ch0, cl1, ch1,
     & rf,    fl0, fh0, fl1, fh1,
     &        cregl0, cregh0, cregl1, cregh1,
     & ir, jr, ga, idd,
     & hx, irz, imax, idense)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision rc(cl0:ch0,cl1:ch1)
      double precision rf(fl0:fh0,fl1:fh1)
      double precision hx
      integer ir, jr, ga(0:1,0:1), irz, imax, idd
      double precision rm2, sum, center, fac, ffac, cfac, fac1
      double precision r, rfac, rfac0, rfac1
      integer ic, jc, if, jf, ii, ji, irc, jrc, irf, jrf
      integer m, n, idir, jdir
      integer idense
      rm2 = 1.d0 / (ir * jr)
      ic = cregl0
      jc = cregl1
      if = ic * ir
      jf = jc * jr

      sum = 0.d0
      center = 0.d0
c quadrants
      fac = rm2
      ffac = rm2
      cfac = 1.d0
      do ji = 0, 1
         jrf = jf + ji - 1
         jrc = jc + ji - 1
         do ii = 0, 1
            if (ga(ii,ji) .eq. 1) then
               irf = if + ii - 1
               center = center + ffac
               sum = sum + fac * rf(irf,jrf)
               if ( idense .eq. 0 ) then
c     We dont want these extra terms for the cross stencil
               if (irz .eq. 1) then
                  idir = 2 * ii - 1
                  r = (irf + 0.5d0) * hx
                  if (irf .lt. (ir * imax)) then
                     rfac =  hx / (6.d0 * r)
                  else
                     rfac = -hx / (6.d0 * (r - hx))
                  end if
                  sum = sum - fac * rfac * idir * rf(irf,jrf)
               end if
               end if
            else
               irc = ic + ii - 1
               center = center + cfac
               sum = sum + rc(irc,jrc)
               if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
               if (irz .eq. 1) then
                  idir = 2 * ii - 1
                  r = (irc + 0.5d0) * (hx * ir)
                  if (irc .lt. imax) then
                     rfac =  (hx * ir) / (6.d0 * r)
                  else
                     rfac = -(hx * ir) / (6.d0 * (r - (hx * ir)))
                  end if
                  sum = sum - rfac * idir * rc(irc,jrc)
               end if
               end if
            end if
         end do
      end do

c     We *only* want this modification for the 5-point stencil:
c      here we halve the average at the r=0 axis.
      if (irz .eq. 1 .and. ic .eq. 0) then
         sum = sum * 0.5d0
      endif

c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         jrf = jf + ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            irf = if + ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = rm2 / ir
               ffac = (ir-1) * rm2
               center = center + ffac
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac * (rf(if+m,jrf) + rf(if+m-1,jrf))
                  if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
                  if (irz .eq. 1) then
                     r = (if + 0.5d0) * hx
                     if (irf .lt. (ir * imax)) then
                        rfac0 =  hx / (6.d0 * (r + (m - 1) * hx))
                        rfac1 =  hx / (6.d0 * (r + m * hx))
                     else
                        rfac0 = -hx / (6.d0 * (r - m * hx))
                        rfac1 = -hx / (6.d0 * (r - (m + 1) * hx))
                     end if
                     sum = sum + fac *
     &                 (rfac0 * rf(if+m-1,jrf) - rfac1 * rf(if+m,jrf))
                  end if
                  end if
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = rm2 / jr
               ffac = (jr-1) * rm2
               center = center + ffac
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac * (rf(irf,jf+n) + rf(irf,jf+n-1))
                  if ( idense .eq. 1 ) then
c     We dont want these extra terms for the cross stencil
                  if (irz .eq. 1) then
                     r = (irf + 0.5d0) * hx
                     rfac = hx / (6.d0 * r)
                     sum = sum - fac *
     &                 (rfac * idir * (rf(irf,jf+n) + rf(irf,jf+n-1)))
                  end if
                  end if
               end do
            end if
         end do
      end do
c weighting

c     Need to modify the weighting of the RHS for the dense stencil
      if ( idense .eq. 1 ) sum = sum * hx

      src(if,jf) = src(if,jf) + sum / center
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: ABec_UTIL.F,v 1.3 2003/02/18 20:54:40 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>

c-----------------------------------------------------------------------
c
c     Tridiagonal solve
c
      subroutine tridiag(a,b,c,r,u,n)
 
      integer n
      integer nmax
  
      REAL_T a(n)
      REAL_T b(n)
      REAL_T c(n)
      REAL_T r(n)
      REAL_T u(n)

      parameter (nmax = 4098)

      integer j
      REAL_T bet
      REAL_T gam(nmax)
      if (n .gt. nmax ) call bl_error('tridiag: size exceeded')
      if (b(1) .eq. 0) call bl_error('tridiag: CANT HAVE B(1) = ZERO')

      bet = b(1)
      u(1) = r(1)/bet

      do j = 2,n
        gam(j) = c(j-1)/bet
        bet = b(j) - a(j)*gam(j)
        if (bet .eq. 0) call bl_error('tridiag: TRIDIAG FAILED')
        u(j) = (r(j)-a(j)*u(j-1))/bet
      end do

      do j = n-1,1,-1
        u(j) = u(j) - gam(j+1)*u(j+1)
      end do

      return
      end

      

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** SLOPEX **
c ** Compute the slope of nvar components of s in the x-direction
c *************************************************************************

      subroutine FORT_SLOPEX(s,slx,dxscr,DIMS,nvar,bc,slope_order)
 
      implicit none

      integer DIMS
      integer nvar
      REAL_T      s(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,nvar)
      REAL_T    slx(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1,nvar)
      REAL_T  dxscr(lo_1-2:hi_1+2,4)
      integer bc(2,3)
      integer slope_order

c     Local variables
      integer is,js,ks,ie,je,ke
      integer i,j,k,iv
      integer cen,lim,flag,fromm
      REAL_T del,slim,sflag
      REAL_T dpls,dmin,ds

      parameter( cen = 1 )
      parameter( lim = 2 )
      parameter( flag = 3 )
      parameter( fromm = 4 )

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

c     HERE DOING 1ST ORDER
      if (slope_order .eq. 0) then
        do iv = 1,nvar 
          do k = ks-1,ke+1 
           do j = js-1,je+1 
            do i = is-1,ie+1 
              slx(i,j,k,iv) = zero
            enddo
           enddo
          enddo
        enddo

c     HERE DOING 2ND ORDER
      else if (slope_order .eq. 2) then

        do iv=1,nvar 
          do k = ks-1,ke+1 
          do j = js-1,je+1 

            do i = is-1,ie+1 
              del = half*(s(i+1,j,k,iv) - s(i-1,j,k,iv))
              dpls = two*(s(i+1,j,k,iv) - s(i  ,j,k,iv))
              dmin = two*(s(i  ,j,k,iv) - s(i-1,j,k,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(i,j,k,iv)= sflag*min(slim,abs(del))
            enddo

            if (BCX_LO .eq. WALL  .or.  BCX_LO .eq. INLET) then

              slx(is-1,j,k,iv) = zero

              del = (s(is+1,j,k,iv)+three*s(is,j,k,iv)-
     $               four*s(is-1,j,k,iv) ) * third
              dpls = two*(s(is+1,j,k,iv) - s(is  ,j,k,iv))
              dmin = two*(s(is  ,j,k,iv) - s(is-1,j,k,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(is,j,k,iv)= sflag*min(slim,abs(del))

            elseif (BCX_LO .eq. OUTLET) then

              slx(is-1,j,k,iv)= zero

            endif

            if (BCX_HI .eq. WALL  .or.  BCX_HI .eq. INLET) then

              slx(ie+1,j,k,iv) = zero

              del = -(s(ie-1,j,k,iv)+three*s(ie,j,k,iv)-
     $                four*s(ie+1,j,k,iv)) * third
              dpls = two*(s(ie+1,j,k,iv) - s(ie  ,j,k,iv))
              dmin = two*(s(ie  ,j,k,iv) - s(ie-1,j,k,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(ie,j,k,iv)= sflag*min(slim,abs(del))

            elseif (BCX_HI .eq. OUTLET) then

              slx(ie+1,j,k,iv)= zero

            endif

          enddo
          enddo
        enddo

      else 

c     HERE DOING 4TH ORDER
      do iv=1,nvar 
        do k = ks-1,ke+1 
        do j = js-1,je+1 

          do i = is-2,ie+2 
            dxscr(i,cen) = half*(s(i+1,j,k,iv)-s(i-1,j,k,iv))
            dmin = two*(s(i  ,j,k,iv)-s(i-1,j,k,iv))
            dpls = two*(s(i+1,j,k,iv)-s(i  ,j,k,iv))
            dxscr(i,lim)= min(abs(dmin),abs(dpls))
            dxscr(i,lim) = cvmgp(dxscr(i,lim),zero,dpls*dmin)
            dxscr(i,flag) = sign(one,dxscr(i,cen))
            dxscr(i,fromm)= dxscr(i,flag)*min(dxscr(i,lim),
     $                      abs(dxscr(i,cen)))
          enddo

          do i = is-1,ie+1 
            ds = two * two3rd * dxscr(i,cen) - 
     $           sixth * (dxscr(i+1,fromm) + dxscr(i-1,fromm))
            slx(i,j,k,iv) = dxscr(i,flag)*min(abs(ds),dxscr(i,lim))
          enddo

          if (BCX_LO .eq. WALL  .or.  BCX_LO .eq. INLET) then

            slx(is-1,j,k,iv) = zero

            del = -sixteen/fifteen*s(is-1,j,k,iv) + half*s(is,j,k,iv) + 
     $                      two3rd*s(is+1,j,k,iv) - tenth*s(is+2,j,k,iv)
            dmin = two*(s(is  ,j,k,iv)-s(is-1,j,k,iv))
            dpls = two*(s(is+1,j,k,iv)-s(is  ,j,k,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            slx(is,j,k,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at is+1 using the revised dxscr(is,fromm)
            dxscr(is,fromm) = slx(is,j,k,iv)
            ds = two * two3rd * dxscr(is+1,cen) -
     $           sixth * (dxscr(is+2,fromm) + dxscr(is,fromm))
            slx(is+1,j,k,iv) = dxscr(is+1,flag)*min(abs(ds),dxscr(is+1,lim))

          elseif (BCX_LO .eq. OUTLET) then

            slx(is-1,j,k,iv)= zero

          endif

          if (BCX_HI .eq. WALL  .or.  BCX_HI .eq. INLET) then

            slx(ie+1,j,k,iv) = zero

            del = -( -sixteen/fifteen*s(ie+1,j,k,iv) + half*s(ie,j,k,iv) + 
     $                         two3rd*s(ie-1,j,k,iv) - tenth*s(ie-2,j,k,iv) )
            dmin = two*(s(ie  ,j,k,iv)-s(ie-1,j,k,iv))
            dpls = two*(s(ie+1,j,k,iv)-s(ie  ,j,k,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            slx(ie,j,k,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at ie-1 using the revised dxscr(ie,fromm)
            dxscr(ie,fromm) = slx(ie,j,k,iv)
            ds = two * two3rd * dxscr(ie-1,cen) -
     $           sixth * (dxscr(ie-2,fromm) + dxscr(ie,fromm))
            slx(ie-1,j,k,iv) = dxscr(ie-1,flag)*min(abs(ds),dxscr(ie-1,lim))

          elseif (BCX_HI .eq. OUTLET) then

            slx(ie+1,j,k,iv)= zero

          endif

        enddo
        enddo
      enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: GODUNOV_F.F,v 1.8 2002/11/14 23:04:56 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "GODUNOV_F.H"
#include "ArrayLim.H"

c=========================================================

      subroutine FORT_SET_PARAMS(slope_order_in,use_unlim_in)
      implicit none
      integer slope_order_in,use_unlim_in

#include "GODCOMM_F.H"

      slope_order = slope_order_in

      use_unlimited_slopes = (use_unlim_in .eq. 1)

      if(slope_order.ne.1.and.
#if (BL_SPACEDIM==2)
     &   slope_order.ne.2.and.
#endif
     &   slope_order.ne.4)then
        write(6,*)'FORT_SET_PARAMS : illegal value of slope_order = ',
     &            slope_order

        call bl_abort(" ")
      end if

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: FLUCTFILE.F,v 1.5 2000/06/29 20:49:05 sstanley Exp $
c

#undef BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "SPACE.H"
#include "CONSTANTS.H"
#include "FLUCTFILE.H"


c ::: -----------------------------------------------------------
c ::: This routine sets the values for the lo() and hi() arrays
c ::: from the ARG_L1, ARG_H1, ... macros.  This is done since
c ::: it is more convenient to use the lo() and hi() arrays.
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: DIMS(holder)  => index extent of place holder array
c ::: lo(3)        <=  lower index limits
c ::: hi(3)        <=  upper index limits
c ::: -----------------------------------------------------------

      subroutine FF_SET_LOHI(FF_DIMS(holder), lo, hi)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer FF_DIMDEC(holder)
      integer lo(3), hi(3)

c
c     --------------------------------------
c     :::: Set Values for lo() and hi() ::::
c     --------------------------------------
c
      lo(1) = FF_ARG_L1(holder)
      hi(1) = FF_ARG_H1(holder)
      lo(2) = FF_ARG_L2(holder)
      hi(2) = FF_ARG_H2(holder)
      lo(3) = FF_ARG_L3(holder)
      hi(3) = FF_ARG_H3(holder)

c
c
      return
      end



c ::: -----------------------------------------------------------
c ::: This routine sets the values for the ARG_L1, ARG_H1, ... macros
c ::: from the lo() and hi() arrays.  This is done since
c ::: it is more convenient to use the macros to dimension arrays.
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: FF_DIMS(holder) <=  index extent of place holder array
c ::: lo(3)            => lower index limits
c ::: hi(3)            => upper index limits
c ::: -----------------------------------------------------------

      subroutine FF_SET_ARGS(FF_DIMS(holder), lo, hi)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer FF_DIMDEC(holder)
      integer lo(3), hi(3)

c
c     --------------------------------------
c     :::: Set Values for lo() and hi() ::::
c     --------------------------------------
c
      FF_ARG_L1(holder) = lo(1)
      FF_ARG_H1(holder) = hi(1)
      FF_ARG_L2(holder) = lo(2)
      FF_ARG_H2(holder) = hi(2)
      FF_ARG_L3(holder) = lo(3)
      FF_ARG_H3(holder) = hi(3)

c
c
      return
      end



c
c ::: -----------------------------------------------------------
c ::: This routine reads the information from the header of a
c ::: inflow/initial conditions fluctuations file.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: iunit      => Fortran unit for the input fluctuations file
c ::: nCmpFile   => Number of components in the file
c ::: dimFile    => Dimensions from the fluctuations file
c ::: probSizeFile  => Domain size from the fluctuations file
c ::: dxFile     => Grid spacing from the fluctuations file
c ::: -----------------------------------------------------------
c
      SUBROUTINE RD_SCL_FLCTHD(iunit, nCmpFile, dimFile, probSizeFile, dxFile)

c
c     *****************************
c     *** Variable Declarations ***
c     *****************************
c
      IMPLICIT NONE

c
c     *** Passed Variables ***
c
      INTEGER iunit, dimFile(3), nCmpFile
      REAL_T probSizeFile(3), dxFile(3)

c
c     *** Local Variables ***
c
      integer i1bc, j1bc, k1bc


c 
c     *************************************
c     *** Read Header from Restart File ***
c     *************************************
c
      READ(iunit) dimFile, nCmpFile
      READ(iunit) probSizeFile
      READ(iunit) i1bc, j1bc, k1bc

      dxFile(1) = probSizeFile(1)/FLOAT(dimFile(1)-1)
      dxFile(2) = probSizeFile(2)/FLOAT(dimFile(2)-1)

      if (dimFile(3) .gt. 1) then
        dxFile(3) = probSizeFile(3)/FLOAT(dimFile(3)-1)
      else
        dxFile(3) = zero
      endif

c
c
      RETURN
      END



c
c ::: -----------------------------------------------------------
c ::: This routine reads the information from the header of a
c ::: inflow/initial conditions fluctuations file.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: iunit      => Fortran unit for the input fluctuations file
c ::: dimFile    => Dimensions from the fluctuations file
c ::: probSizeFile  => Domain size from the fluctuations file
c ::: dxFile     => Grid spacing from the fluctuations file
c ::: -----------------------------------------------------------
c
      SUBROUTINE RD_FLCTHD(iunit, dimFile, probSizeFile, dxFile)

c
c     *****************************
c     *** Variable Declarations ***
c     *****************************
c
      IMPLICIT NONE

c
c     *** Passed Variables ***
c
      INTEGER iunit, dimFile(3)
      REAL_T probSizeFile(3), dxFile(3)

c
c     *** Local Variables ***
c
      integer i1bc, j1bc, k1bc


c 
c     *************************************
c     *** Read Header from Restart File ***
c     *************************************
c
      READ(iunit) dimFile
      READ(iunit) probSizeFile
      READ(iunit) i1bc, j1bc, k1bc

      dxFile(1) = probSizeFile(1)/FLOAT(dimFile(1)-1)
      dxFile(2) = probSizeFile(2)/FLOAT(dimFile(2)-1)

      if (dimFile(3) .gt. 1) then
        dxFile(3) = probSizeFile(3)/FLOAT(dimFile(3)-1)
      else
        dxFile(3) = zero
      endif

c
c
      RETURN
      END



c ::: -----------------------------------------------------------
c ::: This routine reads a record of data from an inflow/initial
c ::: conditions fluctuations file.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: iunit         => Fortran unit for the input fluctuations file
c ::: dimFile       => Dimensions from the header of the fluctuations
c ::: arrLo, arrHi  => Range of the array to fill.  This must satisfy
c :::                    rdLgth(1) = arrHi(1) - arrLo(1) + 1
c :::                    dimFile(1) >= fileLo(1) + rdLgth(1) - 1
c ::: fileLo         => Offset into the array in the file indicating the
c :::                    first point to be read.
c ::: FF_DIMS(dat)  => Dimensions of the array dat
c ::: dat          <=  Array to fill
c ::: -----------------------------------------------------------
c
      SUBROUTINE RD_FLCTREC(iunit, dimFile, arrLo, arrHi, fileLo,
     $                      FF_DIMS(dat), dat)

c
c     *****************************
c     *** Variable Declarations ***
c     *****************************
c
      implicit none

c
c     *** Passed Variables ***
c
      integer iunit, dimFile(3)
      integer arrLo(3), arrHi(3), fileLo(3)
      integer FF_DIMDEC(dat)
      REAL_T dat(FF_DIMV(dat))

c
c     *** Local Variables ***
c
      integer i, j, k, ijoff, ipad, kpad
      REAL_T dummy


c
c     ***********************************
c     *** Read Data From Restart File ***
c     ***********************************
c
c     The logic here seems quite complicated.  This is done so that
c     only the data which is needed to fill the FAB is read from the
c     disk and stored into memory.  This should speed up the I/O as
c     well as keep the memory usage down.
c
c     *** Skip through records to the K-range desired as ***
c     ***   specified by fileLo(3)                        ***
c
      do k = 1, fileLo(3)-1
        READ(iunit) dummy
      enddo

c
c     *** Read the Necessary Data ***
c
      ijoff = (fileLo(2) - 1) * dimFile(1)
      ipad    = dimFile(1) - (fileLo(1)-1 + arrHi(1) - arrLo(1) + 1)

      do k = arrLo(3), arrHi(3)
        READ(iunit) (dummy, i=1, ijoff),
     $             ((dummy, i=1, fileLo(1)-1),
     $              (dat(i,j,k), i=arrLo(1),arrHi(1)),
     $              (dummy, i=1, ipad),                 j=arrLo(2),arrHi(2))
      enddo

c
c     *** Skip through the remaining records for this variable ***
c
      kpad    = dimFile(3) - (fileLo(3)-1 + arrHi(3) - arrLo(3) + 1)
      do k = 1, kpad
        READ(iunit) dummy
      enddo

c
c
      RETURN
      END

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "MACPROJ_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define CDIMS loc_1,loc_2,loc_3,hic_1,hic_2,hic_3

c *************************************************************************
c ** INITSIGMA **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIGMA(sigmax,sigmay,sigmaz,rho,DIMS,
     $                          bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  , lo_3  :hi_3)
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1, lo_3  :hi_3)
      REAL_T sigmaz(lo_1  :hi_1  ,lo_2  :hi_2  , lo_3  :hi_3+1)
      REAL_T    rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1, lo_3-1:hi_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i,j,k
      REAL_T minsig,maxsig

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 

        do i = lo_1+1,hi_1 
          sigmax(i,j,k) = two / (rho(i,j,k) + rho(i-1,j,k))
        enddo

        if (bcx_lo .eq. PERIODIC) then
          sigmax(lo_1,j,k) = two / (rho(lo_1,j,k) + rho(hi_1,j,k))
        else if (bcx_lo .eq. WALL) then
          sigmax(lo_1,j,k) = one / rho(lo_1,j,k)
        else if (bcx_lo .eq. INLET) then
          sigmax(lo_1,j,k) = one / rho(lo_1-1,j,k)
        else if (bcx_lo .eq. OUTLET) then
          sigmax(lo_1,j,k) = one / rho(lo_1,j,k)
        endif

        if (bcx_hi .eq. PERIODIC) then
          sigmax(hi_1+1,j,k) = sigmax(lo_1,j,k)
        else if (bcx_hi .eq. WALL) then
          sigmax(hi_1+1,j,k) = one / rho(hi_1,j,k)
        else if (bcx_hi .eq. INLET) then
          sigmax(hi_1+1,j,k) = one / rho(hi_1+1,j,k)
        else if (bcx_hi .eq. OUTLET) then
          sigmax(hi_1+1,j,k) = one / rho(hi_1,j,k)
        endif

      enddo
      enddo

      do k = lo_3,hi_3 
      do i = lo_1,hi_1 

        do j = lo_2+1,hi_2 
          sigmay(i,j,k) = two / (rho(i,j,k) + rho(i,j-1,k))
        enddo

        if (bcy_lo .eq. PERIODIC) then
          sigmay(i,lo_2,k) = two / (rho(i,lo_2,k) + rho(i,hi_2,k))
        else if (bcy_lo .eq. WALL) then
          sigmay(i,lo_2,k) = one / rho(i,lo_2  ,k)
        else if (bcy_lo .eq. INLET) then
          sigmay(i,lo_2,k) = one / rho(i,lo_2-1,k)
        else if (bcy_lo .eq. OUTLET) then
          sigmay(i,lo_2,k) = one / rho(i,lo_2  ,k)
        endif

        if (bcy_hi .eq. PERIODIC) then
          sigmay(i,hi_2+1,k) = sigmay(i,lo_2,k)
        else if (bcy_hi .eq. WALL) then
          sigmay(i,hi_2+1,k) = one / rho(i,hi_2  ,k)
        else if (bcy_hi .eq. INLET) then
          sigmay(i,hi_2+1,k) = one / rho(i,hi_2+1,k)
        else if (bcy_hi .eq. OUTLET) then
          sigmay(i,hi_2+1,k) = one / rho(i,hi_2  ,k)
        endif

      enddo
      enddo

      do j = lo_2,hi_2 
      do i = lo_1,hi_1 

        do k = lo_3+1,hi_3 
          sigmaz(i,j,k) = two / (rho(i,j,k) + rho(i,j,k-1))
        enddo

        if (bcz_lo .eq. PERIODIC) then
          sigmaz(i,j,lo_3) = two / (rho(i,j,lo_3) + rho(i,j,hi_3))
        else if (bcz_lo .eq. WALL) then
          sigmaz(i,j,lo_3) = one / rho(i,j,lo_3)
        else if (bcz_lo .eq. INLET) then
          sigmaz(i,j,lo_3) = one / rho(i,j,lo_3-1)
        else if (bcz_lo .eq. OUTLET) then
          sigmaz(i,j,lo_3) = one / rho(i,j,lo_3)
        endif

        if (bcz_hi .eq. PERIODIC) then
          sigmaz(i,j,hi_3+1) = sigmaz(i,j,lo_3)
        else if (bcz_hi .eq. WALL) then
          sigmaz(i,j,hi_3+1) = one / rho(i,j,hi_3)
        else if (bcz_hi .eq. INLET) then
          sigmaz(i,j,hi_3+1) = one / rho(i,j,hi_3+1)
        else if (bcz_hi .eq. OUTLET) then
          sigmaz(i,j,hi_3+1) = one / rho(i,j,hi_3)
        endif
      enddo
      enddo

      return
      end

c *************************************************************************
c ** GRADMAC **
c ** Compute the gradient of phi
c *************************************************************************

      subroutine FORT_GRADMAC(gradpx,gradpy,gradpz,phi,DIMS,hx,hy,hz,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T    phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T gradpx(lo_1:hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T gradpy(lo_1:hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T gradpz(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i, is, ie, j, js, je, k, ks, ke

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      do k = ks,ke 
      do j = js,je 
        do i = is,ie+1
          gradpx(i,j,k) = (phi(i,j,k) - phi(i-1,j,k))/hx
        enddo

        if (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) then
          gradpx(is  ,j,k) = zero
        endif
        if (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) then
          gradpx(ie+1,j,k) = zero
        endif

      enddo
      enddo

      do k = ks,ke 
      do i = is,ie 
        do j = js,je+1 
          gradpy(i,j,k) = (phi(i,j,k) - phi(i,j-1,k))/hy
        enddo

        if (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) then
          gradpy(i,js  ,k)= zero
        endif
        if (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) then
          gradpy(i,je+1,k) = zero
        endif

      enddo
      enddo

      do j = js,je 
      do i = is,ie 
        do k = ks,ke+1 
          gradpz(i,j,k) = (phi(i,j,k) - phi(i,j,k-1))/hz
        enddo

        if (bcz_lo .eq. WALL .or. bcz_lo .eq. INLET) then
          gradpz(i,j,ks  )= zero
        endif
        if (bcz_hi .eq. WALL .or. bcz_hi .eq. INLET) then
          gradpz(i,j,ke+1) = zero
        endif

      enddo
      enddo

      return
      end

c *************************************************************************
c ** PROJUMAC **
c ** Update the edge-based velocities
c *************************************************************************

      subroutine FORT_PROJUMAC(uadv,vadv,wadv,gradpx,gradpy,gradpz,rho,DIMS)

      implicit none

      integer DIMS
      REAL_T   uadv(lo_1  :hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T   vadv(lo_1  :hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T   wadv(lo_1  :hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T gradpx(lo_1  :hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T gradpy(lo_1  :hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T gradpz(lo_1  :hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T    rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)

c     Local variables
      REAL_T  rhx,rhy,rhz
      integer i,j,k

        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1+1

            rhx = two / (rho(i,j,k) + rho(i-1,j,k))
            uadv(i,j,k) = uadv(i,j,k) - gradpx(i,j,k) * rhx

        enddo
        enddo
        enddo

        do k = lo_3,hi_3 
        do j = lo_2,hi_2+1 
        do i = lo_1,hi_1 

            rhy = two / (rho(i,j,k) + rho(i,j-1,k))
            vadv(i,j,k) = vadv(i,j,k) - gradpy(i,j,k) * rhy

        enddo
        enddo
        enddo

        do k = lo_3,hi_3+1 
        do j = lo_2,hi_2 
        do i = lo_1,hi_1 

            rhz = two / (rho(i,j,k) + rho(i,j,k-1))
            wadv(i,j,k) = wadv(i,j,k) - gradpz(i,j,k) * rhz

        enddo
        enddo
        enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D( sig G(phi) )
c *************************************************************************

      subroutine FORT_RESIDUAL(resid,phi,f,sigmax,sigmay,sigmaz,DIMS,
     $                         hx,hy,hz,resnorm,
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T  resid(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T    phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1,lo_3  :hi_3  )
      REAL_T sigmaz(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3+1)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      REAL_T resnorm
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T hxsqinv, hysqinv, hzsqinv
      REAL_T rfac, corr
      integer i,j,k

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)
      hzsqinv = one/(hz*hz)

      resnorm = zero

      call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      do k = lo_3,hi_3 
      do j = lo_2,hi_2 
        do i = lo_1,hi_1 

          rfac = ( sigmax(i+1,j,k) + sigmax(i,j,k))*hxsqinv + 
     $           ( sigmay(i,j+1,k) + sigmay(i,j,k))*hysqinv +
     $           ( sigmaz(i,j,k+1) + sigmaz(i,j,k))*hzsqinv

          corr = 
     $      ( sigmax(i+1,j,k)*phi(i+1,j,k) + sigmax(i,j,k)*phi(i-1,j,k))*hxsqinv
     $     +( sigmay(i,j+1,k)*phi(i,j+1,k) + sigmay(i,j,k)*phi(i,j-1,k))*hysqinv
     $     +( sigmaz(i,j,k+1)*phi(i,j,k+1) + sigmaz(i,j,k)*phi(i,j,k-1))*hzsqinv

          resid(i,j,k) = f(i,j,k) - (corr - rfac*phi(i,j,k))

          resnorm = max(abs(resid(i,j,k)), resnorm)

        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRB **
c ** Gauss-Seidel red-black relaxation
c *************************************************************************

      subroutine FORT_GSRB(phi,f,sigmax,sigmay,sigmaz,DIMS,hx,hy,hz,
     $                     bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,nngsrb)

      implicit none

      integer DIMS
      REAL_T    phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T      f(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1,lo_3  :hi_3  )
      REAL_T sigmaz(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3+1)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      integer nngsrb

c     Local variables
      REAL_T hxsq, hysq, hzsq, rfac, corr
      integer i, j, k
      integer iter, ioff, iinc

      hxsq = hx*hx
      hysq = hy*hy
      hzsq = hz*hz

      call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      do iter = 1, nngsrb 
        do ioff = 0,1 
          do k = lo_3,hi_3 
          do j = lo_2,hi_2 
            iinc = mod(j+k+ioff,2)
            do i = lo_1+iinc,hi_1,2 

              rfac = (sigmax(i+1,j,k) + sigmax(i,j,k))/hxsq + 
     $               (sigmay(i,j+1,k) + sigmay(i,j,k))/hysq +
     $               (sigmaz(i,j,k+1) + sigmaz(i,j,k))/hzsq

              corr = 
     $        ( sigmax(i+1,j,k)*phi(i+1,j,k) + sigmax(i,j,k)*phi(i-1,j,k))/hxsq +
     $        ( sigmay(i,j+1,k)*phi(i,j+1,k) + sigmay(i,j,k)*phi(i,j-1,k))/hysq +
     $        ( sigmaz(i,j,k+1)*phi(i,j,k+1) + sigmaz(i,j,k)*phi(i,j,k-1))/hzsq

              phi(i,j,k) = (corr - f(i,j,k))/rfac

            enddo
          enddo
          enddo

          call bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

        enddo
      enddo

      return
      end


c *************************************************************************
c ** BC **
c ** Impose boundary conditions
c *************************************************************************

      subroutine bc(phi,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T  phi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      integer i, j, k, is, ie, js, je, ks, ke

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      if (bcz_lo .eq. OUTLET) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ks-1) = -phi(i,j,ks)
        enddo
        enddo
      elseif (bcz_lo .eq. INLET) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ks-1) =  phi(i,j,ks)
        enddo
        enddo
      elseif (bcz_lo .eq. WALL) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ks-1) = phi(i,j,ks)
        enddo
        enddo
      elseif (bcz_lo .eq. PERIODIC) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ks-1) = phi(i,j,ke)
        enddo
        enddo
      else
        print *,'bogus bcz_lo in bc ',bcz_lo
        stop
      endif

      if (bcz_hi .eq. OUTLET) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ke+1) = -phi(i,j,ke)
        enddo
        enddo
      elseif (bcz_hi .eq. INLET) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ke+1) =  phi(i,j,ke)
        enddo
        enddo
      elseif (bcz_hi .eq. WALL) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ke+1) = phi(i,j,ke)
        enddo
        enddo
      elseif (bcz_hi .eq. PERIODIC) then
        do j = js,je 
        do i = is,ie 
          phi(i,j,ke+1) = phi(i,j,ks)
        enddo
        enddo
      else
        print *,'bogus bcz_hi in bc ',bcz_hi
        stop
      endif

      if (bcy_lo .eq. OUTLET) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,js-1,k) = -phi(i,js,k)
        enddo
        enddo
      elseif (bcy_lo .eq. INLET) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,js-1,k) =  phi(i,js,k)
        enddo
        enddo
      elseif (bcy_lo .eq. WALL) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,js-1,k) = phi(i,js,k)
        enddo
        enddo
      elseif (bcy_lo .eq. PERIODIC) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,js-1,k) = phi(i,je,k)
        enddo
        enddo
      else
        print *,'bogus bcy_lo in bc ',bcy_lo
        stop
      endif

      if (bcy_hi .eq. OUTLET) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,je+1,k) = -phi(i,je,k)
        enddo
        enddo
      elseif (bcy_hi .eq. INLET) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,je+1,k) =  phi(i,je,k)
        enddo
        enddo
      elseif (bcy_hi .eq. WALL) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,je+1,k) = phi(i,je,k)
        enddo
        enddo
      elseif (bcy_hi .eq. PERIODIC) then
        do k = ks-1,ke+1
        do i = is,ie 
          phi(i,je+1,k) = phi(i,js,k)
        enddo
        enddo
      else
        print *,'bogus bcy_hi in bc ',bcy_hi
        stop
      endif

      if (bcx_lo .eq. OUTLET) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(is-1,j,k) = -phi(is,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. INLET) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(is-1,j,k) =  phi(is,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. WALL) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(is-1,j,k) = phi(is,j,k)
        enddo
        enddo
      elseif (bcx_lo .eq. PERIODIC) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(is-1,j,k) = phi(ie,j,k)
        enddo
        enddo
      else
        print *,'bogus bcx_lo in bc ',bcx_lo
        stop
      endif

      if (bcx_hi .eq. OUTLET) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(ie+1,j,k) = -phi(ie,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. INLET) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(ie+1,j,k) =  phi(ie,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. WALL) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(ie+1,j,k) = phi(ie,j,k)
        enddo
        enddo
      elseif (bcx_hi .eq. PERIODIC) then
        do k = ks-1,ke+1 
        do j = js-1,je+1 
          phi(ie+1,j,k) = phi(is,j,k)
        enddo
        enddo
      else
        print *,'bogus bcx_hi in bc ',bcx_hi
        stop
      endif

      return
      end

c *************************************************************************
c ** RHSMAC **
c ** Compute the right-hand-side D(U) for the MAC projection
c *************************************************************************

      subroutine FORT_RHSMAC(uadv,vadv,wadv,divu_src,rhs,DIMS,hx,hy,hz,rhsnorm)

      implicit none

      integer DIMS
      REAL_T     uadv(lo_1  :hi_1+1,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T     vadv(lo_1  :hi_1  ,lo_2:hi_2+1,lo_3:hi_3  )
      REAL_T     wadv(lo_1  :hi_1  ,lo_2:hi_2  ,lo_3:hi_3+1)
      REAL_T divu_src(lo_1  :hi_1  ,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T      rhs(lo_1  :hi_1  ,lo_2:hi_2  ,lo_3:hi_3  )
      REAL_T  hx
      REAL_T  hy
      REAL_T  hz
      REAL_T  rhsnorm

c     Local variables
      integer i,j,k

      rhsnorm = zero

      do k = lo_3,hi_3
      do j = lo_2,hi_2
        do i = lo_1,hi_1

          rhs(i,j,k) = (uadv(i+1,j,k) - uadv(i,j,k)) / hx +
     $                 (vadv(i,j+1,k) - vadv(i,j,k)) / hy +
     $                 (wadv(i,j,k+1) - wadv(i,j,k)) / hz
 
          rhs(i,j,k) = rhs(i,j,k) - divu_src(i,j,k)

          rhsnorm = max(rhsnorm,abs(rhs(i,j,k)))

        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** COARSIGMA **
c ** Coarsen the edge-based sigma coefficients
c *************************************************************************

      subroutine FORT_COARSIGMA(sigmax,sigmay,sigmaz,
     $                          sigmaxc,sigmayc,sigmazc,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T  sigmax(lo_1 :hi_1 +1,lo_2 :hi_2   ,lo_3:hi_3  )
      REAL_T  sigmay(lo_1 :hi_1   ,lo_2 :hi_2 +1,lo_3:hi_3  )
      REAL_T  sigmaz(lo_1 :hi_1   ,lo_2 :hi_2   ,lo_3:hi_3+1)
      REAL_T sigmaxc(loc_1:hic_1+1,loc_2:hic_2  ,loc_3:hic_3  )
      REAL_T sigmayc(loc_1:hic_1  ,loc_2:hic_2+1,loc_3:hic_3  )
      REAL_T sigmazc(loc_1:hic_1  ,loc_2:hic_2  ,loc_3:hic_3+1)

c     Local variables
      integer i,j,k,twoi,twoj,twok

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+lo_3

        do j = loc_2,hic_2 
          twoj = 2*(j-loc_2)+lo_2

          do i = loc_1,hic_1+1 
            twoi = 2*(i-loc_1)+lo_1

            sigmaxc(i,j,k) = fourth*(sigmax(twoi,twoj  ,twok  ) + 
     $                               sigmax(twoi,twoj+1,twok  ) +
     $                               sigmax(twoi,twoj  ,twok+1) +
     $                               sigmax(twoi,twoj+1,twok+1) )
        enddo
      enddo
      enddo

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+lo_3

        do j = loc_2,hic_2+1 
          twoj = 2*(j-loc_2)+lo_2

          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+lo_1

            sigmayc(i,j,k) = fourth*(sigmay(twoi  ,twoj,twok  ) + 
     $                               sigmay(twoi+1,twoj,twok  ) +
     $                               sigmay(twoi  ,twoj,twok+1) +
     $                               sigmay(twoi+1,twoj,twok+1) )
          enddo
        enddo
      enddo

      do k = loc_3,hic_3+1 
        twok = 2*(k-loc_3)+lo_3

        do j = loc_2,hic_2
          twoj = 2*(j-loc_2)+lo_2

          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+lo_1

              sigmazc(i,j,k) = fourth*(sigmaz(twoi  ,twoj  ,twok) + 
     $                                 sigmaz(twoi+1,twoj  ,twok) +
     $                                 sigmaz(twoi  ,twoj+1,twok) +
     $                                 sigmaz(twoi+1,twoj+1,twok) )
          enddo
        enddo
      enddo


      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservatively average the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T  res(lo_1 :hi_1 ,lo_2 :hi_2 ,lo_3 :hi_3)
      REAL_T resc(loc_1:hic_1,loc_2:hic_2,loc_3:hic_3)

c     Local variables
      integer i,j,k,twoi,twoj,twok

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+lo_3
        do j = loc_2,hic_2 
          twoj = 2*(j-loc_2)+lo_2
          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+lo_1
            resc(i,j,k) = (res(twoi  ,twoj,twok  ) + res(twoi  ,twoj+1,twok  ) + 
     $                     res(twoi+1,twoj,twok  ) + res(twoi+1,twoj+1,twok  ) +
     $                     res(twoi  ,twoj,twok+1) + res(twoi  ,twoj+1,twok+1) +
     $                     res(twoi+1,twoj,twok+1) + res(twoi+1,twoj+1,twok+1) )
            resc(i,j,k) = resc(i,j,k) * eighth
        enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INTERPOLATE **
c ** Piecewise constant interpolation
c *************************************************************************

      subroutine FORT_INTERPOLATE(phi,deltac,DIMS,CDIMS)

      implicit none

      integer DIMS
      integer CDIMS
      REAL_T    phi(lo_1 -1:hi_1 +1,lo_2 -1:hi_2 +1,lo_3 -1:hi_3 +1)
      REAL_T deltac(loc_1-1:hic_1+1,loc_2-1:hic_2+1,loc_3-1:hic_3+1)

c     Local variables
      integer i,j,k,twoi,twoj,twok

      do k = loc_3,hic_3 
        twok = 2*(k-loc_3)+lo_3
        do j = loc_2,hic_2 
          twoj = 2*(j-loc_2)+lo_2
          do i = loc_1,hic_1 
            twoi = 2*(i-loc_1)+lo_1

            phi(twoi  ,twoj  ,twok  ) = phi(twoi  ,twoj  ,twok  ) + deltac(i,j,k)
            phi(twoi+1,twoj  ,twok  ) = phi(twoi+1,twoj  ,twok  ) + deltac(i,j,k)
            phi(twoi  ,twoj+1,twok  ) = phi(twoi  ,twoj+1,twok  ) + deltac(i,j,k)
            phi(twoi+1,twoj+1,twok  ) = phi(twoi+1,twoj+1,twok  ) + deltac(i,j,k)
            phi(twoi  ,twoj  ,twok+1) = phi(twoi  ,twoj  ,twok+1) + deltac(i,j,k)
            phi(twoi+1,twoj  ,twok+1) = phi(twoi+1,twoj  ,twok+1) + deltac(i,j,k)
            phi(twoi  ,twoj+1,twok+1) = phi(twoi  ,twoj+1,twok+1) + deltac(i,j,k)
            phi(twoi+1,twoj+1,twok+1) = phi(twoi+1,twoj+1,twok+1) + deltac(i,j,k)
          enddo
        enddo
      enddo

      return
      end

c *************************************************************************
c ** SOLVEMAC **
c ** Conjugate gradient bottom-solver
c *************************************************************************

      subroutine FORT_SOLVEMAC(dest, dest0, source, sigmax, sigmay, sigmaz, 
     $                         sum,  r, w, z, work, DIMS , hx, hy, hz, 
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,
     $                         norm, prob_norm)

      implicit none

      integer DIMS

      REAL_T   dest(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  dest0(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T source(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1,lo_3  :hi_3  )
      REAL_T sigmaz(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3+1)
      REAL_T    sum(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T      r(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T      w(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T      z(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T   work(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      REAL_T norm
      REAL_T prob_norm

c     Local variables
      integer i,j,k,is,ie,js,je,ks,ke,iter
      REAL_T alpha, beta, rho, rhol
      REAL_T local_norm
      REAL_T  tol, tolfac
      REAL_T hxsqinv
      REAL_T hysqinv
      REAL_T hzsqinv

      tolfac = 1.0d-3

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)
      hzsqinv = one/(hz*hz)

      call bc(dest,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      do k = lo_3-1,hi_3+1
      do j = lo_2-1,hi_2+1
      do i = lo_1-1,hi_1+1
         dest0(i,j,k) = dest(i,j,k)
          dest(i,j,k) = zero
      enddo
      enddo
      enddo

 10   do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          w(i,j,k) = 
     $     ( sigmax(i+1,j,k)*dest0(i+1,j,k) + 
     $       sigmax(i  ,j,k)*dest0(i-1,j,k) )*hxsqinv + 
     $     ( sigmay(i,j+1,k)*dest0(i,j+1,k) + 
     $       sigmay(i,j  ,k)*dest0(i,j-1,k) )*hysqinv +
     $     ( sigmaz(i,j,k+1)*dest0(i,j,k+1) + 
     $       sigmaz(i,j,k  )*dest0(i,j,k-1) )*hzsqinv - 
     $    ( (sigmax(i+1,j,k) + sigmax(i,j,k))*hxsqinv + 
     $      (sigmay(i,j+1,k) + sigmay(i,j,k))*hysqinv +
     $      (sigmaz(i,j,k+1) + sigmaz(i,j,k))*hzsqinv )*dest0(i,j,k)
      enddo
      enddo
      enddo

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        r(i,j,k) = source(i,j,k) - w(i,j,k)
      enddo
      enddo
      enddo

      rho        = zero
      local_norm = zero

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho = rho + z(i,j,k) * r(i,j,k)
          local_norm = max(local_norm,abs(r(i,j,k)))
      enddo
      enddo
      enddo

      norm = local_norm

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          work(i,j,k) = zero
          dest(i,j,k) = z(i,j,k)
      enddo
      enddo
      enddo

      iter = 0
c     write(6,1000) iter, norm/prob_norm

100   call bc(dest,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          w(i,j,k) = 
     $     ( sigmax(i+1,j,k)*dest(i+1,j,k) + 
     $       sigmax(i  ,j,k)*dest(i-1,j,k) )*hxsqinv + 
     $     ( sigmay(i,j+1,k)*dest(i,j+1,k) + 
     $       sigmay(i,j  ,k)*dest(i,j-1,k) )*hysqinv +
     $     ( sigmaz(i,j,k+1)*dest(i,j,k+1) + 
     $       sigmaz(i,j,k  )*dest(i,j,k-1) )*hzsqinv - 
     $    ( (sigmax(i+1,j,k) + sigmax(i,j,k))*hxsqinv + 
     $      (sigmay(i,j+1,k) + sigmay(i,j,k))*hysqinv +
     $      (sigmaz(i,j,k+1) + sigmaz(i,j,k))*hzsqinv )*dest(i,j,k)
      enddo
      enddo
      enddo

      alpha = zero
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          alpha = alpha + dest(i,j,k)*w(i,j,k)
      enddo
      enddo
      enddo

      alpha = rho / alpha
      rhol = rho
      rho = zero
      norm = zero

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
          work(i,j,k) = work(i,j,k) + alpha * dest(i,j,k)
          r(i,j,k) = r(i,j,k) - alpha * w(i,j,k)
          z(i,j,k) = r(i,j,k) / sum(i,j,k)
          rho = rho + z(i,j,k) * r(i,j,k)
          norm = max(norm,abs(r(i,j,k)))
      enddo
      enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then

        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1
            dest(i,j,k) = work(i,j,k) + dest0(i,j,k)
        enddo
        enddo
        enddo

      else if (iter .ge. 100  .or.  norm .ge. 100.d0*local_norm) then

        tolfac = 10.d0 * tolfac
        iter = 1
        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1
            dest(i,j,k) = zero
        enddo
        enddo
        enddo
        goto 10

      else

        beta = rho / rhol
        do k = lo_3,hi_3
        do j = lo_2,hi_2
        do i = lo_1,hi_1
            dest(i,j,k) = z(i,j,k) + beta * dest(i,j,k)
        enddo
        enddo
        enddo
        goto 100

      endif

1000  format('Res/Res0 in solve: ',i4,2x,e12.5)

      return
      end

c *************************************************************************
c ** MKSUMMAC **
c ** Pre-compute the sum of coefficients for the conjugate gradient solver
c *************************************************************************

      subroutine FORT_MKSUMMAC(sigmax,sigmay,sigmaz,sum,DIMS,hx,hy,hz,
     $                         bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi)

      implicit none

      integer DIMS
      REAL_T sigmax(lo_1  :hi_1+1,lo_2  :hi_2  ,lo_3:hi_3  )
      REAL_T sigmay(lo_1  :hi_1  ,lo_2  :hi_2+1,lo_3:hi_3  )
      REAL_T sigmaz(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3:hi_3+1)
      REAL_T    sum(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3:hi_3)
      REAL_T hx
      REAL_T hy
      REAL_T hz
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi

c     Local variables
      REAL_T  hxsqinv
      REAL_T  hysqinv
      REAL_T  hzsqinv
      integer i,j,k

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)
      hzsqinv = one/(hz*hz)

      do k = lo_3,hi_3
      do j = lo_2,hi_2
        do i = lo_1,hi_1
          sum(i,j,k) = (sigmax(i+1,j,k) + sigmax(i,j,k))*hxsqinv +
     $                 (sigmay(i,j+1,k) + sigmay(i,j,k))*hysqinv +
     $                 (sigmaz(i,j,k+1) + sigmaz(i,j,k))*hzsqinv
          sum(i,j,k) = -sixth*sum(i,j,k)
        enddo
      enddo
      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define SDIMS slo_1,slo_2,slo_3,shi_1,shi_2,shi_3

c *************************************************************************
c ** PROBINIT **
c ** Read in the problem-dependent parameters for the FORTRAN common blocks
c *************************************************************************

      subroutine FORT_PROBINIT (name,namlen)
      integer namlen
      integer name(namlen)
      integer untin, i

#include "probdata.H"

      namelist /fortin/ prob_type, zero_dir,
     $                  in_xvel, in_yvel, in_zvel, in_density, in_tracer,
     $                  xblob, yblob, zblob, radblob, denblob, velfact

c      Build `probin' filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      character probin*(maxlen)

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      untin = 9
      if (namlen .eq. 0) then
         open(untin,file='probin',form='formatted',status='old')
      else
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if
  
      read(untin,fortin)
      close(unit=untin)

      end

c *************************************************************************
c ** INITDATA **
c ** Call the appropriate subroutine to initialize the data
c *************************************************************************

      subroutine FORT_INITDATA(state,DIMS,dx,time,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)
      REAL_T  time

      if (prob_type .eq. 1) then

        call initspin(state,dx,DIMS,numscal)

      else if (prob_type .eq. 2) then

        call initbubble(state,dx,DIMS,numscal)

      else if (prob_type .eq. 3) then

        call initshear(state,dx,DIMS,numscal)

      else if (prob_type .eq. 4) then

        call initchannel(state,dx,DIMS,numscal)

      else if (prob_type .eq. 5) then

        call initpoiseuille(state,dx,DIMS,numscal)

      else if (prob_type .eq. 6) then

c       call initfile(state,dx,DIMS,numscal)

        call initplate(state,dx,DIMS,numscal)

      else 

        print *,'DONT KNOW THIS PROBLEM TYPE: ',prob_type
        stop
 
      endif

      return
      end

c *************************************************************************
c ** INITSPIN **
c ** Initialize the constant density flow-in-a-box problem
c *************************************************************************

      subroutine initspin(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z 
      REAL_T spx, spy, spz, cpx, cpy, cpz
      integer i, j, k, n

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        z = dx(3)*(float(k) + half)

        spx = sin(0.5d0*x)
        cpx = cos(0.5d0*x)
        spy = sin(0.5d0*y)
        cpy = cos(0.5d0*y)
        spz = sin(0.5d0*z)
        cpz = cos(0.5d0*z)

        if (zero_dir .eq. 3) then
          state(i,j,k,1) =  velfact*two*spy*cpy*spx**2
          state(i,j,k,2) = -velfact*two*spx*cpx*spy**2
          state(i,j,k,3) =  zero
        else if (zero_dir .eq. 2) then
          state(i,j,k,3) =  velfact*two*spx*cpx*spz**2
          state(i,j,k,1) = -velfact*two*spz*cpz*spx**2
          state(i,j,k,2) =  zero
        else if (zero_dir .eq. 1) then
          state(i,j,k,2) =  velfact*two*spz*cpz*spy**2
          state(i,j,k,3) = -velfact*two*spy*cpy*spz**2
          state(i,j,k,1) =  zero
        endif

        state(i,j,k,4) = one

      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,3+n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITBUBBLE **
c ** Initialize the bubble-drop in a box problem
c *************************************************************************

      subroutine initbubble(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z, r
      integer i, j, k, n

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        state(i,j,k,1) = zero
        state(i,j,k,2) = zero
        state(i,j,k,3) = zero

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        z = dx(3)*(float(k) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)

        state(i,j,k,4) = one+(denblob-one)*(half+half*tanh(100.d0*(radblob-r)))
c       state(i,j,k,4) = cvmgt(denblob,one,r .lt. radblob)

      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,3+n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITSHEAR **
c ** Initialize a constant density doubly-periodic shear problem
c *************************************************************************

      subroutine initshear(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z
      integer i, j, k, n

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        z = dx(3)*(float(k) + half)

        if (zero_dir .eq. 3) then
          state(i,j,k,1) = tanh(30.d0*(fourth - abs(y-half)))
          state(i,j,k,2) = 0.05d0 * sin(two*Pi*x)
          state(i,j,k,3) = zero
        else if (zero_dir .eq. 2) then
          state(i,j,k,3) = tanh(30.d0*(fourth - abs(x-half)))
          state(i,j,k,1) = 0.05d0 * sin(two*Pi*z)
          state(i,j,k,2) = zero
        else if (zero_dir .eq. 1) then
          state(i,j,k,2) = tanh(30.d0*(fourth - abs(z-half)))
          state(i,j,k,3) = 0.05d0 * sin(two*Pi*y)
          state(i,j,k,1) = zero
        endif

        state(i,j,k,4) = one

      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,3+n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITCHANNEL **
c ** Initialize the channel inflow problem
c *************************************************************************

      subroutine initchannel(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z, r
      integer i, j, k, n

      do k = lo_3-1,hi_3+1
      do j = lo_2-1,hi_2+1
      do i = lo_1-1,hi_1+1

c       state(i,j,k,1) = in_xvel
c       state(i,j,k,2) = in_yvel
c       state(i,j,k,3) = in_zvel

        state(i,j,k,1) = zero
        state(i,j,k,2) = zero
        state(i,j,k,3) = zero

      enddo
      enddo
      enddo

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        z = dx(3)*(float(k) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)

        state(i,j,k,4) = cvmgt(denblob,in_density,r .lt. radblob)
        if (numscal .ge. 2) 
     $    state(i,j,k,5) = cvmgt(one    ,in_tracer ,r .lt. radblob)

      enddo
      enddo
      enddo

      do n = 3, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,3+n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITPOISEUILLE **
c ** Initialize the Poiseuille flow problem.
c *************************************************************************

      subroutine initpoiseuille(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z, r
      integer i, j, k, n

      do k = lo_3-1,hi_3+1
      do j = lo_2-1,hi_2+1
      do i = lo_1-1,hi_1+1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        z = dx(3)*(float(k) + half)

        state(i,j,k,1) = zero
        state(i,j,k,2) = zero
        state(i,j,k,3) = one - (x-one)*(x-one)

c       state(i,j,k,1) = one - (y-one)*(y-one)
c       state(i,j,k,2) = zero
c       state(i,j,k,3) = zero

c       state(i,j,k,1) = zero
c       state(i,j,k,2) = one - (z-one)*(z-one)
c       state(i,j,k,3) = zero

      enddo
      enddo
      enddo

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        z = dx(3)*(float(k) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)

        state(i,j,k,4) = cvmgt(denblob,in_density,r .lt. radblob)
        if (numscal .ge. 2) 
     $    state(i,j,k,5) = cvmgt(one    ,in_tracer ,r .lt. radblob)

      enddo
      enddo
      enddo

      do n = 3, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,3+n) = zero
      enddo
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITFILE **
c ** Initialize the constant density flow-in-a-box problem
c *************************************************************************

      subroutine initfile(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z 
      REAL_T spx, spy, spz, cpx, cpy, cpz
      integer i, j, k, n
      integer ifile,jfile,kfile,ibc,jbc,kbc,id,jd
      REAL_T scalex,scaley,scalez
      REAL_T scratch(131,131)

      open(2,file='InitTurb',form='unformatted')
 
      rewind 2

      read(2)ifile,jfile,kfile
      read(2)scalex,scaley,scalez
      read(2)ibc,jbc,kbc

      write(*,*) " how did i get here"
      write(*,*)ifile,jfile,kfile
      write(*,*)scalex,scaley,scalez
      write(*,*)ibc,jbc,kbc

      write(*,*) lo_1,lo_2,lo_3
      write(*,*) hi_1,hi_2,hi_3

      do n = 1,3
      read(2)((scratch(id,jd),id=1,ifile),jd=1,jfile)
      do k = lo_3,hi_3

      read(2)((scratch(id,jd),id=1,ifile),jd=1,jfile)

      do j = lo_2,hi_2
      do i = lo_1,hi_1

      state(i,j,k,n) = scratch(i+1,j+1)

      enddo
      enddo
      enddo
      read(2)((scratch(id,jd),id=1,ifile),jd=1,jfile)
      read(2)((scratch(id,jd),id=1,ifile),jd=1,jfile)
      enddo

      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,4) = one
      enddo
      enddo
      enddo

      do n = 2, numscal
      do k = lo_3,hi_3
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        state(i,j,k,3+n) = zero
      enddo
      enddo
      enddo
      enddo

      close(2)

      return
      end

      subroutine initplate(state,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,numscal+BL_SPACEDIM)
      REAL_T  dx(3)

c     Local variables
      REAL_T x, y, z 
      REAL_T spx, spy, spz, cpx, cpy, cpz
      REAL_T holesp,holerad,root3,xloc,yloc,xcen,ycen
      REAL_T scale,mean
      integer icell,jcell,npts
      integer i, j, k, n

      holesp = .0048d0
      holerad = .0016d0
      root3 = sqrt(3.d0)
      
      mean = Pi*holerad**2/(0.5d0*root3*holesp**2)
      scale = 3.0 / mean
      do k = lo_3,hi_3
         do j = lo_2,hi_2
            do i = lo_1,hi_1
               
               x = dx(1)*(dfloat(i) + 0.5d0)
               y = dx(2)*(dfloat(j) + 0.5d0)
               z = dx(3)*(dfloat(k) + 0.5d0)
               
               
               if(y.ge.0.d0)then
                  jcell = int(y / (half*root3*holesp))
               else
                  jcell = -1-int(-y/(half*root3*holesp))
               endif
               yloc = y-dfloat(jcell)*half*root3*holesp
               x = x-y/root3
               if(x.ge.0.d0)then
                  icell = int(x / (holesp))
               else
                  icell = -1-int(-x/(holesp))
               endif
               
               xloc = x - holesp * dfloat(icell) + yloc/root3
               xcen =.75d0*holesp
               ycen =(root3*.25d0)*holesp
               if(((xloc-xcen)**2 + (yloc-ycen)**2).le. holerad**2)then
                  state(i,j,k,3) = scale*(1.d0 - mean)
               else
                  state(i,j,k,3) = scale*(0.d0 - mean)
               endif
c               state(i,j,k,1) = .10d0*sin(2.d0*Pi*y/.05)*
c     &              sin(2.d0*Pi*3.d0*z/.05)
c               state(i,j,k,2) = .10d0*sin(2.d0*Pi*2.d0*x/.05)*
c     &              sin(2.d0*Pi*4.d0*z/.05)
               state(i,j,k,1) = .03d0*sin(2.d0*Pi*10*y/.05)*
     &              sin(2.d0*Pi*7.d0*z/.05)
     &              + .07d0*sin(2.d0*Pi*7*(y-.0012)/.05)*
     &              sin(2.d0*Pi*9.d0*(z-.314)/.05)
               state(i,j,k,2) = .04d0*sin(2.d0*Pi*11.d0*x/.05)*
     &              sin(2.d0*Pi*13.d0*z/.05)
     &              + .06d0*sin(2.d0*Pi*8*(x-.1)/.05)*
     &              sin(2.d0*Pi*13.d0*(z-.378)/.05)
               state(i,j,k,4) = one
            enddo
         enddo
      enddo
      
      do n = 2, numscal
         do k = lo_3,hi_3
            do j = lo_2,hi_2
               do i = lo_1,hi_1
                  state(i,j,k,3+n) = zero
               enddo
            enddo
         enddo
      enddo
      
      end


c *************************************************************************
c ** DERVORT **
c ** Derive a cell-centered vorticity
c *************************************************************************

      subroutine FORT_DERVORT(state,derval,derlo_1,derlo_2,derlo_3,
     $                        derhi_1,derhi_2,derhi_3,DIMS,dx)

      implicit none

      integer DIMS
      integer derlo_1,derlo_2,derlo_3
      integer derhi_1,derhi_2,derhi_3
      REAL_T  state(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,3)
      REAL_T  derval(derlo_1:derhi_1,derlo_2:derhi_2,derlo_3:derhi_3)
      REAL_T  dx(3)

c     Local variables
      integer i, j, k
      REAL_T derx, dery, derz

      do k = lo_3, hi_3 
       do j = lo_2, hi_2 
        do i = lo_1, hi_1 

          derx = eighth*(state(i+1,j+1,k-1,3)+state(i-1,j+1,k-1,3)
     $                  +state(i+1,j+1,k+1,3)+state(i-1,j+1,k+1,3)
     $                  -state(i+1,j-1,k-1,3)-state(i-1,j-1,k-1,3)
     $                  -state(i+1,j-1,k+1,3)-state(i-1,j-1,k+1,3)) / dx(2) -
     $           eighth*(state(i+1,j+1,k+1,2)+state(i-1,j+1,k+1,2)
     $                  +state(i+1,j-1,k+1,2)+state(i-1,j-1,k+1,2)
     $                  -state(i+1,j+1,k-1,2)-state(i-1,j+1,k-1,2)
     $                  -state(i+1,j-1,k-1,2)-state(i-1,j-1,k-1,2)) / dx(3)

          dery = eighth*(state(i+1,j+1,k-1,3)+state(i+1,j-1,k-1,3)
     $                  +state(i+1,j+1,k+1,3)+state(i+1,j-1,k+1,3)
     $                  -state(i-1,j+1,k-1,3)-state(i-1,j-1,k-1,3)
     $                  -state(i-1,j+1,k+1,3)-state(i-1,j-1,k+1,3)) / dx(1) -
     $           eighth*(state(i+1,j+1,k+1,1)+state(i-1,j+1,k+1,1)
     $                  +state(i+1,j-1,k+1,1)+state(i-1,j-1,k+1,1)
     $                  -state(i+1,j+1,k-1,1)-state(i-1,j+1,k-1,1)
     $                  -state(i+1,j-1,k-1,1)-state(i-1,j-1,k-1,1)) / dx(3)

          derz = eighth*(state(i+1,j+1,k-1,2)+state(i+1,j-1,k-1,2)
     $                  +state(i+1,j+1,k+1,2)+state(i+1,j-1,k+1,2)
     $                  -state(i-1,j+1,k-1,2)-state(i-1,j-1,k-1,2)
     $                  -state(i-1,j+1,k+1,2)-state(i-1,j-1,k+1,2)) / dx(1) -
     $           eighth*(state(i+1,j+1,k-1,1)+state(i-1,j+1,k-1,1)
     $                  +state(i+1,j+1,k+1,1)+state(i-1,j+1,k+1,1)
     $                  -state(i+1,j-1,k-1,1)-state(i-1,j-1,k-1,1)
     $                  -state(i+1,j-1,k+1,1)-state(i-1,j-1,k+1,1)) / dx(2)

          derval(i,j,k) = sqrt(derx**2 + dery**2 + derz**2)

        enddo
       enddo
      enddo

      return
      end

c *************************************************************************
c ** DERAVGP **
c ** Average nodal pressure onto cell centers for plotting purposes
c *************************************************************************

      subroutine FORT_DERAVGP(pressure,dat,DIMS)

      implicit none

      integer DIMS
      REAL_T  pressure(lo_1:hi_1+1,lo_2:hi_2+1,lo_3:hi_3+1)
      REAL_T       dat(lo_1:hi_1  ,lo_2:hi_2  ,lo_3:hi_3)

c     Local variables
      integer i, j, k

      do k = lo_3, hi_3
       do j = lo_2, hi_2
        do i = lo_1, hi_1
          dat(i,j,k) = (pressure(i,j  ,k  ) + pressure(i+1,j  ,k  ) +
     $                  pressure(i,j+1,k  ) + pressure(i+1,j+1,k  ) +
     $                  pressure(i,j  ,k+1) + pressure(i+1,j  ,k+1) +
     $                  pressure(i,j+1,k+1) + pressure(i+1,j+1,k+1) ) * eighth
        enddo
       enddo
      enddo

      return
      end

c *************************************************************************
c ** FORT_SET_CELL_VELBC **
c ** set velocity bc for computation of derived variables
c *************************************************************************

      subroutine FORT_SET_CELL_VELBC(u,DIMS,bc,irz,visc_coef,dx,time)
      
      implicit none

#include "probdata.H"      

      integer DIMS
      REAL_T     u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3,3)
      integer bc(2,3)
      integer irz
      REAL_T visc_coef
      REAL_T dx(2)
      REAL_T time

c     Local variables
      integer i, j, k, is, ie, js, je, ks, ke
      REAL_T x

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      if (BCZ_LO .eq. OUTLET) then
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ks-1,3) = u(i,j,ks,3)
          u(i,j,ks-1,2) = u(i,j,ks,2)
          u(i,j,ks-1,1) = u(i,j,ks,1)
        enddo
        enddo
      elseif (BCZ_LO .eq. INLET) then
        if (prob_type .eq. 5) then
          do j = js-1,je+1
          do i = is-1,ie+1
            x = (float(i)+half)*dx(1)
            u(i,j,ks-1,3) =  one - (x-one)*(x-one)
            u(i,j,ks-1,2) =  -u(i,j,ks,2)
            u(i,j,ks-1,1) =  -u(i,j,ks,1)
          enddo
          enddo
        else
          do j = js-1,je+1
          do i = is-1,ie+1
            u(i,j,ks-1,3) =  two* in_zvel - u(i,j,ks,3)
            u(i,j,ks-1,2) =  -u(i,j,ks,2)
            u(i,j,ks-1,1) =  -u(i,j,ks,1)
          enddo
          enddo
        endif
      elseif (BCZ_LO .eq. WALL) then
        do j = js-1,je+1
        do i = is-1,ie+1
           u(i,j,ks-1,3) =  -u(i,j,ks,3)
           u(i,j,ks-1,2) =  three*u(i,j,ks,2) - three*u(i,j,ks+1,2)+u(i,j,ks+2,2)
           u(i,j,ks-1,1) =  three*u(i,j,ks,1) - three*u(i,j,ks+1,1)+u(i,j,ks+2,1)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do j = js-1,je+1
           do i = is-1,ie+1
              u(i,j,ks-1,1) =  -u(i,j,ks,1)
              u(i,j,ks-1,2) =  -u(i,j,ks,2)
           enddo
           enddo
        endif
      endif

      if (BCZ_HI .eq. OUTLET) then
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ke+1,3) = u(i,j,ke,3)
          u(i,j,ke+1,2) = u(i,j,ke,2)
          u(i,j,ke+1,1) = u(i,j,ke,1)
        enddo
        enddo
      elseif (BCZ_HI .eq. INLET) then 
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ke+1,3) = two*in_zvel - u(i,j,ke,3)
          u(i,j,ke+1,2) = - u(i,j,ke,2)
          u(i,j,ke+1,1) = - u(i,j,ke,1)
        enddo
        enddo
      elseif (BCZ_HI .eq. WALL) then
        do j = js-1,je+1
        do i = is-1,ie+1
          u(i,j,ke+1,3) = -u(i,j,ke,3)
          u(i,j,ke+1,2) =  three*u(i,j,ke,2) - three*u(i,j,ke-1,2)+u(i,j,ke-2,2)
          u(i,j,ke+1,1) =  three*u(i,j,ke,1) - three*u(i,j,ke-1,1)+u(i,j,ke-2,1)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do j = js-1,je+1
           do i = is-1,ie+1
              u(i,j,ke+1,2) = -u(i,j,ke,2)
              u(i,j,ke+1,1) = -u(i,j,ke,1)
           enddo
           enddo
        endif
      endif

      if (BCY_LO .eq. OUTLET) then
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,js-1,k,3) = u(i,js,k,3)
          u(i,js-1,k,2) = u(i,js,k,2)
          u(i,js-1,k,1) = u(i,js,k,1)
        enddo
        enddo
      elseif (BCY_LO .eq. INLET) then
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,js-1,k,2) =  two* in_yvel - u(i,js,k,2)
          u(i,js-1,k,3) =  -u(i,js,k,3)
          u(i,js-1,k,1) =  -u(i,js,k,1)
        enddo
        enddo
      elseif (BCY_LO .eq. WALL) then
        do k = ks-1,ke+1
        do i = is-1,ie+1
           u(i,js-1,k,2) =  -u(i,js,k,2)
           u(i,js-1,k,1) =  three*u(i,js,k,1) - three*u(i,js+1,k,1)+u(i,js+2,k,1)
           u(i,js-1,k,3) =  three*u(i,js,k,3) - three*u(i,js+1,k,3)+u(i,js+2,k,3)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do i = is-1,ie+1
              u(i,js-1,k,1) =  -u(i,js,k,1)
              u(i,js-1,k,3) =  -u(i,js,k,3)
           enddo
           enddo
        endif
      endif

      if (BCY_HI .eq. OUTLET) then
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,je+1,k,3) = u(i,je,k,3)
          u(i,je+1,k,2) = u(i,je,k,2)
          u(i,je+1,k,1) = u(i,je,k,1)
        enddo
        enddo
      elseif (BCY_HI .eq. INLET) then 
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,je+1,k,2) = two*in_yvel - u(i,je,k,2)
          u(i,je+1,k,3) = - u(i,je,k,3)
          u(i,je+1,k,1) = - u(i,je,k,1)
        enddo
        enddo
      elseif (BCY_HI .eq. WALL) then
        do k = ks-1,ke+1
        do i = is-1,ie+1
          u(i,je+1,k,2) = -u(i,je,k,2)
          u(i,je+1,k,3) =  three*u(i,je,k,3) - three*u(i,je-1,k,3)+u(i,je-2,k,3)
          u(i,je+1,k,1) =  three*u(i,je,k,1) - three*u(i,je-1,k,1)+u(i,je-2,k,1)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do i = is-1,ie+1
              u(i,je+1,k,3) = -u(i,je,k,3)
              u(i,je+1,k,1) = -u(i,je,k,1)
           enddo
           enddo
        endif
      endif

      if (BCX_LO .eq. OUTLET) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k,1) = u(is,j,k,1)
          u(is-1,j,k,2) = u(is,j,k,2)
          u(is-1,j,k,3) = u(is,j,k,3)
        enddo
        enddo
      elseif (BCX_LO .eq. INLET) then 
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k,1) =  two*in_xvel - u(is,j,k,1)
          u(is-1,j,k,2) =  - u(is,j,k,2)
          u(is-1,j,k,3) =  - u(is,j,k,3)
        enddo
        enddo
      elseif (BCX_LO .eq. WALL) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(is-1,j,k,1) =  -u(is,j,k,1)
          u(is-1,j,k,2) =  three*u(is,j,k,2)-three*u(is+1,j,k,2)+u(is+2,j,k,2)
          u(is-1,j,k,3) =  three*u(is,j,k,3)-three*u(is+1,j,k,3)+u(is+2,j,k,3)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do j = js-1,je+1
              u(is-1,j,k,2) =  -u(is,j,k,2)
              u(is-1,j,k,3) =  -u(is,j,k,3)
           enddo
           enddo
        endif
      endif

      if (BCX_HI .eq. OUTLET) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k,1) = u(ie,j,k,1)
          u(ie+1,j,k,2) = u(ie,j,k,2)
          u(ie+1,j,k,3) = u(ie,j,k,3)
        enddo
        enddo
      elseif (BCX_HI .eq. INLET) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k,1) = two *in_xvel - u(ie,j,k,1)
          u(ie+1,j,k,2) = - u(ie,j,k,2)
          u(ie+1,j,k,3) = - u(ie,j,k,3)
        enddo
        enddo
      elseif (BCX_HI .eq. WALL) then
        do k = ks-1,ke+1
        do j = js-1,je+1
          u(ie+1,j,k,1) = - u(ie,j,k,1)
          u(ie+1,j,k,2) =  three*u(ie,j,k,2)-three*u(ie-1,j,k,2)+u(ie-2,j,k,2)
          u(ie+1,j,k,3) =  three*u(ie,j,k,3)-three*u(ie-1,j,k,3)+u(ie-2,j,k,3)
        enddo
        enddo
        if (visc_coef .gt. zero) then
           do k = ks-1,ke+1
           do j = js-1,je+1
              u(ie+1,j,k,2) = - u(ie,j,k,2)
              u(ie+1,j,k,3) = - u(ie,j,k,3)
           enddo
           enddo
        endif
      endif

      return
      end

c *************************************************************************
c ** VELINFLOW **
c ** Impose the inflow boundary conditions on velocity
c *************************************************************************

      subroutine velinflow(u,DIMS,time,dx,idir,is_hi)

      implicit none

#include "probdata.H"

      integer DIMS
      REAL_T u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3)
      REAL_T time
      REAL_T dx(3)
      integer idir,is_hi

c     Local variables
      integer i,j,k
      REAL_T  x,y,z

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          if (prob_type .eq. 5) then
            do k = lo_3-3,hi_3+3
            do j = lo_2-3,hi_2+3
              y = (float(j)+half)*dx(2)
              u(lo_1-1,j,k) = one - (y-one)*(y-one)
              u(lo_1-2,j,k) = one - (y-one)*(y-one)
              u(lo_1-3,j,k) = one - (y-one)*(y-one)
            enddo
            enddo
          else
            do k = lo_3-3,hi_3+3
            do j = lo_2-3,hi_2+3
              u(lo_1-1,j,k) = in_xvel
              u(lo_1-2,j,k) = in_xvel
              u(lo_1-3,j,k) = in_xvel
            enddo
            enddo
          endif
        else
          do k = lo_3-3,hi_3+3 
          do j = lo_2-3,hi_2+3
            u(hi_1+1,j,k) = in_xvel
            u(hi_1+2,j,k) = in_xvel
            u(hi_1+3,j,k) = in_xvel
          enddo
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          if (prob_type .eq. 5) then
            do k = lo_3-3,hi_3+3
            do i = lo_1-3,hi_1+3 
              z = (float(k)+half)*dx(3)
              u(i,lo_2-1,k) = one - (z-one)*(z-one)
              u(i,lo_2-2,k) = one - (z-one)*(z-one)
              u(i,lo_2-3,k) = one - (z-one)*(z-one)
            enddo
            enddo
          else
            do k = lo_3-3,hi_3+3
            do i = lo_1-3,hi_1+3 
              u(i,lo_2-1,k) = in_yvel
              u(i,lo_2-2,k) = in_yvel
              u(i,lo_2-3,k) = in_yvel
            enddo
            enddo
          endif
        else
          do k = lo_3-3,hi_3+3 
          do i = lo_1-3,hi_1+3
            u(i,hi_2+1,k) = in_yvel
            u(i,hi_2+2,k) = in_yvel
            u(i,hi_2+3,k) = in_yvel
          enddo
          enddo
        endif

      elseif (idir .eq. 2) then

        if (is_hi .eq. 0) then
          if (prob_type .eq. 5) then
            do j = lo_2-3,hi_2+3 
            do i = lo_1-3,hi_1+3 
              x = (float(i)+half)*dx(1)
              u(i,j,lo_3-1) = one - (x-one)*(x-one)
              u(i,j,lo_3-2) = one - (x-one)*(x-one)
              u(i,j,lo_3-3) = one - (x-one)*(x-one)
            enddo
            enddo
          else
            do j = lo_2-3,hi_2+3 
            do i = lo_1-3,hi_1+3 
              u(i,j,lo_3-1) = in_zvel
              u(i,j,lo_3-2) = in_zvel
              u(i,j,lo_3-3) = in_zvel
            enddo
            enddo
          endif
        else
          do j = lo_2-3,hi_2+3 
          do i = lo_1-3,hi_1+3 
            u(i,j,hi_3+1) = in_zvel
            u(i,j,hi_3+2) = in_zvel
            u(i,j,hi_3+3) = in_zvel
          enddo
          enddo
        endif

      else
        print *,'bogus idir in velinflow ',idir
        stop
      endif

      return
      end

c *************************************************************************
c ** SCALINFLOW **
c ** Impose the inflow boundary conditions on scalars
c *************************************************************************

      subroutine scalinflow(s,DIMS,SDIMS,time,dx,idir,is_hi,which_scal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer SDIMS
      REAL_T  s(slo_1:shi_1,slo_2:shi_2,slo_3:shi_3)
      REAL_T  time
      REAL_T  dx(3)
      integer idir, is_hi
      integer which_scal

c     Local variables
      integer i,j,k
      integer ng,ngmax
      REAL_T  inflow_val

      ngmax = lo_1-slo_1
    
      if (which_scal .eq. 0) then
        inflow_val = in_density
      elseif (which_scal .eq. 1) then
        inflow_val = in_tracer
      else
        print *,"STOP IN SCALINFLOW "
        print *," --  DONT HAVE VALUE FOR THIS VARIABLE "
        stop
      endif

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do ng = 1,ngmax
          do k = slo_3,shi_3
          do j = slo_2,shi_2
            s(lo_1-ng,j,k) = inflow_val
          enddo
          enddo
          enddo
        else
          do ng = 1,ngmax
          do k = slo_3,shi_3 
          do j = slo_2,shi_2 
            s(hi_1+ng,j,k) = inflow_val
          enddo
          enddo
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          do ng = 1,ngmax
          do k = slo_3,shi_3 
          do i = slo_1,shi_1 
            s(i,lo_2-ng,k) = inflow_val
          enddo
          enddo
          enddo
        else
          do ng = 1,ngmax
          do k = slo_3,shi_3 
          do i = slo_1,shi_1
            s(i,hi_2+ng,k) = inflow_val
          enddo
          enddo
          enddo
        endif

      elseif (idir .eq. 2) then

        if (is_hi .eq. 0) then
          do ng = 1,ngmax
          do j = slo_2,shi_2
          do i = slo_1,shi_1
            s(i,j,lo_3-ng) = inflow_val
          enddo
          enddo
          enddo
        else
          do ng = 1,ngmax
          do j = slo_2,shi_2 
          do i = slo_1,shi_1 
            s(i,j,hi_3+ng) = inflow_val
          enddo
          enddo
          enddo
        endif

      else

        print *,'bogus idir in scalinflow ',idir
        stop

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: GODUNOV_3D.F,v 1.28 2003/02/18 21:46:35 almgren Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "GODUNOV_F.H"
#include "ArrayLim.H"

#define SDIM 3
#define XVEL 1
#define YVEL 2
#define ZVEL 3
#define RHO  4

#define ALL  999

      subroutine FORT_ESTDT (
     &     vel,DIMS(vel),
     &     tforces,DIMS(tf),
     &     rho,DIMS(rho),
     &     lo,hi,dt,dx,cfl,u_max)
c 
c     ----------------------------------------------------------
c     estimate the timestep for this grid and scale by CFL number
c     This routine sets dt as dt = dt_est*cfl where
c     dt_est is estimated from the actual velocities and their 
c     total forcing
c     ----------------------------------------------------------
c 
      integer i, j, k
      REAL_T  u, v, w
      REAL_T  small
      REAL_T  dt_start
      REAL_T  tforce1,tforce2,tforce3
      integer lo(SDIM), hi(SDIM)
      REAL_T  dt,dx(SDIM),cfl,u_max(SDIM)

      integer DIMDEC(vel)
      integer DIMDEC(rho)
      integer DIMDEC(tf)

      REAL_T  vel(DIMV(vel),SDIM)
      REAL_T  rho(DIMV(rho))
      REAL_T  tforces(DIMV(tf),SDIM)

      small   = 1.0D-8
      u       = zero
      v       = zero
      w       = zero
      tforce1 = zero
      tforce2 = zero
      tforce3 = zero

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               u = max(u,abs(vel(i,j,k,1)))	
               v = max(v,abs(vel(i,j,k,2)))
               w = max(w,abs(vel(i,j,k,3)))
c               tforce1 = max(tforce1,abs(tforces(i,j,k,1)/rho(i,j,k)))
c               tforce2 = max(tforce2,abs(tforces(i,j,k,2)/rho(i,j,k)))
c               tforce3 = max(tforce3,abs(tforces(i,j,k,3)/rho(i,j,k)))
            end do
         end do
      end do

      u_max(1) = u
      u_max(2) = v
      u_max(3) = w

      dt_start = 1.0D+20
      dt = dt_start

      if (u .gt. small) dt = min(dt,dx(1)/u)
      if (v .gt. small) dt = min(dt,dx(2)/v)
      if (w .gt. small) dt = min(dt,dx(3)/w)

      if (tforce1 .gt. small) then
         dt  = min(dt,sqrt(two*dx(1)/tforce1))
      end if

      if (tforce2 .gt. small) then
         dt  = min(dt,sqrt(two*dx(2)/tforce2))
      end if

      if (tforce3 .gt. small) then
         dt  = min(dt,sqrt(two*dx(3)/tforce3))
      end if

      if (dt .eq. dt_start) dt = min(dx(1),dx(2),dx(3))

      dt = dt*cfl

      end

      subroutine FORT_TEST_U_RHO(
     &     u,DIMS(u),
     &     v,DIMS(v),
     &     w,DIMS(w),
     &     rho,DIMS(rho),
     &     lo,hi,dt,dx,cflmax,u_max,verbose)
c
c     This subroutine computes the extrema of the density
c     and velocities at cell centers
c
      integer DIMDEC(u)
      integer DIMDEC(v)
      integer DIMDEC(w)
      integer DIMDEC(rho)
      integer imin, imax, jmin, jmax, kmin, kmax
      integer i, j, k
      integer lo(SDIM),hi(SDIM)
      REAL_T  dx(SDIM), u_max(SDIM),cflmax, dt
      REAL_T  hx, hy, hz
      REAL_T  umax, vmax, wmax, rhomax
      REAL_T  umin, vmin, wmin, rhomin
      REAL_T  u(DIMV(u))
      REAL_T  v(DIMV(v))
      REAL_T  w(DIMV(w))
      REAL_T  rho(DIMV(rho))
      integer verbose

      hx   = dx(1)
      hy   = dx(2)
      hz   = dx(3)
      imin = lo(1)
      imax = hi(1)
      jmin = lo(2)
      jmax = hi(2)
      kmin = lo(3)
      kmax = hi(3)
      umax = -1.d200
      vmax = -1.d200
      wmax = -1.d200
      umin =  1.d200
      vmin =  1.d200
      wmin =  1.d200
      rhomax = -1.d200
      rhomin =  1.d200

      do k = kmin, kmax
         do j = jmin, jmax
            do i = imin, imax
               umax = max(umax,u(i,j,k))
               umin = min(umin,u(i,j,k))
               vmax = max(vmax,v(i,j,k))
               vmin = min(vmin,v(i,j,k))
               wmax = max(wmax,w(i,j,k))
               wmin = min(wmin,w(i,j,k))
               rhomax = max(rhomax,rho(i,j,k))
               rhomin = min(rhomin,rho(i,j,k))
            end do
         end do
      end do

      u_max(1) = max(abs(umax), abs(umin))
      u_max(2) = max(abs(vmax), abs(vmin))
      u_max(3) = max(abs(wmax), abs(wmin))
      cflmax   = dt*max(u_max(1)/hx,u_max(2)/hy,u_max(3)/hz)

      if(verbose.eq.1)then
         write(6,1000) umax,umin,u_max(1)
         write(6,1001) vmax,vmin,u_max(2)
         write(6,1002) wmax,wmin,u_max(3)
         write(6,1003) rhomax,rhomin
#ifndef	BL_NO_FORT_FLUSH
c         call flush(6)
#endif
      end if

 1000 format(' U  MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1001 format(' V  MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1002 format(' W  MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1003 format('RHO MAX/MIN      ',e21.14,2x,e21.14)

      end

      subroutine FORT_TEST_UMAC_RHO(
     &     umac,DIMS(umac),
     &     vmac,DIMS(vmac),
     &     wmac,DIMS(wmac),
     &     rho,DIMS(rho),
     &     lo,hi,dt,dx,cflmax,u_max)
c
c     This subroutine computes the extrema of the density
c     and mac edge velocities
c
      integer lo(SDIM),hi(SDIM)
      REAL_T  dt, dx(SDIM), u_max(SDIM), cflmax
      integer imin, imax, jmin, jmax, kmin, kmax
      integer i, j, k
      REAL_T  hx, hy, hz
      REAL_T  umax, vmax, wmax, rhomax
      REAL_T  umin, vmin, wmin, rhomin

      integer DIMDEC(umac)
      integer DIMDEC(vmac)
      integer DIMDEC(wmac)
      integer DIMDEC(rho)

      REAL_T  umac(DIMV(umac))
      REAL_T  vmac(DIMV(vmac))
      REAL_T  wmac(DIMV(wmac))
      REAL_T  rho(DIMV(rho))

      hx   = dx(1)
      hy   = dx(2)
      hz   = dx(3)
      imin = lo(1)
      imax = hi(1)
      jmin = lo(2)
      jmax = hi(2)
      kmin = lo(3)
      kmax = hi(3)
      umax = -1.d200
      vmax = -1.d200
      wmax = -1.d200
      umin =  1.d200
      vmin =  1.d200
      wmin =  1.d200
      rhomax = -1.d200
      rhomin =  1.d200

      do k = kmin, kmax
         do j = jmin, jmax
            do i = imin, imax+1
               umax = max(umax,umac(i,j,k))
               umin = min(umin,umac(i,j,k))
            end do
         end do
      end do

      do k = kmin, kmax
         do j = jmin, jmax+1
            do i = imin, imax
               vmax = max(vmax,vmac(i,j,k))
               vmin = min(vmin,vmac(i,j,k))
            end do
         end do
      end do

      do k = kmin, kmax+1
         do j = jmin, jmax
            do i = imin, imax
               wmax = max(wmax,wmac(i,j,k))
               wmin = min(wmin,wmac(i,j,k))
            end do
         end do
      end do

      do k = kmin, kmax
         do j = jmin, jmax
            do i = imin, imax
               rhomax = max(rhomax,rho(i,j,k))
               rhomin = min(rhomin,rho(i,j,k))
            end do
         end do
      end do

      u_max(1) = max(abs(umax), abs(umin))
      u_max(2) = max(abs(vmax), abs(vmin))
      u_max(3) = max(abs(wmax), abs(wmin))
      cflmax   = dt*max(u_max(1)/hx,u_max(2)/hy,u_max(3)/hz)

      write(6,1000) umax,umin,u_max(1)
      write(6,1001) vmax,vmin,u_max(2)
      write(6,1002) wmax,wmin,u_max(3)
      write(6,1003) rhomax,rhomin

 1000 format('UMAC MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1001 format('VMAC MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1002 format('WMAC MAX/MIN/AMAX ',e21.14,2x,e21.14,2x,e21.14)
 1003 format('RHO  MAX/MIN      ',e21.14,2x,e21.14)

#ifndef	BL_NO_FORT_FLUSH
c      call flush(6)
#endif

      end

      subroutine FORT_TRANSVEL(
     &     u, ulo, uhi, sx, ubc, slxscr,
     &     v, vlo, vhi, sy, vbc, slyscr,
     &     w, wlo, whi, sz, wbc, slzscr,
     &     DIMS(s), DIMS(work),
     &     lo,hi,dt,dx,use_minion,tforces)
c
c     This subroutine computes the advective velocities used in
c     the transverse derivatives of the Godunov box
c
      implicit none
      integer i,j,k
      integer ubc(SDIM,2),vbc(SDIM,2),wbc(SDIM,2)
      integer lo(SDIM),hi(SDIM)
      integer imin,jmin,kmin,imax,jmax,kmax
      REAL_T hx, hy, hz, dth, dthx, dthy, dthz
      REAL_T dt, dx(SDIM)
      REAL_T eps, eps_for_bc, val, tst
      logical ltm
      parameter (eps        = 1.d-6 )
      parameter (eps_for_bc = 1.d-10)

      integer DIMDEC(s)
      integer DIMDEC(work)
      REAL_T  u(DIMV(s))
      REAL_T  v(DIMV(s))
      REAL_T  w(DIMV(s))
      REAL_T ulo(DIMV(work)),uhi(DIMV(work))
      REAL_T vlo(DIMV(work)),vhi(DIMV(work))
      REAL_T wlo(DIMV(work)),whi(DIMV(work))
      REAL_T sx(DIMV(work))
      REAL_T sy(DIMV(work))
      REAL_T sz(DIMV(work))
      REAL_T slxscr(DIM1(s), 4)
      REAL_T slyscr(DIM2(s), 4)
      REAL_T slzscr(DIM3(s), 4)

      integer use_minion
      REAL_T tforces(DIMV(work),SDIM)

      dth  = half*dt
      dthx = half*dt / dx(1)
      dthy = half*dt / dx(2)
      dthz = half*dt / dx(3)
      hx   = dx(1)
      hy   = dx(2)
      hz   = dx(3)
      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     =============== THE SCREWY ORDER is to maximize comparability
c     with the old fortran
c     --------------------------------------------------------------
c     compute the x transverse velocities
c     --------------------------------------------------------------
c     --------------------------------------------------------------
c     compute the y transverse velocities
c     --------------------------------------------------------------
c     --------------------------------------------------------------
c     compute the z transverse velocities
c     --------------------------------------------------------------
c
      call FORT_SLOPES( XVEL,
     &     u,DIMS(s),
     &     sx,sy,sz,DIMS(work),
     &     lo,hi,slxscr,slyscr,slzscr,ubc)

      do k = kmin-1,kmax+1
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               ulo(i,j,k) = u(i-1,j,k) + (half  - dthx*u(i-1,j,k))*sx(i-1,j,k)
               uhi(i,j,k) = u(i,  j,k) + (-half - dthx*u(i,  j,k))*sx(i,  j,k)
            end do
         end do
      end do

      if (use_minion .eq. 1 )then
         do k = kmin-1,kmax+1
            do j = jmin-1,jmax+1
               do i = imin,  imax+1
                  ulo(i,j,k) = ulo(i,j,k) + dth*tforces(i-1,j,k,1)
                  uhi(i,j,k) = uhi(i,j,k) + dth*tforces(i,  j,k,1)
               end do
            end do
         end do
      end if

      call FORT_SLOPES(YVEL,
     &     v,DIMS(s),
     &     sx,sy,sz,DIMS(work),
     &     lo,hi,slxscr,slyscr,slzscr,vbc)

      do k = kmin-1,kmax+1
         do j = jmin,  jmax+1
            do i = imin-1,imax+1
               vlo(i,j,k) = v(i,j-1,k) + (half  - dthy*v(i,j-1,k))*sy(i,j-1,k)
               vhi(i,j,k) = v(i,j,  k) + (-half - dthy*v(i,j,  k))*sy(i,j,  k)
            end do
         end do
      end do

      if (use_minion .eq. 1 )then
         do k = kmin-1,kmax+1
            do j = jmin,    jmax+1
               do i = imin-1,  imax+1
                  vlo(i,j,k) = vlo(i,j,k) + dth*tforces(i,j-1,k,2)
                  vhi(i,j,k) = vhi(i,j,k) + dth*tforces(i,j,  k,2)
               end do
            end do
         end do
      end if

      call FORT_SLOPES(ZVEL,
     &     w,DIMS(s),
     &     sx,sy,sz,DIMS(work),
     &     lo,hi,slxscr,slyscr,slzscr,wbc)

      do k = kmin,kmax+1
         do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               wlo(i,j,k) = w(i,j,k-1) + (half  - dthz*w(i,j,k-1))*sz(i,j,k-1)
               whi(i,j,k) = w(i,j,k  ) + (-half - dthz*w(i,j,k  ))*sz(i,j,k  )
            end do
         end do
      end do

      if (use_minion .eq. 1 )then
         do k = kmin,kmax+1
            do j = jmin-1,jmax+1
               do i = imin-1,  imax+1
                  wlo(i,j,k) = wlo(i,j,k) + dth*tforces(i,j,k-1,3)
                  whi(i,j,k) = whi(i,j,k) + dth*tforces(i,j,k,  3)
               end do
            end do
         end do
      end if

      call trans_xbc(
     &     u,DIMS(s),
     &     ulo,uhi,DIMS(work),ulo,DIMS(work),
     &     lo,hi,XVEL,ubc,eps_for_bc)

      call trans_ybc(
     &     v,DIMS(s),
     &     vlo,vhi,DIMS(work),vlo,DIMS(work),
     &     lo,hi,YVEL,vbc,eps_for_bc)

      call trans_zbc(
     &     w,DIMS(s),
     &     wlo,whi,DIMS(work),wlo,DIMS(work),
     &     lo,hi,ZVEL,wbc,eps_for_bc)

      do k = kmin-1,kmax+1
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               tst = ulo(i,j,k)+uhi(i,j,k)
               val = cvmgp(ulo(i,j,k),uhi(i,j,k),tst)
               ltm =
     &              ( (ulo(i,j,k) .le. zero) .and.
     &              (uhi(i,j,k) .ge. zero) ) .or.
     &              (abs(tst)   .lt. eps )
               ulo(i,j,k) = cvmgt(zero,val,ltm)
            end do
         end do
      end do

      do k = kmin-1,kmax+1
         do j = jmin,  jmax+1
            do i = imin-1,imax+1
               tst = vlo(i,j,k)+vhi(i,j,k)
               val = cvmgp(vlo(i,j,k),vhi(i,j,k),tst)
               ltm =
     &              ( (vlo(i,j,k) .le. zero) .and.
     &              (vhi(i,j,k) .ge. zero) ) .or.
     &              (abs(tst)   .lt. eps )
               vlo(i,j,k) = cvmgt(zero,val,ltm)
            end do
         end do
      end do
      
      do k = kmin,kmax+1
         do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               tst = wlo(i,j,k)+whi(i,j,k)
               val = cvmgp(wlo(i,j,k),whi(i,j,k),tst)
               ltm =
     &              ( (wlo(i,j,k) .le. zero) .and.
     &              (whi(i,j,k) .ge. zero) ) .or.
     &              (abs(tst)   .lt. eps )
               wlo(i,j,k) = cvmgt(zero,val,ltm)
            end do
         end do
      end do

      end

      subroutine FORT_ESTATE(s, tforces, DIMS(s),

     &     u, xlo, xhi, sx, uad, slxscr, stxlo, stxhi,
     &     uedge, DIMS(uedge), xstate, DIMS(xstate),

     &     v, ylo, yhi, sy, vad, slyscr, stylo, styhi,
     &     vedge, DIMS(vedge), ystate, DIMS(ystate),

     &     w, zlo, zhi, sz, wad, slzscr, stzlo, stzhi,
     &     wedge, DIMS(wedge), zstate, DIMS(zstate),

     &     DIMS(work),
     &     bc,lo,hi,dt,dx,n,velpred, use_minion)
c
c     This subroutine computes edges states, right now it uses
c     a lot of memory, but there becomes a trade off between
c     simplicity-efficiency in the new way of computing states
c     and complexity in the old way.  By eliminating loops over
c     state components though, the new way uses much less memory.
c
      integer i,j,k,n,velpred
      integer lo(SDIM),hi(SDIM),bc(SDIM,2)
      integer imin,jmin,kmin,imax,jmax,kmax,inc
      REAL_T place_to_break
      REAL_T hx, hy, hz, dt, dth, dthx, dthy, dthz
      REAL_T tr1,tr2,ubar,vbar,wbar,stx,sty,stz,fu,fv,fw,dx(SDIM)
      REAL_T eps,eps_for_bc
      logical ltx,lty,ltz
      parameter (eps        = 1.d-6 )
      parameter (eps_for_bc = 1.d-10)

      integer DIMDEC(s)
      integer DIMDEC(work)
      integer DIMDEC(uedge)
      integer DIMDEC(vedge)
      integer DIMDEC(wedge)
      integer DIMDEC(xstate)
      integer DIMDEC(ystate)
      integer DIMDEC(zstate)

      REAL_T s(DIMV(s))
      REAL_T u(DIMV(s))
      REAL_T v(DIMV(s))
      REAL_T w(DIMV(s))
      REAL_T stxlo(DIM1(s)),stxhi(DIM1(s)),slxscr(DIM1(s),4)
      REAL_T stylo(DIM2(s)),styhi(DIM2(s)),slyscr(DIM2(s),4)
      REAL_T stzlo(DIM3(s)),stzhi(DIM3(s)),slzscr(DIM3(s),4)

      REAL_T uedge(DIMV(uedge)), xstate(DIMV(uedge))
      REAL_T vedge(DIMV(vedge)), ystate(DIMV(vedge))
      REAL_T wedge(DIMV(wedge)), zstate(DIMV(wedge))

      REAL_T xlo(DIMV(work)), xhi(DIMV(work))
      REAL_T ylo(DIMV(work)), yhi(DIMV(work))
      REAL_T zlo(DIMV(work)), zhi(DIMV(work))
      REAL_T  sx(DIMV(work)), uad(DIMV(work))
      REAL_T  sy(DIMV(work)), vad(DIMV(work))
      REAL_T  sz(DIMV(work)), wad(DIMV(work))
      REAL_T tforces(DIMV(work))

      integer use_minion

      dth  = half*dt
      dthx = half*dt / dx(1)
      dthy = half*dt / dx(2)
      dthz = half*dt / dx(3)
      hx   = dx(1)
      hy   = dx(2)
      hz   = dx(3)
      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     compute the slopes
c
      call FORT_SLOPES(ALL,
     &     s,DIMS(s),
     &     sx,sy,sz,DIMS(work),
     &     lo,hi,slxscr,slyscr,slzscr,bc)
c
c     trace the state to the cell edges
c
      do k = kmin-1,kmax+1
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               xlo(i,j,k) = s(i-1,j,k) + (half  - dthx*u(i-1,j,k))*sx(i-1,j,k)
               xhi(i,j,k) = s(i,  j,k) + (-half - dthx*u(i,  j,k))*sx(i,  j,k)
            end do
         end do
      end do

      if(use_minion.eq.1)then
         do k = kmin-1,kmax+1
            do j = jmin-1,jmax+1
               do i = imin,  imax+1
                  xlo(i,j,k) = xlo(i,j,k) + dth*tforces(i-1,j,k)
                  xhi(i,j,k) = xhi(i,j,k) + dth*tforces(i,  j,k)
               end do
            end do
         end do
      end if

      call trans_xbc(
     &     s,DIMS(s),
     &     xlo,xhi,DIMS(work),uad,DIMS(work),
     &     lo,hi,n,bc,eps_for_bc)

      do k = kmin-1,kmax+1
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               fu  = cvmgt(zero,one,abs(uad(i,j,k)).lt.eps)
               stx = cvmgp(xlo(i,j,k),xhi(i,j,k),uad(i,j,k))
               xlo(i,j,k) = fu*stx + (one - fu)*half*(xhi(i,j,k)+xlo(i,j,k))
            end do
         end do
      end do

      do k = kmin-1,kmax+1
         do j = jmin,  jmax+1
            do i = imin-1,imax+1
               ylo(i,j,k) = s(i,j-1,k) + (half  - dthy*v(i,j-1,k))*sy(i,j-1,k)
               yhi(i,j,k) = s(i,j, k)  + (-half - dthy*v(i,j,  k))*sy(i,j, k)
            end do
         end do
      end do

      if (use_minion.eq.1)then
         do k = kmin-1,kmax+1
            do j = jmin, jmax+1
               do i = imin-1,  imax+1
                  ylo(i,j,k) = ylo(i,j,k) + dth*tforces(i,j-1,k)
                  yhi(i,j,k) = yhi(i,j,k) + dth*tforces(i,j,  k)
               end do
            end do
         end do
      end if

      call trans_ybc(
     &     s,DIMS(s),
     &     ylo,yhi,DIMS(work),vad,DIMS(work),
     &     lo,hi,n,bc,eps_for_bc)

      do k = kmin-1,kmax+1
         do j = jmin,  jmax+1
            do i = imin-1,imax+1
               fv  = cvmgt(zero,one,abs(vad(i,j,k)).lt.eps)
               sty = cvmgp(ylo(i,j,k),yhi(i,j,k),vad(i,j,k))
               ylo(i,j,k) = fv*sty + (one - fv)*half*(yhi(i,j,k)+ylo(i,j,k))
            end do
         end do
      end do

      do k = kmin,kmax+1
         do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               zlo(i,j,k) = s(i,j,k-1) + (half  - dthz*w(i,j,k-1))*sz(i,j,k-1)
               zhi(i,j,k) = s(i,j,k  ) + (-half - dthz*w(i,j,k  ))*sz(i,j,k  )
            end do
         end do
      end do

      if (use_minion.eq.1)then
         do k = kmin,kmax+1
            do j = jmin-1,jmax+1
               do i = imin-1,  imax+1
                  zlo(i,j,k) = zlo(i,j,k) + dth*tforces(i,j,k-1)
                  zhi(i,j,k) = zhi(i,j,k) + dth*tforces(i,j,k)
               end do
            end do
         end do
      end if

      call trans_zbc(
     &     s,DIMS(s),
     &     zlo,zhi,DIMS(work),wad,DIMS(work),
     &     lo,hi,n,bc,eps_for_bc)

      do k = kmin,kmax+1
         do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               fw  = cvmgt(zero,one,abs(wad(i,j,k)).lt.eps)
               stz = cvmgp(zlo(i,j,k),zhi(i,j,k),wad(i,j,k))
               zlo(i,j,k) = fw*stz + (one-fw)*half*(zhi(i,j,k)+zlo(i,j,k))
            end do
         end do
      end do
c
c     compute the xedge states
c
      if ((velpred.ne.1) .or. (n.eq.XVEL)) then
         do k = kmin,kmax
            do j = jmin,jmax

               do i = imin-1,imax+1
                  if (vad(i,j,k)*vad(i,j+1,k).lt.0.d0) then
                      vbar = 0.5d0*(vad(i,j,k)+vad(i,j+1,k))
                      if (vbar.lt.0.d0) then
                          inc = 1
                      else
                          inc = 0
                      endif
                      tr1 = vbar*(s(i,j+inc,k)-s(i,j+inc-1,k))/hy
                  else
                      tr1 = half*
     &                 (vad(i,j+1,k) + vad(i,j,k)) *
     &                 (ylo(i,j+1,k) - ylo(i,j,k)) / hy
                  endif

                  if (wad(i,j,k)*wad(i,j,k+1).lt.0.d0) then
                      wbar = 0.5d0*(wad(i,j,k)+wad(i,j,k+1))
                      if (wbar.lt.0.d0) then
                          inc = 1
                      else
                          inc = 0
                      endif
                      tr2 = wbar*(s(i,j,k+inc)-s(i,j,k+inc-1))/hz
                  else
                      tr2 = half*
     &                 (wad(i,j,k+1) + wad(i,j,k)) *
     &                 (zlo(i,j,k+1) - zlo(i,j,k)) / hz
                  endif

                  stxlo(i+1)= s(i,j,k) + (half-dthx*u(i,j,k))*sx(i,j,k)
     &                 - dth*tr1 - dth*tr2
     &                 + dth*tforces(i,j,k)
                  stxhi(i  )= s(i,j,k) - (half+dthx*u(i,j,k))*sx(i,j,k)
     &                 - dth*tr1 - dth*tr2
     &                 + dth*tforces(i,j,k)
               end do

               if (bc(1,1).eq.EXT_DIR .and. uad(imin,j,k).ge.zero) then
                  stxhi(imin) = s(imin-1,j,k)
                  stxlo(imin) = s(imin-1,j,k)
               else if (bc(1,1).eq.EXT_DIR .and. uad(imin,j,k).lt.zero) then
                  stxlo(imin) = stxhi(imin)
               else if (bc(1,1).eq.FOEXTRAP.or.bc(1,1).eq.HOEXTRAP
     &                 .or.bc(1,1).eq.REFLECT_EVEN) then
                  stxlo(imin) = stxhi(imin)
               else if (bc(1,1).eq.REFLECT_ODD) then
                  stxhi(imin) = zero
                  stxlo(imin) = zero
               end if
               if (bc(1,2).eq.EXT_DIR .and. uad(imax+1,j,k).le.zero) then
                  stxlo(imax+1) = s(imax+1,j,k)
                  stxhi(imax+1) = s(imax+1,j,k)
               else if (bc(1,2).eq.EXT_DIR .and. uad(imax+1,j,k).gt.zero) then
                  stxhi(imax+1) = stxlo(imax+1)
               else if (bc(1,2).eq.FOEXTRAP.or.bc(1,2).eq.HOEXTRAP
     &                 .or.bc(1,2).eq.REFLECT_EVEN) then
                  stxhi(imax+1) = stxlo(imax+1)
               else if (bc(1,2).eq.REFLECT_ODD) then
                  stxlo(imax+1) = zero
                  stxhi(imax+1) = zero
               end if

               if ( velpred .eq. 1 ) then
                  do i = imin, imax+1
                     ltx = stxlo(i) .le. zero  .and.  stxhi(i) .ge. zero
                     ltx = ltx .or. (abs(stxlo(i)+stxhi(i)) .lt. eps)
                     stx = cvmgp(stxlo(i),stxhi(i),stxlo(i)+stxhi(i))
                     xstate(i,j,k) = cvmgt(zero,stx,ltx)
                  end do
               else
                  do i = imin, imax+1
                     xstate(i,j,k) = cvmgp(stxlo(i),stxhi(i),uedge(i,j,k))
                     xstate(i,j,k) = cvmgt(half*(stxlo(i)+stxhi(i)),xstate(i,j,k)
     &                    ,abs(uedge(i,j,k)).lt.eps)
                  end do
               end if
               place_to_break = 1
            end do
         end do
      end if
c
c     compute the yedge states
c
      if ((velpred.ne.1) .or. (n.eq.YVEL)) then
         do k = kmin,kmax
            do i = imin,imax
               
               do j = jmin-1,jmax+1
                  if (uad(i,j,k)*uad(i+1,j,k).lt.0.d0) then
                      ubar = 0.5d0*(uad(i,j,k)+uad(i+1,j,k))
                      if (ubar.lt.0.d0) then
                          inc = 1
                      else
                          inc = 0
                      endif
                      tr1 = ubar*(s(i+inc,j,k)-s(i+inc-1,j,k))/hx
                  else
                      tr1 = half*
     &                 (uad(i+1,j,k) + uad(i,j,k)) *
     &                 (xlo(i+1,j,k) - xlo(i,j,k)) / hx
                  endif

                  if (wad(i,j,k)*wad(i,j,k+1).lt.0.d0) then
                      wbar = 0.5d0*(wad(i,j,k)+wad(i,j,k+1))
                      if (wbar.lt.0.d0) then
                          inc = 1
                      else
                          inc = 0
                      endif
                      tr2 = wbar*(s(i,j,k+inc)-s(i,j,k+inc-1))/hz
                  else
                      tr2 = half*
     &                 (wad(i,j,k+1) + wad(i,j,k)) *
     &                 (zlo(i,j,k+1) - zlo(i,j,k)) / hz
                  endif

                  stylo(j+1)= s(i,j,k) + (half-dthy*v(i,j,k))*sy(i,j,k)
     &                 - dth*tr1 - dth*tr2
     &                 + dth*tforces(i,j,k)
                  styhi(j)  = s(i,j,k) - (half+dthy*v(i,j,k))*sy(i,j,k)
     &                 - dth*tr1 - dth*tr2
     &                 + dth*tforces(i,j,k)
               end do

               if (bc(2,1).eq.EXT_DIR .and. vad(i,jmin,k).ge.zero) then
                  styhi(jmin) = s(i,jmin-1,k)
                  stylo(jmin) = s(i,jmin-1,k)
               else if (bc(2,1).eq.EXT_DIR .and. vad(i,jmin,k).lt.zero) then
                  stylo(jmin) = styhi(jmin)
               else if (bc(2,1).eq.FOEXTRAP.or.bc(2,1).eq.HOEXTRAP
     &                 .or.bc(2,1).eq.REFLECT_EVEN) then
                  stylo(jmin) = styhi(jmin)
               else if (bc(2,1).eq.REFLECT_ODD) then
                  styhi(jmin) = zero
                  stylo(jmin) = zero
               end if
               
               if (bc(2,2).eq.EXT_DIR .and. vad(i,jmax+1,k).le.zero) then
                  stylo(jmax+1) = s(i,jmax+1,k)
                  styhi(jmax+1) = s(i,jmax+1,k)
               else if (bc(2,2).eq.EXT_DIR .and. vad(i,jmax+1,k).gt.zero) then
                  styhi(jmax+1) = stylo(jmax+1)
               else if (bc(2,2).eq.FOEXTRAP.or.bc(2,2).eq.HOEXTRAP
     &                 .or.bc(2,2).eq.REFLECT_EVEN) then
                  styhi(jmax+1) = stylo(jmax+1)
               else if (bc(2,2).eq.REFLECT_ODD) then
                  stylo(jmax+1) = zero
                  styhi(jmax+1) = zero
               end if

               if ( velpred .eq. 1 ) then
                  do j = jmin, jmax+1
                     lty = stylo(j) .le. zero  .and.  styhi(j) .ge. zero
                     lty = lty .or. (abs(stylo(j)+styhi(j)) .lt. eps)
                     sty = cvmgp(stylo(j),styhi(j),stylo(j)+styhi(j))
                     ystate(i,j,k) = cvmgt(zero,sty,lty)
                  end do
               else
                  do j=jmin,jmax+1
                     ystate(i,j,k) = cvmgp(stylo(j),styhi(j),vedge(i,j,k))
                     ystate(i,j,k) = cvmgt(half*(stylo(j)+styhi(j)),ystate(i,j,k),
     &                    abs(vedge(i,j,k)).lt.eps)
                  end do
               end if
               place_to_break = 1
            end do
         end do
      end if
c
c     compute the zedge states
c
      if ((velpred.ne.1) .or. (n.eq.ZVEL)) then
         do j = jmin,jmax
            do i = imin,imax
               
               do k = kmin-1,kmax+1
                  if (uad(i,j,k)*uad(i+1,j,k).lt.0.d0) then
                      ubar = 0.5d0*(uad(i,j,k)+uad(i+1,j,k))
                      if (ubar.lt.0.d0) then
                          inc = 1
                      else
                          inc = 0
                      endif
                      tr1 = ubar*(s(i+inc,j,k)-s(i+inc-1,j,k))/hx
                  else
                      tr1 = half*
     &                 (uad(i+1,j,k) + uad(i,j,k)) *
     &                 (xlo(i+1,j,k) - xlo(i,j,k)) / hx
                  endif

                  if (vad(i,j,k)*vad(i,j+1,k).lt.0.d0) then
                      vbar = 0.5d0*(vad(i,j,k)+vad(i,j+1,k))
                      if (vbar.lt.0.d0) then
                          inc = 1
                      else
                          inc = 0
                      endif
                      tr2 = vbar*(s(i,j+inc,k)-s(i,j+inc-1,k))/hy
                  else
                      tr2 = half*
     &                 (vad(i,j+1,k) + vad(i,j,k)) *
     &                 (ylo(i,j+1,k) - ylo(i,j,k)) / hy
                  endif

                  stzlo(k+1)= s(i,j,k) + (half-dthz*w(i,j,k))*sz(i,j,k)
     &                 - dth*tr1 - dth*tr2
     &                 + dth*tforces(i,j,k)
                  stzhi(k)  = s(i,j,k) - (half+dthz*w(i,j,k))*sz(i,j,k)
     &                 - dth*tr1 - dth*tr2
     &                 + dth*tforces(i,j,k)
               end do

               if (bc(3,1).eq.EXT_DIR .and. wad(i,j,kmin).ge.zero) then
                  stzlo(kmin) = s(i,j,kmin-1)
                  stzhi(kmin) = s(i,j,kmin-1)
               else if (bc(3,1).eq.EXT_DIR .and. wad(i,j,kmin).lt.zero) then
                  stzlo(kmin) = stzhi(kmin)
               else if (bc(3,1).eq.FOEXTRAP.or.bc(3,1).eq.HOEXTRAP
     &                 .or.bc(3,1).eq.REFLECT_EVEN) then
                  stzlo(kmin) = stzhi(kmin)
               else if (bc(3,1).eq.REFLECT_ODD) then
                  stzlo(kmin) = zero
                  stzhi(kmin) = zero
               end if
               if (bc(3,2).eq.EXT_DIR .and. wad(i,j,kmax+1).le.zero) then
                  stzlo(kmax+1) = s(i,j,kmax+1)
                  stzhi(kmax+1) = s(i,j,kmax+1)
               else if (bc(3,2).eq.EXT_DIR .and. wad(i,j,kmax+1).gt.zero) then
                  stzhi(kmax+1) = stzlo(kmax+1)
               else if (bc(3,2).eq.FOEXTRAP.or.bc(3,2).eq.HOEXTRAP
     &                 .or.bc(3,2).eq.REFLECT_EVEN) then
                  stzhi(kmax+1) = stzlo(kmax+1)
               else if (bc(3,2).eq.REFLECT_ODD) then
                  stzlo(kmax+1) = zero
                  stzhi(kmax+1) = zero
               end if

               if ( velpred .eq. 1 ) then
                  do k = kmin,kmax+1
                     ltz = stzlo(k) .le. zero  .and.  stzhi(k) .ge. zero
                     ltz = ltz .or. (abs(stzlo(k)+stzhi(k)) .lt. eps)
                     stz = cvmgp(stzlo(k),stzhi(k),stzlo(k)+stzhi(k))
                     zstate(i,j,k) = cvmgt(zero,stz,ltz)
                  end do
               else
                  do k = kmin,kmax+1
                     zstate(i,j,k) = cvmgp(stzlo(k),stzhi(k),wedge(i,j,k))
                     zstate(i,j,k) = cvmgt(half*(stzlo(k)+stzhi(k)),zstate(i,j,k),
     &                    abs(wedge(i,j,k)).lt.eps)
                  end do
               end if
               place_to_break = 1
            end do
         end do
      end if

      end

      subroutine FORT_ESTATE_FPU(s, tforces, divu, DIMS(s),
     &     xlo, xhi, sx, slxscr, stxlo, stxhi,
     &     uedge, DIMS(uedge), xstate, DIMS(xstate),

     &     ylo, yhi, sy, slyscr, stylo, styhi,
     &     vedge, DIMS(vedge), ystate, DIMS(ystate),

     &     zlo, zhi, sz, slzscr, stzlo, stzhi,
     &     wedge, DIMS(wedge), zstate, DIMS(zstate),

     &     DIMS(work),
     &     bc,lo,hi,dt,dx,n,use_minion,iconserv)
c
c     This subroutine computes edges states, right now it uses
c     a lot of memory, but there becomes a trade off between
c     simplicity-efficiency in the new way of computing states
c     and complexity in the old way.  By eliminating loops over
c     state components though, the new way uses much less memory.
c
c     This routine differs from the default ESTATE function above in that
c     it assumes that the edge velocities are valid in a grow cell outside
c     the box, and no *ad (unprojected) velocities are used.  This routine
c     will fail if the UMAC coming in hasn't been "fillpatched"
c
      integer i,j,k,n,inc
      integer lo(SDIM),hi(SDIM),bc(SDIM,2)
      integer imin,jmin,kmin,imax,jmax,kmax
      REAL_T place_to_break
      REAL_T hx, hy, hz, dt, dth, dthx, dthy, dthz
      REAL_T tr,tr1,tr2,ubar,vbar,wbar,stx,sty,stz,fu,fv,fw,dx(SDIM)
      REAL_T eps,eps_for_bc
      logical ltx,lty,ltz
      parameter (eps        = 1.d-6 )
      parameter (eps_for_bc = 1.d-10)

      integer DIMDEC(s)
      integer DIMDEC(work)
      integer DIMDEC(uedge)
      integer DIMDEC(xstate)
      integer DIMDEC(vedge)
      integer DIMDEC(ystate)
      integer DIMDEC(wedge)
      integer DIMDEC(zstate)

      REAL_T s(DIMV(s))
      REAL_T stxlo(DIM1(s)),stxhi(DIM1(s)),slxscr(DIM1(s),4)
      REAL_T stylo(DIM2(s)),styhi(DIM2(s)),slyscr(DIM2(s),4)
      REAL_T stzlo(DIM3(s)),stzhi(DIM3(s)),slzscr(DIM3(s),4)

      REAL_T uedge(DIMV(uedge)), xstate(DIMV(xstate))
      REAL_T vedge(DIMV(vedge)), ystate(DIMV(ystate))
      REAL_T wedge(DIMV(wedge)), zstate(DIMV(zstate))

      REAL_T xlo(DIMV(work)), xhi(DIMV(work))
      REAL_T ylo(DIMV(work)), yhi(DIMV(work))
      REAL_T zlo(DIMV(work)), zhi(DIMV(work))
      REAL_T  sx(DIMV(work))
      REAL_T  sy(DIMV(work))
      REAL_T  sz(DIMV(work))
      REAL_T tforces(DIMV(work))
      REAL_T    divu(DIMV(work))

      integer use_minion, iconserv
      REAL_T spx,smx,spy,smy,spz,smz,st,denom

      dth  = half*dt
      dthx = half*dt / dx(1)
      dthy = half*dt / dx(2)
      dthz = half*dt / dx(3)
      hx   = dx(1)
      hy   = dx(2)
      hz   = dx(3)
      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     compute the slopes
c
      call FORT_SLOPES(ALL,
     &     s,DIMS(s),
     &     sx,sy,sz,DIMS(work),
     &     lo,hi,slxscr,slyscr,slzscr,bc)
c
c     trace the state to the cell edges
c
      do k = kmin-1,kmax+1
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               xlo(i,j,k) = s(i-1,j,k) + (half  - dthx*uedge(i,j,k))*sx(i-1,j,k)
               xhi(i,j,k) = s(i,  j,k) + (-half - dthx*uedge(i,j,k))*sx(i,  j,k)
            end do
         end do
      end do

      if(use_minion.eq.1)then
         do k = kmin-1,kmax+1
            do j = jmin-1,jmax+1
               do i = imin,  imax+1
                  xlo(i,j,k) = xlo(i,j,k) + dth*tforces(i-1,j,k)
                  xhi(i,j,k) = xhi(i,j,k) + dth*tforces(i,  j,k)
               end do
            end do
         end do
         if (iconserv .eq. 1) then
           do k = kmin-1,kmax+1
             do j = jmin-1,jmax+1
               do i = imin,  imax+1
                  xlo(i,j,k) = xlo(i,j,k) - dth*s(i-1,j,k)*divu(i-1,j,k)
                  xhi(i,j,k) = xhi(i,j,k) - dth*s(i  ,j,k)*divu(i,  j,k)
               end do
             end do
           end do
         end if

      end if

      call trans_xbc(
     &     s,DIMS(s),
     &     xlo,xhi,DIMS(work),uedge,DIMS(uedge),
     &     lo,hi,n,bc,eps_for_bc)

      do k = kmin-1,kmax+1
         do j = jmin-1,jmax+1
            do i = imin,  imax+1
               fu  = cvmgt(zero,one,abs(uedge(i,j,k)).lt.eps)
               stx = cvmgp(xlo(i,j,k),xhi(i,j,k),uedge(i,j,k))
               xlo(i,j,k) = fu*stx + (one - fu)*half*(xhi(i,j,k)+xlo(i,j,k))
            end do
         end do
      end do

      do k = kmin-1,kmax+1
         do j = jmin,  jmax+1
            do i = imin-1,imax+1
               ylo(i,j,k) = s(i,j-1,k) + (half  - dthy*vedge(i,j,k))*sy(i,j-1,k)
               yhi(i,j,k) = s(i,j, k)  + (-half - dthy*vedge(i,j,k))*sy(i,j, k)
            end do
         end do
      end do

      if (use_minion.eq.1)then
         do k = kmin-1,kmax+1
            do j = jmin, jmax+1
               do i = imin-1,  imax+1
                  ylo(i,j,k) = ylo(i,j,k) + dth*tforces(i,j-1,k)
                  yhi(i,j,k) = yhi(i,j,k) + dth*tforces(i,j,  k)
               end do
            end do
         end do
         if (iconserv .eq. 1) then
           do k = kmin-1,kmax+1
             do j = jmin, jmax+1
               do i = imin-1,  imax+1
                  ylo(i,j,k) = ylo(i,j,k) - dth*s(i,j-1,k)*divu(i,j-1,k)
                  yhi(i,j,k) = yhi(i,j,k) - dth*s(i,j  ,k)*divu(i,j,  k)
               end do
             end do
           end do
         end if
      end if

      call trans_ybc(
     &     s,DIMS(s),
     &     ylo,yhi,DIMS(work),vedge,DIMS(vedge),
     &     lo,hi,n,bc,eps_for_bc)

      do k = kmin-1,kmax+1
         do j = jmin,  jmax+1
            do i = imin-1,imax+1
               fv  = cvmgt(zero,one,abs(vedge(i,j,k)).lt.eps)
               sty = cvmgp(ylo(i,j,k),yhi(i,j,k),vedge(i,j,k))
               ylo(i,j,k) = fv*sty + (one - fv)*half*(yhi(i,j,k)+ylo(i,j,k))
            end do
         end do
      end do

      do k = kmin,kmax+1
         do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               zlo(i,j,k) = s(i,j,k-1) + (half  - dthz*wedge(i,j,k))*sz(i,j,k-1)
               zhi(i,j,k) = s(i,j,k  ) + (-half - dthz*wedge(i,j,k))*sz(i,j,k  )
            end do
         end do
      end do

      if (use_minion.eq.1)then
         do k = kmin,kmax+1
            do j = jmin-1,jmax+1
               do i = imin-1,  imax+1
                  zlo(i,j,k) = zlo(i,j,k) + dth*tforces(i,j,k-1)
                  zhi(i,j,k) = zhi(i,j,k) + dth*tforces(i,j,k)
               end do
            end do
         end do
         if (iconserv .eq. 1) then
           do k = kmin,kmax+1
             do j = jmin-1,jmax+1
               do i = imin-1,  imax+1
                  zlo(i,j,k) = zlo(i,j,k) - dth*s(i,j,k-1)*divu(i,j,k-1)
                  zhi(i,j,k) = zhi(i,j,k) - dth*s(i,j,k  )*divu(i,j,k  )
               end do
             end do
           end do
         end if
      end if

      call trans_zbc(
     &     s,DIMS(s),
     &     zlo,zhi,DIMS(work),wedge,DIMS(wedge),
     &     lo,hi,n,bc,eps_for_bc)

      do k = kmin,kmax+1
         do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               fw  = cvmgt(zero,one,abs(wedge(i,j,k)).lt.eps)
               stz = cvmgp(zlo(i,j,k),zhi(i,j,k),wedge(i,j,k))
               zlo(i,j,k) = fw*stz + (one-fw)*half*(zhi(i,j,k)+zlo(i,j,k))
            end do
         end do
      end do
c
c     compute the xedge states
c
      do k = kmin,kmax
            do j = jmin,jmax
               do i = imin-1,imax+1

                  spx = s(i,j,k) + half*sx(i,j,k)
                  smx = s(i,j,k) - half*sx(i,j,k)

                  if (iconserv.eq.1) then

                     tr =
     &                    (vedge(i,j+1,k)*ylo(i,j+1,k) - vedge(i,j,k)*ylo(i,j,k))/hy +   
     &                    (wedge(i,j,k+1)*zlo(i,j,k+1) - wedge(i,j,k)*zlo(i,j,k))/hz   

                     st = -dth*tr + dth*(tforces(i,j,k) - s(i,j,k)*divu(i,j,k))
     &                    + dth*s(i,j,k)*(vedge(i,j+1,k)-vedge(i,j,k))/hy
     &                    + dth*s(i,j,k)*(wedge(i,j,k+1)-wedge(i,j,k))/hz
c    &                    - dth*s(i,j,k)*(uedge(i+1,j,k)-uedge(i,j,k))/hx

                  else

                     if (vedge(i,j,k)*vedge(i,j+1,k).le.0.d0) then
                        vbar = 0.5d0*(vedge(i,j,k)+vedge(i,j+1,k))
                        if (vbar.lt.0.d0) then
                           inc = 1
                        else
                           inc = 0
                        endif
                        tr1 = vbar*(s(i,j+inc,k)-s(i,j+inc-1,k))/hy
                     else
                        tr1 = half*(vedge(i,j+1,k) + vedge(i,j,k)) *
     &                               (ylo(i,j+1,k) -   ylo(i,j,k)  ) / hy
                     endif
                     if (wedge(i,j,k)*wedge(i,j,k+1).lt.0.d0) then
                        wbar = 0.5d0*(wedge(i,j,k)+wedge(i,j,k+1))
                        if (wbar.lt.0.d0) then
                           inc = 1
                        else
                           inc = 0
                        endif
                        tr2 = wbar*(s(i,j,k+inc)-s(i,j,k+inc-1))/hz
                     else
                        tr2 = half*(wedge(i,j,k+1) + wedge(i,j,k)) *
     &                               (zlo(i,j,k+1) -   zlo(i,j,k)  ) / hz
                     endif

                     st = -dth*(tr1 + tr2) + dth*tforces(i,j,k)
                  endif

                  stxlo(i+1)= spx - dthx*uedge(i+1,j,k)*sx(i,j,k) + st
                  stxhi(i  )= smx - dthx*uedge(i  ,j,k)*sx(i,j,k) + st

               end do

               if (bc(1,1).eq.EXT_DIR .and. uedge(imin,j,k).ge.zero) then
                  stxhi(imin) = s(imin-1,j,k)
                  stxlo(imin) = s(imin-1,j,k)
               else if (bc(1,1).eq.EXT_DIR .and. uedge(imin,j,k).lt.zero) then
                  stxlo(imin) = stxhi(imin)
               else if (bc(1,1).eq.FOEXTRAP.or.bc(1,1).eq.HOEXTRAP
     &                 .or.bc(1,1).eq.REFLECT_EVEN) then
                  stxlo(imin) = stxhi(imin)
               else if (bc(1,1).eq.REFLECT_ODD) then
                  stxhi(imin) = zero
                  stxlo(imin) = zero
               end if
               if (bc(1,2).eq.EXT_DIR .and. uedge(imax+1,j,k).le.zero) then
                  stxlo(imax+1) = s(imax+1,j,k)
                  stxhi(imax+1) = s(imax+1,j,k)
               else if (bc(1,2).eq.EXT_DIR .and. uedge(imax+1,j,k).gt.zero) then
                  stxhi(imax+1) = stxlo(imax+1)
               else if (bc(1,2).eq.FOEXTRAP.or.bc(1,2).eq.HOEXTRAP
     &                 .or.bc(1,2).eq.REFLECT_EVEN) then
                  stxhi(imax+1) = stxlo(imax+1)
               else if (bc(1,2).eq.REFLECT_ODD) then
                  stxlo(imax+1) = zero
                  stxhi(imax+1) = zero
               end if

               do i = imin, imax+1
                  xstate(i,j,k) = cvmgp(stxlo(i),stxhi(i),uedge(i,j,k))
                  xstate(i,j,k) = cvmgt(half*(stxlo(i)+stxhi(i)),xstate(i,j,k)
     &                 ,abs(uedge(i,j,k)).lt.eps)
               end do
               place_to_break = 1
            end do
      end do
c
c     compute the yedge states
c
      do k = kmin,kmax
            do i = imin,imax
               
               do j = jmin-1,jmax+1
                  spy = s(i,j,k) + half*sy(i,j,k)
                  smy = s(i,j,k) - half*sy(i,j,k)
                  if (iconserv.eq.1) then

                     tr =
     &                    (uedge(i+1,j,k)*xlo(i+1,j,k) - uedge(i,j,k)*xlo(i,j,k))/hx +   
     &                    (wedge(i,j,k+1)*zlo(i,j,k+1) - wedge(i,j,k)*zlo(i,j,k))/hz   

                     st = -dth*tr + dth*(tforces(i,j,k) - s(i,j,k)*divu(i,j,k))
     &                    + dth*s(i,j,k)*(uedge(i+1,j,k)-uedge(i,j,k))/hx
     &                    + dth*s(i,j,k)*(wedge(i,j,k+1)-wedge(i,j,k))/hz
c    &                    - dth*s(i,j,k)*(vedge(i,j+1,k)-vedge(i,j,k))/hy


                  else

                     if (uedge(i,j,k)*uedge(i+1,j,k).le.0.d0) then
                        ubar = 0.5d0*(uedge(i,j,k)+uedge(i+1,j,k))
                        if (ubar.lt.0.d0) then
                           inc = 1
                        else
                           inc = 0
                        endif
                        tr1 = ubar*(s(i+inc,j,k)-s(i+inc-1,j,k))/hx
                     else
                        tr1 = half*(uedge(i+1,j,k) + uedge(i,j,k)) *
     &                               (xlo(i+1,j,k) -   xlo(i,j,k)  ) / hx
                     endif
                     if (wedge(i,j,k)*wedge(i,j,k+1).lt.0.d0) then
                        wbar = 0.5d0*(wedge(i,j,k)+wedge(i,j,k+1))
                        if (wbar.lt.0.d0) then
                           inc = 1
                        else
                           inc = 0
                        endif
                        tr2 = wbar*(s(i,j,k+inc)-s(i,j,k+inc-1))/hz
                     else
                        tr2 = half*(wedge(i,j,k+1) + wedge(i,j,k)) *
     &                               (zlo(i,j,k+1) -   zlo(i,j,k)  ) / hz
                     endif

                     st = -dth*(tr1 + tr2) + dth*tforces(i,j,k)

                  endif

                  stylo(j+1)= spy - dthy*vedge(i,j+1,k)*sy(i,j,k) + st
                  styhi(j  )= smy - dthy*vedge(i,j  ,k)*sy(i,j,k) + st
               end do

               if (bc(2,1).eq.EXT_DIR .and. vedge(i,jmin,k).ge.zero) then
                  styhi(jmin) = s(i,jmin-1,k)
                  stylo(jmin) = s(i,jmin-1,k)
               else if (bc(2,1).eq.EXT_DIR .and. vedge(i,jmin,k).lt.zero) then
                  stylo(jmin) = styhi(jmin)
               else if (bc(2,1).eq.FOEXTRAP.or.bc(2,1).eq.HOEXTRAP
     &                 .or.bc(2,1).eq.REFLECT_EVEN) then
                  stylo(jmin) = styhi(jmin)
               else if (bc(2,1).eq.REFLECT_ODD) then
                  styhi(jmin) = zero
                  stylo(jmin) = zero
               end if
               
               if (bc(2,2).eq.EXT_DIR .and. vedge(i,jmax+1,k).le.zero) then
                  stylo(jmax+1) = s(i,jmax+1,k)
                  styhi(jmax+1) = s(i,jmax+1,k)
               else if (bc(2,2).eq.EXT_DIR .and. vedge(i,jmax+1,k).le.zero) then
                  styhi(jmax+1) = stylo(jmax+1)
               else if (bc(2,2).eq.FOEXTRAP.or.bc(2,2).eq.HOEXTRAP
     &                 .or.bc(2,2).eq.REFLECT_EVEN) then
                  styhi(jmax+1) = stylo(jmax+1)
               else if (bc(2,2).eq.REFLECT_ODD) then
                  stylo(jmax+1) = zero
                  styhi(jmax+1) = zero
               end if

               do j=jmin,jmax+1
                  ystate(i,j,k) = cvmgp(stylo(j),styhi(j),vedge(i,j,k))
                  ystate(i,j,k) = cvmgt(half*(stylo(j)+styhi(j)),ystate(i,j,k),
     &                 abs(vedge(i,j,k)).lt.eps)
               end do
               place_to_break = 1
            end do
      end do
c
c     compute the zedge states
c
      do j = jmin,jmax
            do i = imin,imax
               
               do k = kmin-1,kmax+1
                  
                  spz = s(i,j,k) + half*sz(i,j,k)
                  smz = s(i,j,k) - half*sz(i,j,k)

                  if (iconserv.eq.1) then
                     tr =
     &                    (uedge(i+1,j,k)*xlo(i+1,j,k) - uedge(i,j,k)*xlo(i,j,k))/hx +   
     &                    (vedge(i,j+1,k)*ylo(i,j+1,k) - vedge(i,j,k)*ylo(i,j,k))/hy   
                     
                     st = -dth*tr + dth*(tforces(i,j,k) - s(i,j,k)*divu(i,j,k))
     &                    + dth*s(i,j,k)*(uedge(i+1,j,k)-uedge(i,j,k))/hx
     &                    + dth*s(i,j,k)*(vedge(i,j+1,k)-vedge(i,j,k))/hy
c    &                    - dth*s(i,j,k)*(wedge(i,j,k+1)-wedge(i,j,k))/hz

                  else
                     if (uedge(i,j,k)*uedge(i+1,j,k).le.0.d0) then
                        ubar = 0.5d0*(uedge(i,j,k)+uedge(i+1,j,k))
                        if (ubar.lt.0.d0) then
                           inc = 1
                        else
                           inc = 0
                        endif
                        tr1 = ubar*(s(i+inc,j,k)-s(i+inc-1,j,k))/hx
                     else
                        tr1 = half*(uedge(i+1,j,k) + uedge(i,j,k)) *
     &                       (xlo(i+1,j,k) - xlo(i,j,k)  ) / hx
                     endif
                     if (vedge(i,j,k)*vedge(i,j+1,k).lt.0.d0) then
                        vbar = 0.5d0*(vedge(i,j,k)+vedge(i,j+1,k))
                        if (vbar.lt.0.d0) then
                           inc = 1
                        else
                           inc = 0
                        endif
                        tr2 = vbar*(s(i,j+inc,k)-s(i,j+inc-1,k))/hy
                     else
                        tr2 = half*(vedge(i,j+1,k) + vedge(i,j,k)) *
     &                       (ylo(i,j+1,k) - ylo(i,j,k)  ) / hy
                     endif

                     st = -dth*(tr1 + tr2) + dth*tforces(i,j,k)
                  endif

                  stzlo(k+1)= spz - dthz*wedge(i,j,k+1)*sz(i,j,k) + st
                  stzhi(k  )= smz - dthz*wedge(i,j,k  )*sz(i,j,k) + st

               end do

               if (bc(3,1).eq.EXT_DIR .and. wedge(i,j,kmin).ge.zero) then
                  stzlo(kmin) = s(i,j,kmin-1)
                  stzhi(kmin) = s(i,j,kmin-1)
               else if (bc(3,1).eq.EXT_DIR .and. wedge(i,j,kmin).lt.zero) then
                  stzlo(kmin) = stzhi(kmin)
               else if (bc(3,1).eq.FOEXTRAP.or.bc(3,1).eq.HOEXTRAP
     &                 .or.bc(3,1).eq.REFLECT_EVEN) then
                  stzlo(kmin) = stzhi(kmin)
               else if (bc(3,1).eq.REFLECT_ODD) then
                  stzlo(kmin) = zero
                  stzhi(kmin) = zero
               end if
               if (bc(3,2).eq.EXT_DIR .and. wedge(i,j,kmax+1).le.zero) then
                  stzlo(kmax+1) = s(i,j,kmax+1)
                  stzhi(kmax+1) = s(i,j,kmax+1)
               else if (bc(3,2).eq.EXT_DIR .and. wedge(i,j,kmax+1).gt.zero) then
                  stzhi(kmax+1) = stzlo(kmax+1)
               else if (bc(3,2).eq.FOEXTRAP.or.bc(3,2).eq.HOEXTRAP
     &                 .or.bc(3,2).eq.REFLECT_EVEN) then
                  stzhi(kmax+1) = stzlo(kmax+1)
               else if (bc(3,2).eq.REFLECT_ODD) then
                  stzlo(kmax+1) = zero
                  stzhi(kmax+1) = zero
               end if

               do k = kmin,kmax+1
                  zstate(i,j,k) = cvmgp(stzlo(k),stzhi(k),wedge(i,j,k))
                  zstate(i,j,k) = cvmgt(half*(stzlo(k)+stzhi(k)),zstate(i,j,k),
     &                 abs(wedge(i,j,k)).lt.eps)
               end do
               place_to_break = 1
            end do
      end do

      end

      subroutine FORT_ADV_FORCING(
     &     aofs,DIMS(aofs),
     &     xflux,DIMS(xflux),
     &     uedge,DIMS(uedge),
     &     areax,DIMS(ax),
     &     yflux,DIMS(yflux),
     &     vedge,DIMS(vedge),
     &     areay,DIMS(ay),
     &     zflux,DIMS(zflux),
     &     wedge,DIMS(wedge),
     &     areaz,DIMS(az),
     &     vol,DIMS(vol),
     &     lo,hi,iconserv )
c
c     This subroutine uses scalar edge states to compute
c     an advective tendency
c
      implicit none
      integer i,j,k
      integer iconserv
      REAL_T divux,divuy,divuz,rincr
      integer imin,jmin,kmin,imax,jmax,kmax
      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(aofs)
      integer DIMDEC(vol)
      integer DIMDEC(uedge)
      integer DIMDEC(vedge)
      integer DIMDEC(wedge)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(zflux)
      integer DIMDEC(ax)
      integer DIMDEC(ay)
      integer DIMDEC(az)
      REAL_T aofs(DIMV(aofs))
      REAL_T vol(DIMV(vol))
      REAL_T uedge(DIMV(uedge))
      REAL_T vedge(DIMV(vedge))
      REAL_T wedge(DIMV(wedge))
      REAL_T xflux(DIMV(xflux))
      REAL_T yflux(DIMV(yflux))
      REAL_T zflux(DIMV(zflux))
      REAL_T areax(DIMV(ax))
      REAL_T areay(DIMV(ay))
      REAL_T areaz(DIMV(az))

      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     if nonconservative initialize the advective tendency as -U*grad(S)
c
      if ( iconserv .ne. 1 ) then
         do k = kmin,kmax
            do j = jmin,jmax
               do i = imin,imax
                  divux = (
     &                 areax(i+1,j,k)*uedge(i+1,j,k)-
     &                 areax(i,  j,k)*uedge(i,  j,k))/vol(i,j,k)
                  divuy = (
     &                 areay(i,j+1,k)*vedge(i,j+1,k)-
     &                 areay(i,j,  k)*vedge(i,j,  k))/vol(i,j,k)
                  divuz = (
     &                 areaz(i,j,k+1)*wedge(i,j,k+1)-
     &                 areaz(i,j,k  )*wedge(i,j,k  ))/vol(i,j,k)
                  aofs(i,j,k) =
     &                 - divux*half*(xflux(i+1,j,k)+xflux(i,j,k))
     &                 - divuy*half*(yflux(i,j+1,k)+yflux(i,j,k))
     &                 - divuz*half*(zflux(i,j,k+1)+zflux(i,j,k))
              
               end do
            end do
         end do
      end if
c
c     convert edge states to fluxes
c
      do k = kmin,kmax
         do j = jmin,jmax
            do i = imin,imax+1
               xflux(i,j,k) = xflux(i,j,k)*uedge(i,j,k)*areax(i,j,k)
            end do
         end do
      end do
      do k = kmin,kmax
         do j = jmin,jmax+1
            do i = imin,imax
               yflux(i,j,k) = yflux(i,j,k)*vedge(i,j,k)*areay(i,j,k)
            end do
         end do
      end do
      do k = kmin,kmax+1
         do j = jmin,jmax
            do i = imin,imax
               zflux(i,j,k) = zflux(i,j,k)*wedge(i,j,k)*areaz(i,j,k)
            end do
         end do
      end do
c
c     compute the part of the advective tendency 
c     that depends on the flux convergence
c
      if ( iconserv .ne. 1 ) then
         do k = kmin,kmax
            do j = jmin,jmax
               do i = imin,imax
                  aofs(i,j,k) = aofs(i,j,k) + (
     &                 xflux(i+1,j,k) - xflux(i,j,k) +
     &                 yflux(i,j+1,k) - yflux(i,j,k) +
     &                 zflux(i,j,k+1) - zflux(i,j,k))/vol(i,j,k)
               end do
            end do
         end do
      else
         do k = kmin,kmax
            do j = jmin,jmax
               do i = imin,imax
                  aofs(i,j,k) = (
     &                 xflux(i+1,j,k) - xflux(i,j,k) +
     &                 yflux(i,j+1,k) - yflux(i,j,k) +
     &                 zflux(i,j,k+1) - zflux(i,j,k))/vol(i,j,k)
               end do
            end do
         end do
      end if

      end

      subroutine FORT_SYNC_ADV_FORCING(
     &     sync ,DIMS(sync),
     &     xflux,DIMS(xflux),
     &     ucor ,DIMS(ucor),
     &     areax,DIMS(ax),
     &     yflux,DIMS(yflux),
     &     vcor ,DIMS(vcor),
     &     areay,DIMS(ay),
     &     zflux,DIMS(zflux),
     &     wcor ,DIMS(wcor),
     &     areaz,DIMS(az),
     &     vol ,DIMS(vol),
     &     lo,hi,iconserv )
c
c     This subroutine computes the sync advective tendency
c     for a state variable
c
      implicit none
      integer i,j,k
      integer iconserv
      REAL_T divux,divuy,divuz
      integer imin,jmin,kmin,imax,jmax,kmax
      integer lo(SDIM),hi(SDIM)
      integer DIMDEC(sync)
      integer DIMDEC(vol)
      integer DIMDEC(ucor)
      integer DIMDEC(vcor)
      integer DIMDEC(wcor)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      integer DIMDEC(zflux)
      integer DIMDEC(ax)
      integer DIMDEC(ay)
      integer DIMDEC(az)
      REAL_T sync(DIMV(sync))
      REAL_T vol(DIMV(vol))
      REAL_T ucor(DIMV(ucor))
      REAL_T vcor(DIMV(vcor))
      REAL_T wcor(DIMV(wcor))
      REAL_T xflux(DIMV(xflux))
      REAL_T yflux(DIMV(yflux))
      REAL_T zflux(DIMV(zflux))
      REAL_T areax(DIMV(ax))
      REAL_T areay(DIMV(ay))
      REAL_T areaz(DIMV(az))

      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     compute corrective fluxes from edge states 
c     and perform conservative update
c
      do k = kmin,kmax
         do j = jmin,jmax
            do i = imin,imax+1
               xflux(i,j,k) = xflux(i,j,k)*ucor(i,j,k)*areax(i,j,k)
            end do
         end do
      end do
      do k = kmin,kmax
         do j = jmin,jmax+1
            do i = imin,imax
               yflux(i,j,k) = yflux(i,j,k)*vcor(i,j,k)*areay(i,j,k)
            end do
         end do
      end do
      do k = kmin,kmax+1
         do j = jmin,jmax
            do i = imin,imax
               zflux(i,j,k) = zflux(i,j,k)*wcor(i,j,k)*areaz(i,j,k)
            end do
         end do
      end do

      do k = kmin,kmax
         do j = jmin,jmax
            do i = imin,imax
               sync(i,j,k) = sync(i,j,k) + (
     &              xflux(i+1,j,k)-xflux(i,j,k) +
     &              yflux(i,j+1,k)-yflux(i,j,k) +
     &              zflux(i,j,k+1)-zflux(i,j,k) )/vol(i,j,k)
            end do
         end do
      end do

      end

      subroutine trans_xbc(
     &     s,DIMS(s),
     &     xlo,xhi,DIMS(xx),uad,DIMS(uad),
     &     lo,hi,n,xbc,eps)
c
c     This subroutine processes boundary conditions on information
c     traced to cell faces in the x direction.  This is used for
c     computing velocities and edge states used in calculating
c     transverse derivatives
c
      integer DIMDEC(s)
      REAL_T s(DIMV(s))
      integer DIMDEC(xx)
      integer DIMDEC(uad)
      REAL_T xlo(DIMV(xx))
      REAL_T xhi(DIMV(xx))
      REAL_T uad(DIMV(uad))
      REAL_T eps
      integer lo(SDIM), hi(SDIM)
      integer n
      integer xbc(SDIM,2)

      REAL_T stx
      logical ltest
      integer j,k
      integer imin,jmin,kmin,imax,jmax,kmax

      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     -------------- the lower x boundary
c
      if (xbc(1,1).eq.EXT_DIR) then
         if ( n .eq. XVEL ) then
            do j = jmin-1,jmax+1
             do k = kmin-1,kmax+1
              if (uad(imin,j,k) .ge. zero) then
                  xlo(imin,j,k) = s(imin-1,j,k)
                  xhi(imin,j,k) = s(imin-1,j,k)
              else
                  xlo(imin,j,k) = xhi(imin,j,k)
              endif
             end do
            end do
         else
            do j = jmin-1,jmax+1
               do k = kmin-1,kmax+1
                  ltest = uad(imin,j,k).le.eps
                  stx   = cvmgt(xhi(imin,j,k),s(imin-1,j,k),ltest)
                  xlo(imin,j,k) = stx
                  xhi(imin,j,k) = stx
               end do
            end do
         end if
      else if (xbc(1,1).eq.FOEXTRAP.or.xbc(1,1).eq.HOEXTRAP
     &        .or.xbc(1,1).eq.REFLECT_EVEN) then
         do j = jmin-1,jmax+1
            do k = kmin-1,kmax+1
               xlo(imin,j,k) = xhi(imin,j,k)
            end do
         end do
      else if (xbc(1,1).eq.REFLECT_ODD) then
         do j = jmin-1,jmax+1
            do k = kmin-1,kmax+1
               xhi(imin,j,k) = zero
               xlo(imin,j,k) = zero
            end do
         end do
      end if
c
c     -------------- the upper x boundary
c
      if (xbc(1,2).eq.EXT_DIR) then
         if ( n .eq. XVEL ) then
            do j = jmin-1,jmax+1
             do k = kmin-1,kmax+1
               if (uad(imax+1,j,k) .le. zero) then
                  xlo(imax+1,j,k) = s(imax+1,j,k)
                  xhi(imax+1,j,k) = s(imax+1,j,k)
               else
                  xhi(imax+1,j,k) = xlo(imax+1,j,k)
               endif
             end do
            end do
         else
            do j = jmin-1,jmax+1
               do k = kmin-1,kmax+1
                  ltest = uad(imax+1,j,k).ge.-eps
                  stx   = cvmgt(xlo(imax+1,j,k),s(imax+1,j,k),ltest)
                  xlo(imax+1,j,k) = stx
                  xhi(imax+1,j,k) = stx
               end do
            end do
         end if
      else if (xbc(1,2).eq.FOEXTRAP.or.xbc(1,2).eq.HOEXTRAP
     &        .or.xbc(1,2).eq.REFLECT_EVEN) then
         do j = jmin-1,jmax+1
            do k = kmin-1,kmax+1
               xhi(imax+1,j,k) = xlo(imax+1,j,k)
            end do
         end do
      else if (xbc(1,2).eq.REFLECT_ODD) then
         do j = jmin-1,jmax+1
            do k = kmin-1,kmax+1
               xhi(imax+1,j,k) = zero
               xlo(imax+1,j,k) = zero
            end do
         end do
      end if

      end

      subroutine trans_ybc(
     &     s,DIMS(s),
     &     ylo,yhi,DIMS(yy),vad,DIMS(vad),
     &     lo,hi,n,ybc,eps)
c
c     This subroutine processes boundary conditions on information
c     traced to cell faces in the y direction.  This is used for
c     computing velocities and edge states used in calculating
c     transverse derivatives
c
      integer DIMDEC(s)
      REAL_T s(DIMV(s))
      integer DIMDEC(yy)
      integer DIMDEC(vad)
      REAL_T ylo(DIMV(yy))
      REAL_T yhi(DIMV(yy))
      REAL_T vad(DIMV(vad))
      REAL_T eps
      integer lo(SDIM), hi(SDIM)
      integer n
      integer ybc(SDIM,2)

      REAL_T sty
      logical ltest
      integer i,k
      integer imin,jmin,kmin,imax,jmax,kmax

      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     -------------- the lower y boundary
c
      if (ybc(2,1).eq.EXT_DIR) then
         if ( n .eq. YVEL ) then
            do i = imin-1,imax+1
             do k = kmin-1,kmax+1
              if (vad(i,jmin,k) .ge. zero) then
                  ylo(i,jmin,k) = s(i,jmin-1,k)
                  yhi(i,jmin,k) = s(i,jmin-1,k)
              else
                  ylo(i,jmin,k) = yhi(i,jmin,k)
              endif
             end do
            end do
         else
            do i = imin-1,imax+1
               do k = kmin-1,kmax+1
                  ltest = vad(i,jmin,k).le.eps
                  sty   = cvmgt(yhi(i,jmin,k),s(i,jmin-1,k),ltest)
                  ylo(i,jmin,k) = sty
                  yhi(i,jmin,k) = sty
               end do
            end do
         end if
      else if (ybc(2,1).eq.FOEXTRAP.or.ybc(2,1).eq.HOEXTRAP
     &        .or.ybc(2,1).eq.REFLECT_EVEN) then
         do i = imin-1,imax+1
            do k = kmin-1,kmax+1
               ylo(i,jmin,k) = yhi(i,jmin,k)
            end do
         end do
      else if (ybc(2,1).eq.REFLECT_ODD) then
         do i = imin-1,imax+1
            do k = kmin-1,kmax+1
               yhi(i,jmin,k) = zero
               ylo(i,jmin,k) = zero
            end do
         end do
      end if
c
c     -------------- the upper y boundary
c
      if (ybc(2,2).eq.EXT_DIR) then
         if ( n .eq. YVEL ) then
            do i = imin-1,imax+1
             do k = kmin-1,kmax+1
               if (vad(i,jmax+1,k) .le. zero) then
                  ylo(i,jmax+1,k) = s(i,jmax+1,k)
                  yhi(i,jmax+1,k) = s(i,jmax+1,k)
               else
                  yhi(i,jmax+1,k) = ylo(i,jmax+1,k)
               endif
             end do
            end do
         else
            do i = imin-1,imax+1
               do k = kmin-1,kmax+1
                  ltest = vad(i,jmax+1,k).ge.-eps
                  sty   = cvmgt(ylo(i,jmax+1,k),s(i,jmax+1,k),ltest)
                  ylo(i,jmax+1,k) = sty
                  yhi(i,jmax+1,k) = sty
               end do
            end do
         end if
      else if (ybc(2,2).eq.FOEXTRAP.or.ybc(2,2).eq.HOEXTRAP
     &        .or.ybc(2,2).eq.REFLECT_EVEN) then
         do i = imin-1,imax+1
            do k = kmin-1,kmax+1
               yhi(i,jmax+1,k) = ylo(i,jmax+1,k)
            end do
         end do
      else if (ybc(2,2).eq.REFLECT_ODD) then
         do i = imin-1,imax+1
            do k = kmin-1,kmax+1
               ylo(i,jmax+1,k) = zero
               yhi(i,jmax+1,k) = zero
            end do
         end do
      end if

      end

      subroutine trans_zbc(
     &     s,DIMS(s),
     &     zlo,zhi,DIMS(zz),wad,DIMS(wad),
     &     lo,hi,n,zbc,eps)
c
c     This subroutine processes boundary conditions on information
c     traced to cell faces in the z direction.  This is used for
c     computing velocities and edge states used in calculating
c     transverse derivatives
c
      integer DIMDEC(s)
      REAL_T s(DIMV(s))
      integer DIMDEC(zz)
      integer DIMDEC(wad)
      REAL_T zlo(DIMV(zz))
      REAL_T zhi(DIMV(zz))
      REAL_T wad(DIMV(wad))
      REAL_T eps
      integer lo(SDIM), hi(SDIM)
      integer n
      integer zbc(SDIM,2)

      REAL_T stz
      logical ltest
      integer i,j
      integer imin,jmin,kmin,imax,jmax,kmax

      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     -------------- the lower z boundary
c
      if (zbc(3,1).eq.EXT_DIR) then
         if ( n .eq. ZVEL ) then
            do i = imin-1,imax+1
             do j = jmin-1,jmax+1
               if (wad(i,j,kmin) .ge. zero) then
                  zhi(i,j,kmin) = s(i,j,kmin-1)
                  zlo(i,j,kmin) = s(i,j,kmin-1)
               else
                  zlo(i,j,kmin) = zhi(i,j,kmin)
               endif
             end do
            end do
         else
            do i = imin-1,imax+1
               do j = jmin-1,jmax+1
                  ltest = wad(i,j,kmin).le.eps
                  stz   = cvmgt(zhi(i,j,kmin),s(i,j,kmin-1),ltest)
                  zhi(i,j,kmin) = stz
                  zlo(i,j,kmin) = stz
               end do
            end do
         end if
      else if (zbc(3,1).eq.FOEXTRAP.or.zbc(3,1).eq.HOEXTRAP
     &        .or.zbc(3,1).eq.REFLECT_EVEN) then
         do i = imin-1,imax+1
            do j = jmin-1,jmax+1
               zlo(i,j,kmin) = zhi(i,j,kmin)
            end do
         end do
      else if (zbc(3,1).eq.REFLECT_ODD) then
         do i = imin-1,imax+1
            do j = jmin-1,jmax+1
               zhi(i,j,kmin) = zero
               zlo(i,j,kmin) = zero
            end do
         end do
      end if
c
c     -------------- the upper z boundary
c
      if (zbc(3,2).eq.EXT_DIR) then
         if ( n .eq. ZVEL ) then
            do i = imin-1,imax+1
             do j = jmin-1,jmax+1
               if (wad(i,j,kmax+1) .le. zero) then
                  zlo(i,j,kmax+1) = s(i,j,kmax+1)
                  zhi(i,j,kmax+1) = s(i,j,kmax+1)
               else
                  zhi(i,j,kmax+1) = zlo(i,j,kmax+1)
               endif
             end do
            end do
         else
            do i = imin-1,imax+1
               do j = jmin-1,jmax+1
                  ltest = wad(i,j,kmax+1).ge.-eps
                  stz   = cvmgt(zlo(i,j,kmax+1),s(i,j,kmax+1),ltest)
                  zhi(i,j,kmax+1) = stz
                  zlo(i,j,kmax+1) = stz
               end do
            end do
         end if
      else if (zbc(3,2).eq.FOEXTRAP.or.zbc(3,2).eq.HOEXTRAP
     &        .or.zbc(3,2).eq.REFLECT_EVEN) then
         do i = imin-1,imax+1
            do j = jmin-1,jmax+1
               zhi(i,j,kmax+1) = zlo(i,j,kmax+1)
            end do
         end do
      else if (zbc(3,2).eq.REFLECT_ODD) then
         do i = imin-1,imax+1
            do j = jmin-1,jmax+1
               zlo(i,j,kmax+1) = zero
               zhi(i,j,kmax+1) = zero
            end do
         end do
      end if

      end

      subroutine FORT_SLOPES( dir,
     &     s,DIMS(s),
     &     slx,sly,slz,DIMS(sl),
     &     lo,hi,slxscr,slyscr,slzscr,bc)
c 
c     this subroutine computes first or forth order slopes of
c     a 3D scalar field.
c
c     (dir) is used to eliminate calculating extra slopes in transvel
c
c     Boundary conditions on interior slopes are handled automatically
c     by the ghost cells
c
c     Boundary conditions on EXT_DIR and HOEXTRAP slopes are implemented
c     by setting them to zero outside of the domain and using a
c     one-sided derivative from the interior
c
      implicit none

#include "GODCOMM_F.H"

      integer dir
      integer DIMDEC(s)
      REAL_T     s(DIMV(s))
      integer DIMDEC(sl)
      REAL_T   slx(DIMV(sl))
      REAL_T   sly(DIMV(sl))
      REAL_T   slz(DIMV(sl))
      integer lo(SDIM), hi(SDIM)
      REAL_T slxscr(DIM1(s), 4)
      REAL_T slyscr(DIM2(s), 4)
      REAL_T slzscr(DIM3(s), 4)
      integer bc(SDIM,2)

      integer imin,jmin,kmin,imax,jmax,kmax,i,j,k
      integer ng
      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflg
      integer cen,lim,flag,fromm
      parameter( cen = 1   )
      parameter( lim = 2   )
      parameter( flag = 3  )
      parameter( fromm = 4 )

      ng = lo(1) - ARG_L1(s)
      imin = lo(1)
      jmin = lo(2)
      kmin = lo(3)
      imax = hi(1)
      jmax = hi(2)
      kmax = hi(3)
c
c     Added to prevent underflow for small s values.
c
      do k = lo(3)-ng, hi(3)+ng
         do j = lo(2)-ng, hi(2)+ng
            do i = lo(1)-ng, hi(1)+ng
               s(i,j,k) = cvmgt(s(i,j,k), zero, abs(s(i,j,k)).gt.1.0D-20)
            end do
         end do
      end do
c
c     COMPUTE 0TH order slopes
c
      if (slope_order.eq.1) then
        if (ng .lt. 1) then
	   call bl_abort("FORT_SLOPES: not enough bndry cells for 1st order")
        end if
        do k = kmin-1, kmax+1
           do j = jmin-1, jmax+1 
              do i = imin-1, imax+1
                 slx(i,j,k) = zero
                 sly(i,j,k) = zero
                 slz(i,j,k) = zero
              end do
           end do
        end do
        return
      end if

c
c     COMPUTE 2ND order slopes
c
      if (slope_order.eq.2) then
        if (ng .lt. 2) then
	   call bl_abort("FORT_SLOPES: not enough bndry cells for 2nd order")
        end if
c
c     ------------------------ x slopes
c
        if ( (dir.eq.XVEL) .or. (dir.eq.ALL) ) then
         if (use_unlimited_slopes) then
            do k = kmin-1,kmax+1
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  slx(i,j,k)= half*(s(i+1,j,k) - s(i-1,j,k))
               end do
            end do
            end do
            if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do j = jmin-1, jmax+1
                  slx(imin-1,j,k) = zero
                  slx(imin  ,j,k) = (s(imin+1,j,k)+three*s(imin,j,k)-four*s(imin-1,j,k))/three
               end do
               end do
            end if
            if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do j = jmin-1, jmax+1
                  slx(imax+1,j,k) = zero
                  slx(imax  ,j,k) = -(s(imax-1,j,k)+three*s(imax,j,k)-four*s(imax+1,j,k))/three
               end do
               end do
            end if
         else
            do k = kmin-1,kmax+1
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  del  = half*(s(i+1,j,k) - s(i-1,j,k))
                  dpls =  two*(s(i+1,j,k) - s(i  ,j,k))
                  dmin =  two*(s(i  ,j,k) - s(i-1,j,k))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(i,j,k)= sflg*min(slim,abs(del))
               end do
            end do
            end do
            
            if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do j = jmin-1, jmax+1
                  slx(imin-1,j,k) = zero
                  del  = (s(imin+1,j,k)+three*s(imin,j,k)-four*s(imin-1,j,k))/three
                  dpls = two*(s(imin+1,j,k) - s(imin  ,j,k))
                  dmin = two*(s(imin  ,j,k) - s(imin-1,j,k))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(imin,j,k)= sflg*min(slim,abs(del))
               end do
               end do
            end if
            if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do j = jmin-1, jmax+1
                  slx(imax+1,j,k) = zero
                  del  = -(s(imax-1,j,k)+three*s(imax,j,k)-four*s(imax+1,j,k))/three
                  dpls = two*(s(imax+1,j,k) - s(imax  ,j,k))
                  dmin = two*(s(imax  ,j,k) - s(imax-1,j,k))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slx(imax,j,k)= sflg*min(slim,abs(del))
               end do
               end do
            end if
          end if
         end if
c
c     ------------------------ y slopes
c
        if ( (dir.eq.YVEL) .or. (dir.eq.ALL) ) then
         if (use_unlimited_slopes) then
            do k = kmin-1,kmax+1
            do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  sly(i,j,k) = half*(s(i,j+1,k)-s(i,j-1,k))
               end do
            end do
            end do
            if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do i = imin-1, imax+1
                  sly(i,jmin-1,k) = zero
                  sly(i,jmin  ,k) = (s(i,jmin+1,k)+three*s(i,jmin,k)-four*s(i,jmin-1,k))/three
               end do
               end do
            end if
            if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do i = imin-1, imax+1
                  sly(i,jmax+1,k) = zero
                  sly(i,jmax  ,k) = -(s(i,jmax-1,k)+three*s(i,jmax,k)-four*s(i,jmax+1,k))/three
               end do
               end do
            end if
         else
            do j = jmin-1,jmax+1
               do k = kmin-1,kmax+1
               do i = imin-1,imax+1
                  del  = half*(s(i,j+1,k) - s(i,j-1,k))
                  dpls =  two*(s(i,j+1,k) - s(i,j  ,k))
                  dmin =  two*(s(i,j  ,k) - s(i,j-1,k))
                  slim = min(abs(dpls),abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,j,k)= sflg*min(slim,abs(del))
               end do
               end do
            end do

            if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do i = imin-1, imax+1
                  sly(i,jmin-1,k) = zero
                  del  = (s(i,jmin+1,k)+three*s(i,jmin,k)-four*s(i,jmin-1,k))/three
                  dpls = two*(s(i,jmin+1,k) - s(i,jmin  ,k))
                  dmin = two*(s(i,jmin  ,k) - s(i,jmin-1,k))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,jmin,k)= sflg*min(slim,abs(del))
               end do
               end do
            end if
            if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
               do k = kmin-1, kmax+1
               do i = imin-1, imax+1
                  sly(i,jmax+1,k) = zero
                  del  = -(s(i,jmax-1,k)+three*s(i,jmax,k)-four*s(i,jmax+1,k))/three
                  dpls = two*(s(i,jmax+1,k) - s(i,jmax  ,k))
                  dmin = two*(s(i,jmax  ,k) - s(i,jmax-1,k))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  sly(i,jmax,k)= sflg*min(slim,abs(del))
               end do
               end do
            end if
         end if
        end if

c
c     ------------------------ z slopes
c
        if ( (dir.eq.ZVEL) .or. (dir.eq.ALL) ) then
         if (use_unlimited_slopes) then
            do j = jmin-1,jmax+1
            do i = imin-1,imax+1
               do k = kmin-1,kmax+1
                  slz(i,j,k) = half*(s(i,j,k+1)-s(i,j,k-1))
               end do
            end do
            end do
            if (bc(3,1) .eq. EXT_DIR .or. bc(3,1) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
               do i = imin-1, imax+1
                  slz(i,j,kmin-1) = zero
                  slz(i,j,kmin  ) = (s(i,j,kmin+1)+three*s(i,j,kmin)-four*s(i,j,kmin-1))/three
               end do
               end do
            end if
            if (bc(3,2) .eq. EXT_DIR .or. bc(3,2) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
               do i = imin-1, imax+1
                  slz(i,j,kmax+1) = zero
                  slz(i,j,kmax  ) = -(s(i,j,kmax-1)+three*s(i,j,kmax)-four*s(i,j,kmax+1))/three
               end do
               end do
            end if
         else
            do k = kmin-1,kmax+1
               do j = jmin-1,jmax+1
               do i = imin-1,imax+1
                  del  = half*(s(i,j,k+1) - s(i,j,k-1))
                  dpls =  two*(s(i,j,k+1) - s(i,j,k  ))
                  dmin =  two*(s(i,j,k  ) - s(i,j,k-1))
                  slim = min(abs(dpls),abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slz(i,j,k)= sflg*min(slim,abs(del))
               end do
               end do
            end do

            if (bc(3,1) .eq. EXT_DIR .or. bc(3,1) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
               do i = imin-1, imax+1
                  slz(i,j,kmin-1) = zero
                  del  = (s(i,j,kmin+1)+three*s(i,j,kmin)-four*s(i,j,kmin-1))/three
                  dpls = two*(s(i,j,kmin+1) - s(i,j,kmin  ))
                  dmin = two*(s(i,j,kmin  ) - s(i,j,kmin-1))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slz(i,j,kmin)= sflg*min(slim,abs(del))
               end do
               end do
            end if
            if (bc(3,2) .eq. EXT_DIR .or. bc(3,2) .eq. HOEXTRAP) then
               do j = jmin-1, jmax+1
               do i = imin-1, imax+1
                  slz(i,j,kmax+1) = zero
                  del  = -(s(i,j,kmax-1)+three*s(i,j,kmax)-four*s(i,j,kmax+1))/three
                  dpls = two*(s(i,j,kmax+1) - s(i,j,kmax  ))
                  dmin = two*(s(i,j,kmax  ) - s(i,j,kmax-1))
                  slim = min(abs(dpls), abs(dmin))
                  slim = cvmgp(slim, zero, dpls*dmin)
                  sflg = sign(one,del)
                  slz(i,j,kmax)= sflg*min(slim,abs(del))
               end do
               end do
            end if
         end if
        end if
c
c ... end, if slope_order .eq. 2
c
      end if
c
c     COMPUTE 4TH order slopes
c
      if (slope_order.eq.4)then
        if (ng .lt. 3) then
	   call bl_abort("SLOPE_3D: not enough bndry cells for 4th order")
        end if
c
c     ------------------------ x slopes
c
        if ( (dir.eq.XVEL) .or. (dir.eq.ALL) ) then
           if (use_unlimited_slopes) then
              do k = kmin-1,kmax+1
                 do j = jmin-1,jmax+1
                    do i = imin-2,imax+2
                       slxscr(i,cen)  = half*(s(i+1,j,k)-s(i-1,j,k))
                    end do
                    do i = imin-1,imax+1
                       slx(i,j,k) = two * two3rd * slxscr(i,cen) -
     &                      sixth * (slxscr(i+1,cen) + slxscr(i-1,cen))
                    end do
                 end do
              end do
              
              if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
                 do k = kmin-1,kmax+1
                    do j = jmin-1, jmax+1
                       slx(imin,j,k) = -sixteen/fifteen*s(imin-1,j,k) + half*s(imin,j,k) + 
     &                      two3rd*s(imin+1,j,k) - tenth*s(imin+2,j,k)
                       slx(imin-1,j,k) = zero
                    end do
                 end do
              end if
              if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
                 do k = kmin-1,kmax+1
                    do j = jmin-1, jmax+1
                       slx(imax,j,k) = -( -sixteen/fifteen*s(imax+1,j,k) + half*s(imax,j,k) + 
     &                      two3rd*s(imax-1,j,k) - tenth*s(imax-2,j,k) )
                       slx(imax+1,j,k) = zero
                    end do
                 end do
              end if
           else
              do k = kmin-1,kmax+1
                 do j = jmin-1,jmax+1 
                    do i = imin-2,imax+2
                       dmin           =  two*(s(i,  j,k)-s(i-1,j,k))
                       dpls           =  two*(s(i+1,j,k)-s(i,  j,k))
                       slxscr(i,cen)  = half*(s(i+1,j,k)-s(i-1,j,k))
                       slxscr(i,lim)  = min(abs(dmin),abs(dpls))
                       slxscr(i,lim)  = cvmgp(slxscr(i,lim),zero,dpls*dmin)
                       slxscr(i,flag) = sign(one,slxscr(i,cen))
                       slxscr(i,fromm)= slxscr(i,flag)*
     &                      min(slxscr(i,lim),abs(slxscr(i,cen)))
                    end do
                    do i = imin-1,imax+1
                       ds = two * two3rd * slxscr(i,cen) - 
     &                      sixth * (slxscr(i+1,fromm) + slxscr(i-1,fromm))
                       slx(i,j,k) = slxscr(i,flag)*min(abs(ds),slxscr(i,lim))
                    end do

                    if (bc(1,1) .eq. EXT_DIR .or. bc(1,1) .eq. HOEXTRAP) then
                       del  = -sixteen/fifteen*s(imin-1,j,k) + half*s(imin,j,k) + 
     &                      two3rd*s(imin+1,j,k) -  tenth*s(imin+2,j,k)
                       dmin = two*(s(imin  ,j,k)-s(imin-1,j,k))
                       dpls = two*(s(imin+1,j,k)-s(imin  ,j,k))
                       slim = min(abs(dpls), abs(dmin))
                       slim = cvmgp(slim, zero, dpls*dmin)
                       sflg = sign(one,del)
                       slx(imin-1,j,k) = zero
                       slx(imin,  j,k) = sflg*min(slim,abs(del))

c                      Recalculate the slope at imin+1 using the revised slxscr(imin,fromm)
                       slxscr(imin,fromm) = slx(imin,j,k)
                       ds = two * two3rd * slxscr(imin+1,cen) -
     $                    sixth * (slxscr(imin+2,fromm) + slxscr(imin,fromm))
                       slx(imin+1,j,k) = slxscr(imin+1,flag)*min(abs(ds),slxscr(imin+1,lim))
                    end if

                    if (bc(1,2) .eq. EXT_DIR .or. bc(1,2) .eq. HOEXTRAP) then
                       del  = -( -sixteen/fifteen*s(imax+1,j,k) + half*s(imax,j,k) + 
     &                      two3rd*s(imax-1,j,k) - tenth*s(imax-2,j,k) )
                       dmin = two*(s(imax  ,j,k)-s(imax-1,j,k))
                       dpls = two*(s(imax+1,j,k)-s(imax  ,j,k))
                       slim = min(abs(dpls), abs(dmin))
                       slim = cvmgp(slim, zero, dpls*dmin)
                       sflg = sign(one,del)
                       slx(imax,  j,k) = sflg*min(slim,abs(del))
                       slx(imax+1,j,k) = zero

c                      Recalculate the slope at imax-1 using the revised slxscr(imax,fromm)
                       slxscr(imax,fromm) = slx(imax,j,k)
                       ds = two * two3rd * slxscr(imax-1,cen) -
     $                    sixth * (slxscr(imax-2,fromm) + slxscr(imax,fromm))
                       slx(imax-1,j,k) = slxscr(imax-1,flag)*min(abs(ds),slxscr(imax-1,lim))
                    end if
                 end do
              end do
           end if
        end if
c
c     ------------------------ y slopes
c
        if ( (dir.eq.YVEL) .or. (dir.eq.ALL) ) then
           if (use_unlimited_slopes) then
              do k = kmin-1,kmax+1
                 do i = imin-1,imax+1
                    do j = jmin-2,jmax+2
                       slyscr(j,cen)  = half*(s(i,j+1,k)-s(i,j-1,k))
                    end do
                    do j = jmin-1,jmax+1
                       sly(i,j,k) = two * two3rd * slyscr(j,cen) -
     &                      sixth * (slyscr(j+1,cen) + slyscr(j-1,cen))
                    end do
                 end do
              end do
              
              if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
                 do k = kmin-1,kmax+1
                    do i = imin-1, imax+1
                       sly(i,jmin-1,k) = zero
                       sly(i,jmin,k) = -sixteen/fifteen*s(i,jmin-1,k) + half*s(i,jmin,k) + 
     &                      two3rd*s(i,jmin+1,k) - tenth*s(i,jmin+2,k)
                    end do
                 end do
              end if
              if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
                 do k = kmin-1,kmax+1
                    do i = imin-1, imax+1
                       sly(i,jmax,k) = -( -sixteen/fifteen*s(i,jmax+1,k) + half*s(i,jmax,k) + 
     &                      two3rd*s(i,jmax-1,k) - tenth*s(i,jmax-2,k) )
                       sly(i,jmax+1,k) = zero
                    end do
                 end do
              end if
           else
              do k = kmin-1,kmax+1
                 do i = imin-1,imax+1 
                    do j = jmin-2,jmax+2
                       dmin           =  two*(s(i,j,  k)-s(i,j-1,k))
                       dpls           =  two*(s(i,j+1,k)-s(i,j,  k))
                       slyscr(j,cen)  = half*(s(i,j+1,k)-s(i,j-1,k))
                       slyscr(j,lim)  = min(abs(dmin),abs(dpls))
                       slyscr(j,lim)  = cvmgp(slyscr(j,lim),zero,dpls*dmin)
                       slyscr(j,flag) = sign(one,slyscr(j,cen))
                       slyscr(j,fromm)= slyscr(j,flag)*
     &                      min(slyscr(j,lim),abs(slyscr(j,cen)))
                    end do
                    do j = jmin-1,jmax+1
                       ds = two * two3rd * slyscr(j,cen) - 
     &                      sixth * (slyscr(j+1,fromm) + slyscr(j-1,fromm))
                       sly(i,j,k) = slyscr(j,flag)*min(abs(ds),slyscr(j,lim))
                    end do
c
                    if (bc(2,1) .eq. EXT_DIR .or. bc(2,1) .eq. HOEXTRAP) then
                       del  = -sixteen/fifteen*s(i,jmin-1,k) + half*s(i,jmin,k) + 
     &                      two3rd*s(i,jmin+1,k) - tenth*s(i,jmin+2,k)
                       dmin = two*(s(i,jmin  ,k)-s(i,jmin-1,k))
                       dpls = two*(s(i,jmin+1,k)-s(i,jmin  ,k))
                       slim = min(abs(dpls), abs(dmin))
                       slim = cvmgp(slim, zero, dpls*dmin)
                       sflg = sign(one,del)
                       sly(i,jmin-1,k) = zero
                       sly(i,jmin,  k) = sflg*min(slim,abs(del))

c                      Recalculate the slope at jmin+1 using the revised slyscr(jmin,fromm)
                       slyscr(jmin,fromm) = sly(i,jmin,k)
                       ds = two * two3rd * slyscr(jmin+1,cen) -
     $                    sixth * (slyscr(jmin+2,fromm) + slyscr(jmin,fromm))
                       sly(i,jmin+1,k) = slyscr(jmin+1,flag)*min(abs(ds),slyscr(jmin+1,lim))
                    end if
                    if (bc(2,2) .eq. EXT_DIR .or. bc(2,2) .eq. HOEXTRAP) then
                       del  = -( -sixteen/fifteen*s(i,jmax+1,k) + half*s(i,jmax,k) +
     &                      two3rd*s(i,jmax-1,k) - tenth*s(i,jmax-2,k) )
                       dmin = two*(s(i,jmax  ,k)-s(i,jmax-1,k))
                       dpls = two*(s(i,jmax+1,k)-s(i,jmax  ,k))
                       slim = min(abs(dpls), abs(dmin))
                       slim = cvmgp(slim, zero, dpls*dmin)
                       sflg = sign(one,del)
                       sly(i,jmax, k)  = sflg*min(slim,abs(del))
                       sly(i,jmax+1,k) = zero

c                      Recalculate the slope at jmax-1 using the revised slyscr(jmax,fromm)
                       slyscr(jmax,fromm) = sly(i,jmax,k)
                       ds = two * two3rd * slyscr(jmax-1,cen) -
     $                    sixth * (slyscr(jmax-2,fromm) + slyscr(jmax,fromm))
                       sly(i,jmax-1,k) = slyscr(jmax-1,flag)*min(abs(ds),slyscr(jmax-1,lim))
                    end if
                 end do
              end do
           end if
        end if
c
c     ------------------------ z slopes
c
        if ( (dir.eq.ZVEL) .or. (dir.eq.ALL) ) then
           if (use_unlimited_slopes) then
              do j = jmin-1,jmax+1
                 do i = imin-1,imax+1
                    do k = kmin-2,kmax+2
                       slzscr(k,cen)  = half*(s(i,j,k+1)-s(i,j,k-1))
                    end do
                    do k = kmin-1,kmax+1
                       slz(i,j,k) = two * two3rd * slzscr(k,cen) -
     &                      sixth * (slzscr(k+1,cen) + slzscr(k-1,cen))
                    end do
                 end do
              end do
              
              if (bc(3,1) .eq. EXT_DIR .or. bc(3,1) .eq. HOEXTRAP) then
                 do i = imin-1, imax+1
                    do j = jmin-1, jmax+1
                       slz(i,j,kmin-1) = zero
                       slz(i,j,kmin) = -sixteen/fifteen*s(i,j,kmin-1) + half*s(i,j,kmin) + 
     &                      two3rd*s(i,j,kmin+1) - tenth*s(i,j,kmin+2)
                    end do
                 end do
              end if
              if (bc(3,2) .eq. EXT_DIR .or. bc(3,2) .eq. HOEXTRAP) then
                 do j = jmin-1, jmax+1
                    do i = imin-1, imax+1
                       slz(i,j,kmax) = -( -sixteen/fifteen*s(i,j,kmax+1) + half*s(i,j,kmax) + 
     &                      two3rd*s(i,j,kmax-1) - tenth*s(i,j,kmax-2) )
                       slz(i,j,kmax+1) = zero
                    end do
                 end do
              end if
           else
              do j = jmin-1,jmax+1
                 do i = imin-1,imax+1
                    do k = kmin-2,kmax+2
                       dmin           =  two*(s(i,j,k  )-s(i,j,k-1))
                       dpls           =  two*(s(i,j,k+1)-s(i,j,k  ))
                       slzscr(k,cen)  = half*(s(i,j,k+1)-s(i,j,k-1))
                       slzscr(k,lim)  = min(abs(dmin),abs(dpls))
                       slzscr(k,lim)  = cvmgp(slzscr(k,lim),zero,dpls*dmin)
                       slzscr(k,flag) = sign(one,slzscr(k,cen))
                       slzscr(k,fromm)= slzscr(k,flag)*
     &                      min(slzscr(k,lim),abs(slzscr(k,cen)))
                    end do
                    do k = kmin-1,kmax+1
                       ds = two * two3rd * slzscr(k,cen) -
     &                      sixth * (slzscr(k+1,fromm) + slzscr(k-1,fromm))
                       slz(i,j,k) = slzscr(k,flag)*min(abs(ds),slzscr(k,lim))
                    end do
c
                    if (bc(3,1) .eq. EXT_DIR .or. bc(3,1) .eq. HOEXTRAP) then
                       del  = -sixteen/fifteen*s(i,j,kmin-1) + half*s(i,j,kmin) +
     &                      two3rd*s(i,j,kmin+1) - tenth*s(i,j,kmin+2)
                       dmin = two*(s(i,j,kmin  )-s(i,j,kmin-1))
                       dpls = two*(s(i,j,kmin+1)-s(i,j,kmin  ))
                       slim = min(abs(dpls), abs(dmin))
                       slim = cvmgp(slim, zero, dpls*dmin)
                       sflg = sign(one,del)
                       slz(i,j,kmin-1) = zero
                       slz(i,j,kmin  ) = sflg*min(slim,abs(del))

c                      Recalculate the slope at jmin+1 using the revised slzscr(kmin,fromm)
                       slzscr(kmin,fromm) = slz(i,j,kmin)
                       ds = two * two3rd * slzscr(kmin+1,cen) -
     $                    sixth * (slzscr(kmin+2,fromm) + slzscr(kmin,fromm))
                       slz(i,j,kmin+1) = slzscr(kmin+1,flag)*min(abs(ds),slzscr(kmin+1,lim))
                    end if
                    if (bc(3,2) .eq. EXT_DIR .or. bc(3,2) .eq. HOEXTRAP) then
                       del  = sixteen/fifteen*s(i,j,kmax+1) - half*s(i,j,kmax)
     &                      - two3rd*s(i,j,kmax-1) + tenth*s(i,j,kmax-2)
                       dmin = two*(s(i,j,kmax  )-s(i,j,kmax-1))
                       dpls = two*(s(i,j,kmax+1)-s(i,j,kmax  ))
                       slim = min(abs(dpls), abs(dmin))
                       slim = cvmgp(slim, zero, dpls*dmin)
                       sflg = sign(one,del)
                       slz(i,j,kmax  ) = sflg*min(slim,abs(del))
                       slz(i,j,kmax+1) = zero

c                      Recalculate the slope at jmax-1 using the revised slzscr(kmax,fromm)
                       slzscr(kmax,fromm) = slz(i,j,kmax)
                       ds = two * two3rd * slzscr(kmax-1,cen) -
     $                    sixth * (slzscr(kmax-2,fromm) + slzscr(kmax,fromm))
                       slz(i,j,kmax-1) = slzscr(kmax-1,flag)*min(abs(ds),slzscr(kmax-1,lim))
                    end if
                 end do
              end do
           end if
        end if
c
c ... end, if slope_order .eq. 4
c
      end if

      end

      subroutine FORT_SCALMINMAX(s,DIMS(s),sn,DIMS(sn),
     &     smin,smax,DIMS(smin),
     &     lo,hi,bc)
c
c     correct an advected field for under/over shoots
c
      integer  i, j, k, imin, imax, jmin, jmax, kmin, kmax
      integer  DIMDEC(s)
      integer  DIMDEC(sn)
      integer  DIMDEC(smin)
      integer  lo(SDIM), hi(SDIM)
      integer  bc(SDIM,2), do_minmax
      REAL_T   s(DIMV(s))
      REAL_T   sn(DIMV(sn))
      integer  km, kk, kp
      REAL_T   smn, smx
      REAL_T   smin(DIM12(smin),0:2)
      REAL_T   smax(DIM12(smin),0:2)

      imin = lo(1)
      imax = hi(1)
      jmin = lo(2)
      jmax = hi(2)
      kmin = lo(3)
      kmax = hi(3)
c
c     correct the 8 corners
c
      if (bc(1,1).ne.INT_DIR .or. bc(2,1).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
         s(imin-1,jmin-1,kmin-1) = s(imin,jmin,kmin)
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(2,1).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
         s(imax+1,jmin-1,kmin-1) = s(imax,jmin,kmin)
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(2,2).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
         s(imin-1,jmax+1,kmin-1) = s(imin,jmax,kmin)
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(2,2).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
         s(imax+1,jmax+1,kmin-1) = s(imax,jmax,kmin)
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(2,1).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
         s(imin-1,jmin-1,kmax+1) = s(imin,jmin,kmax)
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(2,1).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
         s(imax+1,jmin-1,kmax+1) = s(imax,jmin,kmax)
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(2,2).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
         s(imin-1,jmax+1,kmax+1) = s(imin,jmax,kmax)
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(2,2).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
         s(imax+1,jmax+1,kmax+1) = s(imax,jmax,kmax)
      end if
c
c     correct the 12 edges
c
      if (bc(1,1).ne.INT_DIR .or. bc(2,1).ne.INT_DIR) then
        do k = kmin,kmax
          s(imin-1,jmin-1,k) = s(imin,jmin,k)
        end do
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(2,1).ne.INT_DIR) then
        do k = kmin,kmax
          s(imax+1,jmin-1,k) = s(imax,jmin,k)
        end do
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(2,2).ne.INT_DIR) then
        do k = kmin,kmax
          s(imin-1,jmax+1,k) = s(imin,jmax,k)
        end do
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(2,2).ne.INT_DIR) then
        do k = kmin,kmax
          s(imax+1,jmax+1,k) = s(imax,jmax,k)
        end do
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
        do j = jmin,jmax
          s(imin-1,j,kmin-1) = s(imin,j,kmin)
        end do
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
        do j = jmin,jmax
          s(imax+1,j,kmin-1) = s(imax,j,kmin)
        end do
      end if
      if (bc(1,1).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
        do j = jmin,jmax
          s(imin-1,j,kmax+1) = s(imin,j,kmax)
        end do
      end if
      if (bc(1,2).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
        do j = jmin,jmax
          s(imax+1,j,kmax+1) = s(imax,j,kmax)
        end do
      end if
      if (bc(2,1).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
        do i = imin,imax
          s(i,jmin-1,kmin-1) = s(i,jmin,kmin)
        end do
      end if
      if (bc(2,2).ne.INT_DIR .or. bc(3,1).ne.INT_DIR) then
        do i = imin,imax
          s(i,jmax+1,kmin-1) = s(i,jmax,kmin)
        end do
      end if
      if (bc(2,1).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
        do i = imin,imax
          s(i,jmin-1,kmax+1) = s(i,jmin,kmax)
        end do
      end if
      if (bc(2,2).ne.INT_DIR .or. bc(3,2).ne.INT_DIR) then
        do i = imin,imax
          s(i,jmax+1,kmax+1) = s(i,jmax,kmax)
        end do
      end if
c
c     ::::: compute min/max a slab at a time
c     ::::: compute min and max of neighbors on kmin-1 slab
c
      km = 0
      kk = 1
      kp = 2

      k = kmin-1
      do j = jmin, jmax         
         do i = imin, imax
            smin(i,j,km) = min(s(i-1,j-1,k),s(i,j-1,k),s(i+1,j-1,k),
     &           s(i-1,j  ,k),s(i,j  ,k),s(i+1,j  ,k),
     &           s(i-1,j+1,k),s(i,j+1,k),s(i+1,j+1,k))
            smax(i,j,km) = max(s(i-1,j-1,k),s(i,j-1,k),s(i+1,j-1,k),
     &           s(i-1,j  ,k),s(i,j  ,k),s(i+1,j  ,k),
     &           s(i-1,j+1,k),s(i,j+1,k),s(i+1,j+1,k))
         end do         
      end do
c
c     ::::: compute min and max of neighbors on kmin slab
c
      k = kmin
      do j = jmin, jmax         
         do i = imin, imax
            smin(i,j,kk) = min(s(i-1,j-1,k),s(i,j-1,k),s(i+1,j-1,k),
     &           s(i-1,j  ,k),s(i,j  ,k),s(i+1,j  ,k),
     &           s(i-1,j+1,k),s(i,j+1,k),s(i+1,j+1,k))
            smax(i,j,kk) = max(s(i-1,j-1,k),s(i,j-1,k),s(i+1,j-1,k),
     &           s(i-1,j  ,k),s(i,j  ,k),s(i+1,j  ,k),
     &           s(i-1,j+1,k),s(i,j+1,k),s(i+1,j+1,k))
         end do         
      end do

      do k = kmin, kmax
c
c        ::::: compute min and max of neighbors on k+1 slab
c
         do j = jmin, jmax     
            do i = imin, imax   
               smin(i,j,kp) = min(s(i-1,j-1,k+1),s(i,j-1,k+1),s(i+1,j-1,k+1),
     &              s(i-1,j  ,k+1),s(i,j  ,k+1),s(i+1,j  ,k+1),
     &              s(i-1,j+1,k+1),s(i,j+1,k+1),s(i+1,j+1,k+1))
               smax(i,j,kp) = max(s(i-1,j-1,k+1),s(i,j-1,k+1),s(i+1,j-1,k+1),
     &              s(i-1,j  ,k+1),s(i,j  ,k+1),s(i+1,j  ,k+1),
     &              s(i-1,j+1,k+1),s(i,j+1,k+1),s(i+1,j+1,k+1))
c
c        ::::: compute min/max of cell
c
               smn = min(smin(i,j,km),smin(i,j,kk),smin(i,j,kp))
               smx = max(smax(i,j,km),smax(i,j,kk),smax(i,j,kp))
               sn(i,j,k) = max(sn(i,j,k),smn)
               sn(i,j,k) = min(sn(i,j,k),smx)
               
            end do
         end do
c
c        ::::: roll indices for next slab
c
         km = mod(km+1,3)
         kk = mod(kk+1,3)
         kp = mod(kp+1,3)
      end do

      end

      subroutine FORT_SUM_TF_GP(
     &     tforces,DIMS(tf),
     &     gp,DIMS(gp),
     &     rho,DIMS(rho),
     &     lo,hi )
c
c     sum pressure forcing into tforces
c
      integer i, j, k, n
      integer DIMDEC(tf)
      integer DIMDEC(visc)
      integer DIMDEC(gp)
      integer DIMDEC(rho)
      integer lo(SDIM), hi(SDIM)
      REAL_T tforces(DIMV(tf),SDIM)
      REAL_T gp(DIMV(gp),SDIM)
      REAL_T rho(DIMV(rho))

      do n = 1, SDIM
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tforces(i,j,k,n) = (
     &            tforces(i,j,k,n) - gp(i,j,k,n)
     &                 )/rho(i,j,k)
               end do
            end do
         end do
      end do

      end

      subroutine FORT_SUM_TF_GP_VISC(
     &     tforces,DIMS(tf),
     &     visc,DIMS(visc),
     &     gp,DIMS(gp),
     &     rho,DIMS(rho),
     &     lo,hi )
c
c     sum pressure forcing and viscous forcing into
c     tforces
c
      integer i, j, k, n
      integer DIMDEC(tf)
      integer DIMDEC(visc)
      integer DIMDEC(gp)
      integer DIMDEC(rho)
      integer lo(SDIM), hi(SDIM)
      REAL_T tforces(DIMV(tf),SDIM)
      REAL_T visc(DIMV(visc),SDIM)
      REAL_T gp(DIMV(gp),SDIM)
      REAL_T rho(DIMV(rho))

      do n = 1, SDIM
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tforces(i,j,k,n) = (
     &                 tforces(i,j,k,n)
     &                 +  visc(i,j,k,n)
     &                 -    gp(i,j,k,n) )/rho(i,j,k)
               end do
            end do
         end do
      end do

      end

      subroutine FORT_SUM_TF_DIVU(
     &     S,DIMS(S),
     &     tforces,DIMS(tf),
     &     divu,DIMS(divu),
     &     rho,DIMS(rho),
     &     lo,hi,nvar,iconserv )
c
c     sum tforces, viscous forcing and divU*S into tforces
c     depending on the value of iconserv
c
      integer nvar, iconserv
      integer lo(SDIM), hi(SDIM)
      integer i, j, k, n

      integer DIMDEC(S)
      integer DIMDEC(tf)
      integer DIMDEC(divu)
      integer DIMDEC(rho)

      REAL_T S(DIMV(S),nvar)
      REAL_T tforces(DIMV(tf),nvar)
      REAL_T divu(DIMV(divu))
      REAL_T rho(DIMV(rho))

      if ( iconserv .eq. 1 ) then
         do n = 1, nvar
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     tforces(i,j,k,n) = 
     &               tforces(i,j,k,n) - S(i,j,k,n)*divu(i,j,k)
                  end do
               end do
            end do
         end do
      else
         do n = 1, nvar
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     tforces(i,j,k,n) = 
     &               tforces(i,j,k,n)/rho(i,j,k)
                  end do
               end do
            end do
         end do
      end if

      end

      subroutine FORT_SUM_TF_DIVU_VISC(
     &     S,DIMS(S),
     &     tforces,DIMS(tf),
     &     divu,DIMS(divu),
     &     visc,DIMS(visc),
     &     rho,DIMS(rho),
     &     lo,hi,nvar,iconserv )
c
c     sum tforces, viscous forcing and divU*S into tforces
c     depending on the value of iconserv
c
      integer nvar, iconserv
      integer lo(SDIM), hi(SDIM)
      integer i, j, k, n

      integer DIMDEC(S)
      integer DIMDEC(tf)
      integer DIMDEC(divu)
      integer DIMDEC(visc)
      integer DIMDEC(rho)

      REAL_T S(DIMV(S),nvar)
      REAL_T tforces(DIMV(tf),nvar)
      REAL_T divu(DIMV(divu))
      REAL_T visc(DIMV(visc),nvar)
      REAL_T rho(DIMV(rho))

      if ( iconserv .eq. 1 ) then
         do n = 1, nvar
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     tforces(i,j,k,n) = 
     &                    tforces(i,j,k,n)
     &                    +  visc(i,j,k,n)
     &                    -     S(i,j,k,n)*divu(i,j,k)
                  end do
               end do
            end do
         end do
      else
         do n = 1, nvar
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     tforces(i,j,k,n) = (
     &                    tforces(i,j,k,n)
     &                    +  visc(i,j,k,n) )/rho(i,j,k)
                  end do
               end do
            end do
         end do
      end if

      end

      subroutine FORT_UPDATE_TF(
     &     s,       DIMS(s),
     &     sn,      DIMS(sn),
     &     tforces, DIMS(tf),
     &     lo,hi,dt,nvar)
c
c     update a field with a forcing term
c
      integer i, j, k, n, nvar
      integer DIMDEC(s)
      integer DIMDEC(sn)
      integer DIMDEC(tf)
      integer lo(SDIM), hi(SDIM)
      REAL_T dt
      REAL_T s(DIMV(s),nvar)
      REAL_T sn(DIMV(sn),nvar)
      REAL_T tforces(DIMV(tf),nvar)

      do n = 1,nvar
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  sn(i,j,k,n) = s(i,j,k,n)
     &                 + dt*tforces(i,j,k,n)
               end do
            end do
         end do
      end do

      end

      subroutine FORT_CORRECT_TF(
     &     ss,  sp,  DIMS(ss),
     &     tfs, tfn, DIMS(tfs),
     &     lo,hi,dt,nvar)
c
c     correct 1st order rk to second-order
c
      integer i, j, k, n, nvar
      integer lo(SDIM), hi(SDIM)
      REAL_T dt,hdt

      integer DIMDEC(ss)
      integer DIMDEC(tfs)
      REAL_T  ss(DIMV(ss),nvar)
      REAL_T  sp(DIMV(ss),nvar)
      REAL_T tfs(DIMV(tfs),nvar)
      REAL_T tfn(DIMV(tfs),nvar)

      hdt = half*dt
      do n = 1,nvar
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  sp(i,j,k,n) = ss(i,j,k,n)
     &                 + hdt*(tfs(i,j,k,n)-tfn(i,j,k,n))
               end do
            end do
         end do
      end do

      end

      subroutine FORT_UPDATE_AOFS_TF(
     &     s,       DIMS(s),
     &     sn,      DIMS(sn),
     &     aofs,    DIMS(aofs),
     &     tforces, DIMS(tf),
     &     lo,hi,dt,nvar)
c
c     update a field with an advective tendency
c     and a forcing term
c
      integer i, j, k, n, nvar
      integer DIMDEC(s)
      integer DIMDEC(sn)
      integer DIMDEC(aofs)
      integer DIMDEC(tf)
      integer lo(SDIM), hi(SDIM)
      REAL_T dt
      REAL_T s(DIMV(s),nvar)
      REAL_T sn(DIMV(sn),nvar)
      REAL_T aofs(DIMV(aofs),nvar)
      REAL_T tforces(DIMV(tf),nvar)

      do n = 1,nvar
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  sn(i,j,k,n) = s(i,j,k,n)
     &                 - dt*aofs(i,j,k,n)
     &                 + dt*tforces(i,j,k,n)
               end do
            end do
         end do
      end do

      end

      subroutine FORT_UPDATE_AOFS_TF_GP(
     &     u,       DIMS(u),
     &     un,      DIMS(un),
     &     aofs,    DIMS(aofs),
     &     tforces, DIMS(tf),
     &     gp,      DIMS(gp),
     &     rho,     DIMS(rho),
     &     lo, hi, dt)

c
c     update the velocities
c
      integer i, j, k, n
      integer DIMDEC(u)
      integer DIMDEC(un)
      integer DIMDEC(aofs)
      integer DIMDEC(rho)
      integer DIMDEC(gp)
      integer DIMDEC(tf)
      integer lo(SDIM), hi(SDIM)
      REAL_T u(DIMV(u),SDIM)
      REAL_T un(DIMV(un),SDIM)
      REAL_T aofs(DIMV(aofs),SDIM)
      REAL_T rho(DIMV(rho))
      REAL_T gp(DIMV(gp),SDIM)
      REAL_T tforces(DIMV(tf),SDIM)
      REAL_T dt

      do n = 1, SDIM
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  un(i,j,k,n) = u(i,j,k,n)
     &                 - dt*   aofs(i,j,k,n)
     &                 + dt*tforces(i,j,k,n)/rho(i,j,k)
     &                 - dt*     gp(i,j,k,n)/rho(i,j,k)
               end do
            end do
         end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: INTERPBNDRYDATA_2D.F,v 1.3 2002/10/19 18:33:57 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "BC_TYPES.H"
#include "REAL.H"
#include "CONSTANTS.H"
#include "INTERPBNDRYDATA_F.H"
#include "ArrayLim.H"

#define USE_REORG_VERSION
      
#define SDIM 2
#define NUMDERIV 2
#define XDER   1
#define X2DER  2
      
      
c ---------------------------------------------------------------
c ::  FORT_BDINTERPXLO : Interpolation on Xlo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(2)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(2), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      integer  DIMDEC(cb)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM2(cb),NUMDERIV)      
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, ainterp
      integer  i, j, ic, jc, off, n
      integer  jclo, jchi, ratioy

#ifndef USE_REORG_VERSION
      
      ratioy = ratios(2)

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_L1(cb)-1
      i    = lo(1)-1

      do n = 1, nvar
c        ::::: define interp coefs
         do jc = jclo, jchi
            j = ratioy*jc
            derives(jc,XDER)  = half * (crse(ic,jc+1,n) - crse(ic,jc-1,n))
            derives(jc,X2DER) = crse(ic,jc+1,n)
     &           -              crse(ic,jc  ,n) * two
     &           +              crse(ic,jc-1,n)

            if (mask(i,j-1) .ne. not_covered) then
               derives(jc,XDER)  = crse(ic,jc+1,n) - crse(ic,jc  ,n)
               derives(jc,X2DER) = zero
c     Can we do better by sliding stencil up?
               if (mask(i,j+2*ratioy) .eq. not_covered) then
                  derives(jc,XDER)  = half*(-three*crse(ic,jc,n)
     &           +                           four*crse(ic,jc+1,n)
     &           -                           crse(ic,jc+2,n))
                  derives(jc,X2DER) = crse(ic,jc+2,n)
     &           -                    crse(ic,jc+1,n) * two
     &           +                    crse(ic  ,jc,n)
               end if
            end if
            if (mask(i,j+ratioy) .ne. not_covered) then
               derives(jc,XDER)  = crse(ic,jc  ,n) - crse(ic,jc-1,n)
               derives(jc,X2DER) = zero
c     Can we do better by sliding stencil down?
               if (mask(i,j+ratioy) .eq. not_covered) then
                  derives(jc,XDER)  = half*(three*crse(ic,jc,n)
     &           -                          four*crse(ic,jc-1,n)
     &           +                          crse(ic,jc-2,n))
                  derives(jc,X2DER) = crse(ic,jc,n)
     &           -                    crse(ic,jc-1,n) * two
     &           +                    crse(ic,jc-2,n)
               end if
            end if
            if (mask(i,j-1)     .ne. not_covered .and. 
     $          mask(i,j+ratioy) .ne. not_covered) then
               derives(jc,XDER)  = zero
            end if
         end do

c        ::::: interpolate to fine grid
         do off = 0, ratioy - 1
            xx = (dble(off - ratioy/2) + half)/ratioy
            do jc = jclo, jchi
               j = ratioy*jc + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              +        derives(jc,XDER) *xx
     &              +        half*derives(jc,X2DER)*xx**2
            end do
         end do
      end do

#else
      integer Norder, NN, m
      parameter (Norder = 3)
      REAL_T x(Norder), y(Norder), c(Norder), xInt
      ratioy = ratios(2)

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_L1(cb)-1
      i    = lo(1)-1
      
      do n=1,nvar
         do jc=jclo,jchi
            j = ratioy*jc
            
            NN = 1
            y(NN) = crse(ic,jc,n)
            x(NN) = zero

            if (mask(i,j-1).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc-1,n)
               x(NN) = -one
            else if (mask(i,j+2*ratioy).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc+2,n)
               x(NN) = two
            endif
            
            if (mask(i,j+ratioy).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc+1,n)
               x(NN) = one
            else if (mask(i,j-ratioy-1).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc-2,n)
               x(NN) = -two
            endif
               
            if ( (mask(i,j-1).ne.not_covered).and.
     &           (mask(i,j+ratioy).ne.not_covered) ) NN = 1
            
            do off = 0,ratioy-1
               xInt = (dble(off - ratioy/2) + half)/ratioy
               call polyInterpCoeff(xInt, x, NN, c)
               bdry(i,j+off,n) = zero
               do m=1,NN
                  bdry(i,j+off,n) = bdry(i,j+off,n) + c(m)*y(m)
               end do
            end do
         end do
      end do
      
#endif
      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPXHI : Interpolation on Xhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(2)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(2), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(cb)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM2(cb),NUMDERIV)      
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)

      REAL_T   xx, ainterp
      integer  i, j, ic, jc, off, n
      integer  jclo, jchi, ratioy

#ifndef USE_REORG_VERSION
      
      ratioy = ratios(2)

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_H1(cb)+1
      i    = hi(1)+1
      
      do n = 1, nvar
c        ::::: define interp coefs
         do jc = jclo, jchi
            j = ratioy*jc
            derives(jc,XDER)  = half * (crse(ic,jc+1,n) - crse(ic,jc-1,n))
            derives(jc,X2DER) = crse(ic,jc+1,n)
     &           -              crse(ic,jc  ,n) * two
     &           +              crse(ic,jc-1,n)

            if (mask(i,j-1) .ne. not_covered) then
               derives(jc,XDER)  = crse(ic,jc+1,n) - crse(ic,jc  ,n)
               derives(jc,X2DER) = zero
c     Can we do better by sliding stencil up?
               if (mask(i,j+2*ratioy) .eq. not_covered) then
                  derives(jc,XDER)  = half*(-three*crse(ic,jc,n)
     &           +                           four*crse(ic,jc+1,n)
     &           -                           crse(ic,jc+2,n))
                  derives(jc,X2DER) = crse(ic,jc+2,n)
     &           -                    crse(ic,jc+1,n) * two
     &           +                    crse(ic  ,jc,n)
               end if
            end if
            if (mask(i,j+ratioy) .ne. not_covered) then
               derives(jc,XDER)  = crse(ic,jc  ,n) - crse(ic,jc-1,n)
               derives(jc,X2DER) = zero
c     Can we do better by sliding stencil down?
               if (mask(i,j+ratioy) .eq. not_covered) then
                  derives(jc,XDER)  = half*(three*crse(ic,jc,n)
     &           -                          four*crse(ic,jc-1,n)
     &           +                          crse(ic,jc-2,n))
                  derives(jc,X2DER) = crse(ic,jc,n)
     &           -                    crse(ic,jc-1,n) * two
     &           +                    crse(ic,jc-2,n)
               end if
            end if
            if (mask(i,j-1) .ne. not_covered .and.
     $          mask(i,j+ratioy) .ne. not_covered) then
               derives(jc,XDER)  = zero
               derives(jc,X2DER)  = zero
            end if
         end do

c        ::::: interpolate to fine grid
         do off = 0, ratioy - 1
            xx = (dble(off - ratioy/2) + half)/ratioy
            do jc = jclo, jchi
               j = ratioy*jc + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              +        derives(jc,XDER) *xx
     &              +        half*derives(jc,X2DER)*xx**2
            end do
         end do
      end do

#else
      integer Norder, NN, m
      parameter (Norder = 3)
      REAL_T x(Norder), y(Norder), c(Norder), xInt
      ratioy = ratios(2)

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_H1(cb)+1
      i    = hi(1)+1
      
      do n=1,nvar
         do jc=jclo,jchi
            j = ratioy*jc
            
            NN = 1
            y(NN) = crse(ic,jc,n)
            x(NN) = zero

            if (mask(i,j-1).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc-1,n)
               x(NN) = -one
            else if (mask(i,j+2*ratioy).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc+2,n)
               x(NN) = two
            endif
            
            if (mask(i,j+ratioy).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc+1,n)
               x(NN) = one
            else if (mask(i,j-ratioy-1).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic,jc-2,n)
               x(NN) = -two
            endif
               
            if ( (mask(i,j-1).ne.not_covered).and.
     &           (mask(i,j+ratioy).ne.not_covered) ) NN = 1
            
            do off = 0,ratioy-1
               xInt = (dble(off - ratioy/2) + half)/ratioy
               call polyInterpCoeff(xInt, x, NN, c)
               bdry(i,j+off,n) = zero
               do m=1,NN
                  bdry(i,j+off,n) = bdry(i,j+off,n) + c(m)*y(m)
               end do
            end do
         end do
      end do
      
#endif
      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPYLO : Interpolation on Ylo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(2)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(2), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(cb)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM1(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   xx, ainterp
      integer  i, j, ic, jc, off, n
      integer  iclo, ichi, ratiox

#ifndef USE_REORG_VERSION
      
      ratiox = ratios(1)

      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_L2(cb)-1
      j    = lo(2)-1

      do n = 1, nvar
c        ::::: define interp coefs
         do ic = iclo, ichi
            i = ratiox*ic
            derives(ic,XDER)  = half * (crse(ic+1,jc,n) - crse(ic-1,jc,n))
            derives(ic,X2DER) = crse(ic+1,jc,n)
     &           -              crse(ic  ,jc,n) * two
     &           +              crse(ic-1,jc,n)
            if (mask(i-1,j) .ne. not_covered) then
               derives(ic,XDER)  = crse(ic+1,jc,n) - crse(ic  ,jc,n)
               derives(ic,X2DER) = zero
c     Can we do better by sliding stencil to the right
               if (mask(i+2*ratiox,j) .eq. not_covered) then
                  derives(ic,XDER)  = half*(-three*crse(ic,jc,n)
     &           +                           four*crse(ic+1,jc,n)
     &           -                           crse(ic+2,jc,n))
                  derives(ic,X2DER) = crse(ic+2,jc,n)
     &           -                    crse(ic+1,jc,n) * two
     &           +                    crse(ic  ,jc,n)
               end if
            end if
            if (mask(i+ratiox,j) .ne. not_covered) then
               derives(ic,XDER)  = crse(ic  ,jc,n) - crse(ic-1,jc,n)
               derives(ic,X2DER) = zero
            end if
c     Can we do better by sliding stencil to the left
               if (mask(i-ratiox,j) .eq. not_covered) then
                  derives(ic,XDER)  = half*(three*crse(ic,jc,n)
     &           -                          four*crse(ic-1,jc,n)
     &           +                          crse(ic-2,jc,n))
                  derives(ic,X2DER) = crse(ic,jc,n)
     &           -                    crse(ic-1,jc,n) * two
     &           +                    crse(ic-2,jc,n)
               end if
            if (mask(i-1,j) .ne. not_covered .and.
     $          mask(i+ratiox,j) .ne. not_covered) then
               derives(ic,XDER)  = zero
               derives(ic,X2DER)  = zero
            end if
         end do

c        ::::: interpolate to fine grid
         do off = 0, ratiox - 1
            xx = (dble(off - ratiox/2) + half)/ratiox
            do ic = iclo, ichi
               i = ratiox*ic + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              +        derives(ic,XDER) *xx
     &              +        half*derives(ic,X2DER)*xx**2
            end do
         end do
      end do

#else
      integer Norder, NN, m
      parameter (Norder = 3)
      REAL_T x(Norder), y(Norder), c(Norder), xInt
      ratiox = ratios(1)

      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_L2(cb)-1
      j    = lo(2)-1
      
      do n=1,nvar
         do ic=iclo,ichi
            i = ratiox*ic
            
            NN = 1
            y(NN) = crse(ic,jc,n)
            x(NN) = zero

            if (mask(i-1,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic-1,jc,n)
               x(NN) = -one
            else if (mask(i+2*ratiox,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic+2,jc,n)
               x(NN) = two
            endif
            
            if (mask(i+ratiox,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic+1,jc,n)
               x(NN) = one
            else if (mask(i-ratiox-1,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic-2,jc,n)
               x(NN) = -two
            endif
               
            if ( (mask(i-1,j).ne.not_covered).and.
     &           (mask(i+ratiox,j).ne.not_covered) ) NN = 1
            
            do off = 0,ratiox-1
               xInt = (dble(off - ratiox/2) + half)/ratiox
               call polyInterpCoeff(xInt, x, NN, c)
               bdry(i+off,j,n) = zero
               do m=1,NN
                  bdry(i+off,j,n) = bdry(i+off,j,n) + c(m)*y(m)
               end do
            end do
         end do
      end do
      
#endif
      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPYHI : Interpolation on Yhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables to interpolate
c ::  ratios(2)   => refinement ratios
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratios,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives)

      integer  nvar, ratios(2), not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(cb)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),nvar)
      REAL_T   derives(DIM1(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   xx, ainterp
      integer  i, j, ic, jc, off, n
      integer  iclo, ichi, ratiox

#ifndef USE_REORG_VERSION
      
      ratiox = ratios(1)

      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_H2(cb)+1
      j    = hi(2)+1

      do n = 1, nvar
c        ::::: define interp coefs
         do ic = iclo, ichi
            i = ratiox*ic
            derives(ic,XDER)  = half * (crse(ic+1,jc,n) - crse(ic-1,jc,n))
            derives(ic,X2DER) = crse(ic+1,jc,n)
     &           -              crse(ic  ,jc,n) * two
     &           +              crse(ic-1,jc,n)
            if (mask(i-1,j) .ne. not_covered) then
               derives(ic,XDER)  = crse(ic+1,jc,n) - crse(ic  ,jc,n)
               derives(ic,X2DER) = zero
c     Can we do better by sliding stencil to the right
               if (mask(i+2*ratiox,j) .eq. not_covered) then
                  derives(ic,XDER)  = half*(-three*crse(ic,jc,n)
     &           +                           four*crse(ic+1,jc,n)
     &           -                           crse(ic+2,jc,n))
                  derives(ic,X2DER) = crse(ic+2,jc,n)
     &           -                    crse(ic+1,jc,n) * two
     &           +                    crse(ic  ,jc,n)
               end if
            end if
            if (mask(i+ratiox,j) .ne. not_covered) then
               derives(ic,XDER)  = crse(ic  ,jc,n) - crse(ic-1,jc,n)
               derives(ic,X2DER) = zero
c     Can we do better by sliding stencil to the left
               if (mask(i-ratiox,j) .eq. not_covered) then
                  derives(ic,XDER)  = half*(three*crse(ic,jc,n)
     &           -                          four*crse(ic-1,jc,n)
     &           +                          crse(ic-2,jc,n))
                  derives(ic,X2DER) = crse(ic,jc,n)
     &           -                    crse(ic-1,jc,n) * two
     &           +                    crse(ic-2,jc,n)
               end if
            end if
            if (mask(i-1,j) .ne. not_covered .and.
     $          mask(i+ratiox,j) .ne. not_covered) then
               derives(ic,XDER)  = zero
               derives(ic,X2DER)  = zero
            end if
         end do

c        ::::: interpolate to fine grid
         do off = 0, ratiox - 1
            xx = (dble(off - ratiox/2) + half)/ratiox
            do ic = iclo, ichi
               i = ratiox*ic + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              +        derives(ic,XDER) *xx
     &              +        half*derives(ic,X2DER)*xx**2
            end do
         end do
      end do

#else
      integer Norder, NN, m
      parameter (Norder = 3)
      REAL_T x(Norder), y(Norder), c(Norder), xInt
      ratiox = ratios(1)

      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_H2(cb)+1
      j    = hi(2)+1
      
      do n=1,nvar
         do ic=iclo,ichi
            i = ratiox*ic
            
            NN = 1
            y(NN) = crse(ic,jc,n)
            x(NN) = zero

            if (mask(i-1,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic-1,jc,n)
               x(NN) = -one
            else if (mask(i+2*ratiox,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic+2,jc,n)
               x(NN) = two
            endif
            
            if (mask(i+ratiox,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic+1,jc,n)
               x(NN) = one
            else if (mask(i-ratiox-1,j).eq.not_covered) then
               NN=NN+1
               y(NN) = crse(ic-2,jc,n)
               x(NN) = -two
            endif
               
            if ( (mask(i-1,j).ne.not_covered).and.
     &           (mask(i+ratiox,j).ne.not_covered) ) NN = 1
            
            do off = 0,ratiox-1
               xInt = (dble(off - ratiox/2) + half)/ratiox
               call polyInterpCoeff(xInt, x, NN, c)
               bdry(i+off,j,n) = zero
               do m=1,NN
                  bdry(i+off,j,n) = bdry(i+off,j,n) + c(m)*y(m)
               end do
            end do
         end do
      end do
      
#endif
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "BC_TYPES.H"
#include "REAL.H"
#include "CONSTANTS.H"
#include "MCINTERPBNDRYDATA_F.H"
#include "ArrayLim.H"

#define SDIM 2
#define NUMDERIV 2
#define XDER   1
#define X2DER  2
      
      
c ---------------------------------------------------------------
c ::  FORT_BDINTERPXLO : Interpolation on Xlo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(crse)
      integer  DIMDEC(cb)
      REAL_T   bdry(DIMV(bdry),2*nvar)
      REAL_T   derives(DIM2(cb),NUMDERIV)      
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   hfine
      REAL_T  hcrse

      REAL_T   xx
      integer  i, j, ic, jc, off, n
      integer  jclo, jchi

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_L1(cb)-1
      i    = lo(1)-1
      hcrse = ratio*hfine

      do n = 1, nvar
c        ::::: define interp coefs
         do jc = jclo, jchi
            j = ratio*jc
            if( mask(i,j-1).eq.not_covered .and.
     &          mask(i,j+ratio).eq.not_covered ) then
               derives(jc,XDER)  = (crse(ic,jc+1,n)-crse(ic,jc-1,n))/(2*hcrse)
               derives(jc,X2DER) = (crse(ic,jc+1,n)
     &           -                  crse(ic,jc  ,n) * two
     &           +                  crse(ic,jc-1,n))/hcrse**2
            else if( mask(i,j-1).ne.not_covered .and.
     &               mask(i,j+ratio).ne.not_covered ) then
c              ::: drop order by 2
               derives(jc,XDER )  = zero
               derives(jc,X2DER)  = zero
            else if( mask(i,j+ratio).eq. not_covered ) then
c              ::: j-1 bad, so try + dir
               if( jc+2 .le. jchi+1 ) then
                  if( mask(i,j+2*ratio).eq.not_covered ) then
c                    ::: can use 3 point stencils for j,j+1,j+2
                     derives(jc,XDER) = (-crse(ic,jc+2,n)+4*crse(ic,jc+1,n)-
     &                    3*crse(ic,jc,n))/(2*hcrse)
                     derives(jc,X2DER) = (crse(ic,jc+2,n)-2*crse(ic,jc+1,n)
     &                    +crse(ic,jc,n))/hcrse**2
                  else
c                    ::: use j,j+1, drop order
                     derives(jc,XDER) = (crse(ic,jc+1,n)-crse(ic,jc,n))/hcrse
                     derives(jc,X2DER) = zero
                  endif
               else
c                 ::: use j,j+1, drop order
                  derives(jc,XDER) = (crse(ic,jc+1,n)-crse(ic,jc,n))/hcrse
                  derives(jc,X2DER) = zero
               endif
            else if( mask(i,j-1) .eq. not_covered ) then
c              ::: try - direction
               if( jc-2 .ge. jclo-1 ) then
                  if( mask(i,j-1) .eq. not_covered ) then
c                    ::: can use 3 point stencils
                     derives(jc,XDER) = (crse(ic,jc-2,n)-4*crse(ic,jc-1,n)
     &                    +3*crse(ic,jc,n))/(2*hcrse)
                     derives(jc,X2DER) = (crse(ic,jc-2,n)-2*crse(ic,jc-1,n)
     &                    +crse(ic,jc,n))/hcrse**2
                  else
                     derives(jc,XDER) = (crse(ic,jc,n)-crse(ic,jc-1,n))/hcrse
                     derives(jc,X2DER) = zero
                  endif
               else
                  derives(jc,XDER) = (crse(ic,jc,n)-crse(ic,jc-1,n))/hcrse
                  derives(jc,X2DER) = zero
               endif
            else
               write(6,*)'impossible BDINTERPYLO'
               stop
            endif
         enddo
         do off = 0, ratio - 1
            xx = (off+0.5)*hfine-hcrse/2
            do jc = jclo, jchi
               j = ratio*jc + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              +derives(jc,XDER)*xx
     &              +derives(jc,X2DER)*xx**2/2
               bdry(i,j,n+nvar) =
     &              derives(jc,XDER)+derives(jc,X2DER)*xx
            enddo
         enddo
      enddo
               

      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPXHI : Interpolation on Xhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPXHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(cb)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),2*nvar)
      REAL_T   derives(DIM2(cb),NUMDERIV)      
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T  hfine
      REAL_T  hcrse

      REAL_T   xx
      integer  i, j, ic, jc, off, n
      integer  jclo, jchi

      jclo = ARG_L2(cb)
      jchi = ARG_H2(cb)
      ic   = ARG_H1(cb)+1
      i    = hi(1)+1
      hcrse = ratio*hfine
      
      do n = 1, nvar
c        ::::: define interp coefs
         do jc = jclo, jchi
            j = ratio*jc
            if( mask(i,j-1).eq.not_covered .and.
     &          mask(i,j+ratio).eq.not_covered ) then
               derives(jc,XDER)  = (crse(ic,jc+1,n)-crse(ic,jc-1,n))/(2*hcrse)
               derives(jc,X2DER) = (crse(ic,jc+1,n)
     &           -                  crse(ic,jc  ,n) * two
     &           +                  crse(ic,jc-1,n))/hcrse**2
            else if( mask(i,j-1).ne.not_covered .and.
     &               mask(i,j+ratio).ne.not_covered ) then
c              ::: drop order by 2
               derives(jc,XDER )  = zero
               derives(jc,X2DER)  = zero
            else if( mask(i,j+ratio).eq. not_covered ) then
c              ::: j-1 bad, so try + dir
               if( jc+2 .le. jchi+1 ) then
                  if( mask(i,j+2*ratio).eq.not_covered ) then
c                    ::: can use 3 point stencils for j,j+1,j+2
                     derives(jc,XDER) = (-crse(ic,jc+2,n)+4*crse(ic,jc+1,n)-
     &                    3*crse(ic,jc,n))/(2*hcrse)
                     derives(jc,X2DER) = (crse(ic,jc+2,n)-2*crse(ic,jc+1,n)
     &                    +crse(ic,jc,n))/hcrse**2
                  else
c                    ::: use j,j+1, drop order
                     derives(jc,XDER) = (crse(ic,jc+1,n)-crse(ic,jc,n))/hcrse
                     derives(jc,X2DER) = zero
                  endif
               else
c                 ::: use j,j+1, drop order
                  derives(jc,XDER) = (crse(ic,jc+1,n)-crse(ic,jc,n))/hcrse
                  derives(jc,X2DER) = zero
               endif
            else if( mask(i,j-1) .eq. not_covered ) then
c              ::: try - direction
               if( jc-2 .ge. jclo-1 ) then
                  if( mask(i,j-1) .eq. not_covered ) then
c                    ::: can use 3 point stencils
                     derives(jc,XDER) = (crse(ic,jc-2,n)-4*crse(ic,jc-1,n)
     &                    +3*crse(ic,jc,n))/(2*hcrse)
                     derives(jc,X2DER) = (crse(ic,jc-2,n)-2*crse(ic,jc-1,n)
     &                    +crse(ic,jc,n))/hcrse**2
                  else
                     derives(jc,XDER) = (crse(ic,jc,n)-crse(ic,jc-1,n))/hcrse
                     derives(jc,X2DER) = zero
                  endif
               else
                  derives(jc,XDER) = (crse(ic,jc,n)-crse(ic,jc-1,n))/hcrse
                  derives(jc,X2DER) = zero
               endif
            else
               write(6,*)'impossible BDINTERPYLO'
               stop
            endif
         enddo
         do off = 0, ratio - 1
            xx = (off+0.5)*hfine-hcrse/2
            do jc = jclo, jchi
               j = ratio*jc + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              +derives(jc,XDER)*xx
     &              +derives(jc,X2DER)*xx**2/2
               bdry(i,j,n+nvar) =
     &              derives(jc,XDER)+derives(jc,X2DER)*xx
            enddo
         enddo
      enddo

      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPYLO : Interpolation on Ylo Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYLO (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(cb)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),2*nvar)
      REAL_T   derives(DIM1(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   xx
      integer  i, j, ic, jc, off, n
      integer  iclo, ichi
      REAL_T  hfine
      REAL_T  hcrse

      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_L2(cb)-1
      j    = lo(2)-1
      hcrse = ratio*hfine

      do n = 1, nvar
c        ::::: define interp coefs
         do ic = iclo, ichi
            i = ratio*ic
            if( mask(i-1,j).eq.not_covered .and. 
     &           mask(i+ratio,j).eq.not_covered ) then
c           :::: use adjoining points
               derives(ic,XDER ) = (crse(ic+1,jc,n)-crse(ic-1,jc,n))/(2*hcrse)
               derives(ic,X2DER) = (crse(ic+1,jc,n)-2*crse(ic,jc,n)+
     &              crse(ic-1,jc,n))/hcrse**2
            else if( mask(i-1,j).ne.not_covered .and.
     &               mask(i+ratio,j).ne.not_covered ) then
c              :::: must drop order by two
               derives(ic,XDER ) = zero
               derives(ic,X2DER) = zero
            else if( mask(i+ratio,j).eq.not_covered ) then
c              ::: i-1 bad, try other direction
               if( ic+2 .le. ichi+1 ) then
                  if( mask(i+2*ratio,j).eq.not_covered ) then
c                    ::: can use 3 points stencils for i,i+1,i+2
                     derives(ic,XDER ) = (-crse(ic+2,jc,n)+4*crse(ic+1,jc,n)-
     &                    3*crse(ic,jc,n))/(2*hcrse)
                     derives(ic,X2DER) = (crse(ic+2,jc,n)-2*crse(ic+1,jc,n)+
     &                    crse(ic,jc,n))/hcrse**2
                  else
c                    ::: use i,i+1
                     derives(ic,XDER ) = (crse(ic+1,jc,n)-crse(ic,jc,n))/hcrse
                     derives(ic,X2DER) = zero
                  endif
              else
c                ::: use i,i+1
                 derives(ic,XDER ) = (crse(ic+1,jc,n)-crse(ic,jc,n))/hcrse
                 derives(ic,X2DER) = zero
              endif
           else if( mask(i-1,j).eq.not_covered ) then
c             ::: i+1 bad, try other direction
              if( ic-2 .ge. iclo-1 ) then
                 if( mask(i-1,j) .eq. not_covered ) then
c                  ::: can use 3 points stencils for i,i-1,i-2
                    derives(ic,XDER ) = (+crse(ic-2,jc,n)-4*crse(ic-1,jc,n)+
     &                    3*crse(ic,jc,n))/(2*hcrse)
                    derives(ic,X2DER) = (crse(ic-2,jc,n)-2*crse(ic-1,jc,n)+
     &                    crse(ic,jc,n))/hcrse**2
                 else
c                   ::: use i,i-1
                     derives(ic,XDER ) = (crse(ic,jc,n)-crse(ic-1,jc,n))/hcrse
                     derives(ic,X2DER) = zero
                 endif
              else
c                ::: use i,i-1
                 derives(ic,XDER ) = (crse(ic,jc,n)-crse(ic-1,jc,n))/hcrse
                 derives(ic,X2DER) = zero
              endif
           else
               write(6,*)'impossible BDINTERPYLO'
              stop
           endif
         enddo
         do off = 0, ratio - 1
            xx = (off+0.5)*hfine-hcrse/2
            do ic = iclo, ichi
               i = ratio*ic + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              + derives(ic,XDER)*xx
     &              + derives(ic,X2DER)*xx**2/2
               bdry(i,j,n+nvar) =
     &              + derives(ic,XDER) + derives(ic,X2DER)*xx
            enddo
         enddo
      enddo

      return
      end

c ---------------------------------------------------------------
c ::  FORT_BDINTERPYHI : Interpolation on Yhi Face
c ::       Quadratic Interpolation from crse data
c ::       in directions transverse to face of grid
c ::
c ::  Inputs/Outputs:
c ::  bdry       <=  fine grid bndry data strip
c ::  DIMS(bdry)  => index limits of bdry
c ::  lo,hi       => index limits of grd interior
c ::  DIMS(cb)    => index limits of coarsened grid interior
c ::  nvar        => number of variables in solution, half number in bdry
c ::  ratio       => refinement ratio
c ::  not_covered => mask is set to this value if cell is not
c ::                 covered by another fine grid and not outside the domain.
c ::  mask        => fine grid mask bndry strip
c ::  DIMS(mask)  => index limits of mask array
c ::  crse        => crse grid bndry data strip
c ::  DIMS(crse)  => index limits of crse array
c ::  derives     => crse grid tmp array
c ---------------------------------------------------------------

      subroutine FORT_BDINTERPYHI (bdry,DIMS(bdry),
     &           lo,hi,DIMS(cb),nvar,ratio,not_covered,
     &           mask,DIMS(mask),crse,DIMS(crse),derives,hfine)

      integer  nvar, ratio, not_covered
      integer  lo(SDIM), hi(SDIM)
      integer  DIMDEC(bdry)
      integer  DIMDEC(mask)
      integer  DIMDEC(cb)
      integer  DIMDEC(crse)
      REAL_T   bdry(DIMV(bdry),2*nvar)
      REAL_T   derives(DIM1(cb),NUMDERIV)
      integer  mask(DIMV(mask))
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T   xx
      integer  i, j, ic, jc, off, n
      integer  iclo, ichi
      REAL_T  hfine
      REAL_T  hcrse

      iclo = ARG_L1(cb)
      ichi = ARG_H1(cb)
      jc   = ARG_H2(cb)+1
      j    = hi(2)+1
      hcrse = ratio*hfine

      do n = 1, nvar
c        ::::: define interp coefs
         do ic = iclo, ichi
            i = ratio*ic
            if( mask(i-1,j).eq.not_covered .and. 
     &           mask(i+ratio,j).eq.not_covered ) then
c           :::: use adjoining points
               derives(ic,XDER ) = (crse(ic+1,jc,n)-crse(ic-1,jc,n))/(2*hcrse)
               derives(ic,X2DER) = (crse(ic+1,jc,n)-2*crse(ic,jc,n)+
     &              crse(ic-1,jc,n))/hcrse**2
            else if( mask(i-1,j).ne.not_covered .and.
     &               mask(i+ratio,j).ne.not_covered ) then
c              :::: must drop order by two
               derives(ic,XDER ) = zero
               derives(ic,X2DER) = zero
            else if( mask(i+ratio,j).eq.not_covered ) then
c              ::: i-1 bad, try other direction
               if( ic+2 .le. ichi+1 ) then
                  if( mask(i+2*ratio,j).eq.not_covered ) then
c                    ::: can use 3 points stencils for i,i+1,i+2
                     derives(ic,XDER ) = (-crse(ic+2,jc,n)+4*crse(ic+1,jc,n)-
     &                    3*crse(ic,jc,n))/(2*hcrse)
                     derives(ic,X2DER) = (crse(ic+2,jc,n)-2*crse(ic+1,jc,n)+
     &                    crse(ic,jc,n))/hcrse**2
                  else
c                    ::: use i,i+1
                     derives(ic,XDER ) = (crse(ic+1,jc,n)-crse(ic,jc,n))/hcrse
                     derives(ic,X2DER) = zero
                  endif
              else
c                ::: use i,i+1
                 derives(ic,XDER ) = (crse(ic+1,jc,n)-crse(ic,jc,n))/hcrse
                 derives(ic,X2DER) = zero
              endif
           else if( mask(i-1,j).eq.not_covered ) then
c             ::: i+1 bad, try other direction
              if( ic-2 .ge. iclo-1 ) then
                 if( mask(i-1,j) .eq. not_covered ) then
c                  ::: can use 3 points stencils for i,i-1,i-2
                    derives(ic,XDER ) = (+crse(ic-2,jc,n)-4*crse(ic-1,jc,n)+
     &                    3*crse(ic,jc,n))/(2*hcrse)
                    derives(ic,X2DER) = (crse(ic-2,jc,n)-2*crse(ic-1,jc,n)+
     &                    crse(ic,jc,n))/hcrse**2
                 else
c                   ::: use i,i-1
                     derives(ic,XDER ) = (crse(ic,jc,n)-crse(ic-1,jc,n))/hcrse
                     derives(ic,X2DER) = zero
                 endif
              else
c                ::: use i,i-1
                 derives(ic,XDER ) = (crse(ic,jc,n)-crse(ic-1,jc,n))/hcrse
                 derives(ic,X2DER) = zero
              endif
           else
               write(6,*)'impossible BDINTERPYHI'
              stop
           endif
         enddo
         do off = 0, ratio - 1
            xx = (off+0.5)*hfine-hcrse/2
            do ic = iclo, ichi
               i = ratio*ic + off
               bdry(i,j,n) = crse(ic,jc,n)
     &              + derives(ic,XDER)*xx
     &              + derives(ic,X2DER)*xx**2/2
               bdry(i,j,n+nvar) =
     &              + derives(ic,XDER) + derives(ic,X2DER)*xx
            enddo
         enddo
      enddo

      return
      end


c ------------------------------------------------------------------------
c :: FORT_BDIDERIVXLO : copy from Xlo face of fine fab (getting values
c ::      which were stuck there by the physical boundary condition routines)
c ::      to get the first nvar values in bdry.  The second nvar values 
c ::      are gotten by computing the transverse derivative.  Two formulas
c ::      are used: 1) on the interior a centered difference is used; 
c ::      2) at the end points a one-sided difference is used.  No check
c ::      is made to check that the one-sided difference does not poke out
c ::      the other side of the grid.  But if grids are that small, a lot
c ::      of things will be blowing up.

c :: Inputs/Outputs:
c ::  bdry <= fine grid bndry data strip
c ::  lo,hi => index limits of "grid". So all action takes place in cells
c ::           outside the grid
c ::  fine  => fine grid data which has phys-bc data stuffed in it
c ::  nvar  => number of components in fine.  But you write twice as many
c ::           components of data in bdry because you compute transverse
c ::           derivatives as well
c ::  hfine => delta x in transverse direction; needed for derivs
c ------------------------------------------------------------------------
      subroutine FORT_BDIDERIVXLO( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),2*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,n

      i = lo(1)-1
      do n=1,nvar
c ::: ::: copy boundary values over
         do j=lo(2),hi(2)
            bdry(i,j,n) = fine(i,j,n)
         enddo
c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.
         do j=lo(2)+1,hi(2)-1
            bdry(i,j,n+nvar) = (fine(i,j+1,n)-fine(i,j-1,n))/(2*hfine)
         enddo
         j = lo(2)
         bdry(i,j,n+nvar) = (-fine(i,j+2,n)+4*fine(i,j+1,n)-3*fine(i,j,n))/
     &        (2*hfine)
         j = hi(2)
         bdry(i,j,n+nvar) = (+fine(i,j-2,n)-4*fine(i,j-1,n)+3*fine(i,j,n))/
     &        (2*hfine)
      enddo

      return
      end
      

      subroutine FORT_BDIDERIVXHI( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),2*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,n

      i = hi(1)+1
      do n=1,nvar
c ::: ::: copy boundary values over
         do j=lo(2),hi(2)
            bdry(i,j,n) = fine(i,j,n)
         enddo
c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.
         do j=lo(2)+1,hi(2)-1
            bdry(i,j,n+nvar) = (fine(i,j+1,n)-fine(i,j-1,n))/(2*hfine)
         enddo
         j = lo(2)
         bdry(i,j,n+nvar) = (-fine(i,j+2,n)+4*fine(i,j+1,n)-3*fine(i,j,n))/
     &        (2*hfine)
         j = hi(2)
         bdry(i,j,n+nvar) = (+fine(i,j-2,n)-4*fine(i,j-1,n)+3*fine(i,j,n))/
     &        (2*hfine)
      enddo

      return
      end
      

      subroutine FORT_BDIDERIVYLO( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),2*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,n

      j = lo(2)-1
      do n=1,nvar
c ::: ::: copy boundary values over
         do i=lo(1),hi(1)
            bdry(i,j,n) = fine(i,j,n)
         enddo
c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.
         do i=lo(1)+1,hi(1)-1
            bdry(i,j,n+nvar) = (fine(i+1,j,n)-fine(i-1,j,n))/(2*hfine)
         enddo
         i = lo(1)
         bdry(i,j,n+nvar) = (-fine(i+2,j,n)+4*fine(i+1,j,n)-3*fine(i,j,n))/
     &        (2*hfine)
         i = hi(1)
         bdry(i,j,n+nvar) = (+fine(i-2,j,n)-4*fine(i-1,j,n)+3*fine(i,j,n))/
     &        (2*hfine)
      enddo

      return
      end
      


      subroutine FORT_BDIDERIVYHI( bdry, DIMS(bdry),
     &     lo, hi,
     &     fine, DIMS(fine),
     &     nvar, hfine)
      integer nvar
      REAL_T  hfine
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(bdry)
      integer DIMDEC(fine)
      REAL_T  bdry(DIMV(bdry),2*nvar)
      REAL_T  fine(DIMV(fine),  nvar)

      integer i,j,n

      j = hi(2)+1
      do n=1,nvar
c ::: ::: copy boundary values over
         do i=lo(1),hi(1)
            bdry(i,j,n) = fine(i,j,n)
         enddo
c ::: ::: do stinking calculation of derivativ using centered difference
c ::: ::: this ONLY makes sense for DIRICHLET BC.  For other BC,
c ::: ::: we will not use these values.
         do i=lo(1)+1,hi(1)-1
            bdry(i,j,n+nvar) = (fine(i+1,j,n)-fine(i-1,j,n))/(2*hfine)
         enddo
         i = lo(1)
         bdry(i,j,n+nvar) = (-fine(i+2,j,n)+4*fine(i+1,j,n)-3*fine(i,j,n))/
     &        (2*hfine)
         i = hi(1)
         bdry(i,j,n+nvar) = (+fine(i-2,j,n)-4*fine(i-1,j,n)+3*fine(i,j,n))/
     &        (2*hfine)
      enddo

      return
      end
      

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

#if BL_USE_FLOAT
#define twentyfive 25.e0
#define fifth 0.2
#else
#define twentyfive 25.d0
#define fifth 0.2d0
#endif

c *************************************************************************
c ** LAPLAC **
c ** Compute the viscous/diffusive terms for the momentum and scalar update
c ** equations
c ********************************************************************

      subroutine laplac(u,lapu,areax,areay,areaz,vol,DIMS,dx,diff_coef,bc)

      implicit none

      integer DIMS
      REAL_T      u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,lo_3-3:hi_3+3)
      REAL_T   lapu(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  areax(lo_1  :hi_1+1,lo_2  :hi_2  ,lo_3  :hi_3  )
      REAL_T  areay(lo_1  :hi_1  ,lo_2  :hi_2+1,lo_3  :hi_3  )
      REAL_T  areaz(lo_1  :hi_1  ,lo_2  :hi_2  ,lo_3  :hi_3+1)
      REAL_T    vol(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T  dx(3)
      REAL_T  diff_coef
      integer bc(2,3)

c     Local variables
      REAL_T facx,facy,facz
      REAL_T ux_left,ux_left_wall
      REAL_T ux_rght,ux_rght_wall
      REAL_T uy_bot,uy_bot_wall
      REAL_T uy_top,uy_top_wall
      REAL_T uz_bot,uz_bot_wall
      REAL_T uz_top,uz_top_wall
      integer is, ie, js, je, ks, ke
      integer i,j,k

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3
      facx = one / (dx(1)*dx(1))
      facy = one / (dx(2)*dx(2))
      facz = one / (dx(3)*dx(3))

      if (diff_coef .gt. zero) then

        do k = ks, ke 
        do j = js, je 
        do i = is, ie 

            ux_left = (u(i,j,k) - u(i-1,j,k)) 
            ux_left_wall = (-sixteen * u(is-1,j,k) + twenty * u(is,j,k) 
     $                         -five * u(is+1,j,k) + u(is+2,j,k) ) * fifth
            ux_left = cvmgt(ux_left_wall, ux_left, i .eq. is .and.
     $                      (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) )
            ux_left = areax(i,j,k) * ux_left / dx(1)

            ux_rght = (u(i+1,j,k) - u(i,j,k)) 
            ux_rght_wall = -(-sixteen * u(ie+1,j,k) + twenty * u(ie,j,k)
     $                          -five * u(ie-1,j,k) + u(ie-2,j,k) ) * fifth
            ux_rght = cvmgt(ux_rght_wall, ux_rght, i .eq. ie .and.
     $                      (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
            ux_rght = areax(i+1,j,k) * ux_rght / dx(1)

            uy_bot = (u(i,j,k) - u(i,j-1,k)) 
            uy_bot_wall = (-sixteen * u(i,js-1,k) + twenty * u(i,js,k)
     $                        -five * u(i,js+1,k) + u(i,js+2,k) ) * fifth
            uy_bot = cvmgt(uy_bot_wall, uy_bot, j .eq. js .and.
     $                      (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
            uy_bot = areay(i,j,k) * uy_bot / dx(2)

            uy_top = (u(i,j+1,k) - u(i,j,k)) 
            uy_top_wall = -(-sixteen * u(i,je+1,k) + twenty * u(i,je,k)
     $                         -five * u(i,je-1,k) + u(i,je-2,k) ) * fifth
            uy_top = cvmgt(uy_top_wall, uy_top, j .eq. je .and.
     $                      (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
            uy_top = areay(i,j+1,k) * uy_top / dx(2)

            uz_bot = (u(i,j,k) - u(i,j,k-1)) 
            uz_bot_wall = (-sixteen * u(i,j,ks-1) + twenty * u(i,j,ks)
     $                        -five * u(i,j,ks+1) + u(i,j,ks+2) ) * fifth
            uz_bot = cvmgt(uz_bot_wall, uz_bot, k .eq. ks .and.
     $                      (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) )
            uz_bot = areaz(i,j,k) * uz_bot / dx(3)

            uz_top = (u(i,j,k+1) - u(i,j,k)) 
            uz_top_wall = -(-sixteen * u(i,j,ke+1) + twenty * u(i,j,ke)
     $                         -five * u(i,j,ke-1) + u(i,j,ke-2) ) * fifth
            uz_top = cvmgt(uz_top_wall, uz_top, k .eq. ke .and.
     $                      (BCZ_HI .eq. WALL .or. BCZ_HI .eq. INLET) )
            uz_top = areaz(i,j,k+1) * uz_top / dx(3)

            lapu(i,j,k) = diff_coef * 
     $          (ux_rght-ux_left+uy_top-uy_bot+uz_top-uz_bot) / vol(i,j,k)

        enddo
        enddo
        enddo

      else

        do k = ks, ke 
        do j = js, je 
        do i = is, ie 
            lapu(i,j,k) = zero
        enddo
        enddo
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "HGPROJ_F.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define sixteenth  .0625e0
#else
#define sixteenth  .0625d0
#endif

#define DIMS lo_1,lo_2,hi_1,hi_2
#define CDIMS loc_1,loc_2,hic_1,hic_2
#define GDIMS g_lo_1,g_lo_2,g_hi_1,g_hi_2
#define PDIMS p_lo_1,p_lo_2,p_hi_1,p_hi_2

c *************************************************************************
c ** INITSIG **
c ** Define the 1/rho coefficients at the top level of the multigrid
c *************************************************************************

      subroutine FORT_INITSIG(sigma,rho,r,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer DIMS
      REAL_T sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     r(lo_1-1:hi_1+1)
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      integer i,j

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          sigma(i,j) = r(i) / rho(i,j)
        enddo
      enddo

      if (bcx_lo .eq. PERIODIC) then

        do j = lo_2-1,hi_2+1 
          sigma(lo_1-1,j) = sigma(hi_1,j)
          sigma(hi_1+1,j) = sigma(lo_1,j)
        enddo

      endif

      if (bcy_lo .eq. PERIODIC) then

        do i = lo_1-1,hi_1+1 
          sigma(i,lo_2-1) = sigma(i,hi_2)
          sigma(i,hi_2+1) = sigma(i,lo_2)
        enddo

      endif

      return
      end

c *************************************************************************
c ** GRADHG **
c ** Compute the cell-centered gradient of the nodal pressure field
c *************************************************************************

      subroutine FORT_GRADHG(gphi,GDIMS,phi,PDIMS,DIMS,hx,hy,
     &                       bcx_lo, bcx_hi, bcy_lo, bcy_hi)

      implicit none

      integer DIMS
      integer p_lo_1, p_lo_2
      integer p_hi_1, p_hi_2
      integer g_lo_1, g_lo_2
      integer g_hi_1, g_hi_2
      REAL_T  gphi(g_lo_1:g_hi_1,g_lo_2:g_hi_2,2)
      REAL_T   phi(p_lo_1:p_hi_1,p_lo_2:p_hi_2  )
      REAL_T  hx
      REAL_T  hy
      integer bcx_lo, bcx_hi, bcy_lo, bcy_hi

c     Local variables
      integer i, j

      do j = lo_2,hi_2
        do i = lo_1,hi_1
          gphi(i,j,1) = half*(phi(i+1,j) + phi(i+1,j+1) - 
     $                        phi(i  ,j) - phi(i  ,j+1) ) /hx
          gphi(i,j,2) = half*(phi(i,j+1) + phi(i+1,j+1) - 
     $                        phi(i,j  ) - phi(i+1,j  ) ) /hy
        enddo
      enddo

      if (g_lo_1 .le. lo_1-1 .and. g_hi_1 .ge. hi_1+1) then
         if (bcx_lo .eq. PERIODIC) then
            do j = lo_2,hi_2
               gphi(lo_1-1,j,1) = gphi(hi_1,j,1)
               gphi(lo_1-1,j,2) = gphi(hi_1,j,2)
            enddo
         endif
         if (bcx_hi .eq. PERIODIC) then
            do j = lo_2,hi_2
               gphi(hi_1+1,j,1) = gphi(lo_1,j,1)
               gphi(hi_1+1,j,2) = gphi(lo_1,j,2)
            enddo
         endif
      endif

      if (g_lo_2 .le. lo_2-1 .and. g_hi_2 .ge. hi_2+1) then
          if (bcy_lo .eq. PERIODIC) then
             do i = lo_1,hi_1
                gphi(i,lo_2-1,1) = gphi(i,hi_2,1)
                gphi(i,lo_2-1,2) = gphi(i,hi_2,2)
             enddo
          endif
          if (bcy_hi .eq. PERIODIC) then
             do i = lo_1,hi_1
                gphi(i,hi_2+1,1) = gphi(i,lo_2,1)
                gphi(i,hi_2+1,2) = gphi(i,lo_2,2)
             enddo
          endif
       endif

      if (g_lo_1 .le. lo_1-1 .and. g_hi_1 .ge. hi_1+1 .and.
     $    g_lo_2 .le. lo_2-1 .and. g_hi_2 .ge. hi_2+1 .and.
     $   (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC) ) then
          gphi(lo_1-1,lo_2-1,1) = gphi(hi_1,hi_2,1)
          gphi(lo_1-1,lo_2-1,2) = gphi(hi_1,hi_2,2)

          gphi(hi_1+1,lo_2-1,1) = gphi(lo_1,hi_2,1)
          gphi(hi_1+1,lo_2-1,2) = gphi(lo_1,hi_2,2)

          gphi(lo_1-1,hi_2+1,1) = gphi(hi_1,lo_2,1)
          gphi(lo_1-1,hi_2+1,2) = gphi(hi_1,lo_2,2)

          gphi(hi_1+1,hi_2+1,1) = gphi(lo_1,lo_2,1)
          gphi(hi_1+1,hi_2+1,2) = gphi(lo_1,lo_2,2)
      endif

      return
      end

c *************************************************************************
c ** RHSHG **
c ** Compute the right-hand-side D(V) for the projection
c *************************************************************************

      subroutine FORT_RHSHG(du,u,divu_src,r,DIMS,hx,hy,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,norm,time,dt)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T        du(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  divu_src(lo_1  :hi_1+1,lo_2  :hi_2+1)
      REAL_T         r(lo_1-1:hi_1+1)
      REAL_T         u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  hx
      REAL_T  hy
      REAL_T  time
      REAL_T  dt
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      REAL_T  fac,norm
      REAL_T  rnode
      REAL_T  factor
      REAL_T  sum_src, sum_fac
      integer i, j, n
      integer is,ie,js,je
      integer istart,iend
      integer jstart,jend
      logical is_singular

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      norm = zero

      istart = cvmgt(lo_1+1,lo_1  ,bcx_lo .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,bcx_hi .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,bcy_lo .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,bcy_hi .eq. OUTLET)

      if (bcx_lo .eq. PERIODIC) then
        do n = 1,2
        do j = js-1,je+1
          u(is-1,j,n) = u(ie,j,n)
          u(ie+1,j,n) = u(is,j,n)
        enddo
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do n = 1,2
        do i = is-1,ie+1
          u(i,js-1,n) = u(i,je,n)
          u(i,je+1,n) = u(i,js,n)
        enddo
        enddo
      endif

      is_singular = .true.
      if (bcx_lo .eq. OUTLET .or. bcy_lo .eq. OUTLET .or.
     $    bcx_hi .eq. OUTLET .or. bcy_hi .eq. OUTLET) is_singular = .false.

      fac = one/twelve*(one/(hx*hx) + one/(hy*hy))

      do j = jstart,jend 
        do i = istart,iend 
            du(i,j) = (r(i  )*(u(i  ,j-1,1) +      u(i  ,j,1)) - 
     $                 r(i-1)*(u(i-1,j-1,1) +      u(i-1,j,1))) / (two*hx) + 
     $               ((r(i-1)* u(i-1,j  ,2) + r(i)*u(i,j  ,2)) -
     $                (r(i-1)* u(i-1,j-1,2) + r(i)*u(i,j-1,2))) / (two*hy)
        enddo
      enddo

      if (bcx_lo .eq. WALL) then
          i = is
          do j = jstart,jend 
            du(i,j) = r(i)*( (u(i,j-1,1) + u(i,j  ,1))/ (two*hx)
     $                      +(u(i,j  ,2) - u(i,j-1,2))/ (two*hy) )
          enddo
      endif

      if (bcx_hi .eq. WALL) then
          i = ie+1
          do j = jstart,jend 
            du(i,j) = r(i-1)*(-(u(i-1,j-1,1) + u(i-1,j,1))/ (two*hx)
     $                        +(u(i-1,j,2) - u(i-1,j-1,2))/ (two*hy) )
          enddo
      endif

      if (bcy_lo .eq. WALL) then
          j = js
          do i = is,iend 
            du(i,j) = ( (r(i  )*u(i  ,j,1) - r(i-1)*u(i-1,j,1))/ (two*hx) 
     $                 +(r(i-1)*u(i-1,j,2) + r(i  )*u(i  ,j,2))/ (two*hy) )
          enddo
      endif

      if (bcy_hi .eq. WALL) then
          j = je+1
          do i = is,iend 
            du(i,j) = ( (r(i  )*u(i  ,j-1,1) - r(i-1)*u(i-1,j-1,1))/ (two*hx)
     $                 -(r(i-1)*u(i-1,j-1,2) + r(i  )*u(i  ,j-1,2))/ (two*hy) )
          enddo
      endif

      if (bcx_lo .eq. WALL  .and.  bcy_lo .eq. WALL) then
          i = is
          j = js
          du(i,j) = r(i)*(u(i,j,1)/(two*hx) + u(i,j,2)/(two*hy))
      endif

      if (bcx_hi .eq. WALL  .and.  bcy_lo .eq. WALL) then
          i = ie+1
          j = js
          du(i,j) = r(i-1)*(-u(i-1,j,1)/(two*hx) + u(i-1,j,2)/(two*hy))
      endif

      if (bcx_lo .eq. WALL  .and.  bcy_hi .eq. WALL) then
          i = is
          j = je+1
          du(i,j) = r(i)*(u(i,j-1,1)/(two*hx) - u(i,j-1,2)/(two*hy))
      endif

      if (bcx_hi .eq. WALL  .and.  bcy_hi .eq. WALL) then
          i = ie+1
          j = je+1
          du(i,j) = -r(i-1)*(u(i-1,j-1,1)/(two*hx) + u(i-1,j-1,2)/(two*hy))
      endif

      if (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) then
          do j = jstart,jend 
            du(is,j) = two*du(is,j)
          enddo
      endif

      if (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) then
          do j = jstart,jend 
            du(ie+1,j) = two*du(ie+1,j)
          enddo
      endif

      if (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) then
          do i = istart,iend 
            du(i,js) = two*du(i,js)
          enddo
      endif

      if (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) then
          do i = istart,iend 
            du(i,je+1) = two*du(i,je+1)
          enddo
      endif

      do j = jstart,jend 
         do i = istart,iend 
           rnode = half * (r(i) + r(i-1))
           du(i,j) = du(i,j) - rnode * divu_src(i,j)
         enddo
      enddo

      if (is_singular) then
         sum_src  = zero
         sum_fac  = zero
         do j = jstart, jend
         do i = istart, iend
           factor = one
           factor = cvmgt(half*factor,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
           factor = cvmgt(half*factor,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
           sum_src = sum_src + factor * du(i,j)
           sum_fac = sum_fac + factor
         enddo
         enddo

         sum_src = sum_src / sum_fac
 
c        write(6,999) sum_src
 
         do j = jstart, jend
         do i = istart, iend
           du(i,j) = du(i,j) - sum_src
         enddo
         enddo
      endif

      do j = jstart,jend 
        do i = istart,iend 
          norm = max(norm, abs(du(i,j)))
        enddo
      enddo
 999  format('Singular adjustment is ',e12.5)

      return
      end

c *************************************************************************
c ** PROJUHG **
c ** Define the updated pressure and vector field
c *************************************************************************

      subroutine FORT_PROJUHG(u,pressure,phi,gradphi,rhonph,DIMS)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T         u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  pressure(lo_1  :hi_1+1,lo_2  :hi_2+1)
      REAL_T       phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T   gradphi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T    rhonph(lo_1-1:hi_1+1,lo_2-1:hi_2+1)

c     Local variables
      integer i, j

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          u(i,j,1) = u(i,j,1) - gradphi(i,j,1)/rhonph(i,j)
          u(i,j,2) = u(i,j,2) - gradphi(i,j,2)/rhonph(i,j)
        enddo
      enddo


      do j = lo_2,hi_2+1
        do i = lo_1,hi_1+1
           pressure(i,j) = phi(i,j)
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D(sigma G(phi))
c *************************************************************************

      subroutine FORT_RESIDUAL(residual,phi,source,sigma,dgphi,
     $                         DIMS,hx,hy,resnorm,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T  residual(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T       phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T    source(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T       sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     dgphi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  hx
      REAL_T  hy
      REAL_T  resnorm
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      integer i,j
      integer istart,iend
      integer jstart,jend

      resnorm = zero

      istart = cvmgt(lo_1+1,lo_1  ,bcx_lo .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,bcx_hi .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,bcy_lo .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,bcy_hi .eq. OUTLET)
       
      call makedgphi(phi,dgphi,sigma,DIMS,hx,hy,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      do j = jstart,jend
        do i = istart,iend
          residual(i,j) = source(i,j) - dgphi(i,j)
        enddo
      enddo

      do j = jstart,jend 
        do i = istart,iend 
          resnorm = max(resnorm,abs(residual(i,j)))
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RELAX **
c ** Gauss-Seidel relaxation
c *************************************************************************

      subroutine FORT_RELAX(phi,source,sigma,dgphi,DIMS,hx,hy,
     $                      bcx_lo,bcx_hi,bcy_lo,bcy_hi,nnrelax)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T     phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  source(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T   sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T   dgphi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T hx
      REAL_T hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi
      integer nnrelax

c     Local variables
      REAL_T  hxsqinv,hysqinv
      REAL_T  rfac
      integer i,j
      integer iter
      integer is,ie,js,je
      integer istart,iend
      integer jstart,jend

c     Additional temporaries for the line solve
      REAL_T a_ls(0:4096)
      REAL_T b_ls(0:4096)
      REAL_T c_ls(0:4096)
      REAL_T r_ls(0:4096)
      REAL_T u_ls(0:4096)

      integer do_line
      integer ilen,jlen

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      istart = cvmgt(lo_1+1,lo_1  ,bcx_lo .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,bcx_hi .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,bcy_lo .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,bcy_hi .eq. OUTLET)

      if (hy. gt. 1.5*hx) then
         do_line = 1
         ilen = iend - istart + 1
         if (ilen .gt. 4096) then
           print *,'TOO BIG FOR LINE SOLVE IN GSRB: ilen = ',ilen
           stop
         endif
       elseif (hx .gt. 1.5*hy) then
         do_line = 2
         jlen = jend - jstart + 1
         if (jlen .gt. 4096) then
           print *,'TOO BIG FOR LINE SOLVE IN GSRB: jlen = ',jlen
           stop
         endif
       else
         do_line = 0
       endif

      do iter = 1, nnrelax 

          if (bcx_lo .eq. PERIODIC) then
            do j = js-1,je+2
              phi(ie+1,j) = phi(is  ,j)
              phi(ie+2,j) = phi(is+1,j)
              phi(is-1,j) = phi(ie  ,j)
            enddo
          endif

          if (bcy_lo .eq. PERIODIC) then
            do i = is-1,ie+2
              phi(i,je+1) = phi(i,js  )
              phi(i,je+2) = phi(i,js+1)
              phi(i,js-1) = phi(i,je  )
            enddo
          endif

          call makedgphi(phi,dgphi,sigma,DIMS,hx,hy,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

          if (do_line .eq. 0) then
            do j = jstart,jend
            do i = istart,iend
#if 0
              dgphi(i,j) = sixth * (
     $         hxsqinv * 
     $          (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i,j-1) + 
     $                       two * phi(i-1,j)) + 
     $           sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i,j+1) + 
     $                       two * phi(i-1,j)) + 
     $           sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i,j-1) + 
     $                       two * phi(i+1,j)) + 
     $           sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i,j+1) + 
     $                       two * phi(i+1,j)) - 
     $           two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j)) * phi(i,j)) + 
     $         hysqinv * 
     $          (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i-1,j) +   
     $                       two * phi(i  ,j-1)) + 
     $           sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i-1,j) + 
     $                       two * phi(i  ,j+1)) + 
     $           sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i+1,j) + 
     $                       two * phi(i  ,j-1)) + 
     $           sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i+1,j) +
     $                       two * phi(i,j+1)) - 
     $           two*(sigma(i-1,j-1) + sigma(i-1,j) +
     $                sigma(i  ,j-1) + sigma(i  ,j)) * phi(i,j)) )
#endif


              rfac = (hxsqinv + hysqinv) * 
     $               (sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j))

              if ( (i .eq. is .or. i .eq. ie+1) .and. bcx_lo .ne. PERIODIC) then
c               dgphi(i,j) = two*dgphi(i,j)
                rfac = two*rfac
              endif

              if ( (j .eq. js .or. j .eq. je+1) .and. bcy_lo .ne. PERIODIC) then
c               dgphi(i,j) = two*dgphi(i,j)
                rfac = two*rfac
              endif

              rfac = three/rfac

              phi(i,j) = phi(i,j) + rfac*(dgphi(i,j) - source(i,j))

            enddo
            enddo

          else if (do_line .eq. 1) then

            do j = jstart,jend

            do i = istart,iend
              a_ls(i-istart) = third * hxsqinv * 
     $                      (sigma(i-1,j-1) + sigma(i-1,j)) 
     $                     - sixth * hysqinv * 
     $                      (sigma(i-1,j-1) + sigma(i-1,j)) 

              c_ls(i-istart) = third * hxsqinv * 
     $                      (sigma(i,j-1) + sigma(i,j)) 
     $                     - sixth * hysqinv * 
     $                      (sigma(i,j-1) + sigma(i,j)) 

              b_ls(i-istart) = -third * (hxsqinv + hysqinv) * 
     $                       (sigma(i-1,j-1) + sigma(i-1,j) + 
     $                        sigma(i  ,j-1) + sigma(i  ,j))

              dgphi(i,j) = sixth * (
     $         hxsqinv * 
     $          (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i,j-1) ) + 
     $           sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i,j+1) ) + 
     $           sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i,j-1) ) + 
     $           sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i,j+1) ) ) + 
     $         hysqinv * 
     $          (sigma(i-1,j-1) * (phi(i-1,j-1)              +   
     $                       two * phi(i  ,j-1)) + 
     $           sigma(i-1,j  ) * (phi(i-1,j+1)              + 
     $                       two * phi(i  ,j+1)) + 
     $           sigma(i  ,j-1) * (phi(i+1,j-1)              + 
     $                       two * phi(i  ,j-1)) + 
     $           sigma(i  ,j  ) * (phi(i+1,j+1)              +
     $                       two * phi(i,j+1)) ) )

              if ( (i .eq. is   .and. (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET)) .or. 
     $             (i .eq. ie+1 .and. (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET)) ) then
                dgphi(i,j) = two*dgphi(i,j)
                a_ls(i-istart) = two*a_ls(i-istart)
                b_ls(i-istart) = two*b_ls(i-istart)
                c_ls(i-istart) = two*c_ls(i-istart)
              endif

              if ( (j .eq. js   .and. (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET)) .or. 
     $             (j .eq. je+1 .and. (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET)) ) then
                dgphi(i,j) = two*dgphi(i,j)
                a_ls(i-istart) = two*a_ls(i-istart)
                b_ls(i-istart) = two*b_ls(i-istart)
                c_ls(i-istart) = two*c_ls(i-istart)
              endif

              r_ls(i-istart) = source(i,j) - dgphi(i,j)

            enddo

            call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,ilen)

            do i = istart,iend
              phi(i,j) = u_ls(i-istart)
            enddo

            enddo
          else if (do_line .eq. 2) then

            do i = istart,iend

            do j = jstart,jend
              a_ls(j-jstart) = sixth * hxsqinv * (
     $                       -sigma(i-1,j-1) - sigma(i,j-1) )
     $                     + third * hysqinv * (
     $                        sigma(i-1,j-1) + sigma(i,j-1) )

              c_ls(j-jstart) = sixth * hxsqinv * (
     $                       -sigma(i-1,j) - sigma(i,j) )
     $                     + third * hysqinv * (
     $                        sigma(i-1,j) + sigma(i,j) )

              b_ls(j-jstart) = -third * (hxsqinv + hysqinv) * 
     $                       (sigma(i-1,j-1) + sigma(i-1,j) + 
     $                        sigma(i  ,j-1) + sigma(i  ,j))

              dgphi(i,j) = sixth * (
     $         hxsqinv * 
     $          (sigma(i-1,j-1) * (phi(i-1,j-1)              + 
     $                       two * phi(i-1,j)) +
     $           sigma(i-1,j  ) * (phi(i-1,j+1)              + 
     $                       two * phi(i-1,j)) + 
     $           sigma(i  ,j-1) * (phi(i+1,j-1)              + 
     $                       two * phi(i+1,j)) + 
     $           sigma(i  ,j  ) * (phi(i+1,j+1)              + 
     $                       two * phi(i+1,j)) ) + 
     $         hysqinv * 
     $          (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i-1,j) ) +   
     $           sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i-1,j) ) + 
     $           sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i+1,j) ) + 
     $           sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i+1,j) ) ) )

              if ( (i .eq. is   .and. (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET)) .or. 
     $             (i .eq. ie+1 .and. (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET)) ) then
                dgphi(i,j) = two*dgphi(i,j)
                a_ls(j-jstart) = two*a_ls(j-jstart)
                b_ls(j-jstart) = two*b_ls(j-jstart)
                c_ls(j-jstart) = two*c_ls(j-jstart)
              endif

              if ( (j .eq. js   .and. (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET)) .or. 
     $             (j .eq. je+1 .and. (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET)) ) then
                dgphi(i,j) = two*dgphi(i,j)
                a_ls(j-jstart) = two*a_ls(j-jstart)
                b_ls(j-jstart) = two*b_ls(j-jstart)
                c_ls(j-jstart) = two*c_ls(j-jstart)
              endif

              r_ls(j-jstart) = source(i,j) - dgphi(i,j)

            enddo

            call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,jlen)

            do j = js,jend
              phi(i,j) = u_ls(j-jstart)
            enddo

            enddo

          endif

      enddo

      if (bcx_lo .eq. PERIODIC) then
        do j = js-1,je+2
          phi(ie+1,j) = phi(is  ,j)
          phi(ie+2,j) = phi(is+1,j)
          phi(is-1,j) = phi(ie  ,j)
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do i = is-1,ie+2
          phi(i,je+1) = phi(i,js  )
          phi(i,je+2) = phi(i,js+1)
          phi(i,js-1) = phi(i,je  )
        enddo
      endif

      return
      end

c *************************************************************************
c ** COARSIG **
c ** Coarsening of the sig coefficients
c *************************************************************************

      subroutine FORT_COARSIG(sigma,sigmac,DIMS,CDIMS,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      REAL_T  sigma(lo_1 -1:hi_1 +1,lo_2 -1:hi_2 +1)
      REAL_T sigmac(loc_1-1:hic_1+1,loc_2-1:hic_2+1)
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      integer i ,j
      integer i2,j2

      do j = loc_2,hic_2 
        do i = loc_1,hic_1 
          i2 = 2*(i-loc_1)+lo_1
          j2 = 2*(j-loc_2)+lo_2
          sigmac(i,j) = (sigma(i2  ,j2) + sigma(i2  ,j2+1)+ 
     $                   sigma(i2+1,j2) + sigma(i2+1,j2+1))*fourth
        enddo
      enddo

      if (bcx_lo .eq. PERIODIC) then

        do j = loc_2-1,hic_2+1 
          sigmac(loc_1-1,j) = sigmac(hic_1,j)
          sigmac(hic_1+1,j) = sigmac(loc_1,j)
        enddo

      endif

      if (bcy_lo .eq. PERIODIC) then

        do i = loc_1-1,hic_1+1 
          sigmac(i,loc_2-1) = sigmac(i,hic_2)
          sigmac(i,hic_2+1) = sigmac(i,loc_2)
        enddo

      endif

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      REAL_T   res(lo_1 -1:hi_1 +2,lo_2 -1:hi_2 +2)
      REAL_T  resc(loc_1-1:hic_1+2,loc_2-1:hic_2+2)
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      integer i,j,ii,jj
      integer istart,iend
      integer jstart,jend

      istart = cvmgt(loc_1+1,loc_1  ,bcx_lo .eq. OUTLET)
      iend   = cvmgt(hic_1  ,hic_1+1,bcx_hi .eq. OUTLET)
      jstart = cvmgt(loc_2+1,loc_2  ,bcy_lo .eq. OUTLET)
      jend   = cvmgt(hic_2  ,hic_2+1,bcy_hi .eq. OUTLET)

      if (bcx_lo .eq. PERIODIC) then
        do j = lo_2-1,hi_2+2
          res(hi_1+1,j) = res(lo_1  ,j)
          res(hi_1+2,j) = res(lo_1+1,j)
          res(lo_1-1,j) = res(hi_1  ,j)
        enddo
      endif

      if (bcy_lo.eq. PERIODIC) then
        do i = lo_1-1,hi_1+2
          res(i,hi_2+1) = res(i,lo_2  )
          res(i,hi_2+2) = res(i,lo_2+1)
          res(i,lo_2-1) = res(i,hi_2  )
        enddo
      endif

      do j = jstart,jend
        do i = istart,iend

          ii = 2*(i-loc_1)+lo_1
          jj = 2*(j-loc_2)+lo_2

          resc(i,j) = fourth*res(ii  ,jj) + 
     $               eighth*(res(ii+1,jj  ) + res(ii-1,jj  ) + 
     $                       res(ii  ,jj+1) + res(ii  ,jj-1) ) +
     $            sixteenth*(res(ii+1,jj+1) + res(ii+1,jj-1) + 
     $                       res(ii-1,jj+1) + res(ii-1,jj-1) )
        enddo
      enddo

      if (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) then
        i = loc_1
        ii = 2*(i-loc_1)+lo_1

        do j = jstart,jend
          jj = 2*(j-loc_2)+lo_2
          resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  )) + 
     $                eighth*(res(ii,jj-1) + res(ii+1,jj-1)+
     $                        res(ii,jj+1) + res(ii+1,jj+1) )
        enddo
      endif

      if (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) then
        j = loc_2
        jj = 2*(j-loc_2)+lo_2

        do i = istart,iend
          ii = 2*(i-loc_1)+lo_1
          resc(i,j) = fourth*(res(ii  ,jj) + res(ii  ,jj+1)) + 
     $                eighth*(res(ii+1,jj) + res(ii+1,jj+1)+
     $                        res(ii-1,jj) + res(ii-1,jj+1) )
        enddo
      endif

      if (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) then
        i = hic_1+1
        ii = 2*(i-loc_1)+lo_1

        do j = jstart,jend
          jj = 2*(j-loc_2)+lo_2
          resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  )) + 
     $                eighth*(res(ii,jj-1) + res(ii-1,jj-1)+
     $                        res(ii,jj+1) + res(ii-1,jj+1) )
        enddo
      endif

      if (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) then
        j = hic_2+1
        jj = 2*(j-loc_2)+lo_2

        do i = istart,iend
          ii = 2*(i-loc_1)+lo_1
          resc(i,j) = fourth*(res(ii  ,jj) + res(ii  ,jj-1)) + 
     $                eighth*(res(ii+1,jj) + res(ii+1,jj-1)+
     $                        res(ii-1,jj) + res(ii-1,jj-1) )
        enddo
      endif

      if ( (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) .and.
     $     (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) ) then
        i = loc_1
        j = loc_2
        ii = 2*(i-loc_1)+lo_1
        jj = 2*(j-loc_2)+lo_2
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  ) +
     $                      res(ii,jj+1) + res(ii+1,jj+1) )
      endif
 
      if ( (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) .and.
     $     (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) ) then
        i = hic_1+1
        j = hic_2+1
        ii = 2*(i-loc_1)+lo_1
        jj = 2*(j-loc_2)+lo_2
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  ) +
     $                      res(ii,jj-1) + res(ii-1,jj-1) )
      endif

      if ( (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) .and.
     $     (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) ) then
        i = loc_1
        j = hic_2+1
        ii = 2*(i-loc_1)+lo_1
        jj = 2*(j-loc_2)+lo_2
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  ) +
     $                      res(ii,jj-1) + res(ii+1,jj-1) )
      endif

      if ( (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) .and.
     $     (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) ) then
        i = hic_1+1
        j = loc_2
        ii = 2*(i-loc_1)+lo_1
        jj = 2*(j-loc_2)+lo_2
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  ) +
     $                      res(ii,jj+1) + res(ii-1,jj+1) )
      endif

      return
      end

c *************************************************************************
c ** INTERP **
c ** Simple bilinear interpolation
c *************************************************************************

      subroutine FORT_INTERP(phi,deltac,DIMS,CDIMS)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      REAL_T     phi(lo_1 -1:hi_1 +2,lo_2 -1:hi_2 +2)
      REAL_T  deltac(loc_1-1:hic_1+2,loc_2-1:hic_2+2)

c     Local variables
      integer i,j,ii,jj
      integer is,ie,js,je,isc,iec,jsc,jec

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      isc = loc_1
      jsc = loc_2
      iec = hic_1
      jec = hic_2

      do j = jsc, jec+1 
        do i = isc, iec+1

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js

          phi(ii,jj) = deltac(i,j)

        enddo
      enddo

      do j = jsc, jec
        do i = isc, iec+1

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js

          phi(ii,jj+1) = half*(deltac(i,j) + deltac(i,j+1)) 

        enddo
      enddo

      do j = jsc, jec+1 
        do i = isc, iec

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js

          phi(ii+1,jj) = half*(deltac(i,j) + deltac(i+1,j))

        enddo
      enddo

      do j = jsc, jec 
        do i = isc, iec 

          ii = 2*(i-isc)+is
          jj = 2*(j-jsc)+js

          phi(ii+1,jj+1) = fourth*(deltac(i,j  ) + deltac(i+1,j  ) + 
     $                             deltac(i,j+1) + deltac(i+1,j+1) )
        enddo
      enddo

      return
      end

c *************************************************************************
c ** MAKEDGPHI **
c ** Compute D(sig G(phi))
c *************************************************************************

      subroutine makedgphi(phi,dgphi,sigma,DIMS,hx,hy,
     $                     bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T    phi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  dgphi(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  hx
      REAL_T  hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      REAL_T hxsqinv
      REAL_T hysqinv
      integer is,ie,js,je
      integer i,j

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      if (bcx_lo .eq. PERIODIC) then
        do j = js,je+1 
          phi(ie+2,j) = phi(is+1,j)
          phi(is-1,j) = phi(ie  ,j)
        enddo
      endif

      if (bcy_lo .eq. PERIODIC) then
        do i = is,ie+1 
          phi(i,je+2) = phi(i,js+1)
          phi(i,js-1) = phi(i,je  )
        enddo
      endif

      if (bcx_lo .eq. PERIODIC .and. bcy_lo .eq. PERIODIC) then
        phi(is-1,js-1) = phi(ie  ,je  )
        phi(is-1,je+2) = phi(ie  ,js+1)
        phi(ie+2,js-1) = phi(is+1,je  )
        phi(ie+2,je+2) = phi(is+1,js+1)
      endif    

      do j = js,je+1
        do i = is,ie+1

            dgphi(i,j) = sixth * (hxsqinv * 
     $       (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i,j-1) + two * phi(i-1,j)) +
     $        sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i,j+1) + two * phi(i-1,j)) +
     $        sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i,j-1) + two * phi(i+1,j)) +
     $        sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i,j+1) + two * phi(i+1,j)) -
     $           two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j)) * phi(i,j)) +
     $                          hysqinv * 
     $       (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i-1,j) + two * phi(i,j-1)) +
     $        sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i-1,j) + two * phi(i,j+1)) +
     $        sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i+1,j) + two * phi(i,j-1)) +
     $        sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i+1,j) + two * phi(i,j+1)) -
     $           two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j)) *  phi(i,j)))
        enddo
      enddo

      if (bcx_lo .eq. WALL .or. bcx_lo .eq. INLET) then
         do j = js,je+1
            dgphi(is  ,j) = two * dgphi(is  ,j)
         enddo
      else if (bcx_lo .eq. OUTLET) then
         do j = js,je+1
            dgphi(is  ,j) = zero
         enddo
      endif

      if (bcx_hi .eq. WALL .or. bcx_hi .eq. INLET) then
         do j = js,je+1
            dgphi(ie+1,j) = two * dgphi(ie+1,j)
         enddo
      else if (bcx_hi .eq. OUTLET) then
         do j = js,je+1
            dgphi(ie+1,j) = zero
         enddo
      endif

      if (bcy_lo .eq. WALL .or. bcy_lo .eq. INLET) then
         do i = is,ie+1
            dgphi(i,js  ) = two * dgphi(i,js  ) 
         enddo
      else if (bcy_lo .eq. OUTLET) then
         do i = is,ie+1
            dgphi(i,js  ) = zero
         enddo
      endif

      if (bcy_hi .eq. WALL .or. bcy_hi .eq. INLET) then
         do i = is,ie+1
            dgphi(i,je+1) = two * dgphi(i,je+1) 
         enddo
      else if (bcy_hi .eq. OUTLET) then
         do i = is,ie+1
            dgphi(i,je+1) = zero
         enddo
      endif

      return
      end

c *************************************************************************
c ** SOLVEHG **
c *************************************************************************

      subroutine FORT_SOLVEHG(dest,dest0,source,sigma,sum,r,w,z,work,
     $                        DIMS,hx,hy,bcx_lo,bcx_hi,bcy_lo,bcy_hi,
     $                        maxiter,norm,prob_norm)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T   dest(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  dest0(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T source(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    sum(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T      r(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T      w(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T      z(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T   work(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T hx
      REAL_T hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi
      integer maxiter
      REAL_T norm
      REAL_T prob_norm

c     Local variables
      REAL_T  factor
      REAL_T  alpha
      REAL_T  beta
      REAL_T  rho
      REAL_T  rhol
      REAL_T  tol,tolfac
      REAL_T  local_norm
      logical testx
      logical testy
      integer i,j,iter
      integer istart,iend
      integer jstart,jend

      tolfac = 1.0d-3

      istart = cvmgt(lo_1+1,lo_1  ,bcx_lo .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,bcx_hi .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,bcy_lo .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,bcy_hi .eq. OUTLET)

      do j = lo_2-1,hi_2+2
         do i = lo_1-1,hi_1+2
            dest0(i,j) = dest(i,j)
            dest(i,j) = zero
         enddo
      enddo

  10  call makedgphi(dest0,w,sigma,DIMS,hx,hy,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      rho = zero
      norm = zero

      do j = jstart, jend 
        do i = istart, iend 
          r(i,j) = source(i,j) - w(i,j)
        enddo
      enddo

      local_norm = zero
      do j = jstart, jend 
        do i = istart, iend 
          factor = one
          testx  = (i .eq. lo_1 .or. i .eq. hi_1+1)
          testy  = (j .eq. lo_2 .or. j .eq. hi_2+1)
          factor = cvmgt(factor*half,factor,testx)
          factor = cvmgt(factor*half,factor,testy)
          local_norm  = max(local_norm, abs(r(i,j)))
          z(i,j) = r(i,j) 
          rho    = rho + z(i,j) * r(i,j) * factor
          norm   = max(norm,abs(r(i,j)))
        enddo
      enddo

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do j = jstart, jend 
        do i = istart, iend 
          work(i,j) = zero
          dest(i,j) = z(i,j)
        enddo
      enddo

      iter  = 0
c     write(6,1000) iter, norm/prob_norm

100   continue  

      call makedgphi(dest,w,sigma,DIMS,hx,hy,bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      alpha = zero
      do j = jstart, jend 
        do i = istart, iend 
          factor = one
          testx  = (i .eq. lo_1 .or. i .eq. hi_1+1)
          testy  = (j .eq. lo_2 .or. j .eq. hi_2+1)
          factor = cvmgt(factor*half,factor,testx)
          factor = cvmgt(factor*half,factor,testy)
          alpha  = alpha + dest(i,j)*w(i,j) * factor
        enddo
      enddo

      alpha = rho / alpha
      rhol  = rho
      rho   = zero
      norm  = zero

      do j = jstart, jend 
        do i = istart, iend 
          factor = one
          testx  = (i .eq. lo_1 .or. i .eq. hi_1+1)
          testy  = (j .eq. lo_2 .or. j .eq. hi_2+1)
          factor = cvmgt(factor*half,factor,testx)
          factor = cvmgt(factor*half,factor,testy)
          work(i,j) = work(i,j) + alpha * dest(i,j)
          r(i,j) = r(i,j) - alpha * w(i,j)
          z(i,j) = r(i,j) 
          rho    = rho + z(i,j) * r(i,j) * factor
          norm   = max(norm,abs(r(i,j)))
        enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then
         
         do j = jstart, jend 
            do i = istart, iend 
               dest(i,j) = work(i,j) + dest0(i,j)
            enddo
         enddo
         
      else if (iter .ge. maxiter  .or.  norm .ge. 100.d0*local_norm) then

         tolfac = 10.d0 * tolfac
         iter = 1
         do j = jstart, jend 
            do i = istart, iend 
               dest(i,j) = zero
            enddo
         enddo
         goto 10

      else

        beta = rho / rhol
        do j = jstart, jend 
          do i = istart, iend 
            dest(i,j) = z(i,j) + beta * dest(i,j)
          enddo
        enddo
        goto 100

      endif

1000  format('Res/Res0 in solve : ',i4,2x,e12.5)
c      call flush(6)

      return
      end

c *************************************************************************
c ** MAKESUM **
c *************************************************************************

      subroutine FORT_MAKESUM(sigma,sum,DIMS,hx,hy,
     $                        bcx_lo,bcx_hi,bcy_lo,bcy_hi)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      REAL_T  sigma(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T    sum(lo_1-1:hi_1+2,lo_2-1:hi_2+2)
      REAL_T  hx
      REAL_T  hy
      integer bcx_lo, bcx_hi
      integer bcy_lo, bcy_hi

c     Local variables
      integer i, j
      integer is, ie, js, je
      integer istart,iend
      integer jstart,jend
      REAL_T  hxsqinv, hysqinv

      hxsqinv = one/(hx*hx)
      hysqinv = one/(hy*hy)

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      if (bcx_lo .eq. OUTLET) then
        istart = lo_1+1
      else
        istart = lo_1
      endif
      if (bcx_hi .eq. OUTLET) then
        iend = hi_1
      else
        iend = hi_1+1
      endif

      if (bcy_lo .eq. OUTLET) then
        jstart = lo_2+1
      else
        jstart = lo_2
      endif
      if (bcy_hi .eq. OUTLET) then
        jend = hi_2
      else
        jend = hi_2+1
      endif

      do j = jstart, jend 
        do i = istart, iend 

          sum(i,j) = third * (hxsqinv * 
     $      (sigma(i-1,j-1) + sigma(i-1,j) + sigma(i,j-1) + sigma(i,j)) + 
     $                        hysqinv * 
     $      (sigma(i-1,j-1) + sigma(i-1,j) + sigma(i ,j-1) + sigma(i,j)))
          sum(i,j) = -fourth*sum(i,j)

        enddo
      enddo

      if (bcx_lo .eq. WALL) then
        do j = jstart, jend
          sum(is  ,j) = two * sum(is  ,j)
        enddo
      endif

      if (bcx_hi .eq. WALL) then
        do j = jstart, jend
          sum(ie+1,j) = two * sum(ie+1,j)
        enddo
      endif

      if (bcy_lo .eq. WALL) then
        do i = istart, iend 
          sum(i,js  ) = two * sum(i,js  )
        enddo
      endif

      if (bcy_hi .eq. WALL) then
        do i = istart, iend 
          sum(i,je+1) = two * sum(i,je+1)
        enddo
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** MKDIVUCC **
c ** Define the RHS of the cell-centered divergence constraint 
c ***************************************************************

      subroutine FORT_MKDIVUCC(divu_src,u,v,rho,time,dx,DIMS)

      implicit none

      integer DIMS

      REAL_T  divu_src(lo_1  :hi_1  ,lo_2  :hi_2  )
      REAL_T         u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T         v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T       rho(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  time
      REAL_T  dx(2)

c     Local variables
      integer i,j 

      do j = lo_2,hi_2
      do i = lo_1,hi_1
        divu_src(i,j) = zero
      enddo
      enddo

      return
      end

(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     61315,       2219]*)
(*NotebookOutlinePosition[     62304,       2253]*)
(*  CellTagsIndexPosition[     62260,       2249]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[
"a clone of visc2d.ma  which\nshould work in 3D"], "Subtitle",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["definition of tau"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
tauxxdef = tauxx[i_ + half, j_ ,k_] -> 
\t\t2*mu[i+half,j,k]*dudx[i+half,j,k]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(tauxx[half + i_, j_, k_] \[Rule] 
      2\ dudx[half + i, j, k]\ mu[half + i, j, k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
tauyydef = tauyy[i_, j_ + half,k_] ->
\t\t2*mu[i,j+half,k] * dvdy[i,j+half,k]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(tauyy[i_, half + j_, k_] \[Rule] 
      2\ dvdy[i, half + j, k]\ mu[i, half + j, k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
tauzzdef = tauzz[i_,j_,k_+half] ->
\t\t2*mu[i,j,k+half]*dwdz[i,j,k+half]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(tauzz[i_, j_, half + k_] \[Rule] 
      2\ dwdz[i, j, half + k]\ mu[i, j, half + k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
tauxydef = tauxy[i_,j_,k_] -> mu[i,j,k]*
\t\t\t\t\t\t\t(dudy[i,j,k]+dvdx[i,j,k])\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauxydef\)\" is similar \
to existing symbols \!\({tauxxdef, tauyydef}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauxy\)\" is similar to \
existing symbols \!\({tauxx, tauyy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudy\)\" is similar to \
existing symbols \!\({dudx, dvdy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(tauxy[i_, j_, k_] \[Rule] 
      \((dudy[i, j, k] + dvdx[i, j, k])\)\ mu[i, j, k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
tauxzdef = tauxz[i_,j_,k_] -> mu[i,j,k]*
\t\t\t\t\t\t\t(dudz[i,j,k]+dwdx[i,j,k])\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauxzdef\)\" is similar \
to existing symbols \!\({tauxxdef, tauxydef, tauzzdef}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauxz\)\" is similar to \
existing symbols \!\({tauxx, tauxy, tauzz}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudz\)\" is similar to \
existing symbols \!\({dudx, dudy, dwdz}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(tauxz[i_, j_, k_] \[Rule] 
      \((dudz[i, j, k] + dwdx[i, j, k])\)\ mu[i, j, k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
tauyzdef = tauyz[i_,j_,k_] -> mu[i,j,k]*
\t\t\t\t\t\t\t(dvdz[i,j,k]+dwdy[i,j,k])\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauyzdef\)\" is similar \
to existing symbols \!\({tauxzdef, tauyydef, tauzzdef}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(tauyz\)\" is similar to \
existing symbols \!\({tauxz, tauyy, tauzz}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dvdz\)\" is similar to \
existing symbols \!\({dudz, dvdx, dvdy, dwdz}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(tauyz[i_, j_, k_] \[Rule] 
      \((dvdz[i, j, k] + dwdy[i, j, k])\)\ mu[i, j, k]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions of derivatives"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["diagonal derivatives"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
dudxdef = dudx[i_+half,j_,k_] -> 
\t\t(u[i+1,j,k]-u[i,j,k])/hx\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dudx[half + i_, j_, k_] \[Rule] 
      \(\(-u[i, j, k]\) + u[1 + i, j, k]\)\/hx\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dvdydef = dvdy[i_,j_+half,k_] ->
\t\t(v[i,j+1,k]-v[i,j,k])/hy\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dvdy[i_, half + j_, k_] \[Rule] 
      \(\(-v[i, j, k]\) + v[i, 1 + j, k]\)\/hy\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dwdzdef = dwdz[i_,j_,k_+half] ->
\t\t(w[i,j,k+1]-w[i,j,k])/hz\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dwdz[i_, j_, half + k_] \[Rule] 
      \(\(-w[i, j, k]\) + w[i, j, 1 + k]\)\/hz\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["dudy"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dudydef1 = dudy[i_,j_+half,k_] -> (u[i,j+1,k]-u[i,j,k])/hy", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dudy[i_, half + j_, k_] \[Rule] 
      \(\(-u[i, j, k]\) + u[i, 1 + j, k]\)\/hy\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dudydef2 = dudy[i_+half,j_,k_] -> 
\t\t(u[i,j+1,k]-u[i,j-1,k]+u[i+1,j+1,k]-u[i+1,j-1,k])/
\t\t\t\t\t\t\t\t\t\t\t\t\t(4*hy)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dudy[half + i_, j_, k_] \[Rule] 
      \(1\/\(4\ hy\)\((
        \(-u[i, \(-1\) + j, k]\) + u[i, 1 + j, k] - u[1 + i, \(-1\) + j, k] + 
          u[1 + i, 1 + j, k])\)\)\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["dudz"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dudzdef1 = dudz[i_,j_,k_+half]->(u[i,j,k+1]-u[i,j,k])/hz", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudzdef1\)\" is similar \
to existing symbol \"\!\(dudydef1\)\"."\)], "Message"],

Cell[BoxData[
    \(dudz[i_, j_, half + k_] \[Rule] 
      \(\(-u[i, j, k]\) + u[i, j, 1 + k]\)\/hz\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dudzdef2 = dudz[i_+half,j_,k_] ->
\t\t(u[i,j,k+1]-u[i,j,k-1]+u[i+1,j,k+1]-u[i+1,j,k-1])/
\t\t\t\t\t\t\t\t\t\t\t\t(4*hz)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudzdef2\)\" is similar \
to existing symbol \"\!\(dudydef2\)\"."\)], "Message"],

Cell[BoxData[
    \(dudz[half + i_, j_, k_] \[Rule] 
      \(1\/\(4\ hz\)\((
        \(-u[i, j, \(-1\) + k]\) + u[i, j, 1 + k] - u[1 + i, j, \(-1\) + k] + 
          u[1 + i, j, 1 + k])\)\)\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["dvdx"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dvdxdef1 = dvdx[i_+half,j_,k_] -> (v[i+1,j,k]-v[i,j,k])/hx", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dvdx[half + i_, j_, k_] \[Rule] 
      \(\(-v[i, j, k]\) + v[1 + i, j, k]\)\/hx\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dvdxdef2 = dvdx[i_,j_+half,k_] ->
\t\t(v[i+1,j+1,k]-v[i-1,j+1,k]+v[i+1,j,k]-v[i-1,j,k])/(4*hx)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(dvdx[i_, half + j_, k_] \[Rule] 
      \(1\/\(4\ hx\)\((
        \(-v[\(-1\) + i, j, k]\) - v[\(-1\) + i, 1 + j, k] + v[1 + i, j, k] + 
          v[1 + i, 1 + j, k])\)\)\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["dvdz"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dvdzdef1 = dvdz[i_,j_,k_+half]->(v[i,j,k+1]-v[i,j,k])/hz", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dvdzdef1\)\" is similar \
to existing symbols \!\({dudzdef1, dvdxdef1}\)."\)], "Message"],

Cell[BoxData[
    \(dvdz[i_, j_, half + k_] \[Rule] 
      \(\(-v[i, j, k]\) + v[i, j, 1 + k]\)\/hz\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dvdzdef2 = dvdz[i_,j_+half,k_]->
\t\t(v[i,j,k+1]-v[i,j,k-1]+v[i,j+1,k+1]-v[i,j+1,k-1])/
\t\t\t\t\t\t\t\t\t\t\t\t(4*hz)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dvdzdef2\)\" is similar \
to existing symbols \!\({dudzdef2, dvdxdef2}\)."\)], "Message"],

Cell[BoxData[
    \(dvdz[i_, half + j_, k_] \[Rule] 
      \(1\/\(4\ hz\)\((
        \(-v[i, j, \(-1\) + k]\) + v[i, j, 1 + k] - v[i, 1 + j, \(-1\) + k] + 
          v[i, 1 + j, 1 + k])\)\)\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["dwdx"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dwdxdef1 = dwdx[i_+half,j_,k_]->(w[i+1,j,k]-w[i,j,k])/hx", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dwdxdef1\)\" is similar \
to existing symbol \"\!\(dvdxdef1\)\"."\)], "Message"],

Cell[BoxData[
    \(dwdx[half + i_, j_, k_] \[Rule] 
      \(\(-w[i, j, k]\) + w[1 + i, j, k]\)\/hx\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dwdxdef2 = dwdx[i_,j_,k_+half]->
\t\t(w[i+1,j,k]-w[i-1,j,k]+w[i+1,j,k+1]-w[i-1,j,k+1])/
\t\t\t\t\t\t\t\t\t\t\t(4*hx)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dwdxdef2\)\" is similar \
to existing symbol \"\!\(dvdxdef2\)\"."\)], "Message"],

Cell[BoxData[
    \(dwdx[i_, j_, half + k_] \[Rule] 
      \(1\/\(4\ hx\)\((
        \(-w[\(-1\) + i, j, k]\) - w[\(-1\) + i, j, 1 + k] + w[1 + i, j, k] + 
          w[1 + i, j, 1 + k])\)\)\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["dwdy"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
dwdydef1 = dwdy[i_,j_+half,k_] ->
\t\t(w[i,j+1,k]-w[i,j,k])/hy\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dwdydef1\)\" is similar \
to existing symbols \!\({dudydef1, dwdxdef1}\)."\)], "Message"],

Cell[BoxData[
    \(dwdy[i_, half + j_, k_] \[Rule] 
      \(\(-w[i, j, k]\) + w[i, 1 + j, k]\)\/hy\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dwdydef2 = dwdy[i_,j_,k_+half] ->
\t(w[i,j+1,k]-w[i,j-1,k]+w[i,j+1,k+1]-w[i,j-1,k+1])/(4*hy)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dwdydef2\)\" is similar \
to existing symbols \!\({dudydef2, dwdxdef2}\)."\)], "Message"],

Cell[BoxData[
    \(dwdy[i_, j_, half + k_] \[Rule] 
      \(1\/\(4\ hy\)\((
        \(-w[i, \(-1\) + j, k]\) - w[i, \(-1\) + j, 1 + k] + w[i, 1 + j, k] + 
          w[i, 1 + j, 1 + k])\)\)\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions used to test taylor expansions"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
taylorudef = u[i_,j_,k_]->
\t\t\tU[x0,y0,z0]+
\t\t\tDuDx[x0,y0,z0]*((i+1/2)*hx-x0)+
\t\t\tDuDy[x0,y0,z0]*((j+1/2)*hy-y0)+
\t\t\tDuDz[x0,y0,z0]*((k+1/2)*hz-z0)+
\t\t\tD2uDy2[x0,y0,z0]/2*((i+1/2)*hx-x0)^2+
\t\t\tD2uDx2[x0,y0,z0]/2*((j+1/2)*hy-y0)^2+
\t\t\tD2uDz2[x0,y0,z0]/2*((k+1/2)*hz-z0)^2+
\t\t\tD2uDxDy[x0,y0,z0]*((i+1/2)*hx-x0)*((j+1/2)*hy-y0)+
\t\t\tD2uDxDz[x0,y0,z0]*((i+1/2)*hx-x0)*((k+1/2)*hz-z0)+
\t\t\tD2uDyDz[x0,y0,z0]*((j+1/2)*hy-y0)*((k+1/2)*hz-z0)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DuDy\)\" is similar to \
existing symbol \"\!\(DuDx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DuDz\)\" is similar to \
existing symbols \!\({DuDx, DuDy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2uDx2\)\" is similar \
to existing symbol \"\!\(D2uDy2\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2uDz2\)\" is similar \
to existing symbols \!\({D2uDx2, D2uDy2}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2uDxDz\)\" is similar \
to existing symbol \"\!\(D2uDxDy\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell1\"\) will be suppressed \
during this calculation."\)], "Message"],

Cell[BoxData[
    \(u[i_, j_, k_] \[Rule] 
      1\/2\ \((hy\ \((1\/2 + j)\) - y0)\)\^2\ D2uDx2[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hy\ \((1\/2 + j)\) - y0)\)\ 
          D2uDxDy[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hz\ \((1\/2 + k)\) - z0)\)\ 
          D2uDxDz[x0, y0, z0] + 
        1\/2\ \((hx\ \((1\/2 + i)\) - x0)\)\^2\ D2uDy2[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ \((hz\ \((1\/2 + k)\) - z0)\)\ 
          D2uDyDz[x0, y0, z0] + 
        1\/2\ \((hz\ \((1\/2 + k)\) - z0)\)\^2\ D2uDz2[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ DuDx[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DuDy[x0, y0, z0] + 
        \((hz\ \((1\/2 + k)\) - z0)\)\ DuDz[x0, y0, z0] + U[x0, y0, z0]\)], 
  "Output"]
}, Open  ]],

Cell["dog = dudy[i+half,j,k] //. {dudydef1,dudydef2,taylorudef} ;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog /. {i->0,j->0,k->0,x0->hx,y0->hy/2,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell["dog = dudy[i,j+half,k] //. {dudydef1,dudydef2,taylorudef} ;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog /. {i->0,j->0,k->0,x0->hx/2,y0->hy,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
taylorvdef = v[i_,j_,k_]->
\t\t\tV[x0,y0,z0]+
\t\t\tDvDx[x0,y0,z0]*((i+1/2)*hx-x0)+
\t\t\tDvDy[x0,y0,z0]*((j+1/2)*hy-y0)+
\t\t\tDvDz[x0,y0,z0]*((k+1/2)*hz-z0)+
\t\t\tD2vDy2[x0,y0,z0]/2*((i+1/2)*hx-x0)^2+
\t\t\tD2vDx2[x0,y0,z0]/2*((j+1/2)*hy-y0)^2+
\t\t\tD2vDz2[x0,y0,z0]/2*((k+1/2)*hz-z0)^2+
\t\t\tD2vDxDy[x0,y0,z0]*((i+1/2)*hx-x0)*((j+1/2)*hy-y0)+
\t\t\tD2vDxDz[x0,y0,z0]*((i+1/2)*hx-x0)*((k+1/2)*hz-z0)+
\t\t\tD2vDyDz[x0,y0,z0]*((j+1/2)*hy-y0)*((k+1/2)*hz-z0)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(taylorvdef\)\" is \
similar to existing symbol \"\!\(taylorudef\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DvDx\)\" is similar to \
existing symbol \"\!\(DuDx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DvDy\)\" is similar to \
existing symbols \!\({DuDy, DvDx}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DvDz\)\" is similar to \
existing symbols \!\({DuDz, DvDx, DvDy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2vDy2\)\" is similar \
to existing symbol \"\!\(D2uDy2\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell1\"\) will be suppressed \
during this calculation."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(D2vDx2\)\" is similar \
to existing symbols \!\({D2uDx2, D2vDy2}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(v[i_, j_, k_] \[Rule] 
      1\/2\ \((hy\ \((1\/2 + j)\) - y0)\)\^2\ D2vDx2[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hy\ \((1\/2 + j)\) - y0)\)\ 
          D2vDxDy[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hz\ \((1\/2 + k)\) - z0)\)\ 
          D2vDxDz[x0, y0, z0] + 
        1\/2\ \((hx\ \((1\/2 + i)\) - x0)\)\^2\ D2vDy2[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ \((hz\ \((1\/2 + k)\) - z0)\)\ 
          D2vDyDz[x0, y0, z0] + 
        1\/2\ \((hz\ \((1\/2 + k)\) - z0)\)\^2\ D2vDz2[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ DvDx[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DvDy[x0, y0, z0] + 
        \((hz\ \((1\/2 + k)\) - z0)\)\ DvDz[x0, y0, z0] + V[x0, y0, z0]\)], 
  "Output"]
}, Open  ]],

Cell["dog = dvdy[i,j+half,k] //. {dvdydef, taylorvdef} ;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog /. {i->0,j->0,k->0,x0->hx/2,y0->hy,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DvDy[hx\/2, hy, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
taylorwdef = w[i_,j_,k_]->
\t\t\tW[x0,y0,z0]+
\t\t\tDwDx[x0,y0,z0]*((i+1/2)*hx-x0)+
\t\t\tDwDy[x0,y0,z0]*((j+1/2)*hy-y0)+
\t\t\tDwDz[x0,y0,z0]*((k+1/2)*hz-z0)+
\t\t\tD2wDy2[x0,y0,z0]/2*((i+1/2)*hx-x0)^2+
\t\t\tD2wDx2[x0,y0,z0]/2*((j+1/2)*hy-y0)^2+
\t\t\tD2wDz2[x0,y0,z0]/2*((k+1/2)*hz-z0)^2+
\t\t\tD2wDxDy[x0,y0,z0]*((i+1/2)*hx-x0)*((j+1/2)*hy-y0)+
\t\t\tD2wDxDz[x0,y0,z0]*((i+1/2)*hx-x0)*((k+1/2)*hz-z0)+
\t\t\tD2wDyDz[x0,y0,z0]*((j+1/2)*hy-y0)*((k+1/2)*hz-z0)\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(taylorwdef\)\" is \
similar to existing symbols \!\({taylorudef, taylorvdef}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DwDx\)\" is similar to \
existing symbols \!\({DuDx, DvDx}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DwDy\)\" is similar to \
existing symbols \!\({DuDy, DvDy, DwDx}\)."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \( : \ \) 
      "Further output of \!\(General :: \"spell\"\) will be suppressed during \
this calculation."\)], "Message"],

Cell[BoxData[
    \(w[i_, j_, k_] \[Rule] 
      1\/2\ \((hy\ \((1\/2 + j)\) - y0)\)\^2\ D2wDx2[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hy\ \((1\/2 + j)\) - y0)\)\ 
          D2wDxDy[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ \((hz\ \((1\/2 + k)\) - z0)\)\ 
          D2wDxDz[x0, y0, z0] + 
        1\/2\ \((hx\ \((1\/2 + i)\) - x0)\)\^2\ D2wDy2[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ \((hz\ \((1\/2 + k)\) - z0)\)\ 
          D2wDyDz[x0, y0, z0] + 
        1\/2\ \((hz\ \((1\/2 + k)\) - z0)\)\^2\ D2wDz2[x0, y0, z0] + 
        \((hx\ \((1\/2 + i)\) - x0)\)\ DwDx[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DwDy[x0, y0, z0] + 
        \((hz\ \((1\/2 + k)\) - z0)\)\ DwDz[x0, y0, z0] + W[x0, y0, z0]\)], 
  "Output"]
}, Open  ]],

Cell["dog = dwdy[i,j+half,k] //. {dwdydef1,dwdydef2, taylorwdef} ;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog /. {i->0,j->0,k->0,x0->hx/2,y0->hy,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DwDy[hx\/2, hy, hz\/2]\)], "Output"]
}, Open  ]],

Cell["dog = dwdy[i,j,k+half] //. {dwdydef1,dwdydef2, taylorwdef} ;", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog /. {i->0,j->0,k->0,x0->hx/2,y0->hy/2,z0->hz}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DwDy[hx\/2, hy\/2, hz]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
taylormudef = mu[i_,j_]->
\t\t\tMU[x0,y0,z0]+
\t\t\tDmuDx[x0,y0,z0]*((i+1/2)*hx-x0)+
\t\t\tDmuDy[x0,y0,z0]*((j+1/2)*hy-y0)+
\t\t\tDmuDz[x0,y0,z0]*((k+1/2)*hz-z0)
\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(taylormudef\)\" is \
similar to existing symbol \"\!\(taylorudef\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DmuDx\)\" is similar to \
existing symbol \"\!\(DuDx\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DmuDy\)\" is similar to \
existing symbols \!\({DmuDx, DuDy}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DmuDz\)\" is similar to \
existing symbols \!\({DmuDx, DmuDy, DuDz}\)."\)], "Message"],

Cell[BoxData[
    \(mu[i_, j_] \[Rule] 
      \((hx\ \((1\/2 + i)\) - x0)\)\ DmuDx[x0, y0, z0] + 
        \((hy\ \((1\/2 + j)\) - y0)\)\ DmuDy[x0, y0, z0] + 
        \((hz\ \((1\/2 + k)\) - z0)\)\ DmuDz[x0, y0, z0] + MU[x0, y0, z0]\)], 
  "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["tests"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[TextData["diagonal elements of tau"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
dog = tauxx[i+half,j,k] //.
\t\t{tauxxdef,dudxdef,taylormudef,taylorudef};\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
 dog //. {half->1/2,i->0,j->0,k->0,x0->hx,y0 -> hy/2,z0->hz/2 } \
\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(2\ DuDx[hx, hy\/2, hz\/2]\ mu[1\/2, 0, 0]\)], "Output"]
}, Open  ]],

Cell["\<\
dog = tauyy[i,j+half,k] //. 
\t\t{tauyydef,dvdydef,taylormudef,taylorvdef};\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx/2,y0->hy,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(2\ DvDy[hx\/2, hy, hz\/2]\ mu[0, 1\/2, 0]\)], "Output"]
}, Open  ]],

Cell["\<\
dog = tauzz[i,j,k+half] //. 
\t\t{tauzzdef,dwdzdef,taylormudef,taylorvdef,taylorwdef};\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx/2,y0->hy/2,z0->hz}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(2\ DwDz[hx\/2, hy\/2, hz]\ mu[0, 0, 1\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[" tauxy"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
dog = tauxy[i,j+half,k] //.
\t\t{tauxydef,dudydef1,dudydef2,dvdxdef1,dvdxdef2,
\t\t taylormudef,taylorudef,taylorvdef};\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx/2,y0->hy,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DuDy[hx\/2, hy, hz\/2] + DvDx[hx\/2, hy, hz\/2])\)\ 
      mu[0, 1\/2, 0]\)], "Output"]
}, Open  ]],

Cell["\<\
dog = tauxy[i+half,j,k] //.
\t\t{tauxydef,dudydef1,dudydef2,dvdxdef1,dvdxdef2,
\t\t taylormudef,taylorudef,taylorvdef};\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx,y0->hy/2,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DuDy[hx, hy\/2, hz\/2] + DvDx[hx, hy\/2, hz\/2])\)\ 
      mu[1\/2, 0, 0]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[" tauxz"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
dog = tauxz[i+half,j,k] //.
\t\t{tauxzdef,dudzdef1,dudzdef2,dwdxdef1,dwdxdef2,
\t\t taylormudef,taylorudef,taylorwdef} ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx,y0->hy/2,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DuDz[hx, hy\/2, hz\/2] + DwDx[hx, hy\/2, hz\/2])\)\ 
      mu[1\/2, 0, 0]\)], "Output"]
}, Open  ]],

Cell["\<\
dog = tauxz[i,j,k+half] //.
\t\t{tauxzdef,dudzdef1,dudzdef2,dwdxdef1,dwdxdef2,
\t\t taylormudef,taylorudef,taylorwdef} ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx/2,y0->hy/2,z0->hz}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DuDz[hx\/2, hy\/2, hz] + DwDx[hx\/2, hy\/2, hz])\)\ 
      mu[0, 0, 1\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[" tauyz"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
dog = tauyz[i,j+half,k] //.
\t\t{tauyzdef,dvdzdef1,dvdzdef2,dwdydef1,dwdydef2,
\t\t taylormudef,taylorvdef,taylorwdef} ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx/2,y0->hy,z0->hz/2}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DvDz[hx\/2, hy, hz\/2] + DwDy[hx\/2, hy, hz\/2])\)\ 
      mu[0, 1\/2, 0]\)], "Output"]
}, Open  ]],

Cell["\<\
dog = tauyz[i,j,k+half] //.
\t\t{tauyzdef,dvdzdef1,dvdzdef2,dwdydef1,dwdydef2,
\t\t taylormudef,taylorvdef,taylorwdef} ;\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["dog //. {half->1/2,i->0,j->0,k->0,x0->hx/2,y0->hy/2,z0->hz}", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(\((DvDz[hx\/2, hy\/2, hz] + DwDy[hx\/2, hy\/2, hz])\)\ 
      mu[0, 0, 1\/2]\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions used for fortran output"], "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["murepl1 = mu[i_,j_+half,k_] -> muY[i,j+1,k]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(mu[i_, half + j_, k_] \[Rule] muY[i, 1 + j, k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["murepl2 = mu[i_+half,j_,k_] -> muX[i+1,j,k]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(mu[half + i_, j_, k_] \[Rule] muX[1 + i, j, k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["murepl3 = mu[i_,j_,k_+half] -> muZ[i,j,k+1]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(mu[i_, j_, half + k_] \[Rule] muZ[i, j, 1 + k]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["urepl = u[i_,j_,k_] -> U[i,j,k,1]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(u[i_, j_, k_] \[Rule] U[i, j, k, 1]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["vrepl = v[i_,j_,k_] -> U[i,j,k,2]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(vrepl\)\" is similar to \
existing symbol \"\!\(urepl\)\"."\)], "Message"],

Cell[BoxData[
    \(v[i_, j_, k_] \[Rule] U[i, j, k, 2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["wrepl = w[i_,j_,k_] -> U[i,j,k,3]", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(wrepl\)\" is similar to \
existing symbols \!\({urepl, vrepl}\)."\)], "Message"],

Cell[BoxData[
    \(w[i_, j_, k_] \[Rule] U[i, j, k, 3]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"dependentCellsNotCovered is a function which returns a logical expression \
suitable for inclusion in fortran.  Give an expression, exp, we wish to \
determine which mesh locations are accessed by the expression.  However, we \
do not wish to examine all possible locations, only those outside the grid \
patch region.  So we provide a second argument, which is a boolean function \
taking two arguments.  The combination will give logical expressions testing \
the mask for cells utilized by the\nexpression and for which the boolean \
function, logfunc[il,jl], evaluates as true. The third argument is the name \
of the mask array"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Clear[ dependentCellsNotCovered ]", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
dependentCellsNotCovered[exp_ , logfunc_ ,maskfun_] :=
  Module[{cond,lexp,il,jl,kl,ml},
\tcond = False;
\tlexp = exp;
\tFor[il=-1,il<=+1,il++,
      For[jl=-1,jl<=+1,jl++,
        For[kl=-1,kl<=+1,kl++,
          For[ml=1,ml<=3,ml++,
            If[ (logfunc[il,jl,kl]) &&
\t          (Coefficient[
\t\t        Expand[ 
\t\t          exp
\t\t        ] ,
\t\t        U[i+il,j+jl,k+kl,ml]
\t          ] =!= 0), cond = cond || (maskfun[i+il,j+jl,k+kl]>0)
\t        ]
\t      ]
        ]
      ]
    ];
    cond
  ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(exp\)\" is similar to \
existing symbol \"\!\(Exp\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(lexp\)\" is similar to \
existing symbol \"\!\(exp\)\"."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
dependentCellsNotCovered[abba*U[i+1,j-1,k,1]+U[i-1,j-1,k+1,2]
\t\t\t\t\t\t\t, Function[{i,j,k},(k>0)] , 
\t\t\t\t\t\t\t  masks  ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(masks[\(-1\) + i, \(-1\) + j, 1 + k] > 0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"dependentCellsCovered is the logical inverse of dependentCellsNotCovered"], 
  "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Clear[ dependentCellsCovered ]", "Input",
  AspectRatioFixed->True],

Cell["\<\
dependentCellsCovered[exp_ , logfunc_ ,maskfun_] :=
  Module[{cond,lexp,il,jl,kl,ml},
\tcond = True;
\tlexp = exp;
\tFor[il=-1,il<=+1,il++,
      For[jl=-1,jl<=+1,jl++,
        For[kl=-1,kl<=+1,kl++,
          For[ml=1,ml<=3,ml++,
            If[ (logfunc[il,jl,kl]) &&
\t          (Coefficient[
\t\t        Expand[ 
\t\t          exp
\t\t        ] ,
\t\t        U[i+il,j+jl,k+kl,ml]
\t          ] =!= 0), cond = cond && (maskfun[i+il,j+jl,k+kl]==0)
\t        ]
\t      ]
        ]
      ]
    ];
    cond
  ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
dependentCellsCovered[abba*U[i+1,j-1,k,1]+U[i-1,j-1,k+1,2]
\t\t\t\t\t\t\t, Function[{i,j,k},(k>0)] , 
\t\t\t\t\t\t\t  masks  ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(masks[\(-1\) + i, \(-1\) + j, 1 + k] == 0\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["definitions for two sided derivs"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["DTwoX[u_,i_,j_,k_] := (u[i+1,j,k]-u[i-1,j,k])/(2*hx)", "Input",
  AspectRatioFixed->True],

Cell["DTwoX[u_,i_,j_,k_,n_] := (u[i+1,j,k,n]-u[i-1,j,k,n])/(2*hx)", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DTwoX[u,0,0,0] //. {taylorudef,x0->hx/2,y0->hy/2,
\t\t\t\t\t\t\t\t\tz0->hz/2} ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["DTwoY[u_,i_,j_,k_] := (u[i,j+1,k]-u[i,j-1,k])/(2*hy)", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DTwoY\)\" is similar to \
existing symbol \"\!\(DTwoX\)\"."\)], "Message"]
}, Open  ]],

Cell["DTwoY[u_,i_,j_,k_,n_] := (u[i,j+1,k,n]-u[i,j-1,k,n])/(2*hy)", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DTwoY[u,0,0,0] //. {taylorudef,x0->hx/2,y0->hy/2,
\t\t\t\t\t\t\t\t\tz0->hz/2} ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["DTwoZ[u_,i_,j_,k_] := (u[i,j,k+1]-u[i,j,k-1])/(2*hz)", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DTwoZ\)\" is similar to \
existing symbols \!\({DTwoX, DTwoY}\)."\)], "Message"]
}, Open  ]],

Cell["DTwoZ[u_,i_,j_,k_,n_] := (u[i,j,k+1,n]-u[i,j,k-1,n])/(2*hz)", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DTwoZ[u,0,0,0] //. {taylorudef,x0->hx/2,y0->hy/2,
\t\t\t\t\t\t\t\t\tz0->hz/2} ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDz[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"definitions for Do One-sided Derivative in X direction.  if sign is \
positive, \nit means extend the stencil in the positivie x direction.  if \
negative, extend\nin other direction"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[BoxData[
    \(Clear[DOneX]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(DOneX[u_, i_, j_, k_, sign_]\  := \ \n\t\t
      \((\(-u[i + 2, j, k]\) + 4*u[i + 1, j, k] - 3*u[i, j, k])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hx)\)\ \  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(sign\)\" is similar to \
existing symbol \"\!\(Sign\)\"."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(DOneX[u_, i_, j_, k_, sign_]\  := \ \n\t\t
      \((u[i - 2, j, k] - 4*u[i - 1, j, k] + 3*u[i, j, k])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hx)\)\  /; \ sign == \(-1\)\)], "Input"],

Cell[BoxData[
    \(DOneX[u_, i_, j_, k_, n_, sign_]\  := \ \n\t\t
      \((\(-u[i + 2, j, k, n]\) + 4*u[i + 1, j, k, n] - 3*u[i, j, k, n])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hx)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneX[u_, i_, j_, k_, n_, sign_]\  := \ \n\t\t
      \((u[i - 2, j, k, n] - 4*u[i - 1, j, k, n] + 3*u[i, j, k, n])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hx)\)\  /; \ sign == \(-1\)\)], "Input"],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DOneX[u,0,0,0,-1] //. 
\t\t{taylorudef,x0->hx/2,y0->hy/2,z0->hz/2}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DOneX[u,0,0,0,+1] //. 
\t\t{taylorudef,x0->hx/2,y0->hy/2,z0->hz/2}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDx[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"definitions for Do One-sided Derivative in Y direction.  if sign is \
positive, \nit means extend the stencil in the positivie y direction.  if \
negative, extend\nin other direction"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(Clear[DOneY]\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DOneY\)\" is similar to \
existing symbol \"\!\(DOneX\)\"."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(DOneY[u_, i_, j_, k_, sign_]\  := \ \n\t\t
      \((\(-u[i, j + 2, k]\) + 4*u[i, j + 1, k] - 3*u[i, j, k])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hy)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneY[u_, i_, j_, k_, sign_]\  := \ \n\t\t
      \((u[i, j - 2, k] - 4*u[i, j - 1, k] + 3*u[i, j, k])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hy)\)\  /; \ sign == \(-1\)\)], "Input"],

Cell[BoxData[
    \(DOneY[u_, i_, j_, k_, n_, sign_]\  := \ \n\t\t
      \((\(-u[i, j + 2, k, n]\) + 4*u[i, j + 1, k, n] - 3*u[i, j, k, n])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hy)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneY[u_, i_, j_, k_, n_, sign_]\  := \ \n\t\t
      \((u[i, j - 2, k, n] - 4*u[i, j - 1, k, n] + 3*u[i, j, k, n])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hy)\)\  /; \ sign == \(-1\)\)], "Input"],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DOneY[u,0,0,0,-1] //. 
\t\t{taylorudef,x0->hx/2,y0->hy/2,z0->hz/2}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DOneY[u,0,0,0,+1] //. 
\t\t{taylorudef,x0->hx/2,y0->hy/2,z0->hz/2}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDy[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"definitions for Do One-sided Derivative in Z direction.  if sign is \
positive, \nit means extend the stencil in the positivie z direction.  if \
negative, extend\nin other direction"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(Clear[DOneZ]\)], "Input"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(DOneZ\)\" is similar to \
existing symbols \!\({DOneX, DOneY}\)."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(DOneZ[u_, i_, j_, k_, sign_]\  := \ \n\t\t
      \((\(-u[i, j, k + 2]\) + 4*u[i, j, k + 1] - 3*u[i, j, k])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hz)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneZ[u_, i_, j_, k_, sign_]\  := \ \n\t\t
      \((u[i, j, k - 2] - 4*u[i, j, k - 1] + 3*u[i, j, k])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hz)\)\ \  /; \ sign == \(-1\)\)], "Input"],

Cell[BoxData[
    \(DOneZ[u_, i_, j_, k_, n_, sign_]\  := \ \n\t\t
      \((\(-u[i, j, k + 2, n]\) + 4*u[i, j, k + 1, n] - 3*u[i, j, k, n])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hz)\)\  /; \ sign == 1\)], "Input"],

Cell[BoxData[
    \(DOneZ[u_, i_, j_, k_, n_, sign_]\  := \ \n\t\t
      \((u[i, j, k - 2, n] - 4*u[i, j, k - 1, n] + 3*u[i, j, k, n])\)/\n
          \t\t\t\t\t\t\t\t\t\((2*hz)\)\ \  /; \ sign == \(-1\)\)], "Input"],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DOneZ[u,0,0,0,-1] //. 
\t\t{taylorudef,x0->hx/2,y0->hy/2,z0->hz/2}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDz[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Simplify[ DOneZ[u,0,0,0,+1] //. 
\t\t{taylorudef,x0->hx/2,y0->hy/2,z0->hz/2}]\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DuDz[hx\/2, hy\/2, hz\/2]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["useful one-sided derivatives"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(Clear[dvdxalt, dudyalt, dvdzalt, dwdyalt, dudzalt, dwdxalt]\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dvdzalt\)\" is similar \
to existing symbol \"\!\(dvdxalt\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dwdyalt\)\" is similar \
to existing symbol \"\!\(dudyalt\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dudzalt\)\" is similar \
to existing symbols \!\({dudyalt, dvdzalt}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \( : \ \) 
      "Possible spelling error: new symbol name \"\!\(dwdxalt\)\" is similar \
to existing symbols \!\({dvdxalt, dwdyalt}\)."\)], "Message"]
}, Open  ]],

Cell[BoxData[
    \(dvdxalt[i_, j_ + half, k_, sign_]\  := \ 
      \((DOneX[v, i, j, k, sign] + DOneX[v, i, j + 1, k, sign])\)/2\)], 
  "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(dvdxalt[i, j + half, k, 1]\)], "Input"],

Cell[BoxData[
    \(1\/2\ 
      \((\(\(-3\)\ v[i, j, k] + 4\ v[1 + i, j, k] - v[2 + i, j, k]\)\/\(2\ hx
              \) + \(\(-3\)\ v[i, 1 + j, k] + 4\ v[1 + i, 1 + j, k] - 
              v[2 + i, 1 + j, k]\)\/\(2\ hx\))\)\)], "Output"]
}, Open  ]],

Cell["\<\
dudyalt[i_+half,j_,k_,sign_] := (DOneY[u,i  ,j,k,sign]+
\t\t\t\t\t\t\t     DOneY[u,i+1,j,k,sign])/2\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dudyalt[i + half, j, k, 1]\)], "Input"],

Cell[BoxData[
    \(1\/2\ 
      \((\(\(-3\)\ u[i, j, k] + 4\ u[i, 1 + j, k] - u[i, 2 + j, k]\)\/\(2\ hy
              \) + \(\(-3\)\ u[1 + i, j, k] + 4\ u[1 + i, 1 + j, k] - 
              u[1 + i, 2 + j, k]\)\/\(2\ hy\))\)\)], "Output"]
}, Open  ]],

Cell["\<\
dvdzalt[i_,j_+half,k_,sign_] := (DOneZ[v,i,j  ,k,sign]+
\t\t\t\t\t\t\t     DOneZ[v,i,j+1,k,sign])/2\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dvdzalt[i, j + half, k, 1]\)], "Input"],

Cell[BoxData[
    \(1\/2\ 
      \((\(\(-3\)\ v[i, j, k] + 4\ v[i, j, 1 + k] - v[i, j, 2 + k]\)\/\(2\ hz
              \) + \(\(-3\)\ v[i, 1 + j, k] + 4\ v[i, 1 + j, 1 + k] - 
              v[i, 1 + j, 2 + k]\)\/\(2\ hz\))\)\)], "Output"]
}, Open  ]],

Cell["\<\
dwdyalt[i_,j_,k_+half,sign_] := (DOneY[w,i,j,k  ,sign]+
\t\t\t\t\t\t\t\t DOneY[w,i,j,k+1,sign])/2\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dwdyalt[i, j, k + half, 1]\)], "Input"],

Cell[BoxData[
    \(1\/2\ 
      \((\(\(-3\)\ w[i, j, k] + 4\ w[i, 1 + j, k] - w[i, 2 + j, k]\)\/\(2\ hy
              \) + \(\(-3\)\ w[i, j, 1 + k] + 4\ w[i, 1 + j, 1 + k] - 
              w[i, 2 + j, 1 + k]\)\/\(2\ hy\))\)\)], "Output"]
}, Open  ]],

Cell["\<\
dudzalt[i_+half,j_,k_,sign_] := (DOneZ[u,i  ,j,k,sign]+
\t\t\t\t\t\t\t\t DOneZ[u,i+1,j,k,sign])/2\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(dudzalt[i + half, j, k, 1]\)], "Input"],

Cell[BoxData[
    \(1\/2\ 
      \((\(\(-3\)\ u[i, j, k] + 4\ u[i, j, 1 + k] - u[i, j, 2 + k]\)\/\(2\ hz
              \) + \(\(-3\)\ u[1 + i, j, k] + 4\ u[1 + i, j, 1 + k] - 
              u[1 + i, j, 2 + k]\)\/\(2\ hz\))\)\)], "Output"]
}, Open  ]],

Cell["\<\
dwdxalt[i_,j_,k_+half,sign_] := (DOneX[w,i,j,k  ,sign]+
\t\t\t\t\t\t\t\t DOneX[w,i,j,k+1,sign])/2\
\>", "Input",
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dwdxalt[i, j, k + half, 1]\)], "Input"],

Cell[BoxData[
    \(1\/2\ 
      \((\(\(-3\)\ w[i, j, k] + 4\ w[1 + i, j, k] - w[2 + i, j, k]\)\/\(2\ hx
              \) + \(\(-3\)\ w[i, j, 1 + k] + 4\ w[1 + i, j, 1 + k] - 
              w[2 + i, j, 1 + k]\)\/\(2\ hx\))\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["setup to use the Format.m package "], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["Off[General::spell,General::spell1];", "Input",
  AspectRatioFixed->True],

Cell["SetOptions[$Output,PageWidth->73];", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["<</usr/people/wyc/_math/MathSource/Format/Format.m", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(exp::"shdw" \( : \ \) 
      "Symbol \!\(\"exp\"\) appears in multiple contexts \!\({\"Format`\", \
\"Global`\"}\); definitions in context \!\(\"Format`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"],

Cell[BoxData[
    \(sign::"shdw" \( : \ \) 
      "Symbol \!\(\"sign\"\) appears in multiple contexts \!\({\"Format`\", \
\"Global`\"}\); definitions in context \!\(\"Format`\"\) may shadow or be \
shadowed by other definitions."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"substitution for all derivatives and variables"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
allDerivAllUV = {dudxdef,
\t\t\t\t dvdydef,
\t\t\t\t dwdzdef,
\t\t\t\t dudydef1,dudydef2,
\t\t\t\t dudzdef1,dudzdef2,
\t\t\t\t dvdxdef1,dvdxdef2,
\t\t\t\t dvdzdef1,dvdzdef2,
\t\t\t\t dwdxdef1,dwdxdef2,
\t\t\t\t dwdydef1,dwdydef2,
\t\t\t\t urepl,
\t\t\t\t vrepl,
\t\t\t\t wrepl};\
\>", "Input",
  AspectRatioFixed->True],

Cell["\<\
allUVW = {       urepl,
\t\t\t\t vrepl,
\t\t\t\t wrepl};\
\>", "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["transverse u derivs"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["tduext[half+i,j,k] = trandere[i+1,j,k,1];", "Input",
  AspectRatioFixed->True],

Cell["tduext[half+i-1,j,k] = tranderw[i-1,j,k,1];", "Input",
  AspectRatioFixed->True],

Cell["tduext[i,j+half,k] = trandern[i,j+1,k,1];", "Input",
  AspectRatioFixed->True],

Cell["tduext[i,j-1+half,k] = tranders[i,j-1,k,1];", "Input",
  AspectRatioFixed->True],

Cell["tduext[i,j,k+half] = trandert[i,j,k+1,1];", "Input",
  AspectRatioFixed->True],

Cell["tduext[i,j,k-1+half] = tranderb[i,j,k-1,1];", "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["transverse v derivs"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["tdvext[half+i,j,k] = trandere[i+1,j,k,2];", "Input",
  AspectRatioFixed->True],

Cell["tdvext[half+i-1,j,k] = tranderw[i-1,j,k,2];", "Input",
  AspectRatioFixed->True],

Cell["tdvext[i,j+half,k] = trandern[i,j+1,k,2];", "Input",
  AspectRatioFixed->True],

Cell["tdvext[i,j-1+half,k] = tranders[i,j-1,k,2];", "Input",
  AspectRatioFixed->True],

Cell["tdvext[i,j,k+half] = trandert[i,j,k+1,2];", "Input",
  AspectRatioFixed->True],

Cell["tdvext[i,j,k-1+half] = tranderb[i,j,k-1,2];", "Input",
  AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["transverse w derivs"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["tdwext[half+i,j,k] = trandere[i+1,j,k,3];", "Input",
  AspectRatioFixed->True],

Cell["tdwext[half+i-1,j,k] = tranderw[i-1,j,k,3];", "Input",
  AspectRatioFixed->True],

Cell["tdwext[i,j+half,k] = trandern[i,j+1,k,3];", "Input",
  AspectRatioFixed->True],

Cell["tdwext[i,j-1+half,k] = tranders[i,j-1,k,3];", "Input",
  AspectRatioFixed->True],

Cell["tdwext[i,j,k+half] = trandert[i,j,k+1,3];", "Input",
  AspectRatioFixed->True],

Cell["tdwext[i,j,k-1+half] = tranderb[i,j,k-1,3];", "Input",
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[
"an alternate approach which seeks to automatically determine which \n\
direction to use for one sided deriv"], "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
altgen[lhs_,indx_,indy_,indz_,
       exp_,expalt_,expext_,
       varindx_,derivindx_,
       indexcond_,mask_] :=
\tBlock[
\t\t{tmpcond,tmp,tmpalt,
\t\t depplus,depminus,sign,
\t\t line1,line2,line3,line4,line5,
\t\t icase,jcase,kcase},
\t\t(* conditions are False if expression is safe to use *)
\t\ttmpcond = dependentCellsNotCovered[
\t\t\t\t\texp[indx,indy,indz] //. allDerivAllUV,
\t\t\t\t\tindexcond,mask];
\t\tdepplus = dependentCellsNotCovered[
\t\t\t\t\texpalt[indx,indy,indz,+1] //.allDerivAllUV,
\t\t\t\t\tindexcond,mask];
\t\tdepminus = dependentCellsNotCovered[
\t\t\t\t\texpalt[indx,indy,indz,-1] //.allDerivAllUV,
\t\t\t\t\tindexcond,mask];
\t\t(* temporary *)
\t\tIf[ depplus === False , 
\t\t\tsign = 1,
\t\t\tIf[ depminus === False ,
\t\t\t\tsign = -1,
\t\t\t\tsign = 0  (* means neither of one 
\t\t\t\t             sided is safe *)
\t\t\t]
\t\t];
\t\t(* treat 3 different cases *)
\t\tWhich[
\t\t\ttmpcond === False,
\t\t\t(* exp does not extend into masked region *)
\t\t\tFortranAssign[
\t\t\t\tlhs,
\t\t\t\texp[indx,indy,indz] //.allDerivAllUV,
\t\t\t\tAssignToArray->{U},
\t\t\t\tAssignPrecision->Infinity
\t\t\t],
\t\t\t
\t\t\ttmpcond =!= False && sign != 0,
\t\t\t(* exp extends outside, output conditional mask *)

\t\t\ttmp = FortranAssign[
\t\t\t\ttmpcond,
\t\t\t\tAssignToArray->{mask},
\t\t\t\tAssignIndent->\"\",
\t\t\t\tAssignPrecision->Infinity
\t\t\t];
\t\t\ttmpalt =dependentCellsNotCovered[
\t\t\t\t\texpalt[indx,indx,indz,sign]//.allDerivAllUV,
\t\t\t\t\t\tindexcond,mask];
\t\t\tline1 = StringForm[\"      if(``) then \", tmp];
\t\t\tline2 = FortranAssign[
\t\t\t\tlhs,
\t\t\t\texpalt[indx,indy,indz,sign]//.allDerivAllUV,
\t\t\t\tAssignToArray->{U},
\t\t\t\tAssignPrecision->Infinity
\t\t\t];
\t\t\tline3 = StringForm[\"      else\"];
\t\t\tline4 = FortranAssign[
\t\t\t\tlhs,
\t\t\t\texp[indx,indy,indz] //.allDerivAllUV,
\t\t\t\tAssignToArray->{U},
\t\t\t\tAssignPrecision->Infinity
\t\t\t];
\t\t\tIf[tmpalt =!= False ,
\t\t\t\t(* this is an error, the alternate form should
\t\t\t\t   be specified to be inside safe region *)
\t\t   \t\tline5 = StringForm[\" error in tandergen\"]
\t\t   \t,
\t\t   \t\tline5 = StringForm[\"      endif\"]
\t\t\t];
\t\t\tColumnForm[{line1,line2,line3,line4,line5}],
\t\t\t
\t\t\tTrue,
\t\t\t(* cannot use exp or expalt, must be
\t\t\t   externally supplied derivative *)

\t\t\t(* need to figure out where to evaluate
\t\t\t   the transverse derivative *)
\t\t\ticase = Which[ indx === i-1+half, -1,
\t\t\t\t\t\t   indx === i       ,  0,
\t\t\t\t\t\t   indx === i  +half, +1,
\t\t\t\t\t\t   _, Print[\"error in icase\"]];
\t\t\tjcase = Which[ indy === j-1+half, -1,
\t\t\t\t\t\t   indy === j       ,  0,
\t\t\t\t\t\t   indy === j  +half, +1,
\t\t\t\t\t\t   _, Print[\"error in jcase\"]];

\t\t\tkcase = Which[ indz === k-1+half, -1,
\t\t\t\t\t\t   indz === k       ,  0,
\t\t\t\t\t\t   indz === k  +half, +1,
\t\t\t\t\t\t   _, Print[\"error in kcase\"]];
\t\t
\t\t\tFortranAssign[
\t\t\t\t\tlhs, expext[i+icase,
\t\t\t\t\t\t\t\tj+jcase,
\t\t\t\t\t\t\t\tk+kcase,
\t\t\t\t\t\t\t\tvarindx,derivindx],
\t\t\t\t\tAssignToArray->{trandere,tranderw,
\t\t\t\t\t\t\t\t\ttrandern,tranders,
\t\t\t\t\t\t\t\t\ttrandert,tranderb},
\t\t\t\t\tAssignPrecision->Infinity]\t
\t\t]\t
\t]\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
altgen[ dwdxt, 
\t\ti,j,k+half,
\t\tdwdx,dwdxalt,
\t\ttrandern,3,1,Function[{i,j,k},(k>0)],
\t\tmaskn ]\
\>", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
\"        dwdxt=trandern(i,j,1+k,3,1)\"\
\>", 
"\<\
        dwdxt=trandern(i,j,1+k,3,1)\
\>"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
altgen[ dudye, 
\t\ti+half,j,k,
\t\tdudy,
\t\tdudyalt,
\t\ttduext,
\t\t1,2,
\t\tFunction[{i,j,k},(i<0)],
\t\tmaskn ] \
\>", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
\"        \\
dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\\n     & \\
 +U(1+i,1+j,k,1))/(4.d0*hy)\"\
\>", 
"\<\
        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)
     &  +U(1+i,1+j,k,1))/(4.d0*hy)\
\>"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
altgen[ dudye, 
\t\ti+half,j,k,
\t\tdudy,
\t\tdudyalt,
\t\ttrandere,
\t\t1,2,
\t\tFunction[{i,j,k},(i>0)],
\t\tmaskn ] \
\>", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
\"        dudye=trandere(1+i,j,k,1,2)\"\
\>", 
"\<\
        dudye=trandere(1+i,j,k,1,2)\
\>"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
altgen[ dudye, 
\t\ti+half,j,k,
\t\tdudy,
\t\tdudyalt,
\t\ttranderns,
\t\t1,2,
\t\tFunction[{i,j,k},(j<0)],
\t\tmaskn ] \
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {
            "\<\"      \
if(\\!\\(\\*FrameBox[\\\"\\\\\\\"maskn(i,-1+j,k).gt.0.or.maskn(1+i,-1+j,k).gt.\
0\\\\\\\"\\\", Rule[BoxFrame, False], Rule[BoxMargins, False]]\\)) then \
\"\>"},
          {
            
            FrameBox[
              \("        dudye=((-3*U(i,j,k,1)+4*U(i,1+j,k,1)-U(i,2+j,k,1))\n \
    &  /(2.d0*hy)+(-3*U(1+i,j,k,1)+4*U(1+i,1+j,k,1)-U(1+i\n     &  \
,2+j,k,1))/(2.d0*hy))/2.d0"\),
              BoxFrame->False,
              BoxMargins->False]},
          {"\<\"      else\"\>"},
          {
            
            FrameBox[
              \("        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\n \
    &  +U(1+i,1+j,k,1))/(4.d0*hy)"\),
              BoxFrame->False,
              BoxMargins->False]},
          {"\<\"      endif\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {
        StringForm[ "      if(``) then ", 
          OutputForm[ 
            
            ColumnForm[ {
              "maskn(i,-1+j,k).gt.0.or.maskn(1+i,-1+j,k).gt.0"}]]], 
        OutputForm[ 
          
          ColumnForm[ {
            "        dudye=((-3*U(i,j,k,1)+4*U(i,1+j,k,1)-U(i,2+j,k,1))\n     \
&  /(2.d0*hy)+(-3*U(1+i,j,k,1)+4*U(1+i,1+j,k,1)-U(1+i\n     &  \
,2+j,k,1))/(2.d0*hy))/2.d0"}]], 
        StringForm[ "      else"], 
        OutputForm[ 
          
          ColumnForm[ {
            "        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\n     \
&  +U(1+i,1+j,k,1))/(4.d0*hy)"}]], 
        StringForm[ "      endif"]}],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
altgen[ dudye, 
\t\ti+half,j,k,
\t\tdudy,
\t\tdudyalt,
\t\ttrandere,
\t\t1,2,
\t\tFunction[{i,j,k},(j>0)],
\t\tmaskn ] \
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {
            "\<\"      \
if(\\!\\(\\*FrameBox[\\\"\\\\\\\"maskn(i,1+j,k).gt.0.or.maskn(1+i,1+j,k).gt.0\
\\\\\\\"\\\", Rule[BoxFrame, False], Rule[BoxMargins, False]]\\)) then \"\>"},
          
          {
            
            FrameBox[
              \("        dudye=((U(i,-2+j,k,1)-4*U(i,-1+j,k,1)+3*U(i,j,k,1)\n \
    &  )/(2.d0*hy)+(U(1+i,-2+j,k,1)-4*U(1+i,-1+j,k,1)+3*U\n     &  \
(1+i,j,k,1))/(2.d0*hy))/2.d0"\),
              BoxFrame->False,
              BoxMargins->False]},
          {"\<\"      else\"\>"},
          {
            
            FrameBox[
              \("        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\n \
    &  +U(1+i,1+j,k,1))/(4.d0*hy)"\),
              BoxFrame->False,
              BoxMargins->False]},
          {"\<\"      endif\"\>"}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      ColumnForm[ {
        StringForm[ "      if(``) then ", 
          OutputForm[ 
            ColumnForm[ {"maskn(i,1+j,k).gt.0.or.maskn(1+i,1+j,k).gt.0"}]]], 
        OutputForm[ 
          
          ColumnForm[ {
            "        dudye=((U(i,-2+j,k,1)-4*U(i,-1+j,k,1)+3*U(i,j,k,1)\n     \
&  )/(2.d0*hy)+(U(1+i,-2+j,k,1)-4*U(1+i,-1+j,k,1)+3*U\n     &  \
(1+i,j,k,1))/(2.d0*hy))/2.d0"}]], 
        StringForm[ "      else"], 
        OutputForm[ 
          
          ColumnForm[ {
            "        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\n     \
&  +U(1+i,1+j,k,1))/(4.d0*hy)"}]], 
        StringForm[ "      endif"]}],
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
altgen[ dudye, 
\t\ti+half,j,k,
\t\tdudy,
\t\tdudyalt,
\t\ttranderb,
\t\t1,2,
\t\tFunction[{i,j,k},(k<0)],
\t\tmaskn ] \
\>", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
\"        \\
dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\\n     & \\
 +U(1+i,1+j,k,1))/(4.d0*hy)\"\
\>", 
"\<\
        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)
     &  +U(1+i,1+j,k,1))/(4.d0*hy)\
\>"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
altgen[ dudye, 
\t\ti+half,j,k,
\t\tdudy,
\t\tdudyalt,
\t\ttrandert,
\t\t1,2,
\t\tFunction[{i,j,k},(k>0)],
\t\tmaskn ] \
\>", "Input",
  AspectRatioFixed->True],

Cell[OutputFormData["\<\
\"        \\
dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)\\n     & \\
 +U(1+i,1+j,k,1))/(4.d0*hy)\"\
\>", 
"\<\
        dudye=(-U(i,-1+j,k,1)+U(i,1+j,k,1)-U(1+i,-1+j,k,1)
     &  +U(1+i,1+j,k,1))/(4.d0*hy)\
\>"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData["a short-hand function"], "Subsubsection",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell["\<\
FA[x_] := FortranAssign[x,
\t\t\t\t\t\tAssignToArray->{U,muX,muY,muZ,a,u,
\t\t\t\t\t\t\t\t\t\tmaskn,maske,maskw,
\t\t\t\t\t\t\t\t\t\tmasks,maskt,maskb},
\t\t\t\t\t\tAssignIndent->\"\",
\t\t\t\t\t\tAssignPrecision->Infinity];\t\t\
\>", "Input",
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["\<\
DeleteFile[ \"dog.mf\"];
CopyFile[ \"DV_3D1.mF\" , \"dog.mf\"];
Splice[\"dog.mf\",FormatType->OutputForm];
DeleteFile[ \"DV_3D1.F\"];
CopyFile[ \"dog.f\", \"DV_3D1.F\" ];
<<\"!touch DV_3D1.F\"
\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DeleteFile::"nffil" \( : \ \) 
      "File not found during \!\(DeleteFile[\"DV_3D1.F\"]\)."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DeleteFile[ \"dog.mf\"];
CopyFile[ \"DV_3D2.mF\" , \"dog.mf\"];
Splice[\"dog.mf\",FormatType->OutputForm];
DeleteFile[ \"DV_3D2.F\"];
CopyFile[ \"dog.f\", \"DV_3D2.F\" ];
<<\"!touch DV_3D2.F\"
\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DeleteFile::"nffil" \( : \ \) 
      "File not found during \!\(DeleteFile[\"DV_3D2.F\"]\)."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DeleteFile[ \"dog.mf\"];
CopyFile[ \"DV_3D3.mF\" , \"dog.mf\"];
Splice[\"dog.mf\",FormatType->OutputForm];
DeleteFile[ \"DV_3D3.F\"];
CopyFile[ \"dog.f\", \"DV_3D3.F\" ];
<<\"!touch DV_3D3.F\"
\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DeleteFile::"nffil" \( : \ \) 
      "File not found during \!\(DeleteFile[\"DV_3D3.F\"]\)."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DeleteFile[ \"dog.mf\"];
CopyFile[ \"DV_3D4.mF\" , \"dog.mf\"];
Splice[\"dog.mf\",FormatType->OutputForm];
DeleteFile[ \"DV_3D4.F\"];
CopyFile[ \"dog.f\", \"DV_3D4.F\" ];
<<\"!touch DV_3D4.F\"
\
\>", "Input",
  AspectRatioFixed->True],

Cell[BoxData[
    \(DeleteFile::"nffil" \( : \ \) 
      "File not found during \!\(DeleteFile[\"DV_3D4.F\"]\)."\)], "Message"]
}, Open  ]],

Cell[TextData[
"\n FA[ Coefficient[Expand[\n  alpha*a[i,j,k]*u[i,j,k]-beta*(\n\t\
hy*hz*(tauxx[i+half  ,j      , k]-\n\t       tauxx[i-1+half,j      , k])+\n\t\
hx*hz*(tauxy[i       ,j+half  ,k]-   \n\t       tauxy[i       ,j-1+half,k])+\n\
\thx*hy*(tauxz[i       ,j       ,k+half]-\n\t       tauxz[i       ,j       \
,k-1+half]))/vol //. \n\t       {murepl1,murepl2,murepl3,\n\t        \
tauxxdef,tauyydef,tauxydef,tauxzdef,tauyzdef,\n\t        tauzzdef,\n\t        \
vol->hx*hy*hz,\n\t        dudxdef,dvdydef,dwdzdef,\n\t        \
dudydef1,dudydef2,\n\t        dudzdef1,dudzdef2,\n\t        \
dwdxdef1,dwdxdef2,\n\t        dvdxdef1,dvdxdef2 }\n ],u[i,j+1,k]]]\n\t       \
"], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"\nFA[Coefficient[ Expand[\n  alpha*a[i,j,k]*v[i,j,k]-beta*(\n\t\
hy*hz*(tauxy[i+half  ,j      , k]-\n\t       tauxy[i-1+half,j      , k])+\n\t\
hx*hz*(tauyy[i       ,j+half  ,k]-   \n\t       tauyy[i       ,j-1+half,k])+\n\
\thx*hy*(tauyz[i       ,j       ,k+half]-\n\t       tauyz[i       ,j       \
,k-1+half]))/vol //. \n\t       {murepl1,murepl2,murepl3,\n\t        \
tauxxdef,tauyydef,tauxydef,tauxzdef,tauyzdef,\n\t        tauzzdef,\n\t        \
vol->hx*hy*hz,\n\t        dudxdef,dvdydef,dwdzdef,\n\t        \
dudydef1,dudydef2,\n\t        dudzdef1,dudzdef2,\n\t        \
dwdxdef1,dwdxdef2,\n\t        dvdxdef1,dvdxdef2,\n\t        \
dvdzdef1,dvdzdef2,\n\t        dwdydef1,dwdydef2 } ] , v[i,j+1,k] ] ]"], 
  "Input",
  AspectRatioFixed->True],

Cell[TextData[
"\nFA[ Coefficient[ Expand[\n  alpha*a[i,j,k]*w[i,j,k]-beta*(\n\t\
hy*hz*(tauxz[i+half  ,j      , k]-\n\t       tauxz[i-1+half,j      , k])+\n\t\
hx*hz*(tauyz[i       ,j+half  ,k]-   \n\t       tauyz[i       ,j-1+half,k])+\n\
\thx*hy*(tauzz[i       ,j       ,k+half]-\n\t       tauzz[i       ,j       \
,k-1+half]))/vol //. \n\t       {murepl1,murepl2,murepl3,\n\t        \
tauxxdef,tauyydef,tauxydef,tauxzdef,tauyzdef,\n\t        tauzzdef,\n\t        \
vol->hx*hy*hz,\n\t        dudxdef,dvdydef,dwdzdef,\n\t        \
dudydef1,dudydef2,\n\t        dudzdef1,dudzdef2,\n\t        \
dwdxdef1,dwdxdef2,\n\t        dvdxdef1,dvdxdef2,\n\t        \
dvdzdef1,dvdzdef2,\n\t        dwdydef1,dwdydef2 } ] , w[i,j+1,k] ] ]"], 
  "Input",
  AspectRatioFixed->True],

Cell[TextData["\n\tDTwoY[u,i,j,k] //. allDerivAllUV"], "Input",
  AspectRatioFixed->True],

Cell[TextData[
"FA[ dependentCellsNotCovered[\n\tDTwoY[u,i,j,k] //. allDerivAllUV,\n\t\
Function[{i,j,k},(j<0)],masks] ]"], "Input",
  AspectRatioFixed->True],

Cell[TextData["FA[ DTwoY[U,i,j,k,n] ]"], "Input",
  AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{517, 949},
WindowMargins->{{Automatic, 112}, {Automatic, 22}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"Magnification"->1},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 125, 3, 93, "Subtitle",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1881, 58, 94, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[2000, 64, 128, 4, 42, "Input"],
Cell[2131, 70, 117, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2285, 77, 128, 4, 42, "Input"],
Cell[2416, 83, 117, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2570, 90, 123, 4, 42, "Input"],
Cell[2696, 96, 117, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2850, 103, 131, 4, 42, "Input"],
Cell[2984, 109, 191, 3, 55, "Message"],
Cell[3178, 114, 182, 3, 55, "Message"],
Cell[3363, 119, 179, 3, 39, "Message"],
Cell[3545, 124, 160, 3, 39, "Message"],
Cell[3708, 129, 115, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3860, 136, 131, 4, 42, "Input"],
Cell[3994, 142, 201, 3, 55, "Message"],
Cell[4198, 147, 189, 3, 55, "Message"],
Cell[4390, 152, 185, 3, 55, "Message"],
Cell[4578, 157, 160, 3, 39, "Message"],
Cell[4741, 162, 115, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4893, 169, 131, 4, 42, "Input"],
Cell[5027, 175, 201, 3, 55, "Message"],
Cell[5231, 180, 189, 3, 55, "Message"],
Cell[5423, 185, 191, 3, 55, "Message"],
Cell[5617, 190, 160, 3, 39, "Message"],
Cell[5780, 195, 115, 2, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5944, 203, 103, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[6072, 209, 103, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[6200, 215, 113, 4, 42, "Input"],
Cell[6316, 221, 113, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6466, 228, 112, 4, 42, "Input"],
Cell[6581, 234, 113, 2, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6731, 241, 112, 4, 42, "Input"],
Cell[6846, 247, 113, 2, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7008, 255, 87, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[7120, 261, 101, 1, 27, "Input"],
Cell[7224, 264, 113, 2, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7374, 271, 173, 5, 57, "Input"],
Cell[7550, 278, 203, 4, 69, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7802, 288, 87, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[7914, 294, 99, 1, 27, "Input"],
Cell[8016, 297, 183, 3, 39, "Message"],
Cell[8202, 302, 113, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8352, 309, 170, 5, 57, "Input"],
Cell[8525, 316, 183, 3, 39, "Message"],
Cell[8711, 321, 203, 4, 65, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8963, 331, 87, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[9075, 337, 101, 1, 27, "Input"],
Cell[9179, 340, 113, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9329, 347, 145, 4, 57, "Input"],
Cell[9477, 353, 203, 4, 65, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9729, 363, 87, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[9841, 369, 99, 1, 27, "Input"],
Cell[9943, 372, 191, 3, 55, "Message"],
Cell[10137, 377, 113, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10287, 384, 169, 5, 57, "Input"],
Cell[10459, 391, 191, 3, 55, "Message"],
Cell[10653, 396, 203, 4, 65, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10905, 406, 87, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[11017, 412, 99, 1, 27, "Input"],
Cell[11119, 415, 183, 3, 39, "Message"],
Cell[11305, 420, 113, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11455, 427, 167, 5, 57, "Input"],
Cell[11625, 434, 183, 3, 39, "Message"],
Cell[11811, 439, 203, 4, 65, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12063, 449, 87, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[12175, 455, 113, 4, 42, "Input"],
Cell[12291, 461, 191, 3, 55, "Message"],
Cell[12485, 466, 113, 2, 50, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12635, 473, 143, 4, 42, "Input"],
Cell[12781, 479, 191, 3, 55, "Message"],
Cell[12975, 484, 203, 4, 69, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[13239, 495, 119, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[13383, 501, 512, 13, 207, "Input"],
Cell[13898, 516, 175, 3, 39, "Message"],
Cell[14076, 521, 179, 3, 39, "Message"],
Cell[14258, 526, 179, 3, 39, "Message"],
Cell[14440, 531, 185, 3, 55, "Message"],
Cell[14628, 536, 181, 3, 39, "Message"],
Cell[14812, 541, 161, 3, 39, "Message"],
Cell[14976, 546, 769, 14, 381, "Output"]
}, Open  ]],
Cell[15760, 563, 102, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[15887, 568, 91, 1, 27, "Input"],
Cell[15981, 571, 56, 1, 47, "Output"]
}, Open  ]],
Cell[16052, 575, 102, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[16179, 580, 91, 1, 27, "Input"],
Cell[16273, 583, 56, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16366, 589, 512, 13, 207, "Input"],
Cell[16881, 604, 187, 3, 55, "Message"],
Cell[17071, 609, 175, 3, 39, "Message"],
Cell[17249, 614, 179, 3, 39, "Message"],
Cell[17431, 619, 185, 3, 55, "Message"],
Cell[17619, 624, 179, 3, 39, "Message"],
Cell[17801, 629, 161, 3, 39, "Message"],
Cell[17965, 634, 185, 3, 55, "Message"],
Cell[18153, 639, 160, 3, 39, "Message"],
Cell[18316, 644, 769, 14, 381, "Output"]
}, Open  ]],
Cell[19100, 661, 93, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[19218, 666, 91, 1, 27, "Input"],
Cell[19312, 669, 56, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19405, 675, 512, 13, 207, "Input"],
Cell[19920, 690, 197, 3, 55, "Message"],
Cell[20120, 695, 179, 3, 39, "Message"],
Cell[20302, 700, 185, 3, 55, "Message"],
Cell[20490, 705, 160, 3, 39, "Message"],
Cell[20653, 710, 769, 14, 381, "Output"]
}, Open  ]],
Cell[21437, 727, 103, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[21565, 732, 91, 1, 27, "Input"],
Cell[21659, 735, 56, 1, 47, "Output"]
}, Open  ]],
Cell[21730, 739, 103, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[21858, 744, 91, 1, 27, "Input"],
Cell[21952, 747, 56, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22045, 753, 213, 8, 102, "Input"],
Cell[22261, 763, 188, 3, 55, "Message"],
Cell[22452, 768, 176, 3, 39, "Message"],
Cell[22631, 773, 181, 3, 39, "Message"],
Cell[22815, 778, 188, 3, 55, "Message"],
Cell[23006, 783, 248, 5, 129, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[23303, 794, 82, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[23410, 800, 107, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[23520, 804, 125, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[23670, 812, 117, 4, 42, "Input"],
Cell[23790, 818, 75, 1, 47, "Output"]
}, Open  ]],
Cell[23880, 822, 126, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[24031, 830, 102, 1, 27, "Input"],
Cell[24136, 833, 75, 1, 47, "Output"]
}, Open  ]],
Cell[24226, 837, 137, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[24388, 845, 102, 1, 27, "Input"],
Cell[24493, 848, 75, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[24617, 855, 89, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[24709, 859, 170, 5, 57, "Input"],

Cell[CellGroupData[{
Cell[24904, 868, 102, 1, 27, "Input"],
Cell[25009, 871, 110, 2, 47, "Output"]
}, Open  ]],
Cell[25134, 876, 170, 5, 57, "Input"],

Cell[CellGroupData[{
Cell[25329, 885, 102, 1, 27, "Input"],
Cell[25434, 888, 110, 2, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[25593, 896, 89, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[25685, 900, 171, 5, 57, "Input"],

Cell[CellGroupData[{
Cell[25881, 909, 102, 1, 27, "Input"],
Cell[25986, 912, 110, 2, 47, "Output"]
}, Open  ]],
Cell[26111, 917, 171, 5, 57, "Input"],

Cell[CellGroupData[{
Cell[26307, 926, 102, 1, 27, "Input"],
Cell[26412, 929, 110, 2, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[26571, 937, 89, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[26663, 941, 171, 5, 57, "Input"],

Cell[CellGroupData[{
Cell[26859, 950, 102, 1, 27, "Input"],
Cell[26964, 953, 110, 2, 47, "Output"]
}, Open  ]],
Cell[27089, 958, 171, 5, 57, "Input"],

Cell[CellGroupData[{
Cell[27285, 967, 102, 1, 27, "Input"],
Cell[27390, 970, 110, 2, 47, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[27561, 979, 112, 2, 47, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[27698, 985, 86, 1, 27, "Input"],
Cell[27787, 988, 80, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27904, 994, 86, 1, 27, "Input"],
Cell[27993, 997, 80, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28110, 1003, 86, 1, 27, "Input"],
Cell[28199, 1006, 80, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28316, 1012, 76, 1, 27, "Input"],
Cell[28395, 1015, 69, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28501, 1021, 76, 1, 27, "Input"],
Cell[28580, 1024, 177, 3, 39, "Message"],
Cell[28760, 1029, 69, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[28866, 1035, 76, 1, 27, "Input"],
Cell[28945, 1038, 182, 3, 55, "Message"],
Cell[29130, 1043, 69, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29236, 1049, 713, 11, 181, "Subsection",
  Evaluatable->False],
Cell[29952, 1062, 76, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[30053, 1067, 563, 24, 357, "Input"],
Cell[30619, 1093, 173, 3, 39, "Message"],
Cell[30795, 1098, 174, 3, 39, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31006, 1106, 180, 5, 72, "Input"],
Cell[31189, 1113, 74, 1, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[31312, 1120, 156, 4, 62, "Subsection",
  Evaluatable->False],
Cell[31471, 1126, 73, 1, 27, "Input"],
Cell[31547, 1129, 560, 24, 357, "Input"],

Cell[CellGroupData[{
Cell[32132, 1157, 177, 5, 57, "Input"],
Cell[32312, 1164, 75, 1, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[32436, 1171, 112, 2, 45, "Subsection",
  Evaluatable->False],
Cell[32551, 1175, 95, 1, 27, "Input"],
Cell[32649, 1178, 102, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[32776, 1183, 140, 4, 42, "Input"],
Cell[32919, 1189, 59, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33015, 1195, 95, 1, 27, "Input"],
Cell[33113, 1198, 177, 3, 39, "Message"]
}, Open  ]],
Cell[33305, 1204, 102, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[33432, 1209, 140, 4, 42, "Input"],
Cell[33575, 1215, 59, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33671, 1221, 95, 1, 27, "Input"],
Cell[33769, 1224, 182, 3, 55, "Message"]
}, Open  ]],
Cell[33966, 1230, 102, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[34093, 1235, 140, 4, 42, "Input"],
Cell[34236, 1241, 59, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[34344, 1248, 263, 5, 113, "Subsection",
  Evaluatable->False],
Cell[34610, 1255, 45, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[34680, 1260, 202, 3, 59, "Input"],
Cell[34885, 1265, 175, 3, 39, "Message"]
}, Open  ]],
Cell[35075, 1271, 200, 3, 59, "Input"],
Cell[35278, 1276, 213, 3, 59, "Input"],
Cell[35494, 1281, 213, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[35732, 1288, 128, 4, 42, "Input"],
Cell[35863, 1294, 59, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35959, 1300, 128, 4, 42, "Input"],
Cell[36090, 1306, 59, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[36198, 1313, 263, 5, 113, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[36486, 1322, 45, 1, 27, "Input"],
Cell[36534, 1325, 177, 3, 39, "Message"]
}, Open  ]],
Cell[36726, 1331, 200, 3, 59, "Input"],
Cell[36929, 1336, 200, 3, 59, "Input"],
Cell[37132, 1341, 213, 3, 59, "Input"],
Cell[37348, 1346, 213, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[37586, 1353, 128, 4, 42, "Input"],
Cell[37717, 1359, 59, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37813, 1365, 128, 4, 42, "Input"],
Cell[37944, 1371, 59, 1, 47, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[38052, 1378, 263, 5, 113, "Subsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[38340, 1387, 45, 1, 27, "Input"],
Cell[38388, 1390, 182, 3, 55, "Message"]
}, Open  ]],
Cell[38585, 1396, 200, 3, 59, "Input"],
Cell[38788, 1401, 202, 3, 59, "Input"],
Cell[38993, 1406, 213, 3, 59, "Input"],
Cell[39209, 1411, 215, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[39449, 1418, 128, 4, 42, "Input"],
Cell[39580, 1424, 59, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39676, 1430, 128, 4, 42, "Input"],
Cell[39807, 1436, 59, 1, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[39903, 1442, 111, 2, 42, "Subsubsection",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[40039, 1448, 92, 1, 27, "Input"],
Cell[40134, 1451, 181, 3, 39, "Message"],
Cell[40318, 1456, 181, 3, 39, "Message"],
Cell[40502, 1461, 188, 3, 55, "Message"],
Cell[40693, 1466, 188, 3, 55, "Message"]
}, Open  ]],
Cell[40896, 1472, 145, 3, 43, "Input"],

Cell[CellGroupData[{
Cell[41066, 1479, 59, 1, 27, "Input"],
Cell[41128, 1482, 238, 4, 88, "Output"]
}, Open  ]],
Cell[41381, 1489, 150, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[41556, 1497, 59, 1, 27, "Input"],
Cell[41618, 1500, 238, 4, 97, "Output"]
}, Open  ]],
Cell[41871, 1507, 150, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[42046, 1515, 59, 1, 27, "Input"],
Cell[42108, 1518, 238, 4, 88, "Output"]
}, Open  ]],
Cell[42361, 1525, 148, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[42534, 1533, 59, 1, 27, "Input"],
Cell[42596, 1536, 238, 4, 97, "Output"]
}, Open  ]],
Cell[42849, 1543, 148, 4, 42, "Input"],

Cell[CellGroupData[{
Cell[43022, 1551, 59, 1, 27, "Input"],
Cell[43084, 1554, 238, 4, 88, "Output"]
}, Open  ]],
Cell[43337, 1561, 148, 4, 42, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[43534, 1571, 59, 1, 27, "Input"],
Cell[43596, 1574, 238, 4, 88, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[43871, 1583, 114, 2, 45, "Subsection",
  Evaluatable->False],
Cell[43988, 1587, 79, 1, 27, "Input"],
Cell[44070, 1590, 77, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[44172, 1595, 93, 1, 27, "Input"],
Cell[44268, 1598, 242, 4, 55, "Message"],
Cell[44513, 1604, 244, 4, 55, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[44794, 1613, 130, 3, 42, "Subsubsection",
  Evaluatable->False],
Cell[44927, 1618, 329, 14, 192, "Input"],
Cell[45259, 1634, 107, 5, 57, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[45403, 1644, 102, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[45508, 1648, 84, 1, 27, "Input"],
Cell[45595, 1651, 86, 1, 27, "Input"],
Cell[45684, 1654, 84, 1, 27, "Input"],
Cell[45771, 1657, 86, 1, 27, "Input"],
Cell[45860, 1660, 84, 1, 27, "Input"],
Cell[45947, 1663, 86, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[46070, 1669, 102, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[46175, 1673, 84, 1, 27, "Input"],
Cell[46262, 1676, 86, 1, 27, "Input"],
Cell[46351, 1679, 84, 1, 27, "Input"],
Cell[46438, 1682, 86, 1, 27, "Input"],
Cell[46527, 1685, 84, 1, 27, "Input"],
Cell[46614, 1688, 86, 1, 27, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[46737, 1694, 102, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[46842, 1698, 84, 1, 27, "Input"],
Cell[46929, 1701, 86, 1, 27, "Input"],
Cell[47018, 1704, 84, 1, 27, "Input"],
Cell[47105, 1707, 86, 1, 27, "Input"],
Cell[47194, 1710, 84, 1, 27, "Input"],
Cell[47281, 1713, 86, 1, 27, "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[47416, 1720, 188, 4, 62, "Subsection",
  Evaluatable->False],
Cell[47607, 1726, 3297, 107, 1677, "Input"],

Cell[CellGroupData[{
Cell[50929, 1837, 154, 7, 87, "Input"],
Cell[51086, 1846, 129, 5, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[51252, 1856, 168, 10, 132, "Input"],
Cell[51423, 1868, 253, 8, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[51713, 1881, 170, 10, 132, "Input"],
Cell[51886, 1893, 129, 5, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52052, 1903, 171, 10, 132, "Input"],
Cell[52226, 1915, 1635, 46, 149, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[53898, 1966, 170, 10, 132, "Input"],
Cell[54071, 1978, 1616, 44, 149, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[55724, 2027, 170, 10, 132, "Input"],
Cell[55897, 2039, 253, 8, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[56187, 2052, 170, 10, 132, "Input"],
Cell[56360, 2064, 253, 8, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[56650, 2077, 104, 2, 42, "Subsubsection",
  Evaluatable->False],
Cell[56757, 2081, 279, 8, 102, "Input"],

Cell[CellGroupData[{
Cell[57061, 2093, 244, 9, 117, "Input"],
Cell[57308, 2104, 127, 2, 39, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[57472, 2111, 244, 9, 117, "Input"],
Cell[57719, 2122, 127, 2, 39, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[57883, 2129, 244, 9, 117, "Input"],
Cell[58130, 2140, 127, 2, 39, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[58294, 2147, 244, 9, 117, "Input"],
Cell[58541, 2158, 127, 2, 39, "Message"]
}, Open  ]],
Cell[58683, 2163, 712, 11, 312, "Input"],
Cell[59398, 2176, 765, 12, 312, "Input"],
Cell[60166, 2190, 766, 12, 312, "Input"],
Cell[60935, 2204, 89, 1, 42, "Input"],
Cell[61027, 2207, 158, 3, 57, "Input"],
Cell[61188, 2212, 75, 1, 27, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c     $Id: CG_3D.F,v 1.6 2002/08/29 22:14:39 car Exp $
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>
#include "CG_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
c      
c     CGUPDATE: Modify the input arrays as follows:
c     
c     phi = phi + a*pp
c     rr  = rr  - a*ww    through range lo:hi
c     
c     phi <=>
c     rr  <=>
c     a   <=
c     ww  <=
c     pp  <=
c     
c-----------------------------------------------------------------------
      subroutine FORT_CGUPDATE(
     $     phi, DIMS(phi),
     $     rr,  DIMS(rr),
     $     a,
     $     ww,  DIMS(ww),
     $     pp,  DIMS(pp),
     $     lo, hi, nc
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(rr)
      REAL_T rr(DIMV(rr),nc)
      integer DIMDEC(ww)
      REAL_T ww(DIMV(ww),nc)
      integer DIMDEC(pp)
      REAL_T pp(DIMV(pp),nc)
      integer DIMDEC(phi)
      REAL_T phi(DIMV(phi),nc)
      REAL_T a
c ::: wyc change -- why was a a vector?
c     REAL_T a(nc)
c
      integer i,j,k,n
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  phi(i,j,k,n) = phi(i,j,k,n) + a * pp(i,j,k,n)
                  rr(i,j,k,n) = rr(i,j,k,n) - a * ww(i,j,k,n)
c ::: wyc change -- why was a a vector?
c                 phi(i,j,k,n) = phi(i,j,k,n) + a(n) * pp(i,j,k,n)
c                 rr(i,j,k,n) = rr(i,j,k,n) - a(n) * ww(i,j,k,n)
               end do
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
c      
c     CGADVCP: Modify the input arrays as follows:
c     
c     pp = rr + b*pp    through range lo:hi
c     
c     pp  <=>
c     rr  <=>
c     b   <=
c     
c-----------------------------------------------------------------------
      subroutine FORT_CGADVCP(
     $     pp, DIMS(pp),
     $     rr, DIMS(rr),
     $     b,
     $     lo, hi, nc
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(rr)
      REAL_T rr(DIMV(rr),nc)
      integer DIMDEC(pp)
      REAL_T pp(DIMV(pp),nc)
      REAL_T b
c ::: wyc change
c     REAL_T b(nc)
c
c
      integer i,j,k,n
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  pp(i,j,k,n) = rr(i,j,k,n) + b*pp(i,j,k,n)
c                 pp(i,j,k,n) = rr(i,j,k,n) + b(n)*pp(i,j,k,n)
               end do
            end do
         end do
      end do
c
      end
      
c-----------------------------------------------------------------------
c      
c     CGAXP: Modify the input as follows:
c     
c     pw = Transpose(pp) . ww    through range lo:hi
c     
c     pw   =>
c     pp  <=
c     ww  <=
c     
c-----------------------------------------------------------------------
      subroutine FORT_CGXDOTY(
     $     pw,
     $     pp, DIMS(pp),
     $     ww, DIMS(ww),
     $     lo, hi, nc
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(ww)
      REAL_T ww(DIMV(ww),nc)
      integer DIMDEC(pp)
      REAL_T pp(DIMV(pp),nc)
      REAL_T pw
c
      integer i, j, k, n
c
      pw = 0.0D0
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  pw = pw + pp(i,j,k,n)*ww(i,j,k,n)
               end do
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_CGSXAY(
     $     ss, DIMS(ss),
     $     xx, DIMS(xx),
     $     a,
     $     yy, DIMS(yy),
     $     lo, hi, nc
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(ss)
      REAL_T ss(DIMV(ss),nc)
      integer DIMDEC(xx)
      REAL_T xx(DIMV(xx),nc)
      integer DIMDEC(yy)
      REAL_T yy(DIMV(yy),nc)
      REAL_T a
c
      integer i, j, k, n
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  ss(i,j,k,n) = xx(i,j,k,n) + a*yy(i,j,k,n)
               end do
            end do
         end do
      end do
c
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: MACPROJ_3D.F,v 1.6 2000/06/02 17:25:51 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "MACPROJ_F.H"
#include "ArrayLim.H"

#define SDIM 3

c :: ----------------------------------------------------------
c :: MACDIV:  compute the MAC divergence in generalized coordinates
c ::
c :: INPUTS / OUTPUTS:
c ::  dmac        <=  MAC divergence (cell centered)
c ::  DIMS(dmac)   => index limits for dmac
c ::  lo,hi        => index limits of grid interior
c ::  ux           => X edge velocity
c ::  DIMS(ux)     => index limits for ux
c ::  uy           => Y edge velocity
c ::  DIMS(uy)     => index limits for uy
c ::  uz           => Y edge velocity
c ::  DIMS(uz)     => index limits for uz
c ::  xarea        => area of cell faces in X dircetion
c ::  DIMS(ax)     => index limits for xarea
c ::  yarea        => area of cell faces in Y dircetion
c ::  DIMS(ay)     => index limits for yarea
c ::  zarea        => area of cell faces in Z dircetion
c ::  DIMS(az)     => index limits for zarea
c ::  vol          => cell volume
c ::  DIMS(vol)    => index limits for vol
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACDIV (dmac,DIMS(dmac),lo,hi,
     &                         ux,DIMS(ux),uy,DIMS(uy),uz,DIMS(uz),
     &                         xarea,DIMS(ax),yarea,DIMS(ay),
     &                         zarea,DIMS(az),vol,DIMS(vol))

       integer DIMDEC(dmac)
       integer lo(SDIM), hi(SDIM)
       integer DIMDEC(ux)
       integer DIMDEC(uy)
       integer DIMDEC(uz)
       integer DIMDEC(ax)
       integer DIMDEC(ay)
       integer DIMDEC(az)
       integer DIMDEC(vol)
       REAL_T  dmac(DIMV(dmac))
       REAL_T    ux(DIMV(ux))
       REAL_T    uy(DIMV(uy))
       REAL_T    uz(DIMV(uz))
       REAL_T xarea(DIMV(ax))
       REAL_T yarea(DIMV(ay))
       REAL_T zarea(DIMV(az))
       REAL_T   vol(DIMV(vol))

       integer i, j, k

       do k = lo(3), hi(3)
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                dmac(i,j,k) = ( xarea(i+1,j,k)*ux(i+1,j,k) - xarea(i,j,k)*ux(i,j,k)
     &               +     yarea(i,j+1,k)*uy(i,j+1,k) - yarea(i,j,k)*uy(i,j,k)
     &               +     zarea(i,j,k+1)*uz(i,j,k+1) - zarea(i,j,k)*uz(i,j,k)
     &               )/vol(i,j,k)
             end do
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: UCORUPDT
c ::          Snew = Snew + mult*Sold*dmac
c ::
c :: INPUTS / OUTPUTS:
c ::  snew        <=  state vector at new time
c ::  sold         => state vector at old time
c ::  DIMS(s)      => index limits for sold and snew
c ::  lo,hi        => index limits of grid interior
c ::  nvar         => number of components in state vector
c ::  dmac         => MAC divergence of Ucorr
c ::  DIMS(dmac)   => index limits for dmac
c ::  mult         => scalar multiplier
c :: ----------------------------------------------------------
c ::
       subroutine FORT_UCORUPDT (snew,sold,DIMS(s),nvar,lo,hi,
     &                           dmac,DIMS(dmac),mult)

       integer DIMDEC(s)
       integer lo(SDIM), hi(SDIM)
       integer DIMDEC(dmac)
       integer nvar
       REAL_T  mult
       REAL_T  snew(DIMV(s),nvar)
       REAL_T  sold(DIMV(s),nvar)
       REAL_T  dmac(DIMV(dmac))

       integer i, j, k, n


       do n = 1, nvar
          do k = lo(3), hi(3)
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   snew(i,j,k,n) = snew(i,j,k,n) + mult*dmac(i,j,k)*sold(i,j,k,n)
                end do
             end do
          end do
       end do

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: COORDSYS_3D.F,v 1.8 2002/11/14 23:04:56 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "COORDSYS_F.H"
#include "ArrayLim.H"

#define SDIM 3

c :: ----------------------------------------------------------
c :: SETVOL
c ::             Compute the volume of each cell
c ::
c :: INPUTS / OUTPUTS:
c ::  vol         <=  volume array
c ::  vlo,vhi      => index limits of vol array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 = cartesian, 1 = RZ)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETVOL(vol,DIMS(vol),offset,dx,coord)
       integer    DIMDEC(vol)
       integer    coord
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     vol(DIMV(vol))
       
       integer    i, j, k
       REAL_T     ri, ro, v
       
       if (coord .eq. 0) then
c
c         ::::: cartesian
c
          v = dx(1)*dx(2)*dx(3)
          do k = ARG_L3(vol), ARG_H3(vol)
             do j = ARG_L2(vol), ARG_H2(vol)
                do i = ARG_L1(vol), ARG_H1(vol)
                   vol(i,j,k) = v
                end do
             end do
          end do
       else
          write(6,*) "FORT_SETVOLUME not define for coord = ",coord
          call bl_abort(" ")
       end if
       
       end

c :: ----------------------------------------------------------
c :: SETAREA
c ::             Compute the area of given cell face
c ::
c :: INPUTS / OUTPUTS:
c ::  area        <=  area array
c ::  alo,ahi      => index limits of area array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 =cartesian, 1 = RZ)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETAREA(area,DIMS(area),offset,dx,dir,coord)
       integer    DIMDEC(area)
       integer    coord, dir
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     area(DIMV(area))
       
       integer    i, j, k
       REAL_T     fa
       
       if (coord .eq. 0) then
          if (dir .eq. 0) then
             fa = dx(2)*dx(3)
          else if (dir .eq. 1) then
             fa = dx(1)*dx(3)
          else if (dir .eq. 2) then
             fa = dx(1)*dx(2)
          else
             write(6,*) "FORT_SETAREA: invalid dir = ",dir
             call bl_abort(" ")
          end if
          do k = ARG_L3(area), ARG_H3(area)
             do j = ARG_L2(area), ARG_H2(area)
                do i = ARG_L1(area), ARG_H1(area)
                   area(i,j,k) = fa
                end do
             end do
          end do
       else
          write(6,*) "FORT_SETAREA not define for coord = ",coord
          call bl_abort(" ")
       end if
       
       end

c :: SETDLOGA
c ::             Compute  d(log(A))/dr in each cell
c ::
c :: INPUTS / OUTPUTS:
c ::  dloga        <=  dloga array
c ::  dlo,dhi      => index limits of dloga array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 = cartesian, 1 = RZ)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETDLOGA(dloga,DIMS(dloga),offset,dx,dir,coord)

       integer    DIMDEC(dloga)
       integer    coord
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     dloga(DIMV(dloga))
       integer dir
       
       integer    i, j, k
       REAL_T     ri, ro, dlga, po, pi
       
       if (coord .eq. 0) then
c
c         ::::: cartesian
c
          do k = ARG_L3(dloga), ARG_H3(dloga)
          do j = ARG_L2(dloga), ARG_H2(dloga)
             do i = ARG_L1(dloga), ARG_H1(dloga)
                dloga(i,j,k) = zero
             end do
          end do
	  enddo

       else 
	 write(6,*)' non-cartesian not allowed in 3D yet'
	call bl_abort(" ")

	endif

	return
	end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: MAKESLICE_3D.F,v 1.7 1998/11/03 18:16:38 lijewski Exp $
c

#undef  BL_LANG_CC         
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "ArrayLim.H"
#include "REAL.H"
#include "CONSTANTS.H"
#include "MAKESLICE_F.H"

#define SDIM 3       
#define npart 20

      subroutine FORT_MAKEMASKSLICE(data1,DIMS(data1),
     &  data2,DIMS(data2),data_min,data_max,slice_val,slice,dx)
      
      integer DIMDEC(data1)
      integer DIMDEC(data2)
      integer data1(DIMV(data1))
      integer data2(DIMV(data2))
      REAL_T dx(SDIM)
      REAL_T data_min,data_max,slice_val
      integer slice

      integer dlo1(SDIM), dhi1(SDIM)
      integer dlo2(SDIM), dhi2(SDIM)
      integer index,idx1,idx2,found,i,j,k,kval,kval1,kval2
      integer leftval,rightval
      REAL_T zval,tval,floatdata

      dlo1(1) = ARG_L1(data1)
      dlo1(2) = ARG_L2(data1)
      dlo1(3) = ARG_L3(data1)
      dhi1(1) = ARG_H1(data1)
      dhi1(2) = ARG_H2(data1)
      dhi1(3) = ARG_H3(data1)
      dlo2(1) = ARG_L1(data2)
      dlo2(2) = ARG_L2(data2)
      dlo2(3) = ARG_L3(data2)
      dhi2(1) = ARG_H1(data2)
      dhi2(2) = ARG_H2(data2)
      dhi2(3) = ARG_H3(data2)

      if ((dlo2(3).ne.0).or.(dhi2(3).ne.0)) then
         write (6,*) "second data must be thin!"
      end if

      if (slice.eq.0) then
         idx1=1
         idx2=2
         index=3
      else if (slice.eq.1) then
         idx1=1
         idx2=3
         index=2
      else
         idx1=2
         idx2=3
         index=1
      end if

      if ( (dlo1(idx1).ne.dlo2(1)).or.(dlo1(idx2).ne.dlo2(2)).or.
     &     (dhi1(idx1).ne.dhi2(1)).or.(dhi1(idx2).ne.dhi2(2)) ) then
         write (6,*) "thin data must jive with 3d data!"
      end if

      found=0
      do k=dlo1(index)-1,dhi1(index)
         zval=(k+half)*dx(index)
         if ((slice_val.ge.zval).and.(slice_val.le.zval+dx(index)).and.
     &        (found.eq.0)) then
            found=1
            kval=k 
         end if
      end do
      if (found.eq.0) then
         write (6,*) "slice data out of range!"
      end if
      kval1=kval
      kval2=kval+1
      if (kval1.lt.dlo1(index)) then
         kval1=kval2
      end if
      if (kval2.gt.dhi1(index)) then
         kval2=kval1
      end if

      do i=dlo1(idx1),dhi1(idx1)
         do j=dlo1(idx2),dhi1(idx2)
            zval=(kval+half)*dx(index)
            if (slice.eq.0) then
               leftval=data1(i,j,kval1)
               rightval=data1(i,j,kval2)
            else if (slice.eq.1) then
               leftval=data1(i,kval1,j)
               rightval=data1(i,kval2,j)
            else if (slice.eq.2) then
               leftval=data1(kval1,i,j)
               rightval=data1(kval2,i,j)
            end if
            tval=(slice_val-zval)/dx(index)
            floatdata=leftval*(one-tval)+rightval*tval
            
            if (floatdata.gt.zero) then
               data2(i,j,0)=1
            else
               data2(i,j,0)=0
            end if
         end do
      end do

      end

      subroutine FORT_MAKESLICE(data1,DIMS(data1),
     &  data2,DIMS(data2),data_min,data_max,slice_val,
     &  slice,dx)

      integer DIMDEC(data1)
      integer DIMDEC(data2)
      REAL_T data1(DIMV(data1))
      REAL_T data2(DIMV(data2))
      REAL_T dx(SDIM)
      REAL_T data_min,data_max,slice_val
      integer slice

      integer index,idx1,idx2,found,i,j,k,kval,kval1,kval2
      REAL_T zval,leftval,rightval,tval

      integer dlo1(SDIM),dhi1(SDIM)
      integer dlo2(SDIM),dhi2(SDIM)

      dlo1(1) = ARG_L1(data1)
      dlo1(2) = ARG_L2(data1)
      dlo1(3) = ARG_L3(data1)
      dhi1(1) = ARG_H1(data1)
      dhi1(2) = ARG_H2(data1)
      dhi1(3) = ARG_H3(data1)
      dlo2(1) = ARG_L1(data2)
      dlo2(2) = ARG_L2(data2)
      dlo2(3) = ARG_L3(data2)
      dhi2(1) = ARG_H1(data2)
      dhi2(2) = ARG_H2(data2)
      dhi2(3) = ARG_H3(data2)

      if ((dlo2(3).ne.0).or.(dhi2(3).ne.0)) then
         write (6,*) "second data must be thin!"
      end if

      if (slice.eq.0) then
         idx1=1
         idx2=2
         index=3
      else if (slice.eq.1) then
         idx1=1
         idx2=3
         index=2
      else
         idx1=2
         idx2=3
         index=1
      end if

      if ( (dlo1(idx1).ne.dlo2(1)).or.(dlo1(idx2).ne.dlo2(2)).or.
     &     (dhi1(idx1).ne.dhi2(1)).or.(dhi1(idx2).ne.dhi2(2)) ) then
         write (6,*) "thin data must jive with 3d data!"
      end if

      found=0
      do k=dlo1(index)-1,dhi1(index)
         zval=(k+half)*dx(index)
         if ((slice_val.ge.zval).and.(slice_val.le.zval+dx(index)).and.
     &        (found.eq.0)) then
            found=1
            kval=k 
         end if
      end do
      if (found.eq.0) then
         write (6,*) "slice data out of range!"
      end if
      kval1=kval
      kval2=kval+1
      if (kval1.lt.dlo1(index)) then
         kval1=kval2
      end if
      if (kval2.gt.dhi1(index)) then
         kval2=kval1
      end if

      do i=dlo1(idx1),dhi1(idx1)
         do j=dlo1(idx2),dhi1(idx2)
            zval=(kval+half)*dx(index)
            if (slice.eq.0) then
               leftval=data1(i,j,kval1)
               rightval=data1(i,j,kval2)
            else if (slice.eq.1) then
               leftval=data1(i,kval1,j)
               rightval=data1(i,kval2,j)
            else if (slice.eq.2) then
               leftval=data1(kval1,i,j)
               rightval=data1(kval2,i,j)
            end if
            tval=(slice_val-zval)/dx(index)
            data2(i,j,0)=leftval*(one-tval)+rightval*tval
         end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: LO_3D.F,v 1.4 2002/11/27 21:54:35 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>
#include <CONSTANTS.H>
#include "LO_BCTYPES.H"
#include "LO_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
      subroutine FORT_RESIDL (
     $     res, DIMS(res), 
     $     rhs, DIMS(rhs),
     $     phi, DIMS(phi),
     $     lo, hi, nc
     $     )
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(phi)
      REAL_T phi(DIMV(phi),nc)
      integer DIMDEC(rhs)
      REAL_T rhs(DIMV(rhs),nc)
      integer DIMDEC(res)
      REAL_T res(DIMV(res),nc)
c
      integer i
      integer j
      integer k
      integer n
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  res(i,j,k,n) = rhs(i,j,k,n) - phi(i,j,k,n)
               end do
            end do
         end do
      end do
c     
      end
c-----------------------------------------------------------------------
      subroutine FORT_HARMONIC_AVERAGEEC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc,
     $     cdir
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer cdir
      integer DIMDEC(f)
      REAL_T f(DIMV(f),nc)
      integer DIMDEC(c)
      REAL_T c(DIMV(c),nc)
c
      REAL_T  factor
      parameter(factor=four)

      integer n
      integer i
      integer j
      integer k
c
      if ( cdir .eq. 0 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)+1
c                  
                     c(i,j,k,n) = factor/(
     $                    + 1.0D0/f(2*i,2*j  ,2*k  ,n)
     $                    + 1.0D0/f(2*i,2*j+1,2*k  ,n)
     $                    + 1.0D0/f(2*i,2*j  ,2*k+1,n)
     $                    + 1.0D0/f(2*i,2*j+1,2*k+1,n) )
c                     
                  end do
               end do
            end do
         end do
      else if (cdir .eq. 1 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)+1
                  do i = lo(1), hi(1)
c
                     c(i,j,k,n) = factor/(
     $                    + 1.0D0/f(2*i  ,2*j,2*k  ,n)
     $                    + 1.0D0/f(2*i+1,2*j,2*k  ,n)
     $                    + 1.0D0/f(2*i  ,2*j,2*k+1,n)
     $                    + 1.0D0/f(2*i+1,2*j,2*k+1,n) )
c                     
                  end do
               end do
            end do
         end do
      else if (cdir .eq. 2 ) then
         do n = 1, nc
            do k = lo(3), hi(3)+1
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
c                     
                     c(i,j,k,n) = factor/(
     $                    + 1.0D0/f(2*i  ,2*j  ,2*k,n)
     $                    + 1.0D0/f(2*i+1,2*j  ,2*k,n)
     $                    + 1.0D0/f(2*i  ,2*j+1,2*k,n)
     $                    + 1.0D0/f(2*i+1,2*j+1,2*k,n) )
c                     
                  end do
               end do
            end do
         end do
      end if
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_AVERAGEEC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc,
     $     cdir
     $     )
c
      integer nc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer cdir
      integer DIMDEC(f)
      REAL_T f(DIMV(f),nc)
      integer DIMDEC(c)
      REAL_T c(DIMV(c),nc)
c     
      integer n
      integer i
      integer j
      integer k
      REAL_T factor
      parameter(factor = fourth)
c     
      if ( cdir .eq. 0 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)+1
c     
                     c(i,j,k,n) = factor*(
     $                    + f(2*i,2*j  ,2*k  ,n)
     $                    + f(2*i,2*j+1,2*k  ,n)
     $                    + f(2*i,2*j  ,2*k+1,n)
     $                    + f(2*i,2*j+1,2*k+1,n) )
c                     
                  end do
               end do
            end do
         end do
      else if (cdir .eq. 1 ) then
         do n = 1, nc
            do k = lo(3), hi(3)
               do j = lo(2), hi(2)+1
                  do i = lo(1), hi(1)
c                     
                     c(i,j,k,n) = factor*(
     $                    + f(2*i  ,2*j,2*k  ,n)
     $                    + f(2*i+1,2*j,2*k  ,n)
     $                    + f(2*i  ,2*j,2*k+1,n)
     $                    + f(2*i+1,2*j,2*k+1,n) )
c                     
                  end do
               end do
            end do
         end do
      else if (cdir .eq. 2 ) then
         do n = 1, nc
            do k = lo(3), hi(3)+1
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
c     
                     c(i,j,k,n) = factor*(
     $                    + f(2*i  ,2*j  ,2*k,n)
     $                    + f(2*i+1,2*j  ,2*k,n)
     $                    + f(2*i  ,2*j+1,2*k,n)
     $                    + f(2*i+1,2*j+1,2*k,n) )
c                     
                  end do
               end do
            end do
         end do
      end if
c     
      end
c-----------------------------------------------------------------------
      subroutine FORT_AVERAGECC (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc
     $     )
c
      integer nc
      integer DIMDEC(f)
      integer DIMDEC(c)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i
      integer j
      integer k
      integer n
      REAL_T factor
      parameter(factor=eighth)
c
      do n = 1, nc
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
c                  
                  c(i,j,k,n) =  factor*(
     $                 + f(2*i+1,2*j+1,2*k  ,n)
     $                 + f(2*i  ,2*j+1,2*k  ,n)
     $                 + f(2*i+1,2*j  ,2*k  ,n)
     $                 + f(2*i  ,2*j  ,2*k  ,n)
     $                 + f(2*i+1,2*j+1,2*k+1,n)
     $                 + f(2*i  ,2*j+1,2*k+1,n)
     $                 + f(2*i+1,2*j  ,2*k+1,n)
     $                 + f(2*i  ,2*j  ,2*k+1,n) )
c                     
               end do
            end do
         end do
      end do
c     
      end
c-----------------------------------------------------------------------
      subroutine FORT_APPLYBC (
     $     flagden, flagbc, maxorder,
     $     phi, DIMS(phi),
     $     cdir, bct, bcl,
     $     bcval, DIMS(bcval),
     $     mask, DIMS(mask),
     $     den, DIMS(den),
     $     lo, hi, nc,
     $     h
     $     )
c
c     If the boundary is of Neumann type, set the ghost cell value to
c     that of the outermost point in the valid data (2nd order accurate)
c     and then fill the "den" array with the value "1"
c     
c     
c     If flagbc==1:
c     
c     If the boundary is of Dirichlet type, construct a polynomial
c     interpolation through the boundary location and internal points
c     (at locations x(-1:len-2) that generates the ghost cell value (at
c     location xInt).  Then fill the ghost cell with the interpolated value.
c     If flagden==1, load the "den" array with the interpolation
c     coefficient corresponding to outermost point in the valid region
c     ( the coef(0) corresponding to the location x(0) )
c
c     Note: 
c     The bc type = LO_REFLECT_ODD is a special type of dirichlet condition,
c     in that we want a "zeroth" order interpolant to fill the ghost cell.
c     If this were treated in the normal way, then ALL boundaries would be
c     low order.
c      
      integer maxorder
      integer nc, cdir, flagden, flagbc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(phi)
      REAL_T phi(DIMV(phi),nc)
      integer DIMDEC(den)
      REAL_T den(DIMV(den))
      integer DIMDEC(bcval)
      REAL_T bcval(DIMV(bcval),nc)
      integer DIMDEC(mask)
      integer mask(DIMV(mask))
      integer bct
      REAL_T bcl
      REAL_T h(BL_SPACEDIM)
c
      integer i
      integer j
      integer k
      integer n
      logical is_dirichlet
      logical is_neumann
      logical is_odd
      REAL_T xb
c
      integer lenx
      integer leny
      integer lenz
      integer m
c
      integer Lmaxorder
      integer maxmaxorder
      parameter(maxmaxorder=4)
      REAL_T x(-1:maxmaxorder-2)
      REAL_T coef(-1:maxmaxorder-2)
      REAL_T xInt
c
      is_dirichlet(i) = ( i .eq. LO_DIRICHLET )
      is_neumann(i) = (i .eq. LO_NEUMANN)
c
      if ( maxorder .eq. -1 ) then
         Lmaxorder = maxmaxorder
      else
         Lmaxorder = MIN(maxorder,maxmaxorder)
      end if
      lenx = MIN(hi(1)-lo(1), Lmaxorder-2)
      leny = MIN(hi(2)-lo(2), Lmaxorder-2)
      lenz = MIN(hi(3)-lo(3), Lmaxorder-2)
c
c     TODO:
c     In order for this to work with growing multigrid, must
c     sort xa[] because it is possible for the xb value to lay
c     within this range.

c     
c     The Left face of the grid
c
      if(cdir .eq. 0) then
         if (is_neumann(bct)) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     phi(lo(1)-1,j,k,n) = cvmgt(
     $                    phi(lo(1),j,k,n),
     $                    phi(lo(1)-1,j,k,n),
     $                    mask(lo(1)-1,j,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     den(lo(1),j,k) = 1.0D0
                  end do
               end do
            end if
         else if (is_dirichlet(bct)) then
            do m=0,lenx
               x(m) = m + 0.5D0
            end do
            x(-1) = - bcl/h(1)
            xInt = - 0.5D0
            call polyInterpCoeff(xInt, x, lenx+2, coef)
            do n = 1, nc
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        phi(lo(1)-1, j, k, n) = cvmgt(
     $                       bcval(lo(1)-1,j,k,n)*coef(-1),
     $                       phi(lo(1)-1, j,k, n),
     $                       mask(lo(1)-1,j,k) .gt. 0)
                     end do
                  end do
               else
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        phi(lo(1)-1, j, k, n) = cvmgt(
     $                       0.0D0,
     $                       phi(lo(1)-1, j, k, n),
     $                       mask(lo(1)-1,j, k) .gt. 0)
                     end do
                  end do
               end if
               do m = 0, lenx
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        phi(lo(1)-1,j,k,n) = cvmgt(
     $                       phi(lo(1)-1,j,k,n)
     $                       + phi(lo(1)+m, j, k, n)*coef(m),
     $                       phi(lo(1)-1,j,k,n),
     $                       mask(lo(1)-1,j,k) .gt. 0)
                     end do
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     den(lo(1),j,k) = cvmgt(coef(0), 0.0D0,
     $                    mask(lo(1)-1,j,k) .gt. 0)
                  end do
               end do
            end if
         else if ( bct .eq. LO_REFLECT_ODD ) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     phi(lo(1)-1, j, k, n) = cvmgt(
     $                   -phi(lo(1),j,k,n),
     $                    phi(lo(1)-1,j,k,n),
     $                    mask(lo(1)-1,j,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     den(lo(1),j,k) = cvmgt(-1.0D0, 0.0D0,
     $                    mask(lo(1)-1,j,k) .gt. 0)
                  end do
               end do
            end if
         else
            print *,'UNKNOWN BC ON LEFT FACE IN APPLYBC'
            call bl_error("stop")
         end if
      end if
c
c     The Right face of the grid
c
      if(cdir .eq. 3) then
         if(is_neumann(bct)) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     phi(hi(1)+1,j,k,n) = cvmgt(
     $                    phi(hi(1), j, k, n),
     $                    phi(hi(1)+1, j, k, n),
     $                    mask(hi(1)+1,j,k) .gt. 0)
                  end do
               end do
            end do
	    if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     den(hi(1),j,k) = 1.0D0
                  end do
               end do
	    end if
         else if (is_dirichlet(bct)) then
            do m=0,lenx
               x(m) = m + 0.5D0
            end do
            x(-1) = - bcl/h(1)
            xInt = - 0.5D0
            call polyInterpCoeff(xInt, x, lenx+2, coef)
            do n = 1, nc
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        phi(hi(1)+1,j,k,n) = cvmgt(
     $                       bcval(hi(1)+1,j,k,n)*coef(-1),
     $                       phi(hi(1)+1,j,k,n),
     $                       mask(hi(1)+1,j,k) .gt. 0)
                     end do
                  end do
               else
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        phi(hi(1)+1,j,k,n) = cvmgt(
     $                       0.0D0,
     $                       phi(hi(1)+1,j,k,n),
     $                       mask(hi(1)+1,j,k) .gt. 0)
                     end do
                  end do
               end if
               do m = 0, lenx
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        phi(hi(1)+1,j,k,n) = cvmgt(
     $                       phi(hi(1)+1,j,k,n)
     $                       + phi(hi(1)-m,j,k,n)*coef(m),
     $                       phi(hi(1)+1,j,k,n),
     $                       mask(hi(1)+1,j,k) .gt. 0)
                     end do
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     den(hi(1),j,k)   = cvmgt(coef(0), 0.0D0,
     $                    mask(hi(1)+1,j,k) .gt. 0)
                  end do
               end do
            end if
         else if ( bct .eq. LO_REFLECT_ODD ) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     phi(hi(1)+1, j, k, n) = cvmgt(
     $                   -phi(hi(1),j,k,n),
     $                    phi(hi(1)+1,j,k,n),
     $                    mask(hi(1)+1,j,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     den(hi(1),j,k) = cvmgt(-1.0D0, 0.0D0,
     $                    mask(hi(1)+1,j,k) .gt. 0)
                  end do
               end do
            end if
         else
            print *,'UNKNOWN BC ON RIGHT FACE IN APPLYBC'
            call bl_error("stop")
         end if
      end if
c
c     The Bottom of the Grid
c
      if(cdir .eq. 1) then
         if(is_neumann(bct)) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do i = lo(1),hi(1)
                     phi(i,lo(2)-1,k,n) = cvmgt(
     $                    phi(i,lo(2),k,n),
     $                    phi(i,lo(2)-1,k,n),
     $                    mask(i,lo(2)-1,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do i = lo(1),hi(1)
                     den(i,lo(2),k)   = 1.0D0
                  end do
               end do
            end if
         else if (is_dirichlet(bct)) then
            do m=0,leny
               x(m) = m + 0.5D0
            end do
            x(-1) = - bcl/h(2)
            xInt = - 0.5D0
            call polyInterpCoeff(xInt, x, leny+2, coef)
            do n = 1, nc
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        phi(i,lo(2)-1,k,n) = cvmgt(
     $                       bcval(i,lo(2)-1,k,n)*coef(-1),
     $                       phi(i,lo(2)-1,k,n),
     $                       mask(i,lo(2)-1,k) .gt. 0)
                     end do
                  end do
               else
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        phi(i,lo(2)-1,k,n) = cvmgt(
     $                       0.0D0,
     $                       phi(i,lo(2)-1,k,n),
     $                       mask(i,lo(2)-1,k) .gt. 0)
                     end do
                  end do
               end if
               do m = 0, leny
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        phi(i, lo(2)-1, k, n) = cvmgt(
     $                       phi(i, lo(2)-1,k,n)
     $                       + phi(i, lo(2)+m, k,n)*coef(m),
     $                       phi(i, lo(2)-1, k, n),
     $                       mask(i, lo(2)-1, k) .gt. 0)
                     end do
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     den(i, lo(2),k)   = cvmgt(coef(0), 0.0D0,
     $                    mask(i, lo(2)-1,k) .gt. 0)
                  end do
               end do
            end if
         else if ( bct .eq. LO_REFLECT_ODD ) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     phi(i, lo(2)-1, k, n) = cvmgt(
     $                   -phi(i,lo(2),k,n),
     $                    phi(i,lo(2)-1,k,n),
     $                    mask(i,lo(2)-1,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     den(i,lo(2),k) = cvmgt(-1.0D0, 0.0D0,
     $                    mask(i,lo(2)-1,k) .gt. 0)
                  end do
               end do
            end if
         else
            print *,'UNKNOWN BC ON BOTTOM FACE IN APPLYBC'
            call bl_error("stop")
         end if
      end if
c
c     The top of the grid
c
      if (cdir .eq. 4) then
         if(is_neumann(bct)) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     phi(i,hi(2)+1,k,n) = cvmgt(
     $                    phi(i,hi(2),k,n),
     $                    phi(i,hi(2)+1,k,n),
     $                    mask(i,hi(2)+1,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     den(i,hi(2),k)   = 1.0D0
                  end do
               end do
            end if
         else if (is_dirichlet(bct)) then
            do m=0,leny
               x(m) = m + 0.5D0
            end do
            x(-1) = - bcl/h(2)
            xInt = - 0.5D0
            call polyInterpCoeff(xInt, x, leny+2, coef)
            do n = 1, nc
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        phi(i,hi(2)+1,k,n) = cvmgt(
     $                       bcval(i,hi(2)+1,k,n)*coef(-1),
     $                       phi(i,hi(2)+1,k,n),
     $                       mask(i,hi(2)+1,k) .gt. 0)
                     end do
                  end do
               else
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        phi(i,hi(2)+1,k,n) = cvmgt(
     $                       0.0D0,
     $                       phi(i,hi(2)+1,k,n),
     $                       mask(i,hi(2)+1,k) .gt. 0)
                     end do
                  end do
               end if
               do m = 0, leny
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        phi(i, hi(2)+1,k,n) = cvmgt(
     $                       phi(i,hi(2)+1,k,n)
     $                       + phi(i, hi(2)-m,k,n)*coef(m),
     $                       phi(i,hi(2)+1,k,n),
     $                       mask(i,hi(2)+1,k) .gt. 0)
                     end do
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     den(i,hi(2),k)   = cvmgt(coef(0), 0.0D0,
     $                    mask(i,hi(2)+1,k) .gt. 0)
                  end do
               end do
            end if
         else if ( bct .eq. LO_REFLECT_ODD ) then
            do n = 1, nc
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     phi(i, hi(2)+1, k, n) = cvmgt(
     $                   -phi(i,hi(2),k,n),
     $                    phi(i,hi(2)+1,k,n),
     $                    mask(i,hi(2)+1,k) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     den(i,hi(2),k) = cvmgt(-1.0D0, 0.0D0,
     $                    mask(i,hi(2)+1,k) .gt. 0)
                  end do
               end do
            end if
         else
            print *,'UNKNOWN BC ON TOP FACE IN APPLYBC'
            call bl_error("stop")
         end if
      end if
c
c     The Front of the Grid
c
      if(cdir .eq. 2) then
         if(is_neumann(bct)) then
            do n = 1, nc
               do j = lo(2), hi(2)
                  do i = lo(1),hi(1)
                     phi(i,j,lo(3)-1,n) = cvmgt(
     $                    phi(i,j,lo(3),n),
     $                    phi(i,j,lo(3)-1,n),
     $                    mask(i,j,lo(3)-1) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do j = lo(2), hi(2)
                  do i = lo(1),hi(1)
                     den(i,j,lo(3))   = 1.0D0
                  end do
               end do
            end if
         else if (is_dirichlet(bct)) then
            do m=0,lenz
               x(m) = m + 0.5D0
            end do
            x(-1) = - bcl/h(3)
            xInt = - 0.5D0
            call polyInterpCoeff(xInt, x, lenz+2, coef)
            do n = 1, nc
               if ( flagbc .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        phi(i,j,lo(3)-1,n) = cvmgt(
     $                       bcval(i,j,lo(3)-1,n)*coef(-1),
     $                       phi(i,j,lo(3)-1,n),
     $                       mask(i,j,lo(3)-1) .gt. 0)
                     end do
                  end do
               else
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        phi(i,j,lo(3)-1,n) = cvmgt(
     $                       0.0D0,
     $                       phi(i,j,lo(3)-1,n),
     $                       mask(i,j,lo(3)-1) .gt. 0)
                     end do
                  end do
               end if
               do m = 0, lenz
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        phi(i, j, lo(3)-1, n) = cvmgt(
     $                       phi(i, j, lo(3)-1,n)
     $                       + phi(i, j, lo(3)+m, n)*coef(m),
     $                       phi(i, j, lo(3)-1,n),
     $                       mask(i, j, lo(3)-1) .gt. 0)
                     end do
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     den(i, j, lo(3))   = cvmgt(coef(0), 0.0D0,
     $                    mask(i, j, lo(3)-1) .gt. 0)
                  end do
               end do
            end if
         else if ( bct .eq. LO_REFLECT_ODD ) then
            do n = 1, nc
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     phi(i, j, lo(3)-1, n) = cvmgt(
     $                   -phi(i,j,lo(3),n),
     $                    phi(i,j,lo(3)-1,n),
     $                    mask(i,j,lo(3)-1) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     den(i,j,lo(3)) = cvmgt(-1.0D0, 0.0D0,
     $                    mask(i,j,lo(3)-1) .gt. 0)
                  end do
               end do
            end if
         else
            print *,'UNKNOWN BC ON FRONT FACE IN APPLYBC'
            call bl_error("stop")
         end if
      end if
c
c     The back of the grid
c
      if (cdir .eq. 5) then
         if(is_neumann(bct)) then
            do n = 1, nc
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     phi(i,j, hi(3)+1,n) = cvmgt(
     $                    phi(i,j, hi(3),n),
     $                    phi(i,j, hi(3)+1,n),
     $                    mask(i,j, hi(3)+1) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     den(i,j, hi(3))   = 1.0D0
                  end do
               end do
            end if
         else if (is_dirichlet(bct)) then
            do m=0,lenz
               x(m) = m + 0.5D0
            end do
            x(-1) = - bcl/h(3)
            xInt = - 0.5D0
            call polyInterpCoeff(xInt, x, lenz+2, coef)
            do n = 1, nc
               if ( flagbc .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        phi(i,j, hi(3)+1,n) = cvmgt(
     $                       bcval(i,j, hi(3)+1,n)*coef(-1),
     $                       phi(i,j, hi(3)+1,n),
     $                       mask(i,j, hi(3)+1) .gt. 0)
                     end do
                  end do
               else
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        phi(i,j, hi(3)+1,n) = cvmgt(
     $                       0.0D0,
     $                       phi(i,j, hi(3)+1,n),
     $                       mask(i,j, hi(3)+1) .gt. 0)
                     end do
                  end do
               end if
               do m = 0, lenz
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        phi(i, j, hi(3)+1,n) = cvmgt(
     $                       phi(i,j, hi(3)+1,n)
     $                       + phi(i, j, hi(3)-m,n)*coef(m),
     $                       phi(i,j, hi(3)+1,n),
     $                       mask(i,j, hi(3)+1) .gt. 0)
                     end do
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     den(i,j, hi(3))   = cvmgt(coef(0), 0.0D0,
     $                    mask(i,j, hi(3)+1) .gt. 0)
                  end do
               end do
            end if
         else if ( bct .eq. LO_REFLECT_ODD ) then
            do n = 1, nc
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     phi(i, j, hi(3)+1, n) = cvmgt(
     $                   -phi(i,j,hi(3),n),
     $                    phi(i,j,hi(3)+1,n),
     $                    mask(i,j,hi(3)+1) .gt. 0)
                  end do
               end do
            end do
            if ( flagden .eq. 1 ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     den(i,j,hi(3)) = cvmgt(-1.0D0, 0.0D0,
     $                    mask(i,j,hi(3)+1) .gt. 0)
                  end do
               end do
            end if
         else
            print *,'UNKNOWN BC ON BACK FACE IN APPLYBC'
            call bl_error("stop")
         end if
      end if
c
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#define USE_TMP 1
#include <REAL.H>

#include "DivVis_F.H"
#include <LO_BCTYPES.H>
#include "ArrayLim.H"

c :::: usage:
c :::: this .mF file is meant to be run through Mathematica.  This converts
c :::: compact symbolic expressions into fortran which is stored in a .F
c :::: file.

c----------------------------------------------------------------
c     this is the fortran support file for the the operator 
c     L(U) = alpha*a(x)*U - beta*Div( tau )
c
c     where U is the two component vector (u,v) and
c     tau is a three by three tensor
c     tau = | t_xx     t_xy 	t_xz|
c           | t_xy     t_yy 	t_yz|
c	    | t_xz     t_yz	t_zz|
c
c     t_xx = 2*mu * u_x
c     t_yy = 2*mu * v_y
c     t_zz = 2*mu * w_z
c     t_xy = mu*(u_y + v_x)
c     t_xz = mu*(u_z + w_x)
c     t_yz = mu*(v_z + w_y)

c ::: define standard replacements used by Mathematica
c ::: see file visc3d.ma
c ::: Null

c ::: interface notes:
c ::: 1) trander* ALWAYS have values in them, even if the cells are
c :::    all covered.  Might as well.  These are edge located derivative
c :::    values.  In index space, they are located the same as the mask
c :::    cells.  Which is somewhat anomalous.  These are edge values, after
c :::    all.  While the masks are cell-centered.  But it seems easier
c :::    at the moment.
c ::: 1a) trander is 3x3 for each location; first is component number, then
c :::     derivative direction.  Not all of these are used, in fact, only the
c :::     component which is normal to the face is used, and only the 
c :::     tangential directions are used.
c ::: 2) the normal derivatives are evaluated in the normal fashion.
c ::: 3) tangential derivatives which reach outside the rectangle DO have
c :::    to check the masks.  

      subroutine FORT_APPLYBC (
     $     flagden, flagbc, maxorder,
     $     u, DIMS(u),
     $     cdir, bct, bcl,
     $     bcval, DIMS(bcval),
     $     maskn, DIMS(maskn),
     $     maske, DIMS(maske),
     $     maskw, DIMS(maskw),
     $     masks, DIMS(masks),
     $     maskt, DIMS(maskt),
     $     maskb, DIMS(maskb),
     $     den, DIMS(den),
     $     exttd,DIMS(exttd),
     $     trander,DIMS(trander),
     $     lo, hi, nc,
     $     h
     $     )
c
c     If the boundary is of Neumann type, set the ghost cell value to
c     that of the outermost point in the valid data (2nd order accurate)
c     and then fill the "den" array with the value "1"
c     
c     
c     If flagbc==1:
c     
c     If the boundary is of Dirichlet type, construct a polynomial
c     interpolation through the boundary location and internal points
c     (at locations x(-1:len-2) that generates the ghost cell value (at
c     location xInt).  Then fill the ghost cell with the interpolated value.
c     If flagden==1, load the "den" array with the interpolation
c     coefficient corresponding to outermost point in the valid region
c     ( the coef(0) corresponding to the location x(0) )
c
c     Note: 
c     The bc type = LO_REFLECT_ODD is a special type of dirichlet condition,
c     in that we want a "zeroth" order interpolant to fill the ghost cell.
c     If this were treated in the normal way, then ALL boundaries would be
c     low order.

c ::: other notes since previous developers didn't bother to document
c ::: cdir is mnemonic for coordinate direction. i.e. which side is
c ::: cdir==0->west
c ::: cdir==3->east
c ::: cdir==1->south
c ::: cdir==4->north
c ::: cdir==2->bottom
c ::: cdir==5->top
c      
      integer maxorder
      integer nc, cdir, flagden, flagbc
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      integer DIMDEC(u)
      REAL_T u(DIMV(u),nc)
      integer DIMDEC(den)
      REAL_T den(DIMV(den),nc)
      integer DIMDEC(exttd)
      REAL_T exttd(DIMV(exttd),nc,3)
      integer DIMDEC(bcval)
      REAL_T bcval(DIMV(bcval),nc)
      integer DIMDEC(maskn)
      integer maskn(DIMV(maskn))
      integer DIMDEC(maske)
      integer maske(DIMV(maske))
      integer DIMDEC(maskw)
      integer maskw(DIMV(maskw))
      integer DIMDEC(masks)
      integer masks(DIMV(masks))
      integer DIMDEC(maskt)
      integer maskt(DIMV(maskt))
      integer DIMDEC(maskb)
      integer maskb(DIMV(maskb))
      integer DIMDEC(trander)
      REAL_T trander(DIMV(trander),3,3)
      integer bct(nc)
      REAL_T bcl
      REAL_T h(BL_SPACEDIM)
c
      integer i
      integer j
      integer k
      integer n
      logical is_dirichlet
      logical is_neumann
      logical is_odd
      REAL_T xb
      REAL_T innder,outder,innloc
      REAL_T edgloc,outloc
      REAL_T lambda
      REAL_T hx,hy,hz
c
      integer lenx
      integer leny
      integer lenz
      integer m
c...........trial change .................
      integer tmplen
      parameter(tmplen=256)
      REAL_T tmp(0:tmplen)
c...........trial change .................
c
      integer Lmaxorder
      integer maxmaxorder
      parameter(maxmaxorder=4)
      REAL_T x(-1:maxmaxorder-2)
      REAL_T coef(-1:maxmaxorder-2)
      REAL_T xInt
      logical False, True
      parameter( False=.false.)
      parameter( True=.true. )
c
      is_dirichlet(i) = ( i .eq. LO_DIRICHLET )
      is_neumann(i) = (i .eq. LO_NEUMANN)
c
      if ( maxorder .eq. -1 ) then
         Lmaxorder = maxmaxorder
      else
         Lmaxorder = MIN(maxorder,maxmaxorder)
      endif
      lenx = MIN(hi(1)-lo(1), Lmaxorder-2)
      leny = MIN(hi(2)-lo(2), Lmaxorder-2)
      lenz = MIN(hi(3)-lo(3), Lmaxorder-2)
      hx = h(1)
      hy = h(2)
      hz = h(3)
c...........trial change .................
      if( (hi(1)-lo(1)+1).gt.tmplen .or. 
     &     (hi(2)-lo(2)+1).gt.tmplen .or. 
     &     (hi(3)-lo(3)+1).gt.tmplen) then
         write(6,*)'FORT_APPLYBC: tmplen must be larger'
         stop
      endif
c...........trial change .................

c
c     TODO:
c     In order for this to work with growing multigrid, must
c     sort xa[] because it is possible for the xb value to lay
c     within this range.

c     
c     The west face of the grid
c
      if(cdir .eq. 0) then
         do n = 1,nc
            if (is_neumann(bct(n))) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     u(lo(1)-1,j,k,n) = cvmgt(
     $                    u(lo(1),j,k,n),
     $                    u(lo(1)-1,j,k,n),
     $                    maskw(lo(1)-1,j,k) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        den(lo(1),j,k,n) = 1.0
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential derivative part
c ::: ::: Null
               i = lo(1)
c ::: ::: ::: Y
               do k=lo(3),hi(3)
c ::: ::: ::: ::: interior part of west face
                  do j=lo(2)+1,hi(2)-1
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                     trander(i-1,j,k,n,2) = innder
                  enddo
                  j = lo(2)
                  if(masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i-1,j,k,n,2) = innder
                  j = hi(2)
                  if(maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i-1,j,k,n,2) = innder
               enddo
c ::: ::: ::: Z
               do j=lo(2),hi(2)
                  do k=lo(3)+1,hi(3)-1
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                     trander(i-1,j,k,n,3) = innder
                  enddo
                  k = lo(3)
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i-1,j,k,n,3) = innder
                  k = hi(3)
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i-1,j,k,n,3) = innder
               enddo
            else if (is_dirichlet(bct(n))) then
               do m=0,lenx
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(1)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, lenx+2, coef)
#if USE_TMP
               do k = lo(3), hi(3)
                  if ( flagbc .eq. 1 ) then
                     do j = lo(2), hi(2)
                        tmp(j-lo(2)) = bcval(lo(1)-1,j,k,n)*coef(-1)
                     enddo
                  else
                     do j = lo(2), hi(2)
                        tmp(j-lo(2)) = 0.0
                     enddo
                  endif
                  do m = 0, lenx
                     do j = lo(2), hi(2)
                        tmp(j-lo(2)) = tmp(j-lo(2))+u(lo(1)+m,j,k,n)*coef(m)
                     enddo
                  enddo
                  do j = lo(2), hi(2)
                     u(lo(1)-1, j, k, n) = cvmgt(
     &                    tmp(j-lo(2)),
     $                    u(lo(1)-1, j,k, n),
     $                    maskw(lo(1)-1,j,k) .gt. 0)
                  enddo
               enddo
#else
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        u(lo(1)-1, j, k, n) = cvmgt(
     $                       bcval(lo(1)-1,j,k,n)*coef(-1),
     $                       u(lo(1)-1, j,k, n),
     $                       maskw(lo(1)-1,j,k) .gt. 0)
                     enddo
                  enddo
               else
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        u(lo(1)-1, j, k, n) = cvmgt(
     $                       0.0,
     $                       u(lo(1)-1, j, k, n),
     $                       maskw(lo(1)-1,j, k) .gt. 0)
                     enddo
                  enddo
               endif
               do k = lo(3), hi(3)
                  do m = 0, lenx
                     do j = lo(2), hi(2)
                        u(lo(1)-1,j,k,n) = cvmgt(
     $                       u(lo(1)-1,j,k,n)
     $                       + u(lo(1)+m, j, k, n)*coef(m),
     $                       u(lo(1)-1,j,k,n),
     $                       maskw(lo(1)-1,j,k) .gt. 0)
                     enddo
                  enddo
               enddo
#endif
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        den(lo(1),j,k,n) = cvmgt(coef(0), 0.0,
     $                       maskw(lo(1)-1,j,k) .gt. 0)
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential deriv part
c ::: ::: Null
c ::: ::: interior part of west side
               edgloc = 0.
               i = lo(1)
c ::: ::: ::: Y
               do k=lo(3),hi(3)
                  do j=lo(2)+1,hi(2)-1
                     if( maskw(-1+i,-1+j,k).eq.0.and.maskw(-1+i,1+j,k).eq.0)then
                         outloc = -0.5
                         outder = (-U(-1+i,-1+j,k,n)+U(-1+i,1+j,k,n))/(2.d0*hy)
                     elseif( maskw(-1+i,j,k).eq.0.and.maskw(-1+i,1+j,k).eq.0)then
                         outloc = -0.5
                         outder = (-3*U(-1+i,j,k,n)+4*U(-1+i,1+j,k,n)-U(-1+i,2+j,k,n))/(2.d0
     &  *hy)
                     elseif( maskw(-1+i,-1+j,k).eq.0.and.maskw(-1+i,j,k).eq.0)then
                         outloc = -0.5
                         outder = (U(-1+i,-2+j,k,n)-4*U(-1+i,-1+j,k,n)+3*U(-1+i,j,k,n))/(2.d
     &  0*hy)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1) then
                           outder = exttd(i-1,j,k,n,2)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i-1,j,k,n,2) = lambda*innder+(1-lambda)*outder
                  enddo
c ::: ::: ::: now endpoints
                  j = lo(2)
                  if( maskw(-1+i,-1+j,k).eq.0.and.maskw(-1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,-1+j,k,n)+U(-1+i,1+j,k,n))/(2.d0*hy)
                  elseif( maskw(-1+i,j,k).eq.0.and.maskw(-1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(-1+i,j,k,n)+4*U(-1+i,1+j,k,n)-U(-1+i,2+j,k,n))/(2.d0
     &  *hy)
                  elseif( maskw(-1+i,-1+j,k).eq.0.and.maskw(-1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(-1+i,-2+j,k,n)-4*U(-1+i,-1+j,k,n)+3*U(-1+i,j,k,n))/(2.d
     &  0*hy)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i-1,j,k,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i-1,j,k,n,2) = lambda*innder+(1-lambda)*outder

                  j = hi(2)
                  if( maskw(-1+i,-1+j,k).eq.0.and.maskw(-1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,-1+j,k,n)+U(-1+i,1+j,k,n))/(2.d0*hy)
                  elseif( maskw(-1+i,j,k).eq.0.and.maskw(-1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(-1+i,j,k,n)+4*U(-1+i,1+j,k,n)-U(-1+i,2+j,k,n))/(2.d0
     &  *hy)
                  elseif( maskw(-1+i,-1+j,k).eq.0.and.maskw(-1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(-1+i,-2+j,k,n)-4*U(-1+i,-1+j,k,n)+3*U(-1+i,j,k,n))/(2.d
     &  0*hy)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i-1,j,k,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i-1,j,k,n,2) = lambda*innder+(1-lambda)*outder
               enddo
c ::: ::: ::: Z
               do j=lo(2),hi(2)
                  do k=lo(3)+1,hi(3)-1
                     if( maskw(-1+i,j,-1+k).eq.0.and.maskw(-1+i,j,1+k).eq.0)then
                         outloc = -0.5
                         outder = (-U(-1+i,j,-1+k,n)+U(-1+i,j,1+k,n))/(2.d0*hz)
                     elseif( maskw(-1+i,j,k).eq.0.and.maskw(-1+i,j,1+k).eq.0)then
                         outloc = -0.5
                         outder = (-3*U(-1+i,j,k,n)+4*U(-1+i,j,1+k,n)-U(-1+i,j,2+k,n))/(2.d0
     &  *hz)
                     elseif( maskw(-1+i,j,-1+k).eq.0.and.maskw(-1+i,j,k).eq.0)then
                         outloc = -0.5
                         outder = (U(-1+i,j,-2+k,n)-4*U(-1+i,j,-1+k,n)+3*U(-1+i,j,k,n))/(2.d
     &  0*hz)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1) then
                           outder = exttd(i-1,j,k,n,3)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i-1,j,k,n,3) = lambda*innder+(1-lambda)*outder
                  enddo
c ::: ::: ::: now endpoints
                  k = lo(3)
                  if( maskw(-1+i,j,-1+k).eq.0.and.maskw(-1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,j,-1+k,n)+U(-1+i,j,1+k,n))/(2.d0*hz)
                  elseif( maskw(-1+i,j,k).eq.0.and.maskw(-1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(-1+i,j,k,n)+4*U(-1+i,j,1+k,n)-U(-1+i,j,2+k,n))/(2.d0
     &  *hz)
                  elseif( maskw(-1+i,j,-1+k).eq.0.and.maskw(-1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(-1+i,j,-2+k,n)-4*U(-1+i,j,-1+k,n)+3*U(-1+i,j,k,n))/(2.d
     &  0*hz)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i-1,j,k,n,3)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i-1,j,k,n,3) = lambda*innder+(1-lambda)*outder

                  k = hi(3)
                  if( maskw(-1+i,j,-1+k).eq.0.and.maskw(-1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,j,-1+k,n)+U(-1+i,j,1+k,n))/(2.d0*hz)
                  elseif( maskw(-1+i,j,k).eq.0.and.maskw(-1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(-1+i,j,k,n)+4*U(-1+i,j,1+k,n)-U(-1+i,j,2+k,n))/(2.d0
     &  *hz)
                  elseif( maskw(-1+i,j,-1+k).eq.0.and.maskw(-1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(-1+i,j,-2+k,n)-4*U(-1+i,j,-1+k,n)+3*U(-1+i,j,k,n))/(2.d
     &  0*hz)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i-1,j,k,n,3)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i-1,j,k,n,3) = lambda*innder+(1-lambda)*outder
               enddo
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     u(lo(1)-1, j, k, n) = cvmgt(
     $                   -u(lo(1),j,k,n),
     $                    u(lo(1)-1,j,k,n),
     $                    maskw(lo(1)-1,j,k) .gt. 0)
                     trander(lo(1)-1,j,k,n,2) = 0.
                     trander(lo(1)-1,j,k,n,3) = 0.
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        den(lo(1),j,k,n) = cvmgt(-1.0, 0.0,
     $                       maskw(lo(1)-1,j,k) .gt. 0)
                     enddo
                  enddo
               endif
            else
               print *,'UNKNOWN BC ON WEST FACE IN APPLYBC'
               stop
            endif
	 enddo
      endif
c
c     The east face of the grid
c
      if(cdir .eq. 3) then
         do n = 1,nc
            if(is_neumann(bct(n))) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     u(hi(1)+1,j,k,n) = cvmgt(
     $                    u(hi(1), j, k, n),
     $                    u(hi(1)+1, j, k, n),
     $                    maske(hi(1)+1,j,k) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        den(hi(1),j,k,n) = 1.0
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential derivative part
               i = hi(1)
c ::: ::: ::: Y
               do k=lo(3),hi(3)
c ::: ::: ::: ::: interior part of west face
                  do j=lo(2)+1,hi(2)-1
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                     trander(i+1,j,k,n,2) = innder
                  enddo
                  j = lo(2)
                  if(masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i+1,j,k,n,2) = innder
                  j = hi(2)
                  if(maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i+1,j,k,n,2) = innder
               enddo
c ::: ::: ::: Z
               do j=lo(2),hi(2)
                  do k=lo(3)+1,hi(3)-1
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                     trander(i+1,j,k,n,3) = innder
                  enddo
                  k = lo(3)
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i+1,j,k,n,3) = innder
                  k = hi(3)
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i+1,j,k,n,3) = innder
               enddo
            else if (is_dirichlet(bct(n))) then
               do m=0,lenx
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(1)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, lenx+2, coef)
#if USE_TMP
               do k = lo(3), hi(3)
                  if ( flagbc .eq. 1 ) then
                     do j = lo(2), hi(2)
                        tmp(j-lo(2)) = bcval(hi(1)+1,j,k,n)*coef(-1)
                     enddo
                  else
                     do j = lo(2), hi(2)
                        tmp(j-lo(2)) = 0.0
                     enddo
                  endif
                  do m = 0, lenx
                     do j = lo(2), hi(2)
                        tmp(j-lo(2)) = tmp(j-lo(2))+u(hi(1)-m,j,k,n)*coef(m)
                     enddo
                  enddo
                  do j = lo(2), hi(2)
                     u(hi(1)+1,j,k,n) = cvmgt(
     $                    tmp(j-lo(2)),
     $                    u(hi(1)+1,j,k,n),
     $                    maske(hi(1)+1,j,k) .gt. 0)
                  enddo
               enddo
#else
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        u(hi(1)+1,j,k,n) = cvmgt(
     $                       bcval(hi(1)+1,j,k,n)*coef(-1),
     $                       u(hi(1)+1,j,k,n),
     $                       maske(hi(1)+1,j,k) .gt. 0)
                     enddo
                  enddo
               else
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        u(hi(1)+1,j,k,n) = cvmgt(
     $                       0.0,
     $                       u(hi(1)+1,j,k,n),
     $                       maske(hi(1)+1,j,k) .gt. 0)
                     enddo
                  enddo
               endif
               do k = lo(3), hi(3)
                  do m = 0, lenx
                     do j = lo(2), hi(2)
                        u(hi(1)+1,j,k,n) = cvmgt(
     $                       u(hi(1)+1,j,k,n)
     $                       + u(hi(1)-m,j,k,n)*coef(m),
     $                       u(hi(1)+1,j,k,n),
     $                       maske(hi(1)+1,j,k) .gt. 0)
                     enddo
                  enddo
               enddo
#endif
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        den(hi(1),j,k,n)   = cvmgt(coef(0), 0.0,
     $                       maske(hi(1)+1,j,k) .gt. 0)
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential deriv part
c ::: ::: interior part of west side
               edgloc = 0.
               i = hi(1)
c ::: ::: ::: Y
               do k=lo(3),hi(3)
                  do j=lo(2)+1,hi(2)-1
                     if( maske(1+i,-1+j,k).eq.0.and.maske(1+i,1+j,k).eq.0)then
                         outloc = -0.5
                         outder = (-U(1+i,-1+j,k,n)+U(1+i,1+j,k,n))/(2.d0*hy)
                     elseif( maske(1+i,j,k).eq.0.and.maske(1+i,1+j,k).eq.0)then
                         outloc = -0.5
                         outder = (-3*U(1+i,j,k,n)+4*U(1+i,1+j,k,n)-U(1+i,2+j,k,n))/(2.d0*hy
     &  )
                     elseif( maske(1+i,-1+j,k).eq.0.and.maske(1+i,j,k).eq.0)then
                         outloc = -0.5
                         outder = (U(1+i,-2+j,k,n)-4*U(1+i,-1+j,k,n)+3*U(1+i,j,k,n))/(2.d0*h
     &  y)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1) then
                           outder = exttd(i+1,j,k,n,2)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i+1,j,k,n,2) = lambda*innder+(1-lambda)*outder
                  enddo
c ::: ::: ::: now endpoints
                  j = lo(2)
                  if( maske(1+i,-1+j,k).eq.0.and.maske(1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-U(1+i,-1+j,k,n)+U(1+i,1+j,k,n))/(2.d0*hy)
                  elseif( maske(1+i,j,k).eq.0.and.maske(1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(1+i,j,k,n)+4*U(1+i,1+j,k,n)-U(1+i,2+j,k,n))/(2.d0*hy
     &  )
                  elseif( maske(1+i,-1+j,k).eq.0.and.maske(1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(1+i,-2+j,k,n)-4*U(1+i,-1+j,k,n)+3*U(1+i,j,k,n))/(2.d0*h
     &  y)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i+1,j,k,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i+1,j,k,n,2) = lambda*innder+(1-lambda)*outder

                  j = hi(2)
                  if( maske(1+i,-1+j,k).eq.0.and.maske(1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-U(1+i,-1+j,k,n)+U(1+i,1+j,k,n))/(2.d0*hy)
                  elseif( maske(1+i,j,k).eq.0.and.maske(1+i,1+j,k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(1+i,j,k,n)+4*U(1+i,1+j,k,n)-U(1+i,2+j,k,n))/(2.d0*hy
     &  )
                  elseif( maske(1+i,-1+j,k).eq.0.and.maske(1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(1+i,-2+j,k,n)-4*U(1+i,-1+j,k,n)+3*U(1+i,j,k,n))/(2.d0*h
     &  y)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i+1,j,k,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i+1,j,k,n,2) = lambda*innder+(1-lambda)*outder
               enddo
c ::: ::: ::: Z
               do j=lo(2),hi(2)
                  do k=lo(3)+1,hi(3)-1
                     if( maske(1+i,j,-1+k).eq.0.and.maske(1+i,j,1+k).eq.0)then
                         outloc = -0.5
                         outder = (-U(1+i,j,-1+k,n)+U(1+i,j,1+k,n))/(2.d0*hz)
                     elseif( maske(1+i,j,k).eq.0.and.maske(1+i,j,1+k).eq.0)then
                         outloc = -0.5
                         outder = (-3*U(1+i,j,k,n)+4*U(1+i,j,1+k,n)-U(1+i,j,2+k,n))/(2.d0*hz
     &  )
                     elseif( maske(1+i,j,-1+k).eq.0.and.maske(1+i,j,k).eq.0)then
                         outloc = -0.5
                         outder = (U(1+i,j,-2+k,n)-4*U(1+i,j,-1+k,n)+3*U(1+i,j,k,n))/(2.d0*h
     &  z)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1) then
                           outder = exttd(i+1,j,k,n,3)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i+1,j,k,n,3) = lambda*innder+(1-lambda)*outder
                  enddo
c ::: ::: ::: now endpoints
                  k = lo(3)
                  if( maske(1+i,j,-1+k).eq.0.and.maske(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(1+i,j,-1+k,n)+U(1+i,j,1+k,n))/(2.d0*hz)
                  elseif( maske(1+i,j,k).eq.0.and.maske(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(1+i,j,k,n)+4*U(1+i,j,1+k,n)-U(1+i,j,2+k,n))/(2.d0*hz
     &  )
                  elseif( maske(1+i,j,-1+k).eq.0.and.maske(1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(1+i,j,-2+k,n)-4*U(1+i,j,-1+k,n)+3*U(1+i,j,k,n))/(2.d0*h
     &  z)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i+1,j,k,n,3)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i+1,j,k,n,3) = lambda*innder+(1-lambda)*outder

                  k = hi(3)
                  if( maske(1+i,j,-1+k).eq.0.and.maske(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(1+i,j,-1+k,n)+U(1+i,j,1+k,n))/(2.d0*hz)
                  elseif( maske(1+i,j,k).eq.0.and.maske(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(1+i,j,k,n)+4*U(1+i,j,1+k,n)-U(1+i,j,2+k,n))/(2.d0*hz
     &  )
                  elseif( maske(1+i,j,-1+k).eq.0.and.maske(1+i,j,k).eq.0)then
                     outloc = -0.5
                     outder = (U(1+i,j,-2+k,n)-4*U(1+i,j,-1+k,n)+3*U(1+i,j,k,n))/(2.d0*h
     &  z)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1) then
                        outder = exttd(i+1,j,k,n,3)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i+1,j,k,n,3) = lambda*innder+(1-lambda)*outder
               enddo
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     u(hi(1)+1, j, k, n) = cvmgt(
     $                   -u(hi(1),j,k,n),
     $                    u(hi(1)+1,j,k,n),
     $                    maske(hi(1)+1,j,k) .gt. 0)
                     trander(hi(1)+1,j,k,n,2) = 0.
                     trander(hi(1)+1,j,k,n,3) = 0.
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do j = lo(2), hi(2)
                        den(hi(1),j,k,n) = cvmgt(-1.0, 0.0,
     $                       maske(hi(1)+1,j,k) .gt. 0)
                     enddo
                  enddo
               endif
            else
               print *,'UNKNOWN BC ON RIGHT FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c
c     The south of the Grid
c
      if(cdir .eq. 1) then
	 do n = 1,nc
            if(is_neumann(bct(n))) then
               do k = lo(3), hi(3)
                  do i = lo(1),hi(1)
                     u(i,lo(2)-1,k,n) = cvmgt(
     $                    u(i,lo(2),k,n),
     $                    u(i,lo(2)-1,k,n),
     $                    masks(i,lo(2)-1,k) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1),hi(1)
                        den(i,lo(2),k,n)   = 1.0
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential derivative part
               j = lo(2)
c ::: ::: ::: X
               do k=lo(3),hi(3)
c ::: ::: ::: ::: interior part of south face
                  do i=lo(1)+1,hi(1)-1
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                     trander(i,j-1,k,n,1) = innder
                  enddo
                  i = lo(1)
                  if(maskw(-1+i,j,k).gt.0) then
                       innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                       innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j-1,k,n,1) = innder
                  i = hi(1)
                  if(maske(1+i,j,k).gt.0) then
                     innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j-1,k,n,1) = innder
               enddo
c ::: ::: ::: Z
               do i=lo(1),hi(1)
c ::: ::: ::: ::: interior part of south face
                  do k=lo(3)+1,hi(3)-1
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                     trander(i,j-1,k,n,3) = innder
                  enddo
                  k = lo(3)
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i,j-1,k,n,3) = innder
                  k = hi(3)
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i,j-1,k,n,3) = innder
               enddo
            else if (is_dirichlet(bct(n))) then
               do m=0,leny
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(2)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, leny+2, coef)
#if USE_TMP
               do k = lo(3), hi(3)
                  if ( flagbc .eq. 1 ) then
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = bcval(i,lo(2)-1,k,n)*coef(-1)
                     enddo
                  else
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = 0.0
                     enddo
                  endif
                  do m = 0, leny
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = tmp(i-lo(1))+u(i,lo(2)+m,k,n)*coef(m)
                     enddo
                  enddo
                  do i = lo(1), hi(1)
                     u(i,lo(2)-1,k,n) = cvmgt(
     $                    tmp(i-lo(1)),
     $                    u(i,lo(2)-1,k,n),
     $                    masks(i,lo(2)-1,k) .gt. 0)
                  enddo
               enddo
#else
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        u(i,lo(2)-1,k,n) = cvmgt(
     $                       bcval(i,lo(2)-1,k,n)*coef(-1),
     $                       u(i,lo(2)-1,k,n),
     $                       masks(i,lo(2)-1,k) .gt. 0)
                     enddo
                  enddo
               else
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        u(i,lo(2)-1,k,n) = cvmgt(
     $                       0.0,
     $                       u(i,lo(2)-1,k,n),
     $                       masks(i,lo(2)-1,k) .gt. 0)
                     enddo
                  enddo
               endif
               do k = lo(3), hi(3)
                  do m = 0, leny
                     do i = lo(1), hi(1)
                        u(i, lo(2)-1, k, n) = cvmgt(
     $                       u(i, lo(2)-1,k,n)
     $                       + u(i, lo(2)+m, k,n)*coef(m),
     $                       u(i, lo(2)-1, k, n),
     $                       masks(i, lo(2)-1, k) .gt. 0)
                     enddo
                  enddo
               enddo
#endif
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        den(i, lo(2),k,n)   = cvmgt(coef(0), 0.0,
     $                       masks(i, lo(2)-1,k) .gt. 0)
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential deriv part
c ::: ::: interior part first, followed by end points
               edgloc = 0.
               j=lo(2)
c ::: ::: ::: X
               do k=lo(3),hi(3)
                  do i=lo(1)+1, hi(1)-1
                     if( masks(-1+i,-1+j,k).eq.0.and.masks(1+i,-1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (-U(-1+i,-1+j,k,n)+U(1+i,-1+j,k,n))/(2.d0*hx)
                    elseif( masks(i,-1+j,k).eq.0.and.masks(1+i,-1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (-3*U(i,-1+j,k,n)+4*U(1+i,-1+j,k,n)-U(2+i,-1+j,k,n))/(2.d0
     &  *hx)
                    elseif( masks(-1+i,-1+j,k).eq.0.and.masks(i,-1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (U(-2+i,-1+j,k,n)-4*U(-1+i,-1+j,k,n)+3*U(i,-1+j,k,n))/(2.d
     &  0*hx)
                    else
                       outloc = x(-1)
                       if( flagbc .eq. 1 ) then
                          outder = exttd(i,j-1,k,n,1)
                       else
                          outder = 0.
                       endif
                    endif
                    innloc = 0.5
                    innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                    lambda = (edgloc-outloc)/(innloc-outloc)
                    trander(i,j-1,k,n,1) = lambda*innder+(1-lambda)*outder
                  enddo

                  i = lo(1)
                  if( masks(-1+i,-1+j,k).eq.0.and.masks(1+i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-U(-1+i,-1+j,k,n)+U(1+i,-1+j,k,n))/(2.d0*hx)
                  elseif( masks(i,-1+j,k).eq.0.and.masks(1+i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,-1+j,k,n)+4*U(1+i,-1+j,k,n)-U(2+i,-1+j,k,n))/(2.d0
     &  *hx)
                  elseif( masks(-1+i,-1+j,k).eq.0.and.masks(i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(-2+i,-1+j,k,n)-4*U(-1+i,-1+j,k,n)+3*U(i,-1+j,k,n))/(2.d
     &  0*hx)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j-1,k,n,1)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maskw(-1+i,j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j-1,k,n,1) = lambda*innder+(1-lambda)*outder

                  i = hi(1)
                  if( masks(-1+i,-1+j,k).eq.0.and.masks(1+i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-U(-1+i,-1+j,k,n)+U(1+i,-1+j,k,n))/(2.d0*hx)
                  elseif( masks(i,-1+j,k).eq.0.and.masks(1+i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,-1+j,k,n)+4*U(1+i,-1+j,k,n)-U(2+i,-1+j,k,n))/(2.d0
     &  *hx)
                  elseif( masks(-1+i,-1+j,k).eq.0.and.masks(i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(-2+i,-1+j,k,n)-4*U(-1+i,-1+j,k,n)+3*U(i,-1+j,k,n))/(2.d
     &  0*hx)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j-1,k,n,1)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maske(1+i,j,k).gt.0) then
                     innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j-1,k,n,1) = lambda*innder+(1-lambda)*outder                 
               enddo
c ::: ::: ::: Z
               do i=lo(1), hi(1)
                  do k=lo(3)+1,hi(3)-1
                     if( masks(i,-1+j,-1+k).eq.0.and.masks(i,-1+j,1+k).eq.0)then
                       outloc = -0.5
                       outder = (-U(i,-1+j,-1+k,n)+U(i,-1+j,1+k,n))/(2.d0*hz)
                    elseif( masks(i,-1+j,k).eq.0.and.masks(i,-1+j,1+k).eq.0)then
                       outloc = -0.5
                       outder = (-3*U(i,-1+j,k,n)+4*U(i,-1+j,1+k,n)-U(i,-1+j,2+k,n))/(2.d0
     &  *hz)
                    elseif( masks(i,-1+j,-1+k).eq.0.and.masks(i,-1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (U(i,-1+j,-2+k,n)-4*U(i,-1+j,-1+k,n)+3*U(i,-1+j,k,n))/(2.d
     &  0*hz)
                    else
                       outloc = x(-1)
                       if( flagbc .eq. 1 ) then
                          outder = exttd(i,j-1,k,n,3)
                       else
                          outder = 0.
                       endif
                    endif
                    innloc = 0.5
                    innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                    lambda = (edgloc-outloc)/(innloc-outloc)
                    trander(i,j-1,k,n,3) = lambda*innder+(1-lambda)*outder
                  enddo

                  k = lo(3)
                  if( masks(i,-1+j,-1+k).eq.0.and.masks(i,-1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-U(i,-1+j,-1+k,n)+U(i,-1+j,1+k,n))/(2.d0*hz)
                  elseif( masks(i,-1+j,k).eq.0.and.masks(i,-1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,-1+j,k,n)+4*U(i,-1+j,1+k,n)-U(i,-1+j,2+k,n))/(2.d0
     &  *hz)
                  elseif( masks(i,-1+j,-1+k).eq.0.and.masks(i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(i,-1+j,-2+k,n)-4*U(i,-1+j,-1+k,n)+3*U(i,-1+j,k,n))/(2.d
     &  0*hz)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j-1,k,n,3)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j-1,k,n,3) = lambda*innder+(1-lambda)*outder

                  k = hi(3)
                  if( masks(i,-1+j,-1+k).eq.0.and.masks(i,-1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-U(i,-1+j,-1+k,n)+U(i,-1+j,1+k,n))/(2.d0*hz)
                  elseif( masks(i,-1+j,k).eq.0.and.masks(i,-1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,-1+j,k,n)+4*U(i,-1+j,1+k,n)-U(i,-1+j,2+k,n))/(2.d0
     &  *hz)
                  elseif( masks(i,-1+j,-1+k).eq.0.and.masks(i,-1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(i,-1+j,-2+k,n)-4*U(i,-1+j,-1+k,n)+3*U(i,-1+j,k,n))/(2.d
     &  0*hz)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j-1,k,n,3)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j-1,k,n,3) = lambda*innder+(1-lambda)*outder                 
               enddo
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     u(i, lo(2)-1, k, n) = cvmgt(
     $                   -u(i,lo(2),k,n),
     $                    u(i,lo(2)-1,k,n),
     $                    masks(i,lo(2)-1,k) .gt. 0)
                     trander(i,lo(2)-1,k,n,1) = 0.
                     trander(i,lo(2)-1,k,n,3) = 0.
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        den(i,lo(2),k,n) = cvmgt(-1.0, 0.0,
     $                       masks(i,lo(2)-1,k) .gt. 0)
                     enddo
                  enddo
               endif
            else
               print *,'UNKNOWN BC ON BOTTOM FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c
c     The north of the grid
c
      if (cdir .eq. 4) then
         do n = 1,nc
            if(is_neumann(bct(n))) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     u(i,hi(2)+1,k,n) = cvmgt(
     $                    u(i,hi(2),k,n),
     $                    u(i,hi(2)+1,k,n),
     $                    maskn(i,hi(2)+1,k) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        den(i,hi(2),k,n)   = 1.0
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential derivative part
               j = hi(2)
c ::: ::: ::: X
               do k=lo(3),hi(3)
c ::: ::: ::: ::: interior part of south face
                  do i=lo(1)+1,hi(1)-1
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                     trander(i,j+1,k,n,1) = innder
                  enddo
                  i = lo(1)
                  if(maskw(-1+i,j,k).gt.0) then
                       innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                       innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j+1,k,n,1) = innder
                  i = hi(1)
                  if(maske(1+i,j,k).gt.0) then
                     innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j+1,k,n,1) = innder
               enddo
c ::: ::: ::: Z
               do i=lo(1),hi(1)
c ::: ::: ::: ::: interior part of south face
                  do k=lo(3)+1,hi(3)-1
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                     trander(i,j+1,k,n,3) = innder
                  enddo
                  k = lo(3)
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i,j+1,k,n,3) = innder
                  k = hi(3)
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  trander(i,j+1,k,n,3) = innder
               enddo
            else if (is_dirichlet(bct(n))) then
               do m=0,leny
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(2)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, leny+2, coef)
#if USE_TMP
               do k = lo(3), hi(3)
                  if ( flagbc .eq. 1 ) then
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = bcval(i,hi(2)+1,k,n)*coef(-1)
                     enddo
                  else
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = 0.0
                     enddo
                  endif
                  do m = 0, leny
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = tmp(i-lo(1))+u(i,hi(2)-m,k,n)*coef(m)
                     enddo
                  enddo
                  do i = lo(1), hi(1)
                     u(i,hi(2)+1,k,n) = cvmgt(
     $                    tmp(i-lo(1)),
     $                    u(i,hi(2)+1,k,n),
     $                    maskn(i,hi(2)+1,k) .gt. 0)
                  enddo
               enddo
#else
               if ( flagbc .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        u(i,hi(2)+1,k,n) = cvmgt(
     $                       bcval(i,hi(2)+1,k,n)*coef(-1),
     $                       u(i,hi(2)+1,k,n),
     $                       maskn(i,hi(2)+1,k) .gt. 0)
                     enddo
                  enddo
               else
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        u(i,hi(2)+1,k,n) = cvmgt(
     $                       0.0,
     $                       u(i,hi(2)+1,k,n),
     $                       maskn(i,hi(2)+1,k) .gt. 0)
                     enddo
                  enddo
               endif
               do k = lo(3), hi(3)
                  do m = 0, leny
                     do i = lo(1), hi(1)
                        u(i, hi(2)+1,k,n) = cvmgt(
     $                       u(i,hi(2)+1,k,n)
     $                       + u(i, hi(2)-m,k,n)*coef(m),
     $                       u(i,hi(2)+1,k,n),
     $                       maskn(i,hi(2)+1,k) .gt. 0)
                     enddo
                  enddo
               enddo
#endif
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        den(i,hi(2),k,n)   = cvmgt(coef(0), 0.0,
     $                       maskn(i,hi(2)+1,k) .gt. 0)
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential deriv part
c ::: ::: interior part first, followed by end points
               edgloc = 0.
               j=hi(2)
c ::: ::: ::: X
               do k=lo(3),hi(3)
                  do i=lo(1)+1, hi(1)-1
                     if( maskn(-1+i,1+j,k).eq.0.and.maskn(1+i,1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (-U(-1+i,1+j,k,n)+U(1+i,1+j,k,n))/(2.d0*hx)
                    elseif( maskn(i,1+j,k).eq.0.and.maskn(1+i,1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (-3*U(i,1+j,k,n)+4*U(1+i,1+j,k,n)-U(2+i,1+j,k,n))/(2.d0*hx
     &  )
                    elseif( maskn(-1+i,1+j,k).eq.0.and.maskn(i,1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (U(-2+i,1+j,k,n)-4*U(-1+i,1+j,k,n)+3*U(i,1+j,k,n))/(2.d0*h
     &  x)
                    else
                       outloc = x(-1)
                       if( flagbc .eq. 1 ) then
                          outder = exttd(i,j+1,k,n,1)
                       else
                          outder = 0.
                       endif
                    endif
                    innloc = 0.5
                    innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                    lambda = (edgloc-outloc)/(innloc-outloc)
                    trander(i,j+1,k,n,1) = lambda*innder+(1-lambda)*outder
                  enddo

                  i = lo(1)
                  if( maskn(-1+i,1+j,k).eq.0.and.maskn(1+i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-U(-1+i,1+j,k,n)+U(1+i,1+j,k,n))/(2.d0*hx)
                  elseif( maskn(i,1+j,k).eq.0.and.maskn(1+i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,1+j,k,n)+4*U(1+i,1+j,k,n)-U(2+i,1+j,k,n))/(2.d0*hx
     &  )
                  elseif( maskn(-1+i,1+j,k).eq.0.and.maskn(i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(-2+i,1+j,k,n)-4*U(-1+i,1+j,k,n)+3*U(i,1+j,k,n))/(2.d0*h
     &  x)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j+1,k,n,1)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maskw(-1+i,j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j+1,k,n,1) = lambda*innder+(1-lambda)*outder

                  i = hi(1)
                  if( maskn(-1+i,1+j,k).eq.0.and.maskn(1+i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-U(-1+i,1+j,k,n)+U(1+i,1+j,k,n))/(2.d0*hx)
                  elseif( maskn(i,1+j,k).eq.0.and.maskn(1+i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,1+j,k,n)+4*U(1+i,1+j,k,n)-U(2+i,1+j,k,n))/(2.d0*hx
     &  )
                  elseif( maskn(-1+i,1+j,k).eq.0.and.maskn(i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(-2+i,1+j,k,n)-4*U(-1+i,1+j,k,n)+3*U(i,1+j,k,n))/(2.d0*h
     &  x)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j+1,k,n,1)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maske(1+i,j,k).gt.0) then
                     innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j+1,k,n,1) = lambda*innder+(1-lambda)*outder                 
               enddo
c ::: ::: ::: Z
               do i=lo(1), hi(1)
                  do k=lo(3)+1,hi(3)-1
                     if( maskn(i,1+j,-1+k).eq.0.and.maskn(i,1+j,1+k).eq.0)then
                       outloc = -0.5
                       outder = (-U(i,1+j,-1+k,n)+U(i,1+j,1+k,n))/(2.d0*hz)
                    elseif( maskn(i,1+j,k).eq.0.and.maskn(i,1+j,1+k).eq.0)then
                       outloc = -0.5
                       outder = (-3*U(i,1+j,k,n)+4*U(i,1+j,1+k,n)-U(i,1+j,2+k,n))/(2.d0*hz
     &  )
                    elseif( maskn(i,1+j,-1+k).eq.0.and.maskn(i,1+j,k).eq.0)then
                       outloc = -0.5
                       outder = (U(i,1+j,-2+k,n)-4*U(i,1+j,-1+k,n)+3*U(i,1+j,k,n))/(2.d0*h
     &  z)
                    else
                       outloc = x(-1)
                       if( flagbc .eq. 1 ) then
                          outder = exttd(i,j+1,k,n,3)
                       else
                          outder = 0.
                       endif
                    endif
                    innloc = 0.5
                    innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                    lambda = (edgloc-outloc)/(innloc-outloc)
                    trander(i,j+1,k,n,3) = lambda*innder+(1-lambda)*outder
                  enddo

                  k = lo(3)
                  if( maskn(i,1+j,-1+k).eq.0.and.maskn(i,1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-U(i,1+j,-1+k,n)+U(i,1+j,1+k,n))/(2.d0*hz)
                  elseif( maskn(i,1+j,k).eq.0.and.maskn(i,1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,1+j,k,n)+4*U(i,1+j,1+k,n)-U(i,1+j,2+k,n))/(2.d0*hz
     &  )
                  elseif( maskn(i,1+j,-1+k).eq.0.and.maskn(i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(i,1+j,-2+k,n)-4*U(i,1+j,-1+k,n)+3*U(i,1+j,k,n))/(2.d0*h
     &  z)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j+1,k,n,3)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maskb(i,j,-1+k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,j,1+k,n)-U(i,j,2+k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j+1,k,n,3) = lambda*innder+(1-lambda)*outder

                  k = hi(3)
                  if( maskn(i,1+j,-1+k).eq.0.and.maskn(i,1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-U(i,1+j,-1+k,n)+U(i,1+j,1+k,n))/(2.d0*hz)
                  elseif( maskn(i,1+j,k).eq.0.and.maskn(i,1+j,1+k).eq.0)then
                    outloc = -0.5
                    outder = (-3*U(i,1+j,k,n)+4*U(i,1+j,1+k,n)-U(i,1+j,2+k,n))/(2.d0*hz
     &  )
                  elseif( maskn(i,1+j,-1+k).eq.0.and.maskn(i,1+j,k).eq.0)then
                    outloc = -0.5
                    outder = (U(i,1+j,-2+k,n)-4*U(i,1+j,-1+k,n)+3*U(i,1+j,k,n))/(2.d0*h
     &  z)
                  else
                    outloc = x(-1)
                    if( flagbc .eq. 1 ) then
                       outder = exttd(i,j+1,k,n,3)
                    else
                       outder = 0.
                    endif
                  endif
                  if(maskt(i,j,1+k).gt.0) then
                     innder = (U(i,j,-2+k,n)-4*U(i,j,-1+k,n)+3*U(i,j,k,n))/(2.d0*hz)
                  else
                     innder = (-U(i,j,-1+k,n)+U(i,j,1+k,n))/(2.d0*hz)
                  endif
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j+1,k,n,3) = lambda*innder+(1-lambda)*outder                 
               enddo
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               do k = lo(3), hi(3)
                  do i = lo(1), hi(1)
                     u(i, hi(2)+1, k, n) = cvmgt(
     $                   -u(i,hi(2),k,n),
     $                    u(i,hi(2)+1,k,n),
     $                    maskn(i,hi(2)+1,k) .gt. 0)
                     trander(i,hi(2)+1,k,n,1) = 0.
                     trander(i,hi(2)+1,k,n,3) = 0.
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do k = lo(3), hi(3)
                     do i = lo(1), hi(1)
                        den(i,hi(2),k,n) = cvmgt(-1.0, 0.0,
     $                       maskn(i,hi(2)+1,k) .gt. 0)
                     enddo
                  enddo
               endif
            else
               print *,'UNKNOWN BC ON TOP FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c
c     The bottom of the Grid
c
      if(cdir .eq. 2) then
         do n = 1,nc
           if(is_neumann(bct(n))) then
               do j = lo(2), hi(2)
                  do i = lo(1),hi(1)
                     u(i,j,lo(3)-1,n) = cvmgt(
     $                    u(i,j,lo(3),n),
     $                    u(i,j,lo(3)-1,n),
     $                    maskb(i,j,lo(3)-1) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1),hi(1)
                        den(i,j,lo(3),n)   = 1.0
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential derivative part
               k = lo(3)
c ::: ::: X
               do j=lo(2),hi(2)
c ::: ::: ::: interior part of bottom face
                  do i=lo(1)+1,hi(1)-1
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                     trander(i,j,k-1,n,1) = innder
                  enddo
                  i = lo(1)
                  if( maskw(-1+i,j,k).gt.0) then
                       innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                       innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j,k-1,n,1) = innder
                  i = hi(1)
                  if( maske(1+i,j,k).gt.0) then
                       innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                       innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j,k-1,n,1) = innder
               enddo
c ::: ::: ::: Y
               do i=lo(1),hi(1)
c ::: ::: ::: interior part of bottom face
                  do j=lo(2)+1,hi(2)-1
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                     trander(i,j,k-1,n,2) = innder
                  enddo
                  j = lo(2)
                  if( masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i,j,k-1,n,2) = innder
                  j = hi(2)
                  if( maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i,j,k-1,n,2) = innder
               enddo
            else if (is_dirichlet(bct(n))) then
               do m=0,lenz
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(3)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, lenz+2, coef)
#if USE_TMP
               do j = lo(2), hi(2)
                  if ( flagbc .eq. 1 ) then
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = bcval(i,j,lo(3)-1,n)*coef(-1)
                     enddo
                  else
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = 0.0
                     enddo
                  endif
                  do m = 0, lenz
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = tmp(i-lo(1))+u(i,j,lo(3)+m,n)*coef(m)
                     enddo
                  enddo
                  do i=lo(1),hi(1)
                     u(i,j,lo(3)-1,n) = cvmgt(
     &                    tmp(i-lo(1)),
     &                    u(i,j,lo(3)-1,n),
     &                    maskb(i,j,lo(3)-1).gt. 0 )
                  enddo
               enddo
#else
               if ( flagbc .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        u(i,j,lo(3)-1,n) = cvmgt(
     $                       bcval(i,j,lo(3)-1,n)*coef(-1),
     $                       u(i,j,lo(3)-1,n),
     $                       maskb(i,j,lo(3)-1) .gt. 0)
                     enddo
                  enddo
               else
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        u(i,j,lo(3)-1,n) = cvmgt(
     $                       0.0,
     $                       u(i,j,lo(3)-1,n),
     $                       maskb(i,j,lo(3)-1) .gt. 0)
                     enddo
                  enddo
               endif
               do j = lo(2), hi(2)
                  do m = 0, lenz
                     do i = lo(1), hi(1)
                        u(i, j, lo(3)-1, n) = cvmgt(
     $                       u(i, j, lo(3)-1,n)
     $                       + u(i, j, lo(3)+m, n)*coef(m),
     $                       u(i, j, lo(3)-1,n),
     $                       maskb(i, j, lo(3)-1) .gt. 0)
                     enddo
                  enddo
               enddo
#endif
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        den(i, j, lo(3),n)   = cvmgt(coef(0), 0.0,
     $                       maskb(i, j, lo(3)-1) .gt. 0)
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential deriv part
c ::: ::: interior part first, followed by end points
               edgloc = 0.
               k = lo(3)
c ::: ::: ::: X
               do j=lo(2),hi(2)
                  do i=lo(1)+1, hi(1)-1
                     if( maskb(-1+i,j,-1+k).eq.0.and.maskb(1+i,j,-1+k).eq.0)then
                        outloc = -0.5
                        outder = (-U(-1+i,j,-1+k,n)+U(1+i,j,-1+k,n))/(2.d0*hx)
                     else if( maskb(i,j,-1+k).eq.0.and.maskb(1+i,j,-1+k).eq.0)then
                        outloc = -0.5
                        outder = (-3*U(i,j,-1+k,n)+4*U(1+i,j,-1+k,n)-U(2+i,j,-1+k,n))/(2.d0
     &  *hx)
                     else if( maskb(-1+i,j,-1+k).eq.0.and.maskb(i,j,-1+k).eq.0)then
                        outloc = -0.5
                        outder = (U(-2+i,j,-1+k,n)-4*U(-1+i,j,-1+k,n)+3*U(i,j,-1+k,n))/(2.d
     &  0*hx)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1 ) then
                           outder = exttd(i,j,k-1,n,1)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-u(-1+i,j,k,n)+u(1+i,j,k,n))/(2.d0*hx)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i,j,k-1,n,1) = lambda*innder+(1-lambda)*outder
                  enddo

                  i = lo(1)
                  if( maskb(-1+i,j,-1+k).eq.0.and.maskb(1+i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,j,-1+k,n)+U(1+i,j,-1+k,n))/(2.d0*hx)
                  else if( maskb(i,j,-1+k).eq.0.and.maskb(1+i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,-1+k,n)+4*U(1+i,j,-1+k,n)-U(2+i,j,-1+k,n))/(2.d0
     &  *hx)
                  else if( maskb(-1+i,j,-1+k).eq.0.and.maskb(i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(-2+i,j,-1+k,n)-4*U(-1+i,j,-1+k,n)+3*U(i,j,-1+k,n))/(2.d
     &  0*hx)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k-1,n,1)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskw(-1+i,j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k-1,n,1) = lambda*innder+(1-lambda)*outder

                  i = hi(1)
                  if( maskb(-1+i,j,-1+k).eq.0.and.maskb(1+i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,j,-1+k,n)+U(1+i,j,-1+k,n))/(2.d0*hx)
                  else if( maskb(i,j,-1+k).eq.0.and.maskb(1+i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,-1+k,n)+4*U(1+i,j,-1+k,n)-U(2+i,j,-1+k,n))/(2.d0
     &  *hx)
                  else if( maskb(-1+i,j,-1+k).eq.0.and.maskb(i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(-2+i,j,-1+k,n)-4*U(-1+i,j,-1+k,n)+3*U(i,j,-1+k,n))/(2.d
     &  0*hx)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k-1,n,1)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maske(1+i,j,k).gt.0) then
                     innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k-1,n,1) = lambda*innder+(1-lambda)*outder
               enddo
c ::: ::: ::: Y               
               do i=lo(1), hi(1)
                  do j=lo(2)+1,hi(2)-1
                     if( maskb(i,-1+j,-1+k).eq.0.and.maskb(i,1+j,-1+k).eq.0)then
                        outloc = -0.5
                        outder = (-U(i,-1+j,-1+k,n)+U(i,1+j,-1+k,n))/(2.d0*hy)
                     else if( maskb(i,j,-1+k).eq.0.and.maskb(i,1+j,-1+k).eq.0)then
                        outloc = -0.5
                        outder = (-3*U(i,j,-1+k,n)+4*U(i,1+j,-1+k,n)-U(i,2+j,-1+k,n))/(2.d0
     &  *hy)
                     else if( maskb(i,-1+j,-1+k).eq.0.and.maskb(i,j,-1+k).eq.0)then
                        outloc = -0.5
                        outder = (U(i,-2+j,-1+k,n)-4*U(i,-1+j,-1+k,n)+3*U(i,j,-1+k,n))/(2.d
     &  0*hy)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1 ) then
                           outder = exttd(i,j,k-1,n,2)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-u(i,-1+j,k,n)+u(i,1+j,k,n))/(2.d0*hy)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i,j,k-1,n,2) = lambda*innder+(1-lambda)*outder
                  enddo

                  j = lo(2)
                  if( maskb(i,-1+j,-1+k).eq.0.and.maskb(i,1+j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(i,-1+j,-1+k,n)+U(i,1+j,-1+k,n))/(2.d0*hy)
                  else if( maskb(i,j,-1+k).eq.0.and.maskb(i,1+j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,-1+k,n)+4*U(i,1+j,-1+k,n)-U(i,2+j,-1+k,n))/(2.d0
     &  *hy)
                  else if( maskb(i,-1+j,-1+k).eq.0.and.maskb(i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(i,-2+j,-1+k,n)-4*U(i,-1+j,-1+k,n)+3*U(i,j,-1+k,n))/(2.d
     &  0*hy)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k-1,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k-1,n,2) = lambda*innder+(1-lambda)*outder

                  j = hi(2)
                  if( maskb(i,-1+j,-1+k).eq.0.and.maskb(i,1+j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(i,-1+j,-1+k,n)+U(i,1+j,-1+k,n))/(2.d0*hy)
                  else if( maskb(i,j,-1+k).eq.0.and.maskb(i,1+j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,-1+k,n)+4*U(i,1+j,-1+k,n)-U(i,2+j,-1+k,n))/(2.d0
     &  *hy)
                  else if( maskb(i,-1+j,-1+k).eq.0.and.maskb(i,j,-1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(i,-2+j,-1+k,n)-4*U(i,-1+j,-1+k,n)+3*U(i,j,-1+k,n))/(2.d
     &  0*hy)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k-1,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k-1,n,2) = lambda*innder+(1-lambda)*outder
               enddo
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     u(i, j, lo(3)-1, n) = cvmgt(
     $                   -u(i,j,lo(3),n),
     $                    u(i,j,lo(3)-1,n),
     $                    maskb(i,j,lo(3)-1) .gt. 0)
                     trander(i,j,lo(3)-1,n,1) = 0.
                     trander(i,j,lo(3)-1,n,2) = 0.
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        den(i,j,lo(3),n) = cvmgt(-1.0, 0.0,
     $                       maskb(i,j,lo(3)-1) .gt. 0)
                     enddo
                  enddo
               endif
            else
               print *,'UNKNOWN BC ON FRONT FACE IN APPLYBC'
               stop
            endif
         enddo
      endif
c
c     The top of the grid
c
      if (cdir .eq. 5) then
         do n = 1,nc
            if(is_neumann(bct(n))) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     u(i,j, hi(3)+1,n) = cvmgt(
     $                    u(i,j, hi(3),n),
     $                    u(i,j, hi(3)+1,n),
     $                    maskt(i,j, hi(3)+1) .gt. 0)
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        den(i,j, hi(3),n)   = 1.0
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential derivative part
               k = hi(3)
c ::: ::: X
               do j=lo(2),hi(2)
c ::: ::: ::: interior part of bottom face
                  do i=lo(1)+1,hi(1)-1
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                     trander(i,j,k+1,n,1) = innder
                  enddo
                  i = lo(1)
                  if( maskw(-1+i,j,k).gt.0) then
                       innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                       innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j,k+1,n,1) = innder
                  i = hi(1)
                  if( maske(1+i,j,k).gt.0) then
                       innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                       innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif
                  trander(i,j,k+1,n,1) = innder
               enddo
c ::: ::: ::: Y
               do i=lo(1),hi(1)
c ::: ::: ::: interior part of bottom face
                  do j=lo(2)+1,hi(2)-1
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                     trander(i,j,k+1,n,2) = innder
                  enddo
                  j = lo(2)
                  if( masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i,j,k+1,n,2) = innder
                  j = hi(2)
                  if( maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif
                  trander(i,j,k+1,n,2) = innder
               enddo
            else if (is_dirichlet(bct(n))) then
               do m=0,lenz
                  x(m) = m + 0.5
               enddo
               x(-1) = - bcl/h(3)
               xInt = - 0.5
               call polyInterpCoeff(xInt, x, lenz+2, coef)
#if USE_TMP
               do j = lo(2), hi(2)
                  if ( flagbc .eq. 1 ) then
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = bcval(i,j, hi(3)+1,n)*coef(-1)
                     enddo
                  else
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = 0.0
                     enddo
                  endif
                  do m = 0, lenz
                     do i = lo(1), hi(1)
                        tmp(i-lo(1)) = tmp(i-lo(1))
     $                       + u(i, j, hi(3)-m,n)*coef(m)
                     enddo
                  enddo
                  do i = lo(1), hi(1)
                     u(i,j, hi(3)+1,n) = cvmgt(
     $                    tmp(i-lo(1)),
     $                    u(i,j, hi(3)+1,n),
     $                    maskt(i,j, hi(3)+1) .gt. 0)
                  enddo
               enddo
#else
               if ( flagbc .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        u(i,j, hi(3)+1,n) = cvmgt(
     $                       bcval(i,j, hi(3)+1,n)*coef(-1),
     $                       u(i,j, hi(3)+1,n),
     $                       maskt(i,j, hi(3)+1) .gt. 0)
                     enddo
                  enddo
               else
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        u(i,j, hi(3)+1,n) = cvmgt(
     $                       0.0,
     $                       u(i,j, hi(3)+1,n),
     $                       maskt(i,j, hi(3)+1) .gt. 0)
                     enddo
                  enddo
               endif
               do j = lo(2), hi(2)
                  do m = 0, lenz
                     do i = lo(1), hi(1)
                        u(i, j, hi(3)+1,n) = cvmgt(
     $                       u(i,j, hi(3)+1,n)
     $                       + u(i, j, hi(3)-m,n)*coef(m),
     $                       u(i,j, hi(3)+1,n),
     $                       maskt(i,j, hi(3)+1) .gt. 0)
                     enddo
                  enddo
               enddo
#endif
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        den(i,j, hi(3),n)   = cvmgt(coef(0), 0.0,
     $                       maskt(i,j, hi(3)+1) .gt. 0)
                     enddo
                  enddo
               endif
c ::: ::: now do the tangential deriv part
c ::: ::: interior part first, followed by end points
               edgloc = 0.
               k = hi(3)
c ::: ::: ::: X
               do j=lo(2),hi(2)
                  do i=lo(1)+1, hi(1)-1
                     if( maskt(-1+i,j,1+k).eq.0.and.maskt(1+i,j,1+k).eq.0)then
                        outloc = -0.5
                        outder = (-U(-1+i,j,1+k,n)+U(1+i,j,1+k,n))/(2.d0*hx)
                     else if( maskt(i,j,1+k).eq.0.and.maskt(1+i,j,1+k).eq.0)then
                        outloc = -0.5
                        outder = (-3*U(i,j,1+k,n)+4*U(1+i,j,1+k,n)-U(2+i,j,1+k,n))/(2.d0*hx
     &  )
                     else if( maskt(-1+i,j,1+k).eq.0.and.maskt(i,j,1+k).eq.0)then
                        outloc = -0.5
                        outder = (U(-2+i,j,1+k,n)-4*U(-1+i,j,1+k,n)+3*U(i,j,1+k,n))/(2.d0*h
     &  x)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1 ) then
                           outder = exttd(i,j,k+1,n,1)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-u(-1+i,j,k,n)+u(1+i,j,k,n))/(2.d0*hx)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i,j,k+1,n,1) = lambda*innder+(1-lambda)*outder
                  enddo

                  i = lo(1)
                  if( maskt(-1+i,j,1+k).eq.0.and.maskt(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,j,1+k,n)+U(1+i,j,1+k,n))/(2.d0*hx)
                  else if( maskt(i,j,1+k).eq.0.and.maskt(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,1+k,n)+4*U(1+i,j,1+k,n)-U(2+i,j,1+k,n))/(2.d0*hx
     &  )
                  else if( maskt(-1+i,j,1+k).eq.0.and.maskt(i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(-2+i,j,1+k,n)-4*U(-1+i,j,1+k,n)+3*U(i,j,1+k,n))/(2.d0*h
     &  x)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k+1,n,1)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskw(-1+i,j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(1+i,j,k,n)-U(2+i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k+1,n,1) = lambda*innder+(1-lambda)*outder

                  i = hi(1)
                  if( maskt(-1+i,j,1+k).eq.0.and.maskt(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(-1+i,j,1+k,n)+U(1+i,j,1+k,n))/(2.d0*hx)
                  else if( maskt(i,j,1+k).eq.0.and.maskt(1+i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,1+k,n)+4*U(1+i,j,1+k,n)-U(2+i,j,1+k,n))/(2.d0*hx
     &  )
                  else if( maskt(-1+i,j,1+k).eq.0.and.maskt(i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(-2+i,j,1+k,n)-4*U(-1+i,j,1+k,n)+3*U(i,j,1+k,n))/(2.d0*h
     &  x)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k+1,n,1)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maske(1+i,j,k).gt.0) then
                     innder = (U(-2+i,j,k,n)-4*U(-1+i,j,k,n)+3*U(i,j,k,n))/(2.d0*hx)
                  else
                     innder = (-U(-1+i,j,k,n)+U(1+i,j,k,n))/(2.d0*hx)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k+1,n,1) = lambda*innder+(1-lambda)*outder
               enddo
c ::: ::: ::: Y               
               do i=lo(1), hi(1)
                  do j=lo(2)+1,hi(2)-1
                     if( maskt(i,-1+j,1+k).eq.0.and.maskt(i,1+j,1+k).eq.0)then
                        outloc = -0.5
                        outder = (-U(i,-1+j,1+k,n)+U(i,1+j,1+k,n))/(2.d0*hy)
                     else if( maskt(i,j,1+k).eq.0.and.maskt(i,1+j,1+k).eq.0)then
                        outloc = -0.5
                        outder = (-3*U(i,j,1+k,n)+4*U(i,1+j,1+k,n)-U(i,2+j,1+k,n))/(2.d0*hy
     &  )
                     else if( maskt(i,-1+j,1+k).eq.0.and.maskt(i,j,1+k).eq.0)then
                        outloc = -0.5
                        outder = (U(i,-2+j,1+k,n)-4*U(i,-1+j,1+k,n)+3*U(i,j,1+k,n))/(2.d0*h
     &  y)
                     else
                        outloc = x(-1)
                        if( flagbc .eq. 1 ) then
                           outder = exttd(i,j,k+1,n,2)
                        else
                           outder = 0.
                        endif
                     endif
                     innloc = 0.5
                     innder = (-u(i,-1+j,k,n)+u(i,1+j,k,n))/(2.d0*hy)
                     lambda = (edgloc-outloc)/(innloc-outloc)
                     trander(i,j,k+1,n,2) = lambda*innder+(1-lambda)*outder
                  enddo

                  j = lo(2)
                  if( maskt(i,-1+j,1+k).eq.0.and.maskt(i,1+j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(i,-1+j,1+k,n)+U(i,1+j,1+k,n))/(2.d0*hy)
                  else if( maskt(i,j,1+k).eq.0.and.maskt(i,1+j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,1+k,n)+4*U(i,1+j,1+k,n)-U(i,2+j,1+k,n))/(2.d0*hy
     &  )
                  else if( maskt(i,-1+j,1+k).eq.0.and.maskt(i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(i,-2+j,1+k,n)-4*U(i,-1+j,1+k,n)+3*U(i,j,1+k,n))/(2.d0*h
     &  y)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k+1,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(masks(i,-1+j,k).gt.0) then
                     innder = (-3*U(i,j,k,n)+4*U(i,1+j,k,n)-U(i,2+j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k+1,n,2) = lambda*innder+(1-lambda)*outder

                  j = hi(2)
                  if( maskt(i,-1+j,1+k).eq.0.and.maskt(i,1+j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-U(i,-1+j,1+k,n)+U(i,1+j,1+k,n))/(2.d0*hy)
                  else if( maskt(i,j,1+k).eq.0.and.maskt(i,1+j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (-3*U(i,j,1+k,n)+4*U(i,1+j,1+k,n)-U(i,2+j,1+k,n))/(2.d0*hy
     &  )
                  else if( maskt(i,-1+j,1+k).eq.0.and.maskt(i,j,1+k).eq.0)then
                     outloc = -0.5
                     outder = (U(i,-2+j,1+k,n)-4*U(i,-1+j,1+k,n)+3*U(i,j,1+k,n))/(2.d0*h
     &  y)
                  else
                     outloc = x(-1)
                     if( flagbc .eq. 1 ) then
                        outder = exttd(i,j,k+1,n,2)
                     else
                        outder = 0.
                     endif
                  endif
                  if(maskn(i,1+j,k).gt.0) then
                     innder = (U(i,-2+j,k,n)-4*U(i,-1+j,k,n)+3*U(i,j,k,n))/(2.d0*hy)
                  else
                     innder = (-U(i,-1+j,k,n)+U(i,1+j,k,n))/(2.d0*hy)
                  endif                     
                  innloc = 0.5
                  lambda = (edgloc-outloc)/(innloc-outloc)
                  trander(i,j,k+1,n,2) = lambda*innder+(1-lambda)*outder
               enddo
            else if ( bct(n) .eq. LO_REFLECT_ODD ) then
               do j = lo(2), hi(2)
                  do i = lo(1), hi(1)
                     u(i, j, hi(3)+1, n) = cvmgt(
     $                   -u(i,j,hi(3),n),
     $                    u(i,j,hi(3)+1,n),
     $                    maskt(i,j,hi(3)+1) .gt. 0)
                     trander(i,j,hi(3)+1,n,1) = 0.
                     trander(i,j,hi(3)+1,n,2) = 0.
                  enddo
               enddo
               if ( flagden .eq. 1 ) then
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        den(i,j,hi(3),n) = cvmgt(-1.0, 0.0,
     $                       maskt(i,j,hi(3)+1) .gt. 0)
                     enddo
                  enddo
               endif
            else
               print *,'UNKNOWN BC ON BACK FACE IN APPLYBC'
               stop
            endif
	 enddo
      endif
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: ABec_2D.F,v 1.9 2002/11/27 21:54:35 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>

#include "ABec_F.H"
#include "ArrayLim.H"
#include "CONSTANTS.H"

c-----------------------------------------------------------------------
c      
c     Gauss-Seidel Red-Black (GSRB):
c     Apply the GSRB relaxation to the state phi for the equation
c     L(phi) = alpha*a(x)*phi(x) - beta*Div(b(x)Grad(phi(x))) = rhs(x)
c     central differenced, according to the arrays of boundary
c     masks (m#) and auxiliary data (f#).
c     
c     In general, if the linear operator L=gamma*y-rho, the GS relaxation
c     is y = (R - rho)/gamma.  Near a boundary, the ghost data is filled
c     using a polynomial interpolant based on the "old" phi values, so
c     L=(gamma-delta)*y - rho + delta*yOld.   The resulting iteration is
c     
c     y = (R - delta*yOld + rho)/(gamma - delta)
c     
c     This expression is valid additionally in the interior provided
c     delta->0 there.  delta is constructed by summing all the
c     contributions to the central stencil element coming from boundary 
c     interpolants.  The f#s contain the corresponding coefficient of 
c     the interpolating polynomial.  The masks are set > 0 if the boundary 
c     value was filled with an interpolant involving the central stencil 
c     element.
c     
c-----------------------------------------------------------------------
      subroutine FORT_GSRB (
     $     phi,DIMS(phi),
     $     rhs,DIMS(rhs),
     $     alpha, beta,
     $     a,  DIMS(a),
     $     bX, DIMS(bX),
     $     bY, DIMS(bY),
     $     f0, DIMS(f0),
     $     m0, DIMS(m0),
     $     f1, DIMS(f1),
     $     m1, DIMS(m1),
     $     f2, DIMS(f2),
     $     m2, DIMS(m2),
     $     f3, DIMS(f3),
     $     m3, DIMS(m3),
     $     lo,hi,nc,
     $     h,redblack
     $     )
      REAL_T alpha, beta
      integer DIMDEC(phi)
      integer DIMDEC(rhs)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM)
      integer nc
      integer redblack
      integer DIMDEC(f0)
      REAL_T f0(DIMV(f0))
      integer DIMDEC(f1)
      REAL_T f1(DIMV(f1))
      integer DIMDEC(f2)
      REAL_T f2(DIMV(f2))
      integer DIMDEC(f3)
      REAL_T f3(DIMV(f3))
      integer DIMDEC(m0)
      integer m0(DIMV(m0))
      integer DIMDEC(m1)
      integer m1(DIMV(m1))
      integer DIMDEC(m2)
      integer m2(DIMV(m2))
      integer DIMDEC(m3)
      integer m3(DIMV(m3))
      REAL_T  h(BL_SPACEDIM)
      REAL_T   phi(DIMV(phi),nc)
      REAL_T   rhs(DIMV(rhs),nc)
      REAL_T     a(DIMV(a))
      REAL_T    bX(DIMV(bX))
      REAL_T    bY(DIMV(bY))
c
      integer  i, j, ioff, n
c
      REAL_T dhx, dhy, cf0, cf1, cf2, cf3
      REAL_T delta, gamma, rho, rho_x, rho_y

      integer LSDIM
      parameter(LSDIM=127)
      REAL_T a_ls(0:LSDIM)
      REAL_T b_ls(0:LSDIM)
      REAL_T c_ls(0:LSDIM)
      REAL_T r_ls(0:LSDIM)
      REAL_T u_ls(0:LSDIM)

      integer do_line
      integer ilen,jlen
      
      if (h(2). gt. 1.5D0*h(1)) then 
        do_line = 1
        ilen = hi(1)-lo(1)+1
        if (ilen .gt. LSDIM) then
          print *,'TOO BIG FOR LINE SOLVE IN GSRB: ilen = ',ilen
          call bl_error("stop")
        end if
      else if (h(1) .gt. 1.5D0*h(2)) then
        do_line = 2
        jlen = hi(2)-lo(2)+1
        if (jlen .gt. LSDIM) then
          print *,'TOO BIG FOR LINE SOLVE IN GSRB: jlen = ',jlen
          call bl_error("stop")
        end if
      else 
        do_line = 0
      end if

c
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
      do n = 1, nc
       if (do_line .eq. 0) then
         do j = lo(2), hi(2)
            ioff = MOD(j + redblack,2)
            do i = lo(1) + ioff,hi(1),2
c     
               cf0 = cvmgt(f0(lo(1),j), 0.0D0,
     $              (i .eq. lo(1)) .and. (m0(lo(1)-1,j).gt.0))
               cf1 = cvmgt(f1(i,lo(2)), 0.0D0,
     $              (j .eq. lo(2)) .and. (m1(i,lo(2)-1).gt.0))
               cf2 = cvmgt(f2(hi(1),j), 0.0D0,
     $              (i .eq. hi(1)) .and. (m2(hi(1)+1,j).gt.0))
               cf3 = cvmgt(f3(i,hi(2)), 0.0D0,
     $              (j .eq. hi(2)) .and. (m3(i,hi(2)+1).gt.0))
c     
               delta = dhx*(bX(i,j)*cf0 + bX(i+1,j)*cf2)
     $              +  dhy*(bY(i,j)*cf1 + bY(i,j+1)*cf3)
c     
               gamma = alpha*a(i,j)
     $              +   dhx*( bX(i,j) + bX(i+1,j) )
     $              +   dhy*( bY(i,j) + bY(i,j+1) )
c     
               rho = dhx*(bX(i,j)*phi(i-1,j,n) + bX(i+1,j)*phi(i+1,j,n))
     $              +dhy*(bY(i,j)*phi(i,j-1,n) + bY(i,j+1)*phi(i,j+1,n))
c     
               phi(i,j,n) = (rhs(i,j,n) + rho - phi(i,j,n)*delta)
     $              /                (gamma - delta)
c     
            end do
         end do
       else if (do_line .eq. 2) then
         do i = lo(1) + redblack,hi(1),2
             do j = lo(2), hi(2)
c     
               cf0 = cvmgt(f0(lo(1),j), 0.0D0,
     $              (i .eq. lo(1)) .and. (m0(lo(1)-1,j).gt.0))
               cf1 = cvmgt(f1(i,lo(2)), 0.0D0,
     $              (j .eq. lo(2)) .and. (m1(i,lo(2)-1).gt.0))
               cf2 = cvmgt(f2(hi(1),j), 0.0D0,
     $              (i .eq. hi(1)) .and. (m2(hi(1)+1,j).gt.0))
               cf3 = cvmgt(f3(i,hi(2)), 0.0D0,
     $              (j .eq. hi(2)) .and. (m3(i,hi(2)+1).gt.0))
c     
               delta = dhx*(bX(i,j)*cf0 + bX(i+1,j)*cf2)
     $               + dhy*(bY(i,j)*cf1 + bY(i,j+1)*cf3)
c     
               gamma = alpha*a(i,j)
     $              +   dhx*( bX(i,j) + bX(i+1,j) )
     $              +   dhy*( bY(i,j) + bY(i,j+1) )
c     
               rho_x = dhx*(bX(i,j)*phi(i-1,j,n) + bX(i+1,j)*phi(i+1,j,n))

               a_ls(j-lo(2)) = -dhy*bY(i,j)
               b_ls(j-lo(2)) = gamma - delta
               c_ls(j-lo(2)) = -dhy*bY(i,j+1)
               r_ls(j-lo(2)) = rhs(i,j,n) + rho_x - phi(i,j,n)*delta

               if (j .eq. lo(2)) 
     $            r_ls(j-lo(2)) = r_ls(j-lo(2)) + dhy*bY(i,j)*phi(i,j-1,n)

               if (j .eq. hi(2)) 
     $            r_ls(j-lo(2)) = r_ls(j-lo(2)) + dhy*bY(i,j+1)*phi(i,j+1,n)

             end do

             call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,jlen)
c     
             do j = lo(2), hi(2)
               phi(i,j,n) = u_ls(j-lo(2))
             end do
         end do

       else if (do_line .eq. 1) then

           do j = lo(2) + redblack,hi(2),2
             do i = lo(1), hi(1)
c     
               cf0 = cvmgt(f0(lo(1),j), 0.0D0,
     $              (i .eq. lo(1)) .and. (m0(lo(1)-1,j).gt.0))
               cf1 = cvmgt(f1(i,lo(2)), 0.0D0,
     $              (j .eq. lo(2)) .and. (m1(i,lo(2)-1).gt.0))
               cf2 = cvmgt(f2(hi(1),j), 0.0D0,
     $              (i .eq. hi(1)) .and. (m2(hi(1)+1,j).gt.0))
               cf3 = cvmgt(f3(i,hi(2)), 0.0D0,
     $              (j .eq. hi(2)) .and. (m3(i,hi(2)+1).gt.0))
c     
               delta = dhx*(bX(i,j)*cf0 + bX(i+1,j)*cf2)
     $               + dhy*(bY(i,j)*cf1 + bY(i,j+1)*cf3)
c     
               gamma = alpha*a(i,j)
     $              +   dhx*( bX(i,j) + bX(i+1,j) )
     $              +   dhy*( bY(i,j) + bY(i,j+1) )
c     
               rho_y = dhy*(bY(i,j)*phi(i,j-1,n) + bY(i,j+1)*phi(i,j+1,n))

               a_ls(i-lo(1)) = -dhx*bX(i,j)
               b_ls(i-lo(1)) = gamma - delta
               c_ls(i-lo(1)) = -dhx*bX(i+1,j)
               r_ls(i-lo(1)) = rhs(i,j,n) + rho_y - phi(i,j,n)*delta

               if (i .eq. lo(1)) 
     $            r_ls(i-lo(1)) = r_ls(i-lo(1)) + dhx*bX(i,j)*phi(i-1,j,n)

               if (i .eq. hi(1)) 
     $            r_ls(i-lo(1)) = r_ls(i-lo(1)) + dhx*bX(i+1,j)*phi(i+1,j,n)
             end do

             call tridiag(a_ls,b_ls,c_ls,r_ls,u_ls,ilen)
c     
             do i = lo(1), hi(1)
               phi(i,j,n) = u_ls(i-lo(1))
             end do
         end do

       else
         print *,'BOGUS DO_LINE '
         call bl_error("stop")
       end if
      end do

      end
      
c-----------------------------------------------------------------------
c
c     Solve Preconditioned system here
c
      subroutine FORT_CGPRECND(
     $     zz,DIMS(zz),
     $     rho,
     $     rr,DIMS(rr),
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     lo,hi,nc,
     $     h
     $     )
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(zz)
      integer DIMDEC(rr)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      REAL_T zz(DIMV(zz),nc)
      REAL_T rr(DIMV(rr),nc)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T h(BL_SPACEDIM), rho
c
      integer i,j, n
      REAL_T de, dhx, dhy
c
      rho = 0
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               de = 1.0D0/(alpha*a(i,j) + dhx*(bX(i+1,j)+bX(i,j))
     $              + dhy*(bY(i,j+1)+bY(i,j))
     $              )
               zz(i,j,n) = rr(i,j,n)*de
               rho = rho + zz(i,j,n)*rr(i,j,n)
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
c
c     Fill in a matrix x vector operator here
c
      subroutine FORT_ADOTX(
     $     y,DIMS(y),
     $     x,DIMS(x),
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     lo,hi,nc,
     $     h
     $     )
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(y)
      integer DIMDEC(x)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      REAL_T  y(DIMV(y),nc)
      REAL_T  x(DIMV(x),nc)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T h(BL_SPACEDIM)
c
      integer i,j,n
      REAL_T uxx,uyy,dhx,dhy
c
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               y(i,j,n) = alpha*a(i,j)*x(i,j,n)
     $              - dhx*
     $              (   bX(i+1,j)*( x(i+1,j,n) - x(i  ,j,n) )
     $              -   bX(i  ,j)*( x(i  ,j,n) - x(i-1,j,n) ) )
     $              - dhy*
     $              (   bY(i,j+1)*( x(i,j+1,n) - x(i,j  ,n) )
     $              -   bY(i,j  )*( x(i,j  ,n) - x(i,j-1,n) ) )
            end do
         end do
      end do
      end

c-----------------------------------------------------------------------
c
c     Fill in a matrix x vector operator here
c
      subroutine FORT_NORMA(
     &     res,
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     lo,hi,nc,
     $     h
     $     )
      REAL_T res
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T h(BL_SPACEDIM)
c
      integer i,j,n
      REAL_T uxx,uyy,dhx,dhy
c
      dhx = beta/h(1)**2
      dhy = beta/h(2)**2
c
      res = 0.0D0
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               res = max(res, 
     &              + abs( alpha*a(i,j) 
     &                   + dhx * (bX(i+1,j) + bX(i,j)) 
     &                   + dhy * (bY(i,j+1) + bY(i,j)))
     $              + abs(-dhx*bX(i+1,j)) + abs(-dhx*bX(i,j))
     &              + abs(-dhy*bY(i,j+1)) + abs(-dhy*bY(i,j)))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c
c     Fill in fluxes
c
      subroutine FORT_FLUX(
     $     x,DIMS(x),
     $     alpha, beta,
     $     a, DIMS(a),
     $     bX,DIMS(bX),
     $     bY,DIMS(bY),
     $     lo,hi,nc,
     $     h,
     $     xflux,DIMS(xflux),
     $     yflux,DIMS(yflux)
     $     )
      implicit none
      REAL_T alpha, beta
      integer lo(BL_SPACEDIM), hi(BL_SPACEDIM), nc
      integer DIMDEC(x)
      integer DIMDEC(a)
      integer DIMDEC(bX)
      integer DIMDEC(bY)
      integer DIMDEC(xflux)
      integer DIMDEC(yflux)
      REAL_T  x(DIMV(x),nc)
      REAL_T  a(DIMV(a))
      REAL_T bX(DIMV(bX))
      REAL_T bY(DIMV(bY))
      REAL_T xflux(DIMV(xflux),nc)
      REAL_T yflux(DIMV(yflux),nc)
      REAL_T h(BL_SPACEDIM)
c
      REAL_T dhx, dhy
      integer i,j,n
c
      dhx = one/h(1)
      dhy = one/h(2)
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)+1
               xflux(i,j,n) = - dhx*bX(i,j)*( x(i,j,n) - x(i-1,j,n) )
            end do
         end do
      end do
      do n = 1, nc
         do j = lo(2), hi(2)+1
            do i = lo(1), hi(1)
               yflux(i,j,n) = - dhy*bY(i,j)*( x(i,j,n) - x(i,j-1,n) )
            end do
         end do
      end do
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: COORDSYS_2D.F,v 1.10 2002/12/30 22:09:45 almgren Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "COORDSYS_F.H"
#include "ArrayLim.H"

#define SDIM 2

c :: ----------------------------------------------------------
c :: SETVOL
c ::             Compute the volume of each cell
c ::
c :: INPUTS / OUTPUTS:
c ::  vol         <=  volume array
c ::  vlo,vhi      => index limits of vol array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 = cartesian, 1 = RZ, 2 = RTHETA)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETVOL(vol,DIMS(vol),offset,dx,coord)
       integer    DIMDEC(vol)
       integer    coord
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     vol(DIMV(vol))
       
       integer    i, j
       REAL_T     ri, ro, pi, po, v
       REAL_T     RZFACTOR
       parameter (RZFACTOR = 2.d0*3.14159265358979323846d0)
       
       if (coord .eq. 0) then
c
c         ::::: cartesian
c
          v = dx(1)*dx(2)
          do j = ARG_L2(vol), ARG_H2(vol)
             do i = ARG_L1(vol), ARG_H1(vol)
                vol(i,j) = v
             end do
          end do
       elseif(coord .eq. 1) then
c
c         ::::: R-Z
c
          do i = ARG_L1(vol), ARG_H1(vol)
             ri = offset(1) + dx(1)*i
             ro = ri + dx(1)
             v = (half*RZFACTOR)*dx(2)*dx(1)*(ro + ri)
             do j = ARG_L2(vol), ARG_H2(vol)
                vol(i,j) = abs(v)
             end do
          end do
       elseif(coord .eq. 2) then
c
c  	  ::::: R-THETA
c
          do i = ARG_L1(vol), ARG_H1(vol)
             ri = offset(1) + dx(1)*i
             ro = ri + dx(1)
             do j = ARG_L2(vol), ARG_H2(vol)
                pi = offset(2) + dx(2)*j
                po = pi + dx(2)
                v = RZFACTOR*(ro**3 - ri**3)*(cos(pi)-cos(po))/three
                vol(i,j) = abs(v)
             enddo
          enddo

       end if
       
       end

c========================================================
c========================================================
        subroutine FORT_SETVOLPT(vol,
     $          ro, ri, po, pi,  dx, coord)

        integer coord
        REAL_T dx(SDIM)
        REAL_T     vol
        REAL_T     ro, po, pi
        REAL_T     ri

        REAL_T     RZFACTOR
        parameter (RZFACTOR = 2*Pi)

        if(coord .eq. 0) then
           vol = (ro-ri)*dx(2)
        elseif(coord .eq. 1) then
           vol = half*RZFACTOR*dx(2)*(ro**2 - ri**2)
           vol = abs(vol)
        elseif(coord .eq. 2) then
           vol = RZFACTOR*(ro**3-ri**3)*(cos(pi)-cos(po))/three
        else
            call bl_abort('bogus value of coord ... bndrylib::SETVOLPT')
        endif

        return
        end



c :: ----------------------------------------------------------
c :: SETDLOGA
c ::             Compute  d(log(A))/dr in each cell
c ::
c :: INPUTS / OUTPUTS:
c ::  dloga        <=  dloga array
c ::  dlo,dhi      => index limits of dloga array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 = cartesian, 1 = RZ)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETDLOGA(dloga,DIMS(dloga),offset,dx,dir,coord)

       integer    DIMDEC(dloga)
       integer    coord
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     dloga(DIMV(dloga))
       integer dir
       
       integer    i, j
       REAL_T     ri, ro, dlga, po, pi
       
       if (coord .eq. 0) then
c
c         ::::: cartesian
c
          do j = ARG_L2(dloga), ARG_H2(dloga)
             do i = ARG_L1(dloga), ARG_H1(dloga)
                dloga(i,j) = zero
             end do
          end do

       else if( coord .eq. 1 ) then
c
c         ::::: R-Z
c
          if( dir .eq. 0 ) then
             do i = ARG_L1(dloga), ARG_H1(dloga)
                ri = offset(1) + dx(1)*i
                ro = ri + dx(1)
                dlga = two/(ro+ri)                                        
                do j = ARG_L2(dloga), ARG_H2(dloga)
                   dloga(i,j) = dlga
                end do
             end do
          else if( dir .eq. 1 ) then
             do i = ARG_L1(dloga), ARG_H1(dloga)
                ri = offset(1) + dx(1)*i
                ro = ri + dx(1)
                dlga = two/(ro+ri)                                        
                do j = ARG_L2(dloga), ARG_H2(dloga)
                   dloga(i,j) = zero
                end do
             end do
          else
             call bl_abort('setdloga: illegal direction')
          end if
       else if( coord .eq. 2) then
          if(dir .eq. 0) then
             do i = ARG_L1(dloga), ARG_H1(dloga)
                ri = offset(1) + dx(1)*i
                ri = ri
                ro = ri + dx(1)
                ro = ro
                dlga = four/(ro+ri)
                do j = ARG_L2(dloga), ARG_H2(dloga)
                   dloga(i,j) = dlga
                enddo
             enddo
          elseif(dir .eq. 1) then
             do i = ARG_L1(dloga), ARG_H1(dloga)
                ri = offset(1) + dx(1)*i
                ri = ri
                ro = ri + dx(1)
                ro = ro
                dlga = two/(ro+ri)
                do j = ARG_L2(dloga), ARG_H2(dloga)
                   pi = offset(2) + dx(2)*j
                   po = pi + dx(2)
                   dloga(i,j) = dlga/tan(half*(pi+po))
                enddo
             enddo
	  else
          call bl_abort('setdloga: illegal coordinate system')
	  endif
       end if
       
       end

c :: ----------------------------------------------------------
c :: SETAREA
c ::             Compute the area of given cell face
c ::
c :: INPUTS / OUTPUTS:
c ::  area        <=  area array
c ::  alo,ahi      => index limits of area array
c ::  offset       => shift to origin of computational domain
c ::  dx           => cell size
c ::  coord        => coordinate flag (0 =cartesian, 1 = RZ)
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SETAREA(area,DIMS(area),offset,dx,dir,coord)

       integer    DIMDEC(area)
       integer    coord, dir
       REAL_T     dx(SDIM), offset(SDIM)
       REAL_T     area(DIMV(area))
       
       integer    i, j
       REAL_T     ri, ro, a, pi, po
       REAL_T     RZFACTOR
       parameter (RZFACTOR = 2.d0*3.14159265358979323846d0)
       
       if (coord .eq. 0) then
c
c         ::::: cartesian
c
          if (dir .eq. 0) then
             do j = ARG_L2(area), ARG_H2(area)
                do i = ARG_L1(area), ARG_H1(area)
                   area(i,j) = dx(2)
                end do
             end do
          else
             do j = ARG_L2(area), ARG_H2(area)
                do i = ARG_L1(area), ARG_H1(area)
                   area(i,j) = dx(1)
                end do
             end do
          end if
       elseif(coord .eq. 1) then
c
c         ::::: R-Z
c
          if (dir .eq. 0) then
             do i = ARG_L1(area), ARG_H1(area)
                ri = offset(1) + dx(1)*i
                a = RZFACTOR*ri*dx(2)
                do j = ARG_L2(area), ARG_H2(area)
                   area(i,j) = abs(a)
                end do
             end do
          else
             do i = ARG_L1(area), ARG_H1(area)
                ri = offset(1) + dx(1)*i
                ro = ri + dx(1)
                a = dx(1)*(half*RZFACTOR)*(ri + ro)
                do j = ARG_L2(area), ARG_H2(area)
                   area(i,j) = abs(a)
                end do
             end do
          end if
       elseif(coord .eq. 2) then
              if (dir .eq. 0) then
                 do i = ARG_L1(area), ARG_H1(area)
                    ri = offset(1) + dx(1)*i
                    do j = ARG_L2(area), ARG_H2(area)
                       pi = offset(2) + dx(2)*j
                       po = pi + dx(2)
                       a = RZFACTOR*ri*ri*(cos(pi)-cos(po))
                       area(i,j) = abs(a)
                    enddo
                 enddo
              elseif(dir .eq. 1) then
                 do i = ARG_L1(area), ARG_H1(area)
                    ri = offset(1) + dx(1)*i
                    ro = ri + dx(1)
                    do j = ARG_L2(area), ARG_H2(area)
                       pi = offset(2) + dx(2)*j
                       a = RZFACTOR*sin(pi)*(ro**2 - ri**2)/two
                       area(i,j) = abs(a)
                    enddo
                 enddo
              else
                 write(6,*)' bogus dir ', dir
                 call bl_abort(" ")
              endif

       end if
       
       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** PROBINIT **
c ** Read in the problem-dependent parameters for the FORTRAN common blocks
c *************************************************************************

      subroutine FORT_PROBINIT (name,namlen)
      integer namlen
      integer name(namlen)
      integer untin, i

#include "probdata.H"

      namelist /fortin/ prob_type, 
     $                  in_xvel, in_yvel, in_density, in_tracer,
     $                  xblob, yblob, radblob, denblob, velfact

c      Build `probin' filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      character probin*(maxlen)

      if (namlen .gt. maxlen) then
         write(6,*) 'probin file name too long'
         stop
      end if

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      untin = 9
      if (namlen .eq. 0) then
         open(untin,file='probin',form='formatted',status='old')
      else
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if

      write(6,*) ' '
      write(6,*) 'READING PROBIN_FILE ',probin(1:namlen)
      write(6,*) ' '
c      call flush(6)

      read(untin,fortin)
      close(unit=untin)

      end

c *************************************************************************
c ** INITDATA **
c ** Call the appropriate subroutine to initialize the data
c *************************************************************************

      subroutine FORT_INITDATA(u,v,scal,DIMS,dx,time,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)
      REAL_T  time

      print *,' '

      if (prob_type .eq. 1) then

        call initspin(u,v,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 2) then

        call initbubble(u,v,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 3) then

        call initshear(u,v,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 4) then

        call initchannel(u,v,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 5) then

        call initxypoiseuille(u,v,scal,dx,DIMS,numscal)

      else if (prob_type .eq. 6) then

        call initrzpoiseuille(u,v,scal,dx,DIMS,numscal)

      else 

        print *,'DONT KNOW THIS PROBLEM TYPE: ',prob_type
        stop
 
      endif

      return
      end

c *************************************************************************
c ** INITSPIN **
c ** Initialize the constant density flow-in-a-box problem
c *************************************************************************

      subroutine initspin(u,v,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y
      REAL_T spx, spy, cpx, cpy
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        spx = sin(Pi*x)
        cpx = cos(Pi*x)
        spy = sin(Pi*y)
        cpy = cos(Pi*y)

        u(i,j) =  velfact*two*spy*cpy*spx**2
        v(i,j) = -velfact*two*spx*cpx*spy**2

        scal(i,j,1) = one

      enddo
      enddo

      do n = 2, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITBUBBLE **
c ** Initialize the bubble-drop in a box problem
c *************************************************************************

      subroutine initbubble(u,v,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        u(i,j) = zero
        v(i,j) = zero

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2)

        scal(i,j,1) = one+(denblob-one)*(half+half*tanh(100.d0*(radblob-r)))
c       scal(i,j,1) = cvmgt(denblob,one,r .lt. radblob)

      enddo
      enddo

      do n = 2, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITSHEAR **
c ** Initialize a constant density doubly-periodic shear problem
c *************************************************************************

      subroutine initshear(u,v,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        u(i,j) = tanh(30.d0*(fourth - abs(y-half)))
        v(i,j) = 0.05d0 * sin(two*Pi*x)

        scal(i,j,1) = one

      enddo
      enddo

      do n = 2, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        x = dx(1)*(float(i) + half) - 0.5d0
        y = dx(2)*(float(j) + half) - 0.5d0
        scal(i,j,n) = sqrt(x*x+y*y)
c       scal(i,j,n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITCHANNEL **
c ** Initialize the channel inflow problem
c *************************************************************************

      subroutine initchannel(u,v,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)
        r = sqrt((x-xblob)**2 + (y-yblob)**2)

        u(i,j) = in_xvel
        v(i,j) = in_yvel

        scal(i,j,1) = cvmgt(denblob,in_density,r .lt. radblob)

      enddo
      enddo

      if (numscal .ge. 2) then
        do j = lo_2,hi_2
        do i = lo_1,hi_1
          x = dx(1)*(float(i) + half)
          y = dx(2)*(float(j) + half)
          r = sqrt((x-xblob)**2 + (y-yblob)**2)
          scal(i,j,2) = cvmgt(one    ,in_tracer ,r .lt. radblob)
        enddo
        enddo
      endif

      do n = 3, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITXYPOISEUILLE **
c ** Initialize the Poiseuille (viscous flow in an x-y pipe) problem
c *************************************************************************

      subroutine initxypoiseuille(u,v,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        u(i,j) = zero
        v(i,j) = (one-(x-one)*(x-one))
        scal(i,j,1) = one

      enddo
      enddo

      if (numscal .ge. 2) then
        do j = lo_2,hi_2
        do i = lo_1,hi_1
          x = dx(1)*(float(i) + half)
          y = dx(2)*(float(j) + half)
          r = sqrt((x-xblob)**2 + (y-yblob)**2)
          scal(i,j,2) = cvmgt(one    ,in_tracer ,r .lt. radblob)
        enddo
        enddo
      endif

      do n = 3, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** INITRZPOISEUILLE **
c ** Initialize the Poiseuille (viscous flow in a circular pipe) problem
c *************************************************************************

      subroutine initrzpoiseuille(u,v,scal,dx,DIMS,numscal)

      implicit none

#include "probdata.H"

      integer DIMS
      integer numscal
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  scal(lo_1-1:hi_1+1,lo_2-1:hi_2+1,numscal)
      REAL_T  dx(2)

c     Local variables
      REAL_T x, y, r
      integer i, j, n

      do j = lo_2,hi_2
      do i = lo_1,hi_1

        x = dx(1)*(float(i) + half)
        y = dx(2)*(float(j) + half)

        u(i,j) = zero
        v(i,j) = (one-x*x)
        scal(i,j,1) = one

      enddo
      enddo

      if (numscal .ge. 2) then
        do j = lo_2,hi_2
        do i = lo_1,hi_1
          x = dx(1)*(float(i) + half)
          y = dx(2)*(float(j) + half)
          r = sqrt((x-xblob)**2 + (y-yblob)**2)
          scal(i,j,2) = cvmgt(one    ,in_tracer ,r .lt. radblob)
        enddo
        enddo
      endif

      do n = 3, numscal
      do j = lo_2,hi_2
      do i = lo_1,hi_1
        scal(i,j,n) = zero
      enddo
      enddo
      enddo

      return
      end

c *************************************************************************
c ** DERVORT **
c ** Derive a cell-centered vorticity
c *************************************************************************

      subroutine FORT_DERVORT(state,derval,derlo_1,derlo_2,derhi_1,derhi_2,
     $                        DIMS,dx)

      implicit none

      integer derlo_1, derlo_2
      integer derhi_1, derhi_2
      integer DIMS
      REAL_T   state(lo_1-1:hi_1+1,lo_2-1:hi_2+1,4)
      REAL_T  derval(derlo_1:derhi_1,derlo_2:derhi_2)
      REAL_T  dx(2)

c     Local variables
      integer i, j

      do j = lo_2, hi_2 
      do i = lo_1, hi_1 
          derval(i,j) = fourth*(state(i+1,j+1,2)+state(i+1,j-1,2)- 
     $                          state(i-1,j+1,2)-state(i-1,j-1,2)) / dx(1) -
     $                  fourth*(state(i+1,j+1,1)+state(i-1,j+1,1)- 
     $                          state(i+1,j-1,1)-state(i-1,j-1,1)) / dx(2)
      enddo
      enddo

      return
      end

c *************************************************************************
c ** DERAVGP **
c ** Average nodal pressure onto cell centers for plotting purposes
c *************************************************************************

      subroutine FORT_DERAVGP(pressure,dat,DIMS)

      implicit none

      integer DIMS
      REAL_T  pressure(lo_1:hi_1+1,lo_2:hi_2+1)
      REAL_T       dat(lo_1:hi_1  ,lo_2:hi_2  )

c     Local variables
      integer i, j

      do j = lo_2, hi_2
        do i = lo_1, hi_1
          dat(i,j) = (pressure(i,j  ) + pressure(i+1,j  ) +
     $                pressure(i,j+1) + pressure(i+1,j+1) ) * fourth
      enddo
      enddo

      return
      end

c *************************************************************************
c ** FORT_SET_CELL_VELBC **
c ** set velocity bc for computation of derived variables
c *************************************************************************

      subroutine FORT_SET_CELL_VELBC(u,v,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,
     &                               irz,visc_coef,dx,time)
      
      implicit none

#include "probdata.H"      

      integer DIMS
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer irz
      REAL_T visc_coef
      REAL_T dx(2)
      REAL_T time

c     Local variables
      integer i, j, is, ie, js, je
      REAL_T  x

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (bcy_lo .eq. OUTLET) then
        do i = is,ie
          v(i,js-1) = v(i,js)
          u(i,js-1) = u(i,js)
        enddo
      elseif (bcy_lo .eq. INLET) then
        if (prob_type .eq. 5) then
          do i = is-1,ie+1 
            x = (float(i)+half)*dx(1)
            u(i,js-1) = -u(i,js)
            v(i,js-1) = (one-(x-one)*(x-one))
          enddo
        elseif (prob_type .eq. 6) then
          do i = is-1,ie+1 
            x = (float(i)+half)*dx(1)
            u(i,js-1) = -u(i,js)
            v(i,js-1) = (one-x*x)
          enddo
        else 
          do i = is-1,ie+1
            v(i,js-1) =  two* in_yvel - v(i,js)
            u(i,js-1) =  -u(i,js)
          enddo
        endif
      elseif (bcy_lo .eq. WALL) then
        do i = is-1,ie+1
           v(i,js-1) =  -v(i,js)
           u(i,js-1) =  three*u(i,js) - three*u(i,js+1)+u(i,js+2)
        enddo
        if (visc_coef .gt. zero) then
           do i = is-1,ie+1
              u(i,js-1) =  -u(i,js)
           enddo
        endif
      elseif (bcy_lo .eq. PERIODIC) then
        do i = is,ie
          u(i,js-1) = u(i,je)
          v(i,js-1) = v(i,je)
        enddo
      endif

      if (bcy_hi .eq. OUTLET) then
        do i = is,ie
          v(i,je+1) = v(i,je)
          u(i,je+1) = u(i,je)
        enddo
      elseif (bcy_hi .eq. INLET) then 
        do i = is-1,ie+1
          v(i,je+1) = two*in_yvel - v(i,je)
          u(i,je+1) = - u(i,je)
        enddo
      elseif (bcy_hi .eq. WALL) then
        do i = is-1,ie+1
          v(i,je+1) = -v(i,je)
          u(i,je+1) =  three*u(i,je) - three*u(i,je-1)+u(i,je-2)
        enddo
        if (visc_coef .gt. zero) then
           do i = is-1,ie+1
              u(i,je+1) = -u(i,je)
           enddo
        endif
      elseif (bcy_hi .eq. PERIODIC) then
        do i = is,ie
          u(i,je+1) = u(i,js)
          v(i,je+1) = v(i,js)
        enddo
      endif

      if (bcx_lo .eq. OUTLET) then
        do j = js-1,je+1
          u(is-1,j) = u(is,j)
          v(is-1,j) = v(is,j)
        enddo
      elseif (bcx_lo .eq. INLET) then 
        do j = js-1,je+1
          u(is-1,j) =  two*in_xvel - u(is,j)
          v(is-1,j) =  - v(is,j)
        enddo
      elseif (bcx_lo .eq. WALL) then
        do j = js-1,je+1
          u(is-1,j) =  -u(is,j)
          v(is-1,j) =  three*v(is,j)-three*v(is+1,j)+v(is+2,j)
        enddo
        if (visc_coef .gt. zero .and. irz. eq. 0) then
           do j = js-1,je+1
              v(is-1,j) =  -v(is,j)
           enddo
        endif
      elseif (bcx_lo .eq. PERIODIC) then
        do j = js-1,je+1
          u(is-1,j) = u(ie,j)
          v(is-1,j) = v(ie,j)
        enddo
      endif

      if (bcx_hi .eq. OUTLET) then
        do j = js-1,je+1
          u(ie+1,j) = u(ie,j)
          v(ie+1,j) = v(ie,j)
        enddo
      elseif (bcx_hi .eq. INLET) then
        do j = js-1,je+1
          u(ie+1,j) = two *in_xvel - u(ie,j)
          v(ie+1,j) = - v(ie,j)
        enddo
      elseif (bcx_hi .eq. WALL) then
        do j = js-1,je+1
          u(ie+1,j) = - u(ie,j)
          v(ie+1,j) =  three*v(ie,j)-three*v(ie-1,j)+v(ie-2,j)
        enddo
        if (visc_coef .gt. zero) then
           do j = js-1,je+1
              v(ie+1,j) = - v(ie,j)
           enddo
        endif
      elseif (bcx_hi .eq. PERIODIC) then
        do j = js-1,je+1
          u(ie+1,j) = u(is,j)
          v(ie+1,j) = v(is,j)
        enddo
      endif

      return
      end

c *************************************************************************
c ** VELINFLOW **
c ** Impose the inflow boundary conditions on velocity
c *************************************************************************

      subroutine velinflow(u,DIMS,time,dy,idir,is_hi)

      implicit none

#include "probdata.H"

      integer DIMS
      REAL_T u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T time
      REAL_T dy
      integer idir
      integer is_hi

c     Local variables
      integer i,j
      REAL_T  x

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do j = lo_2-1,hi_2+1 
            u(lo_1-1,j) = in_xvel
          enddo
        else
          do j = lo_2-1,hi_2+1 
            u(hi_1+1,j) = in_xvel
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          if (prob_type .eq. 5) then
            do i = lo_1-1,hi_1+1 
              x = (float(i)+half)*dy
              u(i,lo_2-1) = (one-(x-one)*(x-one))
            enddo
          elseif (prob_type .eq. 6) then
            do i = lo_1-1,hi_1+1 
              x = (float(i)+half)*dy
              u(i,lo_2-1) = (one-x*x)
            enddo
          else 
            do i = lo_1-1,hi_1+1 
              u(i,lo_2-1) = in_yvel
            enddo
          endif
        else
          do i = lo_1-1,hi_1+1 
            u(i,hi_2+1) = in_yvel
          enddo
        endif

      else
        print *,'bogus idir in velinflow ',idir
        stop
      endif

      return
      end

c *************************************************************************
c ** SCALINFLOW **
c ** Impose the inflow boundary conditions on scalars
c *************************************************************************

      subroutine scalinflow(s,DIMS,time,dy,idir,is_hi,which_scal)

      implicit none

#include "probdata.H"

      integer DIMS
      REAL_T  s(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  time
      REAL_T  dy
      integer idir
      integer is_hi
      integer which_scal

c     Local variables
      integer i,j
      REAL_T  inflow_val
    
      if (which_scal .eq. 0) then
        inflow_val = in_density
      elseif (which_scal .eq. 1) then
        inflow_val = in_tracer
      else
        print *,"STOP IN SCALINFLOW "
        print *," --  DONT HAVE VALUE FOR THIS VARIABLE "
        stop
      endif

      if (idir .eq. 0) then

        if (is_hi .eq. 0) then
          do j = lo_2-1,hi_2+1 
            s(lo_1-1,j) = inflow_val
          enddo
        else 
          do j = lo_2-1,hi_2+1 
            s(hi_1+1,j) = inflow_val
          enddo
        endif

      elseif (idir .eq. 1) then

        if (is_hi .eq. 0) then
          do i = lo_1-1,hi_1+1 
            s(i,lo_2-1) = inflow_val
          enddo
        else
          do i = lo_1-1,hi_1+1 
            s(i,hi_2+1) = inflow_val
          enddo
        endif

      else

        print *,'bogus idir in scalinflow ',idir
        stop

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: PROB_3D.F,v 1.20 2002/06/03 21:38:01 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROB_AMR_F.H"
#include "PROB_NS_F.H"
#include "ArrayLim.H"

#define SDIM 3

c ::: -----------------------------------------------------------
c ::: This routine is called at problem initialization time
c ::: and when restarting from a checkpoint file.
c ::: The purpose is (1) to specify the initial time value
c ::: (not all problems start at time=0.0) and (2) to read
c ::: problem specific data from a namelist or other input
c ::: files and possibly store them or derived information
c ::: in FORTRAN common blocks for later use.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: init      => TRUE if called at start of problem run
c :::              FALSE if called from restart
c ::: name      => name of "probin" file
c ::: namlen    => length of name
c ::: strttime <=  start problem with this time variable
c ::: 
c ::: -----------------------------------------------------------
      subroutine FORT_PROBINIT (init,name,namlen,problo,probhi)

      integer init,namlen
      integer name(namlen)
      integer untin, i
      REAL_T  problo(SDIM), probhi(SDIM)

#include "probdata.H"

      namelist /fortin/ denerr, vorterr, adverr, temperr,
     &			denfact, xblob, yblob, zblob, radblob, 
     &                  velfact, probtype, randfact, bubgrad,
     &			rhozero, tempzero, c_d, r_d, 
     &                  adv_dir, adv_vel, axis_dir, radvort,
     &                  den1,den2,vel1,vel2,delta0,xlev1,zlev1,amag,
     &                  vb_unifdir
c
c      Build "probin" filename -- the name of file containing fortin namelist.
c
      integer maxlen
      parameter (maxlen=256)

      REAL_T frecon, onep7
      parameter (frecon=.219, onep7=1.7)

      character probin*(maxlen)

      if (namlen .gt. maxlen) then
         write(6,*) 'probin file name too long'
         stop
      end if

      do i = 1, namlen
         probin(i:i) = char(name(i))
      end do

      untin = 9
      if (namlen .eq. 0) then
         open(untin,file='probin',form='formatted',status='old')
      else
         open(untin,file=probin(1:namlen),form='formatted',status='old')
      end if
      read(untin,fortin)
c      write(6,fortin)
      close(unit=untin)


      if(probtype.eq.8)then

      freq(1) = frecon
      do i=2,10
       freq(i)=freq(1)/float(i)
      enddo
      mag(1) = amag
      mag(2) = .75*amag
      mag(3) = .55*amag
      mag(4) = .44*amag

      do i=5,10
      mag(i)=onep7*mag(1)/float(i)
      enddo

      endif
c
c     Initialize the common blocks
c
      do i=1, SDIM
        f_problo(i) = problo(i)
        f_probhi(i) = probhi(i)
      enddo

      end

c ::: -----------------------------------------------------------
c ::: This routine is called at problem setup time and is used
c ::: to initialize data on each grid.  The velocity field you
c ::: provide does not have to be divergence free and the pressure
c ::: field need not be set.  A subsequent projection iteration
c ::: will define aa divergence free velocity field along with a
c ::: consistant pressure.
c ::: 
c ::: NOTE:  all arrays have one cell of ghost zones surrounding
c :::        the grid interior.  Values in these cells need not
c :::        be set here.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: level     => amr level of grid
c ::: time      => time at which to init data             
c ::: lo,hi     => index limits of grid interior (cell centered)
c ::: nscal     => number of scalar quantities.  You should know
c :::		   this already!
c ::: vel      <=  Velocity array
c ::: scal     <=  Scalar array
c ::: press    <=  Pressure array
c ::: dx     => cell size
c ::: xlo,xhi   => physical locations of lower left and upper
c :::              right hand corner of grid.  (does not include
c :::		   ghost region).
c ::: -----------------------------------------------------------
      subroutine FORT_INITDATA(level,time,lo,hi,nscal,
     &	 	               vel,scal,DIMS(state),press,DIMS(press),
     &                         dx,xlo,xhi)
      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))

#include "probdata.H"

      if (probtype .eq. 1) then
         call initspin(level,time,lo,hi,nscal,
     &     	       vel,scal,DIMS(state),press,DIMS(press),
     &                 dx,xlo,xhi)

      else if (probtype .eq. 2) then
         call initbubble(level,time,lo,hi,nscal,
     &     	         vel,scal,DIMS(state),press,DIMS(press),
     &                   dx,xlo,xhi)

      else if (probtype .eq. 3) then
         call initvort(level,time,lo,hi,nscal,
     &     	       vel,scal,DIMS(state),press,DIMS(press),
     &                 dx,xlo,xhi)

      else if (probtype .eq. 4) then
         call initchannel(level,time,lo,hi,nscal,
     &     	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 5) then
         call initpervort(level,time,lo,hi,nscal,
     &     	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 6) then
         call inithotspot(level,time,lo,hi,nscal,
     &     	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 7) then
         call initeuler(level,time,lo,hi,nscal,
     &                    vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 8) then
         call initbrnrsh(level,time,lo,hi,nscal,
     &                    vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      else if (probtype .eq. 9) then
         call initviscbench(level,time,lo,hi,nscal,
     &                      vel,scal,DIMS(state),press,DIMS(press),
     &                      dx,xlo,xhi)


      else
         write(6,*) "INITDATA: bad probtype = ",probtype
      end if
      end

c
c ::: -----------------------------------------------------------
c
      subroutine initbubble(level,time,lo,hi,nscal,
     &	 	            vel,scal,DIMS(state),press,DIMS(press),
     &                      dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  dist
      REAL_T  x_vel, y_vel, z_vel

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
         y_vel = zero
         z_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = adv_vel
         z_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = zero
         z_vel = adv_vel
      else 
         write(6,*) "initbubble: adv_dir = ",adv_dir
         stop
      end if

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half)
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
            do i = lo(1), hi(1)
               x = xlo(1) + hx*(float(i-lo(1)) + half)
               dist = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)
               vel(i,j,k,1) = x_vel
               vel(i,j,k,2) = y_vel
               vel(i,j,k,3) = z_vel
               scal(i,j,k,1) = cvmgt(denfact,one,dist.lt.radblob)
               do n = 2,nscal-1
                  scal(i,j,k,n) = one
               end do                  
               scal(i,j,k,nscal) = cvmgt(one,zero,dist.lt.radblob)
   	    end do
         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initspin(level,time,lo,hi,nscal,
     &	 	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  dist
      REAL_T  x_vel, y_vel, z_vel
      REAL_T  spx, spy, cpx, cpy

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(2)

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
         y_vel = zero
         z_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = adv_vel
         z_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = zero
         z_vel = adv_vel
      else
         write(6,*) "INITSPIN: adv_dir = ",adv_dir
         stop
      end if

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half)
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
	    spy = sin(Pi*y)
	    cpy = cos(Pi*y)
	    do i = lo(1), hi(1)
               x = xlo(1) + hx*(float(i-lo(1)) + half)

 	       spx = sin(Pi*x)
               cpx = cos(Pi*x)

               vel(i,j,k,1) = x_vel - velfact*two*spy*cpy*spx**2
               vel(i,j,k,2) = y_vel + velfact*two*spx*cpx*spy**2
               vel(i,j,k,3) = z_vel

  	       dist = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)

               scal(i,j,k,1) = one + (denfact-one) * tanh(10.*(dist-radblob))
               do n = 2,nscal-1
                  scal(i,j,k,n) = one
               end do                  
	       scal(i,j,k,nscal) = cvmgt(one,zero,dist.lt.radblob)

	    end do
         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c ::: This case is an unsteady  viscous benchmark for which the
c ::: exact solution is,
c :::     u(x,y,t) = - Cos(Pi x) Sin(Pi y) Exp(-2 Pi^2 Nu t)
c :::     v(x,y,t) =   Sin(Pi x) Cos(Pi y) Exp(-2 Pi^2 Nu t)
c :::     p(x,y,t) = - {Cos(2 Pi x) + Cos(2 Pi y)} Exp(-4 Pi^2 Nu t) / 4
c ::: In the utilities, iamrlib/BenchMarks, there is a
c ::: tool ViscBench2d.cpp that reads a plot file and compares the
c ::: solution against this exact solution.  This benchmark was
c ::: originally derived by G.I. Taylor (Phil. Mag., Vol. 46, No. 274,
c ::: pp. 671-674, 1923) and Ethier and Steinman
c ::: (Intl. J. Num. Meth. Fluids, Vol. 19, pp. 369-375, 1994) give
c ::: the pressure field.
c
      subroutine initviscbench(level,time,lo,hi,nscal,
     &                         vel,scal,DIMS(state),press,DIMS(press),
     &                         dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  spx, spy, spz, cpx, cpy, cpz

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      do k = lo(3), hi(3)
        z = xlo(3) + hz*(float(k-lo(3)) + half)
        spz = sin(Pi*z)
        cpz = cos(Pi*z)

        do j = lo(2), hi(2)
          y = xlo(2) + hy*(float(j-lo(2)) + half)
          spy = sin(Pi*y)
          cpy = cos(Pi*y)

          do i = lo(1), hi(1)
            x = xlo(1) + hx*(float(i-lo(1)) + half)

            spx = sin(Pi*x)
            cpx = cos(Pi*x)

c
c           Uniform in the X-direction
c
            if (vb_unifdir .eq. 0) then
              vel(i,j,k,1) =   zero
              vel(i,j,k,2) =   spz*cpy
              vel(i,j,k,3) = - cpz*spy
              scal(i,j,k,1) =   one
              do n = 2, nscal
                scal(i,j,k,n) =   cpz*cpy
              enddo

c
c           Uniform in the Y-direction
c
            elseif (vb_unifdir .eq. 1) then
              vel(i,j,k,1) = - cpx*spz
              vel(i,j,k,2) =   zero
              vel(i,j,k,3) =   spx*cpz
              scal(i,j,k,1) =   one
              do n = 2, nscal
                scal(i,j,k,n) =   cpx*cpz
              enddo

c
c           Uniform in the Z-direction
c
            elseif (vb_unifdir .eq. 2) then
              vel(i,j,k,1) = - cpx*spy
              vel(i,j,k,2) =   spx*cpy
              vel(i,j,k,3) =   zero
              scal(i,j,k,1) =   one
              do n = 2, nscal
                scal(i,j,k,n) =   cpx*cpy
              enddo
            endif
            end do
         end do
      end do
      end
c
c ::: -----------------------------------------------------------
c
      subroutine initvort(level,time,lo,hi,nscal,
     &	 	          vel,scal,DIMS(state),press,DIMS(press),
     &                    dx,xlo,xhi)
      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z, r
      REAL_T  hx, hy, hz
      REAL_T  c, ux, uy, uz
      REAL_T  umagin, umagout, absu, sinth, costh
      REAL_T  small, a, b, r0

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)
      small = 1.0e-10

      r0 = two/three * radvort
      a = one / ((radvort - r0)*(two*radvort - r0))
      b = a * radvort**2 * (radvort - r0)

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half) - zblob
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half) - yblob
	    do i = lo(1), hi(1)
               x = xlo(1) + hx*(float(i-lo(1)) + half) - xblob
  	       r = sqrt(x**2 + y**2)
c              umagin = .5*r - 4*r**3
c              umagout = radvort*(.5*radvort - 4*radvort**3)/max(radvort,r)
               umagin = velfact * (one - a*(r - r0)**2)
               umagout = velfact * b/max(radvort,r)
               absu = cvmgp(umagout,umagin,r - radvort)
               sinth = y/max(r,small*radvort)
               costh = x/max(r,small*radvort)
               vel(i,j,k,1) = -absu*sinth
               vel(i,j,k,2) = absu*costh
               vel(i,j,k,3) = zero
               scal(i,j,k,1) = cvmgt(denfact,one,r.lt.radblob)
               do n = 2,nscal-1
                  scal(i,j,k,n) = one
               end do                  
               scal(i,j,k,nscal) = cvmgt(one,zero,r.lt.radblob)
	    end do
         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initchannel(level,time,lo,hi,nscal,
     &	 	             vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  dist

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half)
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
            do i = lo(1), hi(1)
               vel(i,j,k,1) = adv_vel
               vel(i,j,k,2) = zero
               vel(i,j,k,3) = zero
               scal(i,j,k,1) = one

               do n = 2,nscal-1
                  scal(i,j,k,n) = one
               end do                  

               x = xlo(1) + hx*(float(i-lo(1)) + half)
  	       dist = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)
	       scal(i,j,k,nscal) = cvmgt(one,zero,dist.lt.radblob)
            end do
         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initpervort(level,time,lo,hi,nscal,
     &	 	             vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  dist

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half)
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
	    do i = lo(1), hi(1)

               x = xlo(1) + hx*(float(i-lo(1)) + half)

               vel(i,j,k,1) = tanh(30.*(.25-abs(y-.5)))
               vel(i,j,k,2) = .05*sin(two*Pi*x)
               vel(i,j,k,3) = zero

               scal(i,j,k,1) = one
               do n = 2,nscal-1
                  scal(i,j,k,n) = one
               end do
                  
  	       dist = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)
	       scal(i,j,k,nscal) = cvmgt(one,zero,dist.lt.radblob)
	    end do
         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine inithotspot(level,time,lo,hi,nscal,
     &	 	             vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))


c     ::::: local variables
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  x_vel, y_vel, z_vel
      REAL_T  dist

#include "probdata.H"

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
         y_vel = zero
         z_vel = zero
      else if (adv_dir .eq. 2) then
         x_vel = zero
         y_vel = adv_vel
         z_vel = zero
      else if (adv_dir .eq. 3) then
         x_vel = zero
         y_vel = zero
         z_vel = adv_vel
      else 
         write(6,*) "inithotspot: adv_dir = ",adv_dir
         stop
      end if

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half)
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
            do i = lo(1), hi(1)
               x = xlo(1) + hx*(float(i-lo(1)) + half)
               dist = sqrt((x-xblob)**2 + (y-yblob)**2 + (z-zblob)**2)
               vel(i,j,k,1) = x_vel
               vel(i,j,k,2) = y_vel
               vel(i,j,k,3) = z_vel
               scal(i,j,k,1) = one/denfact + (one - one/denfact)
     &              *half*(one + tanh(40.*(dist - radblob)))
               scal(i,j,k,2) = cvmgt(one,zero,dist.lt.radblob)
               do n = 3,nscal-1
                  scal(i,j,k,n) = one
               end do
               scal(i,j,k,nscal) = one / scal(i,j,k,1)
            end do
         end do
      end do
      
      end
c
c ::: -----------------------------------------------------------
c
      subroutine initeuler(level,time,lo,hi,nscal,
     &                       vel,scal,DIMS(state),press,DIMS(press),
     &                       dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz, r_yz

      REAL_T  eps_input, beta_input, rho_input
      REAL_T  delta_input, kappa_input

      parameter (eps_input=0.05, rho_input=0.15)
      parameter (beta_input=15., delta_input=0.0333)
      parameter (kappa_input=500.)

#include "probdata.H"
      
      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      do k = lo(3), hi(3)
         z = xlo(3) + hz*(float(k-lo(3)) + half) -half
         do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half) -half
            r_yz = sqrt(y*y+z*z)
            do i = lo(1), hi(1)

               x = xlo(1) + hx*(float(i-lo(1)) + half) -half
               vel(i,j,k,1) = tanh( (rho_input - r_yz) / delta_input)
               vel(i,j,k,2) = zero
               vel(i,j,k,3) = eps_input * exp(-beta_input * (x*x + y*y) )

               scal(i,j,k,1) = one
               scal(i,j,k,2) = exp( -kappa_input * (rho_input - r_yz)**2 )

               do n = 3,nscal
                  scal(i,j,k,n) = one
               end do

            end do
         end do
      end do

      end
c
c ::: -----------------------------------------------------------
c
      subroutine initbrnrsh(level,time,lo,hi,nscal,
     &                      vel,scal,DIMS(state),press,DIMS(press),
     &                      dx,xlo,xhi)

      integer    level, nscal
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      integer    DIMDEC(press)
      REAL_T     time, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     vel(DIMV(state),SDIM)
      REAL_T    scal(DIMV(state),nscal)
      REAL_T   press(DIMV(press))
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  dist
      REAL_T  x_vel, y_vel, z_vel
      REAL_T  umid,rmid,lamv,lamr,rfact


#include "probdata.H"
      hx = dx(1)
      hy = dx(2)
      hz = dx(3)


      umid = (vel1+vel2)*half
      rmid = (den1+den2)*half
      lamv = (vel1-vel2)/(vel1+vel2)
      lamr = (den1-den2)/(den1+den2)

         do k = lo(3), hi(3)
            z = xlo(3) + hz*(float(k-lo(3)) + half)
            do j = lo(2), hi(2)
            y = xlo(2) + hy*(float(j-lo(2)) + half)
            do i = lo(1), hi(1)
               vel(i,j,k,1) = umid*(one+lamv*tanh(two*z/delta0))
               vel(i,j,k,2) = zero
               vel(i,j,k,3) = zero
               scal(i,j,k,1) = rmid*(one+lamr*tanh(two*z/delta0))
               scal(i,j,k,2) = cvmgt(one,zero,z.gt.zero)
            enddo
         enddo
         enddo


      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: density gradient
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: rho       => density array
c ::: DIMS(rho) => index extent of rho array
c ::: nvar      => number of components in rho array (should be 1)
c ::: lo,hi     => index extent of grid
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_DENERROR (tag,DIMS(tag),set,clear,
     &                          rho,DIMS(rho),lo,hi,nvar,
     &                          domlo,domhi,dx,xlo,
     &			        problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(rho)
      integer   lo(SDIM), hi(SDIM)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    rho(DIMV(rho),nvar)

      integer   i, j, k

#include "probdata.H"

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               tag(i,j,k) = cvmgt(set,tag(i,j,k),rho(i,j,k,1).lt.denerr)
            end do
         end do
      end do

      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: density gradient
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: adv       => scalar array
c ::: DIMS(adv) => index extent of adv array
c ::: nvar      => number of components in rho array (should be 1)
c ::: lo,hi     => index extent of grid
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_ADVERROR (tag,DIMS(tag),set,clear,
     &                          adv,DIMS(adv),lo,hi,nvar,
     &                          domlo,domhi,dx,xlo,
     &			        problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(adv)
      integer   lo(SDIM), hi(SDIM)
      integer   ng, nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    adv(DIMV(adv),nvar)

      REAL_T    x, y, z, ax, ay, az, aerr
      integer   i, j, k

#include "probdata.H"

c     probtype = SPIN
      if (probtype .eq. 1) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do

c     probtype = BUBBLE
      else if (probtype .eq. 2) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do

c     probtype = VORTEX IN A BOX
      else if (probtype .eq. 3) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do

c     probtype = CHANNEL
      else if (probtype .eq. 4) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do

c     probtype = PERIODIC SHEAR LAYER
      else if (probtype .eq. 5) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do

c     probtype = HOT SPOT
      else if (probtype .eq. 6) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do

      else if (probtype .eq. 7) then

        return

      else if (probtype .eq. 8) then

        if (level .eq. 0) then
          do k = lo(3), hi(3)
          z = xlo(3) + dx(3)*(float(k-lo(3)) + half)
             do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                  x = xlo(1) + dx(1)*(float(i-lo(1)) + half)
                  tag(i,j,k) = cvmgt(set,clear,abs(z).lt.zlev1.and.x.lt.xlev1)
             enddo
             enddo
          enddo
        else
          do k = lo(3), hi(3)
          do j = lo(2), hi(2)
          do i = lo(1), hi(1)
            x = xlo(1) + dx(1)*(float(i-lo(1)) + half)
            ax = abs(adv(i+1,j,k,1) - adv(i-1,j,k,1))
            ay = abs(adv(i,j+1,k,1) - adv(i,j-1,k,1))
            az = abs(adv(i,j,k+1,1) - adv(i,j,k-1,1))
            aerr = max(ax,ay,az)
            tag(i,j,k) = cvmgt(set,tag(i,j,k),aerr.gt.adverr.and. x.lt.xlev1)
          enddo
          enddo
          enddo
        endif

c     probtype = VISCOUS BENCHMARK
      else if (probtype .eq. 9) then

        do k = lo(3), hi(3)
           do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 tag(i,j,k) = cvmgt(set,tag(i,j,k),adv(i,j,k,1).gt.adverr)
              end do
           end do
        end do


      else
        print *,'DONT KNOW THIS PROBTYPE IN FORT_ADVERROR ',probtype
        stop
      end if
 
      end

c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the
c ::: temperature gradient
c :::
c ::: INPUTS/OUTPUTS:
c :::
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: temp      => density array
c ::: DIMS(temp)=> index extent of temp array
c ::: lo,hi     => index extent of grid
c ::: nvar      => number of components in rho array (should be 1)
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::              corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_TEMPERROR (tag,DIMS(tag),set,clear,
     &                           temperature,DIMS(temp),lo,hi,nvar,
     &                           domlo,domhi,dx,xlo,
     &                           problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(temp)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      integer   lo(SDIM), hi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    temperature(DIMV(temp),nvar)

      REAL_T    x, y, z, ax, ay, az, aerr
      integer   i, j, k

#include "probdata.H"

c     probtype = SPIN
      if (probtype .eq. 1) then

c     probtype = BUBBLE
      else if (probtype .eq. 2) then

c     probtype = VORTEX IN A BOX
      else if (probtype .eq. 3) then

c     probtype = CHANNEL
      else if (probtype .eq. 4) then

c     probtype = PERIODIC SHEAR LAYER
      else if (probtype .eq. 5) then

c     probtype = HOT SPOT
      else if (probtype .eq. 6) then

        if (level .eq. 0) then
c         ::::: refine around entire hot spot
          do k = lo(3), hi(3)
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   tag(i,j,k) = cvmgt(set,tag(i,j,k),temperature(i,j,k,1).gt.temperr)
                end do
             end do
          end do
        else
c         ::::: refine where there is temperature gradient
          do k = lo(3), hi(3)
             do j = lo(2), hi(2)
                do i = lo(1), hi(1)
                   ax = abs(temperature(i+1,j,k,1) - temperature(i-1,j,k,1))
                   ay = abs(temperature(i,j+1,k,1) - temperature(i,j-1,k,1))
                   az = abs(temperature(i,j,k+1,1) - temperature(i,j,k-1,1))
                   aerr = max(ax,ay,az)
                   tag(i,j,k) = cvmgt(set,tag(i,j,k),aerr.gt.bubgrad)
                end do
             end do
          end do
        end if


c     probtype = VISCOUS BENCHMARK
      else if (probtype .eq. 9) then


      else
        print *,'DONT KNOW THIS PROBTYPE IN FORT_TEMPERROR ',probtype
        stop
      end if

      end
c ::: -----------------------------------------------------------
c ::: This routine will tag high error cells based on the 
c ::: magnitude of vorticity
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: tag      <=  integer tag array
c ::: DIMS(tag) => index extent of tag array
c ::: set       => integer value to tag cell for refinement
c ::: clear     => integer value to untag cell
c ::: vort      => vorticitiy array
c ::: DIMS(vort)=> index extent of vort array
c ::: nvar      => number of components in rho array (should be 1)
c ::: lo,hi     => index extent of grid
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of tag array
c ::: problo    => phys loc of lower left corner of prob domain
c ::: time      => problem evolution time
c ::: -----------------------------------------------------------
      subroutine FORT_MVERROR (tag,DIMS(tag),set,clear,
     &                         vort,DIMS(vort),lo,hi,nvar,
     &                         domlo,domhi,dx,xlo,
     &			       problo,time,level)

      integer   DIMDEC(tag)
      integer   DIMDEC(vort)
      integer   lo(SDIM), hi(SDIM)
      integer   nvar, set, clear, level
      integer   domlo(SDIM), domhi(SDIM)
      REAL_T    dx(SDIM), xlo(SDIM), problo(SDIM), time
      integer   tag(DIMV(tag))
      REAL_T    vort(DIMV(vort),nvar)

      REAL_T    x, y, dist
      integer   i, j, k
      REAL_T    radius

#include "probdata.H"

c     probtype = SPIN
      if (probtype .eq. 1) then

c     probtype = BUBBLE
      else if (probtype .eq. 2) then

         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),abs(vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do

c     probtype = VORTEX IN A BOX
      else if (probtype .eq. 3) then

         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),abs(vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do

c     probtype = CHANNEL
      else if (probtype .eq. 4) then

         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),abs(vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do

c     probtype = PERIODIC SHEAR LAYER
      else if (probtype .eq. 5) then

         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),abs(vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do

c     probtype = HOT SPOT
      else if (probtype .eq. 6) then

         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),abs(vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do
c     probtype = EULER
      else if (probtype .eq. 7) then

         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),
     &                   abs(dx(1)*vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do

c     probtype = BROWN ROSHKO
      else if (probtype .eq. 8) then

        return


c     probtype = VISCOUS BENCHMARK
      else if (probtype .eq. 9) then
         do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               do i = lo(1), hi(1)
                  tag(i,j,k) = cvmgt(set,tag(i,j,k),abs(vort(i,j,k,1)).gt.vorterr)
               end do
            end do
         end do


      else
        print *,'DONT KNOW THIS PROBTYPE IN FORT_MVERROR ',probtype
        stop
      end if

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: rho      <=  density array
c ::: DIMS(rho) => index extent of rho array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_DENFILL (rho,DIMS(rho),domlo,domhi,dx,
     &                         xlo,time,bc )

      integer    DIMDEC(rho)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     rho(DIMV(rho))
      integer    bc(SDIM,2)
      integer    lo(SDIM), hi(SDIM)

      integer    i, j, k
      REAL_T  umid,rmid,lamv,lamr,rfact
      REAL_T  hx, hy, hz, gpert, z, y, ypert, magwif, constn

      parameter (constn=.22089323)

#include "probdata.H"

      call filcc(rho,DIMS(rho),domlo,domhi,dx,xlo,bc)

      if(probtype .eq.8 ) then

      lo(1) = ARG_L1(rho)
      lo(2) = ARG_L2(rho)
      lo(3) = ARG_L3(rho)
      hi(1) = ARG_H1(rho)
      hi(2) = ARG_H2(rho)
      hi(3) = ARG_H3(rho)

      umid = (vel1+vel2)*half
      rmid = (den1+den2)*half
      lamv = (vel1-vel2)/(vel1+vel2)
      lamr = (den1-den2)/(den1+den2)
      hx = dx(1)
      hy = dx(2)
      hz = dx(3)
      magwif = one/ten

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do k = lo(3), hi(3)
            z = xlo(3) + hz*(float(k-lo(3)) + half)
            do j = lo(2), hi(2)
               y = xlo(2)+hy*(float(j-lo(2))+half)
               ypert = magwif*sin(freq(1)*time)*sin(constn*y)
               rho(i,j,k) =  rmid*(one+lamr*tanh(two*(z-ypert)/delta0))
            enddo
            enddo
         enddo
      endif

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               rho(i,j,k) = denfact
            enddo
            enddo
         enddo
      endif

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
           do j = lo(2), domlo(2)-1
              do k = lo(3), hi(3)
              do i = lo(1), hi(1)
                 rho(i,j,k) = denfact
              enddo
              enddo
           enddo
      endif

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do k = lo(3), hi(3)
            do i = lo(1), hi(1)
               rho(i,j,k) = denfact
            enddo
            enddo
         enddo
      endif

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
           do k = lo(3), domlo(3)-1
              do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                 rho(i,j,k) = den2
              enddo
              enddo
           enddo
      endif

      if (bc(3,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
           do k = domhi(3)+1, hi(3)
              do j = lo(2), hi(2)
              do i = lo(1), hi(1)
                rho(i,j,k) = den1
              enddo
              enddo
         enddo
      endif

      else


      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(rho).lt.domlo(1)) then
         do i = ARG_L1(rho), domlo(1)-1
            do k = ARG_L3(rho), ARG_H3(rho)
               do j = ARG_L2(rho), ARG_H2(rho)
                  rho(i,j,k) = denfact
               end do
	    end do
	 end do
      end if

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(rho).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(rho)
            do k = ARG_L3(rho), ARG_H3(rho)
               do j = ARG_L2(rho), ARG_H2(rho)
                  rho(i,j,k) = denfact
               end do
	    end do
	 end do
      end if         

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(rho).lt.domlo(2)) then
         do j = ARG_L2(rho), domlo(2)-1
            do k = ARG_L3(rho), ARG_H3(rho)
               do i = ARG_L1(rho), ARG_H1(rho)
                  rho(i,j,k) = denfact
               end do
            end do
         end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(rho).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(rho)
            do k = ARG_L3(rho), ARG_H3(rho)
               do i = ARG_L1(rho), ARG_H1(rho)
                  rho(i,j,k) = denfact
               end do
	    end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(rho).lt.domlo(3)) then
         do k = ARG_L3(rho), domlo(3)-1
            do j = ARG_L2(rho), ARG_H2(rho)
               do i = ARG_L1(rho), ARG_H1(rho)
                  rho(i,j,k) = denfact
               end do
            end do
         end do
      end if

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(rho).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(rho)
            do j = ARG_L2(rho), ARG_H2(rho)
               do i = ARG_L1(rho), ARG_H1(rho)
                  rho(i,j,k) = denfact
               end do
            end do
         end do
      end if

      endif

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: adv      <=  advected quantity array
c ::: DIMS(adv) => index extent of adv array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of adv array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_ADVFILL (adv,DIMS(adv),domlo,domhi,dx,
     &                         xlo,time,bc )

      integer    DIMDEC(adv)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     adv(DIMV(adv))
      integer    bc(SDIM,2)
      integer    lo(SDIM), hi(SDIM)

      integer    i, j, k
      REAL_T  hx, hy, hz, gpert, z, y, ypert, magwif, constn

      parameter (constn=.22089323)

#include "probdata.H"

      call filcc(adv,DIMS(adv),domlo,domhi,dx,xlo,bc)
      if( probtype .eq. 8) then
      lo(1) = ARG_L1(adv)
      lo(2) = ARG_L2(adv)
      lo(3) = ARG_L3(adv)
      hi(1) = ARG_H1(adv)
      hi(2) = ARG_H2(adv)
      hi(3) = ARG_H3(adv)

      hy = dx(2)
      hz = dx(3)
      magwif = one/ten
      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then
         do i = lo(1), domlo(1)-1
            do k = lo(3), hi(3)
            z = xlo(3) + hz*(float(k-lo(3)) + half)
            do j = lo(2), hi(2)
               y = xlo(2)+hy*(float(j-lo(2))+half)
               ypert = magwif*sin(freq(1)*time)*sin(constn*y)
               adv(i,j,k) = cvmgt(one,zero,(z-ypert).gt.zero)
            enddo
            enddo
         enddo
      endif

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               adv(i,j,k) = cvmgt(one,zero,z.gt.zero)
            enddo
            enddo
         enddo
      endif

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do k = lo(3), hi(3)
            z = xlo(3) + hz*(float(k-lo(3)) + half)
            do i = lo(1), hi(1)
               adv(i,j,k) =  cvmgt(one,zero,z.gt.zero)
            enddo
            enddo
         enddo
      endif

      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do k = lo(3), hi(3)
            z = xlo(3) + hz*(float(k-lo(3)) + half)
            do i = lo(1), hi(1)
               adv(i,j,k) =  cvmgt(one,zero,z.gt.zero)
            enddo
            enddo
         enddo
      endif
      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               adv(i,j,k) = zero
            enddo
            enddo
         enddo
      endif

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               adv(i,j,k) = one
            enddo
            enddo
         enddo
      endif


      else

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(adv).lt.domlo(1)) then
         do i = ARG_L1(adv), domlo(1)-1
            do k = ARG_L3(adv), ARG_H3(adv)
               do j = ARG_L2(adv), ARG_H2(adv)
                  adv(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(adv).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(adv)
            do k = ARG_L3(adv), ARG_H3(adv)
               do j = ARG_L2(adv), ARG_H2(adv)
                  adv(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(adv).lt.domlo(2)) then
         do j = ARG_L2(adv), domlo(2)-1
            do k = ARG_L3(adv), ARG_H3(adv)
               do i = ARG_L1(adv), ARG_H1(adv)
                  adv(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(adv).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(adv)
            do k = ARG_L3(adv), ARG_H3(adv)
               do i = ARG_L1(adv), ARG_H1(adv)
                  adv(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(adv).lt.domlo(3)) then
         do k = ARG_L3(adv), domlo(3)-1
            do j = ARG_L2(adv), ARG_H2(adv)
               do i = ARG_L1(adv), ARG_H1(adv)
                  adv(i,j,k) = zero
               end do
            end do
         end do
      end if 

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(adv).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(adv)
            do j = ARG_L2(adv), ARG_H2(adv)
               do i = ARG_L1(adv), ARG_H1(adv)
                  adv(i,j,k) = zero
               end do
            end do
         end do
      end if

      endif

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: temp      <= temperature array
c ::: DIMS(temp)=> index extent of temp array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of temp array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_TEMPFILL (temp,DIMS(temp),domlo,domhi,dx,
     &                          xlo,time,bc )

      integer    DIMDEC(temp)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     temp(DIMV(temp))
      integer    bc(SDIM,2)

      integer    i, j, k
      REAL_T     z

#include "probdata.H"

      call filcc(temp,DIMS(temp),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(temp).lt.domlo(1)) then
         do i = ARG_L1(temp), domlo(1)-1
            do k = ARG_L3(temp), ARG_H3(temp)
               do j = ARG_L2(temp), ARG_H2(temp)
                  temp(i,j,k) = one
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(temp).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(temp)
            do k = ARG_L3(temp), ARG_H3(temp)
               do j = ARG_L2(temp), ARG_H2(temp)
                  temp(i,j,k) = one
               end do
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(temp).lt.domlo(2)) then
         do j = ARG_L2(temp), domlo(2)-1
            do k = ARG_L3(temp), ARG_H3(temp)
               do i = ARG_L1(temp), ARG_H1(temp)
                  temp(i,j,k) = one
               end do
	    end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(temp).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(temp)
            do k = ARG_L3(temp), ARG_H3(temp)
               do i = ARG_L1(temp), ARG_H1(temp)
                  temp(i,j,k) = one
               end do
	    end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(temp).lt.domlo(3)) then
         do k = ARG_L3(temp), domlo(3)-1
            do j = ARG_L2(temp), ARG_H2(temp)
               do i = ARG_L1(temp), ARG_H1(temp)
                  temp(i,j,k) = one
               end do
            end do
         end do
      end if 

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(temp).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(temp)
            do j = ARG_L2(temp), ARG_H2(temp)
               do i = ARG_L1(temp), ARG_H1(temp)
                  temp(i,j,k) = one
               end do
            end do
         end do
      end if

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: u        <=  x velocity array
c ::: DIMS(u)   => index extent of u array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_XVELFILL (u,DIMS(u),domlo,domhi,dx,
     &                          xlo,time,bc)

      integer    DIMDEC(u)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     u(DIMV(u))
      integer    bc(SDIM,2)
      integer    lo(SDIM),hi(SDIM)

      integer    i, j, k
      REAL_T     x_vel
      REAL_T     y, ul, g_t
      REAL_T  umid,rmid,lamv,lamr,rfact
      REAL_T  hx, hy, hz, gpert, z,  ypert, magwif, constn

      parameter (constn=.22089323)

#include "probdata.H"

      if (adv_dir .eq. 1) then
         x_vel = adv_vel
      else  
         x_vel = zero
      end if

      call filcc(u,DIMS(u),domlo,domhi,dx,xlo,bc)
      if(probtype .eq. 8) then


      lo(1) = ARG_L1(u)
      lo(2) = ARG_L2(u)
      lo(3) = ARG_L3(u)
      hi(1) = ARG_H1(u)
      hi(2) = ARG_H2(u)
      hi(3) = ARG_H3(u)

      x_vel = one
      magwif = one/ten

      umid = (vel1+vel2)*half
      rmid = (den1+den2)*half
      lamv = (vel1-vel2)/(vel1+vel2)
      lamr = (den1-den2)/(den1+den2)
      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      if (bc(1,1).eq.EXT_DIR.and.lo(1).lt.domlo(1)) then

         gpert = one
         do i = 1,10
            gpert = gpert + mag(i)*sin(freq(i)*time)
         enddo

         do i = lo(1), domlo(1)-1
            do k = lo(3), hi(3)
            z = xlo(3) + hz*(float(k-lo(3)) + half)
            do j = lo(2), hi(2)
               y = xlo(2)+hy*(float(j-lo(2))+half)
               ypert = magwif*sin(freq(1)*time)*sin(constn*y)
               u(i,j,k) = gpert*umid*(one+lamv*tanh(two*(z-ypert)/delta0))
            enddo
            enddo
         enddo
      endif

      if (bc(1,2).eq.EXT_DIR.and.hi(1).gt.domhi(1)) then
         do i = domhi(1)+1, hi(1)
            do k = lo(3), hi(3)
            do j = lo(2), hi(2)
               u(i,j,k) = x_vel
            enddo
            enddo
         enddo
      endif

      if (bc(2,1).eq.EXT_DIR.and.lo(2).lt.domlo(2)) then
         do j = lo(2), domlo(2)-1
            do k = lo(3), hi(3)
            do i = lo(1), hi(1)
               u(i,j,k) = x_vel
            enddo
            enddo
         enddo
      endif
      if (bc(2,2).eq.EXT_DIR.and.hi(2).gt.domhi(2)) then
         do j = domhi(2)+1, hi(2)
            do k = lo(3), hi(3)
            do i = lo(1), hi(1)
               u(i,j,k) = x_vel
            enddo
            enddo
         enddo
      endif

      if (bc(3,1).eq.EXT_DIR.and.lo(3).lt.domlo(3)) then
         do k = lo(3), domlo(3)-1
            do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               u(i,j,k) = vel2
            enddo
            enddo
         enddo
      endif

      if (bc(3,2).eq.EXT_DIR.and.hi(3).gt.domhi(3)) then
         do k = domhi(3)+1, hi(3)
            do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               u(i,j,k) = vel1
            enddo
            enddo
         enddo
      endif

      else


      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(u).lt.domlo(1)) then
         do i = ARG_L1(u), domlo(1)-1
            do k = ARG_L3(u), ARG_H3(u)
               do j = ARG_L2(u), ARG_H2(u)
                  u(i,j,k) = x_vel
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(u).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(u)
            do k = ARG_L3(u), ARG_H3(u)
               do j = ARG_L2(u), ARG_H2(u)
                  u(i,j,k) = x_vel
               end do
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(u).lt.domlo(2)) then
         do j = ARG_L2(u), domlo(2)-1
            do k = ARG_L3(u), ARG_H3(u)
               do i = ARG_L1(u), ARG_H1(u)
                  u(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(u).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(u)
            do k = ARG_L3(u), ARG_H3(u)
               do i = ARG_L1(u), ARG_H1(u)
                  u(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(u).lt.domlo(3)) then
         do k = ARG_L3(u), domlo(3)-1
            do j = ARG_L2(u), ARG_H2(u)
               do i = ARG_L1(u), ARG_H1(u)
                  u(i,j,k) = zero
               end do
            end do
         end do
      end if

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(u).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(u)
            do j = ARG_L2(u), ARG_H2(u)
               do i = ARG_L1(u), ARG_H1(u)
                  u(i,j,k) = zero
               end do
            end do
         end do
      end if

      endif

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: v        <=  y velocity array
c ::: DIMS(v)   => index extent of v array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_YVELFILL (v,DIMS(v),domlo,domhi,dx,
     &                          xlo,time,bc)

      integer    DIMDEC(v)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     v(DIMV(v))
      integer    bc(SDIM,2)

      integer    i, j, k
      REAL_T     y_vel
      REAL_T     rn

#include "probdata.H"

      if(probtype.eq.8)then

         y_vel = zero

      else

      if (adv_dir .eq. 2) then
         y_vel = adv_vel
      else  
         y_vel = zero
      end if

      endif

      call filcc(v,DIMS(v),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(v).lt.domlo(1)) then
         do i = ARG_L1(v), domlo(1)-1
            do k = ARG_L3(v), ARG_H3(v)
               do j = ARG_L2(v), ARG_H2(v)
                  v(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(v).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(v)
            do k = ARG_L3(v), ARG_H3(v)
               do j = ARG_L2(v), ARG_H2(v)
                  v(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(v).lt.domlo(2)) then
         do j = ARG_L2(v), domlo(2)-1
            do k = ARG_L3(v), ARG_H3(v)
               do i = ARG_L1(v), ARG_H1(v)
                  v(i,j,k) = y_vel
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(v).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(v)
            do k = ARG_L3(v), ARG_H3(v)
               do i = ARG_L1(v), ARG_H1(v)
                  v(i,j,k) = y_vel
               end do
            end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(v).lt.domlo(3)) then
         do k = ARG_L3(v), domlo(3)-1
            do j = ARG_L2(v), ARG_H2(v)
               do i = ARG_L1(v), ARG_H1(v)
                  v(i,j,k) = zero
               end do
            end do
         end do
      end if        

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(v).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(v)
            do j = ARG_L2(v), ARG_H2(v)
               do i = ARG_L1(v), ARG_H1(v)
                  v(i,j,k) = zero
               end do
            end do
         end do
      end if        

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: w        <=  z velocity array
c ::: DIMS(w)   => index extent of v array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_ZVELFILL (w,DIMS(w),domlo,domhi,dx,
     &                          xlo,time,bc)

      integer    DIMDEC(w)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     w(DIMV(w))
      integer    bc(SDIM,2)

      integer    i, j, k
      REAL_T     z_vel

#include "probdata.H"


      if(probtype.eq.8)then

      z_vel = zero

      else



      if (adv_dir .eq. 3) then
         z_vel = adv_vel
      else  
         z_vel = zero
      end if

      endif

      call filcc(w,DIMS(w),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(w).lt.domlo(1)) then
         do i = ARG_L1(w), domlo(1)-1
            do k = ARG_L3(w), ARG_H3(w)
               do j = ARG_L2(w), ARG_H2(w)
                  w(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(w).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(w)
            do k = ARG_L3(w), ARG_H3(w)
               do j = ARG_L2(w), ARG_H2(w)
                  w(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(w).lt.domlo(2)) then
         do j = ARG_L2(w), domlo(2)-1
            do k = ARG_L3(w), ARG_H3(w)
               do i = ARG_L1(w), ARG_H1(w)
                  w(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(w).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(w)
            do k = ARG_L3(w), ARG_H3(w)
               do i = ARG_L1(w), ARG_H1(w)
                  w(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(w).lt.domlo(3)) then
         do k = ARG_L3(w), domlo(3)-1
            do j = ARG_L2(w), ARG_H2(w)
               do i = ARG_L1(w), ARG_H1(w)
                  w(i,j,k) = z_vel
               end do
            end do
         end do
      end if        

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(w).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(w)
            do j = ARG_L2(w), ARG_H2(w)
               do i = ARG_L1(w), ARG_H1(w)
                  w(i,j,k) = z_vel
               end do
            end do
         end do
      end if        

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: divu     <=  divergence of velocity array
c ::: DIMS(divu)=> index extent of divu array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_DIVUFILL (divu,DIMS(divu),domlo,domhi,dx,
     &                          xlo,time,bc)

      integer    DIMDEC(divu)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     divu(DIMV(divu))
      integer    bc(SDIM,2)

      integer    i, j, k
      REAL_T     z_vel

#include "probdata.H"

      if (adv_dir .eq. 3) then
         z_vel = adv_vel
      else  
         z_vel = zero
      end if

      call filcc(divu,DIMS(divu),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(divu).lt.domlo(1)) then
         do i = ARG_L1(divu), domlo(1)-1
            do k = ARG_L3(divu), ARG_H3(divu)
               do j = ARG_L2(divu), ARG_H2(divu)
                  divu(i,j,k) = z_vel
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(divu).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(divu)
            do k = ARG_L3(divu), ARG_H3(divu)
               do j = ARG_L2(divu), ARG_H2(divu)
                  divu(i,j,k) = z_vel
               end do
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(divu).lt.domlo(2)) then
         do j = ARG_L2(divu), domlo(2)-1
            do k = ARG_L3(divu), ARG_H3(divu)
               do i = ARG_L1(divu), ARG_H1(divu)
                  divu(i,j,k) = z_vel
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(divu).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(divu)
            do k = ARG_L3(divu), ARG_H3(divu)
               do i = ARG_L1(divu), ARG_H1(divu)
                  divu(i,j,k) = z_vel
               end do
            end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(divu).lt.domlo(3)) then
         do k = ARG_L3(divu), domlo(3)-1
            do j = ARG_L2(divu), ARG_H2(divu)
               do i = ARG_L1(divu), ARG_H1(divu)
                  divu(i,j,k) = z_vel
               end do
            end do
         end do
      end if        

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(divu).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(divu)
            do j = ARG_L2(divu), ARG_H2(divu)
               do i = ARG_L1(divu), ARG_H1(divu)
                  divu(i,j,k) = z_vel
               end do
            end do
         end do
      end if        

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: dsdt     <=  dsdt array
c ::: DIMS(dsdt)=> index extent of dsdt array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_DSDTFILL (dsdt,DIMS(dsdt),domlo,domhi,dx,
     &                          xlo,time,bc)

      integer    DIMDEC(dsdt)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     dsdt(DIMV(dsdt))
      integer    bc(SDIM,2)

      integer    i, j, k

      call filcc(dsdt,DIMS(dsdt),domlo,domhi,dx,xlo,bc)

      if (bc(1,1).eq.EXT_DIR.and.ARG_L1(dsdt).lt.domlo(1)) then
         do i = ARG_L1(dsdt), domlo(1)-1
            do k = ARG_L3(dsdt), ARG_H3(dsdt)
               do j = ARG_L2(dsdt), ARG_H2(dsdt)
                  dsdt(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(1,2).eq.EXT_DIR.and.ARG_H1(dsdt).gt.domhi(1)) then
         do i = domhi(1)+1, ARG_H1(dsdt)
            do k = ARG_L3(dsdt), ARG_H3(dsdt)
               do j = ARG_L2(dsdt), ARG_H2(dsdt)
                  dsdt(i,j,k) = zero
               end do
	    end do
	 end do
      end if            

      if (bc(2,1).eq.EXT_DIR.and.ARG_L2(dsdt).lt.domlo(2)) then
         do j = ARG_L2(dsdt), domlo(2)-1
            do k = ARG_L3(dsdt), ARG_H3(dsdt)
               do i = ARG_L1(dsdt), ARG_H1(dsdt)
                  dsdt(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(2,2).eq.EXT_DIR.and.ARG_H2(dsdt).gt.domhi(2)) then
         do j = domhi(2)+1, ARG_H2(dsdt)
            do k = ARG_L3(dsdt), ARG_H3(dsdt)
               do i = ARG_L1(dsdt), ARG_H1(dsdt)
                  dsdt(i,j,k) = zero
               end do
            end do
	 end do
      end if            

      if (bc(3,1).eq.EXT_DIR.and.ARG_L3(dsdt).lt.domlo(3)) then
         do k = ARG_L3(dsdt), domlo(3)-1
            do j = ARG_L2(dsdt), ARG_H2(dsdt)
               do i = ARG_L1(dsdt), ARG_H1(dsdt)
                  dsdt(i,j,k) = zero
               end do
            end do
         end do
      end if        

      if (bc(3,2).eq.EXT_DIR.and.ARG_H3(dsdt).gt.domhi(3)) then
         do k = domhi(3)+1, ARG_H3(dsdt)
            do j = ARG_L2(dsdt), ARG_H2(dsdt)
               do i = ARG_L1(dsdt), ARG_H1(dsdt)
                  dsdt(i,j,k) = zero
               end do
            end do
         end do
      end if        

      end

c ::: -----------------------------------------------------------
c ::: This routine is called during a filpatch operation when
c ::: the patch to be filled falls outside the interior
c ::: of the problem domain.  You are requested to supply the
c ::: data outside the problem interior in such a way that the
c ::: data is consistant with the types of the boundary conditions
c ::: you specified in the C++ code.  
c ::: 
c ::: NOTE:  you can assume all interior cells have been filled
c :::        with valid data.
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: p        <=  pressure array
c ::: lo,hi     => index extent of p array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of rho array
c ::: time      => problem evolution time
c ::: bc	=> array of boundary flags bc(BL_SPACEDIM,lo:hi)
c ::: -----------------------------------------------------------

      subroutine FORT_PRESFILL (p,DIMS(p),domlo,domhi,dx,
     &                          xlo,time,bc)

      integer    DIMDEC(p)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     dx(SDIM), xlo(SDIM), time
      REAL_T     p(DIMV(p))
      integer    bc(SDIM,2)

      integer    i, j, k
      integer    jlo, jhi, ilo, ihi, klo, khi
      logical    fix_xlo, fix_ylo, fix_zlo
      logical    fix_xhi, fix_yhi, fix_zhi
      logical    per_xlo, per_ylo, per_zlo
      logical    per_xhi, per_yhi, per_zhi

#include "probdata.H"

      fix_xlo = (ARG_L1(p) .lt. domlo(1)) .and. (bc(1,1) .ne. INT_DIR)
      per_xlo = (ARG_L1(p) .lt. domlo(1)) .and. (bc(1,1) .eq. INT_DIR)
      fix_xhi = (ARG_H1(p) .gt. domhi(1)) .and. (bc(1,2) .ne. INT_DIR)
      per_xhi = (ARG_H1(p) .gt. domhi(1)) .and. (bc(1,2) .eq. INT_DIR)
      fix_ylo = (ARG_L2(p) .lt. domlo(2)) .and. (bc(2,1) .ne. INT_DIR)
      per_ylo = (ARG_L2(p) .lt. domlo(2)) .and. (bc(2,1) .eq. INT_DIR)
      fix_yhi = (ARG_H2(p) .gt. domhi(2)) .and. (bc(2,2) .ne. INT_DIR)
      per_yhi = (ARG_H2(p) .gt. domhi(2)) .and. (bc(2,2) .eq. INT_DIR)
      fix_zlo = (ARG_L3(p) .lt. domlo(3)) .and. (bc(3,1) .ne. INT_DIR)
      per_zlo = (ARG_L3(p) .lt. domlo(3)) .and. (bc(3,1) .eq. INT_DIR)
      fix_zhi = (ARG_H3(p) .gt. domhi(3)) .and. (bc(3,2) .ne. INT_DIR)
      per_zhi = (ARG_H3(p) .gt. domhi(3)) .and. (bc(3,2) .eq. INT_DIR)

      ilo = max(ARG_L1(p),domlo(1))
      ihi = min(ARG_H1(p),domhi(1))
      jlo = max(ARG_L2(p),domlo(2))
      jhi = min(ARG_H2(p),domhi(2))
      Klo = max(ARG_L3(p),domlo(3))
      khi = min(ARG_H3(p),domhi(3))

c*****************************************************************************
c SETTING XLO 
c*****************************************************************************

      if (fix_xlo) then
         do i = ARG_L1(p), domlo(1)-1
            do k = klo, khi
               do j = jlo,jhi
                  p(i,j,k) = p(ilo,j,k)
               end do 
            end do
	 end do

	 if (fix_ylo) then
	    do i = ARG_L1(p), domlo(1)-1
               do j = ARG_L2(p), domlo(2)-1
                  do k = klo, khi
                     p(i,j,k) = p(ilo,jlo,k)
                  end do
               end do
	    end do

	    if (fix_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,jlo,klo)
                     end do
                  end do
               end do
	    else if (per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,jlo,k)
                     end do
                  end do
               end do
	    end if
	    if (fix_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,jlo,khi)
                     end do
                  end do
               end do
	    else if (per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,jlo,k)
                     end do
                  end do
               end do
	    end if
	 end if

	 if (fix_yhi) then
	    do i = ARG_L1(p), domlo(1)-1
               do j = domhi(2)+1, ARG_H2(p)
                  do k = klo, khi
                     p(i,j,k) = p(ilo,jhi,k)
                  end do
               end do
	    end do
	    if (fix_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,jhi,klo)
                     end do
                  end do
               end do
	    else if (per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,jhi,k)
                     end do
                  end do
               end do
	    end if
	    if (fix_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,jhi,khi)
                     end do
                  end do
               end do
	    else if (per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,jhi,k)
                     end do
                  end do
               end do
	    end if
	 end if

	 if (fix_zlo) then
	    do i = ARG_L1(p), domlo(1)-1
               do j = jlo, jhi
                  do k = ARG_L3(p), domlo(3)-1
                     p(i,j,k) = p(ilo,j,klo)
                  end do
               end do
	    end do
            if (per_ylo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,j,klo)
                     end do
                  end do
               end do
            end if
            if (per_yhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,j,klo)
                     end do
                  end do
               end do
            end if

	 end if

	 if (fix_zhi) then
	    do i = ARG_L1(p), domlo(1)-1
               do j = jlo, jhi
                  do k = domhi(3)+1, ARG_H3(p)
                     p(i,j,k) = p(ilo,j,khi)
                  end do
               end do
	    end do
            if (per_ylo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,j,khi)
                     end do
                  end do
               end do
            end if
            if (per_yhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,j,khi)
                     end do
                  end do
               end do
            end if
	 end if
 
         if (per_ylo) then
               do i = ARG_L1(p), domlo(1)-1
                  do k = klo,khi
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
         end if
         if (per_yhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do k = klo,khi
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
         end if
 
         if (per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = jlo,jhi
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
         end if
         if (per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = jlo,jhi
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
         end if

         if (per_ylo .and. per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
	 end if

         if (per_ylo .and. per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
	 end if

         if (per_yhi .and. per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
	 end if

         if (per_yhi .and. per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ilo,j,k)
                     end do
                  end do
               end do
	 end if

      end if            

c*****************************************************************************
c SETTING XHI
c*****************************************************************************

      if (fix_xhi) then
         do i = domhi(1)+1, ARG_H1(p)
            do k = klo, khi
               do j = jlo,jhi
                  p(i,j,k) = p(ihi,j,k)
               end do
            end do
	 end do

	 if (fix_ylo) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = ARG_L2(p), domlo(2)-1
                  do k = klo, khi
                     p(i,j,k) = p(ihi,jlo,k)
                  end do
               end do
	    end do

	    if (fix_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,jlo,klo)
                     end do
                  end do
               end do
	    else if (per_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,jlo,k)
                     end do
                  end do
               end do
	    end if
	    if (fix_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,jlo,khi)
                     end do
                  end do
               end do
	    else if (per_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,jlo,k)
                     end do
                  end do
               end do
	    end if
	 end if
	 if (fix_yhi) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = domhi(2)+1, ARG_H2(p)
                  do k = klo, khi
                     p(i,j,k) = p(ihi,jhi,k)
                  end do
               end do
	    end do
	    if (fix_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,jhi,klo)
                     end do
                  end do
               end do
	    else if (per_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,jhi,k)
                     end do
                  end do
               end do
	    end if
	    if (fix_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,jhi,khi)
                     end do
                  end do
               end do
	    else if (per_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,jhi,k)
                     end do
                  end do
               end do
	    end if
	 end if

	 if (fix_zlo) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = jlo, jhi
                  do k = ARG_L3(p), domlo(3)-1
                     p(i,j,k) = p(ihi,j,klo)
                  end do
               end do
	    end do
            if (per_ylo) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,j,klo)
                     end do
                  end do
               end do
            end if
            if (per_yhi) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,j,klo)
                     end do
                  end do
               end do
            end if

	 end if

	 if (fix_zhi) then
	    do i = domhi(1)+1, ARG_H1(p)
               do j = jlo, jhi
                  do k = domhi(3)+1, ARG_H3(p)
                     p(i,j,k) = p(ihi,j,khi)
                  end do
               end do
	    end do
            if (per_ylo) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,j,khi)
                     end do
                  end do
               end do
            end if
            if (per_yhi) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,j,khi)
                     end do
                  end do
               end do
            end if
	 end if

         if (per_ylo) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do k = klo,khi
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if
         if (per_yhi) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do k = klo,khi
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if

         if (per_zlo) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do j = jlo,jhi
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if
         if (per_zhi) then
	       do i = domhi(1)+1, ARG_H1(p)
                  do j = jlo,jhi
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if


         if (per_ylo .and. per_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if

         if (per_ylo .and. per_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if

         if (per_yhi .and. per_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if

         if (per_yhi .and. per_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(ihi,j,k)
                     end do
                  end do
               end do
         end if

      end if            

c*****************************************************************************
c SETTING YLO
c*****************************************************************************

      if (fix_ylo) then
         do j = ARG_L2(p), domlo(2)-1
            do k = klo, khi
               do i = ilo, ihi
                  p(i,j,k) = p(i,jlo,k)
               end do
            end do
	 end do

	 if (fix_zlo) then
	    do j = ARG_L2(p), domlo(2)-1
               do k = ARG_L3(p), domlo(3)-1
                  do i = ilo, ihi
                     p(i,j,k) = p(i,jlo,klo)
                  end do
               end do
	    end do
            if (per_xlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jlo,klo)
                     end do
                  end do
               end do
            end if
            if (per_xhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jlo,klo)
                     end do
                  end do
               end do
            end if
	 end if

	 if (fix_zhi) then
	    do j = ARG_L2(p), domlo(2)-1
               do k = domhi(3)+1, ARG_H3(p)
                  do i = ilo, ihi
                     p(i,j,k) = p(i,jlo,khi)
                  end do
               end do
	    end do
            if (per_xlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jlo,khi)
                     end do
                  end do
               end do
            end if
            if (per_xhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jlo,khi)
                     end do
                  end do
               end do
            end if
	 end if

         if (per_xlo) then
               do j = ARG_L2(p), domlo(2)-1
                  do k = klo,khi
                     do i = ARG_L1(p), domlo(1)-1
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if
         if (per_xhi) then
               do j = ARG_L2(p), domlo(2)-1
                  do k = klo,khi
                     do i = domhi(1)+1, ARG_H1(p)
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if

         if (per_zlo) then
               do j = ARG_L2(p), domlo(2)-1
                  do i = ilo,ihi
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if
         if (per_zhi) then
               do j = ARG_L2(p), domlo(2)-1
                  do i = ilo,ihi
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if


         if (per_xlo .and. per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if

         if (per_xlo .and. per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
                  do j = ARG_L2(p), domlo(2)-1
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jlo,k)
                     end do
                  end do
               end do
         end if

      end if            
 
c*****************************************************************************
c SETTING YHI
c*****************************************************************************

      if (fix_yhi) then
         do j = domhi(2)+1, ARG_H2(p)
            do k = klo, khi
               do i = ilo, ihi
                  p(i,j,k) = p(i,jhi,k)
               end do
            end do
	 end do

	 if (fix_zlo) then
	    do j = domhi(2)+1, ARG_H2(p)
               do k = ARG_L3(p), domlo(3)-1
                  do i = ilo, ihi
                     p(i,j,k) = p(i,jhi,klo)
                  end do
               end do
	    end do
            if (per_xlo) then
               do i = ARG_L1(p), domlo(1)-1
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jhi,klo)
                     end do
                  end do
               end do
            end if
            if (per_xhi) then
               do i = domhi(1)+1, ARG_H1(p)
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jhi,klo)
                     end do
                  end do
               end do
            end if
	 end if

	 if (fix_zhi) then
	    do j = domhi(2)+1, ARG_H2(p)
               do k = domhi(3)+1, ARG_H3(p)
                  do i = ilo, ihi
                     p(i,j,k) = p(i,jhi,khi)
                  end do
               end do
	    end do
            if (per_xlo) then
               do i = ARG_L1(p), domlo(1)-1
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jhi,khi)
                     end do
                  end do
               end do
            end if
            if (per_xhi) then
               do i = domhi(1)+1, ARG_H1(p)
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jhi,khi)
                     end do
                  end do
               end do
            end if
	 end if

         if (per_xlo) then
               do j = domhi(2)+1, ARG_H2(p)
                  do k = klo,khi
                     do i = ARG_L1(p), domlo(1)-1
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if
         if (per_xhi) then
               do j = domhi(2)+1, ARG_H2(p)
                  do k = klo,khi
                     do i = domhi(1)+1, ARG_H1(p)
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if

         if (per_zlo) then
               do j = domhi(2)+1, ARG_H2(p)
                  do i = ilo,ihi
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if
         if (per_zhi) then
               do j = domhi(2)+1, ARG_H2(p)
                  do i = ilo,ihi
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if

         if (per_xlo .and. per_zlo) then
               do i = ARG_L1(p), domlo(1)-1
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if

         if (per_xlo .and. per_zhi) then
               do i = ARG_L1(p), domlo(1)-1
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_zlo) then
               do i = domhi(1)+1, ARG_H1(p)
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = ARG_L3(p), domlo(3)-1
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_zhi) then
               do i = domhi(1)+1, ARG_H1(p)
	          do j = domhi(2)+1, ARG_H2(p)
                     do k = domhi(3)+1, ARG_H3(p)
                        p(i,j,k) = p(i,jhi,k)
                     end do
                  end do
               end do
         end if

      end if            

c*****************************************************************************
c SETTING ZLO
c*****************************************************************************

      if (fix_zlo) then
         do k = ARG_L3(p), domlo(3)-1
            do j = jlo, jhi
               do i = ilo, ihi
                  p(i,j,k) = p(i,j,klo)
               end do
            end do
	 end do

         if (per_xlo) then
               do k = ARG_L3(p), domlo(3)-1
                  do j = jlo,jhi
                     do i = ARG_L1(p), domlo(1)-1
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if
         if (per_xhi) then
               do k = ARG_L3(p), domlo(3)-1
                  do j = jlo,jhi
                     do i = domhi(1)+1, ARG_H1(p)
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if

         if (per_ylo) then
               do k = ARG_L3(p), domlo(3)-1
                  do i = ilo,ihi
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if
         if (per_yhi) then
               do k = ARG_L3(p), domlo(3)-1
                  do i = ilo,ihi
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if

         if (per_xlo .and. per_ylo) then
               do k = ARG_L3(p), domlo(3)-1
                  do i = ARG_L1(p), domlo(1)-1
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if

         if (per_xlo .and. per_yhi) then
               do k = ARG_L3(p), domlo(3)-1
                  do i = ARG_L1(p), domlo(1)-1
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_ylo) then
               do k = ARG_L3(p), domlo(3)-1
                  do i = domhi(1)+1, ARG_H1(p)
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_yhi) then
               do k = ARG_L3(p), domlo(3)-1
                  do i = domhi(1)+1, ARG_H1(p)
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(i,j,klo)
                     end do
                  end do
               end do
         end if

      end if            

c*****************************************************************************
c SETTING ZHI
c*****************************************************************************

      if (fix_zhi) then
         do k = domhi(3)+1, ARG_H3(p)
            do j = jlo, jhi
               do i = ilo, ihi
                  p(i,j,k) = p(i,j,khi)
               end do
            end do
	 end do

         if (per_xlo) then
               do k = domhi(3)+1, ARG_H3(p)
                  do j = jlo,jhi
                     do i = ARG_L1(p), domlo(1)-1
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if
         if (per_xhi) then
               do k = domhi(3)+1, ARG_H3(p)
                  do j = jlo,jhi
                     do i = domhi(1)+1, ARG_H1(p)
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if

         if (per_ylo) then
               do k = domhi(3)+1, ARG_H3(p)
                  do i = ilo,ihi
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if
         if (per_yhi) then
               do k = domhi(3)+1, ARG_H3(p)
                  do i = ilo,ihi
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if


         if (per_xlo .and. per_ylo) then
               do k = domhi(3)+1, ARG_H3(p)
                  do i = ARG_L1(p), domlo(1)-1
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if

         if (per_xlo .and. per_yhi) then
               do k = domhi(3)+1, ARG_H3(p)
                  do i = ARG_L1(p), domlo(1)-1
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_ylo) then
               do k = domhi(3)+1, ARG_H3(p)
                  do i = domhi(1)+1, ARG_H1(p)
                     do j = ARG_L2(p), domlo(2)-1
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if

         if (per_xhi .and. per_yhi) then
               do k = domhi(3)+1, ARG_H3(p)
                  do i = domhi(1)+1, ARG_H1(p)
                     do j = domhi(2)+1, ARG_H2(p)
                        p(i,j,k) = p(i,j,khi)
                     end do
                  end do
               end do
         end if

      end if            

c*****************************************************************************

      end

c-----------------------------------------------------------------------
      subroutine hggrad_dense(
     & gpx, gpy,
     &     gpl0, gph0, gpl1, gph1,
     & dest, destl0, desth0, destl1, desth1,
     &     fregl0, fregh0, fregl1, fregh1,
     & hx, hy, idummy)
      integer gpl0, gph0, gpl1, gph1
      integer destl0, desth0, destl1, desth1
      integer fregl0, fregh0, fregl1, fregh1
      double precision hx, hy
      double precision gpx(gpl0:gph0,gpl1:gph1)
      double precision gpy(gpl0:gph0,gpl1:gph1)
      double precision dest(destl0:desth0,destl1:desth1)
      integer idummy
      integer i, j
      do j = fregl1, fregh1
         do i = fregl0, fregh0
            gpx(i,j) = 0.5d0 * (dest(i+1,j) + dest(i+1,j+1) -
     &                          dest(i  ,j) - dest(i  ,j+1))
            gpy(i,j) = 0.5d0 * (dest(i,j+1) + dest(i+1,j+1) -
     &                          dest(i,j  ) - dest(i+1,j  ))
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgdiv_dense(
     & src, srcl0, srch0, srcl1, srch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     fregl0, fregh0, fregl1, fregh1,
     & hx, hy, idummy, jdummy)
      integer srcl0, srch0, srcl1, srch1
      integer fl0, fh0, fl1, fh1
      integer fregl0, fregh0, fregl1, fregh1
      double precision hx, hy
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision fac
      integer idummy, jdummy
      integer i, j
      fac = 0.5d0
      do j = fregl1, fregh1
         do i = fregl0, fregh0
            src(i,j) = fac *
     &        (uf(i,j-1) - uf(i-1,j-1) +
     &         uf(i,j  ) - uf(i-1,j) +
     &         vf(i-1,j) - vf(i-1,j-1) +
     &         vf(i  ,j) - vf(i,j-1))
         end do
      end do
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfdiv_dense(
     & src, srcl0, srch0, srcl1, srch1,
     & uc, vc,
     &     cl0, ch0, cl1, ch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     cregl0, cregh0, cregl1, cregh1,
     & hx, hy, ir, jr, idim, idir, idd1, idd2)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      double precision hx, hy
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      integer ir, jr, idim, idir
      double precision fac0, fac1
      integer i, j, iuf, juf, iuc, juc, m, n
      integer idd1, idd2
      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            iuc = i - 1
            iuf = i * ir
         else
            iuc = i
            iuf = i * ir - 1
         end if
         fac0 = 0.5d0
         do j = cregl1, cregh1
            src(i*ir,j*jr) = fac0 *
     &        ((vc(iuc,j) - vc(iuc,j-1)) -
     &         idir * (uc(iuc,j) + uc(iuc,j-1)))
         end do
         fac0 = fac0 / jr
         i = i * ir
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*cregl1, jr*cregh1, jr
               src(i,j) = src(i,j) + fac1 *
     &           (idir * (uf(iuf,j-n) + uf(iuf,j-n-1) +
     &                    uf(iuf,j+n) + uf(iuf,j+n-1)) +
     &                   (vf(iuf,j-n) - vf(iuf,j-n-1) +
     &                    vf(iuf,j+n) - vf(iuf,j+n-1)))
            end do
         end do
      else
         j = cregl1
         if (idir .eq. 1) then
            juc = j - 1
            juf = j * jr
         else
            juc = j
            juf = j * jr - 1
         end if
         fac0 = 0.5d0
         do i = cregl0, cregh0
            src(i*ir,j*jr) = fac0 *
     &        ((uc(i,juc) - uc(i-1,juc)) -
     &         idir * (vc(i,juc) + vc(i-1,juc)))
         end do
         fac0 = fac0 / ir
         j = j * jr
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*cregl0, ir*cregh0, ir
               src(i,j) = src(i,j) + fac1 *
     &           ((uf(i-m,juf) - uf(i-m-1,juf) +
     &             uf(i+m,juf) - uf(i+m-1,juf)) +
     &            idir * (vf(i-m,juf) + vf(i-m-1,juf) +
     &                    vf(i+m,juf) + vf(i+m-1,juf)))
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcdiv_dense(
     & src, srcl0, srch0, srcl1, srch1,
     & uc, vc,
     &     cl0, ch0, cl1, ch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     cregl0, cregh0, cregl1, cregh1,
     & hx, hy, ir, jr, ga, idd)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      integer idd
      double precision hx, hy
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      integer ir, jr, ga(0:1,0:1)
      double precision sum, fac, fac1
      integer ic, jc, if, jf, ii, ji, idir, jdir, m, n
      ic = cregl0
      jc = cregl1
      if = ic * ir
      jf = jc * jr
      sum = 0.d0
c quadrants
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) .eq. 1) then
               sum = sum + idir * uf(if+ii-1,jf+ji-1)
     &                   + jdir * vf(if+ii-1,jf+ji-1)
            else
               sum = sum + idir * uc(ic+ii-1,jc+ji-1)
     &                   + jdir * vc(ic+ii-1,jc+ji-1)
            end if
         end do
      end do
c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = 1.d0 / ir
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac * (       (uf(if+m,  jf+ji-1) -
     &                                       uf(if+m-1,jf+ji-1)) +
     &                               jdir * (vf(if+m,  jf+ji-1) +
     &                                       vf(if+m-1,jf+ji-1)))
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = 1.d0 / jr
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac * (idir * (uf(if+ii-1,jf+n) +
     &                                       uf(if+ii-1,jf+n-1)) +
     &                                      (vf(if+ii-1,jf+n) -
     &                                       vf(if+ii-1,jf+n-1)))
               end do
            end if
         end do
      end do
c weighting
      src(if,jf) = 0.5d0 * sum
      end
c-----------------------------------------------------------------------
      subroutine hggrad(
     & gpx, gpy, gpl0,
     &     gph0, gpl1, gph1,
     & dest, destl0, desth0, destl1, desth1,
     &     fregl0, fregh0, fregl1, fregh1,
     & hx, hy,
     & irz)
      integer gpl0, gph0, gpl1, gph1
      integer destl0, desth0, destl1, desth1
      integer fregl0, fregh0, fregl1, fregh1
      double precision gpx(gpl0:gph0,gpl1:gph1)
      double precision gpy(gpl0:gph0,gpl1:gph1)
      double precision dest(destl0:desth0,destl1:desth1)
      double precision hx, hy
      integer irz
      double precision hxm1h, hym1h, fac, r
      integer i, j
      hxm1h = 0.5d0 / hx
      hym1h = 0.5d0 / hy
      do j = fregl1, fregh1
         do i = fregl0, fregh0
            gpx(i,j) = hxm1h * (dest(i+1,j) + dest(i+1,j+1) -
     &                          dest(i,j) - dest(i,j+1))
            gpy(i,j) = hym1h * (dest(i,j+1) + dest(i+1,j+1) -
     &                          dest(i,j) - dest(i+1,j))
         end do
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgdiv(
     & src, srcl0, srch0, srcl1, srch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     fregl0, fregh0, fregl1, fregh1,
     & hx, hy,
     & irz, imax)
      integer srcl0, srch0, srcl1, srch1
      integer fl0, fh0, fl1, fh1
      integer fregl0, fregh0, fregl1, fregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision hx, hy
      integer irz, imax
      double precision hxm1, hym1, fac, r1, r0m, r1m
      integer i, j
      hxm1 = 1.d0 / hx
      hym1 = 1.d0 / hy
      fac = 0.5d0
      do j = fregl1, fregh1
         do i = fregl0, fregh0
            src(i,j) = fac *
     &        (hxm1 * (uf(i,j-1) - uf(i-1,j-1) +
     &                 uf(i,j)   - uf(i-1,j)) +
     &         hym1 * (vf(i-1,j) - vf(i-1,j-1) +
     &                 vf(i,j)   - vf(i,j-1)))
         end do
      end do

c     This correction is *only* for the cross stencil
      if (irz .eq. 1 .and. fregl0 .le. 0 .and. fregh0 .ge. 0) then
         i = 0
         do j = fregl1, fregh1
            src(i,j) = src(i,j) - fac * hym1 * 0.5d0 *
     &                (vf(i-1,j) - vf(i-1,j-1) +
     &                 vf(i,j)   - vf(i  ,j-1))
         end do
      endif

      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfdiv(
     & src, srcl0, srch0, srcl1, srch1,
     & uc, vc,
     &     cl0, ch0, cl1, ch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     cregl0, cregh0, cregl1, cregh1,
     & hx, hy, ir, jr, idim, idir, irz, imax)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision hx, hy
      integer ir, jr, idim, idir, irz, imax
      double precision hxm1, hym1, fac0, fac1, r, rfac, rfac0, rfac1
      double precision rfac0m, rfac1m, rfac0p, rfac1p
      integer i, j, iuf, juf, iuc, juc, m, n
      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            iuc = i - 1
            iuf = i * ir
         else
            iuc = i
            iuf = i * ir - 1
         end if
         fac0 = ir / (ir + 1.d0)
         hxm1 = 1.d0 / (ir * hx)
         hym1 = 1.d0 / (jr * hy)
         do j = cregl1, cregh1
            src(i*ir,j*jr) = fac0 *
     &        (hym1 * (vc(iuc,j) - vc(iuc,j-1)) -
     &         hxm1 * idir * (uc(iuc,j) + uc(iuc,j-1)))
         end do
         fac0 = fac0 / (ir * jr * jr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         i = i * ir
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*cregl1, jr*cregh1, jr
               src(i,j) = src(i,j) + fac1 *
     &           (hxm1 * idir * (uf(iuf,j-n) + uf(iuf,j-n-1) +
     &                           uf(iuf,j+n) + uf(iuf,j+n-1)) +
     &            hym1 * (vf(iuf,j-n) - vf(iuf,j-n-1) +
     &                    vf(iuf,j+n) - vf(iuf,j+n-1)))
            end do
         end do
      else
         j = cregl1
         if (idir .eq. 1) then
            juc = j - 1
            juf = j * jr
         else
            juc = j
            juf = j * jr - 1
         end if
         fac0 = jr / (jr + 1.d0)
         hxm1 = 1.d0 / (ir * hx)
         hym1 = 1.d0 / (jr * hy)
         do i = cregl0, cregh0
            src(i*ir,j*jr) = fac0 *
     &        (hxm1 * (uc(i,juc) - uc(i-1,juc)) -
     &         hym1 * idir * (vc(i,juc) + vc(i-1,juc)))
         end do
         if (irz .eq. 1 .and. cregl0 .le. 0 .and. cregh0 .ge. 0) then
            i = 0
            src(i*ir,j*jr) = fac0 *
     &        (hxm1 * (uc(i,juc) - uc(i-1,juc)) -
     &         hym1 * idir * (vc(i,juc) + vc(i-1,juc))*0.5d0 )
         endif

         fac0 = fac0 / (ir * ir * jr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         j = j * jr
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*cregl0, ir*cregh0, ir
               src(i,j) = src(i,j) + fac1 *
     &           (hxm1 * (uf(i-m,juf) - uf(i-m-1,juf) +
     &                    uf(i+m,juf) - uf(i+m-1,juf)) +
     &            hym1 * idir * (vf(i-m,juf) + vf(i-m-1,juf) +
     &                           vf(i+m,juf) + vf(i+m-1,juf)))
            end do

            if (irz .eq. 1 .and. m .eq. 0 .and.
     &          ir*cregl0 .le. 0 .and. ir*cregh0 .ge. 0) then
              i = 0
              src(i,j) = src(i,j) - fac1 * 0.5d0 *
     &              hym1 * idir * (vf(i-m,juf) + vf(i-m-1,juf) +
     &                             vf(i+m,juf) + vf(i+m-1,juf))
            endif
         end do
      end if
      end

c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcdiv(
     & src, srcl0,srch0,srcl1,srch1,
     & uc, vc,
     &      cl0,ch0,cl1,ch1,
     & uf, vf,
     &      fl0,fh0,fl1,fh1,
     &      cregl0,cregh0,cregl1,cregh1,
     & hx, hy, ir, jr, ga, irz)
      integer srcl0,srch0,srcl1,srch1
      integer cl0,ch0,cl1,ch1
      integer fl0,fh0,fl1,fh1
      integer cregl0,cregh0,cregl1,cregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision hx, hy, hz
      integer ir, jr, kr, ga(0:1,0:1), irz
      double precision r3, hxm1, hym1, hxm1c, hym1c
      double precision sum, center, cfac, ffac, fac0, fac1, fac
      integer ic, jc, if, jf, iuc, iuf, juc, juf
      integer ii, ji, idir, jdir, l, m, n
      r3 = ir * jr
      hxm1c = 1.0D0 / (ir * hx)
      hym1c = 1.0D0 / (jr * hy)
      hxm1 = ir * hxm1c
      hym1 = jr * hym1c
      ic = cregl0
      jc = cregl1
      if = ic * ir
      jf = jc * jr
      sum = 0.0D0
      center = 0.0D0
c octants
      fac = 1.0D0
      ffac = 0.5D0
      cfac = 0.5D0 * r3
      do ji = 0, 1
         jdir = 2 * ji - 1
         juf = jf + ji - 1
         juc = jc + ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) .eq. 1) then
               iuf = if + ii - 1
               center = center + ffac
               if (irz .eq. 1 .and. ic .eq. 0) then
                  sum = sum + fac *
     &                 (hxm1 * idir * uf(iuf,juf) +
     &                 hym1 * jdir * vf(iuf,juf) * 0.5d0)
               else
                  sum = sum + fac *
     &                 (hxm1 * idir * uf(iuf,juf) +
     &                 hym1 * jdir * vf(iuf,juf))
               endif
            else
               iuc = ic + ii - 1
               center = center + cfac
               if (irz .eq. 1 .and. ic .eq. 0) then
                  sum = sum + r3 *
     &                 (hxm1c * idir * uc(iuc,juc) +
     &                 hym1c * jdir * vc(iuc,juc) * 0.5d0)
               else
                  sum = sum + r3 *
     &                 (hxm1c * idir * uc(iuc,juc) +
     &                 hym1c * jdir * vc(iuc,juc))
               endif
            end if
         end do
      end do
c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         juf = jf + ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            iuf = if + ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = 1.0D0 / ir
               ffac = 0.5D0 * (ir-1)
               center = center + ffac
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac * (hxm1 *
     &                 (uf(if+m,juf) - uf(if+m-1,juf)) +
     &                 hym1 * jdir *
     &                 (vf(if+m,juf) + vf(if+m-1,juf)))
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = 1.0D0 / jr
               ffac = 0.5D0 * (jr-1)
               center = center + ffac
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac * (hxm1 * idir *
     &                 (uf(iuf,jf+n) + uf(iuf,jf+n-1)) +
     &                 hym1 *
     &                 (vf(iuf,jf+n) - vf(iuf,jf+n-1)))
               end do
            end if
         end do
      end do
c     weighting
      src(if,jf) = sum / center
      end

c-----------------------------------------------------------------------
      subroutine hgvort_dense(
     & src, srcl0, srch0, srcl1, srch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     fregl0, fregh0, fregl1, fregh1,
     & hx, hy, idummy, jdummy)
      integer srcl0, srch0, srcl1, srch1
      integer fl0, fh0, fl1, fh1
      integer fregl0, fregh0, fregl1, fregh1
      double precision hx, hy
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision fac
      integer idummy, jdummy
      integer i, j
      fac = 0.5d0
      do j = fregl1, fregh1
         do i = fregl0, fregh0
            src(i,j) = fac * (
     &        (vf(i,j-1) - vf(i-1,j-1) +
     &         vf(i,j  ) - vf(i-1,j  )) -
     &        (uf(i-1,j) - uf(i-1,j-1) +
     &         uf(i  ,j) - uf(i  ,j-1)) )
         end do
      end do
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfvort_dense(
     & src, srcl0, srch0, srcl1, srch1,
     & uc, vc,
     &     cl0, ch0, cl1, ch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     cregl0, cregh0, cregl1, cregh1,
     & hx, hy, ir, jr, idim, idir, idd1, idd2)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      double precision hx, hy
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      integer ir, jr, idim, idir
      double precision fac0, fac1
      integer i, j, iuf, juf, iuc, juc, m, n
      integer idd1, idd2
      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            iuc = i - 1
            iuf = i * ir
         else
            iuc = i
            iuf = i * ir - 1
         end if
         fac0 = 0.5d0
         do j = cregl1, cregh1
            src(i*ir,j*jr) = fac0 *
     &        (-(uc(iuc,j) - uc(iuc,j-1)) -
     &         idir * (vc(iuc,j) + vc(iuc,j-1)))
         end do
         fac0 = fac0 / jr
         i = i * ir
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*cregl1, jr*cregh1, jr
               src(i,j) = src(i,j) + fac1 *
     &           (idir * (vf(iuf,j-n) + vf(iuf,j-n-1) +
     &                    vf(iuf,j+n) + vf(iuf,j+n-1)) -
     &                   (uf(iuf,j-n) - uf(iuf,j-n-1) +
     &                    uf(iuf,j+n) - uf(iuf,j+n-1)))
            end do
         end do
      else
         j = cregl1
         if (idir .eq. 1) then
            juc = j - 1
            juf = j * jr
         else
            juc = j
            juf = j * jr - 1
         end if
         fac0 = 0.5d0
         do i = cregl0, cregh0
            src(i*ir,j*jr) = fac0 *
     &        ((vc(i,juc) - vc(i-1,juc)) +
     &         idir * (uc(i,juc) + uc(i-1,juc)))
         end do
         fac0 = fac0 / ir
         j = j * jr
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*cregl0, ir*cregh0, ir
               src(i,j) = src(i,j) + fac1 *
     &           ((vf(i-m,juf) - vf(i-m-1,juf) +
     &             vf(i+m,juf) - vf(i+m-1,juf)) -
     &            idir * (uf(i-m,juf) + uf(i-m-1,juf) +
     &                    uf(i+m,juf) + uf(i+m-1,juf)))
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcvort_dense(
     & src, srcl0, srch0, srcl1, srch1,
     & uc, vc,
     &     cl0, ch0, cl1, ch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     cregl0, cregh0, cregl1, cregh1,
     & hx, hy, ir, jr, ga, idd)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      integer idd
      double precision hx, hy
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      integer ir, jr, ga(0:1,0:1)
      double precision sum, fac, fac1
      integer ic, jc, if, jf, ii, ji, idir, jdir, m, n
      ic = cregl0
      jc = cregl1
      if = ic * ir
      jf = jc * jr
      sum = 0.d0
c quadrants
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) .eq. 1) then
               sum = sum + idir * vf(if+ii-1,jf+ji-1)
     &                   - jdir * uf(if+ii-1,jf+ji-1)
            else
               sum = sum + idir * vc(ic+ii-1,jc+ji-1)
     &                   - jdir * uc(ic+ii-1,jc+ji-1)
            end if
         end do
      end do
c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = 1.d0 / ir
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac * (       (vf(if+m,  jf+ji-1) -
     &                                       vf(if+m-1,jf+ji-1)) -
     &                               jdir * (uf(if+m,  jf+ji-1) +
     &                                       uf(if+m-1,jf+ji-1)))
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = 1.d0 / jr
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac * (idir * (vf(if+ii-1,jf+n) +
     &                                       vf(if+ii-1,jf+n-1)) -
     &                                      (uf(if+ii-1,jf+n) -
     &                                       uf(if+ii-1,jf+n-1)))
               end do
            end if
         end do
      end do
c weighting
      src(if,jf) = 0.5d0 * sum
      end

c-----------------------------------------------------------------------
      subroutine hgvort(
     & src, srcl0, srch0, srcl1, srch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     fregl0, fregh0, fregl1, fregh1,
     & hx, hy,
     & irz, imax)
      integer srcl0, srch0, srcl1, srch1
      integer fl0, fh0, fl1, fh1
      integer fregl0, fregh0, fregl1, fregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision hx, hy
      integer irz, imax
      double precision hxm1, hym1, fac, r1, r0m, r1m
      integer i, j
      hxm1 =  1.d0 / hx
      hym1 = -1.d0 / hy
      fac = 0.5d0

      if (irz .eq. 1) then
         print *,'NOT SET UP TO DO VORTICITY IN R-Z: HGVORT'
         stop
      endif

      do j = fregl1, fregh1
         do i = fregl0, fregh0
            src(i,j) = fac *
     &        (hxm1 * (vf(i,j-1) - vf(i-1,j-1) +
     &                 vf(i,j)   - vf(i-1,j)) +
     &         hym1 * (uf(i-1,j) - uf(i-1,j-1) +
     &                 uf(i,j)   - uf(i,j-1)))
         end do
      end do

      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfvort(
     & src, srcl0, srch0, srcl1, srch1,
     & uc, vc,
     &     cl0, ch0, cl1, ch1,
     & uf, vf,
     &     fl0, fh0, fl1, fh1,
     &     cregl0, cregh0, cregl1, cregh1,
     & hx, hy, ir, jr, idim, idir, irz, imax)
      integer srcl0, srch0, srcl1, srch1
      integer cl0, ch0, cl1, ch1
      integer fl0, fh0, fl1, fh1
      integer cregl0, cregh0, cregl1, cregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision hx, hy
      integer ir, jr, idim, idir, irz, imax
      double precision hxm1, hym1, fac0, fac1, r, rfac, rfac0, rfac1
      double precision rfac0m, rfac1m, rfac0p, rfac1p
      integer i, j, iuf, juf, iuc, juc, m, n

      if (irz .eq. 1) then
         print *,'NOT SET UP TO DO VORTICITY IN R-Z: HGFVORT'
         stop
      endif

      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            iuc = i - 1
            iuf = i * ir
         else
            iuc = i
            iuf = i * ir - 1
         end if
         fac0 = ir / (ir + 1.d0)
         hxm1 =  1.d0 / (ir * hx)
         hym1 = -1.d0 / (jr * hy)
         do j = cregl1, cregh1
            src(i*ir,j*jr) = fac0 *
     &        (hym1 * (uc(iuc,j) - uc(iuc,j-1)) -
     &         hxm1 * idir * (vc(iuc,j) + vc(iuc,j-1)))
         end do

         fac0 = fac0 / (ir * jr * jr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         i = i * ir
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*cregl1, jr*cregh1, jr
               src(i,j) = src(i,j) + fac1 *
     &           (hxm1 * idir * (vf(iuf,j-n) + vf(iuf,j-n-1) +
     &                           vf(iuf,j+n) + vf(iuf,j+n-1)) +
     &            hym1 * (uf(iuf,j-n) - uf(iuf,j-n-1) +
     &                    uf(iuf,j+n) - uf(iuf,j+n-1)))
            end do
         end do
      else
         j = cregl1
         if (idir .eq. 1) then
            juc = j - 1
            juf = j * jr
         else
            juc = j
            juf = j * jr - 1
         end if
         fac0 = jr / (jr + 1.d0)
         hxm1 =  1.d0 / (ir * hx)
         hym1 = -1.d0 / (jr * hy)
         do i = cregl0, cregh0
            src(i*ir,j*jr) = fac0 *
     &        (hxm1 * (vc(i,juc) - vc(i-1,juc)) -
     &         hym1 * idir * (uc(i,juc) + uc(i-1,juc)))
         end do

         fac0 = fac0 / (ir * ir * jr)
         hxm1 = ir * hxm1
         hym1 = jr * hym1
         j = j * jr
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*cregl0, ir*cregh0, ir
               src(i,j) = src(i,j) + fac1 *
     &           (hxm1 * (vf(i-m,juf) - vf(i-m-1,juf) +
     &                    vf(i+m,juf) - vf(i+m-1,juf)) +
     &            hym1 * idir * (uf(i-m,juf) + uf(i-m-1,juf) +
     &                           uf(i+m,juf) + uf(i+m-1,juf)))
            end do
         end do
      end if
      end

c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcvort(
     & src, srcl0,srch0,srcl1,srch1,
     & uc, vc,
     &      cl0,ch0,cl1,ch1,
     & uf, vf,
     &      fl0,fh0,fl1,fh1,
     &      cregl0,cregh0,cregl1,cregh1,
     & hx, hy, ir, jr, ga, irz)
      integer srcl0,srch0,srcl1,srch1
      integer cl0,ch0,cl1,ch1
      integer fl0,fh0,fl1,fh1
      integer cregl0,cregh0,cregl1,cregh1
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision uc(cl0:ch0,cl1:ch1)
      double precision vc(cl0:ch0,cl1:ch1)
      double precision uf(fl0:fh0,fl1:fh1)
      double precision vf(fl0:fh0,fl1:fh1)
      double precision hx, hy, hz
      integer ir, jr, kr, ga(0:1,0:1), irz
      double precision r3, hxm1, hym1, hxm1c, hym1c
      double precision sum, center, cfac, ffac, fac0, fac1, fac
      integer ic, jc, if, jf, iuc, iuf, juc, juf
      integer ii, ji, idir, jdir, l, m, n

      if (irz .eq. 1) then
         print *,'NOT SET UP TO DO VORTICITY IN R-Z: HGCVORT'
         stop
      endif

      r3 = ir * jr
      hxm1c = 1.0D0 / (ir * hx)
      hym1c = 1.0D0 / (jr * hy)
      hxm1 =  ir * hxm1c
      hym1 = -jr * hym1c
      ic = cregl0
      jc = cregl1
      if = ic * ir
      jf = jc * jr
      sum = 0.0D0
      center = 0.0D0
c octants
      fac = 1.0D0
      ffac = 0.5D0
      cfac = 0.5D0 * r3
      do ji = 0, 1
         jdir = 2 * ji - 1
         juf = jf + ji - 1
         juc = jc + ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) .eq. 1) then
               iuf = if + ii - 1
               center = center + ffac
               sum = sum + fac *
     &              (hxm1 * idir * vf(iuf,juf) +
     &               hym1 * jdir * uf(iuf,juf))
            else
               iuc = ic + ii - 1
               center = center + cfac
               sum = sum + r3 *
     &              (hxm1c * idir * vc(iuc,juc) +
     &               hym1c * jdir * uc(iuc,juc))
            end if
         end do
      end do
c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         juf = jf + ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            iuf = if + ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = 1.0D0 / ir
               ffac = 0.5D0 * (ir-1)
               center = center + ffac
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac * (hxm1 *
     &                 (vf(if+m,juf) - vf(if+m-1,juf)) +
     &                 hym1 * jdir *
     &                 (uf(if+m,juf) + uf(if+m-1,juf)))
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = 1.0D0 / jr
               ffac = 0.5D0 * (jr-1)
               center = center + ffac
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac * (hxm1 * idir *
     &                 (vf(iuf,jf+n) + vf(iuf,jf+n-1)) +
     &                 hym1 *
     &                 (uf(iuf,jf+n) - uf(iuf,jf+n-1)))
               end do
            end if
         end do
      end do
c     weighting
      src(if,jf) = sum / center
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: GODUNOV_3D.F,v 1.3 2001/02/14 19:05:36 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "GODUNOV_F.H"
#include "ArrayLim.H"
#include "integrator.fh"
      
#if defined(BL_USE_FLOAT) || defined(BL_T3E)
#define  BL_USE_FLOAT_CONST
#define  onetominussix 1.0e-6
#define  onepointfour  1.4
#endif
#if defined(BL_USE_DOUBLE) && ! defined(BL_T3E)
#define  BL_USE_DOUBLE_CONST
#define  onetominussix 1.0d-6
#define  onepointfour  1.4d+00
#endif

#define SDIM 3
#define NGHOST 3
#define LEFT	 0
#define RIGHT	 1
#define BOTTOM	 2
#define TOP 	 3
#define FRONT	 4
#define BACK 	 5
#define INTERIOR -1
#define ON_PHYS_B 0
#define NTHERM   6
#define NQ	 (6+NADV)

#if __STDC__==1
#define BL_ARGL1(u) u##_l1
#define BL_ARGL2(u) u##_l2
#define BL_ARGL3(u) u##_l3
#define BL_ARGH1(u) u##_h1
#define BL_ARGH2(u) u##_h2
#define BL_ARGH3(u) u##_h3
#define BL_IARG(u) u##_l1, u##_l2, u##_l3, u##_h1, u##_h2, u##_h3
#define BL_UVAR(u,v) REAL_T u(v##_l1:v##_h1, v##_l2:v##_h2, v##_l3:v##_h3)
#else
#define BL_ARGL1(u) u/**/_l1
#define BL_ARGL2(u) u/**/_l2
#define BL_ARGL3(u) u/**/_l3
#define BL_ARGH1(u) u/**/_h1
#define BL_ARGH2(u) u/**/_h2
#define BL_ARGH3(u) u/**/_h3
#define BL_IARG(u) u/**/_l1, u/**/_l2, u/**/_l3, u/**/_h1, u/**/_h2, u/**/_h3
#define BL_UVAR(u,v) REAL_T u(v/**/_l1:v/**/_h1, v/**/_l2:v/**/_h2, v/**/_l3:v/**/_h3)
#endif

c
c From ArrayLim.H ...
c

#define BL_FARG(u) u, DIMS(u)
#define BL_FBOUNDS(u) integer DIMDEC(u)
#define BL_FARRAY(u,n) REAL_T u(DIMV(u), n)
#define BL_FARRAY1(u) REAL_T u(DIMV(u))

#if __STDC__==1
#define BL_BARG(b) b##lo, b##hi
#define BL_BBOUNDS(b) integer b##lo(3), b##hi(3)
#else
#define BL_BARG(b) b/**/lo, b/**/hi
#define BL_BBOUNDS(b) integer b/**/lo(3), b/**/hi(3)
#endif

c 
c ---------------------------------------------------------------
c::  Characteristic tracing for hyperbolic conservation law
c::  Arguments:
c::  q         => field of primitive variables
c::  qx        => x-slopes of primitive variables
c::  c         => sound speed                         
c::  enth     <=  enthalpy
c::  qbarl    <=  left-edge traced state     
c::  qbarr    <=  right-edge traced state   
c::  bxlo,bxhi => index limits of grid interior
c::  bc        => array of bndry condition flags
c::  delta     => cell size
c::  dt        => timestep size
c::  nvar      => number of characteristic variables
c ---------------------------------------------------------------
c ::: these give meaning to the primitive variable components
#define  QRHO    1
#define  QVEL1   2
#define  QVEL2   3
#define  QVEL3   4
#define  QPRES   5
#define  QRHOE   6
#if(NADV>0)
#define  QADV    7
#endif

      subroutine FORT_XTRACE(
     &          BL_FARG(q),
     &          BL_FARG(qx),
     &          BL_FARG(c),
     &          BL_FARG(enth),
     &          BL_FARG(qbarl),
     &          BL_FARG(qbarr),
     &          BL_FARG(dloga),
     &          BL_FARG(courno),
     &          BL_BARG(bx),
     &          delta, dt, bc, gBndry, nvar
     &		)

      integer nvar, gBndry(0:2*SDIM-1)
      integer bc(SDIM,2,nvar-1),qbc(SDIM,2,NQ)
      REAL_T  delta(SDIM), dt
      BL_FBOUNDS(q)
      BL_FARRAY(q,nvar)
      BL_FBOUNDS(qx)
      BL_FARRAY(qx,nvar)
      BL_FBOUNDS(qbarl)
      BL_FARRAY(qbarl,nvar)
      BL_FBOUNDS(qbarr)
      BL_FARRAY(qbarr,nvar)
      BL_FBOUNDS(c)
      BL_FARRAY1(c)
      BL_FBOUNDS(enth)
      BL_FARRAY1(enth)
      BL_FBOUNDS(dloga)
      BL_FARRAY1(dloga)
      BL_FBOUNDS(courno)
      BL_FARRAY1(courno)
      BL_BBOUNDS(bx)

      integer i, j, k, n, nbc
      integer is, ie, js, je, ks, ke, isedg, ieedg,jsedg,jeedg
      integer ksedg, keedg
      REAL_T  dx, dy, dz
      REAL_T spvol, dtbydx, scr, eken, eta, dthalf
      REAL_T sourcp, sourcr, source, avgarea
      REAL_T alpham, alphap, alpha0r, alpha0e
      REAL_T alpha0v1,alpha0v2
      REAL_T spminus, spplus, spzero
      REAL_T apright, amright
      REAL_T apleft, amleft
      REAL_T azrright, azeright, azv1rght,azv2rght
      REAL_T azrleft, azeleft, azv1left,azv2left
      REAL_T smallr
      REAL_T reflect
      
      REAL_T gdum,csdum,pdum
      integer iv

c     ::: some useful macro definitions
#     define U(i,j,k) 		q(i,j,k,QVEL1)
#     define V(i,j,k) 		q(i,j,k,QVEL2)
#     define W(i,j,k) 		q(i,j,k,QVEL3)
#     define P(i,j,k) 		q(i,j,k,QPRES)
#     define RHO(i,j,k) 	q(i,j,k,QRHO)
#     define RHOE(i,j,k) 	q(i,j,k,QRHOE)
#if(NADV>0)
#     define ADV(i,j,k) 	q(i,j,k,QADV)
#endif
#     define DU(i,j,k) 		qx(i,j,k,QVEL1)
#     define DV(i,j,k) 		qx(i,j,k,QVEL2)
#     define DW(i,j,k) 		qx(i,j,k,QVEL3)
#     define DP(i,j,k) 		qx(i,j,k,QPRES)
#     define DRHO(i,j,k) 	qx(i,j,k,QRHO)
#     define DRHOE(i,j,k)	qx(i,j,k,QRHOE)
#if(NADV>0)
#     define DADV(i,j,k)	qx(i,j,k,QADV)
#endif
        
      dx = delta(1)
      dy = delta(2)
      dz = delta(3)
      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      ks = bxlo(3)
      ke = bxhi(3)
      isedg = qbarl_l1 
      ieedg = qbarl_h1 
      jsedg = qbarl_l2 
      jeedg = qbarl_h2 
      ksedg = qbarl_l3 
      keedg = qbarl_h3

      smallr = onetominussix
      dtbydx = dt/dx

c ::: convert energy to intensive form for eos call
c     do k = ks,ke
c      do j = js,je
c       do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)/RHO(i,j,k)
c       enddo
c      enddo
c     enddo

c     convert energy to extensive form and compute courant number
      do k = ks,ke
       do j = js,je
        do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)*RHO(i,j,k)
          courno(i,j,k) = dtbydx*(c(i,j,k)+abs(U(i,j,k)))       
        enddo
       enddo
      enddo

c     characteristic analysis
      do k = ksedg,keedg
       do j = jsedg,jeedg
        do i = isedg,ieedg-1
          enth(i,j,k) = (RHOE(i,j,k)/RHO(i,j,k) +
     $                 P(i,j,k)/RHO(i,j,k))/c(i,j,k)**2
          alpham = half*(DP(i,j,k)/(RHO(i,j,k)*c(i,j,k)) - DU(i,j,k))*RHO(i,j,k)
     $    /c(i,j,k)
          alphap = half*(DP(i,j,k)/(RHO(i,j,k)*c(i,j,k)) + DU(i,j,k))*RHO(i,j,k)
     $    /c(i,j,k)
          alpha0r = DRHO(i,j,k) - DP(i,j,k)/c(i,j,k)**2
          alpha0e = DRHOE(i,j,k) - DP(i,j,k)*enth(i,j,k)
          alpha0v1 = DV(i,j,k)
          alpha0v2 = DW(i,j,k)

c ::: :::::  Right state of edge at left
          spminus = cvmgp(-one,(U(i,j,k) - c(i,j,k))*dtbydx,U(i,j,k) - c(i,j,k))
          spplus = cvmgp(-one,(U(i,j,k) + c(i,j,k))*dtbydx,U(i,j,k) + c(i,j,k))
          spzero = cvmgp(-one, U(i,j,k) *dtbydx,U(i,j,k) )
          apright = half*(-one - spplus )*alphap
          amright = half*(-one - spminus)*alpham
          azrright= half*(-one - spzero )*alpha0r
          azeright= half*(-one - spzero )*alpha0e
          azv1rght= half*(-one - spzero )*alpha0v1
          azv2rght= half*(-one - spzero )*alpha0v2
          qbarr(i,j,k,QRHO) = q(i,j,k,QRHO) + apright + amright + azrright
          qbarr(i,j,k,QRHO) = max(smallr, qbarr(i,j,k,QRHO))
          qbarr(i,j,k,QVEL1) = q(i,j,k,QVEL1) +
     $                      (apright - amright)*c(i,j,k)/RHO(i,j,k)
          qbarr(i,j,k,QVEL2) = q(i,j,k,QVEL2) + azv1rght
          qbarr(i,j,k,QVEL3) = q(i,j,k,QVEL3) + azv2rght
          qbarr(i,j,k,QPRES) = q(i,j,k,QPRES) +
     $                      (apright + amright)*c(i,j,k)**2
          qbarr(i,j,k,QRHOE) = q(i,j,k,QRHOE) + (apright +
     $                       amright)*enth(i,j,k)*c(i,j,k)**2 + azeright
#if(NADV>0)
          qbarr(i,j,k,QADV) = q(i,j,k,QADV)+half*(-one-spzero)*DADV(i,j,k)
#endif

c ::: :::::  Left state of edge at right

          spminus = cvmgp((U(i,j,k) - c(i,j,k))*dtbydx,one,U(i,j,k) - c(i,j,k))
          spplus = cvmgp((U(i,j,k) + c(i,j,k))*dtbydx,one,U(i,j,k) + c(i,j,k))
          spzero = cvmgp( U(i,j,k) *dtbydx,one,U(i,j,k) )
          apleft = half*(one - spplus )*alphap
          amleft = half*(one - spminus)*alpham
          azrleft= half*(one - spzero )*alpha0r
          azeleft= half*(one - spzero )*alpha0e
          azv1left= half*(one - spzero )*alpha0v1
          azv2left= half*(one - spzero )*alpha0v2
          qbarl(i+1,j,k,QRHO) = q(i,j,k,QRHO) + apleft + amleft + azrleft
          qbarl(i+1,j,k,QRHO) = max(smallr, qbarl(i+1,j,k,QRHO))
          qbarl(i+1,j,k,QVEL1) = q(i,j,k,QVEL1) +
     $                         (apleft - amleft)*c(i,j,k)/RHO(i,j,k)
          qbarl(i+1,j,k,QVEL2) = q(i,j,k,QVEL2) + azv1left
          qbarl(i+1,j,k,QVEL3) = q(i,j,k,QVEL3) + azv2left
          qbarl(i+1,j,k,QPRES) = q(i,j,k,QPRES) +
     $                         (apleft + amleft)*c(i,j,k)**2
          qbarl(i+1,j,k,QRHOE) = q(i,j,k,QRHOE) + (apleft + amleft)*
     $                         enth(i,j,k)*c(i,j,k)**2 + azeleft
#if(NADV>0)
          qbarl(i+1,j,k,QADV) = q(i,j,k,QADV)+half*(one-spzero)*DADV(i,j,k)
#endif
        enddo
       enddo
      enddo
          

c ::: Colella hack near R=0 singularity
      do k = ks,ke
       do j = js,je
        do i = is,ie
          if (dloga(i,j,k) .ne. zero) then
              eta = (one-courno(i,j,k))/(c(i,j,k)*dt*dloga(i,j,k))
              eta = min(one, eta)
              dloga(i,j,k) = dloga(i,j,k) * eta
          endif
        enddo
       enddo
      enddo

      dthalf = half*dt
c ::: add geometric source terms to traced states
      do k = ksedg,keedg
       do j = jsedg,jeedg
        do i = isedg,ieedg-1
          sourcr = -RHO(i,j,k)*dloga(i,j,k)*U(i,j,k)*dthalf
          sourcp = sourcr*c(i,j,k)**2
          source = sourcp*enth(i,j,k)
          qbarl(i+1,j,k,QRHO) = qbarl(i+1,j,k,QRHO) + sourcr
          qbarl(i+1,j,k,QRHO) = max(smallr, qbarl(i+1,j,k,QRHO))
          qbarl(i+1,j,k,QPRES) = qbarl(i+1,j,k,QPRES) + sourcp
          qbarl(i+1,j,k,QRHOE) = qbarl(i+1,j,k,QRHOE) + source
          qbarr(i,j,k,QRHO) = qbarr(i,j,k,QRHO) + sourcr
          qbarr(i,j,k,QRHO) = max(smallr, qbarr(i,j,k,QRHO))
          qbarr(i,j,k,QPRES) = qbarr(i,j,k,QPRES) + sourcp
          qbarr(i,j,k,QRHOE) = qbarr(i,j,k,QRHOE) + source
        enddo
       enddo
      enddo

c ::: convert energy back to intensive form 
c ::: for eos call in RIEMANN
c     do k = ks,ke
c      do j = js,je
c       do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)/RHO(i,j,k)
c       enddo
c     enddo
c     enddo


#undef U
#undef V
#undef W
#undef P
#undef RHO
#undef RHOE
#undef DU
#undef DV
#undef DW
#undef DP
#undef DRHO
#undef DRHOE
#if(NADV>0)
#undef DADV
#endif

      end


c 
c ---------------------------------------------------------------
c::  Y characteristic tracing for hyperbolic conservation law
c::  Arguments:
c::  q         => field of primitive variables
c::  qy        => x-slopes of primitive variables
c::  c         => sound speed                         
c::  enth     <=  enthalpy
c::  qbarl    <=  bottom-edge traced state     
c::  qbarr    <=  top-edge traced state   
c::  bxlo,bxhi => index limits of grid interior
c::  bc        => array of bndry condition flags
c::  delta     => cell size
c::  dt        => timestep size
c::  nvar      => number of characteristic variables
c ---------------------------------------------------------------
c ::: these give meaning to the primitive variable components
#define  QRHO    1
#define  QVEL1   2
#define  QVEL2   3
#define  QVEL3   4
#define  QPRES   5
#define  QRHOE   6
#if(NADV>0)
#define  QADV    7
#endif


      subroutine FORT_YTRACE(
     &          BL_FARG(q),
     &          BL_FARG(qy),
     &          BL_FARG(c),
     &          BL_FARG(enth),
     &          BL_FARG(qbarl),
     &          BL_FARG(qbarr),
     &          BL_FARG(dloga),
     &          BL_FARG(courno),
     &          BL_BARG(bx),
     &          delta, dt, bc, gBndry, nvar
     &		)

      integer nvar, gBndry(0:2*SDIM-1)
      integer bc(SDIM,2,nvar-1),qbc(SDIM,2,NQ)
      REAL_T  delta(SDIM), dt
      BL_FBOUNDS(q)
      BL_FARRAY(q,nvar)
      BL_FBOUNDS(qy)
      BL_FARRAY(qy,nvar)
      BL_FBOUNDS(qbarl)
      BL_FARRAY(qbarl,nvar)
      BL_FBOUNDS(qbarr)
      BL_FARRAY(qbarr,nvar)
      BL_FBOUNDS(c)
      BL_FARRAY1(c)
      BL_FBOUNDS(enth)
      BL_FARRAY1(enth)
      BL_FBOUNDS(dloga)
      BL_FARRAY1(dloga)
      BL_FBOUNDS(courno)
      BL_FARRAY1(courno)
      BL_BBOUNDS(bx)

      integer i, j,k, n, nbc
      integer is,ie,js,je,ks,ke,isedg,ieedg,jsedg,jeedg,ksedg,keedg
      REAL_T  dx, dy,dz
      REAL_T spvol, dtbydx, scr, eken, eta, dthalf
      REAL_T sourcp, sourcr, source, avgarea
      REAL_T alpham, alphap, alpha0r, alpha0e
      REAL_T alpha0v1,alpha0v2
      REAL_T spminus, spplus, spzero
      REAL_T apright, amright
      REAL_T apleft, amleft
      REAL_T azrright, azeright, azv1rght,azv2rght
      REAL_T azrleft, azeleft, azv1left,azv2left
      REAL_T smallr
      REAL_T reflect

      REAL_T gdum,csdum,pdum

c     ::: some useful macro definitions
#     define U(i,j,k) 		q(i,j,k,QVEL1)
#     define V(i,j,k) 		q(i,j,k,QVEL2)
#     define W(i,j,k) 		q(i,j,k,QVEL3)
#     define P(i,j,k) 		q(i,j,k,QPRES)
#     define RHO(i,j,k) 	q(i,j,k,QRHO)
#     define RHOE(i,j,k) 	q(i,j,k,QRHOE)
#if(NADV>0)
#     define ADV(i,j,k) 	q(i,j,k,QADV)
#endif
#     define DU(i,j,k)	 	qy(i,j,k,QVEL1)
#     define DV(i,j,k) 		qy(i,j,k,QVEL2)
#     define DW(i,j,k) 		qy(i,j,k,QVEL3)
#     define DP(i,j,k) 		qy(i,j,k,QPRES)
#     define DRHO(i,j,k) 	qy(i,j,k,QRHO)
#     define DRHOE(i,j,k)	qy(i,j,k,QRHOE)
#if(NADV>0)
#     define DADV(i,j,k)	qy(i,j,k,QADV)
#endif
        
      dx = delta(1)
      dy = delta(2)
      dz = delta(3)
      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      ks = bxlo(3)
      ke = bxhi(3)

      isedg = qbarl_l1
      ieedg = qbarl_h1
      jsedg = qbarl_l2
      jeedg = qbarl_h2
      ksedg = qbarl_l3
      keedg = qbarl_h3



      smallr = onetominussix
      dtbydx = dt/dx

c ::: convert energy to intensive form for eos call
c     do k = ks,ke
c      do j = js,je
c       do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)/RHO(i,j,k)
c       enddo
c      enddo
c     enddo


c     convert energy back to extensive form and compute courant number
      do k = ks,ke
       do j = js,je
        do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)*RHO(i,j,k)
          courno(i,j,k) = dtbydx*(c(i,j,k)+abs(V(i,j,k)))       
        enddo
      enddo
      enddo

c     characteristic analysis
      do k = ksedg,keedg
       do j = jsedg,jeedg-1
        do i = isedg,ieedg
          enth(i,j,k) = (RHOE(i,j,k)/RHO(i,j,k) +
     $                 P(i,j,k)/RHO(i,j,k))/c(i,j,k)**2
          alpham = half*(DP(i,j,k)/(RHO(i,j,k)*c(i,j,k)) - DV(i,j,k))*RHO(i,j,k)
     $    /c(i,j,k)
          alphap = half*(DP(i,j,k)/(RHO(i,j,k)*c(i,j,k)) + DV(i,j,k))*RHO(i,j,k)
     $    /c(i,j,k)
          alpha0r = DRHO(i,j,k) - DP(i,j,k)/c(i,j,k)**2
          alpha0e = DRHOE(i,j,k) - DP(i,j,k)*enth(i,j,k)
          alpha0v1 = DU(i,j,k)
          alpha0v2 = DW(i,j,k)

c ::: :::::  Top state of edge at bottom
          spminus = cvmgp(-one,(V(i,j,k) - c(i,j,k))*dtbydx,V(i,j,k) - c(i,j,k))
          spplus = cvmgp(-one,(V(i,j,k) + c(i,j,k))*dtbydx,V(i,j,k) + c(i,j,k))
          spzero = cvmgp(-one, V(i,j,k) *dtbydx,V(i,j,k) )
          apright = half*(-one - spplus )*alphap
          amright = half*(-one - spminus)*alpham
          azrright= half*(-one - spzero )*alpha0r
          azeright= half*(-one - spzero )*alpha0e
          azv1rght= half*(-one - spzero )*alpha0v1
          azv2rght= half*(-one - spzero )*alpha0v2
          qbarr(i,j,k,QRHO) = q(i,j,k,QRHO) + apright + amright + azrright
          qbarr(i,j,k,QRHO) = max(smallr, qbarr(i,j,k,QRHO))
          qbarr(i,j,k,QVEL2) = q(i,j,k,QVEL2) +
     $                      (apright - amright)*c(i,j,k)/RHO(i,j,k)
          qbarr(i,j,k,QVEL1) = q(i,j,k,QVEL1) + azv1rght
          qbarr(i,j,k,QVEL3) = q(i,j,k,QVEL3) + azv2rght
          qbarr(i,j,k,QPRES) = q(i,j,k,QPRES) +
     $                      (apright + amright)*c(i,j,k)**2
          qbarr(i,j,k,QRHOE) = q(i,j,k,QRHOE) + (apright +
     $                       amright)*enth(i,j,k)*c(i,j,k)**2 + azeright
#if(NADV>0)
          qbarr(i,j,k,QADV) = q(i,j,k,QADV)+half*(-one-spzero)*DADV(i,j,k)
#endif

c ::: :::::  Bottom state of edge at top

          spminus = cvmgp((V(i,j,k) - c(i,j,k))*dtbydx,one,V(i,j,k) - c(i,j,k))
          spplus = cvmgp((V(i,j,k) + c(i,j,k))*dtbydx,one,V(i,j,k) + c(i,j,k))
          spzero = cvmgp( V(i,j,k) *dtbydx,one,V(i,j,k) )
          apleft = half*(one - spplus )*alphap
          amleft = half*(one - spminus)*alpham
          azrleft= half*(one - spzero )*alpha0r
          azeleft= half*(one - spzero )*alpha0e
          azv1left= half*(one - spzero )*alpha0v1
          azv2left= half*(one - spzero )*alpha0v2
          qbarl(i,j+1,k,QRHO) = q(i,j,k,QRHO) + apleft + amleft + azrleft
          qbarl(i,j+1,k,QRHO) = max(smallr, qbarl(i,j+1,k,QRHO))
          qbarl(i,j+1,k,QVEL2) = q(i,j,k,QVEL2) +
     $                         (apleft - amleft)*c(i,j,k)/RHO(i,j,k)
          qbarl(i,j+1,k,QVEL1) = q(i,j,k,QVEL1) + azv1left
          qbarl(i,j+1,k,QVEL3) = q(i,j,k,QVEL3) + azv2left
          qbarl(i,j+1,k,QPRES) = q(i,j,k,QPRES) +
     $                         (apleft + amleft)*c(i,j,k)**2
          qbarl(i,j+1,k,QRHOE) = q(i,j,k,QRHOE) + (apleft + amleft)*
     $                         enth(i,j,k)*c(i,j,k)**2 + azeleft
#if(NADV>0)
          qbarl(i,j+1,k,QADV) = q(i,j,k,QADV)+half*(one-spzero)*DADV(i,j,k)
#endif
        enddo
       enddo
      enddo
          

c ::: Colella hack near R=0 singularity
      do k = ks,ke
       do j = js,je
        do i = is,ie
          if (dloga(i,j,k) .ne. zero) then
              eta = (one-courno(i,j,k))/(c(i,j,k)*dt*dloga(i,j,k))
              eta = min(one, eta)
              dloga(i,j,k) = dloga(i,j,k) * eta
          endif
        enddo
       enddo
      enddo

      dthalf = half*dt
c ::: add geometric source terms to traced states
      do k = ksedg,keedg
       do j = jsedg,jeedg-1
        do i = isedg,ieedg
          sourcr = -RHO(i,j,k)*dloga(i,j,k)*V(i,j,k)*dthalf
          sourcp = sourcr*c(i,j,k)**2
          source = sourcp*enth(i,j,k)
          qbarl(i,j+1,k,QRHO) = qbarl(i,j+1,k,QRHO) + sourcr
          qbarl(i,j+1,k,QRHO) = max(smallr, qbarl(i,j+1,k,QRHO))
          qbarl(i,j+1,k,QPRES) = qbarl(i,j+1,k,QPRES) + sourcp
          qbarl(i,j+1,k,QRHOE) = qbarl(i,j+1,k,QRHOE) + source
          qbarr(i,j,k ,QRHO) = qbarr(i,j,k ,QRHO) + sourcr
          qbarr(i,j,k ,QRHO) = max(smallr, qbarr(i,j,k,QRHO))
          qbarr(i,j,k ,QPRES) = qbarr(i,j,k ,QPRES) + sourcp
          qbarr(i,j,k ,QRHOE) = qbarr(i,j,k ,QRHOE) + source
        enddo
       enddo
      enddo

c ::: convert energy back to intensive form 
c ::: for eos call in RIEMANN
c     do k = ks,ke
c      do j = js,je
c       do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)/RHO(i,j,k)
c       enddo
c      enddo
c     enddo

#undef U
#undef V
#undef W
#undef P
#undef RHO
#undef RHOE
#undef DU
#undef DV
#undef DW
#undef DP
#undef DRHO
#undef DRHOE
#if(NADV>0)
#undef DADV
#endif

      end

      subroutine FORT_ZTRACE(
     &          BL_FARG(q),
     &          BL_FARG(qz),
     &          BL_FARG(c),
     &          BL_FARG(enth),
     &          BL_FARG(qbarl),
     &          BL_FARG(qbarr),
     &          BL_FARG(dloga),
     &          BL_FARG(courno),
     &          BL_BARG(bx),
     &          delta, dt, bc, gBndry, nvar
     &		)

      integer nvar, gBndry(0:2*SDIM-1)
      integer bc(SDIM,2,nvar-1),qbc(SDIM,2,NQ)
      REAL_T  delta(SDIM), dt
      BL_FBOUNDS(q)
      BL_FARRAY(q,nvar)
      BL_FBOUNDS(qz)
      BL_FARRAY(qz,nvar)
      BL_FBOUNDS(qbarl)
      BL_FARRAY(qbarl,nvar)
      BL_FBOUNDS(qbarr)
      BL_FARRAY(qbarr,nvar)
      BL_FBOUNDS(c)
      BL_FARRAY1(c)
      BL_FBOUNDS(enth)
      BL_FARRAY1(enth)
      BL_FBOUNDS(dloga)
      BL_FARRAY1(dloga)
      BL_FBOUNDS(courno)
      BL_FARRAY1(courno)
      BL_BBOUNDS(bx)

      integer i, j,k, n, nbc
      integer is,ie,js,je,ks,ke,isedg,ieedg,jsedg,jeedg,ksedg,keedg
      REAL_T  dx, dy,dz
      REAL_T spvol, dtbydx, scr, eken, eta, dthalf
      REAL_T sourcp, sourcr, source, avgarea
      REAL_T alpham, alphap, alpha0r, alpha0e
      REAL_T alpha0v1,alpha0v2
      REAL_T spminus, spplus, spzero
      REAL_T apright, amright
      REAL_T apleft, amleft
      REAL_T azrright, azeright, azv1rght,azv2rght
      REAL_T azrleft, azeleft, azv1left,azv2left
      REAL_T smallr
      REAL_T reflect

      REAL_T gdum,csdum,pdum

c     ::: some useful macro definitions
#     define U(i,j,k) 		q(i,j,k,QVEL1)
#     define V(i,j,k) 		q(i,j,k,QVEL2)
#     define W(i,j,k) 		q(i,j,k,QVEL3)
#     define P(i,j,k) 		q(i,j,k,QPRES)
#     define RHO(i,j,k) 	q(i,j,k,QRHO)
#     define RHOE(i,j,k) 	q(i,j,k,QRHOE)
#if(NADV>0)
#     define ADV(i,j,k) 	q(i,j,k,QADV)
#endif
#     define DU(i,j,k)	 	qz(i,j,k,QVEL1)
#     define DV(i,j,k) 		qz(i,j,k,QVEL2)
#     define DW(i,j,k) 		qz(i,j,k,QVEL3)
#     define DP(i,j,k) 		qz(i,j,k,QPRES)
#     define DRHO(i,j,k) 	qz(i,j,k,QRHO)
#     define DRHOE(i,j,k)	qz(i,j,k,QRHOE)
#if(NADV>0)
#     define DADV(i,j,k)	qz(i,j,k,QADV)
#endif
        
      dx = delta(1)
      dy = delta(2)
      dz = delta(3)
      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      ks = bxlo(3)
      ke = bxhi(3)

      isedg = qbarl_l1
      ieedg = qbarl_h1
      jsedg = qbarl_l2
      jeedg = qbarl_h2
      ksedg = qbarl_l3
      keedg = qbarl_h3

      smallr = onetominussix
      dtbydx = dt/dx

c ::: convert energy to intensive form for eos call
c     do k = ks,ke
c      do j = js,je
c       do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)/RHO(i,j,k)
c       enddo
c      enddo
c     enddo

c     convert energy back to extensive form and compute courant number
      do k = ks,ke
       do j = js,je
        do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)*RHO(i,j,k)
          courno(i,j,k) = dtbydx*(c(i,j,k)+abs(W(i,j,k)))       
        enddo
      enddo
      enddo

c     characteristic analysis
      do k = ksedg,keedg-1
       do j = jsedg,jeedg
        do i = isedg,ieedg
          enth(i,j,k) = (RHOE(i,j,k)/RHO(i,j,k) +
     $                 P(i,j,k)/RHO(i,j,k))/c(i,j,k)**2
          alpham = half*(DP(i,j,k)/(RHO(i,j,k)*c(i,j,k)) - DW(i,j,k))*RHO(i,j,k)
     $    /c(i,j,k)
          alphap = half*(DP(i,j,k)/(RHO(i,j,k)*c(i,j,k)) + DW(i,j,k))*RHO(i,j,k)
     $    /c(i,j,k)
          alpha0r = DRHO(i,j,k) - DP(i,j,k)/c(i,j,k)**2
          alpha0e = DRHOE(i,j,k) - DP(i,j,k)*enth(i,j,k)
          alpha0v1 = DU(i,j,k)
          alpha0v2 = DV(i,j,k)

c ::: :::::  Top state of edge at bottom
          spminus = cvmgp(-one,(W(i,j,k) - c(i,j,k))*dtbydx,W(i,j,k) - c(i,j,k))
          spplus = cvmgp(-one,(W(i,j,k) + c(i,j,k))*dtbydx,W(i,j,k) + c(i,j,k))
          spzero = cvmgp(-one, W(i,j,k) *dtbydx,W(i,j,k) )
          apright = half*(-one - spplus )*alphap
          amright = half*(-one - spminus)*alpham
          azrright= half*(-one - spzero )*alpha0r
          azeright= half*(-one - spzero )*alpha0e
          azv1rght= half*(-one - spzero )*alpha0v1
          azv2rght= half*(-one - spzero )*alpha0v2
          qbarr(i,j,k,QRHO) = q(i,j,k,QRHO) + apright + amright + azrright
          qbarr(i,j,k,QRHO) = max(smallr, qbarr(i,j,k,QRHO))
          qbarr(i,j,k,QVEL3) = q(i,j,k,QVEL3) +
     $                      (apright - amright)*c(i,j,k)/RHO(i,j,k)
          qbarr(i,j,k,QVEL1) = q(i,j,k,QVEL1) + azv1rght
          qbarr(i,j,k,QVEL2) = q(i,j,k,QVEL2) + azv2rght
          qbarr(i,j,k,QPRES) = q(i,j,k,QPRES) +
     $                      (apright + amright)*c(i,j,k)**2
          qbarr(i,j,k,QRHOE) = q(i,j,k,QRHOE) + (apright +
     $                       amright)*enth(i,j,k)*c(i,j,k)**2 + azeright
#if(NADV>0)
          qbarr(i,j,k,QADV) = q(i,j,k,QADV)+half*(-one-spzero)*DADV(i,j,k)
#endif

c ::: :::::  Bottom state of edge at top

          spminus = cvmgp((W(i,j,k) - c(i,j,k))*dtbydx,one,W(i,j,k) - c(i,j,k))
          spplus = cvmgp((W(i,j,k) + c(i,j,k))*dtbydx,one,W(i,j,k) + c(i,j,k))
          spzero = cvmgp( W(i,j,k) *dtbydx,one,W(i,j,k) )
          apleft = half*(one - spplus )*alphap
          amleft = half*(one - spminus)*alpham
          azrleft= half*(one - spzero )*alpha0r
          azeleft= half*(one - spzero )*alpha0e
          azv1left= half*(one - spzero )*alpha0v1
          azv2left= half*(one - spzero )*alpha0v2
          qbarl(i,j,k+1,QRHO) = q(i,j,k,QRHO) + apleft + amleft + azrleft
          qbarl(i,j,k+1,QRHO) = max(smallr, qbarl(i,j,k+1,QRHO))
          qbarl(i,j,k+1,QVEL3) = q(i,j,k,QVEL3) +
     $                         (apleft - amleft)*c(i,j,k)/RHO(i,j,k)
          qbarl(i,j,k+1,QVEL1) = q(i,j,k,QVEL1) + azv1left
          qbarl(i,j,k+1,QVEL2) = q(i,j,k,QVEL2) + azv2left
          qbarl(i,j,k+1,QPRES) = q(i,j,k,QPRES) +
     $                         (apleft + amleft)*c(i,j,k)**2
          qbarl(i,j,k+1,QRHOE) = q(i,j,k,QRHOE) + (apleft + amleft)*
     $                         enth(i,j,k)*c(i,j,k)**2 + azeleft
#if(NADV>0)
          qbarl(i,j,k+1,QADV) = q(i,j,k,QADV)+half*(one-spzero)*DADV(i,j,k)
#endif
        enddo
       enddo
      enddo
          

c ::: Colella hack near R=0 singularity
      do k = ks,ke
       do j = js,je
        do i = is,ie
          if (dloga(i,j,k) .ne. zero) then
              eta = (one-courno(i,j,k))/(c(i,j,k)*dt*dloga(i,j,k))
              eta = min(one, eta)
              dloga(i,j,k) = dloga(i,j,k) * eta
          endif
        enddo
       enddo
      enddo

      dthalf = half*dt
c ::: add geometric source terms to traced states
      do k = ksedg,keedg-1
       do j = jsedg,jeedg
        do i = isedg,ieedg
          sourcr = -RHO(i,j,k)*dloga(i,j,k)*W(i,j,k)*dthalf
          sourcp = sourcr*c(i,j,k)**2
          source = sourcp*enth(i,j,k)
          qbarl(i,j,k+1,QRHO) = qbarl(i,j,k+1,QRHO) + sourcr
          qbarl(i,j,k+1,QRHO) = max(smallr, qbarl(i,j,k+1,QRHO))
          qbarl(i,j,k+1,QPRES) = qbarl(i,j,k+1,QPRES) + sourcp
          qbarl(i,j,k+1,QRHOE) = qbarl(i,j,k+1,QRHOE) + source
          qbarr(i,j,k ,QRHO) = qbarr(i,j,k ,QRHO) + sourcr
          qbarr(i,j,k ,QRHO) = max(smallr, qbarr(i,j,k,QRHO))
          qbarr(i,j,k ,QPRES) = qbarr(i,j,k ,QPRES) + sourcp
          qbarr(i,j,k ,QRHOE) = qbarr(i,j,k ,QRHOE) + source
        enddo
       enddo
      enddo

c ::: convert energy back to intensive form 
c ::: for eos call in RIEMANN
c     do k = ks,ke
c      do j = js,je
c       do i =is,ie
c  RHOE(i,j,k) = RHOE(i,j,k)/RHO(i,j,k)
c       enddo
c      enddo
c     enddo

#undef U
#undef V
#undef W
#undef P
#undef RHO
#undef RHOE
#undef DU
#undef DV
#undef DW
#undef DP
#undef DRHO
#undef DRHOE
#if(NADV>0)
#undef DADV
#endif

      end

#define SRHO 1
#define SXMOM 2
#define SYMOM 3
#define SZMOM 4
#define SRHOE 5
#if(NADV>0)
#define  SADV 6
#endif

      subroutine RIEMANN(
     &		BL_FARG(qbarm),
     &		BL_FARG(qbarp),
     &		BL_FARG(flux),
     &          BL_FARG(rho),
     &          BL_FARG(e),
     &          BL_FARG(adv),
     &		BL_FARG(c),
     &		BL_FARG(csml),
     &		BL_FARG(gamc),
     &		BL_FARG(rgdnv),
     &		BL_FARG(ugdnv),
     &		BL_FARG(pgdnv),
     &		BL_FARG(egdnv),
     &		BL_FARG(utgdnv),
#if(NADV>0)
     &          BL_FARG(advgdnv),
#endif
     &		BL_FARG(ustar),
     &          BL_BARG(bx),
     &		sweep, npvar, nsvar)   

      integer sweep, npvar, nsvar
      BL_FBOUNDS(qbarm)
      BL_FARRAY(qbarm,npvar)
      BL_FBOUNDS(qbarp)
      BL_FARRAY(qbarp,npvar)
      BL_FBOUNDS(c)
      BL_FARRAY1(c)
      BL_FBOUNDS(rho)
      BL_FARRAY1(rho)
      BL_FBOUNDS(e)
      BL_FARRAY1(e)
      BL_FBOUNDS(adv)
      BL_FARRAY1(adv)
      BL_FBOUNDS(csml)
      BL_FARRAY1(csml)
      BL_FBOUNDS(gamc)
      BL_FARRAY1(gamc)
      BL_FBOUNDS(rgdnv)
      BL_FARRAY1(rgdnv)
      BL_FBOUNDS(ugdnv)
      BL_FARRAY1(ugdnv)
      BL_FBOUNDS(pgdnv)
      BL_FARRAY1(pgdnv)
      BL_FBOUNDS(egdnv)
      BL_FARRAY1(egdnv)
      BL_FBOUNDS(utgdnv)
      BL_FARRAY(utgdnv,2)
      BL_FBOUNDS(advgdnv)
      BL_FARRAY1(advgdnv)
      BL_FBOUNDS(ustar)
      BL_FARRAY1(ustar)
      BL_FBOUNDS(flux)
      BL_FARRAY(flux,nsvar)
      BL_BBOUNDS(bx)

      REAL_T wl, wr, cav, pstar
      REAL_T ro, uo, po, eo, gamco, co, entho
      REAL_T rstar, estar, cstar
      REAL_T sgnm, spin, spout, ushock, frac, divuvs
      REAL_T scr

      REAL_T csmall, wsmall, smallr, small
      REAL_T gam_tmp, pdum, c_tmp, csml_tmp

      integer qvnrml, qvtrns1, qvtrns2
      integer is,ie,js,je,ks,ke, i,j,k
      integer    lo(3), hi(3)

      
      if(sweep.eq.0)then
c     ::: x-direction
        qvnrml = QVEL1
        qvtrns1 = QVEL2
        qvtrns2 = QVEL3
      elseif(sweep.eq.1)then
c     ::: y-direction
        qvnrml = QVEL2
        qvtrns1 = QVEL1
        qvtrns2 = QVEL3
      elseif(sweep.eq.2)then
c     ::: z-direction
        qvnrml = QVEL3
        qvtrns1 = QVEL1
        qvtrns2 = QVEL2
      else
        print *,'Abort: Bogus sweep value passed to RIEMANN'
        stop
      endif

      smallr = onetominussix
      small = onetominussix

      is = flux_l1
      ie = flux_h1 
      js = flux_l2  
      je = flux_h2
      ks = flux_l3 
      ke = flux_h3 
      

      do k = ks,ke          
       do j = js,je          
        do i = is,ie          

          if(sweep.eq.0)then
            csmall = max(csml(i-1,j,k),csml(i,j,k))
            cav = half*(c(i,j,k) + c(i-1,j,k))
            wsmall = smallr*csmall
            wl = max(wsmall,sqrt(abs(gamc(i-1,j,k)*
     $           qbarm(i,j,k,QPRES)*qbarm(i,j,k,QRHO))))
          elseif(sweep.eq.1)then
            csmall = max(csml(i,j-1,k),csml(i,j,k))
            cav = half*(c(i,j,k) + c(i,j-1,k))
            wsmall = smallr*csmall
            wl = max(wsmall,sqrt(abs(gamc(i,j-1,k)*
     $           qbarm(i,j,k,QPRES)*qbarm(i,j,k,QRHO))))
          elseif(sweep.eq.2)then
            csmall = max(csml(i,j,k-1),csml(i,j,k))
            cav = half*(c(i,j,k) + c(i,j,k-1))
            wsmall = smallr*csmall
            wl = max(wsmall,sqrt(abs(gamc(i,j,k-1)*
     $           qbarm(i,j,k,QPRES)*qbarm(i,j,k,QRHO))))
          else
            print *,'Abort: Bogus sweep value passed to RIEMANN'
            stop
          endif

          wr = max(wsmall,sqrt(abs(gamc(i,j,k )*qbarp(i,j,k,QPRES)*
     $         qbarp(i,j,k,QRHO))))

          pstar = ((wr*qbarm(i,j,k,QPRES) + wl*qbarp(i,j,k,QPRES)) + wl*wr*
     $    (qbarm(i,j,k,qvnrml) - qbarp(i,j,k,qvnrml)))/(wl + wr)

          ustar(i,j,k) = ((wl*qbarm(i,j,k,qvnrml) + wr*qbarp(i,j,k,qvnrml)) +
     $    (qbarm(i,j,k,QPRES) - qbarp(i,j,k,QPRES)))/(wl + wr)

          ro = cvmgp(qbarm(i,j,k,QRHO),qbarp(i,j,k,QRHO),ustar(i,j,k))
          uo = cvmgp(qbarm(i,j,k,qvnrml),qbarp(i,j,k,qvnrml),ustar(i,j,k))
          po = cvmgp(qbarm(i,j,k,QPRES),qbarp(i,j,k,QPRES),ustar(i,j,k))
          eo = cvmgp(qbarm(i,j,k,QRHOE),qbarp(i,j,k,QRHOE),ustar(i,j,k))

          if(sweep.eq.0)then
            gamco = cvmgp(gamc(i-1,j,k),gamc(i,j,k),ustar(i,j,k))
          elseif(sweep.eq.1)then
            gamco = cvmgp(gamc(i,j-1,k),gamc(i,j,k),ustar(i,j,k))
          else
            gamco = cvmgp(gamc(i,j,k-1),gamc(i,j,k),ustar(i,j,k))
          endif

          co = max(csmall,sqrt(abs(gamco*po/ro)))
          entho = (eo/ro + po/ro)/co**2
          rstar = ro + (pstar - po)/co**2
          rstar = max(rstar,smallr)
          estar = eo + (pstar - po)*entho
          cstar = max(csmall,sqrt(abs(gamco*pstar/rstar)))

          sgnm = sign(one,ustar(i,j,k))
          spout = co - sgnm*uo
          spin = cstar - sgnm*ustar(i,j,k)
          ushock = half*(spin + spout)
          spin = cvmgp(ushock,spin,pstar - po)
          spout = cvmgp(ushock,spout,pstar - po)
          scr = cvmgz(small*cav,spout - spin,spout - spin)
          frac = (one + (spout + spin)/scr)*half
          frac = max(zero,min(one,frac))

          utgdnv(i,j,k,1) = cvmgp(qbarm(i,j,k,qvtrns1),
     &                           qbarp(i,j,k,qvtrns1),ustar(i,j,k))
          utgdnv(i,j,k,2) = cvmgp(qbarm(i,j,k,qvtrns2),
     &                           qbarp(i,j,k,qvtrns2),ustar(i,j,k))
#if(NADV>0)
          advgdnv(i,j,k) = cvmgp(qbarm(i,j,k,QADV),qbarp(i,j,k,QADV),
     &                           ustar(i,j,k))
#endif
          rgdnv(i,j,k) = frac*rstar + (one - frac)*ro
          ugdnv(i,j,k) = frac*ustar(i,j,k) + (one - frac)*uo
          pgdnv(i,j,k) = frac*pstar + (one - frac)*po
          egdnv(i,j,k) = frac*estar + (one - frac)*eo

          rgdnv(i,j,k) = cvmgp(rgdnv(i,j,k),ro,spout)
          ugdnv(i,j,k) = cvmgp(ugdnv(i,j,k),uo,spout)
          pgdnv(i,j,k) = cvmgp(pgdnv(i,j,k),po,spout)
          egdnv(i,j,k) = cvmgp(egdnv(i,j,k),eo,spout)

          rgdnv(i,j,k) = cvmgp(rstar,rgdnv(i,j,k),spin)
          ugdnv(i,j,k) = cvmgp(ustar(i,j,k),ugdnv(i,j,k),spin)
          pgdnv(i,j,k) = cvmgp(pstar,pgdnv(i,j,k),spin)
          egdnv(i,j,k) = cvmgp(estar,egdnv(i,j,k),spin)

        enddo
       enddo
      enddo

c ::: ::::: compute fluxes
      do k = ks,ke
       do j = js,je
        do i = is,ie

          flux(i,j,k,SRHO) = ugdnv(i,j,k)*rgdnv(i,j,k)
          flux(i,j,k,qvnrml) = ugdnv(i,j,k)*flux(i,j,k,SRHO)
          flux(i,j,k,qvtrns1) = utgdnv(i,j,k,1)*flux(i,j,k,SRHO)
          flux(i,j,k,qvtrns2) = utgdnv(i,j,k,2)*flux(i,j,k,SRHO)
          flux(i,j,k,SRHOE) = flux(i,j,k,SRHO)*          
     $     (half*(ugdnv(i,j,k)**2+utgdnv(i,j,k,1)**2+utgdnv(i,j,k,2)**2)
     $    +egdnv(i,j,k)/rgdnv(i,j,k)) + ugdnv(i,j,k)*pgdnv(i,j,k)
#if(NADV>0)
          flux(i,j,k,SADV) = flux(i,j,k,SRHO)*advgdnv(i,j,k)
#endif

        enddo
       enddo
      enddo

      end


      subroutine FORT_COPYSTATE(
     &          BL_FARG(state),
     &          BL_FARG(gstate),
     &          BL_BARG(bx),
     &          nvar)

        integer nvar
	BL_FBOUNDS(state)
	BL_FARRAY(state,nvar)
	BL_FBOUNDS(gstate)
	BL_FARRAY(gstate,nvar)
	BL_BBOUNDS(bx)

        integer i, j, k, n
        integer is, ie, js, je, ks, ke
        
        is = bxlo(1)
        ie = bxhi(1)
        js = bxlo(2)
        je = bxhi(2)
        ks = bxlo(3)
        ke = bxhi(3)

	do n = 1,nvar
           do k = ks, ke
              do j = js, je
                 do i = is, ie
                    gstate(i,j,k,n) = state(i,j,k,n)
                 enddo
              enddo
           enddo
        enddo
	
      end

c 
c ---------------------------------------------------------------
c Node-based divergence for artificial viscosity calculation
c ---------------------------------------------------------------
c       
        subroutine FORT_DIVUNODE (
     &                  BL_FARG(state),
     &                  BL_FARG(div),
     &                  delta, nvar, gbndry)

        integer nvar, gbndry(0:2*SDIM-1)
        REAL_T delta(SDIM)
        BL_FBOUNDS(state)
        BL_FARRAY(state,nvar)
        BL_FBOUNDS(div)
        BL_FARRAY1(div)

	integer i,j,k, is, js, ks, ie, je, ke
        REAL_T ux,vy,wz
        REAL_T uijk,uimjk,uijmk,uimjmk,uijkm,uimjkm,uijmkm,uimjmkm
        REAL_T vijk,vijmk,vimjk,vimjmk,vijkm,vijmkm,vimjkm,vimjmkm
        REAL_T wijk,wijkm,wimjk,wimjkm,wimjmk,wimjmkm,wijmk,wijmkm
        REAL_T quarter

      is = div_l1
      ie = div_h1
      js = div_l2
      je = div_h2
      ks = div_l3
      ke = div_h3

      quarter = 0.25
      
      do k = div_l3, div_h3  
       do j = div_l2, div_h2  
	 do i = div_l1, div_h1  

         uijk = state(i,j,k,2)/state(i,j,k,1)
         uimjk = state(i-1,j,k,2)/state(i-1,j,k,1)
         uijmk = state(i,j-1,k,2)/state(i,j-1,k,1)
         uimjmk = state(i-1,j-1,k,2)/state(i-1,j-1,k,1)
         uijkm = state(i,j,k-1,2)/state(i,j,k-1,1)
         uimjkm = state(i-1,j,k-1,2)/state(i-1,j,k-1,1)
         uijmkm = state(i,j-1,k-1,2)/state(i,j-1,k-1,1)
         uimjmkm = state(i-1,j-1,k-1,2)/state(i-1,j-1,k-1,1)

         vijk = state(i,j,k,3)/state(i,j,k,1)
         vimjk = state(i-1,j,k,3)/state(i-1,j,k,1)
         vijmk = state(i,j-1,k,3)/state(i,j-1,k,1)
         vimjmk = state(i-1,j-1,k,3)/state(i-1,j-1,k,1)
         vijkm = state(i,j,k-1,3)/state(i,j,k-1,1)
         vimjkm = state(i-1,j,k-1,3)/state(i-1,j,k-1,1)
         vijmkm = state(i,j-1,k-1,3)/state(i,j-1,k-1,1)
         vimjmkm = state(i-1,j-1,k-1,3)/state(i-1,j-1,k-1,1)

         wijk = state(i,j,k,4)/state(i,j,k,1)
         wimjk = state(i-1,j,k,4)/state(i-1,j,k,1)
         wijmk = state(i,j-1,k,4)/state(i,j-1,k,1)
         wimjmk = state(i-1,j-1,k,4)/state(i-1,j-1,k,1)
         wijkm = state(i,j,k-1,4)/state(i,j,k-1,1)
         wimjkm = state(i-1,j,k-1,4)/state(i-1,j,k-1,1)
         wijmkm = state(i,j-1,k-1,4)/state(i,j-1,k-1,1)
         wimjmkm = state(i-1,j-1,k-1,4)/state(i-1,j-1,k-1,1)

         ux = quarter*(uijk-uimjk+uijmk-uimjmk+
     &                 uijkm-uimjkm+uijmkm-uimjmkm)/delta(1)

         vy = quarter*(vijk+vimjk-vijmk-vimjmk+
     &                 vijkm+vimjkm-vijmkm-vimjmkm)/delta(2)

         wz = quarter*(wijk+wimjk+wijmk+wimjmk-
     &                 wijkm-wimjkm-wijmkm-wimjmkm)/delta(3)


         div(i,j,k) = ux + vy + wz

         enddo
       enddo
      enddo

      end

c
c--------------------------------------------------------------
c     Conservative update and other final stuff -- x direction
c---------------------------------------------------------------
c


      subroutine FORT_UPDATEX(
     &  		BL_FARG(s),
     &                  BL_FARG(flux),
     &                  BL_FARG(pgdnv),
     &                  BL_FARG(div),
     &                  BL_FARG(area),
     &                  BL_FARG(vol),
     &                  BL_BARG(bx),
     &                  delta, dt, nv, sweep, bc, gBndry)
      integer nv, gBndry(0:2*SDIM-1)
      integer bc(SDIM,2,nv)
      BL_FBOUNDS(s)                  
      BL_FARRAY(s,nv)
      BL_FBOUNDS(flux)
      BL_FARRAY(flux,nv)
      BL_FBOUNDS(pgdnv)
      BL_FARRAY1(pgdnv)
      BL_FBOUNDS(div)
      BL_FARRAY1(div)
      BL_FBOUNDS(area)
      BL_FARRAY1(area)
      BL_FBOUNDS(vol)
      BL_FARRAY1(vol)
      BL_BBOUNDS(bx)
      REAL_T dt
      REAL_T delta(SDIM)
      integer sweep, vnrml
      integer is, ie, js, je,ks,ke, i, j,k, iv, ivbc
      integer isflx, ieflx, jsflx, jeflx, ksflx,keflx
      REAL_T dx, dy,dz,trandiv, divuvs, difmag
      REAL_T avgarea
      REAL_T leftbc, rightbc
      REAL_T trandiv1, trandiv1p, trandivy, trandivz

      data difmag / tenth /

      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      ks = bxlo(3)
      ke = bxhi(3)
      isflx = flux_l1 
      ieflx = flux_h1 
      jsflx = flux_l2 
      jeflx = flux_h2 
      ksflx = flux_l3 
      keflx = flux_h3 

      dx = delta(1)
      dy = delta(2)
      dz = delta(3)

      if(sweep.eq.0)then
	vnrml = 2
      else
	print *,'Abort: bogus sweep value in UPDATEX'
	stop
      endif


c
c ::: add artifical viscosity and convert to extensive quantities
c

      do iv = 1, nv
      do k = ksflx,keflx
       do j = jsflx,jeflx
        do i = isflx, ieflx

          trandiv = fourth*(div(i,j,k) + div(i,j+1,k)
     &     +div(i,j,k+1) + div(i,j+1,k+1))

          divuvs = difmag*dx*trandiv
          divuvs = min(zero,divuvs)
          flux(i,j,k, iv)= flux(i,j,k, iv) +
     $                  divuvs*(s(i,j,k, iv) - s(i-1,j,k,iv)) 

          flux(i,j,k,iv) = flux(i,j,k,iv)*dt*area(i,j,k)
        
        enddo
       enddo
      enddo
      enddo

c
c ::: conservative update
c
 
      do iv = 1, nv
      do k = ks, ke
       do j = js, je
        do i = is, ie
          s(i,j,k,iv) = s(i,j,k,iv) + 
     $               (flux(i,j,k,iv) - flux(i+1,j,k,iv))/vol(i,j,k)
        enddo
       enddo
      enddo
      enddo


c
c ::: add pressure term to normal momnentum
c

      do k = ks, ke
       do j = js, je
        do i = is, ie
          avgarea = half*(area(i,j,k) + area(i+1,j,k))
          s(i,j,k,vnrml) = s(i,j,k,vnrml) + dt*avgarea*
     $                 (pgdnv(i,j,k) - pgdnv(i+1,j,k))/vol(i,j,k)
        enddo
       enddo
      enddo

c
c ::: add pressure term to normal momnentum flux
c
      do k = ksflx,keflx
       do j = jsflx,jeflx
        do i = isflx,ieflx
          flux(i,j,k,vnrml) = flux(i,j,k,vnrml) + dt*area(i,j,k)*pgdnv(i,j,k)
        enddo
       enddo
      enddo

      end

c
c--------------------------------------------------------------
c     Conservative update and other final stuff -- y direction
c---------------------------------------------------------------
c


      subroutine FORT_UPDATEY(
     &  		BL_FARG(s),
     &                  BL_FARG(flux),
     &                  BL_FARG(pgdnv),
     &                  BL_FARG(div),
     &                  BL_FARG(area),
     &                  BL_FARG(vol),
     &                  BL_BARG(bx),
     &                  delta, dt, nv, sweep, bc, gBndry)
      integer nv, gBndry(0:2*SDIM-1)
      integer bc(SDIM,2,nv)
      BL_FBOUNDS(s)                  
      BL_FARRAY(s,nv)
      BL_FBOUNDS(flux)
      BL_FARRAY(flux,nv)
      BL_FBOUNDS(pgdnv)
      BL_FARRAY1(pgdnv)
      BL_FBOUNDS(div)
      BL_FARRAY1(div)
      BL_FBOUNDS(area)
      BL_FARRAY1(area)
      BL_FBOUNDS(vol)
      BL_FARRAY1(vol)
      BL_BBOUNDS(bx)
      REAL_T dt
      REAL_T delta(SDIM)
      integer vnrml,sweep
      integer  is, ie, js, je,ks,ke, i, j,k, iv, ivbc
      integer isflx, ieflx, jsflx, jeflx, ksflx, keflx
      REAL_T dx, dy,dz,trandiv, divuvs, difmag
      REAL_T avgarea
      REAL_T botbc, topbc
      REAL_T trandiv1, trandiv1p, trandivy, trandivz
      data difmag / tenth /

      if(sweep.eq.1)then
        vnrml = 3
      else
	print *,'Abort: bogus sweep value in UPDATEY'
	stop
      endif

      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      ks = bxlo(3)
      ke = bxhi(3)
      isflx = flux_l1 
      ieflx = flux_h1 
      jsflx = flux_l2 
      jeflx = flux_h2 
      ksflx = flux_l3 
      keflx = flux_h3 


      dx = delta(1)
      dy = delta(2)
      dz = delta(3)

c
c ::: add artifical viscosity and convert to extensive quantities
c

      do iv = 1, nv
      do k = ksflx,keflx
       do j = jsflx,jeflx
        do i = isflx,ieflx

          trandiv = fourth*(div(i,j,k) + div(i+1,j,k)
     &     +div(i,j,k+1) + div(i+1,j,k+1))

          divuvs = difmag*dy*trandiv
          divuvs = min(zero,divuvs)
          flux(i,j,k, iv)= flux(i,j,k, iv) +
     $                  divuvs*(s(i,j,k, iv) - s(i,j-1,k,iv)) 

          flux(i,j,k,iv) = flux(i,j,k,iv)*dt*area(i,j,k)
        
        enddo
       enddo
      enddo
      enddo

c
c ::: conservsative update
c
 
      do iv = 1, nv
      do k = ks, ke
       do j = js, je
        do i = is, ie
          s(i,j,k,iv) = s(i,j,k,iv) + 
     $               (flux(i,j,k,iv) - flux(i,j+1,k,iv))/vol(i,j,k)
        enddo
       enddo
      enddo
      enddo


c
c ::: add pressure term to normal momnentum
c

      do k = ks, ke
       do j = js, je
        do i = is, ie

          avgarea = half*(area(i,j,k) + area(i,j+1,k))
          s(i,j,k,vnrml) = s(i,j,k,vnrml) + dt*avgarea*
     $                 (pgdnv(i,j,k) - pgdnv(i,j+1,k))/vol(i,j,k)
        enddo
       enddo
      enddo

c
c ::: add pressure term to normal momnentum flux
c
      do k = ksflx, keflx
       do j = jsflx, jeflx
        do i = isflx, ieflx
          flux(i,j,k,vnrml) = flux(i,j,k,vnrml) + dt*area(i,j,k)*pgdnv(i,j,k)
        enddo
       enddo
      enddo

      end


c
c--------------------------------------------------------------
c     Conservative update and other final stuff -- z direction
c---------------------------------------------------------------
c


      subroutine FORT_UPDATEZ(
     &  		BL_FARG(s),
     &                  BL_FARG(flux),
     &                  BL_FARG(pgdnv),
     &                  BL_FARG(div),
     &                  BL_FARG(area),
     &                  BL_FARG(vol),
     &                  BL_BARG(bx),
     &                  delta, dt, nv, sweep, bc, gBndry)
      integer nv, gBndry(0:2*SDIM-1)
      integer bc(SDIM,2,nv)
      BL_FBOUNDS(s)                  
      BL_FARRAY(s,nv)
      BL_FBOUNDS(flux)
      BL_FARRAY(flux,nv)
      BL_FBOUNDS(pgdnv)
      BL_FARRAY1(pgdnv)
      BL_FBOUNDS(div)
      BL_FARRAY1(div)
      BL_FBOUNDS(area)
      BL_FARRAY1(area)
      BL_FBOUNDS(vol)
      BL_FARRAY1(vol)
      BL_BBOUNDS(bx)
      REAL_T dt
      REAL_T delta(SDIM)
      integer vnrml,sweep
      integer  is, ie, js, je, ks,ke,i, j, k,iv, ivbc
      integer isflx, ieflx, jsflx, jeflx,ksflx,keflx
      REAL_T dx, dy,dz,trandiv, divuvs, difmag
      REAL_T avgarea
      REAL_T botbc, topbc
      REAL_T trandiv1, trandiv1p, trandivy, trandivz
      data difmag / tenth /

      if(sweep.eq.2)then
        vnrml = 4
      else
	print *,'Abort: bogus sweep value in UPDATEZ'
	stop
      endif

      is = bxlo(1)
      ie = bxhi(1)
      js = bxlo(2)
      je = bxhi(2)
      ks = bxlo(3)
      ke = bxhi(3)
      isflx = flux_l1 
      ieflx = flux_h1 
      jsflx = flux_l2 
      jeflx = flux_h2 
      ksflx = flux_l3 
      keflx = flux_h3 

      dx = delta(1)
      dy = delta(2)
      dz = delta(3)

c
c ::: add artifical viscosity and convert to extensive quantities
c

      do iv = 1, nv
      do k = ksflx,keflx
       do j = jsflx,jeflx
        do i = isflx,ieflx

          trandiv = fourth*(div(i,j,k) + div(i,j+1,k)
     &     +div(i+1,j,k) + div(i+1,j+1,k))

          divuvs = difmag*dz*trandiv
          divuvs = min(zero,divuvs)
          flux(i,j,k, iv)= flux(i,j,k, iv) +
     $                  divuvs*(s(i,j,k, iv) - s(i,j,k-1,iv)) 

          flux(i,j,k,iv) = flux(i,j,k,iv)*dt*area(i,j,k)
        
        enddo
       enddo
      enddo
      enddo

c
c ::: conservsative update
c
 
      do iv = 1, nv
      do k = ks, ke
       do j = js, je
        do i = is, ie
          s(i,j,k,iv) = s(i,j,k,iv) + 
     $               (flux(i,j,k,iv) - flux(i,j,k+1,iv))/vol(i,j,k)
        enddo
       enddo
      enddo
      enddo


c
c ::: add pressure term to normal momnentum
c

      do k = ks, ke
       do j = js, je
        do i = is, ie
          avgarea = half*(area(i,j,k) + area(i,j,k+1))
          s(i,j,k,vnrml) = s(i,j,k,vnrml) + dt*avgarea*
     $                 (pgdnv(i,j,k) - pgdnv(i,j,k+1))/vol(i,j,k)
        enddo
       enddo
      enddo

c
c ::: add pressure term to normal momnentum flux
c
      do k = ksflx, keflx
       do j = jsflx, jeflx
        do i = isflx, ieflx
          flux(i,j,k,vnrml) = flux(i,j,k,vnrml) + dt*area(i,j,k)*pgdnv(i,j,k)
        enddo
       enddo
      enddo



      end


      subroutine FORT_PRIMITIVES(
     &                  BL_FARG(s),
     &                  BL_FARG(q),
     &                  BL_FARG(p),
     &                  BL_FARG(c),
     &                  BL_FARG(csml),
     &                  BL_FARG(gamc),
     &                  BL_BARG(bx),
     &                  bc, ns, nq, sweep)
      integer ns, nq, sweep
      integer bc(SDIM,2,ns)

      BL_FBOUNDS(s)
      BL_FBOUNDS(q)
      BL_FBOUNDS(p)
      BL_FBOUNDS(c)
      BL_FBOUNDS(csml)
      BL_FBOUNDS(gamc)
      BL_BBOUNDS(bx)

      BL_FARRAY(s,ns)
      BL_FARRAY(q,nq)
        BL_FARRAY1(p)
        BL_FARRAY1(c)
        BL_FARRAY1(csml)
      BL_FARRAY1(gamc)

      integer is,ie,js,je,ks,ke,i,j,k
      REAL_T u,v,w,rho,e
      REAL_T gdum,cdum,csdum, reflect

#include "xxmeth.fh"

       is = bxlo(1)
       js = bxlo(2)
       ks = bxlo(3)
       ie = bxhi(1)
       je = bxhi(2)
       ke = bxhi(3)


      do k = ks, ke
       do j = js, je
        do i = is, ie

          rho = max(s(i,j,k,SRHO),smallr)
          u = s(i,j,k,SXMOM)/s(i,j,k,SRHO)
          v = s(i,j,k,SYMOM)/s(i,j,k,SRHO)
          w = s(i,j,k,SZMOM)/s(i,j,k,SRHO)
          e = s(i,j,k,SRHOE)/rho - half*(u**2 + v**2 + w**2)
    
          q(i,j,k,QRHO) = rho       
          q(i,j,k,QVEL1) = u
          q(i,j,k,QVEL2) = v
          q(i,j,k,QVEL3) = w
          q(i,j,k,QRHOE) = e
#if(NADV>0)
          q(i,j,k,QADV) = S(i,j,k,SADV)/s(i,j,k,SRHO)
#endif
        
        enddo
       enddo
      enddo


      call eos(q(BL_ARGL1(q),BL_ARGL2(q),BL_ARGL3(q),QRHO),
     $         q(BL_ARGL1(q),BL_ARGL2(q),BL_ARGL3(q),QRHOE),
     $         q(BL_ARGL1(q),BL_ARGL2(q),BL_ARGL3(q),QADV),
     $         BL_IARG(q),
     $         gamc(BL_ARGL1(c),BL_ARGL2(c),BL_ARGL3(c)),
     $         q(BL_ARGL1(c),BL_ARGL2(c),BL_ARGL3(c),QPRES),
     $         c(BL_ARGL1(c),BL_ARGL2(c),BL_ARGL3(c)),
     $         csml(BL_ARGL1(c),BL_ARGL2(c),BL_ARGL3(c)),
     $         BL_IARG(c),
     $         bxlo,bxhi,1,1,1,1)
      do k = ks, ke
       do j = js, je
        do i = is, ie
          q(i,j,k,QPRES) = max(smallp,q(i,j,k,QPRES))
          p(i,j,k) = q(i,j,k,QPRES)
          q(i,j,k,QRHOE) = q(i,j,k,QRHOE)*q(i,j,k,QRHO)
c         c(i,j,k) = sqrt(gamc(i,j,k)*q(i,j,k,QPRES)/q(i,j,k,QRHO))
c         csml(i,j,k) = max(small,small*c(i,j,k))

        enddo
       enddo
      enddo

      end
      
        subroutine FORT_FLATENX(BL_FARG(q),BL_FARG(flatn),
     $          BL_FARG(dp), BL_FARG(z), BL_FARG(chi),
     $          BL_FARG(p), BL_FARG(c),nv)
        integer nv
        BL_FBOUNDS(q)
        BL_FBOUNDS(flatn)
        BL_FBOUNDS(dp)
        BL_FBOUNDS(z)
        BL_FBOUNDS(chi)
        BL_FBOUNDS(p)
        BL_FBOUNDS(c)

        BL_FARRAY(q,nv)
        BL_FARRAY1(flatn)
        BL_FARRAY1(dp)
        BL_FARRAY1(z)
        BL_FARRAY1(chi)
        BL_FARRAY1(p)
        BL_FARRAY1(c)

        integer is,js,ks,ie,je,ke, i,j,k
        REAL_T shktst, zcut1, zcut2, dzcut
        REAL_T denom, zeta, tst, tmp

#include "xxmeth.fh"

c ::: ::::: knobs for detection of strong shock
#ifdef  BL_USE_FLOAT_CONST
      data shktst /0.33/
      data zcut1 /0.75/
      data zcut2 /0.85/
#endif
#ifdef  BL_USE_DOUBLE_CONST
      data shktst /0.33d0/
      data zcut1 /0.75d0/
      data zcut2 /0.85d0/
#endif


        dzcut = one/(zcut2-zcut1)

        is = q_l1
        ie = q_h1
        js = q_l2
        je = q_h2
        ks = q_l3
        ke = q_h3

        if(iorder .eq. 3) then
          return
        else
c
c  this is a hack.  need to compute the pressure from the state in
c  a general way.
c
#if 0
        do i = is,ie
          do j = js,je
            do k = ks,ke
              p(i,j,k) = q(i,j,k,QPRES)
              c(i,j,k) = sqrt(onepointfour*p(i,j,k)/q(i,j,k,QRHO))
            enddo
          enddo
        enddo
#endif

c
c  could use z or chi limits equivalently
c
        is = dp_l1
        ie = dp_h1
        js = dp_l2
        je = dp_h2
        ks = dp_l3
        ke = dp_h3

        do k = ks,ke
          do j = js,je
            do i = is,ie
              dp(i,j,k) = p(i+1,j,k)-p(i-1,j,k)
              denom = max(smallp,abs(p(i+2,j,k)-p(i-2,j,k)))
              zeta = abs(dp(i,j,k))/denom
              z(i,j,k) = min(one,max(zero, dzcut*(zeta-zcut1)))
              tst = cvmgp(one,zero,q(i-1,j,k,QVEL1)-q(i+1,j,k,QVEL1))
              tmp = min(q(i+1,j,k,QRHO)*c(i+1,j,k)**2,q(i-1,j,k,QRHO)*c(i-1,j,k)**2)
              chi(i,j,k) = cvmgt(tst,zero,(abs(dp(i,j,k))/tmp).gt.shktst)
            enddo
          enddo
        enddo

        is = flatn_l1
        ie = flatn_h1
        js = flatn_l2
        je = flatn_h2
        ks = flatn_l3
        ke = flatn_h3

        do k = ks,ke
          do j = js,je
            do i = is,ie
              flatn(i,j,k) = one-max(chi(i-1,j,k)*z(i-1,j,k),
     $            chi(i,j,k)*z(i,j,k),
     $            chi(i+1,j,k)*z(i+1,j,k))
            enddo
          enddo
        enddo

        endif

        end

        subroutine FORT_FLATENY(BL_FARG(q),BL_FARG(flatn),
     $          BL_FARG(dp), BL_FARG(z), BL_FARG(chi),
     $          BL_FARG(p), BL_FARG(c),nv)
        integer nv
        BL_FBOUNDS(q)
        BL_FBOUNDS(flatn)
        BL_FBOUNDS(dp)
        BL_FBOUNDS(z)
        BL_FBOUNDS(chi)
        BL_FBOUNDS(p)
        BL_FBOUNDS(c)

        BL_FARRAY(q,nv)
        BL_FARRAY1(flatn)
        BL_FARRAY1(dp)
        BL_FARRAY1(z)
        BL_FARRAY1(chi)
        BL_FARRAY1(p)
        BL_FARRAY1(c)

        integer is,js,ks,ie,je,ke, i,j,k
        REAL_T shktst, zcut1, zcut2, dzcut
        REAL_T denom, zeta, tst, tmp

#include "xxmeth.fh"

c ::: ::::: knobs for detection of strong shock
#ifdef  BL_USE_FLOAT_CONST
      data shktst /0.33/
      data zcut1 /0.75/
      data zcut2 /0.85/
#endif
#ifdef  BL_USE_DOUBLE_CONST
      data shktst /0.33d0/
      data zcut1 /0.75d0/
      data zcut2 /0.85d0/
#endif

        dzcut = one/(zcut2-zcut1)

        is = q_l1
        ie = q_h1
        js = q_l2
        je = q_h2
        ks = q_l3
        ke = q_h3

        if(iorder .eq. 3) then
          return
        else
c
c  this is a hack.  need to compute the pressure from the state in
c  a general way.
c
#if 0
        do i = is,ie
          do j = js,je
            do k = ks,ke
              p(i,j,k) = q(i,j,k,QPRES)
              c(i,j,k) = sqrt(onepointfour*p(i,j,k)/q(i,j,k,QRHO))
            enddo
          enddo
        enddo
#endif

c
c  could use z or chi limits equivalently
c
        is = dp_l1
        ie = dp_h1
        js = dp_l2
        je = dp_h2
        ks = dp_l3
        ke = dp_h3

        do k = ks,ke
          do j = js,je
            do i = is,ie
              dp(i,j,k) = p(i,j+1,k)-p(i,j-1,k)
              denom = max(smallp,abs(p(i,j+2,k)-p(i,j-2,k)))
              zeta = abs(dp(i,j,k))/denom
              z(i,j,k) = min(one,max(zero, dzcut*(zeta-zcut1)))
              tst = cvmgp(one,zero,q(i,j-1,k,QVEL2)-q(i,j+1,k,QVEL2))
              tmp = min(q(i,j+1,k,QRHO)*c(i,j+1,k)**2,q(i,j-1,k,QRHO)*c(i,j-1,k)**2)
              chi(i,j,k) = cvmgt(tst,zero,(abs(dp(i,j,k))/tmp).gt.shktst)
            enddo
          enddo
        enddo

        is = flatn_l1
        ie = flatn_h1
        js = flatn_l2
        je = flatn_h2
        ks = flatn_l3
        ke = flatn_h3

        do k = ks,ke
          do j = js,je
            do i = is,ie
              flatn(i,j,k) = one-max(chi(i,j-1,k)*z(i,j-1,k),chi(i,j,k)*z(i,j,k),
     $            chi(i,j+1,k)*z(i,j+1,k))
            enddo
          enddo
        enddo

        endif

        end

        subroutine FORT_FLATENZ(BL_FARG(q),BL_FARG(flatn),
     $          BL_FARG(dp), BL_FARG(z), BL_FARG(chi),
     $          BL_FARG(p), BL_FARG(c),nv)
        integer nv
        BL_FBOUNDS(q)
        BL_FBOUNDS(flatn)
        BL_FBOUNDS(dp)
        BL_FBOUNDS(z)
        BL_FBOUNDS(chi)
        BL_FBOUNDS(p)
        BL_FBOUNDS(c)

        BL_FARRAY(q,nv)
        BL_FARRAY1(flatn)
        BL_FARRAY1(dp)
        BL_FARRAY1(z)
        BL_FARRAY1(chi)
        BL_FARRAY1(p)
        BL_FARRAY1(c)

        integer is,js,ks,ie,je,ke, i,j,k
        REAL_T shktst, zcut1, zcut2, dzcut
        REAL_T denom, zeta, tst, tmp

#include "xxmeth.fh"

c ::: ::::: knobs for detection of strong shock
#ifdef  BL_USE_FLOAT_CONST
      data shktst /0.33/
      data zcut1 /0.75/
      data zcut2 /0.85/
#endif
#ifdef  BL_USE_DOUBLE_CONST
      data shktst /0.33d0/
      data zcut1 /0.75d0/
      data zcut2 /0.85d0/
#endif

        dzcut = one/(zcut2-zcut1)

        is = q_l1
        ie = q_h1
        js = q_l2
        je = q_h2
        ks = q_l3
        ke = q_h3

        if(iorder .eq. 3) then
          return
        else
c
c  this is a hack.  need to compute the pressure from the state in
c  a general way.
c
#if 0
        do i = is,ie
          do j = js,je
            do k = ks,ke
              p(i,j,k) = q(i,j,k,QPRES)
              c(i,j,k) = sqrt(onepointfour*p(i,j,k)/q(i,j,k,QRHO))
            enddo
          enddo
        enddo
#endif

c
c  could use z or chi limits equivalently
c
        is = dp_l1
        ie = dp_h1
        js = dp_l2
        je = dp_h2
        ks = dp_l3
        ke = dp_h3

        do k = ks,ke
          do j = js,je
            do i = is,ie
              dp(i,j,k) = p(i,j,k+1)-p(i,j,k-1)
              denom = max(smallp,abs(p(i,j,k+2)-p(i,j,k-2)))
              zeta = abs(dp(i,j,k))/denom
              z(i,j,k) = min(one,max(zero, dzcut*(zeta-zcut1)))
              tst = cvmgp(one,zero,q(i,j,k-1,QVEL3)-q(i,j,k+1,QVEL3))
              tmp = min(q(i,j,k+1,QRHO)*c(i,j,k+1)**2,q(i,j,k-1,QRHO)*c(i,j,k-1)**2)
              chi(i,j,k) = cvmgt(tst,zero,(abs(dp(i,j,k))/tmp).gt.shktst)
            enddo
          enddo
        enddo

        is = flatn_l1
        ie = flatn_h1
        js = flatn_l2
        je = flatn_h2
        ks = flatn_l3
        ke = flatn_h3

        do k = ks,ke
          do j = js,je
            do i = is,ie
              flatn(i,j,k) = one-max(chi(i,j,k-1)*z(i,j,k-1),chi(i,j,k)*z(i,j,k),
     $            chi(i,j,k+1)*z(i,j,k+1))
            enddo
          enddo
        enddo

        endif

        end

c
c---------------------------------------------------------------
c::  X-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEX(BL_FARG(s),BL_FARG(slx),BL_FARG(flatn),
     $  BL_FARG(scen),BL_FARG(ssgn),BL_FARG(slim),BL_FARG(dsf),nv,gBndry)
      integer nv,gBndry(0:2*SDIM-1)

      BL_FBOUNDS(s)
      BL_FBOUNDS(slx)
      BL_FBOUNDS(flatn)
      BL_FBOUNDS(scen)
      BL_FBOUNDS(ssgn)
      BL_FBOUNDS(slim)
      BL_FBOUNDS(dsf)

      BL_FARRAY(s,nv)
      BL_FARRAY(slx,nv)
      BL_FARRAY1(flatn)
      BL_FARRAY1(scen)
      BL_FARRAY1(ssgn)
      BL_FARRAY1(slim)
      BL_FARRAY1(dsf)


      REAL_T dpls,dmin,ds
      REAL_T del,sflag, dq4

      integer is,js,ks,ie,je,ke,i,j,k,iv

#include "xxmeth.fh"


      if(iorder .eq. 1) then
        return
      else

      do 100 iv = 1,nv

          is = dsf_l1
          js = dsf_l2
          ks = dsf_l3
          ie = dsf_h1
          je = dsf_h2
          ke = dsf_h3

          do k = ks,ke
            do j = js,je
              do i = is,ie
                scen(i,j,k) = (s(i+1,j,k,iv)-s(i-1,j,k,iv))
                dpls = (s(i+1,j,k,iv) - s(i ,j,k,iv))
                dmin = (s(i ,j,k,iv) - s(i-1,j,k,iv))
                ssgn(i,j,k) = sign(one,scen(i,j,k))
                slim(i,j,k) = two*min(abs(dpls),abs(dmin))
                slim(i,j,k) = cvmgp(slim(i,j,k),zero,dpls*dmin)
                dsf(i,j,k) = ssgn(i,j,k)*min(half*abs(scen(i,j,k)),slim(i,j,k))
              enddo
            enddo
          enddo

          is = slx_l1
          js = slx_l2
          ks = slx_l3
          ie = slx_h1
          je = slx_h2
          ke = slx_h3

          do k = ks,ke
            do j = js,je
              do i = is,ie
                dq4 = two3rd*(scen(i,j,k) - forth*(dsf(i+1,j,k)+dsf(i-1,j,k)))
                slx(i,j,k,iv) = ssgn(i,j,k)*flatn(i,j,k)*min(abs(dq4),slim(i,j,k))
              enddo
            enddo
          enddo

100       continue
        endif

          end

c
c---------------------------------------------------------------
c::  Y-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEY(BL_FARG(s),BL_FARG(sly),BL_FARG(flatn),
     $  BL_FARG(scen),BL_FARG(ssgn),BL_FARG(slim),BL_FARG(dsf),nv,gBndry)
      integer nv,gBndry(0:SDIM*SDIM-1)

      BL_FBOUNDS(s)
      BL_FBOUNDS(sly)
      BL_FBOUNDS(flatn)
      BL_FBOUNDS(scen)
      BL_FBOUNDS(ssgn)
      BL_FBOUNDS(slim)
      BL_FBOUNDS(dsf)

      BL_FARRAY(s,nv)
      BL_FARRAY(sly,nv)
      BL_FARRAY1(flatn)
      BL_FARRAY1(scen)
      BL_FARRAY1(ssgn)
      BL_FARRAY1(slim)
      BL_FARRAY1(dsf)


      REAL_T dpls,dmin,ds
      REAL_T del,sflag, dq4

      integer is,js,ks,ie,je,ke,i,j,k,iv

#include "xxmeth.fh"



      if(iorder .eq. 1) then
         return
      else
      do 100 iv = 1,nv

          is = dsf_l1
          js = dsf_l2
          ks = dsf_l3
          ie = dsf_h1
          je = dsf_h2
          ke = dsf_h3

          do k = ks,ke
            do j = js,je
              do i = is,ie
                scen(i,j,k) = (s(i,j+1,k,iv)-s(i,j-1,k,iv))
                dpls = (s(i,j+1,k,iv) - s(i ,j,k,iv))
                dmin = (s(i ,j,k,iv) - s(i,j-1,k,iv))
                ssgn(i,j,k) = sign(one,scen(i,j,k))
                slim(i,j,k) = two*min(abs(dpls),abs(dmin))
                slim(i,j,k) = cvmgp(slim(i,j,k),zero,dpls*dmin)
                dsf(i,j,k) = ssgn(i,j,k)*min(half*abs(scen(i,j,k)),slim(i,j,k))
              enddo
            enddo
          enddo

          is = sly_l1
          js = sly_l2
          ks = sly_l3
          ie = sly_h1
          je = sly_h2
          ke = sly_h3

          do k = ks,ke
            do j = js,je
              do i = is,ie
                dq4 = two3rd*(scen(i,j,k) - forth*(dsf(i,j+1,k)+dsf(i,j-1,k)))
                sly(i,j,k,iv) = ssgn(i,j,k)*flatn(i,j,k)*min(abs(dq4),slim(i,j,k))
              enddo
            enddo
          enddo

100   continue
      endif

          end

c
c---------------------------------------------------------------
c::  Z-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEZ(BL_FARG(s),BL_FARG(sly),BL_FARG(flatn),
     $  BL_FARG(scen),BL_FARG(ssgn),BL_FARG(slim),BL_FARG(dsf),nv,gBndry)
      integer nv,gBndry(0:SDIM*SDIM-1)

      BL_FBOUNDS(s)
      BL_FBOUNDS(sly)
      BL_FBOUNDS(flatn)
      BL_FBOUNDS(scen)
      BL_FBOUNDS(ssgn)
      BL_FBOUNDS(slim)
      BL_FBOUNDS(dsf)

      BL_FARRAY(s,nv)
      BL_FARRAY(sly,nv)
      BL_FARRAY1(flatn)
      BL_FARRAY1(scen)
      BL_FARRAY1(ssgn)
      BL_FARRAY1(slim)
      BL_FARRAY1(dsf)


      REAL_T dpls,dmin,ds
      REAL_T del,sflag, dq4

      integer is,js,ks,ie,je,ke,i,j,k,iv

#include "xxmeth.fh"



      if(iorder .eq. 1) then
         return
      else
      do 100 iv = 1,nv

          is = dsf_l1
          js = dsf_l2
          ks = dsf_l3
          ie = dsf_h1
          je = dsf_h2
          ke = dsf_h3

          do k = ks,ke
            do j = js,je
              do i = is,ie
                scen(i,j,k) = (s(i,j,k+1,iv)-s(i,j,k-1,iv))
                dpls = (s(i,j,k+1,iv) - s(i ,j,k,iv))
                dmin = (s(i ,j,k,iv) - s(i,j,k-1,iv))
                ssgn(i,j,k) = sign(one,scen(i,j,k))
                slim(i,j,k) = two*min(abs(dpls),abs(dmin))
                slim(i,j,k) = cvmgp(slim(i,j,k),zero,dpls*dmin)
                dsf(i,j,k) = ssgn(i,j,k)*min(half*abs(scen(i,j,k)),slim(i,j,k))
              enddo
            enddo
          enddo

          is = sly_l1
          js = sly_l2
          ks = sly_l3
          ie = sly_h1
          je = sly_h2
          ke = sly_h3

          do k = ks,ke
            do j = js,je
              do i = is,ie
                dq4 = two3rd*(scen(i,j,k) - forth*(dsf(i,j,k+1)+dsf(i,j,k-1)))
                sly(i,j,k,iv) = ssgn(i,j,k)*flatn(i,j,k)*min(abs(dq4),slim(i,j,k))
              enddo
            enddo
          enddo

100   continue
      endif

          end

c
c---------------------------------------------------------------
c::  X-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  slx      <= slopes                            
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEX2(BL_FARG(s),BL_FARG(slx),nv,gBndry)
      integer nv,gBndry(0:2*SDIM-1)
      BL_FBOUNDS(s)                  
      BL_FARRAY(s,nv)
      BL_FBOUNDS(slx)
      BL_FARRAY(slx,nv)

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag


      integer is,js,ks,ie,je,ke,i,j,k,iv

      is = slx_l1
      js = slx_l2 
      ks = slx_l3 
      ie = slx_h1 
      je = slx_h2 
      ke = slx_h3 


      do 100 iv = 1,nv
 
         do 150 k = ks,ke
          do 160 j = js,je
            do 170 i = is,ie
              del = half*(s(i+1,j,k,iv)-s(i-1,j,k,iv))
              dpls = two*(s(i+1,j,k,iv) - s(i ,j,k,iv))
              dmin = two*(s(i ,j,k,iv) - s(i-1,j,k,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(i,j,k,iv)= sflag*min(slim,abs(del))
170         continue
160       continue
150       continue
             

100       continue

	  end
c
c ---------------------------------------------------------------
c::  Y-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  sly      <= slopes                                    
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEY2(BL_FARG(s),BL_FARG(sly),nv,gBndry)
      integer nv,gBndry(0:2*SDIM-1)
      BL_FBOUNDS(s)                  
      BL_FARRAY(s,nv)
      BL_FBOUNDS(sly)
      BL_FARRAY(sly,nv)

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag


      integer is,js,ks,ie,je,ke,i,j,k,iv

      is = sly_l1 
      js = sly_l2 
      ks = sly_l3 
      ie = sly_h1 
      je = sly_h2 
      ke = sly_h3 


      do 150 iv = 1,nv
 
        do 170 k = ks,ke
          do 180 j = js,je
            do 190 i = is,ie

              del = half*(s(i,j+1,k,iv)-s(i,j-1,k,iv))
              dpls = two*(s(i,j+1,k,iv) - s(i,j,k,iv ))
              dmin = two*(s(i,j,k,iv ) - s(i,j-1,k,iv))
              slim = min(abs(dpls),abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              sly(i,j,k,iv)= sflag*min(slim,abs(del))
190         continue
180       continue
170     continue

150     continue

      end

c
c ---------------------------------------------------------------
c::  z-slopes for characteristic tracing
c::  Arguments:
c::  s         => primitive variables
c::  sly      <= slopes                                    
c::  bc        => bndry condition flags
c::  nvar      => number of advected quantities.
c ---------------------------------------------------------------
c
      subroutine FORT_SLOPEZ2(BL_FARG(s),BL_FARG(slz),nv,gBndry)
      integer nv,gBndry(0:2*SDIM-1)
      BL_FBOUNDS(s)                  
      BL_FARRAY(s,nv)
      BL_FBOUNDS(slz)
      BL_FARRAY(slz,nv)

      REAL_T dpls,dmin,ds
      REAL_T del,slim,sflag


      integer is,js,ks,ie,je,ke,i,j,k,iv

      is = slz_l1 
      js = slz_l2 
      ks = slz_l3 
      ie = slz_h1 
      je = slz_h2 
      ke = slz_h3 


      do 150 iv = 1,nv
 
        do 170 k = ks,ke
          do 180 j = js,je
            do 190 i = is,ie

              del = half*(s(i,j,k+1,iv)-s(i,j,k-1,iv))
              dpls = two*(s(i,j,k+1,iv) - s(i,j,k,iv ))
              dmin = two*(s(i,j,k,iv ) - s(i,j,k-1,iv))
              slim = min(abs(dpls),abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slz(i,j,k,iv)= sflag*min(slim,abs(del))

190         continue
180       continue
170     continue

150     continue

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: NAVIERSTOKES_3D.F,v 1.15 2003/01/31 18:47:22 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "NAVIERSTOKES_F.H"
#include "ArrayLim.H"

#define SDIM 3

      subroutine FORT_GRADP(
     &     p,DIMS(p),
     &     gp,DIMS(gp),
     &     lo,hi,dx)
c ::
c :: ----------------------------------------------------------
c :: Compute a cell centered gradient from a node
c :: centered field.  Returns all components of GRADP
c :: ----------------------------------------------------------
c ::
      integer DIMDEC(p)  
      integer DIMDEC(gp)  
      integer    lo(SDIM),  hi(SDIM)
      integer domlo(SDIM), domhi(SDIM)
      REAL_T  dx(SDIM)
      REAL_T  p(DIMV(p))
      REAL_T  gp(DIMV(gp),SDIM)
      logical    invalid
      integer    i,j,k
      REAL_T     ddx, ddy, ddz
      integer    ilo, ihi, jlo, jhi, klo, khi

      ddx = fourth/dx(1)
      ddy = fourth/dx(2)
      ddz = fourth/dx(3)

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               gp(i,j,k,1) = ddx*(
     &              p(i+1,j,k  )-p(i,j,k  )+p(i+1,j+1,k  )-p(i,j+1,k  )+
     &              p(i+1,j,k+1)-p(i,j,k+1)+p(i+1,j+1,k+1)-p(i,j+1,k+1))

               gp(i,j,k,2) = ddy*(
     &              p(i,j+1,k  )-p(i,j,k  )+p(i+1,j+1,k  )-p(i+1,j,k  )+
     &              p(i,j+1,k+1)-p(i,j,k+1)+p(i+1,j+1,k+1)-p(i+1,j,k+1))

               gp(i,j,k,3) = ddz*(
     &              p(i,  j,k+1)-p(i,  j,k)+p(i,  j+1,k+1)-p(i,  j+1,k)+
     &              p(i+1,j,k+1)-p(i+1,j,k)+p(i+1,j+1,k+1)-p(i+1,j+1,k))
            end do
         end do
      end do

      end

      subroutine FORT_AVGDOWN (
     &     crse,DIMS(crse),nvar,
     &     fine,DIMS(fine),
     &     cv,DIMS(cv),
     &     fv,DIMS(fv),
     &     lo,hi,ratios)
c     ----------------------------------------------------------
c     Volume-weight average the fine grid data onto the coarse
c     grid.  Overlap is given in coarse grid coordinates.
c     
c     crse      =  coarse grid data
c     nvar	= number of components in arrays
c     fine      = fine grid data
c     cv        = coarse grid volume array
c     fv        = fine grid volume array
c     lo,hi     = index limits of overlap (crse grid)
c     ratios    = IntVect refinement ratio
c     ----------------------------------------------------------
      integer  DIMDEC(crse)
      integer  DIMDEC(cv)
      integer  DIMDEC(fine)
      integer  DIMDEC(fv)
      integer  lo(SDIM), hi(SDIM)
      integer  nvar
      integer  ratios(SDIM)
      REAL_T   crse(DIMV(crse),nvar)
      REAL_T     cv(DIMV(cv))
      REAL_T   fine(DIMV(fine),nvar)
      REAL_T     fv(DIMV(fv))

      integer  i, j, k, n, ic, jc, kc, ioff, joff, koff
      integer  lratx, lraty, lratz

      lratx = ratios(1)
      lraty = ratios(2)
      lratz = ratios(3)

      do n = 1, nvar
c
c     set coarse grid to zero on overlap
c
         do kc = lo(3), hi(3)
            do jc = lo(2), hi(2)
               do ic = lo(1), hi(1)
                  crse(ic,jc,kc,n) = zero
               end do
            end do
         end do
c         
c     sum fine data
c
         do koff = 0, lratz-1
            do kc = lo(3),hi(3)
               k = kc*lratz + koff
               do joff = 0, lraty-1
                  do jc = lo(2), hi(2)
                     j = jc*lraty + joff
                     do ioff = 0, lratx-1
                        do ic = lo(1), hi(1)
                           i = ic*lratx + ioff
                           crse(ic,jc,kc,n) = crse(ic,jc,kc,n) +
     &                          fv(i,j,k)*fine(i,j,k,n)
                        end do
                     end do
                  end do
               end do
            end do
         end do
c
c     divide out by volume weight
c
         do kc = lo(3), hi(3)
            do ic = lo(1), hi(1)
               do jc = lo(2), hi(2)
                  crse(ic,jc,kc,n) = crse(ic,jc,kc,n)/cv(ic,jc,kc)
               end do
            end do
         end do
      end do

      end

      subroutine FORT_TESTINJECT(
     &     crse,DIMS(crse),
     &     fine,DIMS(fine),lo,hi,ratios)
c
c     test for consistency of pressure nodes
c
      integer  DIMDEC(crse)
      integer  DIMDEC(fine)
      integer  lo(3), hi(3)
      integer  ratios(3)
      REAL_T   crse(DIMV(crse))
      REAL_T   fine(DIMV(fine))

      REAL_T diff
      integer  ic, jc, kc
      integer  lratx, lraty, lratz

      lratx = ratios(1)
      lraty = ratios(2)
      lratz = ratios(3)

      diff = zero
      do kc = lo(3), hi(3)
         do jc = lo(2), hi(2)
            do ic = lo(1), hi(1)
               diff = max( diff,
     &              abs(crse(ic,jc,kc)-fine(lratx*ic,lraty*jc,lratz*kc)))
            end do
         end do
      end do

      if ( diff .gt. 1.0D-10 ) then
         call bl_abort('mismatch between fine and coarse nodes')
      end if

      end

c :: ----------------------------------------------------------
c :: Replace coarse grid pressure data with corresponding
c :: fine grid pressure data.
c ::
c :: INPUTS / OUTPUTS:
c ::  crse      <=  coarse grid data
c ::  DIMS(crse) => index limits of crse
c ::  fine       => fine grid data
c ::  DIMS(fine) => index limits of fine
c ::  lo,hi      => index limits of overlap (crse grid)
c ::  ratios     => refinement ratio
c ::
c :: NOTE:
c ::  Assumes pressure fields are node based
c :: ----------------------------------------------------------
c ::
      subroutine FORT_PUTDOWN (crse,DIMS(crse),
     &			       fine,DIMS(fine),lo,hi,ratios)

      integer  DIMDEC(crse)
      integer  DIMDEC(fine)
      integer  lo(SDIM), hi(SDIM)
      integer  ratios(SDIM)
      REAL_T   crse(DIMV(crse))
      REAL_T   fine(DIMV(fine))

      integer  ic, jc, kc
      integer  lratx, lraty, lratz

      lratx = ratios(1)
      lraty = ratios(2)
      lratz = ratios(3)

      do kc = lo(3), hi(3)
         do jc = lo(2), hi(2)
            do ic = lo(1), hi(1)
               crse(ic,jc,kc) = fine(lratx*ic,lraty*jc,lratz*kc)
            end do
         end do
      end do

      end

c :: ----------------------------------------------------------
c :: UTILITY ROUTINE: compute:
c ::             A += alpha*B on subrange
c ::
c :: INPUTS / OUTPUTS:
c ::  a         <=  output array
c ::  b          => input array
c ::  alo,ahi    => index limits of a array
c ::  blo,bhi    => index limits of a array
c ::  lo,hi      => index limits of update region
c ::  alpha      => multiplicative factor
c :: ----------------------------------------------------------
c ::
       subroutine FORT_INCRMULT(a,DIMS(a),b,DIMS(b),lo,hi,alpha)

       integer    DIMDEC(a)
       integer    DIMDEC(b)
       integer    lo(SDIM), hi(SDIM)
       REAL_T     alpha
       REAL_T     a(DIMV(a))
       REAL_T     b(DIMV(b))

       integer i, j, k

       do k = lo(3), hi(3)
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                a(i,j,k) = a(i,j,k) + alpha*b(i,j,k)
             end do
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: SUMMASS
c ::             MASS = sum{ vol(i,j)*rho(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  rho        => density field
c ::  DIMS(rho)  => index limits of rho aray
c ::  lo,hi      => index limits of grid interior
c ::  delta	 => cell size
c ::  mass      <=  total mass
c ::  r		 => radius at cell center
c ::  tmp        => temp column array
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMMASS(rho,DIMS(rho),DIMS(grid),delta,mass,tmp)

       integer DIMDEC(rho)
       integer DIMDEC(grid)
       REAL_T  mass, delta(SDIM)
       REAL_T  rho(DIMV(rho))
       REAL_T  tmp(DIM2(grid))

       integer i, j, k
       REAL_T  vol

       vol = delta(1)*delta(2)*delta(3)

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do k = ARG_L3(grid), ARG_H3(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             do j = ARG_L2(grid), ARG_H2(grid)
                tmp(j) = tmp(j) + vol*rho(i,j,k)
             end do
          end do
       end do

       mass = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          mass = mass + tmp(j)
       end do

       end


c :: ----------------------------------------------------------
c :: SUMMASSSQ
c ::             MASS = sum{ vol(i,j)*rho(i,j)*rho(i,j) }
c ::
c :: INPUTS / OUTPUTS:
c ::  rho        => density field
c ::  DIMS(rho)  => index limits of rho aray
c ::  lo,hi      => index limits of grid interior
c ::  delta	 => cell size
c ::  mass      <=  total mass
c ::  r		 => radius at cell center
c ::  tmp        => temp column array
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMMASSSQ(rho,DIMS(rho),DIMS(grid),delta,mass,tmp)

       integer DIMDEC(rho)
       integer DIMDEC(grid)
       REAL_T  mass, delta(SDIM)
       REAL_T  rho(DIMV(rho))
       REAL_T  tmp(DIM2(grid))

       integer i, j, k
       REAL_T  vol

       vol = delta(1)*delta(2)*delta(3)

       do j = ARG_L2(grid), ARG_H2(grid)
          tmp(j) = zero
       end do

       do k = ARG_L3(grid), ARG_H3(grid)
          do i = ARG_L1(grid), ARG_H1(grid)
             do j = ARG_L2(grid), ARG_H2(grid)
                tmp(j) = tmp(j) + vol*rho(i,j,k)*rho(i,j,k)
             end do
          end do
       end do

       mass = zero
       do j = ARG_L2(grid), ARG_H2(grid)
          mass = mass + tmp(j)
       end do

       end

c :: ----------------------------------------------------------
c :: SUMPRESS
c ::             SUM = sum{ press(i,j,k) * surroundingVolume(i,j,k) }
c ::
c :: INPUTS / OUTPUTS:
c ::  press      => pressure field on nodes
c ::  DIMS(press)=> index limits of press aray
c ::  vol        => volume field (zero-ed out under finer grids)
c ::  DIMS(vol)  => index limits of vol aray
c ::  lo,hi      => index limits of grid interior in nodal space
c ::  total_press<= sum of volume-weighted nodal pressures
c ::  total_vol  <= sum of volumes
c :: ----------------------------------------------------------
c ::
       subroutine FORT_SUMPRESS(press,DIMS(press),vol,DIMS(vol),lo,hi,
     $                          total_press,total_vol)

       integer lo(3),hi(3)
       integer DIMDEC(press)
       integer DIMDEC(vol)
       integer DIMDEC(grid)
       REAL_T  press(DIMV(press))
       REAL_T  vol(DIMV(vol))
       REAL_T  total_press,total_vol

       integer i, j, k
       REAL_T  surroundingVolume

       do k = lo(3),hi(3)
          do j = lo(2),hi(2)
             do i = lo(1),hi(1)

                surroundingVolume = vol(i,j  ,k  ) + vol(i-1,j  ,k  ) + 
     $               vol(i,j-1,k  ) + vol(i-1,j-1,k  ) +
     $               vol(i,j  ,k-1) + vol(i-1,j  ,k-1) + 
     $               vol(i,j-1,k-1) + vol(i-1,j-1,k-1)
                total_press = total_press + press(i,j,k) * surroundingVolume
                total_vol   = total_vol   +                surroundingVolume

             end do
          end do
       end do

       end
c-----------------------------------------------------------------------
c     This routine fills an edge-centered fab from a cell-centered
c     fab using simple linear interpolation.
c
c     INPUTS / OUTPUTS:
c     lo,hi      => index limits of the region of the edge-centered fab
c                   to be filled
c     DIMS(cfab) => index limits of the cell-centered fab
c     cfab       => cell-centered data
c     DIMS(efab) => index limits of the edge-centered fab
c     efab       => edge-centered fab to fill
c     nc         => Number of components in the fab to fill
c     dir        => direction data needs to be shifted to get to edges
c-----------------------------------------------------------------------
c
      subroutine FORT_CEN2EDG(lo, hi, 
     &     DIMS(cfab), cfab,
     &     DIMS(efab), efab, nc, dir, isharm
     &     )
      integer lo(SDIM), hi(SDIM), nc, dir, isharm
      integer DIMDEC(cfab)
      integer DIMDEC(efab)
      REAL_T  cfab(DIMV(cfab), nc)
      REAL_T  efab(DIMV(efab), nc)
      integer i,j,k,n

      if ( isharm .eq. 0 ) then
         if (dir .EQ. 0) then
            do n = 1,nc
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     do i = lo(1)+1, hi(1)
                        efab(i,j,k,n) =
     &                       half*(cfab(i,j,k,n) + cfab(i-1,j,k,n))
                     end do
                  end do
               end do
            end do
         else if (dir .EQ. 1) then
            do n = 1,nc
               do k = lo(3), hi(3)
                  do j = lo(2)+1, hi(2)
                     do i = lo(1), hi(1)
                        efab(i,j,k,n) =
     &                       half*(cfab(i,j,k,n) + cfab(i,j-1,k,n))
                     end do
                  end do
               end do
            end do
         else if (dir .EQ. 2) then
            do n = 1,nc
               do k = lo(3)+1, hi(3)
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        efab(i,j,k,n) =
     &                       half*(cfab(i,j,k,n) + cfab(i,j,k-1,n))
                     end do
                  end do
               end do
            end do
         end if
      else
         if (dir .EQ. 0) then
            do n = 1,nc
               do k = lo(3), hi(3)
                  do j = lo(2), hi(2)
                     do i = lo(1)+1, hi(1)
                        if((cfab(i,j,k,n) * cfab(i-1,j,k,n)) .gt.0.d0)
     &                       then
                           efab(i,j,k,n) =
     &                          2.d0*(cfab(i,j,k,n) * cfab(i-1,j,k,n))/
     &                          (cfab(i,j,k,n) + cfab(i-1,j,k,n))
                        else
                           efab(i,j,k,n)=0.d0
                        endif
                     end do
                  end do
               end do
            end do
         else if (dir .EQ. 1) then
            do n = 1,nc
               do k = lo(3), hi(3)
                  do j = lo(2)+1, hi(2)
                     do i = lo(1), hi(1)
                        if((cfab(i,j,k,n) * cfab(i,j-1,k,n)).gt.0.d0)
     &                       then
                           efab(i,j,k,n) =
     &                          2.d0*(cfab(i,j,k,n) * cfab(i,j-1,k,n))/
     &                          (cfab(i,j,k,n) + cfab(i,j-1,k,n))
                        else
                           efab(i,j,k,n)=0.d0
                        endif
                     end do
                  end do
               end do
            end do
         else if (dir .EQ. 2) then
            do n = 1,nc
               do k = lo(3)+1, hi(3)
                  do j = lo(2), hi(2)
                     do i = lo(1), hi(1)
                        if((cfab(i,j,k,n) * cfab(i,j,k-1,n)).gt.0.d0)
     &                       then
                           efab(i,j,k,n) =
     &                          2.d0*(cfab(i,j,k,n) * cfab(i,j,k-1,n))/
     &                          (cfab(i,j,k,n) + cfab(i,j,k-1,n))
                        else
                           efab(i,j,k,n)=0.d0
                        endif
                     end do
                  end do
               end do
            end do
         end if
      end if
      end
c-----------------------------------------------------------------------
      subroutine EDGE_INTERP(flo, fhi, nc, ratio, dir,
     &     fine, fine_l0, fine_l1, fine_l2, fine_h0, fine_h1, fine_h2)
      implicit none
      integer flo(0:3-1), fhi(0:3-1), nc, ratio(0:3-1), dir
      integer fine_l0, fine_l1, fine_l2, fine_h0, fine_h1, fine_h2
      DOUBLE PRECISION
     &     fine(fine_l0:fine_h0,fine_l1:fine_h1,fine_l2:fine_h2,nc)
      integer i,j,k,ii,jj,kk,n,P,M,L,clo(0:3-1),chi(0:3-1)
      DOUBLE PRECISION val, df

c     Do linear in dir, pc transverse to dir, leave alone the fine values
c     lining up with coarse edges--assume these have been set to hold the 
c     values you want to interpolate to the rest.
      if (dir.eq.0) then
         do n=1,nc
            do k=flo(2),fhi(2),ratio(2)
               do j=flo(1),fhi(1),ratio(1)
                  do i=flo(0),fhi(0)-ratio(dir),ratio(0)
                     df = fine(i+ratio(dir),j,k,n)-fine(i,j,k,n)
                     do M=1,ratio(dir)-1
                        val = fine(i,j,k,n)
     &                       + df*dble(M)/dble(ratio(dir))
                        do P=MAX(j,flo(1)),MIN(j+ratio(1)-1,fhi(1))
                           do L=MAX(k,flo(2)),MIN(k+ratio(2)-1,fhi(2))
                              fine(i+M,P,L,n) = val
                           enddo
                        enddo
                     enddo                     
                  enddo
               enddo
            enddo
         enddo
      else if (dir.eq.1) then
         do n=1,nc
            do k=flo(2),fhi(2),ratio(2)
               do j=flo(1),fhi(1)-ratio(dir),ratio(1)
                  do i=flo(0),fhi(0)
                     df = fine(i,j+ratio(dir),k,n)-fine(i,j,k,n)
                     do M=1,ratio(dir)-1
                        val = fine(i,j,k,n)
     &                       + df*dble(M)/dble(ratio(dir))
                        do P=MAX(i,flo(0)),MIN(i+ratio(0)-1,fhi(0))
                           do L=MAX(k,flo(2)),MIN(k+ratio(2)-1,fhi(2))
                              fine(P,j+M,L,n) = val
                           enddo
                        enddo
                     enddo                     
                  enddo
               enddo
            enddo
         enddo
      else
         do n=1,nc
            do k=flo(2),fhi(2)-ratio(dir),ratio(2)
               do j=flo(1),fhi(1),ratio(1)
                  do i=flo(0),fhi(0),ratio(0)
                     df = fine(i,j,k+ratio(dir),n)-fine(i,j,k,n)
                     do M=1,ratio(dir)-1
                        val = fine(i,j,k,n)
     &                       + df*dble(M)/dble(ratio(dir))
                        do P=MAX(i,flo(0)),MIN(i+ratio(0)-1,fhi(0))
                           do L=MAX(j,flo(1)),MIN(j+ratio(1)-1,fhi(1))
                              fine(P,L,k+M,n) = val
                           enddo
                        enddo
                     enddo                     
                  enddo
               enddo
            enddo
         enddo
      endif
      end
c-----------------------------------------------------------------------
      subroutine PC_EDGE_INTERP(lo, hi, nc, ratio, dir,
     &     crse, crse_l0, crse_l1, crse_l2, crse_h0, crse_h1, crse_h2,
     &     fine, fine_l0, fine_l1, fine_l2, fine_h0, fine_h1, fine_h2)
      implicit none
      integer lo(3),hi(3), nc, ratio(0:3-1), dir
      integer crse_l0, crse_l1, crse_l2, crse_h0, crse_h1, crse_h2
      integer fine_l0, fine_l1, fine_l2, fine_h0, fine_h1, fine_h2
      DOUBLE PRECISION
     &     crse(crse_l0:crse_h0,crse_l1:crse_h1,crse_l2:crse_h2,nc)
      DOUBLE PRECISION
     &     fine(fine_l0:fine_h0,fine_l1:fine_h1,fine_l2:fine_h2,nc)
      integer i,j,k,ii,jj,kk,n,L, P
      DOUBLE PRECISION val, dc

c     For edge-based data, fill fine values with piecewise-constant interp of coarse data.
c     Operate only on faces that overlap--ie, only fill the fine faces that make up each
c     coarse face, leave the in-between faces alone.
      if (dir.eq.0) then
         do n=1,nc
            do k=lo(3),hi(3)
               kk = ratio(2)*k
               do j=lo(2),hi(2)
                  jj = ratio(1)*j
                  do i=lo(1),hi(1)
                     ii = ratio(0)*i
                     do P=0,ratio(2)-1
                        do L=0,ratio(1)-1
                           fine(ii,jj+L,kk+P,n) = crse(i,j,k,n)
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      else if (dir.eq.1) then
         do n=1,nc
            do k=lo(3),hi(3)
               kk = ratio(2)*k
               do j=lo(2),hi(2)
                  jj = ratio(1)*j
                  do i=lo(1),hi(1)
                     ii = ratio(0)*i
                     do P=0,ratio(2)-1
                        do L=0,ratio(0)-1
                           fine(ii+L,jj,kk+P,n) = crse(i,j,k,n)
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      else
         do n=1,nc
            do k=lo(3),hi(3)
               kk = ratio(2)*k
               do j=lo(2),hi(2)
                  jj = ratio(1)*j
                  do i=lo(1),hi(1)
                     ii = ratio(0)*i
                     do P=0,ratio(1)-1
                        do L=0,ratio(0)-1
                           fine(ii+L,jj+P,kk,n) = crse(i,j,k,n)
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      endif
      end

c variable density versions:

c Note---assumes fdst linearly interpolated from cdst along edge
      subroutine hgfres(
     & res,  resl0, resh0, resl1, resh1,
     & src,  srcl0, srch0, srcl1, srch1,
     & fdst, fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst, cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &       regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, idim, idir, irz)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1)
      double precision sigmac(scl0:sch0,scl1:sch1)
      double precision hx, hy
      integer irz
      integer ir, jr, idim, idir
      double precision hxm2, hym2, fac0, fac1, tmp
      integer i, is, j, js, m, n

      if (irz .eq. 1 .and. regl0 .le. 0 .and. regh0 .ge. 0) then
         print *,'I DONT THINK WE SHOULD BE IN HGFRES AT I=0 '
         stop
      endif

      if (idim .eq. 0) then
         i = regl0
         if (idir .eq. 1) then
            is = i - 1
         else
            is = i
         end if
         fac0 = ir / (ir + 1.d0)
         hxm2 = 1.d0 / (ir * ir * hx * hx)
         hym2 = 1.d0 / (jr * jr * hy * hy)
         do j = regl1, regh1
            res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &        (hxm2 *
     &          ((sigmac(is,j-1) + sigmac(is,j)) *
     &            (cdst(i-idir,j) - cdst(i,j))) +
     &         hym2 *
     &          (sigmac(is,j-1) *
     &            (cdst(i,j-1) - cdst(i,j)) +
     &           sigmac(is,j) *
     &            (cdst(i,j+1) - cdst(i,j))))
         end do
         fac0 = fac0 / (ir * jr * jr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         i = i * ir
         if (idir .eq. 1) then
            is = i
         else
            is = i - 1
         end if
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*regl1, jr*regh1, jr
               tmp = hxm2 *
     &           ((sigmaf(is,j-n-1) + sigmaf(is,j-n)) *
     &             (fdst(i+idir,j-n) - fdst(i,j-n)) +
     &           (sigmaf(is,j+n-1) + sigmaf(is,j+n)) *
     &             (fdst(i+idir,j+n) - fdst(i,j+n)))
               res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &            (sigmaf(is,j-n-1) *
     &             (fdst(i,j-n-1) - fdst(i,j-n)) +
     &             sigmaf(is,j-n) *
     &             (fdst(i,j-n+1) - fdst(i,j-n)) +
     &             sigmaf(is,j+n-1) *
     &             (fdst(i,j+n-1) - fdst(i,j+n)) +
     &             sigmaf(is,j+n) *
     &             (fdst(i,j+n+1) - fdst(i,j+n))))
            end do
         end do
      else
         j = regl1
         if (idir .eq. 1) then
            js = j - 1
         else
            js = j
         end if
         fac0 = jr / (jr + 1.d0)
         hxm2 = 1.d0 / (ir * ir * hx * hx)
         hym2 = 1.d0 / (jr * jr * hy * hy)
         do i = regl0, regh0
            res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &        (hxm2 *
     &          (sigmac(i-1,js) *
     &            (cdst(i-1,j) - cdst(i,j)) +
     &           sigmac(i,js) *
     &            (cdst(i+1,j) - cdst(i,j))) +
     &         hym2 *
     &          ((sigmac(i-1,js) + sigmac(i,js)) *
     &            (cdst(i,j-idir) - cdst(i,j))))
         end do

c        This correction is *only* for the cross stencil
         if (irz .eq. 1 .and. regl0 .le. 0 .and. regh0 .ge. 0) then
            i = 0
            res(i*ir,j*jr) = res(i*ir,j*jr) + fac0 *
     &         hym2 * 0.5d0 *
     &          ((sigmac(i-1,js) + sigmac(i,js)) *
     &            (cdst(i,j-idir) - cdst(i,j)))
         endif

         fac0 = fac0 / (ir * ir * jr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         j = j * jr
         if (idir .eq. 1) then
            js = j
         else
            js = j - 1
         end if
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*regl0, ir*regh0, ir
               tmp = hxm2 *
     &             (sigmaf(i-m-1,js) *
     &             (fdst(i-m-1,j) - fdst(i-m,j)) +
     &              sigmaf(i-m,js) *
     &             (fdst(i-m+1,j) - fdst(i-m,j)) +
     &              sigmaf(i+m-1,js) *
     &             (fdst(i+m-1,j) - fdst(i+m,j)) +
     &              sigmaf(i+m,js) *
     &             (fdst(i+m+1,j) - fdst(i+m,j)))
               res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &           ((sigmaf(i-m-1,js) + sigmaf(i-m,js)) *
     &             (fdst(i-m,j+idir) - fdst(i-m,j)) +
     &              (sigmaf(i+m-1,js) + sigmaf(i+m,js)) *
     &             (fdst(i+m,j+idir) - fdst(i+m,j))))
            end do

            if (irz .eq. 1 .and. m .eq. 0 .and.
     &          regl0 .le. 0 .and. regh0 .ge. 0) then
               i = 0
               res(i,j) = res(i,j) + fac1 * hym2 * 0.5d0 *
     &           ((sigmaf(i-m-1,js) + sigmaf(i-m,js)) *
     &             (fdst(i-m,j+idir) - fdst(i-m,j)) +
     &              (sigmaf(i+m-1,js) + sigmaf(i+m,js)) *
     &             (fdst(i+m,j+idir) - fdst(i+m,j)))
            endif
         end do
      end if
      end

c Note---assumes fdst linearly interpolated from cdst along edges
      subroutine hgcres(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, ga, irz)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1)
      double precision sigmac(scl0:sch0,scl1:sch1)
      double precision hx, hy
      integer ir, jr, ga(0:1,0:1), irz
      double precision hxm2, hym2, hxm2c, hym2c, sum, center,
     &   ffac, cfac, fac, fac1
      integer ic, jc, if, jf, ii, ji, idir, jdir, m, n
      hxm2c = 1.d0 / (ir * ir * hx * hx)
      hym2c = 1.d0 / (jr * jr * hy * hy)
      hxm2 = ir * ir * hxm2c
      hym2 = jr * jr * hym2c
      ic = regl0
      jc = regl1
      if = ic * ir
      jf = jc * jr

      sum = 0.d0
      center = 0.d0
c quadrants
      ffac = 0.5d0
      cfac = 0.5d0 * ir * jr
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) .eq. 1) then
               center = center + ffac
               sum = sum + sigmaf(if+ii-1,jf+ji-1) *
     &           (hxm2 * (fdst(if+idir,jf) - fdst(if,jf)) +
     &            hym2 * (fdst(if,jf+jdir) - fdst(if,jf)))
               if (irz .eq. 1 .and. ic .eq. 0) then
                 sum = sum - sigmaf(if+ii-1,jf+ji-1) * 0.5d0 *
     &             (hym2 * (fdst(if,jf+jdir) - fdst(if,jf)))
               endif
            else
               center = center + cfac
               sum = sum + ir * jr * sigmac(ic+ii-1,jc+ji-1) *
     &           (hxm2c * (cdst(ic+idir,jc) - cdst(ic,jc)) +
     &            hym2c * (cdst(ic,jc+jdir) - cdst(ic,jc)))
               if (irz .eq. 1 .and. ic .eq. 0) then
                 sum = sum - ir * jr * sigmac(ic+ii-1,jc+ji-1) * 0.5d0 *
     &             (hym2c * (cdst(ic,jc+jdir) - cdst(ic,jc)))
               endif
            end if
         end do
      end do
c edges
      do ji = 0, 1
         jdir = 2 * ji - 1
         do ii = 0, 1
            idir = 2 * ii - 1
            if (ga(ii,ji) - ga(ii,1-ji) .eq. 1) then
               fac1 = 1.d0 / ir
               ffac = 0.5d0 * (ir-1)
               center = center + ffac
               do m = idir, idir*(ir-1), idir
                  fac = (ir-abs(m)) * fac1
                  sum = sum + fac *
     &              (hxm2 * (sigmaf(if+m-1,jf+ji-1) *
     &                        (fdst(if+m-1,jf) - fdst(if+m,jf)) +
     &                       sigmaf(if+m,jf+ji-1) *
     &                        (fdst(if+m+1,jf) - fdst(if+m,jf))) +
     &               hym2 *
     &                 (sigmaf(if+m-1,jf+ji-1) + sigmaf(if+m,jf+ji-1)) *
     &                 (fdst(if+m,jf+jdir) - fdst(if+m,jf)))
               end do
            end if
            if (ga(ii,ji) - ga(1-ii,ji) .eq. 1) then
               fac1 = 1.d0 / jr
               ffac = 0.5d0 * (jr-1)
               center = center + ffac
               do n = jdir, jdir*(jr-1), jdir
                  fac = (jr-abs(n)) * fac1
                  sum = sum + fac *
     &              (hxm2 *
     &                 (sigmaf(if+ii-1,jf+n-1) + sigmaf(if+ii-1,jf+n)) *
     &                 (fdst(if+idir,jf+n) - fdst(if,jf+n)) +
     &               hym2 * (sigmaf(if+ii-1,jf+n-1) *
     &                        (fdst(if,jf+n-1) - fdst(if,jf+n)) +
     &                       sigmaf(if+ii-1,jf+n) *
     &                        (fdst(if,jf+n+1) - fdst(if,jf+n))))
               end do
            end if
         end do
      end do
c weighting
      res(if,jf) = src(if,jf) - sum / center
      end
c-----------------------------------------------------------------------
      subroutine hgcen(
     & cen,   cenl0,cenh0,cenl1,cenh1,
     & signd, snl0,snh0,snl1,snh1,
     &        regl0,regh0,regl1,regh1,irz)
      integer cenl0,cenh0,cenl1,cenh1
      integer snl0,snh0,snl1,snh1
      integer regl0,regh0,regl1,regh1
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision signd(snl0:snh0,snl1:snh1, 2)
      double precision tmp
      integer irz
      integer i, j, k
      do j = regl1, regh1
         do i = regl0, regh0
            tmp = (signd(i-1,j,1) + signd(i,j,1) 
     &           + signd(i,j-1,2) + signd(i,j,2))
            if ( tmp .eq. 0.0D0 ) then
               cen(i,j) = 0.0D0
            else
               cen(i,j) = 1.0D0 / tmp
            end if
         end do
         if (irz .eq. 1 .and. regl0 .eq. 0) then
            i = 0
            tmp = (signd(i-1,j,1) + signd(i,j,1)
     &           + 0.5d0*(signd(i,j-1,2) + signd(i,j,2)))
            if ( tmp .eq. 0.0D0 ) then
               cen(i,j) = 0.0D0
            else
               cen(i,j) = 1.0D0 / tmp 
            end if
         end if
      end do
      end
c five-point variable stencils
c-----------------------------------------------------------------------
      subroutine hgrlxaaaa(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & sigx, sigy,
     &     sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, irz, imax)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision hx, hy
      integer irz, imax
      double precision hxm2, hym2
      integer i, j, ipass, ipar
      double precision AVG
      AVG() = 0.5d0 * (hxm2 *
     &          ((sigx(i-1,j-1) + sigx(i-1,j)) * cor(i-1,j) +
     &           (sigx(i,j-1) + sigx(i,j)) * cor(i+1,j)) +
     &                 hym2 *
     &          ((sigy(i-1,j-1) + sigy(i,j-1)) * cor(i,j-1) +
     &           (sigy(i-1,j) + sigy(i,j)) * cor(i,j+1)))
      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      if (regh1 - regl1 .gt. regh0 - regl0) then
         do ipass = 1, 0, -1
            ipar = ipass
            do i = regl0, regh0
               ipar = 1 - ipar
cdir$ ivdep
               do j = regl1 + ipar, regh1, 2
                  cor(i,j) = (AVG() - res(i,j)) * cen(i,j)
                  if (irz .eq. 1 .and. i .eq. 0) then
                    cor(i,j) = (
     &                        0.5d0 * hxm2 *
     &                 ((sigx(i-1,j-1) + sigx(i-1,j)) * cor(i-1,j) +
     &                  (sigx(i  ,j-1) + sigx(i  ,j)) * cor(i+1,j)) +
     &                       0.25d0 * hym2 *
     &                 ((sigy(i-1,j-1) + sigy(i,j-1)) * cor(i,j-1) +
     &                  (sigy(i-1,j  ) + sigy(i,j  )) * cor(i,j+1))
     &                    - res(i,j)) * cen(i,j)
                  endif
               end do
            end do
         end do
      else
         do ipass = 1, 0, -1
            ipar = ipass
            do j = regl1, regh1
               ipar = 1 - ipar
cdir$ ivdep
               do i = regl0 + ipar, regh0, 2
                  cor(i,j) = (AVG() - res(i,j)) * cen(i,j)
                  if (irz .eq. 1 .and. i .eq. 0) then
                    cor(i,j) = (
     &                        0.5d0 * hxm2 *
     &                 ((sigx(i-1,j-1) + sigx(i-1,j)) * cor(i-1,j) +
     &                  (sigx(i,j-1) + sigx(i,j)) * cor(i+1,j)) +
     &                       0.25d0 * hym2 *
     &                 ((sigy(i-1,j-1) + sigy(i,j-1)) * cor(i,j-1) +
     &                  (sigy(i-1,j  ) + sigy(i,j  )) * cor(i,j+1))
     &                    - res(i,j)) * cen(i,j)
                  endif
               end do
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgresaaaa(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & dest,  destl0, desth0, destl1, desth1,
     & sigx,  sigy, sfl0, sfh0, sfl1, sfh1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, irz)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer destl0, desth0, destl1, desth1
      integer sfl0, sfh0, sfl1, sfh1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision dest(destl0:desth0,destl1:desth1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision hx, hy
      integer irz
      double precision hxm2, hym2
      integer i, j

      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)

      do j = regl1, regh1
         do i = regl0, regh0
            res(i,j) = src(i,j) - 0.5d0 * (hxm2 *
     &           ((sigx(i-1,j-1) + sigx(i-1,j)) *
     &             (dest(i-1,j) - dest(i,j)) +
     &            (sigx(i,j-1) + sigx(i,j)) *
     &             (dest(i+1,j) - dest(i,j))) +
     &                                        hym2 *
     &           ((sigy(i-1,j-1) + sigy(i,j-1)) *
     &             (dest(i,j-1) - dest(i,j)) +
     &            (sigy(i-1,j) + sigy(i,j)) *
     &             (dest(i,j+1) - dest(i,j))))
         end do
      end do

      if (irz .eq. 1 .and. regl0 .le. 0 .and. regh0 .ge. 0) then
         i = 0
         do j = regl1, regh1
            res(i,j) = res(i,j) + .25d0 * hym2 *
     &        ((sigy(i-1,j-1) + sigy(i,j-1)) *
     &          (dest(i,j-1) - dest(i,j)) +
     &         (sigy(i-1,j) + sigy(i,j)) *
     &          (dest(i,j+1) - dest(i,j)))
         end do
      endif

      end
c-----------------------------------------------------------------------
      subroutine hgrlxl(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & sigx, sigy, sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     &        doml0, domh0, doml1, domh1,
     & hx, hy, irz, imax, lsd)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      integer doml0, domh0, doml1, domh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision hx, hy
      double precision wrk(256)
      integer irz, imax, lsd
      double precision hxm2, hym2, betm, aj
      double precision RHSL0
      double precision RHSL1
      integer i, j, jw, ipass
c      RHSL0()=(res(i,j) - 0.5d0 * hym2 *
c     &          ((sigy(i-1,j-1) + sigy(i,j-1)) * cor(i,j-1) +
c     &           (sigy(i-1,j) + sigy(i,j)) * cor(i,j+1)))

      RHSL1()=(res(i,j) - 0.5d0 * hxm2 *
     &          ((sigx(i-1,j-1) + sigx(i-1,j)) * cor(i-1,j) +
     &           (sigx(i,j-1) + sigx(i,j)) * cor(i+1,j)))

      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      if (lsd .eq. 1) then
         do ipass = 0, 1
            do i = regl0 + ipass, regh0, 2
               j = regl1
               betm = -cen(i,j)
               if (betm .eq. 0.d0) then
c dirichlet bdy:
                  cor(i,j) = 0.d0
                  aj = 0.d0
                  wrk(1) = 0.d0
               else if (regl1 .eq. doml1) then
c neumann bdy:
                  cor(i,j) = RHSL1()* betm
                  aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
                  if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
                  wrk(1) = 2.d0 * aj * betm
               else
c interface to grid at same level:
                  aj = 0.5d0 * hym2 * (sigy(i-1,j-1) + sigy(i,j-1))
                  if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
                  aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
                  if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
                  wrk(1) = aj * betm
               end if
c forward solve loop:
               do j = regl1 + 1, regh1 - 1
                  jw = j - regl1
                  if (cen(i,j) .eq. 0.d0) then
                     betm = 0.d0
                  else
                     betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(jw))
                  end if
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
                  aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
                  if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
                  wrk(jw + 1) = aj * betm
               end do
               j = regh1
               jw = j - regl1
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
                  cor(i,j) = 0.d0
               else if (regh1 .eq. domh1) then
c neumann bdy:
                  aj = 2.d0 * aj
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(jw))
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               else if (jw .gt. 0) then
c interface to grid at same level:
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(jw))
                  cor(i,j) = RHSL1() - aj * cor(i,j-1)
                  aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
                  if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
                  cor(i,j) = (cor(i,j) - aj * cor(i,j+1)) * betm
               end if
c back substitution loop:
               do j = regh1 - 1, regl1, -1
                  jw = j - regl1
                  cor(i,j) = cor(i,j) - wrk(jw + 1) * cor(i,j+1)
               end do
            end do
         end do
      else
         STOP "Line solve implemented in Dimension 1"
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgrlnf(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & wrk,   wrkl0, wrkh0, wrkl1, wrkh1,
     & sigx, sigy, sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     &        doml0, domh0, doml1, domh1,
     & hx, hy, irz, imax, lsd, ipass)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer wrkl0, wrkh0, wrkl1, wrkh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      integer doml0, domh0, doml1, domh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision hx, hy
      integer irz, imax, lsd, ipass
      double precision hxm2, hym2, betm, aj
      double precision RHSL0, RHSL1
      integer i, j, ioff
      RHSL0()=(res(i,j) - 0.5d0 * hym2 *
     &          ((sigy(i-1,j-1) + sigy(i,j-1)) * cor(i,j-1) +
     &           (sigy(i-1,j) + sigy(i,j)) * cor(i,j+1)))

      RHSL1()=(res(i,j) - 0.5d0 * hxm2 *
     &          ((sigx(i-1,j-1) + sigx(i-1,j)) * cor(i-1,j) +
     &           (sigx(i,j-1) + sigx(i,j)) * cor(i+1,j)))
      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      if (lsd .eq. 0) then
         if (mod(regl1,2) .eq. 0) then
            ioff = ipass
         else
            ioff = 1 - ipass
         end if
         i = regl0
         do j = regl1 + ioff, regh1, 2
            aj = 0.5d0 * hxm2 * (sigx(i,j-1) + sigx(i,j))
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               wrk(i,j) = 0.d0
            else if (regl0 .eq. doml0) then
c neumann bdy:
               betm = -cen(i,j)
               cor(i,j) = RHSL0() * betm
               wrk(i,j) = 2.d0 * aj * betm
            end if
            wrk(i+1,j) = aj
         end do
c forward solve loop:
         do i = regl0 + 1, regh0 - 1
            do j = regl1 + ioff, regh1, 2
               aj = wrk(i,j)
               if (cen(i,j) .eq. 0.d0) then
                  betm = 0.d0
               else
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
               end if
               cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
               aj = 0.5d0 * hxm2 * (sigx(i,j-1) + sigx(i,j))
               wrk(i+1,j) = aj
               wrk(i,j) = aj * betm
            end do
         end do
         i = regh0
         do j = regl1 + ioff, regh1, 2
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
            else if (regh0 .eq. domh0) then
c neumann bdy:
               aj = 2.d0 * wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
               cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
            else if (i .gt. regl0) then
c interface to grid at same level:
               aj = wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
               cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
               aj = 0.5d0 * hxm2 * (sigx(i,j-1) + sigx(i,j))
               wrk(i,j) = aj * betm
            end if
         end do
      else
         if (mod(regl0,2) .eq. 0) then
            ioff = ipass
         else
            ioff = 1 - ipass
         end if
         j = regl1
         do i = regl0 + ioff, regh0, 2
            aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
            if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               wrk(i,j) = 0.d0
            else if (regl1 .eq. doml1) then
c neumann bdy:
               betm = -cen(i,j)
               cor(i,j) = RHSL1() * betm
               wrk(i,j) = 2.d0 * aj * betm
            end if
            wrk(i,j+1) = aj
         end do
c forward solve loop:
         do j = regl1 + 1, regh1 - 1
            do i = regl0 + ioff, regh0, 2
               aj = wrk(i,j)
               if (cen(i,j) .eq. 0.d0) then
                  betm = 0.d0
               else
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
               end if
               cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
               if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
               wrk(i,j+1) = aj
               wrk(i,j) = aj * betm
            end do
         end do
         j = regh1
         do i = regl0 + ioff, regh0, 2
            if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
            else if (regh1 .eq. domh1) then
c neumann bdy:
               aj = 2.d0 * wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
               cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
            else if (j .gt. regl1) then
c interface to grid at same level:
               aj = wrk(i,j)
               betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
               cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               aj = 0.5d0 * hym2 * (sigy(i-1,j) + sigy(i,j))
               if (irz .eq. 1 .and. i .eq. 0) aj = 0.5d0 * aj
               wrk(i,j) = aj * betm
            end if
         end do
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgrlx_full_old(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & sigx, sigy, sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, irz, imax)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision hx, hy
      integer irz, imax
      double precision hxm2, hym2, fac, facrz, r0, r1
      integer i, j
      double precision AVG, AVGRZ
      AVG() = fac * (hxm2 *
     &          (sigx(i-1,j-1) *
     &            (cor(i-1,j-1) - cor(i,j-1) + 2.d0 * cor(i-1,j)) +
     &           sigx(i-1,j) *
     &            (cor(i-1,j+1) - cor(i,j+1) + 2.d0 * cor(i-1,j)) +
     &           sigx(i,j-1) *
     &            (cor(i+1,j-1) - cor(i,j-1) + 2.d0 * cor(i+1,j)) +
     &           sigx(i,j) *
     &            (cor(i+1,j+1) - cor(i,j+1) + 2.d0 * cor(i+1,j))) +
     &               hym2 *
     &          (sigy(i-1,j-1) *
     &            (cor(i-1,j-1) - cor(i-1,j) + 2.d0 * cor(i,j-1)) +
     &           sigy(i-1,j) *
     &            (cor(i-1,j+1) - cor(i-1,j) + 2.d0 * cor(i,j+1)) +
     &           sigy(i,j-1) *
     &            (cor(i+1,j-1) - cor(i+1,j) + 2.d0 * cor(i,j-1)) +
     &           sigy(i,j) *
     &            (cor(i+1,j+1) - cor(i+1,j) + 2.d0 * cor(i,j+1))))
      AVGRZ() = AVG() + facrz *
     &           ((sigy(i-1,j-1) / r0 - sigy(i,j-1) / r1) * cor(i,j-1) +
     &             (sigy(i-1,j)   / r0 - sigy(i,j)   / r1) * cor(i,j+1))
      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      fac = 1.d0 / 6.d0
      if (irz .eq. 0) then
         do j = regl1, regh1
cdir$ ivdep
            do i = regl0, regh0
               cor(i,j) = (AVG() - res(i,j)) * cen(i,j)
            end do
         end do
      else
         facrz = hx * hym2 / 12.d0
         do j = regl1, regh1
cdir$ ivdep
            do i = regl0, regh0
               r1 = (i + 0.5d0) * hx
               r0 = r1 - hx
               if (i .eq. imax) then
                  r1 = -r0
               end if
               cor(i,j) = (AVGRZ() - res(i,j)) * cen(i,j)
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgrlxl_full_old(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & sigx, sigy, sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     &        doml0, domh0, doml1, domh1,
     & hx, hy, irz, imax, lsd)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      integer doml0, domh0, doml1, domh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision hx, hy
      double precision wrk(256)
      integer irz, imax, lsd
      double precision hxm2, hym2, fac, facrz, r0, r1, betm, aj
      integer i, j, jw, ipass
c     double precision RHSL0
      double precision RHSL1
c     double precision RHSRZL0, RHSRZL1
      double precision AVG, AVGRZ
c      RHSL0() = (res(i,j) - fac * (hxm2 *
c     &           (sigx(i-1,j-1) *
c     &             (cor(i-1,j-1) - cor(i,j-1)) +
c     &            sigx(i-1,j) *
c     &             (cor(i-1,j+1) - cor(i,j+1)) +
c     &            sigx(i,j-1) *
c     &             (cor(i+1,j-1) - cor(i,j-1)) +
c     &            sigx(i,j) *
c     &             (cor(i+1,j+1) - cor(i,j+1))) +
c     &                            hym2 *
c     &           (sigy(i-1,j-1) *
c     &             (cor(i-1,j-1) + 2.d0 * cor(i,j-1)) +
c     &            sigy(i-1,j) *
c     &             (cor(i-1,j+1) + 2.d0 * cor(i,j+1)) +
c     &            sigy(i,j-1) *
c     &             (cor(i+1,j-1) + 2.d0 * cor(i,j-1)) +
c     &            sigy(i,j) *
c     &             (cor(i+1,j+1) + 2.d0 * cor(i,j+1)))))
      RHSL1() = (res(i,j) - fac * (hxm2 *
     &          (sigx(i-1,j-1) *
     &             (cor(i-1,j-1) + 2.d0 * cor(i-1,j)) +
     &            sigx(i-1,j) *
     &             (cor(i-1,j+1) + 2.d0 * cor(i-1,j)) +
     &            sigx(i,j-1) *
     &             (cor(i+1,j-1) + 2.d0 * cor(i+1,j)) +
     &            sigx(i,j) *
     &             (cor(i+1,j+1) + 2.d0 * cor(i+1,j))) +
     &                            hym2 *
     &           (sigy(i-1,j-1) *
     &             (cor(i-1,j-1) - cor(i-1,j)) +
     &            sigy(i-1,j) *
     &             (cor(i-1,j+1) - cor(i-1,j)) +
     &            sigy(i,j-1) *
     &             (cor(i+1,j-1) - cor(i+1,j)) +
     &            sigy(i,j) *
     &             (cor(i+1,j+1) - cor(i+1,j)))))

c      RHSRZL0() = (RHSL0() - facrz *
c     &          ((sigy(i-1,j-1) / r0 - sigy(i,j-1) / r1) * cor(i,j-1) +
c     &           (sigy(i-1,j)   / r0 - sigy(i,j)   / r1) * cor(i,j+1)))
c
c      RHSRZL1()= RHSL1()
      AVG() = fac * (hxm2 *
     &          (sigx(i-1,j-1) *
     &            (cor(i-1,j-1) - cor(i,j-1) + 2.d0 * cor(i-1,j)) +
     &           sigx(i-1,j) *
     &            (cor(i-1,j+1) - cor(i,j+1) + 2.d0 * cor(i-1,j)) +
     &           sigx(i,j-1) *
     &            (cor(i+1,j-1) - cor(i,j-1) + 2.d0 * cor(i+1,j)) +
     &           sigx(i,j) *
     &            (cor(i+1,j+1) - cor(i,j+1) + 2.d0 * cor(i+1,j))) +
     &               hym2 *
     &          (sigy(i-1,j-1) *
     &            (cor(i-1,j-1) - cor(i-1,j) + 2.d0 * cor(i,j-1)) +
     &           sigy(i-1,j) *
     &            (cor(i-1,j+1) - cor(i-1,j) + 2.d0 * cor(i,j+1)) +
     &           sigy(i,j-1) *
     &            (cor(i+1,j-1) - cor(i+1,j) + 2.d0 * cor(i,j-1)) +
     &           sigy(i,j) *
     &            (cor(i+1,j+1) - cor(i+1,j) + 2.d0 * cor(i,j+1))))
      AVGRZ() = AVG() + facrz *
     &           ((sigy(i-1,j-1) / r0 - sigy(i,j-1) / r1) * cor(i,j-1) +
     &             (sigy(i-1,j)   / r0 - sigy(i,j)   / r1) * cor(i,j+1))
      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      fac = 1.d0 / 6.d0
      if (irz .eq. 0) then
         if (lsd .eq. 1) then
            do ipass = 0, 1
            do i = regl0 + ipass, regh0, 2
               j = regl1
               betm = -cen(i,j)
               if (betm .eq. 0.d0) then
c dirichlet bdy:
                  cor(i,j) = 0.d0
                  wrk(1) = 0.d0
               else if (regl1 .eq. doml1) then
c neumann bdy:
                  cor(i,j) = RHSL1() * betm
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &               hxm2 * (sigx(i-1,j) + sigx(i,j)))
                  wrk(1) = 2.d0 * aj * betm
               else
c interface to grid at same level:
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j-1) + sigy(i,j-1)) -
     &               hxm2 * (sigx(i-1,j-1) + sigx(i,j-1)))
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &               hxm2 * (sigx(i-1,j) + sigx(i,j)))
                  wrk(1) = aj * betm
               end if
c forward solve loop:
               do j = regl1 + 1, regh1 - 1
                  jw = j - regl1
                  if (cen(i,j) .eq. 0.d0) then
                     betm = 0.d0
                  else
                     betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(jw))
                  end if
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &               hxm2 * (sigx(i-1,j) + sigx(i,j)))
                  wrk(jw + 1) = aj * betm
               end do
               j = regh1
               jw = j - regl1
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
                  cor(i,j) = 0.d0
               else if (regh1 .eq. domh1) then
c neumann bdy:
                  aj = 2.d0 * aj
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(jw))
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               else if (jw .gt. 0) then
c interface to grid at same level:
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(jw))
                  cor(i,j) = RHSL1() - aj * cor(i,j-1)
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &               hxm2 * (sigx(i-1,j) + sigx(i,j)))
                  cor(i,j) = (cor(i,j) - aj * cor(i,j+1)) * betm
               end if
c back substitution loop:
               do j = regh1 - 1, regl1, -1
                  jw = j - regl1
                  cor(i,j) = cor(i,j) - wrk(jw + 1) * cor(i,j+1)
               end do
c update neumann bdys:
               if (regl1 .eq. doml1) then
                  cor(i,regl1-1) = cor(i,regl1+1)
               end if
               if (regh1 .eq. domh1) then
                  cor(i,regh1+1) = cor(i,regh1-1)
               end if
            end do
            end do
         else
            print *, "Line solve not implemented in dimension", lsd
            stop
         end if
      else
         STOP "Line solve not implemented for rz: Using Gauss-Seidel
     &  instead."
         facrz = hx * hym2 / 12.d0
         if (regh1 - regl1 .gt. regh0 - regl0) then
            do i = regl0, regh0
               r1 = (i + 0.5d0) * hx
               r0 = r1 - hx
               if (i .eq. imax) then
                  r1 = -r0
               end if
cdir$ ivdep
               do j = regl1, regh1
                  cor(i,j) = (AVGRZ() - res(i,j)) * cen(i,j)
               end do
            end do
         else
            do j = regl1, regh1
cdir$ ivdep
               do i = regl0, regh0
                  r1 = (i + 0.5d0) * hx
                  r0 = r1 - hx
                  if (i .eq. imax) then
                     r1 = -r0
                  end if
                  cor(i,j) = (AVGRZ() - res(i,j)) * cen(i,j)
               end do
            end do
         end if
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgrlnf_full_old(
     & cor,   corl0, corh0, corl1, corh1,
     & res,   resl0, resh0, resl1, resh1,
     & wrk,   wrkl0, wrkh0, wrkl1, wrkh1,
     & sigx, sigy, sfl0, sfh0, sfl1, sfh1,
     & cen,   cenl0, cenh0, cenl1, cenh1,
     &        regl0, regh0, regl1, regh1,
     &        doml0, domh0, doml1, domh1,
     & hx, hy, irz, imax, lsd, ipass)
      integer corl0, corh0, corl1, corh1
      integer resl0, resh0, resl1, resh1
      integer wrkl0, wrkh0, wrkl1, wrkh1
      integer sfl0, sfh0, sfl1, sfh1
      integer cenl0, cenh0, cenl1, cenh1
      integer regl0, regh0, regl1, regh1
      integer doml0, domh0, doml1, domh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision cen(cenl0:cenh0,cenl1:cenh1)
      double precision hx, hy
      integer irz, imax, lsd, ipass
      double precision hxm2, hym2, fac, facrz, r0, r1, betm, aj
      integer i, j, ioff
      double precision RHSL0, RHSL1, RHSRZL0, RHSRZL1
c      double precision AVG
c      double precision AVGRZ
      RHSL0() = (res(i,j) - fac * (hxm2 *
     &           (sigx(i-1,j-1) *
     &             (cor(i-1,j-1) - cor(i,j-1)) +
     &            sigx(i-1,j) *
     &             (cor(i-1,j+1) - cor(i,j+1)) +
     &            sigx(i,j-1) *
     &             (cor(i+1,j-1) - cor(i,j-1)) +
     &            sigx(i,j) *
     &             (cor(i+1,j+1) - cor(i,j+1))) +
     &                            hym2 *
     &           (sigy(i-1,j-1) *
     &             (cor(i-1,j-1) + 2.d0 * cor(i,j-1)) +
     &            sigy(i-1,j) *
     &             (cor(i-1,j+1) + 2.d0 * cor(i,j+1)) +
     &            sigy(i,j-1) *
     &             (cor(i+1,j-1) + 2.d0 * cor(i,j-1)) +
     &            sigy(i,j) *
     &             (cor(i+1,j+1) + 2.d0 * cor(i,j+1)))))
      RHSL1() = (res(i,j) - fac * (hxm2 *
     &          (sigx(i-1,j-1) *
     &             (cor(i-1,j-1) + 2.d0 * cor(i-1,j)) +
     &            sigx(i-1,j) *
     &             (cor(i-1,j+1) + 2.d0 * cor(i-1,j)) +
     &            sigx(i,j-1) *
     &             (cor(i+1,j-1) + 2.d0 * cor(i+1,j)) +
     &            sigx(i,j) *
     &             (cor(i+1,j+1) + 2.d0 * cor(i+1,j))) +
     &                            hym2 *
     &           (sigy(i-1,j-1) *
     &             (cor(i-1,j-1) - cor(i-1,j)) +
     &            sigy(i-1,j) *
     &             (cor(i-1,j+1) - cor(i-1,j)) +
     &            sigy(i,j-1) *
     &             (cor(i+1,j-1) - cor(i+1,j)) +
     &            sigy(i,j) *
     &             (cor(i+1,j+1) - cor(i+1,j)))))

      RHSRZL0() = (RHSL0() - facrz *
     &           ((sigy(i-1,j-1) / r0 - sigy(i,j-1) / r1) * cor(i,j-1) +
     &            (sigy(i-1,j)   / r0 - sigy(i,j)   / r1) * cor(i,j+1)))

      RHSRZL1()= RHSL1()
c      AVG() = fac * (hxm2 *
c     &          (sigx(i-1,j-1) *
c     &            (cor(i-1,j-1) - cor(i,j-1) + 2.d0 * cor(i-1,j)) +
c     &           sigx(i-1,j) *
c     &            (cor(i-1,j+1) - cor(i,j+1) + 2.d0 * cor(i-1,j)) +
c     &           sigx(i,j-1) *
c     &            (cor(i+1,j-1) - cor(i,j-1) + 2.d0 * cor(i+1,j)) +
c     &           sigx(i,j) *
c     &            (cor(i+1,j+1) - cor(i,j+1) + 2.d0 * cor(i+1,j))) +
c     &               hym2 *
c     &          (sigy(i-1,j-1) *
c     &            (cor(i-1,j-1) - cor(i-1,j) + 2.d0 * cor(i,j-1)) +
c     &           sigy(i-1,j) *
c     &            (cor(i-1,j+1) - cor(i-1,j) + 2.d0 * cor(i,j+1)) +
c     &           sigy(i,j-1) *
c     &            (cor(i+1,j-1) - cor(i+1,j) + 2.d0 * cor(i,j-1)) +
c     &           sigy(i,j) *
c     &            (cor(i+1,j+1) - cor(i+1,j) + 2.d0 * cor(i,j+1))))
c      AVGRZ() = AVG() + facrz *
c     &          ((sigy(i-1,j-1) / r0 - sigy(i,j-1) / r1) * cor(i,j-1) +
c     &            (sigy(i-1,j)   / r0 - sigy(i,j)   / r1) * cor(i,j+1))
      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      fac = 1.d0 / 6.d0
      if (irz .eq. 0) then
         if (lsd .eq. 0) then
            if (mod(regl1,2) .eq. 0) then
               ioff = ipass
            else
               ioff = 1 - ipass
            end if
            i = regl0
            do j = regl1 + ioff, regh1, 2
               aj = fac *
     &           (hxm2 * 2.d0 * (sigx(i,j-1) + sigx(i,j)) -
     &            hym2 * (sigy(i,j-1) + sigy(i,j)))
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
                  wrk(i,j) = 0.d0
               else if (regl0 .eq. doml0) then
c neumann bdy:
                  betm = -cen(i,j)
                  cor(i,j) = RHSL0() * betm
                  wrk(i,j) = 2.d0 * aj * betm
               end if
               wrk(i+1,j) = aj
            end do
c forward solve loop:
            do i = regl0 + 1, regh0 - 1
               do j = regl1 + ioff, regh1, 2
                  aj = wrk(i,j)
                  if (cen(i,j) .eq. 0.d0) then
                     betm = 0.d0
                  else
                     betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
                  end if
                  cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
                  aj = fac *
     &              (hxm2 * 2.d0 * (sigx(i,j-1) + sigx(i,j)) -
     &               hym2 * (sigy(i,j-1) + sigy(i,j)))
                  wrk(i+1,j) = aj
                  wrk(i,j) = aj * betm
               end do
            end do
            i = regh0
            do j = regl1 + ioff, regh1, 2
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               else if (regh0 .eq. domh0) then
c neumann bdy:
                  aj = 2.d0 * wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
                  cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
               else if (i .gt. regl0) then
c interface to grid at same level:
                  aj = wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
                  cor(i,j) = (RHSL0() - aj * cor(i-1,j)) * betm
                  aj = fac *
     &              (hxm2 * 2.d0 * (sigx(i,j-1) + sigx(i,j)) -
     &               hym2 * (sigy(i,j-1) + sigy(i,j)))
                  wrk(i,j) = aj * betm
               end if
            end do
         else
            if (mod(regl0,2) .eq. 0) then
               ioff = ipass
            else
               ioff = 1 - ipass
            end if
            j = regl1
            do i = regl0 + ioff, regh0, 2
               aj = fac *
     &           (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &            hxm2 * (sigx(i-1,j) + sigx(i,j)))
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
                  wrk(i,j) = 0.d0
               else if (regl1 .eq. doml1) then
c neumann bdy:
                  betm = -cen(i,j)
                  cor(i,j) = RHSL1() * betm
                  wrk(i,j) = 2.d0 * aj * betm
               end if
               wrk(i,j+1) = aj
            end do
c forward solve loop:
            do j = regl1 + 1, regh1 - 1
               do i = regl0 + ioff, regh0, 2
                  aj = wrk(i,j)
                  if (cen(i,j) .eq. 0.d0) then
                     betm = 0.d0
                  else
                     betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
                  end if
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &               hxm2 * (sigx(i-1,j) + sigx(i,j)))
                  wrk(i,j+1) = aj
                  wrk(i,j) = aj * betm
               end do
            end do
            j = regh1
            do i = regl0 + ioff, regh0, 2
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               else if (regh1 .eq. domh1) then
c neumann bdy:
                  aj = 2.d0 * wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
               else if (j .gt. regl1) then
c interface to grid at same level:
                  aj = wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
                  cor(i,j) = (RHSL1() - aj * cor(i,j-1)) * betm
                  aj = fac *
     &              (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &               hxm2 * (sigx(i-1,j) + sigx(i,j)))
                  wrk(i,j) = aj * betm
               end if
            end do
         end if
      else
         facrz = hx * hym2 / 12.d0
         if (lsd .eq. 0) then
            if (mod(regl1,2) .eq. 0) then
               ioff = ipass
            else
               ioff = 1 - ipass
            end if
            i = regl0
            r1 = (i + 0.5d0) * hx
            r0 = r1 - hx
            do j = regl1 + ioff, regh1, 2
               aj = fac *
     &           (hxm2 * 2.d0 * (sigx(i,j-1) + sigx(i,j)) -
     &            hym2 * (sigy(i,j-1) + sigy(i,j)))
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
                  wrk(i,j) = 0.d0
               else if (regl0 .eq. doml0) then
c neumann bdy:
                  betm = -cen(i,j)
                  cor(i,j) = RHSRZL0() * betm
                  wrk(i,j) = 2.d0 * aj * betm
               end if
               wrk(i+1,j) = aj
            end do
c forward solve loop:
            do i = regl0 + 1, regh0 - 1
               r1 = (i + 0.5d0) * hx
               r0 = r1 - hx
               do j = regl1 + ioff, regh1, 2
                  aj = wrk(i,j)
                  if (cen(i,j) .eq. 0.d0) then
                     betm = 0.d0
                  else
                     betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
                  end if
                  cor(i,j) = (RHSRZL0() - aj * cor(i-1,j)) * betm
                  aj = fac *
     &              (hxm2 * 2.d0 * (sigx(i,j-1) + sigx(i,j)) -
     &               hym2 * (sigy(i,j-1) + sigy(i,j)))
                  wrk(i+1,j) = aj
                  wrk(i,j) = aj * betm
               end do
            end do
            i = regh0
            r1 = (i + 0.5d0) * hx
            r0 = r1 - hx
            if (i .eq. imax) then
               r1 = -r0
            end if
            do j = regl1 + ioff, regh1, 2
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               else if (regh0 .eq. domh0) then
c neumann bdy:
                  aj = 2.d0 * wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
                  cor(i,j) = (RHSRZL0() - aj * cor(i-1,j)) * betm
               else if (i .gt. regl0) then
c interface to grid at same level:
                  aj = wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i-1,j))
                  cor(i,j) = (RHSRZL0() - aj * cor(i-1,j)) * betm
                  aj = fac *
     &              (hxm2 * 2.d0 * (sigx(i,j-1) + sigx(i,j)) -
     &               hym2 * (sigy(i,j-1) + sigy(i,j)))
                  wrk(i,j) = aj * betm
               end if
            end do
         else
            if (mod(regl0,2) .eq. 0) then
               ioff = ipass
            else
               ioff = 1 - ipass
            end if
            j = regl1
            do i = regl0 + ioff, regh0, 2
               r1 = (i + 0.5d0) * hx
               r0 = r1 - hx
               if (i .eq. imax) then
                  r1 = -r0
               end if
               aj = fac *
     &                (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &                 hxm2 * (sigx(i-1,j) + sigx(i,j))) +
     &              facrz * (sigy(i-1,j) / r0 - sigy(i,j) / r1)
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
                  wrk(i,j) = 0.d0
               else if (regl1 .eq. doml1) then
c neumann bdy:
                  betm = -cen(i,j)
                  cor(i,j) = RHSRZL1() * betm
                  wrk(i,j) = 2.d0 * aj * betm
               end if
               wrk(i,j+1) = aj
            end do
c forward solve loop:
            do j = regl1 + 1, regh1 - 1
               do i = regl0 + ioff, regh0, 2
                  r1 = (i + 0.5d0) * hx
                  r0 = r1 - hx
                  if (i .eq. imax) then
                     r1 = -r0
                  end if
                  aj = wrk(i,j)
                  if (cen(i,j) .eq. 0.d0) then
                     betm = 0.d0
                  else
                     betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
                  end if
                  cor(i,j) = (RHSRZL1() - aj * cor(i,j-1)) * betm
                  aj = fac *
     &                   (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &                    hxm2 * (sigx(i-1,j) + sigx(i,j))) +
     &                 facrz * (sigy(i-1,j) / r0 - sigy(i,j) / r1)
                  wrk(i,j+1) = aj
                  wrk(i,j) = aj * betm
               end do
            end do
            j = regh1
            do i = regl0 + ioff, regh0, 2
               if (cen(i,j) .eq. 0.d0) then
c dirichlet bdy:
               else if (regh1 .eq. domh1) then
c neumann bdy:
                  aj = 2.d0 * wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
                  cor(i,j) = (RHSRZL1() - aj * cor(i,j-1)) * betm
               else if (j .gt. regl1) then
c interface to grid at same level:
                  r1 = (i + 0.5d0) * hx
                  r0 = r1 - hx
                  if (i .eq. imax) then
                     r1 = -r0
                  end if
                  aj = wrk(i,j)
                  betm = 1.d0 / (-1.d0 / cen(i,j) - aj * wrk(i,j-1))
                  cor(i,j) = (RHSRZL1() - aj * cor(i,j-1)) * betm
                  aj = fac *
     &                   (hym2 * 2.d0 * (sigy(i-1,j) + sigy(i,j)) -
     &                    hxm2 * (sigx(i-1,j) + sigx(i,j))) +
     &                 facrz * (sigy(i-1,j) / r0 - sigy(i,j) / r1)
                  wrk(i,j) = aj * betm
               end if
            end do
         end if
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgres_full_old(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & dest,  destl0, desth0, destl1, desth1,
     & sigx, sigy, sfl0, sfh0, sfl1, sfh1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, irz, imax)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer destl0, desth0, destl1, desth1
      integer sfl0, sfh0, sfl1, sfh1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision dest(destl0:desth0,destl1:desth1)
      double precision sigx(sfl0:sfh0,sfl1:sfh1)
      double precision sigy(sfl0:sfh0,sfl1:sfh1)
      double precision hx, hy
      integer irz, imax
      double precision hxm2, hym2, fac, r0, r1, tmp
      integer i, j
      hxm2 = 1.d0 / (hx*hx)
      hym2 = 1.d0 / (hy*hy)
      fac = 1.d0 / 6.d0
         do j = regl1, regh1
            do i = regl0, regh0
               tmp = hxm2 *
     &           (sigx(i-1,j-1) *
     &             (dest(i-1,j-1) - dest(i,j-1) +
     &              2.d0 * (dest(i-1,j) - dest(i,j))) +
     &            sigx(i-1,j) *
     &             (dest(i-1,j+1) - dest(i,j+1) +
     &              2.d0 * (dest(i-1,j) - dest(i,j))) +
     &            sigx(i,j-1) *
     &             (dest(i+1,j-1) - dest(i,j-1) +
     &              2.d0 * (dest(i+1,j) - dest(i,j))) +
     &            sigx(i,j) *
     &             (dest(i+1,j+1) - dest(i,j+1) +
     &              2.d0 * (dest(i+1,j) - dest(i,j))))
               res(i,j) = src(i,j) - fac * (tmp + hym2 *
     &           (sigy(i-1,j-1) *
     &             (dest(i-1,j-1) - dest(i-1,j) +
     &              2.d0 * (dest(i,j-1) - dest(i,j))) +
     &            sigy(i-1,j) *
     &             (dest(i-1,j+1) - dest(i-1,j) +
     &              2.d0 * (dest(i,j+1) - dest(i,j))) +
     &            sigy(i,j-1) *
     &             (dest(i+1,j-1) - dest(i+1,j) +
     &              2.d0 * (dest(i,j-1) - dest(i,j))) +
     &            sigy(i,j) *
     &             (dest(i+1,j+1) - dest(i+1,j) +
     &              2.d0 * (dest(i,j+1) - dest(i,j)))))
            end do
         end do
      if (irz .eq. 1) then
         fac = hx * hym2 / 12.d0
         do i = regl0, regh0
            r1 = (i + 0.5d0) * hx
            r0 = r1 - hx
            if (i .eq. imax) then
               r1 = -r0
            end if
            do j = regl1, regh1
               res(i,j) = res(i,j) - fac *
     &          ((sigy(i-1,j-1) * (dest(i,j-1) - dest(i,j)) +
     &            sigy(i-1,j)   * (dest(i,j+1) - dest(i,j))) / r0 -
     &           (sigy(i,j-1)   * (dest(i,j-1) - dest(i,j)) +
     &            sigy(i,j)     * (dest(i,j+1) - dest(i,j))) / r1)
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
      subroutine hgrlnb(
     & cor,   corl0, corh0, corl1, corh1,
     & wrk,   wrkl0, wrkh0, wrkl1, wrkh1,
     &        regl0, regh0, regl1, regh1,
     & lsd, ipass)
      integer corl0, corh0, corl1, corh1
      integer wrkl0, wrkh0, wrkl1, wrkh1
      integer regl0, regh0, regl1, regh1
      double precision cor(corl0:corh0,corl1:corh1)
      double precision wrk(wrkl0:wrkh0,wrkl1:wrkh1)
      integer lsd, ipass
      integer i, j, ioff
      if (lsd .eq. 0) then
         if (mod(regl1,2) .eq. 0) then
            ioff = ipass
         else
            ioff = 1 - ipass
         end if
c back substitution loop:
         do i = regh0 - 1, regl0, -1
            do j = regl1 + ioff, regh1, 2
               cor(i,j) = cor(i,j) - wrk(i,j) * cor(i+1,j)
            end do
         end do
      else
         if (mod(regl0,2) .eq. 0) then
            ioff = ipass
         else
            ioff = 1 - ipass
         end if
c back substitution loop:
         do j = regh1 - 1, regl1, -1
            do i = regl0 + ioff, regh0, 2
               cor(i,j) = cor(i,j) - wrk(i,j) * cor(i,j+1)
            end do
         end do
      end if
      end

c Unrolled indexing in these 3 routines uses the fact that each array
c has a border of width 1
c-----------------------------------------------------------------------
c Works for NODE-based data.
      subroutine hgip(
     & v0, v1, mask,
     &     regl0, regh0, regl1, regh1,
     & sum)
      integer regl0, regh0, regl1, regh1
      double precision v0(*)
      double precision v1(*)
      double precision mask(*)
      double precision sum
      integer i, idiff
c      do 10 i = 1, (regh0 - regl0 + 1) * (regh1 - regl1 + 1)
      idiff = regh0 - regl0 + 1
      do i = idiff + 2, idiff * (regh1 - regl1) - 1
         sum = sum + mask(i) * v0(i) * v1(i)
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgcg1(
     & r, p, z, x, w, c, mask,
     &     regl0, regh0, regl1, regh1,
     & alpha, rho)
      integer regl0, regh0, regl1, regh1
      double precision r(*)
      double precision p(*)
      double precision z(*)
      double precision x(*)
      double precision w(*)
      double precision c(*)
      double precision mask(*)
      double precision alpha, rho
      integer i, idiff
c      do 10 i = 1, (regh0 - regl0 + 1) * (regh1 - regl1 + 1)
      idiff = regh0 - regl0 + 1
      do i = idiff + 2, idiff * (regh1 - regl1) - 1
         r(i) = r(i) - alpha * w(i)
         x(i) = x(i) + alpha * p(i)
         z(i) = r(i) * c(i)
         rho = rho + mask(i) * z(i) * r(i)
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgcg2(p, z,
     &     regl0, regh0, regl1, regh1,
     & alpha)
      integer regl0, regh0, regl1, regh1
      double precision p(*)
      double precision z(*)
      double precision alpha
      integer i, idiff
c      do 10 i = 1, (regh0 - regl0 + 1) * (regh1 - regl1 + 1)
      idiff = regh0 - regl0 + 1
      do i = idiff + 2, idiff * (regh1 - regl1) - 1
         p(i) = alpha * p(i) + z(i)
      end do
      end
c-----------------------------------------------------------------------
      subroutine hgresu(
     & res, resl0,resh0,resl1,resh1,
     & src, dest, signd, mask,
     &      regl0,regh0,regl1,regh1,
     & irz)
      integer resl0,resh0,resl1,resh1
      integer regl0,regh0,regl1,regh1
      double precision res(*)
      double precision src(*)
      double precision dest(*)
      double precision signd(*)
      double precision mask(*)
      integer irz
      integer istart, iend
      integer i, jdiff, ly
      integer ilocal, jlocal
      jdiff = resh0 - resl0 + 1
      ly = (resh1 - resl1 + 1) * jdiff
      istart = (regl1 - resl1) * jdiff + (regl0 - resl0)
      iend   = (regh1 - resl1) * jdiff + (regh0 - resl0)

      do i = istart+1, iend+1
         jlocal = i / jdiff + resl1
         ilocal = resl0 + (i-jlocal*jdiff-resl1)
         res(i) = mask(i) * (src(i) -
     &     (signd(i-1)        * (dest(i-1) - dest(i)) +
     &      signd(i)          * (dest(i+1) - dest(i)) +
     &      signd(i+ly-jdiff) * (dest(i-jdiff) - dest(i)) +
     &      signd(i+ly)       * (dest(i+jdiff) - dest(i))))
      end do

      if (irz .eq. 1 .and. regl0 .eq. 0) then
        do i = (regl1 - resl1) * jdiff + (regl0 - resl0) + 1,
     &         (regh1 - resl1) * jdiff + (regh0 - resl0) + 1, jdiff
           res(i) = mask(i) * (src(i) -
     &       (signd(i-1)        * (dest(i-1) - dest(i)) +
     &        signd(i)          * (dest(i+1) - dest(i)) +
     &        signd(i+ly-jdiff) * (dest(i-jdiff) - dest(i)) * 0.5d0 +
     &        signd(i+ly)       * (dest(i+jdiff) - dest(i)) * 0.5d0 ))
        end do
      endif

      end
c-----------------------------------------------------------------------
      subroutine hgresur(
     & res, resl0,resh0,resl1,resh1,
     & src, dest, signd,
     &      regl0,regh0,regl1,regh1,
     & irz)
      integer resl0,resh0,resl1,resh1
      integer regl0,regh0,regl1,regh1
      double precision res(resl0:resh0, resl1:resh1)
      double precision src(resl0:resh0, resl1:resh1)
      double precision dest(resl0:resh0, resl1:resh1)
      double precision signd(resl0:resh0, resl1:resh1,2)
      integer irz
      integer istart, iend
      integer i, j, jdiff, ly
      integer ilocal, jlocal
      jdiff = resh0 - resl0 + 1
      ly = (resh1 - resl1 + 1) * jdiff
      istart = (regl1 - resl1) * jdiff + (regl0 - resl0)
      iend   = (regh1 - resl1) * jdiff + (regh0 - resl0)

      do j = regl1, regh1
          do i = regl0, regh0
          res(i,j) = (src(i,j) - (
     &    + signd(i-1,j,1)*(dest(i-1,j)-dest(i,j))
     &    + signd(i,j,1)  *(dest(i+1,j)-dest(i,j))
     &    + signd(i,j-1,2)*(dest(i,j-1)-dest(i,j))
     &    + signd(i,j,2)  *(dest(i,j+1)-dest(i,j))
     &    )
     &    )
        end do
        end do

      if (irz .eq. 1 .and. regl0 .eq. 0) then
        do j = regl1, regh1
        do i = regl0, regh0
           res(i,j) = (src(i,j) -
     &       (signd(i-1,j,1) * (dest(i-1,j) - dest(i,j)) +
     &        signd(i,j,1)   * (dest(i+1,j) - dest(i,j)) +
     &        signd(i,j-1,2) * (dest(i,j-1) - dest(i,j)) * 0.5d0 +
     &        signd(i,j,2)   * (dest(i,j+1) - dest(i,j)) * 0.5d0 ))
        end do
        end do
      endif
      end
c-----------------------------------------------------------------------
      subroutine hgscon(
     & signd, snl0,snh0,snl1,snh1,
     & sigx, sigy,
     &        scl0,sch0,scl1,sch1,
     &        regl0,regh0,regl1,regh1,
     & hx, hy)
      integer snl0,snh0,snl1,snh1
      integer scl0,sch0,scl1,sch1
      integer regl0,regh0,regl1,regh1
      double precision signd(snl0:snh0,snl1:snh1, 2)
      double precision sigx(scl0:sch0,scl1:sch1)
      double precision sigy(scl0:sch0,scl1:sch1)
      double precision hx, hy
      double precision facx, facy
      integer i, j
      facx = 0.5D0 / (hx*hx)
      facy = 0.5D0 / (hy*hy)
         do j = regl1, regh1
            do i = regl0-1, regh0
               signd(i,j,1) = facx *
     &               (sigx(i,j) + sigx(i,j-1))
            end do
         end do
         do j = regl1-1, regh1
            do i = regl0, regh0
               signd(i,j,2) = facy *
     &               (sigy(i-1,j) + sigy(i,j))
            end do
         end do
      end
c-----------------------------------------------------------------------
c sig here contains three different directions all stored on "nodes"
      subroutine hgrlxu(
     & cor, res, sig, cen,
     &     resl0,resh0,resl1,resh1,
     & mask,
     &     regl0,regh0,regl1,regh1,irz)
      integer resl0,resh0,resl1,resh1
      integer regl0,regh0,regl1,regh1
      double precision cor(*)
      double precision res(*)
      double precision sig(*)
      double precision cen(*)
      double precision mask(*)
      double precision AVG
      double precision AVGREDGE
      integer irz
      integer istart, iend
      integer i, jdiff, ly
      AVG() = (sig(i-1)        * cor(i-1) +
     &         sig(i)          * cor(i+1) +
     &         sig(i+ly-jdiff) * cor(i-jdiff) +
     &         sig(i+ly)       * cor(i+jdiff))
      AVGREDGE() = (sig(i-1)        * cor(i-1) +
     &              sig(i)          * cor(i+1) +
     &              sig(i+ly-jdiff) * cor(i-jdiff) * 0.5d0 +
     &              sig(i+ly)       * cor(i+jdiff) * 0.5d0 )
      jdiff =  resh0 - resl0 + 1
      ly    = (resh1 - resl1 + 1) * jdiff
      istart = (regl1 - resl1) * jdiff + (regl0 - resl0)
      iend   = (regh1 - resl1) * jdiff + (regh0 - resl0)
cdir$ ivdep
      if (irz .eq. 0 .or. regl0 .gt. 0) then
        do i = istart + 1, iend + 1, 2
           cor(i) = cor(i)
     &        + mask(i) * ((AVG() - res(i)) * cen(i) - cor(i))
        end do
cdir$ ivdep
        do i = istart + 2, iend + 1, 2
           cor(i) = cor(i)
     &        + mask(i) * ((AVG() - res(i)) * cen(i) - cor(i))
        end do

      else

c     Now irz = 1 and regl0 = 0, so we are touching the r=0 edge
        do i = istart + 1, iend + 1, 2
           if (mod(i-istart-1,jdiff) .eq. 0) then
             cor(i) = cor(i)
     &          + mask(i) * ((AVGREDGE() - res(i)) * cen(i) - cor(i))
           else
             cor(i) = cor(i)
     &          + mask(i) * ((AVG() - res(i)) * cen(i) - cor(i))
           endif
        end do
cdir$ ivdep
        do i = istart + 2, iend + 1, 2
           if (mod(i-istart-1,jdiff) .eq. 0) then
             cor(i) = cor(i)
     &          + mask(i) * ((AVGREDGE() - res(i)) * cen(i) - cor(i))
           else
             cor(i) = cor(i)
     &          + mask(i) * ((AVG() - res(i)) * cen(i) - cor(i))
           endif
        end do
      endif
      end
c-----------------------------------------------------------------------
c sig here contains three different directions all stored on "nodes"
      subroutine hgrlxur(
     & cor, res, sig, cen,
     &     resl0,resh0,resl1,resh1,
     &     regl0,regh0,regl1,regh1,irz)
      integer resl0,resh0,resl1,resh1
      integer regl0,regh0,regl1,regh1
      double precision cor(resl0:resh0,resl1:resh1)
      double precision res(resl0:resh0,resl1:resh1)
      double precision sig(resl0:resh0,resl1:resh1,2)
      double precision cen(resl0:resh0,resl1:resh1)
      double precision AVG
      double precision AVGREDGE
      integer irz
      integer istart, iend
      integer i, j, jdiff, ly, ipar
      AVGREDGE() = (sig(i-1,j,1) * cor(i-1,j) +
     &              sig(i,j,1)   * cor(i+1,j) +
     &              sig(i,j-1,2) * cor(i,j-1) * 0.5d0 +
     &              sig(i,j,2)   * cor(i,j+1) * 0.5d0 )
      AVG() = (sig(i-1,j,1)        * cor(i-1,j) +
     &         sig(i,j,1)          * cor(i+1,j) +
     &         sig(i,j-1,2)        * cor(i,j-1) +
     &         sig(i,j,2)          * cor(i,j+1))
      jdiff =  resh0 - resl0 + 1
      ly    = (resh1 - resl1 + 1) * jdiff
      istart = (regl1 - resl1) * jdiff + (regl0 - resl0)
      iend   = (regh1 - resl1) * jdiff + (regh0 - resl0)
      if (irz .eq. 0 .or. regl0 .gt. 0) then
        ipar = 1
        do j = regl1, regh1
          ipar = 1 - ipar
          do i = regl0 + ipar, regh0, 2
            cor(i,j) = (AVG()-res(i,j))*cen(i,j)
          end do
        end do
        ipar = 0
        do j = regl1, regh1
          ipar = 1 - ipar
          do i = regl0+ipar, regh0, 2
            cor(i,j) = (AVG()-res(i,j))*cen(i,j)
          end do
        end do
      else
c     Now irz = 1 and regl0 = 0, so we are touching the r=0 edge
        ipar = 1
        do j = regl1, regh1
          ipar = 1 - ipar
          do i = regl0 + ipar, regh0, 2
            if (i .eq. 0) then
              cor(i,j) = (AVGREDGE() - res(i,j)) * cen(i,j)
            else
              cor(i,j) = (AVG() - res(i,j)) * cen(i,j)
            endif
          end do
        end do
cdir$ ivdep
        ipar = 0
        do j = regl1, regh1
          ipar = 1 - ipar
          do i = regl0 + ipar, regh0, 2
            if ( i .eq. 0) then
              cor(i,j) = (AVGREDGE() - res(i,j)) * cen(i,j)
            else
              cor(i,j) = (AVG() - res(i,j)) * cen(i,j)
            endif
          end do
        end do
      endif
      end
c 9-point stencil versions:


c 9-point variable density stencils:
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along edge
      subroutine hgfres_full_old(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, idim, idir, irz, imax)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1)
      double precision sigmac(scl0:sch0,scl1:sch1)
      double precision hx, hy
      integer ir, jr, idim, idir, irz, imax
      double precision hxm2, hym2, fac0, fac1, r, rfac,
     &      rfac0, rfac1, tmp
      double precision rfac0m, rfac1m, rfac0p, rfac1p
      integer i, j, is, js, m, n
      if (idim .eq. 0) then
         i = regl0
         if (idir .eq. 1) then
            is = i - 1
         else
            is = i
         end if
         fac0 = ir / (3.d0 * (ir + 1.d0))
         hxm2 = 1.d0 / (ir * ir * hx * hx)
         hym2 = 1.d0 / (jr * jr * hy * hy)
         do j = regl1, regh1
            res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &        (hxm2 *
     &          (sigmac(is,j-1) *
     &            (cdst(i-idir,j-1) - cdst(i,j-1) +
     &             2.d0 * (cdst(i-idir,j) - cdst(i,j))) +
     &           sigmac(is,j) *
     &            (cdst(i-idir,j+1) - cdst(i,j+1) +
     &             2.d0 * (cdst(i-idir,j) - cdst(i,j)))) +
     &         hym2 *
     &          (sigmac(is,j-1) *
     &            (cdst(i-idir,j-1) - cdst(i-idir,j) +
     &             2.d0 * (cdst(i,j-1) - cdst(i,j))) +
     &           sigmac(is,j) *
     &            (cdst(i-idir,j+1) - cdst(i-idir,j) +
     &             2.d0 * (cdst(i,j+1) - cdst(i,j)))))
         end do
         if (irz .eq. 1) then
            r = (is + 0.5d0) * (hx * ir)
            rfac = idir * ir * hx * hym2 / (2.d0 * r)
            do j = regl1, regh1
               res(i*ir,j*jr) = res(i*ir,j*jr) - fac0 *
     &           (rfac * (sigmac(is,j-1) * (cdst(i,j-1) - cdst(i,j)) +
     &                    sigmac(is,j)   * (cdst(i,j+1) - cdst(i,j))))
            end do
         end if
         fac0 = fac0 / (ir * jr * jr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         i = i * ir
         if (idir .eq. 1) then
            is = i
         else
            is = i - 1
         end if
         if (irz .eq. 1) then
            r = (is + 0.5d0) * hx
            rfac = idir * hx * hym2 / (2.d0 * r)
         end if
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5d0 * fac1
            do j = jr*regl1, jr*regh1, jr
               tmp = hxm2 *
     &           (sigmaf(is,j-n-1) *
     &             (fdst(i+idir,j-n-1) - fdst(i,j-n-1) +
     &              2.d0 * (fdst(i+idir,j-n) - fdst(i,j-n))) +
     &              sigmaf(is,j-n) *
     &             (fdst(i+idir,j-n+1) - fdst(i,j-n+1) +
     &              2.d0 * (fdst(i+idir,j-n) - fdst(i,j-n))) +
     &              sigmaf(is,j+n-1) *
     &             (fdst(i+idir,j+n-1) - fdst(i,j+n-1) +
     &              2.d0 * (fdst(i+idir,j+n) - fdst(i,j+n))) +
     &              sigmaf(is,j+n) *
     &             (fdst(i+idir,j+n+1) - fdst(i,j+n+1) +
     &              2.d0 * (fdst(i+idir,j+n) - fdst(i,j+n))))
               res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &             (sigmaf(is,j-n-1) *
     &             (fdst(i+idir,j-n-1) - fdst(i+idir,j-n) +
     &              2.d0 * (fdst(i,j-n-1) - fdst(i,j-n))) +
     &              sigmaf(is,j-n) *
     &             (fdst(i+idir,j-n+1) - fdst(i+idir,j-n) +
     &              2.d0 * (fdst(i,j-n+1) - fdst(i,j-n))) +
     &              sigmaf(is,j+n-1) *
     &             (fdst(i+idir,j+n-1) - fdst(i+idir,j+n) +
     &              2.d0 * (fdst(i,j+n-1) - fdst(i,j+n))) +
     &              sigmaf(is,j+n) *
     &             (fdst(i+idir,j+n+1) - fdst(i+idir,j+n) +
     &              2.d0 * (fdst(i,j+n+1) - fdst(i,j+n)))))
            end do
            if (irz .eq. 1) then
               do j = jr*regl1, jr*regh1, jr
                  res(i,j) = res(i,j) + fac1 *
     &       (rfac * (sigmaf(is,j-n-1) * (fdst(i,j-n-1) - fdst(i,j-n)) +
     &                sigmaf(is,j-n)   * (fdst(i,j-n+1) - fdst(i,j-n)) +
     &                sigmaf(is,j+n-1) * (fdst(i,j+n-1) - fdst(i,j+n)) +
     &                sigmaf(is,j+n)   * (fdst(i,j+n+1) - fdst(i,j+n))))
               end do
            end if
         end do
      else
         j = regl1
         if (idir .eq. 1) then
            js = j - 1
         else
            js = j
         end if
         fac0 = jr / (3.d0 * (jr + 1.d0))
         hxm2 = 1.d0 / (ir * ir * hx * hx)
         hym2 = 1.d0 / (jr * jr * hy * hy)
         do i = regl0, regh0
            res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &        (hxm2 *
     &          (sigmac(i-1,js) *
     &            (cdst(i-1,j-idir) - cdst(i,j-idir) +
     &             2.d0 * (cdst(i-1,j) - cdst(i,j))) +
     &           sigmac(i,js) *
     &            (cdst(i+1,j-idir) - cdst(i,j-idir) +
     &             2.d0 * (cdst(i+1,j) - cdst(i,j)))) +
     &         hym2 *
     &          (sigmac(i-1,js) *
     &            (cdst(i-1,j-idir) - cdst(i-1,j) +
     &             2.d0 * (cdst(i,j-idir) - cdst(i,j))) +
     &           sigmac(i,js) *
     &            (cdst(i+1,j-idir) - cdst(i+1,j) +
     &             2.d0 * (cdst(i,j-idir) - cdst(i,j)))))
            end do
         if (irz .eq. 1 .and. regh0 .lt. imax) then
            do i = regl0, regh0
               r = (i + 0.5d0) * (hx * ir)
               rfac0 = ir * hx * hym2 / (2.d0 * (r - hx * ir))
               rfac1 = ir * hx * hym2 / (2.d0 * r)
               res(i*ir,j*jr) = res(i*ir,j*jr) - fac0 *
     &           (rfac0 * sigmac(i-1,js) - rfac1 * sigmac(i,js)) *
     &           (cdst(i,j-idir) - cdst(i,j))
            end do
         else if (irz .eq. 1) then
c This should only occur with a corner at the outer boundary:
            i = regh0
            r = (i - 0.5d0) * (hx * ir)
            rfac0 = ir * hx * hym2 / (2.d0 * r)
            rfac1 = -rfac0
            res(i*ir,j*jr) = res(i*ir,j*jr) - fac0 *
     &           (rfac0 * sigmac(i-1,js) - rfac1 * sigmac(i,js)) *
     &           (cdst(i,j-idir) - cdst(i,j))
         end if
         fac0 = fac0 / (ir * ir * jr)
         hxm2 = ir * ir * hxm2
         hym2 = jr * jr * hym2
         j = j * jr
         if (idir .eq. 1) then
            js = j
         else
            js = j - 1
         end if
         do m = 0, ir-1
            fac1 = (ir-m) * fac0
            if (m .eq. 0) fac1 = 0.5d0 * fac1
            do i = ir*regl0, ir*regh0, ir
               tmp = hxm2 *
     &             (sigmaf(i-m-1,js) *
     &             (fdst(i-m-1,j+idir) - fdst(i-m,j+idir) +
     &              2.d0 * (fdst(i-m-1,j) - fdst(i-m,j))) +
     &              sigmaf(i-m,js) *
     &             (fdst(i-m+1,j+idir) - fdst(i-m,j+idir) +
     &              2.d0 * (fdst(i-m+1,j) - fdst(i-m,j))) +
     &              sigmaf(i+m-1,js) *
     &             (fdst(i+m-1,j+idir) - fdst(i+m,j+idir) +
     &              2.d0 * (fdst(i+m-1,j) - fdst(i+m,j))) +
     &              sigmaf(i+m,js) *
     &             (fdst(i+m+1,j+idir) - fdst(i+m,j+idir) +
     &              2.d0 * (fdst(i+m+1,j) - fdst(i+m,j))))
               res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &           (sigmaf(i-m-1,js) *
     &             (fdst(i-m-1,j+idir) - fdst(i-m-1,j) +
     &              2.d0 * (fdst(i-m,j+idir) - fdst(i-m,j))) +
     &              sigmaf(i-m,js) *
     &             (fdst(i-m+1,j+idir) - fdst(i-m+1,j) +
     &              2.d0 * (fdst(i-m,j+idir) - fdst(i-m,j))) +
     &              sigmaf(i+m-1,js) *
     &             (fdst(i+m-1,j+idir) - fdst(i+m-1,j) +
     &              2.d0 * (fdst(i+m,j+idir) - fdst(i+m,j))) +
     &              sigmaf(i+m,js) *
     &             (fdst(i+m+1,j+idir) - fdst(i+m+1,j) +
     &              2.d0 * (fdst(i+m,j+idir) - fdst(i+m,j)))))
            end do
            if (irz .eq. 1 .and. regh0 .lt. imax) then
               do i = ir*regl0, ir*regh0, ir
                  r = (i + 0.5d0) * hx
                  rfac0m = hx * hym2 / (2.d0 * (r - (m + 1) * hx))
                  rfac1m = hx * hym2 / (2.d0 * (r - m * hx))
                  rfac0p = hx * hym2 / (2.d0 * (r + (m - 1) * hx))
                  rfac1p = hx * hym2 / (2.d0 * (r + m * hx))
                  res(i,j) = res(i,j) - fac1 *
     &          ((rfac0m * sigmaf(i-m-1,js) - rfac1m * sigmaf(i-m,js)) *
     &           (fdst(i-m,j+idir) - fdst(i-m,j)) +
     &           (rfac0p * sigmaf(i+m-1,js) - rfac1p * sigmaf(i+m,js)) *
     &           (fdst(i+m,j+idir) - fdst(i+m,j)))
               end do
            else if (irz .eq. 1) then
c This should only occur with a corner at the outer boundary:
               i = ir * regh0
               r = (i + 0.5d0) * hx
               rfac0m = hx * hym2 / (2.d0 * (r - (m + 1) * hx))
               if (m .eq. 0) then
                  rfac1m = -rfac0m
               else
                  rfac1m = hx * hym2 / (2.d0 * (r - m * hx))
               end if
               rfac0p = -rfac1m
               rfac1p = -rfac0m
               res(i,j) = res(i,j) - fac1 *
     &          ((rfac0m * sigmaf(i-m-1,js) - rfac1m * sigmaf(i-m,js)) *
     &           (fdst(i-m,j+idir) - fdst(i-m,j)) +
     &           (rfac0p * sigmaf(i+m-1,js) - rfac1p * sigmaf(i+m,js)) *
     &           (fdst(i+m,j+idir) - fdst(i+m,j)))
            end if
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along edge
      subroutine hgores_full_old(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, idir, jdir, irz, idd)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1)
      double precision sigmac(scl0:sch0,scl1:sch1)
      double precision hx, hy
      integer ir, jr, idir, jdir, irz, idd
      double precision hxm2, hym2, fac0, fac1, r, rfac,
     &      rfac0, rfac1, tmp
      double precision rfac0p, rfac1p
      integer i, j, is, js, m, n
      i = regl0
      j = regl1
      if (idir .eq. 1) then
         is = i - 1
      else
         is = i
      end if
      if (jdir .eq. 1) then
         js = j - 1
      else
         js = j
      end if
      hxm2 = 1.d0 / (ir * ir * hx * hx)
      hym2 = 1.d0 / (jr * jr * hy * hy)
      fac0 = (ir * jr) / (4.5d0*ir*jr + 1.5d0*ir + 1.5d0*jr - 1.5d0)
      res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &  (hxm2 * (sigmac(is,js+jdir) *
     &            (cdst(i-idir,j+jdir) - cdst(i,j+jdir) +
     &             2.d0 * (cdst(i-idir,j) - cdst(i,j))) +
     &           sigmac(is,js) *
     &            (cdst(i-idir,j-jdir) - cdst(i,j-jdir) +
     &             2.d0 * (cdst(i-idir,j) - cdst(i,j))) +
     &           sigmac(is+idir,js) *
     &            (cdst(i+idir,j-jdir) - cdst(i,j-jdir) +
     &             2.d0 * (cdst(i+idir,j) - cdst(i,j)))) +
     &   hym2 * (sigmac(is,js+jdir) *
     &            (cdst(i-idir,j+jdir) - cdst(i-idir,j) +
     &             2.d0 * (cdst(i,j+jdir) - cdst(i,j))) +
     &           sigmac(is,js) *
     &            (cdst(i-idir,j-jdir) - cdst(i-idir,j) +
     &             2.d0 * (cdst(i,j-jdir) - cdst(i,j))) +
     &           sigmac(is+idir,js) *
     &            (cdst(i+idir,j-jdir) - cdst(i+idir,j) +
     &             2.d0 * (cdst(i,j-jdir) - cdst(i,j)))))
      if (irz .eq. 1) then
         r = (is + 0.5d0) * (hx * ir)
         rfac0 = ir * hx * hym2 / (2.d0 * (r + idir * hx * ir))
         rfac1 = ir * hx * hym2 / (2.d0 * r)
         res(i*ir,j*jr) = res(i*ir,j*jr) + idir * fac0 *
     &     ((rfac0 * sigmac(is+idir,js) - rfac1 * sigmac(is,js)) *
     &      (cdst(i,j-jdir) - cdst(i,j)) -
     &      rfac1 * sigmac(is,js+jdir) * (cdst(i,j+jdir) - cdst(i,j)))
      end if
      fac0 = fac0 / (ir * jr)
      hxm2 = ir * ir * hxm2
      hym2 = jr * jr * hym2
      i = i * ir
      j = j * jr
      if (idir .eq. 1) then
         is = i
      else
         is = i - 1
      end if
      if (jdir .eq. 1) then
         js = j
      else
         js = j - 1
      end if
      res(i,j) = res(i,j) - fac0 * sigmaf(is,js) *
     &  (hxm2 * (fdst(i+idir,j+jdir) - fdst(i,j+jdir) +
     &           2.d0 * (fdst(i+idir,j) - fdst(i,j))) +
     &   hym2 * (fdst(i+idir,j+jdir) - fdst(i+idir,j) +
     &           2.d0 * (fdst(i,j+jdir) - fdst(i,j))))
      if (irz .eq. 1) then
         r = (is + 0.5d0) * hx
         rfac = hx * hym2 / (2.d0 * r)
         res(i,j) = res(i,j) + idir * fac0 *
     &      rfac * sigmaf(is,js) * (fdst(i,j+jdir) - fdst(i,j))
      end if
      fac0 = fac0 / ir
      do m = idir, idir*(ir-1), idir
         fac1 = (ir-abs(m)) * fac0
         tmp = hxm2 *
     &     (sigmaf(i+m-1,js) *
     &       (fdst(i+m-1,j+jdir) - fdst(i+m,j+jdir) +
     &        2.d0 * (fdst(i+m-1,j) - fdst(i+m,j))) +
     &      sigmaf(i+m,js) *
     &       (fdst(i+m+1,j+jdir) - fdst(i+m,j+jdir) +
     &        2.d0 * (fdst(i+m+1,j) - fdst(i+m,j))))
         res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &     (sigmaf(i+m-1,js) *
     &       (fdst(i+m-1,j+jdir) - fdst(i+m-1,j) +
     &        2.d0 * (fdst(i+m,j+jdir) - fdst(i+m,j))) +
     &          sigmaf(i+m,js) *
     &       (fdst(i+m+1,j+jdir) - fdst(i+m+1,j) +
     &        2.d0 * (fdst(i+m,j+jdir) - fdst(i+m,j)))))
         if (irz .eq. 1) then
            r = (i + m + 0.5d0) * hx
            rfac0p = hx * hym2 / (2.d0 * (r - hx))
            rfac1p = hx * hym2 / (2.d0 * r)
            res(i,j) = res(i,j) - fac1 *
     &         (rfac0p * sigmaf(i+m-1,js) - rfac1p * sigmaf(i+m,js)) *
     &          (fdst(i+m,j+jdir) - fdst(i+m,j))
         end if
      end do
      fac0 = ir * fac0 / jr
      do n = jdir, jdir*(jr-1), jdir
         fac1 = (jr-abs(n)) * fac0
         tmp = hxm2 *
     &     (sigmaf(is,j+n-1) *
     &       (fdst(i+idir,j+n-1) - fdst(i,j+n-1) +
     &        2.d0 * (fdst(i+idir,j+n) - fdst(i,j+n))) +
     &      sigmaf(is,j+n) *
     &       (fdst(i+idir,j+n+1) - fdst(i,j+n+1) +
     &        2.d0 * (fdst(i+idir,j+n) - fdst(i,j+n))))
         res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &     (sigmaf(is,j+n-1) *
     &       (fdst(i+idir,j+n-1) - fdst(i+idir,j+n) +
     &        2.d0 * (fdst(i,j+n-1) - fdst(i,j+n))) +
     &          sigmaf(is,j+n) *
     &       (fdst(i+idir,j+n+1) - fdst(i+idir,j+n) +
     &        2.d0 * (fdst(i,j+n+1) - fdst(i,j+n)))))
         if (irz .eq. 1) then
            r = (is + 0.5d0) * hx
            rfac1 = -idir * hx * hym2 / (2.d0 * r)
            res(i,j) = res(i,j) - fac1 *
     &        rfac1 *(sigmaf(is,j+n-1) * (fdst(i,j+n-1) - fdst(i,j+n)) +
     &                sigmaf(is,j+n)   * (fdst(i,j+n+1) - fdst(i,j+n)))
         end if
      end do
      end
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along edge
      subroutine hgires_full_old(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, idir, jdir, irz, idd)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1)
      double precision sigmac(scl0:sch0,scl1:sch1)
      double precision hx, hy
      integer ir, jr, idir, jdir, irz, idd
      double precision hxm2, hym2, fac0, fac1, r, rfac,
     &            rfac0, rfac1, tmp
      double precision rfac0m, rfac1m
      integer i, j, is, js, m, n
      i = regl0
      j = regl1
      if (idir .eq. 1) then
         is = i - 1
      else
         is = i
      end if
      if (jdir .eq. 1) then
         js = j - 1
      else
         js = j
      end if
      hxm2 = 1.d0 / (ir * ir * hx * hx)
      hym2 = 1.d0 / (jr * jr * hy * hy)
      fac0 = (ir * jr) / (1.5d0*ir*jr + 1.5d0*ir + 1.5d0*jr + 1.5d0)
      res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 * sigmac(is,js) *
     &  (hxm2 * (cdst(i-idir,j-jdir) - cdst(i,j-jdir) +
     &           2.d0 * (cdst(i-idir,j) - cdst(i,j))) +
     &   hym2 * (cdst(i-idir,j-jdir) - cdst(i-idir,j) +
     &           2.d0 * (cdst(i,j-jdir) - cdst(i,j))))
      if (irz .eq. 1) then
         r = (is + 0.5d0) * (hx * ir)
         rfac = ir * hx * hym2 / (2.d0 * r)
         res(i*ir,j*jr) = res(i*ir,j*jr) - idir * fac0 *
     &     rfac * sigmac(is,js) * (cdst(i,j-jdir) - cdst(i,j))
      end if
      fac0 = fac0 / (ir * jr)
      hxm2 = ir * ir * hxm2
      hym2 = jr * jr * hym2
      i = i * ir
      j = j * jr
      if (idir .eq. 1) then
         is = i
      else
         is = i - 1
      end if
      if (jdir .eq. 1) then
         js = j
      else
         js = j - 1
      end if
      res(i,j) = res(i,j) - fac0 *
     &  (hxm2 * (sigmaf(is,js-jdir) *
     &            (fdst(i+idir,j-jdir) - fdst(i,j-jdir) +
     &             2.d0 * (fdst(i+idir,j) - fdst(i,j))) +
     &           sigmaf(is,js) *
     &            (fdst(i+idir,j+jdir) - fdst(i,j+jdir) +
     &             2.d0 * (fdst(i+idir,j) - fdst(i,j))) +
     &           sigmaf(is-idir,js) *
     &            (fdst(i-idir,j+jdir) - fdst(i,j+jdir) +
     &             2.d0 * (fdst(i-idir,j) - fdst(i,j)))) +
     &   hym2 * (sigmaf(is,js-jdir) *
     &            (fdst(i+idir,j-jdir) - fdst(i+idir,j) +
     &             2.d0 * (fdst(i,j-jdir) - fdst(i,j))) +
     &           sigmaf(is,js) *
     &            (fdst(i+idir,j+jdir) - fdst(i+idir,j) +
     &             2.d0 * (fdst(i,j+jdir) - fdst(i,j))) +
     &           sigmaf(is-idir,js) *
     &            (fdst(i-idir,j+jdir) - fdst(i-idir,j) +
     &             2.d0 * (fdst(i,j+jdir) - fdst(i,j)))))
      if (irz .eq. 1) then
         r = (is + 0.5d0) * hx
         rfac0 = hx * hym2 / (2.d0 * (r - idir * hx))
         rfac1 = hx * hym2 / (2.d0 * r)
         res(i,j) = res(i,j) - idir * fac0 *
     &     ((rfac0 * sigmaf(is-idir,js) - rfac1 * sigmaf(is,js)) *
     &      (fdst(i,j+jdir) - fdst(i,j)) -
     &      rfac1 * sigmaf(is,js-jdir) * (fdst(i,j-jdir) - fdst(i,j)))
      end if
      fac0 = fac0 / ir
      do m = idir, idir*(ir-1), idir
         fac1 = (ir-abs(m)) * fac0
         tmp = hxm2 *
     &     (sigmaf(i-m-1,js) *
     &       (fdst(i-m-1,j+jdir) - fdst(i-m,j+jdir) +
     &        2.d0 * (fdst(i-m-1,j) - fdst(i-m,j))) +
     &      sigmaf(i-m,js) *
     &       (fdst(i-m+1,j+jdir) - fdst(i-m,j+jdir) +
     &        2.d0 * (fdst(i-m+1,j) - fdst(i-m,j))))
         res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &     (sigmaf(i-m-1,js) *
     &       (fdst(i-m-1,j+jdir) - fdst(i-m-1,j) +
     &        2.d0 * (fdst(i-m,j+jdir) - fdst(i-m,j))) +
     &          sigmaf(i-m,js) *
     &       (fdst(i-m+1,j+jdir) - fdst(i-m+1,j) +
     &        2.d0 * (fdst(i-m,j+jdir) - fdst(i-m,j)))))
         if (irz .eq. 1) then
            r = (i - m + 0.5d0) * hx
            rfac0m = hx * hym2 / (2.d0 * (r - hx))
            rfac1m = hx * hym2 / (2.d0 * r)
            res(i,j) = res(i,j) - fac1 *
     &         (rfac0m * sigmaf(i-m-1,js) - rfac1m * sigmaf(i-m,js)) *
     &          (fdst(i-m,j+jdir) - fdst(i-m,j))
         end if
      end do
      fac0 = ir * fac0 / jr
      do n = jdir, jdir*(jr-1), jdir
         fac1 = (jr-abs(n)) * fac0
         tmp = hxm2 *
     &     (sigmaf(is,j-n-1) *
     &       (fdst(i+idir,j-n-1) - fdst(i,j-n-1) +
     &        2.d0 * (fdst(i+idir,j-n) - fdst(i,j-n))) +
     &      sigmaf(is,j-n) *
     &       (fdst(i+idir,j-n+1) - fdst(i,j-n+1) +
     &        2.d0 * (fdst(i+idir,j-n) - fdst(i,j-n))))
         res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &     (sigmaf(is,j-n-1) *
     &       (fdst(i+idir,j-n-1) - fdst(i+idir,j-n) +
     &        2.d0 * (fdst(i,j-n-1) - fdst(i,j-n))) +
     &          sigmaf(is,j-n) *
     &       (fdst(i+idir,j-n+1) - fdst(i+idir,j-n) +
     &        2.d0 * (fdst(i,j-n+1) - fdst(i,j-n)))))
         if (irz .eq. 1) then
            r = (is + 0.5d0) * hx
            rfac1 = -idir * hx * hym2 / (2.d0 * r)
            res(i,j) = res(i,j) - fac1 *
     &        rfac1 *(sigmaf(is,j-n-1) * (fdst(i,j-n-1) - fdst(i,j-n)) +
     &                sigmaf(is,j-n)   * (fdst(i,j-n+1) - fdst(i,j-n)))
         end if
      end do
      end
c-----------------------------------------------------------------------
c Note---assumes fdst linearly interpolated from cdst along edge
      subroutine hgdres_full_old(
     & res,   resl0, resh0, resl1, resh1,
     & src,   srcl0, srch0, srcl1, srch1,
     & fdst,  fdstl0, fdsth0, fdstl1, fdsth1,
     & cdst,  cdstl0, cdsth0, cdstl1, cdsth1,
     & sigmaf, sfl0, sfh0, sfl1, sfh1,
     & sigmac, scl0, sch0, scl1, sch1,
     &        regl0, regh0, regl1, regh1,
     & hx, hy, ir, jr, jdir, idd, irz, idd1)
      integer resl0, resh0, resl1, resh1
      integer srcl0, srch0, srcl1, srch1
      integer fdstl0, fdsth0, fdstl1, fdsth1
      integer cdstl0, cdsth0, cdstl1, cdsth1
      integer sfl0, sfh0, sfl1, sfh1
      integer scl0, sch0, scl1, sch1
      integer regl0, regh0, regl1, regh1
      double precision res(resl0:resh0,resl1:resh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      double precision fdst(fdstl0:fdsth0,fdstl1:fdsth1)
      double precision cdst(cdstl0:cdsth0,cdstl1:cdsth1)
      double precision sigmaf(sfl0:sfh0,sfl1:sfh1)
      double precision sigmac(scl0:sch0,scl1:sch1)
      double precision hx, hy
      integer ir, jr, jdir, irz, idd, idd1
      double precision hxm2, hym2, fac0, fac1, r, rfac0, rfac1, tmp
      double precision rfac0m, rfac1m, rfac0p, rfac1p
      integer i, j, js, m, n
      i = regl0
      j = regl1
      if (jdir .eq. 1) then
         js = j
      else
         js = j - 1
      end if
      hxm2 = 1.d0 / (ir * ir * hx * hx)
      hym2 = 1.d0 / (jr * jr * hy * hy)
      fac0 = (ir * jr) / (3.d0*ir*jr + 3.d0*ir + 3.d0*jr - 3.d0)
      res(i*ir,j*jr) = src(i*ir,j*jr) - fac0 *
     &  (hxm2 * (sigmac(i,js-jdir) *
     &            (cdst(i+1,j-jdir) - cdst(i,j-jdir) +
     &             2.d0 * (cdst(i+1,j) - cdst(i,j))) +
     &           sigmac(i-1,js) *
     &            (cdst(i-1,j+jdir) - cdst(i,j+jdir) +
     &             2.d0 * (cdst(i-1,j) - cdst(i,j)))) +
     &   hym2 * (sigmac(i,js-jdir) *
     &            (cdst(i+1,j-jdir) - cdst(i+1,j) +
     &             2.d0 * (cdst(i,j-jdir) - cdst(i,j))) +
     &           sigmac(i-1,js) *
     &            (cdst(i-1,j+jdir) - cdst(i-1,j) +
     &             2.d0 * (cdst(i,j+jdir) - cdst(i,j)))))
      if (irz .eq. 1) then
         r = (i + 0.5d0) * (hx * ir)
         rfac0 = ir * hx * hym2 / (2.d0 * (r - hx * ir))
         rfac1 = ir * hx * hym2 / (2.d0 * r)
         res(i*ir,j*jr) = res(i*ir,j*jr) - fac0 *
     &     (rfac0 * sigmac(i-1,js)    * (cdst(i,j+jdir) - cdst(i,j)) -
     &      rfac1 * sigmac(i,js-jdir) * (cdst(i,j-jdir) - cdst(i,j)))
      end if
      fac0 = fac0 / (ir * jr)
      hxm2 = ir * ir * hxm2
      hym2 = jr * jr * hym2
      i = i * ir
      j = j * jr
      if (jdir .eq. 1) then
         js = j
      else
         js = j - 1
      end if
      res(i,j) = res(i,j) - fac0 *
     &  (hxm2 * (sigmaf(i,js) *
     &            (fdst(i+1,j+jdir) - fdst(i,j+jdir) +
     &             2.d0 * (fdst(i+1,j) - fdst(i,j))) +
     &           sigmaf(i-1,js-jdir) *
     &            (fdst(i-1,j-jdir) - fdst(i,j-jdir) +
     &             2.d0 * (fdst(i-1,j) - fdst(i,j)))) +
     &   hym2 * (sigmaf(i,js) *
     &            (fdst(i+1,j+jdir) - fdst(i+1,j) +
     &             2.d0 * (fdst(i,j+jdir) - fdst(i,j))) +
     &           sigmaf(i-1,js-jdir) *
     &            (fdst(i-1,j-jdir) - fdst(i-1,j) +
     &             2.d0 * (fdst(i,j-jdir) - fdst(i,j)))))
      if (irz .eq. 1) then
         r = (i + 0.5d0) * hx
         rfac0 = hx * hym2 / (2.d0 * (r - hx))
         rfac1 = hx * hym2 / (2.d0 * r)
         res(i,j) = res(i,j) - fac0 *
     &     (rfac0 * sigmaf(i-1,js-jdir) * (fdst(i,j-jdir) - fdst(i,j)) -
     &      rfac1 * sigmaf(i,js)        * (fdst(i,j+jdir) - fdst(i,j)))
      end if
      fac0 = fac0 / ir
      do m = 1, ir-1
         fac1 = (ir-m) * fac0
         tmp = hxm2 *
     &     (sigmaf(i+m-1,js) *
     &       (fdst(i+m-1,j+jdir) - fdst(i+m,j+jdir) +
     &        2.d0 * (fdst(i+m-1,j) - fdst(i+m,j))) +
     &      sigmaf(i+m,js) *
     &       (fdst(i+m+1,j+jdir) - fdst(i+m,j+jdir) +
     &        2.d0 * (fdst(i+m+1,j) - fdst(i+m,j))) +
     &      sigmaf(i-m-1,js-jdir) *
     &       (fdst(i-m-1,j-jdir) - fdst(i-m,j-jdir) +
     &        2.d0 * (fdst(i-m-1,j) - fdst(i-m,j))) +
     &      sigmaf(i-m,js-jdir) *
     &       (fdst(i-m+1,j-jdir) - fdst(i-m,j-jdir) +
     &        2.d0 * (fdst(i-m+1,j) - fdst(i-m,j))))
         res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &     (sigmaf(i+m-1,js) *
     &       (fdst(i+m-1,j+jdir) - fdst(i+m-1,j) +
     &        2.d0 * (fdst(i+m,j+jdir) - fdst(i+m,j))) +
     &      sigmaf(i+m,js) *
     &       (fdst(i+m+1,j+jdir) - fdst(i+m+1,j) +
     &        2.d0 * (fdst(i+m,j+jdir) - fdst(i+m,j))) +
     &      sigmaf(i-m-1,js-jdir) *
     &       (fdst(i-m-1,j-jdir) - fdst(i-m-1,j) +
     &        2.d0 * (fdst(i-m,j-jdir) - fdst(i-m,j))) +
     &      sigmaf(i-m,js-jdir) *
     &       (fdst(i-m+1,j-jdir) - fdst(i-m+1,j) +
     &        2.d0 * (fdst(i-m,j-jdir) - fdst(i-m,j)))))
         if (irz .eq. 1) then
            r = (i - m + 0.5d0) * hx
            rfac0m = hx * hym2 / (2.d0 * (r - hx))
            rfac1m = hx * hym2 / (2.d0 * r)
            r = (i + m + 0.5d0) * hx
            rfac0p = hx * hym2 / (2.d0 * (r - hx))
            rfac1p = hx * hym2 / (2.d0 * r)
            res(i,j) = res(i,j) - fac1 *
     &       ((rfac0m * sigmaf(i-m-1,js-jdir)
     &                  - rfac1m * sigmaf(i-m,js-jdir)) *
     &         (fdst(i-m,j-jdir) - fdst(i-m,j)) +
     &        (rfac0p * sigmaf(i+m-1,js) - rfac1p * sigmaf(i+m,js)) *
     &          (fdst(i+m,j+jdir) - fdst(i+m,j)))
         end if
      end do
      fac0 = ir * fac0 / jr
      do n = jdir, jdir*(jr-1), jdir
         fac1 = (jr-abs(n)) * fac0
         tmp = hxm2 *
     &     (sigmaf(i,j+n-1) *
     &       (fdst(i+1,j+n-1) - fdst(i,j+n-1) +
     &        2.d0 * (fdst(i+1,j+n) - fdst(i,j+n))) +
     &      sigmaf(i,j+n) *
     &       (fdst(i+1,j+n+1) - fdst(i,j+n+1) +
     &        2.d0 * (fdst(i+1,j+n) - fdst(i,j+n))) +
     &      sigmaf(i-1,j-n-1) *
     &       (fdst(i-1,j-n-1) - fdst(i,j-n-1) +
     &        2.d0 * (fdst(i-1,j-n) - fdst(i,j-n))) +
     &      sigmaf(i-1,j-n) *
     &       (fdst(i-1,j-n+1) - fdst(i,j-n+1) +
     &        2.d0 * (fdst(i-1,j-n) - fdst(i,j-n))))
         res(i,j) = res(i,j) - fac1 * (tmp + hym2 *
     &     (sigmaf(i,j+n-1) *
     &       (fdst(i+1,j+n-1) - fdst(i+1,j+n) +
     &        2.d0 * (fdst(i,j+n-1) - fdst(i,j+n))) +
     &      sigmaf(i,j+n) *
     &       (fdst(i+1,j+n+1) - fdst(i+1,j+n) +
     &        2.d0 * (fdst(i,j+n+1) - fdst(i,j+n))) +
     &      sigmaf(i-1,j-n-1) *
     &       (fdst(i-1,j-n-1) - fdst(i-1,j-n) +
     &        2.d0 * (fdst(i,j-n-1) - fdst(i,j-n))) +
     &      sigmaf(i-1,j-n) *
     &       (fdst(i-1,j-n+1) - fdst(i-1,j-n) +
     &        2.d0 * (fdst(i,j-n+1) - fdst(i,j-n)))))
         if (irz .eq. 1) then
            r = (i + 0.5d0) * hx
            rfac0 = hx * hym2 / (2.d0 * (r - hx))
            rfac1 = hx * hym2 / (2.d0 * r)
            res(i,j) = res(i,j) - fac1 *
     &       (rfac0 * (sigmaf(i-1,j-n-1) *
     &                     (fdst(i,j-n-1) - fdst(i,j-n)) +
     &                 sigmaf(i-1,j-n)   *
     &                        (fdst(i,j-n+1) - fdst(i,j-n))) -
     &        rfac1 * (sigmaf(i,j+n-1) * (fdst(i,j+n-1) - fdst(i,j+n)) +
     &                 sigmaf(i,j+n)   * (fdst(i,j+n+1) - fdst(i,j+n))))
         end if
      end do
      end
c-----------------------------------------------------------------------
c NODE-based data, factor of 2 only.
      subroutine hgints_dense(
     & dest, destl0, desth0, destl1, desth1,
     &       regl0, regh0, regl1, regh1,
     & sigx, sigy,
     &       sbl0, sbh0, sbl1, sbh1,
     & src,  srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & ir, jr)
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer sbl0, sbh0, sbl1, sbh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer ir, jr
      double precision dest(destl0:desth0,destl1:desth1)
      double precision sigx(sbl0:sbh0,sbl1:sbh1)
      double precision sigy(sbl0:sbh0,sbl1:sbh1)
      double precision src(srcl0:srch0,srcl1:srch1)
      integer i, j, ic, jc
      do jc = bbl1, bbh1
         do ic = bbl0, bbh0
            dest(ir*ic,jr*jc) = src(ic,jc)
         end do
      end do
      if (ir .eq. 2) then
         do jc = bbl1, bbh1
            do ic = bbl0, bbh0-1
               i = ir * ic
               j = jr * jc
               dest(i+1,j) =
     &           ((sigx(i,j-1)+sigx(i,j)) * src(ic,jc) +
     &            (sigx(i+1,j-1)+sigx(i+1,j)) * src(ic+1,jc)) /
     &           (sigx(i,j-1)+sigx(i,j)+
     &            sigx(i+1,j-1)+sigx(i+1,j))
            end do
         end do
      end if
      if (jr .eq. 2) then
         do jc = bbl1, bbh1-1
            do ic = bbl0, bbh0
               i = ir * ic
               j = jr * jc
               dest(i,j+1) =
     &           ((sigy(i-1,j)+sigy(i,j)) * src(ic,jc) +
     &            (sigy(i-1,j+1)+sigy(i,j+1)) * src(ic,jc+1)) /
     &           (sigy(i-1,j)+sigy(i,j)+
     &            sigy(i-1,j+1)+sigy(i,j+1))
            end do
         end do
      end if
      if (ir .eq. 2 .and. jr .eq. 2) then
         do jc = bbl1, bbh1-1
cdir$ ivdep
            do ic = bbl0, bbh0-1
               i = ir * ic
               j = jr * jc
               dest(i+1,j+1) = ((sigx(i,j) + sigx(i,j+1)) *
     &                            dest(i,j+1) +
     &                          (sigx(i+1,j) + sigx(i+1,j+1)) *
     &                            dest(i+2,j+1) +
     &                          (sigy(i,j) + sigy(i+1,j)) *
     &                            dest(i+1,j) +
     &                          (sigy(i,j+1) + sigy(i+1,j+1)) *
     &                            dest(i+1,j+2)) /
     &                         (sigx(i,j) + sigx(i,j+1) +
     &                          sigx(i+1,j) + sigx(i+1,j+1) +
     &                          sigy(i,j) + sigy(i+1,j) +
     &                          sigy(i,j+1) + sigy(i+1,j+1))
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c NODE-based data, factor of 2 only.
      subroutine hgints(
     & dest,  destl0,desth0,destl1,desth1,
     &        regl0,regh0,regl1,regh1,
     & signd, snl0,snh0,snl1,snh1,
     & src,   srcl0,srch0,srcl1,srch1,
     &        bbl0,bbh0,bbl1,bbh1,
     & ir, jr)
      integer destl0,desth0,destl1,desth1
      integer regl0,regh0,regl1,regh1
      integer snl0,snh0,snl1,snh1
      integer srcl0,srch0,srcl1,srch1
      integer bbl0,bbh0,bbl1,bbh1
      integer ir, jr
      double precision dest(destl0:desth0,destl1:desth1)
      double precision signd(snl0:snh0,snl1:snh1, 2)
      double precision src(srcl0:srch0,srcl1:srch1)
      integer i, j, ic, jc
      do jc = bbl1, bbh1
         do ic = bbl0, bbh0
            dest(ir*ic,jr*jc) = src(ic,jc)
         end do
      end do
      if (ir .eq. 2) then
         do jc = bbl1, bbh1
            do ic = bbl0, bbh0-1
               i = ir * ic
               j = jr * jc
               dest(i+1,j) = (signd(i,j,1)  * src(ic,jc) +
     &                        signd(i+1,j,1) * src(ic+1,jc)) /
     &                       (signd(i,j,1) + signd(i+1,j,1))
            end do
         end do
      end if
      if (jr .eq. 2) then
         do jc = bbl1, bbh1-1
            do ic = bbl0, bbh0
               i = ir * ic
               j = jr * jc
               dest(i,j+1) = (signd(i,j,2)  * src(ic,jc) +
     &                        signd(i,j+1,2) * src(ic,jc+1)) /
     &                       (signd(i,j,2) + signd(i,j+1,2))
            end do
         end do
      end if
      if (ir .eq. 2 .and. jr .eq. 2) then
         do jc = bbl1, bbh1-1
cdir$ ivdep
            do ic = bbl0, bbh0-1
               i = ir * ic
               j = jr * jc
               dest(i+1,j+1) = (signd(i,j+1,1)   * dest(i,j+1) +
     &                          signd(i+1,j+1,1) * dest(i+2,j+1) +
     &                          signd(i+1,j,2)   * dest(i+1,j) +
     &                          signd(i+1,j+1,2) * dest(i+1,j+2)) /
     &                         (signd(i,j+1,1) + signd(i+1,j+1,1) +
     &                          signd(i+1,j,2) + signd(i+1,j+1,2))
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c NODE-based data, factor of 2 only.
      subroutine hgints_old(
     & dest, destl0, desth0, destl1, desth1,
     &       regl0, regh0, regl1, regh1,
     & signd, sbl0, sbh0, sbl1, sbh1,
     & src,   srcl0, srch0, srcl1, srch1,
     &        bbl0, bbh0, bbl1, bbh1,
     & ir, jr)
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer sbl0, sbh0, sbl1, sbh1
      integer srcl0, srch0, srcl1, srch1
      integer bbl0, bbh0, bbl1, bbh1
      integer ir, jr
      double precision dest(destl0:desth0,destl1:desth1)
      double precision signd(sbl0:sbh0,sbl1:sbh1, 2)
      double precision src(srcl0:srch0,srcl1:srch1)
      stop 'no code for hgints (sigma node) in 2D'
      end

c-----------------------------------------------------------------------
c CELL-based data only.
      subroutine hgsrst(
     & destx, desty,
     &     destl0, desth0, destl1, desth1,
     &     regl0, regh0, regl1, regh1,
     & srcx, srcy,
     &     srcl0, srch0, srcl1, srch1,
     & ir, jr)
      integer destl0, desth0, destl1, desth1
      integer regl0, regh0, regl1, regh1
      integer srcl0, srch0, srcl1, srch1
      integer ir, jr
      double precision destx(destl0:desth0,destl1:desth1)
      double precision desty(destl0:desth0,destl1:desth1)
      double precision srcx(srcl0:srch0,srcl1:srch1)
      double precision srcy(srcl0:srch0,srcl1:srch1)
      integer i, j, i2, j2
      if (ir .eq. 2 .and. jr .eq. 2) then
         do j = regl1, regh1
            do i = regl0, regh0
               i2 = 2 * i
               j2 = 2 * j
               destx(i,j) = 1.d0 /
     &                      (1.d0 / (srcx(i2,j2)   + srcx(i2,j2+1)) +
     &                       1.d0 / (srcx(i2+1,j2) + srcx(i2+1,j2+1)))
               desty(i,j) = 1.d0 /
     &                      (1.d0 / (srcy(i2,j2)   + srcy(i2+1,j2)) +
     &                       1.d0 / (srcy(i2,j2+1) + srcy(i2+1,j2+1)))
            end do
         end do
      else if (ir .eq. 2) then
         do j = regl1, regh1
            do i = regl0, regh0
               i2 = 2 * i
               destx(i,j) = 2.d0 /
     &                      (1.d0 / srcx(i2,j) + 1.d0 / srcx(i2+1,j))
               desty(i,j) = 0.5d0 * (srcy(i2,j) + srcy(i2+1,j))
            end do
         end do
      else
         do j = regl1, regh1
            do i = regl0, regh0
               j2 = 2 * j
               destx(i,j) = 0.5d0 * (srcx(i,j2) + srcx(i,j2+1))
               desty(i,j) = 2.d0 /
     &                      (1.d0 / srcy(i,j2) + 1.d0 / srcy(i,j2+1))
            end do
         end do
      end if
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3

c *************************************************************************
c ** SETVELBC **
c ** Impose the physical boundary conditions on the velocity (u,v)
c *************************************************************************

      subroutine setvelbc(u,v,w,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,bcz_lo,bcz_hi,
     $                    visc_coef,dx,time)

      implicit none

      integer DIMS
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      REAL_T     w(lo_1-1:hi_1+1,lo_2-1:hi_2+1,lo_3-1:hi_3+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer bcz_lo,bcz_hi
      REAL_T visc_coef
      REAL_T dx(3)
      REAL_T time

c     Local variables
      integer is,ie,js,je,ks,ke,i,j,k

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      if (bcz_lo .eq. PERIODIC) then

        do j = js,je 
        do i = is,ie 
          u(i,j,ks-1) = u(i,j,ke)
          v(i,j,ks-1) = v(i,j,ke)
          w(i,j,ks-1) = w(i,j,ke)
        enddo
        enddo

      elseif (bcz_lo .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do j = js,je 
        do i = is,ie 
          w(i,j,ks-1) = zero
          u(i,j,ks-1) = (fifteen*u(i,j,ks  ) - ten*u(i,j,ks+1) + 
     $                     three*u(i,j,ks+2)) / eight
          v(i,j,ks-1) = (fifteen*v(i,j,ks  ) - ten*v(i,j,ks+1) + 
     $                     three*v(i,j,ks+2)) / eight
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do j = js,je 
          do i = is,ie 
            u(i,j,ks-1) = zero
            v(i,j,ks-1) = zero
          enddo
          enddo
        endif

      elseif (bcz_lo .eq. INLET) then

        call velinflow(w,DIMS,time,2,0)

        do j = js,je
        do i = is,ie 
          u(i,j,ks-1) = zero
          v(i,j,ks-1) = zero
        enddo
        enddo

      elseif (bcz_lo .eq. OUTLET) then

        do j = js,je
        do i = is,ie 
          u(i,j,ks-1) = u(i,j,ks)
          v(i,j,ks-1) = v(i,j,ks)
          w(i,j,ks-1) = w(i,j,ks)
        enddo
        enddo

      else

        print *,'bogus bcz_lo in setvelbc ',bcz_lo
        stop

      endif

      if (bcz_hi .eq. PERIODIC) then

        do j = js,je 
        do i = is,ie 
          u(i,j,ke+1) = u(i,j,ks)
          v(i,j,ke+1) = v(i,j,ks)
          w(i,j,ke+1) = w(i,j,ks)
        enddo
        enddo

      elseif (bcz_hi .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do j = js,je 
        do i = is,ie 
          w(i,j,ke+1) = zero
          u(i,j,ke+1) = (fifteen*u(i,j,ke  ) - ten*u(i,j,ke-1) + 
     $                     three*u(i,j,ke-2)) / eight
          v(i,j,ke+1) = (fifteen*v(i,j,ke  ) - ten*v(i,j,ke-1) + 
     $                     three*v(i,j,ke-2)) / eight
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do j = js,je 
          do i = is,ie 
            u(i,j,ke+1) = zero
            v(i,j,ke+1) = zero
          enddo
          enddo
        endif

      elseif (bcz_hi .eq. INLET) then

        call velinflow(w,DIMS,time,2,1)

        do j = js,je
        do i = is,ie 
          u(i,j,ke+1) = zero
          v(i,j,ke+1) = zero
        enddo
        enddo

      elseif (bcz_hi .eq. OUTLET) then

        do j = js,je
        do i = is,ie 
          u(i,j,ke+1) = u(i,j,ke)
          v(i,j,ke+1) = v(i,j,ke)
          w(i,j,ke+1) = w(i,j,ke)
        enddo
        enddo

      else

        print *,'bogus bcz_hi in setvelbc ',bcz_hi
        stop

      endif

      if (bcy_lo .eq. PERIODIC) then

        do k = ks-1,ke+1 
        do i = is,ie 
          u(i,js-1,k) = u(i,je,k)
          v(i,js-1,k) = v(i,je,k)
          w(i,js-1,k) = w(i,je,k)
        enddo
        enddo

      elseif (bcy_lo .eq. WALL) then


c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do k = ks-1,ke+1 
        do i = is,ie 
          v(i,js-1,k) = zero
          u(i,js-1,k) = (fifteen*u(i,js  ,k) - ten*u(i,js+1,k) + 
     $                     three*u(i,js+2,k)) / eight
          w(i,js-1,k) = (fifteen*w(i,js  ,k) - ten*w(i,js+1,k) + 
     $                     three*w(i,js+2,k)) / eight
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do k = ks-1,ke+1 
          do i = is,ie 
            u(i,js-1,k) = zero
            w(i,js-1,k) = zero
          enddo
          enddo
        endif

      elseif (bcy_lo .eq. INLET) then

        call velinflow(v,DIMS,time,1,0)

        do k = ks-1,ke+1
        do i = is,ie 
          u(i,js-1,k) = zero
          w(i,js-1,k) = zero
        enddo
        enddo

      elseif (bcy_lo .eq. OUTLET) then

        do k = ks-1,ke+1
        do i = is,ie 
          u(i,js-1,k) = u(i,js,k)
          v(i,js-1,k) = v(i,js,k)
          w(i,js-1,k) = w(i,js,k)
        enddo
        enddo

      else

        print *,'bogus bcy_lo in setvelbc ', bcy_lo
        stop

      endif

      if (bcy_hi .eq. PERIODIC) then

        do k = ks-1,ke+1 
        do i = is,ie 
          u(i,je+1,k) = u(i,js,k)
          v(i,je+1,k) = v(i,js,k)
          w(i,je+1,k) = w(i,js,k)
        enddo
        enddo

      elseif (bcy_hi .eq. WALL) then


c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do k = ks-1,ke+1 
        do i = is,ie 
          v(i,je+1,k) = zero
          u(i,je+1,k) = (fifteen*u(i,je  ,k) - ten*u(i,je-1,k) + 
     $                     three*u(i,je-2,k)) / eight
          w(i,je+1,k) = (fifteen*w(i,je  ,k) - ten*w(i,je-1,k) + 
     $                     three*w(i,je-2,k)) / eight
        enddo
        enddo

        if (visc_coef .gt. zero) then
          do k = ks-1,ke+1 
          do i = is,ie 
            u(i,je+1,k) = zero
            w(i,je+1,k) = zero
          enddo
          enddo
        endif

      elseif (bcy_hi .eq. INLET) then

        call velinflow(v,DIMS,time,1,1)

        do k = ks-1,ke+1
        do i = is,ie 
          u(i,je+1,k) = zero
          w(i,je+1,k) = zero
        enddo
        enddo

      elseif (bcy_hi .eq. OUTLET) then

        do k = ks-1,ke+1
        do i = is,ie 
          u(i,je+1,k) = u(i,je,k)
          v(i,je+1,k) = v(i,je,k)
          w(i,je+1,k) = w(i,je,k)
        enddo
        enddo

      else

        print *,'bogus bcy_hi in setvelbc ',bcy_hi
        stop

      endif

      if (bcx_lo .eq. PERIODIC) then

        do k = ks-1,ke+1 
        do j = js-1,je+1 
             u(is-1,j,k) =    u(ie,j,k)
             v(is-1,j,k) =    v(ie,j,k)
             w(is-1,j,k) =    w(ie,j,k)
        enddo
        enddo

      elseif (bcx_lo .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do k = ks-1,ke+1 
        do j = js-1,je+1 
          u(is-1,j,k) = zero
          v(is-1,j,k) = (fifteen*v(is  ,j,k) - ten*v(is+1,j,k) + 
     $                     three*v(is+2,j,k)) / eight
          w(is-1,j,k) = (fifteen*w(is  ,j,k) - ten*w(is+1,j,k) + 
     $                     three*w(is+2,j,k)) / eight
       enddo
       enddo

        if (visc_coef .gt. zero) then
          do k = ks-1,ke+1 
          do j = js-1,je+1 
            v(is-1,j,k) = zero
            w(is-1,j,k) = zero
          enddo
          enddo
        endif

      elseif (bcx_lo .eq. INLET) then

        call velinflow(u,DIMS,time,0,0)

        do k = ks-1,ke+1 
        do j = js-1,je+1 
          v(is-1,j,k) = zero
          w(is-1,j,k) = zero
        enddo
        enddo

      elseif (bcx_lo .eq. OUTLET) then

        do k = ks-1,ke+1 
        do j = js-1,je+1 
          u(is-1,j,k) = u(is,j,k)
          v(is-1,j,k) = v(is,j,k)
          w(is-1,j,k) = w(is,j,k)
        enddo
        enddo

      else

        print *,'bogus bcx_lo in setvelbc ',bcx_lo
        stop

      endif

      if (bcx_hi .eq. PERIODIC) then

        do k = ks-1,ke+1 
        do j = js-1,je+1 
             u(ie+1,j,k) =    u(is,j,k)
             v(ie+1,j,k) =    v(is,j,k)
             w(ie+1,j,k) =    w(is,j,k)
        enddo
        enddo

      elseif (bcx_hi .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do k = ks-1,ke+1 
        do j = js-1,je+1 
          u(ie+1,j,k) = zero
          v(ie+1,j,k) = (fifteen*v(ie  ,j,k) - ten*v(ie-1,j,k) + 
     $                     three*v(ie-2,j,k)) / eight
          w(ie+1,j,k) = (fifteen*w(ie  ,j,k) - ten*w(ie-1,j,k) + 
     $                     three*w(ie-2,j,k)) / eight
       enddo
       enddo

        if (visc_coef .gt. zero) then
          do k = ks-1,ke+1 
          do j = js-1,je+1 
            v(ie+1,j,k) = zero
            w(ie+1,j,k) = zero
          enddo
          enddo
        endif

      elseif (bcx_hi .eq. INLET) then

        call velinflow(u,DIMS,time,0,1)

        do k = ks-1,ke+1 
        do j = js-1,je+1 
          v(ie+1,j,k) = zero
          w(ie+1,j,k) = zero
        enddo
        enddo

      elseif (bcx_hi .eq. OUTLET) then

        do k = ks-1,ke+1 
        do j = js-1,je+1 
          u(ie+1,j,k) = u(ie,j,k)
          v(ie+1,j,k) = v(ie,j,k)
          w(ie+1,j,k) = w(ie,j,k)
        enddo
        enddo

      else

        print *,'bogus bcx_hi in setvelbc ', bcx_hi
        stop

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: MACOPERATOR_3D.F,v 1.8 2003/02/05 22:11:42 almgren Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "MACOPERATOR_F.H"
#include "ArrayLim.H"

#define SDIM 3

c :: ----------------------------------------------------------
c :: MACCOEF
c ::             Compute the coefficents for MAC solve
c ::
c :: INPUTS / OUTPUTS:
c ::  cx,cy,cz    <=  edge coef arrays
c ::  DIMS(cx)     => index limits for cx
c ::  DIMS(cy)     => index limits for cy
c ::  DIMS(cz)     => index limits for cz
c ::  ax,ay,az     => edge based area arrays
c ::  DIMS(ax)     => index limits for ax
c ::  DIMS(ay)     => index limits for ay
c ::  DIMS(az)     => index limits for az
c ::  rho          => cell centered density array
c ::  DIMS(rho)    => index limits of rho array
c ::  lo,hi        => index limits for rhs
c ::  dx           => cell size
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACCOEF (cx,DIMS(cx),cy,DIMS(cy),cz,DIMS(cz),
     &                          ax,DIMS(ax),ay,DIMS(ay),az,DIMS(az),
     &                          rho,DIMS(rho),lo,hi,dx)
       integer DIMDEC(cx)
       integer DIMDEC(cy)
       integer DIMDEC(cz)
       integer DIMDEC(ax)
       integer DIMDEC(ay)
       integer DIMDEC(az)
       integer DIMDEC(rho)
       integer lo(SDIM), hi(SDIM)
       REAL_T  dx(SDIM)
       REAL_T  cx(DIMV(cx))
       REAL_T  cy(DIMV(cy))
       REAL_T  cz(DIMV(cz))
       REAL_T  ax(DIMV(ax))
       REAL_T  ay(DIMV(ay))
       REAL_T  az(DIMV(az))
       REAL_T  rho(DIMV(rho))

       integer i, j, k
       REAL_T  rhoavg

       do k = lo(3), hi(3)
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                if (rho(i,j,k) .lt. zero) then
                   print *,' '
                   print *,'TESTING in MACCOEF '
                   print *,'RHO HAS GONE NEGATIVE AT ',i,j,k,rho(i,j,k)
                   call bl_abort(" ")
                end if
             end do
          end do
       end do
c
c      ::::: finish coef in X direction (part 2)
c
       do k = lo(3), hi(3)
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)+1
                rhoavg = half * ( rho(i,j,k) + rho(i-1,j,k) )
c          cx(i,j,k) = half*dx(1)*ax(i,j,k)*(one/rho(i,j,k) + one/rho(i-1,j,k))
                cx(i,j,k) = dx(1) * ax(i,j,k) / rhoavg 
             end do
          end do
       end do
c
c      ::::: finish coef in Y direction (part 2)
c
       do k = lo(3), hi(3)
          do j = lo(2), hi(2)+1
             do i = lo(1), hi(1)
                rhoavg = half * ( rho(i,j,k) + rho(i,j-1,k) )
c          cy(i,j,k) = half*dx(2)*ay(i,j,k)*(one/rho(i,j,k) + one/rho(i,j-1,k))
                cy(i,j,k) = dx(2) * ay(i,j,k) / rhoavg 
             end do
          end do
       end do
c
c      ::::: finish coef in Z direction (part 2)
c
       do k = lo(3), hi(3)+1
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                rhoavg = half * ( rho(i,j,k) + rho(i,j,k-1) )
c          cz(i,j,k) = half*dx(3)*az(i,j,k)*(one/rho(i,j,k) + one/rho(i,j,k-1))
                cz(i,j,k) = dx(3) * az(i,j,k) / rhoavg 
             end do
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: MACRHS
c ::             Compute the RHS for MAC solve
c ::
c :: INPUTS / OUTPUTS:
c ::  ux,uy,uz    <=  edge velocity arrays
c ::  DIMS(ux)     => index limits for ux
c ::  DIMS(uy)     => index limits for uy
c ::  DIMS(uz)     => index limits for uz
c ::  ax,ay,az     => edge based area arrays
c ::  DIMS(ax)     => index limits for ax
c ::  DIMS(ay)     => index limits for ay
c ::  DIMS(az)     => index limits for az
c ::  vol          => cell centered volume array
c ::  DIMS(vol)    => index limits of vol array
c ::  rhs         <=> cell centered rhs array
c ::  DIMS(rhs)    => index limits of rhs array
c ::  lo,hi        => index limits for rhs
c ::  scale        => scale factor
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACRHS (ux,DIMS(ux),uy,DIMS(uy),uz,DIMS(uz),
     &                         ax,DIMS(ax),ay,DIMS(ay),az,DIMS(az),
     &                         vol,DIMS(vol),rhs,DIMS(rhs),lo,hi,scale)
       integer DIMDEC(ux)
       integer DIMDEC(uy)
       integer DIMDEC(uz)
       integer DIMDEC(ax)
       integer DIMDEC(ay)
       integer DIMDEC(az)
       integer DIMDEC(vol)
       integer DIMDEC(rhs)
       integer lo(SDIM), hi(SDIM)
       REAL_T  scale
       REAL_T  ux(DIMV(ux))
       REAL_T  uy(DIMV(uy))
       REAL_T  uz(DIMV(uz))
       REAL_T  ax(DIMV(ax))
       REAL_T  ay(DIMV(ay))
       REAL_T  az(DIMV(az))
       REAL_T  vol(DIMV(vol))
       REAL_T  rhs(DIMV(rhs))

       integer i, j, k
       REAL_T  divu
c
c      ::::: rhs holds the divergence condition (possibly zero)
c
       do k = lo(3), hi(3)
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                divu = ax(i+1,j,k)*ux(i+1,j,k) - ax(i,j,k)*ux(i,j,k)
     &               + ay(i,j+1,k)*uy(i,j+1,k) - ay(i,j,k)*uy(i,j,k)
     &               + az(i,j,k+1)*uz(i,j,k+1) - az(i,j,k)*uz(i,j,k)
                rhs(i,j,k) = scale*(divu - vol(i,j,k)*rhs(i,j,k))
             end do
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: MACUPDATE
c ::             Compute the update to velocity field to
c ::             make it divergence free
c ::
c :: INPUTS / OUTPUTS:
c ::  ux,uy,uz    <=  edge based velocity arrays
c ::  DIMS(ux)     => index limits for ux
c ::  DIMS(uy)     => index limits for uy
c ::  DIMS(uz)     => index limits for uz
c ::  phi          => soln from MAC project
c ::  DIMS(phi)    => index limits for phi
c ::  rho          => density at time N
c ::  DIMS(rho)    => index limits for rho
c ::  dx           => cell size
c ::  mult         => scalar multiplier
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACUPDATE(
     &     init,
     &     ux,DIMS(ux),uy,DIMS(uy),uz,DIMS(uz),
     &     phi,DIMS(phi),rho,DIMS(rho),
     &     lo,hi,dx,mult)

       integer DIMDEC(ux)
       integer DIMDEC(uy)
       integer DIMDEC(uz)
       integer DIMDEC(phi)
       integer DIMDEC(rho)
       integer lo(SDIM), hi(SDIM)
       REAL_T  dx(SDIM), mult
       REAL_T  ux(DIMV(ux))
       REAL_T  uy(DIMV(uy))
       REAL_T  uz(DIMV(uz))
       REAL_T  phi(DIMV(phi))
       REAL_T  rho(DIMV(rho))
       integer init

       integer i, j, k
       REAL_T  rhoavg, gp
c
c     set gradient to zero if initializing
c
       if ( init .eq. 1 ) then
          do k = ARG_L3(ux), ARG_H3(ux)
             do j = ARG_L2(ux), ARG_H2(ux)
                do i = ARG_L1(ux), ARG_H1(ux)
                   ux(i,j,k) = zero
                end do
             end do
          end do
          do k = ARG_L3(uy), ARG_H3(uy)
             do j = ARG_L2(uy), ARG_H2(uy)
                do i = ARG_L1(uy), ARG_H1(uy)
                   uy(i,j,k) = zero
                end do
             end do
          end do
          do k = ARG_L3(uz), ARG_H3(uz)
             do j = ARG_L2(uz), ARG_H2(uz)
                do i = ARG_L1(uz), ARG_H1(uz)
                   uz(i,j,k) = zero
                end do
             end do
          end do
       end if
c
c      compute x MAC gradient
c
       do k = lo(3),hi(3)
          do j = lo(2),hi(2)
             do i = lo(1),hi(1)+1
                rhoavg = half*(rho(i,j,k) + rho(i-1,j,k))
                gp = (phi(i,j,k)-phi(i-1,j,k))/dx(1)
                ux(i,j,k) = ux(i,j,k) + mult * gp / rhoavg
             end do
          end do
       end do
c     
c     compute y mac gradient
c
       do k = lo(3),hi(3)
          do j = lo(2),hi(2)+1
             do i = lo(1),hi(1)
                rhoavg = half*(rho(i,j,k) + rho(i,j-1,k))
                gp = (phi(i,j,k)-phi(i,j-1,k))/dx(2)
                uy(i,j,k) = uy(i,j,k) + mult * gp / rhoavg
             end do
          end do
       end do
c       
c     compute z mac gradient
c
       do k = lo(3),hi(3)+1
          do j = lo(2),hi(2)
             do i = lo(1),hi(1)
                rhoavg = half*(rho(i,j,k) + rho(i,j,k-1))
                gp = (phi(i,j,k)-phi(i,j,k-1))/dx(3)
                uz(i,j,k) = uz(i,j,k) + mult * gp / rhoavg
             end do
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: MACSYNCRHS
c ::        Modify the RHS for MAC SYNC solve
c ::
c :: INPUTS / OUTPUTS:
c ::  rhs         <=  right hand side array
c ::  lo,hi        => index limits for rhs
c ::  vol          => cell centered volume array
c ::  vlo,vhi      => index limits of vol array
c ::  rhsscale     => const multiplier to rhs
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACSYNCRHS(rhs,DIMS(rhs),lo,hi,
     &                            vol,DIMS(vol),rhsscale)
       integer DIMDEC(rhs)
       integer DIMDEC(vol)
       integer lo(SDIM), hi(SDIM)
       REAL_T  rhsscale
       REAL_T  rhs(DIMV(rhs))
       REAL_T  vol(DIMV(vol))

       integer i, j, k
c
c      ::::: multiply by volume since reflux step (which computed rhs)
c      ::::: divided by volume.
c
       do k = lo(3), hi(3)
          do j = lo(2), hi(2)
             do i = lo(1), hi(1)
                rhs(i,j,k) = rhsscale*vol(i,j,k)*rhs(i,j,k)
             end do
          end do
       end do

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** SLOPEX **
c ** Compute the slope of nvar components of s in the x-direction
c *************************************************************************

      subroutine FORT_SLOPEX(s,slx,dxscr,DIMS,first_comp,nvar,
     $                       bcx_lo,bcx_hi,irz,slope_order)
 
      implicit none

      integer DIMS
      integer nvar
      REAL_T      s(lo_1-1:hi_1+1,lo_2-1:hi_2+1,nvar)
      REAL_T    slx(lo_1-1:hi_1+1,lo_2-1:hi_2+1,nvar)
      REAL_T  dxscr(lo_1-1:hi_1+1,4)
      integer bcx_lo,bcx_hi
      integer irz
      integer first_comp
      integer slope_order

c     Local variables
      integer is,js,ie,je
      integer i,j,iv
      integer cen,lim,flag,fromm
      REAL_T del,slim,sflag
      REAL_T dpls,dmin,ds

      parameter( cen = 1 )
      parameter( lim = 2 )
      parameter( flag = 3 )
      parameter( fromm = 4 )

      is = lo_1
      js = lo_2
      ie = hi_1
      je = hi_2

      if (irz .eq. 1 .and. lo_1 .ne. 0) then
         print *,'NEED LO(1) = 0 WHEN IRZ = 1'
         stop
      endif

c     HERE DOING 1ST ORDER
      if (slope_order .eq. 0) then
        do iv = 1,nvar 
          do j = js-1,je+1 
            do i = is-1,ie+1 
              slx(i,j,iv) = zero
            enddo
          enddo
        enddo

c     HERE DOING 2ND ORDER
      else if (slope_order .eq. 2) then

        do iv=1,nvar 
          do j = js-1,je+1 
            do i = is,ie 
              del = half*(s(i+1,j,iv) - s(i-1,j,iv))
              dpls = two*(s(i+1,j,iv) - s(i  ,j,iv))
              dmin = two*(s(i  ,j,iv) - s(i-1,j,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(i,j,iv)= sflag*min(slim,abs(del))
            enddo

            if (bcx_lo .eq. PERIODIC) then

              slx(is-1,j,iv) = slx(ie,j,iv)

            elseif (bcx_lo .eq. WALL  .or.  bcx_lo .eq. INLET) then

              slx(is-1,j,iv) = zero
              del = (s(is+1,j,iv)+three*s(is,j,iv)-
     $               four*s(is-1,j,iv) ) * third
              dpls = two*(s(is+1,j,iv) - s(is  ,j,iv))
              dmin = two*(s(is  ,j,iv) - s(is-1,j,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(is,j,iv)= sflag*min(slim,abs(del))

            elseif (bcx_lo .eq. OUTLET) then

              slx(is-1,j,iv) = zero

            endif

            if (bcx_hi .eq. PERIODIC) then

              slx(ie+1,j,iv) = slx(is,j,iv)

            elseif (bcx_hi .eq. WALL  .or.  bcx_hi .eq. INLET) then

              slx(ie+1,j,iv) = zero
              del = -(s(ie-1,j,iv)+three*s(ie,j,iv)-
     $                four*s(ie+1,j,iv) ) * third
              dpls = two*(s(ie  ,j,iv) - s(ie-1,j,iv))
              dmin = two*(s(ie+1,j,iv) - s(ie  ,j,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(ie,j,iv)= sflag*min(slim,abs(del))

            elseif (bcx_hi .eq. OUTLET) then

              slx(ie+1,j,iv) = zero

            endif
          enddo
          enddo

      else 

c     HERE DOING 4TH ORDER
      do iv=1,nvar 
        do j = js-1,je+1 

          if (irz .eq. 1 .and.  
     $        first_comp .eq. 0 .and. iv .eq. 1) then
            s(-1,j,1) = -s(0,j,1)
          endif

          do i = is,ie 
            dxscr(i,cen) = half*(s(i+1,j,iv)-s(i-1,j,iv))
            dmin = two*(s(i  ,j,iv)-s(i-1,j,iv))
            dpls = two*(s(i+1,j,iv)-s(i  ,j,iv))
            dxscr(i,lim)= min(abs(dmin),abs(dpls))
            dxscr(i,lim) = cvmgp(dxscr(i,lim),zero,dpls*dmin)
            dxscr(i,flag) = sign(one,dxscr(i,cen))
            dxscr(i,fromm)= dxscr(i,flag)*min(dxscr(i,lim),
     $                      abs(dxscr(i,cen)))
          enddo

          if (bcx_lo .eq. PERIODIC) then
            dxscr(is-1,fromm) = dxscr(ie,fromm)
          else
            dxscr(is-1,fromm) = dxscr(is,fromm)
          endif

          if (bcx_hi .eq. PERIODIC) then
            dxscr(ie+1,fromm) = dxscr(is,fromm)
          else
            dxscr(ie+1,fromm) = dxscr(ie,fromm)
          endif

          do i = is,ie 

            ds = two * two3rd * dxscr(i,cen) - 
     $           sixth * (dxscr(i+1,fromm) + dxscr(i-1,fromm))
            slx(i,j,iv) = dxscr(i,flag)*min(abs(ds),dxscr(i,lim))

          enddo

          if (irz .eq. 1 .and.
     $        first_comp .eq. 0 .and. iv .eq. 1) then
            s(-1,j,1) = zero
          endif

          if (bcx_lo .eq. PERIODIC) then

            slx(is-1,j,iv)=slx(ie,j,iv)

          elseif (bcx_lo .eq. WALL  .or.  bcx_lo .eq. INLET) then

            slx(is-1,j,iv) = zero

            if (irz .eq. 0  .or.  .not. 
     $          (first_comp .eq. 0 .and. iv .eq. 1) ) then
              del = -sixteen/fifteen*s(is-1,j,iv) + half*s(is,j,iv) + 
     $                        two3rd*s(is+1,j,iv) - tenth*s(is+2,j,iv)
              dmin = two*(s(is  ,j,iv)-s(is-1,j,iv))
              dpls = two*(s(is+1,j,iv)-s(is  ,j,iv))
              slim = min(abs(dpls), abs(dmin))
              slim = cvmgp(slim, zero, dpls*dmin)
              sflag = sign(one,del)
              slx(is,j,iv)= sflag*min(slim,abs(del))

c             Recalculate the slope at is+1 using the revised dxscr(is,fromm)
              dxscr(is,fromm) = slx(is,j,iv)
              ds = two * two3rd * dxscr(is+1,cen) -
     $             sixth * (dxscr(is+2,fromm) + dxscr(is,fromm))
              slx(is+1,j,iv) = dxscr(is+1,flag)*min(abs(ds),dxscr(is+1,lim))
            endif

          elseif (bcx_lo .eq. OUTLET) then

            slx(is-1,j,iv) = zero

          endif

          if (bcx_hi .eq. PERIODIC) then

            slx(ie+1,j,iv)=slx(is,j,iv)

          elseif (bcx_hi .eq. WALL  .or.  bcx_hi .eq. INLET) then

            slx(ie+1,j,iv) = zero

            del = -( -sixteen/fifteen*s(ie+1,j,iv) + half*s(ie,j,iv) + 
     $                         two3rd*s(ie-1,j,iv) - tenth*s(ie-2,j,iv) )
            dmin = two*(s(ie  ,j,iv)-s(ie-1,j,iv))
            dpls = two*(s(ie+1,j,iv)-s(ie  ,j,iv))
            slim = min(abs(dpls), abs(dmin))
            slim = cvmgp(slim, zero, dpls*dmin)
            sflag = sign(one,del)
            slx(ie,j,iv)= sflag*min(slim,abs(del))

c           Recalculate the slope at ie-1 using the revised dxscr(ie,fromm)
            dxscr(ie,fromm) = slx(ie,j,iv)
            ds = two * two3rd * dxscr(ie-1,cen) -
     $           sixth * (dxscr(ie-2,fromm) + dxscr(ie,fromm))
            slx(ie-1,j,iv) = dxscr(ie-1,flag)*min(abs(ds),dxscr(ie-1,lim))

          elseif (bcx_hi .eq. OUTLET) then

            slx(ie+1,j,iv) = zero

          endif
        enddo
      enddo

        if (irz .eq. 1 .and.
     $     first_comp .eq. 0 .and. nvar .ge. 2) then

           do iv = 2,nvar
           do j = js,je 
             slx(is-1,j,iv)=-slx(is,j,iv)
           enddo
           enddo

        endif

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** SETVELBC **
c ** Impose the physical boundary conditions on the velocity (u,v)
c *************************************************************************

      subroutine setvelbc(u,v,DIMS,bcx_lo,bcx_hi,bcy_lo,bcy_hi,irz,
     $                    visc_coef,dx,time)

      implicit none

      integer DIMS
      REAL_T     u(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T     v(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      integer bcx_lo,bcx_hi
      integer bcy_lo,bcy_hi
      integer irz
      REAL_T visc_coef
      REAL_T dx(2)
      REAL_T time

c     Local variables
      integer is,ie,js,je,i,j

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

      if (bcy_lo .eq. PERIODIC) then

        do i = is,ie 
          u(i,js-1) = u(i,je)
          v(i,js-1) = v(i,je)
        enddo

      elseif (bcy_lo .eq. WALL) then


c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do i = is,ie 
          v(i,js-1) = zero
          u(i,js-1) = (fifteen*u(i,js  ) - ten*u(i,js+1) + 
     $                   three*u(i,js+2)) / eight
        enddo

        if (visc_coef .gt. zero) then
          do i = is,ie 
            u(i,js-1) = zero
          enddo
        endif

      elseif (bcy_lo .eq. INLET) then

        call velinflow(v,DIMS,time,dx(1),1,0)

        do i = is-1,ie+1 
          u(i,js-1) = zero
        enddo

      elseif (bcy_lo .eq. OUTLET) then

        do i = is-1,ie+1 
          u(i,js-1) = u(i,js)
          v(i,js-1) = v(i,js)
        enddo

      endif

      if (bcy_hi .eq. PERIODIC) then

        do i = is,ie 
          u(i,je+1) = u(i,js)
          v(i,je+1) = v(i,js)
        enddo

      elseif (bcy_hi .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do i = is,ie 
          v(i,je+1) = zero
          u(i,je+1) = (fifteen*u(i,je  ) - ten*u(i,je-1) + 
     $                   three*u(i,je-2)) / eight
        enddo

        if (visc_coef .gt. zero) then
          do i = is,ie 
            u(i,je+1) = zero
          enddo
        endif

      elseif (bcy_hi .eq. INLET) then

        call velinflow(v,DIMS,time,dx(1),1,1)

        do i = is-1,ie+1 
          u(i,je+1) = zero
        enddo

      elseif (bcy_hi .eq. OUTLET) then

        do i = is-1,ie+1 
          u(i,je+1) = u(i,je)
          v(i,je+1) = v(i,je)
        enddo

      endif

      if (bcx_lo .eq. PERIODIC) then

        do j = js-1,je+1 
          u(is-1,j) =    u(ie,j)
          v(is-1,j) =    v(ie,j)
        enddo

      elseif (bcx_lo .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do j = js-1,je+1 
          u(is-1,j) = zero
          v(is-1,j) = (fifteen*v(is  ,j) - ten*v(is+1,j) + 
     $                   three*v(is+2,j)) / eight
        enddo

        if (irz .eq. 0 .and. visc_coef .gt. zero) then
          do j = js-1,je+1 
            v(is-1,j) = zero
          enddo
        endif

        if (irz .eq. 1) then
          do j = js-1,je+1 
             v(is-1,j) =    v(is,j)
          enddo
        endif

      elseif (bcx_lo .eq. INLET) then

        call velinflow(u,DIMS,time,dx(2),0,0)

        do j = js-1,je+1 
          v(is-1,j) = zero
        enddo

      elseif (bcx_lo .eq. OUTLET) then

        do j = js-1,je+1 
          u(is-1,j) = u(is,j)
          v(is-1,j) = v(is,j)
        enddo

      endif

      if (bcx_hi .eq. PERIODIC) then

        do j = js-1,je+1 
          u(ie+1,j) =    u(is,j)
          v(ie+1,j) =    v(is,j)
        enddo

      elseif (bcx_hi .eq. WALL) then

c ::: REMEMBER -  THESE VALUES NOW LIVE ON CELL EDGES

        do j = js-1,je+1 
          u(ie+1,j) = zero
          v(ie+1,j) = (fifteen*v(ie  ,j) - ten*v(ie-1,j) + 
     $                   three*v(ie-2,j)) / eight
       enddo

        if (visc_coef .gt. zero) then
          do j = js-1,je+1 
            v(ie+1,j) = zero
          enddo
        endif

      elseif (bcx_hi .eq. INLET) then

        call velinflow(u,DIMS,time,dx(2),0,1)

        do j = js-1,je+1 
          v(ie+1,j) = zero
        enddo

      elseif (bcx_hi .eq. OUTLET) then

        do j = js-1,je+1 
          u(ie+1,j) = u(ie,j)
          v(ie+1,j) = v(ie,j)
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: STATS_2D.F,v 1.3 2000/07/19 23:30:31 sstanley Exp $
c

#include "REAL.H"
#include "CONSTANTS.H"
#include "ArrayLim.H"

#include "StatTypes.H"
#define SDIM 2


c ::: -----------------------------------------------------------
c ::: This routine calculates the velocity statistics using Reynolds
c ::: averaging.
c :::
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: ssDat        =>  (const)  SlabStat data
c ::: nSSComp      =>  (const)  Number of components in ssDat
c ::: DIMS(dat)    =>  (const)  Dimensions of SlabStat data
c ::: nStats       =>  (const)  Number of statistics to calculate
c ::: nStns        =>  (const)  Number of stations in the statistic array
c ::: stats       <=   (modify) Array to hold statistics
c :::
c :::                  Output Values:
c :::                      <U> <V> <uu> <vv> <uv> TKE
c :::                  
c ::: vblo, vbhi   =>  (const)  subregion where statistics are calculated
c ::: -----------------------------------------------------------
c
      subroutine FORT_VEL_RA_RND(ssDat, nSSComp, DIMS(ssdat),
     $                           nStats, nStns, stats, physStn,
     $                           vblo, vbhi, dx, probLo, probHi,
     $                           axialDir, nStations)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer nSSComp, nStats, nStns, axialDir, nStations
      integer vblo(SDIM), vbhi(SDIM)
      integer DIMDEC(ssdat)
      REAL_T ssDat(DIMV(ssdat),nSSComp)
      REAL_T stats(nStns,nStats)
      REAL_T physStn(nStns)
      REAL_T dx(SDIM), probLo(SDIM), probHi(SDIM)

c
c     ::::: local variables
c
      integer i, j, n, profDir, nSSexpect, nStatsExpect
      integer flo(SDIM), fhi(SDIM)
      integer rho, rho2,
     $        u, u2, rhoU, rhoU2,
     $        v, v2, rhoV, rhoV2,
     $        tr, tr2, rhoTr, rhoTr2,
     $        uV, rhoUV, uTr, vTr, rhoUTr, rhoVTr, p, p2, uP, vP


c
c     ------------------------------
c     ::: Define Local Constants :::
c     ------------------------------
c
      parameter (nSSexpect = 24, nStatsExpect = 6)

      call SET_LOHI(DIMS(ssdat), flo, fhi)


c
c     -----------------------------
c     ::: Perform Sanity Checks :::
c     -----------------------------
c
      call SANITY_TEST(nStns, nStats, nSSComp, profDir, 
     $                 nSSexpect, nStatsExpect, vblo, vbhi)

c
c     ------------------------------------------
c     ::: Define SlabStat Variable Locations :::
c     ------------------------------------------
c
      rho    = 1
      u      = 2
      rhoU   = 3
      v      = 4
      rhoV   = 5
      tr     = 6
      rhoTr  = 7
      p      = 8
      rho2   = 9
      u2     = 10
      rhoU2  = 11
      v2     = 12
      rhoV2  = 13
      tr2    = 14
      rhoTr2 = 15
      p2     = 16
      uV     = 17
      rhoUV  = 18
      uTr    = 19
      vTr    = 20
      rhoUTr = 21
      rhoVTr = 22
      uP     = 23
      vP     = 24


c
c     ----------------------------
c     ::: Calculate Statistics :::
c     ----------------------------
c
      nStations = vbhi(profDir) - vblo(profDir) + 1
      do n = 1, vbhi(profDir) - vblo(profDir) + 1
        physStn(n) = (FLOAT(n) + half) * dx(profDir)

        if (profDir .eq. 1) then
          i = n - 1 + vblo(profDir)
          j = vblo(2)
        else
          i = vblo(1)
          j = n - 1 + vblo(profDir)
        endif

        stats(n,1) = ssDat(i,j,u)
        stats(n,2) = ssDat(i,j,v)
        stats(n,3) = ssDat(i,j,u2) - ssDat(i,j,u)**2
        stats(n,4) = ssDat(i,j,v2) - ssDat(i,j,v)**2
        stats(n,5) = ssDat(i,j,uV) - ssDat(i,j,u) * ssDat(i,j,v)
        stats(n,6) = half * ( stats(n,3) + stats(n,4) )
      enddo


c
c
      return
      end


c ::: -----------------------------------------------------------
c ::: This routine calculates the velocity statistics using Favre
c ::: averaging.
c :::
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: ssDat        =>  (const)  SlabStat data
c ::: nSSComp      =>  (const)  Number of components in ssDat
c ::: DIMS(dat)    =>  (const)  Dimensions of SlabStat data
c ::: nStats       =>  (const)  Number of statistics to calculate
c ::: nStns        =>  (const)  Number of stations in the statistic array
c ::: stats       <=   (modify) Array to hold statistics
c :::
c :::                  Output Values:
c :::                      <U> <V> <uu> <vv> <uv> TKE
c :::                  
c ::: vblo, vbhi   =>  (const)  subregion where statistics are calculated
c ::: -----------------------------------------------------------
c
      subroutine FORT_VEL_FA_RND(ssDat, nSSComp, DIMS(ssdat),
     $                           nStats, nStns, stats, physStn,
     $                           vblo, vbhi, dx, probLo, probHi,
     $                           axialDir, nStations)

      implicit none

c
c     :::: Passed Variables ::::
c
      integer nSSComp, nStats, nStns, axialDir, nStations
      integer vblo(SDIM), vbhi(SDIM)
      integer DIMDEC(ssdat)
      REAL_T ssDat(DIMV(ssdat),nSSComp)
      REAL_T stats(nStns,nStats)
      REAL_T physStn(nStns)
      REAL_T dx(SDIM), probLo(SDIM), probHi(SDIM)

c
c     ::::: local variables
c
      integer i, j, n, profDir, nSSexpect, nStatsExpect
      integer flo(SDIM), fhi(SDIM)
      integer rho, rho2,
     $        u, u2, rhoU, rhoU2,
     $        v, v2, rhoV, rhoV2,
     $        tr, tr2, rhoTr, rhoTr2,
     $        uV, rhoUV, uTr, vTr, rhoUTr, rhoVTr, p, p2, uP, vP


c
c     ------------------------------
c     ::: Define Local Constants :::
c     ------------------------------
c
      parameter (nSSexpect = 24, nStatsExpect = 6)

      call SET_LOHI(DIMS(ssdat), flo, fhi)


c
c     -----------------------------
c     ::: Perform Sanity Checks :::
c     -----------------------------
c
      call SANITY_TEST(nStns, nStats, nSSComp, profDir, 
     $                 nSSexpect, nStatsExpect, vblo, vbhi)

c
c     ------------------------------------------
c     ::: Define SlabStat Variable Locations :::
c     ------------------------------------------
c
      rho    = 1
      u      = 2
      rhoU   = 3
      v      = 4
      rhoV   = 5
      tr     = 6
      rhoTr  = 7
      p      = 8
      rho2   = 9
      u2     = 10
      rhoU2  = 11
      v2     = 12
      rhoV2  = 13
      tr2    = 14
      rhoTr2 = 15
      p2     = 16
      uV     = 17
      rhoUV  = 18
      uTr    = 19
      vTr    = 20
      rhoUTr = 21
      rhoVTr = 22
      uP     = 23
      vP     = 24


c
c     ----------------------------
c     ::: Calculate Statistics :::
c     ----------------------------
c
      nStations = vbhi(profDir) - vblo(profDir) + 1
      do n = 1, vbhi(profDir) - vblo(profDir) + 1
        physStn(n) = (FLOAT(n) + half) * dx(profDir)

        if (profDir .eq. 1) then
          i = n - 1 + vblo(profDir)
          j = vblo(2)
        else
          i = vblo(1)
          j = n - 1 + vblo(profDir)
        endif

        stats(n,1) = ssDat(i,j,rhoU) / ssDat(i,j,rho)
        stats(n,2) = ssDat(i,j,rhoV) / ssDat(i,j,rho)
        stats(n,3) = ssDat(i,j,rhoU2) / ssDat(i,j,rho)
     $                               - ssDat(i,j,rhoU)**2 / ssDat(i,j,rho)**2
        stats(n,4) = ssDat(i,j,rhoV2) / ssDat(i,j,rho)
     $                               - ssDat(i,j,rhoV)**2 / ssDat(i,j,rho)**2
        stats(n,5) = ssDat(i,j,rhoUV) / ssDat(i,j,rho)
     $                - ssDat(i,j,rhoU) * ssDat(i,j,rhoV) / ssDat(i,j,rho)**2
        stats(n,6) = half * ( stats(n,3) + stats(n,4) )
      enddo


c
c
      return
      end



c ::: ---------------------------------------------------------------------
c ::: This routine does general sanity testing on the inputs for the
c ::: SlabStat statistics routines.  This should be called by each of the 
c ::: actual fortran routines used to calculate statistics.  This routine
c ::: also sets the profile direction, profDir.
c :::
c ::: INPUTS/OUTPUTS:
c ::: 
c ::: nStns         => (const)  Number of stations in the statistic array
c ::: nStats        => (const)  Number of statistics to calculate
c ::: nSSComp       => (const)  Number of components in ssDat
c ::: profDir      <=           Profile direction
c ::: nSSexpect     => (const)  Number of components in ssDat
c ::: nStatsExpect  => (const)  Te number of statistics expected to calculate
c ::: vblo, vbhi    => (const)  subregion where statistics are calculated
c ::: ---------------------------------------------------------------------
c
      subroutine SANITY_TEST(nStns, nStats, nSSComp, profDir,
     $                       nSSexpect, nStatsExpect, vblo, vbhi)

      implicit none
c
c     ::: Passed Variables :::
c
      integer nStns, nStats, nSSComp, profDir, nSSexpect, nStatsExpect
      integer vblo(SDIM), vbhi(SDIM)

c
c     ::: Local Variables :::
c
      integer n

c
c     -----------------------------
c     ::: Perform Sanity Checks :::
c     -----------------------------
c
      profDir = -1
      do n = 1, SDIM
        if (vbhi(n) - vblo(n) + 1 .gt. 1) then
          if (profDir .ne. -1) then
            write(*,1000) vblo, vbhi
 1000       format("Error: Valid region of SlabStat data is dimensioned",
     $            /"       greater than one in more than one direction.",
     $            /"       vblo = ", SDIM(I4,1x),
     $            /"       vbhi = ", SDIM(I4,1x))
            call BL_PD_ABORT()
          endif

          profDir = n
        endif
      enddo

      if (nStns .lt. vbhi(profDir)-vblo(profDir)) then
        write(*,1010) nStns, profDir, vblo, vbhi
 1010   format("Error: The dimensions of the statistics array are insufficient",
     $        /"       to hold the profile.",
     $        /"       nStns = ", I4, "      profDir = ", I1,
     $        /"       vblo = ", SDIM(I4,1x),
     $        /"       vbhi = ", SDIM(I4,1x))
        call BL_PD_ABORT()
      endif

      if (nSSComp .lt. nSSexpect) then
        write(*,1020) nSSexpect, nSSComp
 1020   format("Error: There are fewer SlabStat components than are expected",
     $         "       from the NavierStokes statistics routines.  The",
     $         "       SlabStat components defined in this routine should be",
     $         "       updated to match those saved by the code.",
     $         "       nSSexpect = ", I4, "     nSSComp = ", I4)
        call BL_PD_ABORT()
      endif

      if (nStats .ne. nStatsExpect) then
        write(*,1030) nStatsExpect, nStats
 1030   format("Error: The number of statistics passed in do not match what",
     $         "       was expected.",
     $         "       nStatsExpect = ", I4, "     nStats = ", I4)
        call BL_PD_ABORT()
      endif

c
c
      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "ArrayLim.H"

#define SDIM 3

      subroutine TRANSV(v,DIMS(v),dx,domnlo,
     &     avVR,avVT,avVZ,Nbin,DIMS(av),maxbin)
      implicit none
      integer DIMDEC(v)
      integer DIMDEC(av)
      REAL_T  v(DIMV(v),SDIM)
      REAL_T avVR(DIMV(av))
      REAL_T avVT(DIMV(av))
      REAL_T avVZ(DIMV(av))
      integer Nbin(DIMV(av))
      REAL_T dx(SDIM), domnlo(SDIM)
      integer i,j,k,n,bsize,maxbin,bin
c      REAL_T binVRSQ(0:maxbin),binVTSQ(0:maxbin),binVZSQ(0:maxbin)
      REAL_T x,y,vx,vy,vz,vr,vt,rat,r,st,ct,kk
      integer ishift , ishm,npts
      integer irlo,irhi
      integer jrlo,jrhi
      integer krlo,krhi
      REAL_T  energy,scale,sum

      kk = ARG_L3(av)
      bsize = 5

      ishm = 1.5/dx(1)
      krlo = 1.5/dx(3)
      krhi = 4.5/dx(3)
      irlo = 1.5/dx(1)
      irhi = 3.0/dx(1)
      npts = (krhi-krlo+1)*(irhi-irlo+1)
      jrhi = ARG_H2(v)
      jrlo = jrhi - 50

      npts = npts *(jrhi-jrlo+1)
      

      scale = 0.d0

         sum = 0.d0

#if 1

      do j=jrlo,jrhi


         do k=krlo,krhi
            do i=irlo,irhi+ishm

              sum = sum+v(i,j,k,1)

            enddo
         enddo
         enddo

         sum = sum / ((krhi-krlo+1)*(irhi+ishm-irlo+1)*(jrhi-jrlo+1))

      do j=ARG_L2(v), ARG_H2(v)

         do k=krlo,krhi
            do i=irlo,irhi+ishm

              v(i,j,k,1)  = v(i,j,k,1) - sum

            enddo
         enddo
         enddo

#endif

      do ishift = 0,ishm

         sum = 0.d0

      do j=jrlo,jrhi
         do k=krlo,krhi
            do i=irlo,irhi

              sum = sum+v(i,j,k,1)*v(i+ishift,j,k,1)

            enddo
         enddo
         enddo

         sum = sum/npts
         if(ishift .eq.0)then
              energy = sum
         endif

         write(6,*)" level, shift",j,ishift,sum,sum/energy

         scale = scale + sum /energy

      enddo
         write(6,*)" scale",j,scale,scale*dx(1)

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** SETVELBC **
c ** Impose the physical boundary conditions on the velocity (u,v)
c *************************************************************************

      subroutine setvelbc(vel,DIMS,bc,irz,visc_coef,dx,time)

      implicit none

      integer DIMS
      REAL_T   vel(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      integer bc(2,2)
      integer irz
      REAL_T visc_coef
      REAL_T dx(2)
      REAL_T time

c     Local variables
      integer is,ie,js,je,i,j
      integer ilo,ihi
      integer ng

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2

c     NOTE: IF BC == WALL, THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL
c           BOUNDARY, NOT IN THE GHOST CELL

      ilo = cvmgt(is-3,is,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(ie+3,ie,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)

      if (BCY_LO .eq. WALL) then

        do ng = 1,3
        do i = ilo,ihi
          vel(i,js-ng,2) = zero
        enddo
        enddo

        do i = ilo,ihi
          vel(i,js-1,1) = (fifteen*vel(i,js  ,1) - ten*vel(i,js+1,1) + 
     $                       three*vel(i,js+2,1)) / eight
          vel(i,js-2,1) = vel(i,js-1,1)
          vel(i,js-3,1) = vel(i,js-1,1)
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do i = ilo,ihi
            vel(i,js-ng,1) = zero
          enddo
          enddo
        endif

      elseif (BCY_LO .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,2),DIMS,time,dx,1,0)

        do ng = 1,3
        do i = is-3,ie+3
          vel(i,js-ng,1) = zero
        enddo
        enddo

      elseif (BCY_LO .eq. OUTLET) then

        do ng = 1,3
        do i = ilo,ihi
          vel(i,js-ng,1) = vel(i,js,1)
          vel(i,js-ng,2) = vel(i,js,2)
        enddo
        enddo

      endif

      if (BCY_HI .eq. WALL) then

        do ng = 1,3
        do i = ilo,ihi
          vel(i,je+ng,2) = zero
        enddo
        enddo

        do i = ilo,ihi
          vel(i,je+1,1) = (fifteen*vel(i,je  ,1) - ten*vel(i,je-1,1) + 
     $                       three*vel(i,je-2,1)) / eight
          vel(i,je+2,1) = vel(i,je+1,1)
          vel(i,je+3,1) = vel(i,je+1,1)
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do i = ilo,ihi
            vel(i,je+ng,1) = zero
          enddo
          enddo
        endif

      elseif (BCY_HI .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,2),DIMS,time,dx,1,1)

        do ng = 1,3
        do i = is-3,ie+3
          vel(i,je+ng,1) = zero
        enddo
        enddo

      elseif (BCY_HI .eq. OUTLET) then

        do ng = 1,3
        do i = ilo,ihi
          vel(i,je+ng,1) = vel(i,je,1)
          vel(i,je+ng,2) = vel(i,je,2)
        enddo
        enddo

      endif

      if (BCX_LO .eq. WALL) then

        do ng = 1,3
        do j = js-3,je+3 
          vel(is-ng,j,1) = zero
        enddo
        enddo

        do j = js-3,je+3 
          vel(is-1,j,2) = (fifteen*vel(is  ,j,2) - ten*vel(is+1,j,2) + 
     $                       three*vel(is+2,j,2)) / eight
          vel(is-2,j,2) = vel(is-1,j,2)
          vel(is-3,j,2) = vel(is-1,j,2)
        enddo

        if (visc_coef .gt. zero .and. irz .eq. 0) then
          do ng = 1,3
          do j = js-3,je+3
            vel(is-ng,j,2) = zero
          enddo
          enddo
        endif

        if (irz .eq. 1) then
          do ng = 1,3
          do j = js-3,je+3 
             vel(is-ng,j,2) = vel(is+ng-1,j,2)
          enddo
          enddo
        endif

      elseif (BCX_LO .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,1),DIMS,time,dx,0,0)

        do ng = 1,3
        do j = js-3,je+3
          vel(is-ng,j,2) = zero
        enddo
        enddo

      elseif (BCX_LO .eq. OUTLET) then

        do ng = 1,3
        do j = js-3,je+3
          vel(is-ng,j,1) = vel(is,j,1)
          vel(is-ng,j,2) = vel(is,j,2)
        enddo
        enddo

      endif

      if (BCX_HI .eq. WALL) then

        do ng = 1,3
        do j = js-3,je+3 
          vel(ie+ng,j,1) = zero
        enddo
        enddo

        do j = js-3,je+3 
          vel(ie+1,j,2) = (fifteen*vel(ie  ,j,2) - ten*vel(ie-1,j,2) + 
     $                       three*vel(ie-2,j,2)) / eight
          vel(ie+2,j,2) = vel(ie+1,j,2)
          vel(ie+3,j,2) = vel(ie+1,j,2)
        enddo

        if (visc_coef .gt. zero) then
          do ng = 1,3
          do j = js-3,je+3
            vel(ie+ng,j,2) = zero
          enddo
          enddo
        endif

      elseif (BCX_HI .eq. INLET) then

        call velinflow(vel(lo_1-3,lo_2-3,1),DIMS,time,dx,0,1)

        do ng = 1,3
        do j = js-3,je+3
          vel(ie+ng,j,2) = zero
        enddo
        enddo

      elseif (BCX_HI .eq. OUTLET) then

        do ng = 1,3
        do j = js-3,je+3 
          vel(ie+ng,j,1) = vel(ie,j,1)
          vel(ie+ng,j,2) = vel(ie,j,2)
        enddo
        enddo

      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define SDIMS slo_1,slo_2,slo_3,shi_1,shi_2,shi_3

#if BL_USE_FLOAT
#define threehalves    1.5e0
#else
#define threehalves    1.5d0
#endif

c *************************************************************************
c ** SETSCALBC **
c ** Impose the physical boundary conditions on scalars s
c *************************************************************************

      subroutine setscalbc(s,DIMS,SDIMS,bc,which_scal,dx,time)

      implicit none

      integer DIMS
      integer SDIMS
      integer which_scal
      integer bc(2,3)
      REAL_T  dx(3)
      REAL_T  time
      REAL_T  s(slo_1:shi_1,slo_2:shi_2,slo_3:shi_3)

c     Local variables
      integer is,ie,js,je,ks,ke,i,j,k
      integer ilo,ihi,jlo,jhi
      integer ng,ngmax

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      ilo = cvmgt(slo_1,lo_1,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(shi_1,hi_1,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
      jlo = cvmgt(slo_2,lo_2,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
      jhi = cvmgt(shi_2,hi_2,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)
 
      ngmax = lo_1 - slo_1

c     NOTE: IF BC == WALL, THESE VALUES ARE DEFINED ON THE EDGE OF THE PHYSICAL
c           BOUNDARY, NOT IN THE GHOST CELL

      if (BCZ_LO .eq. WALL) then

        do ng = 1,ngmax
        do j = jlo,jhi
        do i = ilo,ihi
c         s(i,j,ks-1) = threehalves*s(i,j,ks) - half*s(i,j,ks+1)
          s(i,j,ks-ng) = s(i,j,ks)
        enddo
        enddo
        enddo

      elseif (BCZ_LO .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,2,0,which_scal)

      elseif (BCZ_LO .eq. OUTLET) then

        do ng = 1,ngmax
        do j = jlo,jhi
        do i = ilo,ihi
c         s(i,j,ks-1) = threehalves*s(i,j,ks) - half*s(i,j,ks+1)
          s(i,j,ks-ng) = s(i,j,ks)
        enddo
        enddo
        enddo

      endif

      if (BCZ_HI .eq. WALL) then

        do ng = 1,ngmax
        do j = jlo,jhi
        do i = ilo,ihi
c         s(i,j,ke+1) = threehalves*s(i,j,ke) - half*s(i,j,ke-1)
          s(i,j,ke+ng) = s(i,j,ke)
        enddo
        enddo
        enddo

      elseif (BCZ_HI .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,2,1,which_scal)

      elseif (BCZ_HI .eq. OUTLET) then

        do ng = 1,ngmax
        do j = jlo,jhi
        do i = ilo,ihi
c         s(i,j,ke+1) = threehalves*s(i,j,ke) - half*s(i,j,ke-1)
          s(i,j,ke+ng) = s(i,j,ke)
        enddo
        enddo
        enddo

      endif

      if (BCY_LO .eq. WALL) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do i = ilo,ihi
c         s(i,js-1,k) = threehalves*s(i,js,k) - half*s(i,js+1,k)
          s(i,js-ng,k) = s(i,js,k)
        enddo
        enddo
        enddo

      elseif (BCY_LO .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,1,0,which_scal)

      elseif (BCY_LO .eq. OUTLET) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do i = ilo,ihi
c         s(i,js-1,k) = threehalves*s(i,js,k) - half*s(i,js+1,k)
          s(i,js-ng,k) = s(i,js,k)
        enddo
        enddo
        enddo

      endif

      if (BCY_HI .eq. WALL) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do i = ilo,ihi
c         s(i,je+1,k) = threehalves*s(i,je,k) - half*s(i,je-1,k)
          s(i,je+ng,k) = s(i,je,k)
        enddo
        enddo
        enddo

      elseif (BCY_HI .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,1,1,which_scal)

      elseif (BCY_HI .eq. OUTLET) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do i = ilo,ihi
c         s(i,je+1,k) = threehalves*s(i,je,k) - half*s(i,je-1,k)
          s(i,je+ng,k) = s(i,je,k)
        enddo
        enddo
        enddo

      endif

      if (BCX_LO .eq. WALL) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do j = slo_2,shi_2
c         s(is-1,j,k) = threehalves*s(is,j,k) - half*s(is+1,j,k)
          s(is-ng,j,k) = s(is,j,k)
        enddo
        enddo
        enddo

      elseif (BCX_LO .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,0,0,which_scal)

      elseif (BCX_LO .eq. OUTLET) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do j = slo_2,shi_2
c         s(is-1,j,k) = threehalves*s(is,j,k) - half*s(is+1,j,k)
          s(is-ng,j,k) = s(is,j,k)
        enddo
        enddo
        enddo

      endif

      if (BCX_HI .eq. WALL) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do j = slo_2,shi_2
c         s(ie+1,j,k) = threehalves*s(ie,j,k) - half*s(ie-1,j,k)
          s(ie+ng,j,k) = s(ie,j,k)
        enddo
        enddo
        enddo

      elseif (BCX_HI .eq. INLET) then

        call scalinflow(s,DIMS,SDIMS,time,dx,0,1,which_scal)

      elseif (BCX_HI .eq. OUTLET) then

        do ng = 1,ngmax
        do k = slo_3,shi_3
        do j = slo_2,shi_2
c         s(ie+1,j,k) = threehalves*s(ie,j,k) - half*s(ie-1,j,k)
          s(ie+ng,j,k) = s(ie,j,k)
        enddo
        enddo
        enddo

      endif

      return
      end

c-----------------------------------------------------------------------
      subroutine hgavg(
     & src, srcl0, srch0, srcl1, srch1, srcl2, srch2,
     & rf,  fl0, fh0, fl1, fh1, fl2, fh2,
     &      fregl0, fregh0, fregl1, fregh1, fregl2, fregh2)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer fregl0,fregh0,fregl1,fregh1,fregl2,fregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision rf(fl0:fh0,fl1:fh1,fl2:fh2)
      double precision fac
      parameter (fac = 0.1250D0)
      integer i, j, k
      do k = fregl2, fregh2
         do j = fregl1, fregh1
            do i = fregl0, fregh0
               src(i,j,k) = src(i,j,k) + fac *
     &              (rf(i-1,j-1,k-1) + rf(i-1,j-1,k) +
     &               rf(i-1,j,k-1)   + rf(i-1,j,k) +
     &               rf(i,j-1,k-1)   + rf(i,j-1,k) +
     &               rf(i,j,k-1)     + rf(i,j,k))
            end do
         end do
      end do
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgfavg(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & rc,  cl0,ch0,cl1,ch1,cl2,ch2,
     & rf,  fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & ir, jr, kr, idim, idir)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision rc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision rf(fl0:fh0,fl1:fh1,fl2:fh2)
      integer ir, jr, kr, idim, idir
      double precision fac0, fac1, fac
      integer i, j, k, irc, irf, jrc, jrf, krc, krf, l, m, n
      if (idim .eq. 0) then
         i = cregl0
         if (idir .eq. 1) then
            irc = i - 1
            irf = i * ir
         else
            irc = i
            irf = i * ir - 1
         end if
         fac0 = 0.25D0 * ir / (ir+1)
         do k = cregl2, cregh2
            do j = cregl1, cregh1
               src(i*ir,j*jr,k*kr) =
     &            src(i*ir,j*jr,k*kr) + fac0 *
     &              (rc(irc,j,k)   + rc(irc,j,k-1) +
     &               rc(irc,j-1,k) + rc(irc,j-1,k-1))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * jr * kr)
         i = i * ir
         do l = 0, kr-1
            fac1 = (kr-l) * fac0
            if (l .eq. 0) fac1 = 0.5D0 * fac1
            do n = 0, jr-1
               fac = (jr-n) * fac1
               if (n .eq. 0) fac = 0.5D0 * fac
               do k = kr*cregl2, kr*cregh2, kr
                  do j = jr*cregl1, jr*cregh1, jr
                     src(i,j,k) = src(i,j,k) + fac *
     &                 (rf(irf,j-n,k-l) + rf(irf,j-n,k-l-1) +
     &                  rf(irf,j-n-1,k-l) + rf(irf,j-n-1,k-l-1) +
     &                  rf(irf,j-n,k+l) + rf(irf,j-n,k+l-1) +
     &                  rf(irf,j-n-1,k+l) + rf(irf,j-n-1,k+l-1) +
     &                  rf(irf,j+n,k-l) + rf(irf,j+n,k-l-1) +
     &                  rf(irf,j+n-1,k-l) + rf(irf,j+n-1,k-l-1) +
     &                  rf(irf,j+n,k+l) + rf(irf,j+n,k+l-1) +
     &                  rf(irf,j+n-1,k+l) + rf(irf,j+n-1,k+l-1))
                  end do
               end do
            end do
         end do
      else if (idim .eq. 1) then
         j = cregl1
         if (idir .eq. 1) then
            jrc = j - 1
            jrf = j * jr
         else
            jrc = j
            jrf = j * jr - 1
         end if
         fac0 = 0.25D0 * jr / (jr+1)
         do k = cregl2, cregh2
            do i = cregl0, cregh0
               src(i*ir,j*jr,k*kr) =
     &            src(i*ir,j*jr,k*kr) + fac0 *
     &           (rc(i,jrc,k)   + rc(i-1,jrc,k) +
     &            rc(i,jrc,k-1) + rc(i-1,jrc,k-1))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * ir * kr)
         j = j * jr
         do l = 0, kr-1
            fac1 = (kr-l) * fac0
            if (l .eq. 0) fac1 = 0.5D0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5D0 * fac
               do k = kr*cregl2, kr*cregh2, kr
                  do i = ir*cregl0, ir*cregh0, ir
                     src(i,j,k) = src(i,j,k) + fac *
     &                 (rf(i-m,jrf,k-l) + rf(i-m-1,jrf,k-l) +
     &                  rf(i-m,jrf,k-l-1) + rf(i-m-1,jrf,k-l-1) +
     &                  rf(i-m,jrf,k+l) + rf(i-m-1,jrf,k+l) +
     &                  rf(i-m,jrf,k+l-1) + rf(i-m-1,jrf,k+l-1) +
     &                  rf(i+m,jrf,k-l) + rf(i+m-1,jrf,k-l) +
     &                  rf(i+m,jrf,k-l-1) + rf(i+m-1,jrf,k-l-1) +
     &                  rf(i+m,jrf,k+l) + rf(i+m-1,jrf,k+l) +
     &                  rf(i+m,jrf,k+l-1) + rf(i+m-1,jrf,k+l-1))
                  end do
               end do
            end do
         end do
      else
         k = cregl2
         if (idir .eq. 1) then
            krc = k - 1
            krf = k * kr
         else
            krc = k
            krf = k * kr - 1
         end if
         fac0 = 0.25D0 * kr / (kr+1)
         do j = cregl1, cregh1
            do i = cregl0, cregh0
               src(i*ir,j*jr,k*kr) =
     &            src(i*ir,j*jr,k*kr) + fac0 *
     &           (rc(i,j,krc)   + rc(i-1,j,krc) +
     &            rc(i,j-1,krc) + rc(i-1,j-1,krc))
            end do
         end do
         fac0 = fac0 / (ir * jr * kr * ir * jr)
         k = k * kr
         do n = 0, jr-1
            fac1 = (jr-n) * fac0
            if (n .eq. 0) fac1 = 0.5D0 * fac1
            do m = 0, ir-1
               fac = (ir-m) * fac1
               if (m .eq. 0) fac = 0.5D0 * fac
               do j = jr*cregl1, jr*cregh1, jr
                  do i = ir*cregl0, ir*cregh0, ir
                     src(i,j,k) = src(i,j,k) + fac *
     &                 (rf(i-m,j-n,krf) + rf(i-m-1,j-n,krf) +
     &                  rf(i-m,j-n-1,krf) + rf(i-m-1,j-n-1,krf) +
     &                  rf(i-m,j+n,krf) + rf(i-m-1,j+n,krf) +
     &                  rf(i-m,j+n-1,krf) + rf(i-m-1,j+n-1,krf) +
     &                  rf(i+m,j-n,krf) + rf(i+m-1,j-n,krf) +
     &                  rf(i+m,j-n-1,krf) + rf(i+m-1,j-n-1,krf) +
     &                  rf(i+m,j+n,krf) + rf(i+m-1,j+n,krf) +
     &                  rf(i+m,j+n-1,krf) + rf(i+m-1,j+n-1,krf))
                  end do
               end do
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgeavg(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & rc,  cl0,ch0,cl1,ch1,cl2,ch2,
     & rf,  fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & ir, jr, kr, ga, ivect)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision rc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision rf(fl0:fh0,fl1:fh1,fl2:fh2)
      integer ir, jr, kr, ivect(0:2), ga(0:1,0:1,0:1)
      double precision rm3, center, cfac, ffac, fac0, fac1, fac
      integer ic, jc, kc, if, jf, kf, ii, ji, ki
      integer irc, irf, jrc, jrf, krc, krf, idir, jdir, kdir, l, m, n
      rm3 = 1.0D0 / (ir * jr * kr)
      ic = cregl0
      jc = cregl1
      kc = cregl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      center = 0.0D0
      if (ivect(0) .eq. 0) then
c quadrants
c each quadrant is two octants and their share of the two central edges
         ffac = 2.0D0 * ir * rm3
         cfac = 2.0D0
         do ki = 0, 1
            do ji = 0, 1
               if (ga(0,ji,ki) .eq. 1) then
                  center = center + ffac
               else
                  center = center + cfac
               end if
            end do
         end do
         do ki = 0, 1
            do ji = 0, 1
               if (ga(0,ji,ki) - ga(0,ji,1-ki) .eq. 1) then
                  ffac = 2.0D0 * ir * (jr - 1) * rm3
                  center = center + ffac
               end if
               if (ga(0,ji,ki) - ga(0,1-ji,ki) .eq. 1) then
                  ffac = 2.0D0 * ir * (kr - 1) * rm3
                  center = center + ffac
               end if
            end do
         end do
         center = 1.0D0 / center
         fac1 = center * rm3 / ir
         do ki = 0, 1
            do ji = 0, 1
               if (ga(0,ji,ki) .eq. 1) then
                  krf = kf + ki - 1
                  jrf = jf + ji - 1
                  do m = 0, ir-1
                     fac = (ir-m) * fac1
                     if (m .eq. 0) fac = 0.5D0 * fac
                     do if = ir*cregl0, ir*cregh0, ir
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                    (rf(if-m,jrf,krf) + rf(if-m-1,jrf,krf) +
     &                     rf(if+m,jrf,krf) + rf(if+m-1,jrf,krf))
                     end do
                  end do
               else
                  krc = kc + ki - 1
                  jrc = jc + ji - 1
                  do ic = cregl0, cregh0
                     if = ic * ir
                     src(if,jf,kf) = src(if,jf,kf) + center *
     &                 (rc(ic,jrc,krc) + rc(ic-1,jrc,krc))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ji = 0, 1
               jdir = 2 * ji - 1
               if (ga(0,ji,ki) - ga(0,ji,1-ki) .eq. 1) then
                  krf = kf + ki - 1
                  fac0 = center * rm3 / (ir * jr)
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*cregl0, ir*cregh0, ir
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                    (rf(if-m,jf+n,krf) + rf(if-m-1,jf+n,krf) +
     &                     rf(if-m,jf+n-1,krf) + rf(if-m-1,jf+n-1,krf) +
     &                     rf(if+m,jf+n,krf) + rf(if+m-1,jf+n,krf) +
     &                     rf(if+m,jf+n-1,krf) + rf(if+m-1,jf+n-1,krf))
                        end do
                     end do
                  end do
               end if
               if (ga(0,ji,ki) - ga(0,1-ji,ki) .eq. 1) then
                  jrf = jf + ji - 1
                  fac0 = center * rm3 / (ir * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = 0, ir-1
                        fac = (ir-m) * fac1
                        if (m .eq. 0) fac = 0.5D0 * fac
                        do if = ir*cregl0, ir*cregh0, ir
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                    (rf(if-m,jrf,kf+l) + rf(if-m-1,jrf,kf+l) +
     &                     rf(if-m,jrf,kf+l-1) + rf(if-m-1,jrf,kf+l-1) +
     &                     rf(if+m,jrf,kf+l) + rf(if+m-1,jrf,kf+l) +
     &                     rf(if+m,jrf,kf+l-1) + rf(if+m-1,jrf,kf+l-1))
                        end do
                     end do
                  end do
               end if
            end do
         end do
      else if (ivect(1) .eq. 0) then
c quadrants
c each quadrant is two octants and their share of the two central edges
         ffac = 2.0D0 * jr * rm3
         cfac = 2.0D0
         do ki = 0, 1
            do ii = 0, 1
               if (ga(ii,0,ki) .eq. 1) then
                  center = center + ffac
               else
                  center = center + cfac
               end if
            end do
         end do
         do ki = 0, 1
            do ii = 0, 1
               if (ga(ii,0,ki) - ga(ii,0,1-ki) .eq. 1) then
                  ffac = 2.0D0 * jr * (ir - 1) * rm3
                  center = center + ffac
               end if
               if (ga(ii,0,ki) - ga(1-ii,0,ki) .eq. 1) then
                  ffac = 2.0D0 * jr * (kr - 1) * rm3
                  center = center + ffac
               end if
            end do
         end do
         center = 1.0D0 / center
         fac1 = center * rm3 / jr
         do ki = 0, 1
            do ii = 0, 1
               if (ga(ii,0,ki) .eq. 1) then
                  krf = kf + ki - 1
                  irf = if + ii - 1
                  do n = 0, jr-1
                     fac = (jr-n) * fac1
                     if (n .eq. 0) fac = 0.5D0 * fac
                     do jf = jr*cregl1, jr*cregh1, jr
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                    (rf(irf,jf-n,krf) + rf(irf,jf-n-1,krf) +
     &                     rf(irf,jf+n,krf) + rf(irf,jf+n-1,krf))
                     end do
                  end do
               else
                  krc = kc + ki - 1
                  irc = ic + ii - 1
                  do jc = cregl1, cregh1
                     jf = jc * jr
                     src(if,jf,kf) = src(if,jf,kf) + center *
     &                 (rc(irc,jc,krc) + rc(irc,jc-1,krc))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ki = 0, 1
            kdir = 2 * ki - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,0,ki) - ga(ii,0,1-ki) .eq. 1) then
                  krf = kf + ki - 1
                  fac0 = center * rm3 / (ir * jr)
                  do  n = 0, jr-1
                     fac1 = (jr-n) * fac0
                     if (n .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do jf = jr*cregl1, jr*cregh1, jr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                   (rf(if+m,jf-n,krf) + rf(if+m-1,jf-n,krf) +
     &                    rf(if+m,jf-n-1,krf) + rf(if+m-1,jf-n-1,krf) +
     &                    rf(if+m,jf+n,krf) + rf(if+m-1,jf+n,krf) +
     &                    rf(if+m,jf+n-1,krf) + rf(if+m-1,jf+n-1,krf))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,0,ki) - ga(1-ii,0,ki) .eq. 1) then
                  irf = if + ii - 1
                  fac0 = center * rm3 / (jr * kr)
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = 0, jr-1
                        fac = (jr-n) * fac1
                        if (n .eq. 0) fac = 0.5D0 * fac
                        do jf = jr*cregl1, jr*cregh1, jr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                  (rf(irf,jf-n,kf+l) + rf(irf,jf-n-1,kf+l) +
     &                   rf(irf,jf-n,kf+l-1) + rf(irf,jf-n-1,kf+l-1) +
     &                   rf(irf,jf+n,kf+l) + rf(irf,jf+n-1,kf+l) +
     &                   rf(irf,jf+n,kf+l-1) + rf(irf,jf+n-1,kf+l-1))
                        end do
                     end do
                  end do
               end if
            end do
         end do
      else
c quadrants
c each quadrant is two octants and their share of the two central edges
         ffac = 2.0D0 * kr * rm3
         cfac = 2.0D0
         do ji = 0, 1
            do ii = 0, 1
               if (ga(ii,ji,0) .eq. 1) then
                  center = center + ffac
               else
                  center = center + cfac
               end if
            end do
         end do
         do ji = 0, 1
            do ii = 0, 1
               if (ga(ii,ji,0) - ga(ii,1-ji,0) .eq. 1) then
                  ffac = 2.0D0 * kr * (ir - 1) * rm3
                  center = center + ffac
               end if
               if (ga(ii,ji,0) - ga(1-ii,ji,0) .eq. 1) then
                  ffac = 2.0D0 * kr * (jr - 1) * rm3
                  center = center + ffac
               end if
            end do
         end do
         center = 1.0D0 / center
         fac1 = center * rm3 / kr
         do ji = 0, 1
            do ii = 0, 1
               if (ga(ii,ji,0) .eq. 1) then
                  jrf = jf + ji - 1
                  irf = if + ii - 1
                  do l = 0, kr-1
                     fac = (kr-l) * fac1
                     if (l .eq. 0) fac = 0.5D0 * fac
                     do kf = kr*cregl2, kr*cregh2, kr
                        src(if,jf,kf) = src(if,jf,kf) + fac *
     &                    (rf(irf,jrf,kf-l) + rf(irf,jrf,kf-l-1) +
     &                     rf(irf,jrf,kf+l) + rf(irf,jrf,kf+l-1))
                     end do
                  end do
               else
                  jrc = jc + ji - 1
                  irc = ic + ii - 1
                  do kc = cregl2, cregh2
                     kf = kc * kr
                     src(if,jf,kf) = src(if,jf,kf) + center *
     &                 (rc(irc,jrc,kc) + rc(irc,jrc,kc-1))
                  end do
               end if
            end do
         end do
c faces
c each face is two faces and two sides of an edge
         do ji = 0, 1
            jdir = 2 * ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               if (ga(ii,ji,0) - ga(ii,1-ji,0) .eq. 1) then
                  jrf = jf + ji - 1
                  fac0 = center * rm3 / (ir * kr)
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        do kf = kr*cregl2, kr*cregh2, kr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                  (rf(if+m,jrf,kf-l) + rf(if+m-1,jrf,kf-l) +
     &                   rf(if+m,jrf,kf-l-1) + rf(if+m-1,jrf,kf-l-1) +
     &                   rf(if+m,jrf,kf+l) + rf(if+m-1,jrf,kf+l) +
     &                   rf(if+m,jrf,kf+l-1) + rf(if+m-1,jrf,kf+l-1))
                        end do
                     end do
                  end do
               end if
               if (ga(ii,ji,0) - ga(1-ii,ji,0) .eq. 1) then
                  irf = if + ii - 1
                  fac0 = center * rm3 / (jr * kr)
                  do l = 0, kr-1
                     fac1 = (kr-l) * fac0
                     if (l .eq. 0) fac1 = 0.5D0 * fac1
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        do kf = kr*cregl2, kr*cregh2, kr
                           src(if,jf,kf) = src(if,jf,kf) + fac *
     &                  (rf(irf,jf+n,kf-l) + rf(irf,jf+n-1,kf-l) +
     &                   rf(irf,jf+n,kf-l-1) + rf(irf,jf+n-1,kf-l-1) +
     &                   rf(irf,jf+n,kf+l) + rf(irf,jf+n-1,kf+l) +
     &                   rf(irf,jf+n,kf+l-1) + rf(irf,jf+n-1,kf+l-1))
                        end do
                     end do
                  end do
               end if
            end do
         end do
      end if
      end
c-----------------------------------------------------------------------
c Note---only generates values at coarse points along edge of fine grid
      subroutine hgcavg(
     & src, srcl0,srch0,srcl1,srch1,srcl2,srch2,
     & rc,  cl0,ch0,cl1,ch1,cl2,ch2,
     & rf,  fl0,fh0,fl1,fh1,fl2,fh2,
     &      cregl0,cregh0,cregl1,cregh1,cregl2,cregh2,
     & ir, jr, kr, ga, idd)
      integer srcl0,srch0,srcl1,srch1,srcl2,srch2
      integer cl0,ch0,cl1,ch1,cl2,ch2
      integer fl0,fh0,fl1,fh1,fl2,fh2
      integer cregl0,cregh0,cregl1,cregh1,cregl2,cregh2
      double precision src(srcl0:srch0,srcl1:srch1,srcl2:srch2)
      double precision rc(cl0:ch0,cl1:ch1,cl2:ch2)
      double precision rf(fl0:fh0,fl1:fh1,fl2:fh2)
      integer ir, jr, kr, ga(0:1,0:1,0:1), idd
      double precision rm3, sum, center, cfac, ffac, fac0, fac1, fac
      integer ic, jc, kc, if, jf, kf, ii, ji, ki
      integer irc, irf, jrc, jrf, krc, krf, idir, jdir, kdir, l, m, n
      rm3 = 1.0D0 / (ir * jr * kr)
      ic = cregl0
      jc = cregl1
      kc = cregl2
      if = ic * ir
      jf = jc * jr
      kf = kc * kr
      sum = 0.0D0
      center = 0.0D0
c octants
      fac = rm3
      ffac = rm3
      cfac = 1.0D0
      do ki = 0, 1
         krf = kf + ki - 1
         krc = kc + ki - 1
         do ji = 0, 1
            jrf = jf + ji - 1
            jrc = jc + ji - 1
            do ii = 0, 1
               if (ga(ii,ji,ki) .eq. 1) then
                  irf = if + ii - 1
                  center = center + ffac
                  sum = sum + fac * rf(irf,jrf,krf)
               else
                  irc = ic + ii - 1
                  center = center + cfac
                  sum = sum + rc(irc,jrc,krc)
               end if
            end do
         end do
      end do
c faces
      do ki = 0, 1
         kdir = 2 * ki - 1
         krf = kf + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            jrf = jf + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               irf = if + ii - 1
               if (ga(ii,ji,ki) - ga(ii,ji,1-ki) .eq. 1) then
                  fac0 = rm3 / (ir * jr)
                  ffac = (ir-1) * (jr-1) * rm3
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac1 = (jr-abs(n)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac *
     &                    (rf(if+m,jf+n,krf) + rf(if+m-1,jf+n,krf) +
     &                     rf(if+m,jf+n-1,krf) + rf(if+m-1,jf+n-1,krf))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(ii,1-ji,ki) .eq. 1) then
                  fac0 = rm3 / (ir * kr)
                  ffac = (ir-1) * (kr-1) * rm3
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do m = idir, idir*(ir-1), idir
                        fac = (ir-abs(m)) * fac1
                        sum = sum + fac *
     &                    (rf(if+m,jrf,kf+l) + rf(if+m-1,jrf,kf+l) +
     &                     rf(if+m,jrf,kf+l-1) + rf(if+m-1,jrf,kf+l-1))
                     end do
                  end do
               end if
               if (ga(ii,ji,ki) - ga(1-ii,ji,ki) .eq. 1) then
                  fac0 = rm3 / (jr * kr)
                  ffac = (jr-1) * (kr-1) * rm3
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac1 = (kr-abs(l)) * fac0
                     do n = jdir, jdir*(jr-1), jdir
                        fac = (jr-abs(n)) * fac1
                        sum = sum + fac *
     &                    (rf(irf,jf+n,kf+l) + rf(irf,jf+n,kf+l-1) +
     &                     rf(irf,jf+n-1,kf+l) + rf(irf,jf+n-1,kf+l-1))
                     end do
                  end do
               end if
            end do
         end do
      end do
c edges
      do ki = 0, 1
         kdir = 2 * ki - 1
         krf = kf + ki - 1
         do ji = 0, 1
            jdir = 2 * ji - 1
            jrf = jf + ji - 1
            do ii = 0, 1
               idir = 2 * ii - 1
               irf = if + ii - 1
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(ii,1-ji,ki), ga(ii,1-ji,1-ki))
     &             .eq. 1) then
                  fac1 = rm3 / ir
                  ffac = (ir-1) * rm3
                  center = center + ffac
                  do m = idir, idir*(ir-1), idir
                     fac = (ir-abs(m)) * fac1
                     sum = sum + fac *
     &                 (rf(if+m,jrf,krf) + rf(if+m-1,jrf,krf))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,ji,1-ki), ga(1-ii,ji,ki), ga(1-ii,ji,1-ki))
     &             .eq. 1) then
                  fac1 = rm3 / jr
                  ffac = (jr-1) * rm3
                  center = center + ffac
                  do n = jdir, jdir*(jr-1), jdir
                     fac = (jr-abs(n)) * fac1
                     sum = sum + fac *
     &                 (rf(irf,jf+n,krf) + rf(irf,jf+n-1,krf))
                  end do
               end if
               if (ga(ii,ji,ki) -
     &             min(ga(ii,1-ji,ki), ga(1-ii,ji,ki), ga(1-ii,1-ji,ki))
     &             .eq. 1) then
                  fac1 = rm3 / kr
                  ffac = (kr-1) * rm3
                  center = center + ffac
                  do l = kdir, kdir*(kr-1), kdir
                     fac = (kr-abs(l)) * fac1
                     sum = sum + fac *
     &                 (rf(irf,jrf,kf+l) + rf(irf,jrf,kf+l-1))
                  end do
               end if
            end do
         end do
      end do
c weighting
      src(if,jf,kf) = src(if,jf,kf) + sum / center
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "ArrayLim.H"

#define SDIM 3

      subroutine AVGPLANE(v,DIMS(v),avg,DIMS(avg),jlo,jhi)
      implicit none
      integer DIMDEC(v)
      integer DIMDEC(avg)
      integer jlo, jhi
      REAL_T   v(DIMV(v))
      REAL_T avg(DIMV(avg))
      integer i,j,k,jj,N

      jj = ARG_L2(avg)
      do k=ARG_L3(v),ARG_H3(v)
         do i=ARG_L1(v),ARG_H1(v)
            avg(i,jj,k) = 0.d0
            do j=jlo,jhi
               avg(i,jj,k) = avg(i,jj,k) + v(i,j,k)
            enddo
            N = jhi - jlo + 1
            avg(i,jj,k) = avg(i,jj,k) / N
         enddo
      enddo
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: MACOPERATOR_2D.F,v 1.8 2003/02/05 22:11:42 almgren Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "MACOPERATOR_F.H"
#include "ArrayLim.H"

#define SDIM 2

c :: ----------------------------------------------------------
c :: MACCOEF
c ::             Compute the coefficents for MAC solve
c ::
c :: INPUTS / OUTPUTS:
c ::  cx,cy       <=  edge coef arrays
c ::  DIMS(cx)     => index limits for cx
c ::  DIMS(cy)     => index limits for cy
c ::  lo,hi        => index limits for rhs
c ::  ax,ay        => edge based area arrays
c ::  DIMS(ax)     => index limits for ax
c ::  DIMS(ay)     => index limits for ay
c ::  rho          => cell centered density array
c ::  DIMS(rho)    => index limits for rho
c ::  dx           => cell size
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACCOEF (cx,DIMS(cx),cy,DIMS(cy),
     &                          ax,DIMS(ax),ay,DIMS(ay),
     &                          rho,DIMS(rho),lo,hi,dx)
       integer DIMDEC(cx)
       integer DIMDEC(cy)
       integer DIMDEC(ax)
       integer DIMDEC(ay)
       integer DIMDEC(rho)
       integer lo(SDIM), hi(SDIM)
       REAL_T  dx(SDIM)
       REAL_T  cx(DIMV(cx))
       REAL_T  cy(DIMV(cy))
       REAL_T  ax(DIMV(ax))
       REAL_T  ay(DIMV(ay))
       REAL_T  rho(DIMV(rho))

       integer i, j
       REAL_T rhoavg

       do j = lo(2), hi(2)
          do i = lo(1), hi(1)
            if (rho(i,j) .lt. zero) then
	      print *,' '
	      print *,'TESTING in MACCOEF '
	      print *,'RHO HAS GONE NEGATIVE AT ',i,j,rho(i,j)
              call bl_abort(" ")
            end if
          end do
       end do
c
c      ::::: finish coef in X direction (part 2)
c
       do j = lo(2), hi(2)
          do i = lo(1), hi(1)+1
             rhoavg = half * (rho(i,j) + rho(i-1,j))
             cx(i,j) = dx(1) * ax(i,j) / rhoavg
          end do
       end do
c
c      ::::: finish coef in Y direction (part 2)
c
       do j = lo(2), hi(2)+1
          do i = lo(1), hi(1)
             rhoavg = half * (rho(i,j) + rho(i,j-1))
             cy(i,j) = dx(2) * ay(i,j) / rhoavg
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: MACRHS
c ::             Compute the RHS for MAC solve
c ::
c :: INPUTS / OUTPUTS:
c ::  ux,uy       <=  edge velocity arrays
c ::  DIMS(ux)     => index limits for ux
c ::  DIMS(uy)     => index limits for uy
c ::  lo,hi        => index limits for rhs
c ::  ax,ay        => edge based area arrays
c ::  DIMS(ax)     => index limits for ax
c ::  DIMS(ay)     => index limits for ay
c ::  vol          => cell centered volume array
c ::  vlo,vhi      => index limits of vol array
c ::  DIMS(vol)    => index limits for vol
c ::  rhs         <=> cell centered rhs array
c ::  DIMS(rhs)    => index limits for rhs
c ::  scale        => scale factor
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACRHS (ux,DIMS(ux),uy,DIMS(uy),
     &                         ax,DIMS(ax),ay,DIMS(ay),
     &                         vol,DIMS(vol),rhs,DIMS(rhs),
     &                         lo,hi,scale)
       integer DIMDEC(ux)
       integer DIMDEC(uy)
       integer DIMDEC(ax)
       integer DIMDEC(ay)
       integer DIMDEC(vol)
       integer DIMDEC(rhs)
       integer lo(SDIM), hi(SDIM)
       REAL_T  scale
       REAL_T  ux(DIMV(ux))
       REAL_T  uy(DIMV(uy))
       REAL_T  ax(DIMV(ax))
       REAL_T  ay(DIMV(ay))
       REAL_T  vol(DIMV(vol))
       REAL_T  rhs(DIMV(rhs))

       integer i, j
       REAL_T  divu
c
c      ::::: rhs holds the divergence condition (possibly zero)
c
       do j = lo(2), hi(2)
          do i = lo(1), hi(1)
             divu = ax(i+1,j)*ux(i+1,j) - ax(i,j)*ux(i,j)
     &            + ay(i,j+1)*uy(i,j+1) - ay(i,j)*uy(i,j)
             rhs(i,j) = scale*(divu - vol(i,j)*rhs(i,j))
          end do
       end do
 
       end

c :: ----------------------------------------------------------
c :: MACUPDATE
c ::             Compute the update to velocity field to
c ::             make it divergence free
c ::
c :: INPUTS / OUTPUTS:
c ::  ux,uy       <=  edge based velocity arrays
c ::  DIMS(ux)     => index limits for ux
c ::  DIMS(uy)     => index limits for uy
c ::  phi          => soln from MAC project
c ::  DIMS(phi)    => index limits for phi
c ::  rho          => density at time N
c ::  DIMS(rho)    => index limits for rho
c ::  dx           => cell size
c ::  mult         => scalar multiplier
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACUPDATE(init,ux,DIMS(ux),uy,DIMS(uy),
     &                           phi,DIMS(phi),rho,DIMS(rho),
     &                           lo,hi,dx,mult)

       integer DIMDEC(ux)
       integer DIMDEC(uy)
       integer DIMDEC(phi)
       integer DIMDEC(rho)
       integer lo(SDIM), hi(SDIM)
       REAL_T  ux(DIMV(ux))
       REAL_T  uy(DIMV(uy))
       REAL_T  phi(DIMV(phi))
       REAL_T  rho(DIMV(rho))
       REAL_T  dx(SDIM), mult
       integer init

       integer i, j
       REAL_T  rhoavg, gp
c
c     set values to 0.0 if initializing
c
       if ( init .eq. 1 ) then
          do j = ARG_L2(ux), ARG_H2(ux)
             do i = ARG_L1(ux), ARG_H1(ux)
                ux(i,j) = zero
             end do
          end do
          do j = ARG_L2(uy), ARG_H2(uy)
             do i = ARG_L1(uy), ARG_H1(uy)
                uy(i,j) = zero
             end do
          end do
       end if
c
c     compute the x mac gradient
c
       do j = lo(2),hi(2)
          do i = lo(1),hi(1)+1
             rhoavg = half*(rho(i,j) + rho(i-1,j))
             gp = (phi(i,j)-phi(i-1,j))/dx(1)
             ux(i,j) = ux(i,j) + mult * gp / rhoavg
          end do
       end do
c
c      compute the y mac gradient
c
       do j = lo(2),hi(2)+1
          do i = lo(1),hi(1)
             rhoavg = half*(rho(i,j) + rho(i,j-1))
             gp = (phi(i,j)-phi(i,j-1))/dx(2)
             uy(i,j) = uy(i,j) + mult * gp / rhoavg
          end do
       end do

       end

c :: ----------------------------------------------------------
c :: MACSYNCRHS
c ::        Modify the RHS for MAC SYNC solve
c ::
c :: INPUTS / OUTPUTS:
c ::  rhs         <=  right hand side array
c ::  DIMS(rhs)    => index limits for rhs
c ::  vol          => cell centered volume array
c ::  DIMS(vol)    => index limits of vol array
c ::  rhsscale     => const multiplier to rhs
c :: ----------------------------------------------------------
c ::
       subroutine FORT_MACSYNCRHS(rhs,DIMS(rhs),lo,hi,
     &                            vol,DIMS(vol),rhsscale)
       integer DIMDEC(rhs)
       integer DIMDEC(vol)
       integer lo(SDIM), hi(SDIM)
       REAL_T  rhsscale
       REAL_T  rhs(DIMV(rhs))
       REAL_T  vol(DIMV(vol))

       integer i, j
c
c      ::::: multiply by volume since reflux step (which computed rhs)
c      ::::: divided by volume.
c
       do j = lo(2), hi(2)
          do i = lo(1), hi(1)
             rhs(i,j) = rhsscale*vol(i,j)*rhs(i,j)
          end do
       end do

       end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "HGPROJ_F.H"
#include "BCTypes.H"

#if BL_USE_FLOAT
#define sixteenth  .0625e0
#else
#define sixteenth  .0625d0
#endif

#define DIMS lo_1,lo_2,hi_1,hi_2
#define CDIMS loc_1,loc_2,hic_1,hic_2
#define GDIMS g_lo_1,g_lo_2,g_hi_1,g_hi_2
#define PDIMS p_lo_1,p_lo_2,p_hi_1,p_hi_2

#define NINEPT

c *************************************************************************
c ** GRADHG **
c ** Compute the cell-centered gradient of the nodal pressure field
c *************************************************************************

      subroutine FORT_GRADHG(gphi,GDIMS,phi,PDIMS,DIMS,dx)

      implicit none

      integer DIMS
      integer p_lo_1, p_lo_2
      integer p_hi_1, p_hi_2
      integer g_lo_1, g_lo_2
      integer g_hi_1, g_hi_2
      REAL_T  gphi(g_lo_1:g_hi_1,g_lo_2:g_hi_2,2)
      REAL_T   phi(p_lo_1:p_hi_1,p_lo_2:p_hi_2  )
      REAL_T  dx(2)

c     Local variables
      integer i, j

      do j = lo_2,hi_2
        do i = lo_1,hi_1
          gphi(i,j,1) = half*(phi(i+1,j) + phi(i+1,j+1) - 
     $                        phi(i  ,j) - phi(i  ,j+1) ) /dx(1)
          gphi(i,j,2) = half*(phi(i,j+1) + phi(i+1,j+1) - 
     $                        phi(i,j  ) - phi(i+1,j  ) ) /dx(2)
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RHSHG **
c ** Compute the right-hand-side D(V) for the projection
c *************************************************************************

      subroutine FORT_RHSHG(du,u,divu_src,vol,DIMS,dx,bc,norm,ng,is_singular,
     $                      sum_src,sum_fac)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer ng
      REAL_T        du(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T         u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      REAL_T  divu_src(lo_1  :hi_1+1,lo_2  :hi_2+1)
      REAL_T       vol(lo_1-1:hi_1+1,lo_2-1:hi_2+1)
      REAL_T  dx(2)
      REAL_T  sum_src,sum_fac
      integer is_singular
      integer bc(2,2)

c     Local variables
      REAL_T fac,norm
      REAL_T factor
      REAL_T vavg
      REAL_T hx,hy
      integer i, j
      integer istart,iend
      integer jstart,jend

      hx = dx(1)
      hy = dx(2)

      norm = zero

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      if (BCX_LO .eq. WALL) then
        do j = lo_2-1,hi_2+1
          u(lo_1-1,j,1) = zero
          u(lo_1-1,j,2) = zero
        enddo
      endif
      if (BCX_HI .eq. WALL) then
        do j = lo_2-1,hi_2+1
          u(hi_1+1,j,1) = zero
          u(hi_1+1,j,2) = zero
        enddo
      endif
      if (BCY_LO .eq. WALL) then
        do i = lo_1-1,hi_1+1
          u(i,lo_2-1,1) = zero
          u(i,lo_2-1,2) = zero
        enddo
      endif
      if (BCY_HI .eq. WALL) then
        do i = lo_1-1,hi_1+1
          u(i,hi_2+1,1) = zero
          u(i,hi_2+1,2) = zero
        enddo
      endif

      do j = jstart,jend 
      do i = istart,iend 

         du(i,j) = ( vol(i  ,j)*u(i  ,j,1) + vol(i  ,j-1)*u(i  ,j-1,1) 
     $              -vol(i-1,j)*u(i-1,j,1) - vol(i-1,j-1)*u(i-1,j-1,1)) / (two*hx) +
     $             ( vol(i  ,j)*u(i  ,j,2) - vol(i  ,j-1)*u(i  ,j-1,2) 
     $              +vol(i-1,j)*u(i-1,j,2) - vol(i-1,j-1)*u(i-1,j-1,2)) / (two*hy)

         fac = one
         fac = cvmgt(two*fac,fac,i.eq.lo_1 .and. 
     $               (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) )
         fac = cvmgt(two*fac,fac,i.eq.hi_1+1 .and. 
     $               (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
         fac = cvmgt(two*fac,fac,j.eq.lo_2 .and. 
     $               (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
         fac = cvmgt(two*fac,fac,j.eq.hi_2+1 .and. 
     $               (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )

         du(i,j) = fac * du(i,j)

         vavg = fourth * (vol(i,j) + vol(i-1,j) + vol(i,j-1) + vol(i-1,j-1))

         du(i,j) = du(i,j) - vavg * divu_src(i,j)

      enddo
      enddo

      if (is_singular .eq. 1) then
        sum_src  = zero
        sum_fac  = zero
        do j = jstart, jend 
        do i = istart, iend 
          factor = one
          factor = cvmgt(half*factor,factor,i.eq.lo_1 .or. i.eq.hi_1+1)
          factor = cvmgt(half*factor,factor,j.eq.lo_2 .or. j.eq.hi_2+1)
          sum_src = sum_src + factor * du(i,j)
          sum_fac = sum_fac + factor
        enddo
        enddo
      endif

      do j = jstart,jend 
         do i = istart,iend 
           norm = max(norm, abs(du(i,j)))
         enddo
      enddo

      return
      end

c *************************************************************************
c ** ADJUSTRHS **
c ** Adjust the RHS so it sums to zero if the problem has no outflow boundaries.
c *************************************************************************

      subroutine FORT_ADJUSTRHS(du,DIMS,bc,ng,sum_src)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer bc(2,2)
      integer ng
      REAL_T  du(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  sum_src

c     Local variables
      integer i, j
      integer istart,iend,jstart,jend

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      do j = jstart,jend 
         do i = istart,iend 
           du(i,j) = du(i,j) - sum_src
         enddo
      enddo

      return
      end

c *************************************************************************
c ** PROJUHG **
c ** Define the updated pressure and vector field
c *************************************************************************

      subroutine FORT_PROJUHG(u,pressure,phi,gradphi,rhonph,DIMS,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer ng
      REAL_T         u(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      REAL_T  pressure(lo_1  :hi_1+1,lo_2  :hi_2+1)
      REAL_T       phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T   gradphi(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T    rhonph(lo_1-1:hi_1+1,lo_2-1:hi_2+1)

c     Local variables
      integer i, j

      do j = lo_2,hi_2 
        do i = lo_1,hi_1 
          u(i,j,1) = u(i,j,1) - gradphi(i,j,1)/rhonph(i,j)
          u(i,j,2) = u(i,j,2) - gradphi(i,j,2)/rhonph(i,j)
        enddo
      enddo

      do j = lo_2,hi_2+1
        do i = lo_1,hi_1+1
c          pressure(i,j) = pressure(i,j) + phi(i,j)
           pressure(i,j) = phi(i,j)
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RESIDUAL **
c ** Compute the residual R = f - D(sigma G(phi))
c *************************************************************************

      subroutine FORT_RESIDUAL(resid,phi,source,sigma,dgphi,
     $                         DIMS,dx,resnorm,bc,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer ng
      REAL_T  resid(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T    phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  sigma(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2+  ng)
      REAL_T  dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  dx(2)
      REAL_T  resnorm
      integer bc(2,2)

c     Local variables
      integer i,j
      integer istart,iend
      integer jstart,jend

      resnorm = zero

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      call makedgphi(phi,dgphi,sigma,DIMS,dx,bc,ng,istart,jstart,iend,jend)

      do j = jstart,jend
        do i = istart,iend
          resid(i,j) = source(i,j) - dgphi(i,j)
        enddo
      enddo

      do j = jstart,jend 
        do i = istart,iend 
          resnorm = max(resnorm,abs(resid(i,j)))
        enddo
      enddo

      return
      end

#ifdef NINEPT

c *************************************************************************
c ** RELAX **
c ** Gauss-Seidel relaxation
c *************************************************************************

      subroutine FORT_RELAX(phi,source,sigma,dgphi,DIMS,dx,bc,nnrelax,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer ng
      REAL_T     phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T   sigma(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2  +ng)
      REAL_T   dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T dx(2)
      integer bc(2,2)
      integer nnrelax

c     Local variables
      REAL_T  hxsqinv,hysqinv
      REAL_T  rfac
      REAL_T  mult
      integer i,j
      integer extra_xlo
      integer extra_xhi
      integer extra_ylo
      integer extra_yhi
      integer iter,iinc
      integer istart,iend
      integer jstart,jend

      hxsqinv = one/(dx(1)*dx(1))
      hysqinv = one/(dx(2)*dx(2))

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)
 
      if (nnrelax .gt. ng) then
        print *,'DONT HAVE ENOUGH BUFFER CELLS IN HG:RELAX '
        print *,'NG = ',ng
        print *,'NRELAX = ',nnrelax
        stop
      endif

c     do iter = 1, 2*nnrelax 
      do iter = 1, nnrelax 
          
          extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
          extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
          extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
          extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)

          call makedgphi(phi,dgphi,sigma,DIMS,dx,bc,ng,
     $                   istart-extra_xlo,jstart-extra_ylo,
     $                   iend  +extra_xhi,jend  +extra_yhi)

          do j = jstart-extra_ylo,jend+extra_yhi
          do i = istart-extra_xlo,iend+extra_xhi

c         do j = jstart-extra_ylo,jend+extra_yhi
c           iinc = mod(j+iter+1+extra_xlo+2*ng,2)
c           do i = istart-extra_xlo+iinc,iend+extra_xhi,2

#if 0
              dgphi(i,j) = sixth * (hxsqinv * 
     $         (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i,j-1) + two * phi(i-1,j)) +
     $          sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i,j+1) + two * phi(i-1,j)) +
     $          sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i,j-1) + two * phi(i+1,j)) +
     $          sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i,j+1) + two * phi(i+1,j)) -
     $             two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                  sigma(i  ,j-1) + sigma(i  ,j)) * phi(i,j)) +
     $                            hysqinv * 
     $         (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i-1,j) + two * phi(i,j-1)) +
     $          sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i-1,j) + two * phi(i,j+1)) +
     $          sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i+1,j) + two * phi(i,j-1)) +
     $          sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i+1,j) + two * phi(i,j+1)) -
     $             two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                  sigma(i  ,j-1) + sigma(i  ,j)) *  phi(i,j)))
#endif
  
              mult = one
              mult = cvmgt(two*mult,mult,
     $                     i.eq.lo_1   .and. (BCX_LO.eq.WALL.or.BCX_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     j.eq.lo_2   .and. (BCY_LO.eq.WALL.or.BCY_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     i.eq.hi_1+1 .and. (BCX_HI.eq.WALL.or.BCX_HI.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     j.eq.hi_2+1 .and. (BCY_HI.eq.WALL.or.BCY_HI.eq.INLET))

c             dgphi(i,j) = mult * dgphi(i,j)

              rfac = mult * (hxsqinv + hysqinv) * 
     $               (sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j))

              rfac = three/rfac
              phi(i,j) = phi(i,j) + rfac*(dgphi(i,j) - source(i,j))

          enddo
          enddo
      enddo

      return
      end
#endif


#ifdef FIVEPT

c *************************************************************************
c ** RELAX **
c ** Gauss-Seidel relaxation
c *************************************************************************

      subroutine FORT_RELAX(phi,source,sigma,dgphi,DIMS,dx,bc,nnrelax,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer ng
      REAL_T     phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T   sigma(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2  +ng)
      REAL_T   dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T dx(2)
      integer bc(2,2)
      integer nnrelax

c     Local variables
      REAL_T  hxsqinv,hysqinv
      REAL_T  rfac, mult
      integer i,j
      integer extra_xlo
      integer extra_xhi
      integer extra_ylo
      integer extra_yhi
      integer iter
      integer istart,iend
      integer jstart,jend
      integer iinc

      hxsqinv = one/(dx(1)*dx(1))
      hysqinv = one/(dx(2)*dx(2))

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)
 
      do iter = 1, 2*nnrelax 

          extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
          extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
          extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
          extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)

          do j = jstart-extra_ylo,jend+extra_yhi
            iinc = mod(j+iter+1+extra_xlo+2*ng,2)
            do i = istart-extra_xlo+iinc,iend+extra_xhi,2

              dgphi(i,j) = hysqinv * (
     $          half*(sigma(i,j  )+sigma(i-1,j  )) * (phi(i,j+1)-phi(i,j)) +
     $          half*(sigma(i,j-1)+sigma(i-1,j-1)) * (phi(i,j-1)-phi(i,j)) )
                         + hxsqinv * (
     $          half*(sigma(i,j  )+sigma(i  ,j-1)) * (phi(i+1,j)-phi(i,j)) +
     $          half*(sigma(i-1,j)+sigma(i-1,j-1)) * (phi(i-1,j)-phi(i,j)) )

              mult = one
              mult = cvmgt(two*mult,mult,
     $                     i.eq.lo_1   .and. (BCX_LO.eq.WALL.or.BCX_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     j.eq.lo_2   .and. (BCY_LO.eq.WALL.or.BCY_LO.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     i.eq.hi_1+1 .and. (BCX_HI.eq.WALL.or.BCX_HI.eq.INLET))
              mult = cvmgt(two*mult,mult,
     $                     j.eq.hi_2+1 .and. (BCY_HI.eq.WALL.or.BCY_HI.eq.INLET))

              dgphi(i,j) = mult*dgphi(i,j)

              rfac =  mult * half * (
     $                     hysqinv * (
     $               (sigma(i,j  )+sigma(i-1,j  ))
     $               (sigma(i,j-1)+sigma(i-1,j-1)) )
                         + hxsqinv * (
     $               (sigma(i,j  )+sigma(i  ,j-1))
     $               (sigma(i-1,j)+sigma(i-1,j-1)) ) )

              rfac = one/rfac

              phi(i,j) = phi(i,j) + rfac*(dgphi(i,j) - source(i,j))

            enddo
            enddo

      enddo

      return
      end

#endif

c *************************************************************************
c ** COARSIG **
c ** Coarsening of the sig coefficients
c *************************************************************************

      subroutine FORT_COARSIG(sigma,sigmac,DIMS,CDIMS,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      integer ng
      REAL_T  sigma(lo_1 -ng:hi_1 +ng,lo_2 -ng:hi_2 +ng)
      REAL_T sigmac(loc_1-ng:hic_1+ng,loc_2-ng:hic_2+ng)

c     Local variables
      integer i ,j

      do j = lo_2,hi_2,2
        do i = lo_1,hi_1,2 
          sigmac(i/2,j/2) = (sigma(i  ,j) + sigma(i  ,j+1)+ 
     $                       sigma(i+1,j) + sigma(i+1,j+1)) * fourth
        enddo
      enddo

      return
      end

c *************************************************************************
c ** RESTRICT **
c ** Conservative restriction of the residual
c *************************************************************************

      subroutine FORT_RESTRICT(res,resc,DIMS,CDIMS,bc,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      integer ng
      REAL_T   res(lo_1 -ng:hi_1 +1+ng,lo_2 -ng:hi_2 +1+ng)
      REAL_T  resc(loc_1-ng:hic_1+1+ng,loc_2-ng:hic_2+1+ng)
      integer bc(2,2)

c     Local variables
      integer i,j,ii,jj
      integer istart,iend
      integer jstart,jend

      istart = cvmgt((lo_1  )/2+1,(lo_1  )/2,BCX_LO .eq. OUTLET)
      iend   = cvmgt((hi_1+1)/2-1,(hi_1+1)/2,BCX_HI .eq. OUTLET)
      jstart = cvmgt((lo_2  )/2+1,(lo_2  )/2,BCY_LO .eq. OUTLET)
      jend   = cvmgt((hi_2+1)/2-1,(hi_2+1)/2,BCY_HI .eq. OUTLET)

      do j = jstart,jend
        do i = istart,iend

          ii = 2*i
          jj = 2*j

          resc(i,j) = fourth*res(ii  ,jj) + 
     $               eighth*(res(ii+1,jj  ) + res(ii-1,jj  ) + 
     $                       res(ii  ,jj+1) + res(ii  ,jj-1) ) +
     $            sixteenth*(res(ii+1,jj+1) + res(ii+1,jj-1) + 
     $                       res(ii-1,jj+1) + res(ii-1,jj-1) )
        enddo
      enddo

      if ((BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) .and. lo_1 .eq. 2*loc_1) then
        i = loc_1
        ii = 2*i

        do j = jstart,jend
          jj = 2*j
          resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  )) + 
     $                eighth*(res(ii,jj-1) + res(ii+1,jj-1)+
     $                        res(ii,jj+1) + res(ii+1,jj+1) )
        enddo
      endif

      if ((BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) .and. lo_2 .eq. 2*loc_2) then
        j = loc_2
        jj = 2*j

        do i = istart,iend
          ii = 2*i
          resc(i,j) = fourth*(res(ii  ,jj) + res(ii  ,jj+1)) + 
     $                eighth*(res(ii+1,jj) + res(ii+1,jj+1)+
     $                        res(ii-1,jj) + res(ii-1,jj+1) )
        enddo
      endif

      if ((BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) .and. hi_1 .eq. 2*hic_1+1) then
        i = hic_1+1
        ii = 2*i

        do j = jstart,jend
          jj = 2*j
          resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  )) + 
     $                eighth*(res(ii,jj-1) + res(ii-1,jj-1)+
     $                        res(ii,jj+1) + res(ii-1,jj+1) )
        enddo
      endif

      if ((BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) .and. hi_2 .eq. 2*hic_2+1) then
        j = hic_2+1
        jj = 2*j

        do i = istart,iend
          ii = 2*i
          resc(i,j) = fourth*(res(ii  ,jj) + res(ii  ,jj-1)) + 
     $                eighth*(res(ii+1,jj) + res(ii+1,jj-1)+
     $                        res(ii-1,jj) + res(ii-1,jj-1) )
        enddo
      endif

      if ( (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) .and.
     $     (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) .and.
     $     (lo_1 .eq. 2*loc_1 .and. lo_2 .eq. 2*loc_2) ) then
        i = loc_1
        j = loc_2
        ii = 2*i
        jj = 2*j
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  ) +
     $                      res(ii,jj+1) + res(ii+1,jj+1) )
      endif
 
      if ( (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) .and.
     $     (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) .and.
     $     (hi_1 .eq. 2*hic_1+1 .and. hi_2 .eq. 2*hic_2+1) ) then
        i = hic_1+1
        j = hic_2+1
        ii = 2*i
        jj = 2*j
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  ) +
     $                      res(ii,jj-1) + res(ii-1,jj-1) )
      endif

      if ( (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) .and.
     $     (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) .and.
     $     (lo_1 .eq. 2*loc_1 .and. hi_2 .eq. 2*hic_2+1) ) then
        i = loc_1
        j = hic_2+1
        ii = 2*i
        jj = 2*j
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii+1,jj  ) +
     $                      res(ii,jj-1) + res(ii+1,jj-1) )
      endif

      if ( (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) .and.
     $     (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) .and.
     $     (hi_1 .eq. 2*hic_1+1 .and. lo_2 .eq. 2*loc_2) ) then
        i = hic_1+1
        j = loc_2
        ii = 2*i
        jj = 2*j
        resc(i,j) = fourth*(res(ii,jj  ) + res(ii-1,jj  ) +
     $                      res(ii,jj+1) + res(ii-1,jj+1) )
      endif


      return
      end

c *************************************************************************
c ** INTERP **
c ** Simple bilinear interpolation
c *************************************************************************

      subroutine FORT_INTERP(phi,deltac,DIMS,CDIMS,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer loc_1, loc_2
      integer hic_1, hic_2
      integer ng
      REAL_T     phi(lo_1 -ng:hi_1 +1+ng,lo_2 -ng:hi_2 +1+ng)
      REAL_T  deltac(loc_1-ng:hic_1+1+ng,loc_2-ng:hic_2+1+ng)

c     Local variables
      integer i,j

      do j = lo_2,hi_2+1,2
      do i = lo_1,hi_1+1,2
          phi(i,j) = phi(i,j) + deltac(i/2,j/2)
      enddo
      enddo

      do j = lo_2+1,hi_2  ,2
      do i = lo_1  ,hi_1+1,2
        phi(i,j) = phi(i,j) + half*(deltac(i/2,j/2)+deltac(i/2,j/2+1))
      enddo
      enddo

      do j = lo_2  ,hi_2+1,2
      do i = lo_1+1,hi_1  ,2
        phi(i,j) = phi(i,j) + half*(deltac(i/2,j/2)+deltac(i/2+1,j/2))
      enddo
      enddo

      do j = lo_2+1,hi_2,2
      do i = lo_1+1,hi_1,2
        phi(i,j) = phi(i,j) + fourth*(deltac(i/2,j/2  )+deltac(i/2+1,j/2  )
     $                               +deltac(i/2,j/2+1)+deltac(i/2+1,j/2+1))
      enddo
      enddo

      return
      end

c *************************************************************************
c ** MAKEDGPHI **
c ** Compute D(sig G(phi))
c *************************************************************************

      subroutine makedgphi(phi,dgphi,sigma,DIMS,dx,bc,ng,rlo_1,rlo_2,rhi_1,rhi_2)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer rlo_1,rlo_2
      integer rhi_1, rhi_2
      integer ng
      REAL_T    phi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  dgphi(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  sigma(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2  +ng)
      REAL_T  dx(2)
      integer bc(2,2)

c     Local variables
      REAL_T hxsqinv
      REAL_T hysqinv
      REAL_T mult
      integer istart,iend
      integer jstart,jend
      integer i,j
      integer ii,jj

      hxsqinv = one/(dx(1)*dx(1))
      hysqinv = one/(dx(2)*dx(2))

      istart = cvmgt(lo_1+1,rlo_1,BCX_LO .eq. OUTLET)
      jstart = cvmgt(lo_2+1,rlo_2,BCY_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,rhi_1,BCX_HI .eq. OUTLET)
      jend   = cvmgt(hi_2  ,rhi_2,BCY_HI .eq. OUTLET)

      do j = jstart,jend
      do i = istart,iend

#ifdef NINEPT
            dgphi(i,j) = sixth * (hxsqinv * 
     $       (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i,j-1) + two * phi(i-1,j)) +
     $        sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i,j+1) + two * phi(i-1,j)) +
     $        sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i,j-1) + two * phi(i+1,j)) +
     $        sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i,j+1) + two * phi(i+1,j)) -
     $           two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j)) * phi(i,j)) +
     $                          hysqinv * 
     $       (sigma(i-1,j-1) * (phi(i-1,j-1) - phi(i-1,j) + two * phi(i,j-1)) +
     $        sigma(i-1,j  ) * (phi(i-1,j+1) - phi(i-1,j) + two * phi(i,j+1)) +
     $        sigma(i  ,j-1) * (phi(i+1,j-1) - phi(i+1,j) + two * phi(i,j-1)) +
     $        sigma(i  ,j  ) * (phi(i+1,j+1) - phi(i+1,j) + two * phi(i,j+1)) -
     $           two*(sigma(i-1,j-1) + sigma(i-1,j) + 
     $                sigma(i  ,j-1) + sigma(i  ,j)) *  phi(i,j)))
#endif
#ifdef FIVEPT
            dgphi(i,j) = hysqinv * (
     $        half*(sigma(i,j  )+sigma(i-1,j  )) * (phi(i,j+1)-phi(i,j)) +
     $        half*(sigma(i,j-1)+sigma(i-1,j-1)) * (phi(i,j-1)-phi(i,j)) )
                       + hxsqinv * (
     $        half*(sigma(i,j  )+sigma(i  ,j-1)) * (phi(i+1,j)-phi(i,j)) +
     $        half*(sigma(i-1,j)+sigma(i-1,j-1)) * (phi(i-1,j)-phi(i,j)) )
#endif

            mult = one
            mult = cvmgt(two*mult,mult,
     $                   i.eq.lo_1   .and. (BCX_LO.eq.WALL.or.BCX_LO.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   j.eq.lo_2   .and. (BCY_LO.eq.WALL.or.BCY_LO.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   i.eq.hi_1+1 .and. (BCX_HI.eq.WALL.or.BCX_HI.eq.INLET))
            mult = cvmgt(two*mult,mult,
     $                   j.eq.hi_2+1 .and. (BCY_HI.eq.WALL.or.BCY_HI.eq.INLET))
 
            dgphi(i,j) = mult*dgphi(i,j)
 
        enddo
      enddo

      return
      end

c *************************************************************************
c ** SOLVEHG **
c *************************************************************************

      subroutine FORT_SOLVEHG(dest,dest0,source,sigma,sum,r,w,z,work,
     $                        DIMS,dx,bc,maxiter,norm,prob_norm,ng)

      implicit none

      integer lo_1, lo_2
      integer hi_1, hi_2
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  dest0(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T source(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T  sigma(lo_1-ng:hi_1  +ng,lo_2-ng:hi_2  +ng)
      REAL_T    sum(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T      r(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T      w(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T      z(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T   work(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      REAL_T dx(2)
      integer bc(2,2)
      integer maxiter
      REAL_T norm
      REAL_T prob_norm

c     Local variables
      REAL_T  factor
      REAL_T  alpha
      REAL_T  beta
      REAL_T  rho
      REAL_T  rhol
      REAL_T  tol, tolfac
      logical testx
      logical testy
      integer i,j,iter
      integer istart,iend
      integer jstart,jend
      REAL_T local_norm

      tolfac = 1.0d-3 

      istart = cvmgt(lo_1+1,lo_1  ,BCX_LO .eq. OUTLET)
      iend   = cvmgt(hi_1  ,hi_1+1,BCX_HI .eq. OUTLET)
      jstart = cvmgt(lo_2+1,lo_2  ,BCY_LO .eq. OUTLET)
      jend   = cvmgt(hi_2  ,hi_2+1,BCY_HI .eq. OUTLET)

      call setperiodic(dest,DIMS,bc,ng)

      do j = lo_2-1,hi_2+2
         do i = lo_1-1,hi_1+2
            dest0(i,j) = dest(i,j)
            dest(i,j) = zero
         enddo
      enddo

  10  call makedgphi(dest0,w,sigma,DIMS,dx,bc,ng,istart,jstart,iend,jend)

      rho = zero
      norm = zero

      do j = jstart, jend 
        do i = istart, iend 
          r(i,j) = source(i,j) - w(i,j)
        enddo
      enddo

      local_norm = zero
      do j = jstart, jend 
        do i = istart, iend 
          factor = one
          testx  = (i .eq. lo_1 .or. i .eq. hi_1+1)
          testy  = (j .eq. lo_2 .or. j .eq. hi_2+1)
          factor = cvmgt(factor*half,factor,testx)
          factor = cvmgt(factor*half,factor,testy)
          local_norm  = max(local_norm, abs(r(i,j)))
          z(i,j) = r(i,j) 
          rho    = rho + z(i,j) * r(i,j) * factor
          norm   = max(norm,abs(r(i,j)))
        enddo
      enddo

      tol = Max(tolfac*local_norm,1.0d-15*prob_norm)
      if (norm .le. tol) return

      do j = jstart, jend 
        do i = istart, iend 
          work(i,j) = zero
          dest(i,j) = z(i,j)
        enddo
      enddo

      iter  = 0
c     write(6,1000) iter, norm/prob_norm

 100  call setperiodic(dest,DIMS,bc,ng)

      call makedgphi(dest,w,sigma,DIMS,dx,bc,ng,istart,jstart,iend,jend)

      alpha = zero
      do j = jstart, jend 
        do i = istart, iend 
          factor = one
          testx  = (i .eq. lo_1 .or. i .eq. hi_1+1)
          testy  = (j .eq. lo_2 .or. j .eq. hi_2+1)
          factor = cvmgt(factor*half,factor,testx)
          factor = cvmgt(factor*half,factor,testy)
          alpha  = alpha + dest(i,j)*w(i,j) * factor
        enddo
      enddo

      alpha = rho / alpha
      rhol  = rho
      rho   = zero
      norm  = zero

      do j = jstart, jend 
        do i = istart, iend 
          factor = one
          testx  = (i .eq. lo_1 .or. i .eq. hi_1+1)
          testy  = (j .eq. lo_2 .or. j .eq. hi_2+1)
          factor = cvmgt(factor*half,factor,testx)
          factor = cvmgt(factor*half,factor,testy)
          work(i,j) = work(i,j) + alpha * dest(i,j)
          r(i,j) = r(i,j) - alpha * w(i,j)
          z(i,j) = r(i,j) 
          rho    = rho + z(i,j) * r(i,j) * factor
          norm   = max(norm,abs(r(i,j)))
        enddo
      enddo

      iter = iter+1
c     write(6,1000) iter, norm/prob_norm

      if (norm .le. tol) then
         
         do j = jstart, jend 
            do i = istart, iend 
               dest(i,j) = work(i,j) + dest0(i,j)
            enddo
         enddo
         
      else if (iter .ge. maxiter .or. norm .ge. 100.d0*local_norm) then

        tolfac = 10.d0 * tolfac
        iter = 1
        do j = jstart, jend 
          do i = istart, iend 
            dest(i,j) = zero
          enddo
        enddo
        goto 10

      else

        beta = rho / rhol
        do j = jstart, jend 
          do i = istart, iend 
            dest(i,j) = z(i,j) + beta * dest(i,j)
          enddo
        enddo
        goto 100

      endif

1000  format('Res/Res0 in solve : ',i4,2x,e12.5)
c      call flush(6)

      return
      end

c *************************************************************************
c ** SETPERIODIC **
c  Impose periodic boundary conditions on the single grid data in the
c   conjugate gradient bottom solver.
c *************************************************************************

      subroutine setperiodic(dest,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T   dest(lo_1-ng:hi_1+1+ng,lo_2-ng:hi_2+1+ng)
      integer bc(2,2)

      integer i,j

      if (BCX_LO .eq. PERIODIC .and. BCX_HI .eq. PERIODIC) then
        do j = lo_2,hi_2+1
          dest(hi_1+2,j) = dest(lo_1+1,j)
          dest(lo_1-1,j) = dest(hi_1  ,j)
        enddo
      endif

      if (BCY_LO .eq. PERIODIC .and. BCY_HI .eq. PERIODIC) then
        do i = lo_1,hi_1+1
          dest(i,hi_2+2) = dest(i,lo_2+1)
          dest(i,lo_2-1) = dest(i,hi_2  )
        enddo
      endif

      if (BCX_LO .eq. PERIODIC .and. BCY_LO .eq. PERIODIC) then
        dest(lo_1-1,lo_2-1) = dest(hi_1  ,hi_2  )
        dest(lo_1-1,hi_2+2) = dest(hi_1  ,lo_2+1)
        dest(hi_1+2,lo_2-1) = dest(lo_1+1,hi_2  )
        dest(hi_1+2,hi_2+2) = dest(lo_1+1,lo_2+1)
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: MG_2D.F,v 1.3 1999/02/03 00:39:25 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include <REAL.H>
#include <CONSTANTS.H>
#include "MG_F.H"
#include "ArrayLim.H"

c-----------------------------------------------------------------------
      subroutine FORT_AVERAGE (
     $     c, DIMS(c),
     $     f, DIMS(f),
     $     lo, hi, nc
     $     )
      integer nc
      integer DIMDEC(f)
      integer DIMDEC(c)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i
      integer j
      integer n
      REAL_T denom
      parameter(denom=fourth)
c
      do n = 1, nc
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               c(i,j,n) =  (
     $              f(2*i+1,2*j+1,n) + f(2*i  ,2*j+1,n)
     $              + f(2*i+1,2*j,n ) + f(2*i  ,2*j ,n))*denom
            end do
         end do
      end do
c
      end
c-----------------------------------------------------------------------
      subroutine FORT_INTERP (
     $     f, DIMS(f),
     $     c, DIMS(c),
     $     lo, hi, nc
     $     )
      integer nc
      integer DIMDEC(f)
      integer DIMDEC(c)
      integer lo(BL_SPACEDIM)
      integer hi(BL_SPACEDIM)
      REAL_T f(DIMV(f),nc)
      REAL_T c(DIMV(c),nc)
c
      integer i
      integer j
      integer n
c
      do n = 1, nc
         do j = lo(2), hi(2)
cdir$   ivdep
            do i = lo(1), hi(1)
               f(2*i+1,2*j+1,n) = c(i,j,n) + f(2*i+1,2*j+1,n)
               f(2*i  ,2*j+1,n) = c(i,j,n) + f(2*i  ,2*j+1,n)
               f(2*i+1,2*j  ,n) = c(i,j,n) + f(2*i+1,2*j  ,n)
               f(2*i  ,2*j  ,n) = c(i,j,n) + f(2*i  ,2*j  ,n)
            end do
         end do
      end do
c
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "GRID_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,hi_1,hi_2

c *************************************************************************
c ** MKUTRANS **
c ** Construct the velocities to be used in defining transverse derivatives.
c ***************************************************************

      subroutine FORT_MKUTRANS(utrans,vtrans,vel,velx,vely,force,
     $                         dx,dt,DIMS,bc)

      implicit none

      integer DIMS

      REAL_T utrans(lo_1-1:hi_1+2,lo_2-1:hi_2+1)
      REAL_T vtrans(lo_1-1:hi_1+1,lo_2-1:hi_2+2)
      REAL_T    vel(lo_1-3:hi_1+3,lo_2-3:hi_2+3,2)
      REAL_T   velx(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T   vely(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  force(lo_1-1:hi_1+1,lo_2-1:hi_2+1,2)
      REAL_T  dx(2)
      REAL_T  dt
      integer bc(2,2)

c     Local variables
      REAL_T hx,hy,dth
      REAL_T ulft,urgt,vbot,vtop
      REAL_T eps

      integer i,j,is,js,ie,je
      logical test

      eps = 1.0e-8

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      dth = half*dt
      hx = dx(1)
      hy = dx(2)

c     Create the x-velocity to be used for transverse derivatives.
      do j = js-1,je+1 
        do i = is,ie+1 

          urgt = vel(i  ,j,1) - (half + dth*vel(i  ,j,1)/hx) * velx(i  ,j,1)
c    $           + dth * force(i  ,j,1)
          ulft = vel(i-1,j,1) + (half - dth*vel(i-1,j,1)/hx) * velx(i-1,j,1)
c    $           + dth * force(i-1,j,1)

          urgt = cvmgt(vel(is-1,j,1),urgt,i.eq.is   .and. BCX_LO .eq. INLET)
          urgt = cvmgt(vel(ie+1,j,1),urgt,i.eq.ie+1 .and. BCX_HI .eq. INLET)
          urgt = cvmgt(zero     ,urgt,i.eq.is   .and. BCX_LO .eq. WALL)
          urgt = cvmgt(zero     ,urgt,i.eq.ie+1 .and. BCX_HI .eq. WALL)

          ulft = cvmgt(vel(is-1,j,1),ulft,i.eq.is   .and. BCX_LO .eq. INLET)
          ulft = cvmgt(vel(ie+1,j,1),ulft,i.eq.ie+1 .and. BCX_HI .eq. INLET)
          ulft = cvmgt(zero     ,ulft,i.eq.is   .and. BCX_LO .eq. WALL)
          ulft = cvmgt(zero     ,ulft,i.eq.ie+1 .and. BCX_HI .eq. WALL)

          utrans(i,j) = cvmgp(ulft,urgt,ulft+urgt)
          test = ( (ulft .le. zero  .and.  urgt .ge. zero)  .or.  
     $             (abs(ulft+urgt) .lt. eps) )
          utrans(i,j) = cvmgt(zero,utrans(i,j),test)

        enddo
      enddo

c     Create the y-velocity to be used for transverse derivatives.
      do j = js,je+1 
        do i = is-1,ie+1 

          vtop = vel(i,j  ,2) - (half + dth*vel(i,j  ,2)/hy) * vely(i,j  ,2)
c    $           + dth * force(i,j  ,2)
          vbot = vel(i,j-1,2) + (half - dth*vel(i,j-1,2)/hy) * vely(i,j-1,2)
c    $           + dth * force(i,j-1,2)

          vtop = cvmgt(vel(i,js-1,2),vtop,j.eq.js   .and. BCY_LO .eq. INLET)
          vtop = cvmgt(vel(i,je+1,2),vtop,j.eq.je+1 .and. BCY_HI .eq. INLET)
          vtop = cvmgt(zero     ,vtop,j.eq.js   .and. BCY_LO .eq. WALL)
          vtop = cvmgt(zero     ,vtop,j.eq.je+1 .and. BCY_HI .eq. WALL)

          vbot = cvmgt(vel(i,js-1,2),vbot,j.eq.js   .and. BCY_LO .eq. INLET)
          vbot = cvmgt(vel(i,je+1,2),vbot,j.eq.je+1 .and. BCY_HI .eq. INLET)
          vbot = cvmgt(zero     ,vbot,j.eq.js   .and. BCY_LO .eq. WALL)
          vbot = cvmgt(zero     ,vbot,j.eq.je+1 .and. BCY_HI .eq. WALL)

          vtrans(i,j)=cvmgp(vbot,vtop,vbot+vtop)
          test = ( (vbot .le. zero  .and.  vtop .ge. zero)  .or.  
     $             (abs(vbot+vtop) .lt. eps))
          vtrans(i,j) = cvmgt(zero,vtrans(i,j),test)
        enddo
      enddo

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: PROJECTION_3D.F,v 1.13 2002/11/14 23:04:56 lijewski Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROJECTION_F.H"
#include "ArrayLim.H"

#define SDIM 3

       subroutine FORT_FILTERP (
     &     pnew,scratch,DIMS(p),
     &     lo,hi,dx,fac)
c
c     ----------------------------------------------------------
c     filter the pressure coming out of the level projection
c     
c     pnew := pnew - fac * lap_7pt(pnew)
c     
c     INPUTS / OUTPUTS:
c     pnew       => 
c     pnew      <=> 
c     p_lo,p_hi  => index limits of pressure array
c     lo,hi      => index limits of cell centered interior
c     fac        => fudge factor for filtering
c     
c     ----------------------------------------------------------
c 
       integer    DIMDEC(p)
       REAL_T     pnew(DIMV(p))
       REAL_T     scratch(DIMV(p))
       integer    lo(3), hi(3)
       REAL_T     dx(3)
       REAL_T     fac

       integer i, j, k
       REAL_T     twelfth

       twelfth = one / twelve

       do k = lo(3)+1, hi(3)
          do j = lo(2)+1, hi(2)
             do i = lo(1)+1, hi(1)
                
                scratch(i,j,k) = six * pnew(i,j,k) - 
     $               (pnew(i-1,j,k) + pnew(i+1,j,k) + 
     $               pnew(i,j-1,k) + pnew(i,j+1,k) +
     $               pnew(i,j,k-1) + pnew(i,j,k+1) )
                scratch(i,j,k) = - twelfth * scratch(i,j,k) * fac

             end do
          end do
       end do

       do k = lo(3)+1, hi(3)
          do j = lo(2)+1, hi(2)
             do i = lo(1)+1, hi(1)
                pnew(i,j,k) = pnew(i,j,k) + scratch(i,j,k)
             end do
          end do
       end do
 
       end

       subroutine FORT_ACCEL_TO_VEL( lo, hi, 
     &     uold,DIMS(uold),
     &     dt,
     &     unew,DIMS(unew) )
c
c     This function converts unew into a velocity via
c     Unew = Uold + alpha*Unew
c
       integer    lo(SDIM), hi(SDIM)
       REAL_T     dt
       integer    DIMDEC(uold),DIMDEC(unew)
       REAL_T     uold(DIMV(uold),SDIM)
       REAL_T     unew(DIMV(unew),SDIM)

       integer i, j, k, n

       do n = 1, SDIM
          do k = lo(3)-1, hi(3)+1
             do j = lo(2)-1, hi(2)+1
                do i = lo(1)-1, hi(1)+1
                   unew(i,j,k,n) = uold(i,j,k,n) + dt*unew(i,j,k,n)
                end do
             end do
          end do
       end do

       end

      subroutine FORT_VEL_TO_ACCEL( lo, hi, 
     &     unew,DIMS(unew),
     &     uold,DIMS(uold),
     &     dt )
c     
c     This function converts unew into an acceleration
c     
      integer    lo(SDIM), hi(SDIM)
      REAL_T     dt
      integer    DIMDEC(unew),DIMDEC(uold)
      REAL_T     uold(DIMV(uold),SDIM)
      REAL_T     unew(DIMV(unew),SDIM)

      integer i, j, k, n

      do n = 1, SDIM
         do k = lo(3)-1, hi(3)+1
            do j = lo(2)-1, hi(2)+1
               do i = lo(1)-1, hi(1)+1
                  unew(i,j,k,n) = (unew(i,j,k,n)-uold(i,j,k,n))/dt
               end do
            end do
         end do
      end do

      end

      subroutine FORT_PROJ_UPDATE(
     &     boxlo, boxhi, nvar, ngrow,
     &     un, DIMS(un),
     &     alpha,
     &     uo, DIMS(uo) )
c     
c     This function updates un via un = un + alpha*uo
c     The loop bounds are determined in the C++
c     
      integer    boxlo(SDIM), boxhi(SDIM), nvar, ngrow
      REAL_T     alpha
      integer    DIMDEC(un),DIMDEC(uo)
      REAL_T     un(DIMV(un),nvar)
      REAL_T     uo(DIMV(uo),nvar)

      integer i, j, k, n

      do n = 1, nvar
         do k = boxlo(3), boxhi(3)
            do j = boxlo(2), boxhi(2)
               do i = boxlo(1), boxhi(1)
                  un(i,j,k,n) = un(i,j,k,n) + alpha*uo(i,j,k,n)
               end do
            end do
         end do
      end do

      end

      subroutine FORT_RADMPY(a,DIMS(grid),ng,r,nr,n)
c 
c     multiply A by a Radius r
c
      integer    ng,nr
      integer    n(SDIM)
      integer    DIMDEC(grid)
      REAL_T     a(ARG_L1(grid)-ng:ARG_H1(grid)+ng,
     $             ARG_L2(grid)-ng:ARG_H2(grid)+ng,
     $             ARG_L3(grid)-ng:ARG_H3(grid)+ng)
      REAL_T     r(ARG_L1(grid)-nr:ARG_H1(grid)+nr)

      call bl_abort('SHOULD NEVER BE IN RADMPY IN 3D')

      end

      subroutine FORT_RADDIV(a,DIMS(grid),ng,r,nr,n)
c 
c     divide A by a Radius r
c
      integer    ng,nr
      integer    n(SDIM)
      integer    DIMDEC(grid)
      REAL_T     a(ARG_L1(grid)-ng:ARG_H1(grid)+ng,
     $             ARG_L2(grid)-ng:ARG_H2(grid)+ng,
     $             ARG_L3(grid)-ng:ARG_H3(grid)+ng)
      REAL_T     r(ARG_L1(grid)-nr:ARG_H1(grid)+nr)

      call bl_abort('SHOULD NEVER BE IN RADDIV IN 3D')
      end

      subroutine FORT_HGN2C(
     &     isrz,lrweighted, DIMS(nodedat), nodedat,
     &     DIMS(ccdat), lo, hi, ccdat)

c     ----------------------------------------------------------
c     HGN2C
c     averages node centered data to cell centers for use in 
c     holy grail projection

      implicit none
      integer isrz,lrweighted
      integer lo(SDIM), hi(SDIM)
      integer DIMDEC(ccdat)
      integer DIMDEC(nodedat)
      REAL_T  nodedat(DIMV(nodedat))
      REAL_T  ccdat(DIMV(ccdat))

      integer i,j,k

      if (ARG_H1(ccdat)   .lt. lo(1) .or. 
     &    ARG_L1(ccdat)   .gt. hi(1) .or. 
     &    ARG_H2(ccdat)   .lt. lo(2) .or. 
     &    ARG_L2(ccdat)   .gt. hi(2) .or. 
     &    ARG_H3(ccdat)   .lt. lo(3) .or. 
     &    ARG_L3(ccdat)   .gt. hi(3) .or. 
     &    ARG_H1(nodedat) .lt. lo(1)+1 .or. 
     &    ARG_L1(nodedat) .gt. hi(1) .or. 
     &    ARG_H2(nodedat) .lt. lo(2)+1 .or. 
     &    ARG_L2(nodedat) .gt. hi(2) .or.
     &    ARG_H3(nodedat) .lt. lo(3)+1 .or. 
     &    ARG_L3(nodedat) .gt. hi(3) ) then 
        call bl_abort("FORT_HG_CELL_TO_NODE: bad index limits")
      end if

      if(isrz.eq.1.and.lrweighted.ne.1)then
        call bl_abort('FORT_HGN2C : isrz=1 and lrweighted!=1 not implemented')
      end if

      do k=lo(3),hi(3)
         do j=lo(2),hi(2)
            do i=lo(1),hi(1)
               ccdat(i,j,k)=eighth*(nodedat(i  ,j,  k  )+nodedat(i+1,j  ,k  )+
     &                              nodedat(i  ,j+1,k  )+nodedat(i+1,j+1,k  )+
     &                              nodedat(i  ,j,  k+1)+nodedat(i+1,j  ,k+1)+
     &                              nodedat(i  ,j+1,k+1)+nodedat(i+1,j+1,k+1))
            end do
         end do
      end do

      end


       subroutine FORT_HGC2N(
     &     nghost, DIMS(dat), dat, rcen,
     &     DIMS(rhs), rhs,
     &     domlo, domhi, lowfix, hifix, dr, is_rz) 
c
c     ----------------------------------------------------------
c     HGC2N
c     averages cell centered data to nodes for use in 
c     holy grail projection
c     
c     INPUTS / OUTPUTS:
c     nghost      => indicates buffer of rhs that does not need values
c     dat         => cell centered array to be averaged
c     DIMS(dat)   => index limits of dat
c     rhslo,rhshi => index extents of rhs
c     rhs         <= node centered array with results
c     rcen,lowfix,hifix are artifacts of 2D r-z version and are not used
c     ----------------------------------------------------------
c 
      implicit none
      integer nghost
      integer domlo(SDIM), domhi(SDIM)
      integer DIMDEC(dat)
      integer DIMDEC(rhs)
      REAL_T  dat(DIMV(dat))
      REAL_T  rhs(DIMV(rhs))

c not used
      integer is_rz, lowfix, hifix
      REAL_T  rcen(DIM1(dat))
      REAL_T  dr

c local variables
      integer i, j, k

      if (ARG_L1(rhs)+1 .lt. ARG_L1(dat) .or. 
     $    ARG_H1(rhs)-1 .gt. ARG_H1(dat) .or.
     &    ARG_L2(rhs)+1 .lt. ARG_L2(dat) .or. 
     $    ARG_H2(rhs)-1 .gt. ARG_H2(dat) .or.
     &    ARG_L3(rhs)+1 .lt. ARG_L3(dat) .or. 
     $    ARG_H3(rhs)-1 .gt. ARG_H3(dat) ) then
         call bl_abort("FORT_HG_CELL_TO_NODE: bad index limits")
      end if

      do k=ARG_L3(rhs)+nghost,ARG_H3(rhs)-nghost
         do j=ARG_L2(rhs)+nghost,ARG_H2(rhs)-nghost
            do i=ARG_L1(rhs)+nghost,ARG_H1(rhs)-nghost
               rhs(i,j,k)=eighth*(dat(i-1,j-1,k  )+dat(i-1,j,k  )+
     &                            dat(i  ,j-1,k  )+dat(i  ,j,k  )+
     &                            dat(i-1,j-1,k-1)+dat(i-1,j,k-1)+
     &                            dat(i  ,j-1,k-1)+dat(i  ,j,k-1))
            end do
         end do
      end do

      end


c ::: -----------------------------------------------------------
c ::: This routine will compute D (U / dt + sigma G^perp phi)
c :::
c ::: NOTE: phi is node-centered
c :::       sigma is cell-centered      
c :::       U is cell-centered      
c :::
c ::: As of now, this routine assumes dx == dy == dz
c ::: Eventually, this will be changed..
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: phi        => node centered data
c ::: DIMS(phi)  => index limits for phi
c ::: sigma      => cell-centered coefficient array
c ::: DIMS(sigma)=> index limits for sigma      
c ::: u          => cell-centered velocity array
c ::: DIMS(u)    => index limits for u      
c ::: divgp     <=  node-centered divergence of gradient
c ::: DIMS(divgp)=> index limits for divgp
c ::: lo,hi      => node-centered subregion of divgp to define
c ::: dx         => cell sizes      
c ::: mult       => scalar multiplicative factor      
c ::: -----------------------------------------------------------

      subroutine FORT_FILTRHS(phi,DIMS(phi),sigma,DIMS(sigma),
     &                        divgp,DIMS(divgp),
     &                        lo,hi,dx,mult,is_rz)

      integer    DIMDEC(phi)
      integer    DIMDEC(sigma)
      integer    DIMDEC(divgp)
      integer    lo(SDIM), hi(SDIM)
      REAL_T     dx(SDIM), mult
      REAL_T     phi(DIMV(phi))
      REAL_T     sigma(DIMV(sigma))
      REAL_T     divgp(DIMV(divgp))
      integer    is_rz

      integer    i, j, k
      REAL_T     p1, p2, p3, p4, p5, p6, p7, p8, denom

c     NOTE: the factor of mult here accounts for the fact that one
c           takes ratio time steps on the fine grid for every one
c           timestep on the coarse grid.  mult = 1/ratio.
      
      denom = -mult/(sixteen*dx(1)**2)

c check and make sure dx == dy == dz
      if ( dx(1) .NE. dx(2) .or. dx(1) .NE. dx(3) ) then
         call bl_abort('FILTRHS:  code for dx != dy != dz not implemented')
      endif

      do k = lo(3), hi(3)
         do j = lo(2), hi(2)
            do i = lo(1), hi(1)
               p1 = sigma(i,j,k)*(
     &              five*(phi(i+1,j,k) + phi(i,j+1,k) + phi(i,j,k+1)) 
     &              - phi(i+1,j+1,k) - phi(i,j+1,k+1) - phi(i+1,j,k+1) 
     &              - three*phi(i+1,j+1,k+1) - nine*phi(i,j,k) )
               p2 = sigma(i-1,j,k)*(
     &              five*(phi(i-1,j,k) + phi(i,j+1,k) + phi(i,j,k+1)) 
     &              - phi(i-1,j+1,k) - phi(i,j+1,k+1) - phi(i-1,j,k+1) 
     &              - three*phi(i-1,j+1,k+1) - nine*phi(i,j,k) )
               p3 = sigma(i,j-1,k)*(
     &              five*(phi(i+1,j,k) + phi(i,j-1,k) + phi(i,j,k+1)) 
     &              - phi(i+1,j-1,k) - phi(i,j-1,k+1) - phi(i+1,j,k+1) 
     &              - three*phi(i+1,j-1,k+1) - nine*phi(i,j,k) )
               p4 = sigma(i-1,j-1,k)*(
     &              five*(phi(i-1,j,k) + phi(i,j-1,k) + phi(i,j,k+1)) 
     &              - phi(i-1,j-1,k) - phi(i,j-1,k+1) - phi(i-1,j,k+1) 
     &              - three*phi(i-1,j-1,k+1) - nine*phi(i,j,k) )
               p5 = sigma(i,j,k-1)*(
     &              five*(phi(i+1,j,k) + phi(i,j+1,k) + phi(i,j,k-1)) 
     &              - phi(i+1,j+1,k) - phi(i,j+1,k-1) - phi(i+1,j,k-1) 
     &              - three*phi(i+1,j+1,k-1) - nine*phi(i,j,k) )
               p6 = sigma(i-1,j,k-1)*(
     &              five*(phi(i-1,j,k) + phi(i,j+1,k) + phi(i,j,k-1)) 
     &              - phi(i-1,j+1,k) - phi(i,j+1,k-1) - phi(i-1,j,k-1) 
     &              - three*phi(i-1,j+1,k-1) - nine*phi(i,j,k) )
               p7 = sigma(i,j-1,k-1)*(
     &              five*(phi(i+1,j,k) + phi(i,j-1,k) + phi(i,j,k-1)) 
     &              - phi(i+1,j-1,k) - phi(i,j-1,k-1) - phi(i+1,j,k-1) 
     &              - three*phi(i+1,j-1,k-1) - nine*phi(i,j,k) )
               p8 = sigma(i-1,j-1,k-1)*(
     &              five*(phi(i-1,j,k) + phi(i,j-1,k) + phi(i,j,k-1)) 
     &              - phi(i-1,j-1,k) - phi(i,j-1,k-1) - phi(i-1,j,k-1) 
     &              - three*phi(i-1,j-1,k-1) - nine*phi(i,j,k) )
               divgp(i,j,k) = denom*(p1+p2+p3+p4+p5+p6+p7+p8)

            end do
         end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include "REAL.H"
#include "CONSTANTS.H"
#include "VISC_F.H"
#include "BCTypes.H"

#define DIMS lo_1,lo_2,lo_3,hi_1,hi_2,hi_3
#define CDIMS loc_1,loc_2,loc_3,hic_1,hic_2,hic_3

#if BL_USE_FLOAT
#define twentyfive 25.e0
#define fifth 0.2
#else
#define twentyfive 25.d0
#define fifth 0.2d0
#endif

c *************************************************************************
c ** RESID **
c ** Compute the residual
c *************************************************************************

      subroutine FORT_RESID(res,u,f,areax,areay,areaz,alpha,
     $                      DIMS,dx,resnorm,bc,level,idir,mu,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T    res(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T      u(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  ,lo_3-ng  :hi_3+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T  areax(lo_1-ng+1:hi_1+ng  ,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T  areay(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng  ,lo_3-ng+1:hi_3+ng-1)
      REAL_T  areaz(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng  )
      REAL_T  alpha(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng  )

      REAL_T dx(3)
      REAL_T mu
      REAL_T resnorm
      integer bc(2,3)
      integer level
      integer idir

c     Local variables
      REAL_T rlu
      REAL_T ux_left,ux_left_wall
      REAL_T ux_rght,ux_rght_wall
      REAL_T uy_bot,uy_bot_wall
      REAL_T uy_top,uy_top_wall
      REAL_T uz_dwn,uz_dwn_wall
      REAL_T uz_up ,uz_up_wall
      integer is,ie,js,je,ks,ke
      integer i,j,k

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      call gsrbvbc(u,DIMS,bc,ng)

      resnorm = zero

      do k = lo_3,hi_3 
       do j = lo_2,hi_2 
        do i = lo_1,hi_1 

            ux_left = (u(i,j,k) - u(i-1,j,k)) 
            ux_left_wall = (-sixteen * u(is-1,j,k) + twenty * u(is,j,k)
     $                         -five * u(is+1,j,k) + u(is+2,j,k) ) * fifth
            ux_left = cvmgt(ux_left_wall, ux_left, i .eq. is .and.
     $                      (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) )
            ux_left = areax(i,j,k) * ux_left / dx(1)

            ux_rght = (u(i+1,j,k) - u(i,j,k)) 
            ux_rght_wall = -(-sixteen * u(ie+1,j,k) + twenty * u(ie,j,k)
     $                          -five * u(ie-1,j,k) + u(ie-2,j,k) ) * fifth
            ux_rght = cvmgt(ux_rght_wall, ux_rght, i .eq. ie .and.
     $                      (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
            ux_rght = areax(i+1,j,k) * ux_rght / dx(1)

            uy_bot = (u(i,j,k) - u(i,j-1,k)) 
            uy_bot_wall = (-sixteen * u(i,js-1,k) + twenty * u(i,js,k)
     $                         -five * u(i,js+1,k) + u(i,js+2,k) ) * fifth
            uy_bot = cvmgt(uy_bot_wall, uy_bot, j .eq. js .and.
     $                      (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
            uy_bot = areay(i,j,k) * uy_bot / dx(2)

            uy_top = (u(i,j+1,k) - u(i,j,k)) 
            uy_top_wall = -(-sixteen * u(i,je+1,k) + twenty * u(i,je,k)
     $                         -five * u(i,je-1,k) + u(i,je-2,k) ) * fifth
            uy_top = cvmgt(uy_top_wall, uy_top, j .eq. je .and.
     $                      (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
            uy_top = areay(i,j+1,k) * uy_top / dx(2)

            uz_dwn = (u(i,j,k) - u(i,j,k-1)) 
            uz_dwn_wall = (-sixteen * u(i,j,ks-1) + twenty * u(i,j,ks)
     $                        -five * u(i,j,ks+1) + u(i,j,ks+2) ) * fifth
            uz_dwn = cvmgt(uz_dwn_wall, uz_dwn, k .eq. ks .and.
     $                      (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) )
            uz_dwn = areaz(i,j,k) * uz_dwn / dx(3)

            uz_up = (u(i,j,k+1) - u(i,j,k)) 
            uz_up_wall = -(-sixteen * u(i,j,ke+1) + twenty * u(i,j,ke)
     $                        -five * u(i,j,ke-1) + u(i,j,ke-2) ) * fifth
            uz_up = cvmgt(uz_up_wall, uz_up, k .eq. ke .and.
     $                      (BCZ_HI .eq. WALL .or. BCZ_HI .eq. INLET) )
            uz_up = areaz(i,j,k+1) * uz_up / dx(3)

            rlu = alpha(i,j,k)*u(i,j,k) - mu*((ux_rght - ux_left)+
     $                                        (uy_top  - uy_bot )+
     $                                        (uz_up   - uz_dwn ) )

            res(i,j,k) = f(i,j,k) - rlu

            resnorm = max(resnorm,abs(res(i,j,k)))

        enddo
       enddo
      enddo

      return
      end

c *************************************************************************
c ** GSRBV **
c ** Gauss-Seidel red-black relaxation 
c *************************************************************************

      subroutine FORT_GSRBV(u,f,areax,areay,areaz,alpha,
     $                      DIMS,dx,bc,level,idir,nngsrb,mu,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T      u(lo_1-ng  :hi_1+ng  ,lo_2-ng  :hi_2+ng  ,lo_3-ng  :hi_3+ng  )
      REAL_T      f(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T  areax(lo_1-ng+1:hi_1+ng  ,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng-1)
      REAL_T  areay(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng  ,lo_3-ng+1:hi_3+ng-1)
      REAL_T  areaz(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng  )
      REAL_T  alpha(lo_1-ng+1:hi_1+ng-1,lo_2-ng+1:hi_2+ng-1,lo_3-ng+1:hi_3+ng  )
      REAL_T dx(3)
      REAL_T mu
      integer bc(2,3)
      integer level,idir
      integer nngsrb

c     Local variables
      REAL_T rlam,rlu
      REAL_T facx,facy,facz
      REAL_T hxsqinv, hysqinv, hzsqinv
      REAL_T ux_left,ux_left_wall
      REAL_T ux_rght,ux_rght_wall
      REAL_T uy_bot,uy_bot_wall
      REAL_T uy_top,uy_top_wall
      REAL_T uz_dwn,uz_dwn_wall
      REAL_T uz_up,uz_up_wall
      REAL_T facx_left, facx_rght
      REAL_T facy_bot, facy_top
      REAL_T facz_dwn, facz_up
      integer i,j,k,iter
      integer is,ie,js,je,ks,ke
      integer extra_xlo,extra_xhi
      integer extra_ylo,extra_yhi
      integer extra_zlo,extra_zhi
      integer iinc
      logical ltest

      is = lo_1
      ie = hi_1
      js = lo_2
      je = hi_2
      ks = lo_3
      ke = hi_3

      call gsrbvbc(u,DIMS,bc,ng)

      do iter = 1, 2*nngsrb
 
         extra_xlo = cvmgt(ng-iter,0,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
         extra_xhi = cvmgt(ng-iter,0,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
         extra_ylo = cvmgt(ng-iter,0,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
         extra_yhi = cvmgt(ng-iter,0,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)
         extra_zlo = cvmgt(ng-iter,0,BCZ_LO .eq. INTERIOR .or. BCZ_LO .eq. PERIODIC)
         extra_zhi = cvmgt(ng-iter,0,BCZ_HI .eq. INTERIOR .or. BCZ_HI .eq. PERIODIC)
 
         do k = lo_3-extra_zlo,hi_3+extra_zhi
         do j = lo_2-extra_ylo,hi_2+extra_yhi
            iinc = mod(j+k+iter+1+extra_xlo+2*ng,2)
            do i = lo_1-extra_xlo+iinc,hi_1+extra_xhi,2

              ux_left = (u(i,j,k) - u(i-1,j,k)) 
              ux_left_wall = (-sixteen * u(is-1,j,k) + twenty * u(is,j,k)
     $                           -five * u(is+1,j,k) + u(is+2,j,k) ) * fifth
              ltest = (i .eq. is .and. level .eq. 0 .and. 
     $                 (BCX_LO .eq. WALL .or. BCX_LO .eq. INLET) )
              ux_left   = cvmgt(ux_left_wall,ux_left,ltest)
              facx_left = cvmgt(four        ,one    ,ltest)
              ux_left   = areax(i,j,k) *   ux_left / dx(1)
              facx_left = areax(i,j,k) * facx_left / dx(1)

              ux_rght = (u(i+1,j,k) - u(i,j,k)) 
              ux_rght_wall = -(-sixteen * u(ie+1,j,k) + twenty * u(ie,j,k)
     $                            -five * u(ie-1,j,k) + u(ie-2,j,k) ) * fifth
              ltest = (i .eq. ie .and. level .eq. 0 .and. 
     $                 (BCX_HI .eq. WALL .or. BCX_HI .eq. INLET) )
              ux_rght   = cvmgt(ux_rght_wall,ux_rght,ltest)
              facx_rght = cvmgt(four        ,one    ,ltest)
              ux_rght   = areax(i+1,j,k) *   ux_rght / dx(1)
              facx_rght = areax(i+1,j,k) * facx_rght / dx(1)

              uy_bot = (u(i,j,k) - u(i,j-1,k)) 
              uy_bot_wall = (-sixteen * u(i,js-1,k) + twenty * u(i,js,k)
     $                          -five * u(i,js+1,k) + u(i,js+2,k) ) * fifth
              ltest = (j .eq. js .and. level .eq. 0 .and. 
     $                 (BCY_LO .eq. WALL .or. BCY_LO .eq. INLET) )
              uy_bot   = cvmgt(uy_bot_wall,uy_bot,ltest)
              facy_bot = cvmgt(four       ,one   ,ltest)
              uy_bot   = areay(i,j,k) *   uy_bot / dx(2)
              facy_bot = areay(i,j,k) * facy_bot / dx(2)

              uy_top = (u(i,j+1,k) - u(i,j,k)) 
              uy_top_wall = -(-sixteen * u(i,je+1,k) + twenty * u(i,je,k)
     $                           -five * u(i,je-1,k) + u(i,je-2,k) ) * fifth
              ltest = (j .eq. je .and. level .eq. 0 .and. 
     $                 (BCY_HI .eq. WALL .or. BCY_HI .eq. INLET) )
              uy_top   = cvmgt(uy_top_wall,uy_top,ltest)
              facy_top = cvmgt(four       ,one   ,ltest)
              uy_top   = areay(i,j+1,k) *   uy_top  / dx(2)
              facy_top = areay(i,j+1,k) * facy_top / dx(2)

              uz_dwn = (u(i,j,k) - u(i,j,k-1)) 
              uz_dwn_wall = (-sixteen * u(i,j,ks-1) + twenty * u(i,j,ks)
     $                          -five * u(i,j,ks+1) + u(i,j,ks+2) ) * fifth
              ltest = (k .eq. ks .and. level .eq. 0 .and. 
     $                 (BCZ_LO .eq. WALL .or. BCZ_LO .eq. INLET) )
              uz_dwn   = cvmgt(uz_dwn_wall,uz_dwn,ltest)
              facz_dwn = cvmgt(four       ,one   ,ltest)
              uz_dwn   = areaz(i,j,k) *   uz_dwn / dx(3)
              facz_dwn = areaz(i,j,k) * facz_dwn / dx(3)

              uz_up  = (u(i,j,k+1) - u(i,j,k)) 
              uz_up _wall = -(-sixteen * u(i,j,ke+1) + twenty * u(i,j,ke)
     $                           -five * u(i,j,ke-1) + u(i,j,ke-2) ) * fifth
              ltest = (k .eq. ke .and. level .eq. 0 .and. 
     $                 (BCZ_HI .eq. WALL .or. BCZ_HI .eq. INLET) )
              uz_up    = cvmgt(uz_up_wall ,uz_up ,ltest)
              facz_up  = cvmgt(four       ,one   ,ltest)
              uz_up    = areaz(i,j,k+1) *   uz_up  / dx(3)
              facz_up  = areaz(i,j,k+1) * facz_up  / dx(3)

              rlu = alpha(i,j,k)*u(i,j,k) - mu*((ux_rght - ux_left)+
     $                                          (uy_top  - uy_bot )+
     $                                          (uz_up   - uz_dwn ))

              rlam = alpha(i,j,k) + mu*(facx_left+facx_rght+facy_bot+facy_top+
     $                                  facz_dwn+facz_up)
              rlam = one/rlam
              u(i,j,k) = u(i,j,k) - rlam*(rlu - f(i,j,k))

            enddo
         enddo
         enddo

         call gsrbvbc(u,DIMS,bc,ng)

      enddo

      return
      end

c *************************************************************************
c ** GSRBVBC **
c ** Impose phyical boundary conditions
c *************************************************************************

      subroutine gsrbvbc(u,DIMS,bc,ng)

      implicit none

      integer DIMS
      integer ng
      REAL_T  u(lo_1-ng:hi_1+ng,lo_2-ng:hi_2+ng,lo_3-ng:hi_3+ng)
      integer bc(2,3)

c     Local variables
      integer i,j,k,is,ie,js,je,ks,ke
      integer ilo,ihi,jlo,jhi,klo,khi

      is = lo_1
      js = lo_2
      ks = lo_3
      ie = hi_1
      je = hi_2
      ke = hi_3

      ilo = cvmgt(lo_1-ng,lo_1,BCX_LO .eq. INTERIOR .or. BCX_LO .eq. PERIODIC)
      ihi = cvmgt(hi_1+ng,hi_1,BCX_HI .eq. INTERIOR .or. BCX_HI .eq. PERIODIC)
      jlo = cvmgt(lo_2-ng,lo_2,BCY_LO .eq. INTERIOR .or. BCY_LO .eq. PERIODIC)
      jhi = cvmgt(hi_2+ng,hi_2,BCY_HI .eq. INTERIOR .or. BCY_HI .eq. PERIODIC)
      klo = cvmgt(lo_3-ng,lo_3,BCZ_LO .eq. INTERIOR .or. BCZ_LO .eq. PERIODIC)
      khi = cvmgt(hi_3+ng,hi_3,BCZ_HI .eq. INTERIOR .or. BCZ_HI .eq. PERIODIC)

c
c     The only boundary conditions we need to enforce are OUTLET,
c      since all the others are zero (now that we've put the equations
c      into residual-correction form). 
c

      if (BCZ_LO .eq. OUTLET) then
        do j = jlo,jhi
        do i = ilo,ihi
          u(i,j,ks-1) = u(i,j,ks)
        enddo
        enddo
      endif

      if (BCZ_HI .eq. OUTLET) then
        do j = jlo,jhi
        do i = ilo,ihi
          u(i,j,ke+1) = u(i,j,ke)
        enddo
        enddo
      endif

      if (BCY_LO .eq. OUTLET) then
        do k = klo,khi
        do i = ilo,ihi
          u(i,js-1,k) = u(i,js,k)
        enddo
        enddo
      endif

      if (BCY_HI .eq. OUTLET) then
        do k = klo,khi
        do i = ilo,ihi
          u(i,je+1,k) = u(i,je,k)
        enddo
        enddo
      endif


      if (BCX_LO .eq. OUTLET) then
        do k = klo,khi
        do j = jlo,jhi
          u(is-1,j,k) = u(is,j,k)
        enddo
        enddo
      endif

      if (BCX_HI .eq. OUTLET) then
        do k = klo,khi
        do j = jlo,jhi
          u(ie+1,j,k) = u(ie,j,k)
        enddo
        enddo
      endif

      return
      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: FILCC_3D.F,v 1.8 2002/07/31 22:32:02 lijewski Exp $
c

#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "ArrayLim.H"

#define SDIM 3

c ::: -----------------------------------------------------------
c ::: This routine is intended to be a generic fill function
c ::: for cell centered data.  It knows how to exrapolate,
c ::: and reflect data and can be used to suppliment problem
c ::: specific fill functions (ie. EXT_DIR).
c ::: 
c ::: INPUTS/OUTPUTS:
c ::: q        <=  array to fill
c ::: DIMS(q)   => index extent of q array
c ::: domlo,hi  => index extent of problem domain
c ::: dx        => cell spacing
c ::: xlo       => physical location of lower left hand
c :::	           corner of q array
c ::: bc	=> array of boundary flags bc(SPACEDIM,lo:hi)
c ::: 
c ::: NOTE: corner data not used in computing soln but must have
c :::       reasonable values for arithmetic to live
c ::: -----------------------------------------------------------

      subroutine filcc(q,DIMS(q),domlo,domhi,dx,xlo,bc)

      integer    DIMDEC(q)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     xlo(SDIM), dx(SDIM)
      REAL_T     q(DIMV(q))
      integer    bc(SDIM,2)

      integer    nlft, nrgt, nbot, ntop, nup, ndwn
      integer    ilo, ihi, jlo, jhi, klo, khi
      integer    is,  ie,  js,  je,  ks,  ke
      integer    i, j, k

      is = max(ARG_L1(q),domlo(1))
      ie = min(ARG_H1(q),domhi(1))
      js = max(ARG_L2(q),domlo(2))
      je = min(ARG_H2(q),domhi(2))
      ks = max(ARG_L3(q),domlo(3))
      ke = min(ARG_H3(q),domhi(3))

      nlft = max(0,domlo(1)-ARG_L1(q))
      nrgt = max(0,ARG_H1(q)-domhi(1))
      nbot = max(0,domlo(2)-ARG_L2(q))
      ntop = max(0,ARG_H2(q)-domhi(2))
      ndwn = max(0,domlo(3)-ARG_L3(q))
      nup  = max(0,ARG_H3(q)-domhi(3))
c
c     ::::: first fill sides
c
      if (nlft .gt. 0) then
         ilo = domlo(1)

	 if (bc(1,1) .eq. FOEXTRAP) then
	    do i = 1, nlft
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ilo-i,j,k) = q(ilo,j,k)
                  end do
               end do
	    end do
	 else if (bc(1,1) .eq. HOEXTRAP) then
	    do i = 2, nlft
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ilo-i,j,k) = q(ilo,j,k)
                  end do
               end do
	    end do
            if (ilo+2 .le. ie) then
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ilo-1,j,k) = (15*q(ilo,j,k) - 10*q(ilo+1,j,k) + 
     $                    3*q(ilo+2,j,k)) * eighth
                  end do
               end do
            else  
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ilo-1,j,k) = half*(3*q(ilo,j,k) - q(ilo+1,j,k))
                  end do
               end do
            end if
	 else if (bc(1,1) .eq. REFLECT_EVEN) then
	    do i = 1, nlft
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ilo-i,j,k) = q(ilo+i-1,j,k)
                  end do
               end do
	    end do
	 else if (bc(1,1) .eq. REFLECT_ODD) then
	    do i = 1, nlft
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ilo-i,j,k) = -q(ilo+i-1,j,k)
                  end do
               end do
	    end do
	 end if
      end if

      if (nrgt .gt. 0) then
         ihi = domhi(1)

	 if (bc(1,2) .eq. FOEXTRAP) then
	    do i = 1, nrgt
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ihi+i,j,k) = q(ihi,j,k)
                  end do
               end do
	    end do
         else if (bc(1,2) .eq. HOEXTRAP) then
            do i = 2, nrgt
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ihi+i,j,k) = q(ihi,j,k)
                  end do
               end do
            end do
            if (ihi-2 .ge. is) then
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ihi+1,j,k) = (15*q(ihi,j,k) - 10*q(ihi-1,j,k) + 
     $                    3*q(ihi-2,j,k)) * eighth
                  end do
               end do
            else
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ihi+1,j,k) = half*(3*q(ihi,j,k) - q(ihi-1,j,k))
                  end do
               end do
            end if
	 else if (bc(1,2) .eq. REFLECT_EVEN) then
	    do i = 1, nrgt
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ihi+i,j,k) = q(ihi-i+1,j,k)
                  end do
               end do
	    end do
	 else if (bc(1,2) .eq. REFLECT_ODD) then
	    do i = 1, nrgt
               do k = ARG_L3(q),ARG_H3(q)
                  do j = ARG_L2(q),ARG_H2(q)
                     q(ihi+i,j,k) = -q(ihi-i+1,j,k)
                  end do
               end do
	    end do
	 end if
      end if

      if (nbot .gt. 0) then
         jlo = domlo(2)
         
	 if (bc(2,1) .eq. FOEXTRAP) then
	    do j = 1, nbot
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jlo-j,k) = q(i,jlo,k)
                  end do
               end do
	    end do
         else if (bc(2,1) .eq. HOEXTRAP) then
            do j = 2, nbot
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jlo-j,k) = q(i,jlo,k)
                  end do
               end do
            end do
            if (jlo+2 .le. je) then
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jlo-1,k) = (15*q(i,jlo,k) - 10*q(i,jlo+1,k) + 
     $                    3*q(i,jlo+2,k)) * eighth
                  end do
               end do
	    else
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jlo-1,k) = half*(3*q(i,jlo,k) - q(i,jlo+1,k))
                  end do
               end do
	    end if
	 else if (bc(2,1) .eq. REFLECT_EVEN) then
	    do j = 1, nbot 
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jlo-j,k) = q(i,jlo+j-1,k)
                  end do
               end do
	    end do
	 else if (bc(2,1) .eq. REFLECT_ODD) then
	    do j = 1, nbot
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jlo-j,k) = -q(i,jlo+j-1,k)
                  end do
               end do
	    end do
	 end if
      end if

      if (ntop .gt. 0) then
         jhi = domhi(2)

	 if (bc(2,2) .eq. FOEXTRAP) then
	    do j = 1, ntop
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jhi+j,k) = q(i,jhi,k)
                  end do
               end do
	    end do
         else if (bc(2,2) .eq. HOEXTRAP) then
            do j = 2, ntop
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jhi+j,k) = q(i,jhi,k)
                  end do
               end do
            end do
            if (jhi-2 .ge. js) then
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jhi+1,k) = (15*q(i,jhi,k) - 10*q(i,jhi-1,k) + 
     $                    3*q(i,jhi-2,k)) * eighth
                  end do
               end do
	    else
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jhi+1,k) = half*(3*q(i,jhi,k) - q(i,jhi-1,k))
                  end do
               end do
	    end if
	 else if (bc(2,2) .eq. REFLECT_EVEN) then
	    do j = 1, ntop
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jhi+j,k) = q(i,jhi-j+1,k)
                  end do
               end do
	    end do
	 else if (bc(2,2) .eq. REFLECT_ODD) then
	    do j = 1, ntop
               do k = ARG_L3(q),ARG_H3(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,jhi+j,k) = -q(i,jhi-j+1,k)
                  end do
               end do
	    end do
	 end if
      end if

      if (ndwn .gt. 0) then
         klo = domlo(3)

	 if (bc(3,1) .eq. FOEXTRAP) then
	    do k = 1, ndwn
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,klo-k) = q(i,j,klo)
                  end do
               end do
	    end do
         else if (bc(3,1) .eq. HOEXTRAP) then
            do k = 2, ndwn
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,klo-k) = q(i,j,klo)
                  end do
               end do
            end do
            if (klo+2 .le. ke) then
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,klo-1) = (15*q(i,j,klo) - 10*q(i,j,klo+1) + 
     $                    3*q(i,j,klo+2)) * eighth
                  end do
               end do
	    else
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,klo-1) = half*(3*q(i,j,klo) - q(i,j,klo+1))
                  end do
               end do
	    end if
	 else if (bc(3,1) .eq. REFLECT_EVEN) then
	    do k = 1, ndwn
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,klo-k) = q(i,j,klo+k-1)
                  end do
               end do
	    end do
	 else if (bc(3,1) .eq. REFLECT_ODD) then
	    do k = 1, ndwn
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,klo-k) = -q(i,j,klo+k-1)
                  end do
               end do
	    end do
	 end if
      end if

      if (nup .gt. 0) then
         khi = domhi(3)

	 if (bc(3,2) .eq. FOEXTRAP) then
	    do k = 1, nup
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,khi+k) = q(i,j,khi)
                  end do
               end do
	    end do
         else if (bc(3,2) .eq. HOEXTRAP) then
            do k = 2, nup
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,khi+k) = q(i,j,khi)
                  end do
               end do
            end do
            if (khi-2 .ge. ks) then
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,khi+1) = (15*q(i,j,khi) - 10*q(i,j,khi-1) + 
     $                    3*q(i,j,khi-2)) * eighth
                  end do
               end do
	    else
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,khi+1) = half*(3*q(i,j,khi) - q(i,j,khi-1))
                  end do
               end do
	    end if
	 else if (bc(3,2) .eq. REFLECT_EVEN) then
	    do k = 1, nup
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,khi+k) = q(i,j,khi-k+1)
                  end do
               end do
	    end do
	 else if (bc(3,2) .eq. REFLECT_ODD) then
	    do k = 1, nup
               do j = ARG_L2(q),ARG_H2(q)
                  do i = ARG_L1(q),ARG_H1(q)
                     q(i,j,khi+k) = -q(i,j,khi-k+1)
                  end do
               end do
	    end do
	 end if
      end if
c
c    First correct the i-j edges and all corners
c
      if ((nlft .gt. 0 .and. bc(1,1) .eq. HOEXTRAP) .and.
     $     (nbot .gt. 0 .and. bc(2,1) .eq. HOEXTRAP) ) then
         if (jlo+2 .le. je) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = half * eighth * 
     $              (15*q(ilo-1,jlo,k) - 10*q(ilo-1,jlo+1,k) + 
     $              3*q(ilo-1,jlo+2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = half * half * 
     $              (3*q(ilo-1,jlo,k) - q(ilo-1,jlo+1,k))
            end do
         end if

         if (ilo+2 .le. ie) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = q(ilo-1,jlo-1,k) + half * eighth * 
     $              (15*q(ilo,jlo-1,k) - 10*q(ilo+1,jlo-1,k) + 
     $              3*q(ilo+2,jlo-1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = q(ilo-1,jlo-1,k) + half * half * 
     $              (3*q(ilo,jlo-1,k) - q(ilo+1,jlo-1,k))
            end do
         end if

         if (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) then
            if (klo+2 .le. ke) then
               q(ilo-1,jlo-1,klo-1) = eighth * (
     $              (15*q(ilo-1,jlo-1,klo) - 10*q(ilo-1,jlo-1,klo+1) +
     $              3*q(ilo-1,jlo-1,klo+2)) )
            else
               q(ilo-1,jlo-1,klo-1) = half * 
     $              (3*q(ilo-1,jlo-1,klo) - q(ilo-1,jlo-1,klo+1))
            end if
         end if

         if (nup .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) then
            if (khi-2 .ge. ks) then
               q(ilo-1,jlo-1,khi+1) = eighth * (
     $              (15*q(ilo-1,jlo-1,khi) - 10*q(ilo-1,jlo-1,khi-1) +
     $              3*q(ilo-1,jlo-1,khi-2)) )
            else
               q(ilo-1,jlo-1,khi+1) = half * 
     $              (3*q(ilo-1,jlo-1,khi) - q(ilo-1,jlo-1,khi-1))
            end if
         end if

      end if
c
c ****************************************************************************
c
      if ((nlft .gt. 0 .and. bc(1,1) .eq. HOEXTRAP) .and.
     $     (ntop .gt. 0 .and. bc(2,2) .eq. HOEXTRAP) ) then
         if (jhi-2 .ge. js) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = half * eighth * 
     $              (15*q(ilo-1,jhi,k) - 10*q(ilo-1,jhi-1,k) + 
     $              3*q(ilo-1,jhi-2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = half * half * 
     $              (3*q(ilo-1,jhi,k) - q(ilo-1,jhi-1,k))
            end do
         end if

         if (ilo+2 .le. ie) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = q(ilo-1,jhi+1,k) + half * eighth * 
     $              (15*q(ilo,jhi+1,k) - 10*q(ilo+1,jhi+1,k) + 
     $              3*q(ilo+2,jhi+1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = q(ilo-1,jhi+1,k) + half * half * 
     $              (3*q(ilo,jhi+1,k) - q(ilo+1,jhi+1,k))
            end do
         end if

         if (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) then
            if (klo+2 .le. ke) then
               q(ilo-1,jhi+1,klo-1) = eighth * (
     $              (15*q(ilo-1,jhi+1,klo) - 10*q(ilo-1,jhi+1,klo+1) +
     $              3*q(ilo-1,jhi+1,klo+2)) )
            else
               q(ilo-1,jhi+1,klo-1) = half * 
     $              (3*q(ilo-1,jhi+1,klo) - q(ilo-1,jhi+1,klo+1))
            end if
         end if

         if (nup .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) then
            if (khi-2 .ge. ks) then
               q(ilo-1,jhi+1,khi+1) = eighth * (
     $              (15*q(ilo-1,jhi+1,khi) - 10*q(ilo-1,jhi+1,khi-1) +
     $              3*q(ilo-1,jhi+1,khi-2)) )
            else
               q(ilo-1,jhi+1,khi+1) = half * 
     $              (3*q(ilo-1,jhi+1,khi) - q(ilo-1,jhi+1,khi-1))
            end if
         end if

      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0 .and. bc(1,2) .eq. HOEXTRAP) .and.
     $     (nbot .gt. 0 .and. bc(2,1) .eq. HOEXTRAP) ) then
         if (jlo+2 .le. je) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = half * eighth * 
     $              (15*q(ihi+1,jlo,k) - 10*q(ihi+1,jlo+1,k) + 
     $              3*q(ihi+1,jlo+2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = half * half * 
     $              (3*q(ihi+1,jlo,k) - q(ihi+1,jlo+1,k))
            end do
         end if

         if (ihi-2 .ge. is) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = q(ihi+1,jlo-1,k) + half * eighth * 
     $              (15*q(ihi,jlo-1,k) - 10*q(ihi-1,jlo-1,k) + 
     $              3*q(ihi-2,jlo-1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = q(ihi+1,jlo-1,k) + half * half * 
     $              (3*q(ihi,jlo-1,k) - q(ihi-1,jlo-1,k))
            end do
         end if

         if (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) then
            if (klo+2 .le. ke) then
               q(ihi+1,jlo-1,klo-1) = eighth * 
     $              (15*q(ihi+1,jlo-1,klo) - 10*q(ihi+1,jlo-1,klo+1) +
     $              3*q(ihi+1,jlo-1,klo+2))
            else
               q(ihi+1,jlo-1,klo-1) = half * 
     $              (3*q(ihi+1,jlo-1,klo) - q(ihi+1,jlo-1,klo+1))
            end if
         end if

         if (nup .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) then
            if (khi-2 .ge. ks) then
               q(ihi+1,jlo-1,khi+1) = eighth * 
     $              (15*q(ihi+1,jlo-1,khi) - 10*q(ihi+1,jlo-1,khi-1) +
     $              3*q(ihi+1,jlo-1,khi-2))
            else
               q(ihi+1,jlo-1,khi+1) = half * 
     $              (3*q(ihi+1,jlo-1,khi) - q(ihi+1,jlo-1,khi-1))
            end if
         end if

      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0 .and. bc(1,2) .eq. HOEXTRAP) .and.
     $     (ntop .gt. 0 .and. bc(2,2) .eq. HOEXTRAP) ) then
         if (jhi-2 .ge. js) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = half * eighth * 
     $              (15*q(ihi+1,jhi,k) - 10*q(ihi+1,jhi-1,k) + 
     $              3*q(ihi+1,jhi-2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = half * half * 
     $              (3*q(ihi+1,jhi,k) - q(ihi+1,jhi-1,k))
            end do
         end if

         if (ihi-2 .ge. is) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = q(ihi+1,jhi+1,k) + half * eighth * 
     $              (15*q(ihi,jhi+1,k) - 10*q(ihi-1,jhi+1,k) + 
     $              3*q(ihi-2,jhi+1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = q(ihi+1,jhi+1,k) + half * half * 
     $              (3*q(ihi,jhi+1,k) - q(ihi-1,jhi+1,k))
            end do
         end if

         if (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) then
            if (klo+2 .le. ke) then
               q(ihi+1,jhi+1,klo-1) = eighth *
     $              (15*q(ihi+1,jhi+1,klo) - 10*q(ihi+1,jhi+1,klo+1) +
     $              3*q(ihi+1,jhi+1,klo+2))
            else
               q(ihi+1,jhi+1,klo-1) = half * 
     $              (3*q(ihi+1,jhi+1,klo) - q(ihi+1,jhi+1,klo+1))
            end if
         end if

         if (nup .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) then
            if (khi-2 .ge. ks) then
               q(ihi+1,jhi+1,khi+1) = eighth *
     $              (15*q(ihi+1,jhi+1,khi) - 10*q(ihi+1,jhi+1,khi-1) +
     $              3*q(ihi+1,jhi+1,khi-2))
            else
               q(ihi+1,jhi+1,khi+1) = half * 
     $              (3*q(ihi+1,jhi+1,khi) - q(ihi+1,jhi+1,khi-1))
            end if
         end if

      end if
c
c    Next correct the i-k edges
c
      if ((nlft .gt. 0 .and. bc(1,1) .eq. HOEXTRAP) .and.
     $     (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) ) then
         if (klo+2 .le. ke) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = half * eighth * 
     $              (15*q(ilo-1,j,klo) - 10*q(ilo-1,j,klo+1) + 
     $              3*q(ilo-1,j,klo+2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = half * half * 
     $              (3*q(ilo-1,j,klo) - q(ilo-1,j,klo+1))
            end do
         end if

         if (ilo+2 .le. ie) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = q(ilo-1,j,klo-1) + half * eighth * 
     $              (15*q(ilo,j,klo-1) - 10*q(ilo+1,j,klo-1) + 
     $              3*q(ilo+2,j,klo-1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = q(ilo-1,j,klo-1) + half * half * 
     $              (3*q(ilo,j,klo-1) - q(ilo+1,j,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nlft .gt. 0 .and. bc(1,1) .eq. HOEXTRAP) .and.
     $     (nup  .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) ) then
         if (khi-2 .ge. ks) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = half * eighth * 
     $              (15*q(ilo-1,j,khi) - 10*q(ilo-1,j,khi-1) + 
     $              3*q(ilo-1,j,khi-2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = half * half * 
     $              (3*q(ilo-1,j,khi) - q(ilo-1,j,khi-1))
            end do
         end if

         if (ilo+2 .le. ie) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = q(ilo-1,j,khi+1) + half * eighth * 
     $              (15*q(ilo,j,khi+1) - 10*q(ilo+1,j,khi+1) + 
     $              3*q(ilo+2,j,khi+1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = q(ilo-1,j,khi+1) + half * half * 
     $              (3*q(ilo,j,khi+1) - q(ilo+1,j,khi+1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0 .and. bc(1,2) .eq. HOEXTRAP) .and.
     $     (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) ) then
         if (klo+2 .le. ke) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = half * eighth *
     $              (15*q(ihi+1,j,klo) - 10*q(ihi+1,j,klo+1) + 
     $              3*q(ihi+1,j,klo+2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = half * half * 
     $              (3*q(ihi+1,j,klo) - q(ihi+1,j,klo+1))
            end do
         end if

         if (ihi-2 .ge. is) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = q(ihi+1,j,klo-1) + half * eighth *
     $              (15*q(ihi,j,klo-1) - 10*q(ihi-1,j,klo-1) + 
     $              3*q(ihi-2,j,klo-1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = q(ihi+1,j,klo-1) + half * half * 
     $              (3*q(ihi,j,klo-1) - q(ihi-1,j,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0 .and. bc(1,2) .eq. HOEXTRAP) .and.
     $     (nup  .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) ) then
         if (khi-2 .ge. ks) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = half * eighth * 
     $              (15*q(ihi+1,j,khi) - 10*q(ihi+1,j,khi-1) + 
     $              3*q(ihi+1,j,khi-2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = half * half * 
     $              (3*q(ihi+1,j,khi) - q(ihi+1,j,khi-1))
            end do
         end if
         if (ihi-2 .ge. is) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = q(ihi+1,j,khi+1) + half * eighth * 
     $              (15*q(ihi,j,khi+1) - 10*q(ihi-1,j,khi+1) + 
     $              3*q(ihi-2,j,khi+1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = q(ihi+1,j,khi+1) + half * half * 
     $              (3*q(ihi,j,khi+1) - q(ihi-1,j,khi+1))
            end do
         end if
      end if
c
c    Next correct the j-k edges
c
      if ((nbot .gt. 0 .and. bc(2,1) .eq. HOEXTRAP) .and.
     $     (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) ) then
         if (klo+2 .le. ke) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = half * eighth *
     $              (15*q(i,jlo-1,klo) - 10*q(i,jlo-1,klo+1) + 
     $              3*q(i,jlo-1,klo+2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = half * half * 
     $              (3*q(i,jlo-1,klo) - q(i,jlo-1,klo+1))
            end do
         end if
         if (jlo+2 .le. je) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = q(i,jlo-1,klo-1) + half * eighth * 
     $              (15*q(i,jlo,klo-1) - 10*q(i,jlo+1,klo-1) + 
     $              3*q(i,jlo+2,klo-1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = q(i,jlo-1,klo-1) + half * half * 
     $              (3*q(i,jlo,klo-1) - q(i,jlo+1,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nbot .gt. 0 .and. bc(2,1) .eq. HOEXTRAP) .and.
     $     (nup  .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) ) then
         if (khi-2 .ge. ks) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = half * eighth * 
     $              (15*q(i,jlo-1,khi) - 10*q(i,jlo-1,khi-1) + 
     $              3*q(i,jlo-1,khi-2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = half * half *
     $              (3*q(i,jlo-1,khi) - q(i,jlo-1,khi-1))
            end do
         end if

         if (jlo+2 .le. je) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = q(i,jlo-1,khi+1) + half * eighth * 
     $              (15*q(i,jlo,khi+1) - 10*q(i,jlo+1,khi+1) + 
     $              3*q(i,jlo+2,khi+1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = q(i,jlo-1,khi+1) + half * half *
     $              (3*q(i,jlo,khi+1) - q(i,jlo+1,khi+1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((ntop .gt. 0 .and. bc(2,2) .eq. HOEXTRAP) .and.
     $     (ndwn .gt. 0 .and. bc(3,1) .eq. HOEXTRAP) ) then
         if (klo+2 .le. ke) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = half * eighth * 
     $              (15*q(i,jhi+1,klo) - 10*q(i,jhi+1,klo+1) + 
     $              3*q(i,jhi+1,klo+2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = half * half * 
     $              (3*q(i,jhi+1,klo) - q(i,jhi+1,klo+1))
            end do
         end if
         if (jhi-2 .ge. js) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = q(i,jhi+1,klo-1) + half * eighth * 
     $              (15*q(i,jhi,klo-1) - 10*q(i,jhi-1,klo-1) + 
     $              3*q(i,jhi-2,klo-1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = q(i,jhi+1,klo-1) + half * half * 
     $              (3*q(i,jhi,klo-1) - q(i,jhi-1,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((ntop .gt. 0 .and. bc(2,2) .eq. HOEXTRAP) .and.
     $     (nup  .gt. 0 .and. bc(3,2) .eq. HOEXTRAP) ) then
         if (khi-2 .ge. ks) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = half * eighth * 
     $              (15*q(i,jhi+1,khi) - 10*q(i,jhi+1,khi-1) + 
     $              3*q(i,jhi+1,khi-2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = half * half * 
     $              (3*q(i,jhi+1,khi) - q(i,jhi+1,khi-1))
            end do
         end if
         if (jhi-2 .ge. js) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = q(i,jhi+1,khi+1) + half * eighth * 
     $              (15*q(i,jhi,khi+1) - 10*q(i,jhi-1,khi+1) + 
     $              3*q(i,jhi-2,khi+1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = q(i,jhi+1,khi+1) + half * half * 
     $              (3*q(i,jhi,khi+1) - q(i,jhi-1,khi+1))
            end do
         end if
      end if

      end

      subroutine hoextraptocc(q,DIMS(q),domlo,domhi,dx,xlo)

      integer    DIMDEC(q)
      integer    domlo(SDIM), domhi(SDIM)
      REAL_T     xlo(SDIM), dx(SDIM)
      REAL_T     q(DIMV(q))

      integer    nlft, nrgt, nbot, ntop, nup, ndwn
      integer    ilo, ihi, jlo, jhi, klo, khi
      integer    is,  ie,  js,  je,  ks,  ke
      integer    i, j, k

      is = max(ARG_L1(q),domlo(1))
      ie = min(ARG_H1(q),domhi(1))
      js = max(ARG_L2(q),domlo(2))
      je = min(ARG_H2(q),domhi(2))
      ks = max(ARG_L3(q),domlo(3))
      ke = min(ARG_H3(q),domhi(3))

      nlft = max(0,domlo(1)-ARG_L1(q))
      nrgt = max(0,ARG_H1(q)-domhi(1))
      nbot = max(0,domlo(2)-ARG_L2(q))
      ntop = max(0,ARG_H2(q)-domhi(2))
      ndwn = max(0,domlo(3)-ARG_L3(q))
      nup  = max(0,ARG_H3(q)-domhi(3))
c
c     First fill sides.
c
      if (nlft .gt. 0) then
         ilo = domlo(1)

         do i = 2, nlft
            do k = ARG_L3(q),ARG_H3(q)
               do j = ARG_L2(q),ARG_H2(q)
                  q(ilo-i,j,k) = q(ilo,j,k)
               end do
            end do
         end do
         if (ilo+2 .le. ie) then
            do k = ARG_L3(q),ARG_H3(q)
               do j = ARG_L2(q),ARG_H2(q)
                  q(ilo-1,j,k) = 3*q(ilo,j,k) - 3*q(ilo+1,j,k) +
     $                           q(ilo+2,j,k)
               end do
            end do
         else  
            do k = ARG_L3(q),ARG_H3(q)
               do j = ARG_L2(q),ARG_H2(q)
                  q(ilo-1,j,k) = 2*q(ilo,j,k) - q(ilo+1,j,k)
               end do
            end do
         end if
      end if

      if (nrgt .gt. 0) then
         ihi = domhi(1)

         do i = 2, nrgt
            do k = ARG_L3(q),ARG_H3(q)
               do j = ARG_L2(q),ARG_H2(q)
                  q(ihi+i,j,k) = q(ihi,j,k)
               end do
            end do
         end do
         if (ihi-2 .ge. is) then
            do k = ARG_L3(q),ARG_H3(q)
               do j = ARG_L2(q),ARG_H2(q)
                  q(ihi+1,j,k) = 3*q(ihi,j,k) - 3*q(ihi-1,j,k) +
     $                           q(ihi-2,j,k)
               end do
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               do j = ARG_L2(q),ARG_H2(q)
                  q(ihi+1,j,k) = 2*q(ihi,j,k) - q(ihi-1,j,k)
               end do
            end do
         end if
      end if

      if (nbot .gt. 0) then
         jlo = domlo(2)
         
         do j = 2, nbot
            do k = ARG_L3(q),ARG_H3(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,jlo-j,k) = q(i,jlo,k)
               end do
            end do
         end do
         if (jlo+2 .le. je) then
            do k = ARG_L3(q),ARG_H3(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,jlo-1,k) = 3*q(i,jlo,k) - 3*q(i,jlo+1,k) +
     $                           q(i,jlo+2,k)
               end do
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,jlo-1,k) = 2*q(i,jlo,k) - q(i,jlo+1,k)
               end do
            end do
         end if
      end if

      if (ntop .gt. 0) then
         jhi = domhi(2)

         do j = 2, ntop
            do k = ARG_L3(q),ARG_H3(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,jhi+j,k) = q(i,jhi,k)
               end do
            end do
         end do
         if (jhi-2 .ge. js) then
            do k = ARG_L3(q),ARG_H3(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,jhi+1,k) = 3*q(i,jhi,k) - 3*q(i,jhi-1,k) +
     $                           q(i,jhi-2,k)
               end do
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,jhi+1,k) = 2*q(i,jhi,k) - q(i,jhi-1,k)
               end do
            end do
         end if
      end if

      if (ndwn .gt. 0) then
         klo = domlo(3)

         do k = 2, ndwn
            do j = ARG_L2(q),ARG_H2(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,j,klo-k) = q(i,j,klo)
               end do
            end do
         end do
         if (klo+2 .le. ke) then
            do j = ARG_L2(q),ARG_H2(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,j,klo-1) = 3*q(i,j,klo) - 3*q(i,j,klo+1) +
     $                           q(i,j,klo+2)
               end do
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,j,klo-1) = 2*q(i,j,klo) - q(i,j,klo+1)
               end do
            end do
         end if
      end if

      if (nup .gt. 0) then
         khi = domhi(3)

         do k = 2, nup
            do j = ARG_L2(q),ARG_H2(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,j,khi+k) = q(i,j,khi)
               end do
            end do
         end do
         if (khi-2 .ge. ks) then
            do j = ARG_L2(q),ARG_H2(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,j,khi+1) = 3*q(i,j,khi) - 3*q(i,j,khi-1) +
     $                           q(i,j,khi-2)
               end do
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               do i = ARG_L1(q),ARG_H1(q)
                  q(i,j,khi+1) = 2*q(i,j,khi) - q(i,j,khi-1)
               end do
            end do
         end if
      end if
c
c    First correct the i-j edges and all corners
c
      if ((nlft .gt. 0) .and. (nbot .gt. 0)) then
         if (jlo+2 .le. je) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = half *
     $              (3*q(ilo-1,jlo,k) - 3*q(ilo-1,jlo+1,k) +
     $              q(ilo-1,jlo+2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = half *
     $              (2*q(ilo-1,jlo,k) - q(ilo-1,jlo+1,k))
            end do
         end if

         if (ilo+2 .le. ie) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = q(ilo-1,jlo-1,k) + half *
     $              (3*q(ilo,jlo-1,k) - 3*q(ilo+1,jlo-1,k) + 
     $              q(ilo+2,jlo-1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jlo-1,k) = q(ilo-1,jlo-1,k) + half *
     $              (2*q(ilo,jlo-1,k) - q(ilo+1,jlo-1,k))
            end do
         end if

         if (ndwn .gt. 0) then
            if (klo+2 .le. ke) then
               q(ilo-1,jlo-1,klo-1) = 
     $              (3*q(ilo-1,jlo-1,klo) - 3*q(ilo-1,jlo-1,klo+1) +
     $              q(ilo-1,jlo-1,klo+2))
            else
               q(ilo-1,jlo-1,klo-1) = 
     $              (2*q(ilo-1,jlo-1,klo) - q(ilo-1,jlo-1,klo+1))
            end if
         end if

         if (nup .gt. 0) then
            if (khi-2 .ge. ks) then
               q(ilo-1,jlo-1,khi+1) = 
     $              (3*q(ilo-1,jlo-1,khi) - 3*q(ilo-1,jlo-1,khi-1) +
     $              q(ilo-1,jlo-1,khi-2))
            else
               q(ilo-1,jlo-1,khi+1) =
     $              (2*q(ilo-1,jlo-1,khi) - q(ilo-1,jlo-1,khi-1))
            end if
         end if

      end if
c
c ****************************************************************************
c
      if ((nlft .gt. 0) .and. (ntop .gt. 0)) then
         if (jhi-2 .ge. js) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = half *
     $              (3*q(ilo-1,jhi,k) - 3*q(ilo-1,jhi-1,k) + 
     $              q(ilo-1,jhi-2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = half *
     $              (2*q(ilo-1,jhi,k) - q(ilo-1,jhi-1,k))
            end do
         end if

         if (ilo+2 .le. ie) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = q(ilo-1,jhi+1,k) + half *
     $              (3*q(ilo,jhi+1,k) - 3*q(ilo+1,jhi+1,k) + 
     $              q(ilo+2,jhi+1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ilo-1,jhi+1,k) = q(ilo-1,jhi+1,k) + half *
     $              (2*q(ilo,jhi+1,k) - q(ilo+1,jhi+1,k))
            end do
         end if

         if (ndwn .gt. 0) then
            if (klo+2 .le. ke) then
               q(ilo-1,jhi+1,klo-1) = 
     $              (3*q(ilo-1,jhi+1,klo) - 3*q(ilo-1,jhi+1,klo+1) +
     $              q(ilo-1,jhi+1,klo+2))
            else
               q(ilo-1,jhi+1,klo-1) =
     $              (2*q(ilo-1,jhi+1,klo) - q(ilo-1,jhi+1,klo+1))
            end if
         end if

         if (nup .gt. 0) then
            if (khi-2 .ge. ks) then
               q(ilo-1,jhi+1,khi+1) =
     $              (3*q(ilo-1,jhi+1,khi) - 3*q(ilo-1,jhi+1,khi-1) +
     $              q(ilo-1,jhi+1,khi-2))
            else
               q(ilo-1,jhi+1,khi+1) =
     $              (2*q(ilo-1,jhi+1,khi) - q(ilo-1,jhi+1,khi-1))
            end if
         end if

      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0) .and. (nbot .gt. 0)) then
         if (jlo+2 .le. je) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = half *
     $              (3*q(ihi+1,jlo,k) - 3*q(ihi+1,jlo+1,k) + 
     $              q(ihi+1,jlo+2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = half *
     $              (2*q(ihi+1,jlo,k) - q(ihi+1,jlo+1,k))
            end do
         end if

         if (ihi-2 .ge. is) then 
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = q(ihi+1,jlo-1,k) + half *
     $              (3*q(ihi,jlo-1,k) - 3*q(ihi-1,jlo-1,k) + 
     $              q(ihi-2,jlo-1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jlo-1,k) = q(ihi+1,jlo-1,k) + half *
     $              (2*q(ihi,jlo-1,k) - q(ihi-1,jlo-1,k))
            end do
         end if

         if (ndwn .gt. 0) then
            if (klo+2 .le. ke) then
               q(ihi+1,jlo-1,klo-1) =
     $              (3*q(ihi+1,jlo-1,klo) - 3*q(ihi+1,jlo-1,klo+1) +
     $              q(ihi+1,jlo-1,klo+2))
            else
               q(ihi+1,jlo-1,klo-1) =
     $              (2*q(ihi+1,jlo-1,klo) - q(ihi+1,jlo-1,klo+1))
            end if
         end if

         if (nup .gt. 0) then
            if (khi-2 .ge. ks) then
               q(ihi+1,jlo-1,khi+1) =
     $              (3*q(ihi+1,jlo-1,khi) - 3*q(ihi+1,jlo-1,khi-1) +
     $              q(ihi+1,jlo-1,khi-2))
            else
               q(ihi+1,jlo-1,khi+1) =
     $              (2*q(ihi+1,jlo-1,khi) - q(ihi+1,jlo-1,khi-1))
            end if
         end if

      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0) .and. (ntop .gt. 0)) then
         if (jhi-2 .ge. js) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = half *
     $              (3*q(ihi+1,jhi,k) - 3*q(ihi+1,jhi-1,k) + 
     $              q(ihi+1,jhi-2,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = half *
     $              (2*q(ihi+1,jhi,k) - q(ihi+1,jhi-1,k))
            end do
         end if

         if (ihi-2 .ge. is) then
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = q(ihi+1,jhi+1,k) + half *
     $              (3*q(ihi,jhi+1,k) - 3*q(ihi-1,jhi+1,k) + 
     $              q(ihi-2,jhi+1,k))
            end do
         else
            do k = ARG_L3(q),ARG_H3(q)
               q(ihi+1,jhi+1,k) = q(ihi+1,jhi+1,k) + half *
     $              (2*q(ihi,jhi+1,k) - q(ihi-1,jhi+1,k))
            end do
         end if

         if (ndwn .gt. 0) then
            if (klo+2 .le. ke) then
               q(ihi+1,jhi+1,klo-1) =
     $              (3*q(ihi+1,jhi+1,klo) - 3*q(ihi+1,jhi+1,klo+1) +
     $              q(ihi+1,jhi+1,klo+2))
            else
               q(ihi+1,jhi+1,klo-1) =
     $              (2*q(ihi+1,jhi+1,klo) - q(ihi+1,jhi+1,klo+1))
            end if
         end if

         if (nup .gt. 0) then
            if (khi-2 .ge. ks) then
               q(ihi+1,jhi+1,khi+1) =
     $              (3*q(ihi+1,jhi+1,khi) - 3*q(ihi+1,jhi+1,khi-1) +
     $              q(ihi+1,jhi+1,khi-2))
            else
               q(ihi+1,jhi+1,khi+1) =
     $              (2*q(ihi+1,jhi+1,khi) - q(ihi+1,jhi+1,khi-1))
            end if
         end if

      end if
c
c    Next correct the i-k edges
c
      if ((nlft .gt. 0) .and. (ndwn .gt. 0)) then
         if (klo+2 .le. ke) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = half *
     $              (3*q(ilo-1,j,klo) - 3*q(ilo-1,j,klo+1) + 
     $              q(ilo-1,j,klo+2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = half *
     $              (2*q(ilo-1,j,klo) - q(ilo-1,j,klo+1))
            end do
         end if

         if (ilo+2 .le. ie) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = q(ilo-1,j,klo-1) + half *
     $              (3*q(ilo,j,klo-1) - 3*q(ilo+1,j,klo-1) + 
     $              q(ilo+2,j,klo-1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,klo-1) = q(ilo-1,j,klo-1) + half *
     $              (2*q(ilo,j,klo-1) - q(ilo+1,j,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nlft .gt. 0) .and. (nup .gt. 0)) then
         if (khi-2 .ge. ks) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = half *
     $              (3*q(ilo-1,j,khi) - 3*q(ilo-1,j,khi-1) + 
     $              q(ilo-1,j,khi-2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = half *
     $              (2*q(ilo-1,j,khi) - q(ilo-1,j,khi-1))
            end do
         end if

         if (ilo+2 .le. ie) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = q(ilo-1,j,khi+1) + half *
     $              (3*q(ilo,j,khi+1) - 3*q(ilo+1,j,khi+1) + 
     $              q(ilo+2,j,khi+1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ilo-1,j,khi+1) = q(ilo-1,j,khi+1) + half *
     $              (2*q(ilo,j,khi+1) - q(ilo+1,j,khi+1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0) .and. (ndwn .gt. 0)) then
         if (klo+2 .le. ke) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = half *
     $              (3*q(ihi+1,j,klo) - 3*q(ihi+1,j,klo+1) + 
     $              q(ihi+1,j,klo+2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = half *
     $              (2*q(ihi+1,j,klo) - q(ihi+1,j,klo+1))
            end do
         end if

         if (ihi-2 .ge. is) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = q(ihi+1,j,klo-1) + half *
     $              (3*q(ihi,j,klo-1) - 3*q(ihi-1,j,klo-1) + 
     $              q(ihi-2,j,klo-1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,klo-1) = q(ihi+1,j,klo-1) + half *
     $              (2*q(ihi,j,klo-1) - q(ihi-1,j,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nrgt .gt. 0) .and. (nup .gt. 0)) then
         if (khi-2 .ge. ks) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = half *
     $              (3*q(ihi+1,j,khi) - 3*q(ihi+1,j,khi-1) + 
     $              q(ihi+1,j,khi-2))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = half *
     $              (2*q(ihi+1,j,khi) - q(ihi+1,j,khi-1))
            end do
         end if
         if (ihi-2 .ge. is) then
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = q(ihi+1,j,khi+1) + half *
     $              (3*q(ihi,j,khi+1) - 3*q(ihi-1,j,khi+1) + 
     $              q(ihi-2,j,khi+1))
            end do
         else
            do j = ARG_L2(q),ARG_H2(q)
               q(ihi+1,j,khi+1) = q(ihi+1,j,khi+1) + half *
     $              (2*q(ihi,j,khi+1) - q(ihi-1,j,khi+1))
            end do
         end if
      end if
c
c    Next correct the j-k edges
c
      if ((nbot .gt. 0) .and. (ndwn .gt. 0)) then
         if (klo+2 .le. ke) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = half *
     $              (3*q(i,jlo-1,klo) - 3*q(i,jlo-1,klo+1) + 
     $              q(i,jlo-1,klo+2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = half *
     $              (2*q(i,jlo-1,klo) - q(i,jlo-1,klo+1))
            end do
         end if
         if (jlo+2 .le. je) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = q(i,jlo-1,klo-1) + half *
     $              (3*q(i,jlo,klo-1) - 3*q(i,jlo+1,klo-1) + 
     $              q(i,jlo+2,klo-1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,klo-1) = q(i,jlo-1,klo-1) + half *
     $              (2*q(i,jlo,klo-1) - q(i,jlo+1,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((nbot .gt. 0) .and. (nup .gt. 0)) then
         if (khi-2 .ge. ks) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = half *
     $              (3*q(i,jlo-1,khi) - 3*q(i,jlo-1,khi-1) + 
     $              q(i,jlo-1,khi-2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = half *
     $              (2*q(i,jlo-1,khi) - q(i,jlo-1,khi-1))
            end do
         end if

         if (jlo+2 .le. je) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = q(i,jlo-1,khi+1) + half *
     $              (3*q(i,jlo,khi+1) - 3*q(i,jlo+1,khi+1) + 
     $              q(i,jlo+2,khi+1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jlo-1,khi+1) = q(i,jlo-1,khi+1) + half *
     $              (2*q(i,jlo,khi+1) - q(i,jlo+1,khi+1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((ntop .gt. 0) .and. (ndwn .gt. 0)) then
         if (klo+2 .le. ke) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = half *
     $              (3*q(i,jhi+1,klo) - 3*q(i,jhi+1,klo+1) + 
     $              q(i,jhi+1,klo+2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = half *
     $              (2*q(i,jhi+1,klo) - q(i,jhi+1,klo+1))
            end do
         end if
         if (jhi-2 .ge. js) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = q(i,jhi+1,klo-1) + half *
     $              (3*q(i,jhi,klo-1) - 3*q(i,jhi-1,klo-1) + 
     $              q(i,jhi-2,klo-1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,klo-1) = q(i,jhi+1,klo-1) + half *
     $              (2*q(i,jhi,klo-1) - q(i,jhi-1,klo-1))
            end do
         end if
      end if
c
c ****************************************************************************
c
      if ((ntop .gt. 0) .and. (nup .gt. 0)) then
         if (khi-2 .ge. ks) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = half *
     $              (3*q(i,jhi+1,khi) - 3*q(i,jhi+1,khi-1) + 
     $              q(i,jhi+1,khi-2))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = half *
     $              (2*q(i,jhi+1,khi) - q(i,jhi+1,khi-1))
            end do
         end if
         if (jhi-2 .ge. js) then
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = q(i,jhi+1,khi+1) + half *
     $              (3*q(i,jhi,khi+1) - 3*q(i,jhi-1,khi+1) + 
     $              q(i,jhi-2,khi+1))
            end do
         else
            do i = ARG_L1(q),ARG_H1(q)
               q(i,jhi+1,khi+1) = q(i,jhi+1,khi+1) + half *
     $              (2*q(i,jhi,khi+1) - q(i,jhi-1,khi+1))
            end do
         end if
      end if

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: EXACT_3D.F,v 1.3 1999/03/25 23:37:42 sstanley Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif

#include "REAL.H"
#include "CONSTANTS.H"
#include "BC_TYPES.H"
#include "PROB_AMR_F.H"
#include "ArrayLim.H"
#include "EXACT_F.H"

#define SDIM 3
c
c ::: -----------------------------------------------------------
c ::: This case is an unsteady  viscous benchmark for which the 
c ::: exact solution is,
c :::     u(x,y,t) = - Cos(Pi x) Sin(Pi y) Exp(-2 Pi^2 Nu t)
c :::     v(x,y,t) =   Sin(Pi x) Cos(Pi y) Exp(-2 Pi^2 Nu t)
c :::     p(x,y,t) = - {Cos(2 Pi x) + Cos(2 Pi y)} Exp(-4 Pi^2 Nu t) / 4
c ::: In this dircetory, ViscBench3d.cpp, reads a plot file and compares
c ::: the solution against this exact solution.  This benchmark was
c ::: originally derived by G.I. Taylor (Phil. Mag., Vol. 46, No. 274, 
c ::: pp. 671-674, 1923) and Ethier and Steinman
c ::: (Intl. J. Num. Meth. Fluids, Vol. 19, pp. 369-375, 1994) give
c ::: the pressure field.
c
      subroutine FORT_VISCBENCH(time, nu, unifdir, lo, hi, 
     &                          ncomp, state, DIMS(state),
     &                          dx, xlo, xhi)

      implicit none

      integer    ncomp, unifdir
      integer    lo(SDIM), hi(SDIM)
      integer    DIMDEC(state)
      REAL_T     time, nu, dx(SDIM)
      REAL_T     xlo(SDIM), xhi(SDIM)
      REAL_T     state(DIMV(state),ncomp)
c
c     ::::: local variables
c
      integer i, j, k, n
      REAL_T  x, y, z
      REAL_T  hx, hy, hz
      REAL_T  spx, spy, spz, cpx, cpy, cpz
      REAL_T expterm

      hx = dx(1)
      hy = dx(2)
      hz = dx(3)

      expterm = exp(-two*Pi**2*nu*time)

      do k = lo(3), hi(3)
        z = xlo(3) + hz*(float(k-lo(3)) + half)
        spz = sin(Pi*z)
        cpz = cos(Pi*z)

        do j = lo(2), hi(2)
          y = xlo(2) + hy*(float(j-lo(2)) + half)
          spy = sin(Pi*y)
          cpy = cos(Pi*y)

          do i = lo(1), hi(1)
            x = xlo(1) + hx*(float(i-lo(1)) + half)

            spx = sin(Pi*x)
            cpx = cos(Pi*x)

c
c           Uniform in the X-direction
c
            if (unifdir .eq. 0) then
              state(i,j,k,1) =   zero
              state(i,j,k,2) =   spz*cpy * expterm
              state(i,j,k,3) = - cpz*spy * expterm
              state(i,j,k,4) =   one
              do n = 5, ncomp
                state(i,j,k,n) =   cpz*cpy * expterm
              enddo

c
c           Uniform in the Y-direction
c
            elseif (unifdir .eq. 1) then
              state(i,j,k,1) = - cpx*spz * expterm
              state(i,j,k,2) =   zero
              state(i,j,k,3) =   spx*cpz * expterm
              state(i,j,k,4) =   one
              do n = 5, ncomp
                state(i,j,k,n) =   cpx*cpz * expterm
              enddo

c
c           Uniform in the Z-direction
c
            elseif (unifdir .eq. 2) then
              state(i,j,k,1) = - cpx*spy * expterm
              state(i,j,k,2) =   spx*cpy * expterm
              state(i,j,k,3) =   zero
              state(i,j,k,4) =   one
              do n = 5, ncomp
                state(i,j,k,n) =   cpx*cpy * expterm
              enddo
            endif
          end do
        end do
      end do

      end

/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

c
c $Id: LO_UTIL.F,v 1.3 2002/10/19 18:33:57 car Exp $
c
#undef  BL_LANG_CC
#ifndef BL_LANG_FORT
#define BL_LANG_FORT
#endif
      
#undef TESTING_POLYNOMINTERPCOEFFS
#ifdef TESTING_POLYNOMINTERPCOEFFS
#define NORDER 3
#define REAL_T real*8
#define zero 0.d0
#define one 1.d0
#else
#include <CONSTANTS.H>
#include <REAL.H>
#endif
    
      

c     polyInterpCoeff:
c  
c     This routine returns the Lagrange interpolating coefficients for a
c     polynomial through N points, evaluated at xInt (see Numerical Recipes,
c     v2, p102, e.g.):
c
c            (x-x2)(x-x3)...(x-xN)              (x-x1)(x-x2)...(x-x(N-1))
c    P(x) = ----------------------- y1  + ... + ------------------------  yN
c           (x1-x2)(x1-x3)...(x1-xN)            (x1-x2)(x1-x3)...(x1-xN)
c
c     P(xInt) = sum_(i=1)^(N) y[i]*c[i]
c
      subroutine polyInterpCoeff(xInt, x, N, c)
      implicit none
      integer N, i, j
      REAL_T xInt, x(N), c(N), num, den
      do j=1,N
         num = one
         den = one
         do i = 1,j-1
            num = num*(xInt - x(i))
            den = den*(x(j) - x(i))
         end do
         do i = j+1,N
            num = num*(xInt - x(i))
            den = den*(x(j) - x(i))
         end do
#ifndef NDEBUG
         if (den .eq. zero) STOP 'polyInterpCoeff::invalid data'
#endif         
         c(j) = num/den
      end do
      return
      end

      

#ifdef TESTING_POLYNOMINTERPCOEFFS

c     
c     This is a test driver for the routine polyInterpCoeff.  Sample data
c     is created from the statement function, and the location of the 
c     boundary node and internal nodes are set, as apporpriate.  The
c     number of points created is equal to the test NORDER set at the
c     top of this file through a define.  The coefficients are computed,
c     and then the ghost cell value is constructed from the resulting
c     coefficients and written out.
c

      program polyInterpCoeffTest
      integer i, j
      REAL_T c(NORDER), y(NORDER), yInt
      REAL_T x(NORDER), const, yfunc, xx, xInt
c
c     Make data, locations
      yfunc(xx) = (2*xx-one)**(NORDER-1) + const
      const = -one
      x(1) = zero
      y(1) = yfunc(x(1))
      do j=2,NORDER
         x(j) = j - 1.5D0*one
         y(j) = yfunc(x(j))
      end do
c      
c     Set interpolation point to ghost cell location
      xInt = (x(2) - x(3))*0.5D0
c      
c     Call routine
      call polyInterpCoeff(xInt,x,NORDER,c)
c
c     Evaluate result
      yInt = zero
      do j=1,NORDER
         yInt = yInt + c(j)*y(j)
      end do
c
c     Dump output
      write(6,*) 'x = ',x
      write(6,*) 'y = ',y
      write(6,*) 'c = ',c
      write(6,*) 'Interpolated y = ',yInt
      end

#endif

C
C $Id: BLutil_F.f,v 1.4 2002/06/19 20:49:44 car Exp $
C
C=======================================================================
C
C     String handling routines:
C     Strings are handled differently in C++ and in FORTRAN.  In order
C     to simplify the framework strings are passed from FORTRAN to C++
C     as arrays of integer characters, terminated by the EOS symbol
C     which we set to -1
C     blstr2int converts a FORTRAN string to an integer array,
C     blint2str converts an integer array to a FORTRAN string.
C      
C-----------------------------------------------------------------------
      SUBROUTINE blstr2int(iarr, n, str)
      CHARACTER*(*) str
      INTEGER n, i, j
      INTEGER iarr(n)
      INTEGER EOS
      PARAMETER (EOS=-1)
C
      IF ( n .LE. len(str) ) THEN
          STOP "blstr2int: str to large for iarr"
      END IF
C     Make sure that IARR is empty
      DO J = 1, N
          iarr(J) = ichar(' ')
      END DO
      j = 1
      DO i = 1, len(str)
          iarr(j) = ichar(str(i:i))
          j = j + 1
      END DO
C     EOS
      iarr(j) = EOS
C
      END
C-----------------------------------------------------------------------
      SUBROUTINE blint2str(str, iarr, n)
      CHARACTER*(*) str
      INTEGER n
      INTEGER iarr(n)
      INTEGER EOS
      PARAMETER (EOS=-1)
      INTEGER i
C
      DO i = 1, LEN(str)
          str(i:i) = ' '
      END DO
      DO i = 1, n
          IF ( i .GT. LEN(str) ) STOP "blint2str: iarr to large for str"
          IF ( iarr(i) .EQ. EOS ) GO TO 100
          str(i:i) = char(iarr(i))
      END DO
 100  CONTINUE
C
      END
